SystemOrganization addCategory: #'Platypus-ExpressBuiltinsSchema'!
SystemOrganization addCategory: #'Platypus-HW-CodeTokens'!
SystemOrganization addCategory: #'Platypus-HW-STEP'!
SystemOrganization addCategory: #'Platypus-HW-core'!
SystemOrganization addCategory: #'Platypus-HW-interpreter'!
SystemOrganization addCategory: #'Platypus-HW-parsers'!
SystemOrganization addCategory: #'Platypus-HW-tools'!
SystemOrganization addCategory: #'Platypus-HW-translater-private'!
SystemOrganization addCategory: #'Platypus-HW-translater-public'!
SystemOrganization addCategory: #'Platypus-HW-visitors'!
SystemOrganization addCategory: #'Platypus-PlatypusAggregateDataSchemaSchema'!
SystemOrganization addCategory: #'Platypus-PlatypusDictionarySchemaSchema'!
SystemOrganization addCategory: #'Platypus-PlatypusEnvironmentSchemaSchema'!
SystemOrganization addCategory: #'Platypus-PlatypusExpressPrimitivesSchemaInstance'!
SystemOrganization addCategory: #'Platypus-PlatypusExpressionsSchemaSchema'!
SystemOrganization addCategory: #'Platypus-PlatypusMetaSchemasSchemaInstance'!
SystemOrganization addCategory: #'Platypus-PlatypusPopulationSchemaSchema'!
SystemOrganization addCategory: #'Platypus-PlatypusStatementsSchemaSchema'!
SystemOrganization addCategory: #'Platypus-STEP-core'!

Scanner subclass: #PlatypusVWPackageExporterScanner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-translater-private'!

!PlatypusVWPackageExporterScanner methodsFor: 'public access' stamp: 'apl 4/26/2006 09:56'!
canOutputSpaceAfterToken: aToken 
	^ ((#(':' '-' '+' ) includes: aToken)
		or: [aToken size > 1
				and: [aToken first = $"
						and: [aToken last = $"]]]) not! !

!PlatypusVWPackageExporterScanner methodsFor: 'public access' stamp: 'apl 4/26/2006 09:54'!
outPut: aString 
	| tokens |
	tokens := self tokenize: aString.
	^ self outPutTokens: tokens! !

!PlatypusVWPackageExporterScanner methodsFor: 'public access' stamp: 'apl 4/26/2006 09:53'!
outPutTokens: tokens 
	| prettPrinted |
	prettPrinted := WriteStream on: String new.
	tokens
		do: [:t | (t isKindOf: Array)
				ifTrue: [prettPrinted nextPutAll: '#( '.
					prettPrinted
						nextPutAll: (self outPutTokens: t).
					prettPrinted nextPutAll: ') ']
				ifFalse: [prettPrinted nextPutAll: t.
					(self canOutputSpaceAfterToken: t)
						ifTrue: [prettPrinted nextPut: $ ]]].
	^ prettPrinted contents! !

!PlatypusVWPackageExporterScanner methodsFor: 'expression types' stamp: 'apl 4/18/2006 21:31'!
scanToken
	super scanToken.
	tokenType = #leftArrow
		ifTrue: [token := ':='].
	^ token! !

!PlatypusVWPackageExporterScanner methodsFor: 'public access' stamp: 'apl 4/18/2006 22:00'!
tokenize: sourceString 
	| coll |
	coll := OrderedCollection new.
	self
		scan: (ReadStream on: sourceString asString).
	[tokenType = #doIt]
		whileFalse: [(currentComment notNil
					and: [currentComment notEmpty])
				ifTrue: [[currentComment isEmpty]
						whileFalse: [coll addLast: '"' , currentComment removeFirst , '"']].
			token isSymbol
				ifTrue: [token := token asString].
			coll addLast: token.
			self scanToken].
	(currentComment notNil
			and: [currentComment notEmpty])
		ifTrue: [[currentComment isEmpty]
				whileFalse: [
					coll addLast: '"' , currentComment removeFirst , '"']].
	^ coll! !

!PlatypusVWPackageExporterScanner methodsFor: 'multi-character scans' stamp: 'apl 4/18/2006 21:32'!
xBinary
	super xBinary.
! !

!PlatypusVWPackageExporterScanner methodsFor: 'multi-character scans' stamp: 'apl 4/18/2006 17:04'!
xColon
	super xColon.
	tokenType = #leftArrow
		ifTrue: [token := ':=']
		ifFalse: [token := token asString]! !

!PlatypusVWPackageExporterScanner methodsFor: 'multi-character scans' stamp: 'apl 4/18/2006 21:32'!
xDelimiter
	super xDelimiter.
! !

!PlatypusVWPackageExporterScanner methodsFor: 'multi-character scans' stamp: 'apl 4/18/2006 21:25'!
xDigit
	super xDigit.
	token := token asString.
! !

!PlatypusVWPackageExporterScanner methodsFor: 'multi-character scans' stamp: 'apl 4/18/2006 16:32'!
xDollar
	super xDollar.
	token := token printString! !

!PlatypusVWPackageExporterScanner methodsFor: 'multi-character scans' stamp: 'apl 4/18/2006 16:17'!
xDoubleQuote
	super xDoubleQuote.
! !

!PlatypusVWPackageExporterScanner methodsFor: 'multi-character scans' stamp: 'apl 4/18/2006 21:32'!
xLetter
	super xLetter.
	token := token asString.
! !

!PlatypusVWPackageExporterScanner methodsFor: 'multi-character scans' stamp: 'apl 4/18/2006 21:32'!
xLitQuote
	super xLitQuote.
	(token isKindOf: Array)
		ifFalse: [token := '#' , token asString].
! !

!PlatypusVWPackageExporterScanner methodsFor: 'multi-character scans' stamp: 'apl 4/18/2006 16:58'!
xSingleQuote
	super xSingleQuote.
	token := token printString! !

SmaCCScanner subclass: #PlatypusExpressBuiltinFormatScanner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-parsers'!

!PlatypusExpressBuiltinFormatScanner class methodsFor: 'generated-comments' stamp: 'apl 12/12/2005 12:03'!
scannerDefinitionComment

	"<integer>			:		\d+	;
<whitespace>		:		\s+ ;
"! !

!PlatypusExpressBuiltinFormatScanner methodsFor: 'generated-tokens' stamp: 'apl 12/12/2005 12:03'!
emptySymbolTokenId
	^26! !

!PlatypusExpressBuiltinFormatScanner methodsFor: 'generated-tokens' stamp: 'apl 12/12/2005 12:03'!
errorTokenId
	^27! !

!PlatypusExpressBuiltinFormatScanner methodsFor: 'generated-scanner' stamp: 'apl 12/12/2005 12:03'!
keywordFor: aString 
	^aString asUppercase! !

!PlatypusExpressBuiltinFormatScanner methodsFor: 'generated-scanner' stamp: 'apl 12/12/2005 12:03'!
scanForToken
	self step.
	currentCharacter isDigit 
		ifTrue: 
			[
			[self recordMatch: #(11 ).
			self step.
			currentCharacter isDigit] 
					whileTrue.
			^self reportLastMatch].
	(currentCharacter isSeparator or: [currentCharacter == $]) 
		ifTrue: 
			[
			[self recordMatch: #whitespace.
			self step.
			currentCharacter isSeparator or: [currentCharacter == $]] 
					whileTrue.
			^self reportLastMatch].
	(currentCharacter == $E or: [currentCharacter == $e]) 
		ifTrue: [^self recordAndReportMatch: #(9 )].
	(currentCharacter == $F or: [currentCharacter == $f]) 
		ifTrue: [^self recordAndReportMatch: #(4 )].
	(currentCharacter == $I or: [currentCharacter == $i]) 
		ifTrue: [^self recordAndReportMatch: #(3 )].
	currentCharacter == $# ifTrue: [^self recordAndReportMatch: #(7 )].
	currentCharacter == $( ifTrue: [^self recordAndReportMatch: #(10 )].
	currentCharacter == $) ifTrue: [^self recordAndReportMatch: #(8 )].
	currentCharacter == $+ ifTrue: [^self recordAndReportMatch: #(5 )].
	currentCharacter == $, ifTrue: [^self recordAndReportMatch: #(6 )].
	currentCharacter == $- ifTrue: [^self recordAndReportMatch: #(2 )].
	currentCharacter == $. ifTrue: [^self recordAndReportMatch: #(1 )].
	^self reportLastMatch! !

SmaCCScanner subclass: #PlatypusExpressLikeScanner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-parsers'!

!PlatypusExpressLikeScanner class methodsFor: 'generated-comments' stamp: 'apl 2/5/2004 19:15'!
scannerDefinitionComment

	"<character> : \s|\S ;
<anti>		: \\. ;"! !

!PlatypusExpressLikeScanner methodsFor: 'generated-tokens' stamp: 'apl 2/5/2004 19:15'!
emptySymbolTokenId
	^10! !

!PlatypusExpressLikeScanner methodsFor: 'generated-tokens' stamp: 'apl 2/5/2004 19:15'!
errorTokenId
	^11! !

!PlatypusExpressLikeScanner methodsFor: 'generated-scanner' stamp: 'apl 2/5/2004 19:15'!
scanForToken
	self step.
	(currentCharacter <= $> or: 
			[(currentCharacter between: $A and: $[) 
				or: [currentCharacter == $] or: [currentCharacter >= $_]]]) 
		ifTrue: [^self recordAndReportMatch: #(4)].
	currentCharacter == $? ifTrue: [^self recordAndReportMatch: #(3 4)].
	currentCharacter == $@ ifTrue: [^self recordAndReportMatch: #(1 4)].
	currentCharacter == $\ 
		ifTrue: 
			[self recordMatch: #(4).
			self step.
			^self recordAndReportMatch: #(5)].
	currentCharacter == $^ ifTrue: [^self recordAndReportMatch: #(2 4)].
	^self reportLastMatch! !

SmaCCScanner subclass: #PlatypusExpressScanner
	instanceVariableNames: 'tokenList tokenClassifier'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-parsers'!

!PlatypusExpressScanner class methodsFor: 'generated-initialization' stamp: 'AlainPlantec 1/13/2012 15:39'!
initializeKeywordMap
	keywordMap := Dictionary new.
	#(#(130 'ABSTRACT' 121) #(130 'AGGREGATE' 68) #(130 'ALIAS' 25) #(130 'AND' 61) #(130 'ANDOR' 59) #(130 'ARRAY' 62) #(130 'AS' 13) #(130 'BAG' 63) #(130 'BEGIN' 16) #(130 'BINARY' 69) #(130 'BOOLEAN' 91) #(130 'BY' 88) #(130 'CASE' 28) #(130 'CONSTANT' 14) #(130 'CONST_E' 81) #(130 'DERIVE' 110) #(130 'DIV' 56) #(130 'ELSE' 58) #(130 'END' 19) #(130 'END_ALIAS' 26) #(130 'END_CASE' 21) #(130 'END_CONSTANT' 6) #(130 'END_ENTITY' 118) #(130 'END_FUNCTION' 8) #(130 'END_IF' 20) #(130 'END_LOCAL' 104) #(130 'END_MAP' 70) #(130 'END_PROCEDURE' 24) #(130 'END_REPEAT' 105) #(130 'END_RULE' 7) #(130 'END_SCHEMA' 51) #(130 'END_SPLITMARK' 99) #(130 'END_TYPE' 92) #(130 'ENTITY' 116) #(130 'ENUMERATION' 72) #(130 'ESCAPE' 17) #(130 'FALSE' 78) #(130 'FIXED' 89) #(130 'FOR' 3) #(130 'FROM' 54) #(130 'FUNCTION' 5) #(130 'GENERIC' 74) #(130 'IF' 18) #(130 'IN' 46) #(130 'INTEGER' 86) #(130 'INVERSE' 114) #(130 'LIKE' 32) #(130 'LIST' 65) #(130 'LOCAL' 97) #(130 'LOGICAL' 87) #(130 'MAP' 84) #(130 'META' 23) #(130 'MOD' 55) #(130 'NOT' 50) #(130 'NUMBER' 73) #(130 'OF' 29) #(130 'ONEOF' 117) #(130 'OPTIONAL' 109) #(130 'OR' 36) #(130 'OTHERWISE' 30) #(130 'PI' 83) #(130 'PROCEDURE' 12) #(130 'QUERY' 82) #(130 'REAL' 85) #(130 'REFERENCE' 9) #(130 'REPEAT' 107) #(130 'RETURN' 106) #(130 'RULE' 2) #(130 'SCHEMA' 53) #(130 'SELECT' 76) #(130 'SELF' 115) #(130 'SET' 64) #(130 'SKIP' 98) #(130 'SPLITMARK' 94) #(130 'STRING' 66) #(130 'SUBTYPE' 119) #(130 'SUPERTYPE' 120) #(130 'THEN' 22) #(130 'TO' 101) #(130 'TRUE' 77) #(130 'TYPE' 100) #(130 'UNIQUE' 112) #(130 'UNKNOWN' 79) #(130 'UNTIL' 103) #(130 'USE' 27) #(130 'VAR' 111) #(130 'WHERE' 71) #(130 'WHILE' 102) #(130 'XOR' 39))
		do: [ :each | (keywordMap at: each first ifAbsentPut: [ Dictionary new ]) at: (each at: 2) put: each last ].
	^ keywordMap! !

!PlatypusExpressScanner class methodsFor: 'generated-comments' stamp: 'AlainPlantec 1/13/2012 15:39'!
scannerDefinitionComment

	"<tailRemark>		:		[\-][\-][^\n\r\f]* ;
<nativeAlgorithm>	: 		\( \* \# ;			
<embedRemark>	: 		\( \* ;			
<integer>			:		\d+	;
<real>				:		<integer>\.<integer>?(e(\+|-)?<integer>)?	;
<binary>			:		%[01]+	;
<string>			:		'([^']|'')*'	;
<encodedString>	:		\""[^\""]*\""	;
<identifier>			:		[A-Za-z0-9]\w*	;
<whitespace>		:		\s+ ;


"! !

!PlatypusExpressScanner methodsFor: 'generated-tokens' stamp: 'AlainPlantec 1/13/2012 15:39'!
binaryId
	^127! !

!PlatypusExpressScanner methodsFor: 'scanning' stamp: 'apl 11/12/2003 11:36'!
buildTokenList
	[self atEnd]
		whileFalse: [self next].
	^ self tokenList! !

!PlatypusExpressScanner methodsFor: 'scanning' stamp: 'apl 4/18/2006 22:48'!
embedRemark
	| rem remarkToken smaccToken |
	rem := self readEmbedRemark.
	remarkToken := PlatypusEmbeddedRemarkToken token: rem.
	tokenList add: remarkToken.
	rem notEmpty
		ifTrue: [(rem first = $"
					or: [rem first = $<])
				ifTrue: [smaccToken := SmaCCToken
								value: remarkToken
								start: start
								id: (Array with: self remarkRefId).
					matchActions := nil.
					returnMatchBlock value: smaccToken]].
	outputStream reset.
	^ self whitespace! !

!PlatypusExpressScanner methodsFor: 'generated-tokens' stamp: 'AlainPlantec 1/13/2012 15:39'!
emptySymbolTokenId
	^312! !

!PlatypusExpressScanner methodsFor: 'generated-tokens' stamp: 'AlainPlantec 1/13/2012 15:39'!
encodedStringId
	^129! !

!PlatypusExpressScanner methodsFor: 'scanning' stamp: 'apl 4/18/2006 22:48'!
eol
	outputStream reset.
	tokenList add: PlatypusEolToken new.
	^ self whitespace! !

!PlatypusExpressScanner methodsFor: 'generated-tokens' stamp: 'AlainPlantec 1/13/2012 15:39'!
errorTokenId
	^313! !

!PlatypusExpressScanner methodsFor: 'generated-tokens' stamp: 'AlainPlantec 1/13/2012 15:39'!
identifierId
	^130! !

!PlatypusExpressScanner methodsFor: 'scanning' stamp: 'apl 4/18/2006 22:48'!
indent
	outputStream reset.
	tokenList add: PlatypusIndentToken new.
	^ self whitespace! !

!PlatypusExpressScanner methodsFor: 'initialize-release' stamp: 'apl 3/23/2006 14:17'!
initialize
	super initialize.
	tokenList := PlatypusTokenList new.
	tokenClassifier := PlatypusExpressTokenClassifier new.
! !

!PlatypusExpressScanner methodsFor: 'generated-tokens' stamp: 'AlainPlantec 1/13/2012 15:39'!
integerId
	^125! !

!PlatypusExpressScanner methodsFor: 'generated-scanner' stamp: 'AlainPlantec 1/13/2012 15:39'!
keywordFor: aString 
	^aString asUppercase! !

!PlatypusExpressScanner methodsFor: 'generated-tokens' stamp: 'AlainPlantec 1/13/2012 15:39'!
logicalId
	^314! !

!PlatypusExpressScanner methodsFor: 'scanning' stamp: 'apl 4/18/2006 22:48'!
nativeAlgorithm
	| smaccToken nativeAlgorithmToken rem |
	rem := self readEmbedRemark.
	nativeAlgorithmToken := PlatypusExpressNativeAlgorithmToken token: rem allButLast.
	smaccToken := SmaCCToken
				value: nativeAlgorithmToken
				start: start
				id: (Array with: self nativeAlgorithmId).
	matchActions := nil.
	returnMatchBlock value: smaccToken.
	outputStream reset.
	^ self whitespace! !

!PlatypusExpressScanner methodsFor: 'generated-tokens' stamp: 'AlainPlantec 1/13/2012 15:39'!
nativeAlgorithmId
	^123! !

!PlatypusExpressScanner methodsFor: 'accessing' stamp: 'apl 3/30/2006 14:41'!
next
	| token tokenClass tokenNodeData precToken |
	token := super next.
	token value isString
		ifTrue: [token value isEmpty
				ifFalse: [tokenClass := tokenClassifier
								tokenClassFromString: token value
								ifAbsent: [((precToken := tokenList previousNonBlankFrom: tokenList last) notNil
											and: [precToken isPrimaryElementOpenKeyword])
										ifTrue: [PlatypusPrimaryElementIdentifierToken]
										ifFalse: [PlatypusIdentifierToken]].
					tokenNodeData := tokenClass token: token value]]
		ifFalse: [tokenNodeData := token value].
	tokenNodeData
		ifNotNil: [tokenList add: tokenNodeData].
	^ token! !

!PlatypusExpressScanner methodsFor: 'scanning' stamp: 'AlainPlantec 10/7/2010 15:54'!
readEmbedRemark
	| level loop rem endFound prevChar |
	level := 1.
	endFound := false.
	outputStream reset.
	self step.
	loop := stream atEnd not.
	[loop]
		whileTrue: [stream atEnd
				ifTrue: [Transcript show: 'End of input inside comment\' withCRs.
					loop := false]
				ifFalse: [prevChar := currentCharacter.
					self step.
					(prevChar == $(
							and: [currentCharacter == $*])
						ifTrue: [level := level + 1]
						ifFalse: [(prevChar == $*
									and: [currentCharacter == $)])
								ifTrue: [level := level - 1.
									level == 0
										ifTrue: [endFound := true.
											loop := false]]]]].
	rem := outputStream contents.
	endFound
		ifTrue: [rem := rem copyFrom: 1 to: rem size - 2].
	^ rem
! !

!PlatypusExpressScanner methodsFor: 'generated-tokens' stamp: 'AlainPlantec 1/13/2012 15:39'!
realId
	^126! !

!PlatypusExpressScanner methodsFor: 'generated-tokens' stamp: 'AlainPlantec 1/13/2012 15:39'!
remarkRefId
	^220! !

!PlatypusExpressScanner methodsFor: 'generated-scanner' stamp: 'AlainPlantec 1/13/2012 15:39'!
scan1
	[ 
	self step.
	currentCharacter ~= $' ] whileTrue.
	currentCharacter = $'
		ifTrue: [ 
			self recordMatch: #(128).
			self step.
			currentCharacter = $'
				ifTrue: [ ^ self scan1 ].
			^ self reportLastMatch ].
	^ self reportLastMatch! !

!PlatypusExpressScanner methodsFor: 'generated-scanner' stamp: 'AlainPlantec 1/13/2012 15:39'!
scanForToken
	self step.
	((currentCharacter between: $A and: $Z) or: [ currentCharacter between: $a and: $z ])
		ifTrue: [ 
			[ 
			self recordMatch: #(130).
			self step.
			(currentCharacter between: $0 and: $9)
				or: [ (currentCharacter between: $A and: $Z) or: [ currentCharacter = $_ or: [ currentCharacter between: $a and: $z ] ] ] ]
				whileTrue.
			^ self reportLastMatch ].
	(currentCharacter between: $0 and: $9)
		ifTrue: [ 
			[ 
			self recordMatch: #(125 130).
			self step.
			((currentCharacter between: $A and: $Z) or: [ currentCharacter = $_ or: [ currentCharacter between: $a and: $z ] ])
				ifTrue: [ 
					[ 
					self recordMatch: #(130).
					self step.
					(currentCharacter between: $0 and: $9)
						or: [ (currentCharacter between: $A and: $Z) or: [ currentCharacter = $_ or: [ currentCharacter between: $a and: $z ] ] ] ]
						whileTrue.
					^ self reportLastMatch ].
			currentCharacter between: $0 and: $9 ] whileTrue.
			currentCharacter = $.
				ifTrue: [ 
					[ 
					self recordMatch: #(126).
					self step.
					currentCharacter between: $0 and: $9 ] whileTrue.
					(currentCharacter = $E or: [ currentCharacter = $e ])
						ifTrue: [ 
							self step.
							(currentCharacter between: $0 and: $9)
								ifTrue: [ 
									[ 
									self recordMatch: #(126).
									self step.
									currentCharacter between: $0 and: $9 ] whileTrue.
									^ self reportLastMatch ].
							(currentCharacter = $+ or: [ currentCharacter = $- ])
								ifTrue: [ 
									self step.
									(currentCharacter between: $0 and: $9)
										ifTrue: [ 
											[ 
											self recordMatch: #(126).
											self step.
											currentCharacter between: $0 and: $9 ] whileTrue.
											^ self reportLastMatch ].
									^ self reportLastMatch ].
							^ self reportLastMatch ].
					^ self reportLastMatch ].
			^ self reportLastMatch ].
	((currentCharacter between: Character tab and: Character cr) or: [ currentCharacter = Character space ])
		ifTrue: [ 
			[ 
			self recordMatch: #whitespace.
			self step.
			(currentCharacter between: Character tab and: Character cr) or: [ currentCharacter = Character space ] ] whileTrue.
			^ self reportLastMatch ].
	currentCharacter = $"
		ifTrue: [ 
			[ 
			self step.
			currentCharacter ~= $" ] whileTrue.
			currentCharacter = $"
				ifTrue: [ ^ self recordAndReportMatch: #(129) ].
			^ self reportLastMatch ].
	currentCharacter = $%
		ifTrue: [ 
			self recordMatch: #(90).
			self step.
			(currentCharacter between: $0 and: $1)
				ifTrue: [ 
					[ 
					self recordMatch: #(127).
					self step.
					currentCharacter between: $0 and: $1 ] whileTrue.
					^ self reportLastMatch ].
			^ self reportLastMatch ].
	currentCharacter = $'
		ifTrue: [ ^ self scan1 ].
	currentCharacter = $(
		ifTrue: [ 
			self recordMatch: #(10).
			self step.
			currentCharacter = $*
				ifTrue: [ 
					self recordMatch: #embedRemark.
					self step.
					currentCharacter = $#
						ifTrue: [ ^ self recordAndReportMatch: #nativeAlgorithm ].
					^ self reportLastMatch ].
			^ self reportLastMatch ].
	currentCharacter = $)
		ifTrue: [ ^ self recordAndReportMatch: #(11) ].
	currentCharacter = $*
		ifTrue: [ 
			self recordMatch: #(57).
			self step.
			currentCharacter = $*
				ifTrue: [ ^ self recordAndReportMatch: #(52) ].
			currentCharacter = $}
				ifTrue: [ ^ self recordAndReportMatch: #(95) ].
			^ self reportLastMatch ].
	currentCharacter = $+
		ifTrue: [ ^ self recordAndReportMatch: #(38) ].
	currentCharacter = $,
		ifTrue: [ ^ self recordAndReportMatch: #(15) ].
	currentCharacter = $-
		ifTrue: [ 
			self recordMatch: #(34).
			self step.
			currentCharacter = $-
				ifTrue: [ 
					[ 
					self recordMatch: #tailRemark.
					self step.
					currentCharacter <= Character tab
						or: [ currentCharacter = Character pageUp or: [ currentCharacter >= (Character value: 14) ] ] ] whileTrue.
					^ self reportLastMatch ].
			^ self reportLastMatch ].
	currentCharacter = $.
		ifTrue: [ ^ self recordAndReportMatch: #(108) ].
	currentCharacter = $/
		ifTrue: [ ^ self recordAndReportMatch: #(43) ].
	currentCharacter = $:
		ifTrue: [ 
			self recordMatch: #(4).
			self step.
			currentCharacter = $<
				ifTrue: [ 
					self step.
					currentCharacter = $>
						ifTrue: [ 
							self step.
							currentCharacter = $:
								ifTrue: [ ^ self recordAndReportMatch: #(45) ].
							^ self reportLastMatch ].
					^ self reportLastMatch ].
			currentCharacter = $=
				ifTrue: [ 
					self recordMatch: #(1).
					self step.
					currentCharacter = $:
						ifTrue: [ ^ self recordAndReportMatch: #(44) ].
					^ self reportLastMatch ].
			^ self reportLastMatch ].
	currentCharacter = $;
		ifTrue: [ ^ self recordAndReportMatch: #(49) ].
	currentCharacter = $<
		ifTrue: [ 
			self recordMatch: #(35).
			self step.
			currentCharacter = $*
				ifTrue: [ ^ self recordAndReportMatch: #(80) ].
			currentCharacter = $=
				ifTrue: [ ^ self recordAndReportMatch: #(37) ].
			currentCharacter = $>
				ifTrue: [ ^ self recordAndReportMatch: #(33) ].
			^ self reportLastMatch ].
	currentCharacter = $=
		ifTrue: [ ^ self recordAndReportMatch: #(40) ].
	currentCharacter = $>
		ifTrue: [ 
			self recordMatch: #(42).
			self step.
			currentCharacter = $=
				ifTrue: [ ^ self recordAndReportMatch: #(41) ].
			^ self reportLastMatch ].
	currentCharacter = $?
		ifTrue: [ ^ self recordAndReportMatch: #(31) ].
	currentCharacter = $[
		ifTrue: [ ^ self recordAndReportMatch: #(75) ].
	currentCharacter = $\
		ifTrue: [ ^ self recordAndReportMatch: #(113) ].
	currentCharacter = $]
		ifTrue: [ ^ self recordAndReportMatch: #(67) ].
	currentCharacter = ${
		ifTrue: [ 
			self recordMatch: #(47).
			self step.
			currentCharacter = $*
				ifTrue: [ ^ self recordAndReportMatch: #(93) ].
			^ self reportLastMatch ].
	currentCharacter = $|
		ifTrue: [ 
			self recordMatch: #(96).
			self step.
			currentCharacter = $|
				ifTrue: [ ^ self recordAndReportMatch: #(60) ].
			^ self reportLastMatch ].
	currentCharacter = $}
		ifTrue: [ ^ self recordAndReportMatch: #(48) ].
	^ self reportLastMatch! !

!PlatypusExpressScanner methodsFor: 'generated-tokens' stamp: 'AlainPlantec 1/13/2012 15:39'!
stringId
	^128! !

!PlatypusExpressScanner methodsFor: 'scanning' stamp: 'apl 1/25/2007 11:12'!
tailRemark
	| rem remarkToken smaccToken |
	outputStream contents size > 2 
		ifTrue: 
			[rem := outputStream contents copyFrom: 3 to: outputStream contents size.
			remarkToken := PlatypusTailRemarkToken token: rem.
			rem notEmpty 
				ifTrue: 
					[(rem first = $" or: [rem first = $<]) 
						ifTrue: 
							[smaccToken := SmaCCToken 
										value: remarkToken
										start: start
										id: (Array with: self remarkRefId).
							matchActions := nil.
							returnMatchBlock value: smaccToken]]].
	outputStream reset.
	^ self whitespace! !

!PlatypusExpressScanner methodsFor: 'accessing' stamp: 'apl 11/12/2003 11:36'!
tokenList
	^ tokenList! !

!PlatypusExpressScanner methodsFor: 'scanning' stamp: 'apl 4/18/2006 22:48'!
white
	outputStream reset.
	tokenList add: PlatypusOneWhiteSpaceToken new.
	^ self whitespace! !

!PlatypusExpressScanner methodsFor: 'scanning' stamp: 'apl 4/18/2006 14:16'!
whitespace
	| tokenClass |
	outputStream contents
		do: [:c | (tokenClass := tokenClassifier
						tokenClassFromCharacter: c
						ifAbsent: [PlatypusOneWhiteSpaceToken])
				ifNotNil: [tokenList add: tokenClass new]].
	outputStream reset.
	^ super whitespace! !

SmaCCScanner subclass: #StepScanner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-STEP-core'!

!StepScanner class methodsFor: 'generated-initialization' stamp: 'AlainPlantec 5/24/2012 00:14'!
initializeKeywordMap
	keywordMap := Dictionary new.
	#(#(25 'END_SCOPE' 5) #(25 'SCOPE' 2) #(26 '.F.' 13) #(26 '.T.' 16) #(26 '.U.' 11))
		do: [ :each | (keywordMap at: each first ifAbsentPut: [ Dictionary new ]) at: (each at: 2) put: each last ].
	^ keywordMap! !

!StepScanner class methodsFor: 'generated-comments' stamp: 'AlainPlantec 5/24/2012 00:14'!
scannerDefinitionComment

	"<annotation>		: 		[\<] ;
<integer>		:		\d+;
<real>			:		<integer>\.<integer>?(e[\+\-]?<integer>+)?	;
<binary>		:		%[01]+	;
<string>			:		'([^']|'')*' ;
<encodedString>	:		\""[^\""]*\""	;
<identifier>		:		[A-Za-z]\w*	;
<enum>			:		\.\w*\.	;
<comment>		: 		\/ \* ( \w | \W )* \* \/	;
<tailRemark>		:		[\-][\-][^\n\r\f]* ;
<whitespace>		:		\s+	;"! !

!StepScanner methodsFor: 'scanning' stamp: 'AlainPlantec 5/12/2012 23:36'!
annotation
	[ 
	self step.
	currentCharacter ~= $> ] whileTrue.
	^ self whitespace ! !

!StepScanner methodsFor: 'generated-tokens' stamp: 'AlainPlantec 5/24/2012 00:14'!
emptySymbolTokenId
	^58! !

!StepScanner methodsFor: 'generated-tokens' stamp: 'AlainPlantec 5/24/2012 00:14'!
errorTokenId
	^59! !

!StepScanner methodsFor: 'generated-scanner' stamp: 'AlainPlantec 5/24/2012 00:14'!
keywordFor: aString 
	^aString asUppercase! !

!StepScanner methodsFor: 'generated-scanner' stamp: 'AlainPlantec 5/24/2012 00:14'!
scan1
	[ 
	self step.
	(currentCharacter <= $) or: [ (currentCharacter between: $+ and: $.) or: [ currentCharacter >= $0 ] ])
		ifTrue: [ ^ self scan2 ].
	currentCharacter = $* ] whileTrue.
	currentCharacter = $/
		ifTrue: [ 
			self recordMatch: #comment.
			self step.
			currentCharacter ~= $*
				ifTrue: [ ^ self scan2 ].
			currentCharacter = $*
				ifTrue: [ ^ self scan1 ].
			^ self reportLastMatch ].
	^ self reportLastMatch! !

!StepScanner methodsFor: 'generated-scanner' stamp: 'AlainPlantec 5/24/2012 00:14'!
scan2
	[ 
	self step.
	currentCharacter ~= $* ] whileTrue.
	currentCharacter = $*
		ifTrue: [ ^ self scan1 ].
	^ self reportLastMatch! !

!StepScanner methodsFor: 'generated-scanner' stamp: 'AlainPlantec 5/24/2012 00:14'!
scan3
	[ 
	self step.
	currentCharacter ~= $' ] whileTrue.
	currentCharacter = $'
		ifTrue: [ 
			self recordMatch: #(24).
			self step.
			currentCharacter = $'
				ifTrue: [ ^ self scan3 ].
			^ self reportLastMatch ].
	^ self reportLastMatch! !

!StepScanner methodsFor: 'generated-scanner' stamp: 'AlainPlantec 5/24/2012 00:14'!
scanForToken
	self step.
	((currentCharacter between: $A and: $D)
		or: [ 
			(currentCharacter between: $F and: $H)
				or: [ 
					(currentCharacter between: $J and: $Z)
						or: [ 
							(currentCharacter between: $a and: $d)
								or: [ (currentCharacter between: $f and: $h) or: [ currentCharacter between: $j and: $z ] ] ] ] ])
		ifTrue: [ 
			[ 
			self recordMatch: #(25).
			self step.
			(currentCharacter between: $0 and: $9)
				or: [ (currentCharacter between: $A and: $Z) or: [ currentCharacter = $_ or: [ currentCharacter between: $a and: $z ] ] ] ]
				whileTrue.
			^ self reportLastMatch ].
	(currentCharacter between: $0 and: $9)
		ifTrue: [ 
			[ 
			self recordMatch: #(21).
			self step.
			currentCharacter between: $0 and: $9 ] whileTrue.
			currentCharacter = $.
				ifTrue: [ 
					[ 
					self recordMatch: #(22).
					self step.
					currentCharacter between: $0 and: $9 ] whileTrue.
					(currentCharacter = $E or: [ currentCharacter = $e ])
						ifTrue: [ 
							self step.
							(currentCharacter between: $0 and: $9)
								ifTrue: [ 
									[ 
									self recordMatch: #(22).
									self step.
									currentCharacter between: $0 and: $9 ] whileTrue.
									^ self reportLastMatch ].
							(currentCharacter = $+ or: [ currentCharacter = $- ])
								ifTrue: [ 
									self step.
									(currentCharacter between: $0 and: $9)
										ifTrue: [ 
											[ 
											self recordMatch: #(22).
											self step.
											currentCharacter between: $0 and: $9 ] whileTrue.
											^ self reportLastMatch ].
									^ self reportLastMatch ].
							^ self reportLastMatch ].
					^ self reportLastMatch ].
			^ self reportLastMatch ].
	((currentCharacter between: Character tab and: Character cr) or: [ currentCharacter = Character space ])
		ifTrue: [ 
			[ 
			self recordMatch: #whitespace.
			self step.
			(currentCharacter between: Character tab and: Character cr) or: [ currentCharacter = Character space ] ] whileTrue.
			^ self reportLastMatch ].
	(currentCharacter = $E or: [ currentCharacter = $e ])
		ifTrue: [ 
			self recordMatch: #(25).
			self step.
			((currentCharacter between: $0 and: $9)
				or: [ 
					(currentCharacter between: $A and: $M)
						or: [ 
							(currentCharacter between: $O and: $Z)
								or: [ currentCharacter = $_ or: [ (currentCharacter between: $a and: $m) or: [ currentCharacter between: $o and: $z ] ] ] ] ])
				ifTrue: [ 
					[ 
					self recordMatch: #(25).
					self step.
					(currentCharacter between: $0 and: $9)
						or: [ (currentCharacter between: $A and: $Z) or: [ currentCharacter = $_ or: [ currentCharacter between: $a and: $z ] ] ] ]
						whileTrue.
					^ self reportLastMatch ].
			(currentCharacter = $N or: [ currentCharacter = $n ])
				ifTrue: [ 
					self recordMatch: #(25).
					self step.
					((currentCharacter between: $0 and: $9)
						or: [ 
							(currentCharacter between: $A and: $C)
								or: [ 
									(currentCharacter between: $E and: $Z)
										or: [ currentCharacter = $_ or: [ (currentCharacter between: $a and: $c) or: [ currentCharacter between: $e and: $z ] ] ] ] ])
						ifTrue: [ 
							[ 
							self recordMatch: #(25).
							self step.
							(currentCharacter between: $0 and: $9)
								or: [ (currentCharacter between: $A and: $Z) or: [ currentCharacter = $_ or: [ currentCharacter between: $a and: $z ] ] ] ]
								whileTrue.
							^ self reportLastMatch ].
					(currentCharacter = $D or: [ currentCharacter = $d ])
						ifTrue: [ 
							self recordMatch: #(25).
							self step.
							((currentCharacter between: $0 and: $9)
								or: [ (currentCharacter between: $A and: $Z) or: [ currentCharacter = $_ or: [ currentCharacter between: $a and: $z ] ] ])
								ifTrue: [ 
									[ 
									self recordMatch: #(25).
									self step.
									(currentCharacter between: $0 and: $9)
										or: [ (currentCharacter between: $A and: $Z) or: [ currentCharacter = $_ or: [ currentCharacter between: $a and: $z ] ] ] ]
										whileTrue.
									^ self reportLastMatch ].
							currentCharacter = $-
								ifTrue: [ 
									self step.
									(currentCharacter = $I or: [ currentCharacter = $i ])
										ifTrue: [ 
											self step.
											(currentCharacter = $S or: [ currentCharacter = $s ])
												ifTrue: [ 
													self step.
													(currentCharacter = $O or: [ currentCharacter = $o ])
														ifTrue: [ 
															self step.
															currentCharacter = $-
																ifTrue: [ 
																	self step.
																	currentCharacter = $1
																		ifTrue: [ 
																			self step.
																			currentCharacter = $0
																				ifTrue: [ 
																					self step.
																					currentCharacter = $3
																						ifTrue: [ 
																							self step.
																							currentCharacter = $0
																								ifTrue: [ 
																									self step.
																									currentCharacter = $3
																										ifTrue: [ 
																											self step.
																											currentCharacter = $-
																												ifTrue: [ 
																													self step.
																													currentCharacter = $2
																														ifTrue: [ 
																															self step.
																															currentCharacter = $1
																																ifTrue: [ ^ self recordAndReportMatch: #(10) ].
																															^ self reportLastMatch ].
																													^ self reportLastMatch ].
																											^ self reportLastMatch ].
																									^ self reportLastMatch ].
																							^ self reportLastMatch ].
																					^ self reportLastMatch ].
																			^ self reportLastMatch ].
																	^ self reportLastMatch ].
															^ self reportLastMatch ].
													^ self reportLastMatch ].
											^ self reportLastMatch ].
									^ self reportLastMatch ].
							^ self reportLastMatch ].
					^ self reportLastMatch ].
			^ self reportLastMatch ].
	(currentCharacter = $I or: [ currentCharacter = $i ])
		ifTrue: [ 
			self recordMatch: #(25).
			self step.
			((currentCharacter between: $0 and: $9)
				or: [ 
					(currentCharacter between: $A and: $R)
						or: [ 
							(currentCharacter between: $T and: $Z)
								or: [ currentCharacter = $_ or: [ (currentCharacter between: $a and: $r) or: [ currentCharacter between: $t and: $z ] ] ] ] ])
				ifTrue: [ 
					[ 
					self recordMatch: #(25).
					self step.
					(currentCharacter between: $0 and: $9)
						or: [ (currentCharacter between: $A and: $Z) or: [ currentCharacter = $_ or: [ currentCharacter between: $a and: $z ] ] ] ]
						whileTrue.
					^ self reportLastMatch ].
			(currentCharacter = $S or: [ currentCharacter = $s ])
				ifTrue: [ 
					self recordMatch: #(25).
					self step.
					((currentCharacter between: $0 and: $9)
						or: [ 
							(currentCharacter between: $A and: $N)
								or: [ 
									(currentCharacter between: $P and: $Z)
										or: [ currentCharacter = $_ or: [ (currentCharacter between: $a and: $n) or: [ currentCharacter between: $p and: $z ] ] ] ] ])
						ifTrue: [ 
							[ 
							self recordMatch: #(25).
							self step.
							(currentCharacter between: $0 and: $9)
								or: [ (currentCharacter between: $A and: $Z) or: [ currentCharacter = $_ or: [ currentCharacter between: $a and: $z ] ] ] ]
								whileTrue.
							^ self reportLastMatch ].
					(currentCharacter = $O or: [ currentCharacter = $o ])
						ifTrue: [ 
							self recordMatch: #(25).
							self step.
							((currentCharacter between: $0 and: $9)
								or: [ (currentCharacter between: $A and: $Z) or: [ currentCharacter = $_ or: [ currentCharacter between: $a and: $z ] ] ])
								ifTrue: [ 
									[ 
									self recordMatch: #(25).
									self step.
									(currentCharacter between: $0 and: $9)
										or: [ (currentCharacter between: $A and: $Z) or: [ currentCharacter = $_ or: [ currentCharacter between: $a and: $z ] ] ] ]
										whileTrue.
									^ self reportLastMatch ].
							currentCharacter = $-
								ifTrue: [ 
									self step.
									currentCharacter = $1
										ifTrue: [ 
											self step.
											currentCharacter = $0
												ifTrue: [ 
													self step.
													currentCharacter = $3
														ifTrue: [ 
															self step.
															currentCharacter = $0
																ifTrue: [ 
																	self step.
																	currentCharacter = $3
																		ifTrue: [ 
																			self step.
																			currentCharacter = $-
																				ifTrue: [ 
																					self step.
																					currentCharacter = $2
																						ifTrue: [ 
																							self step.
																							currentCharacter = $1
																								ifTrue: [ ^ self recordAndReportMatch: #(6) ].
																							^ self reportLastMatch ].
																					^ self reportLastMatch ].
																			^ self reportLastMatch ].
																	^ self reportLastMatch ].
															^ self reportLastMatch ].
													^ self reportLastMatch ].
											^ self reportLastMatch ].
									^ self reportLastMatch ].
							^ self reportLastMatch ].
					^ self reportLastMatch ].
			^ self reportLastMatch ].
	currentCharacter = $#
		ifTrue: [ ^ self recordAndReportMatch: #(9) ].
	currentCharacter = $$
		ifTrue: [ ^ self recordAndReportMatch: #(18) ].
	currentCharacter = $%
		ifTrue: [ 
			self step.
			(currentCharacter between: $0 and: $1)
				ifTrue: [ 
					[ 
					self recordMatch: #(23).
					self step.
					currentCharacter between: $0 and: $1 ] whileTrue.
					^ self reportLastMatch ].
			^ self reportLastMatch ].
	currentCharacter = $'
		ifTrue: [ ^ self scan3 ].
	currentCharacter = $(
		ifTrue: [ ^ self recordAndReportMatch: #(4) ].
	currentCharacter = $)
		ifTrue: [ ^ self recordAndReportMatch: #(3) ].
	currentCharacter = $*
		ifTrue: [ ^ self recordAndReportMatch: #(19) ].
	currentCharacter = $+
		ifTrue: [ ^ self recordAndReportMatch: #(12) ].
	currentCharacter = $,
		ifTrue: [ ^ self recordAndReportMatch: #(15) ].
	currentCharacter = $-
		ifTrue: [ 
			self recordMatch: #(14).
			self step.
			currentCharacter = $-
				ifTrue: [ 
					[ 
					self recordMatch: #tailRemark.
					self step.
					currentCharacter <= Character tab
						or: [ currentCharacter = Character pageUp or: [ currentCharacter >= (Character value: 14) ] ] ] whileTrue.
					^ self reportLastMatch ].
			^ self reportLastMatch ].
	currentCharacter = $.
		ifTrue: [ 
			[ 
			self step.
			(currentCharacter between: $0 and: $9)
				or: [ (currentCharacter between: $A and: $Z) or: [ currentCharacter = $_ or: [ currentCharacter between: $a and: $z ] ] ] ]
				whileTrue.
			currentCharacter = $.
				ifTrue: [ ^ self recordAndReportMatch: #(26) ].
			^ self reportLastMatch ].
	currentCharacter = $/
		ifTrue: [ 
			self recordMatch: #(1).
			self step.
			currentCharacter = $*
				ifTrue: [ ^ self scan2 ].
			^ self reportLastMatch ].
	currentCharacter = $:
		ifTrue: [ ^ self recordAndReportMatch: #(17) ].
	currentCharacter = $;
		ifTrue: [ ^ self recordAndReportMatch: #(7) ].
	currentCharacter = $<
		ifTrue: [ ^ self recordAndReportMatch: #annotation ].
	currentCharacter = $=
		ifTrue: [ ^ self recordAndReportMatch: #(8) ].
	^ self reportLastMatch! !

!StepScanner methodsFor: 'scanning' stamp: 'AlainPlantec 5/12/2012 23:06'!
tailRemark
	^ self whitespace! !

Object subclass: #PlatypusAbstractTranslaterInterface
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-translater-public'!

!PlatypusAbstractTranslaterInterface class methodsFor: 'accessing' stamp: 'AlainPlantec 7/14/2011 16:55'!
translaterClass
	^ PlatypusPharoSmalltalk at: self translaterClassName asSymbol! !

!PlatypusAbstractTranslaterInterface class methodsFor: 'accessing' stamp: 'apl 2/1/2007 16:15'!
translaterClassName
	^ self subclassResponsibility ! !

!PlatypusAbstractTranslaterInterface methodsFor: 'public accessing' stamp: 'apl 2/15/2007 16:05'!
localTranslate: aMetaData 
	| translater |
	translater := self translaterClass namesBuilder: aMetaData namesBuilder.
	translater localTranslationOnly: true.
	^ self translate: aMetaData withStructureTranslater: translater! !

!PlatypusAbstractTranslaterInterface methodsFor: 'public accessing' stamp: 'apl 2/15/2007 16:05'!
translate: aMetaData 
	| translater |
	translater := self translaterClass namesBuilder: aMetaData namesBuilder.
	^ self translate: aMetaData withStructureTranslater: translater! !

!PlatypusAbstractTranslaterInterface methodsFor: 'public accessing' stamp: 'apl 2/15/2007 15:54'!
translate: aMetaData withStructureTranslater: aTranslater 
	^ aTranslater translate: aMetaData! !

!PlatypusAbstractTranslaterInterface methodsFor: 'accessing' stamp: 'apl 2/15/2007 15:35'!
translaterClass
	^ self class translaterClass
	! !

PlatypusAbstractTranslaterInterface subclass: #PlatypusToPharoTranslater
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-translater-public'!

!PlatypusToPharoTranslater class methodsFor: 'accessing' stamp: 'AlainPlantec 7/14/2011 18:10'!
translaterClassName
	^ #PlatypusExpressStructure2PharoTranslater ! !

PlatypusAbstractTranslaterInterface subclass: #PlatypusToVisualWorksTranslater
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-translater-public'!

!PlatypusToVisualWorksTranslater class methodsFor: 'accessing' stamp: 'apl 2/15/2007 15:57'!
translaterClassName
	^ #PlatypusExpressStructure2VWTranslater! !

Object subclass: #PlatypusAttributeIdentification
	instanceVariableNames: 'definition globalPos localPos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-interpreter'!

!PlatypusAttributeIdentification class methodsFor: 'instance creation' stamp: 'apl 2/4/2006 09:27'!
definition: aPltAttribute globalPos: gpos localPos: lpos
	^ self new definition: aPltAttribute globalPos: gpos localPos: lpos! !

!PlatypusAttributeIdentification methodsFor: 'accessing' stamp: 'apl 2/4/2006 08:52'!
definition
	^definition! !

!PlatypusAttributeIdentification methodsFor: 'accessing' stamp: 'apl 2/4/2006 08:52'!
definition: anObject
	definition := anObject! !

!PlatypusAttributeIdentification methodsFor: 'accessing' stamp: 'apl 2/4/2006 09:28'!
definition: aPltAttribute globalPos: gpos localPos: lpos 
	self definition: aPltAttribute.
	self globalPos: gpos.
	self localPos: lpos ! !

!PlatypusAttributeIdentification methodsFor: 'accessing' stamp: 'apl 2/4/2006 08:52'!
globalPos
	^globalPos! !

!PlatypusAttributeIdentification methodsFor: 'accessing' stamp: 'apl 2/4/2006 08:52'!
globalPos: anObject
	globalPos := anObject! !

!PlatypusAttributeIdentification methodsFor: 'accessing' stamp: 'apl 2/4/2006 08:52'!
localPos
	^localPos! !

!PlatypusAttributeIdentification methodsFor: 'accessing' stamp: 'apl 2/4/2006 08:52'!
localPos: anObject
	localPos := anObject! !

!PlatypusAttributeIdentification methodsFor: 'printing' stamp: 'apl 2/4/2006 10:27'!
printOn: aStream 
	aStream nextPutAll: self class name , '('.
	self definition owner name printOn: aStream.
	aStream nextPutAll: '>>'.
	self definition name printOn: aStream.
	aStream nextPut: Character space.
	self globalPos printOn: aStream.
	aStream nextPut: Character space.
	self localPos printOn: aStream.
	aStream nextPut: $)! !

Object subclass: #PlatypusComplexInstance
	instanceVariableNames: 'records'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-core'!

!PlatypusComplexInstance class methodsFor: 'instance creation' stamp: 'apl 3/11/2005 21:53'!
fromRecords: aListOfRecords
	^ self new addAllRecords: aListOfRecords! !

!PlatypusComplexInstance methodsFor: 'operator' stamp: 'AlainPlantec 7/14/2011 16:55'!
\ aClassSymbol 
	| classif groupClass res resRecords curr selector o |
	groupClass := PlatypusPharoSmalltalk at: aClassSymbol.
	(classif := records
				detect: [:rec | rec isKindOf: groupClass]
				ifNone: [])
		ifNil: [self error: 'invalid group: ' , aClassSymbol].
	res := self class new.
	resRecords := OrderedCollection new.
	curr := classif class.
	[curr == Object
		or: [curr name == aClassSymbol]]
		whileFalse: [curr := curr superclass].
	[curr class includesSelector: #schemaDefinition]
		whileTrue: [selector := PlatypusNamesBuilder new localCopyMethodNameFromEntity: curr platypusMetaData.
			o := curr new.
			classif perform: selector asSymbol with: o.
			resRecords add: o.
			curr := curr superclass].
	res records: resRecords.
	^ res! !

!PlatypusComplexInstance methodsFor: 'private adding' stamp: 'apl 3/6/2005 23:05'!
add: anObject
	self records add: anObject! !

!PlatypusComplexInstance methodsFor: 'adding' stamp: 'apl 3/11/2005 21:52'!
addAllRecords: aListOfRecords
	aListOfRecords do: [ :rec | self addRecord: rec] 
! !

!PlatypusComplexInstance methodsFor: 'adding' stamp: 'apl 3/11/2005 21:58'!
addRecord: aRecord 
	aRecord pltAddIntoComplexeInstance: self.! !

!PlatypusComplexInstance methodsFor: 'converting' stamp: 'apl 3/6/2005 23:02'!
asPlatypusComplexInstance
	^ self! !

!PlatypusComplexInstance methodsFor: 'message handling' stamp: 'apl 12/8/2006 08:47'!
doesNotUnderstand: aMessage 
	| found args newMessage wrappedSelector |
	(found := self records reversed detect: [:rec | rec respondsTo: aMessage selector]
				ifNone: [^ super doesNotUnderstand: aMessage]) ifNotNil: 
				[wrappedSelector := (aMessage selector , 'receiver:') asSymbol.
				(found respondsTo: wrappedSelector) 
					ifTrue: 
						[args := Array new: aMessage arguments size + 1.
						1 to: aMessage arguments size
							do: [:pos | args at: pos put: (aMessage arguments at: pos)].
						args at: aMessage arguments size + 1 put: self.
						newMessage := Message selector: wrappedSelector asSymbol arguments: args.
						^ newMessage sendTo: found]
					ifFalse: 
						[aMessage arguments ifEmpty: 
								[args := Array with: nil.
								wrappedSelector := (aMessage selector , 'UsingContext:') asSymbol.
								newMessage := Message selector: wrappedSelector asSymbol arguments: args.
								^ newMessage sendTo: self].
						^ aMessage sendTo: found]]! !

!PlatypusComplexInstance methodsFor: 'initialize-release' stamp: 'apl 3/6/2005 23:05'!
initialize
	super initialize.
	records := OrderedCollection new.! !

!PlatypusComplexInstance methodsFor: 'class membership' stamp: 'alain.plantec 1/24/2009 09:19'!
isKindOf:  aClass 
	(super isKindOf:  aClass ) ifTrue: [^true].
	self records do: [:rec | (rec isKindOf: aClass) ifTrue: [^true]].
	^ false! !

!PlatypusComplexInstance methodsFor: 'message handling' stamp: 'apl 9/5/2006 12:51'!
name
	^ self doesNotUnderstand: (Message selector: #name)! !

!PlatypusComplexInstance methodsFor: 'adding' stamp: 'apl 3/11/2005 22:00'!
pltAddIntoComplexeInstance: aComplexInstance 
	aComplexInstance addAllRecords: records.! !

!PlatypusComplexInstance methodsFor: 'converting' stamp: 'apl 3/11/2005 22:03'!
pltAsObject
	records size = 1
		ifTrue: [^ records first].
	^ self! !

!PlatypusComplexInstance methodsFor: 'private adding' stamp: 'apl 1/18/2007 12:58'!
privateAddRecord: aRecord 
	| classif |
	(classif := self records detect: [:r | r isKindOf: aRecord class]
				ifNone: []) ifNil: 
				[(classif := self records detect: [:r | aRecord isKindOf: r class]
							ifNone: []) ifNotNil: 
							[self remove: classif.
							classif pltLocalCopyTo: aRecord].
				self add: aRecord]
			ifNotNil: [aRecord pltLocalCopyTo: classif]! !

!PlatypusComplexInstance methodsFor: 'private accessing' stamp: 'apl 3/6/2005 22:52'!
records
	^records! !

!PlatypusComplexInstance methodsFor: 'private accessing' stamp: 'apl 3/6/2005 22:52'!
records: anObject
	records := anObject! !

!PlatypusComplexInstance methodsFor: 'private accessing' stamp: 'apl 3/8/2005 12:34'!
remove: anObject 
	self records remove: anObject! !

Object subclass: #PlatypusCoreAbstractVisitor
	instanceVariableNames: 'logClient logLevel visitPath visitErrors acceptSelectorsMap objectsWithErrorIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-core'!

PlatypusCoreAbstractVisitor subclass: #PlatypusAbstractVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusMetaSchemasSchemaInstance'!

!PlatypusAbstractVisitor class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PlatypusAbstractVisitor class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PlatypusAbstractVisitor class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptAggrUnaryExpression: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusAggregateDataSchema' stamp: ''!
acceptAggregateData: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusAggregateDataSchema' stamp: ''!
acceptAggregateInitializer: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptAggregateInitializerDomain: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusAggregateDataSchema' stamp: ''!
acceptAggregateInitializerElement: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusAggregateDataSchema' stamp: ''!
acceptAggregateInstance: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptAggregateType: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptAggregationType: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptAlgorithmDeclaration: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptAlgorithmRef: e  "my subclasses have to redefine it"

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusStatementsSchema' stamp: ''!
acceptAliasStatement: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusStatementsSchema' stamp: ''!
acceptAliasStatementVariable: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptAndExpression: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptAndSupertype: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptAndorSupertype: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusStatementsSchema' stamp: ''!
acceptAnonymousVariable: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusPopulationSchema' stamp: ''!
acceptApplicationInstance: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptArithmeticExpression: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusAggregateDataSchema' stamp: ''!
acceptArrayInstance: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptArrayType: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusStatementsSchema' stamp: ''!
acceptAssignable: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusStatementsSchema' stamp: ''!
acceptAssignmentStatement: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptAttribute: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptAttributeIdentifier: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptAttributeQualifier: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptAttributeReference: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusAggregateDataSchema' stamp: ''!
acceptBagInstance: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptBagType: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptBinaryExpression: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptBinaryLiteral: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptBinarySupertypeExpression: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptBinaryType: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptBooleanType: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptBound: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptCardinalityExpression: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusStatementsSchema' stamp: ''!
acceptCaseAction: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusStatementsSchema' stamp: ''!
acceptCaseStatement: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptComparisonExpression: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusStatementsSchema' stamp: ''!
acceptCompoundStatement: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptConstantDefinition: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptContextDefinition: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptContextRef: e  "my subclasses have to redefine it"

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptDefinedType: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptDefinedTypeReference: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptDerivedAttribute: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptDictionaryInstance: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptDictionaryInstanceReference: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptDivExpression: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptDomainEquivalentItem: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptEConstant: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptElementQualifier: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptElementRef: e  "my subclasses have to redefine it"

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptElementReference: e  "my subclasses have to redefine it"

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptEmbeddedRemark: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusStatementsSchema' stamp: ''!
acceptEndSplitmarkStatement: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptEntityDefinition: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptEntityDefinitionReference: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptEntityInstance: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptEntityInstanceConstructor: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptEntityInstanceReference: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptEntityInstancesSet: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptEntityReference: e  "my subclasses have to redefine it"

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptEnumerationType: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptEnumerationValue: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptEqualExpression: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusStatementsSchema' stamp: ''!
acceptEscapeStatement: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptEscapedExpression: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptExplicitAttribute: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptExpoExpression: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptExpression: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusPopulationSchema' stamp: ''!
acceptExternalGroupRepresentation: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptExternalMetaSchema: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusPopulationSchema' stamp: ''!
acceptExternalRepresentation: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptExternalSchema: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptFalseConstant: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusPopulationSchema' stamp: ''!
acceptFileDescription: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusPopulationSchema' stamp: ''!
acceptFileName: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusPopulationSchema' stamp: ''!
acceptFileSchema: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptFunctionDeclaration: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptGeneralAggregateType: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusPopulationSchema' stamp: ''!
acceptGenericInstance: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptGenericType: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptGlobalRule: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptGreaterEqualExpression: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptGreaterThanExpression: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptGroupQualifier: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusPopulationSchema' stamp: ''!
acceptGroupRepresentation: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusPopulationSchema' stamp: ''!
acceptHeaderInstance: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptIdentifier: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusStatementsSchema' stamp: ''!
acceptIfStatement: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptImplicitlyDeclaredIdentifier: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptInExpression: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptIncludeSchema: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusStatementsSchema' stamp: ''!
acceptIncrementControl: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusStatementsSchema' stamp: ''!
acceptIncrementControlVariable: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptIndexQualifier: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptInstComparisonExpression: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptInstEqualExpression: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptInstNotEqualExpression: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptInstanceConstructionExpression: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusPopulationSchema' stamp: ''!
acceptInstanceScope: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptIntegerBound: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptIntegerLiteral: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptIntegerType: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusPopulationSchema' stamp: ''!
acceptInternalGroupRepresentation: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusPopulationSchema' stamp: ''!
acceptInternalRepresentation: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptInterval: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptInverseAttribute: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptLessEqualExpression: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptLessThanExpression: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptLikeExpression: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusAggregateDataSchema' stamp: ''!
acceptListInstance: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptListType: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptLiteral: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptLocalVariable: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptLogicalExpression: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptLogicalLiteral: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptLogicalType: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptMetaConceptDefinition: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptMetaMappingDefinition: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptMetaMappingRule: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptMinusExpression: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptMissingValue: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptModExpression: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusEnvironmentSchema' stamp: ''!
acceptModelContents: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptMultExpression: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptNamedType: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptNamedTypeRef: e  "my subclasses have to redefine it"

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptNamedTypeReference: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptNativeAlgorithm: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptNativeCode: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptNativeExpression: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusStatementsSchema' stamp: ''!
acceptNativeStatement: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptNegativeExpression: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptNotEqualExpression: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptNotExpression: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusStatementsSchema' stamp: ''!
acceptNullStatement: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptNumberType: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptNumericLiteral: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptOneofSupertypeExpression: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptOrExpression: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusStatementsSchema' stamp: ''!
acceptOutputStatement: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptParameterDefinition: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptPiConstant: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptPlusExpression: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptPopulationDependentBound: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptPositiveExpression: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusStatementsSchema' stamp: ''!
acceptProcedureCallStatement: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptProcedureDeclaration: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptQualifiedExpression: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptQualifier: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptQueryExpression: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptQueryVariable: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptRangeQualifier: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptRealDivExpression: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptRealLiteral: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptRealType: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptRedefinedAttributeValue: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptReferencedSchema: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptRemark: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptRemarkReference: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusStatementsSchema' stamp: ''!
acceptRepeatStatement: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusStatementsSchema' stamp: ''!
acceptReturnStatement: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptRuleRef: e  "my subclasses have to redefine it"

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptSchemaDefinition: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusEnvironmentSchema' stamp: ''!
acceptSchemaInstance: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptSchemaInstanceRef: e  "my subclasses have to redefine it"

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptSchemaRef: e  "my subclasses have to redefine it"

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptSchemaReference: e  "my subclasses have to redefine it"

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptSdaiInstance: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptSelectType: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptSelfIdentifier: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptSessionInstance: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusAggregateDataSchema' stamp: ''!
acceptSetInstance: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptSetType: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusPopulationSchema' stamp: ''!
acceptSimpleRecord: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptSimpleType: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptSimpleUnaryExpression: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusStatementsSchema' stamp: ''!
acceptSkipStatement: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusStatementsSchema' stamp: ''!
acceptSplitmarkStatement: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusStatementsSchema' stamp: ''!
acceptStatement: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptStatementsContainer: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptStringLiteral: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptStringType: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptSubEntityRefExpression: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptSupertypeConstraint: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptSupertypeExpression: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptTailRemark: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptTrueConstant: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptTypedExpression: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptUnaryExpression: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptUniquenessRule: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptUniquenessRuleAttributeIdentifier: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptUnknownConstant: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptUsedSchema: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusPopulationSchema' stamp: ''!
acceptUserDefinedApplicationInstance: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusPopulationSchema' stamp: ''!
acceptUserDefinedHeaderInstance: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusAggregateDataSchema' stamp: ''!
acceptVariableSizeAggregationInstance: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptVariableSizeAggregationType: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusDictionarySchema' stamp: ''!
acceptWhereRule: e
	"my subclasses have to redefine it"

	

! !

!PlatypusAbstractVisitor methodsFor: 'platypus-generated-visitingPlatypusExpressionsSchema' stamp: ''!
acceptXorExpression: e
	"my subclasses have to redefine it"

	

! !

!PlatypusCoreAbstractVisitor class methodsFor: 'instance creation' stamp: 'apl 5/26/2005 09:17'!
accept: e
	^ e accept: self new.! !

!PlatypusCoreAbstractVisitor class methodsFor: 'instance creation' stamp: 'apl 4/1/2006 16:00'!
visitPath: aStack 
	^self new visitPath: aStack ! !

!PlatypusCoreAbstractVisitor methodsFor: 'accessing' stamp: 'apl 5/25/2005 21:58'!
acceptSelectorsMap
	^ acceptSelectorsMap! !

!PlatypusCoreAbstractVisitor methodsFor: 'visit generic' stamp: 'AlainPlantec 6/13/2012 23:21'!
acceptTry: anObject
	self 
		asVisitPathTop: anObject 
		while: [^ self performAcceptFor: anObject]! !

!PlatypusCoreAbstractVisitor methodsFor: 'error handling' stamp: 'AlainPlantec 6/13/2012 12:16'!
addVisitorError: aVisitorError 
	(self visitErrors size < 30) 
		ifTrue: [
			(self visitErrors noneSatisfy: [:err | 
				err message = aVisitorError message and: [err path = aVisitorError path]])
				ifFalse: [^ false ].
			visitErrors add: aVisitorError.
			^ true].
	^ false! !

!PlatypusCoreAbstractVisitor methodsFor: 'visit generic' stamp: 'AlainPlantec 5/19/2012 23:07'!
asVisitPathTop: anObjectOrCollection while: aBlock
	anObjectOrCollection ifNil: [^self ].
	self pushIntoVisitPath: anObjectOrCollection.
	aBlock
		ensure: [self popFromVisitPath]! !

!PlatypusCoreAbstractVisitor methodsFor: 'copying' stamp: 'apl 4/13/2006 18:16'!
copy
	| cpy |
	cpy := super copy.
	cpy forget.
	^ cpy! !

!PlatypusCoreAbstractVisitor methodsFor: 'error handling' stamp: 'AlainPlantec 6/14/2012 00:58'!
declareWithError: e 
	objectsWithErrorIndex add: e
				! !

!PlatypusCoreAbstractVisitor methodsFor: 'error handling' stamp: 'AlainPlantec 6/14/2012 00:58'!
declareWithoutError: e 
	objectsWithErrorIndex
		remove: e
		ifAbsent: []
! !

!PlatypusCoreAbstractVisitor methodsFor: 'error handling' stamp: 'AlainPlantec 6/14/2012 00:59'!
declaredWithError: e 
	^ objectsWithErrorIndex includes: e
! !

!PlatypusCoreAbstractVisitor methodsFor: 'initialize/release' stamp: 'apl 6/3/2005 16:46'!
destroy
	super destroy.
	logClient ifNotNil: 
			[logClient := nil].
	visitPath := nil.
	visitErrors do: [:e | e destroy].
	visitErrors := nil.
	acceptSelectorsMap := nil! !

!PlatypusCoreAbstractVisitor methodsFor: 'accessing' stamp: 'apl 2/17/2006 18:45'!
errors
	^ self visitErrors
! !

!PlatypusCoreAbstractVisitor methodsFor: 'initialize/release' stamp: 'apl 6/10/2005 11:27'!
forget
	self initializeVisitErrors.
	self initializeObjectsWithErrorIndex! !

!PlatypusCoreAbstractVisitor methodsFor: 'error handling' stamp: 'apl 5/25/2005 21:58'!
haveError
	^ visitErrors notEmpty! !

!PlatypusCoreAbstractVisitor methodsFor: 'initialize/release' stamp: 'AlainPlantec 5/8/2012 20:23'!
initialize
	| logClientClass |
	super initialize.
	logLevel := #NoLog.
	"logLevel := #debug."
	(logClientClass := Smalltalk
				at: #LogClient
				ifAbsent: [])
		ifNotNil: [logClient := logClientClass getInstance: self class name].
	visitPath := PlatypusStack new.
	visitErrors := OrderedCollection new.
	acceptSelectorsMap := SmallIdentityDictionary new.
	self initializeObjectsWithErrorIndex! !

!PlatypusCoreAbstractVisitor methodsFor: 'error handling' stamp: 'AlainPlantec 6/14/2012 00:59'!
initializeObjectsWithErrorIndex
	objectsWithErrorIndex := IdentitySet new! !

!PlatypusCoreAbstractVisitor methodsFor: 'error handling' stamp: 'apl 5/25/2005 21:58'!
initializeVisitErrors
	visitErrors := OrderedCollection new.
! !

!PlatypusCoreAbstractVisitor methodsFor: 'accessing' stamp: 'apl 5/25/2005 21:58'!
logClient
	^ logClient! !

!PlatypusCoreAbstractVisitor methodsFor: 'logging' stamp: 'apl 2/4/2006 11:39'!
logInfo: aMessage 
	logLevel ~= #NoLog
		ifTrue: [self logClient
				ifNil: [Transcript show: Time now printString , ': ' , aMessage , '\' withCRs]
				ifNotNil: [self logClient info: aMessage asString]]! !

!PlatypusCoreAbstractVisitor methodsFor: 'accessing' stamp: 'apl 2/4/2006 11:38'!
logLevel
	^ logLevel! !

!PlatypusCoreAbstractVisitor methodsFor: 'accessing' stamp: 'apl 2/4/2006 11:39'!
logLevel: aSymbol
	logLevel := aSymbol! !

!PlatypusCoreAbstractVisitor methodsFor: 'logging' stamp: 'apl 5/25/2005 21:58'!
logPathAndInfo: aMessage 
	| mess contexts |
	logLevel == #debug
		ifTrue: [mess := WriteStream on: String new.
			contexts := visitPath asArray
						select: [:p | p isCollection not
								and: [p isPltContextDefinition]].
			contexts
				do: [:p | mess nextPutAll: p name]
				separatedBy: [mess nextPutAll: ' | '].
			self logInfo: mess contents , ': ' , aMessage]! !

!PlatypusCoreAbstractVisitor methodsFor: 'visit generic' stamp: 'AlainPlantec 5/8/2012 20:15'!
lookUpAndCacheAcceptSelectorOfClass: aClass 
	| currClass str |
	currClass := aClass.
	str := WriteStream on: (String new: 50).
	[currClass ~~ Object]
		whileTrue: [ | n selector |
			n := currClass name.
			str nextPutAll: 'accept'.
			4 to: n size do: [:p | str nextPut: (n at: p) ].
			str nextPut: $:.
			selector := str contents asSymbol.
			(self class whichClassIncludesSelector: selector)
				ifNotNil: [:cls |
					self acceptSelectorsMap at: cls put: selector.
					^ selector].
			str reset.
			currClass := currClass superclass].
	^ self error: 'unimplemented accept method for class ''' , aClass name , ''''! !

!PlatypusCoreAbstractVisitor methodsFor: 'error handling' stamp: 'apl 6/10/2005 11:26'!
objectsWithErrorIndex
	^ objectsWithErrorIndex
! !

!PlatypusCoreAbstractVisitor methodsFor: 'error handling' stamp: 'AlainPlantec 6/14/2012 00:18'!
pathTo: aDictionaryInstance
	^ aDictionaryInstance inclusiveOwnerPath ! !

!PlatypusCoreAbstractVisitor methodsFor: 'visit generic' stamp: 'AlainPlantec 5/19/2012 23:10'!
performAcceptFor: anObject
	| selector |
	selector := 
		acceptSelectorsMap
			at: anObject class
			ifAbsent: [self lookUpAndCacheAcceptSelectorOfClass: anObject class].
	^ self perform: selector with: anObject! !

!PlatypusCoreAbstractVisitor methodsFor: 'accessing' stamp: 'AlainPlantec 5/13/2012 09:09'!
popFromVisitPath
	^ visitPath pop
! !

!PlatypusCoreAbstractVisitor methodsFor: 'accessing' stamp: 'AlainPlantec 5/13/2012 09:09'!
pushIntoVisitPath: anObject 
	visitPath push: anObject
! !

!PlatypusCoreAbstractVisitor methodsFor: 'error handling' stamp: 'AlainPlantec 6/14/2012 00:04'!
registerError: aVisitorError
	(self addVisitorError: aVisitorError)
		ifTrue: [ aVisitorError path last inclusiveOwnerPath do: [:p | p addError: aVisitorError]]! !

!PlatypusCoreAbstractVisitor methodsFor: 'accessing' stamp: 'apl 5/25/2005 21:58'!
visitContexts: aCollection 
	aCollection
		do: [:el | self pushIntoVisitPath: el]! !

!PlatypusCoreAbstractVisitor methodsFor: 'accessing' stamp: 'AlainPlantec 5/24/2012 00:18'!
visitErrors
	^ visitErrors! !

!PlatypusCoreAbstractVisitor methodsFor: 'accessing' stamp: 'apl 4/1/2006 16:00'!
visitPath: aStack
	visitPath := aStack! !

!PlatypusCoreAbstractVisitor methodsFor: 'accessing' stamp: 'apl 5/25/2005 21:58'!
visitedInstances
	| |
	^ visitPath asArray! !

PlatypusCoreAbstractVisitor subclass: #PlatypusStepAbstractVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-visitors'!

PlatypusStepAbstractVisitor subclass: #PlatypusExpressInterpretor
	instanceVariableNames: 'modelContentsAccessBlock stack contextsStack argsStack requestor splitMarkStack checksAssignments selfStack debugger'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-interpreter'!

!PlatypusExpressInterpretor methodsFor: 'visit aggregate data schema' stamp: 'apl 3/17/2006 13:45'!
acceptAggregateData: e 
	| interpreted contents domain var |
	interpreted := e class new stepInitialize.
	contents := OrderedCollection new.
	domain := e computedDomain.
	var := PltAnonymousVariable domain: domain.
	e contents
		do: [:i | 
			i acceptTry: self.
			contents add: self popVal].
	interpreted contents: contents.
	^ self pushVar: var val: interpreted! !

!PlatypusExpressInterpretor methodsFor: 'visit aggregate data schema' stamp: 'apl 3/1/2004 22:15'!
acceptAggregateInitializer: e 
	| interpreted contents el domain var |
	interpreted := PltAggregateInitializer new.
	contents := OrderedCollection new.
	domain := e computedDomain.
	var := PltAnonymousVariable domain: domain.
	e contents
		do: [:i | 
			el := PltAggregateInitializerElement new.
			i val acceptTry: self.
			el val: self popVal.
			i repetition
				ifNotNil: [i repetition acceptTry: self.
					el repetition: self popVal].
			contents add: el].
	interpreted contents: contents.
	^ self pushVar: var val: interpreted
! !

!PlatypusExpressInterpretor methodsFor: 'visit dictionary schema' stamp: 'AlainPlantec 5/4/2012 10:05'!
acceptAlgorithmDeclaration: e 
	self
		asContext: e
		while: [self acceptStatementsContainer: e]! !

!PlatypusExpressInterpretor methodsFor: 'visit statements schema' stamp: 'apl 12/17/2003 23:06'!
acceptAliasStatement: e 
	^ self
		asContext: e
		while: [e statements
				do: [:stmt | stmt acceptTry: self]]! !

!PlatypusExpressInterpretor methodsFor: 'visit statements schema' stamp: 'apl 3/27/2006 17:19'!
acceptAliasStatementVariable: e 
	| aliasStackElement |
	(aliasStackElement := self localData: e)
		ifNil: [e referenced acceptTry: self.
			aliasStackElement := self top.
			self localData: e value: aliasStackElement]
		ifNotNil: [self push: aliasStackElement]! !

!PlatypusExpressInterpretor methodsFor: 'visit expressions schema' stamp: 'apl 2/23/2005 22:10'!
acceptAndExpression: e 
	| right left |
	e leftExpr acceptTry: self.
	(left := self popVal)
		ifMissing: [^ self pushVal: PltUnknownConstant new]
		ifNotMissing: [left isPltLogicalLiteral
				ifFalse: [PlatypusExpressInvalidArgumentException signal: 'invalid left argument'].
			left
				ifFalseOrUnknownConstant: [^ self pushVal: left].
			e rightExpr acceptTry: self.
			right := self popVal.
			^ self pushVal: right]! !

!PlatypusExpressInterpretor methodsFor: 'visit statements schema' stamp: 'apl 3/31/2006 09:49'!
acceptAssignable: e 
	e head acceptTry: self.
		self doQualifiers: e qualifiers! !

!PlatypusExpressInterpretor methodsFor: 'visit statements schema' stamp: 'AlainPlantec 10/7/2010 13:46'!
acceptAssignmentStatement: e 
	| rightValue currStackElement |
	e rightExpr acceptTry: self.
	rightValue := self popVal.
	e left acceptTry: self.
	currStackElement := self pop.
	currStackElement assign: rightValue! !

!PlatypusExpressInterpretor methodsFor: 'visit dictionary schema' stamp: 'apl 3/31/2006 09:11'!
acceptAttributeIdentifier: e 
self
	asValOfSelf: e selfInstance
	while: [self acceptIdentifier: e]! !

!PlatypusExpressInterpretor methodsFor: 'visit expressions schema' stamp: 'apl 12/20/2005 10:03'!
acceptAttributeQualifier: e 
	| stackElement |
	stackElement := self pop.
	stackElement pushAttribute: e attributeName! !

!PlatypusExpressInterpretor methodsFor: 'visit dictionary schema' stamp: 'apl 7/21/2004 14:42'!
acceptAttributeReference: e 
	| |
	self acceptTry: e ref.
! !

!PlatypusExpressInterpretor methodsFor: 'visit statements schema' stamp: 'apl 2/23/2005 22:26'!
acceptCaseAction: e 
	| selector |
	selector := self popVal.
	(e labels
			anySatisfy: [:l | 
				l acceptTry: self.
				(self popVal equal: selector) isPltTrueConstant])
		ifTrue: [e action acceptTry: self.
			self pushVal: PltTrueConstant new]
		ifFalse: [self pushVal: PltFalseConstant new]! !

!PlatypusExpressInterpretor methodsFor: 'visit statements schema' stamp: 'apl 2/23/2005 22:26'!
acceptCaseStatement: e 
	| selector |
	e selector acceptTry: self.
	selector := self pop.
	e caseActions
		detect: [:ca | 
			self push: selector.
			ca acceptTry: self.
			self popVal isPltTrueConstant]
		ifNone: [e caseOtherwise
				ifNotNil: [e caseOtherwise acceptTry: self]]! !

!PlatypusExpressInterpretor methodsFor: 'visit dictionary schema' stamp: 'apl 3/16/2004 12:01'!
acceptConstantDefinition: e 
	self push: (self data: e)! !

!PlatypusExpressInterpretor methodsFor: 'visit dictionary schema' stamp: 'apl 7/26/2004 14:14'!
acceptDefinedType: e 
! !

!PlatypusExpressInterpretor methodsFor: 'visit dictionary schema' stamp: 'apl 2/17/2006 09:22'!
acceptDerivedAttribute: e 
	e assign acceptTry: self! !

!PlatypusExpressInterpretor methodsFor: 'visit expressions schema' stamp: 'apl 2/23/2005 22:17'!
acceptDivExpression: e 
	| right left |
	self acceptBinaryExpression: e.
	right := self popVal.
	(left := self popVal)
		ifMissing: [^ self pushVal: left]
		ifNotMissing: [left isPltNumericLiteral
				ifFalse: [PlatypusExpressInvalidArgumentException signal: 'invalid left argument'].
			^ self pushVal: left / right]! !

!PlatypusExpressInterpretor methodsFor: 'visit expressions schema' stamp: 'AlainPlantec 10/7/2010 13:46'!
acceptElementQualifier: e 
	| idx stackElement |
	e index acceptTry: self.
	idx := self popVal.
	stackElement := self pop.
	stackElement pushIndex: idx val ! !

!PlatypusExpressInterpretor methodsFor: 'visit statements schema' stamp: 'apl 3/16/2004 13:04'!
acceptEndSplitmarkStatement: e 
	Transcript show: 'Writing ' withCRs , splitMarkStack last name , '\' withCRs.
	splitMarkStack last close.
	splitMarkStack removeLast! !

!PlatypusExpressInterpretor methodsFor: 'visit dictionary schema' stamp: 'AlainPlantec 5/8/2012 17:53'!
acceptEntityDefinition: e 
	| stackElem externalRep rec dataIndex attrIdentOrValue |
	self
		asContext: e
		while: [externalRep := PltExternalRepresentation new. 
			(rec := e emptyRecord) addRecordsToExternalRepresentation: externalRep.
			dataIndex := self currentContext dataIndex.
			rec definition referenced
				explicitAttributesWithIndexDo: [:ea :pos | 
					attrIdentOrValue := dataIndex at: ea.
					rec at: pos put: attrIdentOrValue].
			stackElem := PlatypusExpressInterpretorStackAppInst instance: externalRep interpretor: self.
			externalRep markAsComputed.
			self modelContents
				ifNotNil: [:mc | mc recordComputedInstances ifTrue: [mc add: externalRep]].
			self push: stackElem]! !

!PlatypusExpressInterpretor methodsFor: 'visit expressions schema' stamp: 'apl 3/18/2004 15:48'!
acceptEntityInstancesSet: e
	self
		push: (self data: e)! !

!PlatypusExpressInterpretor methodsFor: 'visit expressions schema' stamp: 'apl 3/1/2004 22:15'!
acceptEnumerationValue: e 
	^ self
		pushVar: (PltAnonymousVariable domain: e computedDomain)
		val: e
! !

!PlatypusExpressInterpretor methodsFor: 'visit expressions schema' stamp: 'AlainPlantec 10/7/2010 13:46'!
acceptEqualExpression: e 
	| right left |
	self acceptBinaryExpression: e.
	right := self popVal.
	left := self popVal.
	^ [self
		pushVal: (left equal: right)]
		on: MessageNotUnderstood
		do: [:ex | 
			Transcript show: ex printString , String cr.
			self pushVal: PltMissingValue new]! !

!PlatypusExpressInterpretor methodsFor: 'visit statements schema' stamp: 'apl 12/17/2003 08:36'!
acceptEscapeStatement: e 
	PlatypusExpressEscapeStatementException signal! !

!PlatypusExpressInterpretor methodsFor: 'visit dictionary schema' stamp: 'apl 3/31/2006 08:45'!
acceptExplicitAttribute: e 
	| stackElement |
	stackElement := self valOfSelf stackElementOfExplicitAttribute: e interpretor: self.
	stackElement ifNil: [^ PlatypusExpressInvalidAttributeException signal: 'attribute : ''' , e name , ''' is not computable'].
	self push: stackElement! !

!PlatypusExpressInterpretor methodsFor: 'visit expressions schema' stamp: 'apl 2/23/2005 22:17'!
acceptExpoExpression: e 
	| right left |
	self acceptBinaryExpression: e.
	right := self popVal.
	(left := self popVal)
		ifMissing: [^ self pushVal: left]
		ifNotMissing: [left isPltNumericLiteral
				ifFalse: [^ PlatypusExpressInvalidArgumentException signal: 'invalid left argument'].
			^ self
				pushVal: (left expo: right)]! !

!PlatypusExpressInterpretor methodsFor: 'visit population schema' stamp: 'AlainPlantec 10/7/2010 13:46'!
acceptGenericInstance: e
	| stackElem |
	stackElem := PlatypusExpressInterpretorStackAppInst instance:  e interpretor: self.
	self push: stackElem! !

!PlatypusExpressInterpretor methodsFor: 'visit dictionary schema' stamp: 'AlainPlantec 4/4/2010 11:15'!
acceptGlobalRule: e 
	| result |
	result := PltListInstance new.
	self
		asContext: e
		while: [e statements
				do: [:stmt | stmt acceptTry: self].
			e whereRules
				do: [:wr | 
					wr acceptTry: self.
					result add: self popVal]].
	result adjustLowerAndUpperBounds.
	self pushVal: result! !

!PlatypusExpressInterpretor methodsFor: 'visit expressions schema' stamp: 'apl 2/23/2005 22:19'!
acceptGreaterEqualExpression: e 
	| right left |
	self acceptBinaryExpression: e.
	right := self popVal.
	(left := self popVal)
		ifMissing: [^ self pushVal: PltUnknownConstant new]
		ifNotMissing: [left isPltOrderedLiteral
				ifTrue: [^ self pushVal: left >= right].
			left isPltAggregateData
				ifTrue: [^ self
						pushVal: (left isSupersetOf: right interpretor: self)].
			^ PlatypusExpressInvalidArgumentException signal: 'invalid left argument']! !

!PlatypusExpressInterpretor methodsFor: 'visit expressions schema' stamp: 'apl 2/23/2005 22:20'!
acceptGreaterThanExpression: e 
	| right left |
	self acceptBinaryExpression: e.
	right := self popVal.
	(left := self popVal)
		ifMissing: [^ self pushVal: PltUnknownConstant new]
		ifNotMissing: [(left isPltOrderedLiteral
					or: [left isPltAggregateData])
				ifFalse: [^ PlatypusExpressInvalidArgumentException signal: 'invalid left argument'].
			^ self pushVal: left > right]! !

!PlatypusExpressInterpretor methodsFor: 'visit expressions schema' stamp: 'AlainPlantec 5/4/2012 19:02'!
acceptGroupQualifier: e 
	| stackElement domain anonymousVar group instRef |
	stackElement := self pop.
	(instRef := stackElement val)
		ifMissing: [^ self pushVal: instRef]
		ifNotMissing: [instRef isPltGenericInstance
				ifFalse: [^ PlatypusExpressInvalidQualifierException signal: 'group qualifier ' , e groupName , ' can''t be interpreted from here '].
			domain := instRef entityDefinitionOfGroupNamed: e groupName.
			domain
				ifNil: [^ PlatypusExpressInvalidGroupException signal: 'invalid group name ' , e groupName].
			anonymousVar := PltAnonymousVariable domain: domain.
			group := instRef buildGroup: domain.
			self pushVar: anonymousVar val: group]! !

!PlatypusExpressInterpretor methodsFor: 'visit expressions schema' stamp: 'AlainPlantec 4/8/2011 10:30'!
acceptIdentifier: e 
	| args |
	e ref canHaveArguments
		ifTrue: [
			args := PlatypusExpressInterpretorCallArguments interpretor: self.
			self pushArgs: args.
			(e parameters notNil
					and: [e parameters notEmpty])
				ifTrue: [e parameters
						do: [:param | 
							self acceptTry: param.
							args addValue: self pop]]].
	e ref acceptTry: self.
	e ref canHaveArguments
		ifTrue: [self popArgs]! !

!PlatypusExpressInterpretor methodsFor: 'visit statements schema' stamp: 'apl 2/10/2004 16:29'!
acceptIfStatement: e 
	e selector acceptTry: self.
	self popVal ifTrueConstant: [e thenStatements
				do: [:stmt | stmt acceptTry: self]]
		ifFalseConstant: [e elseStatements
				ifNotNil: [e elseStatements
						do: [:stmt | stmt acceptTry: self]]]
! !

!PlatypusExpressInterpretor methodsFor: 'visit expressions schema' stamp: 'apl 2/23/2005 21:37'!
acceptInExpression: e 
	| right left |
	self acceptBinaryExpression: e.
	right := self popVal.
	(left := self popVal)
		ifMissing: [^ self pushVal: PltUnknownConstant new]
		ifNotMissing: [right isPltAggregateData
				ifFalse: [PlatypusExpressInvalidArgumentException signal: 'invalid right argument'].
			"(left computedDomain isCompatibleWith: right computedDomain 
			elementType) ifFalse: [PlatypusExpressInvalidArgumentException 
			signal: 'invalid left argument']."
			^ self
				pushVal: (right includesVal: left)]! !

!PlatypusExpressInterpretor methodsFor: 'visit statements schema' stamp: 'apl 3/16/2004 12:13'!
acceptIncrementControl: e 
	| counter step last |
	counter := self data: e variable.
	step := self currentContext step.
	last := self currentContext last.
	counter val val: counter val val + step.
	step = 0
		ifFalse: [^ step > 0
				ifTrue: [counter val val <= last]
				ifFalse: [counter val val >= last]].
	^ false! !

!PlatypusExpressInterpretor methodsFor: 'visit statements schema' stamp: 'apl 1/4/2004 23:35'!
acceptIncrementControlVariable: e 
	self
		push: (self data: e)! !

!PlatypusExpressInterpretor methodsFor: 'visit expressions schema' stamp: 'AlainPlantec 10/7/2010 13:47'!
acceptInstEqualExpression: e 
	| right left |
	self acceptBinaryExpression: e.
	right := self popVal.
	(left := self popVal)
		ifMissing: [^ self pushVal: PltUnknownConstant new]
		ifNotMissing: [
	^ self
		pushVal: (left instEqual: right)]! !

!PlatypusExpressInterpretor methodsFor: 'visit expressions schema' stamp: 'AlainPlantec 10/7/2010 13:47'!
acceptInstNotEqualExpression: e 
	| right left |
	self acceptBinaryExpression: e.
	right := self popVal.
	(left := self popVal)
		ifMissing: [^ self pushVal: PltUnknownConstant new]
		ifNotMissing: [
	^ self
		pushVal: (left instNotEqual: right)]! !

!PlatypusExpressInterpretor methodsFor: 'visit expressions schema' stamp: 'AlainPlantec 5/8/2012 17:54'!
acceptInstanceConstructionExpression: e 
	| stackElem right left externalRep |
	self acceptBinaryExpression: e.
	right := self pop.
	left := self pop.
	externalRep := PltExternalRepresentation new.
	left addRecordsToExternalRepresentation: externalRep.
	right addRecordsToExternalRepresentation: externalRep.
	stackElem := PlatypusExpressInterpretorStackAppInst instance: externalRep interpretor: self.
	externalRep markAsComputed.
	self modelContents 
		ifNotNil: [	:mc | mc recordComputedInstances ifTrue: [mc add: externalRep].
			"left instance isTemporary
				ifTrue: [mc remove: left instance].
			right instance isTemporary 
				ifTrue: [mc remove: right instance]"].
	self push: stackElem.

				
! !

!PlatypusExpressInterpretor methodsFor: 'visit dictionary schema' stamp: 'AlainPlantec 10/7/2010 15:49'!
acceptIntegerBound: e 
	| v var |
	v := PltIntegerLiteral val: e boundValue.
	var := PltAnonymousVariable domain: PltIntegerType new.
	self pushVar: var val: v! !

!PlatypusExpressInterpretor methodsFor: 'visit expressions schema' stamp: 'apl 1/27/2004 17:06'!
acceptInterval: e 
	e expr acceptTry: self.
! !

!PlatypusExpressInterpretor methodsFor: 'visit dictionary schema' stamp: 'AlainPlantec 5/17/2012 11:22'!
acceptInverseAttribute: e 
	| invertedAttrVal result var selfRef |
	selfRef := self valOfSelf.
	e minCardinality ifNil: 
			[result := (self allInstancesOf: e invertedAttr ref owner) detect: 
							[:d | 
							invertedAttrVal := d 
										stackElementOfExplicitAttribute: e invertedAttr ref
										interpretor: self.
							(invertedAttrVal val includesVal: selfRef) isPltTrueConstant]
						ifNone: [PltMissingValue new]]
		ifNotNil: 
			[result := e duplicates 
						ifTrue: [PltBagInstance new]
						ifFalse: [PltSetInstance new].
			(self allInstancesOf: e invertedAttr ref owner) do: 
					[:d | 
					invertedAttrVal := d  stackElementOfExplicitAttribute: e invertedAttr referenced
								interpretor: self.
					(invertedAttrVal val includesVal: selfRef) ifTrueConstant: [result add: d]].
			result adjustLowerAndUpperBounds].
	result 
		ifNotMissing: [result isPltAggregateInstance
			ifTrue: [result := result asListInstance]].
	var := PltAnonymousVariable domain: result computedDomain.
	self pushVar: var val: result.
	^ result! !

!PlatypusExpressInterpretor methodsFor: 'visit expressions schema' stamp: 'apl 2/23/2005 22:20'!
acceptLessEqualExpression: e 
	| right left |
	self acceptBinaryExpression: e.
	right := self popVal.
	(left := self popVal)
		ifMissing: [^ self pushVal: PltUnknownConstant new]
		ifNotMissing: [left isPltOrderedLiteral
				ifTrue: [^ self pushVal: left <= right].
			left isPltAggregateData
				ifTrue: [^ self
						pushVal: (left isSubsetOf: right interpretor: self)].
			^ PlatypusExpressInvalidArgumentException signal: 'invalid left argument']! !

!PlatypusExpressInterpretor methodsFor: 'visit expressions schema' stamp: 'apl 2/23/2005 22:20'!
acceptLessThanExpression: e 
	| right left |
	self acceptBinaryExpression: e.
	right := self popVal.
	(left := self popVal)
		ifMissing: [^ self pushVal: PltUnknownConstant new]
		ifNotMissing: [(left isPltOrderedLiteral
					or: [left isPltAggregateData])
				ifFalse: [PlatypusExpressInvalidArgumentException signal: 'invalid left argument'].
			^ self pushVal: left < right]! !

!PlatypusExpressInterpretor methodsFor: 'visit expressions schema' stamp: 'AlainPlantec 4/8/2011 10:48'!
acceptLiteral: e 
	^ self
		pushVar: (PltAnonymousVariable domain: e computedDomain)
		val: e copy! !

!PlatypusExpressInterpretor methodsFor: 'visit dictionary schema' stamp: 'AlainPlantec 5/4/2012 19:37'!
acceptLocalVariable: e 
	self push: (self data: e)! !

!PlatypusExpressInterpretor methodsFor: 'visit expressions schema' stamp: 'apl 2/23/2005 22:18'!
acceptMinusExpression: e 
	| right left |
	self acceptBinaryExpression: e.
	right := self popVal.
	(left := self popVal)
		ifMissing: [^ self pushVal: left]
		ifNotMissing: [(left isPltNumericLiteral
					or: [left isPltAggregateData])
				ifFalse: [PlatypusExpressInvalidArgumentException signal: 'invalid left argument'].
			^ self
				pushVal: (left minus: right interpretor: self)]! !

!PlatypusExpressInterpretor methodsFor: 'visit expressions schema' stamp: 'apl 1/7/2004 15:07'!
acceptMissingValue: e 
	^ self
		pushVal: e! !

!PlatypusExpressInterpretor methodsFor: 'visit expressions schema' stamp: 'apl 2/23/2005 22:18'!
acceptModExpression: e 
	| right left |
	self acceptBinaryExpression: e.
	right := self popVal.
	(left := self popVal)
		ifMissing: [^ self pushVal: left]
		ifNotMissing: [left isPltNumericLiteral
				ifFalse: [PlatypusExpressInvalidArgumentException signal: 'invalid left argument'].
			^ self
				pushVal: (left mod: right)]! !

!PlatypusExpressInterpretor methodsFor: 'visit expressions schema' stamp: 'apl 2/23/2005 22:18'!
acceptMultExpression: e 
	| right left |
	self acceptBinaryExpression: e.
	right := self popVal.
	(left := self popVal)
		ifMissing: [^ self pushVal: left]
		ifNotMissing: [(left isPltNumericLiteral
					or: [left isPltAggregateData])
				ifFalse: [PlatypusExpressInvalidArgumentException signal: 'invalid left argument'].
			^ self
				pushVal: (left mult: right interpretor: self)]! !

!PlatypusExpressInterpretor methodsFor: 'visit dictionary schema' stamp: 'apl 2/17/2006 10:00'!
acceptNativeAlgorithm: e 
	| nativeCode |
	(nativeCode := e platypusInterpreterCode)
		ifNil: [Error signal: 'no platypus interpreter code'].
	^ self acceptTry: nativeCode! !

!PlatypusExpressInterpretor methodsFor: 'visit dictionary schema' stamp: 'apl 2/17/2006 09:22'!
acceptNativeCode: e 
	^ PlatypusNativeCodeInterpretor new
		evaluate: e
		interpretor: self
		requestor: requestor! !

!PlatypusExpressInterpretor methodsFor: 'visit expressions schema' stamp: 'apl 6/8/2007 15:01'!
acceptNativeExpression: e 
	e source acceptTry: self! !

!PlatypusExpressInterpretor methodsFor: 'visit statements schema' stamp: 'apl 2/17/2006 09:04'!
acceptNativeStatement: e 
	e source acceptTry: self! !

!PlatypusExpressInterpretor methodsFor: 'visit expressions schema' stamp: 'apl 2/23/2005 22:18'!
acceptNegativeExpression: e 
	| expr |
	e expr acceptTry: self.
	(expr := self popVal)
		ifMissing: [^ self pushVal: expr]
		ifNotMissing: [expr isPltNumericLiteral
				ifFalse: [PlatypusExpressInvalidArgumentException signal: 'invalid argument'].
			^ self pushVal: expr negated]! !

!PlatypusExpressInterpretor methodsFor: 'visit expressions schema' stamp: 'AlainPlantec 10/7/2010 15:50'!
acceptNotEqualExpression: e 
	| right left |
	self acceptBinaryExpression: e.
	right := self popVal.
	left := self popVal.
	^ [self
		pushVal: (left notEqual: right)]
		on: MessageNotUnderstood
		do: [:ex | 
			Transcript show: ex printString, String cr.
			self pushVal: PltMissingValue new]! !

!PlatypusExpressInterpretor methodsFor: 'visit expressions schema' stamp: 'apl 2/23/2005 22:10'!
acceptNotExpression: e 
	| expr |
	e expr acceptTry: self.
	(expr := self popVal)
		ifMissing: [^ self pushVal: expr]
		ifNotMissing: [expr isPltLogicalLiteral
				ifFalse: [PlatypusExpressInvalidArgumentException signal: 'invalid argument'].
			^ self pushVal: expr not]! !

!PlatypusExpressInterpretor methodsFor: 'visit statements schema' stamp: 'apl 3/10/2004 17:45'!
acceptNullStatement: e
	^ self
! !

!PlatypusExpressInterpretor methodsFor: 'visit expressions schema' stamp: 'apl 2/23/2005 22:10'!
acceptOrExpression: e 
	| right left |
	e leftExpr acceptTry: self.
	(left := self popVal)
		ifMissing: [^ self pushVal: PltUnknownConstant new]
		ifNotMissing: [left isPltLogicalLiteral
				ifFalse: [PlatypusExpressInvalidArgumentException signal: 'invalid left argument'].
			left
				ifTrueConstant: [^ self pushVal: left].
			e rightExpr acceptTry: self.
			right := self popVal.
			^ self pushVal: right]! !

!PlatypusExpressInterpretor methodsFor: 'visit statements schema' stamp: 'apl 3/16/2004 13:03'!
acceptOutputStatement: e 
	"Transcript show: '#'."
	e output acceptTry: self.
	splitMarkStack last nextPutAll: self popVal asClearText! !

!PlatypusExpressInterpretor methodsFor: 'visit dictionary schema' stamp: 'apl 3/16/2004 12:25'!
acceptParameterDefinition: e 
	self push: (self data: e)! !

!PlatypusExpressInterpretor methodsFor: 'visit expressions schema' stamp: 'apl 3/31/2006 08:33'!
acceptPlusExpression: e 
	| right left |
	self acceptBinaryExpression: e.
	right := self popVal.
	(left := self popVal)
		ifMissing: [^ self pushVal: left]
		ifNotMissing: [(left isPltNumericLiteral
					or: [left isPltStringLiteral
							or: [left isPltAggregateData]])
				ifFalse: [PlatypusExpressInvalidArgumentException signal: 'invalid left argument'].
			^ self
				pushVal: (left plus: right interpretor: self)]! !

!PlatypusExpressInterpretor methodsFor: 'visit dictionary schema' stamp: 'apl 3/10/2004 18:09'!
acceptPopulationDependentBound: e 
	| |
	e boundValue acceptTry: self.
! !

!PlatypusExpressInterpretor methodsFor: 'visit statements schema' stamp: 'apl 5/25/2004 14:50'!
acceptProcedureCallStatement: e 
	e call acceptTry: self! !

!PlatypusExpressInterpretor methodsFor: 'visit expressions schema' stamp: 'AlainPlantec 5/4/2012 19:30'!
acceptQualifiedExpression: e 
	e head acceptTry: self.
	self doQualifiers: e qualifiers! !

!PlatypusExpressInterpretor methodsFor: 'visit expressions schema' stamp: 'apl 2/22/2006 11:45'!
acceptQueryExpression: e 
	| resultVar resultVal |
	self
		asContext: e
		while: [[self currentContext atEnd]
				whileFalse: [self currentContext next.
					self pushVal: self currentContext current.
					self data: e variable value: self pop.
					e suchThat acceptTry: self.
					self popVal
						ifTrueConstant: [self currentContext keep]
						ifFalseConstant: [self currentContext dontKeep]
						 ifUnknownConstant: [self currentContext dontKeep] ].
			resultVal := self currentContext result].
	resultVar := PltAnonymousVariable domain: resultVal computedDomain.
	self pushVar: resultVar val: resultVal! !

!PlatypusExpressInterpretor methodsFor: 'visit expressions schema' stamp: 'apl 3/16/2004 12:06'!
acceptQueryVariable: e 
	self push: (self data: e)! !

!PlatypusExpressInterpretor methodsFor: 'visit expressions schema' stamp: 'AlainPlantec 10/7/2010 15:50'!
acceptRangeQualifier: e 
	| idx1 idx2 stackElement |
	e index1 acceptTry: self.
	idx1 := self popVal.
	e index2 acceptTry: self.
	idx2 := self popVal.
	stackElement := self pop.
	stackElement
		pushRange: (idx1 val to: idx2 val)! !

!PlatypusExpressInterpretor methodsFor: 'visit expressions schema' stamp: 'apl 2/23/2005 22:18'!
acceptRealDivExpression: e 
	| right left |
	self acceptBinaryExpression: e.
	right := self popVal.
	(left := self popVal)
		ifMissing: [^ self pushVal: left]
		ifNotMissing: [left isPltNumericLiteral
				ifFalse: [PlatypusExpressInvalidArgumentException signal: 'invalid left argument'].
			^ self
				pushVal: (left div: right)]! !

!PlatypusExpressInterpretor methodsFor: 'visit statements schema' stamp: 'apl 2/21/2006 08:48'!
acceptRepeatStatement: e 
	| while untilControl skip |
	self
		asContext: e
		while: [
			untilControl := e untilControl.
			skip := false.
			[e incrControl
				ifNil: [while := true]
				ifNotNil: [while := e incrControl acceptTry: self].
			while
				and: [e whileControl
						ifNil: [while := true]
						ifNotNil: [e whileControl acceptTry: self.
							while := self popVal isPltTrueConstant]]]
				whileTrue: [[e statements
						do: [:stmt | [skip
								ifFalse: [stmt acceptTry: self]]
								on: PlatypusExpressSkipStatementException
								do: [skip := true]]]
						on: PlatypusExpressEscapeStatementException
						do: [^ nil].
					skip := false.
					untilControl
						ifNotNil: [untilControl acceptTry: self.
							self popVal isPltTrueConstant
								ifTrue: [^ nil]]]]! !

!PlatypusExpressInterpretor methodsFor: 'visit statements schema' stamp: 'apl 3/22/2006 12:25'!
acceptReturnStatement: e 
	e returned acceptTry: self.
	PlatypusExpressReturnStatementException signal! !

!PlatypusExpressInterpretor methodsFor: 'visit expressions schema' stamp: 'apl 6/5/2004 10:36'!
acceptSelfIdentifier: e 
	| anonymousVar |
	anonymousVar := PltAnonymousVariable domain: self valOfSelf computedDomain.
	self pushVar: anonymousVar val: self valOfSelf! !

!PlatypusExpressInterpretor methodsFor: 'visit statements schema' stamp: 'apl 12/17/2003 08:39'!
acceptSkipStatement: e 
	PlatypusExpressSkipStatementException signal! !

!PlatypusExpressInterpretor methodsFor: 'visit statements schema' stamp: 'AlainPlantec 4/26/2012 09:27'!
acceptSplitmarkStatement: e 
	| contents fileName oldStream |
	contents := ''.
	e filename acceptTry: self.
	fileName := self popVal val.
	e append
		ifTrue: [(self isAFileNamed: fileName)
				ifTrue: [oldStream := self outputFileStreamNamed: fileName.
					[contents := oldStream contentsOfEntireFile]
						ensure: [oldStream close]]].
	splitMarkStack
		add: (self outputFileStreamNamed: fileName).
	e append
		ifTrue: [splitMarkStack last nextPutAll: contents]! !

!PlatypusExpressInterpretor methodsFor: 'visit statements schema' stamp: 'apl 6/16/2004 19:32'!
acceptStatementsContainer: e 
	[e statements
		do: [:stmt | stmt acceptTry: self]] on: PlatypusExpressReturnStatementException do: []! !

!PlatypusExpressInterpretor methodsFor: 'visit generic' stamp: 'apl 3/28/2006 09:13'!
acceptTry: e 
	e referenced
		ifNil: [^ PlatypusExpressUnresolvedIdentifierException signal: 'Unresolved symbol: ' , e name].
	debugger
		ifNotNil: [Transcript show: e prettyPrintedExpressCode , String cr.
			e isDebugged
				ifTrue: [debugger aboutToAccept: e]].
	^ super acceptTry: e! !

!PlatypusExpressInterpretor methodsFor: 'visit dictionary schema' stamp: 'apl 6/8/2004 10:40'!
acceptWhereRule: e 
	e whereValue acceptTry: self.
	self topVal
		ifTrueConstant: [Transcript show: e fullyQualifiedName , ': true\' withCRs]
		ifFalseConstant: [Transcript show: e fullyQualifiedName , ': false\' withCRs]
		ifUnknownConstant: [Transcript show: e fullyQualifiedName , ': unknown\' withCRs]! !

!PlatypusExpressInterpretor methodsFor: 'visit expressions schema' stamp: 'apl 2/23/2005 22:10'!
acceptXorExpression: e 
	| right left |
	self acceptBinaryExpression: e.
	right := self popVal.
	(left := self popVal)
		ifMissing: [^ self pushVal: PltUnknownConstant new]
		ifNotMissing: [left isPltLogicalLiteral
				ifFalse: [PlatypusExpressInvalidArgumentException signal: 'invalid left argument'].
			^ self
				pushVal: (left xor: right)]! !

!PlatypusExpressInterpretor methodsFor: 'data accessing' stamp: 'AlainPlantec 5/16/2012 16:20'!
allApplicationInstances
	^ self applicationInstancesSelect: [:d | d notNil]! !

!PlatypusExpressInterpretor methodsFor: 'data accessing' stamp: 'AlainPlantec 5/4/2012 12:53'!
allInstancesOf: anEntityDefinition 
	^ self applicationInstancesSelect: [:d | d computedDomain isSpecializationOf: anEntityDefinition]! !

!PlatypusExpressInterpretor methodsFor: 'data accessing' stamp: 'AlainPlantec 5/4/2012 18:17'!
allPersistentApplicationInstances
	^ self modelContents dataInstances ! !

!PlatypusExpressInterpretor methodsFor: 'data enumerating' stamp: 'AlainPlantec 5/18/2012 13:18'!
applicationInstancesSelect: aSelectionBlock 
	| selected context schemaInstance models ref |
	selected := OrderedCollection new.
	contextsStack 
		reverseDo: [:c | c applicationInstancesSelect: aSelectionBlock in: selected].
	self modelContents ifNotNil: [:mc | 
		selected addAll: (mc dataInstances select: aSelectionBlock)].
	^selected! !

!PlatypusExpressInterpretor methodsFor: 'accessing' stamp: 'apl 3/31/2006 09:35'!
argsStackSize
	^ argsStack size! !

!PlatypusExpressInterpretor methodsFor: 'accessing' stamp: 'apl 3/31/2006 09:36'!
argsStackTop
	^ argsStack top! !

!PlatypusExpressInterpretor methodsFor: 'accessing' stamp: 'apl 3/27/2006 07:43'!
asContext: contextInstance while: aBlock 
	contextInstance pushContextInInterpretor: self.
	aBlock
		ensure: [self popContext]! !

!PlatypusExpressInterpretor methodsFor: 'accessing' stamp: 'apl 12/20/2005 12:08'!
asContextsStack: aStack while: aBlock
	| oldContexts |
	oldContexts := contextsStack.
	contextsStack := aStack.
	aBlock ensure: [contextsStack := oldContexts]! !

!PlatypusExpressInterpretor methodsFor: 'accessing' stamp: 'AlainPlantec 5/4/2012 18:26'!
asValOfSelf: anInstance while: aBlock
	| omc |
	omc := modelContentsAccessBlock.
	modelContentsAccessBlock :=  [anInstance owningModel].
	selfStack push: anInstance interpretingContext.
	aBlock
		ensure: [
			selfStack pop. 
			modelContentsAccessBlock := omc]! !

!PlatypusExpressInterpretor methodsFor: 'interpreting' stamp: 'AlainPlantec 6/15/2012 12:59'!
attributeOrRule: anAttributeOrLocalRule instance: anEntityInstance 
	| toBeEvaluated |
	toBeEvaluated := anAttributeOrLocalRule isPltWhereRule
		ifTrue: [anAttributeOrLocalRule whereValue]
		ifFalse: [anAttributeOrLocalRule].
	^ self expression: toBeEvaluated context: anAttributeOrLocalRule schemaDefinition instance: anEntityInstance 
! !

!PlatypusExpressInterpretor methodsFor: 'accessing' stamp: 'apl 6/16/2004 12:25'!
checksAssignments
	^ checksAssignments! !

!PlatypusExpressInterpretor methodsFor: 'accessing' stamp: 'apl 6/16/2004 15:40'!
checksAssignments: trueOrFalse
	checksAssignments := trueOrFalse! !

!PlatypusExpressInterpretor methodsFor: 'interpreting' stamp: 'apl 9/26/2006 11:38'!
compute: anExpressionOrStatement 
	[anExpressionOrStatement acceptTry: self]
		on: Error
		do: [:err | 
			PlatypusExpressDebugger interpretor: self statementOrExpression:   visitPath top.
			err signal]! !

!PlatypusExpressInterpretor methodsFor: 'interpreting' stamp: 'AlainPlantec 6/15/2012 12:40'!
compute: anArrayOfExpressionsOrStatements in: context to: receiver notifying: aRequestor ifFail: failBlock logged: isLogged 
	| owners |
	context isPltSchemaInstance
		ifTrue: [owners := context schemataLinkedMetaData]
		ifFalse: [owners := context inclusiveOwnerPath].
	self resolves: anArrayOfExpressionsOrStatements in: context to: receiver notifying: aRequestor owners: owners.
	modelContentsAccessBlock := [context schemaInstance interpreterScope].
	(owners "reject: [:o | o isNil]")
		do: [:own | own pushContextInInterpretor: self].
	(receiver isKindOf: PltGenericInstance)
		ifTrue: [
			self
				asValOfSelf: receiver
				while: [anArrayOfExpressionsOrStatements
						do: [:r | self compute: r]]]
		ifFalse: [anArrayOfExpressionsOrStatements
				do: [:r | | schi |
					schi := r schemaInstance.
					modelContentsAccessBlock := [schi interpreterScope]. 
					self compute: r]].
	^ stack size > 0
		ifTrue: [self pop]
		ifFalse: [self]! !

!PlatypusExpressInterpretor methodsFor: 'accessing' stamp: 'apl 12/20/2005 12:04'!
contextsStack
	^ contextsStack! !

!PlatypusExpressInterpretor methodsFor: 'accessing' stamp: 'apl 6/18/2004 23:26'!
currentContext
	^contextsStack top! !

!PlatypusExpressInterpretor methodsFor: 'accessing' stamp: 'apl 3/27/2006 18:03'!
currentSourceHandler
	| tam |
	self contextsStack reverseDo: [:ctxt| (tam := ctxt contextInstance tamarisItemRef) ifNotNil: [^ tam]].
	^ nil ! !

!PlatypusExpressInterpretor methodsFor: 'accessing' stamp: 'apl 6/15/2005 11:32'!
data: aData 
	| found |
	 contextsStack 
		reverseDo: [:c | (found := c data: aData) ifNotNil: [^found]].
	^PlatypusExpressUnresolvedIdentifierException 
		signal: 'Unresolved symbol: ' , aData name! !

!PlatypusExpressInterpretor methodsFor: 'accessing' stamp: 'apl 6/15/2005 11:32'!
data: aData value: aValue 
	 contextsStack 
		reverseDo: [:c | (c includesData: aData) ifTrue: [^c data: aData value: aValue]].
	^self currentContext data: aData value: aValue! !

!PlatypusExpressInterpretor methodsFor: 'data enumerating' stamp: 'AlainPlantec 5/4/2012 18:20'!
dataDo: aBlock 
	contextsStack reverseDo: [:c | c dataDo: aBlock].
	self modelContents dataInstances do: aBlock.
! !

!PlatypusExpressInterpretor methodsFor: 'accessing' stamp: 'apl 6/15/2005 11:32'!
dataNamed: anIdent 
	| found |
	 contextsStack 
		reverseDo: [:c | (found := c dataNamed: anIdent) ifNotNil: [^found]].
	^nil! !

!PlatypusExpressInterpretor methodsFor: 'accessing' stamp: 'apl 6/15/2005 11:32'!
dataNamed: anIdent value: aValue 
	| found |
	 contextsStack reverseDo: 
			[:c | 
			(found := c stackElementOfDataNamed: anIdent) ifNotNil: 
					[c data: found value: aValue.
					^true]].
	^false! !

!PlatypusExpressInterpretor methodsFor: 'data enumerating' stamp: 'AlainPlantec 5/4/2012 18:57'!
dataSelect: aSelectionBlock
	| result |
	result := OrderedCollection new.
	contextsStack reverseDo: [:c | c dataSelect: aSelectionBlock in: result].
	result addAll: (self modelContents dataInstances select: aSelectionBlock).
	^ result
! !

!PlatypusExpressInterpretor methodsFor: 'accessing' stamp: 'apl 2/20/2006 18:06'!
debugger: anExpressDebogger 
	debugger := anExpressDebogger.
! !

!PlatypusExpressInterpretor methodsFor: 'context initializing' stamp: 'AlainPlantec 5/4/2012 19:02'!
declareConstant: e 
	| varValue value |
	self pushVar: e val: e defaultValue.
	self localData: e value: (varValue := self pop).
	e initializer acceptTry: self.
	value := self valueFromDomain: e domain assignCompatibleWith: self popVal.
	varValue val: value copy! !

!PlatypusExpressInterpretor methodsFor: 'context initializing' stamp: 'alain.plantec 12/18/2008 16:19'!
declareEntityInstancesSet: e 
	| instancesList |
	instancesList := PltListInstance new.
	instancesList contents: (self allInstancesOf: e entityRef).
	instancesList adjustLowerAndUpperBounds.
	self pushVar: e val: instancesList.
	self localData: e value: self pop
	! !

!PlatypusExpressInterpretor methodsFor: 'context initializing' stamp: 'AlainPlantec 5/4/2012 19:59'!
declareLocalVariable: e 
	| domain value varValue |
	self pushVar: e val: e defaultValue.
	self localData: e value: (varValue := self top).
	e initializer 
		ifNotNil: 
			[e initializer acceptTry: self.
			domain := e domain.
			value := self valueFromDomain: domain assignCompatibleWith: self popVal.
			varValue val: value copy].
	self pop! !

!PlatypusExpressInterpretor methodsFor: 'context initializing' stamp: 'apl 2/22/2006 14:58'!
declareParameter: e 
	self pushVar: e val: e defaultValue.
	self localData: e value: (self pop)! !

!PlatypusExpressInterpretor methodsFor: 'context initializing' stamp: 'apl 3/16/2004 12:17'!
declareQueryVariable: e 
	self pushVar: e val: e defaultValue.
	self localData: e value: self pop! !

!PlatypusExpressInterpretor methodsFor: 'initialize/release' stamp: 'apl 6/3/2005 16:48'!
destroy
	super destroy.
	stack destroy.
	stack := nil.
	contextsStack destroy.
	contextsStack := nil! !

!PlatypusExpressInterpretor methodsFor: 'visit expressions schema' stamp: 'apl 3/27/2006 17:30'!
doQualifiers: quals 
	| first |
	quals isEmpty
		ifFalse: [(first := quals first) isPltAttributeQualifier
				ifTrue: [self
						asValOfSelf: self top val 
						while: [self acceptTry: first.
							self doQualifiers: quals allButFirst]]
				ifFalse: [self acceptTry: first.
					self doQualifiers: quals allButFirst]]! !

!PlatypusExpressInterpretor methodsFor: 'interpreting' stamp: 'apl 5/27/2004 10:01'!
evaluate: textOrStream in: context to: receiver notifying: aRequestor ifFail: failBlock 
	^ self
		evaluate: textOrStream
		in: context
		to: receiver
		notifying: aRequestor
		ifFail: failBlock 
		logged: false! !

!PlatypusExpressInterpretor methodsFor: 'interpreting' stamp: 'AlainPlantec 1/21/2011 09:32'!
evaluate: textOrStream in: context to: receiver notifying: aRequestor ifFail: failBlock logged: isLogged 
	^ (self parse: textOrStream in: context notifying: aRequestor ifFail: failBlock)
		ifNotNil: [:result |
			self
				compute: result
				in: context
				to: receiver
				notifying: aRequestor
				ifFail: failBlock
				logged: isLogged]! !

!PlatypusExpressInterpretor methodsFor: 'interpreting' stamp: 'apl 3/27/2006 07:45'!
expression: anExpression context: aContext instance: anEntityInstance 
	requestor := nil.
	aContext
		ifNotNil: [aContext pushContextInInterpretor: self].
	self
		asValOfSelf: anEntityInstance
		while: [self compute: anExpression.
			^ self pop val]! !

!PlatypusExpressInterpretor methodsFor: 'initialize/release' stamp: 'apl 3/31/2006 09:29'!
initialize
	super initialize.
	stack := PlatypusStack new.
	contextsStack := PlatypusStack new.
	selfStack := PlatypusStack new.
	argsStack := PlatypusStack new.
	splitMarkStack := OrderedCollection new.
	checksAssignments := true! !

!PlatypusExpressInterpretor methodsFor: 'result output' stamp: 'apl 12/13/2005 10:56'!
isAFileNamed: aName 
	| filename |
	(FileDirectory default directoryNamed: self resultOutputDirectoryName) assureExistence.
	filename := self resultOutputDirectoryName , FileDirectory slash , aName.
	^ StandardFileStream
		isAFileNamed: (StandardFileStream fullName: filename)! !

!PlatypusExpressInterpretor methodsFor: 'accessing' stamp: 'apl 3/16/2004 11:41'!
localData: aData 
	^ self currentContext data: aData! !

!PlatypusExpressInterpretor methodsFor: 'accessing' stamp: 'apl 1/31/2006 12:27'!
localData: aData value: aValue 
	^ self currentContext data: aData value: aValue! !

!PlatypusExpressInterpretor methodsFor: 'visit generic' stamp: 'apl 4/22/2006 23:11'!
lookUpAndCacheAcceptSelectorOfClass: aClass 
	| currClass selector str |
	currClass := aClass.
	str := WriteStream on: (String new:50).
	[currClass ~~ Object]
		whileTrue: [str nextPutAll: 'accept'.
			str
				next: currClass name size - 3
				putAll: currClass name
				startingAt: 4.
			str nextPut: $:.
			selector := str contents asSymbol.
			(self class includesSelector: selector)
				ifTrue: [self acceptSelectorsMap at: aClass put: selector.
					^ selector].
			str reset.
			currClass := currClass superclass].
	^ self error: 'unimplemented accept method for class ''' , aClass name , ''''! !

!PlatypusExpressInterpretor methodsFor: 'accessing' stamp: 'apl 4/20/2006 10:03'!
lookUpIdentifierBN: aName 
	| found |
	contextsStack
		reverseDo: [:ctx | (found := ctx lookUpIdentifierBN: aName)
				ifNotNil: [^ found]].
	^ PltPlatypusExpressPrimitivesSchemaInstance  lookUpIdentifierBN: aName! !

!PlatypusExpressInterpretor methodsFor: 'accessing' stamp: 'AlainPlantec 6/13/2012 23:48'!
lookUpIdentifierBN: aName fromContext: aContext 
	| found |
	aContext inclusiveOwnerPath
		reverseDo: [:own | (found := own lookUpIdentifierBN: aName)
				ifNotNil: [^ found]].
	^ nil! !

!PlatypusExpressInterpretor methodsFor: 'accessing' stamp: 'apl 4/20/2006 10:03'!
lookUpNamedTypeBN: aName 
	| found |
	contextsStack
		reverseDo: [:ctx | (found := ctx lookUpNamedTypeBN: aName)
				ifNotNil: [^ found]].
	^ PltPlatypusExpressPrimitivesSchemaInstance lookUpNamedTypeBN: aName! !

!PlatypusExpressInterpretor methodsFor: 'accessing' stamp: 'AlainPlantec 5/4/2012 18:24'!
modelContents 
	^ modelContentsAccessBlock value ! !

!PlatypusExpressInterpretor methodsFor: 'accessing' stamp: 'AlainPlantec 5/4/2012 18:36'!
modelContents: aModelContents
	modelContentsAccessBlock := [aModelContents]! !

!PlatypusExpressInterpretor methodsFor: 'result output' stamp: 'AlainPlantec 4/26/2012 09:28'!
outputFileStreamNamed: aName 
	| filename |
	(FileDirectory default directoryNamed: self resultOutputDirectoryName) assureExistence.
	filename := self resultOutputDirectoryName , FileDirectory slash , aName.
	(FileDirectory default
		directoryNamed: (FileDirectory dirPathFor: filename)) assureExistence.
	^ StandardFileStream forceNewFileNamed: filename! !

!PlatypusExpressInterpretor methodsFor: 'interpreting' stamp: 'AlainPlantec 6/15/2012 11:47'!
parse: textOrStream in: context notifying: aRequestor ifFail: failBlock
	| position descr repl contents start result stream |
	stream := textOrStream isStream
				ifTrue: [textOrStream]
				ifFalse: [ReadStream on: textOrStream].
	contents := stream upToEnd copy trimBoth.
	stream := ReadStream on: contents.
	start := (contents last = $;
					or: [contents size > 2
							and: [(contents copyFrom: contents size - 2 to: contents size)
									= '#*)']])
				ifTrue: [PlatypusExpressParser startingStateForStatementsEntry]
				ifFalse: [PlatypusExpressParser startingStateForExpressionEntry].
	result := [PlatypusExpressParser
				parseStream: stream
				startingAt: start
				owner: context]
				on: SmaCCParserError
				do: [:ex | 
					position := ex tag position.
					descr := ex description.
					aRequestor notNil
						ifTrue: [aRequestor selectFrom: position to: position - 1.
							repl := Text string: descr , '->' attribute: TextEmphasis bold.
							aRequestor replaceSelectionWith: repl].
					ex return: failBlock value.
					^ nil].
	result isCollection
		ifFalse: [result := Array with: result].
	result do: [:r | r owner: context].
	^ result
! !

!PlatypusExpressInterpretor methodsFor: 'accessing' stamp: 'apl 6/18/2004 23:15'!
pop
	^ stack pop.
! !

!PlatypusExpressInterpretor methodsFor: 'accessing' stamp: 'apl 3/31/2006 09:32'!
popArgs
	^ argsStack pop! !

!PlatypusExpressInterpretor methodsFor: 'context initializing' stamp: 'apl 3/27/2006 07:43'!
popContext
	contextsStack pop! !

!PlatypusExpressInterpretor methodsFor: 'accessing' stamp: 'AlainPlantec 10/7/2010 15:50'!
popVal
	| elem |
	elem := self pop.
	^ elem val! !

!PlatypusExpressInterpretor methodsFor: 'context initializing' stamp: 'apl 3/16/2004 13:07'!
prepareIncrControl: e 
	| counter step last |
	e first acceptTry: self.
	counter := self pop deepCopy.
	e step
		ifNil: [step := 1]
		ifNotNil: [e step acceptTry: self.
			step := self popVal val].
	counter val val: counter val val - step.
	e last acceptTry: self.
	last := self popVal val.
	self localData: e variable value: counter.
	self currentContext step: step.
	self currentContext last: last! !

!PlatypusExpressInterpretor methodsFor: 'accessing' stamp: 'apl 6/18/2004 23:15'!
push: aStackElement 
	| |
	stack push: aStackElement 
! !

!PlatypusExpressInterpretor methodsFor: 'accessing' stamp: 'apl 3/31/2006 09:31'!
pushArgs: aStackCallArgumentsElement 
	argsStack push: aStackCallArgumentsElement! !

!PlatypusExpressInterpretor methodsFor: 'context initializing' stamp: 'apl 3/27/2006 13:31'!
pushContext: anInterpretorContext 
	contextsStack push: anInterpretorContext.
	anInterpretorContext initializeContextInInterpretor: self! !

!PlatypusExpressInterpretor methodsFor: 'accessing' stamp: 'apl 1/2/2004 19:02'!
pushVal: anObject 
	self
		push: (PlatypusExpressInterpretorStackVar val: anObject interpretor: self)! !

!PlatypusExpressInterpretor methodsFor: 'accessing' stamp: 'apl 1/28/2006 13:38'!
pushVar: aVariable val: aValue 
	self
		push: (PlatypusExpressInterpretorStackVar
				var: aVariable
				val: aValue
				interpretor: self)! !

!PlatypusExpressInterpretor methodsFor: 'accessing' stamp: 'apl 2/23/2006 15:31'!
removeFromStackAt: pos
	stack removeAt: pos! !

!PlatypusExpressInterpretor methodsFor: 'interpreting' stamp: 'AlainPlantec 5/23/2012 15:58'!
resolves: anArrayOfExpressionsOrStatements in: context to: receiver notifying: aRequestor owners: owners
	| resolutionOwners  checker |
	requestor := aRequestor.
	resolutionOwners := owners copy.
	(receiver isKindOf: PltGenericInstance)
		ifTrue: [resolutionOwners addAll: receiver definitionInclusiveOwnerPath].
	checker := PlatypusExpressResolver new visitContexts: resolutionOwners.
	anArrayOfExpressionsOrStatements
		do: [:r | [checker checks: r]
				on: PlatypusVisitorError
				do: [:err | 
					self showInterpreterErrorOnSource: err.
					err signal]].
	^ anArrayOfExpressionsOrStatements
! !

!PlatypusExpressInterpretor methodsFor: 'result output' stamp: 'apl 6/3/2004 17:33'!
resultOutputDirectoryName
	^ 'Platypus-output'! !

!PlatypusExpressInterpretor methodsFor: 'accessing' stamp: 'apl 1/30/2006 13:57'!
return: anObject 
	self pushVal: anObject ! !

!PlatypusExpressInterpretor methodsFor: 'accessing' stamp: 'AlainPlantec 6/15/2012 12:35'!
schemaInstance
	^ contextsStack first contextInstance schemaInstance! !

!PlatypusExpressInterpretor methodsFor: 'accessing' stamp: 'apl 2/20/2006 22:57'!
selfStack
	^ selfStack ! !

!PlatypusExpressInterpretor methodsFor: 'accessing' stamp: 'apl 3/31/2006 09:14'!
selfStackSize
	^ selfStack size! !

!PlatypusExpressInterpretor methodsFor: 'accessing' stamp: 'apl 12/14/2003 14:46'!
stack
	^ stack! !

!PlatypusExpressInterpretor methodsFor: 'accessing' stamp: 'apl 2/23/2006 11:40'!
stackAt: aPos
	^ stack at: aPos! !

!PlatypusExpressInterpretor methodsFor: 'accessing' stamp: 'apl 2/23/2006 11:40'!
stackSize
	^ stack size! !

!PlatypusExpressInterpretor methodsFor: 'accessing' stamp: 'apl 6/18/2004 23:17'!
top
	^ self stack top! !

!PlatypusExpressInterpretor methodsFor: 'accessing' stamp: 'apl 12/18/2003 09:42'!
topVal
	^ self top val! !

!PlatypusExpressInterpretor methodsFor: 'accessing' stamp: 'apl 3/31/2006 10:25'!
valOfSelf
	^ selfStack top! !

!PlatypusExpressInterpretor methodsFor: 'accessing' stamp: 'AlainPlantec 5/4/2012 19:57'!
valueFromDomain: aDomain assignCompatibleWith: aValue 
	^ aValue 
		ifMissing: [aValue]
		ifNotMissing: 
			[[aDomain assignableValueFrom: aValue interpretor: self] on: Error
				do: 
					[
					PlatypusExpressIncompatibleDomainInAssignmentException 
						signal: 'domain : ' , aDomain prettyPrintedExpressCode , ';  value : ' 
								, aValue prettyPrintedExpressCode]]! !

!PlatypusExpressInterpretor methodsFor: 'accessing' stamp: 'AlainPlantec 10/7/2010 15:50'!
valueOf: anIdent 
	| v result |
	result := (v := self dataNamed: anIdent)
		ifNil: [PltMissingValue new]
		ifNotNil: [v val].
	^ result ifNil: [PltMissingValue new]! !

PlatypusStepAbstractVisitor subclass: #PlatypusExpressTranslater
	instanceVariableNames: 'resultStream requestor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-translater-private'!

PlatypusExpressTranslater subclass: #PlatypusExpressExpression2SmalltalkTranslater
	instanceVariableNames: 'receiverName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-translater-private'!

PlatypusExpressExpression2SmalltalkTranslater subclass: #PlatypusExpressExpression2PharoTranslater
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-translater-private'!

!PlatypusExpressExpression2PharoTranslater class methodsFor: 'accessing' stamp: 'AlainPlantec 7/14/2011 18:04'!
expressionTranslaterClassName
	^ #PlatypusExpressExpression2PharoTranslater! !

!PlatypusExpressExpression2PharoTranslater class methodsFor: 'accessing' stamp: 'AlainPlantec 7/14/2011 18:03'!
statementTranslaterClassName
	^ #PlatypusExpressStatement2PharoTranslater! !

!PlatypusExpressExpression2PharoTranslater methodsFor: 'visit dictionary schema' stamp: 'AlainPlantec 7/14/2011 16:53'!
acceptNativeAlgorithm: e 
	| code |
	(code := e pharoCode)
		ifNil: [code := e platypusInterpreterCode.
			code
				ifNil: [Error signal: 'no pharo code in native algorithm']
				ifNotNil: [Transcript show: 'Platypus: Warning: ' , self class name , '>>acceptNativeAlgorithm: "no pharo code, taking platypus interpreter code instead"' withCRs.
					Transcript show: e asClearText withCRs]].
	^ code acceptTry: self! !

!PlatypusExpressExpression2SmalltalkTranslater class methodsFor: 'instance creation' stamp: 'apl 2/28/2006 10:34'!
receiverName: aNameForReceiver accept: aMetaData fromTranslater: aTranslater 
	(self new receiverName: aNameForReceiver fromTranslater: aTranslater)
		acceptTry: aMetaData! !

!PlatypusExpressExpression2SmalltalkTranslater class methodsFor: 'instance creation' stamp: 'apl 12/5/2006 17:39'!
receiverName: aNameForReceiver accept: aMetaData fromTranslater: aTranslater resultStream: aStream 
	| translater |
	(translater := self new 
		receiverName: aNameForReceiver
		fromTranslater: aTranslater
		resultStream: aStream) acceptTry: aMetaData.
		^ translater! !

!PlatypusExpressExpression2SmalltalkTranslater methodsFor: 'visit expressions schema' stamp: 'apl 2/28/2006 20:05'!
acceptAggregateInitializer: e 
	e contents isEmpty ifTrue: [self nextPutAll: ' Array new']
	ifFalse: [
	self nextPutAll: ' ( PlatypusCoreAggregateInitializer collectionFrom: ((OrderedCollection new) '.
	e contents
		do: [:c | self nextPutAll: 'add: '. self acceptTry: c] separatedBy: [self nextPutAll: '; '].
	self nextPutAll: '; yourself) ) ']! !

!PlatypusExpressExpression2SmalltalkTranslater methodsFor: 'visit expressions schema' stamp: 'apl 2/28/2006 20:01'!
acceptAggregateInitializerElement: e 
	| vname |
	vname := self namesBuilder uniqueBlockVarName: 'p' owner: e.
	
	e repetition
		ifNil: [self nextPutAll: '('.
			self acceptTry: e val.
			self nextPutAll: ')']
		ifNotNil: [self nextPutAll: '[((1 to: ('.
			self acceptTry: e repetition.
			self nextPutAll: ')) collect: [:' , vname , '| '.
			self acceptTry: e val.
			self nextPutAll: '])]'].
! !

!PlatypusExpressExpression2SmalltalkTranslater methodsFor: 'visit statements schema' stamp: 'apl 2/27/2006 18:37'!
acceptAliasStatementVariable: e 
	| vn |
	vn := self namesBuilder
				uniqueBlockVarName: (self namesBuilder normalizedNameFrom: e aliasIdent first: false)
				owner: e.
	self nextPutAll: vn , ' '! !

!PlatypusExpressExpression2SmalltalkTranslater methodsFor: 'visit expressions schema' stamp: 'apl 3/4/2005 13:47'!
acceptAndExpression: e 
	self nextPutAll: ' ( '.
	self acceptTry: e leftExpr.
	self nextPutAll: ' and: ['.
	self acceptTry: e rightExpr.
	self nextPutAll: ' ])  '! !

!PlatypusExpressExpression2SmalltalkTranslater methodsFor: 'visit statements schema' stamp: 'apl 6/29/2007 20:00'!
acceptAssignable: e 
	e qualifiers
		ifEmpty: [self nextPutAll: '( '.
			e head acceptTry: self.
			"self acceptTry: PltSelfIdentifier new.
			self nextPutAll: (self namesBuilder
			normalizedVarNameFrom: e head name)."
			self nextPutAll: ') ']
		ifNotEmpty: [:quals | 
			quals
				do: [:q | 
					self nextPutAll: '( '.
					q isPltGroupQualifier
						ifTrue: [self nextPutAll: '( ']].
			e head acceptTry: self.
			e qualifiers
				do: [:q | 
					self acceptTry: q.
					self nextPutAll: ') ']]! !

!PlatypusExpressExpression2SmalltalkTranslater methodsFor: 'visit expressions schema' stamp: 'apl 5/30/2005 00:00'!
acceptAttributeQualifier: e 
	| contextvn selector tmpAttr |
	contextvn := (self namesBuilder contextArgNameFromQualifier: e) 
				ifNil: [' (self class context) '].
	tmpAttr := PltExplicitAttribute new name: e attributeName.
	selector := tmpAttr 
				getSelectorWithContextArgFromNamesBuilder: self namesBuilder.
	self nextPutAll: selector , ' ' , contextvn! !

!PlatypusExpressExpression2SmalltalkTranslater methodsFor: 'visit expressions schema' stamp: 'apl 3/4/2005 12:28'!
acceptBinaryExpression: e 
	self nextPutAll: ' ( '.
	self acceptTry: e leftExpr.
	self nextPutAll: ' ', e pltOperator, ' '.
	self acceptTry: e rightExpr.
	self nextPutAll: ' )  '! !

!PlatypusExpressExpression2SmalltalkTranslater methodsFor: 'visit dictionary schema' stamp: 'apl 2/28/2006 10:52'!
acceptDerivedAttribute: e 
	| contextvn |
	contextvn := self namesBuilder contextArgNameFromAttribute: e.
	self nextPutAll: '( '.
	self acceptTry: PltSelfIdentifier new.
	self 
		nextPutAll: (e getSelectorWithContextArgFromNamesBuilder: self namesBuilder) 
				, ' ' , contextvn 
				, ' ) '! !

!PlatypusExpressExpression2SmalltalkTranslater methodsFor: 'visit expressions schema' stamp: 'apl 3/11/2005 23:44'!
acceptEConstant: e 
	self nextPutAll: ' 2.71828 '
! !

!PlatypusExpressExpression2SmalltalkTranslater methodsFor: 'visit expressions schema' stamp: 'apl 3/3/2005 11:44'!
acceptElementQualifier: e 
	self nextPutAll: '  pltAt:  '.
	self acceptTry: e index! !

!PlatypusExpressExpression2SmalltalkTranslater methodsFor: 'visit expressions schema' stamp: 'apl 3/12/2005 00:36'!
acceptEntityInstanceConstructor: e 
	self error: 'deprecated'! !

!PlatypusExpressExpression2SmalltalkTranslater methodsFor: 'visit dictionary schema' stamp: 'AlainPlantec 11/30/2011 14:06'!
acceptEntityInstancesSet: e
	self nextPutAll: '( ', e name, ' )'.
! !

!PlatypusExpressExpression2SmalltalkTranslater methodsFor: 'visit expressions schema' stamp: 'apl 2/1/2006 23:37'!
acceptEnumerationValue: e 
	self nextPutAll: '#''' , e element asUppercase, ''''! !

!PlatypusExpressExpression2SmalltalkTranslater methodsFor: 'visit dictionary schema' stamp: 'apl 2/28/2006 10:52'!
acceptExplicitAttribute: e 
	self nextPutAll: '( '.
	self acceptTry: PltSelfIdentifier new.
	self nextPutAll: (e getSelectorFromNamesBuilder: self namesBuilder) , ') '! !

!PlatypusExpressExpression2SmalltalkTranslater methodsFor: 'visit expressions schema' stamp: 'apl 3/2/2005 23:30'!
acceptFalseConstant: e 
	^ self acceptLiteral:e! !

!PlatypusExpressExpression2SmalltalkTranslater methodsFor: 'visit expressions schema' stamp: 'apl 2/28/2006 11:09'!
acceptGroupQualifier: e 
	| grpname grpref |
	grpref := self schemaInstance lookUpNamedTypeBN: e groupName.
	grpname := grpref generatedClassName.
	self nextPutAll: 'asPlatypusComplexInstance \ #' , grpname , ')  pltAsObject '
! !

!PlatypusExpressExpression2SmalltalkTranslater methodsFor: 'visit expressions schema' stamp: 'apl 1/18/2007 11:12'!
acceptIdentifier: e 
	e referenced isPltEntityDefinition 
		ifTrue: 
			[self nextPutAll: '(' , e referenced generatedClassName , ' new'.
			(e parameters notNil and: [e parameters notEmpty]) 
				ifTrue: 
					[self nextPutAll: ' ', (self namesBuilder localFromValuesMethodNameFromEntity:  e referenced), ' ((OrderedCollection new)'.
					e parameters do: 
							[:p | 
							self nextPutAll: ' add: '.
							self acceptTry: p]
						separatedBy: [self nextPutAll: ';'].
					self nextPutAll: ' ; yourself); yourself'].
			self nextPutAll: ')']
		ifFalse: 
			[e referenced isPltAlgorithmDeclaration 
				ifTrue: 
					[(e parameters isNil or: [e parameters isEmpty]) 
						ifTrue: 
							[self nextPutAll: '(' , e referenced generatedClassName , '  invoke) ']
						ifFalse: 
							[self nextPutAll: '(' , e referenced generatedClassName 
										, '  invokeFromValues: ((OrderedCollection new)'.
							e parameters do: 
									[:p | 
									self nextPutAll: ' add: '.
									self acceptTry: p]
								separatedBy: [self nextPutAll: ';'].
							self nextPutAll: ' ; yourself))']]
				ifFalse: [self acceptTry: e referenced]]! !

!PlatypusExpressExpression2SmalltalkTranslater methodsFor: 'visit expressions schema' stamp: 'apl 3/6/2005 22:28'!
acceptInExpression: e 
	self nextPutAll: ' ( '.
	self acceptTry: e rightExpr.
	self nextPutAll: ' includes: '.
	self acceptTry: e leftExpr.
	self nextPutAll: ' )  '! !

!PlatypusExpressExpression2SmalltalkTranslater methodsFor: 'visit statements schema' stamp: 'apl 5/13/2005 11:28'!
acceptIncrementControlVariable: e 
	| vn |
	vn := self namesBuilder uniqueBlockVarName: e variableId
				owner: e.
	self nextPutAll: vn! !

!PlatypusExpressExpression2SmalltalkTranslater methodsFor: 'visit expressions schema' stamp: 'apl 3/11/2005 22:41'!
acceptInstanceConstructionExpression: e 
	self nextPutAll: ' ((PlatypusComplexInstance fromRecords: ( (OrderedCollection new) add: '.
	self acceptTry: e leftExpr.
	self nextPutAll: '; add: '.
	self acceptTry: e rightExpr.
	self nextPutAll: '; yourself)) pltAsObject )'! !

!PlatypusExpressExpression2SmalltalkTranslater methodsFor: 'visit expressions schema' stamp: 'apl 3/12/2005 00:26'!
acceptInterval: e 
	self acceptTry: e expr.
! !

!PlatypusExpressExpression2SmalltalkTranslater methodsFor: 'visit dictionary schema' stamp: 'apl 2/28/2006 10:52'!
acceptInverseAttribute: e 
	| contextvn |
	contextvn := self namesBuilder contextArgNameFromAttribute: e.
	self nextPutAll: '( '.
	self acceptTry: PltSelfIdentifier new.
	self 
		nextPutAll: (e getSelectorWithContextArgFromNamesBuilder: self namesBuilder) 
				, ' ' , contextvn 
				, ' ) '! !

!PlatypusExpressExpression2SmalltalkTranslater methodsFor: 'visit expressions schema' stamp: 'apl 3/4/2005 13:53'!
acceptLikeExpression: e 
	self nextPutAll: ' ( '.
	self acceptTry: e rightExpr.
	self nextPutAll: ' match:  '.
	self acceptTry: e leftExpr.
	self nextPutAll: ' )  '! !

!PlatypusExpressExpression2SmalltalkTranslater methodsFor: 'visit expressions schema' stamp: 'apl 3/2/2005 23:51'!
acceptLiteral: e 
	^ self nextPutAll: e val printString! !

!PlatypusExpressExpression2SmalltalkTranslater methodsFor: 'visit dictionary schema' stamp: 'apl 2/28/2006 10:52'!
acceptLocalVariable: e 
	self nextPutAll: '( '.
	self acceptTry: PltSelfIdentifier new.
	self nextPutAll: (self namesBuilder normalizedVarNameFrom: e name)
			, ' ) '! !

!PlatypusExpressExpression2SmalltalkTranslater methodsFor: 'visit expressions schema' stamp: 'apl 3/2/2005 23:30'!
acceptMissingValue: e 
	self nextPutAll: 'nil'.
! !

!PlatypusExpressExpression2SmalltalkTranslater methodsFor: 'visit dictionary schema' stamp: 'apl 2/15/2007 16:19'!
acceptNativeAlgorithm: e 
	self subclassResponsibility ! !

!PlatypusExpressExpression2SmalltalkTranslater methodsFor: 'visit expressions schema' stamp: 'AlainPlantec 4/26/2012 10:50'!
acceptNativeCode: e 
	| stmt |
	self nextPutAllCr: '"---------- native statement ---------- "'.
	stmt := e code trimBoth.
	(stmt endsWith: '.')
		ifFalse: [stmt := stmt , '.'].
	self nextPutAllCr: stmt! !

!PlatypusExpressExpression2SmalltalkTranslater methodsFor: 'visit expressions schema' stamp: 'apl 3/12/2005 00:29'!
acceptNegativeExpression: e 
	self nextPutAll: '( ('. 
	self acceptTry: e expr.
	self nextPutAll: ') negated) '. 
! !

!PlatypusExpressExpression2SmalltalkTranslater methodsFor: 'visit expressions schema' stamp: 'apl 3/2/2006 15:33'!
acceptNotExpression: e 
	self nextPutAll: '( ('.
	self acceptTry: e expr.
	self nextPutAll: ') not) '! !

!PlatypusExpressExpression2SmalltalkTranslater methodsFor: 'visit expressions schema' stamp: 'apl 3/4/2005 13:47'!
acceptOrExpression: e 
	self nextPutAll: ' ( '.
	self acceptTry: e leftExpr.
	self nextPutAll: ' or: ['.
	self acceptTry: e rightExpr.
	self nextPutAll: ' ])  '! !

!PlatypusExpressExpression2SmalltalkTranslater methodsFor: 'visit dictionary schema' stamp: 'apl 2/28/2006 10:53'!
acceptParameterDefinition: e 
	self nextPutAll: '( '.
	self acceptTry: PltSelfIdentifier new.
	self nextPutAll: (self namesBuilder normalizedVarNameFrom: e name) , ' ) '! !

!PlatypusExpressExpression2SmalltalkTranslater methodsFor: 'visit expressions schema' stamp: 'apl 3/12/2005 00:39'!
acceptPiConstant: e 
	self nextPutAll: ' 3.14159 '! !

!PlatypusExpressExpression2SmalltalkTranslater methodsFor: 'visit expressions schema' stamp: 'apl 3/12/2005 00:42'!
acceptPositiveExpression: e 
	self nextPutAll: '( ('.
	self acceptTry: e expr.
	self nextPutAll: ') abs ) '! !

!PlatypusExpressExpression2SmalltalkTranslater methodsFor: 'visit expressions schema' stamp: 'apl 5/27/2005 10:10'!
acceptQualifiedExpression: e 

	e qualifiers do: 
			[:q | 
			self nextPutAll: '( '.
			q isPltGroupQualifier ifTrue: [self nextPutAll: '( ']].
	e head acceptTry: self.
	e qualifiers do: 
			[:q | 
			self acceptTry: q.
			self nextPutAll: ') ']! !

!PlatypusExpressExpression2SmalltalkTranslater methodsFor: 'visit expressions schema' stamp: 'apl 3/12/2005 14:21'!
acceptQueryExpression: e 
	self nextPutAll: '('.
	self acceptTry: e aggregateSource.
	e aggregateSource computedDomain isPltArrayType
		ifTrue: [self nextPutAll: ' collect: [ :'.
			self acceptTry: e variable.
			self nextPutAll: ' | ('.
			self acceptTry: e suchThat.
			self nextPutAll: ' ) ifTrue: [ '.
			self acceptTry: e variable.
			self nextPutAll: ' ] ifFalse: [ nil ]']
		ifFalse: [self nextPutAll: ' select: [ :'.
			self acceptTry: e variable.
			self nextPutAll: ' | '.
			self acceptTry: e suchThat].
	self nextPutAll: '])'! !

!PlatypusExpressExpression2SmalltalkTranslater methodsFor: 'visit expressions schema' stamp: 'apl 5/27/2005 10:21'!
acceptQueryVariable: e 
	| vn |
	vn := self namesBuilder uniqueBlockVarName: e variableId owner: e.
	self nextPutAll: vn, ' '! !

!PlatypusExpressExpression2SmalltalkTranslater methodsFor: 'visit expressions schema' stamp: 'apl 3/12/2005 01:10'!
acceptRangeQualifier: e 

	self nextPutAll: '  pltCopyFrom:  '.
	self acceptTry: e index1.
	self nextPutAll: '  to:  '.
	self acceptTry: e index2! !

!PlatypusExpressExpression2SmalltalkTranslater methodsFor: 'visit expressions schema' stamp: 'apl 2/28/2006 10:43'!
acceptSelfIdentifier: e 
	receiverName
		ifNil: [self nextPutAll: ' self ']
		ifNotNil: [self nextPutAll: receiverName, ' ']! !

!PlatypusExpressExpression2SmalltalkTranslater methodsFor: 'visit expressions schema' stamp: 'apl 2/28/2006 23:30'!
acceptStringLiteral: e 

	self nextPutAll: (self unshunkedString: e val) printString! !

!PlatypusExpressExpression2SmalltalkTranslater methodsFor: 'visit expressions schema' stamp: 'apl 3/2/2005 23:30'!
acceptTrueConstant: e 
	^ self acceptLiteral: e! !

!PlatypusExpressExpression2SmalltalkTranslater methodsFor: 'visit expressions schema' stamp: 'apl 3/2/2005 23:30'!
acceptUnknownConstant: e 
	^ self acceptLiteral: e! !

!PlatypusExpressExpression2SmalltalkTranslater methodsFor: 'visit expressions schema' stamp: 'apl 3/4/2005 13:49'!
acceptXorExpression: e 
	self nextPutAll: ' ( '.
	self acceptTry: e leftExpr.
	self nextPutAll: ' xor: ['.
	self acceptTry: e rightExpr.
	self nextPutAll: ' ])  '! !

!PlatypusExpressExpression2SmalltalkTranslater methodsFor: 'accessing' stamp: 'apl 3/15/2005 19:50'!
namesBuilder
	^ self requestor namesBuilder! !

!PlatypusExpressExpression2SmalltalkTranslater methodsFor: 'accessing' stamp: 'apl 2/28/2006 10:35'!
receiverName: aNameForReceiver 
	receiverName := aNameForReceiver.
! !

!PlatypusExpressExpression2SmalltalkTranslater methodsFor: 'accessing' stamp: 'apl 2/14/2007 14:55'!
receiverName: aNameForReceiver fromTranslater: aTranslater 
	self receiverName: aNameForReceiver.
	self fromTranslater: aTranslater ! !

!PlatypusExpressExpression2SmalltalkTranslater methodsFor: 'accessing' stamp: 'apl 2/14/2007 14:55'!
receiverName: aNameForReceiver fromTranslater: aTranslater resultStream: aStream 
	self receiverName: aNameForReceiver.
	self fromTranslater: aTranslater resultStream: aStream! !

PlatypusExpressExpression2SmalltalkTranslater subclass: #PlatypusExpressExpression2VWTranslater
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-translater-private'!

!PlatypusExpressExpression2VWTranslater class methodsFor: 'accessing' stamp: 'apl 2/15/2007 16:43'!
expressionTranslaterClassName
	^ #PlatypusExpressExpression2VWTranslater! !

!PlatypusExpressExpression2VWTranslater class methodsFor: 'accessing' stamp: 'apl 2/15/2007 16:43'!
statementTranslaterClassName
	^ #PlatypusExpressStatement2VWTranslater! !

!PlatypusExpressExpression2VWTranslater methodsFor: 'visit dictionary schema' stamp: 'apl 2/15/2007 16:20'!
acceptNativeAlgorithm: e 
	| code |
	(code := e visualWorksCode)
		ifNil: [code := e platypusInterpreterCode.
			code
				ifNil: [Error signal: 'no VisualWorks code in native algorithm']
				ifNotNil: [Transcript show: 'Platypus: Warning: ' , self class name , '>>acceptNativeAlgorithm: "no VisualWorks code, taking platypus interpreter code instead"' withCRs.
					Transcript show: e asClearText withCRs]].
	^ code acceptTry: self! !

PlatypusExpressTranslater subclass: #PlatypusExpressStatement2SmalltalkTranslater
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-translater-private'!

PlatypusExpressStatement2SmalltalkTranslater subclass: #PlatypusExpressStatement2PharoTranslater
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-translater-private'!

!PlatypusExpressStatement2PharoTranslater class methodsFor: 'accessing' stamp: 'AlainPlantec 7/14/2011 18:04'!
expressionTranslaterClassName
	^ #PlatypusExpressExpression2PharoTranslater! !

!PlatypusExpressStatement2PharoTranslater class methodsFor: 'accessing' stamp: 'AlainPlantec 7/14/2011 18:03'!
statementTranslaterClassName
	^ #PlatypusExpressStatement2PharoTranslater! !

!PlatypusExpressStatement2PharoTranslater methodsFor: 'visit dictionary schema' stamp: 'AlainPlantec 7/14/2011 16:55'!
acceptNativeAlgorithm: e 
	| code |
	(code := e pharoCode)
		ifNil: [code := e platypusInterpreterCode.
			code
				ifNil: [Error signal: 'no pharo code in native algorithm']
				ifNotNil: [Transcript show: 'Platypus: Warning: ' , self class name , '>>acceptNativeAlgorithm: "no pharo code, taking platypus interpreter code instead"' withCRs , e asClearText withCRs]].
	^ code acceptTry: self! !

!PlatypusExpressStatement2SmalltalkTranslater methodsFor: 'visit statements schema' stamp: 'apl 6/29/2007 20:44'!
acceptAliasStatement: e 
	self nextPutAll: '(PlatypusCoreAliasStatement alias: ('.
	self expressionTranslaterClass accept: e variable ref fromTranslater: self.
	self nextPutAllCr: ') '.
	self nextPutAll: 'statementsBlock: [ :'.
	self expressionTranslaterClass accept: e variable fromTranslater: self.
	self nextPutAll: ' | '.
	e statements
		do: [:stmt | self acceptTry: stmt].
	self nextPutAllCr: ']).'.
! !

!PlatypusExpressStatement2SmalltalkTranslater methodsFor: 'visit statements schema' stamp: 'apl 2/27/2006 17:24'!
acceptAliasStatementVariable: e 
	| vn |
	vn := self namesBuilder
				uniqueBlockVarName: (self namesBuilder normalizedNameFrom: e aliasIdent first: false)
				owner: e.
	self nextPutAll: vn , ': '! !

!PlatypusExpressStatement2SmalltalkTranslater methodsFor: 'visit statements schema' stamp: 'apl 2/15/2007 16:36'!
acceptAssignable: e 
	e qualifiers
		ifEmpty: [self nextPutAll: ' self '
					, (self namesBuilder normalizedVarNameFrom: e head name) , ': ']
		ifNotEmpty: [:quals | 
			quals
				do: [:q | q isPltGroupQualifier
						ifTrue: [self nextPutAll: '( ']].
			e qualifiers allButLast
				do: [:q | self nextPutAll: '( '].
			self expressionTranslaterClass accept: e head fromTranslater: self.
			e qualifiers allButLast
				do: [:q | 
					self expressionTranslaterClass accept: q fromTranslater: self.
					self nextPutAll: ')']
				separatedBy: [].
			e qualifiers last acceptTry: self]! !

!PlatypusExpressStatement2SmalltalkTranslater methodsFor: 'visit statements schema' stamp: 'apl 2/15/2007 16:36'!
acceptAssignmentStatement: e 
	self acceptTry: e left.
	self expressionTranslaterClass accept: e rightExpr fromTranslater: self.
	self nextPutAllCr: ' .'! !

!PlatypusExpressStatement2SmalltalkTranslater methodsFor: 'visit dictionary schema' stamp: 'apl 2/28/2006 11:15'!
acceptAttributeQualifier: e 
	| selector tmpAttr |
	tmpAttr := PltExplicitAttribute new name: e attributeName.
	selector := tmpAttr getSelectorFromNamesBuilder: self namesBuilder.
	self nextPutAll: ' ' , selector , ': '! !

!PlatypusExpressStatement2SmalltalkTranslater methodsFor: 'visit statements schema' stamp: 'apl 2/15/2007 16:36'!
acceptCaseStatement: e 
	| guardBlocksAssocs otherWiseBlock selector |
	guardBlocksAssocs := '((OrderedCollection new) '.
	e caseActions
		do: [:ca | 
			guardBlocksAssocs := guardBlocksAssocs , ' add: ( ( (OrderedCollection new) '.
			ca labels
				do: [:lab | guardBlocksAssocs := guardBlocksAssocs , 'add: ['
								, (self expressionTranslaterClass translate: lab fromTranslater: self) , ']; '].
			guardBlocksAssocs := guardBlocksAssocs , 'yourself) -> [ '
						, (self class translate: ca action fromTranslater: self) , ']); '].
	guardBlocksAssocs := guardBlocksAssocs , 'yourself) '.
	otherWiseBlock := e caseOtherwise
				ifNil: ['[]']
				ifNotNil: ['['
						, (self class translate: e caseOtherwise fromTranslater: self) , ']'].
	selector := self expressionTranslaterClass translate: e selector fromTranslater: self.
	self nextPutAllCr: 'PlatypusCoreCaseStatement caseActionBlocks: ' , guardBlocksAssocs , ' otherwiseBlock: ' , otherWiseBlock , ' case: ' , selector , '.'! !

!PlatypusExpressStatement2SmalltalkTranslater methodsFor: 'visit statements schema' stamp: 'apl 5/14/2005 12:06'!
acceptCompoundStatement: e 
	e statements do: [:stmt | self acceptTry: stmt].
! !

!PlatypusExpressStatement2SmalltalkTranslater methodsFor: 'visit expressions schema' stamp: 'apl 2/15/2007 16:37'!
acceptElementQualifier: e 
	self nextPutAll: '  at:  '.
	self expressionTranslaterClass accept: e index fromTranslater: self.
	self nextPutAll: '  put:  '! !

!PlatypusExpressStatement2SmalltalkTranslater methodsFor: 'visit statements schema' stamp: 'apl 2/28/2006 22:47'!
acceptEndSplitmarkStatement: e 
	self nextPutAllCr: 'self class schemaInstance popSplitmark.'! !

!PlatypusExpressStatement2SmalltalkTranslater methodsFor: 'visit statements schema' stamp: 'apl 1/31/2006 18:12'!
acceptEscapeStatement: e 
	self nextPutAllCr: 'PlatypusExpressEscapeStatementException signal. '! !

!PlatypusExpressStatement2SmalltalkTranslater methodsFor: 'visit expressions schema' stamp: 'apl 2/15/2007 16:37'!
acceptIdentifier: e 
	e referenced isPltAlgorithmDeclaration
		ifTrue: [(e parameters isNil
					or: [e parameters isEmpty])
				ifTrue: [self nextPutAll: '(' , e referenced generatedClassName , '  invoke).']
				ifFalse: [self nextPutAll: '(' , e referenced generatedClassName , '  invokeFromValues: ((OrderedCollection new) '.
					(e parameters
						ifNil: [#()])
						do: [:p | 
							self nextPutAll: 'add: '.
							self expressionTranslaterClass accept: p fromTranslater: self]
						separatedBy: [self nextPutAll: '; '].
					self nextPutAllCr: '; yourself)).']]
		ifFalse: [self acceptTry: e referenced]! !

!PlatypusExpressStatement2SmalltalkTranslater methodsFor: 'visit statements schema' stamp: 'apl 2/15/2007 16:37'!
acceptIfStatement: e 
	self nextPutAll: '('.
	self expressionTranslaterClass accept: e selector fromTranslater: self.
	self nextPutAllCr: ') ifTrue: ['.
	e thenStatements
		do: [:stmt | self acceptTry: stmt].
	e elseStatements
		ifNotNil: [self nextPutAllCr: '] ifFalse: ['.
			e elseStatements
				do: [:stmt | self acceptTry: stmt]].
	self nextPutAllCr: '].'! !

!PlatypusExpressStatement2SmalltalkTranslater methodsFor: 'visit dictionary schema' stamp: 'apl 2/28/2006 11:16'!
acceptLocalVariable: e 
	self nextPutAll: ' self '
			, (self namesBuilder normalizedVarNameFrom: e name) , ': '! !

!PlatypusExpressStatement2SmalltalkTranslater methodsFor: 'visit dictionary schema' stamp: 'apl 2/15/2007 16:25'!
acceptNativeAlgorithm: e 
	self subclassResponsibility ! !

!PlatypusExpressStatement2SmalltalkTranslater methodsFor: 'visit statements schema' stamp: 'AlainPlantec 4/26/2012 10:50'!
acceptNativeCode: e 
	| stmt |
	self nextPutAllCr: '"---------- native statement ---------- "'.
	stmt := e code trimBoth.
	(stmt endsWith: '.')
		ifFalse: [stmt := stmt , '.'].
	self nextPutAllCr: stmt! !

!PlatypusExpressStatement2SmalltalkTranslater methodsFor: 'visit statements schema' stamp: 'apl 2/15/2007 16:37'!
acceptOutputStatement: e 
	self nextPutAll: 'self class schemaInstance splitMarkOutput: ( '.
	self expressionTranslaterClass accept: e output fromTranslater: self.
	self nextPutAllCr: '). '! !

!PlatypusExpressStatement2SmalltalkTranslater methodsFor: 'visit dictionary schema' stamp: 'apl 2/28/2006 11:16'!
acceptParameterDefinition: e 
	self nextPutAll: ' self '
			, (self namesBuilder normalizedVarNameFrom: e name) , ': '! !

!PlatypusExpressStatement2SmalltalkTranslater methodsFor: 'visit statements schema' stamp: 'apl 6/17/2005 22:13'!
acceptQualifiedExpression: e 
	e qualifiers
		do: [:q | 
			q isPltGroupQualifier
				ifTrue: [self nextPutAll: '( ']].
	e head acceptTry: self.
	e qualifiers
		do: [:q | 
			self acceptTry: q.] separatedBy: [
			self nextPutAll: ') ']! !

!PlatypusExpressStatement2SmalltalkTranslater methodsFor: 'visit statements schema' stamp: 'apl 2/15/2007 16:37'!
acceptRepeatStatement: e 
	| whileBlock untilBlock statementsBlock first last incrVar blockHead novar |
	novar := 'r' , e identityHash asString.
	e incrControl
		ifNil: [blockHead := ' [:' , novar , ' | ']
		ifNotNil: [incrVar := self expressionTranslaterClass translate: e incrControl variable fromTranslater: self.
			first := self expressionTranslaterClass translate: e incrControl first fromTranslater: self.
			last := self expressionTranslaterClass translate: e incrControl last fromTranslater: self.
			blockHead := ' [ :' , incrVar , ' | '].
	whileBlock := e whileControl
				ifNil: ['']
				ifNotNil: ['whileControlBlock: ' , blockHead
						, (self expressionTranslaterClass translate: e whileControl fromTranslater: self) , ']'].
	untilBlock := e untilControl
				ifNil: ['']
				ifNotNil: ['untilControlBlock: ' , blockHead
						, (self expressionTranslaterClass translate: e untilControl fromTranslater: self) , ']'].
	statementsBlock := ''.
	e statements
		do: [:stmt | statementsBlock := statementsBlock
						, (self class translate: stmt fromTranslater: self)].
	statementsBlock := statementsBlock , ']'.
	e incrControl
		ifNil: [self nextPutAllCr: ' PlatypusCoreRepeatStatement ' , whileBlock , '  ' , untilBlock , ' repeat: [' , statementsBlock , '.']
		ifNotNil: [self nextPutAllCr: 'PlatypusCoreRepeatStatement ' , whileBlock , '  ' , untilBlock , ' repeat: ' , blockHead , statementsBlock , ' from: ' , first , ' to: ' , last , '.']! !

!PlatypusExpressStatement2SmalltalkTranslater methodsFor: 'visit statements schema' stamp: 'apl 2/15/2007 16:37'!
acceptReturnStatement: e 
	self nextPutAll: '	^ self return: ('.
	e returned
		ifNil: [self nextPutAll: 'self']
		ifNotNil: [self expressionTranslaterClass accept: e returned fromTranslater: self].
	self nextPutAllCr: ').'! !

!PlatypusExpressStatement2SmalltalkTranslater methodsFor: 'visit statements schema' stamp: 'apl 1/31/2006 18:13'!
acceptSkipStatement: e 
	self nextPutAllCr: 'PlatypusExpressSkipStatementException signal. '! !

!PlatypusExpressStatement2SmalltalkTranslater methodsFor: 'visit statements schema' stamp: 'apl 2/15/2007 16:37'!
acceptSplitmarkStatement: e 
	self nextPutAll: 'self class schemaInstance pushSplitmark: ( '.
	self expressionTranslaterClass accept: e filename fromTranslater: self.
	self nextPutAllCr: ') append: ' , e append printString , '. '! !

!PlatypusExpressStatement2SmalltalkTranslater methodsFor: 'accessing' stamp: 'apl 3/15/2005 19:55'!
namesBuilder
	^ self requestor namesBuilder! !

PlatypusExpressStatement2SmalltalkTranslater subclass: #PlatypusExpressStatement2VWTranslater
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-translater-private'!

!PlatypusExpressStatement2VWTranslater class methodsFor: 'accessing' stamp: 'apl 2/15/2007 16:42'!
expressionTranslaterClassName
	^ #PlatypusExpressExpression2VWTranslater! !

!PlatypusExpressStatement2VWTranslater class methodsFor: 'accessing' stamp: 'apl 2/15/2007 16:43'!
statementTranslaterClassName
	^ #PlatypusExpressStatement2VWTranslater! !

!PlatypusExpressStatement2VWTranslater methodsFor: 'visit dictionary schema' stamp: 'apl 2/15/2007 16:25'!
acceptNativeAlgorithm: e 
	| code |
	(code := e visualWorksCode)
		ifNil: [code := e platypusInterpreterCode.
			code
				ifNil: [Error signal: 'no visualworks code in native algorithm']
				ifNotNil: [Transcript show: 'Platypus: Warning: ' , self class name , '>>acceptNativeAlgorithm: "no visualworks code, taking platypus interpreter code instead"' withCRs , e asClearText withCRs]].
	^ code acceptTry: self! !

PlatypusExpressTranslater subclass: #PlatypusExpressStructure2SmalltalkTranslater
	instanceVariableNames: 'translationsDone namesBuilder localTranslationOnly schemaInstance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-translater-private'!

PlatypusExpressStructure2SmalltalkTranslater subclass: #PlatypusExpressStructure2PharoTranslater
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-translater-private'!

PlatypusExpressStructure2PharoTranslater subclass: #PlatypusExpressMetaStructure2PharoTranslater
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-translater-private'!

!PlatypusExpressMetaStructure2PharoTranslater methodsFor: 'generating from schemaInstance' stamp: 'apl 1/30/2007 12:56'!
buildInitializeMethodFromSchemaInstance: e 
	| selector clsName code |
	clsName := e generatedClassName.
	selector := 'bootstraps'.
	code := '	self reinitializeSingleton. self singleton buildIndexes.'.
	self 
		fileOutMethodSource: selector , ' ' , code
		className: clsName
		meta: true
		category: 'initializing'! !

!PlatypusExpressStructure2PharoTranslater class methodsFor: 'accessing' stamp: 'AlainPlantec 7/14/2011 18:04'!
expressionTranslaterClassName
	^ #PlatypusExpressExpression2PharoTranslater! !

!PlatypusExpressStructure2PharoTranslater class methodsFor: 'accessing' stamp: 'AlainPlantec 7/14/2011 18:03'!
statementTranslaterClassName
	^ #PlatypusExpressStatement2PharoTranslater! !

!PlatypusExpressStructure2PharoTranslater methodsFor: 'utilities' stamp: 'apl 1/25/2007 11:25'!
commentFromMetaData: e classname: aClassName 
	self nextPutAllCr: '!!' , aClassName 
				, '  commentStamp: ''platypus comment'' prior:0!!'.
	self nextPutAllCr: PlatypusCoreObject expressSchemaCodeStartMark.
	self nextPutAll: (self unshunkedString: e translatedSchemaCode).
	self nextPutAll: PlatypusCoreObject expressSchemaCodeStopMark , '!!'! !

!PlatypusExpressStructure2PharoTranslater methodsFor: 'utilities' stamp: 'apl 12/6/2006 13:52'!
fileOutClassDefinition: aClassName superClassName: superClassName instVars: instVars classVars: classVars namespace: namespace packageName: packageName category: aCategoryName 
	| pointPos supName |
	pointPos := superClassName indexOf: $..
	supName := superClassName copyFrom: pointPos + 1 to: superClassName size.
	self nextPutAllCr: ''.
	self nextPutAll: supName , ' subclass: #'.
	self nextPutAllCr: aClassName.
	self nextPutAllCr: ' instanceVariableNames: ''' , instVars , ''''.
	self nextPutAllCr: ' classVariableNames: ''' , classVars , ''''.
	self nextPutAllCr: ' poolDictionaries: '''''.
	self nextPutAll: ' category: '''.
	self nextPutAll: aCategoryName.
	self nextPutAllCrCr: '''!!'.
	self buildPlatypusSignatureMethodForClass: aClassName namespace: namespace packageName: packageName category: aCategoryName! !

!PlatypusExpressStructure2PharoTranslater methodsFor: 'utilities' stamp: 'apl 12/15/2006 16:18'!
fileOutDoIt: aSource 
	self
				nextPutAllCr: aSource, '!!'
				
! !

!PlatypusExpressStructure2PharoTranslater methodsFor: 'utilities' stamp: 'AlainPlantec 4/26/2012 08:14'!
fileOutMethodSource: aSource className: aClassName meta: isMeta packageName: packageName category: aCategorySymbol 
	| categoryCode |
	categoryCode := self namesBuilder 
				normalizedMethodCategory: aCategorySymbol
				className: aClassName
				meta: isMeta.
	self nextPutAllCrCr: categoryCode.
	self nextPutAllCrCr: (RBConfigurableFormatter new format: (RBParser parseMethod: aSource)).
	self nextPutAllCr: '!! !!'.
! !

!PlatypusExpressStructure2PharoTranslater methodsFor: 'utilities' stamp: 'apl 12/5/2006 21:31'!
fileOutNamespaceDefinition: aNamespaceName imports: imports environment: envName packageName: packageName category: aCategoryName 
! !

!PlatypusExpressStructure2PharoTranslater methodsFor: 'utilities' stamp: 'apl 2/14/2007 17:18'!
finalResultFrom: aString 
	^ (super finalResultFrom: aString)! !

!PlatypusExpressStructure2PharoTranslater methodsFor: 'utilities' stamp: 'apl 12/16/2006 00:04'!
mcCategory: aCat 
	^ '*' , aCat! !

!PlatypusExpressStructure2PharoTranslater methodsFor: 'utilities' stamp: 'apl 12/15/2006 22:23'!
qualifiedClassNameOf: e 
	^ e generatedClassName! !

!PlatypusExpressStructure2SmalltalkTranslater class methodsFor: 'instance creation' stamp: 'apl 12/7/2006 13:38'!
namesBuilder: aNamesBuilder
	^ self new namesBuilder: aNamesBuilder! !

!PlatypusExpressStructure2SmalltalkTranslater class methodsFor: 'accessing' stamp: 'apl 12/7/2006 17:28'!
translaterRequiredAspects
	^ #(
		#classPrefix
		#systemCategoryPrefix
		#rootClassName
		#rootClassSystemCategory
	)! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'visit dictionary schema' stamp: 'apl 3/2/2005 22:18'!
acceptDerivedAttribute: e 
	(translationsDone includes: e)
		ifFalse: [translationsDone add: e.
			self doDerivedAttribute: e.
			]! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'visit dictionary schema' stamp: 'AlainPlantec 6/15/2012 12:41'!
acceptEntityDefinition: e 
	(translationsDone includes: e)
		ifFalse: [translationsDone add: e.
			schemaInstance = e schemaInstance
				ifTrue: [self doEntityDefinition: e.
					super acceptEntityDefinition: e]]! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'visit dictionary schema' stamp: 'apl 3/2/2005 22:18'!
acceptExplicitAttribute: e 
	(translationsDone includes: e)
		ifFalse: [translationsDone add: e.
			self doExplicitAttribute: e.
			]! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'visit dictionary schema' stamp: 'apl 3/15/2005 16:04'!
acceptFunctionDeclaration: e 
	(translationsDone includes: e)
		ifFalse: [translationsDone add: e.
			self doAlgorithmDeclaration: e]! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'visit dictionary schema' stamp: 'AlainPlantec 11/30/2011 10:55'!
acceptGlobalRule: e 
	(translationsDone includes: e)
		ifFalse: [translationsDone add: e.
			self doGlobalRule: e]! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'visit dictionary schema' stamp: 'apl 3/3/2005 01:06'!
acceptInverseAttribute: e 
	(translationsDone includes: e)
		ifFalse: [translationsDone add: e.
			self doInverseAttribute: e]! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'visit dictionary schema' stamp: 'apl 3/15/2005 16:04'!
acceptProcedureDeclaration: e 
	(translationsDone includes: e)
		ifFalse: [translationsDone add: e.
			self doAlgorithmDeclaration: e]! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'visit dictionary schema' stamp: 'apl 12/15/2006 18:01'!
acceptSchemaDefinition: e 
	(translationsDone includes: e) 
		ifFalse: 
			[translationsDone add: e.
			self doSchemaDefinition: e.self localTranslationOnly ifFalse: [
			super acceptSchemaDefinition: e]]! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'visit dictionary schema' stamp: 'apl 3/22/2006 08:24'!
acceptSchemaInstance: e 
	(translationsDone includes: e)
		ifFalse: [translationsDone add: e.
			self doSchemaInstance: e.
			e internalSchemata
				do: [:sch | sch acceptTry: self]]! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'visit generic' stamp: 'AlainPlantec 6/15/2012 12:41'!
acceptTry: e
	schemaInstance
		ifNil: [schemaInstance := e schemaInstance].
	^ super acceptTry: e
! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'visit dictionary schema' stamp: 'apl 5/30/2005 09:50'!
acceptWhereRule: e 
	(translationsDone includes: e) 
		ifFalse: 
			[translationsDone add: e.
			self doWhereRule: e]! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'generating from algorithm' stamp: 'apl 2/15/2007 16:36'!
buildAlgorithmCodeFrom: e 
	| clsName invoquing paramInfos localInfos count ln allInfos affect code |
	clsName := e generatedClassName.
	paramInfos := self namesBuilder normalizedAlgorithmFormalParametersInfosFrom: e.
	localInfos := self namesBuilder normalizedAlgorithmLocalVariablesInfosFrom: e.
	allInfos := paramInfos asOrderedCollection , localInfos.
	invoquing := self namesBuilder functionInvokingFrom: e.
	paramInfos isEmpty
		ifFalse: [paramInfos size < 6
				ifTrue: [self
						fileOutMethodSource: invoquing , '	^ self new ' , invoquing
						className: clsName
						meta: false
						category: 'instance-creation'.
					count := 0.
					code := ''.
					paramInfos
						do: [:sp | 
							count := count + 1.
							code := code , '	self ' , sp first , ':  (values at: ' , count asString , ').'].
					self
						fileOutMethodSource: 'fromValues: values ' , code
						className: clsName
						meta: false
						category: 'accessing'.
					paramInfos size > 1
						ifTrue: [code := ''.
							paramInfos
								do: [:sp | code := code , '	self ' , sp first , ': ' , sp second , '.'].
							self
								fileOutMethodSource: invoquing , code
								className: clsName
								meta: false
								category: 'accessing']]].
	allInfos isEmpty
		ifFalse: [allInfos
				do: [:sp | 
					affect := (sp fourth isPltAggregationType
									and: [sp third])
								ifTrue: [sp second , ' ifNil: ['
										, (self namesBuilder smalltalkInitializingExpressionOf: sp fourth) , '] ifNotNil: [' , sp second , ' as: '
										, (self namesBuilder smalltalkTypeOf: sp fourth) , ']']
								ifFalse: [sp second].
					code := '	' , sp first , ' := ' , affect.
					self
						fileOutMethodSource: sp first , ': ' , sp second , '  ' , code
						className: clsName
						meta: false
						category: 'accessing'].
			allInfos
				do: [:sp | self
						fileOutMethodSource: sp first , '	 ^' , sp first
						className: clsName
						meta: false
						category: 'accessing']].
	code := '" ---------- locals assignments ----------"'.
	(e locals
		select: [:l | l initializer notNil])
		do: [:l | 
			ln := self namesBuilder normalizedVarNameFrom: l name.
			code := code , 'self ' , ln , ': (' , (self expressionTranslaterClass 
							accept: l initializer
							fromTranslater: self
							resultStream: (WriteStream on: String new)) result.
			code := code , ').'].
	code := code , '" ---------- statements ----------"'.
	e statements
		do: [:stmt | code := code , (self statementTranslaterClass
							accept: stmt
							fromTranslater: self
							resultStream: (WriteStream on: String new)) result].
	self
		fileOutMethodSource: 'invoke ' , code
		className: clsName
		meta: false
		category: 'invoking'! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'generating from entity' stamp: 'AlainPlantec 6/15/2012 13:01'!
buildClassificationMethodFromEntity: e 
	| selector clsName |
	clsName := e generatedClassName.
	selector := 'is' , clsName.
	self 
		fileOutMethodSource: selector , ' ' , '^ true'
		className: clsName
		meta: false
		category: 'classifying'.
	self 
		fileOutMethodSource: selector , ' ' , '^ false'
		className: self rootClassName
		meta: false
		packageName: self rootClassSystemCategory
		category: (self mcCategory: ((e schemaDefinition  systemCategoryFromNamesBuilder: self namesBuilder) , '-classifying' ))! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'generating from schema' stamp: 'apl 12/5/2006 18:24'!
buildContextAccessingMethodsFromSchema: e 
	| selector clsName |
	clsName := e generatedClassName.
	selector := 'context'.
		self 
					fileOutMethodSource: selector , '	^ self schemaInstance context' 
					className: clsName
					meta: false
					category: 'context-accessing'! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'generating from schemaInstance' stamp: 'apl 12/5/2006 18:57'!
buildContextAccessingMethodsFromSchemaInstance: e 
	| clsName |
	clsName := e generatedClassName.
	self 
		fileOutMethodSource: 'context	^context'
		className: clsName
		meta: false
		category: 'context-accessing'.
	self 
		fileOutMethodSource: 'context:  aContext context := aContext. super context: aContext'
		className: clsName
		meta: false
		category: 'context-accessing'! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'generating from entity' stamp: 'apl 12/5/2006 11:06'!
buildCopyGroupToMethodFromEntity: e 
	| arg1vn arg2vn selector1 selector2 code |
	arg1vn := self namesBuilder localVarName: 'aClassSymbol' inScope: e.
	arg2vn := self namesBuilder localVarName: 'anObject' inScope: e.
	selector1 := 'pltCopyGroup:'.
	selector2 := 'to: '.
	code :=  '	self class name == ' , arg1vn , ' ifTrue: [self pltCopyTo: ' , arg2vn , '] ifFalse: [super ' , selector1 , ' ' , arg1vn , ' ' , selector2 , ' ', arg2vn , ']'.
			
		self 
		fileOutMethodSource: (selector1 , arg1vn , ' ' , selector2 , arg2vn , ' ', code)
		className: e generatedClassName 
		meta: false
		category: 'copying'! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'generating from entity' stamp: 'apl 1/18/2007 10:22'!
buildCopyToMethodFromEntity: e 
	| selector clsName argvn code localCopyMthName |
	clsName := e generatedClassName.
	localCopyMthName := self namesBuilder localCopyMethodNameFromEntity: e.
	argvn := self namesBuilder localVarName: 'another' inScope: e.
	selector := 'pltCopyTo:'.
	code := '	super pltCopyTo: ' , argvn , '. self ', localCopyMthName,  ' ', argvn 
				, '.'.
	self 
		fileOutMethodSource: selector , argvn , ' ' , code
		className: clsName
		meta: false
		category: 'copying'! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'generating from schema' stamp: 'apl 12/5/2006 19:36'!
buildEntitiesMethodsFromSchema: e 
	| clsName cpt buildSelector prefix |
	clsName := e generatedClassName.
	prefix := 'entityDefinition'.
	cpt := 0.
	e entities do: 
			[:elem | 
			cpt := cpt + 1.
			buildSelector := prefix , cpt asString.
			self 
				fileOutMethodSource: buildSelector , '^ #( #''' , elem name , ''' #' 
						, (elem generatedClassNameFromNamesBuilder: self namesBuilder) , ' )'
				className: clsName
				meta: false
				category: 'entities'].
	buildSelector := prefix , 'Count'.
	self 
		fileOutMethodSource: buildSelector , ' ^ ' , cpt asString
		className: clsName
		meta: false
		category: 'entities'! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'generating from schemaInstance' stamp: 'apl 2/2/2006 11:48'!
buildExpressMetaSchemaCodeMethodFromSchemaInstance: e 
	self
		buildExpressMetaSchemaCodeMethodFromSchemaInstance: e
		intoClassNamed: (e generatedClassName)! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'generating from schemaInstance' stamp: 'apl 2/2/2006 11:48'!
buildExpressSchemaCodeMethodFromSchemaInstance: e 
	self
		buildExpressSchemaCodeMethodFromSchemaInstance: e
		intoClassNamed: (e generatedClassName)! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'generating from schemaInstance' stamp: 'apl 8/31/2006 11:50'!
buildExpressSchemaCodeMethodFromSchemaInstance: e intoClassNamed: aClassName 
	| express |
	express := e translatedSchemaCode.
	self
		fileInSplittedBaseSelector: 'expressSchemaCode'
		contents: express
		className: aClassName
		category: 'schema-accessing'
		step: 200
		meta: false! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'generating from schemaInstance' stamp: 'apl 12/5/2006 18:59'!
buildExternalsSchemaInstancesMethodFromSchemaInstance: e 
	| selector clsName code |
	clsName := e generatedClassName.
	selector := 'externalSchemaInstanceClassNames'.
	code := '	^ #('.
	e externalSchemaInstances 
		do: [:s | code := code, '	#' , s generatedClassName].
code := code, ')'.	self 
		fileOutMethodSource: selector,  ' ', code
		className: clsName
		meta: false
		category: 'accessing'.
		
! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'generating from schema' stamp: 'apl 12/5/2006 18:35'!
buildFunctionsMethodsFromSchema: e 
	| clsName cpt buildSelector prefix |
	clsName := e generatedClassName.
	prefix := 'functionDeclaration'.
	cpt := 0.
	e functionDeclarations do: 
			[:elem | 
			cpt := cpt + 1.
			buildSelector := prefix , cpt asString.
			self 
				fileOutMethodSource: buildSelector , ' ^ #( #''' , elem name , ''' #' 
						, (elem generatedClassNameFromNamesBuilder: self namesBuilder) , ' )'
				className: clsName
				meta: false
				category: 'functions'].
	buildSelector := prefix , 'Count'.
	self 
		fileOutMethodSource: buildSelector , ' ^ ' , cpt asString
		className: clsName
		meta: false
		category: 'functions'.
! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'generating from attribute' stamp: 'apl 2/15/2007 16:36'!
buildGetAccessorMethodFromDerivedAttribute: e 
	| selector clsName contextvn calledSelector receivervn receiverPart code |
	clsName := e generatedClassName.
	selector := e getSelectorWithContextArgFromNamesBuilder: self namesBuilder.
	receiverPart := 'receiver:'.
	contextvn := self namesBuilder contextArgNameFromAttribute: e.
	receivervn := self namesBuilder receiverArgNameFromAttribute: e.
	self
		fileOutMethodSource: selector , contextvn , '	^ self ' , selector , ' ' , contextvn , ' ' , receiverPart , ' self'
		className: clsName
		meta: false
		category: 'deriving'.
	code := (self expressionTranslaterClass
				receiverName: receivervn
				accept: e assign
				fromTranslater: self
				resultStream: (WriteStream on: String new)) result.
	self
		fileOutMethodSource: selector , ' ' , contextvn , ' ' , receiverPart , ' ' , receivervn , ' ^' , code
		className: clsName
		meta: false
		category: 'deriving'.
	calledSelector := selector.
	selector := e getSelectorFromNamesBuilder: self namesBuilder.
	self
		fileOutMethodSource: selector , '	^ self ' , calledSelector , self contextAccessingCode
		className: clsName
		meta: false
		category: 'deriving'! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'generating from attribute' stamp: 'apl 2/9/2007 14:42'!
buildGetAccessorMethodFromInverseAttribute: e 
	| selector clsName invertedAttrOwnerClassName invertedAttrGetterSelector foundvn currvn contextvn cmp calledSelector code |
	clsName := e generatedClassName.
	selector := e getSelectorWithContextArgFromNamesBuilder: self namesBuilder.
	contextvn := self namesBuilder contextArgNameFromAttribute: e.
	invertedAttrOwnerClassName := e invertedAttr ref generatedClassNameFromNamesBuilder: self namesBuilder.
	invertedAttrGetterSelector := e invertedAttr ref getSelectorFromNamesBuilder: self namesBuilder.
	currvn := self namesBuilder localVarName: 'curr' inScope: e owner.
	e minCardinality
		ifNil: [e invertedAttr ref domain isPltAggregationType
				ifTrue: [cmp := 'includes: ']
				ifFalse: [cmp := ' = '].
			code := contextvn , '  allInstancesOf: ' , invertedAttrOwnerClassName , ' do: [ :repo :inst |  ((inst ' , invertedAttrGetterSelector , ') ' , cmp , ' self) ifTrue: [^ inst ]]. ^ nil']
		ifNotNil: [foundvn := self namesBuilder localVarName: 'founds' inScope: e owner.
			code := '	| ' , foundvn , ' |'.
			e duplicates
				ifTrue: [code := code , ' ' , foundvn , ' := Bag new.']
				ifFalse: [code := code , ' ' , foundvn , ' := Set new.'].
			code := code , contextvn , '  allInstancesOf: ' , invertedAttrOwnerClassName , ' do: [ :repo :inst |  | ' , currvn , ' |	(' , currvn , ' := inst ' , invertedAttrGetterSelector , ') == self ifTrue: [' , foundvn , ' add: ' , currvn , ']].' , ' ^ ' , foundvn].
	self
		fileOutMethodSource: selector , ' ' , contextvn , ' ' , code
		className: clsName
		meta: false
		category: 'inverse-accessing'.
	selector := e getSelectorFromNamesBuilder: self namesBuilder.
	calledSelector := e getSelectorWithContextArgFromNamesBuilder: self namesBuilder.
	self
		fileOutMethodSource: selector , '	^ self ' , calledSelector , self contextAccessingCode
		className: clsName
		meta: false
		category: 'inverse-accessing'! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'generating from attribute' stamp: 'alain.plantec 12/18/2008 10:06'!
buildGetAccessorMethodFromWhereRule: e 
	| selector clsName contextvn calledSelector code |
	clsName := e generatedClassName.
	selector := e getSelectorWithContextArgFromNamesBuilder: self namesBuilder.
	contextvn :=  'aContext'.
	code := '	^ ' , (self expressionTranslaterClass
					accept: e whereValue
					fromTranslater: self
					resultStream: (WriteStream on: String new)) result.
	self
		fileOutMethodSource: selector , contextvn , code
		className: clsName
		meta: false
		category: 'rules'.
	calledSelector := selector.
	selector := e getSelectorFromNamesBuilder: self namesBuilder.
	self
		fileOutMethodSource: selector , '	^ self ' , calledSelector , self contextAccessingCode
		className: clsName
		meta: false
		category: 'rules'! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'generating from attribute' stamp: 'apl 12/7/2006 12:36'!
buildGetAndSetAccessorMethodFromExpliciteAttribute: e 
	| vname argName selector lowSet clsName getSelector |
	vname := e instVarNameFromNamesBuilder: self namesBuilder.
	clsName := e generatedClassName.
	argName := self namesBuilder argNameFor: e domain scopeMetaData: e owner.
	lowSet := self lowSetExpressionFromAttribute: e.
	selector := e getSelectorFromNamesBuilder: self namesBuilder.
	self 
					fileOutMethodSource: selector , '	 ^' , vname
					className: clsName
					meta: false
					category: 'accessing'.
	selector := e setSelectorFromNamesBuilder: self namesBuilder.
	self 
					fileOutMethodSource: selector , argName , '	self ' 
							, (e lowSetSelectorFromNamesBuilder: self namesBuilder) , argName
					className: clsName
					meta: false
					category: 'set-accessing'.
	selector := e lowSetSelectorFromNamesBuilder: self namesBuilder.
	self 
					fileOutMethodSource: selector , argName , '	' , vname , ' := ' , lowSet
					className: clsName
					meta: false
					category: 'accessing'.
	selector := e fastSetSelectorFromNamesBuilder: self namesBuilder.
	self 
					fileOutMethodSource: selector , argName , '	' , vname , ' := ' , argName
					className: clsName
					meta: false
					category: 'fast-set-accessing'.
	selector := e getSelectorWithContextArgFromNamesBuilder: self namesBuilder.
	argName := self namesBuilder contextArgNameFromAttribute: e.
	getSelector := e getSelectorFromNamesBuilder: self namesBuilder.
self 
					fileOutMethodSource: selector , argName , '	^ self ' , getSelector
					className: clsName
					meta: false
					category: 'with-context-accessing'! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'generating from algorithm' stamp: 'AlainPlantec 11/30/2011 14:26'!
buildGlobalRuleAccessingFrom: e 
	|  clsName localInfos affect code|
	clsName := e generatedClassName.
	localInfos := self namesBuilder normalizedAlgorithmLocalVariablesInfosFrom: e.
	localInfos
				do: [:sp | 
					affect := (sp fourth isPltAggregationType
									and: [sp third])
								ifTrue: [sp second , ' ifNil: ['
										, (self namesBuilder smalltalkInitializingExpressionOf: sp fourth) , '] ifNotNil: [' , sp second , ' as: '
										, (self namesBuilder smalltalkTypeOf: sp fourth) , ']']
								ifFalse: [sp second].
					code := '	' , sp first , ' := ' , affect.
					self
						fileOutMethodSource: sp first , ': ' , sp second , '  ' , code
						className: clsName
						meta: false
						category: 'accessing'].
			localInfos
				do: [:sp | self
						fileOutMethodSource: sp first , '	 ^' , sp first
						className: clsName
						meta: false
						category: 'accessing']! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'generating from algorithm' stamp: 'AlainPlantec 11/30/2011 12:21'!
buildGlobalRuleInitializeFrom: e 
	| code clsName |
	clsName := e generatedClassName.
	code := String cr, String tab, 'super initialize.', String cr.
	code := code, String tab, '" ---------- locals assignments ----------"'.
	(e locals select: [:l | l initializer notNil])
		do: [:l | | ln |
			ln := self namesBuilder normalizedVarNameFrom: l name.
			code := code , String cr, String tab, 'self ' , ln , ': (' , (self expressionTranslaterClass 
							accept: l initializer
							fromTranslater: self
							resultStream: (WriteStream on: String new)) result.
			code := code , ').'].
	e forEntities isEmpty
		ifFalse: [
			code := code, String cr, String tab, '" ---------- entity instance set assignments ----------"'.
			code := code, (String 
				streamContents: [:strm | 
					e forEntities do: [:fe | | ent |
						ent := fe entityRef ref. 
						strm nextPutAll: String cr, String tab, fe name, ' := self myContext allInstancesOf: ', ent generatedClassName, '.']])].	
	self
		fileOutMethodSource: 'initialize' , code
		className: clsName
		meta: false
		category: 'initializing'! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'generating from algorithm' stamp: 'AlainPlantec 11/30/2011 14:25'!
buildGlobalRuleWhereRulesCodeFrom: e 
	| code clsName |
	clsName := e generatedClassName.
	e whereRules do: [:wr | self doWhereRule: wr].
	e whereRules 
		ifNotEmpty: [
			code := String tab, '" ---------- global checking ----------"', String cr, String tab, ' ^ self ', e whereRules first label, ' '.
			e whereRules copyWithoutFirst do: [:wr | code := code, ' and: [ self ', wr label ].
			1 to: (e whereRules size) - 1 do: [:i | code := code, '] '].
			self
				fileOutMethodSource: 'invoke ' , code
				className: clsName
				meta: false
				category: 'invoking']
! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'generating from entity' stamp: 'apl 12/5/2006 11:42'!
buildInitializeMethodFromEntity: e 
	| selector clsName code |
	clsName := e generatedClassName.
	selector := 'stepInitialize'.
	code := '	super ' , selector , '.'.
	e explicitAttributesDo: 
			[:a | 
			code := code , '	' , (self initializeStatementFromAttribute: a)].
	self 
		fileOutMethodSource: selector , ' ' , code
		className: clsName
		meta: false
		category: 'initializing'! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'generating from schemaInstance' stamp: 'apl 1/29/2007 16:59'!
buildInitializeMethodFromSchemaInstance: e 
	| selector clsName code |
	clsName := e generatedClassName.
	selector := 'initialize'.
	code := '	self reinitializeSingleton. self singleton buildIndexes.'.
	self 
		fileOutMethodSource: selector , ' ' , code
		className: clsName
		meta: true
		category: 'initializing'! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'generating from entity' stamp: 'apl 1/18/2007 11:24'!
buildLocalCopyToMethodFromEntity: e 
	| selector clsName argvn getterSelector setterSelector code |
	clsName := e generatedClassName.
	argvn := self namesBuilder localVarName: 'another' inScope: e.
	selector := self namesBuilder localCopyMethodNameFromEntity: e.
	code := ''.
	e explicitAttributesDo: 
			[:a | 
			getterSelector := a getSelectorFromNamesBuilder: self namesBuilder.
			setterSelector := a fastSetSelectorFromNamesBuilder: self namesBuilder.
			code := code , '	' , argvn , ' ' , setterSelector , ' (self ' 
						, getterSelector , ').'].
	self 
		fileOutMethodSource: selector , argvn , ' ' , code
		className: clsName
		meta: false
		category: 'copying'.
	self 
		fileOutMethodSource: ('pltLocalCopyTo: ' , argvn , ' self ', selector, argvn)
		className: clsName
		meta: false
		category: 'copying'! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'generating from entity' stamp: 'MrCleaner 1/18/2011 18:20'!
buildLocalGroupAccessingMethodFromEntity: e 
	| clsName setterSelector selectorsAndArgs reservedvn setter argvn localvn getterSelector selector code localFromValuesSelector localToValuesSelector |
	clsName := e generatedClassName.
	selectorsAndArgs := OrderedCollection new.
	reservedvn := OrderedCollection new.
	e explicitAttributesDo: 
			[:a | 
			setter := a lowSetSelectorFromNamesBuilder: self namesBuilder.
			argvn := self namesBuilder 
						argNameFor: a domain
						scopeMetaData: e
						reservedNames: reservedvn.
			selectorsAndArgs add: (Array 
						with: a
						with: setter
						with: argvn)].
	e numberOfExplicitAttributes > 1 
		ifTrue: 
			[selector := ''.
			selectorsAndArgs 
				do: [:selarg | selector := selector , selarg second , ' ' , selarg third]
				separatedBy: [selector := selector , ' '].
			code := ''.
			selectorsAndArgs do: 
					[:selarg | 
					setterSelector := selarg first 
								setSelectorFromNamesBuilder: self namesBuilder.
					code := code , '	self ' , setterSelector , selarg third , '.'].
			false ifTrue: [self 
				fileOutMethodSource: selector , ' ' , code
				className: clsName
				meta: false
				category: 'group-accessing']].
	argvn := self namesBuilder localVarName: 'values' inScope: e.
	localvn := self namesBuilder localVarName: argvn , 'loc' inScope: e.
	code := '	| ' , localvn , ' |' , localvn , ' := ' , argvn 
				, ' asOrderedCollection.'.
	selectorsAndArgs do: 
			[:selarg | 
			setterSelector := selarg first 
						setSelectorFromNamesBuilder: self namesBuilder.
			code := code , '	self ' , setterSelector , localvn , ' removeFirst.'].
	code := code , '	^ ' , localvn.
	localFromValuesSelector := self namesBuilder 
				localFromValuesMethodNameFromEntity: e.
	localToValuesSelector := self namesBuilder 
				localToValuesMethodNameFromEntity: e.
	self 
		fileOutMethodSource: localFromValuesSelector , argvn , ' ' , code
		className: clsName
		meta: false
		category: 'group-accessing'.
	code := ''.
	selectorsAndArgs do: 
			[:selarg | 
			getterSelector := selarg first 
						getSelectorFromNamesBuilder: self namesBuilder.
			code := code , '	' , argvn , ' add: (self ' , getterSelector , ').'].
	code := code , '	^ ' , argvn.
	self 
		fileOutMethodSource: localToValuesSelector , argvn , ' ' , code
		className: clsName
		meta: false
		category: 'group-accessing'.
	code := '	^ self ' , localToValuesSelector , ' (super toValues: ' , argvn 
				, ')'.
	self 
		fileOutMethodSource: 'toValues:' , argvn , ' ' , code
		className: clsName
		meta: false
		category: 'group-accessing'.
	code := '	^ self ' , localFromValuesSelector , ' (super fromValues: ' 
				, argvn , ')'.
	self 
		fileOutMethodSource: 'fromValues:' , argvn , ' ' , code
		className: clsName
		meta: false
		category: 'group-accessing'.
	self 
		fileOutMethodSource: 'localFromValues: ' , argvn , ' ^ self ' , localFromValuesSelector 
				, argvn
		className: clsName
		meta: false
		category: 'group-accessing'.
	self 
		fileOutMethodSource: 'localToValues: ' , argvn , ' ^ self ' , localToValuesSelector 
				, argvn
		className: clsName
		meta: false
		category: 'group-accessing'.
! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'generating from schemaInstance' stamp: 'apl 8/31/2006 11:50'!
buildMetaDataFileContentsMethodFromSchemaInstance: e 
	| clsName metaDataStream |
	clsName := e generatedClassName.
	metaDataStream := WriteStream on: String new.
	e metaDataToStream: metaDataStream.
	self
		fileInSplittedBaseSelector: 'metaDataFileContents'
		contents: metaDataStream contents
		className: clsName
		category: 'meta-data-accessing'
		step: 200
		meta: false! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'generating from schemaInstance' stamp: 'apl 12/7/2006 13:20'!
buildNamesBuilderClassNameMethodFromSchemaInstance: e 
	| selector clsName |
	clsName := e generatedClassName.
	selector := 'namesBuilderClassName'.
	self 
		fileOutMethodSource: selector , '	^ #' , self namesBuilder class name
		className: clsName
		meta: false
		category: 'accessing'! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'generating from schemaInstance' stamp: 'apl 12/7/2006 13:21'!
buildNamesBuilderMethodFromSchemaInstance: e 
	| selector clsName code |
	clsName := e generatedClassName.
	selector := 'namesBuilder'.
	code := '	| namesBuilder |'.
	code := code , '	namesBuilder := self namesBuilderClass new.'.
	self class translaterRequiredAspects do: 
			[:aspect | 
			code := code , '	namesBuilder ' , aspect , ': ' 
						, (self perform: aspect) printString , '.'].
	code := code , '	^ namesBuilder'.
	self 
		fileOutMethodSource: selector , code
		className: clsName
		meta: false
		category: 'accessing'! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'generating from entity' stamp: 'apl 12/15/2006 23:07'!
buildPlatypusSignatureMethodForClass: className namespace: namespace packageName: packageName category: aCategoryName 
	self 
		fileOutMethodSource: 'translatedFromISO10303P11 ^ true.'
		className: className
		meta: true packageName: packageName
		category: 'platypus-signature'.
	self 
		fileOutMethodSource: 'iso10303P11Translater ^ ''Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'''
		className: className
		meta: true packageName: packageName
		category: 'platypus-signature'.
	self 
		fileOutMethodSource: 'vwNamespaceName ^#''' , namespace , ''''
		className: className
		meta: true packageName: packageName
		category: 'platypus-signature'! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'generating from schemaInstance' stamp: 'apl 12/7/2006 17:15'!
buildRepositoryMethodFromSchemaInstance: e 
	| selector clsName repositoryClassName |
	clsName := e generatedClassName.
	repositoryClassName := e 
				repositoryClassNameFromNamesBuilder: self namesBuilder.
	selector := 'repositoryClassName'.
	self 
		fileOutMethodSource: selector , '	^ #' , repositoryClassName
		className: clsName
		meta: false
		category: 'accessing'.
	selector := 'generatedMetaDataSchemaInstanceName'.
	self 
		fileOutMethodSource: selector , '	^  #' , clsName
		className: repositoryClassName
		meta: true
		category: 'accessing'! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'generating from entity' stamp: 'AlainPlantec 10/27/2011 18:17'!
buildRootEntityClass
	| rootClsName selector code |
	(translationsDone includes: (rootClsName := self rootClassName asSymbol)) 
		ifFalse: 
			[translationsDone add: rootClsName.
			self 
				fileOutNamespaceDefinition: self rootClassSystemCategory
				imports: ''
				environment: 'Smalltalk'
				packageName: self rootClassSystemCategory
				category: self rootClassSystemCategory.
			self 
				fileOutClassDefinition: rootClsName
				superClassName: 'Object'
				instVars: ''
				classVars: ''
				namespace: self rootClassSystemCategory
				packageName: self rootClassSystemCategory
				category: self rootClassSystemCategory.
			selector := 'platypusMetaData'.
			code := '	^ self schemaDefinition metaDataFor: self name asSymbol'.
			self 
				fileOutMethodSource: selector , ' ' , code
				className: rootClsName
				meta: true
				packageName: self rootClassSystemCategory
				category: 'meta-data-accessing'.
			selector := 'platypusMetaData'.
			code := '	^ self class platypusMetaData'.
			self 
				fileOutMethodSource: selector , ' ' , code
				className: rootClsName
				meta: false
				packageName: self rootClassSystemCategory
				category: 'meta-data-accessing'.
			selector := 'context'.
			self 
				fileOutMethodSource: selector , ' ^ self schemaDefinition context'
				className: rootClsName
				meta: true
				packageName: self rootClassSystemCategory
				category: 'context-accessing']! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'generating from entity' stamp: 'apl 12/5/2006 11:35'!
buildSchemaDefinitionMethodFromAlgorithm: e 
	| selector clsName schemaClassName code |
	clsName := e generatedClassName.
	schemaClassName := e owner 
				generatedClassNameFromNamesBuilder: self namesBuilder.
	selector := 'schemaDefinition'.
	code :=  '	^ ' , schemaClassName , ' singleton'.
	self 
		fileOutMethodSource: selector,  ' ' , code
		className: clsName
		meta: true
		category: 'meta-data-accessing'! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'generating from entity' stamp: 'apl 12/5/2006 11:36'!
buildSchemaDefinitionMethodFromEntity: e 
	| selector clsName schemaClassName code |
	clsName := e generatedClassName.
	schemaClassName := e owner 
				generatedClassNameFromNamesBuilder: self namesBuilder.
	selector := 'schemaDefinition'.
	code := '	^ ' , schemaClassName , ' singleton'.

	self 
		fileOutMethodSource: selector , ' ' , code
		className: clsName
		meta: true
		category: 'meta-data-accessing'! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'generating from schemaInstance' stamp: 'apl 12/5/2006 19:09'!
buildSchemaDefinitionsMethodsFromSchemaInstance: e 
	| clsName cpt buildSelector prefix code |
	clsName := e generatedClassName.
	cpt := 0.
	prefix := 'schemaDefinition'.
	e internalSchemata do: 
			[:elem | 
			cpt := cpt + 1.
			buildSelector := prefix , cpt asString.
			code := ' ^ #( #''' , elem name , ''' #' 
						, (elem generatedClassNameFromNamesBuilder: self namesBuilder) , ' )'.
			self 
				fileOutMethodSource: buildSelector , '	' , code
				className: clsName
				meta: false
				category: 'schemata-accessing'].
	buildSelector := prefix , 'Count'.
	self 
		fileOutMethodSource: buildSelector , '	^ ' , cpt asString
		className: clsName
		meta: false
		category: 'schemata-accessing'! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'generating from schema' stamp: 'apl 12/5/2006 18:37'!
buildSchemaInstanceClassNameMethodsFromSchema: e 
	| clsName schInstClsName selector |
	clsName := e generatedClassName.
	schInstClsName := e owner 
				generatedClassNameFromNamesBuilder: self namesBuilder.
	selector := 'schemaInstanceClassName'.	
	self 
		fileOutMethodSource: selector , ' ^ #' , schInstClsName 
		className: clsName
		meta: false
		category: 'meta-data-accessing'! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'generating from entity' stamp: 'AlainPlantec 6/15/2012 12:42'!
buildSchemaInstanceMethodFromEntity: e 
	| selector clsName schemaInstanceClassName code |
	clsName := e generatedClassName.
	schemaInstanceClassName := e schemaInstance 
				generatedClassName.
	selector := 'schemaInstance'.
	code := '	^ ' , schemaInstanceClassName , ' singleton'.
	self 
		fileOutMethodSource: selector , ' ' , code
		className: clsName
		meta: true
		category: 'meta-data-accessing'! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'generating from entity' stamp: 'apl 12/5/2006 11:42'!
buildVisitMethodFromEntity: e 
	| selector clsName code category |
	clsName := e generatedClassName.
	selector := 'accept: aVisitor'.
	code :=  '	^ aVisitor accept' 
				, (self namesBuilder normalizedNameFrom: e name first: true) , ': self.'.
	self 
		fileOutMethodSource: selector , ' ' , code
		className: clsName
		meta: false
		category: 'visiting'.
		
	clsName := self namesBuilder abstractVisitorClassName.
	category :=  'visiting' 
						, (self namesBuilder normalizedNameFrom: e lookUpSchemaDefinition name
								first: true).
	selector := 'accept' 
				, (self namesBuilder normalizedNameFrom: e name first: true) , ': e'.
	code := ' "my subclasses have to redefine it"'.
	self 
		fileOutMethodSource: selector , ' ' , code
		className: clsName
		meta: false
		category: category.
! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'accessing' stamp: 'apl 12/7/2006 13:11'!
classPrefix
	^ self namesBuilder classPrefix! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'utilities' stamp: 'apl 2/2/2006 11:49'!
commentFromMetaData: e 
	| clsName |
	clsName := e generatedClassName.
	self commentFromMetaData: e classname: clsName! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'utilities' stamp: 'apl 12/7/2006 10:51'!
commentFromMetaData: e classname: aClassName 
	self subclassResponsibility ! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'generating from attribute' stamp: 'apl 8/31/2006 11:50'!
contextAccessingCode
	^ ' self class context'! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'visit dictionary schema' stamp: 'apl 12/5/2006 16:01'!
doAlgorithmDeclaration: e 
	| paramInfos localInfos allInfos instv |
	paramInfos := self namesBuilder 
				normalizedAlgorithmFormalParametersInfosFrom: e.
	localInfos := self namesBuilder 
				normalizedAlgorithmLocalVariablesInfosFrom: e.
	allInfos := paramInfos asOrderedCollection , localInfos.
	instv := ''.
	allInfos do: [:sp | instv := instv , sp first , ' '].
	self 
		fileOutClassDefinition: e generatedClassName
		superClassName: self platypusVWNamespace, '.PlatypusCoreAlgorithmDeclaration'
		instVars: instv
		classVars: ''
		category: e generatedSystemCategory.
	self commentFromMetaData: e.
	self buildAlgorithmCodeFrom: e.
	self buildSchemaDefinitionMethodFromAlgorithm: e! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'visit dictionary schema' stamp: 'apl 3/2/2005 09:44'!
doDerivedAttribute: e 
	 self buildGetAccessorMethodFromDerivedAttribute: e! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'visit dictionary schema' stamp: 'AlainPlantec 6/15/2012 12:42'!
doEntityDefinition: e 
	| superClassname instv classv |
	self localTranslationOnly 
		ifTrue: [self acceptSchemaInstance: e schemaInstance]
		ifFalse: [self buildRootEntityClass].
	e supertypes ifNotEmpty: 
			[:supertypes | 
			self localTranslationOnly 
				ifFalse: [supertypes do: [:st | self acceptEntityDefinition: st ref]].
			superClassname := e generatedSystemCategoryPrefix , '.' 
						, e supertypes first generatedClassName]
		ifEmpty: 
			[superClassname := self rootClassSystemCategory , '.' , self rootClassName].
	instv := ''.
	(self namesBuilder allInstVarNamesFromEntity: e) 
		do: [:n | instv := instv , n]
		separatedBy: [instv := instv , ' '].
	classv := ''.
	(self namesBuilder allClassVarNamesFromEntity: e) 
		, (self namesBuilder allClassInstVarNamesFromEntity: e) 
			do: [:n | classv := classv , n]
			separatedBy: [classv := classv , ' '].
	superClassname = (e generatedSystemCategory , '.' , e generatedClassName) 
		ifTrue: [superClassname := 'Object'].
	self 
		fileOutClassDefinition: e generatedClassName
		superClassName: superClassname
		instVars: instv
		classVars: classv
		category: e generatedSystemCategory.
	self commentFromMetaData: e.
	self buildInitializeMethodFromEntity: e.
	self buildClassificationMethodFromEntity: e.
	self buildVisitMethodFromEntity: e.
	self buildLocalCopyToMethodFromEntity: e.
	self buildCopyToMethodFromEntity: e.
	self buildCopyGroupToMethodFromEntity: e.
	self buildLocalGroupAccessingMethodFromEntity: e.
	self buildSchemaDefinitionMethodFromEntity: e.
	self buildSchemaInstanceMethodFromEntity: e! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'visit dictionary schema' stamp: 'apl 3/1/2005 21:14'!
doExplicitAttribute: e 
	self buildGetAndSetAccessorMethodFromExpliciteAttribute: e! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'visit dictionary schema' stamp: 'AlainPlantec 11/30/2011 14:25'!
doGlobalRule: e 
	|  instv allInfos |
	allInfos := self namesBuilder normalizedAlgorithmLocalVariablesInfosFrom: e.
	instv := ''.
	allInfos do: [:sp | instv := instv , sp first , ' '].
	instv := instv, ' ', (String streamContents: [:strm | e forEntities do: [:fe | strm nextPutAll: fe name, ' ']]).
	self 
		fileOutClassDefinition: e generatedClassName
		superClassName: self platypusVWNamespace, '.PlatypusCoreAlgorithmDeclaration'
		instVars: instv
		classVars: ''
		category: e generatedSystemCategory.
	self commentFromMetaData: e.
	self buildGlobalRuleInitializeFrom: e.
	self buildGlobalRuleAccessingFrom: e.
	self buildSchemaDefinitionMethodFromAlgorithm: e.
	self buildGlobalRuleWhereRulesCodeFrom: e
! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'visit dictionary schema' stamp: 'apl 3/3/2005 01:06'!
doInverseAttribute: e 
	self buildGetAccessorMethodFromInverseAttribute: e ! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'visit dictionary schema' stamp: 'apl 12/5/2006 15:25'!
doSchemaDefinition: e 
	self 
		fileOutClassDefinition: e generatedClassName
		superClassName: self platypusVWNamespace , '.PlatypusCoreSchema'
		instVars: ''
		classVars: ''
		category: e generatedSystemCategory.
	self commentFromMetaData: e.
	self buildSchemaInstanceClassNameMethodsFromSchema: e.
	self buildContextAccessingMethodsFromSchema: e.
	self buildEntitiesMethodsFromSchema: e.
	self buildFunctionsMethodsFromSchema: e! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'visit dictionary schema' stamp: 'apl 3/8/2007 15:06'!
doSchemaInstance: e 
	| clsName |
	self
		fileOutNamespaceDefinition: self environment
		imports: self rootClassSystemCategory , '.* '
		environment: 'Smalltalk'
		packageName: self environment
		category: self environment.
	self
		fileOutClassDefinition: (clsName := e generatedClassName)
		superClassName: self platypusVWNamespace , '.PlatypusCoreSchemaInstance'
		instVars: 'context'
		classVars: ''
		category: e generatedSystemCategory.
	self commentFromMetaData: e classname: clsName.
	self buildNamesBuilderClassNameMethodFromSchemaInstance: e.
	self buildNamesBuilderMethodFromSchemaInstance: e.
	self buildSchemaDefinitionsMethodsFromSchemaInstance: e.
	self buildContextAccessingMethodsFromSchemaInstance: e.
	self
		fileOutClassDefinition: (e repositoryClassNameFromNamesBuilder: self namesBuilder)
		superClassName: self platypusVWNamespace , '.PlatypusCoreRepository'
		instVars: ''
		classVars: ''
		category: e generatedSystemCategory.
	self buildRepositoryMethodFromSchemaInstance: e.
	self buildExternalsSchemaInstancesMethodFromSchemaInstance: e.
	self
		fileOutClassDefinition: self namesBuilder abstractVisitorClassName
		superClassName: self platypusVWNamespace , '.PlatypusCoreAbstractVisitor'
		instVars: ''
		classVars: ''
		category: e generatedSystemCategory.
	self buildInitializeMethodFromSchemaInstance: e! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'visit dictionary schema' stamp: 'apl 5/30/2005 09:56'!
doWhereRule: e 
	e label ifNotNil: [
	self buildGetAccessorMethodFromWhereRule: e]! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'utilities' stamp: 'apl 12/5/2006 08:51'!
environment
	^ self namesBuilder systemCategoryPrefix
! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'utilities' stamp: 'apl 12/5/2006 16:10'!
fileInSplittedBaseSelector: selector contents: aBigString className: clsName category: category step: step meta: isMeta 
	|  lines prev buildSelector count code |
	lines := OrderedCollection new.
	aBigString linesDo: [:line | lines add: line , '(*\\*)'].
	prev := 1.
	count := 0.
	1 to: lines size
		by: step
		do: 
			[:cpt | 
			count := count + 1.
			buildSelector := selector , count asString.
			code := '	^'.
			prev to: (lines size min: prev + step - 1)
				do: [:cpt2 | code := code , '	' , (lines at: cpt2) printString , ','].
			code := code , '	'''''.
			self 
				fileOutMethodSource: buildSelector , code
				className: clsName
				meta: isMeta
				category: category.
			prev := prev + step].
	buildSelector := selector , 'PartsCount'.
	code := ' ^' , count asString.
	self 
		fileOutMethodSource: buildSelector , code
		className: clsName
		meta: isMeta
		category: category! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'utilities' stamp: 'apl 12/6/2006 21:56'!
fileOutClassDefinition: aClassName superClassName: superClassName instVars: instVars classVars: classVars category: aCategoryName 
	self 
		fileOutClassDefinition: aClassName
		superClassName: superClassName
		instVars: instVars
		classVars: classVars
		namespace: self environment
		packageName: self environment
		category: aCategoryName! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'utilities' stamp: 'apl 12/7/2006 10:52'!
fileOutClassDefinition: aClassName superClassName: superClassName instVars: instVars classVars: classVars namespace: namespace packageName: packageName category: aCategoryName 
	self subclassResponsibility ! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'utilities' stamp: 'apl 12/15/2006 16:18'!
fileOutDoIt: aSource 
		self subclassResponsibility
! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'utilities' stamp: 'apl 12/5/2006 10:58'!
fileOutMethodSource: aSource className: aClassName meta: isMeta category: aCategorySymbol 
	self 
		fileOutMethodSource: aSource
		className: aClassName
		meta: isMeta
		packageName: self environment
		category: aCategorySymbol! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'utilities' stamp: 'apl 12/7/2006 10:52'!
fileOutMethodSource: aSource className: aClassName meta: isMeta packageName: packageName category: aCategorySymbol 
		self subclassResponsibility ! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'utilities' stamp: 'apl 12/7/2006 10:52'!
fileOutNamespaceDefinition: aNamespaceName imports: imports environment: envName packageName: packageName category: aCategoryName 
		self subclassResponsibility ! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'utilities' stamp: 'apl 2/14/2007 17:20'!
finalResultFrom: aString

 ^ super finalResultFrom: aString
! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'initialize/release' stamp: 'apl 3/2/2005 18:47'!
initialize
	super initialize.
	translationsDone := Set new.
! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'generating from attribute' stamp: 'apl 3/14/2005 10:23'!
initializeStatementFromAttribute: e 
	| varName initExpr |
	varName := e instVarNameFromNamesBuilder: self namesBuilder.
	e optionalFlag
		ifTrue: [^ varName , ' := nil.']
		ifFalse: [initExpr := self namesBuilder smalltalkInitializingExpressionOf: e domain.
			^ varName , ' := ' , initExpr , '.']! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'accessing' stamp: 'apl 3/2/2005 14:02'!
localTranslationOnly
	^ localTranslationOnly ifNil: [localTranslationOnly := false]! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'accessing' stamp: 'apl 3/2/2005 14:01'!
localTranslationOnly: anObject
	localTranslationOnly := anObject! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'generating from attribute' stamp: 'apl 2/6/2006 16:18'!
lowSetExpressionFromAttribute: e 
	| domain argName |
	domain := e domain referenced.
	argName := self namesBuilder argNameFor: domain scopeMetaData: e owner.
	domain isPltAggregationType
		ifTrue: [^ argName , ' ifNil: ['
				, (self namesBuilder smalltalkInitializingExpressionOf: domain) , '] ifNotNil: [' , argName , ' as: '
				, (self namesBuilder smalltalkTypeOf: domain) , ']']
		ifFalse: [(domain isPltDefinedType
					and: [domain domain isPltEnumerationType])
				ifTrue: [^ argName , ' asUppercase asSymbol']
				ifFalse: [^ argName]]! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'utilities' stamp: 'apl 12/16/2006 00:05'!
mcCategory: aCat 
	self subclassResponsibility! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'accessing' stamp: 'apl 12/7/2006 13:07'!
namesBuilder
	^ namesBuilder 
		! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'accessing' stamp: 'apl 12/7/2006 13:07'!
namesBuilder: aNamesBuilder
	
	 namesBuilder := aNamesBuilder
! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'utilities' stamp: 'apl 8/31/2006 12:50'!
platypusVWNamespace
	^ 'Platypus'! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'utilities' stamp: 'apl 2/1/2007 16:09'!
prettyPrint: aString 
	^ PlatypusVWPackageExporterScanner new outPut: aString! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'utilities' stamp: 'apl 12/15/2006 22:23'!
qualifiedClassNameOf: e 
		self subclassResponsibility! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'accessing' stamp: 'apl 12/7/2006 13:11'!
rootClassName
	^self namesBuilder  rootClassName! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'accessing' stamp: 'apl 12/7/2006 13:12'!
rootClassSystemCategory
	^  self namesBuilder  rootClassSystemCategory 
		! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'accessing' stamp: 'apl 12/7/2006 13:12'!
systemCategoryPrefix
	^  self namesBuilder  systemCategoryPrefix 
! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'public accessing' stamp: 'AlainPlantec 6/15/2012 12:42'!
translate: aMetaData 
	Cursor wait
		showWhile: [self acceptTry: aMetaData.
			self fileOutDoIt: (self qualifiedClassNameOf: aMetaData schemaInstance)
					, ' initialize.'.
			^ self finalResult]
! !

!PlatypusExpressStructure2SmalltalkTranslater methodsFor: 'accessing' stamp: 'apl 3/14/2005 13:57'!
xtraMethodCategory: name xtraClassname: aClassName schema: aSchema 
	^ String cr , '!!' , aClassName , ' methodsFor: ''' , '*'
		, (aSchema systemCategoryFromNamesBuilder: self namesBuilder) , '-' , name , '''!!'! !

PlatypusExpressStructure2SmalltalkTranslater subclass: #PlatypusExpressStructure2VWTranslater
	instanceVariableNames: 'level convertCharDict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-translater-private'!

!PlatypusExpressStructure2VWTranslater class methodsFor: 'accessing' stamp: 'apl 2/15/2007 16:30'!
expressionTranslaterClassName
	^ #PlatypusExpressExpression2VWTranslater! !

!PlatypusExpressStructure2VWTranslater class methodsFor: 'accessing' stamp: 'apl 2/15/2007 16:29'!
statementTranslaterClassName
	^ #PlatypusExpressStatement2VWTranslater! !

!PlatypusExpressStructure2VWTranslater methodsFor: 'utilities' stamp: 'apl 12/15/2006 22:36'!
asXmlText: aString 
	| wStr |
	wStr := WriteStream on: (String new: aString size).
	^ (self writeXmlText: aString on: wStr) contents! !

!PlatypusExpressStructure2VWTranslater methodsFor: 'generating from schemaInstance' stamp: 'AlainPlantec 7/14/2011 16:57'!
buildInitializeMethodFromSchemaInstance: e 
	| selector clsName code |
	clsName := e generatedClassName.
	selector := 'initialize'.
	code := '	PlatypusPharoSmalltalk initialize. self reinitializeSingleton. self singleton buildIndexes.'.
	self 
		fileOutMethodSource: selector , ' ' , code
		className: clsName
		meta: true
		category: 'initializing'! !

!PlatypusExpressStructure2VWTranslater methodsFor: 'generating from entity' stamp: 'apl 1/22/2007 16:45'!
buildRootEntityClass
	super buildRootEntityClass.
	self 
		fileOutMethodSource: 'new ^ super new stepInitialize'
		className: self rootClassName
		meta: true
		packageName: self rootClassSystemCategory
		category: 'instance-creation'.
	self 
		fileOutMethodSource: 'stepInitialize'
		className: self rootClassName
		meta: false
		packageName: self rootClassSystemCategory
		category: 'initializing'! !

!PlatypusExpressStructure2VWTranslater methodsFor: 'utilities' stamp: 'apl 1/18/2007 18:16'!
commentFromMetaData: e classname: aClassName 
	self tag: 'comment'
		do: 
			[self tag: 'class-id' with: self environment , '.' , aClassName.
			self tag: 'body'
				do: 
					[self nextPutAllCr: (self 
								asXmlText:PlatypusCoreObject expressSchemaCodeStartMark , String cr , e prettyPrintedExpressCode 
										, String cr ,PlatypusCoreObject expressSchemaCodeStopMark)]]! !

!PlatypusExpressStructure2VWTranslater methodsFor: 'accessing' stamp: 'apl 12/15/2006 22:37'!
convertCharDict
	^ convertCharDict! !

!PlatypusExpressStructure2VWTranslater methodsFor: 'utilities' stamp: 'apl 12/6/2006 14:02'!
fileOutClassDefinition: aClassName superClassName: superClassName instVars: instVars classVars: classVars namespace: namespace packageName: packageName category: aCategoryName 
	self tag: 'class'
		do: 
			[self tag: 'name' with: aClassName.
			self tag: 'environment' with: namespace.
			self tag: 'super' with: superClassName.
			self tag: 'private' with: 'false'.
			self tag: 'indexed-type' with: 'none'.
			self tag: 'inst-vars' with: instVars.
			self tag: 'class-inst-vars' with: classVars.
			self tag: 'imports' with: ''.
			self tag: 'category' with: aCategoryName.
			self tag: 'attributes' do: [self tag: 'package' with: packageName]].
	self 
		buildPlatypusSignatureMethodForClass: aClassName
		namespace: namespace
		packageName: packageName
		category: aCategoryName! !

!PlatypusExpressStructure2VWTranslater methodsFor: 'utilities' stamp: 'apl 12/15/2006 16:19'!
fileOutDoIt: aSource 
	self tag: 'do-it'
		do: 
			[self
				nextPutAllCr: aSource
				]
! !

!PlatypusExpressStructure2VWTranslater methodsFor: 'utilities' stamp: 'apl 2/15/2007 14:55'!
fileOutMethodSource: aSource className: aClassName meta: isMeta packageName: packageName category: aCategorySymbol 
	self
		tag: 'methods'
		do: [self tag: 'class-id' with: packageName , '.' , aClassName
					, (isMeta
							ifTrue: [' class']
							ifFalse: ['']).
			self tag: 'category' with: self namesBuilder methodCategoryPrefix , '-' , aCategorySymbol.
			self
				tag: 'body'
				attributes: 'package="' , packageName , '"'
				with: (self
						asXmlText:aSource)]! !

!PlatypusExpressStructure2VWTranslater methodsFor: 'utilities' stamp: 'apl 12/15/2006 22:51'!
fileOutNamespaceDefinition: aNamespaceName imports: imports environment: envName packageName: packageName category: aCategoryName 
	self tag: 'name-space'
		do: 
			[self tag: 'name' with: aNamespaceName.
			self tag: 'environment' with: envName.
			self tag: 'private' with: 'false'.
			self tag: 'imports'
				with: 'private Smalltalk.* Refactory.SmaCC.* Platypus.* ' 
						,  imports.
			self tag: 'category' with: aCategoryName.
			self tag: 'attributes' do: [self tag: 'package' with: packageName]]! !

!PlatypusExpressStructure2VWTranslater methodsFor: 'accessing' stamp: 'apl 2/14/2007 17:18'!
finalResultFrom: aString 
	^ '<?xml version="1.0"?>' , String cr , '<st-source>' , String cr , (super  finalResultFrom: aString) , '</st-source>'! !

!PlatypusExpressStructure2VWTranslater methodsFor: 'utilities' stamp: 'apl 12/7/2006 11:09'!
indent
	level timesRepeat: [self nextPutAll: '    ']! !

!PlatypusExpressStructure2VWTranslater methodsFor: 'initialize/release' stamp: 'apl 12/15/2006 22:36'!
initialize
	super initialize.
convertCharDict := Dictionary new.
	0 to: 31
		do: [:each | convertCharDict at: each put: '(' , each asString , ' asCharacter)'].
	32 to: 47
		do: [:each | convertCharDict at: each put: '&#' , each asString , ';'].
	65534 to: 65535
		do: [:each | convertCharDict at: each put: '(' , each asString , ' asCharacter)'].
	convertCharDict
		at: $& asciiValue put: '&amp;';
		at: $< asciiValue put: '&lt;';
		at: $> asciiValue put: '&gt;';
		at: $' asciiValue put: '&apos;';
		at: $" asciiValue put: '&quot;'.
	convertCharDict
		removeKey: Character space asciiValue;
		removeKey: Character tab asciiValue;
		removeKey: Character cr asciiValue;
		removeKey: Character lf asciiValue.
	convertCharDict
		removeKey: $/ asciiValue;
		removeKey: $- asciiValue;
		removeKey: $. asciiValue.
	level := 0.
! !

!PlatypusExpressStructure2VWTranslater methodsFor: 'utilities' stamp: 'apl 8/31/2006 12:23'!
mapType: aSymbol 
	aSymbol == #normal
		ifTrue: [^ #none].
	aSymbol == #variable
		ifTrue: [^ #objects].
	^ aSymbol! !

!PlatypusExpressStructure2VWTranslater methodsFor: 'utilities' stamp: 'apl 12/16/2006 00:05'!
mcCategory: aCat 
	^ aCat! !

!PlatypusExpressStructure2VWTranslater methodsFor: 'utilities' stamp: 'apl 12/15/2006 22:18'!
qualifiedClassNameOf: e 
	^ e generatedNamespaceName, '.', e generatedClassName! !

!PlatypusExpressStructure2VWTranslater methodsFor: 'utilities' stamp: 'apl 12/6/2006 09:57'!
tag: aString attributes: attrString with: contentString 
	self indent.
	self
		nextPutAll: '<';
		nextPutAll: aString;
		nextPutAll: ' ' , attrString;
		nextPutAll: '>'.
	self nextPutAll: (contentString).
	self
		nextPutAll: '</';
		nextPutAll: aString;
		nextPutAll: '>';
		cr! !

!PlatypusExpressStructure2VWTranslater methodsFor: 'utilities' stamp: 'apl 12/4/2006 19:26'!
tag: aString do: aBlock 
	self indent.
	self nextPutAll: '<';
		 nextPutAll: aString;
		 nextPutAll: '>';
		 cr.
		level := level + 1.
	aBlock value.
		level := level - 1.
	self indent.
	self nextPutAll: '</';
		 nextPutAll: aString;
		 nextPutAll: '>';
		 cr! !

!PlatypusExpressStructure2VWTranslater methodsFor: 'utilities' stamp: 'apl 12/15/2006 22:02'!
tag: aString with: contentString 
	self indent.
	self
		nextPutAll: '<';
		nextPutAll: aString;
		nextPutAll: '>'.
	self nextPutAll: (contentString).
	self
		nextPutAll: '</';
		nextPutAll: aString;
		nextPutAll: '>';
		cr! !

!PlatypusExpressStructure2VWTranslater methodsFor: 'utilities' stamp: 'apl 12/15/2006 22:37'!
writeXmlText: aString on: aWriteStream 
	| cDict wStr |
	cDict := self convertCharDict.
	wStr := aWriteStream.
	aString do: 
			[:eachChar | 
			| val |
			val := eachChar asciiValue.
			val >= 127 
				ifTrue: 
					[wStr
						nextPutAll: '&#';
						nextPutAll: val asString;
						nextPut: $;]
				ifFalse: 
					[| conv |
					conv := cDict at: val ifAbsent: [].
					conv isNil 
						ifTrue: [wStr nextPut: eachChar]
						ifFalse: [wStr nextPutAll: conv]]].
	^ wStr! !

!PlatypusExpressTranslater class methodsFor: 'instance creation' stamp: 'apl 3/1/2006 08:41'!
accept: aMetaData fromTranslater: aTranslater 
	(self new fromTranslater: aTranslater) acceptTry: aMetaData
	! !

!PlatypusExpressTranslater class methodsFor: 'instance creation' stamp: 'apl 12/5/2006 18:08'!
accept: aMetaData fromTranslater: aTranslater resultStream: aStream 
	| translater |
	(translater := self new fromTranslater: aTranslater resultStream: aStream ) acceptTry: aMetaData.
	^ translater! !

!PlatypusExpressTranslater class methodsFor: 'accessing' stamp: 'AlainPlantec 7/14/2011 16:57'!
expressionTranslaterClass
^ PlatypusPharoSmalltalk at: self expressionTranslaterClassName
! !

!PlatypusExpressTranslater class methodsFor: 'accessing' stamp: 'apl 2/15/2007 16:39'!
expressionTranslaterClassName
	^ self subclassResponsibility ! !

!PlatypusExpressTranslater class methodsFor: 'utilities' stamp: 'apl 2/26/2005 00:12'!
fileIn: code 
	| reader chunk st |
	reader := ReadStream on: code.
	[reader atEnd]
		whileFalse: [reader skipSeparators.
			[(reader peekFor: $!!)
				ifTrue: [(st := Compiler evaluate: reader nextChunk logged: false)
						ifNotNil: [st scanFrom: reader]]
				ifFalse: [chunk := reader nextChunk.
					reader checkForPreamble: chunk.
					Compiler evaluate: chunk logged: true]]
				on: InMidstOfFileinNotification
				do: [:ex | ex resume: true].
			reader skipStyleChunk].
	reader close! !

!PlatypusExpressTranslater class methodsFor: 'utilities' stamp: 'apl 2/15/2005 19:54'!
fileIn: code message: aMessage 
	self fileIn: code.
	"Note: The main purpose of this banner is to flush the changes file."
	SmalltalkImage current logChange: '----End Platypus of ' , aMessage , '----'! !

!PlatypusExpressTranslater class methodsFor: 'instance creation' stamp: 'apl 3/1/2006 08:40'!
fromTranslater: aTranslater 
	^ self new fromTranslater: aTranslater! !

!PlatypusExpressTranslater class methodsFor: 'instance creation' stamp: 'apl 3/1/2006 08:41'!
fromTranslater: aTranslater resultStream: aStream 
	^ self new fromTranslater: aTranslater resultStream: aStream! !

!PlatypusExpressTranslater class methodsFor: 'instance creation' stamp: 'apl 2/11/2005 00:12'!
resultStream: anObject 
	^ self new resultStream: anObject ! !

!PlatypusExpressTranslater class methodsFor: 'accessing' stamp: 'AlainPlantec 7/14/2011 16:57'!
statementTranslaterClass
	^ PlatypusPharoSmalltalk at: self statementTranslaterClassName! !

!PlatypusExpressTranslater class methodsFor: 'accessing' stamp: 'apl 2/15/2007 16:39'!
statementTranslaterClassName
	^ self subclassResponsibility! !

!PlatypusExpressTranslater class methodsFor: 'utilities' stamp: 'apl 5/13/2005 11:02'!
translate: aMetaData fromTranslater: aTranslater 
	^(self new fromTranslater: aTranslater
		resultStream: (WriteStream on: String new)) translate: aMetaData! !

!PlatypusExpressTranslater methodsFor: 'stream utilities' stamp: 'apl 8/31/2006 11:56'!
cr
	self resultStream cr! !

!PlatypusExpressTranslater methodsFor: 'accessing' stamp: 'apl 2/15/2007 16:38'!
expressionTranslaterClass
	^ self class expressionTranslaterClass! !

!PlatypusExpressTranslater methodsFor: 'public accessing' stamp: 'apl 12/5/2006 15:13'!
finalResult
	^ self finalResultFrom: self result! !

!PlatypusExpressTranslater methodsFor: 'public accessing' stamp: 'apl 12/5/2006 15:07'!
finalResultFrom: aString 
	^ aString! !

!PlatypusExpressTranslater methodsFor: 'accessing' stamp: 'apl 3/1/2006 08:37'!
fromTranslater: aTranslater 
	self
		fromTranslater: aTranslater
		resultStream: aTranslater resultStream! !

!PlatypusExpressTranslater methodsFor: 'accessing' stamp: 'apl 3/1/2006 08:37'!
fromTranslater: aTranslater resultStream: aStream 
	self requestor: aTranslater.
	self resultStream: aStream! !

!PlatypusExpressTranslater methodsFor: 'stream utilities' stamp: 'apl 3/2/2005 16:38'!
nextPutAll: aString 
	self resultStream nextPutAll: aString! !

!PlatypusExpressTranslater methodsFor: 'stream utilities' stamp: 'apl 2/14/2005 18:16'!
nextPutAllCr: aString 
	self nextPutAll: aString , String cr! !

!PlatypusExpressTranslater methodsFor: 'stream utilities' stamp: 'apl 2/14/2005 18:16'!
nextPutAllCrCr: aString 
	self nextPutAllCr: aString , String cr! !

!PlatypusExpressTranslater methodsFor: 'accessing' stamp: 'apl 3/1/2006 08:35'!
requestor
	^ requestor! !

!PlatypusExpressTranslater methodsFor: 'accessing' stamp: 'apl 3/1/2006 08:35'!
requestor: anObject 
	requestor := anObject! !

!PlatypusExpressTranslater methodsFor: 'accessing' stamp: 'apl 3/11/2005 09:41'!
result
	^ self resultStream contents! !

!PlatypusExpressTranslater methodsFor: 'accessing' stamp: 'AlainPlantec 10/7/2010 15:56'!
resultStream
	^ resultStream ifNil: [resultStream := WriteStream on: String new]! !

!PlatypusExpressTranslater methodsFor: 'accessing' stamp: 'apl 2/10/2005 22:57'!
resultStream: anObject
	resultStream := anObject! !

!PlatypusExpressTranslater methodsFor: 'accessing' stamp: 'AlainPlantec 6/15/2012 12:38'!
schemaInstance
	^ self requestor
		ifNil: [visitPath first schemaInstance]
		ifNotNil: [self requestor schemaInstance]! !

!PlatypusExpressTranslater methodsFor: 'accessing' stamp: 'apl 2/15/2007 16:38'!
statementTranslaterClass
^ self class statementTranslaterClass
! !

!PlatypusExpressTranslater methodsFor: 'public accessing' stamp: 'apl 2/14/2007 17:22'!
translate: aMetaData 
	self acceptTry: aMetaData.
			^ self result! !

!PlatypusExpressTranslater methodsFor: 'stream utilities' stamp: 'apl 2/28/2006 23:30'!
unshunkedString: aString
	| terminator code |
	terminator := $!!.
	code := WriteStream on: String new.
	aString
		do: [:c | c = terminator
				ifTrue: [code nextPut: terminator.
					code nextPut: terminator]
				ifFalse: [code nextPut: c]].
	^ code contents! !

PlatypusStepAbstractVisitor subclass: #PlatypusModelContentsStepWriter
	instanceVariableNames: 'outStream p21Syntax tokenClassifier modelContents annote'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-visitors'!

!PlatypusModelContentsStepWriter methodsFor: 'visit aggregate data schema' stamp: 'AlainPlantec 5/4/2012 20:42'!
acceptAggregateData: e 
	self nextPut: $(.
	e contents acceptTry: self 
		separatedBy: [self nextPut: $,].
	self nextPut: $)! !

!PlatypusModelContentsStepWriter methodsFor: 'visit aggregate data schema' stamp: 'apl 3/17/2006 09:53'!
acceptAggregateInitializer: e 
	self nextPut: $(.
	e contents acceptTry: self 
		separatedBy: [self nextPut: $,].
	self nextPut: $)! !

!PlatypusModelContentsStepWriter methodsFor: 'visit aggregate data schema' stamp: 'apl 1/31/2006 14:08'!
acceptAggregateInitializerElement: e 
	self acceptTry: e val.
	self nextPut: $:.
	e repetition notNil
		ifTrue: [self acceptTry: e repetition] ifFalse: [self nextPut: $1]! !

!PlatypusModelContentsStepWriter methodsFor: 'visit aggregate data schema' stamp: 'AlainPlantec 5/4/2012 20:44'!
acceptAggregateInstance: e 
	self nextPut: $(.
	e 
		contents do: [:c |
			c isPltGenericInstance 
				ifTrue: [
					outStream nextPut: $#.
					outStream nextPutAll: c persistentLabel]
				ifFalse: [c acceptTry: self ] ]
		separatedBy: [self nextPut: $,].
	self nextPut: $)! !

!PlatypusModelContentsStepWriter methodsFor: 'accessing' stamp: 'AlainPlantec 6/13/2012 13:59'!
acceptAllParameters: parameters definition: definition fromSimpleRecord: fromSimpleRecord 
	| attrs |
	definition ifNotNil: [
		fromSimpleRecord 
			ifTrue: [attrs := definition explicitAttributes copy]
			ifFalse: [attrs := definition inheritedExplicitAttributes copy]].
	attrs ifNil: [attrs := OrderedCollection new].
	attrs := attrs asOrderedCollection.
	[parameters size < attrs size] whileTrue: [parameters add: PltMissingValue new].
	[attrs size < parameters size] whileTrue: [attrs add: nil].
	parameters
		with: attrs 
		do: [:v :a | self acceptParameter: v entity: definition attribute: a fromSimpleRecord: fromSimpleRecord]
		separatedBy: [p21Syntax ifTrue: [outStream nextPutAll: ', ']].
	p21Syntax
		ifFalse: [parameters notEmpty 
			ifTrue: [outStream nextPut: Character cr]]! !

!PlatypusModelContentsStepWriter methodsFor: 'visit expressions schema' stamp: 'apl 11/13/2003 12:33'!
acceptEConstant: e 
	self nextPutAll: 'E' ! !

!PlatypusModelContentsStepWriter methodsFor: 'visit population schema' stamp: 'AlainPlantec 1/14/2010 11:55'!
acceptEntityDefinitionReference: e 
	e ref ifNil: 
			[outStream nextPutAll: e name asUppercase]
		ifNotNil: 
			[outStream nextPutAll: e ref name asUppercase]! !

!PlatypusModelContentsStepWriter methodsFor: 'visit expressions schema' stamp: 'apl 11/13/2003 16:22'!
acceptEnumerationValue: e 
	self nextPutAll: '.', e element asUppercase, '.'.
! !

!PlatypusModelContentsStepWriter methodsFor: 'visit population schema' stamp: 'apl 2/2/2004 23:04'!
acceptExternalGroupRepresentation: e 
 	self acceptExternalInstance: e! !

!PlatypusModelContentsStepWriter methodsFor: 'visit population schema' stamp: 'apl 1/16/2007 15:08'!
acceptExternalInstance: e 
	self acceptGenericInstance: e.
	self nextPutAll: '('.
	e records isNil ifFalse: [
	e records size > 1 ifTrue: [self nextPutAll: String cr , String tab].
	e records acceptTry: self
		separatedBy: [self nextPutAll: String cr , String tab].
	e records size > 1 ifTrue: [self nextPutAll: String cr]].
	self nextPutAll: ');'! !

!PlatypusModelContentsStepWriter methodsFor: 'visit population schema' stamp: 'apl 2/2/2004 23:04'!
acceptExternalRepresentation: e 
	self acceptExternalInstance: e! !

!PlatypusModelContentsStepWriter methodsFor: 'visit expressions schema' stamp: 'apl 11/13/2003 12:33'!
acceptFalseConstant: e 
	self nextPutAll: '.F.'! !

!PlatypusModelContentsStepWriter methodsFor: 'visit population schema' stamp: 'apl 2/2/2004 14:33'!
acceptFileDescription: e 
	self nextPutAll: 'FILE_DESCRIPTION(('.
	e description
		do: [:desc | self nextPutAllString: desc]
		separatedBy: [self nextPut: $,].
	self nextPutAll: '),'.
	self nextPutAllString: e implementationLevel.
	self nextPutAll: ');'.! !

!PlatypusModelContentsStepWriter methodsFor: 'visit population schema' stamp: 'apl 2/2/2004 14:35'!
acceptFileName: e 
	self nextPutAll: 'FILE_NAME('.
	self nextPutAllString: e name.
	self nextPutAll: ','.
	self nextPutAllString: e timeStamp.
	self nextPutAll: ',('.
	e author
		do: [:a | self nextPutAllString: a]
		separatedBy: [self nextPut: $,].
	self nextPutAll: '),('.
	e organization
		do: [:a | self nextPutAllString: a]
		separatedBy: [self nextPut: $,].
	self nextPutAll: '),'.
	self nextPutAllString: e preprocessorVersion.
	self nextPutAll: ','.
	self nextPutAllString: e originatingSystem.
	self nextPutAll: ','.
	self nextPutAllString: e authorisation.
	self nextPutAll: ');'! !

!PlatypusModelContentsStepWriter methodsFor: 'visit population schema' stamp: 'AlainPlantec 5/16/2012 20:16'!
acceptFileSchema: e 
	self nextPutAll: 'FILE_SCHEMA(('.
	e schemaIdentifiers
		do: [:a | self nextPutAllString: a]
		separatedBy: [self nextPut: $,].
	self nextPutAll: '));'! !

!PlatypusModelContentsStepWriter methodsFor: 'visit population schema' stamp: 'AlainPlantec 5/13/2012 01:58'!
acceptGenericInstance: t1 
	outStream nextPut: $#.
	outStream nextPutAll: t1 persistentLabel asString.
	self nextPut: $=.
	t1 instanceScope
		ifNotNil: [t1 instanceScope acceptTry: self]! !

!PlatypusModelContentsStepWriter methodsFor: 'visit population schema' stamp: 'apl 3/17/2006 09:54'!
acceptInstanceScope: e 
	self nextPutAll: '&SCOPE\' withCRs.
	e owned
		acceptTry: self
		separatedBy: [self nextPut: Character cr].
	self nextPutAll: '\END_SCOPE' withCRs.
	e exportList size > 0
		ifTrue: [self nextPutAll: ' /'.
			e exportList acceptTry: self 
				separatedBy: [self nextPutAll: ','].
			self nextPutAll: '/\' withCRs]
		ifFalse: [self nextPut: Character cr]! !

!PlatypusModelContentsStepWriter methodsFor: 'visit expressions schema' stamp: 'apl 11/13/2003 12:33'!
acceptIntegerLiteral: e 
	self nextPutAll: e val printString! !

!PlatypusModelContentsStepWriter methodsFor: 'visit population schema' stamp: 'apl 2/2/2004 23:05'!
acceptInternalGroupRepresentation: e 
	self acceptInternalInstance: e! !

!PlatypusModelContentsStepWriter methodsFor: 'visit population schema' stamp: 'AlainPlantec 6/12/2012 12:02'!
acceptInternalInstance: e 
	self acceptGenericInstance: e.
	self acceptTry: e definition.
	self nextPut: $(. 
	self
		acceptAllParameters: e parameters copy
		definition: e definition referenced
		fromSimpleRecord: false.
	self nextPutAll: ');'! !

!PlatypusModelContentsStepWriter methodsFor: 'visit population schema' stamp: 'apl 2/2/2004 23:05'!
acceptInternalRepresentation: e 
	self acceptInternalInstance: e 
! !

!PlatypusModelContentsStepWriter methodsFor: 'visit expressions schema' stamp: 'apl 11/13/2003 12:33'!
acceptMissingValue: e 
	self nextPut: $$! !

!PlatypusModelContentsStepWriter methodsFor: 'accessing' stamp: 'AlainPlantec 6/12/2012 13:39'!
acceptParameter: aParameter entity: definition attribute: anExplicitAttribute fromSimpleRecord: fromSimpleRecord 
	p21Syntax
		ifFalse: [ 
			outStream nextPut: Character cr.
 			outStream nextPut: Character tab.
			fromSimpleRecord
				ifTrue: [outStream nextPut: Character tab].
			anExplicitAttribute ifNotNil: [
				outStream nextPutAll: anExplicitAttribute name.
				outStream nextPutAll: ': ']].
	(anExplicitAttribute notNil and: [definition isAttributeRedeclared: anExplicitAttribute])
		ifTrue: [outStream nextPut: $*]
		ifFalse: [
			aParameter isPltGenericInstance 
				ifTrue: [
					outStream nextPut: $#.
					outStream nextPutAll: aParameter persistentLabel]
				ifFalse: [aParameter acceptTry: self]. 
			(p21Syntax not or: [self annote])
				ifTrue: [ | ann |
					ann := anExplicitAttribute ifNil: ['?'] ifNotNil: [anExplicitAttribute annotation].
					outStream nextPutAll: ' <' , ann, '>']].
! !

!PlatypusModelContentsStepWriter methodsFor: 'visit expressions schema' stamp: 'apl 11/13/2003 12:34'!
acceptPiConstant: e 
	self nextPutAll: 'PI'! !

!PlatypusModelContentsStepWriter methodsFor: 'visit expressions schema' stamp: 'apl 11/13/2003 12:34'!
acceptRealLiteral: e 
	self nextPutAll: e val printString! !

!PlatypusModelContentsStepWriter methodsFor: 'visit expressions schema' stamp: 'apl 11/13/2003 12:34'!
acceptRedefinedAttributeValue: e 
	self nextPut: $*! !

!PlatypusModelContentsStepWriter methodsFor: 'visit population schema' stamp: 'AlainPlantec 6/12/2012 12:44'!
acceptSimpleRecord: e 
	self acceptTry: e definition.
	(p21Syntax not
			and: [e definitionOk])
		ifTrue: [outStream nextPut: Character tab].
	self nextPut: $(.
	self
		acceptAllParameters: e parameters copy
		definition: e definition referenced
		fromSimpleRecord: true.
	(p21Syntax not	and: [e parameters notEmpty and: [e definitionOk]])
		ifTrue: [outStream nextPut: Character tab].
	self nextPut: $)! !

!PlatypusModelContentsStepWriter methodsFor: 'visit expressions schema' stamp: 'apl 5/27/2004 16:44'!
acceptStringLiteral: e 
	self nextPutAllString: e asClearText! !

!PlatypusModelContentsStepWriter methodsFor: 'visit expressions schema' stamp: 'apl 11/13/2003 12:34'!
acceptTrueConstant: e 
	self nextPutAll: '.T.'! !

!PlatypusModelContentsStepWriter methodsFor: 'visit expressions schema' stamp: 'apl 11/13/2003 12:34'!
acceptTypedExpression: e 
	e domain
		ifNotNil: [self nextPutAll: e domain name asUppercase;
				 nextPut: $(].
	e expr acceptTry: self.
	e domain
		ifNotNil: [self nextPut: $)]! !

!PlatypusModelContentsStepWriter methodsFor: 'visit expressions schema' stamp: 'apl 11/13/2003 12:34'!
acceptUnknownConstant: e 
	self nextPutAll: '.U.'! !

!PlatypusModelContentsStepWriter methodsFor: 'visit population schema' stamp: 'apl 3/17/2006 09:54'!
acceptUserDefinedApplicationInstance: e 
	self nextPut: $#;
		 nextPutAll: e persistentLabel;
		 nextPut: $!!;
		 nextPutAll: e name;
		 nextPut: $(.
	e parameters acceptTry: self 
		separatedBy: [self nextPut: $,].
	self nextPutAll: ');'! !

!PlatypusModelContentsStepWriter methodsFor: 'visit population schema' stamp: 'apl 3/17/2006 09:54'!
acceptUserDefinedHeaderInstance: e 
	self nextPutAll: e name;
		 nextPut: $(.
	e parameters acceptTry: self 
		separatedBy: [self nextPut: $,].
	self nextPutAll: ');'! !

!PlatypusModelContentsStepWriter methodsFor: 'accessing' stamp: 'AlainPlantec 5/12/2012 21:36'!
annote
	^ annote ifNil: [annote := false]! !

!PlatypusModelContentsStepWriter methodsFor: 'accessing' stamp: 'AlainPlantec 5/12/2012 21:36'!
annote: aBoolean
	annote := aBoolean! !

!PlatypusModelContentsStepWriter methodsFor: 'initialize/release' stamp: 'apl 5/20/2005 21:49'!
initialize
	super initialize.
	p21Syntax := true.
	tokenClassifier := PlatypusExpressTokenClassifier new! !

!PlatypusModelContentsStepWriter methodsFor: 'accessing' stamp: 'apl 2/2/2004 14:55'!
modelContents
	^modelContents! !

!PlatypusModelContentsStepWriter methodsFor: 'accessing' stamp: 'apl 2/2/2004 14:55'!
modelContents: anObject
	modelContents := anObject! !

!PlatypusModelContentsStepWriter methodsFor: 'accessing' stamp: 'apl 2/12/2007 10:56'!
nextPut: aCharacter 
	"| tokenClass |
	tokenClass := tokenClassifier
				tokenClassFromCharacter: aCharacter
				ifAbsent: [].
	outStream
		withStyleFor: tokenClass
		do: [outStream nextPut: aCharacter]"
		outStream nextPut: aCharacter! !

!PlatypusModelContentsStepWriter methodsFor: 'accessing' stamp: 'apl 2/12/2007 10:44'!
nextPutAll: aString 
	"| tokenClass |
	tokenClass := tokenClassifier
				tokenClassFromString: aString
				ifAbsent: [].
	outStream
		withStyleFor: tokenClass
		do: [outStream nextPutAll: aString]."
	outStream nextPutAll: aString! !

!PlatypusModelContentsStepWriter methodsFor: 'visit generic' stamp: 'apl 2/2/2004 14:29'!
nextPutAllString: aString 
	self nextPutAll: ''''
			, (aString copyReplaceAll: '''' with: '''''') , ''''! !

!PlatypusModelContentsStepWriter methodsFor: 'accessing' stamp: 'apl 1/10/2004 10:00'!
outStream
	^outStream! !

!PlatypusModelContentsStepWriter methodsFor: 'accessing' stamp: 'apl 1/10/2004 10:00'!
outStream: anObject
	outStream := anObject! !

!PlatypusModelContentsStepWriter methodsFor: 'accessing' stamp: 'AlainPlantec 5/12/2012 19:07'!
p21Syntax: useP21Syntax 
	p21Syntax := useP21Syntax! !

!PlatypusModelContentsStepWriter methodsFor: 'accessing' stamp: 'AlainPlantec 6/12/2012 12:59'!
stream: anOutputStream modelContents: aModelContents instance: anInstance p21Syntax: useP21Syntax 
	self outStream: anOutputStream.
	self modelContents: aModelContents.
	self p21Syntax: useP21Syntax.
	self acceptTry: anInstance! !

!PlatypusModelContentsStepWriter methodsFor: 'accessing' stamp: 'AlainPlantec 6/12/2012 12:59'!
stream: anOutputStream modelContents: aModelContents instance: anInstance p21Syntax: useP21Syntax annote: withTypeAnnotations
	self outStream: anOutputStream.
	self modelContents: aModelContents.
	self p21Syntax: useP21Syntax.
	self annote: withTypeAnnotations.
	self acceptTry: anInstance! !

!PlatypusModelContentsStepWriter methodsFor: 'accessing' stamp: 'AlainPlantec 1/11/2010 17:27'!
stream: anOutputStream modelContents: aModelContents p21Syntax: useP21Syntax 
	| hinstances instances dateTime |
	self modelContents: aModelContents.
	p21Syntax := useP21Syntax.
	hinstances := modelContents headerInstances.
	instances := modelContents dataInstances.
	outStream := anOutputStream.
	outStream nextPutAll: 'ISO-10303-21;\HEADER;\' withCRs.
	hinstances acceptTry: self 
				separatedBy: [outStream nextPut: Character cr].
	(hinstances isNil
			or: [(hinstances
					anySatisfy: [:hi | hi isPltFileName]) not])
		ifTrue: [dateTime := Time dateAndTimeNow.
			self nextPutAll: String cr , 'FILE_NAME(''<name>'', ''' , dateTime first yyyymmdd asString , ' ' , dateTime second asString , ''', (''<author>''), (''<organisation>''), ''<preprocessor version>'', ''<originating system>'', ''<authorization>'');'].
	(hinstances isNil
			or: [(hinstances
					anySatisfy: [:hi | hi isPltFileSchema]) not])
		ifTrue: [self nextPutAll: String cr , 'FILE_SCHEMA(('.
			self modelContents owner schemata
				do: [:sch | self nextPutAllString: sch name]
				separatedBy: [outStream nextPut: $,].
			outStream nextPutAll: '));'].
	(hinstances isNil
			or: [(hinstances
					anySatisfy: [:hi | hi isPltFileDescription]) not])
		ifTrue: [self nextPutAll: String cr , 'FILE_DESCRIPTION((''<description1>'', ''<description 2>''), ''<implementation level>''); '].
	outStream nextPutAll: '\ENDSEC;\DATA;\' withCRs.
	instances acceptTry: self 
				separatedBy: [outStream nextPut: Character cr].
			outStream nextPut: Character cr.
	outStream nextPutAll: 'ENDSEC;\END-ISO-10303-21;\' withCRs! !

!PlatypusModelContentsStepWriter methodsFor: 'accessing' stamp: 'AlainPlantec 5/10/2012 22:29'!
stream: anOutputStream modelContents: aModelContents values: values p21Syntax: useP21Syntax 
	self modelContents: aModelContents.
	outStream := anOutputStream.
	p21Syntax := useP21Syntax.
	values 
		acceptTry: self 
		separatedBy: [outStream nextPut: Character cr]! !

PlatypusStepAbstractVisitor subclass: #PlatypusSchemaInstanceTokenizer
	instanceVariableNames: 'tokenList tokenClassifier literalEncoder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-visitors'!

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit aggregate data schema' stamp: 'apl 12/12/2003 13:28'!
acceptAggregateInitializer: e 
	self add: '[' asSymbol.
	self acceptAll: e contents separator: ',' asSymbol.
	self add: ']' asSymbol! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: 'apl 7/20/2004 11:25'!
acceptAggregateInitializerDomain: e 
	self add: '[' asSymbol.
	self acceptAll: e types separator: ',' asSymbol.
	self add: ']' asSymbol! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit expressions schema' stamp: 'apl 4/18/2006 13:23'!
acceptAggregateInitializerElement: e 
	e val acceptTry: self.
	e repetition notNil
		ifTrue: [self add: ':' asSymbol.
			e repetition acceptTry: self]! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit aggregate data schema' stamp: 'apl 12/18/2003 22:01'!
acceptAggregateInstance: e 
	self add: '[' asSymbol.
	self acceptAll: e contents separator: ',' asSymbol.
	self add: ']' asSymbol! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit generic' stamp: 'apl 4/18/2006 13:25'!
acceptAggregationType: e lower: l upper: u symbol: subtype flags: aCollection 
	self add: subtype.
	l notNil
		ifTrue: [self add: '[' asSymbol.
			l acceptTry: self.
			self add:  ':' asSymbol.
			u notNil
				ifTrue: [u acceptTry: self]
				ifFalse: [self add: '?' asSymbol].
			self add: ']' asSymbol].
	self add: #of.
	aCollection
		do: [:f | self add: f].
	self acceptTry: e elementType! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit statements schema' stamp: 'apl 3/17/2006 09:33'!
acceptAliasStatement: e 
	self add: #alias.
	e variable acceptTry: self.
	self add: ';' asSymbol.
	e statements acceptTry: self.
	self add: #'end_alias';
		 add: ';' asSymbol! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit statements schema' stamp: 'apl 11/3/2003 10:24'!
acceptAliasStatementVariable: e 
	self add: e name;
		 add: #for.
	e ref acceptTry: self! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit generic' stamp: ''!
acceptAll: aCollection separator: sep 
	aCollection
		do: [:each | each acceptTry: self]
		separatedBy: [self add: sep]! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit statements schema' stamp: ''!
acceptAssignmentStatement: e 
	
	e left acceptTry: self.
	self add: #':='.
	e rightExpr acceptTry: self.
	self add: ';' asSymbol! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: 'apl 1/25/2007 11:42'!
acceptAttribute: e 
	self remarksBefore: e.
	e redeclaring notNil 
		ifTrue: 
			[self
				add: #self;
				add: '\' asSymbol;
				add: e redeclaring entityRef name;
				add: '.' asSymbol].
	self add: e name! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit expressions schema' stamp: 'apl 4/18/2006 13:17'!
acceptAttributeQualifier: e 
	self add: '.' asSymbol;
		 add: e attributeName! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: 'apl 3/23/2006 16:04'!
acceptAttributeReference: e 
	
	self add: e name! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit expressions schema' stamp: ''!
acceptBinaryExpression: e 
	(e parenthesis notNil
			and: [e parenthesis])
		ifTrue: [self add: #'('].
	e leftExpr acceptTry: self.
	self add: e operatorSymbol.
	e rightExpr acceptTry: self.
	(e parenthesis notNil
			and: [e parenthesis])
		ifTrue: [self add: #')']! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: ''!
acceptBinarySupertypeExpression: e 
	(e parenthesis notNil
			and: [e parenthesis])
		ifTrue: [self add: #'('].
	e leftExpr acceptTry: self.
	self add: e operatorSymbol.
	e rightExpr acceptTry: self.
	(e parenthesis notNil
			and: [e parenthesis])
		ifTrue: [self add: #')']! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: ''!
acceptBinaryType: e 
	self add: #binary.
	e width notNil
		ifTrue: [self add: #'('.
			e width acceptTry: self.
			self add: #')']! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: ''!
acceptBooleanType: e 
	self add: #boolean! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit expressions schema' stamp: 'apl 3/22/2006 11:23'!
acceptCardinalityExpression: e 
	e leftExpr acceptTry: self.
	self add: '{' asSymbol.
	e card1 acceptTry: self.
	self add: ',' asSymbol.
	e card2 acceptTry: self.
	self add: '}' asSymbol.
	e rightExpr acceptTry: self! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit statements schema' stamp: 'apl 4/18/2006 13:26'!
acceptCaseAction: e 
	self acceptAll: e labels separator: ',' asSymbol.
	self add:  ':' asSymbol.
	e action acceptTry: self! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit statements schema' stamp: 'apl 4/18/2006 13:26'!
acceptCaseStatement: e 
	self add: #case.
	e selector acceptTry: self.
	self add: #of.
	e caseActions acceptTry: self.
	e caseOtherwise notNil
		ifTrue: [self add: #otherwise;
				 add:  ':' asSymbol.
			e caseOtherwise acceptTry: self].
	self add: #'end_case';
		 add: ';' asSymbol! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit statements schema' stamp: 'apl 3/17/2006 09:33'!
acceptCompoundStatement: e 
	self add: #begin.
	e statements acceptTry: self.
	self add: #end;
		 add: ';' asSymbol! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: 'apl 1/25/2007 11:39'!
acceptConstantDefinition: e 
	self remarksBefore: e.
	self add: e name.
	self add: ':' asSymbol.
	self acceptTry: e domain.
	self add: #':='.
	e initializer acceptTry: self.
	self add: ';' asSymbol. 	self remarksAfter: e.
! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: 'apl 3/17/2006 09:45'!
acceptContextDefinition: e 
	e constants isEmpty
		ifFalse: [self add: #constant.
			e constants acceptTry: self.
			self add: #'end_constant';
				 add: ';' asSymbol].
	 e types acceptTry: self.
	 e entities acceptTry: self.
	 e algorithmes acceptTry: self! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: 'apl 1/25/2007 11:40'!
acceptDefinedType: e 
	self remarksBefore: e.
	self
		add: #type;
		add: e name;
		add: '=' asSymbol.
	self acceptTry: e domain.
	self add: ';' asSymbol.
	e whereRules size > 0 
		ifTrue: 
			[self add: #where.
			e whereRules acceptTry: self].
	self
		add: #'end_type';
		add: ';' asSymbol.
			self remarksAfter: e.
! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: 'apl 1/25/2007 11:43'!
acceptDerivedAttribute: e 
	self acceptAttribute: e.
	self add: ':' asSymbol.
	self acceptTry: e domain.
	self add: #':='.
	e assign acceptTry: self.
	self add: ';' asSymbol.
	self remarksAfter: e! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: 'apl 6/16/2004 10:56'!
acceptDictionaryInstanceReference: e 
	self add: e name! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: 'apl 3/11/2003 10:25'!
acceptDomainEquivalentItem: e 
	| |
	self add: (e nativeItem name).
	e nativeItem name asLowercase ~= e externalItemId asLowercase
		ifTrue: [self add: #as;
				 add: e externalItemId]! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit expressions schema' stamp: 'apl 3/7/2003 16:57'!
acceptElementQualifier: e 
	self add: '[' asSymbol.
	e index acceptTry: self.
	self add: ']' asSymbol! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: 'apl 1/25/2007 11:22'!
acceptEmbeddedRemark: e 
	self tokenList add: (PlatypusEmbeddedRemarkToken token: e text)! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit statements schema' stamp: ''!
acceptEndSplitmarkStatement: e 
	self 
		 add: '{*';
		 add: #'end_splitmark';
		 add: '*}'! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: 'apl 1/25/2007 11:01'!
acceptEntityDefinition: e 
	| supertypes |
	self remarksBefore: e.
	self
		add: #entity;
		add: e name.
	e metaConcept acceptTry: self.
	e supertypeConstraint acceptTry: self.
	(supertypes := e supertypes) ifNotNil: 
			[supertypes isEmpty 
				ifFalse: 
					[self add: #subtype.
					self
						add: #of;
						add: #'('.
					supertypes acceptTry: self separatedBy: [self add: ',' asSymbol].
					self add: #')']].
	self add: ';' asSymbol.
	self remarksAfter: e.
	e explicitAttributesDo: [:ea | ea acceptTry: self].
	e derivedAttributes isEmpty 
		ifFalse: 
			[self add: #derive.
			e derivedAttributes acceptTry: self].
	e inverseAttributes isEmpty 
		ifFalse: 
			[self add: #inverse.
			e inverseAttributes acceptTry: self].
	(e uniquenessRules notNil and: [e uniquenessRules notEmpty]) 
		ifTrue: 
			[self add: #unique.
			e uniquenessRules acceptTry: self].
	(e whereRules notNil and: [e whereRules notEmpty]) 
		ifTrue: 
			[self add: #where.
			e whereRules acceptTry: self].
	self
		add: #'end_entity';
		add: ';' asSymbol! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit expressions schema' stamp: 'apl 3/10/2003 22:34'!
acceptEntityInstancesSet: e 
	self add: e entityRef name! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: ''!
acceptEnumerationType: e 
	self add: #enumeration;
		 add: #of;
		 add: #'('.
	e elements
		do: [:l | self add: l]
		separatedBy: [self add: ',' asSymbol].
	self add: #')'! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit expressions schema' stamp: ''!
acceptEnumerationValue: e 
	self  add: e element! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit statements schema' stamp: ''!
acceptEscapeStatement: e 
	self 
		 add: #escape;
		 add: ';' asSymbol! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit expressions schema' stamp: 'apl 4/13/2006 12:02'!
acceptEscapedExpression: e 
	self add: #%.
	e expr acceptTry: self.
	self add: #%! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: 'apl 1/25/2007 11:43'!
acceptExplicitAttribute: e 
	self acceptAttribute: e.
	self add: ':' asSymbol.
	e optionalFlag ifTrue: [self add: #optional].
	self acceptTry: e domain.
	self add: ';' asSymbol.
		self remarksAfter: e! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: 'apl 3/25/2006 10:37'!
acceptExternalSchema: e 
	e isPltExternalMetaSchema
		ifTrue: [self add: #meta]
		ifFalse: [e isPltUsedSchema
				ifTrue: [self add: #use]
				ifFalse: [self add: #reference]].
	self add: #from;
		 add: e name.
	e isPltIncludeSchema ifTrue: [
		e explicitlyImportedItems
			ifNotNil: [e explicitlyImportedItems size > 0
					ifTrue: [self add: #'('.
						self acceptAll: e explicitlyImportedItems separator: ',' asSymbol.
						self add: #')']]].
	self add: ';' asSymbol! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit expressions schema' stamp: ''!
acceptFalseConstant: e 
	self 
		 add: #false! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: 'apl 1/25/2007 11:40'!
acceptFunctionDeclaration: e 
	self remarksBefore: e.
	self
		add: #function;
		add: e name.
	e formalParameters isEmpty 
		ifFalse: 
			[self add: #'('.
			self acceptAll: e formalParameters separator: ';' asSymbol.
			self add: #')'].
	self add: ':' asSymbol.
	self acceptTry: e returnType.
	self add: ';' asSymbol.
		self remarksAfter: e.

	self acceptContextDefinition: e.
	e locals isEmpty 
		ifFalse: 
			[self add: #local.
			e locals acceptTry: self.
			self
				add: #'end_local';
				add: ';' asSymbol].
	e statements acceptTry: self.
	self
		add: #'end_function';
		add: ';' asSymbol! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: 'apl 4/18/2006 13:32'!
acceptGeneralAggregateType: e 
	self add: #aggregate.
	e typeLabel notNil
		ifTrue: [self add:  ':' asSymbol;
				 add: e typeLabel].
	self add: #of.
	self acceptTry: e elementType! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit population schema' stamp: 'AlainPlantec 6/12/2012 13:38'!
acceptGenericInstance: e 
	| writer |
	writer := PlatypusModelContentsStepWriter new.
	writer outStream: (WriteStream on: String new).
	writer acceptTry: e.
	self add: writer outStream contents! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: 'apl 4/18/2006 13:31'!
acceptGenericType: e 
	self add: #generic.
	e typeLabel notNil
		ifTrue: [self add:  ':' asSymbol;
				 add: e typeLabel]! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: 'apl 1/25/2007 11:41'!
acceptGlobalRule: e 
	self remarksBefore: e.
	self
		add: #rule;
		add: e name;
		add: #for;
		add: #'('.
	self acceptAll: e forEntities separator: ',' asSymbol.
	self
		add: #')';
		add: ';' asSymbol.
	self remarksAfter: e.
	self acceptContextDefinition: e.
	e locals isEmpty 
		ifFalse: 
			[self add: #local.
			e locals acceptTry: self.
			self
				add: #'end_local';
				add: ';' asSymbol].
	e statements acceptTry: self.
	e whereRules isEmpty 
		ifFalse: 
			[self add: #where.
			e whereRules acceptTry: self].
	self
		add: #'end_rule';
		add: ';' asSymbol! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit expressions schema' stamp: 'apl 3/10/2003 22:21'!
acceptGroupQualifier: e 
	self add: #\;
		 add: e groupName! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit expressions schema' stamp: 'apl 2/28/2006 16:43'!
acceptIdentifier: e 
	self add: e name.
	e parameters
		ifNotNil: [self add: #'('.
			self acceptAll: e parameters separator: ',' asSymbol.
			self add: #')'].
! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit statements schema' stamp: 'apl 3/17/2006 09:36'!
acceptIfStatement: e 
	self add: #if.
	e selector acceptTry: self.
	self add: #then.
	e thenStatements acceptTry: self.
	(e elseStatements notNil
			and: [e elseStatements notEmpty])
		ifTrue: [self add: #else.
			e elseStatements acceptTry: self].
	self add: #'end_if';
		 add: ';' asSymbol! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: 'apl 9/25/2006 13:12'!
acceptIncludeSchema: e
	self acceptExternalSchema: e 
! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit statements schema' stamp: ''!
acceptIncrementControl: e 
	e variable acceptTry: self.
	self add: #':='.
	e first acceptTry: self.
	self add: #to.
	e last acceptTry: self.
	e step notNil
		ifTrue: [self add: #by.
			e step acceptTry: self]! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit statements schema' stamp: 'apl 3/11/2003 18:44'!
acceptIncrementControlVariable: e 
	self add: e variableId! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: ''!
acceptIntegerBound: e 
	self add: e boundValue printString! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: ''!
acceptIntegerType: e 
	self add: #integer.
	e precision notNil
		ifTrue: [self add: #'('.
			e precision acceptTry: self.
			self add: #')']! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit expressions schema' stamp: 'AlainPlantec 10/7/2010 15:59'!
acceptInterval: e 
	| andExpression left right |
	andExpression := e expr.
	left := andExpression leftExpr.
	right := andExpression rightExpr.
	self add: '{' asSymbol.
	left leftExpr acceptTry: self.
	self add: left operatorSymbol.
	left rightExpr acceptTry: self.
	self add: right operatorSymbol.
	right rightExpr acceptTry: self.
	self add: '}' asSymbol! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: 'apl 1/25/2007 11:43'!
acceptInverseAttribute: e 
	self acceptAttribute: e.
	self add: ':' asSymbol.
	e minCardinality notNil 
		ifTrue: 
			[e duplicates 
				ifTrue: 
					[self
						add: #bag;
						add: '[' asSymbol]
				ifFalse: 
					[self
						add: #set;
						add: '[' asSymbol].
			e minCardinality acceptTry: self.
			self add: ':' asSymbol.
			e maxCardinality notNil 
				ifTrue: [e maxCardinality acceptTry: self]
				ifFalse: [self add: '?' asSymbol].
			self
				add: ']' asSymbol;
				add: #of].
	self
		add: e domain name;
		add: #for;
		add: e invertedAttr name;
		add: ';' asSymbol.
		self remarksAfter: e! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit expressions schema' stamp: 'apl 3/11/2005 08:44'!
acceptLiteral: e 
	self literalEncoder doToken: e val.
	self add: self literalEncoder flushedContents! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: 'apl 4/18/2006 13:29'!
acceptLocalVariable: e 
	self add: e name;
		 add:  ':' asSymbol.
	self acceptTry: e domain.
	e initializer notNil
		ifTrue: [self add: #':='.
			e initializer acceptTry: self].
	self add: ';' asSymbol! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: ''!
acceptLogicalType: e 
	self add: #logical! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: 'apl 4/7/2006 17:28'!
acceptMetaConceptDefinition: e 
	self add: #'{'.
	e metaExpression acceptTry: self.
	self add: #'}'! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: 'apl 9/19/2007 11:37'!
acceptMetaMappingDefinition: e 
	self add: #map.
	e definitionPath
		do: [:p | self add: p]
		separatedBy: [self add: #.].
	self add: #=; add: #{.
	e metaExpression acceptTry: self.
	self add: #};
		 add: #;;
		 add: #'end_map';
		 add: #;! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: 'MrCleaner 1/20/2011 21:23'!
acceptMetaMappingRule: e 
	self add: #map.
	self add: #to.
	e metaExpression acceptTry: self.
	self add: #where.
	e metaCondition acceptTry: self.
	self add: #;;
		 add: #'end_map';
		 add: #;! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit expressions schema' stamp: ''!
acceptMissingValue: e 
	self add: '?' asSymbol! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: 'apl 2/16/2005 10:06'!
acceptNamedTypeReference: e 
	self add: e name.! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: 'apl 2/17/2006 10:16'!
acceptNativeAlgorithme: e 

	e implementations do: [:i | i acceptTry: self]! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: 'apl 2/19/2006 00:01'!
acceptNativeCode: e 
	self add: '(*#'.
	(e languageSignature notNil
			and: [e languageSignature notEmpty])
		ifTrue: [self add: '<' , e languageSignature , '>' , e code]
		ifFalse: [self add: e code].
	self add: '#*)'.
! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit expressions schema' stamp: 'apl 2/19/2006 00:13'!
acceptNativeExpression: e 
	e source acceptTry: self.
	! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit statements schema' stamp: 'apl 2/19/2006 00:19'!
acceptNativeStatement: e 
	e source acceptTry: self.
! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit statements schema' stamp: 'apl 2/17/2006 10:29'!
acceptNullStatement: e 
	self add: ';' asSymbol! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: ''!
acceptNumberType: e 
	self add: #number! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: ''!
acceptOneofSupertypeExpression: e 
	self 
		 add: e operatorSymbol;
		 add: #'('.
	self acceptAll: e exprList separator: ',' asSymbol.
	self add: #')'! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit statements schema' stamp: ''!
acceptOutputStatement: e 
	self 
		 add: #|.
	e output acceptTry: self.
	self add: #|;
		 add: ';' asSymbol! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: 'apl 4/18/2006 13:29'!
acceptParameterDefinition: e 
	e byCopy
		ifFalse: [self add: #var].
	self add: e name;
		 add:  ':' asSymbol.
	self acceptTry: e domain! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit statements schema' stamp: 'apl 2/28/2006 16:40'!
acceptProcedureCallStatement: e
	super acceptProcedureCallStatement: e.
	self add: ';' asSymbol! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: 'apl 1/25/2007 11:41'!
acceptProcedureDeclaration: e 
	self remarksBefore: e.
	self
		add: #procedure;
		add: e name.
	e formalParameters isEmpty 
		ifFalse: 
			[self add: #'('.
			self acceptAll: e formalParameters separator: ';' asSymbol.
			self add: #')'].
	self add: ';' asSymbol.
		self remarksAfter: e.

	self acceptContextDefinition: e.
	e locals isEmpty 
		ifFalse: 
			[self add: #local.
			e locals acceptTry: self.
			self
				add: #'end_local';
				add: ';' asSymbol].
	e statements acceptTry: self.
	self
		add: #'end_procedure';
		add: ';' asSymbol! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit expressions schema' stamp: ''!
acceptQueryExpression: e 
	self 
		 add: #query;
		 add: #'('.
	e variable acceptTry: self.
	self add: #<*.
	e aggregateSource acceptTry: self.
	self add: #|.
	e suchThat acceptTry: self.
	self add: #')'! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit expressions schema' stamp: ''!
acceptQueryVariable: e 
	self 
		 add: e variableId! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit expressions schema' stamp: 'apl 4/18/2006 13:24'!
acceptRangeQualifier: e 
	self add: '[' asSymbol.
	e index1 acceptTry: self.
	self add:  ':' asSymbol.
	e index2 acceptTry: self.
	self add: ']' asSymbol! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: 'apl 7/20/2004 00:39'!
acceptRealType: e 
	self add: #real.
	(e precision notNil)
		ifTrue: [self add: #'('.
			e precision acceptTry: self.
			self add: #')']! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit expressions schema' stamp: 'apl 6/2/2004 09:46'!
acceptRedefinedAttributeValue: e 
	^ self add: #'*'! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: 'apl 9/25/2006 13:13'!
acceptReferencedSchema: e
	self acceptIncludeSchema: e 
! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: 'apl 1/25/2007 10:41'!
acceptRemarkReference: e 
	e remark acceptTry: self! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit statements schema' stamp: 'apl 3/17/2006 09:36'!
acceptRepeatStatement: e 
	self add: #repeat.
	e incrControl notNil
		ifTrue: [e incrControl acceptTry: self].
	e untilControl notNil
		ifTrue: [self add: #until.
			e untilControl acceptTry: self].
	e whileControl notNil
		ifTrue: [self add: #while.
			e whileControl acceptTry: self].
	self add: ';' asSymbol.
	e statements notNil
		ifTrue: [e statements acceptTry: self].
	self add: #'end_repeat';
		 add: ';' asSymbol! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit statements schema' stamp: ''!
acceptReturnStatement: e 
	self 
		 add: #return.
	e returned notNil
		ifTrue: [self add: #'('.
			e returned acceptTry: self.
			self add: #')'].
	self add: ';' asSymbol! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: 'apl 9/19/2007 11:34'!
acceptSchemaDefinition: e 
	self remarksBefore: e.
	self add: #schema;
		 add: e name;
		 add: ';' asSymbol.
	self remarksAfter: e.
	e interface acceptTry: self.
	self acceptContextDefinition: e.
	e globalRules acceptTry: self.
	e mappings acceptTry: self.
	self addEol; add: #'end_schema'; add: ';' asSymbol; addEol! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: 'apl 7/20/2004 11:24'!
acceptSelectType: e 
	self add: #select.
	self add: #'('.
	e selections
		do: [:s | self acceptTry: s]
		separatedBy: [self add: ',' asSymbol].
	self add: #')'! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit expressions schema' stamp: ''!
acceptSelfIdentifier: e 
	self  add: #self! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit expressions schema' stamp: ''!
acceptSimpleUnaryExpression: e 
	self add: e operatorSymbol.
	e expr acceptTry: self! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit statements schema' stamp: ''!
acceptSkipStatement: e 
	self 
		 add: #skip;
		 add: ';' asSymbol! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit statements schema' stamp: ''!
acceptSplitmarkStatement: e 
	self add: #'{*';
		 add: #splitmark.
		
	e filename acceptTry: self.
	self add: #'*}'! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: ''!
acceptStringType: e 
	self add: #string.
	e width notNil
		ifTrue: [self add: #'('.
			e width acceptTry: self.
			self add: #')']! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: 'apl 11/26/2003 14:01'!
acceptSubEntityRefExpression: e 
	self add: e entityRef name! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: 'AlainPlantec 5/14/2012 23:04'!
acceptSupertypeConstraint: e 
	(e constrained ref notNil and: [e constrained ref instantiable])
		ifTrue: [self add: #supertype]
		ifFalse: [self add: #abstract;
				 add: #supertype].
	e expr notNil
		ifTrue: [self add: #of;
				 add: #'('.
			e expr acceptTry: self.
			self add: #')']! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: 'apl 1/25/2007 11:18'!
acceptTailRemark: e 
	self tokenList add: (PlatypusTailRemarkToken token: e text)! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit expressions schema' stamp: ''!
acceptTrueConstant: e 
	self 
		 add: #true! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit expressions schema' stamp: 'apl 11/26/2003 14:01'!
acceptTypedExpression: e 
	self add: e domain name;
		 add: #'('.
	e expr acceptTry: self.
	self add: #')'! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: 'apl 1/25/2007 11:45'!
acceptUniquenessRule: e 
	self remarksBefore: e.
		e label notNil 
		ifTrue: 
			[self
				add: e label;
				add: ':' asSymbol].
	e attributes do: [:a | self add: a name]
		separatedBy: [self add: ',' asSymbol].
	self add: ';' asSymbol.
	self remarksAfter: e! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit expressions schema' stamp: ''!
acceptUnknownConstant: e 
	self 
		 add: #unknown! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: 'apl 9/25/2006 13:13'!
acceptUsedSchema: e
	self acceptIncludeSchema: e 
! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: 'apl 1/25/2007 11:45'!
acceptWhereRule: e 
	self remarksBefore: e.
	e label notNil 
		ifTrue: 
			[self
				add: e label;
				add: ':' asSymbol].
	e whereValue acceptTry: self.
	self add: ';' asSymbol.
	self remarksAfter: e! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'adding' stamp: 'apl 5/20/2005 19:04'!
add: aLexicalElement 
	| tokenClass |
	tokenClass := tokenClassifier tokenClassFromString: aLexicalElement
				ifAbsent: [PlatypusIdentifierToken].
	self tokenList add: (tokenClass token: aLexicalElement)! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'adding' stamp: 'apl 7/26/2004 23:18'!
addAll: aCollection
	aCollection do: [:e | self add: e]! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'adding' stamp: 'apl 5/20/2005 19:02'!
addEol
	self tokenList add: PlatypusEolToken new! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'initializing' stamp: 'apl 5/20/2005 21:50'!
initialize
	tokenList := PlatypusTokenList new.
	tokenClassifier := PlatypusExpressTokenClassifier new.
	super initialize! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'accessing' stamp: 'apl 3/11/2005 15:41'!
literalEncoder
	^ literalEncoder
		ifNil: [literalEncoder := PlatypusCoreRepositoryStepFileWriter new]! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: 'apl 1/25/2007 10:50'!
remarksAfter: e 
	(e relatedRemarks select: [:r | r isPltTailRemark]) acceptTry: self! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'visit dictionary schema' stamp: 'apl 1/25/2007 10:50'!
remarksBefore: e 
	(e relatedRemarks select: [:r | r isPltEmbeddedRemark]) acceptTry: self! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'accessing' stamp: 'apl 11/12/2003 11:38'!
tokenList
	^ tokenList! !

!PlatypusSchemaInstanceTokenizer methodsFor: 'public tokenizing' stamp: 'apl 11/12/2003 11:37'!
tokenize: anPlatypusDictionaryInstance 
	self acceptTry: anPlatypusDictionaryInstance.
	^ self tokenList! !

PlatypusStepAbstractVisitor subclass: #PlatypusSmartNamer
	instanceVariableNames: 'query namesBuilder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-translater-private'!

!PlatypusSmartNamer class methodsFor: 'instance creation' stamp: 'apl 1/20/2007 10:02'!
query: aQuerySymbol namesBuilder: aNameBuilder
	^ self new query: aQuerySymbol namesBuilder: aNameBuilder! !

!PlatypusSmartNamer class methodsFor: 'accessing' stamp: 'apl 1/20/2007 09:51'!
querySymbols
	^ #(#argName #smalltalkType #smalltalkInitializingExpression)! !

!PlatypusSmartNamer methodsFor: 'visit dictionary schema' stamp: 'apl 1/20/2007 09:50'!
acceptAggregationType: e 
	| suffix |
	query = #smalltalkType ifTrue: [^ 'OrderedCollection'].
	query = #smalltalkInitializingExpression 
		ifTrue: [^ 'OrderedCollection new'].
	query = #argName 
		ifTrue: 
			[suffix := self  
						argNameSuffixFor: e elementType.
			^ 'aCollectionOf' , suffix].
	^ self signal error: 'invalid query'! !

!PlatypusSmartNamer methodsFor: 'visit dictionary schema' stamp: 'apl 1/20/2007 09:50'!
acceptArrayType: e 
	| suffix |
	query = #smalltalkType ifTrue: [^ 'OrderedCollection'].
	query = #smalltalkInitializingExpression 
		ifTrue: [^ 'OrderedCollection new'].
	query = #argName 
		ifTrue: 
			[suffix := self  
						argNameSuffixFor: e elementType.
			^ 'anArrayOf' , suffix].
	^ self signal error: 'invalid query'! !

!PlatypusSmartNamer methodsFor: 'visit dictionary schema' stamp: 'apl 1/20/2007 09:50'!
acceptBagType: e 
	| suffix |
	query = #smalltalkType ifTrue: [^ 'Bag'].
	query = #smalltalkInitializingExpression ifTrue: [^ 'Bag new'].
	query = #argName 
		ifTrue: 
			[suffix := self
						argNameSuffixFor: e elementType.
			^ 'aBagOf' , suffix].
	^ self signal error: 'invalid query'! !

!PlatypusSmartNamer methodsFor: 'visit dictionary schema' stamp: 'apl 1/20/2007 09:50'!
acceptBinaryType: e 
	query = #smalltalkType
		ifTrue: [^ 'ByteArray'].
	query = #smalltalkInitializingExpression
		ifTrue: [^ 'nil'].
	query = #argName
		ifTrue: [^ 'aBinary'].
	^ self signal error: 'invalid query'! !

!PlatypusSmartNamer methodsFor: 'visit dictionary schema' stamp: 'apl 1/20/2007 09:50'!
acceptBooleanType: e 
	query = #smalltalkType
		ifTrue: [^ 'Boolean'].
	query = #smalltalkInitializingExpression
		ifTrue: [^ 'false'].
	query = #argName
		ifTrue: [^ 'aBoolean'].
	^ self signal error: 'invalid query'! !

!PlatypusSmartNamer methodsFor: 'visit dictionary schema' stamp: 'apl 1/20/2007 09:50'!
acceptDefinedType: e
	^ e domain acceptTry: self! !

!PlatypusSmartNamer methodsFor: 'visit dictionary schema' stamp: 'apl 1/20/2007 10:18'!
acceptEntityDefinition: e 
	query = #smalltalkType 
		ifTrue: [^ e generatedClassNameFromNamesBuilder: namesBuilder].
	query = #smalltalkInitializingExpression ifTrue: [^ 'nil'].
	query = #argName 
		ifTrue: [^ 'a' , (e generatedClassNameFromNamesBuilder: namesBuilder)].
	^ self signal error: 'invalid query'! !

!PlatypusSmartNamer methodsFor: 'visit dictionary schema' stamp: 'apl 1/20/2007 09:50'!
acceptEntityDefinitionReference: e 
	^ self acceptEntityDefinition: e referenced! !

!PlatypusSmartNamer methodsFor: 'visit dictionary schema' stamp: 'apl 1/20/2007 09:50'!
acceptEntityInstance: e 
	query = #smalltalkType
		ifTrue: [^ 'Object'].
	query = #smalltalkInitializingExpression
		ifTrue: [^ 'nil'].
	query = #argName
		ifTrue: [^ 'anObject'].
	^ self signal error: 'invalid query'! !

!PlatypusSmartNamer methodsFor: 'visit dictionary schema' stamp: 'apl 1/20/2007 10:19'!
acceptEnumerationType: e 
	query = #smalltalkType ifTrue: [^ 'Symbol'].
	query = #smalltalkInitializingExpression ifTrue: [^ 'nil'].
	query = #argName 
		ifTrue: 
			[^ 'a' , (e owner generatedClassNameFromNamesBuilder: namesBuilder) , 'Symbol'].
	^ self signal error: 'invalid query'! !

!PlatypusSmartNamer methodsFor: 'visit dictionary schema' stamp: 'apl 1/20/2007 09:50'!
acceptGeneralAggregateType: e 
	| suffix |
	query = #smalltalkType ifTrue: [^ 'OrderedCollection'].
	query = #smalltalkInitializingExpression 
		ifTrue: [^ 'OrderedCollection new'].
	query = #argName 
		ifTrue: 
			[suffix := self 
						argNameSuffixFor: e elementType.
			^ 'aCollectionOf' , suffix].
	^ self signal error: 'invalid query'! !

!PlatypusSmartNamer methodsFor: 'visit dictionary schema' stamp: 'apl 1/20/2007 09:51'!
acceptGenericType: e 
	^ self acceptEntityInstance: e 
! !

!PlatypusSmartNamer methodsFor: 'visit dictionary schema' stamp: 'apl 1/20/2007 09:51'!
acceptIntegerType: e 
	query = #smalltalkType
		ifTrue: [^ 'Integer'].
	query = #smalltalkInitializingExpression
		ifTrue: [^ '0'].
	query = #argName
		ifTrue: [^ 'anInteger'].
	^ self signal error: 'invalid query'! !

!PlatypusSmartNamer methodsFor: 'visit dictionary schema' stamp: 'apl 1/20/2007 09:51'!
acceptListType: e 
	| suffix |
	query = #smalltalkType ifTrue: [^ 'OrderedCollection'].
	query = #smalltalkInitializingExpression 
		ifTrue: [^ 'OrderedCollection new'].
	query = #argName 
		ifTrue: 
			[suffix := self 
						argNameSuffixFor: e elementType.
			^ 'aListOf' , suffix].
	^ self signal error: 'invalid query'! !

!PlatypusSmartNamer methodsFor: 'visit dictionary schema' stamp: 'apl 1/20/2007 09:51'!
acceptLogicalType: e 
	query = #smalltalkType
		ifTrue: [^ 'Boolean'].
	query = #smalltalkInitializingExpression
		ifTrue: [^ 'false'].
	query = #argName
		ifTrue: [^ 'aLogical'].
	^ self signal error: 'invalid query'! !

!PlatypusSmartNamer methodsFor: 'visit dictionary schema' stamp: 'apl 1/20/2007 09:51'!
acceptNamedTypeReference: e 
	"query = #smalltalkType 
	ifTrue: [^ self translater classNameFromNamedType: e]. 
	query = #smalltalkInitializingExpression 
	ifTrue: [^ 'nil']. 
	query = #argName 
	ifTrue: [^ 'a' 
	, (self translater classNameFromNamedType: e)]. 
	^ self signal error: 'invalid query'"
	^ e referenced acceptTry: self! !

!PlatypusSmartNamer methodsFor: 'visit dictionary schema' stamp: 'apl 1/20/2007 09:51'!
acceptNumberType: e 
	query = #smalltalkType
		ifTrue: [^ 'Number'].
	query = #smalltalkInitializingExpression
		ifTrue: [^ '0.0'].
	query = #argName
		ifTrue: [^ 'aNumber'].
	^ self signal error: 'invalid query'! !

!PlatypusSmartNamer methodsFor: 'visit dictionary schema' stamp: 'apl 1/20/2007 09:51'!
acceptRealType: e 
	query = #smalltalkType
		ifTrue: [^ 'Float'].
	query = #smalltalkInitializingExpression
		ifTrue: [^ '0.0'].
	query = #argName
		ifTrue: [^ 'aReal'].
	^ self signal error: 'invalid query'! !

!PlatypusSmartNamer methodsFor: 'visit dictionary schema' stamp: 'apl 1/20/2007 10:12'!
acceptSelectType: e 
	query = #smalltalkType ifTrue: [^ 'Object'].
	query = #smalltalkInitializingExpression ifTrue: [^ 'nil'].
	query = #argName 
		ifTrue: [^ 'a' , (e owner generatedClassNameFromNamesBuilder: namesBuilder)].
	^ self signal error: 'invalid query'! !

!PlatypusSmartNamer methodsFor: 'visit dictionary schema' stamp: 'apl 1/20/2007 09:51'!
acceptSetType: e 
	| suffix |
	query = #smalltalkType ifTrue: [^ 'Set'].
	query = #smalltalkInitializingExpression ifTrue: [^ 'Set new'].
	query = #argName 
		ifTrue: 
			[suffix :=  self 
						argNameSuffixFor: e elementType.
			^ 'aSetOf' , suffix].
	^ self signal error: 'invalid query'! !

!PlatypusSmartNamer methodsFor: 'visit dictionary schema' stamp: 'apl 1/20/2007 09:51'!
acceptStringType: e 
	query = #smalltalkType
		ifTrue: [^ 'String'].
	query = #smalltalkInitializingExpression
		ifTrue: [^ ''''''].
	query = #argName
		ifTrue: [^ 'aString'].
	^ self signal error: 'invalid query'! !

!PlatypusSmartNamer methodsFor: 'querying' stamp: 'apl 1/20/2007 10:12'!
argNameSuffixFor: aMetaData 
	| argname |
	argname := namesBuilder argNameFor: aMetaData.
	argname size = 1 ifTrue: [^ argname].
	argname first = $a 
		ifTrue: [argname := argname copyFrom: 2 to: argname size].
	argname size = 1 ifTrue: [^ argname].
	argname first = $n 
		ifTrue: [argname := argname copyFrom: 2 to: argname size].
	^ argname! !

!PlatypusSmartNamer methodsFor: 'accessing' stamp: 'apl 1/20/2007 10:02'!
query: anObject namesBuilder: aNameBuilder 
	query := anObject.
	namesBuilder := aNameBuilder! !

!PlatypusStepAbstractVisitor methodsFor: 'visit aggregate data schema' stamp: 'apl 3/17/2006 09:37'!
acceptAggregateData: e 
	e contents acceptTry: self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit expressions schema' stamp: 'apl 3/17/2006 09:37'!
acceptAggregateInitializer: e 
	e contents acceptTry: self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit expressions schema' stamp: 'apl 3/22/2006 11:20'!
acceptAggregateInitializerElement: e 
	self acceptTry: e val.
	e repetition acceptTry: self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit aggregate data schema' stamp: 'apl 5/29/2004 17:14'!
acceptAggregateInstance: e 
	e lowerBound acceptTry: self.
	e upperBound acceptTry: self.
	self acceptAggregateData: e.! !

!PlatypusStepAbstractVisitor methodsFor: 'visit generic' stamp: 'apl 7/20/2004 01:51'!
acceptAggregationType: e lower: l upper: u symbol: subtype flags: aCollection 
	l notNil
		ifTrue: [l acceptTry: self.
			u notNil
				ifTrue: [u acceptTry: self]].
	self acceptTry: e elementType.
! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: 'apl 3/17/2006 09:37'!
acceptAlgorithmDeclaration: e 
	e formalParameters acceptTry: self.
	self acceptStatementsContainer: e! !

!PlatypusStepAbstractVisitor methodsFor: 'visit statements schema' stamp: 'apl 3/17/2006 09:37'!
acceptAliasStatement: e 
	e variable acceptTry: self.
	e statements acceptTry: self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit statements schema' stamp: ''!
acceptAliasStatementVariable: e 
	e ref acceptTry: self
! !

!PlatypusStepAbstractVisitor methodsFor: 'visit statements schema' stamp: 'apl 12/21/2003 10:36'!
acceptAnonymousVariable: e 
	^ self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: 'AlainPlantec 10/7/2010 16:02'!
acceptArrayType: e 
	| flags |
	flags := OrderedCollection new.
	e uniqueFlag
		ifTrue: [flags add: #unique].
	e optionalFlag
		ifTrue: [flags add: #optional].
	self
		acceptAggregationType: e
		lower: e lowerBound
		upper: e upperBound
		symbol: #array
		flags: flags
! !

!PlatypusStepAbstractVisitor methodsFor: 'visit statements schema' stamp: 'AlainPlantec 5/20/2012 00:51'!
acceptAssignable: e
	e head acceptTry: self.
	e qualifiers acceptTry: self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit statements schema' stamp: ''!
acceptAssignmentStatement: e 
	
	e left acceptTry: self.
	e rightExpr acceptTry: self.
! !

!PlatypusStepAbstractVisitor methodsFor: 'visit expressions schema' stamp: 'apl 3/10/2003 22:15'!
acceptAttributeQualifier: e 
! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: 'apl 3/23/2006 16:03'!
acceptAttributeReference: e 
	! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: ''!
acceptBagType: e 
	self
		acceptVariableSizeAggregationType: e
		symbol: #bag
		flags: #()
! !

!PlatypusStepAbstractVisitor methodsFor: 'visit expressions schema' stamp: ''!
acceptBinaryExpression: e 
	e leftExpr acceptTry: self.
	e rightExpr acceptTry: self.
! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: ''!
acceptBinarySupertypeExpression: e 
	e leftExpr acceptTry: self.
	e rightExpr acceptTry: self.
! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: 'apl 3/22/2006 11:38'!
acceptBinaryType: e 
	e width acceptTry: self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: ''!
acceptBooleanType: e 
! !

!PlatypusStepAbstractVisitor methodsFor: 'visit expressions schema' stamp: 'apl 3/22/2006 11:23'!
acceptCardinalityExpression: e 
	e leftExpr acceptTry: self.
	e card1 acceptTry: self.
	e card2 acceptTry: self.
	e rightExpr acceptTry: self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit statements schema' stamp: 'apl 3/17/2006 09:37'!
acceptCaseAction: e 
	e labels acceptTry: self.
	e action acceptTry: self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit statements schema' stamp: 'apl 3/17/2006 09:38'!
acceptCaseStatement: e 
	e selector acceptTry: self.
	e caseActions acceptTry: self.
	e caseOtherwise notNil
		ifTrue: [e caseOtherwise acceptTry: self]! !

!PlatypusStepAbstractVisitor methodsFor: 'visit statements schema' stamp: 'apl 3/17/2006 09:38'!
acceptCompoundStatement: e 
	e statements acceptTry: self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: 'apl 7/20/2004 11:24'!
acceptConstantDefinition: e 
	self acceptTry: e domain.
	e initializer acceptTry: self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: 'apl 3/17/2006 09:38'!
acceptContextDefinition: e 
	e constants acceptTry: self.
	 e types acceptTry: self.
	 e entities acceptTry: self.
	 e algorithmes acceptTry: self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: 'apl 3/23/2006 10:32'!
acceptDefinedType: e 
	e domain acceptTry: self.
	self acceptNamedType: e! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: 'AlainPlantec 6/14/2012 15:28'!
acceptDerivedAttribute: e 
	self acceptTry: e domain.
	e assign acceptTry: self.
	e redeclaring acceptTry: self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: 'apl 6/16/2004 10:51'!
acceptDictionaryInstanceReference: e 
	! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: 'apl 3/22/2006 11:44'!
acceptDomainEquivalentItem: e 
	e nativeItem acceptTry: self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit expressions schema' stamp: 'apl 3/7/2003 16:57'!
acceptElementQualifier: e 
	e index acceptTry: self.
! !

!PlatypusStepAbstractVisitor methodsFor: 'visit statements schema' stamp: ''!
acceptEndSplitmarkStatement: e 
! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: 'apl 3/29/2006 13:36'!
acceptEntityDefinition: e 
	e supertypeConstraint acceptTry: self.
	e supertypes acceptTry: self.
	e attributes acceptTry: self.
	e uniquenessRules acceptTry: self.
	self acceptNamedType: e! !

!PlatypusStepAbstractVisitor methodsFor: 'visit expressions schema' stamp: 'apl 7/20/2004 11:24'!
acceptEntityInstancesSet: e 
	^ self acceptTry: e entityRef! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: ''!
acceptEnumerationType: e 
! !

!PlatypusStepAbstractVisitor methodsFor: 'visit expressions schema' stamp: 'AlainPlantec 6/14/2012 15:28'!
acceptEnumerationValue: e
	^ e domain acceptTry: self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit statements schema' stamp: ''!
acceptEscapeStatement: e 
! !

!PlatypusStepAbstractVisitor methodsFor: 'visit expressions schema' stamp: 'apl 4/13/2006 11:57'!
acceptEscapedExpression: e 
	e expr acceptTry: self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: 'apl 3/15/2006 15:51'!
acceptExplicitAttribute: e 
	self acceptTry: e domain.
	e redeclaring acceptTry: self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: 'apl 3/25/2006 13:11'!
acceptExternalMetaSchema: e 
! !

!PlatypusStepAbstractVisitor methodsFor: 'visit population schema' stamp: 'apl 3/17/2006 09:39'!
acceptExternalRepresentation: e 
	self acceptGenericInstance: e.
	 e records acceptTry: self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: 'apl 3/25/2006 10:38'!
acceptExternalSchema: e 
	^ self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit expressions schema' stamp: ''!
acceptFalseConstant: e 
! !

!PlatypusStepAbstractVisitor methodsFor: 'visit population schema' stamp: 'apl 11/7/2003 14:56'!
acceptFileDescription: e! !

!PlatypusStepAbstractVisitor methodsFor: 'visit population schema' stamp: 'apl 11/7/2003 14:56'!
acceptFileName: e 
	^ self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit population schema' stamp: 'apl 11/7/2003 14:57'!
acceptFileSchema: e 
	^ self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: 'apl 3/22/2006 15:08'!
acceptFunctionDeclaration: e 
	self acceptAlgorithmDeclaration: e.
	e returnType acceptTry: self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: 'apl 7/20/2004 11:24'!
acceptGeneralAggregateType: e 
	self acceptTry: e elementType! !

!PlatypusStepAbstractVisitor methodsFor: 'visit population schema' stamp: 'AlainPlantec 5/13/2012 01:58'!
acceptGenericInstance: e 
	e instanceScope acceptTry: self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: 'apl 3/7/2003 17:01'!
acceptGenericType: e 
! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: 'apl 3/17/2006 09:39'!
acceptGlobalRule: e 
	self acceptStatementsContainer: e.
	 e forEntities acceptTry: self.
	e whereRules acceptTry: self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit expressions schema' stamp: 'apl 3/10/2003 22:21'!
acceptGroupQualifier: e 
! !

!PlatypusStepAbstractVisitor methodsFor: 'visit expressions schema' stamp: 'apl 7/20/2004 11:11'!
acceptIdentifier: e 
	! !

!PlatypusStepAbstractVisitor methodsFor: 'visit statements schema' stamp: 'apl 3/17/2006 09:39'!
acceptIfStatement: e 
	e selector acceptTry: self.
	 e thenStatements acceptTry: self.
	e elseStatements acceptTry: self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: 'apl 3/25/2006 10:26'!
acceptIncludeSchema: e 
	e explicitlyImportedItems acceptTry: self.
	e implicitlyImportedItems acceptTry: self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit statements schema' stamp: 'apl 3/22/2006 12:22'!
acceptIncrementControl: e 
	e variable acceptTry: self.
	e first acceptTry: self.
	e last acceptTry: self.
	e step acceptTry: self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit statements schema' stamp: ''!
acceptIncrementControlVariable: e 
! !

!PlatypusStepAbstractVisitor methodsFor: 'visit population schema' stamp: 'apl 3/17/2006 09:40'!
acceptInstanceScope: e 
	 e owned acceptTry: self.
	 e exportList acceptTry: self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: ''!
acceptIntegerBound: e 
! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: 'apl 3/15/2006 15:51'!
acceptIntegerType: e 
	e precision acceptTry: self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit population schema' stamp: 'apl 3/17/2006 09:40'!
acceptInternalRepresentation: e 
	self acceptGenericInstance: e.
	  e parameters acceptTry: self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit expressions schema' stamp: 'apl 6/18/2004 18:43'!
acceptInterval: e 
	e expr acceptTry: self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: 'apl 3/15/2006 15:51'!
acceptInverseAttribute: e 
	e invertedAttr acceptTry: self.
	e minCardinality acceptTry: self.
			e maxCardinality acceptTry: self.
	e redeclaring acceptTry: self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: 'apl 3/7/2003 17:02'!
acceptListType: e 
	e uniqueFlag
		ifTrue: [self
				acceptVariableSizeAggregationType: e
				symbol: #list
				flags: #(#unique )]
		ifFalse: [self
				acceptVariableSizeAggregationType: e
				symbol: #list
				flags: #()]
! !

!PlatypusStepAbstractVisitor methodsFor: 'visit expressions schema' stamp: 'apl 3/10/2003 23:43'!
acceptLiteral: e 
! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: 'apl 3/15/2006 15:52'!
acceptLocalVariable: e 
	self acceptTry: e domain.
	e initializer acceptTry: self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: ''!
acceptLogicalType: e 
! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: 'apl 3/18/2006 14:48'!
acceptMetaConceptDefinition: e 
	^ self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: 'apl 9/19/2007 10:11'!
acceptMetaMappingDefinition: e ! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: 'MrCleaner 1/20/2011 21:16'!
acceptMetaMappingRule: e ! !

!PlatypusStepAbstractVisitor methodsFor: 'visit expressions schema' stamp: ''!
acceptMissingValue: e 
! !

!PlatypusStepAbstractVisitor methodsFor: 'visit environment schema' stamp: 'AlainPlantec 10/14/2010 21:40'!
acceptModelContents: e 
	e headerInstances acceptTry: self.
	e dataInstances
		do: [:v | v acceptTry: self]! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: 'apl 3/17/2006 09:40'!
acceptNamedType: e 
	e whereRules acceptTry: self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: 'apl 7/23/2004 11:03'!
acceptNamedTypeReference: e 
 ! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: 'apl 3/17/2006 09:40'!
acceptNativeAlgorithm: e 
	 e implementations acceptTry: self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: 'apl 2/10/2006 13:19'!
acceptNativeCode: e 
	^ self ! !

!PlatypusStepAbstractVisitor methodsFor: 'visit expressions schema' stamp: 'apl 2/17/2006 08:50'!
acceptNativeExpression: e 
	e source acceptTry: self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit statements schema' stamp: 'apl 2/10/2006 11:32'!
acceptNativeStatement: e
	e source acceptTry: self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit statements schema' stamp: 'apl 12/19/2003 13:55'!
acceptNullStatement: e 
! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: ''!
acceptNumberType: e 
! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: 'apl 3/17/2006 09:41'!
acceptOneofSupertypeExpression: e 
	e exprList acceptTry: self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit statements schema' stamp: ''!
acceptOutputStatement: e 
	e output acceptTry: self.
! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: 'apl 7/20/2004 11:22'!
acceptParameterDefinition: e 
	self acceptTry: e domain! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: ''!
acceptPopulationDependentBound: e 
	e boundValue acceptTry: self
! !

!PlatypusStepAbstractVisitor methodsFor: 'visit statements schema' stamp: 'apl 5/24/2004 15:53'!
acceptProcedureCallStatement: e 
	e call acceptTry: self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: 'apl 6/18/2004 20:05'!
acceptProcedureDeclaration: e 
self acceptAlgorithmDeclaration: e! !

!PlatypusStepAbstractVisitor methodsFor: 'visit expressions schema' stamp: 'apl 3/17/2006 09:41'!
acceptQualifiedExpression: e 
	e head acceptTry: self.
	e qualifiers acceptTry: self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit expressions schema' stamp: 'AlainPlantec 1/28/2011 11:36'!
acceptQueryExpression: e 
	e variable acceptTry: self.
	e aggregateSource acceptTry: self.
	e suchThat acceptTry: self ! !

!PlatypusStepAbstractVisitor methodsFor: 'visit expressions schema' stamp: ''!
acceptQueryVariable: e 
! !

!PlatypusStepAbstractVisitor methodsFor: 'visit expressions schema' stamp: ''!
acceptRangeQualifier: e 
	e index1 acceptTry: self.
	e index2 acceptTry: self.
! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: 'apl 3/15/2006 15:52'!
acceptRealType: e 
	e precision acceptTry: self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit expressions schema' stamp: 'apl 11/7/2003 16:24'!
acceptRedefinedAttributeValue: e 
! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: 'apl 3/25/2006 10:27'!
acceptReferencedSchema: e 
	self acceptIncludeSchema: e! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: 'apl 11/6/2003 22:16'!
acceptRemark: e 
	! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: 'apl 9/21/2006 15:52'!
acceptRemarkReference: e 
	e inside ref
		ifNil: [e inside
				ref: (self schemaInstance lookUpSchemaDefinitionBN: e inside name)].
	e remark acceptTry: self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit statements schema' stamp: 'apl 3/17/2006 09:41'!
acceptRepeatStatement: e 
	e incrControl acceptTry: self.
	e untilControl acceptTry: self.
	e whileControl acceptTry: self.
	e statements acceptTry: self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit statements schema' stamp: 'apl 3/22/2006 12:25'!
acceptReturnStatement: e 
	e returned acceptTry: self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: 'AlainPlantec 10/19/2010 01:08'!
acceptSchemaDefinition: e 
	e interface acceptTry: self.
	self acceptContextDefinition: e.
	e globalRules acceptTry: self.
	e remarkReferences acceptTry: self.
	e mappings acceptTry: self.! !

!PlatypusStepAbstractVisitor methodsFor: 'visit environment schema' stamp: 'apl 3/29/2006 13:56'!
acceptSchemaInstance: e 
	e schemataLinkedMetaData acceptTry: self.
	e metaConceptsIndex acceptTry: self.
! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: 'apl 3/17/2006 09:42'!
acceptSelectType: e 
	 e selections acceptTry: self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit expressions schema' stamp: ''!
acceptSelfIdentifier: e 
! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: ''!
acceptSetType: e 
	self
		acceptVariableSizeAggregationType: e
		symbol: #set
		flags: #()
! !

!PlatypusStepAbstractVisitor methodsFor: 'visit population schema' stamp: 'apl 3/17/2006 09:42'!
acceptSimpleRecord: e 
	 e parameters acceptTry: self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit expressions schema' stamp: ''!
acceptSimpleUnaryExpression: e 
	e expr acceptTry: self
! !

!PlatypusStepAbstractVisitor methodsFor: 'visit statements schema' stamp: ''!
acceptSkipStatement: e 
! !

!PlatypusStepAbstractVisitor methodsFor: 'visit statements schema' stamp: ''!
acceptSplitmarkStatement: e 
	e filename acceptTry: self.
! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: 'apl 3/17/2006 09:42'!
acceptStatementsContainer: e 
	e locals acceptTry: self.
	self acceptContextDefinition: e.
	 e statements acceptTry: self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: 'apl 3/22/2006 12:10'!
acceptStringType: e 
	e width acceptTry: self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: 'apl 3/22/2006 12:11'!
acceptSubEntityRefExpression: e 
	self acceptTry: e entityRef! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: 'apl 3/22/2006 12:13'!
acceptSupertypeConstraint: e 
	e constrained acceptTry: self.
	e expr acceptTry: self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit expressions schema' stamp: ''!
acceptTrueConstant: e 
! !

!PlatypusStepAbstractVisitor methodsFor: 'visit expressions schema' stamp: ''!
acceptTypedExpression: e 
	e expr acceptTry: self.
! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: 'apl 3/17/2006 09:43'!
acceptUniquenessRule: e 
	 e attributes acceptTry: self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit expressions schema' stamp: ''!
acceptUnknownConstant: e 
! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: 'apl 3/25/2006 10:27'!
acceptUsedSchema: e 
	self acceptIncludeSchema: e! !

!PlatypusStepAbstractVisitor methodsFor: 'visit population schema' stamp: 'apl 3/17/2006 09:43'!
acceptUserDefinedApplicationInstance: e 
	 e parameters acceptTry: self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit population schema' stamp: 'apl 3/17/2006 09:43'!
acceptUserDefinedHeaderInstance: e 
	 e parameters acceptTry: self! !

!PlatypusStepAbstractVisitor methodsFor: 'visit generic' stamp: ''!
acceptVariableSizeAggregationType: e symbol: aSymbol flags: aCollection 
	self
		acceptAggregationType: e
		lower: e lowerBound
		upper: e upperBound
		symbol: aSymbol
		flags: aCollection! !

!PlatypusStepAbstractVisitor methodsFor: 'visit dictionary schema' stamp: ''!
acceptWhereRule: e 
	e whereValue acceptTry: self.
! !

!PlatypusStepAbstractVisitor methodsFor: 'type checking' stamp: 'apl 7/22/2004 17:17'!
checkAssignmentOf: aValue to: anAssignable 
	| leftDomain rightDomain |
	(self value: aValue isAssignableTo: anAssignable)
		ifFalse: [
			leftDomain := anAssignable computedDomain.
			rightDomain := aValue computedDomain.
			PlatypusExpressIncompatibleDomainInAssignmentException signal: 'lhs domain : ' , leftDomain prettyPrintedExpressCode , ';  rhs domain : ' , rightDomain prettyPrintedExpressCode].
	^ true! !

!PlatypusStepAbstractVisitor methodsFor: 'accessing' stamp: 'apl 9/8/2006 18:19'!
lookUpIdentifierBN: name 
	| found |
	visitPath
		reverseDo: [:el | (found := el lookUpIdentifierBN: name)
				ifNotNil: [^ found]].
	^ nil! !

!PlatypusStepAbstractVisitor methodsFor: 'accessing' stamp: 'apl 6/18/2004 22:37'!
lookUpNamedTypeBN: name 
	| found |
	visitPath 
		reverseDo: [:el | (found := el lookUpNamedTypeBN: name) ifNotNil: [^found]].
	^nil! !

!PlatypusStepAbstractVisitor methodsFor: 'accessing' stamp: 'apl 3/24/2006 19:00'!
schemaDefinition
	^ visitPath asArray reversed detect: [:e | e isPltSchemaDefinition ]! !

!PlatypusStepAbstractVisitor methodsFor: 'accessing' stamp: 'AlainPlantec 6/15/2012 12:39'!
schemaInstance
	^ visitPath notEmpty
		ifTrue: [visitPath first schemaInstance]
		ifFalse: [nil]! !

!PlatypusStepAbstractVisitor methodsFor: 'error handling' stamp: 'AlainPlantec 6/14/2012 00:39'!
showInterpreterErrorOnSource: error
	| e |
	e := PlatypusExpressInterpretorError
		metaData: visitPath last
		message: error messageText.
	self registerError: e.
	self schemaInstance addError: e.
	PlatypusExpressEditor
		openWithSourceHandler: self schemaInstance tamarisItemRef
		windowLabel: 'Error: ' , error messageText! !

!PlatypusStepAbstractVisitor methodsFor: 'type checking' stamp: 'apl 2/19/2006 20:20'!
value: aValue isAssignableTo: anAssignable 
	| leftDomain rightDomain |
	self checksAssignments
		ifTrue: [leftDomain := anAssignable domain.
			rightDomain := aValue computedDomain.
			^ rightDomain isAssignableTo: leftDomain].
	^ true! !

PlatypusStepAbstractVisitor subclass: #PlatypusStepOnePassAbstractVisitor
	instanceVariableNames: 'visited'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-visitors'!

PlatypusStepOnePassAbstractVisitor subclass: #PlatypusExpressInterfaceBuilder
	instanceVariableNames: 'interface'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-visitors'!

!PlatypusExpressInterfaceBuilder class methodsFor: 'instance creation' stamp: 'apl 5/19/2004 09:33'!
exportedPrimariesElementsOf: aDictionaryInstance 
	| interfaceBuilder |
	interfaceBuilder := self new.
	interfaceBuilder acceptTry: aDictionaryInstance.
	^ interfaceBuilder! !

!PlatypusExpressInterfaceBuilder methodsFor: 'visit dictionary schema' stamp: 'apl 3/17/2006 09:29'!
acceptAlgorithmDeclaration: e 
	self acceptContextDefinition: e.
	self addInInterface: e.
	e formalParameters acceptTry: self! !

!PlatypusExpressInterfaceBuilder methodsFor: 'visit dictionary schema' stamp: 'apl 6/18/2004 15:31'!
acceptConstantDefinition: e 
	self addInInterface: e.
	e domain acceptTry: self.
	e initializer acceptTry: self! !

!PlatypusExpressInterfaceBuilder methodsFor: 'visit dictionary schema' stamp: 'apl 3/25/2006 10:29'!
acceptExternalSchema: e 
	super acceptExternalSchema: e.
! !

!PlatypusExpressInterfaceBuilder methodsFor: 'visit dictionary schema' stamp: 'apl 3/17/2006 09:29'!
acceptGlobalRule: e 
	self addInInterface: e.
	e forEntities acceptTry: self! !

!PlatypusExpressInterfaceBuilder methodsFor: 'visit dictionary schema' stamp: 'apl 3/25/2006 10:29'!
acceptIncludeSchema: e 
	super acceptIncludeSchema: e.
	e nativeSchema
		ifNotNil: [e nativeSchema acceptTry: self]! !

!PlatypusExpressInterfaceBuilder methodsFor: 'visit dictionary schema' stamp: 'apl 3/17/2006 09:29'!
acceptNamedType: e 
	self addInInterface: e.
	e whereRules acceptTry: self! !

!PlatypusExpressInterfaceBuilder methodsFor: 'accessing' stamp: 'apl 4/1/2003 19:39'!
addInInterface: e 
	interface add: e! !

!PlatypusExpressInterfaceBuilder methodsFor: 'initialize/release' stamp: 'apl 6/14/2004 19:23'!
initialize
	super initialize.
	interface := IdentitySet new! !

!PlatypusExpressInterfaceBuilder methodsFor: 'accessing' stamp: 'apl 6/13/2003 14:27'!
interface
	^ interface ! !

PlatypusStepOnePassAbstractVisitor subclass: #PlatypusExpressTypeOfBuilder
	instanceVariableNames: 'resultSet startElement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-interpreter'!

!PlatypusExpressTypeOfBuilder class methodsFor: 'instance creation' stamp: 'apl 6/14/2004 19:31'!
typeOfSetFor: anElement 
	^ self new typeOfSetFor: anElement ! !

!PlatypusExpressTypeOfBuilder methodsFor: 'visit dictionary schema' stamp: 'apl 6/14/2004 19:26'!
acceptAggregateInitializerDomain: e 
	resultSet
		add: (PltStringLiteral val: 'LIST')! !

!PlatypusExpressTypeOfBuilder methodsFor: 'visit dictionary schema' stamp: 'apl 6/14/2004 19:26'!
acceptAggregationType: e 
	resultSet
		add: (PltStringLiteral val: e expressTypeForTypeOf)! !

!PlatypusExpressTypeOfBuilder methodsFor: 'visit dictionary schema' stamp: 'apl 1/20/2004 23:38'!
acceptAnonymousVariable: e 
	e domain acceptTry: self! !

!PlatypusExpressTypeOfBuilder methodsFor: 'visit dictionary schema' stamp: 'apl 1/30/2004 09:26'!
acceptBinarySupertypeExpression: e 
	"e leftExpr acceptTry: self.
	e rightExpr acceptTry: self"
	^ nil! !

!PlatypusExpressTypeOfBuilder methodsFor: 'visit native ' stamp: 'apl 2/2/2006 08:22'!
acceptCollection: e 
	resultSet
		add: (PltStringLiteral val: 'AGGREGATE')! !

!PlatypusExpressTypeOfBuilder methodsFor: 'visit dictionary schema' stamp: 'apl 1/20/2004 21:29'!
acceptConstantDefinition: e 
	e domain acceptTry: self! !

!PlatypusExpressTypeOfBuilder methodsFor: 'visit dictionary schema' stamp: 'apl 1/20/2004 21:28'!
acceptDefinedType: e 
	self acceptNamedType: e.
	e domain acceptTry: self! !

!PlatypusExpressTypeOfBuilder methodsFor: 'visit dictionary schema' stamp: 'apl 5/26/2004 23:40'!
acceptDictionaryInstanceReference: e 
	e ref
		ifNotNil: [self acceptTry: e ref]! !

!PlatypusExpressTypeOfBuilder methodsFor: 'visit dictionary schema' stamp: 'apl 3/17/2006 09:31'!
acceptEntityDefinition: e 
	self acceptNamedType: e.
	e supertypes acceptTry: self.
	e supertypeConstraint acceptTry: self! !

!PlatypusExpressTypeOfBuilder methodsFor: 'visit dictionary schema' stamp: 'apl 1/21/2004 11:56'!
acceptEnumerationType: e 
	^ e owner acceptTry: self! !

!PlatypusExpressTypeOfBuilder methodsFor: 'visit dictionary schema' stamp: 'apl 1/21/2004 11:57'!
acceptGenericType: e 
	^ self! !

!PlatypusExpressTypeOfBuilder methodsFor: 'visit dictionary schema' stamp: 'apl 1/20/2004 21:40'!
acceptLocalVariable: e 
	e domain acceptTry: self! !

!PlatypusExpressTypeOfBuilder methodsFor: 'visit dictionary schema' stamp: 'apl 6/14/2004 19:26'!
acceptNamedType: e 
	resultSet
		add: (PltStringLiteral val: e expressTypeForTypeOf)! !

!PlatypusExpressTypeOfBuilder methodsFor: 'visit native ' stamp: 'apl 2/2/2006 09:38'!
acceptObject: e 
	^ self acceptTry: e class platypusMetaData ! !

!PlatypusExpressTypeOfBuilder methodsFor: 'visit dictionary schema' stamp: 'apl 1/30/2004 09:26'!
acceptOneofSupertypeExpression: e 
	"self acceptAll: e exprList"
	^ nil! !

!PlatypusExpressTypeOfBuilder methodsFor: 'visit dictionary schema' stamp: 'apl 3/17/2006 09:31'!
acceptSelectType: e 
	e selections acceptTry: self! !

!PlatypusExpressTypeOfBuilder methodsFor: 'visit dictionary schema' stamp: 'apl 6/14/2004 19:26'!
acceptSimpleType: e 
	resultSet
		add: (PltStringLiteral val: e expressTypeForTypeOf)! !

!PlatypusExpressTypeOfBuilder methodsFor: 'visit dictionary schema' stamp: 'apl 3/22/2006 12:11'!
acceptSubEntityRefExpression: e 
	^ nil! !

!PlatypusExpressTypeOfBuilder methodsFor: 'visit dictionary schema' stamp: 'apl 1/30/2004 09:27'!
acceptSupertypeConstraint: e 
	"e expr
		ifNotNil: [e expr acceptTry: self]"
		^ nil! !

!PlatypusExpressTypeOfBuilder methodsFor: 'initialize/release' stamp: 'apl 1/20/2004 21:24'!
initialize
	super initialize.
	resultSet := Set new! !

!PlatypusExpressTypeOfBuilder methodsFor: 'visit generic' stamp: 'apl 2/14/2007 16:17'!
lookUpAndCacheAcceptSelectorOfClass: aClass 
	| currClass selector |
	currClass := aClass.
	[currClass ~~ nil]
		whileTrue: [(currClass class canUnderstand: #platypusMetaData)
				ifTrue: [selector := (#accept
								, (PlatypusNamesBuilder capitalize: currClass platypusMetaData name first: true) , ':') asSymbol]
				ifFalse: [selector := (#accept , currClass name , ':') asSymbol].
			(self class includesSelector: selector)
				ifTrue: [self acceptSelectorsMap at: aClass put: selector.
					^ selector].
			currClass := currClass superclass].
	^ self error: 'unimplemented accept method for class ''' , aClass name , ''''! !

!PlatypusExpressTypeOfBuilder methodsFor: 'visit generic' stamp: 'apl 6/14/2004 19:28'!
typeOfSetFor: anElement 
	startElement := anElement.
	anElement acceptTry: self.
	^ resultSet! !

PlatypusStepOnePassAbstractVisitor subclass: #PlatypusInstanceDoer
	instanceVariableNames: 'modelContents action sourceCollection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-visitors'!

!PlatypusInstanceDoer methodsFor: 'visit population schema' stamp: 'AlainPlantec 5/8/2012 14:55'!
acceptAggregateData: e 
	e contents 	
		doWithIndex: [:v :p |
			action value: e contents value: p.
			self acceptTry: v]! !

!PlatypusInstanceDoer methodsFor: 'visit population schema' stamp: 'AlainPlantec 5/8/2012 14:54'!
acceptExternalRepresentation: e 
	e records
		doWithIndex: [:v :p |
			action value: e records value: p.
			self acceptTry: v]! !

!PlatypusInstanceDoer methodsFor: 'visit population schema' stamp: 'AlainPlantec 5/8/2012 14:48'!
acceptInternalRepresentation: e 
	e parameters 
		doWithIndex: [:v :p |
			action value: e parameters value: p.
			self acceptTry: v]! !

!PlatypusInstanceDoer methodsFor: 'visit population schema' stamp: 'AlainPlantec 5/8/2012 14:55'!
acceptModelContents: e 
	self modelContents: e.
	e dataInstances  
		doWithIndex: [:v :p |
			(sourceCollection includes: v)
				ifTrue: [
					action value: e dataInstances value: p.
					self acceptTry: v]]! !

!PlatypusInstanceDoer methodsFor: 'visit population schema' stamp: 'AlainPlantec 5/8/2012 14:54'!
acceptSimpleRecord: e 
	e parameters 
		doWithIndex: [:v :p |
			action value: e parameters value: p.
			self acceptTry: v]! !

!PlatypusInstanceDoer methodsFor: 'accessing' stamp: 'AlainPlantec 5/8/2012 15:00'!
do: aBlock from: aCollection in: aModelContents
	action := aBlock.
	sourceCollection := aCollection.
	self acceptTry: aModelContents.
! !

!PlatypusInstanceDoer methodsFor: 'accessing' stamp: 'AlainPlantec 5/8/2012 14:18'!
modelContents: anObject
	modelContents := anObject! !

PlatypusStepOnePassAbstractVisitor subclass: #PlatypusInstanceReplacer
	instanceVariableNames: 'index modelContents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-visitors'!

!PlatypusInstanceReplacer methodsFor: 'visit population schema' stamp: 'AlainPlantec 5/5/2012 01:37'!
acceptAggregateData: e 
	e contents 
		doWithIndex: [:v :p |
			index 
				at: v 
				ifPresent: [:found | e contents at: p put: found]
				ifAbsent: [self acceptTry: v]]! !

!PlatypusInstanceReplacer methodsFor: 'visit population schema' stamp: 'AlainPlantec 5/8/2012 13:07'!
acceptExternalRepresentation: e 
	e records 
		doWithIndex: [:v :p |
			index 
				at: v 
				ifPresent: [:found | e records at: p put: found]
				ifAbsent: [self acceptTry: v]]! !

!PlatypusInstanceReplacer methodsFor: 'visit population schema' stamp: 'AlainPlantec 5/5/2012 01:37'!
acceptInternalRepresentation: e 
	e parameters 
		doWithIndex: [:v :p |
			index 
				at: v 
				ifPresent: [:found | e parameters at: p put: found]
				ifAbsent: [self acceptTry: v]]! !

!PlatypusInstanceReplacer methodsFor: 'visit population schema' stamp: 'AlainPlantec 5/5/2012 01:36'!
acceptSimpleRecord: e 
	e parameters 
		doWithIndex: [:v :p |
			index 
				at: v 
				ifPresent: [:found | e parameters at: p put: found]
				ifAbsent: [self acceptTry: v]]! !

!PlatypusInstanceReplacer methodsFor: 'accessing' stamp: 'AlainPlantec 5/4/2012 23:33'!
modelContents: anObject
	modelContents := anObject! !

!PlatypusInstanceReplacer methodsFor: 'accessing' stamp: 'AlainPlantec 5/5/2012 01:50'!
remove: oldInst from: aModelContents 
	| idx |
	idx := IdentityDictionary new.
	idx at: oldInst put: PltMissingValue new.
	self removeIndex: idx from: aModelContents! !

!PlatypusInstanceReplacer methodsFor: 'accessing' stamp: 'AlainPlantec 5/8/2012 16:29'!
removeIndex: aDictionary from: aModelContents 
	index := aDictionary.
	self modelContents: aModelContents.
	self acceptTry: aModelContents.
	aDictionary keysAndValuesDo: [:k :v |
		| pos newInst oldInst |
		oldInst := k.
		newInst := v.
		pos := aModelContents indexOf: oldInst.
		pos > 0 
			ifTrue: [
				aModelContents dataInstances remove: oldInst.
				aModelContents removeFromIndexes: oldInst]].
	! !

!PlatypusInstanceReplacer methodsFor: 'accessing' stamp: 'AlainPlantec 5/16/2012 22:24'!
replace: oldInst with: newInst in: aModelContents
	self modelContents: aModelContents.
	self replaceInIndexes: oldInst with: newInst.
	index := IdentityDictionary new.
	index at: oldInst put: newInst.
	self acceptTry: aModelContents.
! !

!PlatypusInstanceReplacer methodsFor: 'accessing' stamp: 'AlainPlantec 5/17/2012 11:14'!
replaceInIndexes: oldInst with: newInst
	| pos |
	newInst persistentLabel: oldInst persistentLabel.
	newInst owningModel: modelContents.
	newInst computed: oldInst computed.
	pos := modelContents indexOf: newInst.
	pos > 0 
		ifTrue: [
			modelContents privateRemove: newInst.
			modelContents dataInstances at: pos put: nil].
	pos := modelContents indexOf: oldInst.
	pos > 0 
		ifTrue: [
			modelContents privateRemove: oldInst.
			modelContents dataInstances at: pos put: newInst].
	modelContents addToIndexes:  newInst withPosition: pos.
! !

!PlatypusInstanceReplacer methodsFor: 'accessing' stamp: 'AlainPlantec 5/16/2012 14:52'!
replaceIndex: aDictionary in: aModelContents
	index := aDictionary.
	self modelContents: aModelContents.
	self acceptTry: aModelContents.
	aDictionary keysAndValuesDo: [:k :v | self replaceInIndexes: k with: v].
! !

PlatypusStepOnePassAbstractVisitor subclass: #PlatypusMetaDataDestroyer
	instanceVariableNames: 'modelContents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-visitors'!

!PlatypusMetaDataDestroyer methodsFor: 'visit aggregate data schema' stamp: 'apl 3/22/2006 11:25'!
acceptAggregateData: e 
	super acceptAggregateData: e.
	e fastSetContents: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit expressions schema' stamp: 'apl 3/22/2006 11:24'!
acceptAggregateInitializer: e 
	super acceptAggregateInitializer: e .
	e fastSetContents: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit expressions schema' stamp: 'apl 3/22/2006 11:25'!
acceptAggregateInitializerElement: e 
	super acceptAggregateInitializerElement: e.
	e val: nil.
	e repetition: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit aggregate data schema' stamp: 'apl 3/22/2006 11:26'!
acceptAggregateInstance: e 
	super acceptAggregateInstance: e. 
	e lowerBound: nil.
	e upperBound: nil.
! !

!PlatypusMetaDataDestroyer methodsFor: 'visit dictionary schema' stamp: 'apl 3/22/2006 11:35'!
acceptAlgorithmDeclaration: e 
	super acceptAlgorithmDeclaration: e.
	e fastSetFormalParameters: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit statements schema' stamp: 'apl 3/22/2006 12:15'!
acceptAliasStatement: e
	super  acceptAliasStatement: e.
	e variable: nil.
	e fastSetStatements: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit statements schema' stamp: 'apl 3/22/2006 12:15'!
acceptAliasStatementVariable: e 
	super acceptAliasStatementVariable: e .
	e ref: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit statements schema' stamp: 'apl 3/22/2006 12:16'!
acceptAnonymousVariable: e 
	e domain acceptTry: self.
	e domain: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit dictionary schema' stamp: 'apl 3/22/2006 11:35'!
acceptArrayType: e 
	super acceptArrayType: e. 
	e elementType: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit statements schema' stamp: 'apl 3/22/2006 12:17'!
acceptAssignable: e 
	super acceptAssignable: e.
	e head: nil.
	e fastSetQualifiers: nil.! !

!PlatypusMetaDataDestroyer methodsFor: 'visit statements schema' stamp: 'apl 3/22/2006 12:17'!
acceptAssignmentStatement: e 
	super acceptAssignmentStatement: e .
	e left: nil.
	e rightExpr: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit expressions schema' stamp: 'apl 3/22/2006 14:14'!
acceptAttributeQualifier: e 
	super  acceptAttributeQualifier: e.
	e owner: nil.! !

!PlatypusMetaDataDestroyer methodsFor: 'visit dictionary schema' stamp: 'apl 3/22/2006 11:36'!
acceptAttributeReference: e 
	e ref: nil.! !

!PlatypusMetaDataDestroyer methodsFor: 'visit dictionary schema' stamp: 'apl 3/22/2006 11:36'!
acceptBagType: e 
	super acceptBagType: e. 
	e elementType: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit expressions schema' stamp: 'apl 3/22/2006 11:24'!
acceptBinaryExpression: e 
	super acceptBinaryExpression: e .
	e leftExpr: nil.
	e rightExpr: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit dictionary schema' stamp: 'apl 3/22/2006 11:37'!
acceptBinarySupertypeExpression: e 
	super acceptBinarySupertypeExpression: e.
	e leftExpr: nil.
	e rightExpr: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit dictionary schema' stamp: 'apl 3/22/2006 11:37'!
acceptBinaryType: e 
	super acceptBinaryType: e.
	e width: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit expressions schema' stamp: 'apl 3/22/2006 11:24'!
acceptCardinalityExpression: e 
	super acceptCardinalityExpression: e.
	e leftExpr: nil.
	e card1: nil.
	e card2: nil.
	e rightExpr: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit statements schema' stamp: 'apl 3/22/2006 12:18'!
acceptCaseAction: e 
	super acceptCaseAction: e.
	e fastSetLabels: nil.
	e action: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit statements schema' stamp: 'apl 3/22/2006 12:19'!
acceptCaseStatement: e 
	super acceptCaseStatement: e.
	e selector: nil.
	e fastSetCaseActions: nil.
	e caseOtherwise: nil
! !

!PlatypusMetaDataDestroyer methodsFor: 'visit statements schema' stamp: 'apl 3/22/2006 12:19'!
acceptCompoundStatement: e 
	super acceptCompoundStatement: e .
	e statements: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit dictionary schema' stamp: 'apl 3/22/2006 11:38'!
acceptConstantDefinition: e 
	super acceptConstantDefinition: e. 
	e domain: nil.
	e initializer: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit dictionary schema' stamp: 'apl 3/29/2006 13:49'!
acceptContextDefinition: e 
	super acceptContextDefinition: e.
	e removeMetaConcept.
	e owner: nil.
	e fastSetConstants: nil.
	e fastSetTypes: nil.
	e fastSetEntities: nil.
	e fastSetAlgorithmes: nil.
	e namedTypesCache: nil.
	e identifiersCache: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit dictionary schema' stamp: 'apl 3/22/2006 11:41'!
acceptDefinedType: e 
	super acceptDefinedType: e.
	e domain: nil.
! !

!PlatypusMetaDataDestroyer methodsFor: 'visit dictionary schema' stamp: 'apl 4/18/2006 13:14'!
acceptDerivedAttribute: e 
	super acceptDerivedAttribute: e.
	e domain: nil.
	e assign: nil.
	e redeclaring: nil
! !

!PlatypusMetaDataDestroyer methodsFor: 'visit dictionary schema' stamp: 'AlainPlantec 5/10/2012 16:28'!
acceptDictionaryInstanceReference: e 
	e setRef: nil.! !

!PlatypusMetaDataDestroyer methodsFor: 'visit dictionary schema' stamp: 'apl 3/22/2006 11:44'!
acceptDomainEquivalentItem: e 
	super acceptDomainEquivalentItem: e.
	e nativeItem: nil.
! !

!PlatypusMetaDataDestroyer methodsFor: 'visit expressions schema' stamp: 'apl 3/22/2006 11:26'!
acceptElementQualifier: e 
	super acceptElementQualifier: e. 
	e index: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit dictionary schema' stamp: 'AlainPlantec 5/10/2012 16:21'!
acceptEntityDefinition: e
	super acceptEntityDefinition: e.
	self acceptNamedType: e.
	e destroySubtypes.
	e supertypeConstraint: nil.
	e fastSetSupertypes: nil.
	e fastSetAttributes: nil.
	e fastSetUniquenessRules: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit dictionary schema' stamp: 'AlainPlantec 5/10/2012 16:19'!
acceptEntityDefinitionReference: e 
	self acceptNamedTypeReference: e
		! !

!PlatypusMetaDataDestroyer methodsFor: 'visit expressions schema' stamp: 'apl 3/22/2006 11:27'!
acceptEntityInstancesSet: e 
	super acceptEntityInstancesSet: e .
	e entityRef: nil.! !

!PlatypusMetaDataDestroyer methodsFor: 'visit dictionary schema' stamp: 'apl 3/22/2006 11:50'!
acceptEnumerationType: e 
	super acceptEnumerationType: e.
	e owner: nil.
	e fastSetElements: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit expressions schema' stamp: 'apl 3/22/2006 15:28'!
acceptEnumerationValue: e 
	super acceptEnumerationValue: e.
	e domain: nil.
	e element: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit expressions schema' stamp: 'apl 4/13/2006 12:00'!
acceptEscapedExpression: e 
	super acceptEscapedExpression: e.
	e expr: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit dictionary schema' stamp: 'apl 3/22/2006 15:24'!
acceptExplicitAttribute: e 
	super acceptExplicitAttribute: e.
	e domain: nil.
	e redeclaring: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit dictionary schema' stamp: 'AlainPlantec 5/13/2012 08:33'!
acceptExternalMetaSchema: e 
	e nativeSchema: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit population schema' stamp: 'apl 3/22/2006 12:26'!
acceptExternalRepresentation: e 
	super acceptExternalRepresentation: e.
	e fastSetRecords: nil.! !

!PlatypusMetaDataDestroyer methodsFor: 'visit dictionary schema' stamp: 'AlainPlantec 5/13/2012 08:34'!
acceptExternalSchema: e 
! !

!PlatypusMetaDataDestroyer methodsFor: 'visit dictionary schema' stamp: 'apl 3/22/2006 11:53'!
acceptFunctionDeclaration: e 
	super acceptFunctionDeclaration: e. 
	e returnType: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit dictionary schema' stamp: 'apl 3/22/2006 11:52'!
acceptGeneralAggregateType: e 
	super acceptGeneralAggregateType: e.
	e elementType: nil.! !

!PlatypusMetaDataDestroyer methodsFor: 'visit population schema' stamp: 'AlainPlantec 5/13/2012 01:59'!
acceptGenericInstance: e 
	super acceptGenericInstance: e.
	e instanceScope: nil.! !

!PlatypusMetaDataDestroyer methodsFor: 'visit dictionary schema' stamp: 'apl 3/22/2006 11:54'!
acceptGlobalRule: e 
	super acceptGlobalRule: e. 
	e fastSetForEntities: nil.
	e fastSetWhereRules: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit expressions schema' stamp: 'apl 3/22/2006 11:30'!
acceptIdentifier: e 
	e ref: nil.
	e parameters acceptTry: self.
	e fastSetParameters: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit statements schema' stamp: 'apl 3/22/2006 12:21'!
acceptIfStatement: e 
	super acceptIfStatement: e.
	e selector: nil.
	e fastSetThenStatements: nil.
	e fastSetElseStatements: nil.! !

!PlatypusMetaDataDestroyer methodsFor: 'visit dictionary schema' stamp: 'AlainPlantec 5/13/2012 08:35'!
acceptIncludeSchema: e 
	e fastSetExplicitlyImportedItems: nil.
	e fastSetImplicitlyImportedItems: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit statements schema' stamp: 'apl 3/22/2006 12:22'!
acceptIncrementControl: e 
	super acceptIncrementControl: e .
	e variable: nil.
	e first: nil.
	e last: nil.
	e step: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit population schema' stamp: 'apl 3/22/2006 12:28'!
acceptInstanceScope: e 
	super acceptInstanceScope: e.
	e owned: nil.
	e fastSetExportList: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit dictionary schema' stamp: 'apl 3/22/2006 11:54'!
acceptIntegerType: e 
	super acceptIntegerType: e.
	e precision: nil. ! !

!PlatypusMetaDataDestroyer methodsFor: 'visit population schema' stamp: 'apl 3/22/2006 12:28'!
acceptInternalRepresentation: e 
	super acceptInternalRepresentation: e.
	e fastSetParameters: nil ! !

!PlatypusMetaDataDestroyer methodsFor: 'visit expressions schema' stamp: 'apl 3/22/2006 11:30'!
acceptInterval: e 
	super acceptInterval: e. 
	e expr: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit dictionary schema' stamp: 'apl 3/22/2006 11:55'!
acceptInverseAttribute: e 
	super acceptInverseAttribute: e.
	e invertedAttr: nil.
	e minCardinality: nil.
	e maxCardinality: nil.
	e redeclaring: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit dictionary schema' stamp: 'apl 3/22/2006 11:55'!
acceptListType: e 
	super acceptListType: e .
	e elementType: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit expressions schema' stamp: 'apl 3/22/2006 11:31'!
acceptLiteral: e 
	e val: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit dictionary schema' stamp: 'apl 3/22/2006 11:56'!
acceptLocalVariable: e 
	super acceptLocalVariable: e.
	e domain: nil.
	e initializer: nil.
 ! !

!PlatypusMetaDataDestroyer methodsFor: 'visit dictionary schema' stamp: 'apl 3/22/2006 11:57'!
acceptMetaConceptDefinition: e 
	super acceptMetaConceptDefinition: e.
	e metaExpression acceptTry: self.
	e metaExpression: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit dictionary schema' stamp: 'apl 9/19/2007 10:05'!
acceptMetaMappingDefinition: e 
	super acceptMetaMappingDefinition: e.
	e definition: nil.
	e metaExpression acceptTry: self.
	e metaExpression: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit dictionary schema' stamp: 'MrCleaner 1/20/2011 21:16'!
acceptMetaMappingRule: e 
	super acceptMetaMappingRule: e.
	e metaExpression acceptTry: self.
	e metaExpression: nil.
	e metaCondition acceptTry: self.
	e metaCondition: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit environment schema' stamp: 'AlainPlantec 5/20/2012 11:05'!
acceptModelContents: e 
	self modelContents: e.
	e dataInstances
		do: [:v | v acceptTry: self].
	e headerInstances: nil.
	e dataInstances: nil.
	e dataInstancesByLabelIndex: nil.
	e entitiesByInstanceIndex: nil.
	e dataInstancesByEntityIndex: nil.
	e positionByDataInstanceIndex: nil.
	e owner: nil.
! !

!PlatypusMetaDataDestroyer methodsFor: 'visit dictionary schema' stamp: 'apl 12/20/2006 11:03'!
acceptNamedType: e 
	super acceptNamedType: e.
	e removeMetaConcept.
	e owner: nil.
	e identifiersCache: nil.
	e setWhereRules: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit dictionary schema' stamp: 'apl 3/22/2006 11:57'!
acceptNamedTypeReference: e 
	e setRef: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit dictionary schema' stamp: 'apl 3/22/2006 11:59'!
acceptNativeAlgorithm: e 
	super acceptNativeAlgorithm: e.
	e fastSetImplementations: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit dictionary schema' stamp: 'apl 3/22/2006 12:00'!
acceptNativeCode: e 
	e code: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit expressions schema' stamp: 'apl 3/22/2006 11:31'!
acceptNativeExpression: e 
	super acceptNativeExpression: e .
	e source: nil.! !

!PlatypusMetaDataDestroyer methodsFor: 'visit statements schema' stamp: 'apl 3/22/2006 12:23'!
acceptNativeStatement: e 
	super acceptNativeStatement: e.
	e source: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit dictionary schema' stamp: 'apl 3/22/2006 12:00'!
acceptOneofSupertypeExpression: e 
	super acceptOneofSupertypeExpression: e.
	e fastSetExprList: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit statements schema' stamp: 'apl 3/22/2006 12:23'!
acceptOutputStatement: e 
	super acceptOutputStatement: e .
	e output: nil.! !

!PlatypusMetaDataDestroyer methodsFor: 'visit dictionary schema' stamp: 'apl 3/22/2006 12:01'!
acceptParameterDefinition: e 
	super acceptParameterDefinition: e.
	e domain: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit dictionary schema' stamp: 'apl 3/22/2006 12:01'!
acceptPopulationDependentBound: e
	super  acceptPopulationDependentBound: e.
	e boundValue: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit statements schema' stamp: 'apl 3/22/2006 12:23'!
acceptProcedureCallStatement: e 
	super acceptProcedureCallStatement: e.
	e call: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit dictionary schema' stamp: 'apl 3/22/2006 12:01'!
acceptProcedureDeclaration: e 
	super acceptProcedureDeclaration: e ! !

!PlatypusMetaDataDestroyer methodsFor: 'visit expressions schema' stamp: 'apl 3/22/2006 11:32'!
acceptQualifiedExpression: e 
	super acceptQualifiedExpression: e. 
	e head: nil.
	e fastSetQualifiers: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit expressions schema' stamp: 'apl 3/22/2006 11:32'!
acceptQueryExpression: e 
	super acceptQueryExpression: e. 
	e variable: nil.
	e aggregateSource: nil.
	e suchThat: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit expressions schema' stamp: 'apl 3/22/2006 11:33'!
acceptRangeQualifier: e 
	super acceptRangeQualifier: e.
	e index1: nil.
	e index2: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit dictionary schema' stamp: 'apl 3/22/2006 12:02'!
acceptRealType: e 
	super acceptRealType: e.
	e precision: nil ! !

!PlatypusMetaDataDestroyer methodsFor: 'visit dictionary schema' stamp: 'apl 3/31/2006 22:34'!
acceptRemarkReference: e 
	e inside acceptTry: self.
	e remark acceptTry: self.
	e inside: nil.
	e remark: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit statements schema' stamp: 'apl 3/22/2006 12:24'!
acceptRepeatStatement: e 
	super acceptRepeatStatement: e.
	e incrControl: nil.
	e untilControl: nil.
	e whileControl: nil.
	e fastSetStatements: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit statements schema' stamp: 'apl 3/22/2006 12:24'!
acceptReturnStatement: e 
	super acceptReturnStatement: e.
	e returned: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit dictionary schema' stamp: 'apl 3/22/2006 12:07'!
acceptSchemaDefinition: e
	super acceptSchemaDefinition: e.
	e interface: nil.
	e fastSetGlobalRules: nil.
	e fastSetRemarkReferences: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit environment schema' stamp: 'AlainPlantec 5/20/2012 09:24'!
acceptSchemaInstance: e 
	e internalSchemata acceptTry: self.
	e fastSetSchemata: nil.
	e associatedModels acceptTry: self.
	e fastSetAssociatedModels: nil.
	e removeTamarisItemReferencesIndex.
	e removeMetaConceptsIndex! !

!PlatypusMetaDataDestroyer methodsFor: 'visit dictionary schema' stamp: 'apl 3/22/2006 12:08'!
acceptSelectType: e
	super  acceptSelectType: e.
	e fastSetSelections: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit dictionary schema' stamp: 'apl 3/22/2006 12:09'!
acceptSetType: e 
	super acceptSetType: e.
	e elementType: nil.
! !

!PlatypusMetaDataDestroyer methodsFor: 'visit population schema' stamp: 'apl 3/22/2006 12:28'!
acceptSimpleRecord: e 
	super acceptSimpleRecord: e.
	e fastSetParameters: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit expressions schema' stamp: 'apl 3/22/2006 11:33'!
acceptSimpleUnaryExpression: e 
	super acceptSimpleUnaryExpression: e.
	e expr: nil.! !

!PlatypusMetaDataDestroyer methodsFor: 'visit statements schema' stamp: 'apl 3/22/2006 12:25'!
acceptSplitmarkStatement: e 
	e filename: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit dictionary schema' stamp: 'apl 3/22/2006 12:09'!
acceptStatementsContainer: e 
	super acceptStatementsContainer: e.
	e fastSetLocals: nil.
	e fastSetStatements: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit dictionary schema' stamp: 'apl 3/22/2006 12:10'!
acceptStringType: e 
	super acceptStringType: e.
	e width: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit dictionary schema' stamp: 'apl 3/22/2006 12:12'!
acceptSubEntityRefExpression: e 
super acceptSubEntityRefExpression: e. 
	e entityRef: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit dictionary schema' stamp: 'apl 3/22/2006 12:13'!
acceptSupertypeConstraint: e 
	super acceptSupertypeConstraint: e.
	e constrained: nil.
	e expr: nil.
! !

!PlatypusMetaDataDestroyer methodsFor: 'visit expressions schema' stamp: 'apl 3/22/2006 11:34'!
acceptTypedExpression: e 
	super acceptTypedExpression: e.
	e expr: nil.! !

!PlatypusMetaDataDestroyer methodsFor: 'visit dictionary schema' stamp: 'apl 3/22/2006 12:14'!
acceptUniquenessRule: e
	super  acceptUniquenessRule: e.
	e fastSetAttributes: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'visit dictionary schema' stamp: 'AlainPlantec 5/5/2012 22:37'!
acceptUnresolvedSymbol: e! !

!PlatypusMetaDataDestroyer methodsFor: 'visit population schema' stamp: 'apl 3/22/2006 12:29'!
acceptUserDefinedApplicationInstance: e 
	super acceptUserDefinedApplicationInstance: e.
	e fastSetParameters: nil.! !

!PlatypusMetaDataDestroyer methodsFor: 'visit population schema' stamp: 'apl 3/22/2006 12:29'!
acceptUserDefinedHeaderInstance: e
	super  acceptUserDefinedHeaderInstance: e.
	e fastSetParameters: nil.! !

!PlatypusMetaDataDestroyer methodsFor: 'visit dictionary schema' stamp: 'apl 3/22/2006 12:14'!
acceptWhereRule: e 
	super acceptWhereRule: e.
	e whereValue: nil! !

!PlatypusMetaDataDestroyer methodsFor: 'accessing' stamp: 'AlainPlantec 5/5/2012 00:26'!
modelContents: anObject
	modelContents := anObject! !

PlatypusStepOnePassAbstractVisitor subclass: #PlatypusMetaRepositoryBuilder
	instanceVariableNames: 'stepRepo modelContents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-visitors'!

!PlatypusMetaRepositoryBuilder class methodsFor: 'repository building' stamp: 'AlainPlantec 10/7/2010 15:56'!
build: aStepRepository with: aMetaData 
	| builder |
	builder := self new stepRepo: aStepRepository.
	builder acceptTry: aMetaData.
	^ builder! !

!PlatypusMetaRepositoryBuilder methodsFor: 'visit dictionary schema' stamp: 'apl 5/28/2004 11:26'!
acceptContextDefinition: e 
	super acceptContextDefinition: e.
	e owner acceptTry: self! !

!PlatypusMetaRepositoryBuilder methodsFor: 'visit dictionary schema' stamp: 'apl 3/18/2006 10:24'!
acceptEntityDefinition: e 
	e owner acceptTry: self.
	super acceptEntityDefinition: e! !

!PlatypusMetaRepositoryBuilder methodsFor: 'visit dictionary schema' stamp: 'apl 3/24/2007 13:46'!
acceptExternalMetaSchema: e 
	^ super acceptExternalMetaSchema: e! !

!PlatypusMetaRepositoryBuilder methodsFor: 'visit dictionary schema' stamp: 'apl 3/25/2006 10:32'!
acceptExternalSchema: e 
	! !

!PlatypusMetaRepositoryBuilder methodsFor: 'visit dictionary schema' stamp: 'apl 3/24/2007 09:50'!
acceptIncludeSchema: e 
	e nativeSchema acceptTry: self.
	super acceptIncludeSchema: e! !

!PlatypusMetaRepositoryBuilder methodsFor: 'visit population schema' stamp: 'apl 10/25/2007 11:24'!
acceptInternalRepresentation: e 
	super acceptInternalRepresentation: e.
	e definition acceptTry: self! !

!PlatypusMetaRepositoryBuilder methodsFor: 'visit dictionary schema' stamp: 'apl 3/11/2005 09:29'!
acceptInverseAttribute: e 
	e domain acceptTry: self.
	^ super acceptInverseAttribute: e! !

!PlatypusMetaRepositoryBuilder methodsFor: 'visit dictionary schema' stamp: 'apl 2/24/2006 11:50'!
acceptLocalVariable: e 
	super acceptLocalVariable: e.
	e owner
		ifNotNil: [e owner acceptTry: self]! !

!PlatypusMetaRepositoryBuilder methodsFor: 'visit dictionary schema' stamp: 'apl 2/24/2006 11:50'!
acceptParameterDefinition: e 
	super acceptParameterDefinition: e.
	e owner ifNotNil: [e owner  acceptTry: self]! !

!PlatypusMetaRepositoryBuilder methodsFor: 'visit dictionary schema' stamp: 'apl 10/3/2006 01:31'!
acceptRemarkReference: e 
	super acceptRemarkReference: e.
	e inside acceptTry: self.
	e referenced acceptTry: self! !

!PlatypusMetaRepositoryBuilder methodsFor: 'visit dictionary schema' stamp: 'apl 3/24/2006 22:59'!
acceptSchemaDefinition: e 
	super acceptSchemaDefinition: e! !

!PlatypusMetaRepositoryBuilder methodsFor: 'visit environment schema' stamp: 'AlainPlantec 5/5/2012 09:10'!
acceptSchemaInstance: e
	e dataSchemata acceptTry: self.
	e metaConceptsIndex acceptTry: self.
	e associatedModels acceptTry: self! !

!PlatypusMetaRepositoryBuilder methodsFor: 'visit population schema' stamp: 'apl 5/29/2004 17:09'!
acceptSimpleRecord: e 
	super acceptSimpleRecord: e.
	e definition acceptTry: self! !

!PlatypusMetaRepositoryBuilder methodsFor: 'visit generic' stamp: 'apl 7/26/2004 19:11'!
acceptTry: anObject 
	stepRepo registerInstance: anObject.
	^ super acceptTry: anObject! !

!PlatypusMetaRepositoryBuilder methodsFor: 'accessing' stamp: 'AlainPlantec 5/4/2012 21:58'!
modelContents
	^ modelContents! !

!PlatypusMetaRepositoryBuilder methodsFor: 'accessing' stamp: 'AlainPlantec 5/4/2012 21:58'!
modelContents: aModelContents
	modelContents := aModelContents! !

!PlatypusMetaRepositoryBuilder methodsFor: 'accessing' stamp: 'apl 11/3/2003 17:27'!
stepRepo: anObject
	stepRepo := anObject! !

PlatypusStepOnePassAbstractVisitor subclass: #PlatypusModelContentsP28XmlWriter
	instanceVariableNames: 'outStream p21Syntax tokenClassifier modelContents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-visitors'!

!PlatypusModelContentsP28XmlWriter methodsFor: 'visit aggregate data schema' stamp: 'apl 3/17/2006 09:50'!
acceptAggregateData: e 
	self nextPut: $(.
	self halt.
	e contents acceptTry: self 
		separatedBy: [self nextPut: $,].
	self nextPut: $)! !

!PlatypusModelContentsP28XmlWriter methodsFor: 'visit aggregate data schema' stamp: 'apl 3/17/2006 09:50'!
acceptAggregateInstance: e 
	self nextPut: $(.
	e contents acceptTry: self 
		separatedBy: [self nextPut: $,].
	self nextPut: $)! !

!PlatypusModelContentsP28XmlWriter methodsFor: 'accessing' stamp: 'apl 3/17/2006 09:50'!
acceptAllParameters: parameters definition: definition fromSimpleRecord: fromSimpleRecord 
	| pos attributes attr |
	(p21Syntax
			or: [definition isNil])
		ifTrue: ["visitPath first persistentLabel = '7' 
			ifTrue: [self halt]."
			parameters acceptTry: self 
				separatedBy: [self nextPut: $,]]
		ifFalse: [pos := 1.
			attributes := fromSimpleRecord
						ifTrue: [definition explicitAttributes]
						ifFalse: [definition inheritedExplicitAttributes].
			parameters
				ifNotEmpty: [:arg | 
					outStream nextPut: Character cr.
					parameters
						do: [:param | pos <= attributes size
								ifTrue: [attr := attributes at: pos.
									outStream nextPut: Character tab.
									fromSimpleRecord
										ifTrue: [outStream nextPut: Character tab].
									self
										doSimpleTagNamed: attr name
										while: [outStream
												withStyleFor: PlatypusKeywordToken
												do: [outStream nextPutAll: attr name]].
									pos := pos + 1]]
						separatedBy: [outStream nextPut: Character cr].
					outStream nextPut: Character cr]]! !

!PlatypusModelContentsP28XmlWriter methodsFor: 'visit expressions schema' stamp: 'apl 3/24/2005 14:52'!
acceptEConstant: e 
	self nextPutAll: 'E' ! !

!PlatypusModelContentsP28XmlWriter methodsFor: 'visit population schema' stamp: 'apl 6/10/2005 11:20'!
acceptEntityDefinitionReference: e 
	e ref ifNil: 
			[outStream withStyleFor: PlatypusUnresolvedReferenceToken
				do: [outStream nextPutAll: e name asUppercase]]
		ifNotNil: 
			[outStream withStyleFor: PlatypusPrimaryElementOpenKeywordToken
				do: [outStream nextPutAll: e ref name asUppercase]]! !

!PlatypusModelContentsP28XmlWriter methodsFor: 'visit expressions schema' stamp: 'apl 3/24/2005 14:52'!
acceptEnumerationValue: e 
	self nextPutAll: '.', e element asUppercase, '.'.
! !

!PlatypusModelContentsP28XmlWriter methodsFor: 'visit population schema' stamp: 'apl 3/24/2005 14:52'!
acceptExternalGroupRepresentation: e 
 	self acceptExternalInstance: e! !

!PlatypusModelContentsP28XmlWriter methodsFor: 'visit population schema' stamp: 'apl 3/17/2006 09:51'!
acceptExternalInstance: e 
	self acceptGenericInstance: e.
	self nextPutAll: '('.
	e records size > 1
		ifTrue: [self nextPutAll: String cr , String tab].
	e records acceptTry: self 
		separatedBy: [self nextPutAll: String cr , String tab].
	e records size > 1
		ifTrue: [self nextPutAll: String cr].
	self nextPutAll: ');'! !

!PlatypusModelContentsP28XmlWriter methodsFor: 'visit population schema' stamp: 'apl 3/24/2005 14:52'!
acceptExternalRepresentation: e 
	self acceptExternalInstance: e! !

!PlatypusModelContentsP28XmlWriter methodsFor: 'visit expressions schema' stamp: 'apl 3/24/2005 14:52'!
acceptFalseConstant: e 
	self nextPutAll: '.F.'! !

!PlatypusModelContentsP28XmlWriter methodsFor: 'visit population schema' stamp: 'apl 3/24/2005 14:52'!
acceptFileDescription: e 
	self nextPutAll: 'FILE_DESCRIPTION(('.
	e description
		do: [:desc | self nextPutAllString: desc]
		separatedBy: [self nextPut: $,].
	self nextPutAll: '),'.
	self nextPutAllString: e implementationLevel.
	self nextPutAll: ');'.! !

!PlatypusModelContentsP28XmlWriter methodsFor: 'visit population schema' stamp: 'apl 3/24/2005 14:52'!
acceptFileName: e 
	self nextPutAll: 'FILE_NAME('.
	self nextPutAllString: e name.
	self nextPutAll: ','.
	self nextPutAllString: e timeStamp.
	self nextPutAll: ',('.
	e author
		do: [:a | self nextPutAllString: a]
		separatedBy: [self nextPut: $,].
	self nextPutAll: '),('.
	e organization
		do: [:a | self nextPutAllString: a]
		separatedBy: [self nextPut: $,].
	self nextPutAll: '),'.
	self nextPutAllString: e preprocessorVersion.
	self nextPutAll: ','.
	self nextPutAllString: e originatingSystem.
	self nextPutAll: ','.
	self nextPutAllString: e authorisation.
	self nextPutAll: ');'! !

!PlatypusModelContentsP28XmlWriter methodsFor: 'visit population schema' stamp: 'apl 3/24/2005 14:52'!
acceptFileSchema: e 
	self nextPutAll: 'FILE_SCHEMA(('.
	e schemaIdentifiers
		do: [:a | self nextPutAllString: a]
		separatedBy: [self nextPut: $,].
	self nextPutAll: '));'! !

!PlatypusModelContentsP28XmlWriter methodsFor: 'visit population schema' stamp: 'AlainPlantec 5/13/2012 01:58'!
acceptGenericInstance: e 
	outStream withStyleFor: PlatypusDelimToken
		do: 
			[outStream nextPut: $#.
			outStream nextPutAll: e persistentLabel asString].
	self nextPut: $=.
	e instanceScope ifNotNil: [e instanceScope acceptTry: self]! !

!PlatypusModelContentsP28XmlWriter methodsFor: 'visit population schema' stamp: 'apl 3/17/2006 09:51'!
acceptInstanceScope: e 
	self nextPutAll: '&SCOPE\' withCRs.
	e owned
		acceptTry: self
		separatedBy: [self nextPut: Character cr].
	self nextPutAll: '\END_SCOPE' withCRs.
	e exportList size > 0
		ifTrue: [self nextPutAll: ' /'.
			e exportList acceptTry: self 
				separatedBy: [self nextPutAll: ','].
			self nextPutAll: '/\' withCRs]
		ifFalse: [self nextPut: Character cr]! !

!PlatypusModelContentsP28XmlWriter methodsFor: 'visit expressions schema' stamp: 'apl 3/24/2005 14:52'!
acceptIntegerLiteral: e 
	self nextPutAll: e val printString! !

!PlatypusModelContentsP28XmlWriter methodsFor: 'visit population schema' stamp: 'apl 3/24/2005 14:52'!
acceptInternalGroupRepresentation: e 
	self acceptInternalInstance: e! !

!PlatypusModelContentsP28XmlWriter methodsFor: 'visit population schema' stamp: 'AlainPlantec 6/3/2012 20:53'!
acceptInternalInstance: e 
	self acceptGenericInstance: e.
	self acceptTry: e definition.
	self nextPut: $(.
	self
		acceptAllParameters: e parameters copy
		definition: e definition referenced
		fromSimpleRecord: false.
	self nextPutAll: ');'! !

!PlatypusModelContentsP28XmlWriter methodsFor: 'visit population schema' stamp: 'apl 3/24/2005 14:52'!
acceptInternalRepresentation: e 
	self acceptInternalInstance: e 
! !

!PlatypusModelContentsP28XmlWriter methodsFor: 'visit expressions schema' stamp: 'apl 3/24/2005 14:52'!
acceptMissingValue: e 
	self nextPut: $$! !

!PlatypusModelContentsP28XmlWriter methodsFor: 'visit expressions schema' stamp: 'apl 3/24/2005 14:52'!
acceptPiConstant: e 
	self nextPutAll: 'PI'! !

!PlatypusModelContentsP28XmlWriter methodsFor: 'visit expressions schema' stamp: 'apl 3/24/2005 14:52'!
acceptRealLiteral: e 
	self nextPutAll: e val printString! !

!PlatypusModelContentsP28XmlWriter methodsFor: 'visit expressions schema' stamp: 'apl 3/24/2005 14:52'!
acceptRedefinedAttributeValue: e 
	self nextPut: $*! !

!PlatypusModelContentsP28XmlWriter methodsFor: 'visit population schema' stamp: 'AlainPlantec 6/3/2012 20:53'!
acceptSimpleRecord: e 
	self acceptTry: e definition.
	(p21Syntax not
			and: [e definitionOk])
		ifTrue: [outStream nextPut: Character tab].
	self nextPut: $(.
	self
		acceptAllParameters: e parameters copy
		definition: e definition referenced
		fromSimpleRecord: true.
	(p21Syntax not
			and: [e definitionOk])
		ifTrue: [outStream nextPut: Character tab].
	self nextPut: $)! !

!PlatypusModelContentsP28XmlWriter methodsFor: 'visit expressions schema' stamp: 'apl 3/24/2005 14:52'!
acceptStringLiteral: e 
	self nextPutAllString: e asClearText! !

!PlatypusModelContentsP28XmlWriter methodsFor: 'visit expressions schema' stamp: 'apl 3/24/2005 14:52'!
acceptTrueConstant: e 
	self nextPutAll: '.T.'! !

!PlatypusModelContentsP28XmlWriter methodsFor: 'visit expressions schema' stamp: 'apl 3/24/2005 14:52'!
acceptTypedExpression: e 
	e domain
		ifNotNil: [self nextPutAll: e domain name asUppercase;
				 nextPut: $(].
	e expr acceptTry: self.
	e domain
		ifNotNil: [self nextPut: $)]! !

!PlatypusModelContentsP28XmlWriter methodsFor: 'visit expressions schema' stamp: 'apl 3/24/2005 14:52'!
acceptUnknownConstant: e 
	self nextPutAll: '.U.'! !

!PlatypusModelContentsP28XmlWriter methodsFor: 'visit population schema' stamp: 'apl 3/17/2006 09:51'!
acceptUserDefinedApplicationInstance: e 
	self nextPut: $#;
		 nextPutAll: e persistentLabel;
		 nextPut: $!!;
		 nextPutAll: e name;
		 nextPut: $(.
	e parameters acceptTry: self 
		separatedBy: [self nextPut: $,].
	self nextPutAll: ');'! !

!PlatypusModelContentsP28XmlWriter methodsFor: 'visit population schema' stamp: 'apl 3/17/2006 09:51'!
acceptUserDefinedHeaderInstance: e 
	self nextPutAll: e name;
		 nextPut: $(.
	e parameters acceptTry: self 
		separatedBy: [self nextPut: $,].
	self nextPutAll: ');'! !

!PlatypusModelContentsP28XmlWriter methodsFor: 'accessing' stamp: 'apl 5/20/2005 19:04'!
doSimpleTagNamed: tagName while: aBlock 
	outStream nextPutAll: '<'.
	outStream withStyleFor: PlatypusKeywordToken
		do: [outStream nextPutAll: tagName].
	outStream nextPutAll: '>'.
	aBlock value.
	outStream nextPutAll: '</'.
	outStream withStyleFor: PlatypusKeywordToken
		do: [outStream nextPutAll: tagName].
	outStream nextPutAll: '>'! !

!PlatypusModelContentsP28XmlWriter methodsFor: 'initialize/release' stamp: 'apl 5/20/2005 21:49'!
initialize
	super initialize.
	p21Syntax := true.
	tokenClassifier := PlatypusExpressTokenClassifier new! !

!PlatypusModelContentsP28XmlWriter methodsFor: 'accessing' stamp: 'apl 3/24/2005 14:52'!
modelContents
	^modelContents! !

!PlatypusModelContentsP28XmlWriter methodsFor: 'accessing' stamp: 'apl 3/24/2005 14:52'!
modelContents: anObject
	modelContents := anObject! !

!PlatypusModelContentsP28XmlWriter methodsFor: 'accessing' stamp: 'AlainPlantec 10/7/2010 15:57'!
nextPut: aCharacter
	| tokenClass |
	tokenClass := tokenClassifier tokenClassFromCharacter: aCharacter
	ifAbsent: [].
	outStream withStyleFor: tokenClass do: [outStream nextPut: aCharacter]! !

!PlatypusModelContentsP28XmlWriter methodsFor: 'accessing' stamp: 'AlainPlantec 10/7/2010 15:57'!
nextPutAll: aString 
	| tokenClass |
	tokenClass := tokenClassifier
				tokenClassFromString: aString
				ifAbsent: [].
	outStream
		withStyleFor: tokenClass
		do: [outStream nextPutAll: aString]! !

!PlatypusModelContentsP28XmlWriter methodsFor: 'visit generic' stamp: 'apl 3/24/2005 14:52'!
nextPutAllString: aString 
	self nextPutAll: ''''
			, (aString copyReplaceAll: '''' with: '''''') , ''''! !

!PlatypusModelContentsP28XmlWriter methodsFor: 'accessing' stamp: 'apl 3/24/2005 14:52'!
outStream
	^outStream! !

!PlatypusModelContentsP28XmlWriter methodsFor: 'accessing' stamp: 'apl 3/24/2005 14:52'!
outStream: anObject
	outStream := anObject! !

!PlatypusModelContentsP28XmlWriter methodsFor: 'accessing' stamp: 'apl 3/17/2006 09:52'!
stream: anOutputStream modelContents: aModelContents p21Syntax: useP21Syntax 
	| hinstances instances dateTime |
	self modelContents: aModelContents.
	p21Syntax := useP21Syntax.
	hinstances := modelContents headerInstances.
	instances := modelContents dataInstances.
	Cursor write
		showWhile: [outStream := anOutputStream.
			outStream
				withStyleFor: PlatypusDelimToken
				do: [outStream nextPutAll: 'ISO-10303-21;\HEADER;\' withCRs].
			hinstances
						acceptTry: self
						separatedBy: [outStream nextPut: Character cr].
			(hinstances isNil
					or: [(hinstances
							anySatisfy: [:hi | hi isPltFileName]) not])
				ifTrue: [dateTime := Time dateAndTimeNow.
					self nextPutAll: String cr , 'FILE_NAME(''<name>'', ''' , dateTime first yyyymmdd asString , ' ' , dateTime second asString , ''', (''<author>''), (''<organisation>''), ''<preprocessor version>'', ''<originating system>'', ''<authorization>'');'].
			(hinstances isNil
					or: [(hinstances
							anySatisfy: [:hi | hi isPltFileSchema]) not])
				ifTrue: [self nextPutAll: String cr , 'FILE_SCHEMA(('.
					self modelContents owner schemata
						do: [:sch | self nextPutAllString: sch name]
						separatedBy: [outStream nextPut: $,].
					outStream nextPutAll: '));'].
			(hinstances isNil
					or: [(hinstances
							anySatisfy: [:hi | hi isPltFileDescription]) not])
				ifTrue: [self nextPutAll: String cr , 'FILE_DESCRIPTION((''<description1>'', ''<description 2>''), ''<implementation level>''); '].
			outStream
				withStyleFor: PlatypusDelimToken
				do: [outStream nextPutAll: '\ENDSEC;\DATA;\' withCRs].
			instances acceptTry: self 
						separatedBy: [outStream nextPut: Character cr].
					outStream nextPut: Character cr.
			outStream
				withStyleFor: PlatypusDelimToken
				do: [outStream nextPutAll: 'ENDSEC;\END-ISO-10303-21;\' withCRs]]! !

!PlatypusModelContentsP28XmlWriter methodsFor: 'accessing' stamp: 'apl 3/17/2006 09:52'!
stream: anOutputStream modelContents: aModelContents values: values p21Syntax: useP21Syntax 
	self modelContents: aModelContents.
	outStream := anOutputStream.
	p21Syntax := useP21Syntax.
	Cursor write
		showWhile: [values acceptTry: self 
				separatedBy: [outStream nextPut: Character cr]]! !

PlatypusStepOnePassAbstractVisitor subclass: #PlatypusModelContentsVisitor
	instanceVariableNames: 'modelContents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-visitors'!

PlatypusModelContentsVisitor subclass: #PlatypusModelContentsChecker
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-visitors'!

PlatypusModelContentsChecker subclass: #PlatypusModelContentsResolver
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-visitors'!

!PlatypusModelContentsResolver methodsFor: 'visit dictionary schema' stamp: 'apl 12/13/2005 11:35'!
acceptDefinedTypeReference: e 
	| found |
	e setRef: (found := self modelContents lookUpNamedTypeBN: e name).
	found
		ifNil: [self declareWithError: e]
		ifNotNil: [self declareWithoutError: e]! !

!PlatypusModelContentsResolver methodsFor: 'visit dictionary schema' stamp: 'AlainPlantec 5/14/2012 22:56'!
acceptEntityDefinitionReference: e 
	| found chosen |
	e setRef: (found := self modelContents lookUpEntityDefinitionBN: e name).
	found
		ifNil: [(chosen := self interactivelyResolvedSchemaOwningEntityNamed: e name) isNil
				ifFalse: [self schemaInstance tamarisItemRef insertLinkReferenceFrom: chosen].
			e setRef: (found := self modelContents lookUpEntityDefinitionBN: e name).
			found
				ifNil: [self declareWithError: e]]
		ifNotNil: [self declareWithoutError: e]! !

!PlatypusModelContentsResolver methodsFor: 'visit dictionary schema' stamp: 'AlainPlantec 5/16/2012 15:16'!
acceptEntityInstanceReference: e 
	| found |
	e
		ref: (found := self instanceLabelled: e persistentLabel).
	found
		ifNil: [self declareWithError: e]
		ifNotNil: [self declareWithoutError: e]! !

!PlatypusModelContentsResolver methodsFor: 'visit population schema' stamp: 'apl 12/13/2005 11:23'!
acceptEnumerationValue: e 
	super acceptEnumerationValue: e! !

!PlatypusModelContentsResolver methodsFor: 'visit population schema' stamp: 'AlainPlantec 5/23/2012 23:44'!
acceptInternalRepresentation: e 
	e definition acceptTry: self.
	(e definition isPltEntityDefinitionReference
			and: [e definition ref notNil])
		ifTrue: [e definition: e definition ref referenceOnSelf].
	super acceptInternalRepresentation: e! !

!PlatypusModelContentsResolver methodsFor: 'visit environment schema' stamp: 'AlainPlantec 5/4/2012 21:43'!
acceptModelContents: e 
	self modelContents: e.
	e dataInstances
		do: [:v | v acceptTry: self]
! !

!PlatypusModelContentsResolver methodsFor: 'visit population schema' stamp: 'apl 4/7/2006 09:40'!
acceptSimpleRecord: e 
	e definition acceptTry: self.
	(e definition isPltEntityDefinitionReference
			and: [e definition ref notNil])
		ifTrue: [e definition: e definition ref referenceOnSelf].
	super acceptSimpleRecord: e! !

!PlatypusModelContentsResolver methodsFor: 'visit generic' stamp: 'apl 2/6/2006 17:37'!
acceptTry: e 
	e isPltExpression ifTrue: [e removeCachedDomain].
	^ super acceptTry: e! !

!PlatypusModelContentsResolver methodsFor: 'accessing' stamp: 'AlainPlantec 6/14/2012 01:05'!
checks: aMetaData 
	aMetaData acceptTry: self.
	self objectsWithErrorIndex do: [:k | 
		self registerError: (PlatypusModelContentsResolverError metaData: k message:  'unresolved symbol')].
! !

!PlatypusModelContentsResolver methodsFor: 'accessing' stamp: 'AlainPlantec 5/16/2012 15:15'!
instanceLabelled:  persistentLabel 
	^ modelContents instanceLabelled: persistentLabel! !

!PlatypusModelContentsResolver methodsFor: 'visit generic' stamp: 'AlainPlantec 6/15/2012 13:01'!
interactivelyResolvedSchemaOwningEntityNamed: aName 
	| found |
	^ PlatypusSchemaInstanceReference
		interactivelyResolvedSchemaSatisfying: [:r | 
			(found := (r metaData lookUpNamedTypeBN: aName)) notNil 
				and: [found schemaDefinition isNil or: [r metaData = found schemaDefinition]]]
		message: '''' , aName , ''' is inside ?'! !

PlatypusModelContentsChecker subclass: #PlatypusModelContentsSemanticChecker
	instanceVariableNames: 'currInstance domainStack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-visitors'!

!PlatypusModelContentsSemanticChecker methodsFor: 'visit expressions schema' stamp: 'AlainPlantec 6/14/2012 00:36'!
acceptExpression: e 
	| valueDomain declaredDomain |
	e computedDomain
		ifNil: [
			self
				registerError: (PlatypusModelContentsSemanticCheckerError metaData: e message: 'invalid value')]
		ifNotNil: [((valueDomain := e computedDomain) isAssignableTo: (declaredDomain := domainStack top key computedDomain))
				ifFalse: [
					declaredDomain 
						ifNil: [
							self registerError: (PlatypusModelContentsSemanticCheckerError metaData: e  message: 'invalid value, ' , domainStack top value , ': unresolved domain')]
						ifNotNil: [
							self registerError: (PlatypusModelContentsSemanticCheckerError metaData: e  message: 'incompatible value, ' , domainStack top value , ': declared domain: ' , declaredDomain errorQualifier , '; found domain: ' , valueDomain errorQualifier)]]]! !

!PlatypusModelContentsSemanticChecker methodsFor: 'visit population schema' stamp: 'apl 3/17/2006 09:33'!
acceptExternalRepresentation: e 
	e records acceptTry: self! !

!PlatypusModelContentsSemanticChecker methodsFor: 'visit population schema' stamp: 'AlainPlantec 6/14/2012 00:37'!
acceptInternalRepresentation: e 
	| entityDef |
	currInstance := e.
	(entityDef := e definition referenced)
		ifNotNil: [e definition referenced instantiable
				ifFalse: [self
						registerError: (PlatypusModelContentsSemanticCheckerError metaData: e message: 'entity ''' , e definition name , ''' is not instanciable (abstract entity)')]].
	self
		checksValues: e parameters
		attributesAccessor: #inheritedExplicitAttributesDo:
		numberOfAttributes: entityDef numberOfInheritedExplicitAttributes! !

!PlatypusModelContentsSemanticChecker methodsFor: 'visit population schema' stamp: 'apl 3/20/2006 19:21'!
acceptModelContents: e 
	super acceptModelContents: e! !

!PlatypusModelContentsSemanticChecker methodsFor: 'visit population schema' stamp: 'apl 3/20/2006 21:39'!
acceptSimpleRecord: e 
	| entityDef |
	currInstance := e.
	entityDef := e definition referenced.
	self
		checksValues: e parameters
		attributesAccessor: #explicitAttributesDo:
		numberOfAttributes: entityDef numberOfExplicitAttributes! !

!PlatypusModelContentsSemanticChecker methodsFor: 'visit population schema' stamp: 'apl 11/11/2003 15:29'!
acceptUserDefinedApplicationInstance: e 
! !

!PlatypusModelContentsSemanticChecker methodsFor: 'visit population schema' stamp: 'apl 11/11/2003 15:29'!
acceptUserDefinedHeaderInstance: e 
! !

!PlatypusModelContentsSemanticChecker methodsFor: 'visit generic' stamp: 'AlainPlantec 6/14/2012 13:50'!
checksValues: aListOfExpressions attributesAccessor: accessorSymbol numberOfAttributes: numberOfAttributes 
	| pos value esize |
	(esize := aListOfExpressions size) ~= numberOfAttributes
		ifTrue: [self
				registerError: (PlatypusModelContentsSemanticCheckerError
					metaData: visitPath last
					message: 'entity ''' , currInstance definition name , ''' have ' , esize printString , ' values and must have ' , numberOfAttributes printString)]
		ifFalse: [pos := 1.
			currInstance definition ref
				perform: accessorSymbol
				with: [:attr | 
					(value := aListOfExpressions at: pos) isPltMissingValue
						ifTrue: [value isPltRedefinedAttributeValue
								ifFalse: [attr optionalFlag
										ifFalse: [self
												registerError: (PlatypusModelContentsSemanticCheckerError 
													metaData: visitPath top
													message: 'entity ''' , currInstance definition name , ''' mandatory attribute with missing value')]]]
						ifFalse: [domainStack push: attr domain -> ('attribute ''' , attr name , '''').
							[self acceptTry: value]
								ensure: [domainStack pop]].
					pos := pos + 1]]! !

!PlatypusModelContentsSemanticChecker methodsFor: 'initialize/release' stamp: 'apl 7/23/2004 02:26'!
initialize
	domainStack := PlatypusStack new.
	super initialize! !

!PlatypusModelContentsSemanticChecker methodsFor: 'visit generic' stamp: 'apl 4/22/2006 23:12'!
lookUpAndCacheAcceptSelectorOfClass: aClass 
	| currClass selector str |
	currClass := aClass.
	str := WriteStream on: (String new: 50).
	[currClass ~~ Object]
		whileTrue: [str nextPutAll: 'accept'.
			str
				next: currClass name size - 3
				putAll: currClass name
				startingAt: 4.
			str nextPut: $:.
			selector := str contents asSymbol.
			(self class includesSelector: selector)
				ifTrue: [self acceptSelectorsMap at: aClass put: selector.
					^ selector].
			str reset.
			currClass := currClass superclass].
	^ self error: 'unimplemented accept method for class ''' , aClass name , ''''! !

PlatypusModelContentsVisitor subclass: #PlatypusModelContentsRecorder
	instanceVariableNames: 'checkingPass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-visitors'!

!PlatypusModelContentsRecorder methodsFor: 'visit population schema' stamp: 'AlainPlantec 5/11/2012 19:21'!
acceptApplicationInstance: e 
	checkingPass = #recording
		ifTrue: [(e persistentLabel isNil or: [e persistentLabel isEmpty])
			ifTrue: [modelContents add: e]]! !

!PlatypusModelContentsRecorder methodsFor: 'visit population schema' stamp: 'AlainPlantec 5/11/2012 16:43'!
acceptEntityInstanceReference: e 
	(e persistentLabel isNil or: [e persistentLabel isEmpty])
		ifTrue: [checkingPass = #referencing
			ifTrue: [(e ref notNil and: [e ref persistentLabel notNil and: [e ref persistentLabel notEmpty]])
				ifTrue: [e persistentLabel: e ref persistentLabel]]
		ifFalse: [e ref acceptTry: self]]! !

!PlatypusModelContentsRecorder methodsFor: 'visit population schema' stamp: 'apl 3/20/2006 16:21'!
acceptExternalRepresentation: e 
	self acceptApplicationInstance: e.
	super acceptExternalRepresentation: e 
! !

!PlatypusModelContentsRecorder methodsFor: 'visit population schema' stamp: 'apl 3/20/2006 16:21'!
acceptInternalRepresentation: e 
	self acceptApplicationInstance: e.
	super acceptInternalRepresentation: e ! !

!PlatypusModelContentsRecorder methodsFor: 'accessing' stamp: 'AlainPlantec 5/23/2012 22:51'!
checks: aMetaData 
	checkingPass := #recording.
	super checks: aMetaData.
	checkingPass := #referencing.
	super checks: modelContents! !

!PlatypusModelContentsRecorder methodsFor: 'accessing' stamp: 'apl 3/12/2007 14:03'!
checksAll: aMetaDataCollection
	checkingPass := #recording.
	aMetaDataCollection do: [:el | super checks: el].
	checkingPass := #referencing.
	super checks: modelContents! !

!PlatypusModelContentsRecorder methodsFor: 'initialize-release' stamp: 'apl 3/20/2006 16:10'!
initialize
	super initialize.
	checkingPass := #recording! !

!PlatypusModelContentsVisitor class methodsFor: 'checking' stamp: 'AlainPlantec 5/23/2012 22:36'!
checks: metaData 
	^ self
		checks: metaData
		owners: metaData ownerPath
! !

!PlatypusModelContentsVisitor class methodsFor: 'checking' stamp: 'AlainPlantec 5/23/2012 22:36'!
checks: metaData owners: ownerPath 
	| checker |
	checker := self new visitContexts: ownerPath.
	^ checker checks: metaData! !

!PlatypusModelContentsVisitor class methodsFor: 'instance creation' stamp: 'AlainPlantec 5/23/2012 22:36'!
modelContents: aModelContents
	^ self new modelContents: aModelContents
	! !

!PlatypusModelContentsVisitor methodsFor: 'accessing' stamp: 'AlainPlantec 5/23/2012 22:36'!
checks: data 
	data acceptTry: self.
! !

!PlatypusModelContentsVisitor methodsFor: 'accessing' stamp: 'AlainPlantec 5/23/2012 22:36'!
modelContents
	^ modelContents! !

!PlatypusModelContentsVisitor methodsFor: 'accessing' stamp: 'AlainPlantec 5/23/2012 22:36'!
modelContents: aModelContents
	modelContents := aModelContents! !

PlatypusStepOnePassAbstractVisitor subclass: #PlatypusStepChecker
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-visitors'!

PlatypusStepChecker subclass: #PlatypusDataChecker
	instanceVariableNames: 'value attribute aggr aggrType aggrPos instanceOid platypusRepository errors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-visitors'!

!PlatypusDataChecker class methodsFor: 'checking' stamp: 'apl 3/11/2005 13:42'!
checksValue: aValue attribute: anAttribute instanceOid: anInteger repository: aPlatypusRepository 
	| errors instance |
	errors := self new
				checksValue: aValue
				attribute: anAttribute
				instanceOid: anInteger
				repository: aPlatypusRepository.
	^ errors
		collect: [:err | 
			instance := aPlatypusRepository instanceAt: anInteger.
			self errorClass
				error: '#' , anInteger asString , '=' , instance class name , ': ' , err message
				oid: anInteger
				repository: aPlatypusRepository]! !

!PlatypusDataChecker class methodsFor: 'checking' stamp: 'apl 3/11/2005 13:42'!
checksValue: aValue elementType: aMetaData aggrType: anAggrType aggrPos: aPosition attribute: anAttribute instanceOid: anInteger repository: aPlatypusRepository
	^ self new
		checksValue: aValue
		elementType: aMetaData
		aggrType: anAggrType
		aggrPos: aPosition
		attribute: anAttribute
		instanceOid: anInteger
		repository: aPlatypusRepository! !

!PlatypusDataChecker class methodsFor: 'accessing' stamp: 'AlainPlantec 7/14/2011 16:56'!
errorClass
	^ PlatypusPharoSmalltalk at: #PlatypusStepCheckerError! !

!PlatypusDataChecker methodsFor: 'visit dictionary schema' stamp: 'AlainPlantec 7/14/2011 16:56'!
acceptAggregationType: e 
	| pos tmpErrors cls |
	cls := PlatypusPharoSmalltalk at: (self smalltalkTypeOf: e) asSymbol.
	value isCollection
		ifTrue: [(value isKindOf: cls)
				ifFalse: [self valueIsA: value class insteadOf: cls].
			pos := 1.
			value
				do: [:elem | 
					tmpErrors := self class
								checksValue: elem
								elementType: e elementType
								aggrType: e
								aggrPos: pos
								attribute: attribute
								instanceOid: instanceOid
								repository: platypusRepository.
					tmpErrors
						ifNotEmpty: [:suberrs | 
							tmpErrors := tmpErrors
										collect: [:err | self errorClass
												error: self errorHeading , err message
												oid: instanceOid
												repository: platypusRepository].
							errors addAll: tmpErrors]]
				separatedBy: [pos := pos + 1]]
		ifFalse: [self valueIsA: value class insteadOf: cls]! !

!PlatypusDataChecker methodsFor: 'visit dictionary schema' stamp: 'apl 2/26/2005 01:14'!
acceptArrayType: e 
	self acceptAggregationType: e! !

!PlatypusDataChecker methodsFor: 'visit dictionary schema' stamp: 'apl 2/26/2005 01:14'!
acceptBagType: e 
	self acceptAggregationType: e! !

!PlatypusDataChecker methodsFor: 'visit dictionary schema' stamp: 'apl 2/26/2005 01:28'!
acceptBinaryType: e 
	self acceptSimpleType: e! !

!PlatypusDataChecker methodsFor: 'visit dictionary schema' stamp: 'apl 2/26/2005 01:28'!
acceptBooleanType: e 
	self acceptSimpleType: e! !

!PlatypusDataChecker methodsFor: 'visit dictionary schema' stamp: 'apl 2/24/2005 22:31'!
acceptDefinedType: e 
	^ self acceptTry: e domain! !

!PlatypusDataChecker methodsFor: 'visit dictionary schema' stamp: 'apl 2/24/2005 23:11'!
acceptDictionaryInstanceReference: e 
	^ self acceptTry: e referenced! !

!PlatypusDataChecker methodsFor: 'visit dictionary schema' stamp: 'apl 3/14/2005 20:43'!
acceptEntityDefinition: e 
	| cls |
	cls := platypusRepository metaDataSchemaInstance classFromEntityName: e name.
	(value isKindOf: cls)
		ifFalse: [self valueIsA: value class insteadOf: cls]! !

!PlatypusDataChecker methodsFor: 'visit dictionary schema' stamp: 'apl 4/7/2006 19:07'!
acceptEntityDefinitionReference: e 
	| cls |
	cls := platypusRepository metaDataSchemaInstance classFromEntityName: e name.
	(value  isKindOf: cls)
		ifFalse: [self valueIsA: value class insteadOf: cls]! !

!PlatypusDataChecker methodsFor: 'visit dictionary schema' stamp: 'apl 2/26/2005 01:30'!
acceptEnumerationType: e 
	(value isKindOf: Symbol)
		ifTrue: [((e elements
					collect: [:el | el asUppercase])
					includes: value asUppercase)
				ifFalse: [self enumerationValueOutOfDomain: e]]
		ifFalse: [self valueIsA: value class insteadOf: Symbol]! !

!PlatypusDataChecker methodsFor: 'visit dictionary schema' stamp: 'apl 2/25/2005 08:39'!
acceptExplicitAttribute: e 
	^ self acceptTry: e domain! !

!PlatypusDataChecker methodsFor: 'visit dictionary schema' stamp: 'apl 2/26/2005 01:28'!
acceptIntegerType: e 
	self acceptSimpleType:e! !

!PlatypusDataChecker methodsFor: 'visit dictionary schema' stamp: 'apl 2/26/2005 01:14'!
acceptListType: e 
	self acceptAggregationType: e ! !

!PlatypusDataChecker methodsFor: 'visit dictionary schema' stamp: 'apl 2/26/2005 01:28'!
acceptLogicalType: e 
	self acceptSimpleType: e! !

!PlatypusDataChecker methodsFor: 'visit dictionary schema' stamp: 'apl 2/25/2005 10:47'!
acceptNamedTypeReference: e 
	^ self acceptTry: e referenced! !

!PlatypusDataChecker methodsFor: 'visit dictionary schema' stamp: 'apl 2/26/2005 01:28'!
acceptRealType: e 
	self acceptSimpleType: e! !

!PlatypusDataChecker methodsFor: 'visit dictionary schema' stamp: 'apl 3/11/2005 13:44'!
acceptSelectType: e 
	e selections
		do: [:sel | (self class
				checksValue: value
				elementType: sel referenced
				aggrType: aggrType
				aggrPos: aggrPos
				attribute: attribute
				instanceOid: instanceOid
				repository: platypusRepository)
				ifEmpty: [^ #()]].
	self selectValueOutOfDomain: e! !

!PlatypusDataChecker methodsFor: 'visit dictionary schema' stamp: 'apl 2/26/2005 01:14'!
acceptSetType: e 
	self acceptAggregationType: e! !

!PlatypusDataChecker methodsFor: 'visit dictionary schema' stamp: 'AlainPlantec 7/14/2011 16:56'!
acceptSimpleType: e 
	| cls |
	cls := PlatypusPharoSmalltalk at: (self smalltalkTypeOf: e) asSymbol.
	(value isKindOf: cls)
		ifFalse: [self valueIsA: value class insteadOf: cls]! !

!PlatypusDataChecker methodsFor: 'visit dictionary schema' stamp: 'apl 2/26/2005 01:28'!
acceptStringType: e 
	self acceptSimpleType: e! !

!PlatypusDataChecker methodsFor: 'accessing' stamp: 'apl 2/25/2005 22:19'!
acceptTry: e 
	"Transcript show: e class name , String cr."
	value isNil
		ifTrue: [self checksMissingValue]
		ifFalse: [^ super acceptTry: e]! !

!PlatypusDataChecker methodsFor: 'accessing' stamp: 'apl 2/25/2005 14:49'!
aggrPos
	^aggrPos! !

!PlatypusDataChecker methodsFor: 'accessing' stamp: 'apl 2/25/2005 22:21'!
aggrType
	^aggrType! !

!PlatypusDataChecker methodsFor: 'checking' stamp: 'apl 2/25/2005 22:18'!
checksMissingValue
	aggr
		ifNil: [attribute optionalFlag
				ifFalse: [self valueShouldNotBeMissing]]
		ifNotNil: [aggr elementsAreOptional
				ifFalse: [self valueShouldNotBeMissing]]! !

!PlatypusDataChecker methodsFor: 'checking' stamp: 'apl 3/11/2005 13:43'!
checksValue: aValue attribute: anAttribute instanceOid: anInteger repository: aPlatypusRepository
	value := aValue.
	attribute := anAttribute.
	instanceOid := anInteger.
	platypusRepository :=  aPlatypusRepository.
	self acceptTry: anAttribute.
	^ errors! !

!PlatypusDataChecker methodsFor: 'checking' stamp: 'apl 3/11/2005 13:43'!
checksValue: aValue elementType: aMetaData aggrType: anAggrType aggrPos: aPosition attribute: anAttribute instanceOid: anInteger repository: aPlatypusRepository 
	value := aValue.
	aggrPos := aPosition.
	instanceOid := anInteger.
	attribute := anAttribute.
	platypusRepository :=  aPlatypusRepository.
	aggrType := anAggrType.
	self acceptTry: aMetaData.
	^ errors! !

!PlatypusDataChecker methodsFor: 'error handling' stamp: 'apl 3/11/2005 13:54'!
enumerationValueOutOfDomain: enumerationType 
	| elements |
	elements := String new.
	enumerationType elements
		do: [:el | elements := elements , '#' , el asUppercase]
		separatedBy: [elements := elements , ' '].
	errors
		add: (self errorClass
				error: self errorHeading , 'is #' , value , ' but should be one of (' , elements , ')'
				oid: instanceOid
				repository: platypusRepository)! !

!PlatypusDataChecker methodsFor: 'accessing' stamp: 'apl 2/24/2005 23:31'!
errorClass
	^ self class errorClass! !

!PlatypusDataChecker methodsFor: 'error handling' stamp: 'apl 2/25/2005 19:38'!
errorHeading
	| start |
	aggrPos
		ifNil: [start := 'attribute ' , attribute name , ' ']
		ifNotNil: [start := 'value at: #' , aggrPos asString , ' '].
	^ start! !

!PlatypusDataChecker methodsFor: 'initialize/release' stamp: 'apl 2/25/2005 14:54'!
initialize
	super initialize.
	errors := OrderedCollection new! !

!PlatypusDataChecker methodsFor: 'meta data accessing' stamp: 'apl 3/11/2005 14:08'!
metaDataSchemaInstance
	^ platypusRepository metaDataSchemaInstance ! !

!PlatypusDataChecker methodsFor: 'error handling' stamp: 'apl 3/11/2005 14:09'!
selectValueOutOfDomain: selectType 
	| elements cls |
	elements := String new.
	selectType selections
		do: [:el | 
			cls := (self smalltalkTypeOf: el referenced) asSymbol.
			elements := elements , cls]
		separatedBy: [elements := elements , ' '].
	errors
		add: (self errorClass
				error: self errorHeading , 'is a' , value class name , ' but should be in selections (' , elements , ')'
				oid: instanceOid
				repository: platypusRepository)! !

!PlatypusDataChecker methodsFor: 'meta data accessing' stamp: 'apl 3/11/2005 14:09'!
smalltalkTypeOf: anObject 
	^ self metaDataSchemaInstance smalltalkTypeOf: anObject! !

!PlatypusDataChecker methodsFor: 'error handling' stamp: 'apl 3/11/2005 13:54'!
valueIsA: valClass insteadOf: goodClass 
	errors
		add: (self errorClass
				error: self errorHeading , 'is a ' , valClass name , ' but should be a ' , goodClass name
				oid: instanceOid
				repository: platypusRepository)! !

!PlatypusDataChecker methodsFor: 'error handling' stamp: 'apl 3/11/2005 13:54'!
valueShouldNotBeMissing
	errors
		add: (self errorClass
				error: self errorHeading , 'is mandatory but is missing'
				oid: instanceOid
				repository: platypusRepository)! !

PlatypusStepChecker subclass: #PlatypusExpressChecker
	instanceVariableNames: 'schemaInstance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-visitors'!

!PlatypusExpressChecker class methodsFor: 'checking' stamp: 'apl 6/22/2004 18:29'!
checks: metaData 
	^ self
		checks: metaData
		owners: metaData ownerPath
! !

!PlatypusExpressChecker class methodsFor: 'checking' stamp: 'apl 3/20/2006 11:10'!
checks: metaData owners: ownerPath 
	| checker |
	checker := self new visitContexts: ownerPath.
	^ checker checks: metaData! !

!PlatypusExpressChecker methodsFor: 'visit dictionary schema' stamp: 'apl 12/13/2005 11:59'!
acceptDefinedTypeReference: e 
	^ self acceptNamedTypeReference: e! !

!PlatypusExpressChecker methodsFor: 'visit dictionary schema' stamp: 'apl 7/20/2004 10:48'!
acceptEntityDefinitionReference: e 
	^ self acceptNamedTypeReference: e! !

PlatypusExpressChecker subclass: #PlatypusExpressNamesChecker
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-visitors'!

!PlatypusExpressNamesChecker methodsFor: 'visit dictionary schema' stamp: 'AlainPlantec 6/14/2012 00:31'!
acceptContextDefinition: e 
	super acceptContextDefinition: e.
	e namedTypesCache
		keysAndValuesDo: [:k :l | l size > 1
				ifTrue: [l
						do: [:m | self
								registerError: (PlatypusExpressNamesCheckerError metaData: m message: ' multiply defined ')]]].
	e identifiersCache
		keysAndValuesDo: [:k :l | l size > 1
				ifTrue: [(l
							allSatisfy: [:el | el isPltEnumerationValue])
						ifFalse: [l
								do: [:m | self
										registerError: (PlatypusExpressNamesCheckerError metaData: m  message: ' multiply defined ')]]]]! !

!PlatypusExpressNamesChecker methodsFor: 'visit dictionary schema' stamp: 'apl 6/18/2004 17:59'!
acceptSchemaDefinition: e 
		self logInfo: 'schema ' , e name.
		super acceptSchemaDefinition: e! !

!PlatypusExpressNamesChecker methodsFor: 'visit environment schema' stamp: 'AlainPlantec 6/14/2012 00:33'!
acceptSchemaInstance: e 
	| index m |
	index := Dictionary new.
	e schemata
		do: [:sch | 
			m := sch linkedMetaData.
			m isNil ifFalse: [
				index at: m key ifAbsentPut: OrderedCollection new.
				(index at: m key) add: m]].
	index keysAndValuesDo: [:k :l | 
		l size > 1
			ifTrue: [
				self 
					registerError: (PlatypusExpressNamesCheckerError metaData: k message: 'several schemata with the same name ''' , l first key , '''')]].
	e internalSchemata acceptTry: self! !

!PlatypusExpressNamesChecker methodsFor: 'visit generic' stamp: 'AlainPlantec 5/19/2012 23:18'!
checks: aMetaData 
	self logInfo: 'NAMES CHECKING'.
	aMetaData acceptTry: self.
	self logInfo: 'NAMES CHECKING DONE'! !

PlatypusExpressChecker subclass: #PlatypusExpressResolver
	instanceVariableNames: 'resolutionPass parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-visitors'!

!PlatypusExpressResolver methodsFor: 'visit generic' stamp: 'apl 4/29/2008 12:17'!
acceptAggregationType: e lower: l upper: u symbol: subtype flags: aCollection 
	super
		acceptAggregationType: e
		lower: l
		upper: u
		symbol: subtype
		flags: aCollection.
	self acceptTry: e elementType.
	e elementType
		ifNotNil: [(e elementType isPltNamedTypeReference
					and: [e elementType ref notNil])
				ifTrue: [e elementType: e elementType ref referenceOnSelf]]! !

!PlatypusExpressResolver methodsFor: 'visit expressions schema' stamp: 'AlainPlantec 5/20/2012 01:03'!
acceptAssignable: e
	e head acceptTry: self.
	e qualifiers acceptTry: self! !

!PlatypusExpressResolver methodsFor: 'visit dictionary schema' stamp: 'apl 4/7/2006 09:32'!
acceptAttribute: e 
	e redeclaring
		ifNotNil: [self acceptTry: e redeclaring].
	(e domain isPltNamedTypeReference and: [e domain ref notNil]) ifTrue: [e domain: e domain ref referenceOnSelf]! !

!PlatypusExpressResolver methodsFor: 'visit dictionary schema' stamp: 'AlainPlantec 5/23/2012 14:00'!
acceptAttributeReference: e 
	| inversedEntity invKey invertedAttr |
	e entityRef acceptTry: self.
	resolutionPass = 1
		ifTrue: [
			e ref: nil.
			self declareWithError: e].
	e entityRef ref
		ifNil: [self declareWithError: e]
		ifNotNil: [
			e ref
				ifNil: [self declareWithError: e.
					inversedEntity := e entityRef ref.
					invKey := e name asUppercase.
					invertedAttr := inversedEntity inheritedAttributesReverseDetect: [:attr | attr name asUppercase = invKey].
					e ref: invertedAttr.
					invertedAttr notNil
						ifTrue: [self declareWithoutError: e]]]! !

!PlatypusExpressResolver methodsFor: 'visit dictionary schema' stamp: 'apl 4/29/2008 12:15'!
acceptConstantDefinition: e 
	super acceptConstantDefinition: e.
	e domain
		ifNotNil: [(e domain isPltNamedTypeReference
					and: [e domain ref notNil])
				ifTrue: [e domain: e domain ref referenceOnSelf]].
	e metaConcept acceptTry: self! !

!PlatypusExpressResolver methodsFor: 'visit dictionary schema' stamp: 'AlainPlantec 5/19/2012 22:59'!
acceptDefinedType: e 
	super acceptDefinedType: e.
	e metaConcept acceptTry: self.
	e domain
		ifNotNil: [(e domain isPltNamedTypeReference
					and: [e domain ref notNil])
				ifTrue: [e domain: e domain ref referenceOnSelf]]! !

!PlatypusExpressResolver methodsFor: 'visit dictionary schema' stamp: 'apl 1/25/2007 11:43'!
acceptDerivedAttribute: e 
	self acceptAttribute: e.
	super acceptDerivedAttribute: e.
! !

!PlatypusExpressResolver methodsFor: 'visit dictionary schema' stamp: 'AlainPlantec 5/23/2012 13:59'!
acceptDictionaryInstanceReference: e 
	| found |
	resolutionPass = 1
		ifTrue: [
			e setRef: nil.
			self declareWithError: e].
	e ref ifNil: [
		(found := self lookUpIdentifierBN: e name) ifNil: [found := self lookUpNamedTypeBN: e name].
		e setRef: found.
		found
			ifNil: [self declareWithError: e]
			ifNotNil: [self declareWithoutError: e]]! !

!PlatypusExpressResolver methodsFor: 'visit dictionary schema' stamp: 'AlainPlantec 6/13/2012 23:29'!
acceptDomainEquivalentItem: e 
! !

!PlatypusExpressResolver methodsFor: 'visit dictionary schema' stamp: 'AlainPlantec 5/19/2012 22:59'!
acceptEntityDefinition: e 
	| sup |
	self logInfo: '	', e class name , ': ' , e name.
	super acceptEntityDefinition: e.
	resolutionPass = 1 
		ifTrue: [e destroySubtypes]
		ifFalse: 
			[1 to: e supertypes size
				do: 
					[:pos | 
					sup := e supertypes at: pos.
					sup isPltEntityDefinitionReference 
						ifFalse: 
							[sup ref ifNotNil: 
									[sup ref isPltEntityDefinition 
										ifTrue: [e supertypes at: pos put: sup ref referenceOnSelf]
										ifFalse: 
											[sup ref: nil.
											self declareWithError: sup]]]].
			e updateSupertypes].
	e metaConcept acceptTry: self! !

!PlatypusExpressResolver methodsFor: 'visit expressions schema' stamp: 'AlainPlantec 6/24/2010 11:43'!
acceptEntityInstancesSet: e 
	
	^ self acceptTry: e entityRef! !

!PlatypusExpressResolver methodsFor: 'visit expressions schema' stamp: 'AlainPlantec 6/14/2012 01:00'!
acceptEscapedExpression: e 
	| resolver |
	self parent
		ifNil: [super acceptEscapedExpression: e]
		ifNotNil: [
			e acceptTry: (resolver := self parent copy). 
			resolver objectsWithErrorIndex addAll: self objectsWithErrorIndex]
! !

!PlatypusExpressResolver methodsFor: 'visit dictionary schema' stamp: 'apl 1/25/2007 11:43'!
acceptExplicitAttribute: e 
	self acceptAttribute: e.
	super acceptExplicitAttribute: e.
! !

!PlatypusExpressResolver methodsFor: 'visit dictionary schema' stamp: 'AlainPlantec 10/19/2010 01:27'!
acceptExternalMetaSchema: e
	self acceptExternalSchema: e! !

!PlatypusExpressResolver methodsFor: 'visit dictionary schema' stamp: 'AlainPlantec 6/15/2012 12:41'!
acceptExternalSchema: e 
	| chosen |
	resolutionPass = 1
		ifTrue: [
			e nativeSchema: nil.
			self declareWithError: e].
	e nativeSchema: (e schemaInstance lookUpSchemaDefinitionBN: e name).
	e nativeSchema ifNil: [
		(chosen := self interactivelyResolvedSchemaNamed: e name) isNil
			ifFalse: [
				self schemaInstance tamarisItemRef
					ifNotNil: [:tamRef | 
						tamRef insertLinkReferenceFrom: chosen.
						e nativeSchema: (e schemaInstance lookUpSchemaDefinitionBN: e name)].
						e nativeSchema ifNil: [^ self declareWithError: e]]].! !

!PlatypusExpressResolver methodsFor: 'visit dictionary schema' stamp: 'apl 4/29/2008 12:16'!
acceptFunctionDeclaration: e 
	super acceptFunctionDeclaration: e.
	e returnType
		ifNotNil: [(e returnType isPltNamedTypeReference
					and: [e returnType ref notNil])
				ifTrue: [e returnType: e returnType ref referenceOnSelf]].
	e metaConcept acceptTry: self! !

!PlatypusExpressResolver methodsFor: 'visit dictionary schema' stamp: 'apl 3/29/2006 17:39'!
acceptGlobalRule: e 
	super acceptGlobalRule: e.
	e metaConcept acceptTry: self! !

!PlatypusExpressResolver methodsFor: 'visit expressions schema' stamp: 'AlainPlantec 5/20/2012 01:11'!
acceptIdentifier: e 
	| found |
	resolutionPass = 1
		ifTrue: [
			e setRef: nil.
			self declareWithError: e]
		ifFalse: [
			e ref ifNil: [
				e parameters
					ifNil: [(found := self lookUpIdentifierBN: e name) ifNil: [found := self lookUpNamedTypeBN: e name]]
					ifNotNil: [found := self lookUpFunctionCallOrConstructorNamed: e name].
			e setRef: found.
			found
				ifNil: [self declareWithError: e]
				ifNotNil: [
					((found isPltFunctionDeclaration or: [found isPltEntityDefinition]) and: [e parameters isNil])
						ifTrue: [e parameters: #()].
					self declareWithoutError: e]]].
	e parameters acceptTry: self! !

!PlatypusExpressResolver methodsFor: 'visit dictionary schema' stamp: 'AlainPlantec 5/13/2012 09:15'!
acceptIncludeSchema: e
	self acceptExternalSchema: e 
! !

!PlatypusExpressResolver methodsFor: 'visit population schema' stamp: 'AlainPlantec 6/14/2012 14:47'!
acceptInternalRepresentation: e 
	^ e definition acceptTry: self.
! !

!PlatypusExpressResolver methodsFor: 'visit dictionary schema' stamp: 'apl 1/25/2007 11:43'!
acceptInverseAttribute: e 
	self acceptTry: e invertedAttr.
	self acceptAttribute: e.
	self acceptTry: e domain.
	super acceptInverseAttribute: e.
! !

!PlatypusExpressResolver methodsFor: 'visit dictionary schema' stamp: 'apl 4/29/2008 12:17'!
acceptLocalVariable: e 
	super acceptLocalVariable: e.
	e domain
		ifNotNil: [(e domain isPltNamedTypeReference
					and: [e domain ref notNil])
				ifTrue: [e domain: e domain ref referenceOnSelf]]! !

!PlatypusExpressResolver methodsFor: 'visit dictionary schema' stamp: 'AlainPlantec 6/14/2012 01:03'!
acceptMetaConceptDefinition: e 
	| result metaResolContext |
	resolutionPass = 1
		ifTrue: [self declareWithError: e]
		ifFalse: [ | resolver | 
				e haveError
				ifTrue: [metaResolContext := OrderedCollection new.
					metaResolContext addAll: self schemaInstance metaSchemata asArray.
					metaResolContext add: e definition class platypusMetaData.			
					resolver := self new visitContexts: metaResolContext parent: self.
					result := resolver checks: e metaExpression.
					result haveError
						ifTrue: [
							self declareWithError: e.
							e updateExpression.
							self objectsWithErrorIndex addAll: result objectsWithErrorIndex]
						ifFalse: [e haveError: false]]]! !

!PlatypusExpressResolver methodsFor: 'visit dictionary schema' stamp: 'AlainPlantec 6/14/2012 01:03'!
acceptMetaMappingDefinition: e 
	| result metaResolContext |
	resolutionPass = 1
		ifTrue: [
			self declareWithError: e.
			e haveError: true]
		ifFalse: [
			e haveError
				ifTrue: [
					e definition: (self lookUpPath: e definitionPath).
					e definition isNil
						ifTrue: [self declareWithError: e]
						ifFalse: [ | resolver |
							metaResolContext := OrderedCollection new.
							metaResolContext addAll: self schemaInstance metaSchemata asArray.
							metaResolContext add: e definition class platypusMetaData.
							resolver := PlatypusExpressResolver new visitContexts: metaResolContext parent: self.
							result := resolver checks: e metaExpression.
							result haveError
								ifTrue: [
									e updateExpression.
									self objectsWithErrorIndex addAll: result objectsWithErrorIndex]
								ifFalse: [e haveError: false]]]]! !

!PlatypusExpressResolver methodsFor: 'visit dictionary schema' stamp: 'AlainPlantec 6/14/2012 01:04'!
acceptMetaMappingRule: e 
	| result metaResolContext |
	resolutionPass = 1
		ifTrue: [self declareWithError: e.
			e haveError: true]
		ifFalse: [e haveError
				ifTrue: [ | resolver |
					metaResolContext := OrderedCollection new.
					metaResolContext addAll: self schemaInstance metaSchemata asArray.
					resolver := PlatypusExpressResolver new visitContexts: metaResolContext parent: self.
					result := resolver checks: e metaExpression.
					result haveError
						ifTrue: [
							e updateExpression.
							self objectsWithErrorIndex addAll: result objectsWithErrorIndex]
						ifFalse: [e haveError: false].
					result := resolver checks: e metaCondition.
					result haveError
						ifTrue: [
							e haveError: true.
							e updateCondition.
							self objectsWithErrorIndex addAll: result objectsWithErrorIndex]
						ifFalse: [e haveError: false]]]! !

!PlatypusExpressResolver methodsFor: 'visit environment schema' stamp: 'AlainPlantec 5/23/2012 13:54'!
acceptModelContents: e
! !

!PlatypusExpressResolver methodsFor: 'visit dictionary schema' stamp: 'AlainPlantec 6/14/2012 00:58'!
acceptNamedTypeReference: e 
	| found |
	resolutionPass = 1
		ifTrue: [
			e setRef: nil.
			self declareWithError: e].
	(found := e ref) ifNil: [e setRef: (found := self lookUpNamedTypeBN: e name).
	found
		ifNil: [self declareWithError: e]
		ifNotNil: [self declareWithoutError: e]]! !

!PlatypusExpressResolver methodsFor: 'visit dictionary schema' stamp: 'apl 4/29/2008 12:16'!
acceptParameterDefinition: e 
	super acceptParameterDefinition: e.
	e domain
		ifNotNil: [(e domain isPltNamedTypeReference
					and: [e domain ref notNil])
				ifTrue: [e domain: e domain ref referenceOnSelf]]! !

!PlatypusExpressResolver methodsFor: 'visit dictionary schema' stamp: 'apl 3/29/2006 17:41'!
acceptProcedureDeclaration: e 
	super acceptProcedureDeclaration: e.
	e metaConcept acceptTry: self! !

!PlatypusExpressResolver methodsFor: 'visit expressions schema' stamp: 'apl 3/15/2007 10:35'!
acceptQualifiedExpression: e 
	| qual enumVal refed |
	e head referenced ~= e head
		ifTrue: [e head ref: nil].
	super acceptQualifiedExpression: e.
	e head referenced
		ifNil: [e head
				ref: (self lookUpNamedTypeBN: e head name).
			e head referenced
				ifNil: [self declareWithError: e head]
				ifNotNil: [self declareWithoutError: e head]].
	((refed := e head referenced) notNil
			and: [refed isPltDefinedType
					and: [e qualifiers size = 1]])
		ifTrue: [qual := e qualifiers first.
			qual isPltEnumerationValue
				ifFalse: [self declareWithError: qual.
					(refed hasEnumerationElementNamed: qual name)
						ifTrue: [enumVal := PltEnumerationValue
										domain: (PltDefinedTypeReference ref: refed)
										element: qual name.

							self declareWithoutError: qual.
							e qualifiers at: 1 put: enumVal]]].
	(e head isPltNamedTypeReference
			and: [e head ref notNil])
		ifTrue: [e head: e domain ref referenceOnSelf]! !

!PlatypusExpressResolver methodsFor: 'visit expressions schema' stamp: 'AlainPlantec 1/28/2011 12:04'!
acceptQueryExpression: e 
	super acceptQueryExpression: e! !

!PlatypusExpressResolver methodsFor: 'visit dictionary schema' stamp: 'apl 9/19/2007 08:56'!
acceptRemarkReference: e 
	| refed prefRefed |
	super acceptRemarkReference: e.
	e inside name asUppercase = e prefix asUppercase
		ifTrue: [e suffix
				ifNil: [refed := e inside referenced]
				ifNotNil: [(refed := self lookUp: e suffix from: e inside referenced)
						ifNil: [refed := self lookUp: e suffix from: e inside referenced owner]]]
		ifFalse: [(prefRefed := (self lookUp: e prefix from: e inside referenced)
						ifNil: [self lookUp: e prefix from: e inside referenced owner])
				ifNotNil: [e suffix
						ifNil: [refed := prefRefed]
						ifNotNil: [refed := self lookUp: e suffix from: prefRefed]]].
	refed
		ifNil: [self declareWithError: e]
		ifNotNil: [self declareWithoutError: e.
			e referenced: PltDictionaryInstanceReference new.
			e referenced name: refed name.
			e referenced ref: refed]! !

!PlatypusExpressResolver methodsFor: 'visit dictionary schema' stamp: 'AlainPlantec 6/14/2012 02:06'!
acceptSchemaDefinition: e
	self logInfo: 'schema ' , e name.
	super acceptSchemaDefinition: e.
	e metaConcept acceptTry: self! !

!PlatypusExpressResolver methodsFor: 'visit environment schema' stamp: 'AlainPlantec 5/23/2012 13:56'!
acceptSchemaInstance: e 
	resolutionPass <= 1
		ifTrue: [
			e internalSchemata
				do: [:sch | sch rebuildLocalCaches]].
	e internalSchemata
		do: [:sch | 
			sch dataInterface
				do: [:int | 
					int implicitlyImportedItems: OrderedCollection new.
					self acceptTry: int]].
	e internalSchemata acceptTry: self.
! !

!PlatypusExpressResolver methodsFor: 'visit dictionary schema' stamp: 'apl 4/7/2006 10:12'!
acceptSelectType: e 
	| sel |
	super acceptSelectType: e.
	1
		to: e selections size
		do: [:pos | 
			sel := e selections at: pos.
			(sel  isPltNamedTypeReference
					and: [sel ref notNil])
				ifTrue: [e selections at: pos put: sel ref referenceOnSelf]]! !

!PlatypusExpressResolver methodsFor: 'visit expressions schema' stamp: 'apl 3/20/2006 18:53'!
acceptSelfIdentifier: e 
! !

!PlatypusExpressResolver methodsFor: 'visit population schema' stamp: 'apl 6/18/2004 15:32'!
acceptSimpleRecord: e 
	^ e definition acceptTry: self.
! !

!PlatypusExpressResolver methodsFor: 'visit dictionary schema' stamp: 'apl 4/19/2006 13:31'!
acceptSubEntityRefExpression: e 
	super acceptSubEntityRefExpression: e.
	(e entityRef notNil
			and: [e entityRef isPltNamedTypeReference
			and: [e entityRef ref notNil]])
		ifTrue: [e entityRef: e entityRef ref referenceOnSelf]! !

!PlatypusExpressResolver methodsFor: 'visit generic' stamp: 'AlainPlantec 6/13/2012 23:39'!
acceptTry: e
	e removeCachedDomain.
	^ super acceptTry: e! !

!PlatypusExpressResolver methodsFor: 'visit expressions schema' stamp: 'apl 4/2/2006 22:01'!
acceptUniquenessRuleAttributeIdentifier: e 
	| redclEntity ruleAttribute |
	e groupRefName
		ifNil: [^ self acceptIdentifier: e].
	resolutionPass = 1
		ifTrue: [e setRef: nil.
			self declareWithError: e]
		ifFalse: [e ref ifNil: [(redclEntity := self lookUpNamedTypeBN: e groupRefName)
				ifNil: [e ref: nil.
					self declareWithError: e]
				ifNotNil: [(ruleAttribute := redclEntity attributeBN: e name)
						ifNil: [self declareWithError: e]
						ifNotNil: [e ref: ruleAttribute.
							self declareWithoutError: e]]]]! !

!PlatypusExpressResolver methodsFor: 'visit dictionary schema' stamp: 'AlainPlantec 5/6/2012 18:43'!
acceptUnresolvedSymbol: e
	resolutionPass > 1
		ifTrue: [
			e token = 'schema_definition' ifTrue: [self halt].
			(e resolvesFrom: self)
				ifFalse: [self declareWithError: e] ]
! !

!PlatypusExpressResolver methodsFor: 'visit generic' stamp: 'AlainPlantec 5/24/2012 23:57'!
checks: aMetaData 
	self checksAll: (Array with: aMetaData)! !

!PlatypusExpressResolver methodsFor: 'visit generic' stamp: 'AlainPlantec 6/14/2012 01:13'!
checksAll: aCollection 
	| stop prevErrsSet currErrsSet |
	resolutionPass := 1.
	aCollection do: [:e | e acceptTry: self].
	prevErrsSet := IdentitySet new.
	currErrsSet := IdentitySet new.
	[
		resolutionPass := resolutionPass + 1.
		currErrsSet addAll: self objectsWithErrorIndex.
		aCollection acceptTry: self.
		(stop := resolutionPass > 2 and: [(prevErrsSet difference: currErrsSet) isEmpty])
			ifFalse: [
				prevErrsSet addAll: currErrsSet.
				self forget].
		stop] whileFalse.
		self objectsWithErrorIndex do: [:k | 
			self registerError: (PlatypusExpressResolverError metaData: k message: 'unresolved symbol')].
! !

!PlatypusExpressResolver methodsFor: 'accessing' stamp: 'AlainPlantec 5/19/2012 23:00'!
interactivelyResolvedSchemaNamed: aName 
	| key |
	key := aName asUppercase .
	^ PlatypusSchemaInstanceReference 
		interactivelyResolvedSchemaSatisfying: [:r | 
			r name asUppercase = key] message: '''', aName,''' is for ?'.
! !

!PlatypusExpressResolver methodsFor: 'visit generic' stamp: 'apl 9/19/2007 10:21'!
lookUp: anIdent 
	| found |
	(found := self lookUpIdentifierBN: anIdent) isNil
		ifTrue: [found := self lookUpNamedTypeBN: anIdent].
	^ found! !

!PlatypusExpressResolver methodsFor: 'visit generic' stamp: 'apl 9/19/2007 08:55'!
lookUp: ident from: aMetaData 
	^ aMetaData isNil
		ifFalse: [(aMetaData lookUpIdentifierBN: ident)
				ifNil: [(aMetaData lookUpNamedTypeBN: ident)
						ifNil: [aMetaData name asUppercase = ident asUppercase
								ifTrue: [aMetaData]]]]! !

!PlatypusExpressResolver methodsFor: 'visit generic' stamp: 'apl 2/23/2005 21:44'!
lookUpFunctionCallOrConstructorNamed: aName 
	| found |
	found := self lookUpIdentifierBN: aName.
	(found isNil
			or: [found isPltAlgorithmDeclaration not])
		ifTrue: [found := self lookUpNamedTypeBN: aName].
	^ found! !

!PlatypusExpressResolver methodsFor: 'visit generic' stamp: 'AlainPlantec 4/12/2011 11:30'!
lookUpIdentifierBN: aName 
	| found |
	resolutionPass = 1 ifTrue: [self halt].
	visitPath reverseDo: 
			[:el | el ifNotNil: [
			el isPltSchemaInstance 
				ifFalse: [(found := el lookUpIdentifierBN: aName) ifNotNil: [^ found]]]].
	^ PltPlatypusExpressPrimitivesSchemaInstance lookUpIdentifierBN: aName! !

!PlatypusExpressResolver methodsFor: 'visit generic' stamp: 'AlainPlantec 4/12/2011 11:32'!
lookUpNamedTypeBN: aName 
	| found |
	visitPath
		reverseDo: [:el | el 
			ifNotNil: [el isPltSchemaInstance
				ifFalse: [(found := el lookUpNamedTypeBN: aName)
						ifNotNil: [^ found]]]].
		^ PltPlatypusExpressPrimitivesSchemaInstance lookUpNamedTypeBN: aName! !

!PlatypusExpressResolver methodsFor: 'visit generic' stamp: 'AlainPlantec 3/7/2011 14:49'!
lookUpPath: aListOfString 
	| ident found path key |
	ident := aListOfString first.
	key := ident asUppercase.
	found := self schemaInstance allSchemata
				detect: [:schi | schi notNil and: [key = schi key]]
				ifNone: [self lookUp: ident].
	path := aListOfString allButFirst.
	[path isEmpty
		or: [found isNil]]
		whileFalse: [found := self lookUp: path first from: found.
			path := path allButFirst].
	^ found! !

!PlatypusExpressResolver methodsFor: 'accessing' stamp: 'apl 4/13/2006 11:48'!
parent
	^ parent! !

!PlatypusExpressResolver methodsFor: 'accessing' stamp: 'apl 4/13/2006 11:49'!
parent: aResolver
	parent := aResolver! !

!PlatypusExpressResolver methodsFor: 'accessing' stamp: 'apl 4/13/2006 11:56'!
visitContexts: aCollection parent: aResolver
	super visitContexts: aCollection.
	self parent: aResolver
! !

PlatypusExpressChecker subclass: #PlatypusExpressSemanticChecker
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-visitors'!

!PlatypusExpressSemanticChecker methodsFor: 'visit dictionary schema' stamp: 'apl 2/17/2006 22:06'!
acceptAggregationType: e 
	| low upper |
	self
		checksBound: e lowerBound
		messagePrefix: 'lower bound'
		from: e.
	self
		checksBound: e upperBound
		messagePrefix: 'upper bound'
		from: e.
	(e lowerBound notNil
			and: [e upperBound notNil])
		ifTrue: [((low := e lowerBound asInteger) notNil
					and: [(upper := e upperBound asInteger) notNil])
				ifTrue: [low <= upper
						ifFalse: [self
								registerError: (PlatypusExpressSemanticCheckerError message: 'low bound must be greater or equal than upper bound' path: visitPath asArray)]]]! !

!PlatypusExpressSemanticChecker methodsFor: 'visit expressions schema' stamp: 'apl 2/23/2005 22:11'!
acceptAndExpression: e 
	super acceptBinaryExpression: e.
	self
		checksBinaryOperator: e
		testBlock: [:domain1 :domain2 | (domain1 isPltLogicalType
					and: [domain2 isPltLogicalType])
				or: [domain1 isPltGenericType
						or: [domain2 isPltGenericType]]]! !

!PlatypusExpressSemanticChecker methodsFor: 'visit dictionary schema' stamp: 'apl 2/17/2006 22:07'!
acceptArrayType: e 
	super acceptArrayType: e.
	self acceptAggregationType: e.
	e isGeneralType
		ifFalse: [e lowerBound
				ifNil: [self
						registerError: (PlatypusExpressSemanticCheckerError message: 'low index must be set' path: visitPath asArray)].
			e upperBound
				ifNil: [self
						registerError: (PlatypusExpressSemanticCheckerError message: 'high index must be set' path: visitPath asArray)]]! !

!PlatypusExpressSemanticChecker methodsFor: 'visit statements schema' stamp: 'apl 6/22/2004 12:44'!
acceptAssignmentStatement: e 
	e left acceptTry: self.
	e rightExpr acceptTry: self.
	self
		checksAssignOf: e rightExpr
		to: e left
		from: e! !

!PlatypusExpressSemanticChecker methodsFor: 'visit dictionary schema' stamp: 'apl 11/21/2003 15:20'!
acceptBagType: e 
	super acceptBagType: e.
	self acceptAggregationType: e! !

!PlatypusExpressSemanticChecker methodsFor: 'visit dictionary schema' stamp: 'apl 11/21/2003 13:49'!
acceptBound: e 
! !

!PlatypusExpressSemanticChecker methodsFor: 'visit dictionary schema' stamp: 'apl 7/1/2004 00:50'!
acceptConstantDefinition: e 
	self
				checksAssignOf: e initializer
				to: e
				from: e! !

!PlatypusExpressSemanticChecker methodsFor: 'visit dictionary schema' stamp: 'apl 7/1/2004 00:50'!
acceptContextDefinition: e 
	self logPathAndInfo: e name.
			super acceptContextDefinition: e! !

!PlatypusExpressSemanticChecker methodsFor: 'visit dictionary schema' stamp: 'apl 2/18/2006 09:28'!
acceptDefinedType: e 
	| errPathStack errMess |
	super acceptDefinedType: e.
	errPathStack := OrderedCollection new.
	(e checksDomainPath: OrderedCollection new errorStack: errPathStack)
		ifFalse: [errMess := ''.
			errPathStack
				do: [:st | errMess := errMess , st name]
				separatedBy: [errMess := errMess , '->'].
			self
				registerError: (PlatypusExpressSemanticCheckerError message: 'cycle in domain path: ' , errMess path: visitPath asArray)]! !

!PlatypusExpressSemanticChecker methodsFor: 'visit dictionary schema' stamp: 'apl 2/17/2006 22:07'!
acceptDerivedAttribute: e 
	super acceptDerivedAttribute: e.
	e redeclaring
		ifNotNil: [((e redeclaring ref isKindOf: e class)
					or: [e redeclaring ref isKindOf: PltExplicitAttribute])
				ifTrue: [self checksAttributeRedeclaring: e]
				ifFalse: [self
						registerError: (PlatypusExpressSemanticCheckerError message: 'redeclaring attribute ''' , e name , ''' should be an explicit or a derived attribute' path: visitPath asArray)]].
	self
		checksAssignOf: e assign
		to: e
		from: e! !

!PlatypusExpressSemanticChecker methodsFor: 'visit expressions schema' stamp: 'apl 2/23/2005 22:16'!
acceptDivExpression: e 
	super acceptBinaryExpression: e.
	self
		checksBinaryOperator: e
		testBlock: [:domain1 :domain2 | (domain1 isPltNumberType
					and: [domain2 isPltNumberType])
				or: [domain1 isPltGenericType
						or: [domain2 isPltGenericType]]]! !

!PlatypusExpressSemanticChecker methodsFor: 'visit dictionary schema' stamp: 'apl 9/23/2003 19:22'!
acceptDomainEquivalentItem: e 
! !

!PlatypusExpressSemanticChecker methodsFor: 'visit dictionary schema' stamp: 'AlainPlantec 6/13/2012 23:49'!
acceptEntityDefinition: e 
	super acceptEntityDefinition: e.
	(e checksHierarchy: OrderedCollection new errorStack: OrderedCollection new)
		ifTrue: [e checksAttributesNames
				do: [:err | self registerError: err]]
		ifFalse: [self
				registerError: (PlatypusExpressSemanticCheckerError message: 'cycle in hierarchy path' path: e inclusiveOwnerPath)]! !

!PlatypusExpressSemanticChecker methodsFor: 'visit dictionary schema' stamp: 'apl 2/17/2006 22:07'!
acceptEnumerationType: e 
	| elements |
	super acceptEnumerationType: e.
	elements := Set new.
	e elements
		do: [:el | 
			(elements includes: el)
				ifTrue: [self
						registerError: (PlatypusExpressSemanticCheckerError message: 'enumeration type contains several occurences of ''' , el , '''' path: visitPath asArray)].
			elements add: el]! !

!PlatypusExpressSemanticChecker methodsFor: 'visit expressions schema' stamp: 'apl 2/4/2004 13:25'!
acceptEqualExpression: e 
	| |
	super acceptBinaryExpression: e.
	(self checksAggregateOperator: e)
		ifNil: [self
				checksBinaryOperator: e
				testBlock: [:domain1 :domain2 | domain1 isCompatibleWith: domain2]]! !

!PlatypusExpressSemanticChecker methodsFor: 'visit dictionary schema' stamp: 'apl 2/17/2006 22:07'!
acceptExplicitAttribute: e 
	super acceptExplicitAttribute: e.
	e redeclaring
		ifNotNil: [(e redeclaring ref isKindOf: e class)
				ifTrue: [self checksAttributeRedeclaring: e]
				ifFalse: [self
						registerError: (PlatypusExpressSemanticCheckerError message: 'redeclaring attribute ''' , e name , ''' should be an explicit attribute' path: visitPath asArray)]]! !

!PlatypusExpressSemanticChecker methodsFor: 'visit expressions schema' stamp: 'apl 2/23/2005 22:16'!
acceptExpoExpression: e 
	super acceptBinaryExpression: e.
	self
		checksBinaryOperator: e
		testBlock: [:domain1 :domain2 | (domain1 isPltNumberType
					and: [domain2 isPltNumberType])
				or: [domain1 isPltGenericType
						or: [domain2 isPltGenericType]]]! !

!PlatypusExpressSemanticChecker methodsFor: 'visit dictionary schema' stamp: 'AlainPlantec 10/19/2010 01:21'!
acceptExternalMetaSchema: e 
	self acceptExternalSchema: e! !

!PlatypusExpressSemanticChecker methodsFor: 'visit dictionary schema' stamp: 'AlainPlantec 6/13/2012 23:49'!
acceptExternalSchema: e 
	e nativeSchema = e owner
		ifTrue: [self
				registerError: (PlatypusExpressSemanticCheckerError message: 'used/referenced inside itself' path: e inclusiveOwnerPath)]! !

!PlatypusExpressSemanticChecker methodsFor: 'visit dictionary schema' stamp: 'AlainPlantec 6/14/2012 01:45'!
acceptFunctionDeclaration: e 
	super acceptFunctionDeclaration: e.
	(e statements anySatisfy: [:stmt | stmt alwaysReturn]) 
		ifFalse: [
			self registerError: (PlatypusExpressSemanticCheckerError
				metaData: e
				message: 'never return possibility')]! !

!PlatypusExpressSemanticChecker methodsFor: 'visit expressions schema' stamp: 'apl 2/4/2004 13:25'!
acceptGreaterEqualExpression: e 
	| |
	super acceptBinaryExpression: e.
	( self checksAggregateOperator: e)
		ifNil: [^ self
				checksBinaryOperator: e
				testBlock: [:domain1 :domain2 | domain1 isCompatibleWith: domain2]]
		 ! !

!PlatypusExpressSemanticChecker methodsFor: 'visit expressions schema' stamp: 'apl 6/22/2004 15:36'!
acceptGreaterThanExpression: e 
	self acceptBinaryExpression: e.
	(self checksAggregateOperator: e)
		ifNil: [self
				checksBinaryOperator: e
				testBlock: [:domain1 :domain2 | domain1 isCompatibleWith: domain2]]! !

!PlatypusExpressSemanticChecker methodsFor: 'visit expressions schema' stamp: 'apl 2/18/2006 09:30'!
acceptInExpression: e 
	| rinfered linfered |
	super acceptBinaryExpression: e.
	rinfered := e rightExpr computedDomain.
	rinfered isPltGenericType
		ifTrue: [^ true].
	linfered := e leftExpr computedDomain.
	rinfered isPltAggregateCompatibleType
		ifFalse: [self
				registerError: (PlatypusExpressSemanticCheckerError message: 'invalid right operande, should be an aggregate'
				path: visitPath asArray).
			^ false].
	(linfered isCompatibleWith: rinfered elementType)
		ifFalse: [self
				registerError: (PlatypusExpressSemanticCheckerError message: 'operand domain incompatibility: ', ('aggregate domain : ' , rinfered errorQualifier), ('element domain : ' , linfered errorQualifier) ).
				
			^ false].
	^ true! !

!PlatypusExpressSemanticChecker methodsFor: 'visit dictionary schema' stamp: 'apl 4/13/2006 08:38'!
acceptIncludeSchema: e 
	self acceptExternalSchema: e! !

!PlatypusExpressSemanticChecker methodsFor: 'visit expressions schema' stamp: 'apl 2/4/2004 13:26'!
acceptInstEqualExpression: e 
	super acceptBinaryExpression: e.
		( self checksAggregateOperator: e)
		ifNil: [ self
				checksBinaryOperator: e
				testBlock: [:domain1 :domain2 | domain1 isCompatibleWith: domain2]]
		 ! !

!PlatypusExpressSemanticChecker methodsFor: 'visit expressions schema' stamp: 'apl 2/4/2004 13:26'!
acceptInstNotEqualExpression: e 
	super acceptBinaryExpression: e.
		(self checksAggregateOperator: e)
		ifNil: [^ self
				checksBinaryOperator: e
				testBlock: [:domain1 :domain2 | domain1 isCompatibleWith: domain2]]
! !

!PlatypusExpressSemanticChecker methodsFor: 'visit expressions schema' stamp: 'AlainPlantec 3/11/2011 12:26'!
acceptInstanceConstructionExpression: e 
	self acceptBinaryExpression: e.
	"(self checksAggregateOperator: e)
		ifNil: [self
				checksBinaryOperator: e
				testBlock: [:domain1 :domain2 | domain1 isCompatibleWith: domain2]]"! !

!PlatypusExpressSemanticChecker methodsFor: 'visit dictionary schema' stamp: 'apl 2/17/2006 22:07'!
acceptInverseAttribute: e 
	| elementType refedDomain |
	super acceptInverseAttribute: e.
	refedDomain := e invertedAttr entityRef referenced.
	(refedDomain isPltNamedType
			or: [refedDomain isPltAggregationType
					and: [refedDomain isPltSetType
							or: [refedDomain isPltBagType]]])
		ifFalse: [self
				registerError: (PlatypusExpressSemanticCheckerError message: 'bad inverse attribute ''' , e name , ''' domain (should be an Entity, a Set or a Bag)' path: visitPath asArray)].
	refedDomain isPltAggregationType
		ifTrue: [elementType := refedDomain elementType.
			elementType isPltNamedType
				ifFalse: [self
						registerError: (PlatypusExpressSemanticCheckerError message: 'bad inverse attribute ''' , e name , ''' domain' path: visitPath asArray)]].
	e redeclaring
		ifNotNil: [(e redeclaring ref isKindOf: e class)
				ifTrue: [self checksAttributeRedeclaring: e]
				ifFalse: [self
						registerError: (PlatypusExpressSemanticCheckerError message: 'redeclaring attribute ''' , e name , ''' should be an inverse attribute' path: visitPath asArray)]].
	(refedDomain isSpecializationOf: e invertedAttr ref owner)
		ifFalse: [self
				registerError: (PlatypusExpressSemanticCheckerError message: 'inversed attribute domain ''' , e invertedAttr name , ''' in entity ''' , e invertedAttr owner name , ''' should be a specialization of ''' , e owner name , '''' path: visitPath asArray)].
	self
		checksBound: e minCardinality
		messagePrefix: 'min cardinality'
		from: e.
	self
		checksBound: e maxCardinality
		messagePrefix: 'max cardinality'
		from: e! !

!PlatypusExpressSemanticChecker methodsFor: 'visit expressions schema' stamp: 'apl 2/4/2004 13:27'!
acceptLessEqualExpression: e 
	| |
	self acceptBinaryExpression: e.
	( self checksAggregateOperator: e)
		ifNil: [ self
				checksBinaryOperator: e
				testBlock: [:domain1 :domain2 | domain1 isCompatibleWith: domain2]]
		 ! !

!PlatypusExpressSemanticChecker methodsFor: 'visit expressions schema' stamp: 'apl 6/22/2004 15:36'!
acceptLessThanExpression: e 
	self acceptBinaryExpression: e.
	(self checksAggregateOperator: e)
		ifNil: [self
				checksBinaryOperator: e
				testBlock: [:domain1 :domain2 | domain1 isCompatibleWith: domain2]]! !

!PlatypusExpressSemanticChecker methodsFor: 'visit dictionary schema' stamp: 'apl 11/21/2003 15:20'!
acceptListType: e 
	super acceptListType: e.
	self acceptAggregationType: e.
! !

!PlatypusExpressSemanticChecker methodsFor: 'visit dictionary schema' stamp: 'apl 6/22/2004 12:44'!
acceptLocalVariable: e 
	e initializer
		ifNotNil: [self
				checksAssignOf: e initializer
				to: e
				from: e]! !

!PlatypusExpressSemanticChecker methodsFor: 'visit expressions schema' stamp: 'apl 2/23/2005 22:16'!
acceptMinusExpression: e 
	self acceptBinaryExpression: e.
	(self checksAggregateOperator: e)
		ifNil: [self
				checksBinaryOperator: e
				testBlock: [:domain1 :domain2 | (domain1 isPltNumberType
							and: [domain2 isPltNumberType])
						or: [domain1 isPltGenericType
								or: [domain2 isPltGenericType]]]]
		ifNotNil: [self
				checksBinaryOperator: e
				testBlock: [:domain1 :domain2 | domain1 isPltAggregateCompatibleType
						or: [domain1 isPltGenericType]]]! !

!PlatypusExpressSemanticChecker methodsFor: 'visit expressions schema' stamp: 'apl 2/23/2005 22:16'!
acceptModExpression: e 
	self acceptBinaryExpression: e.
	self
		checksBinaryOperator: e
		testBlock: [:domain1 :domain2 | (domain1 isPltNumberType
					and: [domain2 isPltNumberType])
				or: [domain1 isPltGenericType
						or: [domain2 isPltGenericType]]]! !

!PlatypusExpressSemanticChecker methodsFor: 'visit expressions schema' stamp: 'apl 2/23/2005 22:17'!
acceptMultExpression: e 
	self acceptBinaryExpression: e.
	(self checksAggregateOperator: e)
		ifNil: [self
				checksBinaryOperator: e
				testBlock: [:domain1 :domain2 | (domain1 isPltNumberType
							and: [domain2 isPltNumberType])
						or: [domain1 isPltGenericType
								or: [domain2 isPltGenericType]]]]
		ifNotNil: [self
				checksBinaryOperator: e
				testBlock: [:domain1 :domain2 | (domain1 isPltAggregateCompatibleType
							or: [domain1 isPltGenericType])
						and: [domain2 isPltAggregateCompatibleType
								or: [domain2 isPltGenericType]]]]! !

!PlatypusExpressSemanticChecker methodsFor: 'visit expressions schema' stamp: 'apl 2/4/2004 13:28'!
acceptNotEqualExpression: e 
 	self acceptBinaryExpression: e.
	( self checksAggregateOperator: e)
		ifNil: [^ self
				checksBinaryOperator: e
				testBlock: [:domain1 :domain2 | domain1 isCompatibleWith: domain2]]
 ! !

!PlatypusExpressSemanticChecker methodsFor: 'visit expressions schema' stamp: 'apl 2/23/2005 22:12'!
acceptOrExpression: e 
	self acceptBinaryExpression: e.
	self
		checksBinaryOperator: e
		testBlock: [:domain1 :domain2 | (domain1 isPltLogicalType
					and: [domain2 isPltLogicalType])
				or: [domain1 isPltGenericType
						or: [domain2 isPltGenericType]]]! !

!PlatypusExpressSemanticChecker methodsFor: 'visit expressions schema' stamp: 'AlainPlantec 4/5/2010 17:41'!
acceptPlusExpression: e 
	self acceptBinaryExpression: e.
	(self checksAggregateOperator: e)
		ifNil: [self
				checksBinaryOperator: e
				testBlock: [:domain1 :domain2 | (domain1 isPltNumberType
						and: [domain2 isPltNumberType])
						or: [(domain1 isPltStringType
								and: [domain2 isPltStringType])
						or: [domain1 isPltGenericType
								or: [domain2 isPltGenericType]]]]]! !

!PlatypusExpressSemanticChecker methodsFor: 'visit expressions schema' stamp: 'apl 2/23/2005 22:17'!
acceptRealDivExpression: e 
	self acceptBinaryExpression: e.
	self
		checksBinaryOperator: e
		testBlock: [:domain1 :domain2 | (domain1 isPltNumberType
					and: [domain2 isPltNumberType])
				or: [domain1 isPltGenericType
						or: [domain2 isPltGenericType]]]! !

!PlatypusExpressSemanticChecker methodsFor: 'visit dictionary schema' stamp: 'apl 4/13/2006 08:38'!
acceptSchemaDefinition: e 
	self logInfo: 'schema ' , e name.
	super acceptSchemaDefinition: e! !

!PlatypusExpressSemanticChecker methodsFor: 'visit environment schema' stamp: 'apl 3/22/2006 08:24'!
acceptSchemaInstance: e 
	(e internalSchemata)
		acceptTry: self! !

!PlatypusExpressSemanticChecker methodsFor: 'visit dictionary schema' stamp: 'apl 11/21/2003 15:21'!
acceptSetType: e 
	super acceptSetType: e.
	self acceptAggregationType: e! !

!PlatypusExpressSemanticChecker methodsFor: 'visit dictionary schema' stamp: 'apl 6/22/2004 08:44'!
acceptStatementsContainer: e 
	super acceptStatementsContainer: e.
	self statementNotReachTest: e ! !

!PlatypusExpressSemanticChecker methodsFor: 'visit dictionary schema' stamp: 'AlainPlantec 5/6/2012 18:46'!
acceptSupertypeConstraint: e 
	super acceptSupertypeConstraint: e.
	(e checksInheritance: e constrained ref)
		ifNotEmpty: [:errs | self
				registerError: (PlatypusExpressSemanticCheckerError message: 'error in hierarchy specification'
				path: visitPath asArray)]
				! !

!PlatypusExpressSemanticChecker methodsFor: 'visit dictionary schema' stamp: 'apl 2/17/2006 22:07'!
acceptUniquenessRule: e 
	| attributes |
	super acceptUniquenessRule: e.
	attributes := Set new.
	e attributes
		do: [:attr | 
			(attributes includes: attr referenced)
				ifTrue: [self
						registerError: (PlatypusExpressSemanticCheckerError message: 'contains several occurences of ''' , attr name , '''' path: visitPath asArray)].
			attributes add: attr referenced]! !

!PlatypusExpressSemanticChecker methodsFor: 'visit expressions schema' stamp: 'apl 2/23/2005 22:12'!
acceptXorExpression: e 
	self acceptBinaryExpression: e.
	self
		checksBinaryOperator: e
		testBlock: [:domain1 :domain2 | (domain1 isPltLogicalType
					and: [domain2 isPltLogicalType])
				or: [domain1 isPltGenericType
						or: [domain2 isPltGenericType]]]! !

!PlatypusExpressSemanticChecker methodsFor: 'visit generic' stamp: 'AlainPlantec 5/19/2012 23:19'!
checks: aMetaData 
	self logInfo: 'SEMANTIC CHECKING'.
	aMetaData acceptTry: self.
	self logInfo: 'SEMANTIC CHECKING DONE'! !

!PlatypusExpressSemanticChecker methodsFor: 'visit generic' stamp: 'AlainPlantec 6/14/2012 01:52'!
checksAggregateOperator: e 
	| linfered rinfered theElementType theAggrType elType1 elType2 aggrExpr elExpr |
	linfered := e leftExpr computedDomain.
	rinfered := e rightExpr computedDomain.
	(linfered isPltAggregateCompatibleType
			or: [rinfered isPltAggregateCompatibleType])
		ifTrue: [(linfered isPltAggregateCompatibleType
					and: [rinfered isPltAggregateCompatibleType])
				ifTrue: [elType1 := linfered elementType computedDomain.
					elType2 := rinfered elementType computedDomain.
					((linfered canAddElementOfType: elType2)
							and: [rinfered canAddElementOfType: elType1])
						ifFalse: [self
								registerError: (PlatypusExpressSemanticCheckerError 
									metaData: e 
									message: 'aggregation operation domain incompatibility, ' , ('left element domain : ' , elType1 errorQualifier) , ' right element domain : ' , elType2 errorQualifier).
							^ false]]
				ifFalse: [linfered isPltAggregateCompatibleType
						ifTrue: [theElementType := rinfered.
							theAggrType := linfered.
							aggrExpr := e leftExpr.
							elExpr := e rightExpr]
						ifFalse: [theElementType := linfered.
							theAggrType := rinfered.
							aggrExpr := e rightExpr.
							elExpr := e leftExpr].
					elType1 := theAggrType elementType computedDomain.
					elType2 := theElementType.
					(theAggrType canAddElementOfType: elType2)
						ifFalse: [
self
								registerError: (PlatypusExpressSemanticCheckerError 
									metaData: e 
									message: 'aggregation operation domain incompatibility, ' , ('aggregate domain : ' , theAggrType errorQualifier) , ' element domain : ' , theElementType errorQualifier).


							^ false]].
			^ true]
		ifFalse: [^ nil]! !

!PlatypusExpressSemanticChecker methodsFor: 'visit generic' stamp: 'AlainPlantec 6/14/2012 00:45'!
checksAssignOf: expr to: anAssignableOrAttribute from: e 
	| infered static |
	((infered := expr computedDomain) isAssignableTo: (static := anAssignableOrAttribute computedDomain))
		ifFalse: [self registerError: (PlatypusExpressSemanticCheckerError metaData: anAssignableOrAttribute message: 'domain incompatibility in assignment, ', 'lhs domain : ' , static errorQualifier, ', rhs domain : ' , infered errorQualifier)].
	(anAssignableOrAttribute isPltAssignable and: [anAssignableOrAttribute head referenced isPltAliasStatementVariable])
		ifTrue: [
			self registerError: 
				(PlatypusExpressSemanticCheckerError
					metaData: anAssignableOrAttribute head referenced  
					message: 'not implemented feature: writeable alias variable')].! !

!PlatypusExpressSemanticChecker methodsFor: 'visit generic' stamp: 'apl 10/2/2006 09:39'!
checksAttributeRedeclaring: attr 
	| redeclaredDomain redeclaringDomain |
	redeclaringDomain := attr domain referenced.
	redeclaredDomain := attr redeclaring ref domain referenced.
	(redeclaringDomain isSpecializationOf: redeclaredDomain) 
		ifFalse: 
			[self registerError: (PlatypusExpressSemanticCheckerError 
						message: ('redeclaring domain must be a specialization of redeclared domain, ' 
								, ('invalid redeclaring domain : ' , redeclaringDomain errorQualifier 
										, ', redeclared attribute: domain : ' , redeclaredDomain errorQualifier))
									path: visitPath asArray)]! !

!PlatypusExpressSemanticChecker methodsFor: 'visit generic' stamp: 'apl 9/25/2006 16:35'!
checksBinaryOperator: e testBlock: aBlock 
	| linfered rinfered |
	linfered := e leftExpr computedDomain.
	rinfered := e rightExpr computedDomain.
	(aBlock value: linfered value: rinfered)
		ifFalse: [self
				registerError: (PlatypusExpressSemanticCheckerError message: 'domain incompatibility in binary expression, ' , ('lhs domain : ' , linfered errorQualifier) , (' rhs domain : ' , rinfered errorQualifier) path: visitPath asArray).
			^ false].
	^ true! !

!PlatypusExpressSemanticChecker methodsFor: 'visit generic' stamp: 'apl 2/18/2006 10:14'!
checksBound: e messagePrefix: aString from: parent 
	e
		ifNotNil: [(e inferedDomain isCompatibleWith: PltNumberType asDomain)
				ifFalse: [self
				registerError: (PlatypusExpressSemanticCheckerError message:  aString , ' should be a number, ', 'bound domain : ' , e inferedDomain errorQualifier)]]
						! !

!PlatypusExpressSemanticChecker methodsFor: 'visit generic' stamp: 'apl 2/18/2006 10:15'!
statementNotReachTest: aStatementContainer 
	| stmt stmts |
	stmts := aStatementContainer statements.
	1
		to: stmts size - 1
		do: [:pos | 
			stmt := stmts at: pos.
			(stmt alwaysReturn
					and: [stmt isPltNativeStatement not])
				ifTrue: [self
						registerError: (PlatypusExpressSemanticCheckerError message:  'statement not reached: ', (stmts at: pos + 1) prettyPrintedExpressCode path: visitPath asArray)]].
						! !

!PlatypusStepChecker class methodsFor: 'checking' stamp: 'apl 6/22/2004 18:44'!
checks: metaData 
	^ self new checks: metaData! !

!PlatypusStepChecker methodsFor: 'visit generic' stamp: 'apl 11/10/2003 12:22'!
checks: aMetaData 
	self subclassResponsibility! !

!PlatypusStepOnePassAbstractVisitor methodsFor: 'visit dictionary schema' stamp: 'apl 7/20/2004 23:26'!
acceptAttributeReference: e 
	e ref ifNotNil: [e ref acceptTry: self].
	e entityRef acceptTry: self.! !

!PlatypusStepOnePassAbstractVisitor methodsFor: 'visit dictionary schema' stamp: 'apl 7/23/2004 19:44'!
acceptDictionaryInstanceReference: e 
	e ref ifNotNil: [e ref acceptTry: self]! !

!PlatypusStepOnePassAbstractVisitor methodsFor: 'visit dictionary schema' stamp: 'apl 7/23/2004 20:07'!
acceptEntityDefinitionReference: e 
	e ref
		ifNotNil: [e ref acceptTry: self]! !

!PlatypusStepOnePassAbstractVisitor methodsFor: 'visit expressions schema' stamp: 'AlainPlantec 6/14/2012 14:43'!
acceptIdentifier: e 
	 e ref acceptTry: self.
	 e parameters acceptTry: self! !

!PlatypusStepOnePassAbstractVisitor methodsFor: 'visit environment schema' stamp: 'AlainPlantec 6/4/2012 17:39'!
acceptModelContents: e 
	e dataInstances
		do: [:v | v acceptTry: self]
! !

!PlatypusStepOnePassAbstractVisitor methodsFor: 'visit dictionary schema' stamp: 'apl 7/26/2004 19:15'!
acceptNamedTypeReference: e 
	e ref
		ifNotNil: [e ref acceptTry: self]! !

!PlatypusStepOnePassAbstractVisitor methodsFor: 'visit generic' stamp: 'apl 2/15/2005 19:30'!
acceptTry: anObject 
	(self alreadyDoneFor: anObject)
		ifFalse: [self doneFor: anObject.
			^ super acceptTry: anObject]! !

!PlatypusStepOnePassAbstractVisitor methodsFor: 'visit generic' stamp: 'apl 6/14/2004 19:20'!
alreadyDoneFor: anObject 
	visited
		at: anObject
		ifAbsent: [^ false].
	^ true! !

!PlatypusStepOnePassAbstractVisitor methodsFor: 'visit generic' stamp: 'apl 6/14/2004 19:20'!
doneFor: anObject 
	visited at: anObject put: anObject! !

!PlatypusStepOnePassAbstractVisitor methodsFor: 'visit generic' stamp: 'apl 6/14/2004 19:20'!
forceNotdoneFor: anObject 
	visited
		removeKey: anObject
		ifAbsent: []! !

!PlatypusStepOnePassAbstractVisitor methodsFor: 'initialize/release' stamp: 'apl 6/22/2004 13:02'!
forget
	super forget.
	self initializeVisited! !

!PlatypusStepOnePassAbstractVisitor methodsFor: 'initialize/release' stamp: 'apl 6/14/2004 19:21'!
initialize
	super initialize.
	self initializeVisited ! !

!PlatypusStepOnePassAbstractVisitor methodsFor: 'initialize/release' stamp: 'apl 6/14/2004 19:21'!
initializeVisited
	visited := IdentityDictionary new! !

PlatypusStepOnePassAbstractVisitor subclass: #PlatypusStepOwnerSetter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-visitors'!

!PlatypusStepOwnerSetter methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 6/14/2012 15:24'!
acceptEnumerationValue: e
	super acceptEnumerationValue: e! !

!PlatypusStepOwnerSetter methodsFor: 'visit expressions schema' stamp: 'AlainPlantec 6/14/2012 14:43'!
acceptIdentifier: e
	 e ref acceptTry: self. 
	 e parameters acceptTry: self! !

!PlatypusStepOwnerSetter methodsFor: 'visit environment schema' stamp: 'AlainPlantec 6/14/2012 10:52'!
acceptSchemaInstance: e 
	e internalSchemata acceptTry: self.
	e metaConceptsIndex acceptTry: self.
! !

!PlatypusStepOwnerSetter methodsFor: 'visit generic' stamp: 'AlainPlantec 6/14/2012 14:57'!
acceptTry: e
	e ifNotNil: [
		e owner ifNil: [
			visitPath isEmpty
				ifFalse: [e owner: visitPath top]].
		super acceptTry: e]! !

Object subclass: #PlatypusCoreObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-core'!

PlatypusCoreObject subclass: #PlatypusCoreAlgorithmDeclaration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-core'!

!PlatypusCoreAlgorithmDeclaration class methodsFor: 'accessing' stamp: 'apl 5/29/2005 23:41'!
context
	^self schemaDefinition context! !

!PlatypusCoreAlgorithmDeclaration class methodsFor: 'instance creation' stamp: 'apl 3/15/2005 15:08'!
fromValues: values
	^ self new fromValues: values! !

!PlatypusCoreAlgorithmDeclaration class methodsFor: 'instance creation' stamp: 'apl 5/29/2005 23:55'!
invoke
	^self new invoke! !

!PlatypusCoreAlgorithmDeclaration class methodsFor: 'instance creation' stamp: 'apl 5/29/2005 23:56'!
invokeFromValues: values 
	| algo |
	algo := self new fromValues: values.
	^algo invoke! !

!PlatypusCoreAlgorithmDeclaration class methodsFor: 'instance creation' stamp: 'AlainPlantec 4/12/2011 13:11'!
invokeOnContextStream: aStream
	| repo |
	repo := self schemaInstance repositoryClass new asSchemaInstanceContext.
	repo parseStream: aStream.
	^self new invoke! !

!PlatypusCoreAlgorithmDeclaration class methodsFor: 'accessing' stamp: 'apl 2/28/2006 22:46'!
schemaInstance
	^ self schemaDefinition schemaInstance! !

!PlatypusCoreAlgorithmDeclaration methodsFor: 'accessing' stamp: 'apl 3/15/2005 15:09'!
fromValues: values 
! !

!PlatypusCoreAlgorithmDeclaration methodsFor: 'executing' stamp: 'apl 1/31/2006 11:49'!
invoke
	! !

!PlatypusCoreAlgorithmDeclaration methodsFor: 'executing' stamp: 'AlainPlantec 4/12/2011 13:01'!
invokeOnModelDataStream: aStream
	
	! !

!PlatypusCoreAlgorithmDeclaration methodsFor: 'accessing' stamp: 'apl 2/2/2006 16:40'!
myContext
	^ self class context! !

!PlatypusCoreAlgorithmDeclaration methodsFor: 'executing' stamp: 'apl 1/31/2006 10:07'!
return: anObject 
	^ anObject pltNativeValue ! !

PlatypusCoreAlgorithmDeclaration subclass: #PltABSFunction
	instanceVariableNames: 'p'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-ExpressBuiltinsSchema'!

!PltABSFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION ABS ( P : NUMBER ) : NUMBER;
	(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (v class val: (v pltNativeValue) abs)] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: (v abs)] 
		         #*);
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!PltABSFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltABSFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltExpressBuiltinsSchemaDefinition singleton

! !

!PltABSFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltABSFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltABSFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self p: (values at: 1)

! !

!PltABSFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	"---------- native statement ---------- "

	| v |
	^ (v := self p) ifNotNil: [ self return: v abs ]

! !

!PltABSFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p
	^ p

! !

!PltABSFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p: aNumber
	p := aNumber

! !

PlatypusCoreAlgorithmDeclaration subclass: #PltACOSFunction
	instanceVariableNames: 'p'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-ExpressBuiltinsSchema'!

!PltACOSFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION ACOS ( P : NUMBER ) : REAL;
	(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (PltRealLiteral val: (v pltNativeValue) arcCos)] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: (v arcCos)] 
		         #*);
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!PltACOSFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltACOSFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltExpressBuiltinsSchemaDefinition singleton

! !

!PltACOSFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltACOSFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltACOSFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self p: (values at: 1)

! !

!PltACOSFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	"---------- native statement ---------- "

	| v |
	^ (v := self p) ifNotNil: [ self return: v arcCos ]

! !

!PltACOSFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p
	^ p

! !

!PltACOSFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p: aNumber
	p := aNumber

! !

PlatypusCoreAlgorithmDeclaration subclass: #PltASINFunction
	instanceVariableNames: 'p'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-ExpressBuiltinsSchema'!

!PltASINFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION ASIN ( P : NUMBER ) : REAL;
	(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (PltRealLiteral val: (v pltNativeValue) arcSin)] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: (v arcSin)] 
		         #*);
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!PltASINFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltASINFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltExpressBuiltinsSchemaDefinition singleton

! !

!PltASINFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltASINFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltASINFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self p: (values at: 1)

! !

!PltASINFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	"---------- native statement ---------- "

	| v |
	^ (v := self p) ifNotNil: [ self return: v arcSin ]

! !

!PltASINFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p
	^ p

! !

!PltASINFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p: aNumber
	p := aNumber

! !

PlatypusCoreAlgorithmDeclaration subclass: #PltATANFunction
	instanceVariableNames: 'v1 v2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-ExpressBuiltinsSchema'!

!PltATANFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION ATAN ( V1 : NUMBER; V2 : NUMBER ) : REAL;
	(*#          | v |
			(v := self v1)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (PltRealLiteral val: (v pltNativeValue) arcTan)] 
		         #*) (*# <pharo> | v |
			^ (v := self v1) ifNotNil: [self return: (v arcTan)] 
		         #*);
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!PltATANFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltATANFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltExpressBuiltinsSchemaDefinition singleton

! !

!PltATANFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltATANFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltATANFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self v1: (values at: 1).
	self v2: (values at: 2)

! !

!PltATANFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	"---------- native statement ---------- "

	| v |
	^ (v := self v1) ifNotNil: [ self return: v arcTan ]

! !

!PltATANFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
v1
	^ v1

! !

!PltATANFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
v1: aNumber
	v1 := aNumber

! !

!PltATANFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
v1: aNumber v2: aNumber1
	self v1: aNumber.
	self v2: aNumber1

! !

!PltATANFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
v2
	^ v2

! !

!PltATANFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
v2: aNumber1
	v2 := aNumber1

! !

PlatypusCoreAlgorithmDeclaration subclass: #PltBLENGTHFunction
	instanceVariableNames: 'p'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-ExpressBuiltinsSchema'!

!PltBLENGTHFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION BLENGTH ( P : BINARY ) : INTEGER;
	(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (PltIntegerLiteral val: (v pltNativeValue) size)] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: (v size)] 
		         #*);
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!PltBLENGTHFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltBLENGTHFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltExpressBuiltinsSchemaDefinition singleton

! !

!PltBLENGTHFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltBLENGTHFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltBLENGTHFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self p: (values at: 1)

! !

!PltBLENGTHFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	"---------- native statement ---------- "

	| v |
	^ (v := self p) ifNotNil: [ self return: v size ]

! !

!PltBLENGTHFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p
	^ p

! !

!PltBLENGTHFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p: aBinary
	p := aBinary

! !

PlatypusCoreAlgorithmDeclaration subclass: #PltCOSFunction
	instanceVariableNames: 'p'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-ExpressBuiltinsSchema'!

!PltCOSFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION COS ( P : NUMBER ) : REAL;
	(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (PltRealLiteral val: (v pltNativeValue) cos)] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: (v cos)] 
		         #*);
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!PltCOSFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltCOSFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltExpressBuiltinsSchemaDefinition singleton

! !

!PltCOSFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltCOSFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltCOSFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self p: (values at: 1)

! !

!PltCOSFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	"---------- native statement ---------- "

	| v |
	^ (v := self p) ifNotNil: [ self return: v cos ]

! !

!PltCOSFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p
	^ p

! !

!PltCOSFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p: aNumber
	p := aNumber

! !

PlatypusCoreAlgorithmDeclaration subclass: #PltEVENFunction
	instanceVariableNames: 'p'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-ExpressBuiltinsSchema'!

!PltEVENFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION EVEN ( P : NUMBER ) : BOOLEAN;
	(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (PltLogicalLiteral val: (v pltNativeValue) even)] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: (v even)] 
		         #*);
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!PltEVENFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltEVENFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltExpressBuiltinsSchemaDefinition singleton

! !

!PltEVENFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltEVENFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltEVENFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self p: (values at: 1)

! !

!PltEVENFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	"---------- native statement ---------- "

	| v |
	^ (v := self p) ifNotNil: [ self return: v even ]

! !

!PltEVENFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p
	^ p

! !

!PltEVENFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p: aNumber
	p := aNumber

! !

PlatypusCoreAlgorithmDeclaration subclass: #PltEXISTSFunction
	instanceVariableNames: 'p'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-ExpressBuiltinsSchema'!

!PltEXISTSFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION EXISTS ( P : GENERIC ) : BOOLEAN;
	(*#          
			(self p)
				ifMissing: [^ self return: (PltLogicalLiteral val: false) ]
				ifNotMissing: [^ self return: (PltLogicalLiteral val: true) ] 
		         #*) (*# <pharo> | v |
			^ (self return: self p notNil)
		         #*);
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!PltEXISTSFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltEXISTSFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltExpressBuiltinsSchemaDefinition singleton

! !

!PltEXISTSFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltEXISTSFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltEXISTSFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self p: (values at: 1)

! !

!PltEXISTSFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	"---------- native statement ---------- "

	| v |
	^ self return: self p notNil

! !

!PltEXISTSFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p
	^ p

! !

!PltEXISTSFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p: anObject
	p := anObject

! !

PlatypusCoreAlgorithmDeclaration subclass: #PltEXPFunction
	instanceVariableNames: 'p'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-ExpressBuiltinsSchema'!

!PltEXPFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION EXP ( P : NUMBER ) : REAL;
	(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (PltRealLiteral val: (v pltNativeValue) exp)] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: (v exp)] 
		         #*);
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!PltEXPFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltEXPFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltExpressBuiltinsSchemaDefinition singleton

! !

!PltEXPFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltEXPFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltEXPFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self p: (values at: 1)

! !

!PltEXPFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	"---------- native statement ---------- "

	| v |
	^ (v := self p) ifNotNil: [ self return: v exp ]

! !

!PltEXPFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p
	^ p

! !

!PltEXPFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p: aNumber
	p := aNumber

! !

PlatypusCoreAlgorithmDeclaration subclass: #PltFORMATFunction
	instanceVariableNames: 'pN pF'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-ExpressBuiltinsSchema'!

!PltFORMATFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION FORMAT ( PN : NUMBER; PF : STRING ) : STRING;
	(*#          | n f formatted |
			(n := self pN)
				ifMissing: [^ self return: n]
				ifNotMissing: [(f := self pF) 
					ifMissing: [^ self return: f]
					ifNotMissing: [formatted := PlatypusExpressBuiltinFormatFormatter format: n pltNativeValue sourceFormat: f pltNativeValue trimBoth.
						^ self return: (PltStringLiteral val: formatted)]]
		         #*) (*# <pharo> | n f formatted |
			(n := self pN)
				ifNil: [^ self return: n]
				ifNotNil: [(f := self pF) 
					ifNil: [^ self return: f]
					ifNotNil: [formatted := PlatypusExpressBuiltinFormatFormatter format: n sourceFormat: f trimBoth.
						^ self return: formatted]]
		         #*);
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!PltFORMATFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltFORMATFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltExpressBuiltinsSchemaDefinition singleton

! !

!PltFORMATFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltFORMATFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltFORMATFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self pN: (values at: 1).
	self pF: (values at: 2)

! !

!PltFORMATFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	"---------- native statement ---------- "

	| n f formatted |
	(n := self pN)
		ifNil: [ ^ self return: n ]
		ifNotNil: [ 
			(f := self pF)
				ifNil: [ ^ self return: f ]
				ifNotNil: [ 
					formatted := PlatypusExpressBuiltinFormatFormatter format: n sourceFormat: f trimBoth.
					^ self return: formatted ] ]

! !

!PltFORMATFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
pF
	^ pF

! !

!PltFORMATFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
pF: aString
	pF := aString

! !

!PltFORMATFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
pN
	^ pN

! !

!PltFORMATFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
pN: aNumber
	pN := aNumber

! !

!PltFORMATFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
pN: aNumber pF: aString
	self pN: aNumber.
	self pF: aString

! !

PlatypusCoreAlgorithmDeclaration subclass: #PltHIBOUNDFunction
	instanceVariableNames: 'p'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-ExpressBuiltinsSchema'!

!PltHIBOUNDFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION HIBOUND ( P : AGGREGATE OF GENERIC ) : INTEGER;
	(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: v upperBound] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: (v upperBound)] 
		         #*);
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!PltHIBOUNDFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltHIBOUNDFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltExpressBuiltinsSchemaDefinition singleton

! !

!PltHIBOUNDFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltHIBOUNDFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltHIBOUNDFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self p: (values at: 1)

! !

!PltHIBOUNDFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	"---------- native statement ---------- "

	| v |
	^ (v := self p) ifNotNil: [ self return: v upperBound ]

! !

!PltHIBOUNDFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p
	^ p

! !

!PltHIBOUNDFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p: aCollectionOfObject
	p := aCollectionOfObject

! !

PlatypusCoreAlgorithmDeclaration subclass: #PltHIINDEXFunction
	instanceVariableNames: 'p'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-ExpressBuiltinsSchema'!

!PltHIINDEXFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION HIINDEX ( P : AGGREGATE OF GENERIC ) : INTEGER;
	(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [((v := v pltNativeValue) isPltArray)
						ifTrue: [^ self return: (v upperBound)]
						ifFalse: [^ self return: (PltIntegerLiteral val: ( v pltNativeValue ) size)]]
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: (v upperBound)] 
		         #*);
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!PltHIINDEXFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltHIINDEXFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltExpressBuiltinsSchemaDefinition singleton

! !

!PltHIINDEXFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltHIINDEXFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltHIINDEXFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self p: (values at: 1)

! !

!PltHIINDEXFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	"---------- native statement ---------- "

	| v |
	^ (v := self p) ifNotNil: [ self return: v upperBound ]

! !

!PltHIINDEXFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p
	^ p

! !

!PltHIINDEXFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p: aCollectionOfObject
	p := aCollectionOfObject

! !

PlatypusCoreAlgorithmDeclaration subclass: #PltINSERTProcedure
	instanceVariableNames: 'pL pE pP'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-ExpressBuiltinsSchema'!

!PltINSERTProcedure commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
PROCEDURE INSERT ( VAR PL : LIST OF GENERIC : gen; PE : GENERIC : gen; PP : INTEGER );
	(*#         
			| l e p |
			l := self pL.
			e := self pE.
			p := self pP pltNativeValue.
			l pltAdd: e beforeIndex: p
		         #*) (*# <pharo>
			| l e p |
			l := self pL.
			e := self pE.
			p := self pP.
			p <= 0
				ifTrue: [l addFirst: e]
				ifFalse: [p >= l size
						ifTrue: [l addLast: e]
						ifFalse: [l add: e afterIndex: p]]
		         #*);
END_PROCEDURE;
</ISO10303-11-EXPRESS>!

!PltINSERTProcedure class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltINSERTProcedure class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltExpressBuiltinsSchemaDefinition singleton

! !

!PltINSERTProcedure class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltINSERTProcedure class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltINSERTProcedure methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self pL: (values at: 1).
	self pE: (values at: 2).
	self pP: (values at: 3)

! !

!PltINSERTProcedure methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	"---------- native statement ---------- "

	| l e p |
	l := self pL.
	e := self pE.
	p := self pP.
	p <= 0
		ifTrue: [ l addFirst: e ]
		ifFalse: [ 
			p >= l size
				ifTrue: [ l addLast: e ]
				ifFalse: [ l add: e afterIndex: p ] ]

! !

!PltINSERTProcedure methodsFor: 'platypus-generated-accessing' stamp: ''!
pE
	^ pE

! !

!PltINSERTProcedure methodsFor: 'platypus-generated-accessing' stamp: ''!
pE: anObject
	pE := anObject

! !

!PltINSERTProcedure methodsFor: 'platypus-generated-accessing' stamp: ''!
pL
	^ pL

! !

!PltINSERTProcedure methodsFor: 'platypus-generated-accessing' stamp: ''!
pL: aListOfObject
	pL := aListOfObject

! !

!PltINSERTProcedure methodsFor: 'platypus-generated-accessing' stamp: ''!
pL: aListOfObject pE: anObject pP: anInteger
	self pL: aListOfObject.
	self pE: anObject.
	self pP: anInteger

! !

!PltINSERTProcedure methodsFor: 'platypus-generated-accessing' stamp: ''!
pP
	^ pP

! !

!PltINSERTProcedure methodsFor: 'platypus-generated-accessing' stamp: ''!
pP: anInteger
	pP := anInteger

! !

PlatypusCoreAlgorithmDeclaration subclass: #PltLENGTHFunction
	instanceVariableNames: 'p'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-ExpressBuiltinsSchema'!

!PltLENGTHFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION LENGTH ( P : STRING ) : INTEGER;
	(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (PltIntegerLiteral val: (v pltNativeValue) size)] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: (v size)] 
		         #*);
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!PltLENGTHFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltLENGTHFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltExpressBuiltinsSchemaDefinition singleton

! !

!PltLENGTHFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltLENGTHFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltLENGTHFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self p: (values at: 1)

! !

!PltLENGTHFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	"---------- native statement ---------- "

	| v |
	^ (v := self p) ifNotNil: [ self return: v size ]

! !

!PltLENGTHFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p
	^ p

! !

!PltLENGTHFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p: aString
	p := aString

! !

PlatypusCoreAlgorithmDeclaration subclass: #PltLOBOUNDFunction
	instanceVariableNames: 'p'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-ExpressBuiltinsSchema'!

!PltLOBOUNDFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION LOBOUND ( P : AGGREGATE OF GENERIC ) : INTEGER;
	(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [
					(v := v lowerBound)
						ifMissing: [^ self return: (PltIntegerLiteral val: 0)]
						ifNotMissing: [^ self return: v]].
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: (v lowerBound)] 
		         #*);
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!PltLOBOUNDFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltLOBOUNDFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltExpressBuiltinsSchemaDefinition singleton

! !

!PltLOBOUNDFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltLOBOUNDFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltLOBOUNDFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self p: (values at: 1)

! !

!PltLOBOUNDFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	"---------- native statement ---------- "

	| v |
	^ (v := self p) ifNotNil: [ self return: v lowerBound ]

! !

!PltLOBOUNDFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p
	^ p

! !

!PltLOBOUNDFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p: aCollectionOfObject
	p := aCollectionOfObject

! !

PlatypusCoreAlgorithmDeclaration subclass: #PltLOG10Function
	instanceVariableNames: 'p'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-ExpressBuiltinsSchema'!

!PltLOG10Function commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION LOG10 ( P : NUMBER ) : REAL;
	(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (PltRealLiteral val: (v pltNativeValue) log)] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: (v log)] 
		         #*);
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!PltLOG10Function class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltLOG10Function class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltExpressBuiltinsSchemaDefinition singleton

! !

!PltLOG10Function class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltLOG10Function class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltLOG10Function methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self p: (values at: 1)

! !

!PltLOG10Function methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	"---------- native statement ---------- "

	| v |
	^ (v := self p) ifNotNil: [ self return: v log ]

! !

!PltLOG10Function methodsFor: 'platypus-generated-accessing' stamp: ''!
p
	^ p

! !

!PltLOG10Function methodsFor: 'platypus-generated-accessing' stamp: ''!
p: aNumber
	p := aNumber

! !

PlatypusCoreAlgorithmDeclaration subclass: #PltLOG2Function
	instanceVariableNames: 'p'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-ExpressBuiltinsSchema'!

!PltLOG2Function commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION LOG2 ( P : NUMBER ) : REAL;
	(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (PltRealLiteral val: (v pltNativeValue) log: 2)] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: (v log: 2)] 
		         #*);
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!PltLOG2Function class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltLOG2Function class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltExpressBuiltinsSchemaDefinition singleton

! !

!PltLOG2Function class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltLOG2Function class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltLOG2Function methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self p: (values at: 1)

! !

!PltLOG2Function methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	"---------- native statement ---------- "

	| v |
	^ (v := self p) ifNotNil: [ self return: (v log: 2) ]

! !

!PltLOG2Function methodsFor: 'platypus-generated-accessing' stamp: ''!
p
	^ p

! !

!PltLOG2Function methodsFor: 'platypus-generated-accessing' stamp: ''!
p: aNumber
	p := aNumber

! !

PlatypusCoreAlgorithmDeclaration subclass: #PltLOGFunction
	instanceVariableNames: 'p'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-ExpressBuiltinsSchema'!

!PltLOGFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION LOG ( P : NUMBER ) : REAL;
	(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (PltRealLiteral val: (v pltNativeValue) ln)] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: (v ln)] 
		         #*);
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!PltLOGFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltLOGFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltExpressBuiltinsSchemaDefinition singleton

! !

!PltLOGFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltLOGFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltLOGFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self p: (values at: 1)

! !

!PltLOGFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	"---------- native statement ---------- "

	| v |
	^ (v := self p) ifNotNil: [ self return: v ln ]

! !

!PltLOGFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p
	^ p

! !

!PltLOGFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p: aNumber
	p := aNumber

! !

PlatypusCoreAlgorithmDeclaration subclass: #PltLOINDEXFunction
	instanceVariableNames: 'p'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-ExpressBuiltinsSchema'!

!PltLOINDEXFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION LOINDEX ( P : AGGREGATE OF GENERIC ) : INTEGER;
	(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [((v := v pltNativeValue) isPltArray)
						ifTrue: [^ self return: (v lowerBound)]
						ifFalse: [^ self return: (PltIntegerLiteral val: 1)]]
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: (v lowerBound)] 
		         #*);
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!PltLOINDEXFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltLOINDEXFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltExpressBuiltinsSchemaDefinition singleton

! !

!PltLOINDEXFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltLOINDEXFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltLOINDEXFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self p: (values at: 1)

! !

!PltLOINDEXFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	"---------- native statement ---------- "

	| v |
	^ (v := self p) ifNotNil: [ self return: v lowerBound ]

! !

!PltLOINDEXFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p
	^ p

! !

!PltLOINDEXFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p: aCollectionOfObject
	p := aCollectionOfObject

! !

PlatypusCoreAlgorithmDeclaration subclass: #PltNVLFunction
	instanceVariableNames: 'p substitute'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-ExpressBuiltinsSchema'!

!PltNVLFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION NVL ( P : GENERIC : gen1; substitute : GENERIC : gen1 ) : GENERIC : gen1;
	(*#          | v | 
			(v := self p)
				ifMissing: [^ self return: (self substitute)]
				ifNotMissing: [^ self return: (v)]
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNil: [self return: self substitute] ifNotNil: [self return: v] 
		         #*);
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!PltNVLFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltNVLFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltExpressBuiltinsSchemaDefinition singleton

! !

!PltNVLFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltNVLFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltNVLFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self p: (values at: 1).
	self substitute: (values at: 2)

! !

!PltNVLFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	"---------- native statement ---------- "

	| v |
	^ (v := self p) ifNil: [ self return: self substitute ] ifNotNil: [ self return: v ]

! !

!PltNVLFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p
	^ p

! !

!PltNVLFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p: anObject
	p := anObject

! !

!PltNVLFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p: anObject substitute: anObject1
	self p: anObject.
	self substitute: anObject1

! !

!PltNVLFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
substitute
	^ substitute

! !

!PltNVLFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
substitute: anObject1
	substitute := anObject1

! !

PlatypusCoreAlgorithmDeclaration subclass: #PltODDFunction
	instanceVariableNames: 'p'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-ExpressBuiltinsSchema'!

!PltODDFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION ODD ( P : INTEGER ) : BOOLEAN;
	(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (PltLogicalLiteral val: (v pltNativeValue) odd)] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: v odd] 
		         #*);
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!PltODDFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltODDFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltExpressBuiltinsSchemaDefinition singleton

! !

!PltODDFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltODDFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltODDFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self p: (values at: 1)

! !

!PltODDFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	"---------- native statement ---------- "

	| v |
	^ (v := self p) ifNotNil: [ self return: v odd ]

! !

!PltODDFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p
	^ p

! !

!PltODDFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p: anInteger
	p := anInteger

! !

PlatypusCoreAlgorithmDeclaration subclass: #PltREMOVEProcedure
	instanceVariableNames: 'pL pP'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-ExpressBuiltinsSchema'!

!PltREMOVEProcedure commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
PROCEDURE REMOVE ( VAR PL : LIST OF GENERIC : gen; PP : INTEGER );
	(*#         
			| l p |
			l := self pL.
			p := self pP pltNativeValue.
			l removeAt: p	
		         #*) (*# <pharo>
			| l p |
			l := self pL.
			p := self pP.
			l removeAt: p	
		         #*);
END_PROCEDURE;
</ISO10303-11-EXPRESS>!

!PltREMOVEProcedure class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltREMOVEProcedure class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltExpressBuiltinsSchemaDefinition singleton

! !

!PltREMOVEProcedure class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltREMOVEProcedure class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltREMOVEProcedure methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self pL: (values at: 1).
	self pP: (values at: 2)

! !

!PltREMOVEProcedure methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	"---------- native statement ---------- "

	| l p |
	l := self pL.
	p := self pP.
	l removeAt: p

! !

!PltREMOVEProcedure methodsFor: 'platypus-generated-accessing' stamp: ''!
pL
	^ pL

! !

!PltREMOVEProcedure methodsFor: 'platypus-generated-accessing' stamp: ''!
pL: aListOfObject
	pL := aListOfObject

! !

!PltREMOVEProcedure methodsFor: 'platypus-generated-accessing' stamp: ''!
pL: aListOfObject pP: anInteger
	self pL: aListOfObject.
	self pP: anInteger

! !

!PltREMOVEProcedure methodsFor: 'platypus-generated-accessing' stamp: ''!
pP
	^ pP

! !

!PltREMOVEProcedure methodsFor: 'platypus-generated-accessing' stamp: ''!
pP: anInteger
	pP := anInteger

! !

PlatypusCoreAlgorithmDeclaration subclass: #PltROLESOFFunction
	instanceVariableNames: 'p'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-ExpressBuiltinsSchema'!

!PltROLESOFFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION ROLESOF ( P : GENERIC ) : SET OF STRING;
	(*#         
			| arg result tmpResult |
			(arg := self p)
				ifMissing: [^ self return: arg]
				ifNotMissing: [result := PltSetInstance new.
					tmpResult := Set new.
					self
						dataDo: [:d | d rolesOf: arg in: tmpResult].
					result contents: tmpResult.
					^ self return: result]
		         #*) (*# <pharo>
			| arg result |
			(arg := self p)
				ifNil: [^ self return: arg]
				ifNotNil: [
					result := Set new.
					self
						dataDo: [:d | d rolesOf: arg in: result].
					^ self return: result]
		         #*);
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!PltROLESOFFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltROLESOFFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltExpressBuiltinsSchemaDefinition singleton

! !

!PltROLESOFFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltROLESOFFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltROLESOFFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self p: (values at: 1)

! !

!PltROLESOFFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	"---------- native statement ---------- "

	| arg result |
	(arg := self p)
		ifNil: [ ^ self return: arg ]
		ifNotNil: [ 
			result := Set new.
			self dataDo: [ :d | d rolesOf: arg in: result ].
			^ self return: result ]

! !

!PltROLESOFFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p
	^ p

! !

!PltROLESOFFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p: anObject
	p := anObject

! !

PlatypusCoreAlgorithmDeclaration subclass: #PltSINFunction
	instanceVariableNames: 'p'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-ExpressBuiltinsSchema'!

!PltSINFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION SIN ( P : NUMBER ) : REAL;
	(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (PltRealLiteral val: (v pltNativeValue) sin)] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: v sin] 
		         #*);
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!PltSINFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltSINFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltExpressBuiltinsSchemaDefinition singleton

! !

!PltSINFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltSINFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltSINFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self p: (values at: 1)

! !

!PltSINFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	"---------- native statement ---------- "

	| v |
	^ (v := self p) ifNotNil: [ self return: v sin ]

! !

!PltSINFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p
	^ p

! !

!PltSINFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p: aNumber
	p := aNumber

! !

PlatypusCoreAlgorithmDeclaration subclass: #PltSIZEOFFunction
	instanceVariableNames: 'p'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-ExpressBuiltinsSchema'!

!PltSIZEOFFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION SIZEOF ( P : AGGREGATE OF GENERIC ) : INTEGER;
	(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (PltIntegerLiteral val: (v pltNativeValue) size)] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: v size] 
		         #*);
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!PltSIZEOFFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltSIZEOFFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltExpressBuiltinsSchemaDefinition singleton

! !

!PltSIZEOFFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltSIZEOFFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltSIZEOFFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self p: (values at: 1)

! !

!PltSIZEOFFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	"---------- native statement ---------- "

	| v |
	^ (v := self p) ifNotNil: [ self return: v size ]

! !

!PltSIZEOFFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p
	^ p

! !

!PltSIZEOFFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p: aCollectionOfObject
	p := aCollectionOfObject

! !

PlatypusCoreAlgorithmDeclaration subclass: #PltSQRTFunction
	instanceVariableNames: 'p'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-ExpressBuiltinsSchema'!

!PltSQRTFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION SQRT ( P : NUMBER ) : REAL;
	(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (PltRealLiteral val: (v pltNativeValue) sqrt)] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: v sqrt] 
		         #*);
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!PltSQRTFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltSQRTFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltExpressBuiltinsSchemaDefinition singleton

! !

!PltSQRTFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltSQRTFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltSQRTFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self p: (values at: 1)

! !

!PltSQRTFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	"---------- native statement ---------- "

	| v |
	^ (v := self p) ifNotNil: [ self return: v sqrt ]

! !

!PltSQRTFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p
	^ p

! !

!PltSQRTFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p: aNumber
	p := aNumber

! !

PlatypusCoreAlgorithmDeclaration subclass: #PltTANFunction
	instanceVariableNames: 'p'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-ExpressBuiltinsSchema'!

!PltTANFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION TAN ( P : NUMBER ) : REAL;
	(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (PltRealLiteral val: (v pltNativeValue) tan)] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: v tan] 
		         #*);
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!PltTANFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltTANFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltExpressBuiltinsSchemaDefinition singleton

! !

!PltTANFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltTANFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltTANFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self p: (values at: 1)

! !

!PltTANFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	"---------- native statement ---------- "

	| v |
	^ (v := self p) ifNotNil: [ self return: v tan ]

! !

!PltTANFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p
	^ p

! !

!PltTANFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p: aNumber
	p := aNumber

! !

PlatypusCoreAlgorithmDeclaration subclass: #PltTYPEOFFunction
	instanceVariableNames: 'p'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-ExpressBuiltinsSchema'!

!PltTYPEOFFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION TYPEOF ( P : GENERIC ) : SET OF STRING;
	(*#         
			| arg result |
			(arg := self p)
				ifMissing: [^ self return: arg]
				ifNotMissing: [
					result := PltSetInstance new.
					result contents: (PlatypusExpressTypeOfBuilder typeOfSetFor: arg computedDomain).
					^ self return: result]
		         #*) (*# <pharo>
			| arg result |
			(arg := self p)
				ifNil: [^ self return: arg]
				ifNotNil: [
					(arg isKindOf: PlatypusComplexInstance) 
						ifTrue: [result := OrderedCollection new.
							arg records do: [:rec | result addAll: (PlatypusExpressTypeOfBuilder typeOfSetFor: rec class platypusMetaData)]] 
						ifFalse: [result := (PlatypusExpressTypeOfBuilder typeOfSetFor: arg class platypusMetaData)].
					^ self return: (result collect: [:r | r val])]
		         #*);
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!PltTYPEOFFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltTYPEOFFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltExpressBuiltinsSchemaDefinition singleton

! !

!PltTYPEOFFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltTYPEOFFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltTYPEOFFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self p: (values at: 1)

! !

!PltTYPEOFFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	"---------- native statement ---------- "

	| arg result |
	(arg := self p)
		ifNil: [ ^ self return: arg ]
		ifNotNil: [ 
			(arg isKindOf: PlatypusComplexInstance)
				ifTrue: [ 
					result := OrderedCollection new.
					arg records do: [ :rec | result addAll: (PlatypusExpressTypeOfBuilder typeOfSetFor: rec class platypusMetaData) ] ]
				ifFalse: [ result := PlatypusExpressTypeOfBuilder typeOfSetFor: arg class platypusMetaData ].
			^ self return: (result collect: [ :r | r val ]) ]

! !

!PltTYPEOFFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p
	^ p

! !

!PltTYPEOFFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p: anObject
	p := anObject

! !

PlatypusCoreAlgorithmDeclaration subclass: #PltUSEDINFunction
	instanceVariableNames: 't r'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-ExpressBuiltinsSchema'!

!PltUSEDINFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION USEDIN ( T : GENERIC; R : STRING ) : BAG OF GENERIC;
	(*#         
			| result tmpResult ent role schemaEntityAttribute schemaKey entityKey attributeKey |
			ent := self t.
			role := self r.
			result := PltBagInstance new.
			ent 
				ifMissing: [^ self return: ent]
				ifNotMissing: [
					role 
						ifMissing: [^ self return: role]
						ifNotMissing: [
							tmpResult := Bag new.
							role pltNativeValue 
								ifEmpty: [schemaKey := ''.
									entityKey := ''.
									attributeKey := '']
								ifNotEmpty: [:arg | schemaEntityAttribute := role pltNativeValue findTokens: $..
									schemaKey := schemaEntityAttribute first asUppercase.
									entityKey := schemaEntityAttribute second asUppercase.
									attributeKey := schemaEntityAttribute third asUppercase].
							self
								dataDo: [:d | d
									rolesValue: ent
									roleSchema: schemaKey
									roleEntity: entityKey
									roleAttribute: attributeKey
									in: tmpResult].
							result contents: tmpResult.
							^ self return: result]]
		         #*) (*# <pharo>
			| result tmpResult ent role schemaEntityAttribute schemaKey entityKey attributeKey |
			ent := self t.
			role := self r.
			result := Bag new.
			ent 
				ifNil: [^ self return: ent]
				ifNotNil: [
					role 
						ifNil: [^ self return: role]
						ifNotNil: [
							role 
								ifEmpty: [schemaKey := ''.
									entityKey := ''.
									attributeKey := '']
								ifNotEmpty: [:arg | schemaEntityAttribute := role findTokens: $..
									schemaKey := schemaEntityAttribute first asUppercase.
									entityKey := schemaEntityAttribute second asUppercase.
									attributeKey := schemaEntityAttribute third asUppercase].
							self
								dataDo: [:d | d
									rolesValue: ent
									roleSchema: schemaKey
									roleEntity: entityKey
									roleAttribute: attributeKey
									in: result].
							^ self return: result]]
		         #*);
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!PltUSEDINFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltUSEDINFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltExpressBuiltinsSchemaDefinition singleton

! !

!PltUSEDINFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltUSEDINFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltUSEDINFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self t: (values at: 1).
	self r: (values at: 2)

! !

!PltUSEDINFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	"---------- native statement ---------- "

	| result tmpResult ent role schemaEntityAttribute schemaKey entityKey attributeKey |
	ent := self t.
	role := self r.
	result := Bag new.
	ent
		ifNil: [ ^ self return: ent ]
		ifNotNil: [ 
			role
				ifNil: [ ^ self return: role ]
				ifNotNil: [ 
					role
						ifEmpty: [ 
							schemaKey := ''.
							entityKey := ''.
							attributeKey := '' ]
						ifNotEmpty: [ :arg | 
							schemaEntityAttribute := role findTokens: $..
							schemaKey := schemaEntityAttribute first asUppercase.
							entityKey := schemaEntityAttribute second asUppercase.
							attributeKey := schemaEntityAttribute third asUppercase ].
					self
						dataDo: [ :d | 
							d
								rolesValue: ent
								roleSchema: schemaKey
								roleEntity: entityKey
								roleAttribute: attributeKey
								in: result ].
					^ self return: result ] ]

! !

!PltUSEDINFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
r
	^ r

! !

!PltUSEDINFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
r: aString
	r := aString

! !

!PltUSEDINFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
t
	^ t

! !

!PltUSEDINFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
t: anObject
	t := anObject

! !

!PltUSEDINFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
t: anObject r: aString
	self t: anObject.
	self r: aString

! !

PlatypusCoreAlgorithmDeclaration subclass: #PltVALUEFunction
	instanceVariableNames: 'v'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-ExpressBuiltinsSchema'!

!PltVALUEFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION VALUE ( V : STRING ) : NUMBER;
	(*#          | param nb result |
			param := self v.
			param pltNativeValue isString
				ifTrue: [[nb := param pltNativeValue asNumber.
					result := nb isInteger
								ifTrue: [PltIntegerLiteral new]
								ifFalse: [PltRealLiteral new].
					result val: nb]
						on: Error
						do: [result := PltMissingValue new]]
				ifFalse: [result := PltMissingValue new].
			^ self return: result
		         #*) (*# <pharo> | param nb result |
			(param := self v) isString
				ifTrue: [[result := param asNumber]
						on: Error
						do: [result := nil]]
				ifFalse: [result := nil].
			^ self return: result
		         #*);
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!PltVALUEFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltVALUEFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltExpressBuiltinsSchemaDefinition singleton

! !

!PltVALUEFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltVALUEFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltVALUEFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self v: (values at: 1)

! !

!PltVALUEFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	"---------- native statement ---------- "

	| param nb result |
	(param := self v) isString
		ifTrue: [ [ result := param asNumber ] on: Error do: [ result := nil ] ]
		ifFalse: [ result := nil ].
	^ self return: result

! !

!PltVALUEFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
v
	^ v

! !

!PltVALUEFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
v: aString
	v := aString

! !

PlatypusCoreAlgorithmDeclaration subclass: #PltValueInFunction
	instanceVariableNames: 'c v'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-ExpressBuiltinsSchema'!

!PltValueInFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION VALUE_IN ( C : AGGREGATE OF GENERIC : gen; V : GENERIC : gen ) : LOGICAL;
	(*#          self signal: 'Value_in primitive is not implemented'.          #*) (*# <pharo> self signal: 'VALUE_IN primitive is not implemented'.          #*);
	RETURN ( ? );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!PltValueInFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltValueInFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltExpressBuiltinsSchemaDefinition singleton

! !

!PltValueInFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltValueInFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltValueInFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
c
	^ c

! !

!PltValueInFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
c: aCollectionOfObject
	c := aCollectionOfObject

! !

!PltValueInFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
c: aCollectionOfObject v: anObject
	self c: aCollectionOfObject.
	self v: anObject

! !

!PltValueInFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self c: (values at: 1).
	self v: (values at: 2)

! !

!PltValueInFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	"---------- native statement ---------- "

	self signal: 'VALUE_IN primitive is not implemented'.
	^ self return: nil

! !

!PltValueInFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
v
	^ v

! !

!PltValueInFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
v: anObject
	v := anObject

! !

PlatypusCoreAlgorithmDeclaration subclass: #PltValueUniqueFunction
	instanceVariableNames: 'v'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-ExpressBuiltinsSchema'!

!PltValueUniqueFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION VALUE_UNIQUE ( V : AGGREGATE OF GENERIC ) : LOGICAL;
	(*#          self signal: 'Value_unique primitive is not implemented'.          #*) (*# <pharo> self signal: 'VALUE_UNIQUE primitive is not implemented'.          #*);
	RETURN ( ? );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!PltValueUniqueFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltValueUniqueFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltExpressBuiltinsSchemaDefinition singleton

! !

!PltValueUniqueFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltValueUniqueFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltValueUniqueFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self v: (values at: 1)

! !

!PltValueUniqueFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	"---------- native statement ---------- "

	self signal: 'VALUE_UNIQUE primitive is not implemented'.
	^ self return: nil

! !

!PltValueUniqueFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
v
	^ v

! !

!PltValueUniqueFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
v: aCollectionOfObject
	v := aCollectionOfObject

! !

PlatypusCoreObject subclass: #PlatypusCoreContextDefinition
	instanceVariableNames: 'metaData owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-core'!

PlatypusCoreContextDefinition class
	instanceVariableNames: 'singleton'!

PlatypusCoreContextDefinition class
	instanceVariableNames: 'singleton'!

!PlatypusCoreContextDefinition class methodsFor: 'accessing' stamp: 'apl 4/20/2006 09:57'!
lookUpIdentifierBN: aName 
	^ self singleton lookUpIdentifierBN: aName 
! !

!PlatypusCoreContextDefinition class methodsFor: 'accessing' stamp: 'apl 4/20/2006 09:57'!
lookUpNamedTypeBN: aName 
	^ self singleton lookUpNamedTypeBN: aName! !

!PlatypusCoreContextDefinition class methodsFor: 'accessing' stamp: 'alain.plantec 1/20/2009 11:55'!
reinitializeSingleton
	singleton
		ifNotNil: [singleton metaData ifNotNil: [singleton metaData deepDestroy]].
	singleton := nil! !

!PlatypusCoreContextDefinition class methodsFor: 'accessing' stamp: 'alain.plantec 1/20/2009 11:56'!
singleton
	^ singleton ifNil: [singleton := self new]! !

!PlatypusCoreContextDefinition methodsFor: 'private accessing' stamp: 'apl 3/15/2005 13:14'!
entityDefinitionClassInfos
	| result |
	result := OrderedCollection new.
	1
		to: self entityDefinitionCount
		do: [:cpt | result
				add: (self perform: ('entityDefinition' , cpt asString) asSymbol)].
	^ result! !

!PlatypusCoreContextDefinition methodsFor: 'private accessing' stamp: 'apl 3/15/2005 13:12'!
entityDefinitionCount
	self subclassResponsibility ! !

!PlatypusCoreContextDefinition methodsFor: 'private accessing' stamp: 'apl 3/15/2005 13:11'!
functionDeclarationClassInfos
	| result |
	result := OrderedCollection new.
	1
		to: self functionDeclarationCount
		do: [:cpt | result
				add: (self perform: ('functionDeclaration' , cpt asString) asSymbol)].
	^ result! !

!PlatypusCoreContextDefinition methodsFor: 'private accessing' stamp: 'apl 3/15/2005 13:13'!
functionDeclarationCount
	self subclassResponsibility! !

!PlatypusCoreContextDefinition methodsFor: 'private initializing' stamp: 'apl 3/15/2005 13:31'!
initializeFromOwner: myOwner 
	| metaDataByClassNameIndex classNamesByMetaDataNameIndex elementName elementClassName |
	owner := myOwner.
	metaDataByClassNameIndex := myOwner metaDataByClassNameIndex.
	classNamesByMetaDataNameIndex := myOwner classNamesByMetaDataNameIndex.
	metaDataByClassNameIndex at: self class name asSymbol put: self metaData.
	self entityDefinitionClassInfos , self functionDeclarationClassInfos
		do: [:info | 
			elementName := info first.
			elementClassName := info second.
			metaDataByClassNameIndex
				at: elementClassName asSymbol
				put: ((self metaData lookUpNamedTypeBN: elementName)
						ifNil: [self metaData lookUpIdentifierBN: elementName]).
			classNamesByMetaDataNameIndex at: elementName asUppercase asSymbol put: elementClassName asSymbol]! !

!PlatypusCoreContextDefinition methodsFor: 'accessing' stamp: 'apl 1/17/2007 13:00'!
lookUpIdentifierBN: aName 
	self metaData isNil
		ifTrue: [self schemaInstance buildIndexes].
	^ self metaData lookUpIdentifierBN: aName! !

!PlatypusCoreContextDefinition methodsFor: 'accessing' stamp: 'apl 4/20/2006 09:56'!
lookUpNamedTypeBN: aName 
	^ self metaData
		ifNotNil: [self metaData lookUpNamedTypeBN: aName]! !

!PlatypusCoreContextDefinition methodsFor: 'accessing' stamp: 'apl 3/15/2005 08:48'!
metaData
	^ metaData! !

!PlatypusCoreContextDefinition methodsFor: 'accessing' stamp: 'apl 3/15/2005 08:48'!
metaData: anObject 
	metaData := anObject! !

!PlatypusCoreContextDefinition methodsFor: 'accessing' stamp: 'apl 3/15/2005 10:05'!
metaDataByClassNameIndex
	^ self schemaInstance metaDataByClassNameIndex! !

!PlatypusCoreContextDefinition methodsFor: 'accessing' stamp: 'AlainPlantec 10/26/2011 23:00'!
metaDataFor: aSymbol
	^ self schemaInstance metaDataFor: aSymbol! !

!PlatypusCoreContextDefinition methodsFor: 'accessing' stamp: 'apl 6/28/2005 19:41'!
metaDataForInstance: anObject 
	^self metaDataFor: anObject class name! !

!PlatypusCoreContextDefinition methodsFor: 'accessing' stamp: 'apl 3/15/2005 10:34'!
owner
	^owner! !

!PlatypusCoreContextDefinition methodsFor: 'accessing' stamp: 'apl 3/15/2005 10:34'!
owner: anObject
	owner := anObject! !

!PlatypusCoreContextDefinition methodsFor: 'accessing' stamp: 'apl 3/15/2005 08:40'!
schemaInstance
	^ self schemaInstanceClass singleton
! !

!PlatypusCoreContextDefinition methodsFor: 'private accessing' stamp: 'AlainPlantec 7/14/2011 16:55'!
schemaInstanceClass
	^ PlatypusPharoSmalltalk
		at: self schemaInstanceClassName 
		ifAbsent: []! !

!PlatypusCoreContextDefinition methodsFor: 'private accessing' stamp: 'apl 3/15/2005 08:52'!
schemaInstanceClassName
	^ self shouldNotImplement! !

PlatypusCoreContextDefinition subclass: #PlatypusCoreSchema
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-core'!

PlatypusCoreSchema subclass: #PltExpressBuiltinsSchemaDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-ExpressBuiltinsSchema'!

!PltExpressBuiltinsSchemaDefinition commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
SCHEMA EXPRESS_builtins;

	FUNCTION ABS ( P : NUMBER ) : NUMBER;
		(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (v class val: (v pltNativeValue) abs)] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: (v abs)] 
		         #*);
	END_FUNCTION;

	FUNCTION ACOS ( P : NUMBER ) : REAL;
		(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (PltRealLiteral val: (v pltNativeValue) arcCos)] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: (v arcCos)] 
		         #*);
	END_FUNCTION;

	FUNCTION ASIN ( P : NUMBER ) : REAL;
		(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (PltRealLiteral val: (v pltNativeValue) arcSin)] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: (v arcSin)] 
		         #*);
	END_FUNCTION;

	FUNCTION ATAN ( V1 : NUMBER; V2 : NUMBER ) : REAL;
		(*#          | v |
			(v := self v1)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (PltRealLiteral val: (v pltNativeValue) arcTan)] 
		         #*) (*# <pharo> | v |
			^ (v := self v1) ifNotNil: [self return: (v arcTan)] 
		         #*);
	END_FUNCTION;

	FUNCTION BLENGTH ( P : BINARY ) : INTEGER;
		(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (PltIntegerLiteral val: (v pltNativeValue) size)] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: (v size)] 
		         #*);
	END_FUNCTION;

	FUNCTION COS ( P : NUMBER ) : REAL;
		(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (PltRealLiteral val: (v pltNativeValue) cos)] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: (v cos)] 
		         #*);
	END_FUNCTION;

	FUNCTION EVEN ( P : NUMBER ) : BOOLEAN;
		(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (PltLogicalLiteral val: (v pltNativeValue) even)] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: (v even)] 
		         #*);
	END_FUNCTION;

	FUNCTION EXISTS ( P : GENERIC ) : BOOLEAN;
		(*#          
			(self p)
				ifMissing: [^ self return: (PltLogicalLiteral val: false) ]
				ifNotMissing: [^ self return: (PltLogicalLiteral val: true) ] 
		         #*) (*# <pharo> | v |
			^ (self return: self p notNil)
		         #*);
	END_FUNCTION;

	FUNCTION EXP ( P : NUMBER ) : REAL;
		(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (PltRealLiteral val: (v pltNativeValue) exp)] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: (v exp)] 
		         #*);
	END_FUNCTION;

	FUNCTION FORMAT ( PN : NUMBER; PF : STRING ) : STRING;
		(*#          | n f formatted |
			(n := self pN)
				ifMissing: [^ self return: n]
				ifNotMissing: [(f := self pF) 
					ifMissing: [^ self return: f]
					ifNotMissing: [formatted := PlatypusExpressBuiltinFormatFormatter format: n pltNativeValue sourceFormat: f pltNativeValue trimBoth.
						^ self return: (PltStringLiteral val: formatted)]]
		         #*) (*# <pharo> | n f formatted |
			(n := self pN)
				ifNil: [^ self return: n]
				ifNotNil: [(f := self pF) 
					ifNil: [^ self return: f]
					ifNotNil: [formatted := PlatypusExpressBuiltinFormatFormatter format: n sourceFormat: f trimBoth.
						^ self return: formatted]]
		         #*);
	END_FUNCTION;

	FUNCTION HIBOUND ( P : AGGREGATE OF GENERIC ) : INTEGER;
		(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: v upperBound] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: (v upperBound)] 
		         #*);
	END_FUNCTION;

	FUNCTION HIINDEX ( P : AGGREGATE OF GENERIC ) : INTEGER;
		(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [((v := v pltNativeValue) isPltArray)
						ifTrue: [^ self return: (v upperBound)]
						ifFalse: [^ self return: (PltIntegerLiteral val: ( v pltNativeValue ) size)]]
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: (v upperBound)] 
		         #*);
	END_FUNCTION;

	FUNCTION LENGTH ( P : STRING ) : INTEGER;
		(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (PltIntegerLiteral val: (v pltNativeValue) size)] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: (v size)] 
		         #*);
	END_FUNCTION;

	FUNCTION LOBOUND ( P : AGGREGATE OF GENERIC ) : INTEGER;
		(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [
					(v := v lowerBound)
						ifMissing: [^ self return: (PltIntegerLiteral val: 0)]
						ifNotMissing: [^ self return: v]].
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: (v lowerBound)] 
		         #*);
	END_FUNCTION;

	FUNCTION LOG ( P : NUMBER ) : REAL;
		(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (PltRealLiteral val: (v pltNativeValue) ln)] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: (v ln)] 
		         #*);
	END_FUNCTION;

	FUNCTION LOG2 ( P : NUMBER ) : REAL;
		(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (PltRealLiteral val: (v pltNativeValue) log: 2)] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: (v log: 2)] 
		         #*);
	END_FUNCTION;

	FUNCTION LOG10 ( P : NUMBER ) : REAL;
		(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (PltRealLiteral val: (v pltNativeValue) log)] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: (v log)] 
		         #*);
	END_FUNCTION;

	FUNCTION LOINDEX ( P : AGGREGATE OF GENERIC ) : INTEGER;
		(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [((v := v pltNativeValue) isPltArray)
						ifTrue: [^ self return: (v lowerBound)]
						ifFalse: [^ self return: (PltIntegerLiteral val: 1)]]
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: (v lowerBound)] 
		         #*);
	END_FUNCTION;

	FUNCTION ODD ( P : INTEGER ) : BOOLEAN;
		(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (PltLogicalLiteral val: (v pltNativeValue) odd)] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: v odd] 
		         #*);
	END_FUNCTION;

	FUNCTION ROLESOF ( P : GENERIC ) : SET OF STRING;
		(*#         
			| arg result tmpResult |
			(arg := self p)
				ifMissing: [^ self return: arg]
				ifNotMissing: [result := PltSetInstance new.
					tmpResult := Set new.
					self
						dataDo: [:d | d rolesOf: arg in: tmpResult].
					result contents: tmpResult.
					^ self return: result]
		         #*) (*# <pharo>
			| arg result |
			(arg := self p)
				ifNil: [^ self return: arg]
				ifNotNil: [
					result := Set new.
					self
						dataDo: [:d | d rolesOf: arg in: result].
					^ self return: result]
		         #*);
	END_FUNCTION;

	FUNCTION SIN ( P : NUMBER ) : REAL;
		(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (PltRealLiteral val: (v pltNativeValue) sin)] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: v sin] 
		         #*);
	END_FUNCTION;

	FUNCTION SIZEOF ( P : AGGREGATE OF GENERIC ) : INTEGER;
		(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (PltIntegerLiteral val: (v pltNativeValue) size)] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: v size] 
		         #*);
	END_FUNCTION;

	FUNCTION SQRT ( P : NUMBER ) : REAL;
		(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (PltRealLiteral val: (v pltNativeValue) sqrt)] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: v sqrt] 
		         #*);
	END_FUNCTION;

	FUNCTION TAN ( P : NUMBER ) : REAL;
		(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (PltRealLiteral val: (v pltNativeValue) tan)] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: v tan] 
		         #*);
	END_FUNCTION;

	FUNCTION TYPEOF ( P : GENERIC ) : SET OF STRING;
		(*#         
			| arg result |
			(arg := self p)
				ifMissing: [^ self return: arg]
				ifNotMissing: [
					result := PltSetInstance new.
					result contents: (PlatypusExpressTypeOfBuilder typeOfSetFor: arg computedDomain).
					^ self return: result]
		         #*) (*# <pharo>
			| arg result |
			(arg := self p)
				ifNil: [^ self return: arg]
				ifNotNil: [
					(arg isKindOf: PlatypusComplexInstance) 
						ifTrue: [result := OrderedCollection new.
							arg records do: [:rec | result addAll: (PlatypusExpressTypeOfBuilder typeOfSetFor: rec class platypusMetaData)]] 
						ifFalse: [result := (PlatypusExpressTypeOfBuilder typeOfSetFor: arg class platypusMetaData)].
					^ self return: (result collect: [:r | r val])]
		         #*);
	END_FUNCTION;

	FUNCTION USEDIN ( T : GENERIC; R : STRING ) : BAG OF GENERIC;
		(*#         
			| result tmpResult ent role schemaEntityAttribute schemaKey entityKey attributeKey |
			ent := self t.
			role := self r.
			result := PltBagInstance new.
			ent 
				ifMissing: [^ self return: ent]
				ifNotMissing: [
					role 
						ifMissing: [^ self return: role]
						ifNotMissing: [
							tmpResult := Bag new.
							role pltNativeValue 
								ifEmpty: [schemaKey := ''.
									entityKey := ''.
									attributeKey := '']
								ifNotEmpty: [:arg | schemaEntityAttribute := role pltNativeValue findTokens: $..
									schemaKey := schemaEntityAttribute first asUppercase.
									entityKey := schemaEntityAttribute second asUppercase.
									attributeKey := schemaEntityAttribute third asUppercase].
							self
								dataDo: [:d | d
									rolesValue: ent
									roleSchema: schemaKey
									roleEntity: entityKey
									roleAttribute: attributeKey
									in: tmpResult].
							result contents: tmpResult.
							^ self return: result]]
		         #*) (*# <pharo>
			| result tmpResult ent role schemaEntityAttribute schemaKey entityKey attributeKey |
			ent := self t.
			role := self r.
			result := Bag new.
			ent 
				ifNil: [^ self return: ent]
				ifNotNil: [
					role 
						ifNil: [^ self return: role]
						ifNotNil: [
							role 
								ifEmpty: [schemaKey := ''.
									entityKey := ''.
									attributeKey := '']
								ifNotEmpty: [:arg | schemaEntityAttribute := role findTokens: $..
									schemaKey := schemaEntityAttribute first asUppercase.
									entityKey := schemaEntityAttribute second asUppercase.
									attributeKey := schemaEntityAttribute third asUppercase].
							self
								dataDo: [:d | d
									rolesValue: ent
									roleSchema: schemaKey
									roleEntity: entityKey
									roleAttribute: attributeKey
									in: result].
							^ self return: result]]
		         #*);
	END_FUNCTION;

	FUNCTION VALUE ( V : STRING ) : NUMBER;
		(*#          | param nb result |
			param := self v.
			param pltNativeValue isString
				ifTrue: [[nb := param pltNativeValue asNumber.
					result := nb isInteger
								ifTrue: [PltIntegerLiteral new]
								ifFalse: [PltRealLiteral new].
					result val: nb]
						on: Error
						do: [result := PltMissingValue new]]
				ifFalse: [result := PltMissingValue new].
			^ self return: result
		         #*) (*# <pharo> | param nb result |
			(param := self v) isString
				ifTrue: [[result := param asNumber]
						on: Error
						do: [result := nil]]
				ifFalse: [result := nil].
			^ self return: result
		         #*);
	END_FUNCTION;

	FUNCTION VALUE_IN ( C : AGGREGATE OF GENERIC : gen; V : GENERIC : gen ) : LOGICAL;
		(*#          self signal: 'Value_in primitive is not implemented'.          #*) (*# <pharo> self signal: 'VALUE_IN primitive is not implemented'.          #*);
		RETURN ( ? );
	END_FUNCTION;

	FUNCTION VALUE_UNIQUE ( V : AGGREGATE OF GENERIC ) : LOGICAL;
		(*#          self signal: 'Value_unique primitive is not implemented'.          #*) (*# <pharo> self signal: 'VALUE_UNIQUE primitive is not implemented'.          #*);
		RETURN ( ? );
	END_FUNCTION;

	PROCEDURE INSERT ( VAR PL : LIST OF GENERIC : gen; PE : GENERIC : gen; PP : INTEGER );
		(*#         
			| l e p |
			l := self pL.
			e := self pE.
			p := self pP pltNativeValue.
			l pltAdd: e beforeIndex: p
		         #*) (*# <pharo>
			| l e p |
			l := self pL.
			e := self pE.
			p := self pP.
			p <= 0
				ifTrue: [l addFirst: e]
				ifFalse: [p >= l size
						ifTrue: [l addLast: e]
						ifFalse: [l add: e afterIndex: p]]
		         #*);
	END_PROCEDURE;

	PROCEDURE REMOVE ( VAR PL : LIST OF GENERIC : gen; PP : INTEGER );
		(*#         
			| l p |
			l := self pL.
			p := self pP pltNativeValue.
			l removeAt: p	
		         #*) (*# <pharo>
			| l p |
			l := self pL.
			p := self pP.
			l removeAt: p	
		         #*);
	END_PROCEDURE;

	FUNCTION NVL ( P : GENERIC : gen1; substitute : GENERIC : gen1 ) : GENERIC : gen1;
		(*#          | v | 
			(v := self p)
				ifMissing: [^ self return: (self substitute)]
				ifNotMissing: [^ self return: (v)]
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNil: [self return: self substitute] ifNotNil: [self return: v] 
		         #*);
	END_FUNCTION;
END_SCHEMA;

</ISO10303-11-EXPRESS>!

!PltExpressBuiltinsSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltExpressBuiltinsSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltExpressBuiltinsSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltExpressBuiltinsSchemaDefinition methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context
	^ self schemaInstance context

! !

!PltExpressBuiltinsSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinitionCount
	^ 0

! !

!PltExpressBuiltinsSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration1
	^ #(#ABS #PltABSFunction)

! !

!PltExpressBuiltinsSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration10
	^ #(#FORMAT #PltFORMATFunction)

! !

!PltExpressBuiltinsSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration11
	^ #(#HIBOUND #PltHIBOUNDFunction)

! !

!PltExpressBuiltinsSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration12
	^ #(#HIINDEX #PltHIINDEXFunction)

! !

!PltExpressBuiltinsSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration13
	^ #(#LENGTH #PltLENGTHFunction)

! !

!PltExpressBuiltinsSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration14
	^ #(#LOBOUND #PltLOBOUNDFunction)

! !

!PltExpressBuiltinsSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration15
	^ #(#LOG #PltLOGFunction)

! !

!PltExpressBuiltinsSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration16
	^ #(#LOG2 #PltLOG2Function)

! !

!PltExpressBuiltinsSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration17
	^ #(#LOG10 #PltLOG10Function)

! !

!PltExpressBuiltinsSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration18
	^ #(#LOINDEX #PltLOINDEXFunction)

! !

!PltExpressBuiltinsSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration19
	^ #(#ODD #PltODDFunction)

! !

!PltExpressBuiltinsSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration2
	^ #(#ACOS #PltACOSFunction)

! !

!PltExpressBuiltinsSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration20
	^ #(#ROLESOF #PltROLESOFFunction)

! !

!PltExpressBuiltinsSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration21
	^ #(#SIN #PltSINFunction)

! !

!PltExpressBuiltinsSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration22
	^ #(#SIZEOF #PltSIZEOFFunction)

! !

!PltExpressBuiltinsSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration23
	^ #(#SQRT #PltSQRTFunction)

! !

!PltExpressBuiltinsSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration24
	^ #(#TAN #PltTANFunction)

! !

!PltExpressBuiltinsSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration25
	^ #(#TYPEOF #PltTYPEOFFunction)

! !

!PltExpressBuiltinsSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration26
	^ #(#USEDIN #PltUSEDINFunction)

! !

!PltExpressBuiltinsSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration27
	^ #(#VALUE #PltVALUEFunction)

! !

!PltExpressBuiltinsSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration28
	^ #(#VALUE_IN #PltValueInFunction)

! !

!PltExpressBuiltinsSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration29
	^ #(#VALUE_UNIQUE #PltValueUniqueFunction)

! !

!PltExpressBuiltinsSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration3
	^ #(#ASIN #PltASINFunction)

! !

!PltExpressBuiltinsSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration30
	^ #(#NVL #PltNVLFunction)

! !

!PltExpressBuiltinsSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration4
	^ #(#ATAN #PltATANFunction)

! !

!PltExpressBuiltinsSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration5
	^ #(#BLENGTH #PltBLENGTHFunction)

! !

!PltExpressBuiltinsSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration6
	^ #(#COS #PltCOSFunction)

! !

!PltExpressBuiltinsSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration7
	^ #(#EVEN #PltEVENFunction)

! !

!PltExpressBuiltinsSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration8
	^ #(#EXISTS #PltEXISTSFunction)

! !

!PltExpressBuiltinsSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration9
	^ #(#EXP #PltEXPFunction)

! !

!PltExpressBuiltinsSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclarationCount
	^ 30

! !

!PltExpressBuiltinsSchemaDefinition methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstanceClassName
	^ #PltPlatypusExpressPrimitivesSchemaInstance

! !

PlatypusCoreSchema subclass: #PltPlatypusAggregateDataSchemaSchemaDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusAggregateDataSchemaSchema'!

!PltPlatypusAggregateDataSchemaSchemaDefinition commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
SCHEMA Platypus_aggregate_data_schema;
	USE FROM Platypus_population_schema;
	USE FROM Platypus_dictionary_schema;
	USE FROM Platypus_expressions_schema;

	ENTITY aggregate_data 
		ABSTRACT SUPERTYPE OF ( ONEOF ( aggregate_instance, aggregate_initializer ) ) 
		SUBTYPE OF ( expression );
	END_ENTITY;

	ENTITY aggregate_initializer 
		SUBTYPE OF ( aggregate_data );
		contents : LIST OF aggregate_initializer_element;
	END_ENTITY;

	ENTITY aggregate_initializer_element 
		SUBTYPE OF ( dictionary_instance );
		SELF\entity_instance.owner : aggregate_initializer;
		val : primitive;
		repetition : OPTIONAL expression;
	END_ENTITY;

	ENTITY aggregate_instance 
		ABSTRACT SUPERTYPE OF ( ONEOF ( array_instance, variable_size_aggregation_instance ) ) 
		SUBTYPE OF ( aggregate_data );
		lower_bound : integer_literal;
		upper_bound : integer_literal;
	END_ENTITY;

	ENTITY array_instance 
		SUBTYPE OF ( aggregate_instance );
		contents : LIST OF primitive;
	END_ENTITY;

	ENTITY variable_size_aggregation_instance 
		ABSTRACT SUPERTYPE OF ( ONEOF ( set_instance, bag_instance, list_instance ) ) 
		SUBTYPE OF ( aggregate_instance );
	END_ENTITY;

	ENTITY list_instance 
		SUBTYPE OF ( variable_size_aggregation_instance );
		contents : LIST OF primitive;
	END_ENTITY;

	ENTITY bag_instance 
		SUBTYPE OF ( variable_size_aggregation_instance );
		contents : BAG OF primitive;
	END_ENTITY;

	ENTITY set_instance 
		SUBTYPE OF ( variable_size_aggregation_instance );
		contents : SET OF primitive;
	END_ENTITY;
END_SCHEMA;

</ISO10303-11-EXPRESS>!

!PltPlatypusAggregateDataSchemaSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltPlatypusAggregateDataSchemaSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltPlatypusAggregateDataSchemaSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltPlatypusAggregateDataSchemaSchemaDefinition methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context
	^ self schemaInstance context

! !

!PltPlatypusAggregateDataSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition1
	^ #(#aggregate_data #PltAggregateData)

! !

!PltPlatypusAggregateDataSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition2
	^ #(#aggregate_initializer #PltAggregateInitializer)

! !

!PltPlatypusAggregateDataSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition3
	^ #(#aggregate_initializer_element #PltAggregateInitializerElement)

! !

!PltPlatypusAggregateDataSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition4
	^ #(#aggregate_instance #PltAggregateInstance)

! !

!PltPlatypusAggregateDataSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition5
	^ #(#array_instance #PltArrayInstance)

! !

!PltPlatypusAggregateDataSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition6
	^ #(#variable_size_aggregation_instance #PltVariableSizeAggregationInstance)

! !

!PltPlatypusAggregateDataSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition7
	^ #(#list_instance #PltListInstance)

! !

!PltPlatypusAggregateDataSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition8
	^ #(#bag_instance #PltBagInstance)

! !

!PltPlatypusAggregateDataSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition9
	^ #(#set_instance #PltSetInstance)

! !

!PltPlatypusAggregateDataSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinitionCount
	^ 9

! !

!PltPlatypusAggregateDataSchemaSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclarationCount
	^ 0

! !

!PltPlatypusAggregateDataSchemaSchemaDefinition methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstanceClassName
	^ #PltPlatypusMetaSchemasSchemaInstance

! !

PlatypusCoreSchema subclass: #PltPlatypusDictionarySchemaSchemaDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltPlatypusDictionarySchemaSchemaDefinition commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
SCHEMA Platypus_dictionary_schema;
	USE FROM Platypus_expressions_schema;
	USE FROM Platypus_statements_schema;
	USE FROM Platypus_population_schema;
	USE FROM Platypus_environment_schema;
	USE FROM Platypus_aggregate_data_schema;

	TYPE constructed_type = SELECT
		( enumeration_type, select_type );
	END_TYPE;

	TYPE type_or_rule = SELECT
		( named_type, global_rule );
	END_TYPE;

	TYPE base_type = SELECT
		( simple_type, aggregation_type, named_type_reference );
	END_TYPE;

	TYPE underlying_type = SELECT
		( simple_type, aggregation_type, named_type_reference, constructed_type );
	END_TYPE;

	TYPE parameter_type = SELECT
		( simple_type, aggregate_type, aggregate_initializer_domain, named_type_reference );
	END_TYPE;

	TYPE declaration = SELECT
		( named_type, global_rule, constant_definition, procedure_declaration );
	END_TYPE;

	TYPE time_stamp = STRING ( 256 );
	END_TYPE;

	TYPE primitive = expression;
	END_TYPE;

	TYPE schema_name = STRING;
	END_TYPE;

	TYPE context_owner = SELECT
		( context_definition, schema_instance );
	END_TYPE;

	TYPE inter_schema_link = ENUMERATION
		OF ( used, referenced );
	END_TYPE;

	ENTITY entity_instance 
		ABSTRACT SUPERTYPE;
		owner : OPTIONAL entity_instance;
	END_ENTITY;

	ENTITY sdai_instance 
		ABSTRACT SUPERTYPE OF ( ONEOF ( dictionary_instance, session_instance ) ) 
		SUBTYPE OF ( entity_instance );
	END_ENTITY;

	ENTITY dictionary_instance 
		ABSTRACT SUPERTYPE 
		SUBTYPE OF ( sdai_instance );
	DERIVE
		handled : dictionary_instance := SELF;
	END_ENTITY;

	ENTITY session_instance 
		ABSTRACT SUPERTYPE 
		SUBTYPE OF ( sdai_instance );
		change_date : OPTIONAL time_stamp;
		validation_date : time_stamp;
		validation_result : LOGICAL;
	END_ENTITY;

	ENTITY domain_equivalent_item 
		SUBTYPE OF ( dictionary_instance );
		name : STRING;
		external_item_id : STRING;
		native_item : declaration;
	END_ENTITY;

	ENTITY context_definition 
		ABSTRACT SUPERTYPE OF ( ONEOF ( schema_definition, statements_container ) ) 
		SUBTYPE OF ( dictionary_instance );
		name : STRING;
		constants : LIST OF constant_definition;
		types : LIST OF defined_type;
		entities : LIST OF entity_definition;
		algorithmes : LIST OF algorithm_declaration;
		SELF\entity_instance.owner : OPTIONAL context_owner;
	END_ENTITY;

	ENTITY statements_container 
		ABSTRACT SUPERTYPE 
		SUBTYPE OF ( context_definition );
		locals : LIST OF local_variable;
		statements : LIST OF statement;
	END_ENTITY;

	ENTITY global_rule 
		SUBTYPE OF ( statements_container );
		for_entities : LIST [ 1 : ? ] OF entity_instances_set;
		where_rules : LIST [ 1 : ? ] OF where_rule;
		SELF\context_definition.owner : schema_definition;
	DERIVE
		accepted : entity_instance := SELF.accept_global_rule;
	END_ENTITY;

	ENTITY external_schema 
		SUBTYPE OF ( dictionary_instance );
		name : schema_name;
		SELF\entity_instance.owner : schema_definition;
	END_ENTITY;

	ENTITY include_schema 
		SUBTYPE OF ( external_schema );
		native_schema : schema_definition;
		explicitly_imported_items : LIST OF domain_equivalent_item;
		implicitly_imported_items : LIST OF domain_equivalent_item;
	END_ENTITY;

	ENTITY used_schema 
		SUBTYPE OF ( include_schema );
	END_ENTITY;

	ENTITY referenced_schema 
		SUBTYPE OF ( include_schema );
	END_ENTITY;

	ENTITY external_meta_schema 
		SUBTYPE OF ( external_schema );
	END_ENTITY;

	ENTITY algorithm_declaration 
		ABSTRACT SUPERTYPE 
		SUBTYPE OF ( statements_container );
		formal_parameters : LIST OF parameter_definition;
	END_ENTITY;

	ENTITY native_code 
		SUBTYPE OF ( dictionary_instance );
		language_signature : STRING;
		code : STRING;
	END_ENTITY;

	ENTITY native_algorithm 
		SUBTYPE OF ( dictionary_instance );
		implementations : LIST OF native_code;
	END_ENTITY;

	ENTITY procedure_declaration 
		SUBTYPE OF ( algorithm_declaration );
	DERIVE
		accepted : entity_instance := SELF.accept_procedure_declaration;
	END_ENTITY;

	ENTITY function_declaration 
		SUBTYPE OF ( algorithm_declaration );
		return_type : parameter_type;
	DERIVE
		accepted : entity_instance := SELF.accept_function_declaration;
	END_ENTITY;

	ENTITY bound 
		ABSTRACT SUPERTYPE OF ( ONEOF ( integer_bound, population_dependent_bound ) ) 
		SUBTYPE OF ( dictionary_instance );
	END_ENTITY;

	ENTITY integer_bound 
		SUBTYPE OF ( bound );
		bound_value : INTEGER;
	END_ENTITY;

	ENTITY population_dependent_bound 
		SUBTYPE OF ( bound );
		bound_value : expression;
	END_ENTITY;

	ENTITY enumeration_type 
		SUBTYPE OF ( dictionary_instance );
		elements : LIST [ 1 : ? ] OF UNIQUE STRING;
		SELF\entity_instance.owner : defined_type;
	DERIVE
		accepted : entity_instance := SELF.accept_enumeration_type;
	END_ENTITY;

	ENTITY named_type 
		ABSTRACT SUPERTYPE OF ( ONEOF ( entity_definition, defined_type ) ) 
		SUBTYPE OF ( dictionary_instance );
		name : STRING;
		where_rules : LIST [ 0 : ? ] OF where_rule;
		SELF\entity_instance.owner : context_definition;
	END_ENTITY;

	ENTITY dictionary_instance_reference 
		SUBTYPE OF ( dictionary_instance );
		ref : dictionary_instance;
		name : STRING;
	DERIVE
		SELF\dictionary_instance.handled : dictionary_instance := SELF.ref;
	END_ENTITY;

	ENTITY named_type_reference 
		SUBTYPE OF ( dictionary_instance_reference );
		SELF\dictionary_instance_reference.ref : named_type;
	DERIVE
		accepted : entity_instance := SELF.accept_named_type_reference;
	END_ENTITY;

	ENTITY attribute_reference 
		SUBTYPE OF ( dictionary_instance_reference );
		SELF\dictionary_instance_reference.ref : attribute;
		entity_ref : entity_definition_reference;
	DERIVE
		SELF\named_type_reference.accepted : entity_instance := SELF.accept_attribute_reference;
	END_ENTITY;

	ENTITY entity_definition_reference 
		SUBTYPE OF ( named_type_reference );
		SELF\named_type_reference.ref : entity_definition;
	DERIVE
		SELF\named_type_reference.accepted : entity_instance := SELF.accept_entity_definition_reference;
	END_ENTITY;

	ENTITY defined_type_reference 
		SUBTYPE OF ( named_type_reference );
		SELF\named_type_reference.ref : defined_type;
	DERIVE
		SELF\named_type_reference.accepted : entity_instance := SELF.accept_defined_type_reference;
	END_ENTITY;

	ENTITY where_rule 
		SUBTYPE OF ( dictionary_instance );
		label : OPTIONAL STRING;
		SELF\entity_instance.owner : type_or_rule;
		where_value : expression;
	END_ENTITY;

	ENTITY select_type 
		SUBTYPE OF ( dictionary_instance );
		selections : LIST [ 1 : ? ] OF named_type_reference;
		SELF\entity_instance.owner : defined_type;
	DERIVE
		accepted : entity_instance := SELF.accept_select_type;
	END_ENTITY;

	ENTITY defined_type 
		SUBTYPE OF ( named_type );
		domain : underlying_type;
	DERIVE
		accepted : entity_instance := SELF.accept_defined_type;
	END_ENTITY;

	ENTITY entity_definition 
		SUBTYPE OF ( named_type );
		supertype_constraint : OPTIONAL supertype_constraint;
		supertypes : LIST OF UNIQUE entity_definition_reference;
		attributes : LIST OF UNIQUE attribute;
		uniqueness_rules : LIST OF UNIQUE uniqueness_rule;
		complex : BOOLEAN;
		instantiable : BOOLEAN;
		independent : BOOLEAN;
	DERIVE
		accepted : entity_instance := SELF.accept_entity_definition;
	END_ENTITY;

	ENTITY supertype_constraint 
		SUBTYPE OF ( dictionary_instance );
		constrained : entity_definition_reference;
		expr : OPTIONAL supertype_expression;
	END_ENTITY;

	ENTITY supertype_expression 
		ABSTRACT SUPERTYPE OF ( ONEOF ( sub_entity_ref_expression, binary_supertype_expression, oneof_supertype_expression ) ) 
		SUBTYPE OF ( dictionary_instance );
	END_ENTITY;

	ENTITY sub_entity_ref_expression 
		SUBTYPE OF ( supertype_expression );
		entity_ref : entity_definition_reference;
	END_ENTITY;

	ENTITY binary_supertype_expression 
		SUBTYPE OF ( supertype_expression );
		parenthesis : OPTIONAL BOOLEAN;
		left_expr : supertype_expression;
		right_expr : supertype_expression;
	END_ENTITY;

	ENTITY andor_supertype 
		SUBTYPE OF ( binary_supertype_expression );
	END_ENTITY;

	ENTITY and_supertype 
		SUBTYPE OF ( binary_supertype_expression );
	END_ENTITY;

	ENTITY oneof_supertype_expression 
		SUBTYPE OF ( supertype_expression );
		expr_list : LIST OF supertype_expression;
	END_ENTITY;

	ENTITY uniqueness_rule 
		SUBTYPE OF ( dictionary_instance );
		label : OPTIONAL STRING;
		attributes : LIST [ 1 : ? ] OF UNIQUE uniqueness_rule_attribute_identifier;
		SELF\entity_instance.owner : entity_definition;
	END_ENTITY;

	ENTITY attribute 
		ABSTRACT SUPERTYPE OF ( ONEOF ( derived_attribute, explicit_attribute, inverse_attribute ) ) 
		SUBTYPE OF ( dictionary_instance );
		name : STRING;
		SELF\entity_instance.owner : entity_definition;
		domain : base_type;
		redeclaring : OPTIONAL attribute_reference;
	END_ENTITY;

	ENTITY aggregate_initializer_domain 
		SUBTYPE OF ( dictionary_instance );
		types : LIST [ 1 : ? ] OF parameter_type;
	END_ENTITY;

	ENTITY aggregate_type 
		ABSTRACT SUPERTYPE OF ( ONEOF ( aggregation_type, general_aggregate_type ) ) 
		SUBTYPE OF ( dictionary_instance );
		element_type : parameter_type;
	END_ENTITY;

	ENTITY general_aggregate_type 
		SUBTYPE OF ( aggregate_type );
		type_label : OPTIONAL STRING;
	END_ENTITY;

	ENTITY aggregation_type 
		ABSTRACT SUPERTYPE OF ( ONEOF ( variable_size_aggregation_type, array_type ) ) 
		SUBTYPE OF ( aggregate_type );
		lower_bound : OPTIONAL bound;
		upper_bound : OPTIONAL bound;
		is_general_type : BOOLEAN;
	END_ENTITY;

	ENTITY array_type 
		SUBTYPE OF ( aggregation_type );
		unique_flag : BOOLEAN;
		optional_flag : BOOLEAN;
		SELF\aggregation_type.lower_bound : bound;
		SELF\aggregation_type.upper_bound : bound;
	DERIVE
		accepted : entity_instance := SELF.accept_array_type;
	END_ENTITY;

	ENTITY variable_size_aggregation_type 
		ABSTRACT SUPERTYPE OF ( ONEOF ( set_type, bag_type, list_type ) ) 
		SUBTYPE OF ( aggregation_type );
	END_ENTITY;

	ENTITY list_type 
		SUBTYPE OF ( variable_size_aggregation_type );
		unique_flag : BOOLEAN;
	DERIVE
		accepted : entity_instance := SELF.accept_list_type;
	END_ENTITY;

	ENTITY bag_type 
		SUBTYPE OF ( variable_size_aggregation_type );
	DERIVE
		accepted : entity_instance := SELF.accept_bag_type;
	END_ENTITY;

	ENTITY set_type 
		SUBTYPE OF ( variable_size_aggregation_type );
	DERIVE
		accepted : entity_instance := SELF.accept_set_type;
	END_ENTITY;

	ENTITY simple_type 
		ABSTRACT SUPERTYPE OF ( ONEOF ( string_type, binary_type, logical_type, number_type ) ) 
		SUBTYPE OF ( dictionary_instance );
	END_ENTITY;

	ENTITY string_type 
		SUBTYPE OF ( simple_type );
		width : OPTIONAL bound;
		fixed_width : BOOLEAN;
	DERIVE
		accepted : entity_instance := SELF.accept_string_type;
	END_ENTITY;

	ENTITY binary_type 
		SUBTYPE OF ( simple_type );
		width : OPTIONAL bound;
		fixed_width : BOOLEAN;
	DERIVE
		accepted : entity_instance := SELF.accept_binary_type;
	END_ENTITY;

	ENTITY number_type 
		SUBTYPE OF ( simple_type );
	DERIVE
		accepted : entity_instance := SELF.accept_number_type;
	END_ENTITY;

	ENTITY real_type 
		SUBTYPE OF ( number_type );
		precision : OPTIONAL bound;
	DERIVE
		SELF\number_type.accepted : entity_instance := SELF.accept_real_type;
	END_ENTITY;

	ENTITY integer_type 
		SUBTYPE OF ( number_type );
		precision : OPTIONAL bound;
	DERIVE
		SELF\number_type.accepted : entity_instance := SELF.accept_integer_type;
	END_ENTITY;

	ENTITY logical_type 
		SUBTYPE OF ( simple_type );
	DERIVE
		accepted : entity_instance := SELF.accept_logical_type;
	END_ENTITY;

	ENTITY boolean_type 
		SUBTYPE OF ( logical_type );
	DERIVE
		SELF\logical_type.accepted : entity_instance := SELF.accept_boolean_type;
	END_ENTITY;

	ENTITY constant_definition 
		SUBTYPE OF ( dictionary_instance );
		name : STRING;
		domain : base_type;
		initializer : expression;
		SELF\entity_instance.owner : context_definition;
	END_ENTITY;

	ENTITY local_variable 
		SUBTYPE OF ( dictionary_instance );
		SELF\entity_instance.owner : statements_container;
		name : STRING;
		domain : parameter_type;
		initializer : OPTIONAL expression;
	END_ENTITY;

	ENTITY parameter_definition 
		SUBTYPE OF ( dictionary_instance );
		SELF\entity_instance.owner : algorithm_declaration;
		name : STRING;
		by_copy : BOOLEAN;
		domain : parameter_type;
	END_ENTITY;

	ENTITY generic_type 
		SUBTYPE OF ( dictionary_instance );
		type_label : OPTIONAL STRING;
	DERIVE
		accepted : entity_instance := SELF.accept_generic_type;
	END_ENTITY;

	ENTITY remark 
		ABSTRACT SUPERTYPE OF ( ONEOF ( tail_remark, embedded_remark ) ) 
		SUBTYPE OF ( entity_instance );
		text : STRING;
	END_ENTITY;

	ENTITY tail_remark 
		SUBTYPE OF ( remark );
	END_ENTITY;

	ENTITY embedded_remark 
		SUBTYPE OF ( remark );
	END_ENTITY;

	ENTITY remark_reference 
		SUBTYPE OF ( dictionary_instance );
		prefix : STRING;
		suffix : OPTIONAL STRING;
		inside : dictionary_instance_reference;
		referenced : dictionary_instance_reference;
		remark : remark;
	END_ENTITY;

	ENTITY meta_concept_definition 
		SUBTYPE OF ( dictionary_instance );
		definition : dictionary_instance;
		expression : STRING;
	END_ENTITY;

	ENTITY derived_attribute 
		SUBTYPE OF ( attribute );
		assign : expression;
	DERIVE
		accepted : entity_instance := SELF.accept_derived_attribute;
	END_ENTITY;

	ENTITY explicit_attribute 
		SUBTYPE OF ( attribute );
		optional_flag : BOOLEAN;
	DERIVE
		accepted : entity_instance := SELF.accept_explicit_attribute;
	END_ENTITY;

	ENTITY inverse_attribute 
		SUBTYPE OF ( attribute );
		inverted_attr : attribute_reference;
		min_cardinality : OPTIONAL bound;
		max_cardinality : OPTIONAL bound;
		duplicates : BOOLEAN;
	DERIVE
		SELF\attribute.domain : entity_definition_reference := inverted_attr.entity_ref;
		accepted : entity_instance := SELF.accept_inverse_attribute;
	END_ENTITY;

	ENTITY meta_mapping_rule 
		SUBTYPE OF ( dictionary_instance );
		condition : STRING;
		expression : STRING;
	END_ENTITY;

	ENTITY meta_mapping_definition 
		SUBTYPE OF ( dictionary_instance );
		definition : dictionary_instance;
		expression : STRING;
	END_ENTITY;

	ENTITY schema_definition 
		SUBTYPE OF ( context_definition );
		global_rules : LIST OF global_rule;
		interface : LIST OF external_schema;
		remark_references : LIST OF remark_reference;
	DERIVE
		accepted : entity_instance := SELF.accept_schema_definition;
	END_ENTITY;
END_SCHEMA;

</ISO10303-11-EXPRESS>!

!PltPlatypusDictionarySchemaSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltPlatypusDictionarySchemaSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltPlatypusDictionarySchemaSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context
	^ self schemaInstance context

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition1
	^ #(#entity_instance #PltEntityInstance)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition10
	^ #(#include_schema #PltIncludeSchema)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition11
	^ #(#used_schema #PltUsedSchema)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition12
	^ #(#referenced_schema #PltReferencedSchema)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition13
	^ #(#external_meta_schema #PltExternalMetaSchema)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition14
	^ #(#algorithm_declaration #PltAlgorithmDeclaration)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition15
	^ #(#native_code #PltNativeCode)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition16
	^ #(#native_algorithm #PltNativeAlgorithm)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition17
	^ #(#procedure_declaration #PltProcedureDeclaration)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition18
	^ #(#function_declaration #PltFunctionDeclaration)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition19
	^ #(#bound #PltBound)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition2
	^ #(#sdai_instance #PltSdaiInstance)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition20
	^ #(#integer_bound #PltIntegerBound)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition21
	^ #(#population_dependent_bound #PltPopulationDependentBound)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition22
	^ #(#enumeration_type #PltEnumerationType)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition23
	^ #(#named_type #PltNamedType)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition24
	^ #(#dictionary_instance_reference #PltDictionaryInstanceReference)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition25
	^ #(#named_type_reference #PltNamedTypeReference)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition26
	^ #(#attribute_reference #PltAttributeReference)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition27
	^ #(#entity_definition_reference #PltEntityDefinitionReference)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition28
	^ #(#defined_type_reference #PltDefinedTypeReference)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition29
	^ #(#where_rule #PltWhereRule)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition3
	^ #(#dictionary_instance #PltDictionaryInstance)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition30
	^ #(#select_type #PltSelectType)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition31
	^ #(#defined_type #PltDefinedType)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition32
	^ #(#entity_definition #PltEntityDefinition)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition33
	^ #(#supertype_constraint #PltSupertypeConstraint)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition34
	^ #(#supertype_expression #PltSupertypeExpression)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition35
	^ #(#sub_entity_ref_expression #PltSubEntityRefExpression)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition36
	^ #(#binary_supertype_expression #PltBinarySupertypeExpression)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition37
	^ #(#andor_supertype #PltAndorSupertype)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition38
	^ #(#and_supertype #PltAndSupertype)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition39
	^ #(#oneof_supertype_expression #PltOneofSupertypeExpression)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition4
	^ #(#session_instance #PltSessionInstance)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition40
	^ #(#uniqueness_rule #PltUniquenessRule)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition41
	^ #(#attribute #PltAttribute)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition42
	^ #(#aggregate_initializer_domain #PltAggregateInitializerDomain)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition43
	^ #(#aggregate_type #PltAggregateType)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition44
	^ #(#general_aggregate_type #PltGeneralAggregateType)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition45
	^ #(#aggregation_type #PltAggregationType)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition46
	^ #(#array_type #PltArrayType)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition47
	^ #(#variable_size_aggregation_type #PltVariableSizeAggregationType)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition48
	^ #(#list_type #PltListType)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition49
	^ #(#bag_type #PltBagType)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition5
	^ #(#domain_equivalent_item #PltDomainEquivalentItem)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition50
	^ #(#set_type #PltSetType)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition51
	^ #(#simple_type #PltSimpleType)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition52
	^ #(#string_type #PltStringType)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition53
	^ #(#binary_type #PltBinaryType)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition54
	^ #(#number_type #PltNumberType)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition55
	^ #(#real_type #PltRealType)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition56
	^ #(#integer_type #PltIntegerType)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition57
	^ #(#logical_type #PltLogicalType)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition58
	^ #(#boolean_type #PltBooleanType)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition59
	^ #(#constant_definition #PltConstantDefinition)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition6
	^ #(#context_definition #PltContextDefinition)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition60
	^ #(#local_variable #PltLocalVariable)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition61
	^ #(#parameter_definition #PltParameterDefinition)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition62
	^ #(#generic_type #PltGenericType)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition63
	^ #(#remark #PltRemark)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition64
	^ #(#tail_remark #PltTailRemark)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition65
	^ #(#embedded_remark #PltEmbeddedRemark)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition66
	^ #(#remark_reference #PltRemarkReference)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition67
	^ #(#meta_concept_definition #PltMetaConceptDefinition)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition68
	^ #(#derived_attribute #PltDerivedAttribute)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition69
	^ #(#explicit_attribute #PltExplicitAttribute)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition7
	^ #(#statements_container #PltStatementsContainer)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition70
	^ #(#inverse_attribute #PltInverseAttribute)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition71
	^ #(#meta_mapping_rule #PltMetaMappingRule)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition72
	^ #(#meta_mapping_definition #PltMetaMappingDefinition)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition73
	^ #(#schema_definition #PltSchemaDefinition)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition74^ #( #'meta_concept_definition' #PltMetaConceptDefinition )

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition75^ #( #'derived_attribute' #PltDerivedAttribute )

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition76^ #( #'explicit_attribute' #PltExplicitAttribute )

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition77^ #( #'inverse_attribute' #PltInverseAttribute )

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition78^ #( #'meta_mapping_rule' #PltMetaMappingRule )

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition79^ #( #'meta_mapping_definition' #PltMetaMappingDefinition )

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition8
	^ #(#global_rule #PltGlobalRule)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition80^ #( #'schema_definition' #PltSchemaDefinition )

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition9
	^ #(#external_schema #PltExternalSchema)

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinitionCount
	^ 73

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration1 ^ #( #'schema_instance_from_ref' #PltSchemaInstanceFromRefFunction )

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclarationCount
	^ 0

! !

!PltPlatypusDictionarySchemaSchemaDefinition methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstanceClassName
	^ #PltPlatypusMetaSchemasSchemaInstance

! !

PlatypusCoreSchema subclass: #PltPlatypusEnvironmentSchemaSchemaDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusEnvironmentSchemaSchema'!

!PltPlatypusEnvironmentSchemaSchemaDefinition commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
SCHEMA Platypus_environment_schema;
	USE FROM Platypus_population_schema;
	USE FROM Platypus_dictionary_schema;

	ENTITY model_contents 
		SUBTYPE OF ( session_instance );
		SELF\entity_instance.owner : schema_instance;
	INVERSE
		instances : SET [ 0 : ? ] OF application_instance FOR owning_model;
	END_ENTITY;

	ENTITY schema_instance 
		SUBTYPE OF ( session_instance );
		name : STRING;
		associated_models : LIST [ 0 : ? ] OF model_contents;
		schemata : LIST [ 0 : ? ] OF schema_definition;
	DERIVE
		accepted : entity_instance := SELF.accept_schema_instance;
	END_ENTITY;
END_SCHEMA;

</ISO10303-11-EXPRESS>!

!PltPlatypusEnvironmentSchemaSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltPlatypusEnvironmentSchemaSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltPlatypusEnvironmentSchemaSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltPlatypusEnvironmentSchemaSchemaDefinition methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context
	^ self schemaInstance context

! !

!PltPlatypusEnvironmentSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition1
	^ #(#model_contents #PltModelContents)

! !

!PltPlatypusEnvironmentSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition2
	^ #(#schema_instance #PltSchemaInstance)

! !

!PltPlatypusEnvironmentSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinitionCount
	^ 2

! !

!PltPlatypusEnvironmentSchemaSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclarationCount
	^ 0

! !

!PltPlatypusEnvironmentSchemaSchemaDefinition methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstanceClassName
	^ #PltPlatypusMetaSchemasSchemaInstance

! !

PlatypusCoreSchema subclass: #PltPlatypusExpressionsSchemaSchemaDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltPlatypusExpressionsSchemaSchemaDefinition commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
SCHEMA Platypus_expressions_schema;
	USE FROM Platypus_dictionary_schema;
	USE FROM Platypus_statements_schema;
	USE FROM Platypus_population_schema;

	ENTITY expression 
		ABSTRACT SUPERTYPE 
		SUBTYPE OF ( dictionary_instance );
	END_ENTITY;

	ENTITY unary_expression 
		ABSTRACT SUPERTYPE 
		SUBTYPE OF ( expression );
	END_ENTITY;

	ENTITY binary_expression 
		ABSTRACT SUPERTYPE 
		SUBTYPE OF ( expression );
		parenthesis : OPTIONAL BOOLEAN;
		left_expr : expression;
		right_expr : expression;
	END_ENTITY;

	ENTITY logical_expression 
		ABSTRACT SUPERTYPE 
		SUBTYPE OF ( binary_expression );
	END_ENTITY;

	ENTITY entity_instance_reference 
		SUBTYPE OF ( expression );
		persistent_label : STRING;
		ref : entity_instance;
	END_ENTITY;

	ENTITY instance_construction_expression 
		SUBTYPE OF ( binary_expression );
	END_ENTITY;

	ENTITY arithmetic_expression 
		ABSTRACT SUPERTYPE 
		SUBTYPE OF ( binary_expression );
	END_ENTITY;

	ENTITY expo_expression 
		SUBTYPE OF ( arithmetic_expression );
	END_ENTITY;

	ENTITY mult_expression 
		SUBTYPE OF ( arithmetic_expression );
	END_ENTITY;

	ENTITY div_expression 
		SUBTYPE OF ( arithmetic_expression );
	END_ENTITY;

	ENTITY real_div_expression 
		SUBTYPE OF ( arithmetic_expression );
	END_ENTITY;

	ENTITY mod_expression 
		SUBTYPE OF ( arithmetic_expression );
	END_ENTITY;

	ENTITY plus_expression 
		SUBTYPE OF ( arithmetic_expression );
	END_ENTITY;

	ENTITY minus_expression 
		SUBTYPE OF ( arithmetic_expression );
	END_ENTITY;

	ENTITY and_expression 
		SUBTYPE OF ( logical_expression );
	END_ENTITY;

	ENTITY or_expression 
		SUBTYPE OF ( logical_expression );
	END_ENTITY;

	ENTITY xor_expression 
		SUBTYPE OF ( logical_expression );
	END_ENTITY;

	ENTITY comparison_expression 
		ABSTRACT SUPERTYPE 
		SUBTYPE OF ( logical_expression );
	END_ENTITY;

	ENTITY less_than_expression 
		SUBTYPE OF ( comparison_expression );
	END_ENTITY;

	ENTITY greater_than_expression 
		SUBTYPE OF ( comparison_expression );
	END_ENTITY;

	ENTITY equal_expression 
		SUBTYPE OF ( comparison_expression );
	END_ENTITY;

	ENTITY less_equal_expression 
		SUBTYPE OF ( comparison_expression );
	END_ENTITY;

	ENTITY greater_equal_expression 
		SUBTYPE OF ( comparison_expression );
	END_ENTITY;

	ENTITY not_equal_expression 
		SUBTYPE OF ( comparison_expression );
	END_ENTITY;

	ENTITY inst_comparison_expression 
		ABSTRACT SUPERTYPE 
		SUBTYPE OF ( comparison_expression );
	END_ENTITY;

	ENTITY inst_equal_expression 
		SUBTYPE OF ( inst_comparison_expression );
	END_ENTITY;

	ENTITY inst_not_equal_expression 
		SUBTYPE OF ( inst_comparison_expression );
	END_ENTITY;

	ENTITY in_expression 
		SUBTYPE OF ( logical_expression );
	END_ENTITY;

	ENTITY like_expression 
		SUBTYPE OF ( logical_expression );
	END_ENTITY;

	ENTITY cardinality_expression 
		SUBTYPE OF ( logical_expression );
		card1 : expression;
		card2 : expression;
	END_ENTITY;

	ENTITY simple_unary_expression 
		ABSTRACT SUPERTYPE 
		SUBTYPE OF ( unary_expression );
		expr : expression;
	END_ENTITY;

	ENTITY not_expression 
		SUBTYPE OF ( simple_unary_expression );
	END_ENTITY;

	ENTITY positive_expression 
		SUBTYPE OF ( simple_unary_expression );
	END_ENTITY;

	ENTITY negative_expression 
		SUBTYPE OF ( simple_unary_expression );
	END_ENTITY;

	ENTITY typed_expression 
		SUBTYPE OF ( simple_unary_expression );
		domain : named_type_reference;
	END_ENTITY;

	ENTITY enumeration_value 
		SUBTYPE OF ( qualifier );
		domain : defined_type_reference;
		element : STRING;
	END_ENTITY;

	ENTITY entity_instances_set 
		SUBTYPE OF ( unary_expression );
		entity_ref : entity_definition_reference;
	END_ENTITY;

	ENTITY qualified_expression 
		SUBTYPE OF ( unary_expression );
		head : expression;
		qualifiers : LIST OF qualifier;
	END_ENTITY;

	ENTITY literal 
		ABSTRACT SUPERTYPE 
		SUBTYPE OF ( unary_expression );
	END_ENTITY;

	ENTITY identifier 
		SUBTYPE OF ( unary_expression );
		name : STRING;
		ref : dictionary_instance;
		parameters : OPTIONAL LIST OF expression;
	END_ENTITY;

	ENTITY attribute_identifier 
		SUBTYPE OF ( identifier );
		selfInstance : generic_instance;
	END_ENTITY;

	ENTITY self_identifier 
		SUBTYPE OF ( unary_expression );
	END_ENTITY;

	ENTITY uniqueness_rule_attribute_identifier 
		SUBTYPE OF ( identifier );
		group_ref_name : OPTIONAL STRING;
		SELF\identifier.ref : attribute;
	END_ENTITY;

	ENTITY missing_value 
		SUBTYPE OF ( unary_expression );
	END_ENTITY;

	ENTITY redefined_attribute_value 
		SUBTYPE OF ( missing_value );
	END_ENTITY;

	ENTITY implicitly_declared_identifier 
		SUBTYPE OF ( identifier );
	END_ENTITY;

	ENTITY interval 
		SUBTYPE OF ( unary_expression );
		expr : and_expression;
	END_ENTITY;

	ENTITY aggr_unary_expression 
		ABSTRACT SUPERTYPE 
		SUBTYPE OF ( unary_expression );
	END_ENTITY;

	ENTITY query_variable 
		SUBTYPE OF ( dictionary_instance );
		variable_id : STRING;
		SELF\entity_instance.owner : query_expression;
	END_ENTITY;

	ENTITY query_expression 
		SUBTYPE OF ( aggr_unary_expression );
		variable : query_variable;
		aggregate_source : expression;
		such_that : expression;
	END_ENTITY;

	ENTITY entity_instance_constructor 
		SUBTYPE OF ( unary_expression );
		decl : entity_definition_reference;
		parameters : LIST OF expression;
	END_ENTITY;

	ENTITY qualifier 
		ABSTRACT SUPERTYPE 
		SUBTYPE OF ( unary_expression );
	END_ENTITY;

	ENTITY attribute_qualifier 
		SUBTYPE OF ( qualifier );
		attribute_name : STRING;
	END_ENTITY;

	ENTITY group_qualifier 
		SUBTYPE OF ( qualifier );
		group_name : STRING;
	END_ENTITY;

	ENTITY index_qualifier 
		SUBTYPE OF ( qualifier );
	END_ENTITY;

	ENTITY element_qualifier 
		SUBTYPE OF ( index_qualifier );
		index : expression;
	END_ENTITY;

	ENTITY range_qualifier 
		SUBTYPE OF ( index_qualifier );
		index1 : expression;
		index2 : expression;
	END_ENTITY;

	ENTITY numeric_literal 
		ABSTRACT SUPERTYPE 
		SUBTYPE OF ( literal );
	END_ENTITY;

	ENTITY logical_literal 
		ABSTRACT SUPERTYPE 
		SUBTYPE OF ( literal );
	END_ENTITY;

	ENTITY true_constant 
		SUBTYPE OF ( logical_literal );
	END_ENTITY;

	ENTITY false_constant 
		SUBTYPE OF ( logical_literal );
	END_ENTITY;

	ENTITY unknown_constant 
		SUBTYPE OF ( logical_literal );
	END_ENTITY;

	ENTITY integer_literal 
		SUBTYPE OF ( numeric_literal );
		val : INTEGER;
	END_ENTITY;

	ENTITY real_literal 
		SUBTYPE OF ( numeric_literal );
		val : REAL;
	END_ENTITY;

	ENTITY pi_constant 
		SUBTYPE OF ( real_literal );
	DERIVE
		SELF\real_literal.val : REAL := 3.14159;
	END_ENTITY;

	ENTITY e_constant 
		SUBTYPE OF ( real_literal );
	DERIVE
		SELF\real_literal.val : REAL := 2.71828;
	END_ENTITY;

	ENTITY string_literal 
		SUBTYPE OF ( literal );
		val : STRING;
	END_ENTITY;

	ENTITY binary_literal 
		SUBTYPE OF ( literal );
		val : BINARY;
	END_ENTITY;

	ENTITY native_expression 
		SUBTYPE OF ( expression );
		source : native_algorithm;
	END_ENTITY;

	ENTITY escaped_expression 
		SUBTYPE OF ( expression );
		expr : expression;
	END_ENTITY;
END_SCHEMA;

</ISO10303-11-EXPRESS>!

!PltPlatypusExpressionsSchemaSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltPlatypusExpressionsSchemaSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltPlatypusExpressionsSchemaSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context
	^ self schemaInstance context

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition1
	^ #(#expression #PltExpression)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition10
	^ #(#div_expression #PltDivExpression)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition11
	^ #(#real_div_expression #PltRealDivExpression)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition12
	^ #(#mod_expression #PltModExpression)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition13
	^ #(#plus_expression #PltPlusExpression)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition14
	^ #(#minus_expression #PltMinusExpression)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition15
	^ #(#and_expression #PltAndExpression)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition16
	^ #(#or_expression #PltOrExpression)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition17
	^ #(#xor_expression #PltXorExpression)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition18
	^ #(#comparison_expression #PltComparisonExpression)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition19
	^ #(#less_than_expression #PltLessThanExpression)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition2
	^ #(#unary_expression #PltUnaryExpression)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition20
	^ #(#greater_than_expression #PltGreaterThanExpression)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition21
	^ #(#equal_expression #PltEqualExpression)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition22
	^ #(#less_equal_expression #PltLessEqualExpression)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition23
	^ #(#greater_equal_expression #PltGreaterEqualExpression)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition24
	^ #(#not_equal_expression #PltNotEqualExpression)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition25
	^ #(#inst_comparison_expression #PltInstComparisonExpression)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition26
	^ #(#inst_equal_expression #PltInstEqualExpression)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition27
	^ #(#inst_not_equal_expression #PltInstNotEqualExpression)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition28
	^ #(#in_expression #PltInExpression)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition29
	^ #(#like_expression #PltLikeExpression)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition3
	^ #(#binary_expression #PltBinaryExpression)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition30
	^ #(#cardinality_expression #PltCardinalityExpression)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition31
	^ #(#simple_unary_expression #PltSimpleUnaryExpression)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition32
	^ #(#not_expression #PltNotExpression)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition33
	^ #(#positive_expression #PltPositiveExpression)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition34
	^ #(#negative_expression #PltNegativeExpression)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition35
	^ #(#typed_expression #PltTypedExpression)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition36
	^ #(#enumeration_value #PltEnumerationValue)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition37
	^ #(#entity_instances_set #PltEntityInstancesSet)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition38
	^ #(#qualified_expression #PltQualifiedExpression)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition39
	^ #(#literal #PltLiteral)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition4
	^ #(#logical_expression #PltLogicalExpression)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition40
	^ #(#identifier #PltIdentifier)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition41
	^ #(#attribute_identifier #PltAttributeIdentifier)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition42
	^ #(#self_identifier #PltSelfIdentifier)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition43
	^ #(#uniqueness_rule_attribute_identifier #PltUniquenessRuleAttributeIdentifier)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition44
	^ #(#missing_value #PltMissingValue)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition45
	^ #(#redefined_attribute_value #PltRedefinedAttributeValue)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition46
	^ #(#implicitly_declared_identifier #PltImplicitlyDeclaredIdentifier)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition47
	^ #(#interval #PltInterval)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition48
	^ #(#aggr_unary_expression #PltAggrUnaryExpression)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition49
	^ #(#query_variable #PltQueryVariable)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition5
	^ #(#entity_instance_reference #PltEntityInstanceReference)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition50
	^ #(#query_expression #PltQueryExpression)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition51
	^ #(#entity_instance_constructor #PltEntityInstanceConstructor)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition52
	^ #(#qualifier #PltQualifier)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition53
	^ #(#attribute_qualifier #PltAttributeQualifier)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition54
	^ #(#group_qualifier #PltGroupQualifier)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition55
	^ #(#index_qualifier #PltIndexQualifier)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition56
	^ #(#element_qualifier #PltElementQualifier)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition57
	^ #(#range_qualifier #PltRangeQualifier)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition58
	^ #(#numeric_literal #PltNumericLiteral)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition59
	^ #(#logical_literal #PltLogicalLiteral)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition6
	^ #(#instance_construction_expression #PltInstanceConstructionExpression)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition60
	^ #(#true_constant #PltTrueConstant)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition61
	^ #(#false_constant #PltFalseConstant)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition62
	^ #(#unknown_constant #PltUnknownConstant)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition63
	^ #(#integer_literal #PltIntegerLiteral)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition64
	^ #(#real_literal #PltRealLiteral)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition65
	^ #(#pi_constant #PltPiConstant)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition66
	^ #(#e_constant #PltEConstant)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition67
	^ #(#string_literal #PltStringLiteral)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition68
	^ #(#binary_literal #PltBinaryLiteral)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition69
	^ #(#native_expression #PltNativeExpression)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition7
	^ #(#arithmetic_expression #PltArithmeticExpression)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition70
	^ #(#escaped_expression #PltEscapedExpression)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition8
	^ #(#expo_expression #PltExpoExpression)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition9
	^ #(#mult_expression #PltMultExpression)

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinitionCount
	^ 70

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclarationCount
	^ 0

! !

!PltPlatypusExpressionsSchemaSchemaDefinition methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstanceClassName
	^ #PltPlatypusMetaSchemasSchemaInstance

! !

PlatypusCoreSchema subclass: #PltPlatypusPopulationSchemaSchemaDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusPopulationSchemaSchema'!

!PltPlatypusPopulationSchemaSchemaDefinition commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
SCHEMA Platypus_population_schema;
	USE FROM Platypus_expressions_schema;
	USE FROM Platypus_environment_schema;
	USE FROM Platypus_dictionary_schema;

	ENTITY instance_scope 
		SUBTYPE OF ( session_instance );
		owned : LIST [ 1 : ? ] OF entity_instance;
		export_list : LIST [ 0 : ? ] OF entity_instance;
	END_ENTITY;

	ENTITY application_instance 
		ABSTRACT SUPERTYPE 
		SUBTYPE OF ( entity_instance );
		owning_model : model_contents;
		persistent_label : STRING;
	END_ENTITY;

	ENTITY generic_instance 
		ABSTRACT SUPERTYPE 
		SUBTYPE OF ( application_instance );
		instance_scope : OPTIONAL instance_scope;
	END_ENTITY;

	ENTITY internal_representation 
		SUBTYPE OF ( generic_instance );
		definition : entity_definition_reference;
		parameters : LIST OF primitive;
	END_ENTITY;

	ENTITY external_representation 
		SUBTYPE OF ( generic_instance );
		records : LIST OF simple_record;
	END_ENTITY;

	ENTITY group_representation 
		ABSTRACT SUPERTYPE 
		SUBTYPE OF ( generic_instance );
		definition : entity_definition_reference;
		instRef : generic_instance;
	END_ENTITY;

	ENTITY external_group_representation 
		SUBTYPE OF ( group_representation );
	END_ENTITY;

	ENTITY internal_group_representation 
		SUBTYPE OF ( group_representation );
	END_ENTITY;

	ENTITY user_defined_application_instance 
		SUBTYPE OF ( application_instance );
		name : STRING;
		parameters : LIST OF primitive;
	END_ENTITY;

	ENTITY simple_record 
		SUBTYPE OF ( entity_instance );
		definition : entity_definition_reference;
		parameters : LIST OF primitive;
		SELF\entity_instance.owner : generic_instance;
	END_ENTITY;

	ENTITY header_instance 
		ABSTRACT SUPERTYPE 
		SUBTYPE OF ( entity_instance );
		owning_model : model_contents;
	END_ENTITY;

	ENTITY user_defined_header_instance 
		SUBTYPE OF ( header_instance );
		name : STRING;
		parameters : LIST OF primitive;
	END_ENTITY;

	ENTITY file_description 
		SUBTYPE OF ( header_instance );
		description : LIST [ 1 : ? ] OF STRING ( 256 );
		implementation_level : STRING ( 256 );
	END_ENTITY;

	ENTITY file_name 
		SUBTYPE OF ( header_instance );
		name : STRING ( 256 );
		time_stamp : STRING ( 256 );
		author : LIST [ 1 : ? ] OF STRING ( 256 );
		organization : LIST [ 1 : ? ] OF STRING ( 256 );
		preprocessor_version : STRING ( 256 );
		originating_system : STRING ( 256 );
		authorisation : STRING ( 256 );
	END_ENTITY;

	ENTITY file_schema 
		SUBTYPE OF ( header_instance );
		schema_identifiers : LIST [ 1 : ? ] OF schema_name;
	END_ENTITY;
END_SCHEMA;

</ISO10303-11-EXPRESS>!

!PltPlatypusPopulationSchemaSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltPlatypusPopulationSchemaSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltPlatypusPopulationSchemaSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltPlatypusPopulationSchemaSchemaDefinition methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context
	^ self schemaInstance context

! !

!PltPlatypusPopulationSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition1
	^ #(#instance_scope #PltInstanceScope)

! !

!PltPlatypusPopulationSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition10
	^ #(#simple_record #PltSimpleRecord)

! !

!PltPlatypusPopulationSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition11
	^ #(#header_instance #PltHeaderInstance)

! !

!PltPlatypusPopulationSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition12
	^ #(#user_defined_header_instance #PltUserDefinedHeaderInstance)

! !

!PltPlatypusPopulationSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition13
	^ #(#file_description #PltFileDescription)

! !

!PltPlatypusPopulationSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition14
	^ #(#file_name #PltFileName)

! !

!PltPlatypusPopulationSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition15
	^ #(#file_schema #PltFileSchema)

! !

!PltPlatypusPopulationSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition16^ #( #'file_schema' #PltFileSchema )

! !

!PltPlatypusPopulationSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition2
	^ #(#application_instance #PltApplicationInstance)

! !

!PltPlatypusPopulationSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition3
	^ #(#generic_instance #PltGenericInstance)

! !

!PltPlatypusPopulationSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition4
	^ #(#internal_representation #PltInternalRepresentation)

! !

!PltPlatypusPopulationSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition5
	^ #(#external_representation #PltExternalRepresentation)

! !

!PltPlatypusPopulationSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition6
	^ #(#group_representation #PltGroupRepresentation)

! !

!PltPlatypusPopulationSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition7
	^ #(#external_group_representation #PltExternalGroupRepresentation)

! !

!PltPlatypusPopulationSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition8
	^ #(#internal_group_representation #PltInternalGroupRepresentation)

! !

!PltPlatypusPopulationSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition9
	^ #(#user_defined_application_instance #PltUserDefinedApplicationInstance)

! !

!PltPlatypusPopulationSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinitionCount
	^ 15

! !

!PltPlatypusPopulationSchemaSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclarationCount
	^ 0

! !

!PltPlatypusPopulationSchemaSchemaDefinition methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstanceClassName
	^ #PltPlatypusMetaSchemasSchemaInstance

! !

PlatypusCoreSchema subclass: #PltPlatypusStatementsSchemaSchemaDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusStatementsSchemaSchema'!

!PltPlatypusStatementsSchemaSchemaDefinition commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
SCHEMA Platypus_statements_schema;
	USE FROM Platypus_dictionary_schema;
	USE FROM Platypus_expressions_schema;

	ENTITY assignable 
		SUBTYPE OF ( dictionary_instance );
		head : identifier;
		qualifiers : LIST OF qualifier;
	END_ENTITY;

	ENTITY statement 
		ABSTRACT SUPERTYPE 
		SUBTYPE OF ( dictionary_instance );
	END_ENTITY;

	ENTITY null_statement 
		SUBTYPE OF ( statement );
	END_ENTITY;

	ENTITY native_statement 
		SUBTYPE OF ( statement );
		source : native_algorithm;
	END_ENTITY;

	ENTITY alias_statement_variable 
		SUBTYPE OF ( dictionary_instance );
		alias_ident : STRING;
		ref : assignable;
		SELF\entity_instance.owner : alias_statement;
	END_ENTITY;

	ENTITY alias_statement 
		SUBTYPE OF ( statement );
		variable : alias_statement_variable;
		statements : LIST OF statement;
	END_ENTITY;

	ENTITY assignment_statement 
		SUBTYPE OF ( statement );
		left : assignable;
		right_expr : expression;
	END_ENTITY;

	ENTITY case_statement 
		SUBTYPE OF ( statement );
		selector : expression;
		case_actions : LIST OF case_action;
		case_otherwise : OPTIONAL statement;
	END_ENTITY;

	ENTITY case_action 
		SUBTYPE OF ( dictionary_instance );
		labels : LIST OF expression;
		action : statement;
	END_ENTITY;

	ENTITY compound_statement 
		SUBTYPE OF ( statement );
		statements : LIST OF statement;
	END_ENTITY;

	ENTITY escape_statement 
		SUBTYPE OF ( statement );
	END_ENTITY;

	ENTITY if_statement 
		SUBTYPE OF ( statement );
		selector : expression;
		then_statements : LIST OF statement;
		else_statements : OPTIONAL LIST OF statement;
	END_ENTITY;

	ENTITY repeat_statement 
		SUBTYPE OF ( statement );
		incr_control : OPTIONAL increment_control;
		until_control : OPTIONAL expression;
		while_control : OPTIONAL expression;
		statements : LIST OF statement;
	END_ENTITY;

	ENTITY increment_control_variable 
		SUBTYPE OF ( dictionary_instance );
		variable_id : STRING;
		SELF\entity_instance.owner : increment_control;
	END_ENTITY;

	ENTITY increment_control 
		SUBTYPE OF ( dictionary_instance );
		variable : increment_control_variable;
		first : expression;
		last : expression;
		step : OPTIONAL expression;
		SELF\entity_instance.owner : repeat_statement;
	END_ENTITY;

	ENTITY return_statement 
		SUBTYPE OF ( statement );
		returned : OPTIONAL expression;
	END_ENTITY;

	ENTITY procedure_call_statement 
		SUBTYPE OF ( statement );
		call : identifier;
	END_ENTITY;

	ENTITY skip_statement 
		SUBTYPE OF ( statement );
	END_ENTITY;

	ENTITY output_statement 
		SUBTYPE OF ( statement );
		output : expression;
	END_ENTITY;

	ENTITY splitmark_statement 
		SUBTYPE OF ( statement );
		filename : expression;
	END_ENTITY;

	ENTITY end_splitmark_statement 
		SUBTYPE OF ( statement );
	END_ENTITY;

	ENTITY anonymous_variable 
		SUBTYPE OF ( dictionary_instance );
		domain : parameter_type;
	END_ENTITY;
END_SCHEMA;

</ISO10303-11-EXPRESS>!

!PltPlatypusStatementsSchemaSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltPlatypusStatementsSchemaSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltPlatypusStatementsSchemaSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltPlatypusStatementsSchemaSchemaDefinition methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context
	^ self schemaInstance context

! !

!PltPlatypusStatementsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition1
	^ #(#assignable #PltAssignable)

! !

!PltPlatypusStatementsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition10
	^ #(#compound_statement #PltCompoundStatement)

! !

!PltPlatypusStatementsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition11
	^ #(#escape_statement #PltEscapeStatement)

! !

!PltPlatypusStatementsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition12
	^ #(#if_statement #PltIfStatement)

! !

!PltPlatypusStatementsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition13
	^ #(#repeat_statement #PltRepeatStatement)

! !

!PltPlatypusStatementsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition14
	^ #(#increment_control_variable #PltIncrementControlVariable)

! !

!PltPlatypusStatementsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition15
	^ #(#increment_control #PltIncrementControl)

! !

!PltPlatypusStatementsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition16
	^ #(#return_statement #PltReturnStatement)

! !

!PltPlatypusStatementsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition17
	^ #(#procedure_call_statement #PltProcedureCallStatement)

! !

!PltPlatypusStatementsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition18
	^ #(#skip_statement #PltSkipStatement)

! !

!PltPlatypusStatementsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition19
	^ #(#output_statement #PltOutputStatement)

! !

!PltPlatypusStatementsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition2
	^ #(#statement #PltStatement)

! !

!PltPlatypusStatementsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition20
	^ #(#splitmark_statement #PltSplitmarkStatement)

! !

!PltPlatypusStatementsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition21
	^ #(#end_splitmark_statement #PltEndSplitmarkStatement)

! !

!PltPlatypusStatementsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition22
	^ #(#anonymous_variable #PltAnonymousVariable)

! !

!PltPlatypusStatementsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition3
	^ #(#null_statement #PltNullStatement)

! !

!PltPlatypusStatementsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition4
	^ #(#native_statement #PltNativeStatement)

! !

!PltPlatypusStatementsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition5
	^ #(#alias_statement_variable #PltAliasStatementVariable)

! !

!PltPlatypusStatementsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition6
	^ #(#alias_statement #PltAliasStatement)

! !

!PltPlatypusStatementsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition7
	^ #(#assignment_statement #PltAssignmentStatement)

! !

!PltPlatypusStatementsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition8
	^ #(#case_statement #PltCaseStatement)

! !

!PltPlatypusStatementsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition9
	^ #(#case_action #PltCaseAction)

! !

!PltPlatypusStatementsSchemaSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinitionCount
	^ 22

! !

!PltPlatypusStatementsSchemaSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclarationCount
	^ 0

! !

!PltPlatypusStatementsSchemaSchemaDefinition methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstanceClassName
	^ #PltPlatypusMetaSchemasSchemaInstance

! !

PlatypusCoreContextDefinition subclass: #PlatypusCoreSchemaInstance
	instanceVariableNames: 'metaDataByClassNameIndex altMetaDataByClassNameIndex classNamesByMetaDataNameIndex altClassNamesByMetaDataNameIndex splitMarkStack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-core'!

!PlatypusCoreSchemaInstance class methodsFor: 'accessing' stamp: 'alain.plantec 1/20/2009 11:56'!
reinitializeSingleton
	singleton ifNotNil: [singleton schemaDefinitionClasses do: [:c | c reinitializeSingleton]].
	super reinitializeSingleton! !

!PlatypusCoreSchemaInstance methodsFor: 'accessing' stamp: 'AlainPlantec 10/26/2011 22:45'!
altClassNamesByMetaDataNameIndex
	^ altClassNamesByMetaDataNameIndex ifNil: [altClassNamesByMetaDataNameIndex := IdentityDictionary new]! !

!PlatypusCoreSchemaInstance methodsFor: 'accessing' stamp: 'AlainPlantec 10/26/2011 22:46'!
altMetaDataByClassNameIndex

	^ altMetaDataByClassNameIndex ifNil: [altMetaDataByClassNameIndex := IdentityDictionary new]! !

!PlatypusCoreSchemaInstance methodsFor: 'accessing' stamp: 'AlainPlantec 10/26/2011 23:08'!
alternativeIndex: aListOfAssociations
	altClassNamesByMetaDataNameIndex := nil.
	altMetaDataByClassNameIndex := nil.
	aListOfAssociations do: [ :assoc | | ename clsname origClsname origMetaData | 
		ename := assoc key asUppercase asSymbol. 
		clsname := assoc value asSymbol.
		origClsname := self classNamesByMetaDataNameIndex at: ename .
		origMetaData := self metaDataByClassNameIndex at: origClsname.
		self altMetaDataByClassNameIndex at: clsname put: origMetaData.
		self altClassNamesByMetaDataNameIndex at: ename put: clsname].
		! !

!PlatypusCoreSchemaInstance methodsFor: 'private initializing' stamp: 'AlainPlantec 7/14/2011 16:56'!
buildIndexes
	| sch schClass |
	metaDataByClassNameIndex
		ifNil: [self expressParserClass
				ifNil: [self error: 'Platypus: EXPRESS Parser is not present']
				ifNotNil: [metaDataByClassNameIndex := IdentityDictionary new.
					classNamesByMetaDataNameIndex := IdentityDictionary new.
					metaData := self parsedMetaSchemaInstance.
					metaDataByClassNameIndex at: self class name asSymbol put: metaData.
					self schemaDefinitionClassInfos
						do: [:schInfo | 
							sch := self metaData lookUpSchemaDefinitionBN: schInfo first.
							schClass := PlatypusPharoSmalltalk at: schInfo second.
							schClass singleton metaData: sch.
							schClass singleton initializeFromOwner: self]]].
	self externalSchemaInstances
		do: [:schi | 
			schi singleton buildIndexes.
			schi singleton classNamesByMetaDataNameIndex
				keysAndValuesDo: [:k :v | classNamesByMetaDataNameIndex at: k put: v].
			schi singleton metaDataByClassNameIndex
				keysAndValuesDo: [:k :v | metaDataByClassNameIndex at: k put: v]] displayingProgress: 'Building meta data indexes'.! !

!PlatypusCoreSchemaInstance methodsFor: 'accessing' stamp: 'apl 3/15/2005 09:19'!
buildRepository
	^ self repositoryClass new! !

!PlatypusCoreSchemaInstance methodsFor: 'private meta data management' stamp: 'apl 4/19/2006 12:54'!
buildSplittedContents: baseSelector 
	| result max |
	result := WriteStream
				on: (String new: 500).
	max := self perform: (baseSelector , 'PartsCount') asSymbol.
	1
		to: max
		do: [:cpt | result
				nextPutAll: ((self perform: (baseSelector , cpt printString) asSymbol)
						copyReplaceAll: '(*\\*)' 
						with: String cr
						)].
	^ result contents! !

!PlatypusCoreSchemaInstance methodsFor: 'meta data accessing' stamp: 'AlainPlantec 10/26/2011 23:11'!
classFromEntityName: aString
	| key clsname |
	key := aString asUppercase asSymbol.
	clsname := self altClassNamesByMetaDataNameIndex at: key ifAbsent: [self classNamesByMetaDataNameIndex at: key].
	^ PlatypusPharoSmalltalk at: clsname! !

!PlatypusCoreSchemaInstance methodsFor: 'accessing' stamp: 'apl 12/19/2006 08:41'!
classNamesByMetaDataNameIndex
	^ classNamesByMetaDataNameIndex ifNil: [self buildIndexes. classNamesByMetaDataNameIndex]! !

!PlatypusCoreSchemaInstance methodsFor: 'accessing' stamp: 'AlainPlantec 5/13/2012 08:54'!
completeExpressSchemaCode
	| codeStream |
	codeStream := WriteStream on: String new.
	codeStream nextPutAll: self expressSchemaCode.
	self externalSchemaInstances
		do: [:schi | codeStream nextPutAll: schi singleton expressSchemaCode].
	^ codeStream contents! !

!PlatypusCoreSchemaInstance methodsFor: 'accessing' stamp: 'AlainPlantec 7/14/2011 16:56'!
context: aContext 
	self externalSchemaInstanceClassNames
		do: [:schi | (PlatypusPharoSmalltalk at: schi) singleton context: aContext]! !

!PlatypusCoreSchemaInstance methodsFor: 'accessing' stamp: 'AlainPlantec 7/14/2011 16:56'!
expressParserClass
	^ PlatypusPharoSmalltalk
		at: #PlatypusExpressParser
		ifAbsent: []! !

!PlatypusCoreSchemaInstance methodsFor: 'accessing' stamp: 'AlainPlantec 7/14/2011 16:56'!
expressSchemaInstanceClass
	^ PlatypusPharoSmalltalk
		at: #PltSchemaInstance
		ifAbsent: []! !

!PlatypusCoreSchemaInstance methodsFor: 'accessing' stamp: 'apl 2/2/2006 17:02'!
externalSchemaInstanceClassNames
	^ #()! !

!PlatypusCoreSchemaInstance methodsFor: 'accessing' stamp: 'AlainPlantec 7/14/2011 16:56'!
externalSchemaInstances
	^ self externalSchemaInstanceClassNames
		collect: [:cls | PlatypusPharoSmalltalk at: cls]! !

!PlatypusCoreSchemaInstance methodsFor: 'initialize-release' stamp: 'apl 2/28/2006 21:48'!
initialize
	super initialize.
	splitMarkStack := OrderedCollection new.! !

!PlatypusCoreSchemaInstance methodsFor: 'private splitmark stack (to be obsolete)' stamp: 'apl 2/28/2006 21:45'!
isAFileNamed: aName 
	| filename |
	(FileDirectory default directoryNamed: self resultOutputDirectoryName) assureExistence.
	filename := self resultOutputDirectoryName , FileDirectory slash , aName.
	^ StandardFileStream
		isAFileNamed: (StandardFileStream fullName: filename)! !

!PlatypusCoreSchemaInstance methodsFor: 'accessing' stamp: 'apl 12/19/2006 08:42'!
metaDataByClassNameIndex
	^ metaDataByClassNameIndex ifNil: 
			[self buildIndexes.metaDataByClassNameIndex]! !

!PlatypusCoreSchemaInstance methodsFor: 'accessing' stamp: 'AlainPlantec 10/26/2011 23:01'!
metaDataFor: aSymbol 
	^ self altMetaDataByClassNameIndex
		at: aSymbol
		ifAbsent: [self metaDataByClassNameIndex
				at: aSymbol
				ifAbsent: []] ! !

!PlatypusCoreSchemaInstance methodsFor: 'accessing' stamp: 'apl 3/10/2005 17:33'!
metaDataForClass: aClass 
	^ self metaDataFor: aClass name asSymbol! !

!PlatypusCoreSchemaInstance methodsFor: 'accessing' stamp: 'AlainPlantec 7/14/2011 16:55'!
namesBuilderClass

	^ PlatypusPharoSmalltalk at: self namesBuilderClassName! !

!PlatypusCoreSchemaInstance methodsFor: 'private splitmark stack (to be obsolete)' stamp: 'AlainPlantec 4/26/2012 09:27'!
outputFileStreamNamed: aName 
	| filename |
	(FileDirectory default directoryNamed: self resultOutputDirectoryName) assureExistence.
	filename := self resultOutputDirectoryName , FileDirectory slash , aName.
	(FileDirectory default
		directoryNamed: (FileDirectory dirPathFor: filename)) assureExistence.
	^ StandardFileStream forceNewFileNamed: filename! !

!PlatypusCoreSchemaInstance methodsFor: 'meta data accessing' stamp: 'apl 2/15/2007 15:19'!
parsedMetaSchemaInstance
	| schemaInstance |
	schemaInstance  := self expressParserClass schemaInstanceFromSource: self completeExpressSchemaCode.
	schemaInstance namesBuilder: self namesBuilder.
	^ schemaInstance! !

!PlatypusCoreSchemaInstance methodsFor: 'private splitmark stack (to be obsolete)' stamp: 'apl 2/28/2006 21:42'!
popSplitmark
	Transcript 
		show: 'Writing ' withCRs , splitMarkStack last name , '\' withCRs.
	splitMarkStack last close.
	splitMarkStack removeLast! !

!PlatypusCoreSchemaInstance methodsFor: 'private splitmark stack (to be obsolete)' stamp: 'AlainPlantec 4/26/2012 09:27'!
pushSplitmark: aFileName append: appendIt
	| contents oldStream |
	contents := ''.
	appendIt
		ifTrue: 
			[(self isAFileNamed: aFileName) 
				ifTrue: 
					[oldStream := self outputFileStreamNamed: aFileName.
					[contents := oldStream contentsOfEntireFile] ensure: [oldStream close]]].
	splitMarkStack add: (self outputFileStreamNamed: aFileName).
	appendIt ifTrue: [splitMarkStack last nextPutAll: contents]! !

!PlatypusCoreSchemaInstance methodsFor: 'accessing' stamp: 'AlainPlantec 7/14/2011 16:56'!
repositoryClass
	^ PlatypusPharoSmalltalk at: self repositoryClassName! !

!PlatypusCoreSchemaInstance methodsFor: 'accessing' stamp: 'apl 3/15/2005 09:29'!
repositoryClassName
	^ self subclassResponsibility! !

!PlatypusCoreSchemaInstance methodsFor: 'private splitmark stack (to be obsolete)' stamp: 'apl 2/28/2006 21:45'!
resultOutputDirectoryName
	^ 'Platypus-output'! !

!PlatypusCoreSchemaInstance methodsFor: 'private meta data management' stamp: 'apl 3/15/2005 13:16'!
schemaDefinitionClassInfos
	| result |
	result := OrderedCollection new.
	1
		to: self schemaDefinitionCount
		do: [:cpt | result
				add: (self perform: ('schemaDefinition' , cpt asString) asSymbol)].
	^ result! !

!PlatypusCoreSchemaInstance methodsFor: 'private meta data management' stamp: 'AlainPlantec 7/14/2011 16:56'!
schemaDefinitionClasses
	^ self schemaDefinitionClassInfos
		collect: [:info | PlatypusPharoSmalltalk at: info second asSymbol]! !

!PlatypusCoreSchemaInstance methodsFor: 'private meta data management' stamp: 'apl 3/15/2005 09:31'!
schemaDefinitionCount
	^ self subclassResponsibility ! !

!PlatypusCoreSchemaInstance methodsFor: 'accessing' stamp: 'apl 3/15/2005 09:40'!
schemaInstance
	^ self! !

!PlatypusCoreSchemaInstance methodsFor: 'private meta data management' stamp: 'apl 3/15/2005 13:17'!
schemata
	^ self schemaDefinitionClasses
		collect: [:cls | cls singleton]! !

!PlatypusCoreSchemaInstance methodsFor: 'meta data accessing' stamp: 'apl 12/7/2006 14:06'!
smalltalkTypeOf: aData 
	^ self  namesBuilder smalltalkTypeOf: aData! !

!PlatypusCoreSchemaInstance methodsFor: 'private splitmark stack (to be obsolete)' stamp: 'apl 2/28/2006 21:49'!
splitMarkOutput: aString
	splitMarkStack last nextPutAll: aString! !

PlatypusCoreSchemaInstance subclass: #PltPlatypusExpressPrimitivesSchemaInstance
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressPrimitivesSchemaInstance'!

!PltPlatypusExpressPrimitivesSchemaInstance commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
SCHEMA EXPRESS_builtins;

	FUNCTION ABS ( P : NUMBER ) : NUMBER;
		(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (v class val: (v pltNativeValue) abs)] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: (v abs)] 
		         #*);
	END_FUNCTION;

	FUNCTION ACOS ( P : NUMBER ) : REAL;
		(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (PltRealLiteral val: (v pltNativeValue) arcCos)] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: (v arcCos)] 
		         #*);
	END_FUNCTION;

	FUNCTION ASIN ( P : NUMBER ) : REAL;
		(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (PltRealLiteral val: (v pltNativeValue) arcSin)] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: (v arcSin)] 
		         #*);
	END_FUNCTION;

	FUNCTION ATAN ( V1 : NUMBER; V2 : NUMBER ) : REAL;
		(*#          | v |
			(v := self v1)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (PltRealLiteral val: (v pltNativeValue) arcTan)] 
		         #*) (*# <pharo> | v |
			^ (v := self v1) ifNotNil: [self return: (v arcTan)] 
		         #*);
	END_FUNCTION;

	FUNCTION BLENGTH ( P : BINARY ) : INTEGER;
		(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (PltIntegerLiteral val: (v pltNativeValue) size)] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: (v size)] 
		         #*);
	END_FUNCTION;

	FUNCTION COS ( P : NUMBER ) : REAL;
		(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (PltRealLiteral val: (v pltNativeValue) cos)] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: (v cos)] 
		         #*);
	END_FUNCTION;

	FUNCTION EVEN ( P : NUMBER ) : BOOLEAN;
		(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (PltLogicalLiteral val: (v pltNativeValue) even)] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: (v even)] 
		         #*);
	END_FUNCTION;

	FUNCTION EXISTS ( P : GENERIC ) : BOOLEAN;
		(*#          
			(self p)
				ifMissing: [^ self return: (PltLogicalLiteral val: false) ]
				ifNotMissing: [^ self return: (PltLogicalLiteral val: true) ] 
		         #*) (*# <pharo> | v |
			^ (self return: self p notNil)
		         #*);
	END_FUNCTION;

	FUNCTION EXP ( P : NUMBER ) : REAL;
		(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (PltRealLiteral val: (v pltNativeValue) exp)] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: (v exp)] 
		         #*);
	END_FUNCTION;

	FUNCTION FORMAT ( PN : NUMBER; PF : STRING ) : STRING;
		(*#          | n f formatted |
			(n := self pN)
				ifMissing: [^ self return: n]
				ifNotMissing: [(f := self pF) 
					ifMissing: [^ self return: f]
					ifNotMissing: [formatted := PlatypusExpressBuiltinFormatFormatter format: n pltNativeValue sourceFormat: f pltNativeValue trimBoth.
						^ self return: (PltStringLiteral val: formatted)]]
		         #*) (*# <pharo> | n f formatted |
			(n := self pN)
				ifNil: [^ self return: n]
				ifNotNil: [(f := self pF) 
					ifNil: [^ self return: f]
					ifNotNil: [formatted := PlatypusExpressBuiltinFormatFormatter format: n sourceFormat: f trimBoth.
						^ self return: formatted]]
		         #*);
	END_FUNCTION;

	FUNCTION HIBOUND ( P : AGGREGATE OF GENERIC ) : INTEGER;
		(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: v upperBound] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: (v upperBound)] 
		         #*);
	END_FUNCTION;

	FUNCTION HIINDEX ( P : AGGREGATE OF GENERIC ) : INTEGER;
		(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [((v := v pltNativeValue) isPltArray)
						ifTrue: [^ self return: (v upperBound)]
						ifFalse: [^ self return: (PltIntegerLiteral val: ( v pltNativeValue ) size)]]
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: (v upperBound)] 
		         #*);
	END_FUNCTION;

	FUNCTION LENGTH ( P : STRING ) : INTEGER;
		(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (PltIntegerLiteral val: (v pltNativeValue) size)] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: (v size)] 
		         #*);
	END_FUNCTION;

	FUNCTION LOBOUND ( P : AGGREGATE OF GENERIC ) : INTEGER;
		(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [
					(v := v lowerBound)
						ifMissing: [^ self return: (PltIntegerLiteral val: 0)]
						ifNotMissing: [^ self return: v]].
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: (v lowerBound)] 
		         #*);
	END_FUNCTION;

	FUNCTION LOG ( P : NUMBER ) : REAL;
		(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (PltRealLiteral val: (v pltNativeValue) ln)] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: (v ln)] 
		         #*);
	END_FUNCTION;

	FUNCTION LOG2 ( P : NUMBER ) : REAL;
		(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (PltRealLiteral val: (v pltNativeValue) log: 2)] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: (v log: 2)] 
		         #*);
	END_FUNCTION;

	FUNCTION LOG10 ( P : NUMBER ) : REAL;
		(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (PltRealLiteral val: (v pltNativeValue) log)] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: (v log)] 
		         #*);
	END_FUNCTION;

	FUNCTION LOINDEX ( P : AGGREGATE OF GENERIC ) : INTEGER;
		(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [((v := v pltNativeValue) isPltArray)
						ifTrue: [^ self return: (v lowerBound)]
						ifFalse: [^ self return: (PltIntegerLiteral val: 1)]]
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: (v lowerBound)] 
		         #*);
	END_FUNCTION;

	FUNCTION ODD ( P : INTEGER ) : BOOLEAN;
		(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (PltLogicalLiteral val: (v pltNativeValue) odd)] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: v odd] 
		         #*);
	END_FUNCTION;

	FUNCTION ROLESOF ( P : GENERIC ) : SET OF STRING;
		(*#         
			| arg result tmpResult |
			(arg := self p)
				ifMissing: [^ self return: arg]
				ifNotMissing: [result := PltSetInstance new.
					tmpResult := Set new.
					self
						dataDo: [:d | d rolesOf: arg in: tmpResult].
					result contents: tmpResult.
					^ self return: result]
		         #*) (*# <pharo>
			| arg result |
			(arg := self p)
				ifNil: [^ self return: arg]
				ifNotNil: [
					result := Set new.
					self
						dataDo: [:d | d rolesOf: arg in: result].
					^ self return: result]
		         #*);
	END_FUNCTION;

	FUNCTION SIN ( P : NUMBER ) : REAL;
		(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (PltRealLiteral val: (v pltNativeValue) sin)] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: v sin] 
		         #*);
	END_FUNCTION;

	FUNCTION SIZEOF ( P : AGGREGATE OF GENERIC ) : INTEGER;
		(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (PltIntegerLiteral val: (v pltNativeValue) size)] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: v size] 
		         #*);
	END_FUNCTION;

	FUNCTION SQRT ( P : NUMBER ) : REAL;
		(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (PltRealLiteral val: (v pltNativeValue) sqrt)] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: v sqrt] 
		         #*);
	END_FUNCTION;

	FUNCTION TAN ( P : NUMBER ) : REAL;
		(*#          | v |
			(v := self p)
				ifMissing: [^ self return: v]
				ifNotMissing: [^ self return: (PltRealLiteral val: (v pltNativeValue) tan)] 
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNotNil: [self return: v tan] 
		         #*);
	END_FUNCTION;

	FUNCTION TYPEOF ( P : GENERIC ) : SET OF STRING;
		(*#         
			| arg result |
			(arg := self p)
				ifMissing: [^ self return: arg]
				ifNotMissing: [
					result := PltSetInstance new.
					result contents: (PlatypusExpressTypeOfBuilder typeOfSetFor: arg computedDomain).
					^ self return: result]
		         #*) (*# <pharo>
			| arg result |
			(arg := self p)
				ifNil: [^ self return: arg]
				ifNotNil: [
					(arg isKindOf: PlatypusComplexInstance) 
						ifTrue: [result := OrderedCollection new.
							arg records do: [:rec | result addAll: (PlatypusExpressTypeOfBuilder typeOfSetFor: rec class platypusMetaData)]] 
						ifFalse: [result := (PlatypusExpressTypeOfBuilder typeOfSetFor: arg class platypusMetaData)].
					^ self return: (result collect: [:r | r val])]
		         #*);
	END_FUNCTION;

	FUNCTION USEDIN ( T : GENERIC; R : STRING ) : BAG OF GENERIC;
		(*#         
			| result tmpResult ent role schemaEntityAttribute schemaKey entityKey attributeKey |
			ent := self t.
			role := self r.
			result := PltBagInstance new.
			ent 
				ifMissing: [^ self return: ent]
				ifNotMissing: [
					role 
						ifMissing: [^ self return: role]
						ifNotMissing: [
							tmpResult := Bag new.
							role pltNativeValue 
								ifEmpty: [schemaKey := ''.
									entityKey := ''.
									attributeKey := '']
								ifNotEmpty: [:arg | schemaEntityAttribute := role pltNativeValue findTokens: $..
									schemaKey := schemaEntityAttribute first asUppercase.
									entityKey := schemaEntityAttribute second asUppercase.
									attributeKey := schemaEntityAttribute third asUppercase].
							self
								dataDo: [:d | d
									rolesValue: ent
									roleSchema: schemaKey
									roleEntity: entityKey
									roleAttribute: attributeKey
									in: tmpResult].
							result contents: tmpResult.
							^ self return: result]]
		         #*) (*# <pharo>
			| result tmpResult ent role schemaEntityAttribute schemaKey entityKey attributeKey |
			ent := self t.
			role := self r.
			result := Bag new.
			ent 
				ifNil: [^ self return: ent]
				ifNotNil: [
					role 
						ifNil: [^ self return: role]
						ifNotNil: [
							role 
								ifEmpty: [schemaKey := ''.
									entityKey := ''.
									attributeKey := '']
								ifNotEmpty: [:arg | schemaEntityAttribute := role findTokens: $..
									schemaKey := schemaEntityAttribute first asUppercase.
									entityKey := schemaEntityAttribute second asUppercase.
									attributeKey := schemaEntityAttribute third asUppercase].
							self
								dataDo: [:d | d
									rolesValue: ent
									roleSchema: schemaKey
									roleEntity: entityKey
									roleAttribute: attributeKey
									in: result].
							^ self return: result]]
		         #*);
	END_FUNCTION;

	FUNCTION VALUE ( V : STRING ) : NUMBER;
		(*#          | param nb result |
			param := self v.
			param pltNativeValue isString
				ifTrue: [[nb := param pltNativeValue asNumber.
					result := nb isInteger
								ifTrue: [PltIntegerLiteral new]
								ifFalse: [PltRealLiteral new].
					result val: nb]
						on: Error
						do: [result := PltMissingValue new]]
				ifFalse: [result := PltMissingValue new].
			^ self return: result
		         #*) (*# <pharo> | param nb result |
			(param := self v) isString
				ifTrue: [[result := param asNumber]
						on: Error
						do: [result := nil]]
				ifFalse: [result := nil].
			^ self return: result
		         #*);
	END_FUNCTION;

	FUNCTION VALUE_IN ( C : AGGREGATE OF GENERIC : gen; V : GENERIC : gen ) : LOGICAL;
		(*#          self signal: 'Value_in primitive is not implemented'.          #*) (*# <pharo> self signal: 'VALUE_IN primitive is not implemented'.          #*);
		RETURN ( ? );
	END_FUNCTION;

	FUNCTION VALUE_UNIQUE ( V : AGGREGATE OF GENERIC ) : LOGICAL;
		(*#          self signal: 'Value_unique primitive is not implemented'.          #*) (*# <pharo> self signal: 'VALUE_UNIQUE primitive is not implemented'.          #*);
		RETURN ( ? );
	END_FUNCTION;

	PROCEDURE INSERT ( VAR PL : LIST OF GENERIC : gen; PE : GENERIC : gen; PP : INTEGER );
		(*#         
			| l e p |
			l := self pL.
			e := self pE.
			p := self pP pltNativeValue.
			l pltAdd: e beforeIndex: p
		         #*) (*# <pharo>
			| l e p |
			l := self pL.
			e := self pE.
			p := self pP.
			p <= 0
				ifTrue: [l addFirst: e]
				ifFalse: [p >= l size
						ifTrue: [l addLast: e]
						ifFalse: [l add: e afterIndex: p]]
		         #*);
	END_PROCEDURE;

	PROCEDURE REMOVE ( VAR PL : LIST OF GENERIC : gen; PP : INTEGER );
		(*#         
			| l p |
			l := self pL.
			p := self pP pltNativeValue.
			l removeAt: p	
		         #*) (*# <pharo>
			| l p |
			l := self pL.
			p := self pP.
			l removeAt: p	
		         #*);
	END_PROCEDURE;

	FUNCTION NVL ( P : GENERIC : gen1; substitute : GENERIC : gen1 ) : GENERIC : gen1;
		(*#          | v | 
			(v := self p)
				ifMissing: [^ self return: (self substitute)]
				ifNotMissing: [^ self return: (v)]
		         #*) (*# <pharo> | v |
			^ (v := self p) ifNil: [self return: self substitute] ifNotNil: [self return: v] 
		         #*);
	END_FUNCTION;
END_SCHEMA;


</ISO10303-11-EXPRESS>!

!PltPlatypusExpressPrimitivesSchemaInstance class methodsFor: 'platypus-generated-initializing' stamp: ''!
bootstraps
	self reinitializeSingleton.
	self singleton buildIndexes

! !

!PltPlatypusExpressPrimitivesSchemaInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltPlatypusExpressPrimitivesSchemaInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltPlatypusExpressPrimitivesSchemaInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltPlatypusExpressPrimitivesSchemaInstance methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context
	^ context

! !

!PltPlatypusExpressPrimitivesSchemaInstance methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context: aContext
	context := aContext.
	super context: aContext

! !

!PltPlatypusExpressPrimitivesSchemaInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
externalSchemaInstanceClassNames
	^ #()

! !

!PltPlatypusExpressPrimitivesSchemaInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
namesBuilder
	| namesBuilder |
	namesBuilder := self namesBuilderClass new.
	namesBuilder classPrefix: #Plt.
	namesBuilder systemCategoryPrefix: #Platypus.
	namesBuilder rootClassName: #PltEntityInstance.
	namesBuilder rootClassSystemCategory: #'Platypus-PlatypusDictionarySchemaSchema'.
	^ namesBuilder

! !

!PltPlatypusExpressPrimitivesSchemaInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
namesBuilderClassName
	^ #PlatypusNamesBuilder

! !

!PltPlatypusExpressPrimitivesSchemaInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
repositoryClassName
	^ #PltPlatypusExpressPrimitivesRepository

! !

!PltPlatypusExpressPrimitivesSchemaInstance methodsFor: 'platypus-generated-schemata-accessing' stamp: ''!
schemaDefinition1
	^ #(#EXPRESS_builtins #PltExpressBuiltinsSchemaDefinition)

! !

!PltPlatypusExpressPrimitivesSchemaInstance methodsFor: 'platypus-generated-schemata-accessing' stamp: ''!
schemaDefinitionCount
	^ 1

! !

PlatypusCoreSchemaInstance subclass: #PltPlatypusMetaSchemasSchemaInstance
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusMetaSchemasSchemaInstance'!

!PltPlatypusMetaSchemasSchemaInstance commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
SCHEMA Platypus_expressions_schema;
	USE FROM Platypus_dictionary_schema;
	USE FROM Platypus_statements_schema;
	USE FROM Platypus_population_schema;

	ENTITY expression 
		ABSTRACT SUPERTYPE 
		SUBTYPE OF ( dictionary_instance );
	END_ENTITY;

	ENTITY unary_expression 
		ABSTRACT SUPERTYPE 
		SUBTYPE OF ( expression );
	END_ENTITY;

	ENTITY binary_expression 
		ABSTRACT SUPERTYPE 
		SUBTYPE OF ( expression );
		parenthesis : OPTIONAL BOOLEAN;
		left_expr : expression;
		right_expr : expression;
	END_ENTITY;

	ENTITY logical_expression 
		ABSTRACT SUPERTYPE 
		SUBTYPE OF ( binary_expression );
	END_ENTITY;

	ENTITY entity_instance_reference 
		SUBTYPE OF ( expression );
		persistent_label : STRING;
		ref : entity_instance;
	END_ENTITY;

	ENTITY instance_construction_expression 
		SUBTYPE OF ( binary_expression );
	END_ENTITY;

	ENTITY arithmetic_expression 
		ABSTRACT SUPERTYPE 
		SUBTYPE OF ( binary_expression );
	END_ENTITY;

	ENTITY expo_expression 
		SUBTYPE OF ( arithmetic_expression );
	END_ENTITY;

	ENTITY mult_expression 
		SUBTYPE OF ( arithmetic_expression );
	END_ENTITY;

	ENTITY div_expression 
		SUBTYPE OF ( arithmetic_expression );
	END_ENTITY;

	ENTITY real_div_expression 
		SUBTYPE OF ( arithmetic_expression );
	END_ENTITY;

	ENTITY mod_expression 
		SUBTYPE OF ( arithmetic_expression );
	END_ENTITY;

	ENTITY plus_expression 
		SUBTYPE OF ( arithmetic_expression );
	END_ENTITY;

	ENTITY minus_expression 
		SUBTYPE OF ( arithmetic_expression );
	END_ENTITY;

	ENTITY and_expression 
		SUBTYPE OF ( logical_expression );
	END_ENTITY;

	ENTITY or_expression 
		SUBTYPE OF ( logical_expression );
	END_ENTITY;

	ENTITY xor_expression 
		SUBTYPE OF ( logical_expression );
	END_ENTITY;

	ENTITY comparison_expression 
		ABSTRACT SUPERTYPE 
		SUBTYPE OF ( logical_expression );
	END_ENTITY;

	ENTITY less_than_expression 
		SUBTYPE OF ( comparison_expression );
	END_ENTITY;

	ENTITY greater_than_expression 
		SUBTYPE OF ( comparison_expression );
	END_ENTITY;

	ENTITY equal_expression 
		SUBTYPE OF ( comparison_expression );
	END_ENTITY;

	ENTITY less_equal_expression 
		SUBTYPE OF ( comparison_expression );
	END_ENTITY;

	ENTITY greater_equal_expression 
		SUBTYPE OF ( comparison_expression );
	END_ENTITY;

	ENTITY not_equal_expression 
		SUBTYPE OF ( comparison_expression );
	END_ENTITY;

	ENTITY inst_comparison_expression 
		ABSTRACT SUPERTYPE 
		SUBTYPE OF ( comparison_expression );
	END_ENTITY;

	ENTITY inst_equal_expression 
		SUBTYPE OF ( inst_comparison_expression );
	END_ENTITY;

	ENTITY inst_not_equal_expression 
		SUBTYPE OF ( inst_comparison_expression );
	END_ENTITY;

	ENTITY in_expression 
		SUBTYPE OF ( logical_expression );
	END_ENTITY;

	ENTITY like_expression 
		SUBTYPE OF ( logical_expression );
	END_ENTITY;

	ENTITY cardinality_expression 
		SUBTYPE OF ( logical_expression );
		card1 : expression;
		card2 : expression;
	END_ENTITY;

	ENTITY simple_unary_expression 
		ABSTRACT SUPERTYPE 
		SUBTYPE OF ( unary_expression );
		expr : expression;
	END_ENTITY;

	ENTITY not_expression 
		SUBTYPE OF ( simple_unary_expression );
	END_ENTITY;

	ENTITY positive_expression 
		SUBTYPE OF ( simple_unary_expression );
	END_ENTITY;

	ENTITY negative_expression 
		SUBTYPE OF ( simple_unary_expression );
	END_ENTITY;

	ENTITY typed_expression 
		SUBTYPE OF ( simple_unary_expression );
		domain : named_type_reference;
	END_ENTITY;

	ENTITY enumeration_value 
		SUBTYPE OF ( qualifier );
		domain : defined_type_reference;
		element : STRING;
	END_ENTITY;

	ENTITY entity_instances_set 
		SUBTYPE OF ( unary_expression );
		entity_ref : entity_definition_reference;
	END_ENTITY;

	ENTITY qualified_expression 
		SUBTYPE OF ( unary_expression );
		head : expression;
		qualifiers : LIST OF qualifier;
	END_ENTITY;

	ENTITY literal 
		ABSTRACT SUPERTYPE 
		SUBTYPE OF ( unary_expression );
	END_ENTITY;

	ENTITY identifier 
		SUBTYPE OF ( unary_expression );
		name : STRING;
		ref : dictionary_instance;
		parameters : OPTIONAL LIST OF expression;
	END_ENTITY;

	ENTITY attribute_identifier 
		SUBTYPE OF ( identifier );
		selfInstance : generic_instance;
	END_ENTITY;

	ENTITY self_identifier 
		SUBTYPE OF ( unary_expression );
	END_ENTITY;

	ENTITY uniqueness_rule_attribute_identifier 
		SUBTYPE OF ( identifier );
		group_ref_name : OPTIONAL STRING;
		SELF\identifier.ref : attribute;
	END_ENTITY;

	ENTITY missing_value 
		SUBTYPE OF ( unary_expression );
	END_ENTITY;

	ENTITY redefined_attribute_value 
		SUBTYPE OF ( missing_value );
	END_ENTITY;

	ENTITY implicitly_declared_identifier 
		SUBTYPE OF ( identifier );
	END_ENTITY;

	ENTITY interval 
		SUBTYPE OF ( unary_expression );
		expr : and_expression;
	END_ENTITY;

	ENTITY aggr_unary_expression 
		ABSTRACT SUPERTYPE 
		SUBTYPE OF ( unary_expression );
	END_ENTITY;

	ENTITY query_variable 
		SUBTYPE OF ( dictionary_instance );
		variable_id : STRING;
		SELF\entity_instance.owner : query_expression;
	END_ENTITY;

	ENTITY query_expression 
		SUBTYPE OF ( aggr_unary_expression );
		variable : query_variable;
		aggregate_source : expression;
		such_that : expression;
	END_ENTITY;

	ENTITY entity_instance_constructor 
		SUBTYPE OF ( unary_expression );
		decl : entity_definition_reference;
		parameters : LIST OF expression;
	END_ENTITY;

	ENTITY qualifier 
		ABSTRACT SUPERTYPE 
		SUBTYPE OF ( unary_expression );
	END_ENTITY;

	ENTITY attribute_qualifier 
		SUBTYPE OF ( qualifier );
		attribute_name : STRING;
	END_ENTITY;

	ENTITY group_qualifier 
		SUBTYPE OF ( qualifier );
		group_name : STRING;
	END_ENTITY;

	ENTITY index_qualifier 
		SUBTYPE OF ( qualifier );
	END_ENTITY;

	ENTITY element_qualifier 
		SUBTYPE OF ( index_qualifier );
		index : expression;
	END_ENTITY;

	ENTITY range_qualifier 
		SUBTYPE OF ( index_qualifier );
		index1 : expression;
		index2 : expression;
	END_ENTITY;

	ENTITY numeric_literal 
		ABSTRACT SUPERTYPE 
		SUBTYPE OF ( literal );
	END_ENTITY;

	ENTITY logical_literal 
		ABSTRACT SUPERTYPE 
		SUBTYPE OF ( literal );
	END_ENTITY;

	ENTITY true_constant 
		SUBTYPE OF ( logical_literal );
	END_ENTITY;

	ENTITY false_constant 
		SUBTYPE OF ( logical_literal );
	END_ENTITY;

	ENTITY unknown_constant 
		SUBTYPE OF ( logical_literal );
	END_ENTITY;

	ENTITY integer_literal 
		SUBTYPE OF ( numeric_literal );
		val : INTEGER;
	END_ENTITY;

	ENTITY real_literal 
		SUBTYPE OF ( numeric_literal );
		val : REAL;
	END_ENTITY;

	ENTITY pi_constant 
		SUBTYPE OF ( real_literal );
	DERIVE
		SELF\real_literal.val : REAL := 3.14159;
	END_ENTITY;

	ENTITY e_constant 
		SUBTYPE OF ( real_literal );
	DERIVE
		SELF\real_literal.val : REAL := 2.71828;
	END_ENTITY;

	ENTITY string_literal 
		SUBTYPE OF ( literal );
		val : STRING;
	END_ENTITY;

	ENTITY binary_literal 
		SUBTYPE OF ( literal );
		val : BINARY;
	END_ENTITY;

	ENTITY native_expression 
		SUBTYPE OF ( expression );
		source : native_algorithm;
	END_ENTITY;

	ENTITY escaped_expression 
		SUBTYPE OF ( expression );
		expr : expression;
	END_ENTITY;
END_SCHEMA;


SCHEMA Platypus_statements_schema;
	USE FROM Platypus_dictionary_schema;
	USE FROM Platypus_expressions_schema;

	ENTITY assignable 
		SUBTYPE OF ( dictionary_instance );
		head : identifier;
		qualifiers : LIST OF qualifier;
	END_ENTITY;

	ENTITY statement 
		ABSTRACT SUPERTYPE 
		SUBTYPE OF ( dictionary_instance );
	END_ENTITY;

	ENTITY null_statement 
		SUBTYPE OF ( statement );
	END_ENTITY;

	ENTITY native_statement 
		SUBTYPE OF ( statement );
		source : native_algorithm;
	END_ENTITY;

	ENTITY alias_statement_variable 
		SUBTYPE OF ( dictionary_instance );
		alias_ident : STRING;
		ref : assignable;
		SELF\entity_instance.owner : alias_statement;
	END_ENTITY;

	ENTITY alias_statement 
		SUBTYPE OF ( statement );
		variable : alias_statement_variable;
		statements : LIST OF statement;
	END_ENTITY;

	ENTITY assignment_statement 
		SUBTYPE OF ( statement );
		left : assignable;
		right_expr : expression;
	END_ENTITY;

	ENTITY case_statement 
		SUBTYPE OF ( statement );
		selector : expression;
		case_actions : LIST OF case_action;
		case_otherwise : OPTIONAL statement;
	END_ENTITY;

	ENTITY case_action 
		SUBTYPE OF ( dictionary_instance );
		labels : LIST OF expression;
		action : statement;
	END_ENTITY;

	ENTITY compound_statement 
		SUBTYPE OF ( statement );
		statements : LIST OF statement;
	END_ENTITY;

	ENTITY escape_statement 
		SUBTYPE OF ( statement );
	END_ENTITY;

	ENTITY if_statement 
		SUBTYPE OF ( statement );
		selector : expression;
		then_statements : LIST OF statement;
		else_statements : OPTIONAL LIST OF statement;
	END_ENTITY;

	ENTITY repeat_statement 
		SUBTYPE OF ( statement );
		incr_control : OPTIONAL increment_control;
		until_control : OPTIONAL expression;
		while_control : OPTIONAL expression;
		statements : LIST OF statement;
	END_ENTITY;

	ENTITY increment_control_variable 
		SUBTYPE OF ( dictionary_instance );
		variable_id : STRING;
		SELF\entity_instance.owner : increment_control;
	END_ENTITY;

	ENTITY increment_control 
		SUBTYPE OF ( dictionary_instance );
		variable : increment_control_variable;
		first : expression;
		last : expression;
		step : OPTIONAL expression;
		SELF\entity_instance.owner : repeat_statement;
	END_ENTITY;

	ENTITY return_statement 
		SUBTYPE OF ( statement );
		returned : OPTIONAL expression;
	END_ENTITY;

	ENTITY procedure_call_statement 
		SUBTYPE OF ( statement );
		call : identifier;
	END_ENTITY;

	ENTITY skip_statement 
		SUBTYPE OF ( statement );
	END_ENTITY;

	ENTITY output_statement 
		SUBTYPE OF ( statement );
		output : expression;
	END_ENTITY;

	ENTITY splitmark_statement 
		SUBTYPE OF ( statement );
		filename : expression;
	END_ENTITY;

	ENTITY end_splitmark_statement 
		SUBTYPE OF ( statement );
	END_ENTITY;

	ENTITY anonymous_variable 
		SUBTYPE OF ( dictionary_instance );
		domain : parameter_type;
	END_ENTITY;
END_SCHEMA;


SCHEMA Platypus_aggregate_data_schema;
	USE FROM Platypus_population_schema;
	USE FROM Platypus_dictionary_schema;
	USE FROM Platypus_expressions_schema;

	ENTITY aggregate_data 
		ABSTRACT SUPERTYPE OF ( ONEOF ( aggregate_instance, aggregate_initializer ) ) 
		SUBTYPE OF ( expression );
	END_ENTITY;

	ENTITY aggregate_initializer 
		SUBTYPE OF ( aggregate_data );
		contents : LIST OF aggregate_initializer_element;
	END_ENTITY;

	ENTITY aggregate_initializer_element 
		SUBTYPE OF ( dictionary_instance );
		SELF\entity_instance.owner : aggregate_initializer;
		val : primitive;
		repetition : OPTIONAL expression;
	END_ENTITY;

	ENTITY aggregate_instance 
		ABSTRACT SUPERTYPE OF ( ONEOF ( array_instance, variable_size_aggregation_instance ) ) 
		SUBTYPE OF ( aggregate_data );
		lower_bound : integer_literal;
		upper_bound : integer_literal;
	END_ENTITY;

	ENTITY array_instance 
		SUBTYPE OF ( aggregate_instance );
		contents : LIST OF primitive;
	END_ENTITY;

	ENTITY variable_size_aggregation_instance 
		ABSTRACT SUPERTYPE OF ( ONEOF ( set_instance, bag_instance, list_instance ) ) 
		SUBTYPE OF ( aggregate_instance );
	END_ENTITY;

	ENTITY list_instance 
		SUBTYPE OF ( variable_size_aggregation_instance );
		contents : LIST OF primitive;
	END_ENTITY;

	ENTITY bag_instance 
		SUBTYPE OF ( variable_size_aggregation_instance );
		contents : BAG OF primitive;
	END_ENTITY;

	ENTITY set_instance 
		SUBTYPE OF ( variable_size_aggregation_instance );
		contents : SET OF primitive;
	END_ENTITY;
END_SCHEMA;


SCHEMA Platypus_population_schema;
	USE FROM Platypus_expressions_schema;
	USE FROM Platypus_environment_schema;
	USE FROM Platypus_dictionary_schema;

	ENTITY instance_scope 
		SUBTYPE OF ( session_instance );
		owned : LIST [ 1 : ? ] OF entity_instance;
		export_list : LIST [ 0 : ? ] OF entity_instance;
	END_ENTITY;

	ENTITY application_instance 
		ABSTRACT SUPERTYPE 
		SUBTYPE OF ( entity_instance );
		owning_model : model_contents;
		persistent_label : STRING;
	END_ENTITY;

	ENTITY generic_instance 
		ABSTRACT SUPERTYPE 
		SUBTYPE OF ( application_instance );
		instance_scope : OPTIONAL instance_scope;
	END_ENTITY;

	ENTITY internal_representation 
		SUBTYPE OF ( generic_instance );
		definition : entity_definition_reference;
		parameters : LIST OF primitive;
	END_ENTITY;

	ENTITY external_representation 
		SUBTYPE OF ( generic_instance );
		records : LIST OF simple_record;
	END_ENTITY;

	ENTITY group_representation 
		ABSTRACT SUPERTYPE 
		SUBTYPE OF ( generic_instance );
		definition : entity_definition_reference;
		instRef : generic_instance;
	END_ENTITY;

	ENTITY external_group_representation 
		SUBTYPE OF ( group_representation );
	END_ENTITY;

	ENTITY internal_group_representation 
		SUBTYPE OF ( group_representation );
	END_ENTITY;

	ENTITY user_defined_application_instance 
		SUBTYPE OF ( application_instance );
		name : STRING;
		parameters : LIST OF primitive;
	END_ENTITY;

	ENTITY simple_record 
		SUBTYPE OF ( entity_instance );
		definition : entity_definition_reference;
		parameters : LIST OF primitive;
		SELF\entity_instance.owner : generic_instance;
	END_ENTITY;

	ENTITY header_instance 
		ABSTRACT SUPERTYPE 
		SUBTYPE OF ( entity_instance );
		owning_model : model_contents;
	END_ENTITY;

	ENTITY user_defined_header_instance 
		SUBTYPE OF ( header_instance );
		name : STRING;
		parameters : LIST OF primitive;
	END_ENTITY;

	ENTITY file_description 
		SUBTYPE OF ( header_instance );
		description : LIST [ 1 : ? ] OF STRING ( 256 );
		implementation_level : STRING ( 256 );
	END_ENTITY;

	ENTITY file_name 
		SUBTYPE OF ( header_instance );
		name : STRING ( 256 );
		time_stamp : STRING ( 256 );
		author : LIST [ 1 : ? ] OF STRING ( 256 );
		organization : LIST [ 1 : ? ] OF STRING ( 256 );
		preprocessor_version : STRING ( 256 );
		originating_system : STRING ( 256 );
		authorisation : STRING ( 256 );
	END_ENTITY;

	ENTITY file_schema 
		SUBTYPE OF ( header_instance );
		schema_identifiers : LIST [ 1 : ? ] OF schema_name;
	END_ENTITY;
END_SCHEMA;


SCHEMA Platypus_environment_schema;
	USE FROM Platypus_population_schema;
	USE FROM Platypus_dictionary_schema;

	ENTITY model_contents 
		SUBTYPE OF ( session_instance );
		SELF\entity_instance.owner : schema_instance;
	INVERSE
		instances : SET [ 0 : ? ] OF application_instance FOR owning_model;
	END_ENTITY;

	ENTITY schema_instance 
		SUBTYPE OF ( session_instance );
		name : STRING;
		associated_models : LIST [ 0 : ? ] OF model_contents;
		schemata : LIST [ 0 : ? ] OF schema_definition;
	DERIVE
		accepted : entity_instance := SELF.accept_schema_instance;
	END_ENTITY;
END_SCHEMA;


SCHEMA Platypus_dictionary_schema;
	USE FROM Platypus_expressions_schema;
	USE FROM Platypus_statements_schema;
	USE FROM Platypus_population_schema;
	USE FROM Platypus_environment_schema;
	USE FROM Platypus_aggregate_data_schema;

	TYPE constructed_type = SELECT
		( enumeration_type, select_type );
	END_TYPE;

	TYPE type_or_rule = SELECT
		( named_type, global_rule );
	END_TYPE;

	TYPE base_type = SELECT
		( simple_type, aggregation_type, named_type_reference );
	END_TYPE;

	TYPE underlying_type = SELECT
		( simple_type, aggregation_type, named_type_reference, constructed_type );
	END_TYPE;

	TYPE parameter_type = SELECT
		( simple_type, aggregate_type, aggregate_initializer_domain, named_type_reference );
	END_TYPE;

	TYPE declaration = SELECT
		( named_type, global_rule, constant_definition, procedure_declaration );
	END_TYPE;

	TYPE time_stamp = STRING ( 256 );
	END_TYPE;

	TYPE primitive = expression;
	END_TYPE;

	TYPE schema_name = STRING;
	END_TYPE;

	TYPE context_owner = SELECT
		( context_definition, schema_instance );
	END_TYPE;

	TYPE inter_schema_link = ENUMERATION
		OF ( used, referenced );
	END_TYPE;

	ENTITY entity_instance 
		ABSTRACT SUPERTYPE;
		owner : OPTIONAL entity_instance;
	END_ENTITY;

	ENTITY sdai_instance 
		ABSTRACT SUPERTYPE OF ( ONEOF ( dictionary_instance, session_instance ) ) 
		SUBTYPE OF ( entity_instance );
	END_ENTITY;

	ENTITY dictionary_instance 
		ABSTRACT SUPERTYPE 
		SUBTYPE OF ( sdai_instance );
	DERIVE
		handled : dictionary_instance := SELF;
	END_ENTITY;

	ENTITY session_instance 
		ABSTRACT SUPERTYPE 
		SUBTYPE OF ( sdai_instance );
		change_date : OPTIONAL time_stamp;
		validation_date : time_stamp;
		validation_result : LOGICAL;
	END_ENTITY;

	ENTITY domain_equivalent_item 
		SUBTYPE OF ( dictionary_instance );
		name : STRING;
		external_item_id : STRING;
		native_item : declaration;
	END_ENTITY;

	ENTITY context_definition 
		ABSTRACT SUPERTYPE OF ( ONEOF ( schema_definition, statements_container ) ) 
		SUBTYPE OF ( dictionary_instance );
		name : STRING;
		constants : LIST OF constant_definition;
		types : LIST OF defined_type;
		entities : LIST OF entity_definition;
		algorithmes : LIST OF algorithm_declaration;
		SELF\entity_instance.owner : OPTIONAL context_owner;
	END_ENTITY;

	ENTITY statements_container 
		ABSTRACT SUPERTYPE 
		SUBTYPE OF ( context_definition );
		locals : LIST OF local_variable;
		statements : LIST OF statement;
	END_ENTITY;

	ENTITY global_rule 
		SUBTYPE OF ( statements_container );
		for_entities : LIST [ 1 : ? ] OF entity_instances_set;
		where_rules : LIST [ 1 : ? ] OF where_rule;
		SELF\context_definition.owner : schema_definition;
	DERIVE
		accepted : entity_instance := SELF.accept_global_rule;
	END_ENTITY;

	ENTITY external_schema 
		SUBTYPE OF ( dictionary_instance );
		name : schema_name;
		SELF\entity_instance.owner : schema_definition;
	END_ENTITY;

	ENTITY include_schema 
		SUBTYPE OF ( external_schema );
		native_schema : schema_definition;
		explicitly_imported_items : LIST OF domain_equivalent_item;
		implicitly_imported_items : LIST OF domain_equivalent_item;
	END_ENTITY;

	ENTITY used_schema 
		SUBTYPE OF ( include_schema );
	END_ENTITY;

	ENTITY referenced_schema 
		SUBTYPE OF ( include_schema );
	END_ENTITY;

	ENTITY external_meta_schema 
		SUBTYPE OF ( external_schema );
	END_ENTITY;

	ENTITY algorithm_declaration 
		ABSTRACT SUPERTYPE 
		SUBTYPE OF ( statements_container );
		formal_parameters : LIST OF parameter_definition;
	END_ENTITY;

	ENTITY native_code 
		SUBTYPE OF ( dictionary_instance );
		language_signature : STRING;
		code : STRING;
	END_ENTITY;

	ENTITY native_algorithm 
		SUBTYPE OF ( dictionary_instance );
		implementations : LIST OF native_code;
	END_ENTITY;

	ENTITY procedure_declaration 
		SUBTYPE OF ( algorithm_declaration );
	DERIVE
		accepted : entity_instance := SELF.accept_procedure_declaration;
	END_ENTITY;

	ENTITY function_declaration 
		SUBTYPE OF ( algorithm_declaration );
		return_type : parameter_type;
	DERIVE
		accepted : entity_instance := SELF.accept_function_declaration;
	END_ENTITY;

	ENTITY bound 
		ABSTRACT SUPERTYPE OF ( ONEOF ( integer_bound, population_dependent_bound ) ) 
		SUBTYPE OF ( dictionary_instance );
	END_ENTITY;

	ENTITY integer_bound 
		SUBTYPE OF ( bound );
		bound_value : INTEGER;
	END_ENTITY;

	ENTITY population_dependent_bound 
		SUBTYPE OF ( bound );
		bound_value : expression;
	END_ENTITY;

	ENTITY enumeration_type 
		SUBTYPE OF ( dictionary_instance );
		elements : LIST [ 1 : ? ] OF UNIQUE STRING;
		SELF\entity_instance.owner : defined_type;
	DERIVE
		accepted : entity_instance := SELF.accept_enumeration_type;
	END_ENTITY;

	ENTITY named_type 
		ABSTRACT SUPERTYPE OF ( ONEOF ( entity_definition, defined_type ) ) 
		SUBTYPE OF ( dictionary_instance );
		name : STRING;
		where_rules : LIST [ 0 : ? ] OF where_rule;
		SELF\entity_instance.owner : context_definition;
	END_ENTITY;

	ENTITY dictionary_instance_reference 
		SUBTYPE OF ( dictionary_instance );
		ref : dictionary_instance;
		name : STRING;
	DERIVE
		SELF\dictionary_instance.handled : dictionary_instance := SELF.ref;
	END_ENTITY;

	ENTITY named_type_reference 
		SUBTYPE OF ( dictionary_instance_reference );
		SELF\dictionary_instance_reference.ref : named_type;
	DERIVE
		accepted : entity_instance := SELF.accept_named_type_reference;
	END_ENTITY;

	ENTITY attribute_reference 
		SUBTYPE OF ( dictionary_instance_reference );
		SELF\dictionary_instance_reference.ref : attribute;
		entity_ref : entity_definition_reference;
	DERIVE
		SELF\named_type_reference.accepted : entity_instance := SELF.accept_attribute_reference;
	END_ENTITY;

	ENTITY entity_definition_reference 
		SUBTYPE OF ( named_type_reference );
		SELF\named_type_reference.ref : entity_definition;
	DERIVE
		SELF\named_type_reference.accepted : entity_instance := SELF.accept_entity_definition_reference;
	END_ENTITY;

	ENTITY defined_type_reference 
		SUBTYPE OF ( named_type_reference );
		SELF\named_type_reference.ref : defined_type;
	DERIVE
		SELF\named_type_reference.accepted : entity_instance := SELF.accept_defined_type_reference;
	END_ENTITY;

	ENTITY where_rule 
		SUBTYPE OF ( dictionary_instance );
		label : OPTIONAL STRING;
		SELF\entity_instance.owner : type_or_rule;
		where_value : expression;
	END_ENTITY;

	ENTITY select_type 
		SUBTYPE OF ( dictionary_instance );
		selections : LIST [ 1 : ? ] OF named_type_reference;
		SELF\entity_instance.owner : defined_type;
	DERIVE
		accepted : entity_instance := SELF.accept_select_type;
	END_ENTITY;

	ENTITY defined_type 
		SUBTYPE OF ( named_type );
		domain : underlying_type;
	DERIVE
		accepted : entity_instance := SELF.accept_defined_type;
	END_ENTITY;

	ENTITY entity_definition 
		SUBTYPE OF ( named_type );
		supertype_constraint : OPTIONAL supertype_constraint;
		supertypes : LIST OF UNIQUE entity_definition_reference;
		attributes : LIST OF UNIQUE attribute;
		uniqueness_rules : LIST OF UNIQUE uniqueness_rule;
		complex : BOOLEAN;
		instantiable : BOOLEAN;
		independent : BOOLEAN;
	DERIVE
		accepted : entity_instance := SELF.accept_entity_definition;
	END_ENTITY;

	ENTITY supertype_constraint 
		SUBTYPE OF ( dictionary_instance );
		constrained : entity_definition_reference;
		expr : OPTIONAL supertype_expression;
	END_ENTITY;

	ENTITY supertype_expression 
		ABSTRACT SUPERTYPE OF ( ONEOF ( sub_entity_ref_expression, binary_supertype_expression, oneof_supertype_expression ) ) 
		SUBTYPE OF ( dictionary_instance );
	END_ENTITY;

	ENTITY sub_entity_ref_expression 
		SUBTYPE OF ( supertype_expression );
		entity_ref : entity_definition_reference;
	END_ENTITY;

	ENTITY binary_supertype_expression 
		SUBTYPE OF ( supertype_expression );
		parenthesis : OPTIONAL BOOLEAN;
		left_expr : supertype_expression;
		right_expr : supertype_expression;
	END_ENTITY;

	ENTITY andor_supertype 
		SUBTYPE OF ( binary_supertype_expression );
	END_ENTITY;

	ENTITY and_supertype 
		SUBTYPE OF ( binary_supertype_expression );
	END_ENTITY;

	ENTITY oneof_supertype_expression 
		SUBTYPE OF ( supertype_expression );
		expr_list : LIST OF supertype_expression;
	END_ENTITY;

	ENTITY uniqueness_rule 
		SUBTYPE OF ( dictionary_instance );
		label : OPTIONAL STRING;
		attributes : LIST [ 1 : ? ] OF UNIQUE uniqueness_rule_attribute_identifier;
		SELF\entity_instance.owner : entity_definition;
	END_ENTITY;

	ENTITY attribute 
		ABSTRACT SUPERTYPE OF ( ONEOF ( derived_attribute, explicit_attribute, inverse_attribute ) ) 
		SUBTYPE OF ( dictionary_instance );
		name : STRING;
		SELF\entity_instance.owner : entity_definition;
		domain : base_type;
		redeclaring : OPTIONAL attribute_reference;
	END_ENTITY;

	ENTITY aggregate_initializer_domain 
		SUBTYPE OF ( dictionary_instance );
		types : LIST [ 1 : ? ] OF parameter_type;
	END_ENTITY;

	ENTITY aggregate_type 
		ABSTRACT SUPERTYPE OF ( ONEOF ( aggregation_type, general_aggregate_type ) ) 
		SUBTYPE OF ( dictionary_instance );
		element_type : parameter_type;
	END_ENTITY;

	ENTITY general_aggregate_type 
		SUBTYPE OF ( aggregate_type );
		type_label : OPTIONAL STRING;
	END_ENTITY;

	ENTITY aggregation_type 
		ABSTRACT SUPERTYPE OF ( ONEOF ( variable_size_aggregation_type, array_type ) ) 
		SUBTYPE OF ( aggregate_type );
		lower_bound : OPTIONAL bound;
		upper_bound : OPTIONAL bound;
		is_general_type : BOOLEAN;
	END_ENTITY;

	ENTITY array_type 
		SUBTYPE OF ( aggregation_type );
		unique_flag : BOOLEAN;
		optional_flag : BOOLEAN;
		SELF\aggregation_type.lower_bound : bound;
		SELF\aggregation_type.upper_bound : bound;
	DERIVE
		accepted : entity_instance := SELF.accept_array_type;
	END_ENTITY;

	ENTITY variable_size_aggregation_type 
		ABSTRACT SUPERTYPE OF ( ONEOF ( set_type, bag_type, list_type ) ) 
		SUBTYPE OF ( aggregation_type );
	END_ENTITY;

	ENTITY list_type 
		SUBTYPE OF ( variable_size_aggregation_type );
		unique_flag : BOOLEAN;
	DERIVE
		accepted : entity_instance := SELF.accept_list_type;
	END_ENTITY;

	ENTITY bag_type 
		SUBTYPE OF ( variable_size_aggregation_type );
	DERIVE
		accepted : entity_instance := SELF.accept_bag_type;
	END_ENTITY;

	ENTITY set_type 
		SUBTYPE OF ( variable_size_aggregation_type );
	DERIVE
		accepted : entity_instance := SELF.accept_set_type;
	END_ENTITY;

	ENTITY simple_type 
		ABSTRACT SUPERTYPE OF ( ONEOF ( string_type, binary_type, logical_type, number_type ) ) 
		SUBTYPE OF ( dictionary_instance );
	END_ENTITY;

	ENTITY string_type 
		SUBTYPE OF ( simple_type );
		width : OPTIONAL bound;
		fixed_width : BOOLEAN;
	DERIVE
		accepted : entity_instance := SELF.accept_string_type;
	END_ENTITY;

	ENTITY binary_type 
		SUBTYPE OF ( simple_type );
		width : OPTIONAL bound;
		fixed_width : BOOLEAN;
	DERIVE
		accepted : entity_instance := SELF.accept_binary_type;
	END_ENTITY;

	ENTITY number_type 
		SUBTYPE OF ( simple_type );
	DERIVE
		accepted : entity_instance := SELF.accept_number_type;
	END_ENTITY;

	ENTITY real_type 
		SUBTYPE OF ( number_type );
		precision : OPTIONAL bound;
	DERIVE
		SELF\number_type.accepted : entity_instance := SELF.accept_real_type;
	END_ENTITY;

	ENTITY integer_type 
		SUBTYPE OF ( number_type );
		precision : OPTIONAL bound;
	DERIVE
		SELF\number_type.accepted : entity_instance := SELF.accept_integer_type;
	END_ENTITY;

	ENTITY logical_type 
		SUBTYPE OF ( simple_type );
	DERIVE
		accepted : entity_instance := SELF.accept_logical_type;
	END_ENTITY;

	ENTITY boolean_type 
		SUBTYPE OF ( logical_type );
	DERIVE
		SELF\logical_type.accepted : entity_instance := SELF.accept_boolean_type;
	END_ENTITY;

	ENTITY constant_definition 
		SUBTYPE OF ( dictionary_instance );
		name : STRING;
		domain : base_type;
		initializer : expression;
		SELF\entity_instance.owner : context_definition;
	END_ENTITY;

	ENTITY local_variable 
		SUBTYPE OF ( dictionary_instance );
		SELF\entity_instance.owner : statements_container;
		name : STRING;
		domain : parameter_type;
		initializer : OPTIONAL expression;
	END_ENTITY;

	ENTITY parameter_definition 
		SUBTYPE OF ( dictionary_instance );
		SELF\entity_instance.owner : algorithm_declaration;
		name : STRING;
		by_copy : BOOLEAN;
		domain : parameter_type;
	END_ENTITY;

	ENTITY generic_type 
		SUBTYPE OF ( dictionary_instance );
		type_label : OPTIONAL STRING;
	DERIVE
		accepted : entity_instance := SELF.accept_generic_type;
	END_ENTITY;

	ENTITY remark 
		ABSTRACT SUPERTYPE OF ( ONEOF ( tail_remark, embedded_remark ) ) 
		SUBTYPE OF ( entity_instance );
		text : STRING;
	END_ENTITY;

	ENTITY tail_remark 
		SUBTYPE OF ( remark );
	END_ENTITY;

	ENTITY embedded_remark 
		SUBTYPE OF ( remark );
	END_ENTITY;

	ENTITY remark_reference 
		SUBTYPE OF ( dictionary_instance );
		prefix : STRING;
		suffix : OPTIONAL STRING;
		inside : dictionary_instance_reference;
		referenced : dictionary_instance_reference;
		remark : remark;
	END_ENTITY;

	ENTITY meta_concept_definition 
		SUBTYPE OF ( dictionary_instance );
		definition : dictionary_instance;
		expression : STRING;
	END_ENTITY;

	ENTITY derived_attribute 
		SUBTYPE OF ( attribute );
		assign : expression;
	DERIVE
		accepted : entity_instance := SELF.accept_derived_attribute;
	END_ENTITY;

	ENTITY explicit_attribute 
		SUBTYPE OF ( attribute );
		optional_flag : BOOLEAN;
	DERIVE
		accepted : entity_instance := SELF.accept_explicit_attribute;
	END_ENTITY;

	ENTITY inverse_attribute 
		SUBTYPE OF ( attribute );
		inverted_attr : attribute_reference;
		min_cardinality : OPTIONAL bound;
		max_cardinality : OPTIONAL bound;
		duplicates : BOOLEAN;
	DERIVE
		SELF\attribute.domain : entity_definition_reference := inverted_attr.entity_ref;
		accepted : entity_instance := SELF.accept_inverse_attribute;
	END_ENTITY;

	ENTITY meta_mapping_rule 
		SUBTYPE OF ( dictionary_instance );
		condition : STRING;
		expression : STRING;
	END_ENTITY;

	ENTITY meta_mapping_definition 
		SUBTYPE OF ( dictionary_instance );
		definition : dictionary_instance;
		expression : STRING;
	END_ENTITY;

	ENTITY schema_definition 
		SUBTYPE OF ( context_definition );
		global_rules : LIST OF global_rule;
		interface : LIST OF external_schema;
		remark_references : LIST OF remark_reference;
	DERIVE
		accepted : entity_instance := SELF.accept_schema_definition;
	END_ENTITY;
END_SCHEMA;


</ISO10303-11-EXPRESS>!

!PltPlatypusMetaSchemasSchemaInstance class methodsFor: 'platypus-generated-initializing' stamp: 'AlainPlantec 10/31/2012 16:10'!
bootstraps 	
	self reinitializeSingleton. 
	self singleton buildIndexes.

! !

!PltPlatypusMetaSchemasSchemaInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltPlatypusMetaSchemasSchemaInstance class methodsFor: 'accessing' stamp: 'alain.plantec 1/20/2009 11:57'!
singleton
	^ singleton ifNil: [singleton := self new]
	! !

!PltPlatypusMetaSchemasSchemaInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltPlatypusMetaSchemasSchemaInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltPlatypusMetaSchemasSchemaInstance methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context
	^ context

! !

!PltPlatypusMetaSchemasSchemaInstance methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context: aContext
	context := aContext.
	super context: aContext

! !

!PltPlatypusMetaSchemasSchemaInstance methodsFor: 'platypus-generated-schema-accessing' stamp: ''!
expressSchemaCode1	^	'SCHEMA Platypus_expressions_schema;(*\\*)',	'	USE FROM Platypus_dictionary_schema;(*\\*)',	'	USE FROM Platypus_statements_schema;(*\\*)',	'	USE FROM Platypus_population_schema;(*\\*)',	'(*\\*)',	'	ENTITY expression (*\\*)',	'		ABSTRACT SUPERTYPE (*\\*)',	'		SUBTYPE OF ( dictionary_instance );(*\\*)',	'		owner : OPTIONAL dictionary_instance;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY unary_expression (*\\*)',	'		ABSTRACT SUPERTYPE (*\\*)',	'		SUBTYPE OF ( expression );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY binary_expression (*\\*)',	'		ABSTRACT SUPERTYPE (*\\*)',	'		SUBTYPE OF ( expression );(*\\*)',	'		parenthesis : OPTIONAL BOOLEAN;(*\\*)',	'		left_expr : expression;(*\\*)',	'		right_expr : expression;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY logical_expression (*\\*)',	'		ABSTRACT SUPERTYPE (*\\*)',	'		SUBTYPE OF ( binary_expression );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY entity_instance_reference (*\\*)',	'		SUBTYPE OF ( expression );(*\\*)',	'		persistent_label : STRING;(*\\*)',	'		ref : entity_instance;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY instance_construction_expression (*\\*)',	'		SUBTYPE OF ( binary_expression );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY arithmetic_expression (*\\*)',	'		ABSTRACT SUPERTYPE (*\\*)',	'		SUBTYPE OF ( binary_expression );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY expo_expression (*\\*)',	'		SUBTYPE OF ( arithmetic_expression );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY mult_expression (*\\*)',	'		SUBTYPE OF ( arithmetic_expression );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY div_expression (*\\*)',	'		SUBTYPE OF ( arithmetic_expression );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY real_div_expression (*\\*)',	'		SUBTYPE OF ( arithmetic_expression );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY mod_expression (*\\*)',	'		SUBTYPE OF ( arithmetic_expression );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY plus_expression (*\\*)',	'		SUBTYPE OF ( arithmetic_expression );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY minus_expression (*\\*)',	'		SUBTYPE OF ( arithmetic_expression );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY and_expression (*\\*)',	'		SUBTYPE OF ( logical_expression );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY or_expression (*\\*)',	'		SUBTYPE OF ( logical_expression );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY xor_expression (*\\*)',	'		SUBTYPE OF ( logical_expression );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY comparison_expression (*\\*)',	'		ABSTRACT SUPERTYPE (*\\*)',	'		SUBTYPE OF ( logical_expression );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY less_than_expression (*\\*)',	'		SUBTYPE OF ( comparison_expression );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY greater_than_expression (*\\*)',	'		SUBTYPE OF ( comparison_expression );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY equal_expression (*\\*)',	'		SUBTYPE OF ( comparison_expression );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY less_equal_expression (*\\*)',	'		SUBTYPE OF ( comparison_expression );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY greater_equal_expression (*\\*)',	'		SUBTYPE OF ( comparison_expression );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY not_equal_expression (*\\*)',	'		SUBTYPE OF ( comparison_expression );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY inst_comparison_expression (*\\*)',	'		ABSTRACT SUPERTYPE (*\\*)',	'		SUBTYPE OF ( comparison_expression );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY inst_equal_expression (*\\*)',	'		SUBTYPE OF ( inst_comparison_expression );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY inst_not_equal_expression (*\\*)',	'		SUBTYPE OF ( inst_comparison_expression );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY in_expression (*\\*)',	'		SUBTYPE OF ( logical_expression );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY like_expression (*\\*)',	'		SUBTYPE OF ( logical_expression );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY cardinality_expression (*\\*)',	'		SUBTYPE OF ( logical_expression );(*\\*)',	'		card1 : expression;(*\\*)',	'		card2 : expression;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY simple_unary_expression (*\\*)',	'		ABSTRACT SUPERTYPE (*\\*)',	'		SUBTYPE OF ( unary_expression );(*\\*)',	'		expr : expression;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY not_expression (*\\*)',	'		SUBTYPE OF ( simple_unary_expression );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY positive_expression (*\\*)',	'		SUBTYPE OF ( simple_unary_expression );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY negative_expression (*\\*)',	'		SUBTYPE OF ( simple_unary_expression );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY typed_expression (*\\*)',	'		SUBTYPE OF ( simple_unary_expression );(*\\*)',	'		domain : named_type_reference;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY enumeration_value (*\\*)',	'		SUBTYPE OF ( qualifier );(*\\*)',	'		domain : defined_type_reference;(*\\*)',	'		element : STRING;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY entity_instances_set (*\\*)',	'		SUBTYPE OF ( unary_expression );(*\\*)',	'		entity_ref : entity_definition_reference;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY qualified_expression (*\\*)',	'		SUBTYPE OF ( unary_expression );(*\\*)',	'		head : expression;(*\\*)',	'		qualifiers : LIST OF qualifier;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY literal (*\\*)',	'		ABSTRACT SUPERTYPE (*\\*)',	'		SUBTYPE OF ( unary_expression );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY identifier (*\\*)',	'		SUBTYPE OF ( unary_expression );(*\\*)',	'		name : STRING;(*\\*)',	'		ref : dictionary_instance;(*\\*)',	'		parameters : OPTIONAL LIST OF expression;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY attribute_identifier (*\\*)',	'		SUBTYPE OF ( identifier );(*\\*)',	'		selfInstance : generic_instance_reference;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY self_identifier (*\\*)',	'		SUBTYPE OF ( unary_expression );(*\\*)',	'	END_ENTITY;(*\\*)',	''

! !

!PltPlatypusMetaSchemasSchemaInstance methodsFor: 'platypus-generated-schema-accessing' stamp: ''!
expressSchemaCode2	^	'(*\\*)',	'	ENTITY uniqueness_rule_attribute_identifier (*\\*)',	'		SUBTYPE OF ( identifier );(*\\*)',	'		group_ref_name : OPTIONAL STRING;(*\\*)',	'		SELF\identifier.ref : attribute;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY missing_value (*\\*)',	'		SUBTYPE OF ( unary_expression );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY redefined_attribute_value (*\\*)',	'		SUBTYPE OF ( missing_value );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY implicitly_declared_identifier (*\\*)',	'		SUBTYPE OF ( identifier );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY interval (*\\*)',	'		SUBTYPE OF ( unary_expression );(*\\*)',	'		expr : and_expression;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY aggr_unary_expression (*\\*)',	'		ABSTRACT SUPERTYPE (*\\*)',	'		SUBTYPE OF ( unary_expression );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY query_variable (*\\*)',	'		SUBTYPE OF ( dictionary_instance );(*\\*)',	'		variable_id : STRING;(*\\*)',	'		owner : query_expression;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY query_expression (*\\*)',	'		SUBTYPE OF ( aggr_unary_expression );(*\\*)',	'		variable : query_variable;(*\\*)',	'		aggregate_source : expression;(*\\*)',	'		such_that : expression;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY entity_instance_constructor (*\\*)',	'		SUBTYPE OF ( unary_expression );(*\\*)',	'		decl : entity_definition_reference;(*\\*)',	'		parameters : LIST OF expression;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY qualifier (*\\*)',	'		ABSTRACT SUPERTYPE (*\\*)',	'		SUBTYPE OF ( unary_expression );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY attribute_qualifier (*\\*)',	'		SUBTYPE OF ( qualifier );(*\\*)',	'		attribute_name : STRING;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY group_qualifier (*\\*)',	'		SUBTYPE OF ( qualifier );(*\\*)',	'		group_name : STRING;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY index_qualifier (*\\*)',	'		SUBTYPE OF ( qualifier );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY element_qualifier (*\\*)',	'		SUBTYPE OF ( index_qualifier );(*\\*)',	'		index : expression;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY range_qualifier (*\\*)',	'		SUBTYPE OF ( index_qualifier );(*\\*)',	'		index1 : expression;(*\\*)',	'		index2 : expression;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY numeric_literal (*\\*)',	'		ABSTRACT SUPERTYPE (*\\*)',	'		SUBTYPE OF ( literal );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY logical_literal (*\\*)',	'		ABSTRACT SUPERTYPE (*\\*)',	'		SUBTYPE OF ( literal );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY true_constant (*\\*)',	'		SUBTYPE OF ( logical_literal );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY false_constant (*\\*)',	'		SUBTYPE OF ( logical_literal );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY unknown_constant (*\\*)',	'		SUBTYPE OF ( logical_literal );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY integer_literal (*\\*)',	'		SUBTYPE OF ( numeric_literal );(*\\*)',	'		val : INTEGER;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY real_literal (*\\*)',	'		SUBTYPE OF ( numeric_literal );(*\\*)',	'		val : REAL;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY pi_constant (*\\*)',	'		SUBTYPE OF ( real_literal );(*\\*)',	'	DERIVE(*\\*)',	'		SELF\real_literal.val : REAL := 3.14159;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY e_constant (*\\*)',	'		SUBTYPE OF ( real_literal );(*\\*)',	'	DERIVE(*\\*)',	'		SELF\real_literal.val : REAL := 2.71828;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY string_literal (*\\*)',	'		SUBTYPE OF ( literal );(*\\*)',	'		val : STRING;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY binary_literal (*\\*)',	'		SUBTYPE OF ( literal );(*\\*)',	'		val : BINARY;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY native_expression (*\\*)',	'		SUBTYPE OF ( expression );(*\\*)',	'		source : native_algorithm;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY escaped_expression (*\\*)',	'		SUBTYPE OF ( expression );(*\\*)',	'		expr : expression;(*\\*)',	'	END_ENTITY;(*\\*)',	'END_SCHEMA;(*\\*)',	'(*\\*)',	'(*\\*)',	'SCHEMA Platypus_statements_schema;(*\\*)',	'	USE FROM Platypus_dictionary_schema;(*\\*)',	'	USE FROM Platypus_expressions_schema;(*\\*)',	'(*\\*)',	'	ENTITY assignable (*\\*)',	'		SUBTYPE OF ( dictionary_instance );(*\\*)',	'		head : identifier;(*\\*)',	'		qualifiers : LIST OF qualifier;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY statement (*\\*)',	'		ABSTRACT SUPERTYPE (*\\*)',	'		SUBTYPE OF ( dictionary_instance );(*\\*)',	'		owner : dictionary_instance;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY null_statement (*\\*)',	'		SUBTYPE OF ( statement );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY native_statement (*\\*)',	'		SUBTYPE OF ( statement );(*\\*)',	'		source : native_algorithm;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY alias_statement_variable (*\\*)',	'		SUBTYPE OF ( dictionary_instance );(*\\*)',	'		alias_ident : STRING;(*\\*)',	'		ref : assignable;(*\\*)',	'		owner : alias_statement;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY alias_statement (*\\*)',	'		SUBTYPE OF ( statement );(*\\*)',	'		variable : alias_statement_variable;(*\\*)',	'		statements : LIST OF statement;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY assignment_statement (*\\*)',	'		SUBTYPE OF ( statement );(*\\*)',	'		left : assignable;(*\\*)',	'		right_expr : expression;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY case_statement (*\\*)',	'		SUBTYPE OF ( statement );(*\\*)',	'		selector : expression;(*\\*)',	'		case_actions : LIST OF case_action;(*\\*)',	'		case_otherwise : OPTIONAL statement;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY case_action (*\\*)',	'		SUBTYPE OF ( dictionary_instance );(*\\*)',	'		labels : LIST OF expression;(*\\*)',	'		action : statement;(*\\*)',	'	END_ENTITY;(*\\*)',	''

! !

!PltPlatypusMetaSchemasSchemaInstance methodsFor: 'platypus-generated-schema-accessing' stamp: ''!
expressSchemaCode3	^	'(*\\*)',	'	ENTITY compound_statement (*\\*)',	'		SUBTYPE OF ( statement );(*\\*)',	'		statements : LIST OF statement;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY escape_statement (*\\*)',	'		SUBTYPE OF ( statement );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY if_statement (*\\*)',	'		SUBTYPE OF ( statement );(*\\*)',	'		selector : expression;(*\\*)',	'		then_statements : LIST OF statement;(*\\*)',	'		else_statements : OPTIONAL LIST OF statement;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY repeat_statement (*\\*)',	'		SUBTYPE OF ( statement );(*\\*)',	'		incr_control : OPTIONAL increment_control;(*\\*)',	'		until_control : OPTIONAL expression;(*\\*)',	'		while_control : OPTIONAL expression;(*\\*)',	'		statements : LIST OF statement;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY increment_control_variable (*\\*)',	'		SUBTYPE OF ( dictionary_instance );(*\\*)',	'		variable_id : STRING;(*\\*)',	'		owner : increment_control;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY increment_control (*\\*)',	'		SUBTYPE OF ( dictionary_instance );(*\\*)',	'		variable : increment_control_variable;(*\\*)',	'		first : expression;(*\\*)',	'		last : expression;(*\\*)',	'		step : OPTIONAL expression;(*\\*)',	'		owner : repeat_statement;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY return_statement (*\\*)',	'		SUBTYPE OF ( statement );(*\\*)',	'		returned : OPTIONAL expression;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY procedure_call_statement (*\\*)',	'		SUBTYPE OF ( statement );(*\\*)',	'		call : identifier;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY skip_statement (*\\*)',	'		SUBTYPE OF ( statement );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY output_statement (*\\*)',	'		SUBTYPE OF ( statement );(*\\*)',	'		output : expression;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY splitmark_statement (*\\*)',	'		SUBTYPE OF ( statement );(*\\*)',	'		filename : expression;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY end_splitmark_statement (*\\*)',	'		SUBTYPE OF ( statement );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY anonymous_variable (*\\*)',	'		SUBTYPE OF ( dictionary_instance );(*\\*)',	'		domain : parameter_type;(*\\*)',	'	END_ENTITY;(*\\*)',	'END_SCHEMA;(*\\*)',	'(*\\*)',	'(*\\*)',	'SCHEMA Platypus_aggregate_data_schema;(*\\*)',	'	USE FROM Platypus_population_schema;(*\\*)',	'	USE FROM Platypus_dictionary_schema;(*\\*)',	'	USE FROM Platypus_expressions_schema;(*\\*)',	'(*\\*)',	'	ENTITY aggregate_data (*\\*)',	'		ABSTRACT SUPERTYPE OF ( ONEOF ( aggregate_instance, aggregate_initializer ) ) (*\\*)',	'		SUBTYPE OF ( expression );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY aggregate_initializer (*\\*)',	'		SUBTYPE OF ( aggregate_data );(*\\*)',	'		contents : LIST OF aggregate_initializer_element;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY aggregate_initializer_element (*\\*)',	'		SUBTYPE OF ( dictionary_instance );(*\\*)',	'		val : primitive;(*\\*)',	'		repetition : OPTIONAL expression;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY aggregate_instance (*\\*)',	'		ABSTRACT SUPERTYPE OF ( ONEOF ( array_instance, variable_size_aggregation_instance ) ) (*\\*)',	'		SUBTYPE OF ( aggregate_data );(*\\*)',	'		lower_bound : integer_literal;(*\\*)',	'		upper_bound : integer_literal;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY array_instance (*\\*)',	'		SUBTYPE OF ( aggregate_instance );(*\\*)',	'		contents : LIST OF primitive;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY variable_size_aggregation_instance (*\\*)',	'		ABSTRACT SUPERTYPE OF ( ONEOF ( set_instance, bag_instance, list_instance ) ) (*\\*)',	'		SUBTYPE OF ( aggregate_instance );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY list_instance (*\\*)',	'		SUBTYPE OF ( variable_size_aggregation_instance );(*\\*)',	'		contents : LIST OF primitive;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY bag_instance (*\\*)',	'		SUBTYPE OF ( variable_size_aggregation_instance );(*\\*)',	'		contents : BAG OF primitive;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY set_instance (*\\*)',	'		SUBTYPE OF ( variable_size_aggregation_instance );(*\\*)',	'		contents : SET OF primitive;(*\\*)',	'	END_ENTITY;(*\\*)',	'END_SCHEMA;(*\\*)',	'(*\\*)',	'(*\\*)',	'SCHEMA Platypus_population_schema;(*\\*)',	'	USE FROM Platypus_expressions_schema;(*\\*)',	'	USE FROM Platypus_environment_schema;(*\\*)',	'	USE FROM Platypus_dictionary_schema;(*\\*)',	'(*\\*)',	'	ENTITY instance_scope (*\\*)',	'		SUBTYPE OF ( session_instance );(*\\*)',	'		owner : entity_instance;(*\\*)',	'		owned : LIST [ 1 : ? ] OF entity_instance;(*\\*)',	'		export_list : LIST [ 0 : ? ] OF entity_instance;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY application_instance (*\\*)',	'		ABSTRACT SUPERTYPE (*\\*)',	'		SUBTYPE OF ( entity_instance );(*\\*)',	'		owning_model : model_contents;(*\\*)',	'		persistent_label : STRING;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY generic_instance (*\\*)',	'		ABSTRACT SUPERTYPE (*\\*)',	'		SUBTYPE OF ( application_instance );(*\\*)',	'		owner : OPTIONAL entity_instance;(*\\*)',	'		scope : OPTIONAL instance_scope;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY internal_representation (*\\*)',	'		SUBTYPE OF ( generic_instance );(*\\*)',	'		definition : entity_definition_reference;(*\\*)',	'		parameters : LIST OF primitive;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY external_representation (*\\*)',	'		SUBTYPE OF ( generic_instance );(*\\*)',	'		records : LIST OF simple_record;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY group_representation (*\\*)',	'		ABSTRACT SUPERTYPE (*\\*)',	'		SUBTYPE OF ( generic_instance );(*\\*)',	'		definition : entity_definition_reference;(*\\*)',	'		instRef : generic_instance_reference;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY external_group_representation (*\\*)',	'		SUBTYPE OF ( group_representation );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY internal_group_representation (*\\*)',	'		SUBTYPE OF ( group_representation );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY generic_instance_reference (*\\*)',	'		SUBTYPE OF ( entity_instance_reference );(*\\*)',	'		SELF\entity_instance_reference.ref : generic_instance;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY user_defined_application_instance (*\\*)',	'		SUBTYPE OF ( application_instance );(*\\*)',	'		name : STRING;(*\\*)',	'		parameters : LIST OF primitive;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY simple_record (*\\*)',	'		SUBTYPE OF ( entity_instance );(*\\*)',	'		definition : entity_definition_reference;(*\\*)',	'		parameters : LIST OF primitive;(*\\*)',	'		owner : generic_instance;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	''

! !

!PltPlatypusMetaSchemasSchemaInstance methodsFor: 'platypus-generated-schema-accessing' stamp: ''!
expressSchemaCode4	^	'	ENTITY header_instance (*\\*)',	'		ABSTRACT SUPERTYPE (*\\*)',	'		SUBTYPE OF ( entity_instance );(*\\*)',	'		owning_model : model_contents;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY user_defined_header_instance (*\\*)',	'		SUBTYPE OF ( header_instance );(*\\*)',	'		name : STRING;(*\\*)',	'		parameters : LIST OF primitive;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY file_description (*\\*)',	'		SUBTYPE OF ( header_instance );(*\\*)',	'		description : LIST [ 1 : ? ] OF STRING ( 256 );(*\\*)',	'		implementation_level : STRING ( 256 );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY file_name (*\\*)',	'		SUBTYPE OF ( header_instance );(*\\*)',	'		name : STRING ( 256 );(*\\*)',	'		time_stamp : STRING ( 256 );(*\\*)',	'		author : LIST [ 1 : ? ] OF STRING ( 256 );(*\\*)',	'		organization : LIST [ 1 : ? ] OF STRING ( 256 );(*\\*)',	'		preprocessor_version : STRING ( 256 );(*\\*)',	'		originating_system : STRING ( 256 );(*\\*)',	'		authorisation : STRING ( 256 );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY file_schema (*\\*)',	'		SUBTYPE OF ( header_instance );(*\\*)',	'		schema_identifiers : LIST [ 1 : ? ] OF schema_name;(*\\*)',	'	END_ENTITY;(*\\*)',	'END_SCHEMA;(*\\*)',	'(*\\*)',	'(*\\*)',	'SCHEMA Platypus_environment_schema;(*\\*)',	'	USE FROM Platypus_population_schema;(*\\*)',	'	USE FROM Platypus_dictionary_schema;(*\\*)',	'(*\\*)',	'	ENTITY model_contents (*\\*)',	'		SUBTYPE OF ( session_instance );(*\\*)',	'		owner : schema_instance;(*\\*)',	'	INVERSE(*\\*)',	'		instances : SET [ 0 : ? ] OF application_instance FOR owning_model;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY schema_instance (*\\*)',	'		SUBTYPE OF ( session_instance );(*\\*)',	'		name : STRING;(*\\*)',	'		associated_models : LIST [ 0 : ? ] OF model_contents;(*\\*)',	'		schemata : LIST [ 0 : ? ] OF schema_definition;(*\\*)',	'	DERIVE(*\\*)',	'		accepted : entity_instance := SELF.accept_schema_instance;(*\\*)',	'	END_ENTITY;(*\\*)',	'END_SCHEMA;(*\\*)',	'(*\\*)',	'(*\\*)',	'SCHEMA Platypus_dictionary_schema;(*\\*)',	'	USE FROM Platypus_expressions_schema;(*\\*)',	'	USE FROM Platypus_statements_schema;(*\\*)',	'	USE FROM Platypus_population_schema;(*\\*)',	'	USE FROM Platypus_environment_schema;(*\\*)',	'	USE FROM Platypus_aggregate_data_schema;(*\\*)',	'(*\\*)',	'	TYPE constructed_type = SELECT(*\\*)',	'		( enumeration_type, select_type );(*\\*)',	'	END_TYPE;(*\\*)',	'(*\\*)',	'	TYPE type_or_rule = SELECT(*\\*)',	'		( named_type, global_rule );(*\\*)',	'	END_TYPE;(*\\*)',	'(*\\*)',	'	TYPE base_type = SELECT(*\\*)',	'		( simple_type, aggregation_type, named_type_reference );(*\\*)',	'	END_TYPE;(*\\*)',	'(*\\*)',	'	TYPE underlying_type = SELECT(*\\*)',	'		( simple_type, aggregation_type, named_type_reference, constructed_type );(*\\*)',	'	END_TYPE;(*\\*)',	'(*\\*)',	'	TYPE parameter_type = SELECT(*\\*)',	'		( simple_type, aggregate_type, aggregate_initializer_domain, named_type_reference );(*\\*)',	'	END_TYPE;(*\\*)',	'(*\\*)',	'	TYPE declaration = SELECT(*\\*)',	'		( named_type, global_rule, constant_definition, procedure_declaration );(*\\*)',	'	END_TYPE;(*\\*)',	'(*\\*)',	'	TYPE time_stamp = STRING ( 256 );(*\\*)',	'	END_TYPE;(*\\*)',	'(*\\*)',	'	TYPE primitive = expression;(*\\*)',	'	END_TYPE;(*\\*)',	'(*\\*)',	'	TYPE schema_name = STRING;(*\\*)',	'	END_TYPE;(*\\*)',	'(*\\*)',	'	TYPE context_owner = SELECT(*\\*)',	'		( context_definition, schema_instance );(*\\*)',	'	END_TYPE;(*\\*)',	'(*\\*)',	'	TYPE inter_schema_link = ENUMERATION(*\\*)',	'		OF ( used, referenced );(*\\*)',	'	END_TYPE;(*\\*)',	'(*\\*)',	'	TYPE context_container_ref = SELECT(*\\*)',	'		( schema_instance_ref, context_ref );(*\\*)',	'	END_TYPE;(*\\*)',	'(*\\*)',	'	ENTITY element_ref (*\\*)',	'		ABSTRACT SUPERTYPE (*\\*)',	'		SUBTYPE OF ( entity_instance );(*\\*)',	'		name : STRING;(*\\*)',	'	DERIVE(*\\*)',	'		ref : entity_instance := ?;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY schema_instance_ref (*\\*)',	'		SUBTYPE OF ( element_ref );(*\\*)',	'	DERIVE(*\\*)',	'		SELF\element_ref.ref : entity_instance := schema_instance_from_ref ( SELF );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY context_ref (*\\*)',	'		SUBTYPE OF ( element_ref );(*\\*)',	'		owner : context_container_ref;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY schema_ref (*\\*)',	'		SUBTYPE OF ( context_ref );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY algorithm_ref (*\\*)',	'		SUBTYPE OF ( context_ref );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY rule_ref (*\\*)',	'		SUBTYPE OF ( context_ref );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY named_type_ref (*\\*)',	'		SUBTYPE OF ( element_ref );(*\\*)',	'		owner : context_ref;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY entity_instance (*\\*)',	'		ABSTRACT SUPERTYPE;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY sdai_instance (*\\*)',	'		ABSTRACT SUPERTYPE OF ( ONEOF ( dictionary_instance, session_instance ) ) (*\\*)',	'		SUBTYPE OF ( entity_instance );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY dictionary_instance (*\\*)',	'		ABSTRACT SUPERTYPE (*\\*)',	'		SUBTYPE OF ( sdai_instance );(*\\*)',	'	DERIVE(*\\*)',	'		handled : dictionary_instance := SELF;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY session_instance (*\\*)',	'		ABSTRACT SUPERTYPE (*\\*)',	'		SUBTYPE OF ( sdai_instance );(*\\*)',	'		change_date : OPTIONAL time_stamp;(*\\*)',	'		validation_date : time_stamp;(*\\*)',	'		validation_result : LOGICAL;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY domain_equivalent_item (*\\*)',	'		SUBTYPE OF ( dictionary_instance );(*\\*)',	'		name : STRING;(*\\*)',	'		external_item_id : STRING;(*\\*)',	'		native_item : declaration;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY context_definition (*\\*)',	'		ABSTRACT SUPERTYPE OF ( ONEOF ( schema_definition, statements_container ) ) (*\\*)',	'		SUBTYPE OF ( dictionary_instance );(*\\*)',	'		name : STRING;(*\\*)',	'		constants : LIST OF constant_definition;(*\\*)',	'		types : LIST OF defined_type;(*\\*)',	'		entities : LIST OF entity_definition;(*\\*)',	'		algorithmes : LIST OF algorithm_declaration;(*\\*)',	'		owner : OPTIONAL context_owner;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY statements_container (*\\*)',	'		ABSTRACT SUPERTYPE (*\\*)',	'		SUBTYPE OF ( context_definition );(*\\*)',	'		locals : LIST OF local_variable;(*\\*)',	'		statements : LIST OF statement;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY global_rule (*\\*)',	'		SUBTYPE OF ( statements_container );(*\\*)',	'		for_entities : LIST [ 1 : ? ] OF entity_instances_set;(*\\*)',	'		where_rules : LIST [ 1 : ? ] OF where_rule;(*\\*)',	'		SELF\context_definition.owner : schema_definition;(*\\*)',	''

! !

!PltPlatypusMetaSchemasSchemaInstance methodsFor: 'platypus-generated-schema-accessing' stamp: ''!
expressSchemaCode5	^	'	DERIVE(*\\*)',	'		accepted : entity_instance := SELF.accept_global_rule;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY schema_definition (*\\*)',	'		SUBTYPE OF ( context_definition );(*\\*)',	'		global_rules : LIST OF global_rule;(*\\*)',	'		interface : LIST OF external_schema;(*\\*)',	'		remark_references : LIST OF remark_reference;(*\\*)',	'	DERIVE(*\\*)',	'		accepted : entity_instance := SELF.accept_schema_definition;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY external_schema (*\\*)',	'		SUBTYPE OF ( dictionary_instance );(*\\*)',	'		name : schema_name;(*\\*)',	'		owner : schema_definition;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY include_schema (*\\*)',	'		SUBTYPE OF ( external_schema );(*\\*)',	'		native_schema : schema_definition;(*\\*)',	'		explicitly_imported_items : LIST OF domain_equivalent_item;(*\\*)',	'		implicitly_imported_items : LIST OF domain_equivalent_item;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY used_schema (*\\*)',	'		SUBTYPE OF ( include_schema );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY referenced_schema (*\\*)',	'		SUBTYPE OF ( include_schema );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY external_meta_schema (*\\*)',	'		SUBTYPE OF ( external_schema );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY algorithm_declaration (*\\*)',	'		ABSTRACT SUPERTYPE (*\\*)',	'		SUBTYPE OF ( statements_container );(*\\*)',	'		formal_parameters : LIST OF parameter_definition;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY native_code (*\\*)',	'		SUBTYPE OF ( dictionary_instance );(*\\*)',	'		language_signature : STRING;(*\\*)',	'		code : STRING;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY native_algorithm (*\\*)',	'		SUBTYPE OF ( dictionary_instance );(*\\*)',	'		implementations : LIST OF native_code;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY procedure_declaration (*\\*)',	'		SUBTYPE OF ( algorithm_declaration );(*\\*)',	'	DERIVE(*\\*)',	'		accepted : entity_instance := SELF.accept_procedure_declaration;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY function_declaration (*\\*)',	'		SUBTYPE OF ( algorithm_declaration );(*\\*)',	'		return_type : parameter_type;(*\\*)',	'	DERIVE(*\\*)',	'		accepted : entity_instance := SELF.accept_function_declaration;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY bound (*\\*)',	'		ABSTRACT SUPERTYPE OF ( ONEOF ( integer_bound, population_dependent_bound ) ) (*\\*)',	'		SUBTYPE OF ( dictionary_instance );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY integer_bound (*\\*)',	'		SUBTYPE OF ( bound );(*\\*)',	'		bound_value : INTEGER;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY population_dependent_bound (*\\*)',	'		SUBTYPE OF ( bound );(*\\*)',	'		bound_value : expression;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY enumeration_type (*\\*)',	'		SUBTYPE OF ( dictionary_instance );(*\\*)',	'		elements : LIST [ 1 : ? ] OF UNIQUE STRING;(*\\*)',	'		owner : defined_type;(*\\*)',	'	DERIVE(*\\*)',	'		accepted : entity_instance := SELF.accept_enumeration_type;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY named_type (*\\*)',	'		ABSTRACT SUPERTYPE OF ( ONEOF ( entity_definition, defined_type ) ) (*\\*)',	'		SUBTYPE OF ( dictionary_instance );(*\\*)',	'		name : STRING;(*\\*)',	'		where_rules : LIST [ 0 : ? ] OF where_rule;(*\\*)',	'		owner : context_definition;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY dictionary_instance_reference (*\\*)',	'		SUBTYPE OF ( dictionary_instance );(*\\*)',	'		ref : dictionary_instance;(*\\*)',	'		name : STRING;(*\\*)',	'	DERIVE(*\\*)',	'		SELF\dictionary_instance.handled : dictionary_instance := SELF.ref;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY named_type_reference (*\\*)',	'		SUBTYPE OF ( dictionary_instance_reference );(*\\*)',	'		SELF\dictionary_instance_reference.ref : named_type;(*\\*)',	'	DERIVE(*\\*)',	'		accepted : entity_instance := SELF.accept_named_type_reference;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY attribute_reference (*\\*)',	'		SUBTYPE OF ( dictionary_instance_reference );(*\\*)',	'		SELF\dictionary_instance_reference.ref : attribute;(*\\*)',	'		entity_ref : entity_definition_reference;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY entity_definition_reference (*\\*)',	'		SUBTYPE OF ( named_type_reference );(*\\*)',	'		SELF\named_type_reference.ref : entity_definition;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY defined_type_reference (*\\*)',	'		SUBTYPE OF ( named_type_reference );(*\\*)',	'		SELF\named_type_reference.ref : defined_type;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY where_rule (*\\*)',	'		SUBTYPE OF ( dictionary_instance );(*\\*)',	'		label : OPTIONAL STRING;(*\\*)',	'		owner : type_or_rule;(*\\*)',	'		where_value : expression;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY select_type (*\\*)',	'		SUBTYPE OF ( dictionary_instance );(*\\*)',	'		selections : LIST [ 1 : ? ] OF named_type_reference;(*\\*)',	'		owner : defined_type;(*\\*)',	'	DERIVE(*\\*)',	'		accepted : entity_instance := SELF.accept_select_type;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY defined_type (*\\*)',	'		SUBTYPE OF ( named_type );(*\\*)',	'		domain : underlying_type;(*\\*)',	'	DERIVE(*\\*)',	'		accepted : entity_instance := SELF.accept_defined_type;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY entity_definition (*\\*)',	'		SUBTYPE OF ( named_type );(*\\*)',	'		supertype_constraint : OPTIONAL supertype_constraint;(*\\*)',	'		supertypes : LIST OF UNIQUE entity_definition_reference;(*\\*)',	'		attributes : LIST OF UNIQUE attribute;(*\\*)',	'		uniqueness_rules : LIST OF UNIQUE uniqueness_rule;(*\\*)',	'		complex : BOOLEAN;(*\\*)',	'		instantiable : BOOLEAN;(*\\*)',	'		independent : BOOLEAN;(*\\*)',	'	DERIVE(*\\*)',	'		accepted : entity_instance := SELF.accept_entity_definition;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY supertype_constraint (*\\*)',	'		SUBTYPE OF ( dictionary_instance );(*\\*)',	'		constrained : entity_definition_reference;(*\\*)',	'		expr : OPTIONAL supertype_expression;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY supertype_expression (*\\*)',	'		ABSTRACT SUPERTYPE OF ( ONEOF ( sub_entity_ref_expression, binary_supertype_expression, oneof_supertype_expression ) ) (*\\*)',	'		SUBTYPE OF ( dictionary_instance );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY sub_entity_ref_expression (*\\*)',	'		SUBTYPE OF ( supertype_expression );(*\\*)',	'		entity_ref : entity_definition_reference;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY binary_supertype_expression (*\\*)',	'		SUBTYPE OF ( supertype_expression );(*\\*)',	'		parenthesis : OPTIONAL BOOLEAN;(*\\*)',	'		left_expr : supertype_expression;(*\\*)',	'		right_expr : supertype_expression;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY andor_supertype (*\\*)',	'		SUBTYPE OF ( binary_supertype_expression );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY and_supertype (*\\*)',	'		SUBTYPE OF ( binary_supertype_expression );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY oneof_supertype_expression (*\\*)',	'		SUBTYPE OF ( supertype_expression );(*\\*)',	'		expr_list : LIST OF supertype_expression;(*\\*)',	'	END_ENTITY;(*\\*)',	''

! !

!PltPlatypusMetaSchemasSchemaInstance methodsFor: 'platypus-generated-schema-accessing' stamp: ''!
expressSchemaCode6	^	'(*\\*)',	'	ENTITY uniqueness_rule (*\\*)',	'		SUBTYPE OF ( dictionary_instance );(*\\*)',	'		label : OPTIONAL STRING;(*\\*)',	'		attributes : LIST [ 1 : ? ] OF UNIQUE uniqueness_rule_attribute_identifier;(*\\*)',	'		owner : entity_definition;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY attribute (*\\*)',	'		ABSTRACT SUPERTYPE OF ( ONEOF ( derived_attribute, explicit_attribute, inverse_attribute ) ) (*\\*)',	'		SUBTYPE OF ( dictionary_instance );(*\\*)',	'		name : STRING;(*\\*)',	'		owner : entity_definition;(*\\*)',	'		domain : base_type;(*\\*)',	'		redeclaring : OPTIONAL attribute_reference;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY aggregate_initializer_domain (*\\*)',	'		SUBTYPE OF ( dictionary_instance );(*\\*)',	'		types : LIST [ 1 : ? ] OF parameter_type;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY aggregate_type (*\\*)',	'		ABSTRACT SUPERTYPE OF ( ONEOF ( aggregation_type, general_aggregate_type ) ) (*\\*)',	'		SUBTYPE OF ( dictionary_instance );(*\\*)',	'		element_type : parameter_type;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY general_aggregate_type (*\\*)',	'		SUBTYPE OF ( aggregate_type );(*\\*)',	'		type_label : OPTIONAL STRING;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY aggregation_type (*\\*)',	'		ABSTRACT SUPERTYPE OF ( ONEOF ( variable_size_aggregation_type, array_type ) ) (*\\*)',	'		SUBTYPE OF ( aggregate_type );(*\\*)',	'		lower_bound : OPTIONAL bound;(*\\*)',	'		upper_bound : OPTIONAL bound;(*\\*)',	'		is_general_type : BOOLEAN;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY array_type (*\\*)',	'		SUBTYPE OF ( aggregation_type );(*\\*)',	'		unique_flag : BOOLEAN;(*\\*)',	'		optional_flag : BOOLEAN;(*\\*)',	'		SELF\aggregation_type.lower_bound : bound;(*\\*)',	'		SELF\aggregation_type.upper_bound : bound;(*\\*)',	'	DERIVE(*\\*)',	'		accepted : entity_instance := SELF.accept_array_type;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY variable_size_aggregation_type (*\\*)',	'		ABSTRACT SUPERTYPE OF ( ONEOF ( set_type, bag_type, list_type ) ) (*\\*)',	'		SUBTYPE OF ( aggregation_type );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY list_type (*\\*)',	'		SUBTYPE OF ( variable_size_aggregation_type );(*\\*)',	'		unique_flag : BOOLEAN;(*\\*)',	'	DERIVE(*\\*)',	'		accepted : entity_instance := SELF.accept_list_type;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY bag_type (*\\*)',	'		SUBTYPE OF ( variable_size_aggregation_type );(*\\*)',	'	DERIVE(*\\*)',	'		accepted : entity_instance := SELF.accept_bag_type;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY set_type (*\\*)',	'		SUBTYPE OF ( variable_size_aggregation_type );(*\\*)',	'	DERIVE(*\\*)',	'		accepted : entity_instance := SELF.accept_set_type;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY simple_type (*\\*)',	'		ABSTRACT SUPERTYPE OF ( ONEOF ( string_type, binary_type, logical_type, number_type ) ) (*\\*)',	'		SUBTYPE OF ( dictionary_instance );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY string_type (*\\*)',	'		SUBTYPE OF ( simple_type );(*\\*)',	'		width : OPTIONAL bound;(*\\*)',	'		fixed_width : BOOLEAN;(*\\*)',	'	DERIVE(*\\*)',	'		accepted : entity_instance := SELF.accept_string_type;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY binary_type (*\\*)',	'		SUBTYPE OF ( simple_type );(*\\*)',	'		width : OPTIONAL bound;(*\\*)',	'		fixed_width : BOOLEAN;(*\\*)',	'	DERIVE(*\\*)',	'		accepted : entity_instance := SELF.accept_binary_type;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY number_type (*\\*)',	'		SUBTYPE OF ( simple_type );(*\\*)',	'	DERIVE(*\\*)',	'		accepted : entity_instance := SELF.accept_number_type;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY real_type (*\\*)',	'		SUBTYPE OF ( number_type );(*\\*)',	'		precision : OPTIONAL bound;(*\\*)',	'	DERIVE(*\\*)',	'		SELF\number_type.accepted : entity_instance := SELF.accept_real_type;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY integer_type (*\\*)',	'		SUBTYPE OF ( number_type );(*\\*)',	'		precision : OPTIONAL bound;(*\\*)',	'	DERIVE(*\\*)',	'		SELF\number_type.accepted : entity_instance := SELF.accept_integer_type;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY logical_type (*\\*)',	'		SUBTYPE OF ( simple_type );(*\\*)',	'	DERIVE(*\\*)',	'		accepted : entity_instance := SELF.accept_logical_type;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY boolean_type (*\\*)',	'		SUBTYPE OF ( logical_type );(*\\*)',	'	DERIVE(*\\*)',	'		SELF\logical_type.accepted : entity_instance := SELF.accept_boolean_type;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY constant_definition (*\\*)',	'		SUBTYPE OF ( dictionary_instance );(*\\*)',	'		name : STRING;(*\\*)',	'		domain : base_type;(*\\*)',	'		initializer : expression;(*\\*)',	'		owner : context_definition;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY local_variable (*\\*)',	'		SUBTYPE OF ( dictionary_instance );(*\\*)',	'		owner : statements_container;(*\\*)',	'		name : STRING;(*\\*)',	'		domain : parameter_type;(*\\*)',	'		initializer : OPTIONAL expression;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY parameter_definition (*\\*)',	'		SUBTYPE OF ( dictionary_instance );(*\\*)',	'		owner : algorithm_declaration;(*\\*)',	'		name : STRING;(*\\*)',	'		by_copy : BOOLEAN;(*\\*)',	'		domain : parameter_type;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY generic_type (*\\*)',	'		SUBTYPE OF ( dictionary_instance );(*\\*)',	'		type_label : OPTIONAL STRING;(*\\*)',	'	DERIVE(*\\*)',	'		accepted : entity_instance := SELF.accept_generic_type;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY remark (*\\*)',	'		ABSTRACT SUPERTYPE OF ( ONEOF ( tail_remark, embedded_remark ) ) (*\\*)',	'		SUBTYPE OF ( entity_instance );(*\\*)',	'		text : STRING;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY tail_remark (*\\*)',	'		SUBTYPE OF ( remark );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY embedded_remark (*\\*)',	'		SUBTYPE OF ( remark );(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY remark_reference (*\\*)',	'		SUBTYPE OF ( dictionary_instance );(*\\*)',	'		prefix : STRING;(*\\*)',	'		suffix : OPTIONAL STRING;(*\\*)',	'		inside : dictionary_instance_reference;(*\\*)',	'		referenced : dictionary_instance_reference;(*\\*)',	'		remark : remark;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY meta_concept_definition (*\\*)',	'		SUBTYPE OF ( dictionary_instance );(*\\*)',	'		definition : dictionary_instance;(*\\*)',	'		expression : STRING;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY derived_attribute (*\\*)',	'		SUBTYPE OF ( attribute );(*\\*)',	'		assign : expression;(*\\*)',	'	DERIVE(*\\*)',	'		accepted : entity_instance := SELF.accept_derived_attribute;(*\\*)',	'	END_ENTITY;(*\\*)',	'(*\\*)',	'	ENTITY explicit_attribute (*\\*)',	'		SUBTYPE OF ( attribute );(*\\*)',	'		optional_flag : BOOLEAN;(*\\*)',	'	DERIVE(*\\*)',	'		accepted : entity_instance := SELF.accept_explicit_attribute;(*\\*)',	''

! !

!PltPlatypusMetaSchemasSchemaInstance methodsFor: 'platypus-generated-schema-accessing' stamp: ''!
expressSchemaCodePartsCount ^7

! !

!PltPlatypusMetaSchemasSchemaInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
externalSchemaInstanceClassNames
	^ #()

! !

!PltPlatypusMetaSchemasSchemaInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
namesBuilder
	| namesBuilder |
	namesBuilder := self namesBuilderClass new.
	namesBuilder classPrefix: #Plt.
	namesBuilder systemCategoryPrefix: #Platypus.
	namesBuilder rootClassName: #PltEntityInstance.
	namesBuilder rootClassSystemCategory: #'Platypus-PlatypusDictionarySchemaSchema'.
	^ namesBuilder

! !

!PltPlatypusMetaSchemasSchemaInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
namesBuilderClassName
	^ #PlatypusNamesBuilder

! !

!PltPlatypusMetaSchemasSchemaInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
repositoryClassName
	^ #PltPlatypusMetaSchemasRepository

! !

!PltPlatypusMetaSchemasSchemaInstance methodsFor: 'platypus-generated-schemata-accessing' stamp: ''!
schemaDefinition1
	^ #(#Platypus_expressions_schema #PltPlatypusExpressionsSchemaSchemaDefinition)

! !

!PltPlatypusMetaSchemasSchemaInstance methodsFor: 'platypus-generated-schemata-accessing' stamp: ''!
schemaDefinition2
	^ #(#Platypus_statements_schema #PltPlatypusStatementsSchemaSchemaDefinition)

! !

!PltPlatypusMetaSchemasSchemaInstance methodsFor: 'platypus-generated-schemata-accessing' stamp: ''!
schemaDefinition3
	^ #(#Platypus_aggregate_data_schema #PltPlatypusAggregateDataSchemaSchemaDefinition)

! !

!PltPlatypusMetaSchemasSchemaInstance methodsFor: 'platypus-generated-schemata-accessing' stamp: ''!
schemaDefinition4
	^ #(#Platypus_population_schema #PltPlatypusPopulationSchemaSchemaDefinition)

! !

!PltPlatypusMetaSchemasSchemaInstance methodsFor: 'platypus-generated-schemata-accessing' stamp: ''!
schemaDefinition5
	^ #(#Platypus_environment_schema #PltPlatypusEnvironmentSchemaSchemaDefinition)

! !

!PltPlatypusMetaSchemasSchemaInstance methodsFor: 'platypus-generated-schemata-accessing' stamp: ''!
schemaDefinition6
	^ #(#Platypus_dictionary_schema #PltPlatypusDictionarySchemaSchemaDefinition)

! !

!PltPlatypusMetaSchemasSchemaInstance methodsFor: 'platypus-generated-schemata-accessing' stamp: ''!
schemaDefinition7

^ #( #'Platypus_dictionary_schema' #PltPlatypusDictionarySchemaSchemaDefinition )! !

!PltPlatypusMetaSchemasSchemaInstance methodsFor: 'platypus-generated-schemata-accessing' stamp: ''!
schemaDefinitionCount
	^ 6

! !

PlatypusCoreObject subclass: #PlatypusCoreExpression
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-core'!

PlatypusCoreExpression subclass: #PlatypusCoreAggregateInitializer
	instanceVariableNames: 'contentBlocks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-core'!

!PlatypusCoreAggregateInitializer class methodsFor: 'instance creation' stamp: 'apl 2/28/2006 19:42'!
collectionFrom: aListOfBlocks 
	^ (self contentBlocks: aListOfBlocks) asOrderedCollection! !

!PlatypusCoreAggregateInitializer class methodsFor: 'instance creation' stamp: 'apl 2/28/2006 19:13'!
contentBlocks: aListOfBlocks 
	^ self new contentBlocks: aListOfBlocks ! !

!PlatypusCoreAggregateInitializer methodsFor: 'converting' stamp: 'apl 2/28/2006 19:43'!
asArray
	^ self asOrderedCollection asArray! !

!PlatypusCoreAggregateInitializer methodsFor: 'converting' stamp: 'apl 4/7/2006 18:55'!
asOrderedCollection
	| col |
	col := OrderedCollection new.
	(contentBlocks
		collect: [:b | b isBlock
				ifTrue: [b value]
				ifFalse: [b]])
		do: [:elem | (elem isCollection and: [elem isString not])
				ifTrue: [col addAll: elem]
				ifFalse: [col add: elem]].
	^ col! !

!PlatypusCoreAggregateInitializer methodsFor: 'accessing' stamp: 'apl 2/28/2006 19:12'!
contentBlocks: aListOfBlocks
	contentBlocks:= aListOfBlocks! !

!PlatypusCoreObject class methodsFor: 'express code accessing' stamp: 'apl 1/18/2007 18:07'!
expressSchemaCode
	^ self expressSchemaCodeForClass: self ! !

!PlatypusCoreObject class methodsFor: 'express code accessing' stamp: 'apl 1/18/2007 18:07'!
expressSchemaCodeForClass: aClass
	| s i1 i2 |
	s := aClass comment asString.
	i1 := s indexOfSubCollection: self expressSchemaCodeStartMark startingAt: 1.
	i2 := s indexOfSubCollection: self expressSchemaCodeStopMark
				startingAt: i1 + 1.
	^ s copyFrom: i1 + self expressSchemaCodeStartMark size to: i2 - 1! !

!PlatypusCoreObject class methodsFor: 'express code accessing' stamp: 'apl 1/18/2007 18:05'!
expressSchemaCodeStartMark
	^ '<ISO10303-11-EXPRESS>'! !

!PlatypusCoreObject class methodsFor: 'express code accessing' stamp: 'apl 1/18/2007 18:05'!
expressSchemaCodeStopMark
	^ '</ISO10303-11-EXPRESS>'! !

!PlatypusCoreObject class methodsFor: 'as yet unclassified' stamp: 'apl 12/8/2006 18:58'!
platypusMetaData
	^ self schemaDefinition metaDataFor: self name asSymbol! !

!PlatypusCoreObject class methodsFor: 'platypus-signature' stamp: 'apl 12/9/2006 09:54'!
vwNamespaceName
	^ #Platypus! !

!PlatypusCoreObject methodsFor: 'code accessing' stamp: 'apl 1/18/2007 18:06'!
expressSchemaCode
	^ self class expressSchemaCode! !

PlatypusCoreObject subclass: #PlatypusCoreStatement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-core'!

PlatypusCoreStatement subclass: #PlatypusCoreAliasStatement
	instanceVariableNames: 'statementsBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-core'!

!PlatypusCoreAliasStatement class methodsFor: 'instance creation' stamp: 'apl 6/29/2007 20:39'!
alias: anExpression statementsBlock: oneArgStatementsBlock 
	^ (self new statementsBlock: oneArgStatementsBlock) alias: anExpression! !

!PlatypusCoreAliasStatement class methodsFor: 'instance creation' stamp: 'apl 5/14/2005 14:10'!
statementsBlock: oneArgStatementsBlock alias: anExpression
	^ (self new statementsBlock: oneArgStatementsBlock) alias: anExpression! !

!PlatypusCoreAliasStatement methodsFor: 'evaluating' stamp: 'apl 5/14/2005 14:08'!
alias: anExpression
	^ statementsBlock value: anExpression! !

!PlatypusCoreAliasStatement methodsFor: 'accessing' stamp: 'apl 5/14/2005 14:07'!
statementsBlock
	^ statementsBlock ifNil: [[:aliasVar | ]]! !

!PlatypusCoreAliasStatement methodsFor: 'accessing' stamp: 'apl 5/14/2005 14:07'!
statementsBlock: oneArgStatementsBlock
	statementsBlock := oneArgStatementsBlock! !

PlatypusCoreStatement subclass: #PlatypusCoreCaseStatement
	instanceVariableNames: 'caseActionBlocks otherwiseBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-core'!

!PlatypusCoreCaseStatement class methodsFor: 'instance creation' stamp: 'apl 5/14/2005 11:23'!
caseActionBlocks: anArrayOfGuardBlocksWithActionBlockAssoc otherwiseBlock: anActionBlock case: anExpression 
	^(self new caseActionBlocks: anArrayOfGuardBlocksWithActionBlockAssoc
		otherwiseBlock: anActionBlock) case: anExpression! !

!PlatypusCoreCaseStatement methodsFor: 'evaluating' stamp: 'apl 5/14/2005 11:25'!
case: anExpression 
	(self caseActionBlocks detect: [:assoc | (assoc key anySatisfy: [ :blk | blk value = anExpression])]
		ifNone: [^self otherwiseBlock value value]) value 
		value! !

!PlatypusCoreCaseStatement methodsFor: 'accessing' stamp: 'apl 5/14/2005 11:16'!
caseActionBlocks
	^ caseActionBlocks ifNil: [#()]! !

!PlatypusCoreCaseStatement methodsFor: 'accessing' stamp: 'apl 5/14/2005 11:23'!
caseActionBlocks: anArrayOfGuardBlocksWithActionBlockAssoc 
	caseActionBlocks := anArrayOfGuardBlocksWithActionBlockAssoc! !

!PlatypusCoreCaseStatement methodsFor: 'accessing' stamp: 'apl 5/14/2005 11:23'!
caseActionBlocks: anArrayOfGuardBlocksWithActionBlockAssoc otherwiseBlock: anActionBlock 
	self caseActionBlocks: anArrayOfGuardBlocksWithActionBlockAssoc.
	self otherwiseBlock: anActionBlock! !

!PlatypusCoreCaseStatement methodsFor: 'accessing' stamp: 'apl 5/14/2005 11:16'!
otherwiseBlock
	^ otherwiseBlock ifNil: [[]]! !

!PlatypusCoreCaseStatement methodsFor: 'accessing' stamp: 'apl 5/14/2005 11:14'!
otherwiseBlock: anActionBlock 
	otherwiseBlock := anActionBlock! !

PlatypusCoreStatement subclass: #PlatypusCoreRepeatStatement
	instanceVariableNames: 'incrControlBlock untilControlBlock whileControlBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-core'!

!PlatypusCoreRepeatStatement class methodsFor: 'instance creation' stamp: 'apl 3/5/2006 00:03'!
repeat: aBlock 
	^ (self new )
		repeat: aBlock! !

!PlatypusCoreRepeatStatement class methodsFor: 'instance creation' stamp: 'apl 3/5/2006 00:06'!
repeat: aBlock from: start to: stop 
	^ (self new )
		repeat: aBlock
		from: start
		to: stop! !

!PlatypusCoreRepeatStatement class methodsFor: 'instance creation' stamp: 'apl 3/5/2006 00:04'!
untilControlBlock: untilBlock repeat: aBlock 
	^ (self new untilControlBlock: untilBlock)
		repeat: aBlock! !

!PlatypusCoreRepeatStatement class methodsFor: 'instance creation' stamp: 'apl 3/5/2006 00:04'!
untilControlBlock: untilBlock repeat: aBlock from: start to: stop 
	^ (self new untilControlBlock: untilBlock)
		repeat: aBlock
		from: start
		to: stop! !

!PlatypusCoreRepeatStatement class methodsFor: 'instance creation' stamp: 'apl 3/5/2006 00:05'!
whileControlBlock: whileBlock repeat: aBlock 
	^ (self new whileControlBlock: whileBlock )
		repeat: aBlock! !

!PlatypusCoreRepeatStatement class methodsFor: 'instance creation' stamp: 'apl 3/5/2006 00:05'!
whileControlBlock: whileBlock repeat: aBlock from: start to: stop 
	^ (self new whileControlBlock: whileBlock )
		repeat: aBlock
		from: start
		to: stop! !

!PlatypusCoreRepeatStatement class methodsFor: 'instance creation' stamp: 'apl 5/10/2005 19:32'!
whileControlBlock: whileBlock untilControlBlock: untilBlock repeat: aBlock
	^(self new whileControlBlock: whileBlock untilControlBlock: untilBlock) repeat: aBlock! !

!PlatypusCoreRepeatStatement class methodsFor: 'instance creation' stamp: 'apl 5/10/2005 19:32'!
whileControlBlock: whileBlock untilControlBlock: untilBlock repeat: aBlock from: start to: stop
	^(self new whileControlBlock: whileBlock untilControlBlock: untilBlock) 
		repeat: aBlock from: start to: stop! !

!PlatypusCoreRepeatStatement methodsFor: 'evaluating' stamp: 'apl 2/1/2006 22:35'!
repeat: aBlock 
	| done skip |
	done := false.
	[done not
		and: [self whileControlBlock value: nil]]
		whileTrue: [skip := false.
			[aBlock
				on: PlatypusExpressSkipStatementException
				do: [skip := true].
			skip
				ifFalse: [done := (self untilControlBlock value: nil)]]
				on: PlatypusExpressEscapeStatementException
				do: [done := true]]! !

!PlatypusCoreRepeatStatement methodsFor: 'evaluating' stamp: 'apl 2/1/2006 22:31'!
repeat: aBlock from: start to: stop 
	| skip |
	start
		to: stop
		do: [:p | 
			self whileControlBlock ifNotNil: [(self whileControlBlock value: p)
				ifFalse: [^ nil]].
			[skip := false.
			[aBlock value: p]
				on: PlatypusExpressSkipStatementException
				do: [skip := true].
			skip
				ifFalse: [(self untilControlBlock value: p)
						ifTrue: [^ nil]]]
				on: PlatypusExpressEscapeStatementException
				do: [^ nil]]! !

!PlatypusCoreRepeatStatement methodsFor: 'accessing' stamp: 'apl 2/1/2006 22:34'!
untilControlBlock
	^ untilControlBlock
		ifNil: [[:p | false]]! !

!PlatypusCoreRepeatStatement methodsFor: 'accessing' stamp: 'apl 5/10/2005 19:29'!
untilControlBlock: untilBlock 
	untilControlBlock := untilBlock.
! !

!PlatypusCoreRepeatStatement methodsFor: 'accessing' stamp: 'apl 2/1/2006 22:34'!
whileControlBlock
	^ whileControlBlock
		ifNil: [[:p |true]]! !

!PlatypusCoreRepeatStatement methodsFor: 'accessing' stamp: 'apl 5/10/2005 19:30'!
whileControlBlock: whileBlock 
	whileControlBlock := whileBlock! !

!PlatypusCoreRepeatStatement methodsFor: 'accessing' stamp: 'apl 5/10/2005 19:30'!
whileControlBlock: whileBlock untilControlBlock: untilBlock 
	untilControlBlock := untilBlock.
	whileControlBlock := whileBlock! !

Object subclass: #PlatypusCoreRepositoryAbstractVisitor
	instanceVariableNames: 'folder actionMethodsIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-core'!

!PlatypusCoreRepositoryAbstractVisitor class methodsFor: 'instance creation' stamp: 'apl 3/10/2005 22:36'!
folder: aDataFolder
	^ self new folder:  aDataFolder! !

!PlatypusCoreRepositoryAbstractVisitor methodsFor: 'accessing' stamp: 'apl 3/10/2005 22:36'!
actionMethodsIndex
	^ actionMethodsIndex! !

!PlatypusCoreRepositoryAbstractVisitor methodsFor: 'accessing' stamp: 'apl 3/10/2005 22:36'!
actionMethodsIndex: anIndex 
	actionMethodsIndex := anIndex! !

!PlatypusCoreRepositoryAbstractVisitor methodsFor: 'data encoding' stamp: 'apl 3/10/2005 22:36'!
doAggregation: a 
	self subclassResponsibility! !

!PlatypusCoreRepositoryAbstractVisitor methodsFor: 'data encoding' stamp: 'apl 3/10/2005 22:36'!
doBoolean: b
	self subclassResponsibility! !

!PlatypusCoreRepositoryAbstractVisitor methodsFor: 'data encoding' stamp: 'apl 3/10/2005 22:36'!
doEnumeration: e 
		self subclassResponsibility! !

!PlatypusCoreRepositoryAbstractVisitor methodsFor: 'data encoding' stamp: 'apl 4/12/2006 14:21'!
doExternalRepresentation: inst 
	self subclassResponsibility! !

!PlatypusCoreRepositoryAbstractVisitor methodsFor: 'data encoding' stamp: 'apl 3/10/2005 22:36'!
doFolder
self subclassResponsibility ! !

!PlatypusCoreRepositoryAbstractVisitor methodsFor: 'data encoding' stamp: 'apl 3/10/2005 22:40'!
doInstance: inst 
	(inst isKindOf: PlatypusComplexInstance)
		ifTrue: [self doExternalRepresentation: inst]
		ifFalse: [self doInternalRepresentation: inst]! !

!PlatypusCoreRepositoryAbstractVisitor methodsFor: 'data encoding' stamp: 'apl 3/10/2005 22:36'!
doInstanceRef: i 
		self subclassResponsibility! !

!PlatypusCoreRepositoryAbstractVisitor methodsFor: 'data encoding' stamp: 'apl 3/10/2005 22:36'!
doInternalRepresentation: inst 
	self subclassResponsibility! !

!PlatypusCoreRepositoryAbstractVisitor methodsFor: 'data encoding' stamp: 'apl 3/10/2005 22:36'!
doLogical: l 
		self subclassResponsibility! !

!PlatypusCoreRepositoryAbstractVisitor methodsFor: 'data encoding' stamp: 'apl 3/10/2005 22:36'!
doNullValue
	self subclassResponsibility! !

!PlatypusCoreRepositoryAbstractVisitor methodsFor: 'data encoding' stamp: 'apl 3/10/2005 22:36'!
doNumber: n 
	self subclassResponsibility! !

!PlatypusCoreRepositoryAbstractVisitor methodsFor: 'data encoding' stamp: 'apl 3/10/2005 22:38'!
doObject: b 
	self subclassResponsibility! !

!PlatypusCoreRepositoryAbstractVisitor methodsFor: 'data encoding' stamp: 'apl 3/10/2005 22:36'!
doSingleToken: t 
	self push: OrderedCollection new.
	self doToken: t.
	^ self pop first! !

!PlatypusCoreRepositoryAbstractVisitor methodsFor: 'data encoding' stamp: 'apl 3/10/2005 22:36'!
doString: s 
		self subclassResponsibility! !

!PlatypusCoreRepositoryAbstractVisitor methodsFor: 'data encoding' stamp: 'apl 3/10/2005 22:36'!
doToken: t 
	t isNil
		ifTrue: [self doNullValue: nil]
		ifFalse: [self actionMethodsIndex
				do: [:a | (t isKindOf: a key)
						ifTrue: [self perform: a value with: t.
							^ a key]]].
	^ nil! !

!PlatypusCoreRepositoryAbstractVisitor methodsFor: 'accessing' stamp: 'apl 3/10/2005 22:36'!
folder: aDataFolder
	folder := aDataFolder! !

!PlatypusCoreRepositoryAbstractVisitor methodsFor: 'initialize/release' stamp: 'apl 3/10/2005 22:37'!
initialize
	super initialize.
	self actionMethodsIndex: OrderedCollection new.
	self actionMethodsIndex
		add: (Association key: Symbol value: #doEnumeration:).
	self actionMethodsIndex
		add: (Association key: String value: #doString:).
	self actionMethodsIndex
		add: (Association key: Boolean value: #doLogical:).
	self actionMethodsIndex
		add: (Association key: Number value: #doNumber:).
	self actionMethodsIndex
		add: (Association key: UndefinedObject value: #doNullValue:).
	self actionMethodsIndex
		add: (Association key: Collection value: #doAggregation:).
	self actionMethodsIndex
		add: (Association key: Object value: #doObject:)! !

!PlatypusCoreRepositoryAbstractVisitor methodsFor: 'accessing' stamp: 'apl 3/10/2005 22:36'!
oidOf: anInstance 
	^folder ifNil: [-1] ifNotNil: [folder oidOf: anInstance]! !

PlatypusCoreRepositoryAbstractVisitor subclass: #PlatypusCoreRepositoryStepFileWriter
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-core'!

!PlatypusCoreRepositoryStepFileWriter class methodsFor: 'instance creation' stamp: 'apl 12/7/2006 17:05'!
folder: aRepository 
	^ self new folder: aRepository
		! !

!PlatypusCoreRepositoryStepFileWriter methodsFor: 'data encoding' stamp: 'apl 3/10/2005 22:43'!
doAggregation: a  
	stream nextPut: $(.
	a
		do: [:e | self doToken: e]
		separatedBy: [stream nextPut: $,].
	stream nextPut: $)! !

!PlatypusCoreRepositoryStepFileWriter methodsFor: 'data encoding' stamp: 'apl 3/10/2005 22:43'!
doBoolean: b 
	self doLogical: b! !

!PlatypusCoreRepositoryStepFileWriter methodsFor: 'data encoding' stamp: 'apl 3/10/2005 22:43'!
doEnumeration: e 
	e isNil
		ifTrue: [stream nextPut: $$]
		ifFalse: [stream nextPut: $..
			stream nextPutAll: e.
			stream nextPut: $.]! !

!PlatypusCoreRepositoryStepFileWriter methodsFor: 'data encoding' stamp: 'apl 3/10/2005 22:43'!
doExternalRepresentation: inst 
self error: 'not implemented'! !

!PlatypusCoreRepositoryStepFileWriter methodsFor: 'data encoding' stamp: 'AlainPlantec 6/14/2012 15:29'!
doFolder
	| dateTime instances |
	dateTime := Time dateAndTimeNow.
	stream nextPutAll: 'ISO-10303-21;'.
	stream nextPut: Character cr.
	stream nextPutAll: 'HEADER;'.
	stream nextPut: Character cr.
	stream nextPutAll: 'FILE_NAME(''<name>'', ''' , dateTime first printString , ' ' , dateTime second printString , ''', (''<author>''), (''<organisation>''), ''<preprocessor version>'', ''<originating system>'', ''<authorization>'');\' withCRs.
	stream nextPutAll: 'FILE_DESCRIPTION((''<description1>'',''<description 2>''),''<implementation level>'');\' withCRs.
	stream nextPutAll: 'FILE_SCHEMA(());\' withCRs.
	stream nextPutAll: 'ENDSEC;'.
	stream nextPut: Character cr.
	stream nextPutAll: 'DATA;'.
	stream nextPut: Character cr.
	instances := folder instances.
	'Populating...'
		displayProgressAt: Sensor cursorPoint
		from: 1
		to: instances size
		during: [:bar | 1
				to: instances size
				do: [:p | 
					bar value: p.
					(instances at: p) 
						ifNotNil: [:i | 
							self doInstance: i.
							stream nextPut: Character cr]]].
	stream nextPutAll: 'ENDSEC;'.
	stream nextPut: Character cr.
	stream nextPutAll: 'END-ISO-10303-21;'.
	stream nextPut: Character cr! !

!PlatypusCoreRepositoryStepFileWriter methodsFor: 'data encoding' stamp: 'apl 3/10/2005 22:43'!
doInstanceRef: i
	stream nextPut: $#.
	folder
		ifNotNil: [stream nextPutAll: (folder oidOf: i) printString]! !

!PlatypusCoreRepositoryStepFileWriter methodsFor: 'data encoding' stamp: 'apl 3/15/2006 23:09'!
doInternalRepresentation: inst 
	| currToken entityDef getterSymbol |
	stream nextPut: $#.
	stream nextPutAll: (self oidOf: inst) printString.
	stream nextPut: $=.
	entityDef := self metaDataSchemaInstance metaDataForClass: inst class.
	stream nextPutAll: entityDef name asUppercase.
	stream nextPut: $(.
	entityDef
		inheritedExplicitAttributesDo: [:attr | (entityDef isAttributeRedeclared: attr)
				ifTrue: [stream nextPut: $*]
				ifFalse: [getterSymbol := attr getSelectorFromNamesBuilder: self namesBuilder.
					currToken := inst perform: getterSymbol asSymbol.
					self doToken: currToken]]
		separatedBy: [stream nextPut: $,].
	stream nextPutAll: ');'! !

!PlatypusCoreRepositoryStepFileWriter methodsFor: 'data encoding' stamp: 'apl 3/10/2005 22:43'!
doLogical: l 
	stream nextPut: $..
	l = #unknow
		ifTrue: [stream nextPut: $U]
		ifFalse: [l
				ifTrue: [stream nextPut: $T]
				ifFalse: [stream nextPut: $F]].
	stream nextPut: $.! !

!PlatypusCoreRepositoryStepFileWriter methodsFor: 'data encoding' stamp: 'apl 3/10/2005 22:43'!
doNullValue: e
	stream nextPut: $$! !

!PlatypusCoreRepositoryStepFileWriter methodsFor: 'data encoding' stamp: 'apl 3/10/2005 22:43'!
doNumber: n
	stream nextPutAll: n printString! !

!PlatypusCoreRepositoryStepFileWriter methodsFor: 'data encoding' stamp: 'apl 4/7/2006 14:16'!
doObject: o 
	(o isKindOf: PlatypusSchemaWrapper)
		ifTrue: [self doObject: o linkedMetaData]
		ifFalse: [stream nextPutAll: '#' , (self oidOf: o) asString]! !

!PlatypusCoreRepositoryStepFileWriter methodsFor: 'data encoding' stamp: 'apl 3/10/2005 22:43'!
doString: s
	stream nextPut: $'.
	s
		do: [:e | 
			stream nextPut: e.
			e == $'
				ifTrue: [stream nextPut: $']].
	stream nextPut: $'! !

!PlatypusCoreRepositoryStepFileWriter methodsFor: 'accessing' stamp: 'apl 3/11/2005 08:46'!
flushedContents
	| contents |
	contents := stream contents.
	stream reset.
	^ contents! !

!PlatypusCoreRepositoryStepFileWriter methodsFor: 'initialize/release' stamp: 'apl 3/10/2005 22:43'!
initialize
	super initialize.
	stream := WriteStream on: String new.! !

!PlatypusCoreRepositoryStepFileWriter methodsFor: 'accessing' stamp: 'apl 12/7/2006 17:04'!
metaDataSchemaInstance
	^ folder  metaDataSchemaInstance! !

!PlatypusCoreRepositoryStepFileWriter methodsFor: 'accessing' stamp: 'apl 12/7/2006 17:19'!
namesBuilder
	^ folder namesBuilder! !

!PlatypusCoreRepositoryStepFileWriter methodsFor: 'file in-out' stamp: 'apl 4/12/2006 14:28'!
stepFileOut: aFilename 
	| out |
	(out :=  (Filename named: aFilename) writeStream)
		ifNotNil: [[out nextPutAll: stream contents]
				ensure: [out close]]! !

!PlatypusCoreRepositoryStepFileWriter methodsFor: 'accessing' stamp: 'apl 3/10/2005 22:43'!
stream
	^ stream! !

!PlatypusCoreRepositoryStepFileWriter methodsFor: 'accessing' stamp: 'apl 3/10/2005 23:01'!
stream: aStream
	 stream := aStream! !

!PlatypusCoreRepositoryStepFileWriter methodsFor: 'data encoding' stamp: 'apl 3/10/2005 22:43'!
toStream: out 
	| |
	stream := out.
	self doFolder.
! !

Object subclass: #PlatypusCoreRunningContext
	instanceVariableNames: 'folder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-core'!

!PlatypusCoreRunningContext class methodsFor: 'instance creation' stamp: 'apl 3/3/2005 11:10'!
folder: aFolder 
	^ self new folder: aFolder! !

!PlatypusCoreRunningContext methodsFor: 'folder interface' stamp: 'apl 2/27/2006 21:53'!
allApplicationInstances
	^ self folder allApplicationInstances! !

!PlatypusCoreRunningContext methodsFor: 'folder interface' stamp: 'apl 3/3/2005 10:52'!
allInstancesOf: aClass 
	^ self folder allInstancesOf: aClass ! !

!PlatypusCoreRunningContext methodsFor: 'folder interface' stamp: 'apl 3/3/2005 10:53'!
allInstancesOf: aClass do: aBlock 
	^ self folder allInstancesOf: aClass do: aBlock ! !

!PlatypusCoreRunningContext methodsFor: 'accessing' stamp: 'apl 2/27/2006 21:52'!
folder
	^folder! !

!PlatypusCoreRunningContext methodsFor: 'accessing' stamp: 'apl 2/27/2006 21:52'!
folder: aPlatypusCoreRepository 
	folder := aPlatypusCoreRepository! !

!PlatypusCoreRunningContext methodsFor: 'folder interface' stamp: 'apl 4/11/2006 18:50'!
instanceAt: id 
	^ folder instanceAt: id ! !

!PlatypusCoreRunningContext methodsFor: 'folder interface' stamp: 'apl 4/11/2006 08:27'!
oidExists: id 
	^ self folder oidExists: id! !

!PlatypusCoreRunningContext methodsFor: 'folder interface' stamp: 'apl 3/3/2005 10:57'!
oidOf: anInstance 
	^self folder oidOf: anInstance ! !

!PlatypusCoreRunningContext methodsFor: 'folder interface' stamp: 'apl 3/10/2005 08:51'!
parseStream: in 
	^ self folder parseStream: in! !

!PlatypusCoreRunningContext methodsFor: 'folder interface' stamp: 'apl 3/3/2005 10:51'!
registerInstance: appInst 
	^ self folder registerInstance: appInst ! !

!PlatypusCoreRunningContext methodsFor: 'folder interface' stamp: 'apl 3/3/2005 10:53'!
registerInstance: appInst withId: id 
	^ self folder registerInstance: appInst withId: id! !

!PlatypusCoreRunningContext methodsFor: 'folder interface' stamp: 'apl 11/21/2005 10:43'!
stepFileIn: aFilename 
	^self folder stepFileIn: aFilename! !

!PlatypusCoreRunningContext methodsFor: 'folder interface' stamp: 'apl 3/3/2005 10:53'!
unregisterInstance: inst 
	^ self folder unregisterInstance: inst! !

Object subclass: #PlatypusExpressBuiltinFormatFormatter
	instanceVariableNames: 'sourceFormat'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-interpreter'!

!PlatypusExpressBuiltinFormatFormatter class methodsFor: 'instance creation' stamp: 'AlainPlantec 4/26/2012 10:49'!
format: aNumber sourceFormat: aString 
	| formatter src |
	aString trimBoth isEmpty ifTrue: [
		src := aNumber isInteger ifTrue: ['7I'] ifFalse: ['10.1E'].
		] ifFalse: [src := aString].
	formatter := PlatypusExpressBuiltinFormatParser parse: src.
	^ formatter format: aNumber! !

!PlatypusExpressBuiltinFormatFormatter class methodsFor: 'instance creation' stamp: 'apl 1/18/2004 01:06'!
sourceFormat: aFormat 
	^ self new initializeFromSourceFormat: aFormat! !

!PlatypusExpressBuiltinFormatFormatter methodsFor: 'formatting' stamp: 'apl 1/16/2004 22:52'!
format: aNumber 
	^ aNumber asString! !

!PlatypusExpressBuiltinFormatFormatter methodsFor: 'initializing' stamp: 'apl 1/18/2004 01:05'!
initializeFromSourceFormat: aSourceString 
	^ self! !

PlatypusExpressBuiltinFormatFormatter subclass: #PlatypusExpressBuiltinFormatPictureFormatter
	instanceVariableNames: 'negation sign groupingChar decimalChar width decimals'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-interpreter'!

!PlatypusExpressBuiltinFormatPictureFormatter methodsFor: 'accessing' stamp: 'apl 1/20/2004 12:19'!
decimalChar
	^decimalChar! !

!PlatypusExpressBuiltinFormatPictureFormatter methodsFor: 'accessing' stamp: 'apl 1/20/2004 12:19'!
decimalChar: anObject
	decimalChar := anObject! !

!PlatypusExpressBuiltinFormatPictureFormatter methodsFor: 'accessing' stamp: 'apl 1/20/2004 12:39'!
decimals
	^decimals! !

!PlatypusExpressBuiltinFormatPictureFormatter methodsFor: 'accessing' stamp: 'apl 1/20/2004 12:39'!
decimals: anObject
	decimals := anObject! !

!PlatypusExpressBuiltinFormatPictureFormatter methodsFor: 'formatting' stamp: 'apl 4/18/2006 12:50'!
format: aNumber 
	| symbolicFormatter source symbolicResult decIdx groupingPositions result dstPos |
	source := OrderedCollection new.
	source add: (sign).
	source add: (negation
				ifTrue: [((aNumber < 0
							and: [aNumber isFloat])
						ifTrue: [width + 2]
						ifFalse: [aNumber isFloat
								ifTrue: [width + 1]
								ifFalse: [width]]) asString]
				ifFalse: [(sign = $+
							or: [aNumber < 0])
						ifTrue: [(width + 2) asString]
						ifFalse: [width asString]]).
	source add: decimals.
	source add: (decimals
				ifNil: [$I]
				ifNotNil: [$F]).
	symbolicFormatter := PlatypusExpressBuiltinFormatSymbolicFormatter new.
	symbolicFormatter initializeFromSourceFormat: source.
	symbolicResult := symbolicFormatter format: aNumber.
	negation
		ifTrue: [aNumber < 0.0
				ifTrue: [symbolicResult := '('
								, (symbolicResult copyFrom: 2 to: symbolicResult size) , ')'.
					symbolicResult replaceAll: $- with: $ ]].
	(symbolicResult indexOf: $e)
			> 0
		ifTrue: [^ symbolicResult].
	(decimalChar notNil
			and: [decimalChar ~= $.])
		ifTrue: [symbolicResult replaceAll: $. with: decimalChar].
	groupingChar notNil
		ifTrue: [decIdx := symbolicResult indexOf: decimalChar.
			groupingPositions := OrderedCollection new.
			decIdx := decIdx - 3.
			[decIdx > 0
				and: [(symbolicResult at: decIdx) isDigit]]
				whileTrue: [groupingPositions addFirst: decIdx.
					decIdx := decIdx - 3].
			result := String new: symbolicResult size + groupingPositions size.
			dstPos := 1.
			1
				to: symbolicResult size
				do: [:srcPos | 
					(groupingPositions notEmpty
							and: [groupingPositions first = srcPos])
						ifTrue: [result at: dstPos put: groupingChar.
							dstPos := dstPos + 1.
							groupingPositions removeFirst].
					result
						at: dstPos
						put: (symbolicResult at: srcPos).
					dstPos := dstPos + 1].
			^ result].
	^ symbolicResult! !

!PlatypusExpressBuiltinFormatPictureFormatter methodsFor: 'accessing' stamp: 'apl 1/20/2004 12:19'!
groupingChar
	^groupingChar! !

!PlatypusExpressBuiltinFormatPictureFormatter methodsFor: 'accessing' stamp: 'apl 1/20/2004 12:19'!
groupingChar: anObject
	groupingChar := anObject! !

!PlatypusExpressBuiltinFormatPictureFormatter methodsFor: 'initializing' stamp: 'AlainPlantec 10/7/2010 13:44'!
initializeFromSourceFormat: anArray 
	| picture |
	anArray first = $(
		ifTrue: [negation := true]
		ifFalse: [negation := false.
			anArray first = $+
				ifTrue: [sign := $+]
				ifFalse: [sign := $-]].
	picture := anArray second.
	picture size = 1
		ifTrue: [self width: picture first]
		ifFalse: [picture size = 3
				ifTrue: [self width: picture first + picture last.
					self decimals: picture last.
					self decimalChar: picture second]
				ifFalse: [self width: picture first + picture third + picture last.
					self
						decimalChar: (picture at: picture size - 1).
					self decimals: picture last.
					self groupingChar: picture second]]! !

!PlatypusExpressBuiltinFormatPictureFormatter methodsFor: 'accessing' stamp: 'apl 1/20/2004 12:39'!
negation
	^negation! !

!PlatypusExpressBuiltinFormatPictureFormatter methodsFor: 'accessing' stamp: 'apl 1/20/2004 12:39'!
negation: anObject
	negation := anObject! !

!PlatypusExpressBuiltinFormatPictureFormatter methodsFor: 'accessing' stamp: 'apl 1/20/2004 12:39'!
sign
	^sign! !

!PlatypusExpressBuiltinFormatPictureFormatter methodsFor: 'accessing' stamp: 'apl 1/20/2004 12:39'!
sign: anObject
	sign := anObject! !

!PlatypusExpressBuiltinFormatPictureFormatter methodsFor: 'accessing' stamp: 'apl 1/20/2004 12:39'!
width
	^width! !

!PlatypusExpressBuiltinFormatPictureFormatter methodsFor: 'accessing' stamp: 'apl 1/20/2004 12:39'!
width: anObject
	width := anObject! !

PlatypusExpressBuiltinFormatFormatter subclass: #PlatypusExpressBuiltinFormatSymbolicFormatter
	instanceVariableNames: 'sign precZero width decimals type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-interpreter'!

!PlatypusExpressBuiltinFormatSymbolicFormatter methodsFor: 'accessing' stamp: 'apl 1/18/2004 00:20'!
decimals
	^decimals! !

!PlatypusExpressBuiltinFormatSymbolicFormatter methodsFor: 'accessing' stamp: 'apl 1/18/2004 00:20'!
decimals: anObject
	decimals := anObject! !

!PlatypusExpressBuiltinFormatSymbolicFormatter methodsFor: 'formatting' stamp: 'alain.plantec 1/18/2009 12:05'!
finalStringFrom: aStringEncodingANumber forNumber: aNumber 
	| result |
	result := aStringEncodingANumber.
	precZero = $0
		ifTrue: [result := result 
						padded: #left
						to: width - 1
						with: precZero].
	sign = $+
		ifTrue: [aNumber < 0
				ifFalse: [aNumber > 0
						ifTrue: [result := '+' , result]
						ifFalse: [result := ' ' , result]]]
		ifFalse: [aNumber < 0
				ifFalse: [result := '' , result]].
	precZero ~= $0
		ifTrue: [result := result
						padded: #left
						to: width
						with: precZero].
	^ result! !

!PlatypusExpressBuiltinFormatSymbolicFormatter methodsFor: 'formatting' stamp: 'AlainPlantec 10/7/2010 13:45'!
format: aNumber 
	| resultStr dec intPart decPartStr intPartStr fracPartStr fracMax fracPartStrBuf fracPartStrStream startCopy |
	aNumber isInteger
		ifTrue: [type = $I
				ifTrue: [^ self stringFromInteger: aNumber]]
		ifFalse: [type = $I
				ifTrue: [^ self stringFromInteger: aNumber rounded]].
	type = $F
		ifTrue: [resultStr := aNumber printShowingDecimalPlaces: decimals.
			^ self finalStringFrom: resultStr forNumber: aNumber].
	decPartStr := decimals < 10
				ifTrue: ['0']
				ifFalse: [''].
	decPartStr := decPartStr , decimals asString.
	dec := decimals.
	intPart := aNumber asFloat integerPart.
	fracPartStrBuf := aNumber asFloat fractionPart asString.
	fracPartStr := ''.
	fracPartStrStream := WriteStream on: fracPartStr.
	startCopy := false.
	fracPartStrBuf
		do: [:d | startCopy
				ifTrue: [fracPartStrStream nextPut: d]
				ifFalse: [startCopy := d = $.]].
	fracPartStr := fracPartStrStream contents , '000000000000000000000000'.
	[dec > 0]
		whileTrue: [intPart := intPart / 10.0.
			dec := dec - 1].
	intPartStr := intPart asString.
	(intPartStr indexOf: $e) isZero
		ifFalse: [decimals := decimals - 1.
			^ self format: aNumber].
	sign = $+
		ifTrue: [aNumber < 0.0
				ifFalse: [aNumber > 0.0
						ifTrue: [intPartStr := '+' , intPartStr]]].
	(fracMax := width - (intPartStr size + decPartStr size + 2)) > 0
		ifTrue: [fracPartStr := fracPartStr copyFrom: 1 to: fracMax]
		ifFalse: [fracPartStr := ''].
	^ intPartStr , fracPartStr , 'E+' , decPartStr! !

!PlatypusExpressBuiltinFormatSymbolicFormatter methodsFor: 'initializing' stamp: 'apl 12/12/2005 12:07'!
initializeFromSourceFormat: aSourceString 
	| iwidth idecimals |
	type := aSourceString fourth.
	sign := aSourceString first.
	precZero := aSourceString second ifNil: [$ ] ifNotNil: [aSourceString second first = $0
				ifTrue: [$0]
				ifFalse: [$ ]].
	width := (iwidth := aSourceString second)
				ifNil: [type = $I
						ifTrue: [2]
						ifFalse: [type = $F
								ifTrue: [4]
								ifFalse: [7]]]
				ifNotNil: [iwidth asNumber].
	decimals := aSourceString third
				ifNil: [2]
				ifNotNil: [(idecimals := aSourceString third asNumber) < 1
						ifTrue: [1]
						ifFalse: [idecimals]]! !

!PlatypusExpressBuiltinFormatSymbolicFormatter methodsFor: 'accessing' stamp: 'apl 1/18/2004 00:20'!
precZero
	^precZero! !

!PlatypusExpressBuiltinFormatSymbolicFormatter methodsFor: 'accessing' stamp: 'apl 1/18/2004 00:20'!
precZero: anObject
	precZero := anObject! !

!PlatypusExpressBuiltinFormatSymbolicFormatter methodsFor: 'accessing' stamp: 'apl 1/18/2004 00:20'!
sign
	^sign! !

!PlatypusExpressBuiltinFormatSymbolicFormatter methodsFor: 'accessing' stamp: 'apl 1/18/2004 00:20'!
sign: anObject
	sign := anObject! !

!PlatypusExpressBuiltinFormatSymbolicFormatter methodsFor: 'formatting' stamp: 'apl 1/19/2004 23:16'!
stringFromInteger: aNumber 
	^ self finalStringFrom: aNumber asString forNumber: aNumber 
! !

!PlatypusExpressBuiltinFormatSymbolicFormatter methodsFor: 'accessing' stamp: 'apl 1/18/2004 00:20'!
type
	^type! !

!PlatypusExpressBuiltinFormatSymbolicFormatter methodsFor: 'accessing' stamp: 'apl 1/18/2004 00:20'!
type: anObject
	type := anObject! !

!PlatypusExpressBuiltinFormatSymbolicFormatter methodsFor: 'accessing' stamp: 'apl 1/18/2004 00:20'!
width
	^width! !

!PlatypusExpressBuiltinFormatSymbolicFormatter methodsFor: 'accessing' stamp: 'apl 1/18/2004 00:20'!
width: anObject
	width := anObject! !

Object subclass: #PlatypusExpressInterpretorStackValue
	instanceVariableNames: 'interpretor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-interpreter'!

PlatypusExpressInterpretorStackValue subclass: #PlatypusExpressInterpretorCallArguments
	instanceVariableNames: 'arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-interpreter'!

!PlatypusExpressInterpretorCallArguments methodsFor: 'accessing' stamp: 'apl 2/22/2006 17:59'!
addValue: aValue
	arguments add: aValue! !

!PlatypusExpressInterpretorCallArguments methodsFor: 'accessing' stamp: 'apl 2/22/2006 17:59'!
arguments
	^ arguments ! !

!PlatypusExpressInterpretorCallArguments methodsFor: 'initialize-release' stamp: 'apl 2/22/2006 17:58'!
initialize
	super initialize.
	arguments := OrderedCollection new.! !

PlatypusExpressInterpretorStackValue subclass: #PlatypusExpressInterpretorStackElement
	instanceVariableNames: 'var'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-interpreter'!

PlatypusExpressInterpretorStackElement subclass: #PlatypusExpressInterpretorStackAppInst
	instanceVariableNames: 'instance interpreted'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-interpreter'!

!PlatypusExpressInterpretorStackAppInst class methodsFor: 'instance creation' stamp: 'apl 2/3/2004 10:42'!
instance: anInstance interpretor: anInterpretor 
	^ self new instance: anInstance interpretor: anInterpretor! !

!PlatypusExpressInterpretorStackAppInst methodsFor: 'interpreting' stamp: 'apl 7/18/2004 16:41'!
addRecordsToExternalRepresentation: externalRep
	instance asExternalRepresentation records do: [:rec | rec copy addRecordsToExternalRepresentation: externalRep]! !

!PlatypusExpressInterpretorStackAppInst methodsFor: 'interpreting' stamp: 'apl 6/16/2004 12:32'!
assign: aValue 
	| varDomain assigned |
	self interpretor checkAssignmentOf: aValue to: self var.
	varDomain := self var computedDomain.
	assigned := self interpretor valueFromDomain: varDomain assignCompatibleWith: aValue.
	^ self fastAssign: assigned! !

!PlatypusExpressInterpretorStackAppInst methodsFor: 'copying' stamp: 'AlainPlantec 10/7/2010 15:51'!
deepCopy
	| n |
	n := super deepCopy.
	n instance: self instance deepCopy.
	^ n! !

!PlatypusExpressInterpretorStackAppInst methodsFor: 'accessing' stamp: 'apl 7/18/2004 16:43'!
domain
	^ self instance computedDomain
! !

!PlatypusExpressInterpretorStackAppInst methodsFor: 'interpreting' stamp: 'AlainPlantec 10/7/2010 15:51'!
fastAssign: aValue 
	instance := aValue.
	^ instance! !

!PlatypusExpressInterpretorStackAppInst methodsFor: 'accessing' stamp: 'apl 1/26/2004 10:32'!
instance
	^instance! !

!PlatypusExpressInterpretorStackAppInst methodsFor: 'accessing' stamp: 'apl 1/26/2004 15:37'!
instance: anExternalRep
	instance := anExternalRep! !

!PlatypusExpressInterpretorStackAppInst methodsFor: 'accessing' stamp: 'apl 2/3/2004 10:43'!
instance: anInstance interpretor: anInterpretor 
	self instance: anInstance.
	super
		var: (PltAnonymousVariable domain: self domain)
		interpretor: anInterpretor! !

!PlatypusExpressInterpretorStackAppInst methodsFor: 'accessing' stamp: 'apl 10/24/2006 01:43'!
val
	| value attrDomain valueDomain  |
	interpreted ifNil: 
			[interpreted := instance.
			self interpretor asValOfSelf: instance
				while: 
					[self instance records do: 
							[:rec | 
							rec definition referenced explicitAttributesWithIndexDo: 
									[:attr :pos | 
									pos > rec parameters size 
										ifTrue: [rec parameters add: PltMissingValue new].
									value := rec parameters at: pos.
									value isPltValue 
										ifFalse: 
											[value isPltIdentifier 
												ifTrue: 
													[self interpretor asContextsStack: value contextsStack
														while: [value acceptTry: self interpretor]]
												ifFalse: [value acceptTry: self interpretor].
											value := self interpretor popVal].
									attrDomain := attr domain.
									valueDomain := value computedDomain.
									(self interpretor value: value isAssignableTo: attr) 
										ifFalse: 
											[^ PlatypusExpressIncompatibleDomainInAssignmentException 
												signal: 'entity ''' , attr owner name , ''' attribute ''' , attr name 
														, ''' domain : ' , attrDomain prettyPrintedExpressCode 
														, ';  value domain : ' , valueDomain prettyPrintedExpressCode].
									self interpretor asValOfSelf: instance
										while: 
											[value := self interpretor valueFromDomain: attrDomain
														assignCompatibleWith: value].
									rec parameters at: pos put: value]]]].
	^ interpreted! !

!PlatypusExpressInterpretorStackAppInst methodsFor: 'copying' stamp: 'AlainPlantec 10/7/2010 15:51'!
veryDeepCopy
	| n |
	n := super veryDeepCopy.
	n instance: self instance veryDeepCopy.
	^ n! !

PlatypusExpressInterpretorStackElement subclass: #PlatypusExpressInterpretorStackAttribute
	instanceVariableNames: 'record pos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-interpreter'!

!PlatypusExpressInterpretorStackAttribute class methodsFor: 'instance creation' stamp: 'apl 1/3/2004 11:11'!
var: aData record: aRecord pos: anInteger interpretor: anInterpretor 
	^ self new
		var: aData
		record: aRecord
		pos: anInteger
		interpretor: anInterpretor! !

!PlatypusExpressInterpretorStackAttribute methodsFor: 'interpreting' stamp: 'apl 3/31/2006 10:23'!
assign: aValue 
	| varDomain assigned |
	self interpretor checkAssignmentOf: aValue to: self var.
	varDomain := self var computedDomain.
	self interpretor asValOfSelf:  record while: [
	assigned := self interpretor valueFromDomain: varDomain assignCompatibleWith: aValue].
	^ self fastAssign: assigned! !

!PlatypusExpressInterpretorStackAttribute methodsFor: 'copying' stamp: 'AlainPlantec 10/7/2010 15:51'!
deepCopy
	| n |
	n := super deepCopy.
	n record: self record deepCopy.
	^ n! !

!PlatypusExpressInterpretorStackAttribute methodsFor: 'interpreting' stamp: 'apl 1/3/2004 11:20'!
fastAssign: aValue 
	self record parameters at: self pos put: aValue.
	^ aValue! !

!PlatypusExpressInterpretorStackAttribute methodsFor: 'accessing' stamp: 'apl 1/2/2004 22:09'!
pos
	^pos! !

!PlatypusExpressInterpretorStackAttribute methodsFor: 'accessing' stamp: 'apl 1/2/2004 22:09'!
pos: anObject
	pos := anObject! !

!PlatypusExpressInterpretorStackAttribute methodsFor: 'accessing' stamp: 'apl 1/3/2004 11:06'!
record
	^record! !

!PlatypusExpressInterpretorStackAttribute methodsFor: 'accessing' stamp: 'apl 1/3/2004 11:06'!
record: anObject
	record := anObject! !

!PlatypusExpressInterpretorStackAttribute methodsFor: 'accessing' stamp: 'apl 3/31/2006 08:44'!
val
	| fetched attrDef |
	(fetched := self record parameters at: pos)
		ifNil: [attrDef := self record definition attributes at: pos.
			^ PlatypusExpressInvalidAttributeException signal: 'attribute : ''' , attrDef name , ''' is not computable'].
	^ fetched! !

!PlatypusExpressInterpretorStackAttribute methodsFor: 'accessing' stamp: 'apl 1/3/2004 11:09'!
var: aData record: aRecord pos: anInteger interpretor: anInterpretor 
	super var: aData interpretor: anInterpretor.
	self record: aRecord.
	self pos: anInteger! !

!PlatypusExpressInterpretorStackAttribute methodsFor: 'copying' stamp: 'AlainPlantec 10/7/2010 15:51'!
veryDeepCopy
	| n |
	n := super veryDeepCopy.
	n record: self record veryDeepCopy.
	^ n! !

!PlatypusExpressInterpretorStackElement methodsFor: 'interpreting' stamp: 'apl 7/18/2004 16:40'!
addRecordsToExternalRepresentation: externalRep
	self val addRecordsToExternalRepresentation: externalRep
! !

!PlatypusExpressInterpretorStackElement methodsFor: 'accessing' stamp: 'apl 2/23/2005 21:45'!
aggr: anAggr positionFromIndex: anInteger 
	anAggr isPltArrayInstance
		ifTrue: [^ anInteger - self aggr lowerBound val + 1]
		ifFalse: [^ anInteger]! !

!PlatypusExpressInterpretorStackElement methodsFor: 'accessing' stamp: 'apl 6/13/2004 11:46'!
asString
	^ self val printableCode! !

!PlatypusExpressInterpretorStackElement methodsFor: 'accessing' stamp: 'apl 3/1/2004 22:26'!
computedDomain
	^ self val computedDomain
! !

!PlatypusExpressInterpretorStackElement methodsFor: 'interpreting' stamp: 'apl 1/2/2004 19:05'!
fastAssign: aValue 
	self subclassResponsibility
! !

!PlatypusExpressInterpretorStackElement methodsFor: 'accessing' stamp: 'AlainPlantec 5/8/2012 12:54'!
instance
	^ self val! !

!PlatypusExpressInterpretorStackElement methodsFor: 'accessing' stamp: 'apl 6/13/2004 11:47'!
printString
	^ self asString! !

!PlatypusExpressInterpretorStackElement methodsFor: 'interpreting' stamp: 'AlainPlantec 10/7/2010 15:52'!
pushAttribute: anIdent 
	| v key allAttrIdentif |
	(v := self val)
		ifMissing: [self interpretor pushVal: v]
		ifNotMissing: [key := anIdent asUppercase.
			allAttrIdentif := v getInstanceAttributeIdentification: [:a | a name asUppercase = key].
			allAttrIdentif isNil
				ifTrue: [PlatypusExpressInvalidAttributeException signal: 'invalid attribute name: ''' , anIdent , ''''].
				
			self pushAttribute: allAttrIdentif definition entityInstance: v]! !

!PlatypusExpressInterpretorStackElement methodsFor: 'interpreting' stamp: 'apl 10/2/2006 16:00'!
pushAttribute: attrDef entityInstance: entityInst 
	self interpretor asValOfSelf: entityInst
		while: 
			[
			attrDef acceptTry: self interpretor]! !

!PlatypusExpressInterpretorStackElement methodsFor: 'interpreting' stamp: 'apl 1/31/2006 12:32'!
pushIndex: anInteger 
	| elementDomain anonymousVar |
	elementDomain := self var staticDomain elementType.
	anonymousVar := PltAnonymousVariable domain: elementDomain.
	self
		pushVar: anonymousVar
		aggr: self val
		index: anInteger! !

!PlatypusExpressInterpretorStackElement methodsFor: 'interpreting' stamp: 'apl 3/1/2004 22:17'!
pushRange: anInterval 
	| anonymousVar |
	anonymousVar := PltAnonymousVariable domain: self val computedDomain.
	self
		pushVar: anonymousVar
		aggr: self val
		range: anInterval
! !

!PlatypusExpressInterpretorStackElement methodsFor: 'interpreting' stamp: 'AlainPlantec 10/7/2010 15:52'!
pushVar: anObject aggr: anAgregateData index: anInteger 
	| stackElement |
	stackElement := PlatypusExpressInterpretorStackIndexedElement
				var: anObject
				aggr: anAgregateData
				idx: anInteger
				interpretor: interpretor.
	interpretor push: stackElement! !

!PlatypusExpressInterpretorStackElement methodsFor: 'interpreting' stamp: 'AlainPlantec 10/7/2010 15:52'!
pushVar: anObject aggr: anAgregateData range: anInterval 
	| stackElement |
	stackElement := PlatypusExpressInterpretorStackRangeElement
				var: anObject
				aggr: anAgregateData
				range: anInterval
				interpretor: interpretor.
	interpretor push: stackElement! !

!PlatypusExpressInterpretorStackElement methodsFor: 'accessing' stamp: 'apl 1/2/2004 19:00'!
val
	^ self subclassResponsibility ! !

!PlatypusExpressInterpretorStackElement methodsFor: 'accessing' stamp: 'apl 1/22/2004 18:51'!
var
	^var! !

!PlatypusExpressInterpretorStackElement methodsFor: 'accessing' stamp: 'AlainPlantec 10/7/2010 15:52'!
var: anObject 
	var := anObject.
! !

!PlatypusExpressInterpretorStackElement methodsFor: 'accessing' stamp: 'apl 1/22/2004 18:52'!
var: anObject interpretor: anInterpretor
	self var: anObject.
	self interpretor: anInterpretor! !

PlatypusExpressInterpretorStackElement subclass: #PlatypusExpressInterpretorStackIndexedElement
	instanceVariableNames: 'aggr idx'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-interpreter'!

!PlatypusExpressInterpretorStackIndexedElement class methodsFor: 'instance creation' stamp: 'apl 1/2/2004 19:09'!
var: aData aggr: anAggregateData idx: anInteger interpretor: anInterpretor 
	^ self new
		var: aData
		aggr: anAggregateData
		idx: anInteger
		interpretor: anInterpretor! !

!PlatypusExpressInterpretorStackIndexedElement methodsFor: 'accessing' stamp: 'apl 12/21/2003 11:10'!
aggr
	^aggr! !

!PlatypusExpressInterpretorStackIndexedElement methodsFor: 'accessing' stamp: 'apl 12/21/2003 11:10'!
aggr: anObject
	aggr := anObject! !

!PlatypusExpressInterpretorStackIndexedElement methodsFor: 'accessing' stamp: 'apl 1/23/2004 12:08'!
aggrPosition
	^ self aggrPositionFromIndex: self idx! !

!PlatypusExpressInterpretorStackIndexedElement methodsFor: 'accessing' stamp: 'apl 1/27/2004 11:44'!
aggrPositionFromIndex: anInteger 
	^ self aggr: self aggr positionFromIndex: anInteger! !

!PlatypusExpressInterpretorStackIndexedElement methodsFor: 'interpreting' stamp: 'apl 6/16/2004 12:40'!
assign: aValue 
	| varDomain assigned |
	self interpretor checkAssignmentOf: aValue to: self var.
	varDomain := self var computedDomain.
	assigned := self interpretor valueFromDomain: varDomain assignCompatibleWith: aValue.
	^ self fastAssign: assigned! !

!PlatypusExpressInterpretorStackIndexedElement methodsFor: 'copying' stamp: 'AlainPlantec 10/7/2010 15:52'!
deepCopy
	| n |
	n := super deepCopy.
	n aggr: self aggr deepCopy.
	^ n! !

!PlatypusExpressInterpretorStackIndexedElement methodsFor: 'interpreting' stamp: 'apl 1/2/2004 19:11'!
fastAssign: aValue 
	self aggr at: idx put: aValue.
	^ aValue! !

!PlatypusExpressInterpretorStackIndexedElement methodsFor: 'accessing' stamp: 'apl 12/20/2003 12:01'!
idx
	^idx! !

!PlatypusExpressInterpretorStackIndexedElement methodsFor: 'accessing' stamp: 'apl 12/20/2003 12:01'!
idx: anObject
	idx := anObject! !

!PlatypusExpressInterpretorStackIndexedElement methodsFor: 'accessing' stamp: 'apl 1/7/2004 19:16'!
val
	^ self aggr at: self aggrPosition! !

!PlatypusExpressInterpretorStackIndexedElement methodsFor: 'accessing' stamp: 'apl 1/2/2004 19:10'!
var: aData aggr: anAggregateData idx: anInteger interpretor: anInterpretor 
	super var: aData interpretor: anInterpretor.
	self aggr: anAggregateData.
	self idx: anInteger! !

!PlatypusExpressInterpretorStackIndexedElement methodsFor: 'copying' stamp: 'AlainPlantec 10/7/2010 15:52'!
veryDeepCopy
	| n |
	n := super veryDeepCopy.
	n aggr: self aggr veryDeepCopy.
	^ n! !

PlatypusExpressInterpretorStackElement subclass: #PlatypusExpressInterpretorStackRangeElement
	instanceVariableNames: 'aggr range'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-interpreter'!

!PlatypusExpressInterpretorStackRangeElement class methodsFor: 'instance creation' stamp: 'apl 1/2/2004 19:12'!
var: aData aggr: anAggregateData range: anInterval interpretor: anInterpretor 
	^ self new
		var: aData
		aggr: anAggregateData
		range: anInterval
		interpretor: anInterpretor! !

!PlatypusExpressInterpretorStackRangeElement methodsFor: 'accessing' stamp: 'apl 12/22/2003 12:59'!
aggr
	^aggr! !

!PlatypusExpressInterpretorStackRangeElement methodsFor: 'accessing' stamp: 'apl 12/22/2003 12:59'!
aggr: anObject
	aggr := anObject! !

!PlatypusExpressInterpretorStackRangeElement methodsFor: 'interpreting' stamp: 'apl 6/16/2004 12:40'!
assign: aValue 
	| varDomain assigned |
	self interpretor checkAssignmentOf: aValue to: self var.
	varDomain := self var computedDomain.
	assigned := self interpretor valueFromDomain: varDomain assignCompatibleWith: aValue.
	^ self fastAssign: assigned! !

!PlatypusExpressInterpretorStackRangeElement methodsFor: 'copying' stamp: 'AlainPlantec 10/7/2010 15:52'!
deepCopy
	| n |
	n := super deepCopy.
	n aggr: self aggr deepCopy.
	^ n! !

!PlatypusExpressInterpretorStackRangeElement methodsFor: 'accessing' stamp: 'apl 1/27/2004 09:25'!
fastAssign: aValue 
	self aggr range: range put: aValue interpretor: self interpretor.
	^ aValue! !

!PlatypusExpressInterpretorStackRangeElement methodsFor: 'interpreting' stamp: 'apl 3/1/2004 22:22'!
pushIndex: anInteger 
	| elementDomain anonymousVar |
	elementDomain := self var computedDomain elementType.
	anonymousVar := PltAnonymousVariable domain: elementDomain.
	self
		pushVar: anonymousVar
		aggr: self aggr
		index: range first + anInteger - 1
! !

!PlatypusExpressInterpretorStackRangeElement methodsFor: 'interpreting' stamp: 'apl 1/2/2004 19:07'!
pushRange: anInterval 
	self
		pushVar: self var
		aggr: self aggr
		range: (range first + anInterval first - 1 to: anInterval last + range first - 1)! !

!PlatypusExpressInterpretorStackRangeElement methodsFor: 'accessing' stamp: 'apl 12/22/2003 13:00'!
range
	^range! !

!PlatypusExpressInterpretorStackRangeElement methodsFor: 'accessing' stamp: 'apl 12/22/2003 13:00'!
range: anObject
	range := anObject! !

!PlatypusExpressInterpretorStackRangeElement methodsFor: 'accessing' stamp: 'apl 2/23/2005 21:45'!
val
	| rng |
	self aggr isPltArrayInstance
		ifTrue: [rng := (self aggr: self aggr positionFromIndex: range first)
						to: (self aggr: self aggr positionFromIndex: range last)]
		ifFalse: [rng := range].
	^ self aggr range: rng interpretor: self interpretor! !

!PlatypusExpressInterpretorStackRangeElement methodsFor: 'accessing' stamp: 'apl 1/2/2004 19:12'!
var: aData aggr: anAggregateData range: anInterval interpretor: anInterpretor 
	super var: aData interpretor: anInterpretor.
	self aggr: anAggregateData.
	self range: anInterval! !

!PlatypusExpressInterpretorStackRangeElement methodsFor: 'copying' stamp: 'AlainPlantec 10/7/2010 15:52'!
veryDeepCopy
	| n |
	n := super veryDeepCopy.
	n aggr: self aggr veryDeepCopy.
	^ n! !

PlatypusExpressInterpretorStackElement subclass: #PlatypusExpressInterpretorStackVar
	instanceVariableNames: 'val'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-interpreter'!

!PlatypusExpressInterpretorStackVar class methodsFor: 'instance creation' stamp: 'apl 3/17/2006 16:28'!
interpretor: anInterpretor 
	^ self
		var: PltAnonymousVariable default
		val: PltMissingValue new
		interpretor: anInterpretor! !

!PlatypusExpressInterpretorStackVar class methodsFor: 'instance creation' stamp: 'apl 1/21/2004 11:05'!
val: aValue interpretor: anInterpretor 
	^self 
		var: PltAnonymousVariable default
		val: aValue
		interpretor: anInterpretor! !

!PlatypusExpressInterpretorStackVar class methodsFor: 'instance creation' stamp: 'apl 1/2/2004 18:58'!
var: aData val: aValue interpretor: anInterpretor 
	^ self new var: aData val: aValue interpretor: anInterpretor ! !

!PlatypusExpressInterpretorStackVar methodsFor: 'interpreting' stamp: 'apl 6/16/2004 12:41'!
assign: aValue 
	| varDomain assigned |
	self interpretor checkAssignmentOf: aValue to: self var.
	varDomain := self var computedDomain.
	assigned := self interpretor valueFromDomain: varDomain assignCompatibleWith: aValue.
	^ self fastAssign: assigned! !

!PlatypusExpressInterpretorStackVar methodsFor: 'copying' stamp: 'AlainPlantec 10/7/2010 15:53'!
deepCopy
	| n |
	n := super deepCopy.
	n val: self val deepCopy.
	^ n! !

!PlatypusExpressInterpretorStackVar methodsFor: 'interpreting' stamp: 'apl 1/2/2004 18:58'!
fastAssign: aValue 
	self val: aValue.
	^ aValue! !

!PlatypusExpressInterpretorStackVar methodsFor: 'accessing' stamp: 'AlainPlantec 5/4/2012 19:25'!
val
	val ifNotNil: [
		val isPltValue
			ifFalse: [val acceptTry: self interpretor.
				val := self interpretor popVal]].
	^ val! !

!PlatypusExpressInterpretorStackVar methodsFor: 'accessing' stamp: 'apl 7/14/2004 13:12'!
val: anObject 
	val := anObject! !

!PlatypusExpressInterpretorStackVar methodsFor: 'accessing' stamp: 'apl 1/22/2004 18:50'!
var: aData val: aValue interpretor: anInterpretor 
	super var: aData interpretor: anInterpretor.
	self val: aValue! !

!PlatypusExpressInterpretorStackVar methodsFor: 'copying' stamp: 'AlainPlantec 10/7/2010 15:53'!
veryDeepCopy
	| n |
	n := super veryDeepCopy.
	n val: self val veryDeepCopy.
	^ n! !

!PlatypusExpressInterpretorStackValue class methodsFor: 'instance creation' stamp: 'apl 2/23/2006 10:53'!
interpretor: anExpressInterpreter
	^ self new interpretor: anExpressInterpreter! !

!PlatypusExpressInterpretorStackValue methodsFor: 'copying' stamp: 'apl 2/22/2006 17:49'!
deepCopy
	| n |
	n := self copy.
	^ n! !

!PlatypusExpressInterpretorStackValue methodsFor: 'accessing' stamp: 'apl 2/22/2006 17:49'!
interpretor
	^interpretor! !

!PlatypusExpressInterpretorStackValue methodsFor: 'accessing' stamp: 'apl 2/22/2006 17:49'!
interpretor: anObject
	interpretor := anObject! !

!PlatypusExpressInterpretorStackValue methodsFor: 'accessing' stamp: 'apl 2/22/2006 17:49'!
val
	^ self subclassResponsibility ! !

!PlatypusExpressInterpretorStackValue methodsFor: 'copying' stamp: 'AlainPlantec 10/7/2010 15:52'!
veryDeepCopy
	| n |
	n := self copy.
	^ n! !

Object subclass: #PlatypusExpressInterpretorWrapper
	instanceVariableNames: 'myInterpreter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-interpreter'!

!PlatypusExpressInterpretorWrapper class methodsFor: 'instance creation' stamp: 'apl 1/28/2006 10:12'!
interpreter: anExpressInterpreter 
	^ self new myInterpreter: anExpressInterpreter! !

!PlatypusExpressInterpretorWrapper methodsFor: 'platypus interpreting' stamp: ''!
EvaluatePlatypusInterpreterNativeCode
	^ [| t1 t2 |
	t1 := MultiByteFileStream fullName: self filename val.
	t2 := MultiByteFileStream forceNewFileNamed: t1.
	t2 nextPutAll: self contents asClearText.
	t2 close] value! !

!PlatypusExpressInterpretorWrapper methodsFor: 'error handling' stamp: 'AlainPlantec 6/15/2012 11:34'!
doesNotUnderstand: message 
	| v |
	message arguments isEmpty
		ifTrue: [(v := myInterpreter valueOf: message selector)
				ifNotNil: [^ v]]
		ifFalse: [message arguments size = 1
				ifTrue: [(myInterpreter
							dataNamed: (message selector copyFrom: 1 to: message selector size - 1)
							value: (PlatypusExpressInterpretorStackVar val: message arguments first interpretor: myInterpreter))
						ifTrue: [^ self]
						ifFalse: [^myInterpreter  perform: message selector withArguments: message arguments]]].
	^ myInterpreter  perform: message selector withArguments: message arguments! !

!PlatypusExpressInterpretorWrapper methodsFor: 'accessing' stamp: 'apl 2/2/2006 16:36'!
myContext
	^ myInterpreter! !

!PlatypusExpressInterpretorWrapper methodsFor: 'accessing' stamp: 'apl 1/28/2006 10:27'!
myInterpreter: aPlatypusExpressInterpreter 
	myInterpreter := aPlatypusExpressInterpreter! !

Object subclass: #PlatypusExpressParsedMetaConcept
	instanceVariableNames: 'ident metaExpression'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-parsers'!

!PlatypusExpressParsedMetaConcept class methodsFor: 'instance creation' stamp: 'apl 3/29/2006 17:17'!
ident: anIdent
	^ self ident: anIdent metaExpression: nil! !

!PlatypusExpressParsedMetaConcept class methodsFor: 'instance creation' stamp: 'apl 3/29/2006 17:18'!
ident: anIdent metaExpression: aMetaExpression
	^ self new ident: anIdent metaExpression: aMetaExpression! !

!PlatypusExpressParsedMetaConcept methodsFor: 'accessing' stamp: 'apl 3/29/2006 17:14'!
ident
	^ident! !

!PlatypusExpressParsedMetaConcept methodsFor: 'accessing' stamp: 'apl 3/29/2006 17:14'!
ident: anObject
	ident := anObject! !

!PlatypusExpressParsedMetaConcept methodsFor: 'accessing' stamp: 'apl 3/29/2006 17:18'!
ident: anIdent metaExpression: aMetaExpression
	metaExpression := aMetaExpression.
	ident := anIdent! !

!PlatypusExpressParsedMetaConcept methodsFor: 'accessing' stamp: 'apl 3/29/2006 17:14'!
metaExpression
	^metaExpression! !

!PlatypusExpressParsedMetaConcept methodsFor: 'accessing' stamp: 'apl 3/29/2006 17:14'!
metaExpression: anObject
	metaExpression := anObject! !

!PlatypusExpressParsedMetaConcept methodsFor: 'accessing' stamp: 'apl 3/15/2007 10:20'!
updateDictionaryInstanceName: aDictionaryInstance 
	aDictionaryInstance name: self ident.
	self metaExpression 
		ifNotNil: [aDictionaryInstance metaExpression: self metaExpression]! !

Object subclass: #PlatypusExpressParserContext
	instanceVariableNames: 'namedTypesIndex identifiersIndex ownerContext contextInstance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-parsers'!

!PlatypusExpressParserContext class methodsFor: 'instance creation' stamp: 'apl 6/21/2003 11:01'!
contextInstance: anPltDictionaryInstance 
^ self contextInstance: anPltDictionaryInstance owner: nil 
! !

!PlatypusExpressParserContext class methodsFor: 'instance creation' stamp: 'apl 5/17/2004 09:30'!
contextInstance: aPltDictionaryInstance owner: anotherContextOrNil 
	| context |
	context := self new.
	context ownerContext: anotherContextOrNil.
	context existingContextInstance: aPltDictionaryInstance.
	^ context! !

!PlatypusExpressParserContext methodsFor: 'accessing' stamp: 'apl 3/5/2003 17:05'!
contextInstance
	^ contextInstance! !

!PlatypusExpressParserContext methodsFor: 'accessing' stamp: 'AlainPlantec 10/7/2010 15:53'!
contextInstance: anObject 
	contextInstance := anObject! !

!PlatypusExpressParserContext methodsFor: 'initialize/release' stamp: 'apl 6/3/2005 16:48'!
destroy
	namedTypesIndex := nil.
	identifiersIndex := nil.
	ownerContext := nil.
	contextInstance := nil.
	super destroy! !

!PlatypusExpressParserContext methodsFor: 'accessing' stamp: 'apl 2/23/2005 22:32'!
existingContextInstance: anObject 
	self contextInstance: anObject.
	anObject isPltSchemaDefinition
		ifTrue: [anObject identifiersCache
				ifNotNil: [anObject identifiersCache
						keysAndValuesDo: [:k :v | self identifiersIndex at: k put: v]].
			anObject namedTypesCache
				ifNotNil: [anObject namedTypesCache
						keysAndValuesDo: [:k :v | self namedTypesIndex at: k put: v]]]! !

!PlatypusExpressParserContext methodsFor: 'initialize/release' stamp: 'apl 2/23/2005 21:48'!
flushCaches
	self contextInstance isPltContextDefinition
		ifTrue: [self contextInstance namedTypesCache isNil
				ifTrue: [self contextInstance namedTypesCache: self namedTypesIndex]
				ifFalse: [self namedTypesIndex
						associationsDo: [:assoc | self contextInstance namedTypesCache add: assoc]].
			self contextInstance identifiersCache isNil
				ifTrue: [self contextInstance identifiersCache: self identifiersIndex]
				ifFalse: [self identifiersIndex
						associationsDo: [:assoc | self contextInstance identifiersCache add: assoc]]]! !

!PlatypusExpressParserContext methodsFor: 'accessing' stamp: 'apl 6/21/2003 11:11'!
identifiersIndex
	^ identifiersIndex! !

!PlatypusExpressParserContext methodsFor: 'accessing' stamp: 'apl 6/21/2003 11:22'!
identifiersIndex: aDictionary
	identifiersIndex := aDictionary! !

!PlatypusExpressParserContext methodsFor: 'initialize/release' stamp: 'apl 5/15/2004 09:31'!
initialize
	super initialize.
! !

!PlatypusExpressParserContext methodsFor: 'searching' stamp: 'AlainPlantec 10/7/2010 15:53'!
lookUpIdentifierBN: anIdent 
	| availables |
	availables := self identifiersIndex
				at: anIdent asUppercase
				ifAbsent: [].
	^ availables
		ifNotNil: [availables anyOne]! !

!PlatypusExpressParserContext methodsFor: 'searching' stamp: 'AlainPlantec 10/7/2010 15:53'!
lookUpNamedTypeBN: anIdent 
	| availables |
	availables := self namedTypesIndex
				at: anIdent asUppercase
				ifAbsent: [].

	^ availables ifNotNil: [availables anyOne]! !

!PlatypusExpressParserContext methodsFor: 'accessing' stamp: 'apl 6/21/2003 11:11'!
namedTypesIndex
	^ namedTypesIndex! !

!PlatypusExpressParserContext methodsFor: 'accessing' stamp: 'apl 6/21/2003 11:22'!
namedTypesIndex: aDictionary
	namedTypesIndex := aDictionary! !

!PlatypusExpressParserContext methodsFor: 'accessing' stamp: 'apl 6/21/2003 10:58'!
ownerContext
	^ ownerContext! !

!PlatypusExpressParserContext methodsFor: 'accessing' stamp: 'AlainPlantec 10/7/2010 15:54'!
ownerContext: anotherContextOrNil 
	ownerContext := anotherContextOrNil.
	self identifiersIndex: Dictionary new.
	self namedTypesIndex: Dictionary new.
	! !

!PlatypusExpressParserContext methodsFor: 'accessing' stamp: 'apl 2/10/2006 16:10'!
registerIdentifier: data named: anIdent 
	| key set |
	key := anIdent asUppercase.
	set := self identifiersIndex at: key ifAbsentPut: Set new.
	set at: key add: data! !

!PlatypusExpressParserContext methodsFor: 'accessing' stamp: 'apl 2/10/2006 16:11'!
registerNamedType: data named: anIdent 
	| key set |
	key := anIdent asUppercase.
	set := self namedTypesIndex at: key ifAbsentPut: Set new.
	set at: key add: data! !

Object subclass: #PlatypusExpressParserResult
	instanceVariableNames: 'tokenList metaData users'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-parsers'!

!PlatypusExpressParserResult class methodsFor: 'instance creation' stamp: 'apl 3/11/2003 23:06'!
tokenList: aTokenList metaData: aMetaDataInstance
	^ self new tokenList: aTokenList metaData: aMetaDataInstance! !

!PlatypusExpressParserResult methodsFor: 'accessing' stamp: 'apl 3/11/2003 23:06'!
metaData
	^ metaData! !

!PlatypusExpressParserResult methodsFor: 'accessing' stamp: 'apl 2/27/2003 09:58'!
metaData: anObject
	metaData := anObject! !

!PlatypusExpressParserResult methodsFor: 'accessing' stamp: 'apl 2/27/2003 09:51'!
tokenList
	^tokenList! !

!PlatypusExpressParserResult methodsFor: 'accessing' stamp: 'apl 2/27/2003 09:51'!
tokenList: anObject
	tokenList := anObject! !

!PlatypusExpressParserResult methodsFor: 'accessing' stamp: 'apl 9/26/2003 23:21'!
tokenList: aTokenList metaData: aMetaDataInstance 
	self tokenList: aTokenList.
	self metaData: aMetaDataInstance.
! !

!PlatypusExpressParserResult methodsFor: 'accessing' stamp: 'AlainPlantec 5/21/2012 13:56'!
users
	^ users ! !

!PlatypusExpressParserResult methodsFor: 'accessing' stamp: 'AlainPlantec 5/21/2012 13:56'!
users: aListOfSchemaInstanceReferences
	users := aListOfSchemaInstanceReferences! !

Object subclass: #PlatypusModelContentsMetaDefinitionsBuilder
	instanceVariableNames: 'checkingPass rulesIndex interpreter modelContents toBeRecorded replaceIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-visitors'!

!PlatypusModelContentsMetaDefinitionsBuilder methodsFor: 'computing' stamp: 'AlainPlantec 5/11/2012 17:31'!
acceptModelContents: e 
	modelContents := e.
	interpreter modelContents: e.
	checkingPass := #recording.
	'Storing rules'
		displayProgressAt: Sensor cursorPoint
		from: 1
		to: e dataInstances size
		during: [:bar | e dataInstances
				withIndexDo: [:d :idx | 
					bar value: idx.
					self storeRule: d]].
	checkingPass := #resolving.
	'Building mapping'
		displayProgressAt: Sensor cursorPoint
		from: 1
		to: e dataInstances size
		during: [:bar | e dataInstances
				withIndexDo: [:d :idx | 
					bar value: idx.
					self buildMappingFor: d]].
	'Computing mapping'
		displayProgressAt: Sensor cursorPoint
		from: 1
		to: e dataInstances size
		during: [:bar | e dataInstances
				withIndexDo: [:d :idx | 
					bar value: idx.
					self computeMappingFor: d]].
	(PlatypusModelContentsRecorder modelContents: modelContents)
		checksAll: toBeRecorded.
	modelContents replaceIndex: replaceIndex.
	PlatypusInstanceDoer new 
		do: [:c :p | ((c at: p) isPltGenericInstance) ifTrue: [(c at: p) markAsPersistent]] 
		from: replaceIndex values 
		in: modelContents.
	! !

!PlatypusModelContentsMetaDefinitionsBuilder methodsFor: 'computing' stamp: 'AlainPlantec 5/4/2012 18:58'!
buildMappingFor: e
	| instDefinition metaExpression metaCondition evalResult |
	instDefinition := e definition ref.
	((instDefinition inheritsFromEntityDefinitionNamed: PltNamedType platypusMetaData name) or: [
	(instDefinition inheritsFromEntityDefinitionNamed: PltContextDefinition platypusMetaData name) or: [
	(instDefinition inheritsFromEntityDefinitionNamed: PltSchemaDefinition platypusMetaData name) or: [
	instDefinition inheritsFromEntityDefinitionNamed: PltAttribute platypusMetaData name]]])
		ifFalse: [^ self].
	interpreter
		asValOfSelf: e
		while: [rulesIndex keysAndValuesDo: [:currRule :metaAssoc |
				metaCondition := metaAssoc key.
				metaExpression := metaAssoc value key.
				evalResult := interpreter
					compute: metaCondition
						in: modelContents owner 
						to: e
						notifying: nil
						ifFail: [self halt]
						logged: false. 
				evalResult val isPltTrueConstant
					ifTrue: [	| ref newInst |
						ref := PltEntityDefinitionReference ref: PltMetaMappingDefinition platypusMetaData.
						newInst := (PltInternalRepresentation new) definition: ref; parameters: {e. metaAssoc value value copy}.
						toBeRecorded add: newInst]]].
! !

!PlatypusModelContentsMetaDefinitionsBuilder methodsFor: 'computing' stamp: 'AlainPlantec 5/8/2012 17:52'!
computeMappingFor: e 
	| instDefinition key |
	instDefinition := e definition.
	key := PltMetaMappingDefinition platypusMetaData name asUppercase.
	interpreter
		asValOfSelf: e
		while: [(e isPltInternalRepresentation
					and: [e definition name asUppercase = key])
				ifTrue: [| metaExpression metaCondition evalResult newInst |
					metaExpression := e valueOfExplicitAttributeNamed: 'expression'.
					instDefinition := e valueOfExplicitAttributeNamed: 'definition'.
					evalResult := interpreter
								evaluate: metaExpression val
								in: modelContents owner
								to: instDefinition
								notifying: nil
								ifFail: [self halt].
					newInst := evalResult val.
					instDefinition addRecordsToExternalRepresentation: newInst.
					toBeRecorded add: newInst.
					replaceIndex at: instDefinition put: newInst]]! !

!PlatypusModelContentsMetaDefinitionsBuilder methodsFor: 'initialize-release' stamp: 'AlainPlantec 5/5/2012 02:00'!
initialize
	super initialize.
	rulesIndex := IdentityDictionary new.
	interpreter := PlatypusExpressInterpretor new.
	toBeRecorded := OrderedCollection new.
	replaceIndex := IdentityDictionary new
! !

!PlatypusModelContentsMetaDefinitionsBuilder methodsFor: 'computing' stamp: 'AlainPlantec 1/21/2011 22:13'!
storeRule: e 
	| key |
	key := PltMetaMappingRule platypusMetaData name asUppercase.
	(e isPltInternalRepresentation
			and: [e definition name asUppercase = key])
		ifTrue: [| metaExpression metaCondition expression condition |
			expression := e valueOfExplicitAttributeNamed: 'expression'.
			condition := e valueOfExplicitAttributeNamed: 'condition'.
			metaCondition := interpreter
						parse: condition val
						in: modelContents owner
						notifying: nil  
						ifFail: [self halt].
			metaExpression := interpreter
						parse: expression val
						in: modelContents owner
						notifying: nil
						ifFail: [self halt].
			rulesIndex at: e put: metaCondition -> (metaExpression -> expression)]! !

Object subclass: #PlatypusNamesBuilder
	instanceVariableNames: 'classPrefix systemCategoryPrefix rootClassName rootClassSystemCategory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-translater-private'!

!PlatypusNamesBuilder class methodsFor: 'utilities' stamp: 'apl 1/26/2007 11:22'!
capitalize: aString first: firstCapitalized 
	^ aString capitalizeFirst: firstCapitalized! !

!PlatypusNamesBuilder class methodsFor: 'instance creation' stamp: 'apl 12/7/2006 17:30'!
classPrefix: aClassPrefix systemCategoryPrefix: aSysCatPrefix rootClassName: aRootClassName  rootClassSystemCategory: aRootClassSystemCategory 
	^ self new 
		classPrefix: aClassPrefix
		systemCategoryPrefix: aSysCatPrefix
		rootClassName: aRootClassName
		rootClassSystemCategory: aRootClassSystemCategory! !

!PlatypusNamesBuilder class methodsFor: 'instance creation' stamp: 'AlainPlantec 4/27/2012 09:23'!
default
	^ self prefixedBy: #PTs 
	! !

!PlatypusNamesBuilder class methodsFor: 'instance creation' stamp: 'apl 1/29/2007 14:46'!
meta
	^ self 
		classPrefix: #Plt
		systemCategoryPrefix: #Platypus
		rootClassName: #PltEntityInstance
		rootClassSystemCategory: #'Platypus-PlatypusDictionarySchemaSchema'! !

!PlatypusNamesBuilder class methodsFor: 'instance creation' stamp: 'apl 2/15/2007 17:15'!
prefixedBy: aPrefix 
	^ self
		classPrefix: aPrefix
		systemCategoryPrefix: aPrefix
		rootClassName: aPrefix , 'CoreEntity'
		rootClassSystemCategory: aPrefix , '-CoreEntity'! !

!PlatypusNamesBuilder class methodsFor: 'accessing' stamp: 'apl 2/26/2005 16:39'!
querySymbols
	^ #(#argName #smalltalkType #smalltalkInitializingExpression)! !

!PlatypusNamesBuilder class methodsFor: 'utilities' stamp: 'apl 3/9/2005 18:36'!
uncapitalize: aString 
	| instr outstr resString curr |
	instr := ReadStream on: aString.
	outstr := WriteStream on: String new.
	outstr nextPut: instr next asLowercase.
	[instr atEnd]
		whileFalse: [(curr := instr next) isUppercase
				ifTrue: [outstr nextPut: $_;
						 nextPut: curr asLowercase]
				ifFalse: [outstr nextPut: curr asLowercase]].
	resString := outstr contents.
	^ resString! !

!PlatypusNamesBuilder methodsFor: 'naming' stamp: 'apl 5/25/2005 21:57'!
abstractVisitorClassName
	^ systemCategoryPrefix, 'AbstractVisitor'! !

!PlatypusNamesBuilder methodsFor: 'accessing' stamp: 'apl 3/14/2005 23:04'!
allClassInstVarNamesFromEntity: e 
	| cls nativesClassInstVar |
	(cls := self classFromMetaData: e)
		ifNil: [nativesClassInstVar := #()]
		ifNotNil: [nativesClassInstVar := cls class instVarNames].
	^ nativesClassInstVar! !

!PlatypusNamesBuilder methodsFor: 'accessing' stamp: 'apl 3/14/2005 23:04'!
allClassVarNamesFromEntity: e 
	| cls nativesClassVar |
	(cls := self classFromMetaData: e)
		ifNil: [nativesClassVar := #()]
		ifNotNil: [nativesClassVar := cls classVarNames].
	^ nativesClassVar! !

!PlatypusNamesBuilder methodsFor: 'accessing' stamp: 'apl 1/31/2007 15:20'!
allInstVarNamesFromEntity: e 
	| nativesInstVar cls inherited instVarNames locals |
	inherited := Set new.
	locals := Set new.
	e
		inheritedExplicitAttributesDo: [:attr | attr redeclaring
				ifNil: [inherited
						add: (attr instVarNameFromNamesBuilder: attr owner namesBuilder)]].
	e
		explicitAttributesDo: [:attr | attr redeclaring
				ifNil: [locals
						add: (attr instVarNameFromNamesBuilder: self)]].
	(cls := self classFromMetaData: e)
		ifNil: [nativesInstVar := #()]
		ifNotNil: [nativesInstVar := cls instVarNames].
	instVarNames := nativesInstVar asSet.
	instVarNames removeAllFoundIn: inherited.
	instVarNames addAll: locals.
	^ instVarNames! !

!PlatypusNamesBuilder methodsFor: 'accessing' stamp: 'apl 1/31/2007 15:19'!
allReservedNamesFromEntity: e 
	| nativesInstVar cls inherited instVarNames |
	inherited := Set new.
	e
		inheritedExplicitAttributesDo: [:attr | attr redeclaring
				ifNil: [inherited
						add: (attr instVarNameFromNamesBuilder: attr owner namesBuilder)]].
	(cls := self classFromMetaData: e)
		ifNil: [nativesInstVar := #()]
		ifNotNil: [nativesInstVar := cls instVarNames].
	instVarNames := nativesInstVar asSet.
	instVarNames addAll: inherited.
	^ instVarNames! !

!PlatypusNamesBuilder methodsFor: 'querying' stamp: 'apl 1/20/2007 10:03'!
argNameFor: aMetaData 
	^ (PlatypusSmartNamer query: #argName namesBuilder: self) acceptTry: aMetaData! !

!PlatypusNamesBuilder methodsFor: 'querying' stamp: 'apl 3/9/2005 11:37'!
argNameFor: aMetaData scopeMetaData: aScope 
	^ self argNameFor: aMetaData scopeMetaData: aScope reservedNames: OrderedCollection new
	! !

!PlatypusNamesBuilder methodsFor: 'querying' stamp: 'apl 1/20/2007 10:05'!
argNameFor: aMetaData scopeMetaData: aScope reservedNames: aListOfString 
	^ self 
		localVarName: (self argNameFor: aMetaData)
		inScope: aScope
		reservedNames: aListOfString! !

!PlatypusNamesBuilder methodsFor: 'querying' stamp: 'apl 3/4/2005 11:36'!
argNameSuffixFor: aMetaData
	| argname |
	argname := self argNameFor: aMetaData.
	argname size = 1
		ifTrue: [^ argname].
	argname first = $a
		ifTrue: [argname := argname copyFrom: 2 to: argname size].
	argname size = 1
		ifTrue: [^ argname].
	argname first = $n
		ifTrue: [argname := argname copyFrom: 2 to: argname size].
	^ argname! !

!PlatypusNamesBuilder methodsFor: 'utilities' stamp: 'apl 2/27/2005 22:24'!
capitalize: aString first: firstCapitalized 
	^ self class capitalize: aString first: firstCapitalized! !

!PlatypusNamesBuilder methodsFor: 'generated class accessing' stamp: 'AlainPlantec 7/14/2011 16:57'!
classFromMetaData: aMetaData 
	^ PlatypusPharoSmalltalk
		at: (aMetaData generatedClassNameFromNamesBuilder: self) asSymbol
		ifAbsent: []! !

!PlatypusNamesBuilder methodsFor: 'accessing' stamp: 'apl 2/26/2005 17:03'!
classPrefix
	^ classPrefix
! !

!PlatypusNamesBuilder methodsFor: 'accessing' stamp: 'apl 2/26/2005 16:39'!
classPrefix: anObject 
	classPrefix := anObject! !

!PlatypusNamesBuilder methodsFor: 'accessing' stamp: 'apl 12/7/2006 17:30'!
classPrefix: aClassPrefix systemCategoryPrefix: aSysCatPrefix rootClassName: aRootClassName rootClassSystemCategory: aRootClassSystemCategory 
	self classPrefix: aClassPrefix.
	self systemCategoryPrefix: aSysCatPrefix.
	self rootClassName: aRootClassName.
	self rootClassSystemCategory: aRootClassSystemCategory! !

!PlatypusNamesBuilder methodsFor: 'naming' stamp: 'apl 3/3/2005 12:32'!
contextArgNameFromAttribute: e 
	^ self contextArgNameFromEntity: e owner! !

!PlatypusNamesBuilder methodsFor: 'naming' stamp: 'apl 3/4/2005 12:26'!
contextArgNameFromEntity: e 
	^ self localVarName: 'aContext' inScope: e! !

!PlatypusNamesBuilder methodsFor: 'naming' stamp: 'apl 5/15/2005 00:47'!
contextArgNameFromQualifier: e 
	| parent |
	^ (parent := self parentAttributeOf: e) ifNotNil: [
	self contextArgNameFromAttribute: (parent)]! !

!PlatypusNamesBuilder methodsFor: 'accessing' stamp: 'apl 5/29/2005 23:54'!
functionInvokingFrom: anAlgorithm 
	| code selectorParts |
	code := WriteStream on: String new.
	selectorParts := self 
				normalizedAlgorithmFormalParametersInfosFrom: anAlgorithm.
	selectorParts do: 
			[:sp | 
			code nextPutAll: sp first , ': '.
			code nextPutAll: sp second]
		separatedBy: [code nextPutAll: ' '].
	^code contents! !

!PlatypusNamesBuilder methodsFor: 'naming' stamp: 'apl 1/18/2007 10:19'!
localCopyMethodNameFromEntity: e
	^ (self normalizedNameFrom: e name first: false), 'CopyTo:'! !

!PlatypusNamesBuilder methodsFor: 'naming' stamp: 'apl 1/18/2007 10:44'!
localFromValuesMethodNameFromEntity: e 
	^ (self normalizedNameFrom: e name first: false) , 'FromValues:'! !

!PlatypusNamesBuilder methodsFor: 'naming' stamp: 'apl 1/18/2007 10:44'!
localToValuesMethodNameFromEntity: e 
	^ (self normalizedNameFrom: e name first: false) , 'ToValues:'! !

!PlatypusNamesBuilder methodsFor: 'naming' stamp: 'apl 3/14/2005 14:37'!
localVarName: aPrefix inScope: aScopeMetaData 
	^ self
		localVarName: aPrefix
		inScope: aScopeMetaData
		reservedNames: OrderedCollection new! !

!PlatypusNamesBuilder methodsFor: 'naming' stamp: 'apl 1/31/2007 15:20'!
localVarName: aPrefix inScope: aScopeMetaData reservedNames: aListOfString 
	| allInstVars |
	allInstVars := self allReservedNamesFromEntity: aScopeMetaData.
	aListOfString addAll: allInstVars.
	^ self localVarName: aPrefix reservedNames: aListOfString! !

!PlatypusNamesBuilder methodsFor: 'naming' stamp: 'apl 3/15/2005 14:25'!
localVarName: aPrefix reservedNames: aListOfString 
	| candidat cpt |
	candidat := aPrefix asSymbol.
	cpt := 0.
	[aListOfString includes: candidat]
		whileTrue: [cpt := cpt + 1.
			candidat := (aPrefix , cpt asString) asSymbol].
	aListOfString add: candidat.
	^ candidat! !

!PlatypusNamesBuilder methodsFor: 'naming' stamp: 'apl 2/27/2005 21:57'!
methodCategoryPrefix
	^ 'platypus-generated'! !

!PlatypusNamesBuilder methodsFor: 'utilities' stamp: 'apl 3/26/2005 13:25'!
nameWithUnderbar: aName 
	1 to: aName size do: [:pos | ((aName at: pos) = $_) ifTrue: [^true]].
	^false! !

!PlatypusNamesBuilder methodsFor: 'naming basic' stamp: 'apl 4/19/2006 19:02'!
normalizedAlgorithmFormalParametersInfosFrom: aFunctionDeclaration 
	| selp parts reserved arg |
	parts := OrderedCollection new.
	reserved := Set new.
	aFunctionDeclaration formalParameters copy
		do: [:fps | 
			selp := self normalizedVarNameFrom: fps name.
			arg := self
						localVarName: (self argNameFor: fps domain)
						reservedNames: reserved.
			parts add: (Array with: selp with: arg with: fps byCopy with:fps domain)].
	^ parts! !

!PlatypusNamesBuilder methodsFor: 'naming basic' stamp: 'apl 4/19/2006 19:02'!
normalizedAlgorithmLocalVariablesInfosFrom: anAlgorithm 
	| selp parts reserved arg |
	parts := OrderedCollection new.
	reserved := Set new.
	anAlgorithm locals copy
		do: [:fps | 
			selp := self normalizedVarNameFrom: fps name.
			arg := self
						localVarName: (self argNameFor: fps domain)
						reservedNames: reserved.
			parts add: (Array with: selp with:  arg with: true with:  fps domain)].
	^ parts! !

!PlatypusNamesBuilder methodsFor: 'naming basic' stamp: 'apl 3/14/2005 14:47'!
normalizedClassNameFrom: aName 
	^ self normalizedClassNameFrom: aName suffix: ''! !

!PlatypusNamesBuilder methodsFor: 'naming basic' stamp: 'AlainPlantec 10/26/2011 20:50'!
normalizedClassNameFrom: aName suffix: aSuffix
	^self classPrefix ,(self normalizedNameFrom: aName first: true) , aSuffix! !

!PlatypusNamesBuilder methodsFor: 'naming basic' stamp: 'apl 6/28/2005 19:44'!
normalizedGetSelectorFrom: aName prefix: aPrefix suffix: aSuffix 
	^ (aPrefix
		ifNil: [(self normalizedVarNameFrom: aName)
				, aSuffix]
		ifNotNil: [aPrefix
				, (self normalizedVarSuffixFrom: aName) , aSuffix]) asSymbol! !

!PlatypusNamesBuilder methodsFor: 'naming basic' stamp: 'apl 3/14/2005 09:37'!
normalizedGetSelectorFrom: aName suffix: aSuffix 
	^ self normalizedGetSelectorFrom: aName prefix: nil suffix: aSuffix ! !

!PlatypusNamesBuilder methodsFor: 'naming basic' stamp: 'apl 3/14/2005 10:10'!
normalizedGetSelectorWithArgFrom: aName prefix: aPrefix suffix: aSuffix 
	^ (self normalizedGetSelectorFrom: aName prefix: aPrefix suffix: aSuffix), ':' ! !

!PlatypusNamesBuilder methodsFor: 'naming basic' stamp: 'apl 12/16/2006 00:30'!
normalizedMethodCategory: aName className: aClassName meta: isMeta 
	aName first = $* 
		ifTrue: 
			[
	^ String cr , '!!' , aClassName , (isMeta ifTrue: [' class'] ifFalse: ['']) 
		, ' methodsFor: ''' 
		
		, aName , '''!!']
	ifFalse: [
			^ String cr , '!!' , aClassName , (isMeta ifTrue: [' class'] ifFalse: ['']) 
		, ' methodsFor: ''' 
		, self methodCategoryPrefix , '-' 
		, aName , '''!!']! !

!PlatypusNamesBuilder methodsFor: 'naming basic' stamp: 'gr 2/14/2006 13:00'!
normalizedMethodCategory: aName nameSpace: aNameSpace className: aClassName meta: isMeta 
	^ String cr , '!!' , aNameSpace, '.', aClassName
		, (isMeta
				ifTrue: [' class']
				ifFalse: ['']) , ' methodsFor: ''' , self methodCategoryPrefix , '-' , aName , '''!!'! !

!PlatypusNamesBuilder methodsFor: 'naming basic' stamp: 'apl 3/26/2005 13:25'!
normalizedNameFrom: aName first: firstCapitalized 
	^(self nameWithUnderbar: aName ) 
		ifTrue: [self capitalize: aName first: firstCapitalized]
		ifFalse: [aName asIdentifier: firstCapitalized]! !

!PlatypusNamesBuilder methodsFor: 'naming basic' stamp: 'gr 2/21/2006 15:14'!
normalizedNameSpaceFrom: aName suffix: aSuffix 
	^ ((self capitalize: aName first: true)
				asIdentifier: true) , aSuffix! !

!PlatypusNamesBuilder methodsFor: 'naming basic' stamp: 'apl 6/28/2005 19:43'!
normalizedSetSelectorFrom: aName prefix: aPrefix suffix: aSuffix 
	^ (aPrefix
		ifNil: [(self normalizedVarNameFrom: aName)
				, aSuffix , ':']
		ifNotNil: [aPrefix
				, (self normalizedVarSuffixFrom: aName) , aSuffix , ':']) asSymbol! !

!PlatypusNamesBuilder methodsFor: 'naming basic' stamp: 'apl 3/14/2005 09:38'!
normalizedSetSelectorFrom: aName suffix: aSuffix 
 ^ self normalizedSetSelectorFrom: aName prefix: nil suffix: aSuffix 
	! !

!PlatypusNamesBuilder methodsFor: 'naming basic' stamp: 'apl 3/14/2005 10:37'!
normalizedSystemCategoryNameFrom: aName suffix: aSuffix 
	^ self systemCategoryPrefix , '-'
		, ((self capitalize: aName first: true)
				asIdentifier: true) , aSuffix! !

!PlatypusNamesBuilder methodsFor: 'naming basic' stamp: 'apl 3/26/2005 12:16'!
normalizedVarNameFrom: aName 
	^(self normalizedNameFrom: aName first: false) 
! !

!PlatypusNamesBuilder methodsFor: 'naming basic' stamp: 'apl 4/20/2006 15:42'!
normalizedVarSuffixFrom: aName 
	| strim |
	aName size > 1
		ifTrue: [
			strim := WriteStream on: String new.
			strim nextPut: aName first asUppercase.
			strim nextPutAll: (self
						normalizedVarNameFrom: (aName copyFrom: 2 to: aName size)).
			^ strim contents].
		^ aName asUppercase! !

!PlatypusNamesBuilder methodsFor: 'utilities' stamp: 'apl 5/17/2005 08:51'!
parentAttributeOf: aMetaData 
	| md |
	md := aMetaData.
	[md isPltAttribute] whileFalse: 
			[(md respondsTo: #owner) ifFalse: [^nil].
			md owner isNil ifTrue: [^ nil].
			md := md owner].
	^md! !

!PlatypusNamesBuilder methodsFor: 'accessing' stamp: 'apl 2/26/2005 16:39'!
querySymbols
	^ self class querySymbols! !

!PlatypusNamesBuilder methodsFor: 'naming' stamp: 'apl 2/28/2006 10:18'!
receiverArgNameFromAttribute: e 
	^ self receiverArgNameFromEntity: e owner! !

!PlatypusNamesBuilder methodsFor: 'naming' stamp: 'apl 2/28/2006 10:18'!
receiverArgNameFromEntity: e 
	^ self localVarName: 'aReceiver' inScope: e! !

!PlatypusNamesBuilder methodsFor: 'accessing' stamp: 'apl 12/7/2006 12:44'!
rootClassName
	^rootClassName! !

!PlatypusNamesBuilder methodsFor: 'accessing' stamp: 'apl 12/7/2006 12:44'!
rootClassName: anObject
	rootClassName := anObject! !

!PlatypusNamesBuilder methodsFor: 'accessing' stamp: 'apl 12/7/2006 12:44'!
rootClassSystemCategory
	^rootClassSystemCategory! !

!PlatypusNamesBuilder methodsFor: 'accessing' stamp: 'apl 12/7/2006 12:44'!
rootClassSystemCategory: anObject
	rootClassSystemCategory := anObject! !

!PlatypusNamesBuilder methodsFor: 'querying' stamp: 'apl 1/20/2007 10:05'!
smalltalkInitializingExpressionOf: aMetaData 
	^ (PlatypusSmartNamer query: #smalltalkInitializingExpression namesBuilder: self) 
		acceptTry: aMetaData	! !

!PlatypusNamesBuilder methodsFor: 'querying' stamp: 'apl 1/20/2007 10:06'!
smalltalkTypeOf: aMetaData 
^ (PlatypusSmartNamer query: #smalltalkType
		namesBuilder: self) acceptTry: aMetaData
! !

!PlatypusNamesBuilder methodsFor: 'accessing' stamp: 'apl 2/26/2005 17:04'!
systemCategoryPrefix
	^ systemCategoryPrefix
! !

!PlatypusNamesBuilder methodsFor: 'accessing' stamp: 'apl 2/26/2005 16:39'!
systemCategoryPrefix: anObject 
	systemCategoryPrefix := anObject! !

!PlatypusNamesBuilder methodsFor: 'utilities' stamp: 'apl 3/9/2005 18:33'!
uncapitalize: aString
	^ self class uncapitalize: aString! !

!PlatypusNamesBuilder methodsFor: 'naming' stamp: 'apl 3/16/2005 00:55'!
uniqueBlockVarName: aPrefix owner: aMetaData 
	^ aPrefix , aMetaData identityHash asString! !

Object subclass: #PlatypusNativeCodeInterpretor
	instanceVariableNames: 'receiver requestor source preparsed replacementPositions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-interpreter'!

!PlatypusNativeCodeInterpretor class methodsFor: 'private' stamp: 'AlainPlantec 1/11/2010 18:08'!
methodFrom: textOrStream class: aClass requestor: aRequestor ifFail: failBlock 
	| methodNode method compiler |
	compiler := self evaluatorClass new.
	compiler
		from: textOrStream
		class: aClass
		context: nil
		notifying: aRequestor.
	methodNode := compiler
				translate: textOrStream
				noPattern: true
				ifFail: [^ failBlock value].
	method := methodNode generate.
	compiler interactive
		ifTrue: [method := method copyWithTempNames: methodNode tempNames].
	^ method! !

!PlatypusNativeCodeInterpretor methodsFor: 'requestor error notification' stamp: 'AlainPlantec 10/7/2010 15:58'!
correctFrom: begin to: end with: correctWord 
	| offset |
	offset := self notificationOffsetAt: begin.
	begin > source size
		ifTrue: [begin < offset 
					ifTrue: [requestor
					correctFrom: offset + 3
					to: end + (offset - begin) + 3
					with: correctWord]
					ifFalse: [requestor
					correctFrom: begin
					to: end 
					with: correctWord]]
		ifFalse: [requestor
				correctFrom: begin + offset + 1
				to: end + offset + 1
				with: correctWord]! !

!PlatypusNativeCodeInterpretor methodsFor: 'requestor error notification' stamp: 'apl 12/18/2003 23:34'!
deselect
	^ requestor deselect! !

!PlatypusNativeCodeInterpretor methodsFor: 'interpreting' stamp: 'apl 2/10/2006 14:11'!
evaluate: e interpretor: anInterpretor requestor: aRequestor 
	| method |
	receiver := PlatypusExpressInterpretorWrapper interpreter: anInterpretor.
	(method := e cachedMethod)
		ifNil: [replacementPositions := OrderedCollection new.
			source := e code.
			self requestor: aRequestor.
			self preparse.
			method := self class
						methodFrom: preparsed
						class: receiver class
						requestor: aRequestor
						ifFail: [self halt].
			e cachedMethod: method].
	^ self evaluateMethod: method! !

!PlatypusNativeCodeInterpretor methodsFor: 'interpreting' stamp: 'apl 2/10/2006 14:00'!
evaluateMethod: aMethod 
	| selector |
	selector := #EvaluatePlatypusInterpreterNativeCode.
	receiver class addSelectorSilently: selector withMethod: aMethod.
	SystemChangeNotifier uniqueInstance
		doSilently: [self class organization classify: selector under: #'platypus interpreting'].
	^ receiver EvaluatePlatypusInterpreterNativeCode! !

!PlatypusNativeCodeInterpretor methodsFor: 'requestor error notification' stamp: 'apl 3/18/2004 23:38'!
notificationOffsetAt: location 
	| offset |
	offset := (self text asString findString: source).
	replacementPositions
		do: [:triplet | 
			location < triplet first
				ifTrue: [^ offset].
			offset := offset - (triplet third - triplet second) + 3].
	^ offset! !

!PlatypusNativeCodeInterpretor methodsFor: 'requestor error notification' stamp: 'AlainPlantec 5/18/2012 13:29'!
notify: error at: location in: stream 
	| window |
	window := (StandardWindow labelled: error)
				model: self.
	window
		addMorph: requestor
		frame: (0 @ 0 corner: 1 @ 1).
	requestor
		notify: error
		at: location
				+ (self notificationOffsetAt: location)
		in: stream.
	window openInWorld.
	PlatypusNativeCodeErrorException signal: 'error while evaluating ''' , stream contents , ''''! !

!PlatypusNativeCodeInterpretor methodsFor: 'private' stamp: 'AlainPlantec 4/26/2012 10:50'!
preparse
	| ori beginReplPos vname replString |
	preparsed := ReadWriteStream on: String new.
	preparsed nextPut: $[.
	ori := ReadStream on: source.
	[ori atEnd]
		whileFalse: [preparsed
				nextPutAll: (ori upTo: $").
			ori atEnd
				ifFalse: [ori peek == $$
						ifTrue: [beginReplPos := ori position.
							ori next.
							vname := ori upTo: $".
							replString := '(self valueOf: ''' , vname trimBoth , ''') '.
							preparsed nextPutAll: replString.
							replacementPositions
								add: (Array
										with: beginReplPos
										with: vname size
										with: replString size)]
						ifFalse: [preparsed nextPut: $"]]].
	preparsed nextPutAll: '] value'.
	preparsed reset.
	^ preparsed! !

!PlatypusNativeCodeInterpretor methodsFor: 'accessing' stamp: 'apl 5/27/2004 10:29'!
replacementPositions: aCollection 
	replacementPositions := aCollection! !

!PlatypusNativeCodeInterpretor methodsFor: 'accessing' stamp: 'apl 4/6/2004 11:39'!
requestor: aRequestor 
	requestor := TamTextMorph
				on: self
				text: nil
				accept: nil
				readSelection: nil
				menu: nil.
	requestor setText: source.
	requestor changed: #contents! !

!PlatypusNativeCodeInterpretor methodsFor: 'requestor error notification' stamp: 'apl 12/18/2003 23:34'!
select
	^ requestor select! !

!PlatypusNativeCodeInterpretor methodsFor: 'requestor error notification' stamp: 'apl 12/18/2003 23:59'!
selectFrom: begin to: end 
	^ requestor selectFrom: begin  to: end ! !

!PlatypusNativeCodeInterpretor methodsFor: 'requestor error notification' stamp: 'apl 12/18/2003 23:58'!
selectInvisiblyFrom: begin to: end 
	^ requestor selectInvisiblyFrom: begin to: end ! !

!PlatypusNativeCodeInterpretor methodsFor: 'requestor error notification' stamp: 'apl 3/19/2004 23:58'!
selectionInterval
	^ requestor selectionInterval! !

!PlatypusNativeCodeInterpretor methodsFor: 'accessing' stamp: 'apl 3/18/2004 21:46'!
tempNames
	^ #()! !

!PlatypusNativeCodeInterpretor methodsFor: 'requestor error notification' stamp: 'apl 3/19/2004 23:57'!
text
	^ requestor text! !

Object subclass: #PlatypusPharoSmalltalk
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-core'!

!PlatypusPharoSmalltalk class methodsFor: 'accessing' stamp: 'apl 4/14/2006 17:45'!
at: aClassNameSymbol 
		^self at: aClassNameSymbol ifAbsent: []! !

!PlatypusPharoSmalltalk class methodsFor: 'accessing' stamp: 'apl 4/19/2006 10:43'!
at: aClassNameSymbol ifAbsent: aBlock 
	^ Smalltalk at: aClassNameSymbol  asSymbol ifAbsent: aBlock! !

Object subclass: #PlatypusSourceLine
	instanceVariableNames: 'tokens width font maxWidth startLevel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-CodeTokens'!

!PlatypusSourceLine class methodsFor: 'accessing' stamp: ''!
cutableTokens
	^ Array with: (#( ';' ':=' '|' 'and' 'andor' 'or' 'xor' 'oneof' ',' '||') collect: [:e | e asSymbol]) with: (#('in' 'like' '<>' '=' '>=' '<=' '>' '<' ':=:' ':<>:' '+' '-' '*' '/' 'div' 'mod' ) collect: [:e | e asSymbol]) ! !

!PlatypusSourceLine class methodsFor: 'instance creation' stamp: ''!
font: aFont maxWidth: aSize
^ self font: aFont maxWidth: aSize level: 0 
! !

!PlatypusSourceLine class methodsFor: 'instance creation' stamp: 'AlainPlantec 10/7/2010 16:02'!
font: aFont maxWidth: aSize level: anInteger
	| line |
	line := self new.
	line font: aFont.
	line maxWidth: aSize.
	line reachLevel: anInteger.
	^ line! !

!PlatypusSourceLine class methodsFor: 'instance creation' stamp: ''!
new
	^super new initialize! !

!PlatypusSourceLine methodsFor: 'adding' stamp: 'apl 2/14/2006 19:03'!
add: aToken 
	tokens add: aToken copy.
	width := width
				+ (aToken widthOfStringForFont: font)! !

!PlatypusSourceLine methodsFor: 'adding' stamp: 'apl 3/10/2006 15:22'!
add: aToken level: anInteger 
	| added |
	added := aToken copy.
	tokens isEmpty
		ifTrue: [self reachLevel: anInteger].
	tokens add: added.
	width := width
				+ (aToken widthOfStringForFont: font)! !

!PlatypusSourceLine methodsFor: 'adding' stamp: ''!
addAll: aCollection
	aCollection do: [:e | self add: e] 
! !

!PlatypusSourceLine methodsFor: 'copying' stamp: ''!
copyEmpty
	^self class font: font maxWidth: maxWidth! !

!PlatypusSourceLine methodsFor: 'formatting' stamp: 'AlainPlantec 10/7/2010 21:56'!
cutFor: cutArray level: level 
	| lines currLine nextLevel currLevel expressLine |
	nextLevel := currLevel := startLevel.
	lines := OrderedCollection new.
	currLine := OrderedCollection new.

	tokens
		do: [:token | 
			(token isOpenKeyword
					or: [token isOpenDelim])
				ifTrue: [nextLevel := nextLevel + 1]
				ifFalse: [(token isCloseKeyword
							or: [token isCloseDelim])
						ifTrue: [nextLevel := nextLevel - 1]].
			token isIndent
				ifFalse: [currLine add: token].
			(cutArray
					identityIndexOf: token lexicalElement
					ifAbsent: []) notNil
				ifTrue: [currLevel <= level
						ifTrue: [expressLine := self copyEmpty.
							expressLine reachLevel: currLevel.
							expressLine addAll: currLine.
							lines add: expressLine.
							currLine := currLine copyEmpty.
							currLevel := nextLevel]]].
	currLine isEmpty
		ifFalse: [expressLine := self copyEmpty.
			expressLine reachLevel: currLevel.
			expressLine addAll: currLine.
			lines add: expressLine].
	^ lines! !

!PlatypusSourceLine methodsFor: 'accessing' stamp: ''!
cutableTokens
	^self class cutableTokens! !

!PlatypusSourceLine methodsFor: 'printing' stamp: 'apl 2/14/2006 12:11'!
dump: line on: aTokenList 
	line
		do: [:token | aTokenList add: token].
	aTokenList add: PlatypusEolToken new! !

!PlatypusSourceLine methodsFor: 'printing' stamp: ''!
dumpOn: aTokenList 
	self dumpOn: aTokenList cutables: self cutableTokens! !

!PlatypusSourceLine methodsFor: 'printing' stamp: 'apl 12/12/2003 11:30'!
dumpOn: aTokenList cutables: anArray 
	(maxWidth isNil
			or: [width < maxWidth
					or: [anArray size == 0]])
		ifTrue: [self dump: tokens on: aTokenList]
		ifFalse: [anArray notEmpty
				ifTrue: [(self formatLine: anArray first)
						do: [:l | l dumpOn: aTokenList cutables: anArray allButFirst]]]! !

!PlatypusSourceLine methodsFor: 'accessing' stamp: ''!
font
	^font! !

!PlatypusSourceLine methodsFor: 'accessing' stamp: ''!
font: anObject
	font := anObject! !

!PlatypusSourceLine methodsFor: 'formatting' stamp: 'AlainPlantec 10/7/2010 16:01'!
formatLine: cutablesArray 
	| maxlevel lines nextLines |
	lines := OrderedCollection with: self.
	maxlevel := self maxLevel.
	0
		to: maxlevel
		do: [:lvl | 
			nextLines := OrderedCollection new.
			lines
				do: [:ln | nextLines
						addAll: (ln cutFor: cutablesArray level: lvl)].
			lines := nextLines].
	^ lines! !

!PlatypusSourceLine methodsFor: 'initializing' stamp: 'apl 3/6/2004 10:42'!
initialize
	super initialize.
	self reset! !

!PlatypusSourceLine methodsFor: 'testing' stamp: ''!
isEmpty
	^tokens isEmpty! !

!PlatypusSourceLine methodsFor: 'formatting' stamp: 'apl 2/14/2006 12:11'!
levelIndent
	^ (1 to: startLevel)
		collect: [:i | PlatypusIndentToken new]! !

!PlatypusSourceLine methodsFor: 'formatting' stamp: 'apl 3/10/2006 15:11'!
levelIndentString
	| indent |
	indent := String new writeStream.
	self levelIndent
		do: [:i |  indent nextPutAll: i lexicalElement asString].
	^ indent contents! !

!PlatypusSourceLine methodsFor: 'accessing' stamp: ''!
maxLevel
	^ startLevel + (tokens
		count: [:t | t isOpenKeyword
				or: [t isOpenDelim]])! !

!PlatypusSourceLine methodsFor: 'accessing' stamp: ''!
maxWidth: anObject
	maxWidth := anObject! !

!PlatypusSourceLine methodsFor: 'initializing' stamp: 'AlainPlantec 10/7/2010 16:01'!
reachLevel: level 
	startLevel := level.
		(self levelIndent)
		do: [:i | self add: i].
! !

!PlatypusSourceLine methodsFor: 'reset' stamp: 'AlainPlantec 10/7/2010 16:02'!
reset
	tokens := OrderedCollection new.
	width := 0.
	startLevel := 0.! !

!PlatypusSourceLine methodsFor: 'accessing' stamp: ''!
tokens
	^tokens! !

Object subclass: #PlatypusStack
	instanceVariableNames: 'stack stackp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-core'!

!PlatypusStack methodsFor: 'accessing' stamp: 'apl 6/18/2004 22:31'!
asArray
	| arr |
	arr := Array new: stackp.
	1
		to: stackp
		do: [:p | arr
				at: p
				put: (stack at: p)].
	^ arr! !

!PlatypusStack methodsFor: 'accessing' stamp: 'apl 6/18/2004 22:25'!
at: pos
	^ stack at: pos! !

!PlatypusStack methodsFor: 'enumerating' stamp: 'apl 2/20/2006 17:55'!
collect: aBlock 
	| newCollection |
	newCollection := OrderedCollection new: self size.
	self
		do: [:each | newCollection
				add: (aBlock value: each)].
	^ newCollection! !

!PlatypusStack methodsFor: 'enumerating' stamp: 'AlainPlantec 5/1/2012 22:24'!
collectWithIndex: aBlock
	^stack asOrderedCollection collectWithIndex: aBlock! !

!PlatypusStack methodsFor: 'initialize/release' stamp: 'apl 6/3/2005 16:49'!
destroy
	super destroy.
	stack := nil! !

!PlatypusStack methodsFor: 'enumerating' stamp: 'apl 6/18/2004 22:27'!
do: aBlock
	1 to: stackp do: [:p | aBlock value: (stack at: p)]! !

!PlatypusStack methodsFor: 'accessing' stamp: 'apl 6/18/2004 22:39'!
first
	^ stack first! !

!PlatypusStack methodsFor: 'accessing' stamp: 'apl 6/18/2004 22:20'!
grow
	| newStack |
	newStack := Array
				new: stack size + self growSize.
	newStack
		replaceFrom: 1
		to: stack size
		with: stack
		startingAt: 1.
	stack := newStack! !

!PlatypusStack methodsFor: 'accessing' stamp: 'apl 6/18/2004 22:17'!
growSize
	"Return the size by which the receiver should grow if there are no 
	empty slots left."
	^ stack size max: 2! !

!PlatypusStack methodsFor: 'initialize/release' stamp: 'apl 2/23/2006 23:33'!
initialize
	super initialize.
	stack := Array new: 100.
	stackp := 0! !

!PlatypusStack methodsFor: 'accessing' stamp: 'apl 12/20/2005 10:46'!
isEmpty
	^ self size = 0! !

!PlatypusStack methodsFor: 'accessing' stamp: 'AlainPlantec 1/28/2011 05:55'!
notEmpty
	^ self isEmpty not! !

!PlatypusStack methodsFor: 'accessing' stamp: 'apl 6/18/2004 22:22'!
pop
	| val |
	val := stack at: stackp.
	stackp := stackp - 1.
	^ val! !

!PlatypusStack methodsFor: 'copying' stamp: 'apl 12/20/2005 12:50'!
postCopy
	| cpy |
	cpy := super postCopy.
	cpy privateStack: stack copy.
	cpy privateStackp: stackp copy.
	^ cpy! !

!PlatypusStack methodsFor: 'accessing' stamp: 'apl 12/20/2005 12:49'!
privateStack: aCollection 
	stack := aCollection! !

!PlatypusStack methodsFor: 'accessing' stamp: 'apl 12/20/2005 12:49'!
privateStackp: anInteger
	stackp := anInteger! !

!PlatypusStack methodsFor: 'accessing' stamp: 'apl 2/23/2006 23:40'!
push: anObject 
	stackp := stackp + 1.
	stackp > stack size
		ifTrue: [self grow].
	stack at: stackp put: anObject! !

!PlatypusStack methodsFor: 'removing' stamp: 'apl 2/23/2006 15:42'!
removeAt: index 
	| removed |
	removed := stack at: index.
	stackp := stackp - 1.
	index
		to: stackp
		do: [:pos | stack
				at: pos
				put: (stack at: pos + 1)].
	^ removed! !

!PlatypusStack methodsFor: 'accessing' stamp: 'apl 6/18/2004 22:36'!
reverseDo: aBlock 
	stackp
		to: 1
		by: -1
		do: [:p | aBlock
				value: (stack at: p)]! !

!PlatypusStack methodsFor: 'accessing' stamp: 'apl 6/18/2004 22:31'!
size
	^ stackp! !

!PlatypusStack methodsFor: 'accessing' stamp: 'apl 6/18/2004 22:25'!
top
	^ stack at: stackp! !

Object subclass: #PlatypusStepVisitorContext
	instanceVariableNames: 'contextInstance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-visitors'!

PlatypusStepVisitorContext subclass: #PlatypusExpressInterpretorContext
	instanceVariableNames: 'dataIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-interpreter'!

!PlatypusExpressInterpretorContext methodsFor: 'data enumerating' stamp: 'AlainPlantec 5/4/2012 18:55'!
applicationInstanceDo: aBlock 
	| v |
	self
		dataDo: [:d | 
			(v := d val) isPltGenericInstance
				ifTrue: [aBlock value: v]]! !

!PlatypusExpressInterpretorContext methodsFor: 'data enumerating' stamp: 'AlainPlantec 5/4/2012 18:55'!
applicationInstancesDetect: aSelectionBlock 
	| v |
	^ self
		dataDetect: [:d | 
			(v := d val) isPltGenericInstance
				and: [aSelectionBlock value: v]]! !

!PlatypusExpressInterpretorContext methodsFor: 'data enumerating' stamp: 'AlainPlantec 5/4/2012 19:29'!
applicationInstancesSelect: aSelectionBlock in: selected 
	| v |
	self
		dataSelect: [:d | d notNil and: [(v := d val) isPltGenericInstance and: [aSelectionBlock value: v]]]
		in: selected! !

!PlatypusExpressInterpretorContext methodsFor: 'accessing' stamp: 'apl 12/15/2003 15:25'!
data: aData
	^ dataIndex
		at: aData
		ifAbsent: []! !

!PlatypusExpressInterpretorContext methodsFor: 'accessing' stamp: 'apl 1/31/2006 14:24'!
data: aData value: aValue 
	^ dataIndex at: aData put: aValue! !

!PlatypusExpressInterpretorContext methodsFor: 'data enumerating' stamp: 'AlainPlantec 5/4/2012 12:40'!
dataDo: aBlock
	self dataIndex do: [:d | aBlock value: d val]! !

!PlatypusExpressInterpretorContext methodsFor: 'accessing' stamp: 'apl 12/18/2003 10:20'!
dataIndex
	^ dataIndex
	! !

!PlatypusExpressInterpretorContext methodsFor: 'accessing' stamp: 'apl 12/18/2003 19:49'!
dataNamed: anIdent
	| key |
	key := anIdent asUppercase.
	dataIndex keysAndValuesDo: [ :k :v | k name asUppercase = key ifTrue: [^ v]].
	^ nil! !

!PlatypusExpressInterpretorContext methodsFor: 'data enumerating' stamp: 'AlainPlantec 5/4/2012 12:39'!
dataSelect: aSelectionBlock in: selected 
	self dataIndex
		do: [:d | | v |
			v := d val.
			(aSelectionBlock value: v)
				ifTrue: [selected add: v]]! !

!PlatypusExpressInterpretorContext methodsFor: 'initialize/release' stamp: 'apl 6/3/2005 16:48'!
destroy
	dataIndex := nil.
	super destroy! !

!PlatypusExpressInterpretorContext methodsFor: 'accessing' stamp: 'apl 12/18/2003 10:41'!
includesData: aData 
	^ dataIndex includesKey: aData ! !

!PlatypusExpressInterpretorContext methodsFor: 'initialize/release' stamp: 'ap 6/22/2004 23:30'!
initialize
	super initialize.
	dataIndex := IdentityDictionary new! !

!PlatypusExpressInterpretorContext methodsFor: 'initialize/release' stamp: 'apl 3/27/2006 07:54'!
initializeContextInInterpretor: anInterpretor 
	contextInstance initializeContextInInterpretor: anInterpretor! !

!PlatypusExpressInterpretorContext methodsFor: 'accessing' stamp: 'apl 3/8/2004 19:11'!
stackElementOfDataNamed: anIdent 
	| key |
	key := anIdent asUppercase.
	dataIndex
		keysAndValuesDo: [:k :v | k name asUppercase = key
				ifTrue: [^ k]].
	^ nil! !

PlatypusExpressInterpretorContext subclass: #PlatypusExpressInterpretorQueryContext
	instanceVariableNames: 'aggregateSource sourceStream resultStream current'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-interpreter'!

!PlatypusExpressInterpretorQueryContext methodsFor: 'accessing' stamp: 'apl 1/6/2004 09:55'!
aggregateSource
	^aggregateSource! !

!PlatypusExpressInterpretorQueryContext methodsFor: 'accessing' stamp: 'AlainPlantec 10/7/2010 15:50'!
aggregateSource: anObject 
	aggregateSource := anObject.
	sourceStream := ReadStream on: (aggregateSource val nativeCollection) asArray.
	resultStream := WriteStream
				on: (Array new: 100).
	current := PltMissingValue new! !

!PlatypusExpressInterpretorQueryContext methodsFor: 'testing' stamp: 'apl 1/6/2004 10:55'!
atEnd
	^ self sourceStream atEnd! !

!PlatypusExpressInterpretorQueryContext methodsFor: 'accessing' stamp: 'apl 1/6/2004 10:58'!
current
	^ current! !

!PlatypusExpressInterpretorQueryContext methodsFor: 'accessing' stamp: 'apl 1/6/2004 10:45'!
current: anObject
	current := anObject! !

!PlatypusExpressInterpretorQueryContext methodsFor: 'accessing' stamp: 'apl 2/23/2005 21:45'!
dontKeep
	aggregateSource val isPltArrayInstance
		ifTrue: [self resultStream nextPut: PltMissingValue new]! !

!PlatypusExpressInterpretorQueryContext methodsFor: 'accessing' stamp: 'apl 1/6/2004 10:46'!
keep
	self resultStream nextPut: self current ! !

!PlatypusExpressInterpretorQueryContext methodsFor: 'accessing' stamp: 'AlainPlantec 10/7/2010 15:51'!
next
	^ current := self sourceStream next! !

!PlatypusExpressInterpretorQueryContext methodsFor: 'accessing' stamp: 'apl 3/3/2004 18:32'!
result
	| result |
	result := self aggregateSource val copyEmpty.
	result setQueryBoundsFromSource: self aggregateSource val.
	result contents: self resultStream contents.
	^ result! !

!PlatypusExpressInterpretorQueryContext methodsFor: 'accessing' stamp: 'apl 1/6/2004 10:42'!
resultStream
	^resultStream! !

!PlatypusExpressInterpretorQueryContext methodsFor: 'accessing' stamp: 'apl 1/6/2004 10:42'!
resultStream: anObject
	resultStream := anObject! !

!PlatypusExpressInterpretorQueryContext methodsFor: 'accessing' stamp: 'apl 1/6/2004 10:41'!
sourceStream
	^sourceStream! !

!PlatypusExpressInterpretorQueryContext methodsFor: 'accessing' stamp: 'apl 1/6/2004 10:41'!
sourceStream: anObject
	sourceStream := anObject! !

PlatypusExpressInterpretorContext subclass: #PlatypusExpressInterpretorRepeatContext
	instanceVariableNames: 'step last'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-interpreter'!

!PlatypusExpressInterpretorRepeatContext methodsFor: 'accessing' stamp: 'apl 12/20/2003 23:49'!
last
	^last! !

!PlatypusExpressInterpretorRepeatContext methodsFor: 'accessing' stamp: 'apl 12/20/2003 23:49'!
last: anObject
	last := anObject! !

!PlatypusExpressInterpretorRepeatContext methodsFor: 'accessing' stamp: 'apl 12/20/2003 23:48'!
step
	^step! !

!PlatypusExpressInterpretorRepeatContext methodsFor: 'accessing' stamp: 'apl 12/20/2003 23:48'!
step: anObject
	step := anObject! !

!PlatypusStepVisitorContext class methodsFor: 'instance creation' stamp: 'apl 6/14/2004 18:44'!
contextInstance: anPltDictionaryInstance 
	^ self new contextInstance: anPltDictionaryInstance
! !

!PlatypusStepVisitorContext methodsFor: 'accessing' stamp: 'apl 2/20/2006 18:15'!
asString
	^ contextInstance asString! !

!PlatypusStepVisitorContext methodsFor: 'accessing' stamp: 'apl 11/10/2003 12:31'!
contextInstance
	^ contextInstance! !

!PlatypusStepVisitorContext methodsFor: 'accessing' stamp: 'AlainPlantec 10/7/2010 16:03'!
contextInstance: anObject 
	contextInstance := anObject! !

!PlatypusStepVisitorContext methodsFor: 'initialize/release' stamp: 'apl 6/3/2005 16:49'!
destroy
	contextInstance := nil.
	super destroy! !

!PlatypusStepVisitorContext methodsFor: 'searching' stamp: 'apl 6/14/2004 18:52'!
lookUpIdentifierBN: anIdent 
	^ self contextInstance lookUpIdentifierBN: anIdent! !

!PlatypusStepVisitorContext methodsFor: 'searching' stamp: 'apl 6/14/2004 18:52'!
lookUpNamedTypeBN: anIdent 
	^ self contextInstance lookUpNamedTypeBN: anIdent! !

!PlatypusStepVisitorContext methodsFor: 'accessing' stamp: 'apl 2/20/2006 18:20'!
printString
	| res |
	res := WriteStream on: (String new: 40).
	contextInstance inclusiveOwnerPath do: [:own | res nextPutAll: own name] separatedBy: [res nextPut:$.].
	^ res contents! !

Object subclass: #PlatypusTokenClassifier
	instanceVariableNames: 'stringEvaluatedConditionsList characterEvaluatedConditionsList tokensClassByTokenValueMap tokensClassByTokenSymbolMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-CodeTokens'!

PlatypusTokenClassifier subclass: #PlatypusExpressTokenClassifier
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-CodeTokens'!

!PlatypusExpressTokenClassifier methodsFor: 'accessing' stamp: 'apl 2/2/2006 14:59'!
builtinFunctionsSymbols
	^ #(#'value_in' #'value_unique' #even #odd #blength #hiindex #rolesof #sin #valueIn #lobound #nvl #format #hibound #cos #log10 #length #tan #usedin #typeof #log2 #abs #exp #asin #sqrt #acos #exists #sizeof #log #loindex #valueUnique #atan #value )! !

!PlatypusExpressTokenClassifier methodsFor: 'accessing' stamp: 'apl 5/20/2005 21:45'!
builtinProceduresSymbols
	^ #(#remove #insert )! !

!PlatypusExpressTokenClassifier methodsFor: 'initialize/release' stamp: 'AlainPlantec 1/28/2011 09:28'!
initialize
	super initialize.
	#('[' '{' '(' '{*' )
		do: [:value | tokensClassByTokenValueMap at: value put: PlatypusOpenDelimToken].
	#(']' '}' ')' '*}' )
		do: [:value | tokensClassByTokenValueMap at: value put: PlatypusCloseDelimToken].
	#('.' ',' '\' ':' '|' '<*' '?' )
		do: [:value | tokensClassByTokenValueMap at: value put: PlatypusDelimToken].
	#('||' '=' '<>' ':=:' '-' '<' '<=' '/' '*' '>=' '**' ':<>' )
		do: [:value | tokensClassByTokenValueMap at: value put: PlatypusOperatorToken].
	#(#true #false #unknown )
		do: [:symbol | tokensClassByTokenSymbolMap at: symbol put: PlatypusLogicalToken].
	#('.F.' '.T.' '.U.' )
		do: [:symbol | tokensClassByTokenValueMap at: symbol put: PlatypusLogicalToken].
	#(#alias #begin #repeat #if  #local #case #constant )
		do: [:symbol | tokensClassByTokenSymbolMap at: symbol put: PlatypusOpenKeywordToken].
	#(#rule #entity #type #function #procedure #schema #map)
		do: [:symbol | tokensClassByTokenSymbolMap at: symbol put: PlatypusPrimaryElementOpenKeywordToken].
	#(#'end_repeat' #'end_if' #'end_alias' #'end_case' #end #'end_constant' #'end_local' )
		do: [:symbol | tokensClassByTokenSymbolMap at: symbol put: PlatypusCloseKeywordToken].
	#(#'end_function' #'end_entity' #'end_schema' #'end_rule' #'end_type' #'end_procedure' #'end_map' )
		do: [:symbol | tokensClassByTokenSymbolMap at: symbol put: PlatypusPrimaryElementCloseKeywordToken].
	#(#where #inverse #unique #enumeration #else #then #derive #select )
		do: [:symbol | tokensClassByTokenSymbolMap at: symbol put: PlatypusGroupKeywordToken].
	#(#meta #reference #constE #use #skip #fixed #while #to #return #optional #pi #of #by #otherwise #escape #self #var #as #until #subtype #abstract #supertype #for #from #generic )
		do: [:symbol | tokensClassByTokenSymbolMap at: symbol put: PlatypusKeywordToken].
	#(#div #and #andor #xor #in #oneof #query #mod #not #or #like )
		do: [:symbol | tokensClassByTokenSymbolMap at: symbol put: PlatypusOperatorToken].
	#(#list #real #array #set #binary #number #aggregate #logical #string #bag #integer #boolean #generic )
		do: [:symbol | tokensClassByTokenSymbolMap at: symbol put: PlatypusBuiltinDomainToken].
	self builtinProceduresSymbols
		do: [:symbol | tokensClassByTokenSymbolMap at: symbol put: PlatypusBuiltinProcedureToken].
	self builtinFunctionsSymbols
		do: [:symbol | tokensClassByTokenSymbolMap at: symbol put: PlatypusBuiltinFunctionToken].
	tokensClassByTokenValueMap at: ';' asSymbol put: PlatypusSemicolonToken.
	tokensClassByTokenValueMap at: ':=' asSymbol put: PlatypusAssignToken.
	tokensClassByTokenValueMap at: '+' asSymbol put: PlatypusPlusToken.
	tokensClassByTokenValueMap at: $; put: PlatypusSemicolonToken.
	tokensClassByTokenValueMap at: ':=' put: PlatypusAssignToken.
	tokensClassByTokenValueMap at: $+ put: PlatypusPlusToken.
	tokensClassByTokenValueMap at: ';' put: PlatypusSemicolonToken.
	tokensClassByTokenValueMap at: '+' put: PlatypusPlusToken.
	tokensClassByTokenValueMap at: Character space put: PlatypusOneWhiteSpaceToken.
	tokensClassByTokenValueMap at: Character tab put: PlatypusIndentToken.
	tokensClassByTokenValueMap at: Character cr put: PlatypusEolToken.
	tokensClassByTokenValueMap at: Character lf put: nil.
	self
		classifyString: PlatypusNumberToken
		block: [:v | v size > 1
				and: [(v first = $-
							or: [v first = $+])
						and: [v
								allSatisfy: [:c | c isDigit
										or: [#($. $e $- $+ ) includes: c]]]]].
	self
		classifyString: PlatypusLogicalToken
		block: [:v | v size > 2
				and: [v first = $.
						and: [v last = $.]]].
	self
		classifyString: PlatypusNumberToken
		block: [:v | v notEmpty
				and: [v first isDigit]].
	self
		classifyString: PlatypusStringToken
		block: [:v | v notEmpty
				and: [v first == $']].
	self
		classifyString: PlatypusStringToken
		block: [:v | v notEmpty
				and: [v first == $"]].
	self
		classifyString: PlatypusStringToken
		block: [:v | v notEmpty
				and: [v first == $%]]! !

!PlatypusTokenClassifier methodsFor: 'adding' stamp: 'apl 3/7/2003 18:50'!
classifyCharacter: aClass block: aBlock 
	characterEvaluatedConditionsList
		add: (Association key: aBlock value: aClass)! !

!PlatypusTokenClassifier methodsFor: 'adding' stamp: 'apl 3/7/2003 18:54'!
classifyString: aClass block: aBlock 
	stringEvaluatedConditionsList
		add: (Association key: aBlock value: aClass)! !

!PlatypusTokenClassifier methodsFor: 'initialize-release' stamp: 'apl 5/20/2005 22:08'!
initialize
	super initialize.
	stringEvaluatedConditionsList := OrderedCollection new.
	characterEvaluatedConditionsList := OrderedCollection new.
	tokensClassByTokenValueMap := Dictionary new.
	tokensClassByTokenSymbolMap := IdentityDictionary new.
! !

!PlatypusTokenClassifier methodsFor: 'accessing' stamp: 'AlainPlantec 10/7/2010 16:03'!
tokenClassFromCharacter: aValue ifAbsent: aBlock 
	| foundConditionAssoc |
	foundConditionAssoc := characterEvaluatedConditionsList
				detect: [:assoc | assoc key value: aValue]
				ifNone: [].
	foundConditionAssoc notNil
		ifTrue: [^ foundConditionAssoc value].
	^ tokensClassByTokenValueMap
		at: aValue
		ifAbsent: [aBlock value]! !

!PlatypusTokenClassifier methodsFor: 'accessing' stamp: 'AlainPlantec 10/7/2010 16:03'!
tokenClassFromString: aValue ifAbsent: aBlock 
	| foundConditionAssoc |
	foundConditionAssoc := stringEvaluatedConditionsList
				detect: [:assoc | assoc key value: aValue]
				ifNone: [].
	foundConditionAssoc notNil
		ifTrue: [^ foundConditionAssoc value].
	^ tokensClassByTokenSymbolMap
				at: aValue asLowercase asSymbol
				ifAbsent: [tokensClassByTokenValueMap
		at: aValue ifAbsent: [aBlock value]]! !

Object subclass: #PlatypusTokenList
	instanceVariableNames: 'tokens'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-CodeTokens'!

!PlatypusTokenList class methodsFor: 'instance creation' stamp: ''!
tokens: aDLinkedList
	^ self new tokens: aDLinkedList! !

!PlatypusTokenList methodsFor: 'adding' stamp: 'apl 2/14/2006 15:31'!
add: aToken 
	tokens
		add: aToken! !

!PlatypusTokenList methodsFor: 'adding' stamp: 'apl 2/14/2006 15:24'!
addAll: anotherTokenList 
	^ tokens addAll: anotherTokenList tokens! !

!PlatypusTokenList methodsFor: 'adding' stamp: 'apl 2/14/2006 15:29'!
addAll: anotherList before: oldObject 
	^ tokens addAll: anotherList beforeIndex: (tokens indexOf: oldObject)! !

!PlatypusTokenList methodsFor: 'adding' stamp: 'apl 3/22/2006 19:48'!
addFirst: aToken 
	tokens addFirst: aToken! !

!PlatypusTokenList methodsFor: 'converting' stamp: 'apl 3/19/2003 11:57'!
asArray
	^ self tokens asArray! !

!PlatypusTokenList methodsFor: 'accessing' stamp: ''!
at: pos

	^ tokens at: pos! !

!PlatypusTokenList methodsFor: 'accessing' stamp: 'apl 3/3/2006 16:03'!
beginningOfLineFrom: aNode 
	| currNode whiteSpaceTouched |
	aNode isNil
		ifTrue: [^ self first].
	currNode := aNode.
	whiteSpaceTouched := false.
	[currNode notNil]
		whileTrue: [currNode isEol
				ifTrue: [^ currNode next
						ifNil: [currNode]].
			currNode isSemicolon ifTrue: [^  currNode next].
			(currNode isBlank 
					and: [currNode isRemark not])
				ifTrue: [whiteSpaceTouched := true]
				ifFalse: [whiteSpaceTouched
						ifTrue: [currNode isBlank
								ifFalse: [^ currNode next]]].
			currNode := currNode previous].
	^ aNode! !

!PlatypusTokenList methodsFor: 'updating' stamp: 'apl 2/17/2006 12:33'!
calculate
	^ self! !

!PlatypusTokenList methodsFor: 'accessing' stamp: 'apl 2/14/2006 21:05'!
closeTokenFrom: aNode 
	| currLevel curr |
	currLevel := 0.
	curr := aNode.
	curr notNil
		ifTrue: [[curr isOpenKeyword
				ifTrue: [currLevel := currLevel + 1]
				ifFalse: [curr isCloseKeyword
						ifTrue: [currLevel := currLevel - 1]].
			currLevel == 0
				ifTrue: [^ curr].
			curr := curr next.
			curr isNil
				ifTrue: [^ curr]] repeat].
	^ nil! !

!PlatypusTokenList methodsFor: 'enumerating' stamp: 'apl 2/16/2006 11:30'!
collect: aBlock 
	^ self class tokens: (tokens collect: aBlock)! !

!PlatypusTokenList methodsFor: 'copying' stamp: 'apl 2/17/2006 10:00'!
copy
	^ Error signal: 'a ' , self class name , ' can''t be copied'! !

!PlatypusTokenList methodsFor: 'copying' stamp: ''!
copyEmpty
	^ self class new ! !

!PlatypusTokenList methodsFor: 'copying' stamp: 'apl 2/14/2006 16:26'!
copyWithoutBlankFrom: startNode to: stopNode 
	| selection node |
	selection := self copyEmpty.
	node := startNode isNil
				ifTrue: [self first]
				ifFalse: [startNode].
	[node isNil
		ifTrue: [^ selection].
	node == stopNode
		ifTrue: [selection add: node copy.
			^ selection].
	node  isBlank
		ifFalse: [selection add: node copy].
	node := node next] repeat! !

!PlatypusTokenList methodsFor: 'initialize/release' stamp: 'apl 6/3/2005 16:49'!
destroy
	self tokens destroy.
	super destroy! !

!PlatypusTokenList methodsFor: 'enumerating' stamp: 'apl 2/15/2006 10:58'!
detect: aBlock 
	^ tokens detect: aBlock ifNone: []! !

!PlatypusTokenList methodsFor: 'enumerating' stamp: 'apl 2/15/2006 10:57'!
detect: aBlock ifNone: noneBlock
	^ tokens detect: aBlock ifNone: noneBlock! !

!PlatypusTokenList methodsFor: 'enumerating' stamp: ''!
do: aBlock 
	^ tokens do: aBlock! !

!PlatypusTokenList methodsFor: 'enumerating' stamp: 'apl 3/3/2006 16:33'!
do: aBlock from: startNode to: stopNode 
	| currNode endNode |
	currNode := startNode.
	endNode := stopNode.
	[currNode ~~ endNode and: [currNode notNil]]
		whileTrue: [aBlock value: currNode.
			currNode := currNode ifNotNil: [currNode next]].
	endNode notNil
		ifTrue: [aBlock value: endNode]! !

!PlatypusTokenList methodsFor: 'accessing' stamp: 'apl 3/3/2006 16:13'!
endOfLineFrom: aNode 
	| currNode whiteSpaceTouched prev |
	aNode isNil
		ifTrue: [^ self last].
	currNode := aNode.
	whiteSpaceTouched := false.
	[currNode notNil]
		whileTrue: [currNode isEol
				ifTrue: [^ currNode previous
						ifNil: [currNode]].
			currNode isSemicolon
				ifTrue: [^ currNode ].

			(currNode isBlank
					and: [currNode isRemark not])
				ifTrue: [whiteSpaceTouched := true]
				ifFalse: [whiteSpaceTouched
						ifTrue: [currNode isBlank
								ifFalse: [^ currNode previous]]].
			prev := currNode.
			currNode := currNode next].
	^ prev! !

!PlatypusTokenList methodsFor: 'accessing' stamp: 'apl 2/15/2006 15:53'!
first
	^ tokens isEmpty ifTrue: [nil]
	ifFalse: [tokens first]! !

!PlatypusTokenList methodsFor: 'accessing' stamp: 'apl 2/14/2006 21:14'!
indexOf: aNode
	^ tokens indexOf: aNode! !

!PlatypusTokenList methodsFor: 'initialize/release' stamp: 'apl 4/6/2004 11:47'!
initialize
	super initialize.
	tokens := PltDLinkedList new! !

!PlatypusTokenList methodsFor: 'testing' stamp: ''!
isEmpty
	^tokens isEmpty! !

!PlatypusTokenList methodsFor: 'accessing' stamp: 'apl 2/15/2006 15:54'!
last
	^ tokens isEmpty
		ifFalse: [tokens last]! !

!PlatypusTokenList methodsFor: 'accessing' stamp: 'apl 2/25/2006 10:51'!
nextFrom: aNode satisfying: aBlock 
	| currNode |
	currNode := aNode.
	[currNode notNil]
		whileTrue: [(aBlock value: currNode)
				ifTrue: [^ currNode].
			currNode := currNode next].
	^ nil! !

!PlatypusTokenList methodsFor: 'accessing' stamp: 'apl 3/1/2006 15:41'!
nextNonBlankFrom: aNode 
^ self
		nextFrom: aNode
		satisfying: [:n | (n isBlank
				or: [n isRemark]) not]
! !

!PlatypusTokenList methodsFor: 'accessing' stamp: 'apl 2/14/2006 22:38'!
nextOpenKeywordFrom: aNode 
	| currNode |
	currNode := aNode.
	[currNode notNil]
		whileTrue: [currNode isOpenKeyword
				ifTrue: [^ currNode].
			currNode := currNode next].
	^ nil! !

!PlatypusTokenList methodsFor: 'updating' stamp: 'apl 3/1/2006 18:05'!
noEndingEol
	[self last notNil
		and: [self last isEol]]
		whileTrue: [self removeLast].
! !

!PlatypusTokenList methodsFor: 'testing' stamp: ''!
notEmpty
	^ self isEmpty not! !

!PlatypusTokenList methodsFor: 'updating' stamp: 'apl 3/1/2006 18:05'!
onlyOneEndingEol
	self noEndingEol .
	self last
		ifNotNil: [self add: PlatypusEolToken new]! !

!PlatypusTokenList methodsFor: 'accessing' stamp: 'apl 3/1/2006 15:39'!
previousCloseKeywordFrom: aNode 
	^ self
		previousFrom: aNode
		satisfying: [:n | n isCloseKeyword]
! !

!PlatypusTokenList methodsFor: 'accessing' stamp: 'apl 2/25/2006 10:51'!
previousFrom: aNode satisfying: aBlock 
	| currNode |
	currNode := aNode.
	[currNode notNil]
		whileTrue: [(aBlock value: currNode)
				ifTrue: [^ currNode].
			currNode := currNode previous].
	^ nil! !

!PlatypusTokenList methodsFor: 'accessing' stamp: 'apl 3/1/2006 15:37'!
previousKeywordFrom: aNode 
	^ self previousFrom: aNode satisfying: [:n | n isKeyword]
! !

!PlatypusTokenList methodsFor: 'accessing' stamp: 'apl 3/1/2006 15:39'!
previousNonBlankFrom: aNode 
	^ self
		previousFrom: aNode
		satisfying: [:n | n isBlank not]	! !

!PlatypusTokenList methodsFor: 'accessing' stamp: 'apl 3/1/2006 15:38'!
previousOpenKeywordFrom: aNode 
	^ self
		previousFrom: aNode
		satisfying: [:n | n isOpenKeyword]
! !

!PlatypusTokenList methodsFor: 'accessing' stamp: 'apl 3/1/2006 15:42'!
previousPrimaryElementCloseKeywordFrom: aNode 
	^ self
		previousFrom: aNode
		satisfying: [:n | n isPrimaryElementCloseKeyword]! !

!PlatypusTokenList methodsFor: 'accessing' stamp: 'apl 3/1/2006 15:38'!
previousPrimaryElementOpenKeywordFrom: aNode 
	^ self
		previousFrom: aNode
		satisfying: [:n | n isPrimaryElementOpenKeyword]
! !

!PlatypusTokenList methodsFor: 'removing' stamp: 'apl 2/14/2006 18:06'!
removeFrom: firstNode to: lastNode 
	^ tokens
		replaceFromNode: firstNode
		toNode: lastNode
		with: self copyEmpty! !

!PlatypusTokenList methodsFor: 'removing' stamp: 'apl 3/1/2006 17:58'!
removeLast
	^ tokens removeLast
	! !

!PlatypusTokenList methodsFor: 'removing' stamp: 'apl 3/1/2006 15:46'!
replaceFromNode: startNode toNode: stopNode with: replacementList 
	startNode ifNil: [self addAll: replacementList]
	ifNotNil: [
	tokens
		replaceFromNode: startNode
		toNode: stopNode
		with: replacementList]! !

!PlatypusTokenList methodsFor: 'enumerating' stamp: ''!
reverseDo: aBlock 
	^ tokens reverseDo: aBlock! !

!PlatypusTokenList methodsFor: 'enumerating' stamp: 'apl 2/16/2006 11:29'!
select: aBlock 
	^ self class tokens: (tokens select: aBlock)! !

!PlatypusTokenList methodsFor: 'accessing' stamp: ''!
size
	^ tokens size! !

!PlatypusTokenList methodsFor: 'accessing' stamp: 'apl 3/9/2006 13:39'!
sizeFrom: first to: last 
	| currNode count |
	currNode := first.
	count := 0.
	[currNode ~= last and: [currNode notNil]]
		whileTrue: [count := count + 1.
			currNode := currNode next].
	^ count! !

!PlatypusTokenList methodsFor: 'printing' stamp: 'apl 3/30/2006 13:51'!
textWithStreamClass: aStreamClass
	^ self
		textWithStreamClass: aStreamClass
		from: self first
		to: nil! !

!PlatypusTokenList methodsFor: 'printing' stamp: 'AlainPlantec 1/11/2010 17:26'!
textWithStreamClass: aStreamClass from: startNode to: stopNode 
	| stream result |
	stream := aStreamClass on: Text new.
	result := PlatypusCodeStream on: Text new.
	self
		do: [:d | 
			stream nextPutAll: d asString.
			result nextPutAll: stream originalContents endingAt: stream position.
			stream reset]
		from: startNode
		to: stopNode.
	stream close.
	result close.
	^ result contents! !

!PlatypusTokenList methodsFor: 'accessing' stamp: ''!
tokens
	^tokens! !

!PlatypusTokenList methodsFor: 'accessing' stamp: 'AlainPlantec 10/7/2010 16:03'!
tokens: aCollection 
	tokens := aCollection.
! !

!PlatypusTokenList methodsFor: 'updating' stamp: 'apl 2/17/2006 12:38'!
updateAllTokensPositions
	| startPos |
	startPos := 1.
	self
		do: [:tok | startPos := tok stopPosWithStart: startPos]
! !

!PlatypusTokenList methodsFor: 'printing' stamp: 'apl 3/15/2003 10:22'!
writeOn: aStream
	^self writeOn: aStream from: self first to: nil
! !

!PlatypusTokenList methodsFor: 'printing' stamp: 'AlainPlantec 1/11/2010 17:19'!
writeOn: aStream from: startNode to: stopNode 
	self
		do: [:d | aStream nextPutAll: d asString]
		from: startNode
		to: stopNode.
	^ aStream contents! !

Object subclass: #PlatypusTokenPrettyPrinter
	instanceVariableNames: 'delimLevel sourceTokenList resultTokenList startNode stopNode textFont maxLineWidth currentNode eolPrinted currentLevel currentLineno currentLine'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-CodeTokens'!

PlatypusTokenPrettyPrinter subclass: #PlatypusStepTokenPrettyPrinter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-CodeTokens'!

!PlatypusStepTokenPrettyPrinter class methodsFor: 'public pretty printing' stamp: 'apl 3/12/2007 11:28'!
prettyPrint: aSource 
	^ self prettyPrint: aSource startLevel: 0 
! !

!PlatypusStepTokenPrettyPrinter class methodsFor: 'public pretty printing' stamp: 'apl 3/12/2007 11:26'!
prettyPrint: aSource startLevel: anIndentLevel
	| srcTokenList ppTokenList code |
	srcTokenList := (PlatypusExpressScanner on: aSource readStream) buildTokenList.
	ppTokenList := PlatypusStepTokenPrettyPrinter new
				prettyPrint: srcTokenList
				from: srcTokenList first
				to: srcTokenList last
				startLevel: anIndentLevel
				font: nil
				maxLineWidth: 80.
	code := ppTokenList textWithStreamClass: ReadWriteStream.
	^ code! !

!PlatypusStepTokenPrettyPrinter methodsFor: 'visiting' stamp: 'apl 2/14/2006 16:23'!
acceptEmbeddedRemark: n 
	| printEolBefore |
	printEolBefore := true.
	currentNode previous notNil
		ifTrue: [currentNode previous isEmbeddedRemark
				ifTrue: [printEolBefore := false]].
	(currentLevel > 1
			or: [(startNode  is: #schema) not])
		ifTrue: [printEolBefore := false].
	printEolBefore
		ifTrue: [self printEol].
	currentLine add: n level: currentLevel.
	currentLineno := currentLineno
				+ (n asString
						count: [:c | c == Character cr]).
	self printEol! !

!PlatypusStepTokenPrettyPrinter methodsFor: 'visiting' stamp: 'apl 2/14/2006 16:23'!
acceptGroupKeyword: n 
	currentLevel := currentLevel - 1.
	self acceptToken: n.
	currentLevel := currentLevel + 1.
	(n is: #unique)
		ifTrue: [currentNode previous  isSemicolon
				ifTrue: [self printEol]
				ifFalse: [self printWhiteSpace]]
		ifFalse: [self printEol]! !

!PlatypusStepTokenPrettyPrinter methodsFor: 'visiting' stamp: 'apl 4/18/2006 13:54'!
acceptNativeCode: n 
	| printEolBefore |
	printEolBefore := true.
	(currentLevel > 1
			or: [(startNode is: #schema) not])
		ifTrue: [printEolBefore := false].
	printEolBefore
		ifTrue: [self printEol].
	currentLine add: n level: currentLevel.
	currentLineno := currentLineno
				+ (n asString
						count: [:c | c == Character cr]).
	(n next is: ';' asSymbol)
		ifFalse: [self printEol]! !

!PlatypusStepTokenPrettyPrinter methodsFor: 'visiting' stamp: 'apl 3/13/2006 15:41'!
acceptOpenKeyword: n 
	| printeol |
	printeol := true.
	currentLevel > 2
		ifTrue: [printeol := false]
		ifFalse: [currentNode previous isNil
				ifTrue: [printeol := false]
				ifFalse: [currentNode previous isEmbeddedRemark
						ifTrue: [printeol := false]
						ifFalse: [(n is: #local)
								ifTrue: [printeol := false]]]].
	printeol
		ifTrue: [self printEol].
	self acceptToken: n.
	self printWhiteSpace.
	(n is: #(#begin #local #constant ))
		ifTrue: [self printEol].
	currentLevel := currentLevel + 1! !

!PlatypusTokenPrettyPrinter methodsFor: 'visiting' stamp: ''!
acceptAssign: n 
	self acceptOperator: n! !

!PlatypusTokenPrettyPrinter methodsFor: 'visiting' stamp: ''!
acceptBuiltinFunction: n 

	self acceptKeyword: n.
! !

!PlatypusTokenPrettyPrinter methodsFor: 'visiting' stamp: ''!
acceptBuiltinProcedure: n 
	self acceptKeyword: n! !

!PlatypusTokenPrettyPrinter methodsFor: 'visiting' stamp: 'AlainPlantec 10/7/2010 16:03'!
acceptCloseDelim: n 
	currentLevel := currentLevel - 1.
	delimLevel := delimLevel - 1.
	self acceptToken: n.
	(n is: #'*}') ifTrue: [self printEol] ifFalse: [
	self printWhiteSpace]! !

!PlatypusTokenPrettyPrinter methodsFor: 'visiting' stamp: 'AlainPlantec 10/7/2010 16:03'!
acceptCloseKeyword: n 
	currentLevel := currentLevel - 1.
	self acceptToken: n.
	self printWhiteSpace! !

!PlatypusTokenPrettyPrinter methodsFor: 'visiting' stamp: ''!
acceptDelim: n 
	self acceptToken: n.
	self printWhiteSpace! !

!PlatypusTokenPrettyPrinter methodsFor: 'visiting' stamp: ''!
acceptDomain: n 
	self acceptToken: n.
		self printWhiteSpace! !

!PlatypusTokenPrettyPrinter methodsFor: 'visiting' stamp: 'AlainPlantec 10/7/2010 16:04'!
acceptEol: n 
	currentLine dumpOn: resultTokenList.
	eolPrinted := eolPrinted + 1.
	currentLineno := currentLineno + 1.
	currentLine reset! !

!PlatypusTokenPrettyPrinter methodsFor: 'visiting' stamp: 'apl 4/18/2006 13:54'!
acceptIdentifier: n 
	| printit nextNode prevNonBlank prevOpen |
	prevNonBlank := sourceTokenList previousNonBlankFrom: currentNode previous.
	(prevNonBlank notNil
			and: [prevNonBlank is: #of])
		ifTrue: [prevOpen := sourceTokenList previousOpenKeywordFrom: prevNonBlank.
			(prevOpen notNil
					and: [prevOpen is: #case])
				ifTrue: [self printEol]].
	self acceptToken: n.
	printit := true.
	(nextNode := currentNode next) notNil
		ifTrue: [(nextNode is: ']' asSymbol)
				ifTrue: [printit := false]].
	printit
		ifTrue: [self printWhiteSpace]! !

!PlatypusTokenPrettyPrinter methodsFor: 'visiting' stamp: ''!
acceptIndent: n 
	currentLine add: n! !

!PlatypusTokenPrettyPrinter methodsFor: 'visiting' stamp: 'apl 3/13/2006 17:54'!
acceptKeyword: n 
	| prevKeyword |
	(n is: #(#subtype #abstract #realization))
		ifTrue: [self printEol]
		ifFalse: [(n is: #supertype)
				ifTrue: [prevKeyword := sourceTokenList previousKeywordFrom: currentNode previous.
					(prevKeyword is: #abstract)
						ifFalse: [self printEol]]].
	self acceptToken: n.
	self printWhiteSpace! !

!PlatypusTokenPrettyPrinter methodsFor: 'visiting' stamp: 'apl 2/14/2006 22:43'!
acceptLiteral: n 
	| prevNonBlank prevOpen |
	(prevNonBlank := sourceTokenList previousNonBlankFrom: currentNode previous)
		ifNotNil: [(prevNonBlank is: #of)
				ifTrue: [prevOpen := sourceTokenList previousOpenKeywordFrom: prevNonBlank.
					(prevOpen is: #case)
						ifTrue: [self printEol]]].
	self acceptToken: n.
	self printWhiteSpace! !

!PlatypusTokenPrettyPrinter methodsFor: 'visiting' stamp: 'apl 2/14/2003 10:44'!
acceptLogical: n 
	self acceptLiteral: n! !

!PlatypusTokenPrettyPrinter methodsFor: 'visiting' stamp: 'apl 2/14/2003 10:44'!
acceptNumber: n 
	self acceptLiteral: n! !

!PlatypusTokenPrettyPrinter methodsFor: 'visiting' stamp: 'AlainPlantec 10/7/2010 16:04'!
acceptOpenDelim: n 
	self acceptToken: n.
	self printWhiteSpace.
	currentLevel := currentLevel + 1.
	delimLevel := delimLevel + 1! !

!PlatypusTokenPrettyPrinter methodsFor: 'visiting' stamp: ''!
acceptOperator: n 
	self acceptToken: n. self printWhiteSpace! !

!PlatypusTokenPrettyPrinter methodsFor: 'visiting' stamp: 'apl 2/14/2006 16:28'!
acceptPlus: n 
	(currentNode previous notNil
			and: [currentNode previous  isString])
		ifTrue: [(currentNode previous  lexicalElement endsWith: '\n''')
				ifTrue: [self printEol].
			(currentNode previous  lexicalElement endsWith: '\n\n''')
				ifTrue: [self printEol]].
	self acceptOperator: n! !

!PlatypusTokenPrettyPrinter methodsFor: 'visiting' stamp: ''!
acceptRemark: n 
	self acceptToken: n! !

!PlatypusTokenPrettyPrinter methodsFor: 'visiting' stamp: ''!
acceptSemicolon: n 
	self acceptToken: n.
	delimLevel == 0
		ifTrue: [self printEol] ifFalse: [self printWhiteSpace]! !

!PlatypusTokenPrettyPrinter methodsFor: 'visiting' stamp: 'apl 2/14/2003 10:44'!
acceptString: n 
	self acceptLiteral: n.
! !

!PlatypusTokenPrettyPrinter methodsFor: 'visiting' stamp: 'apl 2/14/2006 16:28'!
acceptTailRemark: n 
	| printspace |
	printspace := true.
	((currentNode previous notNil
				and: [currentNode previous isRemark])
			or: [currentNode next notNil
					and: [currentNode next  isRemark]])
		ifTrue: [self printEol.
			printspace := false].
	printspace
		ifTrue: [self printWhiteSpace].
	self acceptToken: n.
	(currentNode next notNil
			and: [currentNode next  isTailRemark])
		ifFalse: [self printEol]! !

!PlatypusTokenPrettyPrinter methodsFor: 'visiting' stamp: ''!
acceptToken: n 
	currentLine add: n level: currentLevel! !

!PlatypusTokenPrettyPrinter methodsFor: 'visiting' stamp: ''!
acceptWhiteSpace: n 
	currentLine add: n! !

!PlatypusTokenPrettyPrinter methodsFor: 'pretty printing' stamp: 'AlainPlantec 10/7/2010 16:04'!
prettyPrint
	| node |
	node := startNode.
	[node isNil
		ifFalse: [self prettyPrintNode: node].
	(node isNil
			or: [node == stopNode])
		ifTrue: [currentLine isEmpty
				ifFalse: [currentLine dumpOn: resultTokenList.
					resultTokenList tokens removeLast].
			^ resultTokenList].
	node := node next] repeat! !

!PlatypusTokenPrettyPrinter methodsFor: 'pretty printing' stamp: 'apl 12/12/2003 11:38'!
prettyPrint: aTokenList 
	^ self
		prettyPrint: aTokenList
		font: nil
		maxLineWidth: nil! !

!PlatypusTokenPrettyPrinter methodsFor: 'pretty printing' stamp: ''!
prettyPrint: aTokenList font: aFont maxLineWidth: aSize 
	^ self
		prettyPrint: aTokenList
		from: aTokenList first
		to: aTokenList last
		font: aFont
		maxLineWidth: aSize! !

!PlatypusTokenPrettyPrinter methodsFor: 'pretty printing' stamp: ''!
prettyPrint: aTokenList from: aStartNode to: aStopNode font: aFont maxLineWidth: aSize 
^ self prettyPrint: aTokenList from: aStartNode to: aStopNode startLevel: 0 font: aFont maxLineWidth: aSize 
! !

!PlatypusTokenPrettyPrinter methodsFor: 'pretty printing' stamp: 'apl 5/20/2005 18:46'!
prettyPrint: aTokenList from: aStartNode to: aStopNode startLevel: anInteger font: aFont maxLineWidth: aSize 
	sourceTokenList := aTokenList isNil 
				ifTrue: [PlatypusTokenList new]
				ifFalse: [aTokenList copyWithoutBlankFrom: aStartNode to: aStopNode].
	resultTokenList := sourceTokenList copyEmpty.
	startNode := sourceTokenList first.
	stopNode := sourceTokenList last.
	textFont := aFont.
	maxLineWidth := aSize.
	currentLevel := anInteger.
	delimLevel := 0.
	currentLineno := 1.
	eolPrinted := 0.
	currentLine := PlatypusSourceLine 
				font: aFont
				maxWidth: aSize
				level: currentLevel.
	^self prettyPrint! !

!PlatypusTokenPrettyPrinter methodsFor: 'pretty printing' stamp: 'apl 2/14/2006 16:28'!
prettyPrintNode: aTokenListNode 
	currentNode := aTokenListNode.
	aTokenListNode  accept: self! !

!PlatypusTokenPrettyPrinter methodsFor: 'pretty printing' stamp: 'apl 2/14/2006 16:28'!
printEol
	| printit |
	printit := true.
	currentNode next notNil
		ifTrue: [(currentNode next  isTailRemark
					and: [currentNode  isTailRemark not])
				ifTrue: [printit := false]].
	printit
		ifTrue: [PlatypusEolToken new accept: self]! !

!PlatypusTokenPrettyPrinter methodsFor: 'pretty printing' stamp: 'apl 4/18/2006 13:20'!
printWhiteSpace
	| printit nextNode |
	printit := true.
	(nextNode := currentNode next)
		ifNil: [printit := false]
		ifNotNil: [(nextNode is: (#(';' ',' '.' '\' ) collect: [:e | e asSymbol]) )
				ifTrue: [printit := false]].
	(currentNode is: (#('.' '\' ) collect: [:e | e asSymbol]))
		ifTrue: [printit := false].
	printit
		ifTrue: [PlatypusOneWhiteSpaceToken new accept: self]! !

Object subclass: #PlatypusVisitorError
	instanceVariableNames: 'message data path metaData'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-visitors'!

PlatypusVisitorError subclass: #PlatypusExpressInterpretorError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-interpreter'!

PlatypusVisitorError subclass: #PlatypusExpressNamesCheckerError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-visitors'!

PlatypusVisitorError subclass: #PlatypusExpressResolverError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-visitors'!

PlatypusVisitorError subclass: #PlatypusExpressSemanticCheckerError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-visitors'!

PlatypusVisitorError subclass: #PlatypusModelContentsResolverError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-visitors'!

PlatypusVisitorError subclass: #PlatypusModelContentsSemanticCheckerError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-visitors'!

PlatypusVisitorError subclass: #PlatypusStepCheckerError
	instanceVariableNames: 'stepFolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-visitors'!

!PlatypusStepCheckerError class methodsFor: 'instance creation' stamp: 'AlainPlantec 6/14/2012 00:41'!
error: aMessage oid: anInteger folder: aStepFolder 
	| instance err |
	instance := aStepFolder instanceAt: anInteger.
	err := self metaData: instance message: aMessage.
	err stepFolder: aStepFolder.
	^ err! !

!PlatypusStepCheckerError class methodsFor: 'instance creation' stamp: 'AlainPlantec 6/14/2012 00:40'!
error: aMessage oid: anInteger 	repository: aPlatypusRepository
	^ self error: aMessage oid: anInteger folder: aPlatypusRepository! !

!PlatypusStepCheckerError methodsFor: 'accessing' stamp: 'apl 2/25/2005 19:30'!
stepFolder
	^stepFolder! !

!PlatypusStepCheckerError methodsFor: 'accessing' stamp: 'apl 2/25/2005 19:30'!
stepFolder: anObject
	stepFolder := anObject! !

!PlatypusVisitorError class methodsFor: 'instance creation' stamp: 'AlainPlantec 6/14/2012 00:42'!
metaData: anEntityInstance message: aMessage 
	^ self new
		message: aMessage;
		metaData: anEntityInstance
! !

!PlatypusVisitorError methodsFor: 'accessing' stamp: 'AlainPlantec 6/14/2012 01:49'!
asString
	| s named p |
	s := WriteStream on: ''.
	p := self path.
	p isEmptyOrNil 
		ifFalse: [
			named := p allButLast
						select: [:elem | elem isPltContextDefinition
								or: [elem isPltNamedType]].
			named
				do: [:elem | s nextPutAll: elem name]
				separatedBy: [s nextPutAll: '\']].
	s nextPutAll: ': '.
	s 
		nextPutAll: (self metaData ifNil: ['?'] ifNotNil: [:md | md errorQualifier contractTo: 90]);
		nextPutAll: ': '.
	s nextPutAll: message.
	^ s contents! !

!PlatypusVisitorError methodsFor: 'accessing' stamp: 'apl 2/17/2006 18:37'!
message
	^message! !

!PlatypusVisitorError methodsFor: 'accessing' stamp: 'apl 2/17/2006 18:37'!
message: anObject
	message := anObject! !

!PlatypusVisitorError methodsFor: 'accessing' stamp: 'AlainPlantec 6/14/2012 00:28'!
metaData
	^ metaData! !

!PlatypusVisitorError methodsFor: 'accessing' stamp: 'AlainPlantec 6/14/2012 00:27'!
metaData: anEntityInstance 
	metaData := anEntityInstance! !

!PlatypusVisitorError methodsFor: 'accessing' stamp: 'AlainPlantec 6/14/2012 01:49'!
path
	^ metaData ifNotNil: [ metaData inclusiveOwnerPath ]! !

Object subclass: #PltDLinkedList
	instanceVariableNames: 'nodesList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-tools'!

!PltDLinkedList commentStamp: 'apl 3/2/2005 19:03' prior: 0!
Un exemple de commentaire!

!PltDLinkedList class methodsFor: 'examples' stamp: 'apl 4/6/2004 11:47'!
example1
	| dlist |
	dlist := self new.
	#(1 2 4 6 8) do: [:e | dlist add: (PltDNode data: e)].
	dlist explore! !

!PltDLinkedList class methodsFor: 'examples' stamp: 'apl 4/6/2004 11:47'!
example10
	| col |
	#(#PltDLinkedList #OrderedCollection) do: 
			[:classSymb | 
			col := (Smalltalk at: classSymb) new.
			(Association key: classSymb , ' 100000 add time'
				value: (Time 
						millisecondsToRun: [1 to: 100000 do: [:e | col add: (PltDNode data: e)]])) 
					explore].
	#(#PltDLinkedList #OrderedCollection) do: 
			[:classSymb | 
			col := (Smalltalk at: classSymb) new.
			1 to: 100000 do: [:e | col add: (PltDNode data: e)].
			(Association key: classSymb , ' 100000 remove first time'
				value: (Time 
						millisecondsToRun: [[col isEmpty] whileFalse: [col removeFirst]])) 
					explore]! !

!PltDLinkedList class methodsFor: 'examples' stamp: 'apl 4/6/2004 11:47'!
example11
	| col rnd |
	col := self new.
	rnd := Random new.
	1 to: 10000 do: [:i | col add: (PltDNode data: (rnd nextInt: 1000))].
	(col asSortedCollection: [:a :b | a data < b data]) explore.
	col explore! !

!PltDLinkedList class methodsFor: 'examples' stamp: 'apl 4/6/2004 11:47'!
example12
	| col rnd |
	col := self new.
	rnd := Random new.
	1 to: 10000 do: [:i | col add: (PltDNode data: (rnd nextInt: 1000))].
	col explore.
	(col sortBy: [:a :b | a data < b data]) explore! !

!PltDLinkedList class methodsFor: 'examples' stamp: 'apl 2/14/2006 15:48'!
example13
	| col1 col2 |
	col1 := self new.
	col2 := self new.
	1
		to: 3
		do: [:i | 
			col1
				add: (PltDNode data: i).
			col2
				add: (PltDNode data: i * 10)].
	^ col1 , col2! !

!PltDLinkedList class methodsFor: 'examples' stamp: 'apl 4/6/2004 11:47'!
example14
	| col1 col2 |
	col1 := self new.
	col2 := self new.
	1 to: 10
		do: 
			[:i | 
			col1 add: (PltDNode data: i).
			col2 add: (PltDNode data: i * 1000)].
	^col1 
		replaceFrom: 4
		to: 5
		with: col2
		startingAt: 2! !

!PltDLinkedList class methodsFor: 'examples' stamp: 'apl 4/6/2004 11:47'!
example15
	| col1 |
	col1 := self new.
	1 to: 10 do: [:i | col1 add: (PltDNode data: i)].
	^col1 copyFrom: 3 to: 6! !

!PltDLinkedList class methodsFor: 'examples' stamp: 'apl 4/6/2004 11:47'!
example2
	| dlist |
	dlist := self new.
	dlist
		addFirst: (PltDNode data: 'first1');
		addLast: (PltDNode data: 'last1');
		addFirst: (PltDNode data: 'first2');
		addLast: (PltDNode data: 'last2').
	dlist explore.
	dlist asArray explore.
	1 to: dlist size
		do: [:pos | (Association key: pos value: (dlist at: pos)) explore]! !

!PltDLinkedList class methodsFor: 'examples' stamp: 'apl 4/6/2004 11:47'!
example3
	| dlist |
	dlist := self new.
	#(1 2 3 4 5) do: [:e | dlist add: (PltDNode data: e)].
	1 to: dlist size
		do: [:pos | (Association key: pos value: (dlist at: pos)) explore]! !

!PltDLinkedList class methodsFor: 'examples' stamp: 'apl 4/6/2004 11:47'!
example4
	| dlist |
	dlist := self new.
	#(1 2 3 4 5) do: [:e | dlist add: (PltDNode data: e)].
	1 to: dlist size
		do: [:pos | dlist at: pos put: (PltDNode data: (dlist at: pos) data * 10)].
	dlist explore! !

!PltDLinkedList class methodsFor: 'examples' stamp: 'apl 4/6/2004 11:47'!
example5
	1 to: 4
		do: 
			[:n | 
			| dlist |
			dlist := self new.
			1 to: n do: [:e | dlist add: (PltDNode data: e)].
			1 to: dlist size * 2
				by: 2
				do: [:pos | dlist add: (PltDNode data: (dlist at: pos) data * 10) afterIndex: pos].
			(Association key: n value: dlist) explore]! !

!PltDLinkedList class methodsFor: 'examples' stamp: 'apl 4/6/2004 11:47'!
example6
	| dlist |
	dlist := self new.
	#(1 2 3 4 5) do: [:e | dlist add: (PltDNode data: e)].
	(dlist collect: [:e | e data * 10]) explore! !

!PltDLinkedList class methodsFor: 'examples' stamp: 'apl 4/6/2004 11:47'!
example7
	| dlist |
	dlist := self new.
	#(1 2 3 4 5) do: [:e | dlist add: (PltDNode data: e)].
	(dlist select: [:e | e data \\ 2 > 0]) explore! !

!PltDLinkedList class methodsFor: 'examples' stamp: 'apl 2/14/2006 15:59'!
example8
	| dlist |
	dlist := self new.
	#(1 2 3 4 5 )
		do: [:e | dlist
				add: (PltDNode data: e)].
	[dlist isEmpty]
		whileFalse: [dlist removeFirst].
	dlist inspect.
	dlist := self new.
	#(1 2 3 4 5 )
		do: [:e | dlist
				add: (PltDNode data: e)].
	[dlist isEmpty]
		whileFalse: [dlist removeLast].
	dlist inspect.
	dlist := self new.
	#(1 2 3 4 5 )
		do: [:e | dlist
				add: (PltDNode data: e)].
	[dlist size == 1]
		whileFalse: [dlist removeLast].
	dlist inspect.
	dlist := self new.
	dlist inspect! !

!PltDLinkedList class methodsFor: 'examples' stamp: 'apl 4/6/2004 11:47'!
example9
	| dlist dlist2 |
	dlist := self new.
	dlist2 := dlist copyEmpty.
	#(1 2 3 4 5) do: [:e | dlist add: (PltDNode data: e)].
	dlist reverseDo: [:e | dlist2 add: (PltDNode data: e data)].
	dlist explore.
	dlist2 explore! !

!PltDLinkedList class methodsFor: 'instance creation' stamp: 'apl 2/11/2004 14:40'!
new: aSize
	^ self new
! !

!PltDLinkedList class methodsFor: 'instance creation' stamp: 'apl 2/14/2006 18:02'!
nodesList: anOrderedCollectionOfNodes 
	^ self new nodesList: anOrderedCollectionOfNodes ! !

!PltDLinkedList methodsFor: 'adding' stamp: ''!
add: data 
	^self addLast: data.
	! !

!PltDLinkedList methodsFor: 'adding' stamp: 'apl 3/29/2006 22:13'!
addAll: anotherList 
	| oldLast otherFirst |
	oldLast := self last.
	otherFirst := anotherList first.
	nodesList addAll: anotherList.
	otherFirst ifNotNil: [otherFirst previous: oldLast].
	oldLast
		ifNotNil: [oldLast next: otherFirst]! !

!PltDLinkedList methodsFor: 'adding' stamp: 'apl 3/31/2006 22:09'!
addAll: anotherList beforeIndex: index 
	| oldAtIndex |
	(index > self size
			or: [self isEmpty])
		ifTrue: [self addAll: anotherList] 
		ifFalse: [index <= 1
				ifTrue: [self addAllFirst: anotherList]
				ifFalse: [oldAtIndex := self at: index.
					anotherList last next: oldAtIndex.
					oldAtIndex previous
						ifNotNil: [oldAtIndex previous next: anotherList first].
					anotherList first previous: oldAtIndex previous.
					oldAtIndex previous: anotherList last.
					anotherList
						reverseDo: [:n | nodesList add: n beforeIndex: index]]]! !

!PltDLinkedList methodsFor: 'adding' stamp: 'apl 3/29/2006 22:44'!
addAllFirst: anotherList 
	| oldFirst otherLast |
	oldFirst := self first.
	otherLast := anotherList last.
	nodesList addAllFirst: anotherList.
	otherLast
		ifNotNil: [otherLast next: oldFirst].
	oldFirst
		ifNotNil: [oldFirst previous: otherLast]! !

!PltDLinkedList methodsFor: 'adding' stamp: 'apl 2/14/2006 15:09'!
addFirst: data 
	| oldSize next |
	oldSize := self size.
	nodesList addFirst: data.
	oldSize > 0 ifTrue: [
		data next: (next := nodesList at: 2).
		next previous: data.
		data previous: nil]
	ifFalse: [
		data next: nil.
		data previous: nil
		]
	! !

!PltDLinkedList methodsFor: 'adding' stamp: 'apl 2/14/2006 15:12'!
addLast: data 
	| oldSize prev |
	oldSize := self size.
	nodesList addLast: data.
	oldSize > 0
		ifTrue: [data previous: (prev := nodesList at: oldSize).
			prev next: data.
			data next: nil]
		ifFalse: [data next: nil.
			data previous: nil]! !

!PltDLinkedList methodsFor: 'accessing' stamp: 'apl 2/14/2006 14:59'!
at: pos 
	^ nodesList at: pos! !

!PltDLinkedList methodsFor: 'accessing' stamp: 'apl 2/14/2006 15:05'!
at: pos put: data 
	| added prev next |
	nodesList at: pos put: data.
	added := nodesList at: pos.
	pos > 1
		ifTrue: [added previous: (prev := nodesList at: pos - 1).
			prev next: added]
		ifFalse: [added previous: nil].
	pos < self size
		ifTrue: [added next: (next := nodesList at: pos + 1).
			next previous: added]
		ifFalse: [added next: nil]! !

!PltDLinkedList methodsFor: 'enumerating' stamp: 'apl 2/16/2006 11:31'!
collect: aBlock 
	| newCollection |
	newCollection := self species new.
	self do: [:each | newCollection add: (aBlock value: each copy)].
	^ newCollection! !

!PltDLinkedList methodsFor: 'copying' stamp: 'apl 2/17/2006 10:00'!
copy
	^ Error signal: 'a ' , self class name , ' can''t be copied'! !

!PltDLinkedList methodsFor: 'copying' stamp: ''!
copyEmpty
	"Answer a copy of the receiver without any of the receiver's 
	elements. "
	^ self class new! !

!PltDLinkedList methodsFor: 'copying' stamp: 'apl 3/21/2006 19:36'!
copyReplaceFrom: start to: stop with: replacementList 
	| newLinkedList |
	newLinkedList := nodesList
				collect: [:n | n copy].
	newLinkedList
		replaceFrom: start
		to: stop
		with: replacementList.
	^ newLinkedList! !

!PltDLinkedList methodsFor: 'initialize/release' stamp: 'apl 2/14/2006 12:17'!
destroy
	self do: [:node | node destroy].
	super destroy! !

!PltDLinkedList methodsFor: 'enumerating' stamp: 'apl 2/14/2006 14:59'!
detect: aBlock 
	^ nodesList
		detect: aBlock
		ifNone: []! !

!PltDLinkedList methodsFor: 'enumerating' stamp: 'apl 2/15/2006 10:58'!
detect: aBlock ifNone: noneBlock
	^ nodesList
		detect: aBlock
		ifNone: noneBlock! !

!PltDLinkedList methodsFor: 'enumerating' stamp: 'apl 2/14/2006 14:59'!
do: aBlock 
nodesList do: aBlock! !

!PltDLinkedList methodsFor: 'accessing' stamp: 'AlainPlantec 1/11/2010 17:17'!
first
	^ nodesList ifEmpty: [nil] ifNotEmpty: [:l | l first]! !

!PltDLinkedList methodsFor: 'accessing' stamp: 'apl 2/14/2006 15:02'!
head
	^ nodesList first! !

!PltDLinkedList methodsFor: 'accessing' stamp: 'apl 4/18/2006 14:26'!
indexOf: aNode
	^ nodesList indexOf: aNode! !

!PltDLinkedList methodsFor: 'initialize/release' stamp: 'apl 2/14/2006 12:19'!
initialize
	super initialize.
	nodesList := OrderedCollection new! !

!PltDLinkedList methodsFor: 'testing' stamp: 'apl 2/14/2006 12:19'!
isEmpty
	^ nodesList isEmpty! !

!PltDLinkedList methodsFor: 'accessing' stamp: 'AlainPlantec 1/11/2010 17:18'!
last
	^ nodesList ifEmpty: [nil] ifNotEmpty: [:l | l last]! !

!PltDLinkedList methodsFor: 'private accessing' stamp: 'apl 2/14/2006 18:02'!
nodesList: anOrderedCollectionOfNodes
	nodesList := anOrderedCollectionOfNodes! !

!PltDLinkedList methodsFor: 'removing' stamp: 'apl 2/14/2006 12:29'!
remove: data ifAbsent: aBlock 
	nodesList remove: data ifAbsent: [ aBlock value. ^ nil].
	data previous
	ifNotNil: [data previous next: data next].
	data next ifNotNil: [data next previous: data previous].
	^ data! !

!PltDLinkedList methodsFor: 'removing' stamp: 'apl 2/14/2006 15:56'!
removeFirst
	| res first |
	nodesList notEmpty
		ifTrue: [res := nodesList removeFirst.
			nodesList notEmpty ifTrue: [(first := self first)
				ifNotNil: [first previous: nil]]].
	^ res! !

!PltDLinkedList methodsFor: 'removing' stamp: 'apl 2/14/2006 15:57'!
removeLast
	| res last |
	nodesList isEmpty ifFalse: [
	res := nodesList removeLast. nodesList isEmpty ifFalse: 
	[(last := self last)
		ifNotNil: [last next: nil]]].
	^ res! !

!PltDLinkedList methodsFor: 'removing' stamp: 'apl 3/21/2006 19:37'!
replaceFrom: start to: stop with: replacementList 
	| endReplacement firstNode prevNode lastNode nextNode |
	endReplacement := start - 1 + replacementList size.
		start
		to: stop
		do: [:p | (nodesList at: p) destroy].

	nodesList := nodesList
				copyReplaceFrom: start
				to: stop
				with: replacementList.
	nodesList isEmpty
		ifFalse: [(start < self size
					and: [start > 0])
				ifTrue: [firstNode := nodesList at: start.
					start > 1
						ifTrue: [firstNode previous: (prevNode := nodesList at: start - 1).
							prevNode next: firstNode]
						ifFalse: [firstNode previous: nil]].
			endReplacement > 0
				ifFalse: [endReplacement := self size].
			lastNode := nodesList at: endReplacement.
			endReplacement < self size
				ifTrue: [lastNode next: (nextNode := nodesList at: endReplacement + 1).
					nextNode previous: lastNode]
				ifFalse: [lastNode next: nil]]! !

!PltDLinkedList methodsFor: 'removing' stamp: 'apl 2/14/2006 18:03'!
replaceFromNode: startNode toNode: stopNode with: replacementList 
	| start stop |
	start := self indexOf: startNode.
	stop := self indexOf: stopNode.
	self
		replaceFrom: start
		to: stop
		with: replacementList! !

!PltDLinkedList methodsFor: 'initialize/release' stamp: 'apl 2/14/2006 12:18'!
reset
	self initialize! !

!PltDLinkedList methodsFor: 'enumerating' stamp: 'apl 2/14/2006 14:59'!
reverseDo: aBlock 
	nodesList reverseDo: aBlock! !

!PltDLinkedList methodsFor: 'enumerating' stamp: 'apl 2/16/2006 11:30'!
select: aBlock 
	| newCollection |
	newCollection := self species new.
	self do: [:each | (aBlock value: each) ifTrue: [newCollection add: each copy]].
	^newCollection! !

!PltDLinkedList methodsFor: 'accessing' stamp: 'apl 2/14/2006 15:02'!
size
	^ nodesList size! !

!PltDLinkedList methodsFor: 'copying' stamp: 'apl 2/14/2006 15:02'!
sortBy: aBlock 
	"Create a copy that is sorted. Sort criteria is the block that 
	accepts two arguments. 
	When the block is true, the first arg goes first ([:a :b | a > b] 
	sorts in descending order)."
	| cpy |
	cpy := self copyEmpty.
	cpy addAll: (self asSortedCollection: aBlock).
	^cpy! !

!PltDLinkedList methodsFor: 'accessing' stamp: 'apl 2/14/2006 15:02'!
tail
	^ nodesList last! !

Object subclass: #PltDNode
	instanceVariableNames: 'next previous data'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-tools'!

PltDNode subclass: #PlatypusGenericToken
	instanceVariableNames: 'startPos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-CodeTokens'!

PlatypusGenericToken subclass: #PlatypusDelimToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-CodeTokens'!

PlatypusDelimToken subclass: #PlatypusCloseDelimToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-CodeTokens'!

!PlatypusCloseDelimToken methodsFor: 'visiting' stamp: ''!
accept: aVisitor 
	^ aVisitor acceptCloseDelim: self! !

!PlatypusCloseDelimToken methodsFor: 'testing' stamp: ''!
isCloseDelim
	^ true! !

!PlatypusDelimToken class methodsFor: 'instance creation' stamp: 'apl 2/26/2003 21:48'!
token: anObject 
	^ super token: anObject  asSymbol! !

!PlatypusDelimToken methodsFor: 'visiting' stamp: ''!
accept: aVisitor 
	^ aVisitor acceptDelim: self! !

PlatypusDelimToken subclass: #PlatypusOpenDelimToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-CodeTokens'!

!PlatypusOpenDelimToken methodsFor: 'visiting' stamp: ''!
accept: aVisitor 
	^ aVisitor acceptOpenDelim: self! !

!PlatypusOpenDelimToken methodsFor: 'testing' stamp: ''!
isOpenDelim
	^ true! !

PlatypusDelimToken subclass: #PlatypusSemicolonToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-CodeTokens'!

!PlatypusSemicolonToken class methodsFor: 'instance creation' stamp: 'apl 3/3/2006 16:01'!
new
	^ super new lexicalElement: ';' asSymbol! !

!PlatypusSemicolonToken methodsFor: 'visiting' stamp: ''!
accept: aVisitor 
	^ aVisitor acceptSemicolon: self! !

!PlatypusSemicolonToken methodsFor: 'testing' stamp: ''!
isSemicolon
	^true! !

PlatypusGenericToken subclass: #PlatypusEolToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-CodeTokens'!

!PlatypusEolToken class methodsFor: 'instance creation' stamp: 'apl 2/17/2006 12:26'!
new
	^ super new lexicalElement: Character cr! !

!PlatypusEolToken methodsFor: 'visiting' stamp: ''!
accept: aVisitor 
	^ aVisitor acceptEol: self! !

!PlatypusEolToken methodsFor: 'testing' stamp: ''!
isEol
	^true! !

PlatypusGenericToken subclass: #PlatypusExpressNativeAlgorithmToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-CodeTokens'!

!PlatypusExpressNativeAlgorithmToken methodsFor: 'visiting' stamp: 'apl 2/10/2006 10:30'!
accept: aVisitor 
	^ aVisitor acceptNativeCode: self! !

!PlatypusExpressNativeAlgorithmToken methodsFor: 'converting' stamp: 'apl 2/10/2006 10:32'!
asPltRemark
	| pltRem |
	pltRem := PltEmbeddedRemark new.
	pltRem setText: self lexicalElement.
	^ pltRem! !

!PlatypusExpressNativeAlgorithmToken methodsFor: 'converting' stamp: 'apl 2/14/2006 12:05'!
asString
	^ '(*#' , self lexicalElement , '#*)'! !

!PlatypusExpressNativeAlgorithmToken methodsFor: 'formating' stamp: 'apl 2/14/2006 12:05'!
formatWithIndentString: aString 
	| newsub newLex |
	newsub := String cr , aString , '(*# '.
	newLex := ''.
	self lexicalElement
		linesDo: [:l | newLex isEmpty
				ifTrue: [newLex := l]
				ifFalse: [newLex := newLex , '#*)' , newsub , l]].
	self lexicalElement: newLex! !

!PlatypusExpressNativeAlgorithmToken methodsFor: 'testing' stamp: 'apl 2/10/2006 10:33'!
isNativeCode
	^ true! !

!PlatypusGenericToken class methodsFor: 'instance creation' stamp: 'apl 2/13/2003 21:14'!
token: anObject 

	^ self new lexicalElement: anObject ! !

!PlatypusGenericToken methodsFor: 'visiting' stamp: ''!
accept: aVisitor
	^aVisitor acceptToken: self! !

!PlatypusGenericToken methodsFor: 'converting' stamp: 'apl 2/24/2006 12:50'!
asString
	^ self lexicalElement isSymbol
		ifTrue: [self lexicalElement]
		ifFalse: [self lexicalElement asString]! !

!PlatypusGenericToken methodsFor: 'testing' stamp: 'apl 2/17/2006 13:08'!
is: aLexicalElement 
	(aLexicalElement isKindOf: Symbol)
		ifTrue: [^ self lexicalElement asString = aLexicalElement asString].
	^ (aLexicalElement
		detect: [:v | v == self lexicalElement]
		ifNone: []) notNil! !

!PlatypusGenericToken methodsFor: 'classification' stamp: ''!
isBlank
	^ self isWhiteSpace
		or: [self isIndent or: [self isEol]]! !

!PlatypusGenericToken methodsFor: 'classification' stamp: ''!
isBuiltinFunction
	^ false! !

!PlatypusGenericToken methodsFor: 'classification' stamp: ''!
isBuiltinProcedure
	^ false! !

!PlatypusGenericToken methodsFor: 'classification' stamp: ''!
isCloseDelim
^false! !

!PlatypusGenericToken methodsFor: 'classification' stamp: ''!
isCloseKeyword
^false! !

!PlatypusGenericToken methodsFor: 'classification' stamp: ''!
isEmbeddedRemark
	^ false! !

!PlatypusGenericToken methodsFor: 'classification' stamp: ''!
isEol
	^ false! !

!PlatypusGenericToken methodsFor: 'testing' stamp: 'apl 6/6/2003 13:40'!
isEquivalentTo: anotherToken 
	^ self = anotherToken! !

!PlatypusGenericToken methodsFor: 'classification' stamp: ''!
isGroupKeyword
^false! !

!PlatypusGenericToken methodsFor: 'classification' stamp: ''!
isIdentifier
	^ false! !

!PlatypusGenericToken methodsFor: 'classification' stamp: ''!
isIndent
	^ false! !

!PlatypusGenericToken methodsFor: 'classification' stamp: 'apl 2/28/2003 21:43'!
isKeyword
	^ false! !

!PlatypusGenericToken methodsFor: 'classification' stamp: 'apl 2/14/2003 09:55'!
isLogical
	^ false! !

!PlatypusGenericToken methodsFor: 'classification' stamp: 'apl 2/10/2006 10:34'!
isNativeCode
	^ false! !

!PlatypusGenericToken methodsFor: 'classification' stamp: 'apl 2/14/2003 09:49'!
isNumber
	^ false! !

!PlatypusGenericToken methodsFor: 'classification' stamp: 'apl 2/14/2003 09:49'!
isOpenDelim
	^ false
! !

!PlatypusGenericToken methodsFor: 'classification' stamp: ''!
isOpenKeyword
^false! !

!PlatypusGenericToken methodsFor: 'classification' stamp: ''!
isOperator
	^false! !

!PlatypusGenericToken methodsFor: 'classification' stamp: 'apl 11/13/2003 09:49'!
isPrimaryElementCloseKeyword
	^ false! !

!PlatypusGenericToken methodsFor: 'classification' stamp: 'apl 11/13/2003 09:49'!
isPrimaryElementOpenKeyword
	^ false! !

!PlatypusGenericToken methodsFor: 'classification' stamp: 'apl 11/13/2003 10:38'!
isPrimaryElementOpenKeyword: anArrayOfSymbol 
	^ self isPrimaryElementOpenKeyword
		and: [anArrayOfSymbol
				anySatisfy: [:s | s = self lexicalElement]]! !

!PlatypusGenericToken methodsFor: 'classification' stamp: ''!
isRemark
	^ false! !

!PlatypusGenericToken methodsFor: 'classification' stamp: ''!
isSemicolon
	^ false! !

!PlatypusGenericToken methodsFor: 'classification' stamp: 'apl 2/23/2005 22:07'!
isStepLiteral
	^ false! !

!PlatypusGenericToken methodsFor: 'classification' stamp: ''!
isString
	^ false! !

!PlatypusGenericToken methodsFor: 'classification' stamp: ''!
isTailRemark
	^ false! !

!PlatypusGenericToken methodsFor: 'classification' stamp: ''!
isWhiteSpace
	^false! !

!PlatypusGenericToken methodsFor: 'accessing' stamp: 'apl 2/14/2006 12:06'!
lexicalElement
	^ data! !

!PlatypusGenericToken methodsFor: 'accessing' stamp: 'apl 2/14/2006 12:07'!
lexicalElement: anObject 
	data := anObject! !

!PlatypusGenericToken methodsFor: 'printing' stamp: 'apl 2/24/2006 12:56'!
printOn: aStream 
	aStream nextPutAll: self class name.
			aStream nextPut: $(.
			aStream nextPutAll: self asString.
			aStream nextPut: $)! !

!PlatypusGenericToken methodsFor: 'accessing' stamp: 'apl 2/17/2006 12:21'!
startPos
	^ startPos! !

!PlatypusGenericToken methodsFor: 'accessing' stamp: 'apl 2/17/2006 12:21'!
startPos: anInteger
	 startPos := anInteger! !

!PlatypusGenericToken methodsFor: 'accessing' stamp: 'apl 2/17/2006 12:22'!
stopPos
	^ startPos + self lexicalElement size! !

!PlatypusGenericToken methodsFor: 'accessing' stamp: 'apl 2/17/2006 12:39'!
stopPosWithStart: aPosition
	startPos := aPosition.
	^ startPos + self asString size! !

!PlatypusGenericToken methodsFor: 'accessing' stamp: ''!
widthOfStringForFont: textFont
	textFont notNil ifTrue: [
	^ textFont widthOfString: self asString].
	^self asString size! !

PlatypusGenericToken subclass: #PlatypusIdentifierToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-CodeTokens'!

!PlatypusIdentifierToken methodsFor: 'visiting' stamp: ''!
accept: aVisitor 
	^ aVisitor acceptIdentifier: self! !

!PlatypusIdentifierToken methodsFor: 'testing' stamp: 'apl 6/6/2003 22:24'!
isEquivalentTo: anotherToken 
	^ ((anotherToken isKindOf: self class)
			or: [self isKindOf: anotherToken class])
		and: [self asString asUppercase = anotherToken asString asUppercase]! !

!PlatypusIdentifierToken methodsFor: 'testing' stamp: ''!
isIdentifier
	^true! !

PlatypusIdentifierToken subclass: #PlatypusPrimaryElementIdentifierToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-CodeTokens'!

PlatypusGenericToken subclass: #PlatypusIndentToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-CodeTokens'!

!PlatypusIndentToken class methodsFor: 'instance creation' stamp: 'apl 2/14/2006 12:10'!
new
	^ super new lexicalElement: String tab! !

!PlatypusIndentToken methodsFor: 'visiting' stamp: ''!
accept: aVisitor 
	^ aVisitor acceptIndent: self! !

!PlatypusIndentToken methodsFor: 'testing' stamp: ''!
isIndent
	^true! !

!PlatypusIndentToken methodsFor: 'accessing' stamp: 'apl 2/28/2003 17:15'!
widthOfStringForFont: textFont 
	textFont notNil
		ifTrue: [^ 50].
	^ 8! !

PlatypusGenericToken subclass: #PlatypusKeywordToken
	instanceVariableNames: ''
	classVariableNames: 'ForceToUppercase'
	poolDictionaries: ''
	category: 'Platypus-HW-CodeTokens'!

PlatypusKeywordToken subclass: #PlatypusBuiltinDomainToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-CodeTokens'!

!PlatypusBuiltinDomainToken methodsFor: 'visiting' stamp: ''!
accept: aVisitor 
	^ aVisitor acceptDomain: self! !

PlatypusKeywordToken subclass: #PlatypusBuiltinFunctionToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-CodeTokens'!

!PlatypusBuiltinFunctionToken class methodsFor: 'accessing' stamp: 'apl 2/14/2003 10:51'!
tokenStyle
	^#(#blue #normal)! !

!PlatypusBuiltinFunctionToken methodsFor: 'visiting' stamp: ''!
accept: aVisitor 
	^ aVisitor acceptBuiltinFunction: self! !

!PlatypusBuiltinFunctionToken methodsFor: 'testing' stamp: ''!
isBuiltinFunction
	^true! !

PlatypusKeywordToken subclass: #PlatypusBuiltinProcedureToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-CodeTokens'!

!PlatypusBuiltinProcedureToken methodsFor: 'visiting' stamp: ''!
accept: aVisitor 
	^ aVisitor acceptBuiltinProcedure: self! !

!PlatypusBuiltinProcedureToken methodsFor: 'testing' stamp: ''!
isBuiltinProcedure
	^ true! !

PlatypusKeywordToken subclass: #PlatypusCloseKeywordToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-CodeTokens'!

!PlatypusCloseKeywordToken methodsFor: 'visiting' stamp: ''!
accept: aVisitor 
	^ aVisitor acceptCloseKeyword: self! !

!PlatypusCloseKeywordToken methodsFor: 'testing' stamp: ''!
isCloseKeyword
	^true! !

PlatypusCloseKeywordToken subclass: #PlatypusPrimaryElementCloseKeywordToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-CodeTokens'!

!PlatypusPrimaryElementCloseKeywordToken methodsFor: 'Classification' stamp: 'apl 11/13/2003 09:50'!
isPrimaryElementCloseKeyword
	^ true! !

PlatypusKeywordToken subclass: #PlatypusGroupKeywordToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-CodeTokens'!

!PlatypusGroupKeywordToken methodsFor: 'visiting' stamp: ''!
accept: aVisitor 
	^ aVisitor acceptGroupKeyword: self! !

!PlatypusGroupKeywordToken methodsFor: 'testing' stamp: ''!
isGroupKeyword
	^true! !

!PlatypusKeywordToken class methodsFor: 'accessing' stamp: 'AlainPlantec 4/26/2012 10:28'!
forceToUppercase
	^ ForceToUppercase ifNil: [ForceToUppercase := true]! !

!PlatypusKeywordToken class methodsFor: 'accessing' stamp: 'AlainPlantec 10/7/2010 15:56'!
forceToUppercase: aBoolean 
	ForceToUppercase := aBoolean! !

!PlatypusKeywordToken class methodsFor: 'class initialization' stamp: 'apl 1/15/2007 16:05'!
initialize
	"self initialize"

	ForceToUppercase := true! !

!PlatypusKeywordToken class methodsFor: 'instance creation' stamp: 'apl 2/26/2003 18:16'!
token: anObject 
	^ super token: anObject asLowercase asSymbol! !

!PlatypusKeywordToken methodsFor: 'visiting' stamp: ''!
accept: aVisitor 
	^ aVisitor acceptKeyword: self! !

!PlatypusKeywordToken methodsFor: 'converting' stamp: 'apl 2/14/2006 12:06'!
asString
	self forceToUppercase
		ifTrue: [^ self lexicalElement asString asUppercase].
	^ self lexicalElement asString! !

!PlatypusKeywordToken methodsFor: 'accessing' stamp: ''!
forceToUppercase
	^ self class forceToUppercase! !

!PlatypusKeywordToken methodsFor: 'testing' stamp: 'apl 2/28/2003 21:43'!
isKeyword 
	^true! !

PlatypusKeywordToken subclass: #PlatypusOpenKeywordToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-CodeTokens'!

!PlatypusOpenKeywordToken methodsFor: 'visiting' stamp: ''!
accept: aVisitor 
	^ aVisitor acceptOpenKeyword: self! !

!PlatypusOpenKeywordToken methodsFor: 'testing' stamp: ''!
isOpenKeyword
	^true! !

PlatypusOpenKeywordToken subclass: #PlatypusPrimaryElementOpenKeywordToken
	instanceVariableNames: 'metaData'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-CodeTokens'!

!PlatypusPrimaryElementOpenKeywordToken methodsFor: 'initialize/release' stamp: 'apl 3/21/2006 19:18'!
destroy
	metaData := nil.
	super destroy! !

!PlatypusPrimaryElementOpenKeywordToken methodsFor: 'Classification' stamp: 'apl 11/13/2003 09:50'!
isPrimaryElementOpenKeyword
	^ true! !

!PlatypusPrimaryElementOpenKeywordToken methodsFor: 'accessing' stamp: 'apl 2/14/2006 19:13'!
metaData
	^metaData! !

!PlatypusPrimaryElementOpenKeywordToken methodsFor: 'accessing' stamp: 'apl 2/14/2006 19:13'!
metaData: anObject
	metaData := anObject! !

PlatypusKeywordToken subclass: #PlatypusOperatorToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-CodeTokens'!

PlatypusOperatorToken subclass: #PlatypusAssignToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-CodeTokens'!

!PlatypusAssignToken methodsFor: 'visiting' stamp: ''!
accept: aVisitor
	^aVisitor acceptAssign: self! !

!PlatypusAssignToken methodsFor: 'testing' stamp: ''!
isAssign
	^true! !

!PlatypusOperatorToken methodsFor: 'visiting' stamp: ''!
accept: aVisitor 
	^ aVisitor acceptOperator: self! !

!PlatypusOperatorToken methodsFor: 'testing' stamp: ''!
isOperator
	^true! !

PlatypusOperatorToken subclass: #PlatypusPlusToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-CodeTokens'!

!PlatypusPlusToken methodsFor: 'visiting' stamp: 'apl 12/12/2005 20:06'!
accept: aVisitor 
	^ aVisitor acceptPlus: self! !

PlatypusGenericToken subclass: #PlatypusLiteralToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-CodeTokens'!

!PlatypusLiteralToken methodsFor: 'visiting' stamp: 'apl 2/14/2003 10:41'!
accept: aVisitor 
	^ aVisitor acceptLiteral: self! !

!PlatypusLiteralToken methodsFor: 'testing' stamp: 'apl 2/23/2005 22:07'!
isStepLiteral
	^ true! !

PlatypusLiteralToken subclass: #PlatypusLogicalToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-CodeTokens'!

!PlatypusLogicalToken class methodsFor: 'instance creation' stamp: 'apl 2/26/2003 21:53'!
token: anObject 
	^ super token: anObject asLowercase asSymbol! !

!PlatypusLogicalToken methodsFor: 'visiting' stamp: 'apl 2/14/2003 10:42'!
accept: aVisitor 
	^ aVisitor acceptLogical: self! !

!PlatypusLogicalToken methodsFor: 'testing' stamp: 'apl 2/14/2003 09:59'!
isLogical
	^true! !

PlatypusLiteralToken subclass: #PlatypusNumberToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-CodeTokens'!

!PlatypusNumberToken methodsFor: 'visiting' stamp: 'apl 2/14/2003 10:42'!
accept: aVisitor 
	^ aVisitor acceptNumber: self! !

!PlatypusNumberToken methodsFor: 'testing' stamp: 'apl 2/14/2003 09:50'!
isNumber
	^ true! !

PlatypusLiteralToken subclass: #PlatypusStringToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-CodeTokens'!

!PlatypusStringToken methodsFor: 'visiting' stamp: 'apl 6/1/2004 11:16'!
accept: aVisitor
	^ aVisitor acceptString: self! !

!PlatypusStringToken methodsFor: 'testing' stamp: 'apl 6/1/2004 11:15'!
isString
	^ true! !

PlatypusGenericToken subclass: #PlatypusRemarkToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-CodeTokens'!

PlatypusRemarkToken subclass: #PlatypusEmbeddedRemarkToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-CodeTokens'!

!PlatypusEmbeddedRemarkToken class methodsFor: 'instance creation' stamp: ''!
token: anObject 
	^ self new lexicalElement: anObject! !

!PlatypusEmbeddedRemarkToken methodsFor: 'visiting' stamp: ''!
accept: aVisitor 
	^ aVisitor acceptEmbeddedRemark: self! !

!PlatypusEmbeddedRemarkToken methodsFor: 'converting' stamp: 'AlainPlantec 10/7/2010 13:44'!
asPltRemark
	| pltRem |
	pltRem := PltEmbeddedRemark new.
	pltRem setText: self lexicalElement.
	^ pltRem! !

!PlatypusEmbeddedRemarkToken methodsFor: 'converting' stamp: 'apl 2/14/2006 12:05'!
asString
	self lexicalElement size > 0
		ifTrue: [(self lexicalElement first == $"
					or: [self lexicalElement first == $<])
				ifTrue: [^ '(*' ,self lexicalElement , '*)']].
	^ '(*' ,self lexicalElement , '*)'! !

!PlatypusEmbeddedRemarkToken methodsFor: 'formating' stamp: 'apl 3/10/2006 15:17'!
formatWithIndentString: aString 
	| newLex lines |
	newLex := ''.
	lines := OrderedCollection new.
	self lexicalElement
		linesDo: [:l | lines add: l].
	lines
		do: [:l | newLex := newLex , l]
		separatedBy: [newLex := newLex , String cr, aString ].
	self lexicalElement: newLex! !

!PlatypusEmbeddedRemarkToken methodsFor: 'testing' stamp: ''!
isEmbeddedRemark
	^ true! !

!PlatypusRemarkToken methodsFor: 'visiting' stamp: ''!
accept: aVisitor 
	^ aVisitor acceptRemark: self! !

!PlatypusRemarkToken methodsFor: 'testing' stamp: ''!
isRemark
	^true! !

PlatypusRemarkToken subclass: #PlatypusTailRemarkToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-CodeTokens'!

!PlatypusTailRemarkToken class methodsFor: 'instance creation' stamp: 'apl 1/25/2007 11:13'!
token: anObject 
	^ self new lexicalElement: anObject! !

!PlatypusTailRemarkToken methodsFor: 'visiting' stamp: ''!
accept: aVisitor 
	^ aVisitor acceptTailRemark: self! !

!PlatypusTailRemarkToken methodsFor: 'converting' stamp: 'apl 3/11/2003 11:59'!
asPltRemark
	| pltRem |
	pltRem :=  PltTailRemark new.
	pltRem setText: self lexicalElement.
	^pltRem! !

!PlatypusTailRemarkToken methodsFor: 'converting' stamp: 'apl 2/14/2006 12:06'!
asString
	^ '--' , self lexicalElement! !

!PlatypusTailRemarkToken methodsFor: 'testing' stamp: ''!
isTailRemark
	^ true! !

PlatypusGenericToken subclass: #PlatypusUnresolvedReferenceToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-CodeTokens'!

PlatypusGenericToken subclass: #PlatypusWhiteSpaceToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-CodeTokens'!

PlatypusWhiteSpaceToken subclass: #PlatypusOneWhiteSpaceToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-CodeTokens'!

!PlatypusOneWhiteSpaceToken class methodsFor: 'instance creation' stamp: 'apl 2/17/2006 12:26'!
new
	^ super new lexicalElement: Character space! !

!PlatypusWhiteSpaceToken methodsFor: 'visiting' stamp: ''!
accept: aVisitor
	^aVisitor acceptWhiteSpace: self! !

!PlatypusWhiteSpaceToken methodsFor: 'testing' stamp: ''!
isWhiteSpace

	^ true! !

!PltDNode class methodsFor: 'instance creation' stamp: ''!
data: data 
	| node |
	node := self new. node data: data. ^ node! !

!PltDNode class methodsFor: 'instance creation' stamp: ''!
new
	^ super new initialize! !

!PltDNode class methodsFor: 'instance creation' stamp: ''!
previous: previousNode next: nextNode data: data 
	| node |
	node := self new.
	node previous: previousNode; next: nextNode; data: data.
	^node! !

!PltDNode methodsFor: 'converting' stamp: 'apl 4/6/2004 11:47'!
asString
	^data asString! !

!PltDNode methodsFor: 'accessing' stamp: 'apl 4/6/2004 11:47'!
data
	^data! !

!PltDNode methodsFor: 'accessing' stamp: 'AlainPlantec 10/7/2010 16:28'!
data: anObject 
	data := anObject! !

!PltDNode methodsFor: 'initialize/release' stamp: 'apl 6/3/2005 16:50'!
destroy
	next := nil.
	previous := nil.
	data := nil.
	super destroy! !

!PltDNode methodsFor: 'initialize/release' stamp: 'apl 3/6/2004 10:41'!
initialize
	super initialize.
	next := nil.
	previous := nil.
	data := nil! !

!PltDNode methodsFor: 'accessing' stamp: ''!
next
	^next! !

!PltDNode methodsFor: 'accessing' stamp: ''!
next: anObject
	next := anObject! !

!PltDNode methodsFor: 'accessing' stamp: ''!
nextLink
	^ next! !

!PltDNode methodsFor: 'accessing' stamp: 'AlainPlantec 10/7/2010 16:28'!
nextLink: anObject 
	next := anObject! !

!PltDNode methodsFor: 'copying' stamp: 'apl 2/14/2006 18:12'!
postCopy
	data := data copy! !

!PltDNode methodsFor: 'accessing' stamp: 'apl 2/14/2006 18:12'!
previous
	^previous! !

!PltDNode methodsFor: 'accessing' stamp: 'AlainPlantec 10/7/2010 16:29'!
previous: anObject 
previous := anObject! !

!PltDNode methodsFor: 'accessing' stamp: 'AlainPlantec 10/7/2010 16:29'!
previous: anObject next: anotherObject 
	previous := anObject.
	next := anotherObject! !

!PltDNode methodsFor: 'printing' stamp: 'apl 2/14/2006 18:12'!
printOn: aStream 
	aStream nextPutAll: self class name, '('.
	data printOn: aStream.
	aStream nextPutAll: ')'! !

Object subclass: #PltEntityInstance
	instanceVariableNames: 'owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltEntityInstance commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY entity_instance 
	ABSTRACT SUPERTYPE;
	owner : OPTIONAL entity_instance;
END_ENTITY;
</ISO10303-11-EXPRESS>!

PltEntityInstance subclass: #PltApplicationInstance
	instanceVariableNames: 'persistentLabel owningModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusPopulationSchemaSchema'!

!PltApplicationInstance commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY application_instance 
	ABSTRACT SUPERTYPE 
	SUBTYPE OF ( entity_instance );
	owning_model : model_contents;
	persistent_label : STRING;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltApplicationInstance class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltApplicationInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltApplicationInstance class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltApplicationInstance class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusPopulationSchemaSchemaDefinition singleton

! !

!PltApplicationInstance class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltApplicationInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltApplicationInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltApplicationInstance methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptApplicationInstance: self

! !

!PltApplicationInstance methodsFor: 'platypus-generated-copying' stamp: ''!
applicationInstanceCopyTo: another
	another fastSetOwningModel: self owningModel.
	another fastSetPersistentLabel: self persistentLabel

! !

!PltApplicationInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
applicationInstanceFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setOwningModel: valuesloc removeFirst.
	self setPersistentLabel: valuesloc removeFirst.
	^ valuesloc

! !

!PltApplicationInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
applicationInstanceToValues: values
	values add: self owningModel.
	values add: self persistentLabel.
	^ values

! !

!PltApplicationInstance methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetOwningModel: aPltModelContents
	owningModel := aPltModelContents

! !

!PltApplicationInstance methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetPersistentLabel: aString
	persistentLabel := aString

! !

!PltApplicationInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self applicationInstanceFromValues: (super fromValues: values)

! !

!PltApplicationInstance methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltApplicationInstance
	^ true

! !

!PltApplicationInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self applicationInstanceFromValues: values

! !

!PltApplicationInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self applicationInstanceToValues: values

! !

!PltApplicationInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
owningModel
	^ owningModel

! !

!PltApplicationInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
owningModel: aPltModelContents
	owningModel := aPltModelContents

! !

!PltApplicationInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
owningModel: aPltModelContents persistentLabel: aString 	self setOwningModel:aPltModelContents.	self setPersistentLabel:aString.

! !

!PltApplicationInstance methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
owningModelUsingContext: aContext
	^ self owningModel

! !

!PltApplicationInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
persistentLabel
	^ persistentLabel

! !

!PltApplicationInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
persistentLabel: aString
	persistentLabel := aString

! !

!PltApplicationInstance methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
persistentLabelUsingContext: aContext
	^ self persistentLabel

! !

!PltApplicationInstance methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltApplicationInstance methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self applicationInstanceCopyTo: another

! !

!PltApplicationInstance methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self applicationInstanceCopyTo: another

! !

!PltApplicationInstance methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setOwningModel: aPltModelContents
	self owningModel: aPltModelContents

! !

!PltApplicationInstance methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setPersistentLabel: aString
	self persistentLabel: aString

! !

!PltApplicationInstance methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	owningModel := nil.
	persistentLabel := ''

! !

!PltApplicationInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self applicationInstanceToValues: (super toValues: values)

! !

PltApplicationInstance subclass: #PltGenericInstance
	instanceVariableNames: 'instanceScope computed scope'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusPopulationSchemaSchema'!

!PltGenericInstance commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY generic_instance 
	ABSTRACT SUPERTYPE 
	SUBTYPE OF ( application_instance );
	instance_scope : OPTIONAL instance_scope;
END_ENTITY;
</ISO10303-11-EXPRESS>!

PltGenericInstance subclass: #PltExternalRepresentation
	instanceVariableNames: 'records'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusPopulationSchemaSchema'!

!PltExternalRepresentation commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY external_representation 
	SUBTYPE OF ( generic_instance );
	records : LIST OF simple_record;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltExternalRepresentation class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltExternalRepresentation class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltExternalRepresentation class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltExternalRepresentation class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusPopulationSchemaSchemaDefinition singleton

! !

!PltExternalRepresentation class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltExternalRepresentation class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltExternalRepresentation class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltExternalRepresentation methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptExternalRepresentation: self

! !

!PltExternalRepresentation methodsFor: 'platypus-generated-copying' stamp: ''!
externalRepresentationCopyTo: another
	another fastSetRecords: self records

! !

!PltExternalRepresentation methodsFor: 'platypus-generated-group-accessing' stamp: ''!
externalRepresentationFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setRecords: valuesloc removeFirst.
	^ valuesloc

! !

!PltExternalRepresentation methodsFor: 'platypus-generated-group-accessing' stamp: ''!
externalRepresentationToValues: values
	values add: self records.
	^ values

! !

!PltExternalRepresentation methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetRecords: aListOfPltSimpleRecord
	records := aListOfPltSimpleRecord

! !

!PltExternalRepresentation methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self externalRepresentationFromValues: (super fromValues: values)

! !

!PltExternalRepresentation methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltExternalRepresentation
	^ true

! !

!PltExternalRepresentation methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self externalRepresentationFromValues: values

! !

!PltExternalRepresentation methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self externalRepresentationToValues: values

! !

!PltExternalRepresentation methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltExternalRepresentation methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self externalRepresentationCopyTo: another

! !

!PltExternalRepresentation methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self externalRepresentationCopyTo: another

! !

!PltExternalRepresentation methodsFor: 'platypus-generated-accessing' stamp: ''!
records
	^ records

! !

!PltExternalRepresentation methodsFor: 'platypus-generated-accessing' stamp: ''!
records: aListOfPltSimpleRecord
	records := aListOfPltSimpleRecord
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfPltSimpleRecord as: OrderedCollection ]

! !

!PltExternalRepresentation methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
recordsUsingContext: aContext
	^ self records

! !

!PltExternalRepresentation methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setRecords: aListOfPltSimpleRecord
	self records: aListOfPltSimpleRecord

! !

!PltExternalRepresentation methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	records := OrderedCollection new

! !

!PltExternalRepresentation methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self externalRepresentationToValues: (super toValues: values)

! !

!PltGenericInstance class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltGenericInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltGenericInstance class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltGenericInstance class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusPopulationSchemaSchemaDefinition singleton

! !

!PltGenericInstance class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltGenericInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltGenericInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltGenericInstance methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptGenericInstance: self

! !

!PltGenericInstance methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetInstanceScope: aPltInstanceScope
	instanceScope := aPltInstanceScope

! !

!PltGenericInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self genericInstanceFromValues: (super fromValues: values)

! !

!PltGenericInstance methodsFor: 'platypus-generated-copying' stamp: ''!
genericInstanceCopyTo: another
	another fastSetInstanceScope: self instanceScope

! !

!PltGenericInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
genericInstanceFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setInstanceScope: valuesloc removeFirst.
	^ valuesloc

! !

!PltGenericInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
genericInstanceToValues: values
	values add: self instanceScope.
	^ values

! !

!PltGenericInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
instanceScope
	^ instanceScope

! !

!PltGenericInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
instanceScope: aPltInstanceScope
	instanceScope := aPltInstanceScope

! !

!PltGenericInstance methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
instanceScopeUsingContext: aContext
	^ self instanceScope

! !

!PltGenericInstance methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltGenericInstance
	^ true

! !

!PltGenericInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self genericInstanceFromValues: values

! !

!PltGenericInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self genericInstanceToValues: values

! !

!PltGenericInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
owner
	^ owner

! !

!PltGenericInstance methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltGenericInstance methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self genericInstanceCopyTo: another

! !

!PltGenericInstance methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self genericInstanceCopyTo: another

! !

!PltGenericInstance methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setInstanceScope: aPltInstanceScope
	self instanceScope: aPltInstanceScope

! !

!PltGenericInstance methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	instanceScope := nil

! !

!PltGenericInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self genericInstanceToValues: (super toValues: values)

! !

PltGenericInstance subclass: #PltGroupRepresentation
	instanceVariableNames: 'definition instRef'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusPopulationSchemaSchema'!

!PltGroupRepresentation commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY group_representation 
	ABSTRACT SUPERTYPE 
	SUBTYPE OF ( generic_instance );
	definition : entity_definition_reference;
	instRef : generic_instance;
END_ENTITY;
</ISO10303-11-EXPRESS>!

PltGroupRepresentation subclass: #PltExternalGroupRepresentation
	instanceVariableNames: 'recordsCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusPopulationSchemaSchema'!

!PltExternalGroupRepresentation commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY external_group_representation 
	SUBTYPE OF ( group_representation );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltExternalGroupRepresentation class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltExternalGroupRepresentation class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltExternalGroupRepresentation class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltExternalGroupRepresentation class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusPopulationSchemaSchemaDefinition singleton

! !

!PltExternalGroupRepresentation class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltExternalGroupRepresentation class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltExternalGroupRepresentation class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltExternalGroupRepresentation methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptExternalGroupRepresentation: self

! !

!PltExternalGroupRepresentation methodsFor: 'platypus-generated-copying' stamp: ''!
externalGroupRepresentationCopyTo: another
	

! !

!PltExternalGroupRepresentation methodsFor: 'platypus-generated-group-accessing' stamp: ''!
externalGroupRepresentationFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltExternalGroupRepresentation methodsFor: 'platypus-generated-group-accessing' stamp: ''!
externalGroupRepresentationToValues: values
	^ values

! !

!PltExternalGroupRepresentation methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self externalGroupRepresentationFromValues: (super fromValues: values)

! !

!PltExternalGroupRepresentation methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltExternalGroupRepresentation
	^ true

! !

!PltExternalGroupRepresentation methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self externalGroupRepresentationFromValues: values

! !

!PltExternalGroupRepresentation methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self externalGroupRepresentationToValues: values

! !

!PltExternalGroupRepresentation methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltExternalGroupRepresentation methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self externalGroupRepresentationCopyTo: another

! !

!PltExternalGroupRepresentation methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self externalGroupRepresentationCopyTo: another

! !

!PltExternalGroupRepresentation methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltExternalGroupRepresentation methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self externalGroupRepresentationToValues: (super toValues: values)

! !

!PltGroupRepresentation class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltGroupRepresentation class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltGroupRepresentation class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltGroupRepresentation class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusPopulationSchemaSchemaDefinition singleton

! !

!PltGroupRepresentation class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltGroupRepresentation class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltGroupRepresentation class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltGroupRepresentation methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptGroupRepresentation: self

! !

!PltGroupRepresentation methodsFor: 'platypus-generated-accessing' stamp: ''!
definition
	^ definition

! !

!PltGroupRepresentation methodsFor: 'platypus-generated-accessing' stamp: ''!
definition: aPltEntityDefinitionReference
	definition := aPltEntityDefinitionReference

! !

!PltGroupRepresentation methodsFor: 'platypus-generated-group-accessing' stamp: ''!
definition: aPltEntityDefinitionReference instRef: aPltGenericInstanceReference 	self setDefinition:aPltEntityDefinitionReference.	self setInstRef:aPltGenericInstanceReference.

! !

!PltGroupRepresentation methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
definitionUsingContext: aContext
	^ self definition

! !

!PltGroupRepresentation methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetDefinition: aPltEntityDefinitionReference
	definition := aPltEntityDefinitionReference

! !

!PltGroupRepresentation methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetInstRef: aPltGenericInstance
	instRef := aPltGenericInstance

! !

!PltGroupRepresentation methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self groupRepresentationFromValues: (super fromValues: values)

! !

!PltGroupRepresentation methodsFor: 'platypus-generated-copying' stamp: ''!
groupRepresentationCopyTo: another
	another fastSetDefinition: self definition.
	another fastSetInstRef: self instRef

! !

!PltGroupRepresentation methodsFor: 'platypus-generated-group-accessing' stamp: ''!
groupRepresentationFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setDefinition: valuesloc removeFirst.
	self setInstRef: valuesloc removeFirst.
	^ valuesloc

! !

!PltGroupRepresentation methodsFor: 'platypus-generated-group-accessing' stamp: ''!
groupRepresentationToValues: values
	values add: self definition.
	values add: self instRef.
	^ values

! !

!PltGroupRepresentation methodsFor: 'platypus-generated-accessing' stamp: ''!
instRef
	^ instRef

! !

!PltGroupRepresentation methodsFor: 'platypus-generated-accessing' stamp: ''!
instRef: aPltGenericInstance
	instRef := aPltGenericInstance

! !

!PltGroupRepresentation methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
instRefUsingContext: aContext
	^ self instRef

! !

!PltGroupRepresentation methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltGroupRepresentation
	^ true

! !

!PltGroupRepresentation methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self groupRepresentationFromValues: values

! !

!PltGroupRepresentation methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self groupRepresentationToValues: values

! !

!PltGroupRepresentation methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltGroupRepresentation methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self groupRepresentationCopyTo: another

! !

!PltGroupRepresentation methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self groupRepresentationCopyTo: another

! !

!PltGroupRepresentation methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setDefinition: aPltEntityDefinitionReference
	self definition: aPltEntityDefinitionReference

! !

!PltGroupRepresentation methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setInstRef: aPltGenericInstance
	self instRef: aPltGenericInstance

! !

!PltGroupRepresentation methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	definition := nil.
	instRef := nil

! !

!PltGroupRepresentation methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self groupRepresentationToValues: (super toValues: values)

! !

PltGroupRepresentation subclass: #PltInternalGroupRepresentation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusPopulationSchemaSchema'!

!PltInternalGroupRepresentation commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY internal_group_representation 
	SUBTYPE OF ( group_representation );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltInternalGroupRepresentation class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltInternalGroupRepresentation class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltInternalGroupRepresentation class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltInternalGroupRepresentation class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusPopulationSchemaSchemaDefinition singleton

! !

!PltInternalGroupRepresentation class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltInternalGroupRepresentation class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltInternalGroupRepresentation class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltInternalGroupRepresentation methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptInternalGroupRepresentation: self

! !

!PltInternalGroupRepresentation methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self internalGroupRepresentationFromValues: (super fromValues: values)

! !

!PltInternalGroupRepresentation methodsFor: 'platypus-generated-copying' stamp: ''!
internalGroupRepresentationCopyTo: another
	

! !

!PltInternalGroupRepresentation methodsFor: 'platypus-generated-group-accessing' stamp: ''!
internalGroupRepresentationFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltInternalGroupRepresentation methodsFor: 'platypus-generated-group-accessing' stamp: ''!
internalGroupRepresentationToValues: values
	^ values

! !

!PltInternalGroupRepresentation methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltInternalGroupRepresentation
	^ true

! !

!PltInternalGroupRepresentation methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self internalGroupRepresentationFromValues: values

! !

!PltInternalGroupRepresentation methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self internalGroupRepresentationToValues: values

! !

!PltInternalGroupRepresentation methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltInternalGroupRepresentation methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self internalGroupRepresentationCopyTo: another

! !

!PltInternalGroupRepresentation methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self internalGroupRepresentationCopyTo: another

! !

!PltInternalGroupRepresentation methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltInternalGroupRepresentation methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self internalGroupRepresentationToValues: (super toValues: values)

! !

PltGenericInstance subclass: #PltInternalRepresentation
	instanceVariableNames: 'definition parameters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusPopulationSchemaSchema'!

!PltInternalRepresentation commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY internal_representation 
	SUBTYPE OF ( generic_instance );
	definition : entity_definition_reference;
	parameters : LIST OF primitive;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltInternalRepresentation class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltInternalRepresentation class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltInternalRepresentation class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltInternalRepresentation class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusPopulationSchemaSchemaDefinition singleton

! !

!PltInternalRepresentation class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltInternalRepresentation class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltInternalRepresentation class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltInternalRepresentation methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptInternalRepresentation: self

! !

!PltInternalRepresentation methodsFor: 'platypus-generated-accessing' stamp: ''!
definition
	^ definition

! !

!PltInternalRepresentation methodsFor: 'platypus-generated-accessing' stamp: ''!
definition: aPltEntityDefinitionReference
	definition := aPltEntityDefinitionReference

! !

!PltInternalRepresentation methodsFor: 'platypus-generated-group-accessing' stamp: ''!
definition: aPltEntityDefinitionReference parameters: aListOfPltExpression 	self setDefinition:aPltEntityDefinitionReference.	self setParameters:aListOfPltExpression.

! !

!PltInternalRepresentation methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
definitionUsingContext: aContext
	^ self definition

! !

!PltInternalRepresentation methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetDefinition: aPltEntityDefinitionReference
	definition := aPltEntityDefinitionReference

! !

!PltInternalRepresentation methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetParameters: aListOfPltExpression
	parameters := aListOfPltExpression

! !

!PltInternalRepresentation methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self internalRepresentationFromValues: (super fromValues: values)

! !

!PltInternalRepresentation methodsFor: 'platypus-generated-copying' stamp: ''!
internalRepresentationCopyTo: another
	another fastSetDefinition: self definition.
	another fastSetParameters: self parameters

! !

!PltInternalRepresentation methodsFor: 'platypus-generated-group-accessing' stamp: ''!
internalRepresentationFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setDefinition: valuesloc removeFirst.
	self setParameters: valuesloc removeFirst.
	^ valuesloc

! !

!PltInternalRepresentation methodsFor: 'platypus-generated-group-accessing' stamp: ''!
internalRepresentationToValues: values
	values add: self definition.
	values add: self parameters.
	^ values

! !

!PltInternalRepresentation methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltInternalRepresentation
	^ true

! !

!PltInternalRepresentation methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self internalRepresentationFromValues: values

! !

!PltInternalRepresentation methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self internalRepresentationToValues: values

! !

!PltInternalRepresentation methodsFor: 'platypus-generated-accessing' stamp: ''!
parameters
	^ parameters

! !

!PltInternalRepresentation methodsFor: 'platypus-generated-accessing' stamp: ''!
parameters: aListOfPltExpression
	parameters := aListOfPltExpression
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfPltExpression as: OrderedCollection ]

! !

!PltInternalRepresentation methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
parametersUsingContext: aContext
	^ self parameters

! !

!PltInternalRepresentation methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltInternalRepresentation methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self internalRepresentationCopyTo: another

! !

!PltInternalRepresentation methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self internalRepresentationCopyTo: another

! !

!PltInternalRepresentation methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setDefinition: aPltEntityDefinitionReference
	self definition: aPltEntityDefinitionReference

! !

!PltInternalRepresentation methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setParameters: aListOfPltExpression
	self parameters: aListOfPltExpression

! !

!PltInternalRepresentation methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	definition := nil.
	parameters := OrderedCollection new

! !

!PltInternalRepresentation methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self internalRepresentationToValues: (super toValues: values)

! !

PltApplicationInstance subclass: #PltUserDefinedApplicationInstance
	instanceVariableNames: 'name parameters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusPopulationSchemaSchema'!

!PltUserDefinedApplicationInstance commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY user_defined_application_instance 
	SUBTYPE OF ( application_instance );
	name : STRING;
	parameters : LIST OF primitive;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltUserDefinedApplicationInstance class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltUserDefinedApplicationInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltUserDefinedApplicationInstance class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltUserDefinedApplicationInstance class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusPopulationSchemaSchemaDefinition singleton

! !

!PltUserDefinedApplicationInstance class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltUserDefinedApplicationInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltUserDefinedApplicationInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltUserDefinedApplicationInstance methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptUserDefinedApplicationInstance: self

! !

!PltUserDefinedApplicationInstance methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetName: aString
	name := aString

! !

!PltUserDefinedApplicationInstance methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetParameters: aListOfPltExpression
	parameters := aListOfPltExpression

! !

!PltUserDefinedApplicationInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self userDefinedApplicationInstanceFromValues: (super fromValues: values)

! !

!PltUserDefinedApplicationInstance methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltUserDefinedApplicationInstance
	^ true

! !

!PltUserDefinedApplicationInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self userDefinedApplicationInstanceFromValues: values

! !

!PltUserDefinedApplicationInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self userDefinedApplicationInstanceToValues: values

! !

!PltUserDefinedApplicationInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
name
	^ name

! !

!PltUserDefinedApplicationInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
name: aString
	name := aString

! !

!PltUserDefinedApplicationInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
name: aString parameters: aListOfPltExpression 	self setName:aString.	self setParameters:aListOfPltExpression.

! !

!PltUserDefinedApplicationInstance methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
nameUsingContext: aContext
	^ self name

! !

!PltUserDefinedApplicationInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
parameters
	^ parameters

! !

!PltUserDefinedApplicationInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
parameters: aListOfPltExpression
	parameters := aListOfPltExpression
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfPltExpression as: OrderedCollection ]

! !

!PltUserDefinedApplicationInstance methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
parametersUsingContext: aContext
	^ self parameters

! !

!PltUserDefinedApplicationInstance methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltUserDefinedApplicationInstance methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self userDefinedApplicationInstanceCopyTo: another

! !

!PltUserDefinedApplicationInstance methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self userDefinedApplicationInstanceCopyTo: another

! !

!PltUserDefinedApplicationInstance methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setName: aString
	self name: aString

! !

!PltUserDefinedApplicationInstance methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setParameters: aListOfPltExpression
	self parameters: aListOfPltExpression

! !

!PltUserDefinedApplicationInstance methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	name := ''.
	parameters := OrderedCollection new

! !

!PltUserDefinedApplicationInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self userDefinedApplicationInstanceToValues: (super toValues: values)

! !

!PltUserDefinedApplicationInstance methodsFor: 'platypus-generated-copying' stamp: ''!
userDefinedApplicationInstanceCopyTo: another
	another fastSetName: self name.
	another fastSetParameters: self parameters

! !

!PltUserDefinedApplicationInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
userDefinedApplicationInstanceFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setName: valuesloc removeFirst.
	self setParameters: valuesloc removeFirst.
	^ valuesloc

! !

!PltUserDefinedApplicationInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
userDefinedApplicationInstanceToValues: values
	values add: self name.
	values add: self parameters.
	^ values

! !

!PltEntityInstance class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context
	^ self schemaDefinition context

! !

!PltEntityInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltEntityInstance class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData
	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltEntityInstance class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltEntityInstance class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltEntityInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltEntityInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltEntityInstance methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptEntityInstance: self

! !

!PltEntityInstance methodsFor: 'platypus-generated-copying' stamp: ''!
entityInstanceCopyTo: another
	another fastSetOwner: self owner

! !

!PltEntityInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
entityInstanceFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setOwner: valuesloc removeFirst.
	^ valuesloc

! !

!PltEntityInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
entityInstanceToValues: values
	values add: self owner.
	^ values

! !

!PltEntityInstance methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetOwner: aPltEntityInstance
	owner := aPltEntityInstance

! !

!PltEntityInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self entityInstanceFromValues: (super fromValues: values)

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltAggrUnaryExpression
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusAggregateDataSchemaSchema-classifying' stamp: ''!
isPltAggregateData
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusAggregateDataSchemaSchema-classifying' stamp: ''!
isPltAggregateInitializer
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltAggregateInitializerDomain
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusAggregateDataSchemaSchema-classifying' stamp: ''!
isPltAggregateInitializerElement
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusAggregateDataSchemaSchema-classifying' stamp: ''!
isPltAggregateInstance
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltAggregateType
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltAggregationType
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltAlgorithmDeclaration
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltAlgorithmRef ^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusStatementsSchemaSchema-classifying' stamp: ''!
isPltAliasStatement
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusStatementsSchemaSchema-classifying' stamp: ''!
isPltAliasStatementVariable
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltAndExpression
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltAndSupertype
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltAndorSupertype
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusStatementsSchemaSchema-classifying' stamp: ''!
isPltAnonymousVariable
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusPopulationSchemaSchema-classifying' stamp: ''!
isPltApplicationInstance
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltArithmeticExpression
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusAggregateDataSchemaSchema-classifying' stamp: ''!
isPltArrayInstance
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltArrayType
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusStatementsSchemaSchema-classifying' stamp: ''!
isPltAssignable
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusStatementsSchemaSchema-classifying' stamp: ''!
isPltAssignmentStatement
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltAttribute
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltAttributeIdentifier
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltAttributeQualifier
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltAttributeReference
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusAggregateDataSchemaSchema-classifying' stamp: ''!
isPltBagInstance
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltBagType
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltBinaryExpression
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltBinaryLiteral
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltBinarySupertypeExpression
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltBinaryType
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltBooleanType
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltBound
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltCardinalityExpression
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusStatementsSchemaSchema-classifying' stamp: ''!
isPltCaseAction
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusStatementsSchemaSchema-classifying' stamp: ''!
isPltCaseStatement
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltComparisonExpression
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusStatementsSchemaSchema-classifying' stamp: ''!
isPltCompoundStatement
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltConstantDefinition
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltContextDefinition
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltContextRef ^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltDefinedType
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltDefinedTypeReference
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltDerivedAttribute
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltDictionaryInstance
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltDictionaryInstanceReference
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltDivExpression
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltDomainEquivalentItem
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltEConstant
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltElementQualifier
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltElementRef ^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltEmbeddedRemark
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusStatementsSchemaSchema-classifying' stamp: ''!
isPltEndSplitmarkStatement
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltEntityDefinition
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltEntityDefinitionReference
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltEntityInstance
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltEntityInstanceConstructor
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltEntityInstanceReference
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltEntityInstancesSet
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltEnumerationType
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltEnumerationValue
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltEqualExpression
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusStatementsSchemaSchema-classifying' stamp: ''!
isPltEscapeStatement
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltEscapedExpression
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltExplicitAttribute
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltExpoExpression
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltExpression
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusPopulationSchemaSchema-classifying' stamp: ''!
isPltExternalGroupRepresentation
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltExternalMetaSchema
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusPopulationSchemaSchema-classifying' stamp: ''!
isPltExternalRepresentation
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltExternalSchema
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltFalseConstant
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusPopulationSchemaSchema-classifying' stamp: ''!
isPltFileDescription
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusPopulationSchemaSchema-classifying' stamp: ''!
isPltFileName
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusPopulationSchemaSchema-classifying' stamp: ''!
isPltFileSchema
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltFunctionDeclaration
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltGeneralAggregateType
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusPopulationSchemaSchema-classifying' stamp: ''!
isPltGenericInstance
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltGenericType
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltGlobalRule
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltGreaterEqualExpression
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltGreaterThanExpression
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltGroupQualifier
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusPopulationSchemaSchema-classifying' stamp: ''!
isPltGroupRepresentation
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusPopulationSchemaSchema-classifying' stamp: ''!
isPltHeaderInstance
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltIdentifier
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusStatementsSchemaSchema-classifying' stamp: ''!
isPltIfStatement
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltImplicitlyDeclaredIdentifier
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltInExpression
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltIncludeSchema
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusStatementsSchemaSchema-classifying' stamp: ''!
isPltIncrementControl
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusStatementsSchemaSchema-classifying' stamp: ''!
isPltIncrementControlVariable
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltIndexQualifier
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltInstComparisonExpression
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltInstEqualExpression
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltInstNotEqualExpression
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltInstanceConstructionExpression
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusPopulationSchemaSchema-classifying' stamp: ''!
isPltInstanceScope
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltIntegerBound
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltIntegerLiteral
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltIntegerType
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusPopulationSchemaSchema-classifying' stamp: ''!
isPltInternalGroupRepresentation
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusPopulationSchemaSchema-classifying' stamp: ''!
isPltInternalRepresentation
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltInterval
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltInverseAttribute
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltLessEqualExpression
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltLessThanExpression
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltLikeExpression
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusAggregateDataSchemaSchema-classifying' stamp: ''!
isPltListInstance
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltListType
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltLiteral
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltLocalVariable
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltLogicalExpression
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltLogicalLiteral
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltLogicalType
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltMetaConceptDefinition
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltMetaMappingDefinition
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltMetaMappingRule
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltMinusExpression
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltMissingValue
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltModExpression
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusEnvironmentSchemaSchema-classifying' stamp: ''!
isPltModelContents
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltMultExpression
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltNamedType
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltNamedTypeRef ^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltNamedTypeReference
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltNativeAlgorithm
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltNativeCode
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltNativeExpression
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusStatementsSchemaSchema-classifying' stamp: ''!
isPltNativeStatement
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltNegativeExpression
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltNotEqualExpression
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltNotExpression
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusStatementsSchemaSchema-classifying' stamp: ''!
isPltNullStatement
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltNumberType
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltNumericLiteral
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltOneofSupertypeExpression
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltOrExpression
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusStatementsSchemaSchema-classifying' stamp: ''!
isPltOutputStatement
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltParameterDefinition
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltPiConstant
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltPlusExpression
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltPopulationDependentBound
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltPositiveExpression
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusStatementsSchemaSchema-classifying' stamp: ''!
isPltProcedureCallStatement
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltProcedureDeclaration
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltQualifiedExpression
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltQualifier
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltQueryExpression
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltQueryVariable
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltRangeQualifier
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltRealDivExpression
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltRealLiteral
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltRealType
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltRedefinedAttributeValue
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltReferencedSchema
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltRemark
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltRemarkReference
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusStatementsSchemaSchema-classifying' stamp: ''!
isPltRepeatStatement
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusStatementsSchemaSchema-classifying' stamp: ''!
isPltReturnStatement
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltRuleRef ^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltSchemaDefinition
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusEnvironmentSchemaSchema-classifying' stamp: ''!
isPltSchemaInstance
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltSchemaInstanceRef ^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltSchemaRef ^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltSdaiInstance
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltSelectType
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltSelfIdentifier
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltSessionInstance
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusAggregateDataSchemaSchema-classifying' stamp: ''!
isPltSetInstance
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltSetType
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusPopulationSchemaSchema-classifying' stamp: ''!
isPltSimpleRecord
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltSimpleType
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltSimpleUnaryExpression
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusStatementsSchemaSchema-classifying' stamp: ''!
isPltSkipStatement
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusStatementsSchemaSchema-classifying' stamp: ''!
isPltSplitmarkStatement
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusStatementsSchemaSchema-classifying' stamp: ''!
isPltStatement
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltStatementsContainer
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltStringLiteral
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltStringType
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltSubEntityRefExpression
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltSupertypeConstraint
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltSupertypeExpression
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltTailRemark
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltTrueConstant
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltTypedExpression
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltUnaryExpression
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltUniquenessRule
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltUniquenessRuleAttributeIdentifier
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltUnknownConstant
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltUsedSchema
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusPopulationSchemaSchema-classifying' stamp: ''!
isPltUserDefinedApplicationInstance
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusPopulationSchemaSchema-classifying' stamp: ''!
isPltUserDefinedHeaderInstance
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusAggregateDataSchemaSchema-classifying' stamp: ''!
isPltVariableSizeAggregationInstance
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltVariableSizeAggregationType
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusDictionarySchemaSchema-classifying' stamp: ''!
isPltWhereRule
	^ false

! !

!PltEntityInstance methodsFor: '*Platypus-PlatypusExpressionsSchemaSchema-classifying' stamp: ''!
isPltXorExpression
	^ false

! !

!PltEntityInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self entityInstanceFromValues: values

! !

!PltEntityInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self entityInstanceToValues: values

! !

!PltEntityInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
owner
	^ owner

! !

!PltEntityInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
owner: aPltEntityInstance
	owner := aPltEntityInstance

! !

!PltEntityInstance methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
ownerUsingContext: aContext
	^ self owner

! !

!PltEntityInstance methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData
	^ self class platypusMetaData

! !

!PltEntityInstance methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltEntityInstance methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self entityInstanceCopyTo: another

! !

!PltEntityInstance methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self entityInstanceCopyTo: another

! !

!PltEntityInstance methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setOwner: aPltEntityInstance
	self owner: aPltEntityInstance

! !

!PltEntityInstance methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	owner := nil

! !

!PltEntityInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self entityInstanceToValues: (super toValues: values)

! !

PltEntityInstance subclass: #PltHeaderInstance
	instanceVariableNames: 'owningModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusPopulationSchemaSchema'!

!PltHeaderInstance commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY header_instance 
	ABSTRACT SUPERTYPE 
	SUBTYPE OF ( entity_instance );
	owning_model : model_contents;
END_ENTITY;
</ISO10303-11-EXPRESS>!

PltHeaderInstance subclass: #PltFileDescription
	instanceVariableNames: 'implementationLevel description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusPopulationSchemaSchema'!

!PltFileDescription commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY file_description 
	SUBTYPE OF ( header_instance );
	description : LIST [ 1 : ? ] OF STRING ( 256 );
	implementation_level : STRING ( 256 );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltFileDescription class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltFileDescription class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltFileDescription class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltFileDescription class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusPopulationSchemaSchemaDefinition singleton

! !

!PltFileDescription class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltFileDescription class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltFileDescription class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltFileDescription methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptFileDescription: self

! !

!PltFileDescription methodsFor: 'platypus-generated-accessing' stamp: ''!
description
	^ description

! !

!PltFileDescription methodsFor: 'platypus-generated-accessing' stamp: ''!
description: aListOfString
	description := aListOfString ifNil: [ OrderedCollection new ] ifNotNil: [ aListOfString as: OrderedCollection ]

! !

!PltFileDescription methodsFor: 'platypus-generated-group-accessing' stamp: ''!
description: aListOfString implementationLevel: aString 	self setDescription:aListOfString.	self setImplementationLevel:aString.

! !

!PltFileDescription methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
descriptionUsingContext: aContext
	^ self description

! !

!PltFileDescription methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetDescription: aListOfString
	description := aListOfString

! !

!PltFileDescription methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetImplementationLevel: aString
	implementationLevel := aString

! !

!PltFileDescription methodsFor: 'platypus-generated-copying' stamp: ''!
fileDescriptionCopyTo: another
	another fastSetDescription: self description.
	another fastSetImplementationLevel: self implementationLevel

! !

!PltFileDescription methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fileDescriptionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setDescription: valuesloc removeFirst.
	self setImplementationLevel: valuesloc removeFirst.
	^ valuesloc

! !

!PltFileDescription methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fileDescriptionToValues: values
	values add: self description.
	values add: self implementationLevel.
	^ values

! !

!PltFileDescription methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self fileDescriptionFromValues: (super fromValues: values)

! !

!PltFileDescription methodsFor: 'platypus-generated-accessing' stamp: ''!
implementationLevel
	^ implementationLevel

! !

!PltFileDescription methodsFor: 'platypus-generated-accessing' stamp: ''!
implementationLevel: aString
	implementationLevel := aString

! !

!PltFileDescription methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
implementationLevelUsingContext: aContext
	^ self implementationLevel

! !

!PltFileDescription methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltFileDescription
	^ true

! !

!PltFileDescription methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self fileDescriptionFromValues: values

! !

!PltFileDescription methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self fileDescriptionToValues: values

! !

!PltFileDescription methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltFileDescription methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self fileDescriptionCopyTo: another

! !

!PltFileDescription methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self fileDescriptionCopyTo: another

! !

!PltFileDescription methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setDescription: aListOfString
	self description: aListOfString

! !

!PltFileDescription methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setImplementationLevel: aString
	self implementationLevel: aString

! !

!PltFileDescription methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	description := OrderedCollection new.
	implementationLevel := ''

! !

!PltFileDescription methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self fileDescriptionToValues: (super toValues: values)

! !

PltHeaderInstance subclass: #PltFileName
	instanceVariableNames: 'preprocessorVersion organization name authorisation author timeStamp originatingSystem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusPopulationSchemaSchema'!

!PltFileName commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY file_name 
	SUBTYPE OF ( header_instance );
	name : STRING ( 256 );
	time_stamp : STRING ( 256 );
	author : LIST [ 1 : ? ] OF STRING ( 256 );
	organization : LIST [ 1 : ? ] OF STRING ( 256 );
	preprocessor_version : STRING ( 256 );
	originating_system : STRING ( 256 );
	authorisation : STRING ( 256 );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltFileName class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltFileName class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltFileName class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltFileName class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusPopulationSchemaSchemaDefinition singleton

! !

!PltFileName class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltFileName class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltFileName class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltFileName methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptFileName: self

! !

!PltFileName methodsFor: 'platypus-generated-accessing' stamp: ''!
author
	^ author

! !

!PltFileName methodsFor: 'platypus-generated-accessing' stamp: ''!
author: aListOfString
	author := aListOfString ifNil: [ OrderedCollection new ] ifNotNil: [ aListOfString as: OrderedCollection ]

! !

!PltFileName methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
authorUsingContext: aContext
	^ self author

! !

!PltFileName methodsFor: 'platypus-generated-accessing' stamp: ''!
authorisation
	^ authorisation

! !

!PltFileName methodsFor: 'platypus-generated-accessing' stamp: ''!
authorisation: aString
	authorisation := aString

! !

!PltFileName methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
authorisationUsingContext: aContext
	^ self authorisation

! !

!PltFileName methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetAuthor: aListOfString
	author := aListOfString

! !

!PltFileName methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetAuthorisation: aString
	authorisation := aString

! !

!PltFileName methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetName: aString
	name := aString

! !

!PltFileName methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetOrganization: aListOfString
	organization := aListOfString

! !

!PltFileName methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetOriginatingSystem: aString
	originatingSystem := aString

! !

!PltFileName methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetPreprocessorVersion: aString
	preprocessorVersion := aString

! !

!PltFileName methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetTimeStamp: aString
	timeStamp := aString

! !

!PltFileName methodsFor: 'platypus-generated-copying' stamp: ''!
fileNameCopyTo: another
	another fastSetName: self name.
	another fastSetTimeStamp: self timeStamp.
	another fastSetAuthor: self author.
	another fastSetOrganization: self organization.
	another fastSetPreprocessorVersion: self preprocessorVersion.
	another fastSetOriginatingSystem: self originatingSystem.
	another fastSetAuthorisation: self authorisation

! !

!PltFileName methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fileNameFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setName: valuesloc removeFirst.
	self setTimeStamp: valuesloc removeFirst.
	self setAuthor: valuesloc removeFirst.
	self setOrganization: valuesloc removeFirst.
	self setPreprocessorVersion: valuesloc removeFirst.
	self setOriginatingSystem: valuesloc removeFirst.
	self setAuthorisation: valuesloc removeFirst.
	^ valuesloc

! !

!PltFileName methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fileNameToValues: values
	values add: self name.
	values add: self timeStamp.
	values add: self author.
	values add: self organization.
	values add: self preprocessorVersion.
	values add: self originatingSystem.
	values add: self authorisation.
	^ values

! !

!PltFileName methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self fileNameFromValues: (super fromValues: values)

! !

!PltFileName methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltFileName
	^ true

! !

!PltFileName methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self fileNameFromValues: values

! !

!PltFileName methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self fileNameToValues: values

! !

!PltFileName methodsFor: 'platypus-generated-accessing' stamp: ''!
name
	^ name

! !

!PltFileName methodsFor: 'platypus-generated-accessing' stamp: ''!
name: aString
	name := aString

! !

!PltFileName methodsFor: 'platypus-generated-group-accessing' stamp: ''!
name: aString timeStamp: aString1 author: aListOfString organization: aListOfString1 preprocessorVersion: aString2 originatingSystem: aString3 authorisation: aString4 	self setName:aString.	self setTimeStamp:aString1.	self setAuthor:aListOfString.	self setOrganization:aListOfString1.	self setPreprocessorVersion:aString2.	self setOriginatingSystem:aString3.	self setAuthorisation:aString4.

! !

!PltFileName methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
nameUsingContext: aContext
	^ self name

! !

!PltFileName methodsFor: 'platypus-generated-accessing' stamp: ''!
organization
	^ organization

! !

!PltFileName methodsFor: 'platypus-generated-accessing' stamp: ''!
organization: aListOfString
	organization := aListOfString ifNil: [ OrderedCollection new ] ifNotNil: [ aListOfString as: OrderedCollection ]

! !

!PltFileName methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
organizationUsingContext: aContext
	^ self organization

! !

!PltFileName methodsFor: 'platypus-generated-accessing' stamp: ''!
originatingSystem
	^ originatingSystem

! !

!PltFileName methodsFor: 'platypus-generated-accessing' stamp: ''!
originatingSystem: aString
	originatingSystem := aString

! !

!PltFileName methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
originatingSystemUsingContext: aContext
	^ self originatingSystem

! !

!PltFileName methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltFileName methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self fileNameCopyTo: another

! !

!PltFileName methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self fileNameCopyTo: another

! !

!PltFileName methodsFor: 'platypus-generated-accessing' stamp: ''!
preprocessorVersion
	^ preprocessorVersion

! !

!PltFileName methodsFor: 'platypus-generated-accessing' stamp: ''!
preprocessorVersion: aString
	preprocessorVersion := aString

! !

!PltFileName methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
preprocessorVersionUsingContext: aContext
	^ self preprocessorVersion

! !

!PltFileName methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setAuthor: aListOfString
	self author: aListOfString

! !

!PltFileName methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setAuthorisation: aString
	self authorisation: aString

! !

!PltFileName methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setName: aString
	self name: aString

! !

!PltFileName methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setOrganization: aListOfString
	self organization: aListOfString

! !

!PltFileName methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setOriginatingSystem: aString
	self originatingSystem: aString

! !

!PltFileName methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setPreprocessorVersion: aString
	self preprocessorVersion: aString

! !

!PltFileName methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setTimeStamp: aString
	self timeStamp: aString

! !

!PltFileName methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	name := ''.
	timeStamp := ''.
	author := OrderedCollection new.
	organization := OrderedCollection new.
	preprocessorVersion := ''.
	originatingSystem := ''.
	authorisation := ''

! !

!PltFileName methodsFor: 'platypus-generated-accessing' stamp: ''!
timeStamp
	^ timeStamp

! !

!PltFileName methodsFor: 'platypus-generated-accessing' stamp: ''!
timeStamp: aString
	timeStamp := aString

! !

!PltFileName methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
timeStampUsingContext: aContext
	^ self timeStamp

! !

!PltFileName methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self fileNameToValues: (super toValues: values)

! !

PltHeaderInstance subclass: #PltFileSchema
	instanceVariableNames: 'schemaIdentifiers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusPopulationSchemaSchema'!

!PltFileSchema commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY file_schema 
	SUBTYPE OF ( header_instance );
	schema_identifiers : LIST [ 1 : ? ] OF schema_name;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltFileSchema class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltFileSchema class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltFileSchema class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltFileSchema class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusPopulationSchemaSchemaDefinition singleton

! !

!PltFileSchema class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltFileSchema class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltFileSchema class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltFileSchema methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptFileSchema: self

! !

!PltFileSchema methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetSchemaIdentifiers: aListOfString
	schemaIdentifiers := aListOfString

! !

!PltFileSchema methodsFor: 'platypus-generated-copying' stamp: ''!
fileSchemaCopyTo: another
	another fastSetSchemaIdentifiers: self schemaIdentifiers

! !

!PltFileSchema methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fileSchemaFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setSchemaIdentifiers: valuesloc removeFirst.
	^ valuesloc

! !

!PltFileSchema methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fileSchemaToValues: values
	values add: self schemaIdentifiers.
	^ values

! !

!PltFileSchema methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self fileSchemaFromValues: (super fromValues: values)

! !

!PltFileSchema methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltFileSchema
	^ true

! !

!PltFileSchema methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self fileSchemaFromValues: values

! !

!PltFileSchema methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self fileSchemaToValues: values

! !

!PltFileSchema methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltFileSchema methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self fileSchemaCopyTo: another

! !

!PltFileSchema methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self fileSchemaCopyTo: another

! !

!PltFileSchema methodsFor: 'platypus-generated-accessing' stamp: ''!
schemaIdentifiers
	^ schemaIdentifiers

! !

!PltFileSchema methodsFor: 'platypus-generated-accessing' stamp: ''!
schemaIdentifiers: aListOfString
	schemaIdentifiers := aListOfString ifNil: [ OrderedCollection new ] ifNotNil: [ aListOfString as: OrderedCollection ]

! !

!PltFileSchema methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
schemaIdentifiersUsingContext: aContext
	^ self schemaIdentifiers

! !

!PltFileSchema methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setSchemaIdentifiers: aListOfString
	self schemaIdentifiers: aListOfString

! !

!PltFileSchema methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	schemaIdentifiers := OrderedCollection new

! !

!PltFileSchema methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self fileSchemaToValues: (super toValues: values)

! !

!PltHeaderInstance class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltHeaderInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltHeaderInstance class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltHeaderInstance class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusPopulationSchemaSchemaDefinition singleton

! !

!PltHeaderInstance class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltHeaderInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltHeaderInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltHeaderInstance methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptHeaderInstance: self

! !

!PltHeaderInstance methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetOwningModel: aPltModelContents
	owningModel := aPltModelContents

! !

!PltHeaderInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self headerInstanceFromValues: (super fromValues: values)

! !

!PltHeaderInstance methodsFor: 'platypus-generated-copying' stamp: ''!
headerInstanceCopyTo: another
	another fastSetOwningModel: self owningModel

! !

!PltHeaderInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
headerInstanceFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setOwningModel: valuesloc removeFirst.
	^ valuesloc

! !

!PltHeaderInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
headerInstanceToValues: values
	values add: self owningModel.
	^ values

! !

!PltHeaderInstance methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltHeaderInstance
	^ true

! !

!PltHeaderInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self headerInstanceFromValues: values

! !

!PltHeaderInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self headerInstanceToValues: values

! !

!PltHeaderInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
owningModel
	^ owningModel

! !

!PltHeaderInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
owningModel: aPltModelContents
	owningModel := aPltModelContents

! !

!PltHeaderInstance methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
owningModelUsingContext: aContext
	^ self owningModel

! !

!PltHeaderInstance methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltHeaderInstance methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self headerInstanceCopyTo: another

! !

!PltHeaderInstance methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self headerInstanceCopyTo: another

! !

!PltHeaderInstance methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setOwningModel: aPltModelContents
	self owningModel: aPltModelContents

! !

!PltHeaderInstance methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	owningModel := nil

! !

!PltHeaderInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self headerInstanceToValues: (super toValues: values)

! !

PltHeaderInstance subclass: #PltUserDefinedHeaderInstance
	instanceVariableNames: 'name parameters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusPopulationSchemaSchema'!

!PltUserDefinedHeaderInstance commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY user_defined_header_instance 
	SUBTYPE OF ( header_instance );
	name : STRING;
	parameters : LIST OF primitive;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltUserDefinedHeaderInstance class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltUserDefinedHeaderInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltUserDefinedHeaderInstance class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltUserDefinedHeaderInstance class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusPopulationSchemaSchemaDefinition singleton

! !

!PltUserDefinedHeaderInstance class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltUserDefinedHeaderInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltUserDefinedHeaderInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltUserDefinedHeaderInstance methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptUserDefinedHeaderInstance: self

! !

!PltUserDefinedHeaderInstance methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetName: aString
	name := aString

! !

!PltUserDefinedHeaderInstance methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetParameters: aListOfPltExpression
	parameters := aListOfPltExpression

! !

!PltUserDefinedHeaderInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self userDefinedHeaderInstanceFromValues: (super fromValues: values)

! !

!PltUserDefinedHeaderInstance methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltUserDefinedHeaderInstance
	^ true

! !

!PltUserDefinedHeaderInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self userDefinedHeaderInstanceFromValues: values

! !

!PltUserDefinedHeaderInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self userDefinedHeaderInstanceToValues: values

! !

!PltUserDefinedHeaderInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
name
	^ name

! !

!PltUserDefinedHeaderInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
name: aString
	name := aString

! !

!PltUserDefinedHeaderInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
name: aString parameters: aListOfPltExpression 	self setName:aString.	self setParameters:aListOfPltExpression.

! !

!PltUserDefinedHeaderInstance methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
nameUsingContext: aContext
	^ self name

! !

!PltUserDefinedHeaderInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
parameters
	^ parameters

! !

!PltUserDefinedHeaderInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
parameters: aListOfPltExpression
	parameters := aListOfPltExpression
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfPltExpression as: OrderedCollection ]

! !

!PltUserDefinedHeaderInstance methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
parametersUsingContext: aContext
	^ self parameters

! !

!PltUserDefinedHeaderInstance methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltUserDefinedHeaderInstance methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self userDefinedHeaderInstanceCopyTo: another

! !

!PltUserDefinedHeaderInstance methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self userDefinedHeaderInstanceCopyTo: another

! !

!PltUserDefinedHeaderInstance methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setName: aString
	self name: aString

! !

!PltUserDefinedHeaderInstance methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setParameters: aListOfPltExpression
	self parameters: aListOfPltExpression

! !

!PltUserDefinedHeaderInstance methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	name := ''.
	parameters := OrderedCollection new

! !

!PltUserDefinedHeaderInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self userDefinedHeaderInstanceToValues: (super toValues: values)

! !

!PltUserDefinedHeaderInstance methodsFor: 'platypus-generated-copying' stamp: ''!
userDefinedHeaderInstanceCopyTo: another
	another fastSetName: self name.
	another fastSetParameters: self parameters

! !

!PltUserDefinedHeaderInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
userDefinedHeaderInstanceFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setName: valuesloc removeFirst.
	self setParameters: valuesloc removeFirst.
	^ valuesloc

! !

!PltUserDefinedHeaderInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
userDefinedHeaderInstanceToValues: values
	values add: self name.
	values add: self parameters.
	^ values

! !

PltEntityInstance subclass: #PltRemark
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltRemark commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY remark 
	ABSTRACT SUPERTYPE OF ( ONEOF ( tail_remark, embedded_remark ) ) 
	SUBTYPE OF ( entity_instance );
	text : STRING;
END_ENTITY;
</ISO10303-11-EXPRESS>!

PltRemark subclass: #PltEmbeddedRemark
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltEmbeddedRemark commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY embedded_remark 
	SUBTYPE OF ( remark );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltEmbeddedRemark class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltEmbeddedRemark class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltEmbeddedRemark class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltEmbeddedRemark class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltEmbeddedRemark class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltEmbeddedRemark class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltEmbeddedRemark class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltEmbeddedRemark methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptEmbeddedRemark: self

! !

!PltEmbeddedRemark methodsFor: 'platypus-generated-copying' stamp: ''!
embeddedRemarkCopyTo: another
	

! !

!PltEmbeddedRemark methodsFor: 'platypus-generated-group-accessing' stamp: ''!
embeddedRemarkFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltEmbeddedRemark methodsFor: 'platypus-generated-group-accessing' stamp: ''!
embeddedRemarkToValues: values
	^ values

! !

!PltEmbeddedRemark methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self embeddedRemarkFromValues: (super fromValues: values)

! !

!PltEmbeddedRemark methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltEmbeddedRemark
	^ true

! !

!PltEmbeddedRemark methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self embeddedRemarkFromValues: values

! !

!PltEmbeddedRemark methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self embeddedRemarkToValues: values

! !

!PltEmbeddedRemark methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltEmbeddedRemark methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self embeddedRemarkCopyTo: another

! !

!PltEmbeddedRemark methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self embeddedRemarkCopyTo: another

! !

!PltEmbeddedRemark methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltEmbeddedRemark methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self embeddedRemarkToValues: (super toValues: values)

! !

!PltRemark class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltRemark class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltRemark class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltRemark class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltRemark class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltRemark class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltRemark class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltRemark methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptRemark: self

! !

!PltRemark methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetText: aString
	text := aString

! !

!PltRemark methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self remarkFromValues: (super fromValues: values)

! !

!PltRemark methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltRemark
	^ true

! !

!PltRemark methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self remarkFromValues: values

! !

!PltRemark methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self remarkToValues: values

! !

!PltRemark methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltRemark methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self remarkCopyTo: another

! !

!PltRemark methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self remarkCopyTo: another

! !

!PltRemark methodsFor: 'platypus-generated-copying' stamp: ''!
remarkCopyTo: another
	another fastSetText: self text

! !

!PltRemark methodsFor: 'platypus-generated-group-accessing' stamp: ''!
remarkFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setText: valuesloc removeFirst.
	^ valuesloc

! !

!PltRemark methodsFor: 'platypus-generated-group-accessing' stamp: ''!
remarkToValues: values
	values add: self text.
	^ values

! !

!PltRemark methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setText: aString
	self text: aString

! !

!PltRemark methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	text := ''

! !

!PltRemark methodsFor: 'platypus-generated-accessing' stamp: ''!
text
	^ text

! !

!PltRemark methodsFor: 'platypus-generated-accessing' stamp: ''!
text: aString
	text := aString

! !

!PltRemark methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
textUsingContext: aContext
	^ self text

! !

!PltRemark methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self remarkToValues: (super toValues: values)

! !

PltRemark subclass: #PltTailRemark
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltTailRemark commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY tail_remark 
	SUBTYPE OF ( remark );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltTailRemark class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltTailRemark class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltTailRemark class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltTailRemark class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltTailRemark class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltTailRemark class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltTailRemark class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltTailRemark methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptTailRemark: self

! !

!PltTailRemark methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self tailRemarkFromValues: (super fromValues: values)

! !

!PltTailRemark methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltTailRemark
	^ true

! !

!PltTailRemark methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self tailRemarkFromValues: values

! !

!PltTailRemark methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self tailRemarkToValues: values

! !

!PltTailRemark methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltTailRemark methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self tailRemarkCopyTo: another

! !

!PltTailRemark methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self tailRemarkCopyTo: another

! !

!PltTailRemark methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltTailRemark methodsFor: 'platypus-generated-copying' stamp: ''!
tailRemarkCopyTo: another
	

! !

!PltTailRemark methodsFor: 'platypus-generated-group-accessing' stamp: ''!
tailRemarkFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltTailRemark methodsFor: 'platypus-generated-group-accessing' stamp: ''!
tailRemarkToValues: values
	^ values

! !

!PltTailRemark methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self tailRemarkToValues: (super toValues: values)

! !

PltEntityInstance subclass: #PltSdaiInstance
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltSdaiInstance commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY sdai_instance 
	ABSTRACT SUPERTYPE OF ( ONEOF ( dictionary_instance, session_instance ) ) 
	SUBTYPE OF ( entity_instance );
END_ENTITY;
</ISO10303-11-EXPRESS>!

PltSdaiInstance subclass: #PltDictionaryInstance
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltDictionaryInstance commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY dictionary_instance 
	ABSTRACT SUPERTYPE 
	SUBTYPE OF ( sdai_instance );
DERIVE
	handled : dictionary_instance := SELF;
END_ENTITY;
</ISO10303-11-EXPRESS>!

PltDictionaryInstance subclass: #PltAggregateInitializerDomain
	instanceVariableNames: 'types'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltAggregateInitializerDomain commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY aggregate_initializer_domain 
	SUBTYPE OF ( dictionary_instance );
	types : LIST [ 1 : ? ] OF parameter_type;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltAggregateInitializerDomain class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltAggregateInitializerDomain class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltAggregateInitializerDomain class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltAggregateInitializerDomain class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltAggregateInitializerDomain class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltAggregateInitializerDomain class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltAggregateInitializerDomain class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltAggregateInitializerDomain methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptAggregateInitializerDomain: self

! !

!PltAggregateInitializerDomain methodsFor: 'platypus-generated-copying' stamp: ''!
aggregateInitializerDomainCopyTo: another
	another fastSetTypes: self types

! !

!PltAggregateInitializerDomain methodsFor: 'platypus-generated-group-accessing' stamp: ''!
aggregateInitializerDomainFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setTypes: valuesloc removeFirst.
	^ valuesloc

! !

!PltAggregateInitializerDomain methodsFor: 'platypus-generated-group-accessing' stamp: ''!
aggregateInitializerDomainToValues: values
	values add: self types.
	^ values

! !

!PltAggregateInitializerDomain methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetTypes: aListOfPltParameterType
	types := aListOfPltParameterType

! !

!PltAggregateInitializerDomain methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self aggregateInitializerDomainFromValues: (super fromValues: values)

! !

!PltAggregateInitializerDomain methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltAggregateInitializerDomain
	^ true

! !

!PltAggregateInitializerDomain methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self aggregateInitializerDomainFromValues: values

! !

!PltAggregateInitializerDomain methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self aggregateInitializerDomainToValues: values

! !

!PltAggregateInitializerDomain methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltAggregateInitializerDomain methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self aggregateInitializerDomainCopyTo: another

! !

!PltAggregateInitializerDomain methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self aggregateInitializerDomainCopyTo: another

! !

!PltAggregateInitializerDomain methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setTypes: aListOfPltParameterType
	self types: aListOfPltParameterType

! !

!PltAggregateInitializerDomain methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	types := OrderedCollection new

! !

!PltAggregateInitializerDomain methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self aggregateInitializerDomainToValues: (super toValues: values)

! !

!PltAggregateInitializerDomain methodsFor: 'platypus-generated-accessing' stamp: ''!
types
	^ types

! !

!PltAggregateInitializerDomain methodsFor: 'platypus-generated-accessing' stamp: ''!
types: aListOfPltParameterType
	types := aListOfPltParameterType
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfPltParameterType as: OrderedCollection ]

! !

!PltAggregateInitializerDomain methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
typesUsingContext: aContext
	^ self types

! !

PltDictionaryInstance subclass: #PltAggregateInitializerElement
	instanceVariableNames: 'val repetition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusAggregateDataSchemaSchema'!

!PltAggregateInitializerElement commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY aggregate_initializer_element 
	SUBTYPE OF ( dictionary_instance );
	SELF\entity_instance.owner : aggregate_initializer;
	val : primitive;
	repetition : OPTIONAL expression;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltAggregateInitializerElement class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltAggregateInitializerElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltAggregateInitializerElement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltAggregateInitializerElement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusAggregateDataSchemaSchemaDefinition singleton

! !

!PltAggregateInitializerElement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltAggregateInitializerElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltAggregateInitializerElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltAggregateInitializerElement methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptAggregateInitializerElement: self

! !

!PltAggregateInitializerElement methodsFor: 'platypus-generated-copying' stamp: ''!
aggregateInitializerElementCopyTo: another
	another fastSetOwner: self owner.
	another fastSetVal: self val.
	another fastSetRepetition: self repetition

! !

!PltAggregateInitializerElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
aggregateInitializerElementFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setOwner: valuesloc removeFirst.
	self setVal: valuesloc removeFirst.
	self setRepetition: valuesloc removeFirst.
	^ valuesloc

! !

!PltAggregateInitializerElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
aggregateInitializerElementToValues: values
	values add: self owner.
	values add: self val.
	values add: self repetition.
	^ values

! !

!PltAggregateInitializerElement methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetOwner: aPltAggregateInitializer
	owner := aPltAggregateInitializer

! !

!PltAggregateInitializerElement methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetRepetition: aPltExpression
	repetition := aPltExpression

! !

!PltAggregateInitializerElement methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetVal: aPltExpression
	val := aPltExpression

! !

!PltAggregateInitializerElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self aggregateInitializerElementFromValues: (super fromValues: values)

! !

!PltAggregateInitializerElement methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltAggregateInitializerElement
	^ true

! !

!PltAggregateInitializerElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self aggregateInitializerElementFromValues: values

! !

!PltAggregateInitializerElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self aggregateInitializerElementToValues: values

! !

!PltAggregateInitializerElement methodsFor: 'platypus-generated-accessing' stamp: ''!
owner
	^ owner

! !

!PltAggregateInitializerElement methodsFor: 'platypus-generated-accessing' stamp: ''!
owner: aPltAggregateInitializer
	owner := aPltAggregateInitializer

! !

!PltAggregateInitializerElement methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
ownerUsingContext: aContext
	^ self owner

! !

!PltAggregateInitializerElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltAggregateInitializerElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self aggregateInitializerElementCopyTo: another

! !

!PltAggregateInitializerElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self aggregateInitializerElementCopyTo: another

! !

!PltAggregateInitializerElement methodsFor: 'platypus-generated-accessing' stamp: ''!
repetition
	^ repetition

! !

!PltAggregateInitializerElement methodsFor: 'platypus-generated-accessing' stamp: ''!
repetition: aPltExpression
	repetition := aPltExpression

! !

!PltAggregateInitializerElement methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
repetitionUsingContext: aContext
	^ self repetition

! !

!PltAggregateInitializerElement methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setOwner: aPltAggregateInitializer
	self owner: aPltAggregateInitializer

! !

!PltAggregateInitializerElement methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setRepetition: aPltExpression
	self repetition: aPltExpression

! !

!PltAggregateInitializerElement methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setVal: aPltExpression
	self val: aPltExpression

! !

!PltAggregateInitializerElement methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	owner := nil.
	val := nil.
	repetition := nil

! !

!PltAggregateInitializerElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self aggregateInitializerElementToValues: (super toValues: values)

! !

!PltAggregateInitializerElement methodsFor: 'platypus-generated-accessing' stamp: ''!
val
	^ val

! !

!PltAggregateInitializerElement methodsFor: 'platypus-generated-accessing' stamp: ''!
val: aPltExpression
	val := aPltExpression

! !

!PltAggregateInitializerElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
val: aPltExpression repetition: aPltExpression1 	self setVal:aPltExpression.	self setRepetition:aPltExpression1.

! !

!PltAggregateInitializerElement methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
valUsingContext: aContext
	^ self val

! !

PltDictionaryInstance subclass: #PltAggregateType
	instanceVariableNames: 'elementType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltAggregateType commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY aggregate_type 
	ABSTRACT SUPERTYPE OF ( ONEOF ( aggregation_type, general_aggregate_type ) ) 
	SUBTYPE OF ( dictionary_instance );
	element_type : parameter_type;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltAggregateType class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltAggregateType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltAggregateType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltAggregateType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltAggregateType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltAggregateType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltAggregateType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltAggregateType methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptAggregateType: self

! !

!PltAggregateType methodsFor: 'platypus-generated-copying' stamp: ''!
aggregateTypeCopyTo: another
	another fastSetElementType: self elementType

! !

!PltAggregateType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
aggregateTypeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setElementType: valuesloc removeFirst.
	^ valuesloc

! !

!PltAggregateType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
aggregateTypeToValues: values
	values add: self elementType.
	^ values

! !

!PltAggregateType methodsFor: 'platypus-generated-accessing' stamp: ''!
elementType
	^ elementType

! !

!PltAggregateType methodsFor: 'platypus-generated-accessing' stamp: ''!
elementType: aPltParameterType
	elementType := aPltParameterType

! !

!PltAggregateType methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
elementTypeUsingContext: aContext
	^ self elementType

! !

!PltAggregateType methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetElementType: aPltParameterType
	elementType := aPltParameterType

! !

!PltAggregateType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self aggregateTypeFromValues: (super fromValues: values)

! !

!PltAggregateType methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltAggregateType
	^ true

! !

!PltAggregateType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self aggregateTypeFromValues: values

! !

!PltAggregateType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self aggregateTypeToValues: values

! !

!PltAggregateType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltAggregateType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self aggregateTypeCopyTo: another

! !

!PltAggregateType methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self aggregateTypeCopyTo: another

! !

!PltAggregateType methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setElementType: aPltParameterType
	self elementType: aPltParameterType

! !

!PltAggregateType methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	elementType := nil

! !

!PltAggregateType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self aggregateTypeToValues: (super toValues: values)

! !

PltAggregateType subclass: #PltAggregationType
	instanceVariableNames: 'upperBound isGeneralType lowerBound'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltAggregationType commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY aggregation_type 
	ABSTRACT SUPERTYPE OF ( ONEOF ( variable_size_aggregation_type, array_type ) ) 
	SUBTYPE OF ( aggregate_type );
	lower_bound : OPTIONAL bound;
	upper_bound : OPTIONAL bound;
	is_general_type : BOOLEAN;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltAggregationType class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltAggregationType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltAggregationType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltAggregationType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltAggregationType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltAggregationType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltAggregationType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltAggregationType methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptAggregationType: self

! !

!PltAggregationType methodsFor: 'platypus-generated-copying' stamp: ''!
aggregationTypeCopyTo: another
	another fastSetLowerBound: self lowerBound.
	another fastSetUpperBound: self upperBound.
	another fastSetIsGeneralType: self isGeneralType

! !

!PltAggregationType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
aggregationTypeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setLowerBound: valuesloc removeFirst.
	self setUpperBound: valuesloc removeFirst.
	self setIsGeneralType: valuesloc removeFirst.
	^ valuesloc

! !

!PltAggregationType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
aggregationTypeToValues: values
	values add: self lowerBound.
	values add: self upperBound.
	values add: self isGeneralType.
	^ values

! !

!PltAggregationType methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetIsGeneralType: aBoolean
	isGeneralType := aBoolean

! !

!PltAggregationType methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetLowerBound: aPltBound
	lowerBound := aPltBound

! !

!PltAggregationType methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetUpperBound: aPltBound
	upperBound := aPltBound

! !

!PltAggregationType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self aggregationTypeFromValues: (super fromValues: values)

! !

!PltAggregationType methodsFor: 'platypus-generated-accessing' stamp: ''!
isGeneralType
	^ isGeneralType

! !

!PltAggregationType methodsFor: 'platypus-generated-accessing' stamp: ''!
isGeneralType: aBoolean
	isGeneralType := aBoolean

! !

!PltAggregationType methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
isGeneralTypeUsingContext: aContext
	^ self isGeneralType

! !

!PltAggregationType methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltAggregationType
	^ true

! !

!PltAggregationType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self aggregationTypeFromValues: values

! !

!PltAggregationType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self aggregationTypeToValues: values

! !

!PltAggregationType methodsFor: 'platypus-generated-accessing' stamp: ''!
lowerBound
	^ lowerBound

! !

!PltAggregationType methodsFor: 'platypus-generated-accessing' stamp: ''!
lowerBound: aPltBound
	lowerBound := aPltBound

! !

!PltAggregationType methodsFor: 'platypus-generated-group-accessing' stamp: 'AlainPlantec 6/13/2012 13:09'!
lowerBound: aPltBound upperBound: aPltBound1 isGeneralType: aBoolean
	self setLowerBound:aPltBound.	
	self setUpperBound:aPltBound1.
	self setIsGeneralType:aBoolean.

! !

!PltAggregationType methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
lowerBoundUsingContext: aContext
	^ self lowerBound

! !

!PltAggregationType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltAggregationType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self aggregationTypeCopyTo: another

! !

!PltAggregationType methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self aggregationTypeCopyTo: another

! !

!PltAggregationType methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setIsGeneralType: aBoolean
	self isGeneralType: aBoolean

! !

!PltAggregationType methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setLowerBound: aPltBound
	self lowerBound: aPltBound

! !

!PltAggregationType methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setUpperBound: aPltBound
	self upperBound: aPltBound

! !

!PltAggregationType methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	lowerBound := nil.
	upperBound := nil.
	isGeneralType := false

! !

!PltAggregationType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self aggregationTypeToValues: (super toValues: values)

! !

!PltAggregationType methodsFor: 'platypus-generated-accessing' stamp: ''!
upperBound
	^ upperBound

! !

!PltAggregationType methodsFor: 'platypus-generated-accessing' stamp: ''!
upperBound: aPltBound
	upperBound := aPltBound

! !

!PltAggregationType methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
upperBoundUsingContext: aContext
	^ self upperBound

! !

PltAggregationType subclass: #PltArrayType
	instanceVariableNames: 'optionalFlag uniqueFlag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltArrayType commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY array_type 
	SUBTYPE OF ( aggregation_type );
	unique_flag : BOOLEAN;
	optional_flag : BOOLEAN;
	SELF\aggregation_type.lower_bound : bound;
	SELF\aggregation_type.upper_bound : bound;
DERIVE
	accepted : entity_instance := SELF.accept_array_type;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltArrayType class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltArrayType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltArrayType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltArrayType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltArrayType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltArrayType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltArrayType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltArrayType methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptArrayType: self

! !

!PltArrayType methodsFor: 'platypus-generated-deriving' stamp: ''!
accepted
	^ self acceptedUsingContext: self class context

! !

!PltArrayType methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext
	^ self acceptedUsingContext: aContext receiver: self

! !

!PltArrayType methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext receiver: aReceiver
	^ aReceiver acceptArrayTypeUsingContext: aContext

! !

!PltArrayType methodsFor: 'platypus-generated-copying' stamp: ''!
arrayTypeCopyTo: another
	another fastSetUniqueFlag: self uniqueFlag.
	another fastSetOptionalFlag: self optionalFlag.
	another fastSetLowerBound: self lowerBound.
	another fastSetUpperBound: self upperBound

! !

!PltArrayType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
arrayTypeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setUniqueFlag: valuesloc removeFirst.
	self setOptionalFlag: valuesloc removeFirst.
	self setLowerBound: valuesloc removeFirst.
	self setUpperBound: valuesloc removeFirst.
	^ valuesloc

! !

!PltArrayType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
arrayTypeToValues: values
	values add: self uniqueFlag.
	values add: self optionalFlag.
	values add: self lowerBound.
	values add: self upperBound.
	^ values

! !

!PltArrayType methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetLowerBound: aPltBound
	lowerBound := aPltBound

! !

!PltArrayType methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetOptionalFlag: aBoolean
	optionalFlag := aBoolean

! !

!PltArrayType methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetUniqueFlag: aBoolean
	uniqueFlag := aBoolean

! !

!PltArrayType methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetUpperBound: aPltBound
	upperBound := aPltBound

! !

!PltArrayType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self arrayTypeFromValues: (super fromValues: values)

! !

!PltArrayType methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltArrayType
	^ true

! !

!PltArrayType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self arrayTypeFromValues: values

! !

!PltArrayType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self arrayTypeToValues: values

! !

!PltArrayType methodsFor: 'platypus-generated-accessing' stamp: ''!
lowerBound
	^ lowerBound

! !

!PltArrayType methodsFor: 'platypus-generated-accessing' stamp: ''!
lowerBound: aPltBound
	lowerBound := aPltBound

! !

!PltArrayType methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
lowerBoundUsingContext: aContext
	^ self lowerBound

! !

!PltArrayType methodsFor: 'platypus-generated-accessing' stamp: ''!
optionalFlag
	^ optionalFlag

! !

!PltArrayType methodsFor: 'platypus-generated-accessing' stamp: ''!
optionalFlag: aBoolean
	optionalFlag := aBoolean

! !

!PltArrayType methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
optionalFlagUsingContext: aContext
	^ self optionalFlag

! !

!PltArrayType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltArrayType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self arrayTypeCopyTo: another

! !

!PltArrayType methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self arrayTypeCopyTo: another

! !

!PltArrayType methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setLowerBound: aPltBound
	self lowerBound: aPltBound

! !

!PltArrayType methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setOptionalFlag: aBoolean
	self optionalFlag: aBoolean

! !

!PltArrayType methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setUniqueFlag: aBoolean
	self uniqueFlag: aBoolean

! !

!PltArrayType methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setUpperBound: aPltBound
	self upperBound: aPltBound

! !

!PltArrayType methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	uniqueFlag := false.
	optionalFlag := false.
	lowerBound := nil.
	upperBound := nil

! !

!PltArrayType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self arrayTypeToValues: (super toValues: values)

! !

!PltArrayType methodsFor: 'platypus-generated-accessing' stamp: ''!
uniqueFlag
	^ uniqueFlag

! !

!PltArrayType methodsFor: 'platypus-generated-accessing' stamp: ''!
uniqueFlag: aBoolean
	uniqueFlag := aBoolean

! !

!PltArrayType methodsFor: 'platypus-generated-group-accessing' stamp: 'AlainPlantec 6/13/2012 13:09'!
uniqueFlag: aBoolean optionalFlag: aBoolean1 lowerBound: aPltBound upperBound: aPltBound1
	self setUniqueFlag:aBoolean.
	self setOptionalFlag:aBoolean1.
	self setLowerBound:aPltBound.
	self setUpperBound:aPltBound1.

! !

!PltArrayType methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
uniqueFlagUsingContext: aContext
	^ self uniqueFlag

! !

!PltArrayType methodsFor: 'platypus-generated-accessing' stamp: ''!
upperBound
	^ upperBound

! !

!PltArrayType methodsFor: 'platypus-generated-accessing' stamp: ''!
upperBound: aPltBound
	upperBound := aPltBound

! !

!PltArrayType methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
upperBoundUsingContext: aContext
	^ self upperBound

! !

PltAggregationType subclass: #PltVariableSizeAggregationType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltVariableSizeAggregationType commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY variable_size_aggregation_type 
	ABSTRACT SUPERTYPE OF ( ONEOF ( set_type, bag_type, list_type ) ) 
	SUBTYPE OF ( aggregation_type );
END_ENTITY;
</ISO10303-11-EXPRESS>!

PltVariableSizeAggregationType subclass: #PltBagType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltBagType commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY bag_type 
	SUBTYPE OF ( variable_size_aggregation_type );
DERIVE
	accepted : entity_instance := SELF.accept_bag_type;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltBagType class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltBagType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltBagType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltBagType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltBagType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltBagType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltBagType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltBagType methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptBagType: self

! !

!PltBagType methodsFor: 'platypus-generated-deriving' stamp: ''!
accepted
	^ self acceptedUsingContext: self class context

! !

!PltBagType methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext
	^ self acceptedUsingContext: aContext receiver: self

! !

!PltBagType methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext receiver: aReceiver
	^ aReceiver acceptBagTypeUsingContext: aContext

! !

!PltBagType methodsFor: 'platypus-generated-copying' stamp: ''!
bagTypeCopyTo: another
	

! !

!PltBagType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
bagTypeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltBagType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
bagTypeToValues: values
	^ values

! !

!PltBagType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self bagTypeFromValues: (super fromValues: values)

! !

!PltBagType methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltBagType
	^ true

! !

!PltBagType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self bagTypeFromValues: values

! !

!PltBagType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self bagTypeToValues: values

! !

!PltBagType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltBagType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self bagTypeCopyTo: another

! !

!PltBagType methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self bagTypeCopyTo: another

! !

!PltBagType methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltBagType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self bagTypeToValues: (super toValues: values)

! !

PltVariableSizeAggregationType subclass: #PltListType
	instanceVariableNames: 'uniqueFlag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltListType commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY list_type 
	SUBTYPE OF ( variable_size_aggregation_type );
	unique_flag : BOOLEAN;
DERIVE
	accepted : entity_instance := SELF.accept_list_type;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltListType class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltListType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltListType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltListType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltListType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltListType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltListType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltListType methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptListType: self

! !

!PltListType methodsFor: 'platypus-generated-deriving' stamp: ''!
accepted
	^ self acceptedUsingContext: self class context

! !

!PltListType methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext
	^ self acceptedUsingContext: aContext receiver: self

! !

!PltListType methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext receiver: aReceiver
	^ aReceiver acceptListTypeUsingContext: aContext

! !

!PltListType methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetUniqueFlag: aBoolean
	uniqueFlag := aBoolean

! !

!PltListType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self listTypeFromValues: (super fromValues: values)

! !

!PltListType methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltListType
	^ true

! !

!PltListType methodsFor: 'platypus-generated-copying' stamp: ''!
listTypeCopyTo: another
	another fastSetUniqueFlag: self uniqueFlag

! !

!PltListType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
listTypeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setUniqueFlag: valuesloc removeFirst.
	^ valuesloc

! !

!PltListType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
listTypeToValues: values
	values add: self uniqueFlag.
	^ values

! !

!PltListType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self listTypeFromValues: values

! !

!PltListType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self listTypeToValues: values

! !

!PltListType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltListType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self listTypeCopyTo: another

! !

!PltListType methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self listTypeCopyTo: another

! !

!PltListType methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setUniqueFlag: aBoolean
	self uniqueFlag: aBoolean

! !

!PltListType methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	uniqueFlag := false

! !

!PltListType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self listTypeToValues: (super toValues: values)

! !

!PltListType methodsFor: 'platypus-generated-accessing' stamp: ''!
uniqueFlag
	^ uniqueFlag

! !

!PltListType methodsFor: 'platypus-generated-accessing' stamp: ''!
uniqueFlag: aBoolean
	uniqueFlag := aBoolean

! !

!PltListType methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
uniqueFlagUsingContext: aContext
	^ self uniqueFlag

! !

PltVariableSizeAggregationType subclass: #PltSetType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltSetType commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY set_type 
	SUBTYPE OF ( variable_size_aggregation_type );
DERIVE
	accepted : entity_instance := SELF.accept_set_type;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltSetType class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltSetType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltSetType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltSetType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltSetType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltSetType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltSetType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltSetType methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptSetType: self

! !

!PltSetType methodsFor: 'platypus-generated-deriving' stamp: ''!
accepted
	^ self acceptedUsingContext: self class context

! !

!PltSetType methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext
	^ self acceptedUsingContext: aContext receiver: self

! !

!PltSetType methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext receiver: aReceiver
	^ aReceiver acceptSetTypeUsingContext: aContext

! !

!PltSetType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self setTypeFromValues: (super fromValues: values)

! !

!PltSetType methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltSetType
	^ true

! !

!PltSetType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self setTypeFromValues: values

! !

!PltSetType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self setTypeToValues: values

! !

!PltSetType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltSetType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self setTypeCopyTo: another

! !

!PltSetType methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self setTypeCopyTo: another

! !

!PltSetType methodsFor: 'platypus-generated-copying' stamp: ''!
setTypeCopyTo: another
	

! !

!PltSetType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
setTypeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltSetType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
setTypeToValues: values
	^ values

! !

!PltSetType methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltSetType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self setTypeToValues: (super toValues: values)

! !

!PltVariableSizeAggregationType class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltVariableSizeAggregationType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltVariableSizeAggregationType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltVariableSizeAggregationType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltVariableSizeAggregationType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltVariableSizeAggregationType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltVariableSizeAggregationType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltVariableSizeAggregationType methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptVariableSizeAggregationType: self

! !

!PltVariableSizeAggregationType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self variableSizeAggregationTypeFromValues: (super fromValues: values)

! !

!PltVariableSizeAggregationType methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltVariableSizeAggregationType
	^ true

! !

!PltVariableSizeAggregationType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self variableSizeAggregationTypeFromValues: values

! !

!PltVariableSizeAggregationType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self variableSizeAggregationTypeToValues: values

! !

!PltVariableSizeAggregationType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltVariableSizeAggregationType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self variableSizeAggregationTypeCopyTo: another

! !

!PltVariableSizeAggregationType methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self variableSizeAggregationTypeCopyTo: another

! !

!PltVariableSizeAggregationType methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltVariableSizeAggregationType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self variableSizeAggregationTypeToValues: (super toValues: values)

! !

!PltVariableSizeAggregationType methodsFor: 'platypus-generated-copying' stamp: ''!
variableSizeAggregationTypeCopyTo: another
	

! !

!PltVariableSizeAggregationType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
variableSizeAggregationTypeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltVariableSizeAggregationType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
variableSizeAggregationTypeToValues: values
	^ values

! !

PltAggregateType subclass: #PltGeneralAggregateType
	instanceVariableNames: 'typeLabel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltGeneralAggregateType commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY general_aggregate_type 
	SUBTYPE OF ( aggregate_type );
	type_label : OPTIONAL STRING;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltGeneralAggregateType class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltGeneralAggregateType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltGeneralAggregateType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltGeneralAggregateType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltGeneralAggregateType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltGeneralAggregateType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltGeneralAggregateType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltGeneralAggregateType methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptGeneralAggregateType: self

! !

!PltGeneralAggregateType methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetTypeLabel: aString
	typeLabel := aString

! !

!PltGeneralAggregateType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self generalAggregateTypeFromValues: (super fromValues: values)

! !

!PltGeneralAggregateType methodsFor: 'platypus-generated-copying' stamp: ''!
generalAggregateTypeCopyTo: another
	another fastSetTypeLabel: self typeLabel

! !

!PltGeneralAggregateType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
generalAggregateTypeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setTypeLabel: valuesloc removeFirst.
	^ valuesloc

! !

!PltGeneralAggregateType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
generalAggregateTypeToValues: values
	values add: self typeLabel.
	^ values

! !

!PltGeneralAggregateType methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltGeneralAggregateType
	^ true

! !

!PltGeneralAggregateType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self generalAggregateTypeFromValues: values

! !

!PltGeneralAggregateType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self generalAggregateTypeToValues: values

! !

!PltGeneralAggregateType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltGeneralAggregateType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self generalAggregateTypeCopyTo: another

! !

!PltGeneralAggregateType methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self generalAggregateTypeCopyTo: another

! !

!PltGeneralAggregateType methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setTypeLabel: aString
	self typeLabel: aString

! !

!PltGeneralAggregateType methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	typeLabel := nil

! !

!PltGeneralAggregateType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self generalAggregateTypeToValues: (super toValues: values)

! !

!PltGeneralAggregateType methodsFor: 'platypus-generated-accessing' stamp: ''!
typeLabel
	^ typeLabel

! !

!PltGeneralAggregateType methodsFor: 'platypus-generated-accessing' stamp: ''!
typeLabel: aString
	typeLabel := aString

! !

!PltGeneralAggregateType methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
typeLabelUsingContext: aContext
	^ self typeLabel

! !

PltDictionaryInstance subclass: #PltAliasStatementVariable
	instanceVariableNames: 'aliasIdent ref'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusStatementsSchemaSchema'!

!PltAliasStatementVariable commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY alias_statement_variable 
	SUBTYPE OF ( dictionary_instance );
	alias_ident : STRING;
	ref : assignable;
	SELF\entity_instance.owner : alias_statement;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltAliasStatementVariable class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltAliasStatementVariable class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltAliasStatementVariable class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltAliasStatementVariable class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusStatementsSchemaSchemaDefinition singleton

! !

!PltAliasStatementVariable class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltAliasStatementVariable class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltAliasStatementVariable class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltAliasStatementVariable methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptAliasStatementVariable: self

! !

!PltAliasStatementVariable methodsFor: 'platypus-generated-accessing' stamp: ''!
aliasIdent
	^ aliasIdent

! !

!PltAliasStatementVariable methodsFor: 'platypus-generated-accessing' stamp: ''!
aliasIdent: aString
	aliasIdent := aString

! !

!PltAliasStatementVariable methodsFor: 'platypus-generated-group-accessing' stamp: ''!
aliasIdent: aString ref: aPltAssignable owner: aPltAliasStatement 	self setAliasIdent:aString.	self setRef:aPltAssignable.	self setOwner:aPltAliasStatement.

! !

!PltAliasStatementVariable methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
aliasIdentUsingContext: aContext
	^ self aliasIdent

! !

!PltAliasStatementVariable methodsFor: 'platypus-generated-copying' stamp: ''!
aliasStatementVariableCopyTo: another
	another fastSetAliasIdent: self aliasIdent.
	another fastSetRef: self ref.
	another fastSetOwner: self owner

! !

!PltAliasStatementVariable methodsFor: 'platypus-generated-group-accessing' stamp: ''!
aliasStatementVariableFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setAliasIdent: valuesloc removeFirst.
	self setRef: valuesloc removeFirst.
	self setOwner: valuesloc removeFirst.
	^ valuesloc

! !

!PltAliasStatementVariable methodsFor: 'platypus-generated-group-accessing' stamp: ''!
aliasStatementVariableToValues: values
	values add: self aliasIdent.
	values add: self ref.
	values add: self owner.
	^ values

! !

!PltAliasStatementVariable methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetAliasIdent: aString
	aliasIdent := aString

! !

!PltAliasStatementVariable methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetOwner: aPltAliasStatement
	owner := aPltAliasStatement

! !

!PltAliasStatementVariable methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetRef: aPltAssignable
	ref := aPltAssignable

! !

!PltAliasStatementVariable methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self aliasStatementVariableFromValues: (super fromValues: values)

! !

!PltAliasStatementVariable methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltAliasStatementVariable
	^ true

! !

!PltAliasStatementVariable methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self aliasStatementVariableFromValues: values

! !

!PltAliasStatementVariable methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self aliasStatementVariableToValues: values

! !

!PltAliasStatementVariable methodsFor: 'platypus-generated-accessing' stamp: ''!
owner
	^ owner

! !

!PltAliasStatementVariable methodsFor: 'platypus-generated-accessing' stamp: ''!
owner: aPltAliasStatement
	owner := aPltAliasStatement

! !

!PltAliasStatementVariable methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
ownerUsingContext: aContext
	^ self owner

! !

!PltAliasStatementVariable methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltAliasStatementVariable methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self aliasStatementVariableCopyTo: another

! !

!PltAliasStatementVariable methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self aliasStatementVariableCopyTo: another

! !

!PltAliasStatementVariable methodsFor: 'platypus-generated-accessing' stamp: ''!
ref
	^ ref

! !

!PltAliasStatementVariable methodsFor: 'platypus-generated-accessing' stamp: ''!
ref: aPltAssignable
	ref := aPltAssignable

! !

!PltAliasStatementVariable methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
refUsingContext: aContext
	^ self ref

! !

!PltAliasStatementVariable methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setAliasIdent: aString
	self aliasIdent: aString

! !

!PltAliasStatementVariable methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setOwner: aPltAliasStatement
	self owner: aPltAliasStatement

! !

!PltAliasStatementVariable methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setRef: aPltAssignable
	self ref: aPltAssignable

! !

!PltAliasStatementVariable methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	aliasIdent := ''.
	ref := nil.
	owner := nil

! !

!PltAliasStatementVariable methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self aliasStatementVariableToValues: (super toValues: values)

! !

PltDictionaryInstance subclass: #PltAnonymousVariable
	instanceVariableNames: 'domain'
	classVariableNames: 'default'
	poolDictionaries: ''
	category: 'Platypus-PlatypusStatementsSchemaSchema'!

PltAnonymousVariable class
	instanceVariableNames: 'default'!

!PltAnonymousVariable commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY anonymous_variable 
	SUBTYPE OF ( dictionary_instance );
	domain : parameter_type;
END_ENTITY;
</ISO10303-11-EXPRESS>!

PltAnonymousVariable class
	instanceVariableNames: 'default'!

!PltAnonymousVariable class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltAnonymousVariable class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltAnonymousVariable class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltAnonymousVariable class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusStatementsSchemaSchemaDefinition singleton

! !

!PltAnonymousVariable class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltAnonymousVariable class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltAnonymousVariable class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltAnonymousVariable methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptAnonymousVariable: self

! !

!PltAnonymousVariable methodsFor: 'platypus-generated-copying' stamp: ''!
anonymousVariableCopyTo: another
	another fastSetDomain: self domain

! !

!PltAnonymousVariable methodsFor: 'platypus-generated-group-accessing' stamp: ''!
anonymousVariableFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setDomain: valuesloc removeFirst.
	^ valuesloc

! !

!PltAnonymousVariable methodsFor: 'platypus-generated-group-accessing' stamp: ''!
anonymousVariableToValues: values
	values add: self domain.
	^ values

! !

!PltAnonymousVariable methodsFor: 'platypus-generated-accessing' stamp: ''!
domain
	^ domain

! !

!PltAnonymousVariable methodsFor: 'platypus-generated-accessing' stamp: ''!
domain: aPltParameterType
	domain := aPltParameterType

! !

!PltAnonymousVariable methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
domainUsingContext: aContext
	^ self domain

! !

!PltAnonymousVariable methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetDomain: aPltParameterType
	domain := aPltParameterType

! !

!PltAnonymousVariable methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self anonymousVariableFromValues: (super fromValues: values)

! !

!PltAnonymousVariable methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltAnonymousVariable
	^ true

! !

!PltAnonymousVariable methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self anonymousVariableFromValues: values

! !

!PltAnonymousVariable methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self anonymousVariableToValues: values

! !

!PltAnonymousVariable methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltAnonymousVariable methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self anonymousVariableCopyTo: another

! !

!PltAnonymousVariable methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self anonymousVariableCopyTo: another

! !

!PltAnonymousVariable methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setDomain: aPltParameterType
	self domain: aPltParameterType

! !

!PltAnonymousVariable methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	domain := nil

! !

!PltAnonymousVariable methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self anonymousVariableToValues: (super toValues: values)

! !

PltDictionaryInstance subclass: #PltAssignable
	instanceVariableNames: 'qualifiers head'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusStatementsSchemaSchema'!

!PltAssignable commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY assignable 
	SUBTYPE OF ( dictionary_instance );
	head : identifier;
	qualifiers : LIST OF qualifier;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltAssignable class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltAssignable class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltAssignable class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltAssignable class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusStatementsSchemaSchemaDefinition singleton

! !

!PltAssignable class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltAssignable class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltAssignable class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltAssignable methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptAssignable: self

! !

!PltAssignable methodsFor: 'platypus-generated-copying' stamp: ''!
assignableCopyTo: another
	another fastSetHead: self head.
	another fastSetQualifiers: self qualifiers

! !

!PltAssignable methodsFor: 'platypus-generated-group-accessing' stamp: ''!
assignableFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setHead: valuesloc removeFirst.
	self setQualifiers: valuesloc removeFirst.
	^ valuesloc

! !

!PltAssignable methodsFor: 'platypus-generated-group-accessing' stamp: ''!
assignableToValues: values
	values add: self head.
	values add: self qualifiers.
	^ values

! !

!PltAssignable methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetHead: aPltIdentifier
	head := aPltIdentifier

! !

!PltAssignable methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetQualifiers: aListOfPltQualifier
	qualifiers := aListOfPltQualifier

! !

!PltAssignable methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self assignableFromValues: (super fromValues: values)

! !

!PltAssignable methodsFor: 'platypus-generated-accessing' stamp: ''!
head
	^ head

! !

!PltAssignable methodsFor: 'platypus-generated-accessing' stamp: ''!
head: aPltIdentifier
	head := aPltIdentifier

! !

!PltAssignable methodsFor: 'platypus-generated-group-accessing' stamp: ''!
head: aPltIdentifier qualifiers: aListOfPltQualifier 	self setHead:aPltIdentifier.	self setQualifiers:aListOfPltQualifier.

! !

!PltAssignable methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
headUsingContext: aContext
	^ self head

! !

!PltAssignable methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltAssignable
	^ true

! !

!PltAssignable methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self assignableFromValues: values

! !

!PltAssignable methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self assignableToValues: values

! !

!PltAssignable methodsFor: 'platypus-generated-accessing' stamp: ''!
owner
	^ owner

! !

!PltAssignable methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltAssignable methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self assignableCopyTo: another

! !

!PltAssignable methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self assignableCopyTo: another

! !

!PltAssignable methodsFor: 'platypus-generated-accessing' stamp: ''!
qualifiers
	^ qualifiers

! !

!PltAssignable methodsFor: 'platypus-generated-accessing' stamp: ''!
qualifiers: aListOfPltQualifier
	qualifiers := aListOfPltQualifier
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfPltQualifier as: OrderedCollection ]

! !

!PltAssignable methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
qualifiersUsingContext: aContext
	^ self qualifiers

! !

!PltAssignable methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setHead: aPltIdentifier
	self head: aPltIdentifier

! !

!PltAssignable methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setQualifiers: aListOfPltQualifier
	self qualifiers: aListOfPltQualifier

! !

!PltAssignable methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	head := nil.
	qualifiers := OrderedCollection new

! !

!PltAssignable methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self assignableToValues: (super toValues: values)

! !

PltDictionaryInstance subclass: #PltAttribute
	instanceVariableNames: 'domain redeclaring name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltAttribute commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY attribute 
	ABSTRACT SUPERTYPE OF ( ONEOF ( derived_attribute, explicit_attribute, inverse_attribute ) ) 
	SUBTYPE OF ( dictionary_instance );
	name : STRING;
	SELF\entity_instance.owner : entity_definition;
	domain : base_type;
	redeclaring : OPTIONAL attribute_reference;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltAttribute class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltAttribute class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltAttribute class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltAttribute class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltAttribute class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltAttribute class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltAttribute class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltAttribute methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptAttribute: self

! !

!PltAttribute methodsFor: 'platypus-generated-copying' stamp: ''!
attributeCopyTo: another
	another fastSetName: self name.
	another fastSetOwner: self owner.
	another fastSetDomain: self domain.
	another fastSetRedeclaring: self redeclaring

! !

!PltAttribute methodsFor: 'platypus-generated-group-accessing' stamp: ''!
attributeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setName: valuesloc removeFirst.
	self setOwner: valuesloc removeFirst.
	self setDomain: valuesloc removeFirst.
	self setRedeclaring: valuesloc removeFirst.
	^ valuesloc

! !

!PltAttribute methodsFor: 'platypus-generated-group-accessing' stamp: ''!
attributeToValues: values
	values add: self name.
	values add: self owner.
	values add: self domain.
	values add: self redeclaring.
	^ values

! !

!PltAttribute methodsFor: 'platypus-generated-accessing' stamp: ''!
domain
	^ domain

! !

!PltAttribute methodsFor: 'platypus-generated-accessing' stamp: ''!
domain: aPltBaseType
	domain := aPltBaseType

! !

!PltAttribute methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
domainUsingContext: aContext
	^ self domain

! !

!PltAttribute methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetDomain: aPltBaseType
	domain := aPltBaseType

! !

!PltAttribute methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetName: aString
	name := aString

! !

!PltAttribute methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetOwner: aPltEntityDefinition
	owner := aPltEntityDefinition

! !

!PltAttribute methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetRedeclaring: aPltAttributeReference
	redeclaring := aPltAttributeReference

! !

!PltAttribute methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self attributeFromValues: (super fromValues: values)

! !

!PltAttribute methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltAttribute
	^ true

! !

!PltAttribute methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self attributeFromValues: values

! !

!PltAttribute methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self attributeToValues: values

! !

!PltAttribute methodsFor: 'platypus-generated-accessing' stamp: ''!
name
	^ name

! !

!PltAttribute methodsFor: 'platypus-generated-accessing' stamp: ''!
name: aString
	name := aString

! !

!PltAttribute methodsFor: 'platypus-generated-group-accessing' stamp: ''!
name: aString owner: aPltEntityDefinition domain: aPltBaseType redeclaring: aPltAttributeReference 	self setName:aString.	self setOwner:aPltEntityDefinition.	self setDomain:aPltBaseType.	self setRedeclaring:aPltAttributeReference.

! !

!PltAttribute methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
nameUsingContext: aContext
	^ self name

! !

!PltAttribute methodsFor: 'platypus-generated-accessing' stamp: ''!
owner
	^ owner

! !

!PltAttribute methodsFor: 'platypus-generated-accessing' stamp: ''!
owner: aPltEntityDefinition
	owner := aPltEntityDefinition

! !

!PltAttribute methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
ownerUsingContext: aContext
	^ self owner

! !

!PltAttribute methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltAttribute methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self attributeCopyTo: another

! !

!PltAttribute methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self attributeCopyTo: another

! !

!PltAttribute methodsFor: 'platypus-generated-accessing' stamp: ''!
redeclaring
	^ redeclaring

! !

!PltAttribute methodsFor: 'platypus-generated-accessing' stamp: ''!
redeclaring: aPltAttributeReference
	redeclaring := aPltAttributeReference

! !

!PltAttribute methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
redeclaringUsingContext: aContext
	^ self redeclaring

! !

!PltAttribute methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setDomain: aPltBaseType
	self domain: aPltBaseType

! !

!PltAttribute methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setName: aString
	self name: aString

! !

!PltAttribute methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setOwner: aPltEntityDefinition
	self owner: aPltEntityDefinition

! !

!PltAttribute methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setRedeclaring: aPltAttributeReference
	self redeclaring: aPltAttributeReference

! !

!PltAttribute methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	name := ''.
	owner := nil.
	domain := nil.
	redeclaring := nil

! !

!PltAttribute methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self attributeToValues: (super toValues: values)

! !

PltAttribute subclass: #PltDerivedAttribute
	instanceVariableNames: 'assign'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltDerivedAttribute commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY derived_attribute 
	SUBTYPE OF ( attribute );
	assign : expression;
DERIVE
	accepted : entity_instance := SELF.accept_derived_attribute;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltDerivedAttribute class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltDerivedAttribute class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltDerivedAttribute class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltDerivedAttribute class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltDerivedAttribute class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltDerivedAttribute class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltDerivedAttribute class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltDerivedAttribute methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptDerivedAttribute: self

! !

!PltDerivedAttribute methodsFor: 'platypus-generated-deriving' stamp: ''!
accepted
	^ self acceptedUsingContext: self class context

! !

!PltDerivedAttribute methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext
	^ self acceptedUsingContext: aContext receiver: self

! !

!PltDerivedAttribute methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext receiver: aReceiver
	^ aReceiver acceptDerivedAttributeUsingContext: aContext

! !

!PltDerivedAttribute methodsFor: 'platypus-generated-accessing' stamp: ''!
assign
	^ assign

! !

!PltDerivedAttribute methodsFor: 'platypus-generated-accessing' stamp: ''!
assign: aPltExpression
	assign := aPltExpression

! !

!PltDerivedAttribute methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
assignUsingContext: aContext
	^ self assign

! !

!PltDerivedAttribute methodsFor: 'platypus-generated-copying' stamp: ''!
derivedAttributeCopyTo: another
	another fastSetAssign: self assign

! !

!PltDerivedAttribute methodsFor: 'platypus-generated-group-accessing' stamp: ''!
derivedAttributeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setAssign: valuesloc removeFirst.
	^ valuesloc

! !

!PltDerivedAttribute methodsFor: 'platypus-generated-group-accessing' stamp: ''!
derivedAttributeToValues: values
	values add: self assign.
	^ values

! !

!PltDerivedAttribute methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetAssign: aPltExpression
	assign := aPltExpression

! !

!PltDerivedAttribute methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self derivedAttributeFromValues: (super fromValues: values)

! !

!PltDerivedAttribute methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltDerivedAttribute
	^ true

! !

!PltDerivedAttribute methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self derivedAttributeFromValues: values

! !

!PltDerivedAttribute methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self derivedAttributeToValues: values

! !

!PltDerivedAttribute methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltDerivedAttribute methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self derivedAttributeCopyTo: another

! !

!PltDerivedAttribute methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self derivedAttributeCopyTo: another

! !

!PltDerivedAttribute methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setAssign: aPltExpression
	self assign: aPltExpression

! !

!PltDerivedAttribute methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	assign := nil

! !

!PltDerivedAttribute methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self derivedAttributeToValues: (super toValues: values)

! !

PltAttribute subclass: #PltExplicitAttribute
	instanceVariableNames: 'optionalFlag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltExplicitAttribute commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY explicit_attribute 
	SUBTYPE OF ( attribute );
	optional_flag : BOOLEAN;
DERIVE
	accepted : entity_instance := SELF.accept_explicit_attribute;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltExplicitAttribute class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltExplicitAttribute class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltExplicitAttribute class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltExplicitAttribute class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltExplicitAttribute class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltExplicitAttribute class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltExplicitAttribute class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltExplicitAttribute methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptExplicitAttribute: self

! !

!PltExplicitAttribute methodsFor: 'platypus-generated-deriving' stamp: ''!
accepted
	^ self acceptedUsingContext: self class context

! !

!PltExplicitAttribute methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext
	^ self acceptedUsingContext: aContext receiver: self

! !

!PltExplicitAttribute methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext receiver: aReceiver
	^ aReceiver acceptExplicitAttributeUsingContext: aContext

! !

!PltExplicitAttribute methodsFor: 'platypus-generated-copying' stamp: ''!
explicitAttributeCopyTo: another
	another fastSetOptionalFlag: self optionalFlag

! !

!PltExplicitAttribute methodsFor: 'platypus-generated-group-accessing' stamp: ''!
explicitAttributeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setOptionalFlag: valuesloc removeFirst.
	^ valuesloc

! !

!PltExplicitAttribute methodsFor: 'platypus-generated-group-accessing' stamp: ''!
explicitAttributeToValues: values
	values add: self optionalFlag.
	^ values

! !

!PltExplicitAttribute methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetOptionalFlag: aBoolean
	optionalFlag := aBoolean

! !

!PltExplicitAttribute methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self explicitAttributeFromValues: (super fromValues: values)

! !

!PltExplicitAttribute methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltExplicitAttribute
	^ true

! !

!PltExplicitAttribute methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self explicitAttributeFromValues: values

! !

!PltExplicitAttribute methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self explicitAttributeToValues: values

! !

!PltExplicitAttribute methodsFor: 'platypus-generated-accessing' stamp: ''!
optionalFlag
	^ optionalFlag

! !

!PltExplicitAttribute methodsFor: 'platypus-generated-accessing' stamp: ''!
optionalFlag: aBoolean
	optionalFlag := aBoolean

! !

!PltExplicitAttribute methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
optionalFlagUsingContext: aContext
	^ self optionalFlag

! !

!PltExplicitAttribute methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltExplicitAttribute methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self explicitAttributeCopyTo: another

! !

!PltExplicitAttribute methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self explicitAttributeCopyTo: another

! !

!PltExplicitAttribute methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setOptionalFlag: aBoolean
	self optionalFlag: aBoolean

! !

!PltExplicitAttribute methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	optionalFlag := false

! !

!PltExplicitAttribute methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self explicitAttributeToValues: (super toValues: values)

! !

PltAttribute subclass: #PltInverseAttribute
	instanceVariableNames: 'minCardinality duplicates maxCardinality invertedAttr'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltInverseAttribute commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY inverse_attribute 
	SUBTYPE OF ( attribute );
	inverted_attr : attribute_reference;
	min_cardinality : OPTIONAL bound;
	max_cardinality : OPTIONAL bound;
	duplicates : BOOLEAN;
DERIVE
	SELF\attribute.domain : entity_definition_reference := inverted_attr.entity_ref;
	accepted : entity_instance := SELF.accept_inverse_attribute;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltInverseAttribute class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltInverseAttribute class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltInverseAttribute class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltInverseAttribute class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltInverseAttribute class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltInverseAttribute class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltInverseAttribute class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltInverseAttribute methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptInverseAttribute: self

! !

!PltInverseAttribute methodsFor: 'platypus-generated-deriving' stamp: ''!
accepted
	^ self acceptedUsingContext: self class context

! !

!PltInverseAttribute methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext
	^ self acceptedUsingContext: aContext receiver: self

! !

!PltInverseAttribute methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext receiver: aReceiver
	^ aReceiver acceptInverseAttributeUsingContext: aContext

! !

!PltInverseAttribute methodsFor: 'platypus-generated-deriving' stamp: ''!
domain
	^ self domainUsingContext: self class context

! !

!PltInverseAttribute methodsFor: 'platypus-generated-deriving' stamp: ''!
domainUsingContext: aContext
	^ self domainUsingContext: aContext receiver: self

! !

!PltInverseAttribute methodsFor: 'platypus-generated-deriving' stamp: ''!
domainUsingContext: aContext receiver: aReceiver
	^ aReceiver invertedAttr entityRefUsingContext: aContext

! !

!PltInverseAttribute methodsFor: 'platypus-generated-accessing' stamp: ''!
duplicates
	^ duplicates

! !

!PltInverseAttribute methodsFor: 'platypus-generated-accessing' stamp: ''!
duplicates: aBoolean
	duplicates := aBoolean

! !

!PltInverseAttribute methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
duplicatesUsingContext: aContext
	^ self duplicates

! !

!PltInverseAttribute methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetDuplicates: aBoolean
	duplicates := aBoolean

! !

!PltInverseAttribute methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetInvertedAttr: aPltAttributeReference
	invertedAttr := aPltAttributeReference

! !

!PltInverseAttribute methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetMaxCardinality: aPltBound
	maxCardinality := aPltBound

! !

!PltInverseAttribute methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetMinCardinality: aPltBound
	minCardinality := aPltBound

! !

!PltInverseAttribute methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self inverseAttributeFromValues: (super fromValues: values)

! !

!PltInverseAttribute methodsFor: 'platypus-generated-copying' stamp: ''!
inverseAttributeCopyTo: another
	another fastSetInvertedAttr: self invertedAttr.
	another fastSetMinCardinality: self minCardinality.
	another fastSetMaxCardinality: self maxCardinality.
	another fastSetDuplicates: self duplicates

! !

!PltInverseAttribute methodsFor: 'platypus-generated-group-accessing' stamp: ''!
inverseAttributeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setInvertedAttr: valuesloc removeFirst.
	self setMinCardinality: valuesloc removeFirst.
	self setMaxCardinality: valuesloc removeFirst.
	self setDuplicates: valuesloc removeFirst.
	^ valuesloc

! !

!PltInverseAttribute methodsFor: 'platypus-generated-group-accessing' stamp: ''!
inverseAttributeToValues: values
	values add: self invertedAttr.
	values add: self minCardinality.
	values add: self maxCardinality.
	values add: self duplicates.
	^ values

! !

!PltInverseAttribute methodsFor: 'platypus-generated-accessing' stamp: ''!
invertedAttr
	^ invertedAttr

! !

!PltInverseAttribute methodsFor: 'platypus-generated-accessing' stamp: ''!
invertedAttr: aPltAttributeReference
	invertedAttr := aPltAttributeReference

! !

!PltInverseAttribute methodsFor: 'platypus-generated-group-accessing' stamp: ''!
invertedAttr: aPltAttributeReference minCardinality: aPltBound maxCardinality: aPltBound1 duplicates: aBoolean 	self setInvertedAttr:aPltAttributeReference.	self setMinCardinality:aPltBound.	self setMaxCardinality:aPltBound1.	self setDuplicates:aBoolean.

! !

!PltInverseAttribute methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
invertedAttrUsingContext: aContext
	^ self invertedAttr

! !

!PltInverseAttribute methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltInverseAttribute
	^ true

! !

!PltInverseAttribute methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self inverseAttributeFromValues: values

! !

!PltInverseAttribute methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self inverseAttributeToValues: values

! !

!PltInverseAttribute methodsFor: 'platypus-generated-accessing' stamp: ''!
maxCardinality
	^ maxCardinality

! !

!PltInverseAttribute methodsFor: 'platypus-generated-accessing' stamp: ''!
maxCardinality: aPltBound
	maxCardinality := aPltBound

! !

!PltInverseAttribute methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
maxCardinalityUsingContext: aContext
	^ self maxCardinality

! !

!PltInverseAttribute methodsFor: 'platypus-generated-accessing' stamp: ''!
minCardinality
	^ minCardinality

! !

!PltInverseAttribute methodsFor: 'platypus-generated-accessing' stamp: ''!
minCardinality: aPltBound
	minCardinality := aPltBound

! !

!PltInverseAttribute methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
minCardinalityUsingContext: aContext
	^ self minCardinality

! !

!PltInverseAttribute methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltInverseAttribute methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self inverseAttributeCopyTo: another

! !

!PltInverseAttribute methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self inverseAttributeCopyTo: another

! !

!PltInverseAttribute methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setDuplicates: aBoolean
	self duplicates: aBoolean

! !

!PltInverseAttribute methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setInvertedAttr: aPltAttributeReference
	self invertedAttr: aPltAttributeReference

! !

!PltInverseAttribute methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setMaxCardinality: aPltBound
	self maxCardinality: aPltBound

! !

!PltInverseAttribute methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setMinCardinality: aPltBound
	self minCardinality: aPltBound

! !

!PltInverseAttribute methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	invertedAttr := nil.
	minCardinality := nil.
	maxCardinality := nil.
	duplicates := false

! !

!PltInverseAttribute methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self inverseAttributeToValues: (super toValues: values)

! !

PltDictionaryInstance subclass: #PltBound
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltBound commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY bound 
	ABSTRACT SUPERTYPE OF ( ONEOF ( integer_bound, population_dependent_bound ) ) 
	SUBTYPE OF ( dictionary_instance );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltBound class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltBound class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltBound class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltBound class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltBound class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltBound class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltBound class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltBound methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptBound: self

! !

!PltBound methodsFor: 'platypus-generated-copying' stamp: ''!
boundCopyTo: another
	

! !

!PltBound methodsFor: 'platypus-generated-group-accessing' stamp: ''!
boundFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltBound methodsFor: 'platypus-generated-group-accessing' stamp: ''!
boundToValues: values
	^ values

! !

!PltBound methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self boundFromValues: (super fromValues: values)

! !

!PltBound methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltBound
	^ true

! !

!PltBound methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self boundFromValues: values

! !

!PltBound methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self boundToValues: values

! !

!PltBound methodsFor: 'platypus-generated-accessing' stamp: ''!
owner
	^ owner

! !

!PltBound methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltBound methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self boundCopyTo: another

! !

!PltBound methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self boundCopyTo: another

! !

!PltBound methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltBound methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self boundToValues: (super toValues: values)

! !

PltBound subclass: #PltIntegerBound
	instanceVariableNames: 'boundValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltIntegerBound commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY integer_bound 
	SUBTYPE OF ( bound );
	bound_value : INTEGER;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltIntegerBound class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltIntegerBound class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltIntegerBound class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltIntegerBound class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltIntegerBound class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltIntegerBound class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltIntegerBound class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltIntegerBound methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptIntegerBound: self

! !

!PltIntegerBound methodsFor: 'platypus-generated-accessing' stamp: ''!
boundValue
	^ boundValue

! !

!PltIntegerBound methodsFor: 'platypus-generated-accessing' stamp: ''!
boundValue: anInteger
	boundValue := anInteger

! !

!PltIntegerBound methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
boundValueUsingContext: aContext
	^ self boundValue

! !

!PltIntegerBound methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetBoundValue: anInteger
	boundValue := anInteger

! !

!PltIntegerBound methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self integerBoundFromValues: (super fromValues: values)

! !

!PltIntegerBound methodsFor: 'platypus-generated-copying' stamp: ''!
integerBoundCopyTo: another
	another fastSetBoundValue: self boundValue

! !

!PltIntegerBound methodsFor: 'platypus-generated-group-accessing' stamp: ''!
integerBoundFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setBoundValue: valuesloc removeFirst.
	^ valuesloc

! !

!PltIntegerBound methodsFor: 'platypus-generated-group-accessing' stamp: ''!
integerBoundToValues: values
	values add: self boundValue.
	^ values

! !

!PltIntegerBound methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltIntegerBound
	^ true

! !

!PltIntegerBound methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self integerBoundFromValues: values

! !

!PltIntegerBound methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self integerBoundToValues: values

! !

!PltIntegerBound methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltIntegerBound methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self integerBoundCopyTo: another

! !

!PltIntegerBound methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self integerBoundCopyTo: another

! !

!PltIntegerBound methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setBoundValue: anInteger
	self boundValue: anInteger

! !

!PltIntegerBound methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	boundValue := 0

! !

!PltIntegerBound methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self integerBoundToValues: (super toValues: values)

! !

PltBound subclass: #PltPopulationDependentBound
	instanceVariableNames: 'boundValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltPopulationDependentBound commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY population_dependent_bound 
	SUBTYPE OF ( bound );
	bound_value : expression;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltPopulationDependentBound class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltPopulationDependentBound class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltPopulationDependentBound class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltPopulationDependentBound class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltPopulationDependentBound class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltPopulationDependentBound class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltPopulationDependentBound class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltPopulationDependentBound methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptPopulationDependentBound: self

! !

!PltPopulationDependentBound methodsFor: 'platypus-generated-accessing' stamp: ''!
boundValue
	^ boundValue

! !

!PltPopulationDependentBound methodsFor: 'platypus-generated-accessing' stamp: ''!
boundValue: aPltExpression
	boundValue := aPltExpression

! !

!PltPopulationDependentBound methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
boundValueUsingContext: aContext
	^ self boundValue

! !

!PltPopulationDependentBound methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetBoundValue: aPltExpression
	boundValue := aPltExpression

! !

!PltPopulationDependentBound methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self populationDependentBoundFromValues: (super fromValues: values)

! !

!PltPopulationDependentBound methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltPopulationDependentBound
	^ true

! !

!PltPopulationDependentBound methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self populationDependentBoundFromValues: values

! !

!PltPopulationDependentBound methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self populationDependentBoundToValues: values

! !

!PltPopulationDependentBound methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltPopulationDependentBound methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self populationDependentBoundCopyTo: another

! !

!PltPopulationDependentBound methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self populationDependentBoundCopyTo: another

! !

!PltPopulationDependentBound methodsFor: 'platypus-generated-copying' stamp: ''!
populationDependentBoundCopyTo: another
	another fastSetBoundValue: self boundValue

! !

!PltPopulationDependentBound methodsFor: 'platypus-generated-group-accessing' stamp: ''!
populationDependentBoundFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setBoundValue: valuesloc removeFirst.
	^ valuesloc

! !

!PltPopulationDependentBound methodsFor: 'platypus-generated-group-accessing' stamp: ''!
populationDependentBoundToValues: values
	values add: self boundValue.
	^ values

! !

!PltPopulationDependentBound methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setBoundValue: aPltExpression
	self boundValue: aPltExpression

! !

!PltPopulationDependentBound methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	boundValue := nil

! !

!PltPopulationDependentBound methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self populationDependentBoundToValues: (super toValues: values)

! !

PltDictionaryInstance subclass: #PltCaseAction
	instanceVariableNames: 'labels action'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusStatementsSchemaSchema'!

!PltCaseAction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY case_action 
	SUBTYPE OF ( dictionary_instance );
	labels : LIST OF expression;
	action : statement;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltCaseAction class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltCaseAction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltCaseAction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltCaseAction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusStatementsSchemaSchemaDefinition singleton

! !

!PltCaseAction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltCaseAction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltCaseAction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltCaseAction methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptCaseAction: self

! !

!PltCaseAction methodsFor: 'platypus-generated-accessing' stamp: ''!
action
	^ action

! !

!PltCaseAction methodsFor: 'platypus-generated-accessing' stamp: ''!
action: aPltStatement
	action := aPltStatement

! !

!PltCaseAction methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
actionUsingContext: aContext
	^ self action

! !

!PltCaseAction methodsFor: 'platypus-generated-copying' stamp: ''!
caseActionCopyTo: another
	another fastSetLabels: self labels.
	another fastSetAction: self action

! !

!PltCaseAction methodsFor: 'platypus-generated-group-accessing' stamp: ''!
caseActionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setLabels: valuesloc removeFirst.
	self setAction: valuesloc removeFirst.
	^ valuesloc

! !

!PltCaseAction methodsFor: 'platypus-generated-group-accessing' stamp: ''!
caseActionToValues: values
	values add: self labels.
	values add: self action.
	^ values

! !

!PltCaseAction methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetAction: aPltStatement
	action := aPltStatement

! !

!PltCaseAction methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetLabels: aListOfPltExpression
	labels := aListOfPltExpression

! !

!PltCaseAction methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self caseActionFromValues: (super fromValues: values)

! !

!PltCaseAction methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltCaseAction
	^ true

! !

!PltCaseAction methodsFor: 'platypus-generated-accessing' stamp: ''!
labels
	^ labels

! !

!PltCaseAction methodsFor: 'platypus-generated-accessing' stamp: ''!
labels: aListOfPltExpression
	labels := aListOfPltExpression
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfPltExpression as: OrderedCollection ]

! !

!PltCaseAction methodsFor: 'platypus-generated-group-accessing' stamp: ''!
labels: aListOfPltExpression action: aPltStatement 	self setLabels:aListOfPltExpression.	self setAction:aPltStatement.

! !

!PltCaseAction methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
labelsUsingContext: aContext
	^ self labels

! !

!PltCaseAction methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self caseActionFromValues: values

! !

!PltCaseAction methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self caseActionToValues: values

! !

!PltCaseAction methodsFor: 'platypus-generated-accessing' stamp: ''!
owner
	^owner! !

!PltCaseAction methodsFor: 'platypus-generated-group-accessing' stamp: ''!
owner: aPltCaseStatement labels: aListOfPltExpression action: aPltStatement
	self setOwner:aPltCaseStatement.
	self setLabels:aListOfPltExpression.
	self setAction:aPltStatement.
! !

!PltCaseAction methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltCaseAction methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self caseActionCopyTo: another

! !

!PltCaseAction methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self caseActionCopyTo: another

! !

!PltCaseAction methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setAction: aPltStatement
	self action: aPltStatement

! !

!PltCaseAction methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setLabels: aListOfPltExpression
	self labels: aListOfPltExpression

! !

!PltCaseAction methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	labels := OrderedCollection new.
	action := nil

! !

!PltCaseAction methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self caseActionToValues: (super toValues: values)

! !

PltDictionaryInstance subclass: #PltConstantDefinition
	instanceVariableNames: 'domain name initializer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltConstantDefinition commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY constant_definition 
	SUBTYPE OF ( dictionary_instance );
	name : STRING;
	domain : base_type;
	initializer : expression;
	SELF\entity_instance.owner : context_definition;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltConstantDefinition class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltConstantDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltConstantDefinition class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltConstantDefinition class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltConstantDefinition class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltConstantDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltConstantDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltConstantDefinition methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptConstantDefinition: self

! !

!PltConstantDefinition methodsFor: 'platypus-generated-copying' stamp: ''!
constantDefinitionCopyTo: another
	another fastSetName: self name.
	another fastSetDomain: self domain.
	another fastSetInitializer: self initializer.
	another fastSetOwner: self owner

! !

!PltConstantDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
constantDefinitionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setName: valuesloc removeFirst.
	self setDomain: valuesloc removeFirst.
	self setInitializer: valuesloc removeFirst.
	self setOwner: valuesloc removeFirst.
	^ valuesloc

! !

!PltConstantDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
constantDefinitionToValues: values
	values add: self name.
	values add: self domain.
	values add: self initializer.
	values add: self owner.
	^ values

! !

!PltConstantDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
domain
	^ domain

! !

!PltConstantDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
domain: aPltBaseType
	domain := aPltBaseType

! !

!PltConstantDefinition methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
domainUsingContext: aContext
	^ self domain

! !

!PltConstantDefinition methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetDomain: aPltBaseType
	domain := aPltBaseType

! !

!PltConstantDefinition methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetInitializer: aPltExpression
	initializer := aPltExpression

! !

!PltConstantDefinition methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetName: aString
	name := aString

! !

!PltConstantDefinition methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetOwner: aPltContextDefinition
	owner := aPltContextDefinition

! !

!PltConstantDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self constantDefinitionFromValues: (super fromValues: values)

! !

!PltConstantDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
initializer
	^ initializer

! !

!PltConstantDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
initializer: aPltExpression
	initializer := aPltExpression

! !

!PltConstantDefinition methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
initializerUsingContext: aContext
	^ self initializer

! !

!PltConstantDefinition methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltConstantDefinition
	^ true

! !

!PltConstantDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self constantDefinitionFromValues: values

! !

!PltConstantDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self constantDefinitionToValues: values

! !

!PltConstantDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
name
	^ name

! !

!PltConstantDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
name: aString
	name := aString

! !

!PltConstantDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
name: aString domain: aPltBaseType initializer: aPltExpression owner: aPltContextDefinition 	self setName:aString.	self setDomain:aPltBaseType.	self setInitializer:aPltExpression.	self setOwner:aPltContextDefinition.

! !

!PltConstantDefinition methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
nameUsingContext: aContext
	^ self name

! !

!PltConstantDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
owner
	^ owner

! !

!PltConstantDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
owner: aPltContextDefinition
	owner := aPltContextDefinition

! !

!PltConstantDefinition methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
ownerUsingContext: aContext
	^ self owner

! !

!PltConstantDefinition methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltConstantDefinition methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self constantDefinitionCopyTo: another

! !

!PltConstantDefinition methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self constantDefinitionCopyTo: another

! !

!PltConstantDefinition methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setDomain: aPltBaseType
	self domain: aPltBaseType

! !

!PltConstantDefinition methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setInitializer: aPltExpression
	self initializer: aPltExpression

! !

!PltConstantDefinition methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setName: aString
	self name: aString

! !

!PltConstantDefinition methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setOwner: aPltContextDefinition
	self owner: aPltContextDefinition

! !

!PltConstantDefinition methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	name := ''.
	domain := nil.
	initializer := nil.
	owner := nil

! !

!PltConstantDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self constantDefinitionToValues: (super toValues: values)

! !

PltDictionaryInstance subclass: #PltContextDefinition
	instanceVariableNames: 'namedTypesCache types constants identifiersCache name algorithmes entities'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltContextDefinition commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY context_definition 
	ABSTRACT SUPERTYPE OF ( ONEOF ( schema_definition, statements_container ) ) 
	SUBTYPE OF ( dictionary_instance );
	name : STRING;
	constants : LIST OF constant_definition;
	types : LIST OF defined_type;
	entities : LIST OF entity_definition;
	algorithmes : LIST OF algorithm_declaration;
	SELF\entity_instance.owner : OPTIONAL context_owner;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltContextDefinition class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltContextDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltContextDefinition class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltContextDefinition class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltContextDefinition class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltContextDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltContextDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltContextDefinition methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptContextDefinition: self

! !

!PltContextDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
algorithmes
	^ algorithmes

! !

!PltContextDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
algorithmes: aListOfPltAlgorithmDeclaration
	algorithmes := aListOfPltAlgorithmDeclaration
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfPltAlgorithmDeclaration as: OrderedCollection ]

! !

!PltContextDefinition methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
algorithmesUsingContext: aContext
	^ self algorithmes

! !

!PltContextDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
constants
	^ constants

! !

!PltContextDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
constants: aListOfPltConstantDefinition
	constants := aListOfPltConstantDefinition
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfPltConstantDefinition as: OrderedCollection ]

! !

!PltContextDefinition methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
constantsUsingContext: aContext
	^ self constants

! !

!PltContextDefinition methodsFor: 'platypus-generated-copying' stamp: ''!
contextDefinitionCopyTo: another
	another fastSetName: self name.
	another fastSetConstants: self constants.
	another fastSetTypes: self types.
	another fastSetEntities: self entities.
	another fastSetAlgorithmes: self algorithmes.
	another fastSetOwner: self owner

! !

!PltContextDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
contextDefinitionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setName: valuesloc removeFirst.
	self setConstants: valuesloc removeFirst.
	self setTypes: valuesloc removeFirst.
	self setEntities: valuesloc removeFirst.
	self setAlgorithmes: valuesloc removeFirst.
	self setOwner: valuesloc removeFirst.
	^ valuesloc

! !

!PltContextDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
contextDefinitionToValues: values
	values add: self name.
	values add: self constants.
	values add: self types.
	values add: self entities.
	values add: self algorithmes.
	values add: self owner.
	^ values

! !

!PltContextDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
entities
	^ entities

! !

!PltContextDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
entities: aListOfPltEntityDefinition
	entities := aListOfPltEntityDefinition
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfPltEntityDefinition as: OrderedCollection ]

! !

!PltContextDefinition methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
entitiesUsingContext: aContext
	^ self entities

! !

!PltContextDefinition methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetAlgorithmes: aListOfPltAlgorithmDeclaration
	algorithmes := aListOfPltAlgorithmDeclaration

! !

!PltContextDefinition methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetConstants: aListOfPltConstantDefinition
	constants := aListOfPltConstantDefinition

! !

!PltContextDefinition methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetEntities: aListOfPltEntityDefinition
	entities := aListOfPltEntityDefinition

! !

!PltContextDefinition methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetName: aString
	name := aString

! !

!PltContextDefinition methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetOwner: aPltContextOwner
	owner := aPltContextOwner

! !

!PltContextDefinition methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetTypes: aListOfPltDefinedType
	types := aListOfPltDefinedType

! !

!PltContextDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self contextDefinitionFromValues: (super fromValues: values)

! !

!PltContextDefinition methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltContextDefinition
	^ true

! !

!PltContextDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self contextDefinitionFromValues: values

! !

!PltContextDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self contextDefinitionToValues: values

! !

!PltContextDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
name
	^ name

! !

!PltContextDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
name: aString
	name := aString

! !

!PltContextDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
name: aString constants: aListOfPltConstantDefinition types: aListOfPltDefinedType entities: aListOfPltEntityDefinition algorithmes: aListOfPltAlgorithmDeclaration owner: aPltContextOwner 	self setName:aString.	self setConstants:aListOfPltConstantDefinition.	self setTypes:aListOfPltDefinedType.	self setEntities:aListOfPltEntityDefinition.	self setAlgorithmes:aListOfPltAlgorithmDeclaration.	self setOwner:aPltContextOwner.

! !

!PltContextDefinition methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
nameUsingContext: aContext
	^ self name

! !

!PltContextDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
owner
	^ owner

! !

!PltContextDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
owner: aPltContextOwner
	owner := aPltContextOwner

! !

!PltContextDefinition methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
ownerUsingContext: aContext
	^ self owner

! !

!PltContextDefinition methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltContextDefinition methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self contextDefinitionCopyTo: another

! !

!PltContextDefinition methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self contextDefinitionCopyTo: another

! !

!PltContextDefinition methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setAlgorithmes: aListOfPltAlgorithmDeclaration
	self algorithmes: aListOfPltAlgorithmDeclaration

! !

!PltContextDefinition methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setConstants: aListOfPltConstantDefinition
	self constants: aListOfPltConstantDefinition

! !

!PltContextDefinition methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setEntities: aListOfPltEntityDefinition
	self entities: aListOfPltEntityDefinition

! !

!PltContextDefinition methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setName: aString
	self name: aString

! !

!PltContextDefinition methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setOwner: aPltContextOwner
	self owner: aPltContextOwner

! !

!PltContextDefinition methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setTypes: aListOfPltDefinedType
	self types: aListOfPltDefinedType

! !

!PltContextDefinition methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	name := ''.
	constants := OrderedCollection new.
	types := OrderedCollection new.
	entities := OrderedCollection new.
	algorithmes := OrderedCollection new.
	owner := nil

! !

!PltContextDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self contextDefinitionToValues: (super toValues: values)

! !

!PltContextDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
types
	^ types

! !

!PltContextDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
types: aListOfPltDefinedType
	types := aListOfPltDefinedType
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfPltDefinedType as: OrderedCollection ]

! !

!PltContextDefinition methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
typesUsingContext: aContext
	^ self types

! !

PltContextDefinition subclass: #PltSchemaDefinition
	instanceVariableNames: 'interface remarkReferences mappings globalRules'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltSchemaDefinition commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY schema_definition 
	SUBTYPE OF ( context_definition );
	global_rules : LIST OF global_rule;
	interface : LIST OF external_schema;
	remark_references : LIST OF remark_reference;
DERIVE
	accepted : entity_instance := SELF.accept_schema_definition;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltSchemaDefinition class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltSchemaDefinition class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltSchemaDefinition class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltSchemaDefinition class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltSchemaDefinition methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptSchemaDefinition: self

! !

!PltSchemaDefinition methodsFor: 'platypus-generated-deriving' stamp: ''!
accepted
	^ self acceptedUsingContext: self class context

! !

!PltSchemaDefinition methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext
	^ self acceptedUsingContext: aContext receiver: self

! !

!PltSchemaDefinition methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext receiver: aReceiver
	^ aReceiver acceptSchemaDefinitionUsingContext: aContext

! !

!PltSchemaDefinition methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetGlobalRules: aListOfPltGlobalRule
	globalRules := aListOfPltGlobalRule

! !

!PltSchemaDefinition methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetInterface: aListOfPltExternalSchema
	interface := aListOfPltExternalSchema

! !

!PltSchemaDefinition methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetRemarkReferences: aListOfPltRemarkReference
	remarkReferences := aListOfPltRemarkReference

! !

!PltSchemaDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self schemaDefinitionFromValues: (super fromValues: values)

! !

!PltSchemaDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
globalRules
	^ globalRules

! !

!PltSchemaDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
globalRules: aListOfPltGlobalRule
	globalRules := aListOfPltGlobalRule
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfPltGlobalRule as: OrderedCollection ]

! !

!PltSchemaDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
globalRules: aListOfPltGlobalRule interface: aListOfPltExternalSchema remarkReferences: aListOfPltRemarkReference 	self setGlobalRules:aListOfPltGlobalRule.	self setInterface:aListOfPltExternalSchema.	self setRemarkReferences:aListOfPltRemarkReference.

! !

!PltSchemaDefinition methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
globalRulesUsingContext: aContext
	^ self globalRules

! !

!PltSchemaDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
interface
	^ interface

! !

!PltSchemaDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
interface: aListOfPltExternalSchema
	interface := aListOfPltExternalSchema
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfPltExternalSchema as: OrderedCollection ]

! !

!PltSchemaDefinition methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
interfaceUsingContext: aContext
	^ self interface

! !

!PltSchemaDefinition methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltSchemaDefinition
	^ true

! !

!PltSchemaDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self schemaDefinitionFromValues: values

! !

!PltSchemaDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self schemaDefinitionToValues: values

! !

!PltSchemaDefinition methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
mappingsUsingContext:aContext	^ self mappings

! !

!PltSchemaDefinition methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltSchemaDefinition methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self schemaDefinitionCopyTo: another

! !

!PltSchemaDefinition methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self schemaDefinitionCopyTo: another

! !

!PltSchemaDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
remarkReferences
	^ remarkReferences

! !

!PltSchemaDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
remarkReferences: aListOfPltRemarkReference
	remarkReferences := aListOfPltRemarkReference
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfPltRemarkReference as: OrderedCollection ]

! !

!PltSchemaDefinition methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
remarkReferencesUsingContext: aContext
	^ self remarkReferences

! !

!PltSchemaDefinition methodsFor: 'platypus-generated-copying' stamp: ''!
schemaDefinitionCopyTo: another
	another fastSetGlobalRules: self globalRules.
	another fastSetInterface: self interface.
	another fastSetRemarkReferences: self remarkReferences

! !

!PltSchemaDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
schemaDefinitionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setGlobalRules: valuesloc removeFirst.
	self setInterface: valuesloc removeFirst.
	self setRemarkReferences: valuesloc removeFirst.
	^ valuesloc

! !

!PltSchemaDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
schemaDefinitionToValues: values
	values add: self globalRules.
	values add: self interface.
	values add: self remarkReferences.
	^ values

! !

!PltSchemaDefinition methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setGlobalRules: aListOfPltGlobalRule
	self globalRules: aListOfPltGlobalRule

! !

!PltSchemaDefinition methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setInterface: aListOfPltExternalSchema
	self interface: aListOfPltExternalSchema

! !

!PltSchemaDefinition methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setRemarkReferences: aListOfPltRemarkReference
	self remarkReferences: aListOfPltRemarkReference

! !

!PltSchemaDefinition methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	globalRules := OrderedCollection new.
	interface := OrderedCollection new.
	remarkReferences := OrderedCollection new

! !

!PltSchemaDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self schemaDefinitionToValues: (super toValues: values)

! !

PltContextDefinition subclass: #PltStatementsContainer
	instanceVariableNames: 'locals statements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltStatementsContainer commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY statements_container 
	ABSTRACT SUPERTYPE 
	SUBTYPE OF ( context_definition );
	locals : LIST OF local_variable;
	statements : LIST OF statement;
END_ENTITY;
</ISO10303-11-EXPRESS>!

PltStatementsContainer subclass: #PltAlgorithmDeclaration
	instanceVariableNames: 'formalParameters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltAlgorithmDeclaration commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY algorithm_declaration 
	ABSTRACT SUPERTYPE 
	SUBTYPE OF ( statements_container );
	formal_parameters : LIST OF parameter_definition;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltAlgorithmDeclaration class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltAlgorithmDeclaration class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltAlgorithmDeclaration class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltAlgorithmDeclaration class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltAlgorithmDeclaration class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltAlgorithmDeclaration class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltAlgorithmDeclaration class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltAlgorithmDeclaration methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptAlgorithmDeclaration: self

! !

!PltAlgorithmDeclaration methodsFor: 'platypus-generated-copying' stamp: ''!
algorithmDeclarationCopyTo: another
	another fastSetFormalParameters: self formalParameters

! !

!PltAlgorithmDeclaration methodsFor: 'platypus-generated-group-accessing' stamp: ''!
algorithmDeclarationFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setFormalParameters: valuesloc removeFirst.
	^ valuesloc

! !

!PltAlgorithmDeclaration methodsFor: 'platypus-generated-group-accessing' stamp: ''!
algorithmDeclarationToValues: values
	values add: self formalParameters.
	^ values

! !

!PltAlgorithmDeclaration methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetFormalParameters: aListOfPltParameterDefinition
	formalParameters := aListOfPltParameterDefinition

! !

!PltAlgorithmDeclaration methodsFor: 'platypus-generated-accessing' stamp: ''!
formalParameters
	^ formalParameters

! !

!PltAlgorithmDeclaration methodsFor: 'platypus-generated-accessing' stamp: ''!
formalParameters: aListOfPltParameterDefinition
	formalParameters := aListOfPltParameterDefinition
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfPltParameterDefinition as: OrderedCollection ]

! !

!PltAlgorithmDeclaration methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
formalParametersUsingContext: aContext
	^ self formalParameters

! !

!PltAlgorithmDeclaration methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self algorithmDeclarationFromValues: (super fromValues: values)

! !

!PltAlgorithmDeclaration methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltAlgorithmDeclaration
	^ true

! !

!PltAlgorithmDeclaration methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self algorithmDeclarationFromValues: values

! !

!PltAlgorithmDeclaration methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self algorithmDeclarationToValues: values

! !

!PltAlgorithmDeclaration methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltAlgorithmDeclaration methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self algorithmDeclarationCopyTo: another

! !

!PltAlgorithmDeclaration methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self algorithmDeclarationCopyTo: another

! !

!PltAlgorithmDeclaration methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setFormalParameters: aListOfPltParameterDefinition
	self formalParameters: aListOfPltParameterDefinition

! !

!PltAlgorithmDeclaration methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	formalParameters := OrderedCollection new

! !

!PltAlgorithmDeclaration methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self algorithmDeclarationToValues: (super toValues: values)

! !

PltAlgorithmDeclaration subclass: #PltFunctionDeclaration
	instanceVariableNames: 'returnType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltFunctionDeclaration commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY function_declaration 
	SUBTYPE OF ( algorithm_declaration );
	return_type : parameter_type;
DERIVE
	accepted : entity_instance := SELF.accept_function_declaration;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltFunctionDeclaration class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltFunctionDeclaration class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltFunctionDeclaration class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltFunctionDeclaration class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltFunctionDeclaration class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltFunctionDeclaration class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltFunctionDeclaration class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltFunctionDeclaration methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptFunctionDeclaration: self

! !

!PltFunctionDeclaration methodsFor: 'platypus-generated-deriving' stamp: ''!
accepted
	^ self acceptedUsingContext: self class context

! !

!PltFunctionDeclaration methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext
	^ self acceptedUsingContext: aContext receiver: self

! !

!PltFunctionDeclaration methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext receiver: aReceiver
	^ aReceiver acceptFunctionDeclarationUsingContext: aContext

! !

!PltFunctionDeclaration methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetReturnType: aPltParameterType
	returnType := aPltParameterType

! !

!PltFunctionDeclaration methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self functionDeclarationFromValues: (super fromValues: values)

! !

!PltFunctionDeclaration methodsFor: 'platypus-generated-copying' stamp: ''!
functionDeclarationCopyTo: another
	another fastSetReturnType: self returnType

! !

!PltFunctionDeclaration methodsFor: 'platypus-generated-group-accessing' stamp: ''!
functionDeclarationFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setReturnType: valuesloc removeFirst.
	^ valuesloc

! !

!PltFunctionDeclaration methodsFor: 'platypus-generated-group-accessing' stamp: ''!
functionDeclarationToValues: values
	values add: self returnType.
	^ values

! !

!PltFunctionDeclaration methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltFunctionDeclaration
	^ true

! !

!PltFunctionDeclaration methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self functionDeclarationFromValues: values

! !

!PltFunctionDeclaration methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self functionDeclarationToValues: values

! !

!PltFunctionDeclaration methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltFunctionDeclaration methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self functionDeclarationCopyTo: another

! !

!PltFunctionDeclaration methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self functionDeclarationCopyTo: another

! !

!PltFunctionDeclaration methodsFor: 'platypus-generated-accessing' stamp: ''!
returnType
	^ returnType

! !

!PltFunctionDeclaration methodsFor: 'platypus-generated-accessing' stamp: ''!
returnType: aPltParameterType
	returnType := aPltParameterType

! !

!PltFunctionDeclaration methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
returnTypeUsingContext: aContext
	^ self returnType

! !

!PltFunctionDeclaration methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setReturnType: aPltParameterType
	self returnType: aPltParameterType

! !

!PltFunctionDeclaration methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	returnType := nil

! !

!PltFunctionDeclaration methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self functionDeclarationToValues: (super toValues: values)

! !

PltAlgorithmDeclaration subclass: #PltProcedureDeclaration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltProcedureDeclaration commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY procedure_declaration 
	SUBTYPE OF ( algorithm_declaration );
DERIVE
	accepted : entity_instance := SELF.accept_procedure_declaration;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltProcedureDeclaration class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltProcedureDeclaration class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltProcedureDeclaration class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltProcedureDeclaration class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltProcedureDeclaration class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltProcedureDeclaration class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltProcedureDeclaration class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltProcedureDeclaration methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptProcedureDeclaration: self

! !

!PltProcedureDeclaration methodsFor: 'platypus-generated-deriving' stamp: ''!
accepted
	^ self acceptedUsingContext: self class context

! !

!PltProcedureDeclaration methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext
	^ self acceptedUsingContext: aContext receiver: self

! !

!PltProcedureDeclaration methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext receiver: aReceiver
	^ aReceiver acceptProcedureDeclarationUsingContext: aContext

! !

!PltProcedureDeclaration methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self procedureDeclarationFromValues: (super fromValues: values)

! !

!PltProcedureDeclaration methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltProcedureDeclaration
	^ true

! !

!PltProcedureDeclaration methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self procedureDeclarationFromValues: values

! !

!PltProcedureDeclaration methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self procedureDeclarationToValues: values

! !

!PltProcedureDeclaration methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltProcedureDeclaration methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self procedureDeclarationCopyTo: another

! !

!PltProcedureDeclaration methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self procedureDeclarationCopyTo: another

! !

!PltProcedureDeclaration methodsFor: 'platypus-generated-copying' stamp: ''!
procedureDeclarationCopyTo: another
	

! !

!PltProcedureDeclaration methodsFor: 'platypus-generated-group-accessing' stamp: ''!
procedureDeclarationFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltProcedureDeclaration methodsFor: 'platypus-generated-group-accessing' stamp: ''!
procedureDeclarationToValues: values
	^ values

! !

!PltProcedureDeclaration methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltProcedureDeclaration methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self procedureDeclarationToValues: (super toValues: values)

! !

PltStatementsContainer subclass: #PltGlobalRule
	instanceVariableNames: 'forEntities whereRules'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltGlobalRule commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY global_rule 
	SUBTYPE OF ( statements_container );
	for_entities : LIST [ 1 : ? ] OF entity_instances_set;
	where_rules : LIST [ 1 : ? ] OF where_rule;
	SELF\context_definition.owner : schema_definition;
DERIVE
	accepted : entity_instance := SELF.accept_global_rule;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltGlobalRule class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltGlobalRule class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltGlobalRule class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltGlobalRule class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltGlobalRule class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltGlobalRule class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltGlobalRule class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltGlobalRule methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptGlobalRule: self

! !

!PltGlobalRule methodsFor: 'platypus-generated-deriving' stamp: ''!
accepted
	^ self acceptedUsingContext: self class context

! !

!PltGlobalRule methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext
	^ self acceptedUsingContext: aContext receiver: self

! !

!PltGlobalRule methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext receiver: aReceiver
	^ aReceiver acceptGlobalRuleUsingContext: aContext

! !

!PltGlobalRule methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetForEntities: aListOfPltEntityInstancesSet
	forEntities := aListOfPltEntityInstancesSet

! !

!PltGlobalRule methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetOwner: aPltSchemaDefinition
	owner := aPltSchemaDefinition

! !

!PltGlobalRule methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetWhereRules: aListOfPltWhereRule
	whereRules := aListOfPltWhereRule

! !

!PltGlobalRule methodsFor: 'platypus-generated-accessing' stamp: ''!
forEntities
	^ forEntities

! !

!PltGlobalRule methodsFor: 'platypus-generated-accessing' stamp: ''!
forEntities: aListOfPltEntityInstancesSet
	forEntities := aListOfPltEntityInstancesSet
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfPltEntityInstancesSet as: OrderedCollection ]

! !

!PltGlobalRule methodsFor: 'platypus-generated-group-accessing' stamp: ''!
forEntities: aListOfPltEntityInstancesSet whereRules: aListOfPltWhereRule owner: aPltSchemaDefinition 	self setForEntities:aListOfPltEntityInstancesSet.	self setWhereRules:aListOfPltWhereRule.	self setOwner:aPltSchemaDefinition.

! !

!PltGlobalRule methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
forEntitiesUsingContext: aContext
	^ self forEntities

! !

!PltGlobalRule methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self globalRuleFromValues: (super fromValues: values)

! !

!PltGlobalRule methodsFor: 'platypus-generated-copying' stamp: ''!
globalRuleCopyTo: another
	another fastSetForEntities: self forEntities.
	another fastSetWhereRules: self whereRules.
	another fastSetOwner: self owner

! !

!PltGlobalRule methodsFor: 'platypus-generated-group-accessing' stamp: ''!
globalRuleFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setForEntities: valuesloc removeFirst.
	self setWhereRules: valuesloc removeFirst.
	self setOwner: valuesloc removeFirst.
	^ valuesloc

! !

!PltGlobalRule methodsFor: 'platypus-generated-group-accessing' stamp: ''!
globalRuleToValues: values
	values add: self forEntities.
	values add: self whereRules.
	values add: self owner.
	^ values

! !

!PltGlobalRule methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltGlobalRule
	^ true

! !

!PltGlobalRule methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self globalRuleFromValues: values

! !

!PltGlobalRule methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self globalRuleToValues: values

! !

!PltGlobalRule methodsFor: 'platypus-generated-accessing' stamp: ''!
owner
	^ owner

! !

!PltGlobalRule methodsFor: 'platypus-generated-accessing' stamp: ''!
owner: aPltSchemaDefinition
	owner := aPltSchemaDefinition

! !

!PltGlobalRule methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
ownerUsingContext: aContext
	^ self owner

! !

!PltGlobalRule methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltGlobalRule methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self globalRuleCopyTo: another

! !

!PltGlobalRule methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self globalRuleCopyTo: another

! !

!PltGlobalRule methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setForEntities: aListOfPltEntityInstancesSet
	self forEntities: aListOfPltEntityInstancesSet

! !

!PltGlobalRule methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setOwner: aPltSchemaDefinition
	self owner: aPltSchemaDefinition

! !

!PltGlobalRule methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setWhereRules: aListOfPltWhereRule
	self whereRules: aListOfPltWhereRule

! !

!PltGlobalRule methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	forEntities := OrderedCollection new.
	whereRules := OrderedCollection new.
	owner := nil

! !

!PltGlobalRule methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self globalRuleToValues: (super toValues: values)

! !

!PltGlobalRule methodsFor: 'platypus-generated-accessing' stamp: ''!
whereRules
	^ whereRules

! !

!PltGlobalRule methodsFor: 'platypus-generated-accessing' stamp: ''!
whereRules: aListOfPltWhereRule
	whereRules := aListOfPltWhereRule
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfPltWhereRule as: OrderedCollection ]

! !

!PltGlobalRule methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
whereRulesUsingContext: aContext
	^ self whereRules

! !

!PltStatementsContainer class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltStatementsContainer class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltStatementsContainer class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltStatementsContainer class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltStatementsContainer class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltStatementsContainer class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltStatementsContainer class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltStatementsContainer methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptStatementsContainer: self

! !

!PltStatementsContainer methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetLocals: aListOfPltLocalVariable
	locals := aListOfPltLocalVariable

! !

!PltStatementsContainer methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetStatements: aListOfPltStatement
	statements := aListOfPltStatement

! !

!PltStatementsContainer methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self statementsContainerFromValues: (super fromValues: values)

! !

!PltStatementsContainer methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltStatementsContainer
	^ true

! !

!PltStatementsContainer methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self statementsContainerFromValues: values

! !

!PltStatementsContainer methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self statementsContainerToValues: values

! !

!PltStatementsContainer methodsFor: 'platypus-generated-accessing' stamp: ''!
locals
	^ locals

! !

!PltStatementsContainer methodsFor: 'platypus-generated-accessing' stamp: ''!
locals: aListOfPltLocalVariable
	locals := aListOfPltLocalVariable
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfPltLocalVariable as: OrderedCollection ]

! !

!PltStatementsContainer methodsFor: 'platypus-generated-group-accessing' stamp: ''!
locals: aListOfPltLocalVariable statements: aListOfPltStatement 	self setLocals:aListOfPltLocalVariable.	self setStatements:aListOfPltStatement.

! !

!PltStatementsContainer methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
localsUsingContext: aContext
	^ self locals

! !

!PltStatementsContainer methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltStatementsContainer methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self statementsContainerCopyTo: another

! !

!PltStatementsContainer methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self statementsContainerCopyTo: another

! !

!PltStatementsContainer methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setLocals: aListOfPltLocalVariable
	self locals: aListOfPltLocalVariable

! !

!PltStatementsContainer methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setStatements: aListOfPltStatement
	self statements: aListOfPltStatement

! !

!PltStatementsContainer methodsFor: 'platypus-generated-accessing' stamp: ''!
statements
	^ statements

! !

!PltStatementsContainer methodsFor: 'platypus-generated-accessing' stamp: ''!
statements: aListOfPltStatement
	statements := aListOfPltStatement
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfPltStatement as: OrderedCollection ]

! !

!PltStatementsContainer methodsFor: 'platypus-generated-copying' stamp: ''!
statementsContainerCopyTo: another
	another fastSetLocals: self locals.
	another fastSetStatements: self statements

! !

!PltStatementsContainer methodsFor: 'platypus-generated-group-accessing' stamp: ''!
statementsContainerFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setLocals: valuesloc removeFirst.
	self setStatements: valuesloc removeFirst.
	^ valuesloc

! !

!PltStatementsContainer methodsFor: 'platypus-generated-group-accessing' stamp: ''!
statementsContainerToValues: values
	values add: self locals.
	values add: self statements.
	^ values

! !

!PltStatementsContainer methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
statementsUsingContext: aContext
	^ self statements

! !

!PltStatementsContainer methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	locals := OrderedCollection new.
	statements := OrderedCollection new

! !

!PltStatementsContainer methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self statementsContainerToValues: (super toValues: values)

! !

!PltDictionaryInstance class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltDictionaryInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltDictionaryInstance class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltDictionaryInstance class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltDictionaryInstance class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltDictionaryInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltDictionaryInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltDictionaryInstance methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptDictionaryInstance: self

! !

!PltDictionaryInstance methodsFor: 'platypus-generated-copying' stamp: ''!
dictionaryInstanceCopyTo: another
	

! !

!PltDictionaryInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
dictionaryInstanceFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltDictionaryInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
dictionaryInstanceToValues: values
	^ values

! !

!PltDictionaryInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self dictionaryInstanceFromValues: (super fromValues: values)

! !

!PltDictionaryInstance methodsFor: 'platypus-generated-deriving' stamp: ''!
handled
	^ self handledUsingContext: self class context

! !

!PltDictionaryInstance methodsFor: 'platypus-generated-deriving' stamp: ''!
handledUsingContext: aContext
	^ self handledUsingContext: aContext receiver: self

! !

!PltDictionaryInstance methodsFor: 'platypus-generated-deriving' stamp: ''!
handledUsingContext: aContext receiver: aReceiver
	^ aReceiver

! !

!PltDictionaryInstance methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltDictionaryInstance
	^ true

! !

!PltDictionaryInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self dictionaryInstanceFromValues: values

! !

!PltDictionaryInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self dictionaryInstanceToValues: values

! !

!PltDictionaryInstance methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltDictionaryInstance methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self dictionaryInstanceCopyTo: another

! !

!PltDictionaryInstance methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self dictionaryInstanceCopyTo: another

! !

!PltDictionaryInstance methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltDictionaryInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self dictionaryInstanceToValues: (super toValues: values)

! !

PltDictionaryInstance subclass: #PltDictionaryInstanceReference
	instanceVariableNames: 'name ref'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltDictionaryInstanceReference commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY dictionary_instance_reference 
	SUBTYPE OF ( dictionary_instance );
	ref : dictionary_instance;
	name : STRING;
DERIVE
	SELF\dictionary_instance.handled : dictionary_instance := SELF.ref;
END_ENTITY;
</ISO10303-11-EXPRESS>!

PltDictionaryInstanceReference subclass: #PltAttributeReference
	instanceVariableNames: 'entityRef'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltAttributeReference commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY attribute_reference 
	SUBTYPE OF ( dictionary_instance_reference );
	SELF\dictionary_instance_reference.ref : attribute;
	entity_ref : entity_definition_reference;
DERIVE
	SELF\named_type_reference.accepted : entity_instance := SELF.accept_attribute_reference;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltAttributeReference class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltAttributeReference class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltAttributeReference class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltAttributeReference class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltAttributeReference class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltAttributeReference class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltAttributeReference class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltAttributeReference methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptAttributeReference: self

! !

!PltAttributeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
accepted
	^ self acceptedUsingContext: self class context

! !

!PltAttributeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext
	^ self acceptedUsingContext: aContext receiver: self

! !

!PltAttributeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext receiver: aReceiver
	^ aReceiver acceptAttributeReferenceUsingContext: aContext

! !

!PltAttributeReference methodsFor: 'platypus-generated-copying' stamp: ''!
attributeReferenceCopyTo: another
	another fastSetRef: self ref.
	another fastSetEntityRef: self entityRef

! !

!PltAttributeReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
attributeReferenceFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setRef: valuesloc removeFirst.
	self setEntityRef: valuesloc removeFirst.
	^ valuesloc

! !

!PltAttributeReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
attributeReferenceToValues: values
	values add: self ref.
	values add: self entityRef.
	^ values

! !

!PltAttributeReference methodsFor: 'platypus-generated-accessing' stamp: ''!
entityRef
	^ entityRef

! !

!PltAttributeReference methodsFor: 'platypus-generated-accessing' stamp: ''!
entityRef: aPltEntityDefinitionReference
	entityRef := aPltEntityDefinitionReference

! !

!PltAttributeReference methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
entityRefUsingContext: aContext
	^ self entityRef

! !

!PltAttributeReference methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetEntityRef: aPltEntityDefinitionReference
	entityRef := aPltEntityDefinitionReference

! !

!PltAttributeReference methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetRef: aPltAttribute
	ref := aPltAttribute

! !

!PltAttributeReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self attributeReferenceFromValues: (super fromValues: values)

! !

!PltAttributeReference methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltAttributeReference
	^ true

! !

!PltAttributeReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self attributeReferenceFromValues: values

! !

!PltAttributeReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self attributeReferenceToValues: values

! !

!PltAttributeReference methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltAttributeReference methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self attributeReferenceCopyTo: another

! !

!PltAttributeReference methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self attributeReferenceCopyTo: another

! !

!PltAttributeReference methodsFor: 'platypus-generated-accessing' stamp: ''!
ref
	^ ref

! !

!PltAttributeReference methodsFor: 'platypus-generated-accessing' stamp: ''!
ref: aPltAttribute
	ref := aPltAttribute

! !

!PltAttributeReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
ref: aPltAttribute entityRef: aPltEntityDefinitionReference 	self setRef:aPltAttribute.	self setEntityRef:aPltEntityDefinitionReference.

! !

!PltAttributeReference methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
refUsingContext: aContext
	^ self ref

! !

!PltAttributeReference methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setEntityRef: aPltEntityDefinitionReference
	self entityRef: aPltEntityDefinitionReference

! !

!PltAttributeReference methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setRef: aPltAttribute
	self ref: aPltAttribute

! !

!PltAttributeReference methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	ref := nil.
	entityRef := nil

! !

!PltAttributeReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self attributeReferenceToValues: (super toValues: values)

! !

!PltDictionaryInstanceReference class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltDictionaryInstanceReference class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltDictionaryInstanceReference class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltDictionaryInstanceReference class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltDictionaryInstanceReference class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltDictionaryInstanceReference class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltDictionaryInstanceReference class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltDictionaryInstanceReference methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptDictionaryInstanceReference: self

! !

!PltDictionaryInstanceReference methodsFor: 'platypus-generated-copying' stamp: ''!
dictionaryInstanceReferenceCopyTo: another
	another fastSetRef: self ref.
	another fastSetName: self name

! !

!PltDictionaryInstanceReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
dictionaryInstanceReferenceFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setRef: valuesloc removeFirst.
	self setName: valuesloc removeFirst.
	^ valuesloc

! !

!PltDictionaryInstanceReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
dictionaryInstanceReferenceToValues: values
	values add: self ref.
	values add: self name.
	^ values

! !

!PltDictionaryInstanceReference methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetName: aString
	name := aString

! !

!PltDictionaryInstanceReference methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetRef: aPltDictionaryInstance
	ref := aPltDictionaryInstance

! !

!PltDictionaryInstanceReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self dictionaryInstanceReferenceFromValues: (super fromValues: values)

! !

!PltDictionaryInstanceReference methodsFor: 'platypus-generated-deriving' stamp: ''!
handled
	^ self handledUsingContext: self class context

! !

!PltDictionaryInstanceReference methodsFor: 'platypus-generated-deriving' stamp: ''!
handledUsingContext: aContext
	^ self handledUsingContext: aContext receiver: self

! !

!PltDictionaryInstanceReference methodsFor: 'platypus-generated-deriving' stamp: ''!
handledUsingContext: aContext receiver: aReceiver
	^ aReceiver refUsingContext: aContext

! !

!PltDictionaryInstanceReference methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltDictionaryInstanceReference
	^ true

! !

!PltDictionaryInstanceReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self dictionaryInstanceReferenceFromValues: values

! !

!PltDictionaryInstanceReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self dictionaryInstanceReferenceToValues: values

! !

!PltDictionaryInstanceReference methodsFor: 'platypus-generated-accessing' stamp: ''!
name
	^ name

! !

!PltDictionaryInstanceReference methodsFor: 'platypus-generated-accessing' stamp: ''!
name: aString
	name := aString

! !

!PltDictionaryInstanceReference methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
nameUsingContext: aContext
	^ self name

! !

!PltDictionaryInstanceReference methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltDictionaryInstanceReference methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self dictionaryInstanceReferenceCopyTo: another

! !

!PltDictionaryInstanceReference methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self dictionaryInstanceReferenceCopyTo: another

! !

!PltDictionaryInstanceReference methodsFor: 'platypus-generated-accessing' stamp: ''!
ref
	^ ref

! !

!PltDictionaryInstanceReference methodsFor: 'platypus-generated-accessing' stamp: ''!
ref: aPltDictionaryInstance
	ref := aPltDictionaryInstance

! !

!PltDictionaryInstanceReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
ref: aPltDictionaryInstance name: aString 	self setRef:aPltDictionaryInstance.	self setName:aString.

! !

!PltDictionaryInstanceReference methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
refUsingContext: aContext
	^ self ref

! !

!PltDictionaryInstanceReference methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setName: aString
	self name: aString

! !

!PltDictionaryInstanceReference methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setRef: aPltDictionaryInstance
	self ref: aPltDictionaryInstance

! !

!PltDictionaryInstanceReference methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	ref := nil.
	name := ''

! !

!PltDictionaryInstanceReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self dictionaryInstanceReferenceToValues: (super toValues: values)

! !

PltDictionaryInstanceReference subclass: #PltNamedTypeReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltNamedTypeReference commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY named_type_reference 
	SUBTYPE OF ( dictionary_instance_reference );
	SELF\dictionary_instance_reference.ref : named_type;
DERIVE
	accepted : entity_instance := SELF.accept_named_type_reference;
END_ENTITY;
</ISO10303-11-EXPRESS>!

PltNamedTypeReference subclass: #PltDefinedTypeReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltDefinedTypeReference commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY defined_type_reference 
	SUBTYPE OF ( named_type_reference );
	SELF\named_type_reference.ref : defined_type;
DERIVE
	SELF\named_type_reference.accepted : entity_instance := SELF.accept_defined_type_reference;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltDefinedTypeReference class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltDefinedTypeReference class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltDefinedTypeReference class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltDefinedTypeReference class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltDefinedTypeReference class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltDefinedTypeReference class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltDefinedTypeReference class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltDefinedTypeReference methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptDefinedTypeReference: self

! !

!PltDefinedTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
accepted
	^ self acceptedUsingContext: self class context

! !

!PltDefinedTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext
	^ self acceptedUsingContext: aContext receiver: self

! !

!PltDefinedTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext receiver: aReceiver
	^ aReceiver acceptDefinedTypeReferenceUsingContext: aContext

! !

!PltDefinedTypeReference methodsFor: 'platypus-generated-copying' stamp: ''!
definedTypeReferenceCopyTo: another
	another fastSetRef: self ref

! !

!PltDefinedTypeReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
definedTypeReferenceFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setRef: valuesloc removeFirst.
	^ valuesloc

! !

!PltDefinedTypeReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
definedTypeReferenceToValues: values
	values add: self ref.
	^ values

! !

!PltDefinedTypeReference methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetRef: aPltDefinedType
	ref := aPltDefinedType

! !

!PltDefinedTypeReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self definedTypeReferenceFromValues: (super fromValues: values)

! !

!PltDefinedTypeReference methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltDefinedTypeReference
	^ true

! !

!PltDefinedTypeReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self definedTypeReferenceFromValues: values

! !

!PltDefinedTypeReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self definedTypeReferenceToValues: values

! !

!PltDefinedTypeReference methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltDefinedTypeReference methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self definedTypeReferenceCopyTo: another

! !

!PltDefinedTypeReference methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self definedTypeReferenceCopyTo: another

! !

!PltDefinedTypeReference methodsFor: 'platypus-generated-accessing' stamp: ''!
ref
	^ ref

! !

!PltDefinedTypeReference methodsFor: 'platypus-generated-accessing' stamp: ''!
ref: aPltDefinedType
	ref := aPltDefinedType

! !

!PltDefinedTypeReference methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
refUsingContext: aContext
	^ self ref

! !

!PltDefinedTypeReference methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setRef: aPltDefinedType
	self ref: aPltDefinedType

! !

!PltDefinedTypeReference methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	ref := nil

! !

!PltDefinedTypeReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self definedTypeReferenceToValues: (super toValues: values)

! !

PltNamedTypeReference subclass: #PltEntityDefinitionReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltEntityDefinitionReference commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY entity_definition_reference 
	SUBTYPE OF ( named_type_reference );
	SELF\named_type_reference.ref : entity_definition;
DERIVE
	SELF\named_type_reference.accepted : entity_instance := SELF.accept_entity_definition_reference;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltEntityDefinitionReference class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltEntityDefinitionReference class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltEntityDefinitionReference class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltEntityDefinitionReference class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltEntityDefinitionReference class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltEntityDefinitionReference class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltEntityDefinitionReference class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltEntityDefinitionReference methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptEntityDefinitionReference: self

! !

!PltEntityDefinitionReference methodsFor: 'platypus-generated-deriving' stamp: ''!
accepted
	^ self acceptedUsingContext: self class context

! !

!PltEntityDefinitionReference methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext
	^ self acceptedUsingContext: aContext receiver: self

! !

!PltEntityDefinitionReference methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext receiver: aReceiver
	^ aReceiver acceptEntityDefinitionReferenceUsingContext: aContext

! !

!PltEntityDefinitionReference methodsFor: 'platypus-generated-copying' stamp: ''!
entityDefinitionReferenceCopyTo: another
	another fastSetRef: self ref

! !

!PltEntityDefinitionReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
entityDefinitionReferenceFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setRef: valuesloc removeFirst.
	^ valuesloc

! !

!PltEntityDefinitionReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
entityDefinitionReferenceToValues: values
	values add: self ref.
	^ values

! !

!PltEntityDefinitionReference methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetRef: aPltEntityDefinition
	ref := aPltEntityDefinition

! !

!PltEntityDefinitionReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self entityDefinitionReferenceFromValues: (super fromValues: values)

! !

!PltEntityDefinitionReference methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltEntityDefinitionReference
	^ true

! !

!PltEntityDefinitionReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self entityDefinitionReferenceFromValues: values

! !

!PltEntityDefinitionReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self entityDefinitionReferenceToValues: values

! !

!PltEntityDefinitionReference methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltEntityDefinitionReference methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self entityDefinitionReferenceCopyTo: another

! !

!PltEntityDefinitionReference methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self entityDefinitionReferenceCopyTo: another

! !

!PltEntityDefinitionReference methodsFor: 'platypus-generated-accessing' stamp: ''!
ref
	^ ref

! !

!PltEntityDefinitionReference methodsFor: 'platypus-generated-accessing' stamp: ''!
ref: aPltEntityDefinition
	ref := aPltEntityDefinition

! !

!PltEntityDefinitionReference methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
refUsingContext: aContext
	^ self ref

! !

!PltEntityDefinitionReference methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setRef: aPltEntityDefinition
	self ref: aPltEntityDefinition

! !

!PltEntityDefinitionReference methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	ref := nil

! !

!PltEntityDefinitionReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self entityDefinitionReferenceToValues: (super toValues: values)

! !

!PltNamedTypeReference class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltNamedTypeReference class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltNamedTypeReference class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltNamedTypeReference class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltNamedTypeReference class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltNamedTypeReference class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltNamedTypeReference class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltNamedTypeReference methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptNamedTypeReference: self

! !

!PltNamedTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
accepted
	^ self acceptedUsingContext: self class context

! !

!PltNamedTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext
	^ self acceptedUsingContext: aContext receiver: self

! !

!PltNamedTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext receiver: aReceiver
	^ aReceiver acceptNamedTypeReferenceUsingContext: aContext

! !

!PltNamedTypeReference methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetRef: aPltNamedType
	ref := aPltNamedType

! !

!PltNamedTypeReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self namedTypeReferenceFromValues: (super fromValues: values)

! !

!PltNamedTypeReference methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltNamedTypeReference
	^ true

! !

!PltNamedTypeReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self namedTypeReferenceFromValues: values

! !

!PltNamedTypeReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self namedTypeReferenceToValues: values

! !

!PltNamedTypeReference methodsFor: 'platypus-generated-copying' stamp: ''!
namedTypeReferenceCopyTo: another
	another fastSetRef: self ref

! !

!PltNamedTypeReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
namedTypeReferenceFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setRef: valuesloc removeFirst.
	^ valuesloc

! !

!PltNamedTypeReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
namedTypeReferenceToValues: values
	values add: self ref.
	^ values

! !

!PltNamedTypeReference methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltNamedTypeReference methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self namedTypeReferenceCopyTo: another

! !

!PltNamedTypeReference methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self namedTypeReferenceCopyTo: another

! !

!PltNamedTypeReference methodsFor: 'platypus-generated-accessing' stamp: ''!
ref
	^ ref

! !

!PltNamedTypeReference methodsFor: 'platypus-generated-accessing' stamp: ''!
ref: aPltNamedType
	ref := aPltNamedType

! !

!PltNamedTypeReference methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
refUsingContext: aContext
	^ self ref

! !

!PltNamedTypeReference methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setRef: aPltNamedType
	self ref: aPltNamedType

! !

!PltNamedTypeReference methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	ref := nil

! !

!PltNamedTypeReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self namedTypeReferenceToValues: (super toValues: values)

! !

PltDictionaryInstance subclass: #PltDomainEquivalentItem
	instanceVariableNames: 'externalItemId name nativeItem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltDomainEquivalentItem commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY domain_equivalent_item 
	SUBTYPE OF ( dictionary_instance );
	name : STRING;
	external_item_id : STRING;
	native_item : declaration;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltDomainEquivalentItem class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltDomainEquivalentItem class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltDomainEquivalentItem class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltDomainEquivalentItem class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltDomainEquivalentItem class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltDomainEquivalentItem class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltDomainEquivalentItem class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltDomainEquivalentItem methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptDomainEquivalentItem: self

! !

!PltDomainEquivalentItem methodsFor: 'platypus-generated-copying' stamp: ''!
domainEquivalentItemCopyTo: another
	another fastSetName: self name.
	another fastSetExternalItemId: self externalItemId.
	another fastSetNativeItem: self nativeItem

! !

!PltDomainEquivalentItem methodsFor: 'platypus-generated-group-accessing' stamp: ''!
domainEquivalentItemFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setName: valuesloc removeFirst.
	self setExternalItemId: valuesloc removeFirst.
	self setNativeItem: valuesloc removeFirst.
	^ valuesloc

! !

!PltDomainEquivalentItem methodsFor: 'platypus-generated-group-accessing' stamp: ''!
domainEquivalentItemToValues: values
	values add: self name.
	values add: self externalItemId.
	values add: self nativeItem.
	^ values

! !

!PltDomainEquivalentItem methodsFor: 'platypus-generated-accessing' stamp: ''!
externalItemId
	^ externalItemId

! !

!PltDomainEquivalentItem methodsFor: 'platypus-generated-accessing' stamp: ''!
externalItemId: aString
	externalItemId := aString

! !

!PltDomainEquivalentItem methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
externalItemIdUsingContext: aContext
	^ self externalItemId

! !

!PltDomainEquivalentItem methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetExternalItemId: aString
	externalItemId := aString

! !

!PltDomainEquivalentItem methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetName: aString
	name := aString

! !

!PltDomainEquivalentItem methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetNativeItem: aPltDeclaration
	nativeItem := aPltDeclaration

! !

!PltDomainEquivalentItem methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self domainEquivalentItemFromValues: (super fromValues: values)

! !

!PltDomainEquivalentItem methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltDomainEquivalentItem
	^ true

! !

!PltDomainEquivalentItem methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self domainEquivalentItemFromValues: values

! !

!PltDomainEquivalentItem methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self domainEquivalentItemToValues: values

! !

!PltDomainEquivalentItem methodsFor: 'platypus-generated-accessing' stamp: ''!
name
	^ name

! !

!PltDomainEquivalentItem methodsFor: 'platypus-generated-accessing' stamp: ''!
name: aString
	name := aString

! !

!PltDomainEquivalentItem methodsFor: 'platypus-generated-group-accessing' stamp: ''!
name: aString externalItemId: aString1 nativeItem: aPltDeclaration 	self setName:aString.	self setExternalItemId:aString1.	self setNativeItem:aPltDeclaration.

! !

!PltDomainEquivalentItem methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
nameUsingContext: aContext
	^ self name

! !

!PltDomainEquivalentItem methodsFor: 'platypus-generated-accessing' stamp: ''!
nativeItem
	^ nativeItem

! !

!PltDomainEquivalentItem methodsFor: 'platypus-generated-accessing' stamp: ''!
nativeItem: aPltDeclaration
	nativeItem := aPltDeclaration

! !

!PltDomainEquivalentItem methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
nativeItemUsingContext: aContext
	^ self nativeItem

! !

!PltDomainEquivalentItem methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltDomainEquivalentItem methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self domainEquivalentItemCopyTo: another

! !

!PltDomainEquivalentItem methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self domainEquivalentItemCopyTo: another

! !

!PltDomainEquivalentItem methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setExternalItemId: aString
	self externalItemId: aString

! !

!PltDomainEquivalentItem methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setName: aString
	self name: aString

! !

!PltDomainEquivalentItem methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setNativeItem: aPltDeclaration
	self nativeItem: aPltDeclaration

! !

!PltDomainEquivalentItem methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	name := ''.
	externalItemId := ''.
	nativeItem := nil

! !

!PltDomainEquivalentItem methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self domainEquivalentItemToValues: (super toValues: values)

! !

PltDictionaryInstance subclass: #PltEnumerationType
	instanceVariableNames: 'elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltEnumerationType commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY enumeration_type 
	SUBTYPE OF ( dictionary_instance );
	elements : LIST [ 1 : ? ] OF UNIQUE STRING;
	SELF\entity_instance.owner : defined_type;
DERIVE
	accepted : entity_instance := SELF.accept_enumeration_type;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltEnumerationType class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltEnumerationType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltEnumerationType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltEnumerationType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltEnumerationType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltEnumerationType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltEnumerationType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltEnumerationType methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptEnumerationType: self

! !

!PltEnumerationType methodsFor: 'platypus-generated-deriving' stamp: ''!
accepted
	^ self acceptedUsingContext: self class context

! !

!PltEnumerationType methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext
	^ self acceptedUsingContext: aContext receiver: self

! !

!PltEnumerationType methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext receiver: aReceiver
	^ aReceiver acceptEnumerationTypeUsingContext: aContext

! !

!PltEnumerationType methodsFor: 'platypus-generated-accessing' stamp: ''!
elements
	^ elements

! !

!PltEnumerationType methodsFor: 'platypus-generated-accessing' stamp: ''!
elements: aListOfString
	elements := aListOfString ifNil: [ OrderedCollection new ] ifNotNil: [ aListOfString as: OrderedCollection ]

! !

!PltEnumerationType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
elements: aListOfString owner: aPltDefinedType 	self setElements:aListOfString.	self setOwner:aPltDefinedType.

! !

!PltEnumerationType methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
elementsUsingContext: aContext
	^ self elements

! !

!PltEnumerationType methodsFor: 'platypus-generated-copying' stamp: ''!
enumerationTypeCopyTo: another
	another fastSetElements: self elements.
	another fastSetOwner: self owner

! !

!PltEnumerationType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
enumerationTypeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setElements: valuesloc removeFirst.
	self setOwner: valuesloc removeFirst.
	^ valuesloc

! !

!PltEnumerationType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
enumerationTypeToValues: values
	values add: self elements.
	values add: self owner.
	^ values

! !

!PltEnumerationType methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetElements: aListOfString
	elements := aListOfString

! !

!PltEnumerationType methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetOwner: aPltDefinedType
	owner := aPltDefinedType

! !

!PltEnumerationType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self enumerationTypeFromValues: (super fromValues: values)

! !

!PltEnumerationType methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltEnumerationType
	^ true

! !

!PltEnumerationType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self enumerationTypeFromValues: values

! !

!PltEnumerationType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self enumerationTypeToValues: values

! !

!PltEnumerationType methodsFor: 'platypus-generated-accessing' stamp: ''!
owner
	^ owner

! !

!PltEnumerationType methodsFor: 'platypus-generated-accessing' stamp: ''!
owner: aPltDefinedType
	owner := aPltDefinedType

! !

!PltEnumerationType methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
ownerUsingContext: aContext
	^ self owner

! !

!PltEnumerationType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltEnumerationType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self enumerationTypeCopyTo: another

! !

!PltEnumerationType methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self enumerationTypeCopyTo: another

! !

!PltEnumerationType methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setElements: aListOfString
	self elements: aListOfString

! !

!PltEnumerationType methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setOwner: aPltDefinedType
	self owner: aPltDefinedType

! !

!PltEnumerationType methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	elements := OrderedCollection new.
	owner := nil

! !

!PltEnumerationType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self enumerationTypeToValues: (super toValues: values)

! !

PltDictionaryInstance subclass: #PltExpression
	instanceVariableNames: 'cachedDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltExpression commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY expression 
	ABSTRACT SUPERTYPE 
	SUBTYPE OF ( dictionary_instance );
END_ENTITY;
</ISO10303-11-EXPRESS>!

PltExpression subclass: #PltAggregateData
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusAggregateDataSchemaSchema'!

!PltAggregateData commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY aggregate_data 
	ABSTRACT SUPERTYPE OF ( ONEOF ( aggregate_instance, aggregate_initializer ) ) 
	SUBTYPE OF ( expression );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltAggregateData class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltAggregateData class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltAggregateData class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltAggregateData class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusAggregateDataSchemaSchemaDefinition singleton

! !

!PltAggregateData class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltAggregateData class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltAggregateData class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltAggregateData methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptAggregateData: self

! !

!PltAggregateData methodsFor: 'platypus-generated-copying' stamp: ''!
aggregateDataCopyTo: another
	

! !

!PltAggregateData methodsFor: 'platypus-generated-group-accessing' stamp: ''!
aggregateDataFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltAggregateData methodsFor: 'platypus-generated-group-accessing' stamp: ''!
aggregateDataToValues: values
	^ values

! !

!PltAggregateData methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self aggregateDataFromValues: (super fromValues: values)

! !

!PltAggregateData methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltAggregateData
	^ true

! !

!PltAggregateData methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self aggregateDataFromValues: values

! !

!PltAggregateData methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self aggregateDataToValues: values

! !

!PltAggregateData methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltAggregateData methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self aggregateDataCopyTo: another

! !

!PltAggregateData methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self aggregateDataCopyTo: another

! !

!PltAggregateData methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltAggregateData methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self aggregateDataToValues: (super toValues: values)

! !

PltAggregateData subclass: #PltAggregateInitializer
	instanceVariableNames: 'contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusAggregateDataSchemaSchema'!

!PltAggregateInitializer commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY aggregate_initializer 
	SUBTYPE OF ( aggregate_data );
	contents : LIST OF aggregate_initializer_element;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltAggregateInitializer class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltAggregateInitializer class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltAggregateInitializer class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltAggregateInitializer class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusAggregateDataSchemaSchemaDefinition singleton

! !

!PltAggregateInitializer class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltAggregateInitializer class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltAggregateInitializer class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltAggregateInitializer methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptAggregateInitializer: self

! !

!PltAggregateInitializer methodsFor: 'platypus-generated-copying' stamp: ''!
aggregateInitializerCopyTo: another
	another fastSetContents: self contents

! !

!PltAggregateInitializer methodsFor: 'platypus-generated-group-accessing' stamp: ''!
aggregateInitializerFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setContents: valuesloc removeFirst.
	^ valuesloc

! !

!PltAggregateInitializer methodsFor: 'platypus-generated-group-accessing' stamp: ''!
aggregateInitializerToValues: values
	values add: self contents.
	^ values

! !

!PltAggregateInitializer methodsFor: 'platypus-generated-accessing' stamp: ''!
contents
	^ contents

! !

!PltAggregateInitializer methodsFor: 'platypus-generated-accessing' stamp: ''!
contents: aListOfPltAggregateInitializerElement
	contents := aListOfPltAggregateInitializerElement
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfPltAggregateInitializerElement as: OrderedCollection ]

! !

!PltAggregateInitializer methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
contentsUsingContext: aContext
	^ self contents

! !

!PltAggregateInitializer methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetContents: aListOfPltAggregateInitializerElement
	contents := aListOfPltAggregateInitializerElement

! !

!PltAggregateInitializer methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self aggregateInitializerFromValues: (super fromValues: values)

! !

!PltAggregateInitializer methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltAggregateInitializer
	^ true

! !

!PltAggregateInitializer methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self aggregateInitializerFromValues: values

! !

!PltAggregateInitializer methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self aggregateInitializerToValues: values

! !

!PltAggregateInitializer methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltAggregateInitializer methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self aggregateInitializerCopyTo: another

! !

!PltAggregateInitializer methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self aggregateInitializerCopyTo: another

! !

!PltAggregateInitializer methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setContents: aListOfPltAggregateInitializerElement
	self contents: aListOfPltAggregateInitializerElement

! !

!PltAggregateInitializer methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	contents := OrderedCollection new

! !

!PltAggregateInitializer methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self aggregateInitializerToValues: (super toValues: values)

! !

PltAggregateData subclass: #PltAggregateInstance
	instanceVariableNames: 'upperBound general lowerBound'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusAggregateDataSchemaSchema'!

!PltAggregateInstance commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY aggregate_instance 
	ABSTRACT SUPERTYPE OF ( ONEOF ( array_instance, variable_size_aggregation_instance ) ) 
	SUBTYPE OF ( aggregate_data );
	lower_bound : integer_literal;
	upper_bound : integer_literal;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltAggregateInstance class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltAggregateInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltAggregateInstance class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltAggregateInstance class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusAggregateDataSchemaSchemaDefinition singleton

! !

!PltAggregateInstance class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltAggregateInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltAggregateInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltAggregateInstance methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptAggregateInstance: self

! !

!PltAggregateInstance methodsFor: 'platypus-generated-copying' stamp: ''!
aggregateInstanceCopyTo: another
	another fastSetLowerBound: self lowerBound.
	another fastSetUpperBound: self upperBound

! !

!PltAggregateInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
aggregateInstanceFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setLowerBound: valuesloc removeFirst.
	self setUpperBound: valuesloc removeFirst.
	^ valuesloc

! !

!PltAggregateInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
aggregateInstanceToValues: values
	values add: self lowerBound.
	values add: self upperBound.
	^ values

! !

!PltAggregateInstance methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetLowerBound: aPltIntegerLiteral
	lowerBound := aPltIntegerLiteral

! !

!PltAggregateInstance methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetUpperBound: aPltIntegerLiteral
	upperBound := aPltIntegerLiteral

! !

!PltAggregateInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self aggregateInstanceFromValues: (super fromValues: values)

! !

!PltAggregateInstance methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltAggregateInstance
	^ true

! !

!PltAggregateInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self aggregateInstanceFromValues: values

! !

!PltAggregateInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self aggregateInstanceToValues: values

! !

!PltAggregateInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
lowerBound
	^ lowerBound

! !

!PltAggregateInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
lowerBound: aPltIntegerLiteral
	lowerBound := aPltIntegerLiteral

! !

!PltAggregateInstance methodsFor: 'platypus-generated-group-accessing' stamp: 'AlainPlantec 6/13/2012 13:08'!
lowerBound: aPltIntegerLiteral upperBound: aPltIntegerLiteral1 	
	self setLowerBound:aPltIntegerLiteral.	self setUpperBound:aPltIntegerLiteral1.

! !

!PltAggregateInstance methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
lowerBoundUsingContext: aContext
	^ self lowerBound

! !

!PltAggregateInstance methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltAggregateInstance methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self aggregateInstanceCopyTo: another

! !

!PltAggregateInstance methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self aggregateInstanceCopyTo: another

! !

!PltAggregateInstance methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setLowerBound: aPltIntegerLiteral
	self lowerBound: aPltIntegerLiteral

! !

!PltAggregateInstance methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setUpperBound: aPltIntegerLiteral
	self upperBound: aPltIntegerLiteral

! !

!PltAggregateInstance methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	lowerBound := nil.
	upperBound := nil

! !

!PltAggregateInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self aggregateInstanceToValues: (super toValues: values)

! !

!PltAggregateInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
upperBound
	^ upperBound

! !

!PltAggregateInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
upperBound: aPltIntegerLiteral
	upperBound := aPltIntegerLiteral

! !

!PltAggregateInstance methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
upperBoundUsingContext: aContext
	^ self upperBound

! !

PltAggregateInstance subclass: #PltArrayInstance
	instanceVariableNames: 'contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusAggregateDataSchemaSchema'!

!PltArrayInstance commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY array_instance 
	SUBTYPE OF ( aggregate_instance );
	contents : LIST OF primitive;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltArrayInstance class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltArrayInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltArrayInstance class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltArrayInstance class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusAggregateDataSchemaSchemaDefinition singleton

! !

!PltArrayInstance class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltArrayInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltArrayInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltArrayInstance methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptArrayInstance: self

! !

!PltArrayInstance methodsFor: 'platypus-generated-copying' stamp: ''!
arrayInstanceCopyTo: another
	another fastSetContents: self contents

! !

!PltArrayInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
arrayInstanceFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setContents: valuesloc removeFirst.
	^ valuesloc

! !

!PltArrayInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
arrayInstanceToValues: values
	values add: self contents.
	^ values

! !

!PltArrayInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
contents
	^ contents

! !

!PltArrayInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
contents: aListOfPltExpression
	contents := aListOfPltExpression
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfPltExpression as: OrderedCollection ]

! !

!PltArrayInstance methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
contentsUsingContext: aContext
	^ self contents

! !

!PltArrayInstance methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetContents: aListOfPltExpression
	contents := aListOfPltExpression

! !

!PltArrayInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self arrayInstanceFromValues: (super fromValues: values)

! !

!PltArrayInstance methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltArrayInstance
	^ true

! !

!PltArrayInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self arrayInstanceFromValues: values

! !

!PltArrayInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self arrayInstanceToValues: values

! !

!PltArrayInstance methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltArrayInstance methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self arrayInstanceCopyTo: another

! !

!PltArrayInstance methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self arrayInstanceCopyTo: another

! !

!PltArrayInstance methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setContents: aListOfPltExpression
	self contents: aListOfPltExpression

! !

!PltArrayInstance methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	contents := OrderedCollection new

! !

!PltArrayInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self arrayInstanceToValues: (super toValues: values)

! !

PltAggregateInstance subclass: #PltVariableSizeAggregationInstance
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusAggregateDataSchemaSchema'!

!PltVariableSizeAggregationInstance commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY variable_size_aggregation_instance 
	ABSTRACT SUPERTYPE OF ( ONEOF ( set_instance, bag_instance, list_instance ) ) 
	SUBTYPE OF ( aggregate_instance );
END_ENTITY;
</ISO10303-11-EXPRESS>!

PltVariableSizeAggregationInstance subclass: #PltBagInstance
	instanceVariableNames: 'contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusAggregateDataSchemaSchema'!

!PltBagInstance commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY bag_instance 
	SUBTYPE OF ( variable_size_aggregation_instance );
	contents : BAG OF primitive;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltBagInstance class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltBagInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltBagInstance class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltBagInstance class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusAggregateDataSchemaSchemaDefinition singleton

! !

!PltBagInstance class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltBagInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltBagInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltBagInstance methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptBagInstance: self

! !

!PltBagInstance methodsFor: 'platypus-generated-copying' stamp: ''!
bagInstanceCopyTo: another
	another fastSetContents: self contents

! !

!PltBagInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
bagInstanceFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setContents: valuesloc removeFirst.
	^ valuesloc

! !

!PltBagInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
bagInstanceToValues: values
	values add: self contents.
	^ values

! !

!PltBagInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
contents
	^ contents

! !

!PltBagInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
contents: aBagOfPltExpression
	contents := aBagOfPltExpression ifNil: [ Bag new ] ifNotNil: [ aBagOfPltExpression as: Bag ]

! !

!PltBagInstance methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
contentsUsingContext: aContext
	^ self contents

! !

!PltBagInstance methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetContents: aBagOfPltExpression
	contents := aBagOfPltExpression

! !

!PltBagInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self bagInstanceFromValues: (super fromValues: values)

! !

!PltBagInstance methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltBagInstance
	^ true

! !

!PltBagInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self bagInstanceFromValues: values

! !

!PltBagInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self bagInstanceToValues: values

! !

!PltBagInstance methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltBagInstance methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self bagInstanceCopyTo: another

! !

!PltBagInstance methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self bagInstanceCopyTo: another

! !

!PltBagInstance methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setContents: aBagOfPltExpression
	self contents: aBagOfPltExpression

! !

!PltBagInstance methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	contents := Bag new

! !

!PltBagInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self bagInstanceToValues: (super toValues: values)

! !

PltVariableSizeAggregationInstance subclass: #PltListInstance
	instanceVariableNames: 'contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusAggregateDataSchemaSchema'!

!PltListInstance commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY list_instance 
	SUBTYPE OF ( variable_size_aggregation_instance );
	contents : LIST OF primitive;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltListInstance class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltListInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltListInstance class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltListInstance class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusAggregateDataSchemaSchemaDefinition singleton

! !

!PltListInstance class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltListInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltListInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltListInstance methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptListInstance: self

! !

!PltListInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
contents
	^ contents

! !

!PltListInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
contents: aListOfPltExpression
	contents := aListOfPltExpression
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfPltExpression as: OrderedCollection ]

! !

!PltListInstance methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
contentsUsingContext: aContext
	^ self contents

! !

!PltListInstance methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetContents: aListOfPltExpression
	contents := aListOfPltExpression

! !

!PltListInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self listInstanceFromValues: (super fromValues: values)

! !

!PltListInstance methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltListInstance
	^ true

! !

!PltListInstance methodsFor: 'platypus-generated-copying' stamp: ''!
listInstanceCopyTo: another
	another fastSetContents: self contents

! !

!PltListInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
listInstanceFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setContents: valuesloc removeFirst.
	^ valuesloc

! !

!PltListInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
listInstanceToValues: values
	values add: self contents.
	^ values

! !

!PltListInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self listInstanceFromValues: values

! !

!PltListInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self listInstanceToValues: values

! !

!PltListInstance methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltListInstance methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self listInstanceCopyTo: another

! !

!PltListInstance methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self listInstanceCopyTo: another

! !

!PltListInstance methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setContents: aListOfPltExpression
	self contents: aListOfPltExpression

! !

!PltListInstance methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	contents := OrderedCollection new

! !

!PltListInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self listInstanceToValues: (super toValues: values)

! !

PltVariableSizeAggregationInstance subclass: #PltSetInstance
	instanceVariableNames: 'contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusAggregateDataSchemaSchema'!

!PltSetInstance commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY set_instance 
	SUBTYPE OF ( variable_size_aggregation_instance );
	contents : SET OF primitive;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltSetInstance class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltSetInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltSetInstance class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltSetInstance class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusAggregateDataSchemaSchemaDefinition singleton

! !

!PltSetInstance class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltSetInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltSetInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltSetInstance methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptSetInstance: self

! !

!PltSetInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
contents
	^ contents

! !

!PltSetInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
contents: aSetOfPltExpression
	contents := aSetOfPltExpression ifNil: [ Set new ] ifNotNil: [ aSetOfPltExpression as: Set ]

! !

!PltSetInstance methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
contentsUsingContext: aContext
	^ self contents

! !

!PltSetInstance methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetContents: aSetOfPltExpression
	contents := aSetOfPltExpression

! !

!PltSetInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self setInstanceFromValues: (super fromValues: values)

! !

!PltSetInstance methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltSetInstance
	^ true

! !

!PltSetInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self setInstanceFromValues: values

! !

!PltSetInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self setInstanceToValues: values

! !

!PltSetInstance methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltSetInstance methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self setInstanceCopyTo: another

! !

!PltSetInstance methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self setInstanceCopyTo: another

! !

!PltSetInstance methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setContents: aSetOfPltExpression
	self contents: aSetOfPltExpression

! !

!PltSetInstance methodsFor: 'platypus-generated-copying' stamp: ''!
setInstanceCopyTo: another
	another fastSetContents: self contents

! !

!PltSetInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
setInstanceFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setContents: valuesloc removeFirst.
	^ valuesloc

! !

!PltSetInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
setInstanceToValues: values
	values add: self contents.
	^ values

! !

!PltSetInstance methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	contents := Set new

! !

!PltSetInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self setInstanceToValues: (super toValues: values)

! !

!PltVariableSizeAggregationInstance class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltVariableSizeAggregationInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltVariableSizeAggregationInstance class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltVariableSizeAggregationInstance class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusAggregateDataSchemaSchemaDefinition singleton

! !

!PltVariableSizeAggregationInstance class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltVariableSizeAggregationInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltVariableSizeAggregationInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltVariableSizeAggregationInstance methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptVariableSizeAggregationInstance: self

! !

!PltVariableSizeAggregationInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self variableSizeAggregationInstanceFromValues: (super fromValues: values)

! !

!PltVariableSizeAggregationInstance methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltVariableSizeAggregationInstance
	^ true

! !

!PltVariableSizeAggregationInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self variableSizeAggregationInstanceFromValues: values

! !

!PltVariableSizeAggregationInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self variableSizeAggregationInstanceToValues: values

! !

!PltVariableSizeAggregationInstance methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltVariableSizeAggregationInstance methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self variableSizeAggregationInstanceCopyTo: another

! !

!PltVariableSizeAggregationInstance methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self variableSizeAggregationInstanceCopyTo: another

! !

!PltVariableSizeAggregationInstance methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltVariableSizeAggregationInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self variableSizeAggregationInstanceToValues: (super toValues: values)

! !

!PltVariableSizeAggregationInstance methodsFor: 'platypus-generated-copying' stamp: ''!
variableSizeAggregationInstanceCopyTo: another
	

! !

!PltVariableSizeAggregationInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
variableSizeAggregationInstanceFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltVariableSizeAggregationInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
variableSizeAggregationInstanceToValues: values
	^ values

! !

PltExpression subclass: #PltBinaryExpression
	instanceVariableNames: 'rightExpr parenthesis leftExpr'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltBinaryExpression commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY binary_expression 
	ABSTRACT SUPERTYPE 
	SUBTYPE OF ( expression );
	parenthesis : OPTIONAL BOOLEAN;
	left_expr : expression;
	right_expr : expression;
END_ENTITY;
</ISO10303-11-EXPRESS>!

PltBinaryExpression subclass: #PltArithmeticExpression
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltArithmeticExpression commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY arithmetic_expression 
	ABSTRACT SUPERTYPE 
	SUBTYPE OF ( binary_expression );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltArithmeticExpression class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltArithmeticExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltArithmeticExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltArithmeticExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltArithmeticExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltArithmeticExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltArithmeticExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltArithmeticExpression methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptArithmeticExpression: self

! !

!PltArithmeticExpression methodsFor: 'platypus-generated-copying' stamp: ''!
arithmeticExpressionCopyTo: another
	

! !

!PltArithmeticExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
arithmeticExpressionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltArithmeticExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
arithmeticExpressionToValues: values
	^ values

! !

!PltArithmeticExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self arithmeticExpressionFromValues: (super fromValues: values)

! !

!PltArithmeticExpression methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltArithmeticExpression
	^ true

! !

!PltArithmeticExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self arithmeticExpressionFromValues: values

! !

!PltArithmeticExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self arithmeticExpressionToValues: values

! !

!PltArithmeticExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltArithmeticExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self arithmeticExpressionCopyTo: another

! !

!PltArithmeticExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self arithmeticExpressionCopyTo: another

! !

!PltArithmeticExpression methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltArithmeticExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self arithmeticExpressionToValues: (super toValues: values)

! !

PltArithmeticExpression subclass: #PltDivExpression
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltDivExpression commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY div_expression 
	SUBTYPE OF ( arithmetic_expression );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltDivExpression class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltDivExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltDivExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltDivExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltDivExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltDivExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltDivExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltDivExpression methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptDivExpression: self

! !

!PltDivExpression methodsFor: 'platypus-generated-copying' stamp: ''!
divExpressionCopyTo: another
	

! !

!PltDivExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
divExpressionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltDivExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
divExpressionToValues: values
	^ values

! !

!PltDivExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self divExpressionFromValues: (super fromValues: values)

! !

!PltDivExpression methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltDivExpression
	^ true

! !

!PltDivExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self divExpressionFromValues: values

! !

!PltDivExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self divExpressionToValues: values

! !

!PltDivExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltDivExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self divExpressionCopyTo: another

! !

!PltDivExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self divExpressionCopyTo: another

! !

!PltDivExpression methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltDivExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self divExpressionToValues: (super toValues: values)

! !

PltArithmeticExpression subclass: #PltExpoExpression
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltExpoExpression commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY expo_expression 
	SUBTYPE OF ( arithmetic_expression );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltExpoExpression class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltExpoExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltExpoExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltExpoExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltExpoExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltExpoExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltExpoExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltExpoExpression methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptExpoExpression: self

! !

!PltExpoExpression methodsFor: 'platypus-generated-copying' stamp: ''!
expoExpressionCopyTo: another
	

! !

!PltExpoExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
expoExpressionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltExpoExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
expoExpressionToValues: values
	^ values

! !

!PltExpoExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self expoExpressionFromValues: (super fromValues: values)

! !

!PltExpoExpression methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltExpoExpression
	^ true

! !

!PltExpoExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self expoExpressionFromValues: values

! !

!PltExpoExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self expoExpressionToValues: values

! !

!PltExpoExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltExpoExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self expoExpressionCopyTo: another

! !

!PltExpoExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self expoExpressionCopyTo: another

! !

!PltExpoExpression methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltExpoExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self expoExpressionToValues: (super toValues: values)

! !

PltArithmeticExpression subclass: #PltMinusExpression
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltMinusExpression commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY minus_expression 
	SUBTYPE OF ( arithmetic_expression );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltMinusExpression class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltMinusExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltMinusExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltMinusExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltMinusExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltMinusExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltMinusExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltMinusExpression methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptMinusExpression: self

! !

!PltMinusExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self minusExpressionFromValues: (super fromValues: values)

! !

!PltMinusExpression methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltMinusExpression
	^ true

! !

!PltMinusExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self minusExpressionFromValues: values

! !

!PltMinusExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self minusExpressionToValues: values

! !

!PltMinusExpression methodsFor: 'platypus-generated-copying' stamp: ''!
minusExpressionCopyTo: another
	

! !

!PltMinusExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
minusExpressionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltMinusExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
minusExpressionToValues: values
	^ values

! !

!PltMinusExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltMinusExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self minusExpressionCopyTo: another

! !

!PltMinusExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self minusExpressionCopyTo: another

! !

!PltMinusExpression methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltMinusExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self minusExpressionToValues: (super toValues: values)

! !

PltArithmeticExpression subclass: #PltModExpression
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltModExpression commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY mod_expression 
	SUBTYPE OF ( arithmetic_expression );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltModExpression class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltModExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltModExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltModExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltModExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltModExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltModExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltModExpression methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptModExpression: self

! !

!PltModExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self modExpressionFromValues: (super fromValues: values)

! !

!PltModExpression methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltModExpression
	^ true

! !

!PltModExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self modExpressionFromValues: values

! !

!PltModExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self modExpressionToValues: values

! !

!PltModExpression methodsFor: 'platypus-generated-copying' stamp: ''!
modExpressionCopyTo: another
	

! !

!PltModExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
modExpressionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltModExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
modExpressionToValues: values
	^ values

! !

!PltModExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltModExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self modExpressionCopyTo: another

! !

!PltModExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self modExpressionCopyTo: another

! !

!PltModExpression methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltModExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self modExpressionToValues: (super toValues: values)

! !

PltArithmeticExpression subclass: #PltMultExpression
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltMultExpression commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY mult_expression 
	SUBTYPE OF ( arithmetic_expression );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltMultExpression class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltMultExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltMultExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltMultExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltMultExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltMultExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltMultExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltMultExpression methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptMultExpression: self

! !

!PltMultExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self multExpressionFromValues: (super fromValues: values)

! !

!PltMultExpression methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltMultExpression
	^ true

! !

!PltMultExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self multExpressionFromValues: values

! !

!PltMultExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self multExpressionToValues: values

! !

!PltMultExpression methodsFor: 'platypus-generated-copying' stamp: ''!
multExpressionCopyTo: another
	

! !

!PltMultExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
multExpressionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltMultExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
multExpressionToValues: values
	^ values

! !

!PltMultExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltMultExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self multExpressionCopyTo: another

! !

!PltMultExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self multExpressionCopyTo: another

! !

!PltMultExpression methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltMultExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self multExpressionToValues: (super toValues: values)

! !

PltArithmeticExpression subclass: #PltPlusExpression
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltPlusExpression commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY plus_expression 
	SUBTYPE OF ( arithmetic_expression );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltPlusExpression class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltPlusExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltPlusExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltPlusExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltPlusExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltPlusExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltPlusExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltPlusExpression methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptPlusExpression: self

! !

!PltPlusExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self plusExpressionFromValues: (super fromValues: values)

! !

!PltPlusExpression methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltPlusExpression
	^ true

! !

!PltPlusExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self plusExpressionFromValues: values

! !

!PltPlusExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self plusExpressionToValues: values

! !

!PltPlusExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltPlusExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self plusExpressionCopyTo: another

! !

!PltPlusExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self plusExpressionCopyTo: another

! !

!PltPlusExpression methodsFor: 'platypus-generated-copying' stamp: ''!
plusExpressionCopyTo: another
	

! !

!PltPlusExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
plusExpressionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltPlusExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
plusExpressionToValues: values
	^ values

! !

!PltPlusExpression methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltPlusExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self plusExpressionToValues: (super toValues: values)

! !

PltArithmeticExpression subclass: #PltRealDivExpression
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltRealDivExpression commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY real_div_expression 
	SUBTYPE OF ( arithmetic_expression );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltRealDivExpression class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltRealDivExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltRealDivExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltRealDivExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltRealDivExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltRealDivExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltRealDivExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltRealDivExpression methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptRealDivExpression: self

! !

!PltRealDivExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self realDivExpressionFromValues: (super fromValues: values)

! !

!PltRealDivExpression methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltRealDivExpression
	^ true

! !

!PltRealDivExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self realDivExpressionFromValues: values

! !

!PltRealDivExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self realDivExpressionToValues: values

! !

!PltRealDivExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltRealDivExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self realDivExpressionCopyTo: another

! !

!PltRealDivExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self realDivExpressionCopyTo: another

! !

!PltRealDivExpression methodsFor: 'platypus-generated-copying' stamp: ''!
realDivExpressionCopyTo: another
	

! !

!PltRealDivExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
realDivExpressionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltRealDivExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
realDivExpressionToValues: values
	^ values

! !

!PltRealDivExpression methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltRealDivExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self realDivExpressionToValues: (super toValues: values)

! !

!PltBinaryExpression class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltBinaryExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltBinaryExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltBinaryExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltBinaryExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltBinaryExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltBinaryExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltBinaryExpression methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptBinaryExpression: self

! !

!PltBinaryExpression methodsFor: 'platypus-generated-copying' stamp: ''!
binaryExpressionCopyTo: another
	another fastSetParenthesis: self parenthesis.
	another fastSetLeftExpr: self leftExpr.
	another fastSetRightExpr: self rightExpr

! !

!PltBinaryExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
binaryExpressionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setParenthesis: valuesloc removeFirst.
	self setLeftExpr: valuesloc removeFirst.
	self setRightExpr: valuesloc removeFirst.
	^ valuesloc

! !

!PltBinaryExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
binaryExpressionToValues: values
	values add: self parenthesis.
	values add: self leftExpr.
	values add: self rightExpr.
	^ values

! !

!PltBinaryExpression methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetLeftExpr: aPltExpression
	leftExpr := aPltExpression

! !

!PltBinaryExpression methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetParenthesis: aBoolean
	parenthesis := aBoolean

! !

!PltBinaryExpression methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetRightExpr: aPltExpression
	rightExpr := aPltExpression

! !

!PltBinaryExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self binaryExpressionFromValues: (super fromValues: values)

! !

!PltBinaryExpression methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltBinaryExpression
	^ true

! !

!PltBinaryExpression methodsFor: 'platypus-generated-accessing' stamp: ''!
leftExpr
	^ leftExpr

! !

!PltBinaryExpression methodsFor: 'platypus-generated-accessing' stamp: ''!
leftExpr: aPltExpression
	leftExpr := aPltExpression

! !

!PltBinaryExpression methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
leftExprUsingContext: aContext
	^ self leftExpr

! !

!PltBinaryExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self binaryExpressionFromValues: values

! !

!PltBinaryExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self binaryExpressionToValues: values

! !

!PltBinaryExpression methodsFor: 'platypus-generated-accessing' stamp: ''!
parenthesis
	^ parenthesis

! !

!PltBinaryExpression methodsFor: 'platypus-generated-accessing' stamp: ''!
parenthesis: aBoolean
	parenthesis := aBoolean

! !

!PltBinaryExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
parenthesis: aBoolean leftExpr: aPltExpression rightExpr: aPltExpression1 	self setParenthesis:aBoolean.	self setLeftExpr:aPltExpression.	self setRightExpr:aPltExpression1.

! !

!PltBinaryExpression methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
parenthesisUsingContext: aContext
	^ self parenthesis

! !

!PltBinaryExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltBinaryExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self binaryExpressionCopyTo: another

! !

!PltBinaryExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self binaryExpressionCopyTo: another

! !

!PltBinaryExpression methodsFor: 'platypus-generated-accessing' stamp: ''!
rightExpr
	^ rightExpr

! !

!PltBinaryExpression methodsFor: 'platypus-generated-accessing' stamp: ''!
rightExpr: aPltExpression
	rightExpr := aPltExpression

! !

!PltBinaryExpression methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
rightExprUsingContext: aContext
	^ self rightExpr

! !

!PltBinaryExpression methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setLeftExpr: aPltExpression
	self leftExpr: aPltExpression

! !

!PltBinaryExpression methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setParenthesis: aBoolean
	self parenthesis: aBoolean

! !

!PltBinaryExpression methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setRightExpr: aPltExpression
	self rightExpr: aPltExpression

! !

!PltBinaryExpression methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	parenthesis := nil.
	leftExpr := nil.
	rightExpr := nil

! !

!PltBinaryExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self binaryExpressionToValues: (super toValues: values)

! !

PltBinaryExpression subclass: #PltInstanceConstructionExpression
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltInstanceConstructionExpression commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY instance_construction_expression 
	SUBTYPE OF ( binary_expression );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltInstanceConstructionExpression class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltInstanceConstructionExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltInstanceConstructionExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltInstanceConstructionExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltInstanceConstructionExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltInstanceConstructionExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltInstanceConstructionExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltInstanceConstructionExpression methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptInstanceConstructionExpression: self

! !

!PltInstanceConstructionExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self instanceConstructionExpressionFromValues: (super fromValues: values)

! !

!PltInstanceConstructionExpression methodsFor: 'platypus-generated-copying' stamp: ''!
instanceConstructionExpressionCopyTo: another
	

! !

!PltInstanceConstructionExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
instanceConstructionExpressionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltInstanceConstructionExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
instanceConstructionExpressionToValues: values
	^ values

! !

!PltInstanceConstructionExpression methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltInstanceConstructionExpression
	^ true

! !

!PltInstanceConstructionExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self instanceConstructionExpressionFromValues: values

! !

!PltInstanceConstructionExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self instanceConstructionExpressionToValues: values

! !

!PltInstanceConstructionExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltInstanceConstructionExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self instanceConstructionExpressionCopyTo: another

! !

!PltInstanceConstructionExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self instanceConstructionExpressionCopyTo: another

! !

!PltInstanceConstructionExpression methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltInstanceConstructionExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self instanceConstructionExpressionToValues: (super toValues: values)

! !

PltBinaryExpression subclass: #PltLogicalExpression
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltLogicalExpression commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY logical_expression 
	ABSTRACT SUPERTYPE 
	SUBTYPE OF ( binary_expression );
END_ENTITY;
</ISO10303-11-EXPRESS>!

PltLogicalExpression subclass: #PltAndExpression
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltAndExpression commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY and_expression 
	SUBTYPE OF ( logical_expression );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltAndExpression class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltAndExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltAndExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltAndExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltAndExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltAndExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltAndExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltAndExpression methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptAndExpression: self

! !

!PltAndExpression methodsFor: 'platypus-generated-copying' stamp: ''!
andExpressionCopyTo: another
	

! !

!PltAndExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
andExpressionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltAndExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
andExpressionToValues: values
	^ values

! !

!PltAndExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self andExpressionFromValues: (super fromValues: values)

! !

!PltAndExpression methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltAndExpression
	^ true

! !

!PltAndExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self andExpressionFromValues: values

! !

!PltAndExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self andExpressionToValues: values

! !

!PltAndExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltAndExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self andExpressionCopyTo: another

! !

!PltAndExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self andExpressionCopyTo: another

! !

!PltAndExpression methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltAndExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self andExpressionToValues: (super toValues: values)

! !

PltLogicalExpression subclass: #PltCardinalityExpression
	instanceVariableNames: 'card2 card1'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltCardinalityExpression commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY cardinality_expression 
	SUBTYPE OF ( logical_expression );
	card1 : expression;
	card2 : expression;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltCardinalityExpression class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltCardinalityExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltCardinalityExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltCardinalityExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltCardinalityExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltCardinalityExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltCardinalityExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltCardinalityExpression methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptCardinalityExpression: self

! !

!PltCardinalityExpression methodsFor: 'platypus-generated-accessing' stamp: ''!
card1
	^ card1

! !

!PltCardinalityExpression methodsFor: 'platypus-generated-accessing' stamp: ''!
card1: aPltExpression
	card1 := aPltExpression

! !

!PltCardinalityExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
card1: aPltExpression card2: aPltExpression1 	self setCard1:aPltExpression.	self setCard2:aPltExpression1.

! !

!PltCardinalityExpression methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
card1UsingContext: aContext
	^ self card1

! !

!PltCardinalityExpression methodsFor: 'platypus-generated-accessing' stamp: ''!
card2
	^ card2

! !

!PltCardinalityExpression methodsFor: 'platypus-generated-accessing' stamp: ''!
card2: aPltExpression
	card2 := aPltExpression

! !

!PltCardinalityExpression methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
card2UsingContext: aContext
	^ self card2

! !

!PltCardinalityExpression methodsFor: 'platypus-generated-copying' stamp: ''!
cardinalityExpressionCopyTo: another
	another fastSetCard1: self card1.
	another fastSetCard2: self card2

! !

!PltCardinalityExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
cardinalityExpressionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setCard1: valuesloc removeFirst.
	self setCard2: valuesloc removeFirst.
	^ valuesloc

! !

!PltCardinalityExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
cardinalityExpressionToValues: values
	values add: self card1.
	values add: self card2.
	^ values

! !

!PltCardinalityExpression methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetCard1: aPltExpression
	card1 := aPltExpression

! !

!PltCardinalityExpression methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetCard2: aPltExpression
	card2 := aPltExpression

! !

!PltCardinalityExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self cardinalityExpressionFromValues: (super fromValues: values)

! !

!PltCardinalityExpression methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltCardinalityExpression
	^ true

! !

!PltCardinalityExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self cardinalityExpressionFromValues: values

! !

!PltCardinalityExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self cardinalityExpressionToValues: values

! !

!PltCardinalityExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltCardinalityExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self cardinalityExpressionCopyTo: another

! !

!PltCardinalityExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self cardinalityExpressionCopyTo: another

! !

!PltCardinalityExpression methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setCard1: aPltExpression
	self card1: aPltExpression

! !

!PltCardinalityExpression methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setCard2: aPltExpression
	self card2: aPltExpression

! !

!PltCardinalityExpression methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	card1 := nil.
	card2 := nil

! !

!PltCardinalityExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self cardinalityExpressionToValues: (super toValues: values)

! !

PltLogicalExpression subclass: #PltComparisonExpression
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltComparisonExpression commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY comparison_expression 
	ABSTRACT SUPERTYPE 
	SUBTYPE OF ( logical_expression );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltComparisonExpression class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltComparisonExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltComparisonExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltComparisonExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltComparisonExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltComparisonExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltComparisonExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltComparisonExpression methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptComparisonExpression: self

! !

!PltComparisonExpression methodsFor: 'platypus-generated-copying' stamp: ''!
comparisonExpressionCopyTo: another
	

! !

!PltComparisonExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
comparisonExpressionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltComparisonExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
comparisonExpressionToValues: values
	^ values

! !

!PltComparisonExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self comparisonExpressionFromValues: (super fromValues: values)

! !

!PltComparisonExpression methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltComparisonExpression
	^ true

! !

!PltComparisonExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self comparisonExpressionFromValues: values

! !

!PltComparisonExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self comparisonExpressionToValues: values

! !

!PltComparisonExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltComparisonExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self comparisonExpressionCopyTo: another

! !

!PltComparisonExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self comparisonExpressionCopyTo: another

! !

!PltComparisonExpression methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltComparisonExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self comparisonExpressionToValues: (super toValues: values)

! !

PltComparisonExpression subclass: #PltEqualExpression
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltEqualExpression commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY equal_expression 
	SUBTYPE OF ( comparison_expression );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltEqualExpression class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltEqualExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltEqualExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltEqualExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltEqualExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltEqualExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltEqualExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltEqualExpression methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptEqualExpression: self

! !

!PltEqualExpression methodsFor: 'platypus-generated-copying' stamp: ''!
equalExpressionCopyTo: another
	

! !

!PltEqualExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
equalExpressionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltEqualExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
equalExpressionToValues: values
	^ values

! !

!PltEqualExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self equalExpressionFromValues: (super fromValues: values)

! !

!PltEqualExpression methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltEqualExpression
	^ true

! !

!PltEqualExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self equalExpressionFromValues: values

! !

!PltEqualExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self equalExpressionToValues: values

! !

!PltEqualExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltEqualExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self equalExpressionCopyTo: another

! !

!PltEqualExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self equalExpressionCopyTo: another

! !

!PltEqualExpression methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltEqualExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self equalExpressionToValues: (super toValues: values)

! !

PltComparisonExpression subclass: #PltGreaterEqualExpression
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltGreaterEqualExpression commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY greater_equal_expression 
	SUBTYPE OF ( comparison_expression );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltGreaterEqualExpression class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltGreaterEqualExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltGreaterEqualExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltGreaterEqualExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltGreaterEqualExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltGreaterEqualExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltGreaterEqualExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltGreaterEqualExpression methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptGreaterEqualExpression: self

! !

!PltGreaterEqualExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self greaterEqualExpressionFromValues: (super fromValues: values)

! !

!PltGreaterEqualExpression methodsFor: 'platypus-generated-copying' stamp: ''!
greaterEqualExpressionCopyTo: another
	

! !

!PltGreaterEqualExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
greaterEqualExpressionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltGreaterEqualExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
greaterEqualExpressionToValues: values
	^ values

! !

!PltGreaterEqualExpression methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltGreaterEqualExpression
	^ true

! !

!PltGreaterEqualExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self greaterEqualExpressionFromValues: values

! !

!PltGreaterEqualExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self greaterEqualExpressionToValues: values

! !

!PltGreaterEqualExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltGreaterEqualExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self greaterEqualExpressionCopyTo: another

! !

!PltGreaterEqualExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self greaterEqualExpressionCopyTo: another

! !

!PltGreaterEqualExpression methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltGreaterEqualExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self greaterEqualExpressionToValues: (super toValues: values)

! !

PltComparisonExpression subclass: #PltGreaterThanExpression
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltGreaterThanExpression commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY greater_than_expression 
	SUBTYPE OF ( comparison_expression );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltGreaterThanExpression class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltGreaterThanExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltGreaterThanExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltGreaterThanExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltGreaterThanExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltGreaterThanExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltGreaterThanExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltGreaterThanExpression methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptGreaterThanExpression: self

! !

!PltGreaterThanExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self greaterThanExpressionFromValues: (super fromValues: values)

! !

!PltGreaterThanExpression methodsFor: 'platypus-generated-copying' stamp: ''!
greaterThanExpressionCopyTo: another
	

! !

!PltGreaterThanExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
greaterThanExpressionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltGreaterThanExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
greaterThanExpressionToValues: values
	^ values

! !

!PltGreaterThanExpression methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltGreaterThanExpression
	^ true

! !

!PltGreaterThanExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self greaterThanExpressionFromValues: values

! !

!PltGreaterThanExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self greaterThanExpressionToValues: values

! !

!PltGreaterThanExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltGreaterThanExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self greaterThanExpressionCopyTo: another

! !

!PltGreaterThanExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self greaterThanExpressionCopyTo: another

! !

!PltGreaterThanExpression methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltGreaterThanExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self greaterThanExpressionToValues: (super toValues: values)

! !

PltComparisonExpression subclass: #PltInstComparisonExpression
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltInstComparisonExpression commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY inst_comparison_expression 
	ABSTRACT SUPERTYPE 
	SUBTYPE OF ( comparison_expression );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltInstComparisonExpression class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltInstComparisonExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltInstComparisonExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltInstComparisonExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltInstComparisonExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltInstComparisonExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltInstComparisonExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltInstComparisonExpression methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptInstComparisonExpression: self

! !

!PltInstComparisonExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self instComparisonExpressionFromValues: (super fromValues: values)

! !

!PltInstComparisonExpression methodsFor: 'platypus-generated-copying' stamp: ''!
instComparisonExpressionCopyTo: another
	

! !

!PltInstComparisonExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
instComparisonExpressionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltInstComparisonExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
instComparisonExpressionToValues: values
	^ values

! !

!PltInstComparisonExpression methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltInstComparisonExpression
	^ true

! !

!PltInstComparisonExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self instComparisonExpressionFromValues: values

! !

!PltInstComparisonExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self instComparisonExpressionToValues: values

! !

!PltInstComparisonExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltInstComparisonExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self instComparisonExpressionCopyTo: another

! !

!PltInstComparisonExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self instComparisonExpressionCopyTo: another

! !

!PltInstComparisonExpression methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltInstComparisonExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self instComparisonExpressionToValues: (super toValues: values)

! !

PltInstComparisonExpression subclass: #PltInstEqualExpression
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltInstEqualExpression commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY inst_equal_expression 
	SUBTYPE OF ( inst_comparison_expression );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltInstEqualExpression class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltInstEqualExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltInstEqualExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltInstEqualExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltInstEqualExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltInstEqualExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltInstEqualExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltInstEqualExpression methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptInstEqualExpression: self

! !

!PltInstEqualExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self instEqualExpressionFromValues: (super fromValues: values)

! !

!PltInstEqualExpression methodsFor: 'platypus-generated-copying' stamp: ''!
instEqualExpressionCopyTo: another
	

! !

!PltInstEqualExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
instEqualExpressionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltInstEqualExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
instEqualExpressionToValues: values
	^ values

! !

!PltInstEqualExpression methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltInstEqualExpression
	^ true

! !

!PltInstEqualExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self instEqualExpressionFromValues: values

! !

!PltInstEqualExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self instEqualExpressionToValues: values

! !

!PltInstEqualExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltInstEqualExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self instEqualExpressionCopyTo: another

! !

!PltInstEqualExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self instEqualExpressionCopyTo: another

! !

!PltInstEqualExpression methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltInstEqualExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self instEqualExpressionToValues: (super toValues: values)

! !

PltInstComparisonExpression subclass: #PltInstNotEqualExpression
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltInstNotEqualExpression commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY inst_not_equal_expression 
	SUBTYPE OF ( inst_comparison_expression );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltInstNotEqualExpression class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltInstNotEqualExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltInstNotEqualExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltInstNotEqualExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltInstNotEqualExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltInstNotEqualExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltInstNotEqualExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltInstNotEqualExpression methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptInstNotEqualExpression: self

! !

!PltInstNotEqualExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self instNotEqualExpressionFromValues: (super fromValues: values)

! !

!PltInstNotEqualExpression methodsFor: 'platypus-generated-copying' stamp: ''!
instNotEqualExpressionCopyTo: another
	

! !

!PltInstNotEqualExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
instNotEqualExpressionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltInstNotEqualExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
instNotEqualExpressionToValues: values
	^ values

! !

!PltInstNotEqualExpression methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltInstNotEqualExpression
	^ true

! !

!PltInstNotEqualExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self instNotEqualExpressionFromValues: values

! !

!PltInstNotEqualExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self instNotEqualExpressionToValues: values

! !

!PltInstNotEqualExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltInstNotEqualExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self instNotEqualExpressionCopyTo: another

! !

!PltInstNotEqualExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self instNotEqualExpressionCopyTo: another

! !

!PltInstNotEqualExpression methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltInstNotEqualExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self instNotEqualExpressionToValues: (super toValues: values)

! !

PltComparisonExpression subclass: #PltLessEqualExpression
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltLessEqualExpression commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY less_equal_expression 
	SUBTYPE OF ( comparison_expression );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltLessEqualExpression class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltLessEqualExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltLessEqualExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltLessEqualExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltLessEqualExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltLessEqualExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltLessEqualExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltLessEqualExpression methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptLessEqualExpression: self

! !

!PltLessEqualExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self lessEqualExpressionFromValues: (super fromValues: values)

! !

!PltLessEqualExpression methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltLessEqualExpression
	^ true

! !

!PltLessEqualExpression methodsFor: 'platypus-generated-copying' stamp: ''!
lessEqualExpressionCopyTo: another
	

! !

!PltLessEqualExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
lessEqualExpressionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltLessEqualExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
lessEqualExpressionToValues: values
	^ values

! !

!PltLessEqualExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self lessEqualExpressionFromValues: values

! !

!PltLessEqualExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self lessEqualExpressionToValues: values

! !

!PltLessEqualExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltLessEqualExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self lessEqualExpressionCopyTo: another

! !

!PltLessEqualExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self lessEqualExpressionCopyTo: another

! !

!PltLessEqualExpression methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltLessEqualExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self lessEqualExpressionToValues: (super toValues: values)

! !

PltComparisonExpression subclass: #PltLessThanExpression
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltLessThanExpression commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY less_than_expression 
	SUBTYPE OF ( comparison_expression );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltLessThanExpression class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltLessThanExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltLessThanExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltLessThanExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltLessThanExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltLessThanExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltLessThanExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltLessThanExpression methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptLessThanExpression: self

! !

!PltLessThanExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self lessThanExpressionFromValues: (super fromValues: values)

! !

!PltLessThanExpression methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltLessThanExpression
	^ true

! !

!PltLessThanExpression methodsFor: 'platypus-generated-copying' stamp: ''!
lessThanExpressionCopyTo: another
	

! !

!PltLessThanExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
lessThanExpressionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltLessThanExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
lessThanExpressionToValues: values
	^ values

! !

!PltLessThanExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self lessThanExpressionFromValues: values

! !

!PltLessThanExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self lessThanExpressionToValues: values

! !

!PltLessThanExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltLessThanExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self lessThanExpressionCopyTo: another

! !

!PltLessThanExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self lessThanExpressionCopyTo: another

! !

!PltLessThanExpression methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltLessThanExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self lessThanExpressionToValues: (super toValues: values)

! !

PltComparisonExpression subclass: #PltNotEqualExpression
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltNotEqualExpression commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY not_equal_expression 
	SUBTYPE OF ( comparison_expression );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltNotEqualExpression class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltNotEqualExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltNotEqualExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltNotEqualExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltNotEqualExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltNotEqualExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltNotEqualExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltNotEqualExpression methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptNotEqualExpression: self

! !

!PltNotEqualExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self notEqualExpressionFromValues: (super fromValues: values)

! !

!PltNotEqualExpression methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltNotEqualExpression
	^ true

! !

!PltNotEqualExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self notEqualExpressionFromValues: values

! !

!PltNotEqualExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self notEqualExpressionToValues: values

! !

!PltNotEqualExpression methodsFor: 'platypus-generated-copying' stamp: ''!
notEqualExpressionCopyTo: another
	

! !

!PltNotEqualExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
notEqualExpressionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltNotEqualExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
notEqualExpressionToValues: values
	^ values

! !

!PltNotEqualExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltNotEqualExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self notEqualExpressionCopyTo: another

! !

!PltNotEqualExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self notEqualExpressionCopyTo: another

! !

!PltNotEqualExpression methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltNotEqualExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self notEqualExpressionToValues: (super toValues: values)

! !

PltLogicalExpression subclass: #PltInExpression
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltInExpression commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY in_expression 
	SUBTYPE OF ( logical_expression );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltInExpression class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltInExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltInExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltInExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltInExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltInExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltInExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltInExpression methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptInExpression: self

! !

!PltInExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self inExpressionFromValues: (super fromValues: values)

! !

!PltInExpression methodsFor: 'platypus-generated-copying' stamp: ''!
inExpressionCopyTo: another
	

! !

!PltInExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
inExpressionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltInExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
inExpressionToValues: values
	^ values

! !

!PltInExpression methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltInExpression
	^ true

! !

!PltInExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self inExpressionFromValues: values

! !

!PltInExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self inExpressionToValues: values

! !

!PltInExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltInExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self inExpressionCopyTo: another

! !

!PltInExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self inExpressionCopyTo: another

! !

!PltInExpression methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltInExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self inExpressionToValues: (super toValues: values)

! !

PltLogicalExpression subclass: #PltLikeExpression
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltLikeExpression commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY like_expression 
	SUBTYPE OF ( logical_expression );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltLikeExpression class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltLikeExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltLikeExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltLikeExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltLikeExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltLikeExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltLikeExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltLikeExpression methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptLikeExpression: self

! !

!PltLikeExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self likeExpressionFromValues: (super fromValues: values)

! !

!PltLikeExpression methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltLikeExpression
	^ true

! !

!PltLikeExpression methodsFor: 'platypus-generated-copying' stamp: ''!
likeExpressionCopyTo: another
	

! !

!PltLikeExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
likeExpressionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltLikeExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
likeExpressionToValues: values
	^ values

! !

!PltLikeExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self likeExpressionFromValues: values

! !

!PltLikeExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self likeExpressionToValues: values

! !

!PltLikeExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltLikeExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self likeExpressionCopyTo: another

! !

!PltLikeExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self likeExpressionCopyTo: another

! !

!PltLikeExpression methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltLikeExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self likeExpressionToValues: (super toValues: values)

! !

!PltLogicalExpression class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltLogicalExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltLogicalExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltLogicalExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltLogicalExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltLogicalExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltLogicalExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltLogicalExpression methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptLogicalExpression: self

! !

!PltLogicalExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self logicalExpressionFromValues: (super fromValues: values)

! !

!PltLogicalExpression methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltLogicalExpression
	^ true

! !

!PltLogicalExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self logicalExpressionFromValues: values

! !

!PltLogicalExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self logicalExpressionToValues: values

! !

!PltLogicalExpression methodsFor: 'platypus-generated-copying' stamp: ''!
logicalExpressionCopyTo: another
	

! !

!PltLogicalExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
logicalExpressionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltLogicalExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
logicalExpressionToValues: values
	^ values

! !

!PltLogicalExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltLogicalExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self logicalExpressionCopyTo: another

! !

!PltLogicalExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self logicalExpressionCopyTo: another

! !

!PltLogicalExpression methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltLogicalExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self logicalExpressionToValues: (super toValues: values)

! !

PltLogicalExpression subclass: #PltOrExpression
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltOrExpression commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY or_expression 
	SUBTYPE OF ( logical_expression );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltOrExpression class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltOrExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltOrExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltOrExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltOrExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltOrExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltOrExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltOrExpression methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptOrExpression: self

! !

!PltOrExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self orExpressionFromValues: (super fromValues: values)

! !

!PltOrExpression methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltOrExpression
	^ true

! !

!PltOrExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self orExpressionFromValues: values

! !

!PltOrExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self orExpressionToValues: values

! !

!PltOrExpression methodsFor: 'platypus-generated-copying' stamp: ''!
orExpressionCopyTo: another
	

! !

!PltOrExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
orExpressionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltOrExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
orExpressionToValues: values
	^ values

! !

!PltOrExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltOrExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self orExpressionCopyTo: another

! !

!PltOrExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self orExpressionCopyTo: another

! !

!PltOrExpression methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltOrExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self orExpressionToValues: (super toValues: values)

! !

PltLogicalExpression subclass: #PltXorExpression
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltXorExpression commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY xor_expression 
	SUBTYPE OF ( logical_expression );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltXorExpression class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltXorExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltXorExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltXorExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltXorExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltXorExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltXorExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltXorExpression methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptXorExpression: self

! !

!PltXorExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self xorExpressionFromValues: (super fromValues: values)

! !

!PltXorExpression methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltXorExpression
	^ true

! !

!PltXorExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self xorExpressionFromValues: values

! !

!PltXorExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self xorExpressionToValues: values

! !

!PltXorExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltXorExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self xorExpressionCopyTo: another

! !

!PltXorExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self xorExpressionCopyTo: another

! !

!PltXorExpression methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltXorExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self xorExpressionToValues: (super toValues: values)

! !

!PltXorExpression methodsFor: 'platypus-generated-copying' stamp: ''!
xorExpressionCopyTo: another
	

! !

!PltXorExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
xorExpressionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltXorExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
xorExpressionToValues: values
	^ values

! !

PltExpression subclass: #PltEntityInstanceReference
	instanceVariableNames: 'persistentLabel ref'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltEntityInstanceReference commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY entity_instance_reference 
	SUBTYPE OF ( expression );
	persistent_label : STRING;
	ref : entity_instance;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltEntityInstanceReference class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltEntityInstanceReference class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltEntityInstanceReference class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltEntityInstanceReference class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltEntityInstanceReference class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltEntityInstanceReference class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltEntityInstanceReference class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltEntityInstanceReference methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptEntityInstanceReference: self

! !

!PltEntityInstanceReference methodsFor: 'platypus-generated-copying' stamp: ''!
entityInstanceReferenceCopyTo: another
	another fastSetPersistentLabel: self persistentLabel.
	another fastSetRef: self ref

! !

!PltEntityInstanceReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
entityInstanceReferenceFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setPersistentLabel: valuesloc removeFirst.
	self setRef: valuesloc removeFirst.
	^ valuesloc

! !

!PltEntityInstanceReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
entityInstanceReferenceToValues: values
	values add: self persistentLabel.
	values add: self ref.
	^ values

! !

!PltEntityInstanceReference methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetPersistentLabel: aString
	persistentLabel := aString

! !

!PltEntityInstanceReference methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetRef: aPltEntityInstance
	ref := aPltEntityInstance

! !

!PltEntityInstanceReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self entityInstanceReferenceFromValues: (super fromValues: values)

! !

!PltEntityInstanceReference methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltEntityInstanceReference
	^ true

! !

!PltEntityInstanceReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self entityInstanceReferenceFromValues: values

! !

!PltEntityInstanceReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self entityInstanceReferenceToValues: values

! !

!PltEntityInstanceReference methodsFor: 'platypus-generated-accessing' stamp: ''!
persistentLabel
	^ persistentLabel

! !

!PltEntityInstanceReference methodsFor: 'platypus-generated-accessing' stamp: ''!
persistentLabel: aString
	persistentLabel := aString

! !

!PltEntityInstanceReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
persistentLabel: aString ref: aPltEntityInstance 	self setPersistentLabel:aString.	self setRef:aPltEntityInstance.

! !

!PltEntityInstanceReference methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
persistentLabelUsingContext: aContext
	^ self persistentLabel

! !

!PltEntityInstanceReference methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltEntityInstanceReference methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self entityInstanceReferenceCopyTo: another

! !

!PltEntityInstanceReference methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self entityInstanceReferenceCopyTo: another

! !

!PltEntityInstanceReference methodsFor: 'platypus-generated-accessing' stamp: ''!
ref
	^ ref

! !

!PltEntityInstanceReference methodsFor: 'platypus-generated-accessing' stamp: ''!
ref: aPltEntityInstance
	ref := aPltEntityInstance

! !

!PltEntityInstanceReference methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
refUsingContext: aContext
	^ self ref

! !

!PltEntityInstanceReference methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setPersistentLabel: aString
	self persistentLabel: aString

! !

!PltEntityInstanceReference methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setRef: aPltEntityInstance
	self ref: aPltEntityInstance

! !

!PltEntityInstanceReference methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	persistentLabel := ''.
	ref := nil

! !

!PltEntityInstanceReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self entityInstanceReferenceToValues: (super toValues: values)

! !

PltExpression subclass: #PltEscapedExpression
	instanceVariableNames: 'expr'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltEscapedExpression commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY escaped_expression 
	SUBTYPE OF ( expression );
	expr : expression;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltEscapedExpression class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltEscapedExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltEscapedExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltEscapedExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltEscapedExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltEscapedExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltEscapedExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltEscapedExpression methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptEscapedExpression: self

! !

!PltEscapedExpression methodsFor: 'platypus-generated-copying' stamp: ''!
escapedExpressionCopyTo: another
	another fastSetExpr: self expr

! !

!PltEscapedExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
escapedExpressionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setExpr: valuesloc removeFirst.
	^ valuesloc

! !

!PltEscapedExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
escapedExpressionToValues: values
	values add: self expr.
	^ values

! !

!PltEscapedExpression methodsFor: 'platypus-generated-accessing' stamp: ''!
expr
	^ expr

! !

!PltEscapedExpression methodsFor: 'platypus-generated-accessing' stamp: ''!
expr: aPltExpression
	expr := aPltExpression

! !

!PltEscapedExpression methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
exprUsingContext: aContext
	^ self expr

! !

!PltEscapedExpression methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetExpr: aPltExpression
	expr := aPltExpression

! !

!PltEscapedExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self escapedExpressionFromValues: (super fromValues: values)

! !

!PltEscapedExpression methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltEscapedExpression
	^ true

! !

!PltEscapedExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self escapedExpressionFromValues: values

! !

!PltEscapedExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self escapedExpressionToValues: values

! !

!PltEscapedExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltEscapedExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self escapedExpressionCopyTo: another

! !

!PltEscapedExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self escapedExpressionCopyTo: another

! !

!PltEscapedExpression methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setExpr: aPltExpression
	self expr: aPltExpression

! !

!PltEscapedExpression methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	expr := nil

! !

!PltEscapedExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self escapedExpressionToValues: (super toValues: values)

! !

!PltExpression class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltExpression methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptExpression: self

! !

!PltExpression methodsFor: 'platypus-generated-copying' stamp: ''!
expressionCopyTo: another
	

! !

!PltExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
expressionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
expressionToValues: values
	^ values

! !

!PltExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self expressionFromValues: (super fromValues: values)

! !

!PltExpression methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltExpression
	^ true

! !

!PltExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self expressionFromValues: values

! !

!PltExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self expressionToValues: values

! !

!PltExpression methodsFor: 'platypus-generated-accessing' stamp: ''!
owner
	^ owner

! !

!PltExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self expressionCopyTo: another

! !

!PltExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self expressionCopyTo: another

! !

!PltExpression methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self expressionToValues: (super toValues: values)

! !

PltExpression subclass: #PltNativeExpression
	instanceVariableNames: 'source'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltNativeExpression commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY native_expression 
	SUBTYPE OF ( expression );
	source : native_algorithm;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltNativeExpression class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltNativeExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltNativeExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltNativeExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltNativeExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltNativeExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltNativeExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltNativeExpression methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptNativeExpression: self

! !

!PltNativeExpression methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetSource: aPltNativeAlgorithm
	source := aPltNativeAlgorithm

! !

!PltNativeExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self nativeExpressionFromValues: (super fromValues: values)

! !

!PltNativeExpression methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltNativeExpression
	^ true

! !

!PltNativeExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self nativeExpressionFromValues: values

! !

!PltNativeExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self nativeExpressionToValues: values

! !

!PltNativeExpression methodsFor: 'platypus-generated-copying' stamp: ''!
nativeExpressionCopyTo: another
	another fastSetSource: self source

! !

!PltNativeExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
nativeExpressionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setSource: valuesloc removeFirst.
	^ valuesloc

! !

!PltNativeExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
nativeExpressionToValues: values
	values add: self source.
	^ values

! !

!PltNativeExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltNativeExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self nativeExpressionCopyTo: another

! !

!PltNativeExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self nativeExpressionCopyTo: another

! !

!PltNativeExpression methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setSource: aPltNativeAlgorithm
	self source: aPltNativeAlgorithm

! !

!PltNativeExpression methodsFor: 'platypus-generated-accessing' stamp: ''!
source
	^ source

! !

!PltNativeExpression methodsFor: 'platypus-generated-accessing' stamp: ''!
source: aPltNativeAlgorithm
	source := aPltNativeAlgorithm

! !

!PltNativeExpression methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
sourceUsingContext: aContext
	^ self source

! !

!PltNativeExpression methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	source := nil

! !

!PltNativeExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self nativeExpressionToValues: (super toValues: values)

! !

PltExpression subclass: #PltUnaryExpression
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltUnaryExpression commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY unary_expression 
	ABSTRACT SUPERTYPE 
	SUBTYPE OF ( expression );
END_ENTITY;
</ISO10303-11-EXPRESS>!

PltUnaryExpression subclass: #PltAggrUnaryExpression
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltAggrUnaryExpression commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY aggr_unary_expression 
	ABSTRACT SUPERTYPE 
	SUBTYPE OF ( unary_expression );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltAggrUnaryExpression class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltAggrUnaryExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltAggrUnaryExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltAggrUnaryExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltAggrUnaryExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltAggrUnaryExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltAggrUnaryExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltAggrUnaryExpression methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptAggrUnaryExpression: self

! !

!PltAggrUnaryExpression methodsFor: 'platypus-generated-copying' stamp: ''!
aggrUnaryExpressionCopyTo: another
	

! !

!PltAggrUnaryExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
aggrUnaryExpressionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltAggrUnaryExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
aggrUnaryExpressionToValues: values
	^ values

! !

!PltAggrUnaryExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self aggrUnaryExpressionFromValues: (super fromValues: values)

! !

!PltAggrUnaryExpression methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltAggrUnaryExpression
	^ true

! !

!PltAggrUnaryExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self aggrUnaryExpressionFromValues: values

! !

!PltAggrUnaryExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self aggrUnaryExpressionToValues: values

! !

!PltAggrUnaryExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltAggrUnaryExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self aggrUnaryExpressionCopyTo: another

! !

!PltAggrUnaryExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self aggrUnaryExpressionCopyTo: another

! !

!PltAggrUnaryExpression methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltAggrUnaryExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self aggrUnaryExpressionToValues: (super toValues: values)

! !

PltAggrUnaryExpression subclass: #PltQueryExpression
	instanceVariableNames: 'identifiersCache variable suchThat aggregateSource'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltQueryExpression commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY query_expression 
	SUBTYPE OF ( aggr_unary_expression );
	variable : query_variable;
	aggregate_source : expression;
	such_that : expression;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltQueryExpression class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltQueryExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltQueryExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltQueryExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltQueryExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltQueryExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltQueryExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltQueryExpression methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptQueryExpression: self

! !

!PltQueryExpression methodsFor: 'platypus-generated-accessing' stamp: ''!
aggregateSource
	^ aggregateSource

! !

!PltQueryExpression methodsFor: 'platypus-generated-accessing' stamp: ''!
aggregateSource: aPltExpression
	aggregateSource := aPltExpression

! !

!PltQueryExpression methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
aggregateSourceUsingContext: aContext
	^ self aggregateSource

! !

!PltQueryExpression methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetAggregateSource: aPltExpression
	aggregateSource := aPltExpression

! !

!PltQueryExpression methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetSuchThat: aPltExpression
	suchThat := aPltExpression

! !

!PltQueryExpression methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetVariable: aPltQueryVariable
	variable := aPltQueryVariable

! !

!PltQueryExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self queryExpressionFromValues: (super fromValues: values)

! !

!PltQueryExpression methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltQueryExpression
	^ true

! !

!PltQueryExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self queryExpressionFromValues: values

! !

!PltQueryExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self queryExpressionToValues: values

! !

!PltQueryExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltQueryExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self queryExpressionCopyTo: another

! !

!PltQueryExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self queryExpressionCopyTo: another

! !

!PltQueryExpression methodsFor: 'platypus-generated-copying' stamp: ''!
queryExpressionCopyTo: another
	another fastSetVariable: self variable.
	another fastSetAggregateSource: self aggregateSource.
	another fastSetSuchThat: self suchThat

! !

!PltQueryExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
queryExpressionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setVariable: valuesloc removeFirst.
	self setAggregateSource: valuesloc removeFirst.
	self setSuchThat: valuesloc removeFirst.
	^ valuesloc

! !

!PltQueryExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
queryExpressionToValues: values
	values add: self variable.
	values add: self aggregateSource.
	values add: self suchThat.
	^ values

! !

!PltQueryExpression methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setAggregateSource: aPltExpression
	self aggregateSource: aPltExpression

! !

!PltQueryExpression methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setSuchThat: aPltExpression
	self suchThat: aPltExpression

! !

!PltQueryExpression methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setVariable: aPltQueryVariable
	self variable: aPltQueryVariable

! !

!PltQueryExpression methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	variable := nil.
	aggregateSource := nil.
	suchThat := nil

! !

!PltQueryExpression methodsFor: 'platypus-generated-accessing' stamp: ''!
suchThat
	^ suchThat

! !

!PltQueryExpression methodsFor: 'platypus-generated-accessing' stamp: ''!
suchThat: aPltExpression
	suchThat := aPltExpression

! !

!PltQueryExpression methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
suchThatUsingContext: aContext
	^ self suchThat

! !

!PltQueryExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self queryExpressionToValues: (super toValues: values)

! !

!PltQueryExpression methodsFor: 'platypus-generated-accessing' stamp: ''!
variable
	^ variable

! !

!PltQueryExpression methodsFor: 'platypus-generated-accessing' stamp: ''!
variable: aPltQueryVariable
	variable := aPltQueryVariable

! !

!PltQueryExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
variable: aPltQueryVariable aggregateSource: aPltExpression suchThat: aPltExpression1 	self setVariable:aPltQueryVariable.	self setAggregateSource:aPltExpression.	self setSuchThat:aPltExpression1.

! !

!PltQueryExpression methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
variableUsingContext: aContext
	^ self variable

! !

PltUnaryExpression subclass: #PltEntityInstanceConstructor
	instanceVariableNames: 'decl parameters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltEntityInstanceConstructor commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY entity_instance_constructor 
	SUBTYPE OF ( unary_expression );
	decl : entity_definition_reference;
	parameters : LIST OF expression;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltEntityInstanceConstructor class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltEntityInstanceConstructor class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltEntityInstanceConstructor class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltEntityInstanceConstructor class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltEntityInstanceConstructor class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltEntityInstanceConstructor class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltEntityInstanceConstructor class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltEntityInstanceConstructor methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptEntityInstanceConstructor: self

! !

!PltEntityInstanceConstructor methodsFor: 'platypus-generated-accessing' stamp: ''!
decl
	^ decl

! !

!PltEntityInstanceConstructor methodsFor: 'platypus-generated-accessing' stamp: ''!
decl: aPltEntityDefinitionReference
	decl := aPltEntityDefinitionReference

! !

!PltEntityInstanceConstructor methodsFor: 'platypus-generated-group-accessing' stamp: ''!
decl: aPltEntityDefinitionReference parameters: aListOfPltExpression 	self setDecl:aPltEntityDefinitionReference.	self setParameters:aListOfPltExpression.

! !

!PltEntityInstanceConstructor methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
declUsingContext: aContext
	^ self decl

! !

!PltEntityInstanceConstructor methodsFor: 'platypus-generated-copying' stamp: ''!
entityInstanceConstructorCopyTo: another
	another fastSetDecl: self decl.
	another fastSetParameters: self parameters

! !

!PltEntityInstanceConstructor methodsFor: 'platypus-generated-group-accessing' stamp: ''!
entityInstanceConstructorFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setDecl: valuesloc removeFirst.
	self setParameters: valuesloc removeFirst.
	^ valuesloc

! !

!PltEntityInstanceConstructor methodsFor: 'platypus-generated-group-accessing' stamp: ''!
entityInstanceConstructorToValues: values
	values add: self decl.
	values add: self parameters.
	^ values

! !

!PltEntityInstanceConstructor methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetDecl: aPltEntityDefinitionReference
	decl := aPltEntityDefinitionReference

! !

!PltEntityInstanceConstructor methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetParameters: aListOfPltExpression
	parameters := aListOfPltExpression

! !

!PltEntityInstanceConstructor methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self entityInstanceConstructorFromValues: (super fromValues: values)

! !

!PltEntityInstanceConstructor methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltEntityInstanceConstructor
	^ true

! !

!PltEntityInstanceConstructor methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self entityInstanceConstructorFromValues: values

! !

!PltEntityInstanceConstructor methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self entityInstanceConstructorToValues: values

! !

!PltEntityInstanceConstructor methodsFor: 'platypus-generated-accessing' stamp: ''!
parameters
	^ parameters

! !

!PltEntityInstanceConstructor methodsFor: 'platypus-generated-accessing' stamp: ''!
parameters: aListOfPltExpression
	parameters := aListOfPltExpression
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfPltExpression as: OrderedCollection ]

! !

!PltEntityInstanceConstructor methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
parametersUsingContext: aContext
	^ self parameters

! !

!PltEntityInstanceConstructor methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltEntityInstanceConstructor methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self entityInstanceConstructorCopyTo: another

! !

!PltEntityInstanceConstructor methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self entityInstanceConstructorCopyTo: another

! !

!PltEntityInstanceConstructor methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setDecl: aPltEntityDefinitionReference
	self decl: aPltEntityDefinitionReference

! !

!PltEntityInstanceConstructor methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setParameters: aListOfPltExpression
	self parameters: aListOfPltExpression

! !

!PltEntityInstanceConstructor methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	decl := nil.
	parameters := OrderedCollection new

! !

!PltEntityInstanceConstructor methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self entityInstanceConstructorToValues: (super toValues: values)

! !

PltUnaryExpression subclass: #PltEntityInstancesSet
	instanceVariableNames: 'entityRef'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltEntityInstancesSet commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY entity_instances_set 
	SUBTYPE OF ( unary_expression );
	entity_ref : entity_definition_reference;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltEntityInstancesSet class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltEntityInstancesSet class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltEntityInstancesSet class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltEntityInstancesSet class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltEntityInstancesSet class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltEntityInstancesSet class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltEntityInstancesSet class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltEntityInstancesSet methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptEntityInstancesSet: self

! !

!PltEntityInstancesSet methodsFor: 'platypus-generated-copying' stamp: ''!
entityInstancesSetCopyTo: another
	another fastSetEntityRef: self entityRef

! !

!PltEntityInstancesSet methodsFor: 'platypus-generated-group-accessing' stamp: ''!
entityInstancesSetFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setEntityRef: valuesloc removeFirst.
	^ valuesloc

! !

!PltEntityInstancesSet methodsFor: 'platypus-generated-group-accessing' stamp: ''!
entityInstancesSetToValues: values
	values add: self entityRef.
	^ values

! !

!PltEntityInstancesSet methodsFor: 'platypus-generated-accessing' stamp: ''!
entityRef
	^ entityRef

! !

!PltEntityInstancesSet methodsFor: 'platypus-generated-accessing' stamp: ''!
entityRef: aPltEntityDefinitionReference
	entityRef := aPltEntityDefinitionReference

! !

!PltEntityInstancesSet methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
entityRefUsingContext: aContext
	^ self entityRef

! !

!PltEntityInstancesSet methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetEntityRef: aPltEntityDefinitionReference
	entityRef := aPltEntityDefinitionReference

! !

!PltEntityInstancesSet methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self entityInstancesSetFromValues: (super fromValues: values)

! !

!PltEntityInstancesSet methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltEntityInstancesSet
	^ true

! !

!PltEntityInstancesSet methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self entityInstancesSetFromValues: values

! !

!PltEntityInstancesSet methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self entityInstancesSetToValues: values

! !

!PltEntityInstancesSet methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltEntityInstancesSet methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self entityInstancesSetCopyTo: another

! !

!PltEntityInstancesSet methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self entityInstancesSetCopyTo: another

! !

!PltEntityInstancesSet methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setEntityRef: aPltEntityDefinitionReference
	self entityRef: aPltEntityDefinitionReference

! !

!PltEntityInstancesSet methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	entityRef := nil

! !

!PltEntityInstancesSet methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self entityInstancesSetToValues: (super toValues: values)

! !

PltUnaryExpression subclass: #PltIdentifier
	instanceVariableNames: 'name contextsStack parameters ref'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltIdentifier commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY identifier 
	SUBTYPE OF ( unary_expression );
	name : STRING;
	ref : dictionary_instance;
	parameters : OPTIONAL LIST OF expression;
END_ENTITY;
</ISO10303-11-EXPRESS>!

PltIdentifier subclass: #PltAttributeIdentifier
	instanceVariableNames: 'selfInstance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltAttributeIdentifier commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY attribute_identifier 
	SUBTYPE OF ( identifier );
	selfInstance : generic_instance;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltAttributeIdentifier class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltAttributeIdentifier class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltAttributeIdentifier class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltAttributeIdentifier class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltAttributeIdentifier class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltAttributeIdentifier class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltAttributeIdentifier class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltAttributeIdentifier methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptAttributeIdentifier: self

! !

!PltAttributeIdentifier methodsFor: 'platypus-generated-copying' stamp: ''!
attributeIdentifierCopyTo: another
	another fastSetSelfInstance: self selfInstance

! !

!PltAttributeIdentifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
attributeIdentifierFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setSelfInstance: valuesloc removeFirst.
	^ valuesloc

! !

!PltAttributeIdentifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
attributeIdentifierToValues: values
	values add: self selfInstance.
	^ values

! !

!PltAttributeIdentifier methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetSelfInstance: aPltGenericInstance
	selfInstance := aPltGenericInstance

! !

!PltAttributeIdentifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self attributeIdentifierFromValues: (super fromValues: values)

! !

!PltAttributeIdentifier methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltAttributeIdentifier
	^ true

! !

!PltAttributeIdentifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self attributeIdentifierFromValues: values

! !

!PltAttributeIdentifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self attributeIdentifierToValues: values

! !

!PltAttributeIdentifier methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltAttributeIdentifier methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self attributeIdentifierCopyTo: another

! !

!PltAttributeIdentifier methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self attributeIdentifierCopyTo: another

! !

!PltAttributeIdentifier methodsFor: 'platypus-generated-accessing' stamp: ''!
selfInstance
	^ selfInstance

! !

!PltAttributeIdentifier methodsFor: 'platypus-generated-accessing' stamp: ''!
selfInstance: aPltGenericInstance
	selfInstance := aPltGenericInstance

! !

!PltAttributeIdentifier methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
selfInstanceUsingContext: aContext
	^ self selfInstance

! !

!PltAttributeIdentifier methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setSelfInstance: aPltGenericInstance
	self selfInstance: aPltGenericInstance

! !

!PltAttributeIdentifier methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	selfInstance := nil

! !

!PltAttributeIdentifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self attributeIdentifierToValues: (super toValues: values)

! !

!PltIdentifier class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltIdentifier class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltIdentifier class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltIdentifier class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltIdentifier class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltIdentifier class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltIdentifier class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltIdentifier methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptIdentifier: self

! !

!PltIdentifier methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetName: aString
	name := aString

! !

!PltIdentifier methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetParameters: aListOfPltExpression
	parameters := aListOfPltExpression

! !

!PltIdentifier methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetRef: aPltDictionaryInstance
	ref := aPltDictionaryInstance

! !

!PltIdentifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self identifierFromValues: (super fromValues: values)

! !

!PltIdentifier methodsFor: 'platypus-generated-copying' stamp: ''!
identifierCopyTo: another
	another fastSetName: self name.
	another fastSetRef: self ref.
	another fastSetParameters: self parameters

! !

!PltIdentifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
identifierFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setName: valuesloc removeFirst.
	self setRef: valuesloc removeFirst.
	self setParameters: valuesloc removeFirst.
	^ valuesloc

! !

!PltIdentifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
identifierToValues: values
	values add: self name.
	values add: self ref.
	values add: self parameters.
	^ values

! !

!PltIdentifier methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltIdentifier
	^ true

! !

!PltIdentifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self identifierFromValues: values

! !

!PltIdentifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self identifierToValues: values

! !

!PltIdentifier methodsFor: 'platypus-generated-accessing' stamp: ''!
name
	^ name

! !

!PltIdentifier methodsFor: 'platypus-generated-accessing' stamp: ''!
name: aString
	name := aString

! !

!PltIdentifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
name: aString ref: aPltDictionaryInstance parameters: aListOfPltExpression 	self setName:aString.	self setRef:aPltDictionaryInstance.	self setParameters:aListOfPltExpression.

! !

!PltIdentifier methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
nameUsingContext: aContext
	^ self name

! !

!PltIdentifier methodsFor: 'platypus-generated-accessing' stamp: ''!
parameters
	^ parameters

! !

!PltIdentifier methodsFor: 'platypus-generated-accessing' stamp: ''!
parameters: aListOfPltExpression
	parameters := aListOfPltExpression
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfPltExpression as: OrderedCollection ]

! !

!PltIdentifier methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
parametersUsingContext: aContext
	^ self parameters

! !

!PltIdentifier methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltIdentifier methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self identifierCopyTo: another

! !

!PltIdentifier methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self identifierCopyTo: another

! !

!PltIdentifier methodsFor: 'platypus-generated-accessing' stamp: ''!
ref
	^ ref

! !

!PltIdentifier methodsFor: 'platypus-generated-accessing' stamp: ''!
ref: aPltDictionaryInstance
	ref := aPltDictionaryInstance

! !

!PltIdentifier methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
refUsingContext: aContext
	^ self ref

! !

!PltIdentifier methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setName: aString
	self name: aString

! !

!PltIdentifier methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setParameters: aListOfPltExpression
	self parameters: aListOfPltExpression

! !

!PltIdentifier methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setRef: aPltDictionaryInstance
	self ref: aPltDictionaryInstance

! !

!PltIdentifier methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	name := ''.
	ref := nil.
	parameters := nil

! !

!PltIdentifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self identifierToValues: (super toValues: values)

! !

PltIdentifier subclass: #PltImplicitlyDeclaredIdentifier
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltImplicitlyDeclaredIdentifier commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY implicitly_declared_identifier 
	SUBTYPE OF ( identifier );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltImplicitlyDeclaredIdentifier class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltImplicitlyDeclaredIdentifier class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltImplicitlyDeclaredIdentifier class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltImplicitlyDeclaredIdentifier class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltImplicitlyDeclaredIdentifier class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltImplicitlyDeclaredIdentifier class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltImplicitlyDeclaredIdentifier class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltImplicitlyDeclaredIdentifier methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptImplicitlyDeclaredIdentifier: self

! !

!PltImplicitlyDeclaredIdentifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self implicitlyDeclaredIdentifierFromValues: (super fromValues: values)

! !

!PltImplicitlyDeclaredIdentifier methodsFor: 'platypus-generated-copying' stamp: ''!
implicitlyDeclaredIdentifierCopyTo: another
	

! !

!PltImplicitlyDeclaredIdentifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
implicitlyDeclaredIdentifierFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltImplicitlyDeclaredIdentifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
implicitlyDeclaredIdentifierToValues: values
	^ values

! !

!PltImplicitlyDeclaredIdentifier methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltImplicitlyDeclaredIdentifier
	^ true

! !

!PltImplicitlyDeclaredIdentifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self implicitlyDeclaredIdentifierFromValues: values

! !

!PltImplicitlyDeclaredIdentifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self implicitlyDeclaredIdentifierToValues: values

! !

!PltImplicitlyDeclaredIdentifier methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltImplicitlyDeclaredIdentifier methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self implicitlyDeclaredIdentifierCopyTo: another

! !

!PltImplicitlyDeclaredIdentifier methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self implicitlyDeclaredIdentifierCopyTo: another

! !

!PltImplicitlyDeclaredIdentifier methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltImplicitlyDeclaredIdentifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self implicitlyDeclaredIdentifierToValues: (super toValues: values)

! !

PltIdentifier subclass: #PltUniquenessRuleAttributeIdentifier
	instanceVariableNames: 'groupRefName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltUniquenessRuleAttributeIdentifier commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY uniqueness_rule_attribute_identifier 
	SUBTYPE OF ( identifier );
	group_ref_name : OPTIONAL STRING;
	SELF\identifier.ref : attribute;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltUniquenessRuleAttributeIdentifier class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltUniquenessRuleAttributeIdentifier class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltUniquenessRuleAttributeIdentifier class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltUniquenessRuleAttributeIdentifier class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltUniquenessRuleAttributeIdentifier class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltUniquenessRuleAttributeIdentifier class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltUniquenessRuleAttributeIdentifier class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltUniquenessRuleAttributeIdentifier methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptUniquenessRuleAttributeIdentifier: self

! !

!PltUniquenessRuleAttributeIdentifier methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetGroupRefName: aString
	groupRefName := aString

! !

!PltUniquenessRuleAttributeIdentifier methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetRef: aPltAttribute
	ref := aPltAttribute

! !

!PltUniquenessRuleAttributeIdentifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self uniquenessRuleAttributeIdentifierFromValues: (super fromValues: values)

! !

!PltUniquenessRuleAttributeIdentifier methodsFor: 'platypus-generated-accessing' stamp: ''!
groupRefName
	^ groupRefName

! !

!PltUniquenessRuleAttributeIdentifier methodsFor: 'platypus-generated-accessing' stamp: ''!
groupRefName: aString
	groupRefName := aString

! !

!PltUniquenessRuleAttributeIdentifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
groupRefName: aString ref: aPltAttribute 	self setGroupRefName:aString.	self setRef:aPltAttribute.

! !

!PltUniquenessRuleAttributeIdentifier methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
groupRefNameUsingContext: aContext
	^ self groupRefName

! !

!PltUniquenessRuleAttributeIdentifier methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltUniquenessRuleAttributeIdentifier
	^ true

! !

!PltUniquenessRuleAttributeIdentifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self uniquenessRuleAttributeIdentifierFromValues: values

! !

!PltUniquenessRuleAttributeIdentifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self uniquenessRuleAttributeIdentifierToValues: values

! !

!PltUniquenessRuleAttributeIdentifier methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltUniquenessRuleAttributeIdentifier methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self uniquenessRuleAttributeIdentifierCopyTo: another

! !

!PltUniquenessRuleAttributeIdentifier methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self uniquenessRuleAttributeIdentifierCopyTo: another

! !

!PltUniquenessRuleAttributeIdentifier methodsFor: 'platypus-generated-accessing' stamp: ''!
ref
	^ ref

! !

!PltUniquenessRuleAttributeIdentifier methodsFor: 'platypus-generated-accessing' stamp: ''!
ref: aPltAttribute
	ref := aPltAttribute

! !

!PltUniquenessRuleAttributeIdentifier methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
refUsingContext: aContext
	^ self ref

! !

!PltUniquenessRuleAttributeIdentifier methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setGroupRefName: aString
	self groupRefName: aString

! !

!PltUniquenessRuleAttributeIdentifier methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setRef: aPltAttribute
	self ref: aPltAttribute

! !

!PltUniquenessRuleAttributeIdentifier methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	groupRefName := nil.
	ref := nil

! !

!PltUniquenessRuleAttributeIdentifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self uniquenessRuleAttributeIdentifierToValues: (super toValues: values)

! !

!PltUniquenessRuleAttributeIdentifier methodsFor: 'platypus-generated-copying' stamp: ''!
uniquenessRuleAttributeIdentifierCopyTo: another
	another fastSetGroupRefName: self groupRefName.
	another fastSetRef: self ref

! !

!PltUniquenessRuleAttributeIdentifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
uniquenessRuleAttributeIdentifierFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setGroupRefName: valuesloc removeFirst.
	self setRef: valuesloc removeFirst.
	^ valuesloc

! !

!PltUniquenessRuleAttributeIdentifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
uniquenessRuleAttributeIdentifierToValues: values
	values add: self groupRefName.
	values add: self ref.
	^ values

! !

PltUnaryExpression subclass: #PltInterval
	instanceVariableNames: 'expr'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltInterval commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY interval 
	SUBTYPE OF ( unary_expression );
	expr : and_expression;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltInterval class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltInterval class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltInterval class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltInterval class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltInterval class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltInterval class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltInterval class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltInterval methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptInterval: self

! !

!PltInterval methodsFor: 'platypus-generated-accessing' stamp: ''!
expr
	^ expr

! !

!PltInterval methodsFor: 'platypus-generated-accessing' stamp: ''!
expr: aPltAndExpression
	expr := aPltAndExpression

! !

!PltInterval methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
exprUsingContext: aContext
	^ self expr

! !

!PltInterval methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetExpr: aPltAndExpression
	expr := aPltAndExpression

! !

!PltInterval methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self intervalFromValues: (super fromValues: values)

! !

!PltInterval methodsFor: 'platypus-generated-copying' stamp: ''!
intervalCopyTo: another
	another fastSetExpr: self expr

! !

!PltInterval methodsFor: 'platypus-generated-group-accessing' stamp: ''!
intervalFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setExpr: valuesloc removeFirst.
	^ valuesloc

! !

!PltInterval methodsFor: 'platypus-generated-group-accessing' stamp: ''!
intervalToValues: values
	values add: self expr.
	^ values

! !

!PltInterval methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltInterval
	^ true

! !

!PltInterval methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self intervalFromValues: values

! !

!PltInterval methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self intervalToValues: values

! !

!PltInterval methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltInterval methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self intervalCopyTo: another

! !

!PltInterval methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self intervalCopyTo: another

! !

!PltInterval methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setExpr: aPltAndExpression
	self expr: aPltAndExpression

! !

!PltInterval methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	expr := nil

! !

!PltInterval methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self intervalToValues: (super toValues: values)

! !

PltUnaryExpression subclass: #PltLiteral
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltLiteral commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY literal 
	ABSTRACT SUPERTYPE 
	SUBTYPE OF ( unary_expression );
END_ENTITY;
</ISO10303-11-EXPRESS>!

PltLiteral subclass: #PltBinaryLiteral
	instanceVariableNames: 'val'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltBinaryLiteral commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY binary_literal 
	SUBTYPE OF ( literal );
	val : BINARY;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltBinaryLiteral class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltBinaryLiteral class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltBinaryLiteral class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltBinaryLiteral class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltBinaryLiteral class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltBinaryLiteral class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltBinaryLiteral class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltBinaryLiteral methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptBinaryLiteral: self

! !

!PltBinaryLiteral methodsFor: 'platypus-generated-copying' stamp: ''!
binaryLiteralCopyTo: another
	another fastSetVal: self val

! !

!PltBinaryLiteral methodsFor: 'platypus-generated-group-accessing' stamp: ''!
binaryLiteralFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setVal: valuesloc removeFirst.
	^ valuesloc

! !

!PltBinaryLiteral methodsFor: 'platypus-generated-group-accessing' stamp: ''!
binaryLiteralToValues: values
	values add: self val.
	^ values

! !

!PltBinaryLiteral methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetVal: aBinary
	val := aBinary

! !

!PltBinaryLiteral methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self binaryLiteralFromValues: (super fromValues: values)

! !

!PltBinaryLiteral methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltBinaryLiteral
	^ true

! !

!PltBinaryLiteral methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self binaryLiteralFromValues: values

! !

!PltBinaryLiteral methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self binaryLiteralToValues: values

! !

!PltBinaryLiteral methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltBinaryLiteral methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self binaryLiteralCopyTo: another

! !

!PltBinaryLiteral methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self binaryLiteralCopyTo: another

! !

!PltBinaryLiteral methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setVal: aBinary
	self val: aBinary

! !

!PltBinaryLiteral methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	val := nil

! !

!PltBinaryLiteral methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self binaryLiteralToValues: (super toValues: values)

! !

!PltBinaryLiteral methodsFor: 'platypus-generated-accessing' stamp: ''!
val
	^ val

! !

!PltBinaryLiteral methodsFor: 'platypus-generated-accessing' stamp: ''!
val: aBinary
	val := aBinary

! !

!PltBinaryLiteral methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
valUsingContext: aContext
	^ self val

! !

!PltLiteral class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltLiteral class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltLiteral class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltLiteral class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltLiteral class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltLiteral class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltLiteral class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltLiteral methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptLiteral: self

! !

!PltLiteral methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self literalFromValues: (super fromValues: values)

! !

!PltLiteral methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltLiteral
	^ true

! !

!PltLiteral methodsFor: 'platypus-generated-copying' stamp: ''!
literalCopyTo: another
	

! !

!PltLiteral methodsFor: 'platypus-generated-group-accessing' stamp: ''!
literalFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltLiteral methodsFor: 'platypus-generated-group-accessing' stamp: ''!
literalToValues: values
	^ values

! !

!PltLiteral methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self literalFromValues: values

! !

!PltLiteral methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self literalToValues: values

! !

!PltLiteral methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltLiteral methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self literalCopyTo: another

! !

!PltLiteral methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self literalCopyTo: another

! !

!PltLiteral methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltLiteral methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self literalToValues: (super toValues: values)

! !

PltLiteral subclass: #PltLogicalLiteral
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltLogicalLiteral commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY logical_literal 
	ABSTRACT SUPERTYPE 
	SUBTYPE OF ( literal );
END_ENTITY;
</ISO10303-11-EXPRESS>!

PltLogicalLiteral subclass: #PltFalseConstant
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltFalseConstant commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY false_constant 
	SUBTYPE OF ( logical_literal );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltFalseConstant class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltFalseConstant class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltFalseConstant class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltFalseConstant class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltFalseConstant class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltFalseConstant class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltFalseConstant class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltFalseConstant methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptFalseConstant: self

! !

!PltFalseConstant methodsFor: 'platypus-generated-copying' stamp: ''!
falseConstantCopyTo: another
	

! !

!PltFalseConstant methodsFor: 'platypus-generated-group-accessing' stamp: ''!
falseConstantFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltFalseConstant methodsFor: 'platypus-generated-group-accessing' stamp: ''!
falseConstantToValues: values
	^ values

! !

!PltFalseConstant methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self falseConstantFromValues: (super fromValues: values)

! !

!PltFalseConstant methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltFalseConstant
	^ true

! !

!PltFalseConstant methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self falseConstantFromValues: values

! !

!PltFalseConstant methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self falseConstantToValues: values

! !

!PltFalseConstant methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltFalseConstant methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self falseConstantCopyTo: another

! !

!PltFalseConstant methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self falseConstantCopyTo: another

! !

!PltFalseConstant methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltFalseConstant methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self falseConstantToValues: (super toValues: values)

! !

!PltLogicalLiteral class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltLogicalLiteral class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltLogicalLiteral class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltLogicalLiteral class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltLogicalLiteral class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltLogicalLiteral class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltLogicalLiteral class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltLogicalLiteral methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptLogicalLiteral: self

! !

!PltLogicalLiteral methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self logicalLiteralFromValues: (super fromValues: values)

! !

!PltLogicalLiteral methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltLogicalLiteral
	^ true

! !

!PltLogicalLiteral methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self logicalLiteralFromValues: values

! !

!PltLogicalLiteral methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self logicalLiteralToValues: values

! !

!PltLogicalLiteral methodsFor: 'platypus-generated-copying' stamp: ''!
logicalLiteralCopyTo: another
	

! !

!PltLogicalLiteral methodsFor: 'platypus-generated-group-accessing' stamp: ''!
logicalLiteralFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltLogicalLiteral methodsFor: 'platypus-generated-group-accessing' stamp: ''!
logicalLiteralToValues: values
	^ values

! !

!PltLogicalLiteral methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltLogicalLiteral methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self logicalLiteralCopyTo: another

! !

!PltLogicalLiteral methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self logicalLiteralCopyTo: another

! !

!PltLogicalLiteral methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltLogicalLiteral methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self logicalLiteralToValues: (super toValues: values)

! !

PltLogicalLiteral subclass: #PltTrueConstant
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltTrueConstant commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY true_constant 
	SUBTYPE OF ( logical_literal );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltTrueConstant class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltTrueConstant class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltTrueConstant class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltTrueConstant class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltTrueConstant class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltTrueConstant class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltTrueConstant class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltTrueConstant methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptTrueConstant: self

! !

!PltTrueConstant methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self trueConstantFromValues: (super fromValues: values)

! !

!PltTrueConstant methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltTrueConstant
	^ true

! !

!PltTrueConstant methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self trueConstantFromValues: values

! !

!PltTrueConstant methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self trueConstantToValues: values

! !

!PltTrueConstant methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltTrueConstant methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self trueConstantCopyTo: another

! !

!PltTrueConstant methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self trueConstantCopyTo: another

! !

!PltTrueConstant methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltTrueConstant methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self trueConstantToValues: (super toValues: values)

! !

!PltTrueConstant methodsFor: 'platypus-generated-copying' stamp: ''!
trueConstantCopyTo: another
	

! !

!PltTrueConstant methodsFor: 'platypus-generated-group-accessing' stamp: ''!
trueConstantFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltTrueConstant methodsFor: 'platypus-generated-group-accessing' stamp: ''!
trueConstantToValues: values
	^ values

! !

PltLogicalLiteral subclass: #PltUnknownConstant
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltUnknownConstant commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY unknown_constant 
	SUBTYPE OF ( logical_literal );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltUnknownConstant class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltUnknownConstant class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltUnknownConstant class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltUnknownConstant class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltUnknownConstant class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltUnknownConstant class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltUnknownConstant class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltUnknownConstant methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptUnknownConstant: self

! !

!PltUnknownConstant methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self unknownConstantFromValues: (super fromValues: values)

! !

!PltUnknownConstant methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltUnknownConstant
	^ true

! !

!PltUnknownConstant methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self unknownConstantFromValues: values

! !

!PltUnknownConstant methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self unknownConstantToValues: values

! !

!PltUnknownConstant methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltUnknownConstant methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self unknownConstantCopyTo: another

! !

!PltUnknownConstant methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self unknownConstantCopyTo: another

! !

!PltUnknownConstant methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltUnknownConstant methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self unknownConstantToValues: (super toValues: values)

! !

!PltUnknownConstant methodsFor: 'platypus-generated-copying' stamp: ''!
unknownConstantCopyTo: another
	

! !

!PltUnknownConstant methodsFor: 'platypus-generated-group-accessing' stamp: ''!
unknownConstantFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltUnknownConstant methodsFor: 'platypus-generated-group-accessing' stamp: ''!
unknownConstantToValues: values
	^ values

! !

PltLiteral subclass: #PltNumericLiteral
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltNumericLiteral commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY numeric_literal 
	ABSTRACT SUPERTYPE 
	SUBTYPE OF ( literal );
END_ENTITY;
</ISO10303-11-EXPRESS>!

PltNumericLiteral subclass: #PltIntegerLiteral
	instanceVariableNames: 'val'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltIntegerLiteral commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY integer_literal 
	SUBTYPE OF ( numeric_literal );
	val : INTEGER;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltIntegerLiteral class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltIntegerLiteral class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltIntegerLiteral class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltIntegerLiteral class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltIntegerLiteral class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltIntegerLiteral class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltIntegerLiteral class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltIntegerLiteral methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptIntegerLiteral: self

! !

!PltIntegerLiteral methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetVal: anInteger
	val := anInteger

! !

!PltIntegerLiteral methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self integerLiteralFromValues: (super fromValues: values)

! !

!PltIntegerLiteral methodsFor: 'platypus-generated-copying' stamp: ''!
integerLiteralCopyTo: another
	another fastSetVal: self val

! !

!PltIntegerLiteral methodsFor: 'platypus-generated-group-accessing' stamp: ''!
integerLiteralFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setVal: valuesloc removeFirst.
	^ valuesloc

! !

!PltIntegerLiteral methodsFor: 'platypus-generated-group-accessing' stamp: ''!
integerLiteralToValues: values
	values add: self val.
	^ values

! !

!PltIntegerLiteral methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltIntegerLiteral
	^ true

! !

!PltIntegerLiteral methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self integerLiteralFromValues: values

! !

!PltIntegerLiteral methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self integerLiteralToValues: values

! !

!PltIntegerLiteral methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltIntegerLiteral methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self integerLiteralCopyTo: another

! !

!PltIntegerLiteral methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self integerLiteralCopyTo: another

! !

!PltIntegerLiteral methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setVal: anInteger
	self val: anInteger

! !

!PltIntegerLiteral methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	val := 0

! !

!PltIntegerLiteral methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self integerLiteralToValues: (super toValues: values)

! !

!PltIntegerLiteral methodsFor: 'platypus-generated-accessing' stamp: ''!
val
	^ val

! !

!PltIntegerLiteral methodsFor: 'platypus-generated-accessing' stamp: ''!
val: anInteger
	val := anInteger

! !

!PltIntegerLiteral methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
valUsingContext: aContext
	^ self val

! !

!PltNumericLiteral class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltNumericLiteral class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltNumericLiteral class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltNumericLiteral class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltNumericLiteral class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltNumericLiteral class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltNumericLiteral class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltNumericLiteral methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptNumericLiteral: self

! !

!PltNumericLiteral methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self numericLiteralFromValues: (super fromValues: values)

! !

!PltNumericLiteral methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltNumericLiteral
	^ true

! !

!PltNumericLiteral methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self numericLiteralFromValues: values

! !

!PltNumericLiteral methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self numericLiteralToValues: values

! !

!PltNumericLiteral methodsFor: 'platypus-generated-copying' stamp: ''!
numericLiteralCopyTo: another
	

! !

!PltNumericLiteral methodsFor: 'platypus-generated-group-accessing' stamp: ''!
numericLiteralFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltNumericLiteral methodsFor: 'platypus-generated-group-accessing' stamp: ''!
numericLiteralToValues: values
	^ values

! !

!PltNumericLiteral methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltNumericLiteral methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self numericLiteralCopyTo: another

! !

!PltNumericLiteral methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self numericLiteralCopyTo: another

! !

!PltNumericLiteral methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltNumericLiteral methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self numericLiteralToValues: (super toValues: values)

! !

PltNumericLiteral subclass: #PltRealLiteral
	instanceVariableNames: 'val'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltRealLiteral commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY real_literal 
	SUBTYPE OF ( numeric_literal );
	val : REAL;
END_ENTITY;
</ISO10303-11-EXPRESS>!

PltRealLiteral subclass: #PltEConstant
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltEConstant commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY e_constant 
	SUBTYPE OF ( real_literal );
DERIVE
	SELF\real_literal.val : REAL := 2.71828;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltEConstant class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltEConstant class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltEConstant class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltEConstant class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltEConstant class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltEConstant class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltEConstant class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltEConstant methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptEConstant: self

! !

!PltEConstant methodsFor: 'platypus-generated-copying' stamp: ''!
eConstantCopyTo: another
	

! !

!PltEConstant methodsFor: 'platypus-generated-group-accessing' stamp: ''!
eConstantFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltEConstant methodsFor: 'platypus-generated-group-accessing' stamp: ''!
eConstantToValues: values
	^ values

! !

!PltEConstant methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self eConstantFromValues: (super fromValues: values)

! !

!PltEConstant methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltEConstant
	^ true

! !

!PltEConstant methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self eConstantFromValues: values

! !

!PltEConstant methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self eConstantToValues: values

! !

!PltEConstant methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltEConstant methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self eConstantCopyTo: another

! !

!PltEConstant methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self eConstantCopyTo: another

! !

!PltEConstant methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltEConstant methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self eConstantToValues: (super toValues: values)

! !

!PltEConstant methodsFor: 'platypus-generated-deriving' stamp: ''!
val
	^ self valUsingContext: self class context

! !

!PltEConstant methodsFor: 'platypus-generated-deriving' stamp: ''!
valUsingContext: aContext
	^ self valUsingContext: aContext receiver: self

! !

!PltEConstant methodsFor: 'platypus-generated-deriving' stamp: ''!
valUsingContext: aContext receiver: aReceiver
	^ 2.71828

! !

PltRealLiteral subclass: #PltPiConstant
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltPiConstant commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY pi_constant 
	SUBTYPE OF ( real_literal );
DERIVE
	SELF\real_literal.val : REAL := 3.14159;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltPiConstant class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltPiConstant class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltPiConstant class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltPiConstant class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltPiConstant class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltPiConstant class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltPiConstant class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltPiConstant methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptPiConstant: self

! !

!PltPiConstant methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self piConstantFromValues: (super fromValues: values)

! !

!PltPiConstant methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltPiConstant
	^ true

! !

!PltPiConstant methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self piConstantFromValues: values

! !

!PltPiConstant methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self piConstantToValues: values

! !

!PltPiConstant methodsFor: 'platypus-generated-copying' stamp: ''!
piConstantCopyTo: another
	

! !

!PltPiConstant methodsFor: 'platypus-generated-group-accessing' stamp: ''!
piConstantFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltPiConstant methodsFor: 'platypus-generated-group-accessing' stamp: ''!
piConstantToValues: values
	^ values

! !

!PltPiConstant methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltPiConstant methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self piConstantCopyTo: another

! !

!PltPiConstant methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self piConstantCopyTo: another

! !

!PltPiConstant methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltPiConstant methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self piConstantToValues: (super toValues: values)

! !

!PltPiConstant methodsFor: 'platypus-generated-deriving' stamp: ''!
val
	^ self valUsingContext: self class context

! !

!PltPiConstant methodsFor: 'platypus-generated-deriving' stamp: ''!
valUsingContext: aContext
	^ self valUsingContext: aContext receiver: self

! !

!PltPiConstant methodsFor: 'platypus-generated-deriving' stamp: ''!
valUsingContext: aContext receiver: aReceiver
	^ 3.14159

! !

!PltRealLiteral class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltRealLiteral class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltRealLiteral class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltRealLiteral class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltRealLiteral class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltRealLiteral class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltRealLiteral class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltRealLiteral methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptRealLiteral: self

! !

!PltRealLiteral methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetVal: aReal
	val := aReal

! !

!PltRealLiteral methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self realLiteralFromValues: (super fromValues: values)

! !

!PltRealLiteral methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltRealLiteral
	^ true

! !

!PltRealLiteral methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self realLiteralFromValues: values

! !

!PltRealLiteral methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self realLiteralToValues: values

! !

!PltRealLiteral methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltRealLiteral methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self realLiteralCopyTo: another

! !

!PltRealLiteral methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self realLiteralCopyTo: another

! !

!PltRealLiteral methodsFor: 'platypus-generated-copying' stamp: ''!
realLiteralCopyTo: another
	another fastSetVal: self val

! !

!PltRealLiteral methodsFor: 'platypus-generated-group-accessing' stamp: ''!
realLiteralFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setVal: valuesloc removeFirst.
	^ valuesloc

! !

!PltRealLiteral methodsFor: 'platypus-generated-group-accessing' stamp: ''!
realLiteralToValues: values
	values add: self val.
	^ values

! !

!PltRealLiteral methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setVal: aReal
	self val: aReal

! !

!PltRealLiteral methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	val := 0.0

! !

!PltRealLiteral methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self realLiteralToValues: (super toValues: values)

! !

!PltRealLiteral methodsFor: 'platypus-generated-accessing' stamp: ''!
val
	^ val

! !

!PltRealLiteral methodsFor: 'platypus-generated-accessing' stamp: ''!
val: aReal
	val := aReal

! !

!PltRealLiteral methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
valUsingContext: aContext
	^ self val

! !

PltLiteral subclass: #PltStringLiteral
	instanceVariableNames: 'val'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltStringLiteral commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY string_literal 
	SUBTYPE OF ( literal );
	val : STRING;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltStringLiteral class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltStringLiteral class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltStringLiteral class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltStringLiteral class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltStringLiteral class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltStringLiteral class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltStringLiteral class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltStringLiteral methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptStringLiteral: self

! !

!PltStringLiteral methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetVal: aString
	val := aString

! !

!PltStringLiteral methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self stringLiteralFromValues: (super fromValues: values)

! !

!PltStringLiteral methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltStringLiteral
	^ true

! !

!PltStringLiteral methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self stringLiteralFromValues: values

! !

!PltStringLiteral methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self stringLiteralToValues: values

! !

!PltStringLiteral methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltStringLiteral methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self stringLiteralCopyTo: another

! !

!PltStringLiteral methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self stringLiteralCopyTo: another

! !

!PltStringLiteral methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setVal: aString
	self val: aString

! !

!PltStringLiteral methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	val := ''

! !

!PltStringLiteral methodsFor: 'platypus-generated-copying' stamp: ''!
stringLiteralCopyTo: another
	another fastSetVal: self val

! !

!PltStringLiteral methodsFor: 'platypus-generated-group-accessing' stamp: ''!
stringLiteralFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setVal: valuesloc removeFirst.
	^ valuesloc

! !

!PltStringLiteral methodsFor: 'platypus-generated-group-accessing' stamp: ''!
stringLiteralToValues: values
	values add: self val.
	^ values

! !

!PltStringLiteral methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self stringLiteralToValues: (super toValues: values)

! !

!PltStringLiteral methodsFor: 'platypus-generated-accessing' stamp: ''!
val
	^ val

! !

!PltStringLiteral methodsFor: 'platypus-generated-accessing' stamp: ''!
val: aString
	val := aString

! !

!PltStringLiteral methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
valUsingContext: aContext
	^ self val

! !

PltUnaryExpression subclass: #PltMissingValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltMissingValue commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY missing_value 
	SUBTYPE OF ( unary_expression );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltMissingValue class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltMissingValue class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltMissingValue class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltMissingValue class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltMissingValue class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltMissingValue class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltMissingValue class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltMissingValue methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptMissingValue: self

! !

!PltMissingValue methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self missingValueFromValues: (super fromValues: values)

! !

!PltMissingValue methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltMissingValue
	^ true

! !

!PltMissingValue methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self missingValueFromValues: values

! !

!PltMissingValue methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self missingValueToValues: values

! !

!PltMissingValue methodsFor: 'platypus-generated-copying' stamp: ''!
missingValueCopyTo: another
	

! !

!PltMissingValue methodsFor: 'platypus-generated-group-accessing' stamp: ''!
missingValueFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltMissingValue methodsFor: 'platypus-generated-group-accessing' stamp: ''!
missingValueToValues: values
	^ values

! !

!PltMissingValue methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltMissingValue methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self missingValueCopyTo: another

! !

!PltMissingValue methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self missingValueCopyTo: another

! !

!PltMissingValue methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltMissingValue methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self missingValueToValues: (super toValues: values)

! !

PltMissingValue subclass: #PltRedefinedAttributeValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltRedefinedAttributeValue commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY redefined_attribute_value 
	SUBTYPE OF ( missing_value );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltRedefinedAttributeValue class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltRedefinedAttributeValue class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltRedefinedAttributeValue class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltRedefinedAttributeValue class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltRedefinedAttributeValue class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltRedefinedAttributeValue class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltRedefinedAttributeValue class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltRedefinedAttributeValue methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptRedefinedAttributeValue: self

! !

!PltRedefinedAttributeValue methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self redefinedAttributeValueFromValues: (super fromValues: values)

! !

!PltRedefinedAttributeValue methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltRedefinedAttributeValue
	^ true

! !

!PltRedefinedAttributeValue methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self redefinedAttributeValueFromValues: values

! !

!PltRedefinedAttributeValue methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self redefinedAttributeValueToValues: values

! !

!PltRedefinedAttributeValue methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltRedefinedAttributeValue methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self redefinedAttributeValueCopyTo: another

! !

!PltRedefinedAttributeValue methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self redefinedAttributeValueCopyTo: another

! !

!PltRedefinedAttributeValue methodsFor: 'platypus-generated-copying' stamp: ''!
redefinedAttributeValueCopyTo: another
	

! !

!PltRedefinedAttributeValue methodsFor: 'platypus-generated-group-accessing' stamp: ''!
redefinedAttributeValueFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltRedefinedAttributeValue methodsFor: 'platypus-generated-group-accessing' stamp: ''!
redefinedAttributeValueToValues: values
	^ values

! !

!PltRedefinedAttributeValue methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltRedefinedAttributeValue methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self redefinedAttributeValueToValues: (super toValues: values)

! !

PltUnaryExpression subclass: #PltQualifiedExpression
	instanceVariableNames: 'qualifiers head'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltQualifiedExpression commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY qualified_expression 
	SUBTYPE OF ( unary_expression );
	head : expression;
	qualifiers : LIST OF qualifier;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltQualifiedExpression class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltQualifiedExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltQualifiedExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltQualifiedExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltQualifiedExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltQualifiedExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltQualifiedExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltQualifiedExpression methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptQualifiedExpression: self

! !

!PltQualifiedExpression methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetHead: aPltExpression
	head := aPltExpression

! !

!PltQualifiedExpression methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetQualifiers: aListOfPltQualifier
	qualifiers := aListOfPltQualifier

! !

!PltQualifiedExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self qualifiedExpressionFromValues: (super fromValues: values)

! !

!PltQualifiedExpression methodsFor: 'platypus-generated-accessing' stamp: ''!
head
	^ head

! !

!PltQualifiedExpression methodsFor: 'platypus-generated-accessing' stamp: ''!
head: aPltExpression
	head := aPltExpression

! !

!PltQualifiedExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
head: aPltExpression qualifiers: aListOfPltQualifier 	self setHead:aPltExpression.	self setQualifiers:aListOfPltQualifier.

! !

!PltQualifiedExpression methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
headUsingContext: aContext
	^ self head

! !

!PltQualifiedExpression methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltQualifiedExpression
	^ true

! !

!PltQualifiedExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self qualifiedExpressionFromValues: values

! !

!PltQualifiedExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self qualifiedExpressionToValues: values

! !

!PltQualifiedExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltQualifiedExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self qualifiedExpressionCopyTo: another

! !

!PltQualifiedExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self qualifiedExpressionCopyTo: another

! !

!PltQualifiedExpression methodsFor: 'platypus-generated-copying' stamp: ''!
qualifiedExpressionCopyTo: another
	another fastSetHead: self head.
	another fastSetQualifiers: self qualifiers

! !

!PltQualifiedExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
qualifiedExpressionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setHead: valuesloc removeFirst.
	self setQualifiers: valuesloc removeFirst.
	^ valuesloc

! !

!PltQualifiedExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
qualifiedExpressionToValues: values
	values add: self head.
	values add: self qualifiers.
	^ values

! !

!PltQualifiedExpression methodsFor: 'platypus-generated-accessing' stamp: ''!
qualifiers
	^ qualifiers

! !

!PltQualifiedExpression methodsFor: 'platypus-generated-accessing' stamp: ''!
qualifiers: aListOfPltQualifier
	qualifiers := aListOfPltQualifier
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfPltQualifier as: OrderedCollection ]

! !

!PltQualifiedExpression methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
qualifiersUsingContext: aContext
	^ self qualifiers

! !

!PltQualifiedExpression methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setHead: aPltExpression
	self head: aPltExpression

! !

!PltQualifiedExpression methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setQualifiers: aListOfPltQualifier
	self qualifiers: aListOfPltQualifier

! !

!PltQualifiedExpression methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	head := nil.
	qualifiers := OrderedCollection new

! !

!PltQualifiedExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self qualifiedExpressionToValues: (super toValues: values)

! !

PltUnaryExpression subclass: #PltQualifier
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltQualifier commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY qualifier 
	ABSTRACT SUPERTYPE 
	SUBTYPE OF ( unary_expression );
END_ENTITY;
</ISO10303-11-EXPRESS>!

PltQualifier subclass: #PltAttributeQualifier
	instanceVariableNames: 'attributeName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltAttributeQualifier commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY attribute_qualifier 
	SUBTYPE OF ( qualifier );
	attribute_name : STRING;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltAttributeQualifier class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltAttributeQualifier class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltAttributeQualifier class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltAttributeQualifier class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltAttributeQualifier class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltAttributeQualifier class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltAttributeQualifier class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltAttributeQualifier methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptAttributeQualifier: self

! !

!PltAttributeQualifier methodsFor: 'platypus-generated-accessing' stamp: ''!
attributeName
	^ attributeName

! !

!PltAttributeQualifier methodsFor: 'platypus-generated-accessing' stamp: ''!
attributeName: aString
	attributeName := aString

! !

!PltAttributeQualifier methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
attributeNameUsingContext: aContext
	^ self attributeName

! !

!PltAttributeQualifier methodsFor: 'platypus-generated-copying' stamp: ''!
attributeQualifierCopyTo: another
	another fastSetAttributeName: self attributeName

! !

!PltAttributeQualifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
attributeQualifierFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setAttributeName: valuesloc removeFirst.
	^ valuesloc

! !

!PltAttributeQualifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
attributeQualifierToValues: values
	values add: self attributeName.
	^ values

! !

!PltAttributeQualifier methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetAttributeName: aString
	attributeName := aString

! !

!PltAttributeQualifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self attributeQualifierFromValues: (super fromValues: values)

! !

!PltAttributeQualifier methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltAttributeQualifier
	^ true

! !

!PltAttributeQualifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self attributeQualifierFromValues: values

! !

!PltAttributeQualifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self attributeQualifierToValues: values

! !

!PltAttributeQualifier methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltAttributeQualifier methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self attributeQualifierCopyTo: another

! !

!PltAttributeQualifier methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self attributeQualifierCopyTo: another

! !

!PltAttributeQualifier methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setAttributeName: aString
	self attributeName: aString

! !

!PltAttributeQualifier methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	attributeName := ''

! !

!PltAttributeQualifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self attributeQualifierToValues: (super toValues: values)

! !

PltQualifier subclass: #PltEnumerationValue
	instanceVariableNames: 'domain element'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltEnumerationValue commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY enumeration_value 
	SUBTYPE OF ( qualifier );
	domain : defined_type_reference;
	element : STRING;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltEnumerationValue class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltEnumerationValue class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltEnumerationValue class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltEnumerationValue class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltEnumerationValue class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltEnumerationValue class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltEnumerationValue class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltEnumerationValue methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptEnumerationValue: self

! !

!PltEnumerationValue methodsFor: 'platypus-generated-accessing' stamp: ''!
domain
	^ domain

! !

!PltEnumerationValue methodsFor: 'platypus-generated-accessing' stamp: ''!
domain: aPltDefinedTypeReference
	domain := aPltDefinedTypeReference

! !

!PltEnumerationValue methodsFor: 'platypus-generated-group-accessing' stamp: ''!
domain: aPltDefinedTypeReference element: aString 	self setDomain:aPltDefinedTypeReference.	self setElement:aString.

! !

!PltEnumerationValue methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
domainUsingContext: aContext
	^ self domain

! !

!PltEnumerationValue methodsFor: 'platypus-generated-accessing' stamp: ''!
element
	^ element

! !

!PltEnumerationValue methodsFor: 'platypus-generated-accessing' stamp: ''!
element: aString
	element := aString

! !

!PltEnumerationValue methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
elementUsingContext: aContext
	^ self element

! !

!PltEnumerationValue methodsFor: 'platypus-generated-copying' stamp: ''!
enumerationValueCopyTo: another
	another fastSetDomain: self domain.
	another fastSetElement: self element

! !

!PltEnumerationValue methodsFor: 'platypus-generated-group-accessing' stamp: ''!
enumerationValueFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setDomain: valuesloc removeFirst.
	self setElement: valuesloc removeFirst.
	^ valuesloc

! !

!PltEnumerationValue methodsFor: 'platypus-generated-group-accessing' stamp: ''!
enumerationValueToValues: values
	values add: self domain.
	values add: self element.
	^ values

! !

!PltEnumerationValue methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetDomain: aPltDefinedTypeReference
	domain := aPltDefinedTypeReference

! !

!PltEnumerationValue methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetElement: aString
	element := aString

! !

!PltEnumerationValue methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self enumerationValueFromValues: (super fromValues: values)

! !

!PltEnumerationValue methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltEnumerationValue
	^ true

! !

!PltEnumerationValue methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self enumerationValueFromValues: values

! !

!PltEnumerationValue methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self enumerationValueToValues: values

! !

!PltEnumerationValue methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltEnumerationValue methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self enumerationValueCopyTo: another

! !

!PltEnumerationValue methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self enumerationValueCopyTo: another

! !

!PltEnumerationValue methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setDomain: aPltDefinedTypeReference
	self domain: aPltDefinedTypeReference

! !

!PltEnumerationValue methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setElement: aString
	self element: aString

! !

!PltEnumerationValue methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	domain := nil.
	element := ''

! !

!PltEnumerationValue methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self enumerationValueToValues: (super toValues: values)

! !

PltQualifier subclass: #PltGroupQualifier
	instanceVariableNames: 'groupName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltGroupQualifier commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY group_qualifier 
	SUBTYPE OF ( qualifier );
	group_name : STRING;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltGroupQualifier class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltGroupQualifier class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltGroupQualifier class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltGroupQualifier class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltGroupQualifier class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltGroupQualifier class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltGroupQualifier class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltGroupQualifier methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptGroupQualifier: self

! !

!PltGroupQualifier methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetGroupName: aString
	groupName := aString

! !

!PltGroupQualifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self groupQualifierFromValues: (super fromValues: values)

! !

!PltGroupQualifier methodsFor: 'platypus-generated-accessing' stamp: ''!
groupName
	^ groupName

! !

!PltGroupQualifier methodsFor: 'platypus-generated-accessing' stamp: ''!
groupName: aString
	groupName := aString

! !

!PltGroupQualifier methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
groupNameUsingContext: aContext
	^ self groupName

! !

!PltGroupQualifier methodsFor: 'platypus-generated-copying' stamp: ''!
groupQualifierCopyTo: another
	another fastSetGroupName: self groupName

! !

!PltGroupQualifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
groupQualifierFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setGroupName: valuesloc removeFirst.
	^ valuesloc

! !

!PltGroupQualifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
groupQualifierToValues: values
	values add: self groupName.
	^ values

! !

!PltGroupQualifier methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltGroupQualifier
	^ true

! !

!PltGroupQualifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self groupQualifierFromValues: values

! !

!PltGroupQualifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self groupQualifierToValues: values

! !

!PltGroupQualifier methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltGroupQualifier methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self groupQualifierCopyTo: another

! !

!PltGroupQualifier methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self groupQualifierCopyTo: another

! !

!PltGroupQualifier methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setGroupName: aString
	self groupName: aString

! !

!PltGroupQualifier methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	groupName := ''

! !

!PltGroupQualifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self groupQualifierToValues: (super toValues: values)

! !

PltQualifier subclass: #PltIndexQualifier
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltIndexQualifier commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY index_qualifier 
	SUBTYPE OF ( qualifier );
END_ENTITY;
</ISO10303-11-EXPRESS>!

PltIndexQualifier subclass: #PltElementQualifier
	instanceVariableNames: 'index'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltElementQualifier commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY element_qualifier 
	SUBTYPE OF ( index_qualifier );
	index : expression;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltElementQualifier class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltElementQualifier class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltElementQualifier class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltElementQualifier class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltElementQualifier class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltElementQualifier class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltElementQualifier class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltElementQualifier methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptElementQualifier: self

! !

!PltElementQualifier methodsFor: 'platypus-generated-copying' stamp: ''!
elementQualifierCopyTo: another
	another fastSetIndex: self index

! !

!PltElementQualifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
elementQualifierFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setIndex: valuesloc removeFirst.
	^ valuesloc

! !

!PltElementQualifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
elementQualifierToValues: values
	values add: self index.
	^ values

! !

!PltElementQualifier methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetIndex: aPltExpression
	index := aPltExpression

! !

!PltElementQualifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self elementQualifierFromValues: (super fromValues: values)

! !

!PltElementQualifier methodsFor: 'platypus-generated-accessing' stamp: ''!
index
	^ index

! !

!PltElementQualifier methodsFor: 'platypus-generated-accessing' stamp: ''!
index: aPltExpression
	index := aPltExpression

! !

!PltElementQualifier methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
indexUsingContext: aContext
	^ self index

! !

!PltElementQualifier methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltElementQualifier
	^ true

! !

!PltElementQualifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self elementQualifierFromValues: values

! !

!PltElementQualifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self elementQualifierToValues: values

! !

!PltElementQualifier methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltElementQualifier methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self elementQualifierCopyTo: another

! !

!PltElementQualifier methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self elementQualifierCopyTo: another

! !

!PltElementQualifier methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setIndex: aPltExpression
	self index: aPltExpression

! !

!PltElementQualifier methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	index := nil

! !

!PltElementQualifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self elementQualifierToValues: (super toValues: values)

! !

!PltIndexQualifier class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltIndexQualifier class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltIndexQualifier class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltIndexQualifier class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltIndexQualifier class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltIndexQualifier class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltIndexQualifier class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltIndexQualifier methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptIndexQualifier: self

! !

!PltIndexQualifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self indexQualifierFromValues: (super fromValues: values)

! !

!PltIndexQualifier methodsFor: 'platypus-generated-copying' stamp: ''!
indexQualifierCopyTo: another
	

! !

!PltIndexQualifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
indexQualifierFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltIndexQualifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
indexQualifierToValues: values
	^ values

! !

!PltIndexQualifier methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltIndexQualifier
	^ true

! !

!PltIndexQualifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self indexQualifierFromValues: values

! !

!PltIndexQualifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self indexQualifierToValues: values

! !

!PltIndexQualifier methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltIndexQualifier methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self indexQualifierCopyTo: another

! !

!PltIndexQualifier methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self indexQualifierCopyTo: another

! !

!PltIndexQualifier methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltIndexQualifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self indexQualifierToValues: (super toValues: values)

! !

PltIndexQualifier subclass: #PltRangeQualifier
	instanceVariableNames: 'index1 index2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltRangeQualifier commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY range_qualifier 
	SUBTYPE OF ( index_qualifier );
	index1 : expression;
	index2 : expression;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltRangeQualifier class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltRangeQualifier class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltRangeQualifier class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltRangeQualifier class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltRangeQualifier class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltRangeQualifier class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltRangeQualifier class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltRangeQualifier methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptRangeQualifier: self

! !

!PltRangeQualifier methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetIndex1: aPltExpression
	index1 := aPltExpression

! !

!PltRangeQualifier methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetIndex2: aPltExpression
	index2 := aPltExpression

! !

!PltRangeQualifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self rangeQualifierFromValues: (super fromValues: values)

! !

!PltRangeQualifier methodsFor: 'platypus-generated-accessing' stamp: ''!
index1
	^ index1

! !

!PltRangeQualifier methodsFor: 'platypus-generated-accessing' stamp: ''!
index1: aPltExpression
	index1 := aPltExpression

! !

!PltRangeQualifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
index1: aPltExpression index2: aPltExpression1 	self setIndex1:aPltExpression.	self setIndex2:aPltExpression1.

! !

!PltRangeQualifier methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
index1UsingContext: aContext
	^ self index1

! !

!PltRangeQualifier methodsFor: 'platypus-generated-accessing' stamp: ''!
index2
	^ index2

! !

!PltRangeQualifier methodsFor: 'platypus-generated-accessing' stamp: ''!
index2: aPltExpression
	index2 := aPltExpression

! !

!PltRangeQualifier methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
index2UsingContext: aContext
	^ self index2

! !

!PltRangeQualifier methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltRangeQualifier
	^ true

! !

!PltRangeQualifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self rangeQualifierFromValues: values

! !

!PltRangeQualifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self rangeQualifierToValues: values

! !

!PltRangeQualifier methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltRangeQualifier methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self rangeQualifierCopyTo: another

! !

!PltRangeQualifier methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self rangeQualifierCopyTo: another

! !

!PltRangeQualifier methodsFor: 'platypus-generated-copying' stamp: ''!
rangeQualifierCopyTo: another
	another fastSetIndex1: self index1.
	another fastSetIndex2: self index2

! !

!PltRangeQualifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
rangeQualifierFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setIndex1: valuesloc removeFirst.
	self setIndex2: valuesloc removeFirst.
	^ valuesloc

! !

!PltRangeQualifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
rangeQualifierToValues: values
	values add: self index1.
	values add: self index2.
	^ values

! !

!PltRangeQualifier methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setIndex1: aPltExpression
	self index1: aPltExpression

! !

!PltRangeQualifier methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setIndex2: aPltExpression
	self index2: aPltExpression

! !

!PltRangeQualifier methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	index1 := nil.
	index2 := nil

! !

!PltRangeQualifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self rangeQualifierToValues: (super toValues: values)

! !

!PltQualifier class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltQualifier class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltQualifier class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltQualifier class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltQualifier class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltQualifier class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltQualifier class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltQualifier methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptQualifier: self

! !

!PltQualifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self qualifierFromValues: (super fromValues: values)

! !

!PltQualifier methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltQualifier
	^ true

! !

!PltQualifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self qualifierFromValues: values

! !

!PltQualifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self qualifierToValues: values

! !

!PltQualifier methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltQualifier methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self qualifierCopyTo: another

! !

!PltQualifier methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self qualifierCopyTo: another

! !

!PltQualifier methodsFor: 'platypus-generated-copying' stamp: ''!
qualifierCopyTo: another
	

! !

!PltQualifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
qualifierFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltQualifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
qualifierToValues: values
	^ values

! !

!PltQualifier methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltQualifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self qualifierToValues: (super toValues: values)

! !

PltUnaryExpression subclass: #PltSelfIdentifier
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltSelfIdentifier commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY self_identifier 
	SUBTYPE OF ( unary_expression );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltSelfIdentifier class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltSelfIdentifier class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltSelfIdentifier class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltSelfIdentifier class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltSelfIdentifier class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltSelfIdentifier class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltSelfIdentifier class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltSelfIdentifier methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptSelfIdentifier: self

! !

!PltSelfIdentifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self selfIdentifierFromValues: (super fromValues: values)

! !

!PltSelfIdentifier methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltSelfIdentifier
	^ true

! !

!PltSelfIdentifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self selfIdentifierFromValues: values

! !

!PltSelfIdentifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self selfIdentifierToValues: values

! !

!PltSelfIdentifier methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltSelfIdentifier methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self selfIdentifierCopyTo: another

! !

!PltSelfIdentifier methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self selfIdentifierCopyTo: another

! !

!PltSelfIdentifier methodsFor: 'platypus-generated-copying' stamp: ''!
selfIdentifierCopyTo: another
	

! !

!PltSelfIdentifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
selfIdentifierFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltSelfIdentifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
selfIdentifierToValues: values
	^ values

! !

!PltSelfIdentifier methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltSelfIdentifier methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self selfIdentifierToValues: (super toValues: values)

! !

PltUnaryExpression subclass: #PltSimpleUnaryExpression
	instanceVariableNames: 'expr'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltSimpleUnaryExpression commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY simple_unary_expression 
	ABSTRACT SUPERTYPE 
	SUBTYPE OF ( unary_expression );
	expr : expression;
END_ENTITY;
</ISO10303-11-EXPRESS>!

PltSimpleUnaryExpression subclass: #PltNegativeExpression
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltNegativeExpression commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY negative_expression 
	SUBTYPE OF ( simple_unary_expression );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltNegativeExpression class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltNegativeExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltNegativeExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltNegativeExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltNegativeExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltNegativeExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltNegativeExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltNegativeExpression methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptNegativeExpression: self

! !

!PltNegativeExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self negativeExpressionFromValues: (super fromValues: values)

! !

!PltNegativeExpression methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltNegativeExpression
	^ true

! !

!PltNegativeExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self negativeExpressionFromValues: values

! !

!PltNegativeExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self negativeExpressionToValues: values

! !

!PltNegativeExpression methodsFor: 'platypus-generated-copying' stamp: ''!
negativeExpressionCopyTo: another
	

! !

!PltNegativeExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
negativeExpressionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltNegativeExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
negativeExpressionToValues: values
	^ values

! !

!PltNegativeExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltNegativeExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self negativeExpressionCopyTo: another

! !

!PltNegativeExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self negativeExpressionCopyTo: another

! !

!PltNegativeExpression methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltNegativeExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self negativeExpressionToValues: (super toValues: values)

! !

PltSimpleUnaryExpression subclass: #PltNotExpression
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltNotExpression commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY not_expression 
	SUBTYPE OF ( simple_unary_expression );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltNotExpression class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltNotExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltNotExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltNotExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltNotExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltNotExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltNotExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltNotExpression methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptNotExpression: self

! !

!PltNotExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self notExpressionFromValues: (super fromValues: values)

! !

!PltNotExpression methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltNotExpression
	^ true

! !

!PltNotExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self notExpressionFromValues: values

! !

!PltNotExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self notExpressionToValues: values

! !

!PltNotExpression methodsFor: 'platypus-generated-copying' stamp: ''!
notExpressionCopyTo: another
	

! !

!PltNotExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
notExpressionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltNotExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
notExpressionToValues: values
	^ values

! !

!PltNotExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltNotExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self notExpressionCopyTo: another

! !

!PltNotExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self notExpressionCopyTo: another

! !

!PltNotExpression methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltNotExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self notExpressionToValues: (super toValues: values)

! !

PltSimpleUnaryExpression subclass: #PltPositiveExpression
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltPositiveExpression commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY positive_expression 
	SUBTYPE OF ( simple_unary_expression );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltPositiveExpression class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltPositiveExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltPositiveExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltPositiveExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltPositiveExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltPositiveExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltPositiveExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltPositiveExpression methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptPositiveExpression: self

! !

!PltPositiveExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self positiveExpressionFromValues: (super fromValues: values)

! !

!PltPositiveExpression methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltPositiveExpression
	^ true

! !

!PltPositiveExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self positiveExpressionFromValues: values

! !

!PltPositiveExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self positiveExpressionToValues: values

! !

!PltPositiveExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltPositiveExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self positiveExpressionCopyTo: another

! !

!PltPositiveExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self positiveExpressionCopyTo: another

! !

!PltPositiveExpression methodsFor: 'platypus-generated-copying' stamp: ''!
positiveExpressionCopyTo: another
	

! !

!PltPositiveExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
positiveExpressionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltPositiveExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
positiveExpressionToValues: values
	^ values

! !

!PltPositiveExpression methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltPositiveExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self positiveExpressionToValues: (super toValues: values)

! !

!PltSimpleUnaryExpression class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltSimpleUnaryExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltSimpleUnaryExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltSimpleUnaryExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltSimpleUnaryExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltSimpleUnaryExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltSimpleUnaryExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltSimpleUnaryExpression methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptSimpleUnaryExpression: self

! !

!PltSimpleUnaryExpression methodsFor: 'platypus-generated-accessing' stamp: ''!
expr
	^ expr

! !

!PltSimpleUnaryExpression methodsFor: 'platypus-generated-accessing' stamp: ''!
expr: aPltExpression
	expr := aPltExpression

! !

!PltSimpleUnaryExpression methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
exprUsingContext: aContext
	^ self expr

! !

!PltSimpleUnaryExpression methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetExpr: aPltExpression
	expr := aPltExpression

! !

!PltSimpleUnaryExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self simpleUnaryExpressionFromValues: (super fromValues: values)

! !

!PltSimpleUnaryExpression methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltSimpleUnaryExpression
	^ true

! !

!PltSimpleUnaryExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self simpleUnaryExpressionFromValues: values

! !

!PltSimpleUnaryExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self simpleUnaryExpressionToValues: values

! !

!PltSimpleUnaryExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltSimpleUnaryExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self simpleUnaryExpressionCopyTo: another

! !

!PltSimpleUnaryExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self simpleUnaryExpressionCopyTo: another

! !

!PltSimpleUnaryExpression methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setExpr: aPltExpression
	self expr: aPltExpression

! !

!PltSimpleUnaryExpression methodsFor: 'platypus-generated-copying' stamp: ''!
simpleUnaryExpressionCopyTo: another
	another fastSetExpr: self expr

! !

!PltSimpleUnaryExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
simpleUnaryExpressionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setExpr: valuesloc removeFirst.
	^ valuesloc

! !

!PltSimpleUnaryExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
simpleUnaryExpressionToValues: values
	values add: self expr.
	^ values

! !

!PltSimpleUnaryExpression methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	expr := nil

! !

!PltSimpleUnaryExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self simpleUnaryExpressionToValues: (super toValues: values)

! !

PltSimpleUnaryExpression subclass: #PltTypedExpression
	instanceVariableNames: 'domain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltTypedExpression commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY typed_expression 
	SUBTYPE OF ( simple_unary_expression );
	domain : named_type_reference;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltTypedExpression class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltTypedExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltTypedExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltTypedExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltTypedExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltTypedExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltTypedExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltTypedExpression methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptTypedExpression: self

! !

!PltTypedExpression methodsFor: 'platypus-generated-accessing' stamp: ''!
domain
	^ domain

! !

!PltTypedExpression methodsFor: 'platypus-generated-accessing' stamp: ''!
domain: aPltNamedTypeReference
	domain := aPltNamedTypeReference

! !

!PltTypedExpression methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
domainUsingContext: aContext
	^ self domain

! !

!PltTypedExpression methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetDomain: aPltNamedTypeReference
	domain := aPltNamedTypeReference

! !

!PltTypedExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self typedExpressionFromValues: (super fromValues: values)

! !

!PltTypedExpression methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltTypedExpression
	^ true

! !

!PltTypedExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self typedExpressionFromValues: values

! !

!PltTypedExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self typedExpressionToValues: values

! !

!PltTypedExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltTypedExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self typedExpressionCopyTo: another

! !

!PltTypedExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self typedExpressionCopyTo: another

! !

!PltTypedExpression methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setDomain: aPltNamedTypeReference
	self domain: aPltNamedTypeReference

! !

!PltTypedExpression methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	domain := nil

! !

!PltTypedExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self typedExpressionToValues: (super toValues: values)

! !

!PltTypedExpression methodsFor: 'platypus-generated-copying' stamp: ''!
typedExpressionCopyTo: another
	another fastSetDomain: self domain

! !

!PltTypedExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
typedExpressionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setDomain: valuesloc removeFirst.
	^ valuesloc

! !

!PltTypedExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
typedExpressionToValues: values
	values add: self domain.
	^ values

! !

!PltUnaryExpression class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltUnaryExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltUnaryExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltUnaryExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltUnaryExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltUnaryExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltUnaryExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltUnaryExpression methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptUnaryExpression: self

! !

!PltUnaryExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self unaryExpressionFromValues: (super fromValues: values)

! !

!PltUnaryExpression methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltUnaryExpression
	^ true

! !

!PltUnaryExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self unaryExpressionFromValues: values

! !

!PltUnaryExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self unaryExpressionToValues: values

! !

!PltUnaryExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltUnaryExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self unaryExpressionCopyTo: another

! !

!PltUnaryExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self unaryExpressionCopyTo: another

! !

!PltUnaryExpression methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltUnaryExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self unaryExpressionToValues: (super toValues: values)

! !

!PltUnaryExpression methodsFor: 'platypus-generated-copying' stamp: ''!
unaryExpressionCopyTo: another
	

! !

!PltUnaryExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
unaryExpressionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltUnaryExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
unaryExpressionToValues: values
	^ values

! !

PltDictionaryInstance subclass: #PltExternalSchema
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltExternalSchema commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY external_schema 
	SUBTYPE OF ( dictionary_instance );
	name : schema_name;
	SELF\entity_instance.owner : schema_definition;
END_ENTITY;
</ISO10303-11-EXPRESS>!

PltExternalSchema subclass: #PltExternalMetaSchema
	instanceVariableNames: 'nativeSchema'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltExternalMetaSchema commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY external_meta_schema 
	SUBTYPE OF ( external_schema );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltExternalMetaSchema class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltExternalMetaSchema class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltExternalMetaSchema class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltExternalMetaSchema class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltExternalMetaSchema class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltExternalMetaSchema class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltExternalMetaSchema class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltExternalMetaSchema methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptExternalMetaSchema: self

! !

!PltExternalMetaSchema methodsFor: 'platypus-generated-copying' stamp: ''!
externalMetaSchemaCopyTo: another
	

! !

!PltExternalMetaSchema methodsFor: 'platypus-generated-group-accessing' stamp: ''!
externalMetaSchemaFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltExternalMetaSchema methodsFor: 'platypus-generated-group-accessing' stamp: ''!
externalMetaSchemaToValues: values
	^ values

! !

!PltExternalMetaSchema methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self externalMetaSchemaFromValues: (super fromValues: values)

! !

!PltExternalMetaSchema methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltExternalMetaSchema
	^ true

! !

!PltExternalMetaSchema methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self externalMetaSchemaFromValues: values

! !

!PltExternalMetaSchema methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self externalMetaSchemaToValues: values

! !

!PltExternalMetaSchema methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltExternalMetaSchema methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self externalMetaSchemaCopyTo: another

! !

!PltExternalMetaSchema methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self externalMetaSchemaCopyTo: another

! !

!PltExternalMetaSchema methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltExternalMetaSchema methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self externalMetaSchemaToValues: (super toValues: values)

! !

!PltExternalSchema class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltExternalSchema class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltExternalSchema class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltExternalSchema class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltExternalSchema class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltExternalSchema class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltExternalSchema class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltExternalSchema methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptExternalSchema: self

! !

!PltExternalSchema methodsFor: 'platypus-generated-copying' stamp: ''!
externalSchemaCopyTo: another
	another fastSetName: self name.
	another fastSetOwner: self owner

! !

!PltExternalSchema methodsFor: 'platypus-generated-group-accessing' stamp: ''!
externalSchemaFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setName: valuesloc removeFirst.
	self setOwner: valuesloc removeFirst.
	^ valuesloc

! !

!PltExternalSchema methodsFor: 'platypus-generated-group-accessing' stamp: ''!
externalSchemaToValues: values
	values add: self name.
	values add: self owner.
	^ values

! !

!PltExternalSchema methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetName: aString
	name := aString

! !

!PltExternalSchema methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetOwner: aPltSchemaDefinition
	owner := aPltSchemaDefinition

! !

!PltExternalSchema methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self externalSchemaFromValues: (super fromValues: values)

! !

!PltExternalSchema methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltExternalSchema
	^ true

! !

!PltExternalSchema methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self externalSchemaFromValues: values

! !

!PltExternalSchema methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self externalSchemaToValues: values

! !

!PltExternalSchema methodsFor: 'platypus-generated-accessing' stamp: ''!
name
	^ name

! !

!PltExternalSchema methodsFor: 'platypus-generated-accessing' stamp: ''!
name: aString
	name := aString

! !

!PltExternalSchema methodsFor: 'platypus-generated-group-accessing' stamp: ''!
name: aString owner: aPltSchemaDefinition 	self setName:aString.	self setOwner:aPltSchemaDefinition.

! !

!PltExternalSchema methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
nameUsingContext: aContext
	^ self name

! !

!PltExternalSchema methodsFor: 'platypus-generated-accessing' stamp: ''!
owner
	^ owner

! !

!PltExternalSchema methodsFor: 'platypus-generated-accessing' stamp: ''!
owner: aPltSchemaDefinition
	owner := aPltSchemaDefinition

! !

!PltExternalSchema methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
ownerUsingContext: aContext
	^ self owner

! !

!PltExternalSchema methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltExternalSchema methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self externalSchemaCopyTo: another

! !

!PltExternalSchema methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self externalSchemaCopyTo: another

! !

!PltExternalSchema methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setName: aString
	self name: aString

! !

!PltExternalSchema methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setOwner: aPltSchemaDefinition
	self owner: aPltSchemaDefinition

! !

!PltExternalSchema methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	name := ''.
	owner := nil

! !

!PltExternalSchema methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self externalSchemaToValues: (super toValues: values)

! !

PltExternalSchema subclass: #PltIncludeSchema
	instanceVariableNames: 'nativeSchema explicitlyImportedItems implicitlyImportedItems'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltIncludeSchema commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY include_schema 
	SUBTYPE OF ( external_schema );
	native_schema : schema_definition;
	explicitly_imported_items : LIST OF domain_equivalent_item;
	implicitly_imported_items : LIST OF domain_equivalent_item;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltIncludeSchema class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltIncludeSchema class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltIncludeSchema class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltIncludeSchema class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltIncludeSchema class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltIncludeSchema class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltIncludeSchema class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltIncludeSchema methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptIncludeSchema: self

! !

!PltIncludeSchema methodsFor: 'platypus-generated-accessing' stamp: ''!
explicitlyImportedItems
	^ explicitlyImportedItems

! !

!PltIncludeSchema methodsFor: 'platypus-generated-accessing' stamp: ''!
explicitlyImportedItems: aListOfPltDomainEquivalentItem
	explicitlyImportedItems := aListOfPltDomainEquivalentItem
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfPltDomainEquivalentItem as: OrderedCollection ]

! !

!PltIncludeSchema methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
explicitlyImportedItemsUsingContext: aContext
	^ self explicitlyImportedItems

! !

!PltIncludeSchema methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetExplicitlyImportedItems: aListOfPltDomainEquivalentItem
	explicitlyImportedItems := aListOfPltDomainEquivalentItem

! !

!PltIncludeSchema methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetImplicitlyImportedItems: aListOfPltDomainEquivalentItem
	implicitlyImportedItems := aListOfPltDomainEquivalentItem

! !

!PltIncludeSchema methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetNativeSchema: aPltSchemaDefinition
	nativeSchema := aPltSchemaDefinition

! !

!PltIncludeSchema methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self includeSchemaFromValues: (super fromValues: values)

! !

!PltIncludeSchema methodsFor: 'platypus-generated-accessing' stamp: ''!
implicitlyImportedItems
	^ implicitlyImportedItems

! !

!PltIncludeSchema methodsFor: 'platypus-generated-accessing' stamp: ''!
implicitlyImportedItems: aListOfPltDomainEquivalentItem
	implicitlyImportedItems := aListOfPltDomainEquivalentItem
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfPltDomainEquivalentItem as: OrderedCollection ]

! !

!PltIncludeSchema methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
implicitlyImportedItemsUsingContext: aContext
	^ self implicitlyImportedItems

! !

!PltIncludeSchema methodsFor: 'platypus-generated-copying' stamp: ''!
includeSchemaCopyTo: another
	another fastSetNativeSchema: self nativeSchema.
	another fastSetExplicitlyImportedItems: self explicitlyImportedItems.
	another fastSetImplicitlyImportedItems: self implicitlyImportedItems

! !

!PltIncludeSchema methodsFor: 'platypus-generated-group-accessing' stamp: ''!
includeSchemaFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setNativeSchema: valuesloc removeFirst.
	self setExplicitlyImportedItems: valuesloc removeFirst.
	self setImplicitlyImportedItems: valuesloc removeFirst.
	^ valuesloc

! !

!PltIncludeSchema methodsFor: 'platypus-generated-group-accessing' stamp: ''!
includeSchemaToValues: values
	values add: self nativeSchema.
	values add: self explicitlyImportedItems.
	values add: self implicitlyImportedItems.
	^ values

! !

!PltIncludeSchema methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltIncludeSchema
	^ true

! !

!PltIncludeSchema methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self includeSchemaFromValues: values

! !

!PltIncludeSchema methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self includeSchemaToValues: values

! !

!PltIncludeSchema methodsFor: 'platypus-generated-accessing' stamp: ''!
nativeSchema
	^ nativeSchema

! !

!PltIncludeSchema methodsFor: 'platypus-generated-accessing' stamp: ''!
nativeSchema: aPltSchemaDefinition
	nativeSchema := aPltSchemaDefinition

! !

!PltIncludeSchema methodsFor: 'platypus-generated-group-accessing' stamp: ''!
nativeSchema: aPltSchemaDefinition explicitlyImportedItems: aListOfPltDomainEquivalentItem implicitlyImportedItems: aListOfPltDomainEquivalentItem1 	self setNativeSchema:aPltSchemaDefinition.	self setExplicitlyImportedItems:aListOfPltDomainEquivalentItem.	self setImplicitlyImportedItems:aListOfPltDomainEquivalentItem1.

! !

!PltIncludeSchema methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
nativeSchemaUsingContext: aContext
	^ self nativeSchema

! !

!PltIncludeSchema methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltIncludeSchema methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self includeSchemaCopyTo: another

! !

!PltIncludeSchema methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self includeSchemaCopyTo: another

! !

!PltIncludeSchema methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setExplicitlyImportedItems: aListOfPltDomainEquivalentItem
	self explicitlyImportedItems: aListOfPltDomainEquivalentItem

! !

!PltIncludeSchema methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setImplicitlyImportedItems: aListOfPltDomainEquivalentItem
	self implicitlyImportedItems: aListOfPltDomainEquivalentItem

! !

!PltIncludeSchema methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setNativeSchema: aPltSchemaDefinition
	self nativeSchema: aPltSchemaDefinition

! !

!PltIncludeSchema methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	nativeSchema := nil.
	explicitlyImportedItems := OrderedCollection new.
	implicitlyImportedItems := OrderedCollection new

! !

!PltIncludeSchema methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self includeSchemaToValues: (super toValues: values)

! !

PltIncludeSchema subclass: #PltReferencedSchema
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltReferencedSchema commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY referenced_schema 
	SUBTYPE OF ( include_schema );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltReferencedSchema class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltReferencedSchema class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltReferencedSchema class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltReferencedSchema class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltReferencedSchema class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltReferencedSchema class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltReferencedSchema class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltReferencedSchema methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptReferencedSchema: self

! !

!PltReferencedSchema methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self referencedSchemaFromValues: (super fromValues: values)

! !

!PltReferencedSchema methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltReferencedSchema
	^ true

! !

!PltReferencedSchema methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self referencedSchemaFromValues: values

! !

!PltReferencedSchema methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self referencedSchemaToValues: values

! !

!PltReferencedSchema methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltReferencedSchema methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self referencedSchemaCopyTo: another

! !

!PltReferencedSchema methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self referencedSchemaCopyTo: another

! !

!PltReferencedSchema methodsFor: 'platypus-generated-copying' stamp: ''!
referencedSchemaCopyTo: another
	

! !

!PltReferencedSchema methodsFor: 'platypus-generated-group-accessing' stamp: ''!
referencedSchemaFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltReferencedSchema methodsFor: 'platypus-generated-group-accessing' stamp: ''!
referencedSchemaToValues: values
	^ values

! !

!PltReferencedSchema methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltReferencedSchema methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self referencedSchemaToValues: (super toValues: values)

! !

PltIncludeSchema subclass: #PltUsedSchema
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltUsedSchema commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY used_schema 
	SUBTYPE OF ( include_schema );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltUsedSchema class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltUsedSchema class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltUsedSchema class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltUsedSchema class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltUsedSchema class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltUsedSchema class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltUsedSchema class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltUsedSchema methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptUsedSchema: self

! !

!PltUsedSchema methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self usedSchemaFromValues: (super fromValues: values)

! !

!PltUsedSchema methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltUsedSchema
	^ true

! !

!PltUsedSchema methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self usedSchemaFromValues: values

! !

!PltUsedSchema methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self usedSchemaToValues: values

! !

!PltUsedSchema methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltUsedSchema methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self usedSchemaCopyTo: another

! !

!PltUsedSchema methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self usedSchemaCopyTo: another

! !

!PltUsedSchema methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltUsedSchema methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self usedSchemaToValues: (super toValues: values)

! !

!PltUsedSchema methodsFor: 'platypus-generated-copying' stamp: ''!
usedSchemaCopyTo: another
	

! !

!PltUsedSchema methodsFor: 'platypus-generated-group-accessing' stamp: ''!
usedSchemaFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltUsedSchema methodsFor: 'platypus-generated-group-accessing' stamp: ''!
usedSchemaToValues: values
	^ values

! !

PltDictionaryInstance subclass: #PltGenericType
	instanceVariableNames: 'typeLabel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltGenericType commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY generic_type 
	SUBTYPE OF ( dictionary_instance );
	type_label : OPTIONAL STRING;
DERIVE
	accepted : entity_instance := SELF.accept_generic_type;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltGenericType class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltGenericType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltGenericType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltGenericType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltGenericType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltGenericType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltGenericType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltGenericType methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptGenericType: self

! !

!PltGenericType methodsFor: 'platypus-generated-deriving' stamp: ''!
accepted
	^ self acceptedUsingContext: self class context

! !

!PltGenericType methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext
	^ self acceptedUsingContext: aContext receiver: self

! !

!PltGenericType methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext receiver: aReceiver
	^ aReceiver acceptGenericTypeUsingContext: aContext

! !

!PltGenericType methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetTypeLabel: aString
	typeLabel := aString

! !

!PltGenericType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self genericTypeFromValues: (super fromValues: values)

! !

!PltGenericType methodsFor: 'platypus-generated-copying' stamp: ''!
genericTypeCopyTo: another
	another fastSetTypeLabel: self typeLabel

! !

!PltGenericType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
genericTypeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setTypeLabel: valuesloc removeFirst.
	^ valuesloc

! !

!PltGenericType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
genericTypeToValues: values
	values add: self typeLabel.
	^ values

! !

!PltGenericType methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltGenericType
	^ true

! !

!PltGenericType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self genericTypeFromValues: values

! !

!PltGenericType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self genericTypeToValues: values

! !

!PltGenericType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltGenericType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self genericTypeCopyTo: another

! !

!PltGenericType methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self genericTypeCopyTo: another

! !

!PltGenericType methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setTypeLabel: aString
	self typeLabel: aString

! !

!PltGenericType methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	typeLabel := nil

! !

!PltGenericType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self genericTypeToValues: (super toValues: values)

! !

!PltGenericType methodsFor: 'platypus-generated-accessing' stamp: ''!
typeLabel
	^ typeLabel

! !

!PltGenericType methodsFor: 'platypus-generated-accessing' stamp: ''!
typeLabel: aString
	typeLabel := aString

! !

!PltGenericType methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
typeLabelUsingContext: aContext
	^ self typeLabel

! !

PltDictionaryInstance subclass: #PltIncrementControl
	instanceVariableNames: 'identifiersCache variable first last step'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusStatementsSchemaSchema'!

!PltIncrementControl commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY increment_control 
	SUBTYPE OF ( dictionary_instance );
	variable : increment_control_variable;
	first : expression;
	last : expression;
	step : OPTIONAL expression;
	SELF\entity_instance.owner : repeat_statement;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltIncrementControl class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltIncrementControl class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltIncrementControl class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltIncrementControl class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusStatementsSchemaSchemaDefinition singleton

! !

!PltIncrementControl class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltIncrementControl class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltIncrementControl class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltIncrementControl methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptIncrementControl: self

! !

!PltIncrementControl methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetFirst: aPltExpression
	first := aPltExpression

! !

!PltIncrementControl methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetLast: aPltExpression
	last := aPltExpression

! !

!PltIncrementControl methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetOwner: aPltRepeatStatement
	owner := aPltRepeatStatement

! !

!PltIncrementControl methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetStep: aPltExpression
	step := aPltExpression

! !

!PltIncrementControl methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetVariable: aPltIncrementControlVariable
	variable := aPltIncrementControlVariable

! !

!PltIncrementControl methodsFor: 'platypus-generated-accessing' stamp: ''!
first
	^ first

! !

!PltIncrementControl methodsFor: 'platypus-generated-accessing' stamp: ''!
first: aPltExpression
	first := aPltExpression

! !

!PltIncrementControl methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
firstUsingContext: aContext
	^ self first

! !

!PltIncrementControl methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self incrementControlFromValues: (super fromValues: values)

! !

!PltIncrementControl methodsFor: 'platypus-generated-copying' stamp: ''!
incrementControlCopyTo: another
	another fastSetVariable: self variable.
	another fastSetFirst: self first.
	another fastSetLast: self last.
	another fastSetStep: self step.
	another fastSetOwner: self owner

! !

!PltIncrementControl methodsFor: 'platypus-generated-group-accessing' stamp: ''!
incrementControlFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setVariable: valuesloc removeFirst.
	self setFirst: valuesloc removeFirst.
	self setLast: valuesloc removeFirst.
	self setStep: valuesloc removeFirst.
	self setOwner: valuesloc removeFirst.
	^ valuesloc

! !

!PltIncrementControl methodsFor: 'platypus-generated-group-accessing' stamp: ''!
incrementControlToValues: values
	values add: self variable.
	values add: self first.
	values add: self last.
	values add: self step.
	values add: self owner.
	^ values

! !

!PltIncrementControl methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltIncrementControl
	^ true

! !

!PltIncrementControl methodsFor: 'platypus-generated-accessing' stamp: ''!
last
	^ last

! !

!PltIncrementControl methodsFor: 'platypus-generated-accessing' stamp: ''!
last: aPltExpression
	last := aPltExpression

! !

!PltIncrementControl methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
lastUsingContext: aContext
	^ self last

! !

!PltIncrementControl methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self incrementControlFromValues: values

! !

!PltIncrementControl methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self incrementControlToValues: values

! !

!PltIncrementControl methodsFor: 'platypus-generated-accessing' stamp: ''!
owner
	^ owner

! !

!PltIncrementControl methodsFor: 'platypus-generated-accessing' stamp: ''!
owner: aPltRepeatStatement
	owner := aPltRepeatStatement

! !

!PltIncrementControl methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
ownerUsingContext: aContext
	^ self owner

! !

!PltIncrementControl methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltIncrementControl methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self incrementControlCopyTo: another

! !

!PltIncrementControl methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self incrementControlCopyTo: another

! !

!PltIncrementControl methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setFirst: aPltExpression
	self first: aPltExpression

! !

!PltIncrementControl methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setLast: aPltExpression
	self last: aPltExpression

! !

!PltIncrementControl methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setOwner: aPltRepeatStatement
	self owner: aPltRepeatStatement

! !

!PltIncrementControl methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setStep: aPltExpression
	self step: aPltExpression

! !

!PltIncrementControl methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setVariable: aPltIncrementControlVariable
	self variable: aPltIncrementControlVariable

! !

!PltIncrementControl methodsFor: 'platypus-generated-accessing' stamp: ''!
step
	^ step

! !

!PltIncrementControl methodsFor: 'platypus-generated-accessing' stamp: ''!
step: aPltExpression
	step := aPltExpression

! !

!PltIncrementControl methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	variable := nil.
	first := nil.
	last := nil.
	step := nil.
	owner := nil

! !

!PltIncrementControl methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
stepUsingContext: aContext
	^ self step

! !

!PltIncrementControl methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self incrementControlToValues: (super toValues: values)

! !

!PltIncrementControl methodsFor: 'platypus-generated-accessing' stamp: ''!
variable
	^ variable

! !

!PltIncrementControl methodsFor: 'platypus-generated-accessing' stamp: ''!
variable: aPltIncrementControlVariable
	variable := aPltIncrementControlVariable

! !

!PltIncrementControl methodsFor: 'platypus-generated-group-accessing' stamp: ''!
variable: aPltIncrementControlVariable first: aPltExpression last: aPltExpression1 step: aPltExpression2 owner: aPltRepeatStatement 	self setVariable:aPltIncrementControlVariable.	self setFirst:aPltExpression.	self setLast:aPltExpression1.	self setStep:aPltExpression2.	self setOwner:aPltRepeatStatement.

! !

!PltIncrementControl methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
variableUsingContext: aContext
	^ self variable

! !

PltDictionaryInstance subclass: #PltIncrementControlVariable
	instanceVariableNames: 'variableId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusStatementsSchemaSchema'!

!PltIncrementControlVariable commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY increment_control_variable 
	SUBTYPE OF ( dictionary_instance );
	variable_id : STRING;
	SELF\entity_instance.owner : increment_control;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltIncrementControlVariable class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltIncrementControlVariable class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltIncrementControlVariable class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltIncrementControlVariable class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusStatementsSchemaSchemaDefinition singleton

! !

!PltIncrementControlVariable class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltIncrementControlVariable class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltIncrementControlVariable class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltIncrementControlVariable methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptIncrementControlVariable: self

! !

!PltIncrementControlVariable methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetOwner: aPltIncrementControl
	owner := aPltIncrementControl

! !

!PltIncrementControlVariable methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetVariableId: aString
	variableId := aString

! !

!PltIncrementControlVariable methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self incrementControlVariableFromValues: (super fromValues: values)

! !

!PltIncrementControlVariable methodsFor: 'platypus-generated-copying' stamp: ''!
incrementControlVariableCopyTo: another
	another fastSetVariableId: self variableId.
	another fastSetOwner: self owner

! !

!PltIncrementControlVariable methodsFor: 'platypus-generated-group-accessing' stamp: ''!
incrementControlVariableFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setVariableId: valuesloc removeFirst.
	self setOwner: valuesloc removeFirst.
	^ valuesloc

! !

!PltIncrementControlVariable methodsFor: 'platypus-generated-group-accessing' stamp: ''!
incrementControlVariableToValues: values
	values add: self variableId.
	values add: self owner.
	^ values

! !

!PltIncrementControlVariable methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltIncrementControlVariable
	^ true

! !

!PltIncrementControlVariable methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self incrementControlVariableFromValues: values

! !

!PltIncrementControlVariable methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self incrementControlVariableToValues: values

! !

!PltIncrementControlVariable methodsFor: 'platypus-generated-accessing' stamp: ''!
owner
	^ owner

! !

!PltIncrementControlVariable methodsFor: 'platypus-generated-accessing' stamp: ''!
owner: aPltIncrementControl
	owner := aPltIncrementControl

! !

!PltIncrementControlVariable methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
ownerUsingContext: aContext
	^ self owner

! !

!PltIncrementControlVariable methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltIncrementControlVariable methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self incrementControlVariableCopyTo: another

! !

!PltIncrementControlVariable methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self incrementControlVariableCopyTo: another

! !

!PltIncrementControlVariable methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setOwner: aPltIncrementControl
	self owner: aPltIncrementControl

! !

!PltIncrementControlVariable methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setVariableId: aString
	self variableId: aString

! !

!PltIncrementControlVariable methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	variableId := ''.
	owner := nil

! !

!PltIncrementControlVariable methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self incrementControlVariableToValues: (super toValues: values)

! !

!PltIncrementControlVariable methodsFor: 'platypus-generated-accessing' stamp: ''!
variableId
	^ variableId

! !

!PltIncrementControlVariable methodsFor: 'platypus-generated-accessing' stamp: ''!
variableId: aString
	variableId := aString

! !

!PltIncrementControlVariable methodsFor: 'platypus-generated-group-accessing' stamp: ''!
variableId: aString owner: aPltIncrementControl 	self setVariableId:aString.	self setOwner:aPltIncrementControl.

! !

!PltIncrementControlVariable methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
variableIdUsingContext: aContext
	^ self variableId

! !

PltDictionaryInstance subclass: #PltLocalVariable
	instanceVariableNames: 'domain name initializer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltLocalVariable commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY local_variable 
	SUBTYPE OF ( dictionary_instance );
	SELF\entity_instance.owner : statements_container;
	name : STRING;
	domain : parameter_type;
	initializer : OPTIONAL expression;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltLocalVariable class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltLocalVariable class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltLocalVariable class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltLocalVariable class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltLocalVariable class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltLocalVariable class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltLocalVariable class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltLocalVariable methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptLocalVariable: self

! !

!PltLocalVariable methodsFor: 'platypus-generated-accessing' stamp: ''!
domain
	^ domain

! !

!PltLocalVariable methodsFor: 'platypus-generated-accessing' stamp: ''!
domain: aPltParameterType
	domain := aPltParameterType

! !

!PltLocalVariable methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
domainUsingContext: aContext
	^ self domain

! !

!PltLocalVariable methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetDomain: aPltParameterType
	domain := aPltParameterType

! !

!PltLocalVariable methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetInitializer: aPltExpression
	initializer := aPltExpression

! !

!PltLocalVariable methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetName: aString
	name := aString

! !

!PltLocalVariable methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetOwner: aPltStatementsContainer
	owner := aPltStatementsContainer

! !

!PltLocalVariable methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self localVariableFromValues: (super fromValues: values)

! !

!PltLocalVariable methodsFor: 'platypus-generated-accessing' stamp: ''!
initializer
	^ initializer

! !

!PltLocalVariable methodsFor: 'platypus-generated-accessing' stamp: ''!
initializer: aPltExpression
	initializer := aPltExpression

! !

!PltLocalVariable methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
initializerUsingContext: aContext
	^ self initializer

! !

!PltLocalVariable methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltLocalVariable
	^ true

! !

!PltLocalVariable methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self localVariableFromValues: values

! !

!PltLocalVariable methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self localVariableToValues: values

! !

!PltLocalVariable methodsFor: 'platypus-generated-copying' stamp: ''!
localVariableCopyTo: another
	another fastSetOwner: self owner.
	another fastSetName: self name.
	another fastSetDomain: self domain.
	another fastSetInitializer: self initializer

! !

!PltLocalVariable methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localVariableFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setOwner: valuesloc removeFirst.
	self setName: valuesloc removeFirst.
	self setDomain: valuesloc removeFirst.
	self setInitializer: valuesloc removeFirst.
	^ valuesloc

! !

!PltLocalVariable methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localVariableToValues: values
	values add: self owner.
	values add: self name.
	values add: self domain.
	values add: self initializer.
	^ values

! !

!PltLocalVariable methodsFor: 'platypus-generated-accessing' stamp: ''!
name
	^ name

! !

!PltLocalVariable methodsFor: 'platypus-generated-accessing' stamp: ''!
name: aString
	name := aString

! !

!PltLocalVariable methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
nameUsingContext: aContext
	^ self name

! !

!PltLocalVariable methodsFor: 'platypus-generated-accessing' stamp: ''!
owner
	^ owner

! !

!PltLocalVariable methodsFor: 'platypus-generated-accessing' stamp: ''!
owner: aPltStatementsContainer
	owner := aPltStatementsContainer

! !

!PltLocalVariable methodsFor: 'platypus-generated-group-accessing' stamp: ''!
owner: aPltStatementsContainer name: aString domain: aPltParameterType initializer: aPltExpression 	self setOwner:aPltStatementsContainer.	self setName:aString.	self setDomain:aPltParameterType.	self setInitializer:aPltExpression.

! !

!PltLocalVariable methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
ownerUsingContext: aContext
	^ self owner

! !

!PltLocalVariable methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltLocalVariable methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self localVariableCopyTo: another

! !

!PltLocalVariable methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self localVariableCopyTo: another

! !

!PltLocalVariable methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setDomain: aPltParameterType
	self domain: aPltParameterType

! !

!PltLocalVariable methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setInitializer: aPltExpression
	self initializer: aPltExpression

! !

!PltLocalVariable methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setName: aString
	self name: aString

! !

!PltLocalVariable methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setOwner: aPltStatementsContainer
	self owner: aPltStatementsContainer

! !

!PltLocalVariable methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	owner := nil.
	name := ''.
	domain := nil.
	initializer := nil

! !

!PltLocalVariable methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self localVariableToValues: (super toValues: values)

! !

PltDictionaryInstance subclass: #PltMetaConceptDefinition
	instanceVariableNames: 'haveError definition expression metaExpression'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltMetaConceptDefinition commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY meta_concept_definition 
	SUBTYPE OF ( dictionary_instance );
	definition : dictionary_instance;
	expression : STRING;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltMetaConceptDefinition class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltMetaConceptDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltMetaConceptDefinition class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltMetaConceptDefinition class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltMetaConceptDefinition class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltMetaConceptDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltMetaConceptDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltMetaConceptDefinition methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptMetaConceptDefinition: self

! !

!PltMetaConceptDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
definition
	^ definition

! !

!PltMetaConceptDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
definition: aPltDictionaryInstance
	definition := aPltDictionaryInstance

! !

!PltMetaConceptDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
definition: aPltDictionaryInstance expression: aString 	self setDefinition:aPltDictionaryInstance.	self setExpression:aString.

! !

!PltMetaConceptDefinition methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
definitionUsingContext: aContext
	^ self definition

! !

!PltMetaConceptDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
expression
	^ expression

! !

!PltMetaConceptDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
expression: aString
	expression := aString

! !

!PltMetaConceptDefinition methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
expressionUsingContext: aContext
	^ self expression

! !

!PltMetaConceptDefinition methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetDefinition: aPltDictionaryInstance
	definition := aPltDictionaryInstance

! !

!PltMetaConceptDefinition methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetExpression: aString
	expression := aString

! !

!PltMetaConceptDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self metaConceptDefinitionFromValues: (super fromValues: values)

! !

!PltMetaConceptDefinition methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltMetaConceptDefinition
	^ true

! !

!PltMetaConceptDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self metaConceptDefinitionFromValues: values

! !

!PltMetaConceptDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self metaConceptDefinitionToValues: values

! !

!PltMetaConceptDefinition methodsFor: 'platypus-generated-copying' stamp: ''!
metaConceptDefinitionCopyTo: another
	another fastSetDefinition: self definition.
	another fastSetExpression: self expression

! !

!PltMetaConceptDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
metaConceptDefinitionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setDefinition: valuesloc removeFirst.
	self setExpression: valuesloc removeFirst.
	^ valuesloc

! !

!PltMetaConceptDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
metaConceptDefinitionToValues: values
	values add: self definition.
	values add: self expression.
	^ values

! !

!PltMetaConceptDefinition methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
parametersUsingContext:aContext
	^ self parameters! !

!PltMetaConceptDefinition methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltMetaConceptDefinition methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self metaConceptDefinitionCopyTo: another

! !

!PltMetaConceptDefinition methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self metaConceptDefinitionCopyTo: another

! !

!PltMetaConceptDefinition methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setDefinition: aPltDictionaryInstance
	self definition: aPltDictionaryInstance

! !

!PltMetaConceptDefinition methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setExpression: aString
	self expression: aString

! !

!PltMetaConceptDefinition methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	definition := nil.
	expression := ''

! !

!PltMetaConceptDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self metaConceptDefinitionToValues: (super toValues: values)

! !

PltDictionaryInstance subclass: #PltMetaMappingDefinition
	instanceVariableNames: 'definitionPath haveError definition expression metaExpression'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltMetaMappingDefinition commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY meta_mapping_definition 
	SUBTYPE OF ( dictionary_instance );
	definition : dictionary_instance;
	expression : STRING;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltMetaMappingDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltMetaMappingDefinition class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltMetaMappingDefinition class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltMetaMappingDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltMetaMappingDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltMetaMappingDefinition methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptMetaMappingDefinition: self

! !

!PltMetaMappingDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
definition
	^ definition

! !

!PltMetaMappingDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
definition: aPltDictionaryInstance
	definition := aPltDictionaryInstance

! !

!PltMetaMappingDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
definition: aPltDictionaryInstance expression: aString 	self setDefinition:aPltDictionaryInstance.	self setExpression:aString.

! !

!PltMetaMappingDefinition methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
definitionUsingContext: aContext
	^ self definition

! !

!PltMetaMappingDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
expression
	^ expression

! !

!PltMetaMappingDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
expression: aString
	expression := aString

! !

!PltMetaMappingDefinition methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
expressionUsingContext: aContext
	^ self expression

! !

!PltMetaMappingDefinition methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetDefinition: aPltDictionaryInstance
	definition := aPltDictionaryInstance

! !

!PltMetaMappingDefinition methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetExpression: aString
	expression := aString

! !

!PltMetaMappingDefinition methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetMetaExpression:aPltExpression	metaExpression := aPltExpression

! !

!PltMetaMappingDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self metaMappingDefinitionFromValues: (super fromValues: values)

! !

!PltMetaMappingDefinition methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltMetaMappingDefinition
	^ true

! !

!PltMetaMappingDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self metaMappingDefinitionFromValues: values

! !

!PltMetaMappingDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self metaMappingDefinitionToValues: values

! !

!PltMetaMappingDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
metaExpression	 ^metaExpression

! !

!PltMetaMappingDefinition methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
metaExpressionUsingContext:aContext	^ self metaExpression

! !

!PltMetaMappingDefinition methodsFor: 'platypus-generated-copying' stamp: ''!
metaMappingDefinitionCopyTo: another
	another fastSetDefinition: self definition.
	another fastSetExpression: self expression

! !

!PltMetaMappingDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
metaMappingDefinitionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setDefinition: valuesloc removeFirst.
	self setExpression: valuesloc removeFirst.
	^ valuesloc

! !

!PltMetaMappingDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
metaMappingDefinitionToValues: values
	values add: self definition.
	values add: self expression.
	^ values

! !

!PltMetaMappingDefinition methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltMetaMappingDefinition methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self metaMappingDefinitionCopyTo: another

! !

!PltMetaMappingDefinition methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self metaMappingDefinitionCopyTo: another

! !

!PltMetaMappingDefinition methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setDefinition: aPltDictionaryInstance
	self definition: aPltDictionaryInstance

! !

!PltMetaMappingDefinition methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setExpression: aString
	self expression: aString

! !

!PltMetaMappingDefinition methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setMetaExpression:aPltExpression	self metaExpression:aPltExpression

! !

!PltMetaMappingDefinition methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	definition := nil.
	expression := ''

! !

!PltMetaMappingDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self metaMappingDefinitionToValues: (super toValues: values)

! !

PltDictionaryInstance subclass: #PltMetaMappingRule
	instanceVariableNames: 'haveError metaCondition condition expression metaExpression'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltMetaMappingRule commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY meta_mapping_rule 
	SUBTYPE OF ( dictionary_instance );
	condition : STRING;
	expression : STRING;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltMetaMappingRule class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltMetaMappingRule class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltMetaMappingRule class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltMetaMappingRule class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltMetaMappingRule class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltMetaMappingRule methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptMetaMappingRule: self

! !

!PltMetaMappingRule methodsFor: 'platypus-generated-accessing' stamp: ''!
condition
	^ condition

! !

!PltMetaMappingRule methodsFor: 'platypus-generated-accessing' stamp: ''!
condition: aString
	condition := aString

! !

!PltMetaMappingRule methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
conditionUsingContext: aContext
	^ self condition

! !

!PltMetaMappingRule methodsFor: 'platypus-generated-accessing' stamp: ''!
expression
	^ expression

! !

!PltMetaMappingRule methodsFor: 'platypus-generated-accessing' stamp: ''!
expression: aString
	expression := aString

! !

!PltMetaMappingRule methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
expressionUsingContext: aContext
	^ self expression

! !

!PltMetaMappingRule methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetCondition: aString
	condition := aString

! !

!PltMetaMappingRule methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetExpression: aString
	expression := aString

! !

!PltMetaMappingRule methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetMetaCondition:aPltExpression	metaCondition := aPltExpression

! !

!PltMetaMappingRule methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetMetaExpression:aPltExpression	metaExpression := aPltExpression

! !

!PltMetaMappingRule methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self metaMappingRuleFromValues: (super fromValues: values)

! !

!PltMetaMappingRule methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltMetaMappingRule
	^ true

! !

!PltMetaMappingRule methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self metaMappingRuleFromValues: values

! !

!PltMetaMappingRule methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self metaMappingRuleToValues: values

! !

!PltMetaMappingRule methodsFor: 'platypus-generated-accessing' stamp: ''!
metaCondition	 ^metaCondition

! !

!PltMetaMappingRule methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
metaConditionUsingContext:aContext	^ self metaCondition

! !

!PltMetaMappingRule methodsFor: 'platypus-generated-accessing' stamp: ''!
metaExpression	 ^metaExpression

! !

!PltMetaMappingRule methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
metaExpressionUsingContext:aContext	^ self metaExpression

! !

!PltMetaMappingRule methodsFor: 'platypus-generated-copying' stamp: ''!
metaMappingRuleCopyTo: another
	another fastSetCondition: self condition.
	another fastSetExpression: self expression

! !

!PltMetaMappingRule methodsFor: 'platypus-generated-group-accessing' stamp: ''!
metaMappingRuleFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setCondition: valuesloc removeFirst.
	self setExpression: valuesloc removeFirst.
	^ valuesloc

! !

!PltMetaMappingRule methodsFor: 'platypus-generated-group-accessing' stamp: ''!
metaMappingRuleToValues: values
	values add: self condition.
	values add: self expression.
	^ values

! !

!PltMetaMappingRule methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltMetaMappingRule methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self metaMappingRuleCopyTo: another

! !

!PltMetaMappingRule methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self metaMappingRuleCopyTo: another

! !

!PltMetaMappingRule methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setCondition: aString
	self condition: aString

! !

!PltMetaMappingRule methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setExpression: aString
	self expression: aString

! !

!PltMetaMappingRule methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setMetaCondition:aPltExpression	self metaCondition:aPltExpression

! !

!PltMetaMappingRule methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setMetaExpression:aPltExpression	self metaExpression:aPltExpression

! !

!PltMetaMappingRule methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	condition := ''.
	expression := ''

! !

!PltMetaMappingRule methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self metaMappingRuleToValues: (super toValues: values)

! !

PltDictionaryInstance subclass: #PltNamedType
	instanceVariableNames: 'identifiersCache whereRules name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltNamedType commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY named_type 
	ABSTRACT SUPERTYPE OF ( ONEOF ( entity_definition, defined_type ) ) 
	SUBTYPE OF ( dictionary_instance );
	name : STRING;
	where_rules : LIST [ 0 : ? ] OF where_rule;
	SELF\entity_instance.owner : context_definition;
END_ENTITY;
</ISO10303-11-EXPRESS>!

PltNamedType subclass: #PltDefinedType
	instanceVariableNames: 'domain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltDefinedType commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY defined_type 
	SUBTYPE OF ( named_type );
	domain : underlying_type;
DERIVE
	accepted : entity_instance := SELF.accept_defined_type;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltDefinedType class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltDefinedType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltDefinedType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltDefinedType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltDefinedType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltDefinedType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltDefinedType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltDefinedType methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptDefinedType: self

! !

!PltDefinedType methodsFor: 'platypus-generated-deriving' stamp: ''!
accepted
	^ self acceptedUsingContext: self class context

! !

!PltDefinedType methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext
	^ self acceptedUsingContext: aContext receiver: self

! !

!PltDefinedType methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext receiver: aReceiver
	^ aReceiver acceptDefinedTypeUsingContext: aContext

! !

!PltDefinedType methodsFor: 'platypus-generated-copying' stamp: ''!
definedTypeCopyTo: another
	another fastSetDomain: self domain

! !

!PltDefinedType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
definedTypeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setDomain: valuesloc removeFirst.
	^ valuesloc

! !

!PltDefinedType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
definedTypeToValues: values
	values add: self domain.
	^ values

! !

!PltDefinedType methodsFor: 'platypus-generated-accessing' stamp: ''!
domain
	^ domain

! !

!PltDefinedType methodsFor: 'platypus-generated-accessing' stamp: ''!
domain: aPltUnderlyingType
	domain := aPltUnderlyingType

! !

!PltDefinedType methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
domainUsingContext: aContext
	^ self domain

! !

!PltDefinedType methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetDomain: aPltUnderlyingType
	domain := aPltUnderlyingType

! !

!PltDefinedType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self definedTypeFromValues: (super fromValues: values)

! !

!PltDefinedType methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltDefinedType
	^ true

! !

!PltDefinedType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self definedTypeFromValues: values

! !

!PltDefinedType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self definedTypeToValues: values

! !

!PltDefinedType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltDefinedType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self definedTypeCopyTo: another

! !

!PltDefinedType methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self definedTypeCopyTo: another

! !

!PltDefinedType methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setDomain: aPltUnderlyingType
	self domain: aPltUnderlyingType

! !

!PltDefinedType methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	domain := nil

! !

!PltDefinedType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self definedTypeToValues: (super toValues: values)

! !

PltNamedType subclass: #PltEntityDefinition
	instanceVariableNames: 'independent subtypes uniquenessRules instantiable complex attributes supertypes supertypeConstraint'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltEntityDefinition commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY entity_definition 
	SUBTYPE OF ( named_type );
	supertype_constraint : OPTIONAL supertype_constraint;
	supertypes : LIST OF UNIQUE entity_definition_reference;
	attributes : LIST OF UNIQUE attribute;
	uniqueness_rules : LIST OF UNIQUE uniqueness_rule;
	complex : BOOLEAN;
	instantiable : BOOLEAN;
	independent : BOOLEAN;
DERIVE
	accepted : entity_instance := SELF.accept_entity_definition;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltEntityDefinition class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltEntityDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltEntityDefinition class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltEntityDefinition class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltEntityDefinition class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltEntityDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltEntityDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltEntityDefinition methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptEntityDefinition: self

! !

!PltEntityDefinition methodsFor: 'platypus-generated-deriving' stamp: ''!
accepted
	^ self acceptedUsingContext: self class context

! !

!PltEntityDefinition methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext
	^ self acceptedUsingContext: aContext receiver: self

! !

!PltEntityDefinition methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext receiver: aReceiver
	^ aReceiver acceptEntityDefinitionUsingContext: aContext

! !

!PltEntityDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
attributes
	^ attributes

! !

!PltEntityDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
attributes: aListOfPltAttribute
	attributes := aListOfPltAttribute
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfPltAttribute as: OrderedCollection ]

! !

!PltEntityDefinition methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
attributesUsingContext: aContext
	^ self attributes

! !

!PltEntityDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
complex
	^ complex

! !

!PltEntityDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
complex: aBoolean
	complex := aBoolean

! !

!PltEntityDefinition methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
complexUsingContext: aContext
	^ self complex

! !

!PltEntityDefinition methodsFor: 'platypus-generated-copying' stamp: ''!
entityDefinitionCopyTo: another
	another fastSetSupertypeConstraint: self supertypeConstraint.
	another fastSetSupertypes: self supertypes.
	another fastSetAttributes: self attributes.
	another fastSetUniquenessRules: self uniquenessRules.
	another fastSetComplex: self complex.
	another fastSetInstantiable: self instantiable.
	another fastSetIndependent: self independent

! !

!PltEntityDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
entityDefinitionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setSupertypeConstraint: valuesloc removeFirst.
	self setSupertypes: valuesloc removeFirst.
	self setAttributes: valuesloc removeFirst.
	self setUniquenessRules: valuesloc removeFirst.
	self setComplex: valuesloc removeFirst.
	self setInstantiable: valuesloc removeFirst.
	self setIndependent: valuesloc removeFirst.
	^ valuesloc

! !

!PltEntityDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
entityDefinitionToValues: values
	values add: self supertypeConstraint.
	values add: self supertypes.
	values add: self attributes.
	values add: self uniquenessRules.
	values add: self complex.
	values add: self instantiable.
	values add: self independent.
	^ values

! !

!PltEntityDefinition methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetAttributes: aListOfPltAttribute
	attributes := aListOfPltAttribute

! !

!PltEntityDefinition methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetComplex: aBoolean
	complex := aBoolean

! !

!PltEntityDefinition methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetIndependent: aBoolean
	independent := aBoolean

! !

!PltEntityDefinition methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetInstantiable: aBoolean
	instantiable := aBoolean

! !

!PltEntityDefinition methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetSupertypeConstraint: aPltSupertypeConstraint
	supertypeConstraint := aPltSupertypeConstraint

! !

!PltEntityDefinition methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetSupertypes: aListOfPltEntityDefinitionReference
	supertypes := aListOfPltEntityDefinitionReference

! !

!PltEntityDefinition methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetUniquenessRules: aListOfPltUniquenessRule
	uniquenessRules := aListOfPltUniquenessRule

! !

!PltEntityDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self entityDefinitionFromValues: (super fromValues: values)

! !

!PltEntityDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
independent
	^ independent

! !

!PltEntityDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
independent: aBoolean
	independent := aBoolean

! !

!PltEntityDefinition methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
independentUsingContext: aContext
	^ self independent

! !

!PltEntityDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
instantiable
	^ instantiable

! !

!PltEntityDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
instantiable: aBoolean
	instantiable := aBoolean

! !

!PltEntityDefinition methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
instantiableUsingContext: aContext
	^ self instantiable

! !

!PltEntityDefinition methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltEntityDefinition
	^ true

! !

!PltEntityDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self entityDefinitionFromValues: values

! !

!PltEntityDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self entityDefinitionToValues: values

! !

!PltEntityDefinition methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltEntityDefinition methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self entityDefinitionCopyTo: another

! !

!PltEntityDefinition methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self entityDefinitionCopyTo: another

! !

!PltEntityDefinition methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setAttributes: aListOfPltAttribute
	self attributes: aListOfPltAttribute

! !

!PltEntityDefinition methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setComplex: aBoolean
	self complex: aBoolean

! !

!PltEntityDefinition methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setIndependent: aBoolean
	self independent: aBoolean

! !

!PltEntityDefinition methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setInstantiable: aBoolean
	self instantiable: aBoolean

! !

!PltEntityDefinition methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setSupertypeConstraint: aPltSupertypeConstraint
	self supertypeConstraint: aPltSupertypeConstraint

! !

!PltEntityDefinition methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setSupertypes: aListOfPltEntityDefinitionReference
	self supertypes: aListOfPltEntityDefinitionReference

! !

!PltEntityDefinition methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setUniquenessRules: aListOfPltUniquenessRule
	self uniquenessRules: aListOfPltUniquenessRule

! !

!PltEntityDefinition methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	supertypeConstraint := nil.
	supertypes := OrderedCollection new.
	attributes := OrderedCollection new.
	uniquenessRules := OrderedCollection new.
	complex := false.
	instantiable := false.
	independent := false

! !

!PltEntityDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
supertypeConstraint
	^ supertypeConstraint

! !

!PltEntityDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
supertypeConstraint: aPltSupertypeConstraint
	supertypeConstraint := aPltSupertypeConstraint

! !

!PltEntityDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
supertypeConstraint: aPltSupertypeConstraint supertypes: aListOfPltEntityDefinitionReference attributes: aListOfPltAttribute uniquenessRules: aListOfPltUniquenessRule complex: aBoolean instantiable: aBoolean1 independent: aBoolean2 	self setSupertypeConstraint:aPltSupertypeConstraint.	self setSupertypes:aListOfPltEntityDefinitionReference.	self setAttributes:aListOfPltAttribute.	self setUniquenessRules:aListOfPltUniquenessRule.	self setComplex:aBoolean.	self setInstantiable:aBoolean1.	self setIndependent:aBoolean2.

! !

!PltEntityDefinition methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
supertypeConstraintUsingContext: aContext
	^ self supertypeConstraint

! !

!PltEntityDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
supertypes
	^ supertypes

! !

!PltEntityDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
supertypes: aListOfPltEntityDefinitionReference
	supertypes := aListOfPltEntityDefinitionReference
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfPltEntityDefinitionReference as: OrderedCollection ]

! !

!PltEntityDefinition methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
supertypesUsingContext: aContext
	^ self supertypes

! !

!PltEntityDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self entityDefinitionToValues: (super toValues: values)

! !

!PltEntityDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
uniquenessRules
	^ uniquenessRules

! !

!PltEntityDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
uniquenessRules: aListOfPltUniquenessRule
	uniquenessRules := aListOfPltUniquenessRule
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfPltUniquenessRule as: OrderedCollection ]

! !

!PltEntityDefinition methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
uniquenessRulesUsingContext: aContext
	^ self uniquenessRules

! !

!PltNamedType class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltNamedType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltNamedType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltNamedType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltNamedType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltNamedType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltNamedType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltNamedType methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptNamedType: self

! !

!PltNamedType methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetName: aString
	name := aString

! !

!PltNamedType methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetOwner: aPltContextDefinition
	owner := aPltContextDefinition

! !

!PltNamedType methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetWhereRules: aListOfPltWhereRule
	whereRules := aListOfPltWhereRule

! !

!PltNamedType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self namedTypeFromValues: (super fromValues: values)

! !

!PltNamedType methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltNamedType
	^ true

! !

!PltNamedType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self namedTypeFromValues: values

! !

!PltNamedType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self namedTypeToValues: values

! !

!PltNamedType methodsFor: 'platypus-generated-accessing' stamp: ''!
name
	^ name

! !

!PltNamedType methodsFor: 'platypus-generated-accessing' stamp: ''!
name: aString
	name := aString

! !

!PltNamedType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
name: aString whereRules: aListOfPltWhereRule owner: aPltContextDefinition 	self setName:aString.	self setWhereRules:aListOfPltWhereRule.	self setOwner:aPltContextDefinition.

! !

!PltNamedType methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
nameUsingContext: aContext
	^ self name

! !

!PltNamedType methodsFor: 'platypus-generated-copying' stamp: ''!
namedTypeCopyTo: another
	another fastSetName: self name.
	another fastSetWhereRules: self whereRules.
	another fastSetOwner: self owner

! !

!PltNamedType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
namedTypeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setName: valuesloc removeFirst.
	self setWhereRules: valuesloc removeFirst.
	self setOwner: valuesloc removeFirst.
	^ valuesloc

! !

!PltNamedType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
namedTypeToValues: values
	values add: self name.
	values add: self whereRules.
	values add: self owner.
	^ values

! !

!PltNamedType methodsFor: 'platypus-generated-accessing' stamp: ''!
owner
	^ owner

! !

!PltNamedType methodsFor: 'platypus-generated-accessing' stamp: ''!
owner: aPltContextDefinition
	owner := aPltContextDefinition

! !

!PltNamedType methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
ownerUsingContext: aContext
	^ self owner

! !

!PltNamedType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltNamedType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self namedTypeCopyTo: another

! !

!PltNamedType methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self namedTypeCopyTo: another

! !

!PltNamedType methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setName: aString
	self name: aString

! !

!PltNamedType methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setOwner: aPltContextDefinition
	self owner: aPltContextDefinition

! !

!PltNamedType methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setWhereRules: aListOfPltWhereRule
	self whereRules: aListOfPltWhereRule

! !

!PltNamedType methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	name := ''.
	whereRules := OrderedCollection new.
	owner := nil

! !

!PltNamedType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self namedTypeToValues: (super toValues: values)

! !

!PltNamedType methodsFor: 'platypus-generated-accessing' stamp: ''!
whereRules
	^ whereRules

! !

!PltNamedType methodsFor: 'platypus-generated-accessing' stamp: ''!
whereRules: aListOfPltWhereRule
	whereRules := aListOfPltWhereRule
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfPltWhereRule as: OrderedCollection ]

! !

!PltNamedType methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
whereRulesUsingContext: aContext
	^ self whereRules

! !

PltDictionaryInstance subclass: #PltNativeAlgorithm
	instanceVariableNames: 'implementations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltNativeAlgorithm commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY native_algorithm 
	SUBTYPE OF ( dictionary_instance );
	implementations : LIST OF native_code;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltNativeAlgorithm class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltNativeAlgorithm class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltNativeAlgorithm class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltNativeAlgorithm class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltNativeAlgorithm class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltNativeAlgorithm class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltNativeAlgorithm class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltNativeAlgorithm methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptNativeAlgorithm: self

! !

!PltNativeAlgorithm methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetImplementations: aListOfPltNativeCode
	implementations := aListOfPltNativeCode

! !

!PltNativeAlgorithm methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self nativeAlgorithmFromValues: (super fromValues: values)

! !

!PltNativeAlgorithm methodsFor: 'platypus-generated-accessing' stamp: ''!
implementations
	^ implementations

! !

!PltNativeAlgorithm methodsFor: 'platypus-generated-accessing' stamp: ''!
implementations: aListOfPltNativeCode
	implementations := aListOfPltNativeCode
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfPltNativeCode as: OrderedCollection ]

! !

!PltNativeAlgorithm methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
implementationsUsingContext: aContext
	^ self implementations

! !

!PltNativeAlgorithm methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltNativeAlgorithm
	^ true

! !

!PltNativeAlgorithm methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self nativeAlgorithmFromValues: values

! !

!PltNativeAlgorithm methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self nativeAlgorithmToValues: values

! !

!PltNativeAlgorithm methodsFor: 'platypus-generated-copying' stamp: ''!
nativeAlgorithmCopyTo: another
	another fastSetImplementations: self implementations

! !

!PltNativeAlgorithm methodsFor: 'platypus-generated-group-accessing' stamp: ''!
nativeAlgorithmFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setImplementations: valuesloc removeFirst.
	^ valuesloc

! !

!PltNativeAlgorithm methodsFor: 'platypus-generated-group-accessing' stamp: ''!
nativeAlgorithmToValues: values
	values add: self implementations.
	^ values

! !

!PltNativeAlgorithm methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltNativeAlgorithm methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self nativeAlgorithmCopyTo: another

! !

!PltNativeAlgorithm methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self nativeAlgorithmCopyTo: another

! !

!PltNativeAlgorithm methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setImplementations: aListOfPltNativeCode
	self implementations: aListOfPltNativeCode

! !

!PltNativeAlgorithm methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	implementations := OrderedCollection new

! !

!PltNativeAlgorithm methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self nativeAlgorithmToValues: (super toValues: values)

! !

PltDictionaryInstance subclass: #PltNativeCode
	instanceVariableNames: 'languageSignature cachedMethod code'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltNativeCode commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY native_code 
	SUBTYPE OF ( dictionary_instance );
	language_signature : STRING;
	code : STRING;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltNativeCode class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltNativeCode class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltNativeCode class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltNativeCode class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltNativeCode class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltNativeCode class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltNativeCode class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltNativeCode methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptNativeCode: self

! !

!PltNativeCode methodsFor: 'platypus-generated-accessing' stamp: ''!
code
	^ code

! !

!PltNativeCode methodsFor: 'platypus-generated-accessing' stamp: ''!
code: aString
	code := aString

! !

!PltNativeCode methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
codeUsingContext: aContext
	^ self code

! !

!PltNativeCode methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetCode: aString
	code := aString

! !

!PltNativeCode methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetLanguageSignature: aString
	languageSignature := aString

! !

!PltNativeCode methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self nativeCodeFromValues: (super fromValues: values)

! !

!PltNativeCode methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltNativeCode
	^ true

! !

!PltNativeCode methodsFor: 'platypus-generated-accessing' stamp: ''!
languageSignature
	^ languageSignature

! !

!PltNativeCode methodsFor: 'platypus-generated-accessing' stamp: ''!
languageSignature: aString
	languageSignature := aString

! !

!PltNativeCode methodsFor: 'platypus-generated-group-accessing' stamp: ''!
languageSignature: aString code: aString1 	self setLanguageSignature:aString.	self setCode:aString1.

! !

!PltNativeCode methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
languageSignatureUsingContext: aContext
	^ self languageSignature

! !

!PltNativeCode methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self nativeCodeFromValues: values

! !

!PltNativeCode methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self nativeCodeToValues: values

! !

!PltNativeCode methodsFor: 'platypus-generated-copying' stamp: ''!
nativeCodeCopyTo: another
	another fastSetLanguageSignature: self languageSignature.
	another fastSetCode: self code

! !

!PltNativeCode methodsFor: 'platypus-generated-group-accessing' stamp: ''!
nativeCodeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setLanguageSignature: valuesloc removeFirst.
	self setCode: valuesloc removeFirst.
	^ valuesloc

! !

!PltNativeCode methodsFor: 'platypus-generated-group-accessing' stamp: ''!
nativeCodeToValues: values
	values add: self languageSignature.
	values add: self code.
	^ values

! !

!PltNativeCode methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltNativeCode methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self nativeCodeCopyTo: another

! !

!PltNativeCode methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self nativeCodeCopyTo: another

! !

!PltNativeCode methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setCode: aString
	self code: aString

! !

!PltNativeCode methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setLanguageSignature: aString
	self languageSignature: aString

! !

!PltNativeCode methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	languageSignature := ''.
	code := ''

! !

!PltNativeCode methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self nativeCodeToValues: (super toValues: values)

! !

PltDictionaryInstance subclass: #PltParameterDefinition
	instanceVariableNames: 'domain byCopy name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltParameterDefinition commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY parameter_definition 
	SUBTYPE OF ( dictionary_instance );
	SELF\entity_instance.owner : algorithm_declaration;
	name : STRING;
	by_copy : BOOLEAN;
	domain : parameter_type;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltParameterDefinition class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltParameterDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltParameterDefinition class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltParameterDefinition class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltParameterDefinition class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltParameterDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltParameterDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltParameterDefinition methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptParameterDefinition: self

! !

!PltParameterDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
byCopy
	^ byCopy

! !

!PltParameterDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
byCopy: aBoolean
	byCopy := aBoolean

! !

!PltParameterDefinition methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
byCopyUsingContext: aContext
	^ self byCopy

! !

!PltParameterDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
domain
	^ domain

! !

!PltParameterDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
domain: aPltParameterType
	domain := aPltParameterType

! !

!PltParameterDefinition methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
domainUsingContext: aContext
	^ self domain

! !

!PltParameterDefinition methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetByCopy: aBoolean
	byCopy := aBoolean

! !

!PltParameterDefinition methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetDomain: aPltParameterType
	domain := aPltParameterType

! !

!PltParameterDefinition methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetName: aString
	name := aString

! !

!PltParameterDefinition methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetOwner: aPltAlgorithmDeclaration
	owner := aPltAlgorithmDeclaration

! !

!PltParameterDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self parameterDefinitionFromValues: (super fromValues: values)

! !

!PltParameterDefinition methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltParameterDefinition
	^ true

! !

!PltParameterDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self parameterDefinitionFromValues: values

! !

!PltParameterDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self parameterDefinitionToValues: values

! !

!PltParameterDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
name
	^ name

! !

!PltParameterDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
name: aString
	name := aString

! !

!PltParameterDefinition methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
nameUsingContext: aContext
	^ self name

! !

!PltParameterDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
owner
	^ owner

! !

!PltParameterDefinition methodsFor: 'platypus-generated-accessing' stamp: ''!
owner: aPltAlgorithmDeclaration
	owner := aPltAlgorithmDeclaration

! !

!PltParameterDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
owner: aPltAlgorithmDeclaration name: aString byCopy: aBoolean domain: aPltParameterType 	self setOwner:aPltAlgorithmDeclaration.	self setName:aString.	self setByCopy:aBoolean.	self setDomain:aPltParameterType.

! !

!PltParameterDefinition methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
ownerUsingContext: aContext
	^ self owner

! !

!PltParameterDefinition methodsFor: 'platypus-generated-copying' stamp: ''!
parameterDefinitionCopyTo: another
	another fastSetOwner: self owner.
	another fastSetName: self name.
	another fastSetByCopy: self byCopy.
	another fastSetDomain: self domain

! !

!PltParameterDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
parameterDefinitionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setOwner: valuesloc removeFirst.
	self setName: valuesloc removeFirst.
	self setByCopy: valuesloc removeFirst.
	self setDomain: valuesloc removeFirst.
	^ valuesloc

! !

!PltParameterDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
parameterDefinitionToValues: values
	values add: self owner.
	values add: self name.
	values add: self byCopy.
	values add: self domain.
	^ values

! !

!PltParameterDefinition methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltParameterDefinition methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self parameterDefinitionCopyTo: another

! !

!PltParameterDefinition methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self parameterDefinitionCopyTo: another

! !

!PltParameterDefinition methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setByCopy: aBoolean
	self byCopy: aBoolean

! !

!PltParameterDefinition methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setDomain: aPltParameterType
	self domain: aPltParameterType

! !

!PltParameterDefinition methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setName: aString
	self name: aString

! !

!PltParameterDefinition methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setOwner: aPltAlgorithmDeclaration
	self owner: aPltAlgorithmDeclaration

! !

!PltParameterDefinition methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	owner := nil.
	name := ''.
	byCopy := false.
	domain := nil

! !

!PltParameterDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self parameterDefinitionToValues: (super toValues: values)

! !

PltDictionaryInstance subclass: #PltQueryVariable
	instanceVariableNames: 'variableId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressionsSchemaSchema'!

!PltQueryVariable commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY query_variable 
	SUBTYPE OF ( dictionary_instance );
	variable_id : STRING;
	SELF\entity_instance.owner : query_expression;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltQueryVariable class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltQueryVariable class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltQueryVariable class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltQueryVariable class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusExpressionsSchemaSchemaDefinition singleton

! !

!PltQueryVariable class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltQueryVariable class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltQueryVariable class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltQueryVariable methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptQueryVariable: self

! !

!PltQueryVariable methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetOwner: aPltQueryExpression
	owner := aPltQueryExpression

! !

!PltQueryVariable methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetVariableId: aString
	variableId := aString

! !

!PltQueryVariable methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self queryVariableFromValues: (super fromValues: values)

! !

!PltQueryVariable methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltQueryVariable
	^ true

! !

!PltQueryVariable methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self queryVariableFromValues: values

! !

!PltQueryVariable methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self queryVariableToValues: values

! !

!PltQueryVariable methodsFor: 'platypus-generated-accessing' stamp: ''!
owner
	^ owner

! !

!PltQueryVariable methodsFor: 'platypus-generated-accessing' stamp: ''!
owner: aPltQueryExpression
	owner := aPltQueryExpression

! !

!PltQueryVariable methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
ownerUsingContext: aContext
	^ self owner

! !

!PltQueryVariable methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltQueryVariable methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self queryVariableCopyTo: another

! !

!PltQueryVariable methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self queryVariableCopyTo: another

! !

!PltQueryVariable methodsFor: 'platypus-generated-copying' stamp: ''!
queryVariableCopyTo: another
	another fastSetVariableId: self variableId.
	another fastSetOwner: self owner

! !

!PltQueryVariable methodsFor: 'platypus-generated-group-accessing' stamp: ''!
queryVariableFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setVariableId: valuesloc removeFirst.
	self setOwner: valuesloc removeFirst.
	^ valuesloc

! !

!PltQueryVariable methodsFor: 'platypus-generated-group-accessing' stamp: ''!
queryVariableToValues: values
	values add: self variableId.
	values add: self owner.
	^ values

! !

!PltQueryVariable methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setOwner: aPltQueryExpression
	self owner: aPltQueryExpression

! !

!PltQueryVariable methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setVariableId: aString
	self variableId: aString

! !

!PltQueryVariable methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	variableId := ''.
	owner := nil

! !

!PltQueryVariable methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self queryVariableToValues: (super toValues: values)

! !

!PltQueryVariable methodsFor: 'platypus-generated-accessing' stamp: ''!
variableId
	^ variableId

! !

!PltQueryVariable methodsFor: 'platypus-generated-accessing' stamp: ''!
variableId: aString
	variableId := aString

! !

!PltQueryVariable methodsFor: 'platypus-generated-group-accessing' stamp: ''!
variableId: aString owner: aPltQueryExpression 	self setVariableId:aString.	self setOwner:aPltQueryExpression.

! !

!PltQueryVariable methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
variableIdUsingContext: aContext
	^ self variableId

! !

PltDictionaryInstance subclass: #PltRemarkReference
	instanceVariableNames: 'suffix inside prefix remark referenced'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltRemarkReference commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY remark_reference 
	SUBTYPE OF ( dictionary_instance );
	prefix : STRING;
	suffix : OPTIONAL STRING;
	inside : dictionary_instance_reference;
	referenced : dictionary_instance_reference;
	remark : remark;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltRemarkReference class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltRemarkReference class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltRemarkReference class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltRemarkReference class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltRemarkReference class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltRemarkReference class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltRemarkReference class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltRemarkReference methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptRemarkReference: self

! !

!PltRemarkReference methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetInside: aPltDictionaryInstanceReference
	inside := aPltDictionaryInstanceReference

! !

!PltRemarkReference methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetPrefix: aString
	prefix := aString

! !

!PltRemarkReference methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetReferenced: aPltDictionaryInstanceReference
	referenced := aPltDictionaryInstanceReference

! !

!PltRemarkReference methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetRemark: aPltRemark
	remark := aPltRemark

! !

!PltRemarkReference methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetSuffix: aString
	suffix := aString

! !

!PltRemarkReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self remarkReferenceFromValues: (super fromValues: values)

! !

!PltRemarkReference methodsFor: 'platypus-generated-accessing' stamp: ''!
inside
	^ inside

! !

!PltRemarkReference methodsFor: 'platypus-generated-accessing' stamp: ''!
inside: aPltDictionaryInstanceReference
	inside := aPltDictionaryInstanceReference

! !

!PltRemarkReference methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
insideUsingContext: aContext
	^ self inside

! !

!PltRemarkReference methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltRemarkReference
	^ true

! !

!PltRemarkReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self remarkReferenceFromValues: values

! !

!PltRemarkReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self remarkReferenceToValues: values

! !

!PltRemarkReference methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltRemarkReference methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self remarkReferenceCopyTo: another

! !

!PltRemarkReference methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self remarkReferenceCopyTo: another

! !

!PltRemarkReference methodsFor: 'platypus-generated-accessing' stamp: ''!
prefix
	^ prefix

! !

!PltRemarkReference methodsFor: 'platypus-generated-accessing' stamp: ''!
prefix: aString
	prefix := aString

! !

!PltRemarkReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
prefix: aString suffix: aString1 inside: aPltDictionaryInstanceReference referenced: aPltDictionaryInstanceReference1 remark: aPltRemark 	self setPrefix:aString.	self setSuffix:aString1.	self setInside:aPltDictionaryInstanceReference.	self setReferenced:aPltDictionaryInstanceReference1.	self setRemark:aPltRemark.

! !

!PltRemarkReference methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
prefixUsingContext: aContext
	^ self prefix

! !

!PltRemarkReference methodsFor: 'platypus-generated-accessing' stamp: ''!
referenced
	^ referenced

! !

!PltRemarkReference methodsFor: 'platypus-generated-accessing' stamp: ''!
referenced: aPltDictionaryInstanceReference
	referenced := aPltDictionaryInstanceReference

! !

!PltRemarkReference methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
referencedUsingContext: aContext
	^ self referenced

! !

!PltRemarkReference methodsFor: 'platypus-generated-accessing' stamp: ''!
remark
	^ remark

! !

!PltRemarkReference methodsFor: 'platypus-generated-accessing' stamp: ''!
remark: aPltRemark
	remark := aPltRemark

! !

!PltRemarkReference methodsFor: 'platypus-generated-copying' stamp: ''!
remarkReferenceCopyTo: another
	another fastSetPrefix: self prefix.
	another fastSetSuffix: self suffix.
	another fastSetInside: self inside.
	another fastSetReferenced: self referenced.
	another fastSetRemark: self remark

! !

!PltRemarkReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
remarkReferenceFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setPrefix: valuesloc removeFirst.
	self setSuffix: valuesloc removeFirst.
	self setInside: valuesloc removeFirst.
	self setReferenced: valuesloc removeFirst.
	self setRemark: valuesloc removeFirst.
	^ valuesloc

! !

!PltRemarkReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
remarkReferenceToValues: values
	values add: self prefix.
	values add: self suffix.
	values add: self inside.
	values add: self referenced.
	values add: self remark.
	^ values

! !

!PltRemarkReference methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
remarkUsingContext: aContext
	^ self remark

! !

!PltRemarkReference methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setInside: aPltDictionaryInstanceReference
	self inside: aPltDictionaryInstanceReference

! !

!PltRemarkReference methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setPrefix: aString
	self prefix: aString

! !

!PltRemarkReference methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setReferenced: aPltDictionaryInstanceReference
	self referenced: aPltDictionaryInstanceReference

! !

!PltRemarkReference methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setRemark: aPltRemark
	self remark: aPltRemark

! !

!PltRemarkReference methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setSuffix: aString
	self suffix: aString

! !

!PltRemarkReference methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	prefix := ''.
	suffix := nil.
	inside := nil.
	referenced := nil.
	remark := nil

! !

!PltRemarkReference methodsFor: 'platypus-generated-accessing' stamp: ''!
suffix
	^ suffix

! !

!PltRemarkReference methodsFor: 'platypus-generated-accessing' stamp: ''!
suffix: aString
	suffix := aString

! !

!PltRemarkReference methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
suffixUsingContext: aContext
	^ self suffix

! !

!PltRemarkReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self remarkReferenceToValues: (super toValues: values)

! !

PltDictionaryInstance subclass: #PltSelectType
	instanceVariableNames: 'selections'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltSelectType commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY select_type 
	SUBTYPE OF ( dictionary_instance );
	selections : LIST [ 1 : ? ] OF named_type_reference;
	SELF\entity_instance.owner : defined_type;
DERIVE
	accepted : entity_instance := SELF.accept_select_type;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltSelectType class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltSelectType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltSelectType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltSelectType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltSelectType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltSelectType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltSelectType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltSelectType methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptSelectType: self

! !

!PltSelectType methodsFor: 'platypus-generated-deriving' stamp: ''!
accepted
	^ self acceptedUsingContext: self class context

! !

!PltSelectType methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext
	^ self acceptedUsingContext: aContext receiver: self

! !

!PltSelectType methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext receiver: aReceiver
	^ aReceiver acceptSelectTypeUsingContext: aContext

! !

!PltSelectType methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetOwner: aPltDefinedType
	owner := aPltDefinedType

! !

!PltSelectType methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetSelections: aListOfPltNamedTypeReference
	selections := aListOfPltNamedTypeReference

! !

!PltSelectType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self selectTypeFromValues: (super fromValues: values)

! !

!PltSelectType methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltSelectType
	^ true

! !

!PltSelectType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self selectTypeFromValues: values

! !

!PltSelectType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self selectTypeToValues: values

! !

!PltSelectType methodsFor: 'platypus-generated-accessing' stamp: ''!
owner
	^ owner

! !

!PltSelectType methodsFor: 'platypus-generated-accessing' stamp: ''!
owner: aPltDefinedType
	owner := aPltDefinedType

! !

!PltSelectType methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
ownerUsingContext: aContext
	^ self owner

! !

!PltSelectType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltSelectType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self selectTypeCopyTo: another

! !

!PltSelectType methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self selectTypeCopyTo: another

! !

!PltSelectType methodsFor: 'platypus-generated-copying' stamp: ''!
selectTypeCopyTo: another
	another fastSetSelections: self selections.
	another fastSetOwner: self owner

! !

!PltSelectType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
selectTypeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setSelections: valuesloc removeFirst.
	self setOwner: valuesloc removeFirst.
	^ valuesloc

! !

!PltSelectType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
selectTypeToValues: values
	values add: self selections.
	values add: self owner.
	^ values

! !

!PltSelectType methodsFor: 'platypus-generated-accessing' stamp: ''!
selections
	^ selections

! !

!PltSelectType methodsFor: 'platypus-generated-accessing' stamp: ''!
selections: aListOfPltNamedTypeReference
	selections := aListOfPltNamedTypeReference
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfPltNamedTypeReference as: OrderedCollection ]

! !

!PltSelectType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
selections: aListOfPltNamedTypeReference owner: aPltDefinedType 	self setSelections:aListOfPltNamedTypeReference.	self setOwner:aPltDefinedType.

! !

!PltSelectType methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
selectionsUsingContext: aContext
	^ self selections

! !

!PltSelectType methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setOwner: aPltDefinedType
	self owner: aPltDefinedType

! !

!PltSelectType methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setSelections: aListOfPltNamedTypeReference
	self selections: aListOfPltNamedTypeReference

! !

!PltSelectType methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	selections := OrderedCollection new.
	owner := nil

! !

!PltSelectType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self selectTypeToValues: (super toValues: values)

! !

PltDictionaryInstance subclass: #PltSimpleType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltSimpleType commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY simple_type 
	ABSTRACT SUPERTYPE OF ( ONEOF ( string_type, binary_type, logical_type, number_type ) ) 
	SUBTYPE OF ( dictionary_instance );
END_ENTITY;
</ISO10303-11-EXPRESS>!

PltSimpleType subclass: #PltBinaryType
	instanceVariableNames: 'width fixedWidth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltBinaryType commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY binary_type 
	SUBTYPE OF ( simple_type );
	width : OPTIONAL bound;
	fixed_width : BOOLEAN;
DERIVE
	accepted : entity_instance := SELF.accept_binary_type;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltBinaryType class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltBinaryType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltBinaryType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltBinaryType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltBinaryType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltBinaryType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltBinaryType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltBinaryType methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptBinaryType: self

! !

!PltBinaryType methodsFor: 'platypus-generated-deriving' stamp: ''!
accepted
	^ self acceptedUsingContext: self class context

! !

!PltBinaryType methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext
	^ self acceptedUsingContext: aContext receiver: self

! !

!PltBinaryType methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext receiver: aReceiver
	^ aReceiver acceptBinaryTypeUsingContext: aContext

! !

!PltBinaryType methodsFor: 'platypus-generated-copying' stamp: ''!
binaryTypeCopyTo: another
	another fastSetWidth: self width.
	another fastSetFixedWidth: self fixedWidth

! !

!PltBinaryType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
binaryTypeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setWidth: valuesloc removeFirst.
	self setFixedWidth: valuesloc removeFirst.
	^ valuesloc

! !

!PltBinaryType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
binaryTypeToValues: values
	values add: self width.
	values add: self fixedWidth.
	^ values

! !

!PltBinaryType methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetFixedWidth: aBoolean
	fixedWidth := aBoolean

! !

!PltBinaryType methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetWidth: aPltBound
	width := aPltBound

! !

!PltBinaryType methodsFor: 'platypus-generated-accessing' stamp: ''!
fixedWidth
	^ fixedWidth

! !

!PltBinaryType methodsFor: 'platypus-generated-accessing' stamp: ''!
fixedWidth: aBoolean
	fixedWidth := aBoolean

! !

!PltBinaryType methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
fixedWidthUsingContext: aContext
	^ self fixedWidth

! !

!PltBinaryType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self binaryTypeFromValues: (super fromValues: values)

! !

!PltBinaryType methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltBinaryType
	^ true

! !

!PltBinaryType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self binaryTypeFromValues: values

! !

!PltBinaryType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self binaryTypeToValues: values

! !

!PltBinaryType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltBinaryType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self binaryTypeCopyTo: another

! !

!PltBinaryType methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self binaryTypeCopyTo: another

! !

!PltBinaryType methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setFixedWidth: aBoolean
	self fixedWidth: aBoolean

! !

!PltBinaryType methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setWidth: aPltBound
	self width: aPltBound

! !

!PltBinaryType methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	width := nil.
	fixedWidth := false

! !

!PltBinaryType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self binaryTypeToValues: (super toValues: values)

! !

!PltBinaryType methodsFor: 'platypus-generated-accessing' stamp: ''!
width
	^ width

! !

!PltBinaryType methodsFor: 'platypus-generated-accessing' stamp: ''!
width: aPltBound
	width := aPltBound

! !

!PltBinaryType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
width: aPltBound fixedWidth: aBoolean 	self setWidth:aPltBound.	self setFixedWidth:aBoolean.

! !

!PltBinaryType methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
widthUsingContext: aContext
	^ self width

! !

PltSimpleType subclass: #PltLogicalType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltLogicalType commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY logical_type 
	SUBTYPE OF ( simple_type );
DERIVE
	accepted : entity_instance := SELF.accept_logical_type;
END_ENTITY;
</ISO10303-11-EXPRESS>!

PltLogicalType subclass: #PltBooleanType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltBooleanType commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY boolean_type 
	SUBTYPE OF ( logical_type );
DERIVE
	SELF\logical_type.accepted : entity_instance := SELF.accept_boolean_type;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltBooleanType class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltBooleanType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltBooleanType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltBooleanType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltBooleanType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltBooleanType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltBooleanType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltBooleanType methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptBooleanType: self

! !

!PltBooleanType methodsFor: 'platypus-generated-deriving' stamp: ''!
accepted
	^ self acceptedUsingContext: self class context

! !

!PltBooleanType methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext
	^ self acceptedUsingContext: aContext receiver: self

! !

!PltBooleanType methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext receiver: aReceiver
	^ aReceiver acceptBooleanTypeUsingContext: aContext

! !

!PltBooleanType methodsFor: 'platypus-generated-copying' stamp: ''!
booleanTypeCopyTo: another
	

! !

!PltBooleanType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
booleanTypeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltBooleanType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
booleanTypeToValues: values
	^ values

! !

!PltBooleanType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self booleanTypeFromValues: (super fromValues: values)

! !

!PltBooleanType methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltBooleanType
	^ true

! !

!PltBooleanType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self booleanTypeFromValues: values

! !

!PltBooleanType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self booleanTypeToValues: values

! !

!PltBooleanType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltBooleanType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self booleanTypeCopyTo: another

! !

!PltBooleanType methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self booleanTypeCopyTo: another

! !

!PltBooleanType methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltBooleanType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self booleanTypeToValues: (super toValues: values)

! !

!PltLogicalType class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltLogicalType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltLogicalType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltLogicalType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltLogicalType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltLogicalType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltLogicalType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltLogicalType methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptLogicalType: self

! !

!PltLogicalType methodsFor: 'platypus-generated-deriving' stamp: ''!
accepted
	^ self acceptedUsingContext: self class context

! !

!PltLogicalType methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext
	^ self acceptedUsingContext: aContext receiver: self

! !

!PltLogicalType methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext receiver: aReceiver
	^ aReceiver acceptLogicalTypeUsingContext: aContext

! !

!PltLogicalType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self logicalTypeFromValues: (super fromValues: values)

! !

!PltLogicalType methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltLogicalType
	^ true

! !

!PltLogicalType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self logicalTypeFromValues: values

! !

!PltLogicalType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self logicalTypeToValues: values

! !

!PltLogicalType methodsFor: 'platypus-generated-copying' stamp: ''!
logicalTypeCopyTo: another
	

! !

!PltLogicalType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
logicalTypeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltLogicalType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
logicalTypeToValues: values
	^ values

! !

!PltLogicalType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltLogicalType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self logicalTypeCopyTo: another

! !

!PltLogicalType methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self logicalTypeCopyTo: another

! !

!PltLogicalType methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltLogicalType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self logicalTypeToValues: (super toValues: values)

! !

PltSimpleType subclass: #PltNumberType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltNumberType commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY number_type 
	SUBTYPE OF ( simple_type );
DERIVE
	accepted : entity_instance := SELF.accept_number_type;
END_ENTITY;
</ISO10303-11-EXPRESS>!

PltNumberType subclass: #PltIntegerType
	instanceVariableNames: 'precision'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltIntegerType commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY integer_type 
	SUBTYPE OF ( number_type );
	precision : OPTIONAL bound;
DERIVE
	SELF\number_type.accepted : entity_instance := SELF.accept_integer_type;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltIntegerType class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltIntegerType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltIntegerType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltIntegerType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltIntegerType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltIntegerType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltIntegerType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltIntegerType methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptIntegerType: self

! !

!PltIntegerType methodsFor: 'platypus-generated-deriving' stamp: ''!
accepted
	^ self acceptedUsingContext: self class context

! !

!PltIntegerType methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext
	^ self acceptedUsingContext: aContext receiver: self

! !

!PltIntegerType methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext receiver: aReceiver
	^ aReceiver acceptIntegerTypeUsingContext: aContext

! !

!PltIntegerType methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetPrecision: aPltBound
	precision := aPltBound

! !

!PltIntegerType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self integerTypeFromValues: (super fromValues: values)

! !

!PltIntegerType methodsFor: 'platypus-generated-copying' stamp: ''!
integerTypeCopyTo: another
	another fastSetPrecision: self precision

! !

!PltIntegerType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
integerTypeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setPrecision: valuesloc removeFirst.
	^ valuesloc

! !

!PltIntegerType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
integerTypeToValues: values
	values add: self precision.
	^ values

! !

!PltIntegerType methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltIntegerType
	^ true

! !

!PltIntegerType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self integerTypeFromValues: values

! !

!PltIntegerType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self integerTypeToValues: values

! !

!PltIntegerType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltIntegerType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self integerTypeCopyTo: another

! !

!PltIntegerType methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self integerTypeCopyTo: another

! !

!PltIntegerType methodsFor: 'platypus-generated-accessing' stamp: ''!
precision
	^ precision

! !

!PltIntegerType methodsFor: 'platypus-generated-accessing' stamp: ''!
precision: aPltBound
	precision := aPltBound

! !

!PltIntegerType methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
precisionUsingContext: aContext
	^ self precision

! !

!PltIntegerType methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setPrecision: aPltBound
	self precision: aPltBound

! !

!PltIntegerType methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	precision := nil

! !

!PltIntegerType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self integerTypeToValues: (super toValues: values)

! !

!PltNumberType class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltNumberType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltNumberType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltNumberType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltNumberType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltNumberType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltNumberType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltNumberType methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptNumberType: self

! !

!PltNumberType methodsFor: 'platypus-generated-deriving' stamp: ''!
accepted
	^ self acceptedUsingContext: self class context

! !

!PltNumberType methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext
	^ self acceptedUsingContext: aContext receiver: self

! !

!PltNumberType methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext receiver: aReceiver
	^ aReceiver acceptNumberTypeUsingContext: aContext

! !

!PltNumberType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self numberTypeFromValues: (super fromValues: values)

! !

!PltNumberType methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltNumberType
	^ true

! !

!PltNumberType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self numberTypeFromValues: values

! !

!PltNumberType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self numberTypeToValues: values

! !

!PltNumberType methodsFor: 'platypus-generated-copying' stamp: ''!
numberTypeCopyTo: another
	

! !

!PltNumberType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
numberTypeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltNumberType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
numberTypeToValues: values
	^ values

! !

!PltNumberType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltNumberType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self numberTypeCopyTo: another

! !

!PltNumberType methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self numberTypeCopyTo: another

! !

!PltNumberType methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltNumberType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self numberTypeToValues: (super toValues: values)

! !

PltNumberType subclass: #PltRealType
	instanceVariableNames: 'precision'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltRealType commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY real_type 
	SUBTYPE OF ( number_type );
	precision : OPTIONAL bound;
DERIVE
	SELF\number_type.accepted : entity_instance := SELF.accept_real_type;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltRealType class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltRealType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltRealType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltRealType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltRealType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltRealType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltRealType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltRealType methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptRealType: self

! !

!PltRealType methodsFor: 'platypus-generated-deriving' stamp: ''!
accepted
	^ self acceptedUsingContext: self class context

! !

!PltRealType methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext
	^ self acceptedUsingContext: aContext receiver: self

! !

!PltRealType methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext receiver: aReceiver
	^ aReceiver acceptRealTypeUsingContext: aContext

! !

!PltRealType methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetPrecision: aPltBound
	precision := aPltBound

! !

!PltRealType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self realTypeFromValues: (super fromValues: values)

! !

!PltRealType methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltRealType
	^ true

! !

!PltRealType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self realTypeFromValues: values

! !

!PltRealType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self realTypeToValues: values

! !

!PltRealType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltRealType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self realTypeCopyTo: another

! !

!PltRealType methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self realTypeCopyTo: another

! !

!PltRealType methodsFor: 'platypus-generated-accessing' stamp: ''!
precision
	^ precision

! !

!PltRealType methodsFor: 'platypus-generated-accessing' stamp: ''!
precision: aPltBound
	precision := aPltBound

! !

!PltRealType methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
precisionUsingContext: aContext
	^ self precision

! !

!PltRealType methodsFor: 'platypus-generated-copying' stamp: ''!
realTypeCopyTo: another
	another fastSetPrecision: self precision

! !

!PltRealType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
realTypeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setPrecision: valuesloc removeFirst.
	^ valuesloc

! !

!PltRealType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
realTypeToValues: values
	values add: self precision.
	^ values

! !

!PltRealType methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setPrecision: aPltBound
	self precision: aPltBound

! !

!PltRealType methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	precision := nil

! !

!PltRealType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self realTypeToValues: (super toValues: values)

! !

!PltSimpleType class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltSimpleType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltSimpleType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltSimpleType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltSimpleType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltSimpleType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltSimpleType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltSimpleType methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptSimpleType: self

! !

!PltSimpleType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self simpleTypeFromValues: (super fromValues: values)

! !

!PltSimpleType methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltSimpleType
	^ true

! !

!PltSimpleType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self simpleTypeFromValues: values

! !

!PltSimpleType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self simpleTypeToValues: values

! !

!PltSimpleType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltSimpleType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self simpleTypeCopyTo: another

! !

!PltSimpleType methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self simpleTypeCopyTo: another

! !

!PltSimpleType methodsFor: 'platypus-generated-copying' stamp: ''!
simpleTypeCopyTo: another
	

! !

!PltSimpleType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
simpleTypeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltSimpleType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
simpleTypeToValues: values
	^ values

! !

!PltSimpleType methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltSimpleType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self simpleTypeToValues: (super toValues: values)

! !

PltSimpleType subclass: #PltStringType
	instanceVariableNames: 'width fixedWidth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltStringType commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY string_type 
	SUBTYPE OF ( simple_type );
	width : OPTIONAL bound;
	fixed_width : BOOLEAN;
DERIVE
	accepted : entity_instance := SELF.accept_string_type;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltStringType class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltStringType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltStringType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltStringType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltStringType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltStringType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltStringType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltStringType methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptStringType: self

! !

!PltStringType methodsFor: 'platypus-generated-deriving' stamp: ''!
accepted
	^ self acceptedUsingContext: self class context

! !

!PltStringType methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext
	^ self acceptedUsingContext: aContext receiver: self

! !

!PltStringType methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext receiver: aReceiver
	^ aReceiver acceptStringTypeUsingContext: aContext

! !

!PltStringType methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetFixedWidth: aBoolean
	fixedWidth := aBoolean

! !

!PltStringType methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetWidth: aPltBound
	width := aPltBound

! !

!PltStringType methodsFor: 'platypus-generated-accessing' stamp: ''!
fixedWidth
	^ fixedWidth

! !

!PltStringType methodsFor: 'platypus-generated-accessing' stamp: ''!
fixedWidth: aBoolean
	fixedWidth := aBoolean

! !

!PltStringType methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
fixedWidthUsingContext: aContext
	^ self fixedWidth

! !

!PltStringType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self stringTypeFromValues: (super fromValues: values)

! !

!PltStringType methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltStringType
	^ true

! !

!PltStringType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self stringTypeFromValues: values

! !

!PltStringType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self stringTypeToValues: values

! !

!PltStringType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltStringType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self stringTypeCopyTo: another

! !

!PltStringType methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self stringTypeCopyTo: another

! !

!PltStringType methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setFixedWidth: aBoolean
	self fixedWidth: aBoolean

! !

!PltStringType methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setWidth: aPltBound
	self width: aPltBound

! !

!PltStringType methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	width := nil.
	fixedWidth := false

! !

!PltStringType methodsFor: 'platypus-generated-copying' stamp: ''!
stringTypeCopyTo: another
	another fastSetWidth: self width.
	another fastSetFixedWidth: self fixedWidth

! !

!PltStringType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
stringTypeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setWidth: valuesloc removeFirst.
	self setFixedWidth: valuesloc removeFirst.
	^ valuesloc

! !

!PltStringType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
stringTypeToValues: values
	values add: self width.
	values add: self fixedWidth.
	^ values

! !

!PltStringType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self stringTypeToValues: (super toValues: values)

! !

!PltStringType methodsFor: 'platypus-generated-accessing' stamp: ''!
width
	^ width

! !

!PltStringType methodsFor: 'platypus-generated-accessing' stamp: ''!
width: aPltBound
	width := aPltBound

! !

!PltStringType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
width: aPltBound fixedWidth: aBoolean 	self setWidth:aPltBound.	self setFixedWidth:aBoolean.

! !

!PltStringType methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
widthUsingContext: aContext
	^ self width

! !

PltDictionaryInstance subclass: #PltStatement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusStatementsSchemaSchema'!

!PltStatement commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY statement 
	ABSTRACT SUPERTYPE 
	SUBTYPE OF ( dictionary_instance );
END_ENTITY;
</ISO10303-11-EXPRESS>!

PltStatement subclass: #PltAliasStatement
	instanceVariableNames: 'identifiersCache variable statements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusStatementsSchemaSchema'!

!PltAliasStatement commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY alias_statement 
	SUBTYPE OF ( statement );
	variable : alias_statement_variable;
	statements : LIST OF statement;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltAliasStatement class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltAliasStatement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltAliasStatement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltAliasStatement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusStatementsSchemaSchemaDefinition singleton

! !

!PltAliasStatement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltAliasStatement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltAliasStatement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltAliasStatement methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptAliasStatement: self

! !

!PltAliasStatement methodsFor: 'platypus-generated-copying' stamp: ''!
aliasStatementCopyTo: another
	another fastSetVariable: self variable.
	another fastSetStatements: self statements

! !

!PltAliasStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
aliasStatementFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setVariable: valuesloc removeFirst.
	self setStatements: valuesloc removeFirst.
	^ valuesloc

! !

!PltAliasStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
aliasStatementToValues: values
	values add: self variable.
	values add: self statements.
	^ values

! !

!PltAliasStatement methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetStatements: aListOfPltStatement
	statements := aListOfPltStatement

! !

!PltAliasStatement methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetVariable: aPltAliasStatementVariable
	variable := aPltAliasStatementVariable

! !

!PltAliasStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self aliasStatementFromValues: (super fromValues: values)

! !

!PltAliasStatement methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltAliasStatement
	^ true

! !

!PltAliasStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self aliasStatementFromValues: values

! !

!PltAliasStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self aliasStatementToValues: values

! !

!PltAliasStatement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltAliasStatement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self aliasStatementCopyTo: another

! !

!PltAliasStatement methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self aliasStatementCopyTo: another

! !

!PltAliasStatement methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setStatements: aListOfPltStatement
	self statements: aListOfPltStatement

! !

!PltAliasStatement methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setVariable: aPltAliasStatementVariable
	self variable: aPltAliasStatementVariable

! !

!PltAliasStatement methodsFor: 'platypus-generated-accessing' stamp: ''!
statements
	^ statements

! !

!PltAliasStatement methodsFor: 'platypus-generated-accessing' stamp: ''!
statements: aListOfPltStatement
	statements := aListOfPltStatement
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfPltStatement as: OrderedCollection ]

! !

!PltAliasStatement methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
statementsUsingContext: aContext
	^ self statements

! !

!PltAliasStatement methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	variable := nil.
	statements := OrderedCollection new

! !

!PltAliasStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self aliasStatementToValues: (super toValues: values)

! !

!PltAliasStatement methodsFor: 'platypus-generated-accessing' stamp: ''!
variable
	^ variable

! !

!PltAliasStatement methodsFor: 'platypus-generated-accessing' stamp: ''!
variable: aPltAliasStatementVariable
	variable := aPltAliasStatementVariable

! !

!PltAliasStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
variable: aPltAliasStatementVariable statements: aListOfPltStatement 	self setVariable:aPltAliasStatementVariable.	self setStatements:aListOfPltStatement.

! !

!PltAliasStatement methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
variableUsingContext: aContext
	^ self variable

! !

PltStatement subclass: #PltAssignmentStatement
	instanceVariableNames: 'rightExpr left'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusStatementsSchemaSchema'!

!PltAssignmentStatement commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY assignment_statement 
	SUBTYPE OF ( statement );
	left : assignable;
	right_expr : expression;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltAssignmentStatement class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltAssignmentStatement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltAssignmentStatement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltAssignmentStatement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusStatementsSchemaSchemaDefinition singleton

! !

!PltAssignmentStatement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltAssignmentStatement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltAssignmentStatement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltAssignmentStatement methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptAssignmentStatement: self

! !

!PltAssignmentStatement methodsFor: 'platypus-generated-copying' stamp: ''!
assignmentStatementCopyTo: another
	another fastSetLeft: self left.
	another fastSetRightExpr: self rightExpr

! !

!PltAssignmentStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
assignmentStatementFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setLeft: valuesloc removeFirst.
	self setRightExpr: valuesloc removeFirst.
	^ valuesloc

! !

!PltAssignmentStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
assignmentStatementToValues: values
	values add: self left.
	values add: self rightExpr.
	^ values

! !

!PltAssignmentStatement methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetLeft: aPltAssignable
	left := aPltAssignable

! !

!PltAssignmentStatement methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetRightExpr: aPltExpression
	rightExpr := aPltExpression

! !

!PltAssignmentStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self assignmentStatementFromValues: (super fromValues: values)

! !

!PltAssignmentStatement methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltAssignmentStatement
	^ true

! !

!PltAssignmentStatement methodsFor: 'platypus-generated-accessing' stamp: ''!
left
	^ left

! !

!PltAssignmentStatement methodsFor: 'platypus-generated-accessing' stamp: ''!
left: aPltAssignable
	left := aPltAssignable

! !

!PltAssignmentStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
left: aPltAssignable rightExpr: aPltExpression 	self setLeft:aPltAssignable.	self setRightExpr:aPltExpression.

! !

!PltAssignmentStatement methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
leftUsingContext: aContext
	^ self left

! !

!PltAssignmentStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self assignmentStatementFromValues: values

! !

!PltAssignmentStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self assignmentStatementToValues: values

! !

!PltAssignmentStatement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltAssignmentStatement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self assignmentStatementCopyTo: another

! !

!PltAssignmentStatement methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self assignmentStatementCopyTo: another

! !

!PltAssignmentStatement methodsFor: 'platypus-generated-accessing' stamp: ''!
rightExpr
	^ rightExpr

! !

!PltAssignmentStatement methodsFor: 'platypus-generated-accessing' stamp: ''!
rightExpr: aPltExpression
	rightExpr := aPltExpression

! !

!PltAssignmentStatement methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
rightExprUsingContext: aContext
	^ self rightExpr

! !

!PltAssignmentStatement methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setLeft: aPltAssignable
	self left: aPltAssignable

! !

!PltAssignmentStatement methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setRightExpr: aPltExpression
	self rightExpr: aPltExpression

! !

!PltAssignmentStatement methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	left := nil.
	rightExpr := nil

! !

!PltAssignmentStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self assignmentStatementToValues: (super toValues: values)

! !

PltStatement subclass: #PltCaseStatement
	instanceVariableNames: 'caseActions caseOtherwise selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusStatementsSchemaSchema'!

!PltCaseStatement commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY case_statement 
	SUBTYPE OF ( statement );
	selector : expression;
	case_actions : LIST OF case_action;
	case_otherwise : OPTIONAL statement;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltCaseStatement class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltCaseStatement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltCaseStatement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltCaseStatement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusStatementsSchemaSchemaDefinition singleton

! !

!PltCaseStatement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltCaseStatement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltCaseStatement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltCaseStatement methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptCaseStatement: self

! !

!PltCaseStatement methodsFor: 'platypus-generated-accessing' stamp: ''!
caseActions
	^ caseActions

! !

!PltCaseStatement methodsFor: 'platypus-generated-accessing' stamp: ''!
caseActions: aListOfPltCaseAction
	caseActions := aListOfPltCaseAction
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfPltCaseAction as: OrderedCollection ]

! !

!PltCaseStatement methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
caseActionsUsingContext: aContext
	^ self caseActions

! !

!PltCaseStatement methodsFor: 'platypus-generated-accessing' stamp: ''!
caseOtherwise
	^ caseOtherwise

! !

!PltCaseStatement methodsFor: 'platypus-generated-accessing' stamp: ''!
caseOtherwise: aPltStatement
	caseOtherwise := aPltStatement

! !

!PltCaseStatement methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
caseOtherwiseUsingContext: aContext
	^ self caseOtherwise

! !

!PltCaseStatement methodsFor: 'platypus-generated-copying' stamp: ''!
caseStatementCopyTo: another
	another fastSetSelector: self selector.
	another fastSetCaseActions: self caseActions.
	another fastSetCaseOtherwise: self caseOtherwise

! !

!PltCaseStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
caseStatementFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setSelector: valuesloc removeFirst.
	self setCaseActions: valuesloc removeFirst.
	self setCaseOtherwise: valuesloc removeFirst.
	^ valuesloc

! !

!PltCaseStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
caseStatementToValues: values
	values add: self selector.
	values add: self caseActions.
	values add: self caseOtherwise.
	^ values

! !

!PltCaseStatement methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetCaseActions: aListOfPltCaseAction
	caseActions := aListOfPltCaseAction

! !

!PltCaseStatement methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetCaseOtherwise: aPltStatement
	caseOtherwise := aPltStatement

! !

!PltCaseStatement methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetSelector: aPltExpression
	selector := aPltExpression

! !

!PltCaseStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self caseStatementFromValues: (super fromValues: values)

! !

!PltCaseStatement methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltCaseStatement
	^ true

! !

!PltCaseStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self caseStatementFromValues: values

! !

!PltCaseStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self caseStatementToValues: values

! !

!PltCaseStatement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltCaseStatement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self caseStatementCopyTo: another

! !

!PltCaseStatement methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self caseStatementCopyTo: another

! !

!PltCaseStatement methodsFor: 'platypus-generated-accessing' stamp: ''!
selector
	^ selector

! !

!PltCaseStatement methodsFor: 'platypus-generated-accessing' stamp: ''!
selector: aPltExpression
	selector := aPltExpression

! !

!PltCaseStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
selector: aPltExpression caseActions: aListOfPltCaseAction caseOtherwise: aPltStatement 	self setSelector:aPltExpression.	self setCaseActions:aListOfPltCaseAction.	self setCaseOtherwise:aPltStatement.

! !

!PltCaseStatement methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
selectorUsingContext: aContext
	^ self selector

! !

!PltCaseStatement methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setCaseActions: aListOfPltCaseAction
	self caseActions: aListOfPltCaseAction

! !

!PltCaseStatement methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setCaseOtherwise: aPltStatement
	self caseOtherwise: aPltStatement

! !

!PltCaseStatement methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setSelector: aPltExpression
	self selector: aPltExpression

! !

!PltCaseStatement methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	selector := nil.
	caseActions := OrderedCollection new.
	caseOtherwise := nil

! !

!PltCaseStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self caseStatementToValues: (super toValues: values)

! !

PltStatement subclass: #PltCompoundStatement
	instanceVariableNames: 'statements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusStatementsSchemaSchema'!

!PltCompoundStatement commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY compound_statement 
	SUBTYPE OF ( statement );
	statements : LIST OF statement;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltCompoundStatement class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltCompoundStatement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltCompoundStatement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltCompoundStatement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusStatementsSchemaSchemaDefinition singleton

! !

!PltCompoundStatement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltCompoundStatement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltCompoundStatement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltCompoundStatement methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptCompoundStatement: self

! !

!PltCompoundStatement methodsFor: 'platypus-generated-copying' stamp: ''!
compoundStatementCopyTo: another
	another fastSetStatements: self statements

! !

!PltCompoundStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
compoundStatementFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setStatements: valuesloc removeFirst.
	^ valuesloc

! !

!PltCompoundStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
compoundStatementToValues: values
	values add: self statements.
	^ values

! !

!PltCompoundStatement methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetStatements: aListOfPltStatement
	statements := aListOfPltStatement

! !

!PltCompoundStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self compoundStatementFromValues: (super fromValues: values)

! !

!PltCompoundStatement methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltCompoundStatement
	^ true

! !

!PltCompoundStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self compoundStatementFromValues: values

! !

!PltCompoundStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self compoundStatementToValues: values

! !

!PltCompoundStatement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltCompoundStatement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self compoundStatementCopyTo: another

! !

!PltCompoundStatement methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self compoundStatementCopyTo: another

! !

!PltCompoundStatement methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setStatements: aListOfPltStatement
	self statements: aListOfPltStatement

! !

!PltCompoundStatement methodsFor: 'platypus-generated-accessing' stamp: ''!
statements
	^ statements

! !

!PltCompoundStatement methodsFor: 'platypus-generated-accessing' stamp: ''!
statements: aListOfPltStatement
	statements := aListOfPltStatement
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfPltStatement as: OrderedCollection ]

! !

!PltCompoundStatement methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
statementsUsingContext: aContext
	^ self statements

! !

!PltCompoundStatement methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	statements := OrderedCollection new

! !

!PltCompoundStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self compoundStatementToValues: (super toValues: values)

! !

PltStatement subclass: #PltEndSplitmarkStatement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusStatementsSchemaSchema'!

!PltEndSplitmarkStatement commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY end_splitmark_statement 
	SUBTYPE OF ( statement );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltEndSplitmarkStatement class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltEndSplitmarkStatement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltEndSplitmarkStatement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltEndSplitmarkStatement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusStatementsSchemaSchemaDefinition singleton

! !

!PltEndSplitmarkStatement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltEndSplitmarkStatement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltEndSplitmarkStatement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltEndSplitmarkStatement methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptEndSplitmarkStatement: self

! !

!PltEndSplitmarkStatement methodsFor: 'platypus-generated-copying' stamp: ''!
endSplitmarkStatementCopyTo: another
	

! !

!PltEndSplitmarkStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
endSplitmarkStatementFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltEndSplitmarkStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
endSplitmarkStatementToValues: values
	^ values

! !

!PltEndSplitmarkStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self endSplitmarkStatementFromValues: (super fromValues: values)

! !

!PltEndSplitmarkStatement methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltEndSplitmarkStatement
	^ true

! !

!PltEndSplitmarkStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self endSplitmarkStatementFromValues: values

! !

!PltEndSplitmarkStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self endSplitmarkStatementToValues: values

! !

!PltEndSplitmarkStatement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltEndSplitmarkStatement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self endSplitmarkStatementCopyTo: another

! !

!PltEndSplitmarkStatement methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self endSplitmarkStatementCopyTo: another

! !

!PltEndSplitmarkStatement methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltEndSplitmarkStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self endSplitmarkStatementToValues: (super toValues: values)

! !

PltStatement subclass: #PltEscapeStatement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusStatementsSchemaSchema'!

!PltEscapeStatement commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY escape_statement 
	SUBTYPE OF ( statement );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltEscapeStatement class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltEscapeStatement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltEscapeStatement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltEscapeStatement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusStatementsSchemaSchemaDefinition singleton

! !

!PltEscapeStatement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltEscapeStatement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltEscapeStatement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltEscapeStatement methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptEscapeStatement: self

! !

!PltEscapeStatement methodsFor: 'platypus-generated-copying' stamp: ''!
escapeStatementCopyTo: another
	

! !

!PltEscapeStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
escapeStatementFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltEscapeStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
escapeStatementToValues: values
	^ values

! !

!PltEscapeStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self escapeStatementFromValues: (super fromValues: values)

! !

!PltEscapeStatement methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltEscapeStatement
	^ true

! !

!PltEscapeStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self escapeStatementFromValues: values

! !

!PltEscapeStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self escapeStatementToValues: values

! !

!PltEscapeStatement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltEscapeStatement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self escapeStatementCopyTo: another

! !

!PltEscapeStatement methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self escapeStatementCopyTo: another

! !

!PltEscapeStatement methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltEscapeStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self escapeStatementToValues: (super toValues: values)

! !

PltStatement subclass: #PltIfStatement
	instanceVariableNames: 'thenStatements elseStatements selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusStatementsSchemaSchema'!

!PltIfStatement commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY if_statement 
	SUBTYPE OF ( statement );
	selector : expression;
	then_statements : LIST OF statement;
	else_statements : OPTIONAL LIST OF statement;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltIfStatement class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltIfStatement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltIfStatement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltIfStatement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusStatementsSchemaSchemaDefinition singleton

! !

!PltIfStatement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltIfStatement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltIfStatement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltIfStatement methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptIfStatement: self

! !

!PltIfStatement methodsFor: 'platypus-generated-accessing' stamp: ''!
elseStatements
	^ elseStatements

! !

!PltIfStatement methodsFor: 'platypus-generated-accessing' stamp: ''!
elseStatements: aListOfPltStatement
	elseStatements := aListOfPltStatement
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfPltStatement as: OrderedCollection ]

! !

!PltIfStatement methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
elseStatementsUsingContext: aContext
	^ self elseStatements

! !

!PltIfStatement methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetElseStatements: aListOfPltStatement
	elseStatements := aListOfPltStatement

! !

!PltIfStatement methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetSelector: aPltExpression
	selector := aPltExpression

! !

!PltIfStatement methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetThenStatements: aListOfPltStatement
	thenStatements := aListOfPltStatement

! !

!PltIfStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self ifStatementFromValues: (super fromValues: values)

! !

!PltIfStatement methodsFor: 'platypus-generated-copying' stamp: ''!
ifStatementCopyTo: another
	another fastSetSelector: self selector.
	another fastSetThenStatements: self thenStatements.
	another fastSetElseStatements: self elseStatements

! !

!PltIfStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
ifStatementFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setSelector: valuesloc removeFirst.
	self setThenStatements: valuesloc removeFirst.
	self setElseStatements: valuesloc removeFirst.
	^ valuesloc

! !

!PltIfStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
ifStatementToValues: values
	values add: self selector.
	values add: self thenStatements.
	values add: self elseStatements.
	^ values

! !

!PltIfStatement methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltIfStatement
	^ true

! !

!PltIfStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self ifStatementFromValues: values

! !

!PltIfStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self ifStatementToValues: values

! !

!PltIfStatement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltIfStatement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self ifStatementCopyTo: another

! !

!PltIfStatement methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self ifStatementCopyTo: another

! !

!PltIfStatement methodsFor: 'platypus-generated-accessing' stamp: ''!
selector
	^ selector

! !

!PltIfStatement methodsFor: 'platypus-generated-accessing' stamp: ''!
selector: aPltExpression
	selector := aPltExpression

! !

!PltIfStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
selector: aPltExpression thenStatements: aListOfPltStatement elseStatements: aListOfPltStatement1 	self setSelector:aPltExpression.	self setThenStatements:aListOfPltStatement.	self setElseStatements:aListOfPltStatement1.

! !

!PltIfStatement methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
selectorUsingContext: aContext
	^ self selector

! !

!PltIfStatement methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setElseStatements: aListOfPltStatement
	self elseStatements: aListOfPltStatement

! !

!PltIfStatement methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setSelector: aPltExpression
	self selector: aPltExpression

! !

!PltIfStatement methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setThenStatements: aListOfPltStatement
	self thenStatements: aListOfPltStatement

! !

!PltIfStatement methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	selector := nil.
	thenStatements := OrderedCollection new.
	elseStatements := nil

! !

!PltIfStatement methodsFor: 'platypus-generated-accessing' stamp: ''!
thenStatements
	^ thenStatements

! !

!PltIfStatement methodsFor: 'platypus-generated-accessing' stamp: ''!
thenStatements: aListOfPltStatement
	thenStatements := aListOfPltStatement
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfPltStatement as: OrderedCollection ]

! !

!PltIfStatement methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
thenStatementsUsingContext: aContext
	^ self thenStatements

! !

!PltIfStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self ifStatementToValues: (super toValues: values)

! !

PltStatement subclass: #PltNativeStatement
	instanceVariableNames: 'source'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusStatementsSchemaSchema'!

!PltNativeStatement commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY native_statement 
	SUBTYPE OF ( statement );
	source : native_algorithm;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltNativeStatement class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltNativeStatement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltNativeStatement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltNativeStatement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusStatementsSchemaSchemaDefinition singleton

! !

!PltNativeStatement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltNativeStatement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltNativeStatement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltNativeStatement methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptNativeStatement: self

! !

!PltNativeStatement methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetSource: aPltNativeAlgorithm
	source := aPltNativeAlgorithm

! !

!PltNativeStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self nativeStatementFromValues: (super fromValues: values)

! !

!PltNativeStatement methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltNativeStatement
	^ true

! !

!PltNativeStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self nativeStatementFromValues: values

! !

!PltNativeStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self nativeStatementToValues: values

! !

!PltNativeStatement methodsFor: 'platypus-generated-copying' stamp: ''!
nativeStatementCopyTo: another
	another fastSetSource: self source

! !

!PltNativeStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
nativeStatementFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setSource: valuesloc removeFirst.
	^ valuesloc

! !

!PltNativeStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
nativeStatementToValues: values
	values add: self source.
	^ values

! !

!PltNativeStatement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltNativeStatement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self nativeStatementCopyTo: another

! !

!PltNativeStatement methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self nativeStatementCopyTo: another

! !

!PltNativeStatement methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setSource: aPltNativeAlgorithm
	self source: aPltNativeAlgorithm

! !

!PltNativeStatement methodsFor: 'platypus-generated-accessing' stamp: ''!
source
	^ source

! !

!PltNativeStatement methodsFor: 'platypus-generated-accessing' stamp: ''!
source: aPltNativeAlgorithm
	source := aPltNativeAlgorithm

! !

!PltNativeStatement methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
sourceUsingContext: aContext
	^ self source

! !

!PltNativeStatement methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	source := nil

! !

!PltNativeStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self nativeStatementToValues: (super toValues: values)

! !

PltStatement subclass: #PltNullStatement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusStatementsSchemaSchema'!

!PltNullStatement commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY null_statement 
	SUBTYPE OF ( statement );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltNullStatement class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltNullStatement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltNullStatement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltNullStatement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusStatementsSchemaSchemaDefinition singleton

! !

!PltNullStatement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltNullStatement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltNullStatement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltNullStatement methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptNullStatement: self

! !

!PltNullStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self nullStatementFromValues: (super fromValues: values)

! !

!PltNullStatement methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltNullStatement
	^ true

! !

!PltNullStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self nullStatementFromValues: values

! !

!PltNullStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self nullStatementToValues: values

! !

!PltNullStatement methodsFor: 'platypus-generated-copying' stamp: ''!
nullStatementCopyTo: another
	

! !

!PltNullStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
nullStatementFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltNullStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
nullStatementToValues: values
	^ values

! !

!PltNullStatement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltNullStatement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self nullStatementCopyTo: another

! !

!PltNullStatement methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self nullStatementCopyTo: another

! !

!PltNullStatement methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltNullStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self nullStatementToValues: (super toValues: values)

! !

PltStatement subclass: #PltOutputStatement
	instanceVariableNames: 'output'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusStatementsSchemaSchema'!

!PltOutputStatement commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY output_statement 
	SUBTYPE OF ( statement );
	output : expression;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltOutputStatement class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltOutputStatement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltOutputStatement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltOutputStatement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusStatementsSchemaSchemaDefinition singleton

! !

!PltOutputStatement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltOutputStatement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltOutputStatement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltOutputStatement methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptOutputStatement: self

! !

!PltOutputStatement methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetOutput: aPltExpression
	output := aPltExpression

! !

!PltOutputStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self outputStatementFromValues: (super fromValues: values)

! !

!PltOutputStatement methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltOutputStatement
	^ true

! !

!PltOutputStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self outputStatementFromValues: values

! !

!PltOutputStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self outputStatementToValues: values

! !

!PltOutputStatement methodsFor: 'platypus-generated-accessing' stamp: ''!
output
	^ output

! !

!PltOutputStatement methodsFor: 'platypus-generated-accessing' stamp: ''!
output: aPltExpression
	output := aPltExpression

! !

!PltOutputStatement methodsFor: 'platypus-generated-copying' stamp: ''!
outputStatementCopyTo: another
	another fastSetOutput: self output

! !

!PltOutputStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
outputStatementFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setOutput: valuesloc removeFirst.
	^ valuesloc

! !

!PltOutputStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
outputStatementToValues: values
	values add: self output.
	^ values

! !

!PltOutputStatement methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
outputUsingContext: aContext
	^ self output

! !

!PltOutputStatement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltOutputStatement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self outputStatementCopyTo: another

! !

!PltOutputStatement methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self outputStatementCopyTo: another

! !

!PltOutputStatement methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setOutput: aPltExpression
	self output: aPltExpression

! !

!PltOutputStatement methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	output := nil

! !

!PltOutputStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self outputStatementToValues: (super toValues: values)

! !

PltStatement subclass: #PltProcedureCallStatement
	instanceVariableNames: 'call'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusStatementsSchemaSchema'!

!PltProcedureCallStatement commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY procedure_call_statement 
	SUBTYPE OF ( statement );
	call : identifier;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltProcedureCallStatement class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltProcedureCallStatement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltProcedureCallStatement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltProcedureCallStatement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusStatementsSchemaSchemaDefinition singleton

! !

!PltProcedureCallStatement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltProcedureCallStatement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltProcedureCallStatement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltProcedureCallStatement methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptProcedureCallStatement: self

! !

!PltProcedureCallStatement methodsFor: 'platypus-generated-accessing' stamp: ''!
call
	^ call

! !

!PltProcedureCallStatement methodsFor: 'platypus-generated-accessing' stamp: ''!
call: aPltIdentifier
	call := aPltIdentifier

! !

!PltProcedureCallStatement methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
callUsingContext: aContext
	^ self call

! !

!PltProcedureCallStatement methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetCall: aPltIdentifier
	call := aPltIdentifier

! !

!PltProcedureCallStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self procedureCallStatementFromValues: (super fromValues: values)

! !

!PltProcedureCallStatement methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltProcedureCallStatement
	^ true

! !

!PltProcedureCallStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self procedureCallStatementFromValues: values

! !

!PltProcedureCallStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self procedureCallStatementToValues: values

! !

!PltProcedureCallStatement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltProcedureCallStatement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self procedureCallStatementCopyTo: another

! !

!PltProcedureCallStatement methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self procedureCallStatementCopyTo: another

! !

!PltProcedureCallStatement methodsFor: 'platypus-generated-copying' stamp: ''!
procedureCallStatementCopyTo: another
	another fastSetCall: self call

! !

!PltProcedureCallStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
procedureCallStatementFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setCall: valuesloc removeFirst.
	^ valuesloc

! !

!PltProcedureCallStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
procedureCallStatementToValues: values
	values add: self call.
	^ values

! !

!PltProcedureCallStatement methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setCall: aPltIdentifier
	self call: aPltIdentifier

! !

!PltProcedureCallStatement methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	call := nil

! !

!PltProcedureCallStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self procedureCallStatementToValues: (super toValues: values)

! !

PltStatement subclass: #PltRepeatStatement
	instanceVariableNames: 'incrControl whileControl statements untilControl'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusStatementsSchemaSchema'!

!PltRepeatStatement commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY repeat_statement 
	SUBTYPE OF ( statement );
	incr_control : OPTIONAL increment_control;
	until_control : OPTIONAL expression;
	while_control : OPTIONAL expression;
	statements : LIST OF statement;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltRepeatStatement class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltRepeatStatement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltRepeatStatement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltRepeatStatement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusStatementsSchemaSchemaDefinition singleton

! !

!PltRepeatStatement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltRepeatStatement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltRepeatStatement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltRepeatStatement methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptRepeatStatement: self

! !

!PltRepeatStatement methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetIncrControl: aPltIncrementControl
	incrControl := aPltIncrementControl

! !

!PltRepeatStatement methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetStatements: aListOfPltStatement
	statements := aListOfPltStatement

! !

!PltRepeatStatement methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetUntilControl: aPltExpression
	untilControl := aPltExpression

! !

!PltRepeatStatement methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetWhileControl: aPltExpression
	whileControl := aPltExpression

! !

!PltRepeatStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self repeatStatementFromValues: (super fromValues: values)

! !

!PltRepeatStatement methodsFor: 'platypus-generated-accessing' stamp: ''!
incrControl
	^ incrControl

! !

!PltRepeatStatement methodsFor: 'platypus-generated-accessing' stamp: ''!
incrControl: aPltIncrementControl
	incrControl := aPltIncrementControl

! !

!PltRepeatStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
incrControl: aPltIncrementControl untilControl: aPltExpression whileControl: aPltExpression1 statements: aListOfPltStatement 	self setIncrControl:aPltIncrementControl.	self setUntilControl:aPltExpression.	self setWhileControl:aPltExpression1.	self setStatements:aListOfPltStatement.

! !

!PltRepeatStatement methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
incrControlUsingContext: aContext
	^ self incrControl

! !

!PltRepeatStatement methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltRepeatStatement
	^ true

! !

!PltRepeatStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self repeatStatementFromValues: values

! !

!PltRepeatStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self repeatStatementToValues: values

! !

!PltRepeatStatement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltRepeatStatement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self repeatStatementCopyTo: another

! !

!PltRepeatStatement methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self repeatStatementCopyTo: another

! !

!PltRepeatStatement methodsFor: 'platypus-generated-copying' stamp: ''!
repeatStatementCopyTo: another
	another fastSetIncrControl: self incrControl.
	another fastSetUntilControl: self untilControl.
	another fastSetWhileControl: self whileControl.
	another fastSetStatements: self statements

! !

!PltRepeatStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
repeatStatementFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setIncrControl: valuesloc removeFirst.
	self setUntilControl: valuesloc removeFirst.
	self setWhileControl: valuesloc removeFirst.
	self setStatements: valuesloc removeFirst.
	^ valuesloc

! !

!PltRepeatStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
repeatStatementToValues: values
	values add: self incrControl.
	values add: self untilControl.
	values add: self whileControl.
	values add: self statements.
	^ values

! !

!PltRepeatStatement methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setIncrControl: aPltIncrementControl
	self incrControl: aPltIncrementControl

! !

!PltRepeatStatement methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setStatements: aListOfPltStatement
	self statements: aListOfPltStatement

! !

!PltRepeatStatement methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setUntilControl: aPltExpression
	self untilControl: aPltExpression

! !

!PltRepeatStatement methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setWhileControl: aPltExpression
	self whileControl: aPltExpression

! !

!PltRepeatStatement methodsFor: 'platypus-generated-accessing' stamp: ''!
statements
	^ statements

! !

!PltRepeatStatement methodsFor: 'platypus-generated-accessing' stamp: ''!
statements: aListOfPltStatement
	statements := aListOfPltStatement
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfPltStatement as: OrderedCollection ]

! !

!PltRepeatStatement methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
statementsUsingContext: aContext
	^ self statements

! !

!PltRepeatStatement methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	incrControl := nil.
	untilControl := nil.
	whileControl := nil.
	statements := OrderedCollection new

! !

!PltRepeatStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self repeatStatementToValues: (super toValues: values)

! !

!PltRepeatStatement methodsFor: 'platypus-generated-accessing' stamp: ''!
untilControl
	^ untilControl

! !

!PltRepeatStatement methodsFor: 'platypus-generated-accessing' stamp: ''!
untilControl: aPltExpression
	untilControl := aPltExpression

! !

!PltRepeatStatement methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
untilControlUsingContext: aContext
	^ self untilControl

! !

!PltRepeatStatement methodsFor: 'platypus-generated-accessing' stamp: ''!
whileControl
	^ whileControl

! !

!PltRepeatStatement methodsFor: 'platypus-generated-accessing' stamp: ''!
whileControl: aPltExpression
	whileControl := aPltExpression

! !

!PltRepeatStatement methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
whileControlUsingContext: aContext
	^ self whileControl

! !

PltStatement subclass: #PltReturnStatement
	instanceVariableNames: 'returned'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusStatementsSchemaSchema'!

!PltReturnStatement commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY return_statement 
	SUBTYPE OF ( statement );
	returned : OPTIONAL expression;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltReturnStatement class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltReturnStatement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltReturnStatement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltReturnStatement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusStatementsSchemaSchemaDefinition singleton

! !

!PltReturnStatement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltReturnStatement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltReturnStatement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltReturnStatement methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptReturnStatement: self

! !

!PltReturnStatement methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetReturned: aPltExpression
	returned := aPltExpression

! !

!PltReturnStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self returnStatementFromValues: (super fromValues: values)

! !

!PltReturnStatement methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltReturnStatement
	^ true

! !

!PltReturnStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self returnStatementFromValues: values

! !

!PltReturnStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self returnStatementToValues: values

! !

!PltReturnStatement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltReturnStatement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self returnStatementCopyTo: another

! !

!PltReturnStatement methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self returnStatementCopyTo: another

! !

!PltReturnStatement methodsFor: 'platypus-generated-copying' stamp: ''!
returnStatementCopyTo: another
	another fastSetReturned: self returned

! !

!PltReturnStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
returnStatementFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setReturned: valuesloc removeFirst.
	^ valuesloc

! !

!PltReturnStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
returnStatementToValues: values
	values add: self returned.
	^ values

! !

!PltReturnStatement methodsFor: 'platypus-generated-accessing' stamp: ''!
returned
	^ returned

! !

!PltReturnStatement methodsFor: 'platypus-generated-accessing' stamp: ''!
returned: aPltExpression
	returned := aPltExpression

! !

!PltReturnStatement methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
returnedUsingContext: aContext
	^ self returned

! !

!PltReturnStatement methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setReturned: aPltExpression
	self returned: aPltExpression

! !

!PltReturnStatement methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	returned := nil

! !

!PltReturnStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self returnStatementToValues: (super toValues: values)

! !

PltStatement subclass: #PltSkipStatement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusStatementsSchemaSchema'!

!PltSkipStatement commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY skip_statement 
	SUBTYPE OF ( statement );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltSkipStatement class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltSkipStatement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltSkipStatement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltSkipStatement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusStatementsSchemaSchemaDefinition singleton

! !

!PltSkipStatement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltSkipStatement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltSkipStatement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltSkipStatement methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptSkipStatement: self

! !

!PltSkipStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self skipStatementFromValues: (super fromValues: values)

! !

!PltSkipStatement methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltSkipStatement
	^ true

! !

!PltSkipStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self skipStatementFromValues: values

! !

!PltSkipStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self skipStatementToValues: values

! !

!PltSkipStatement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltSkipStatement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self skipStatementCopyTo: another

! !

!PltSkipStatement methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self skipStatementCopyTo: another

! !

!PltSkipStatement methodsFor: 'platypus-generated-copying' stamp: ''!
skipStatementCopyTo: another
	

! !

!PltSkipStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
skipStatementFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltSkipStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
skipStatementToValues: values
	^ values

! !

!PltSkipStatement methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltSkipStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self skipStatementToValues: (super toValues: values)

! !

PltStatement subclass: #PltSplitmarkStatement
	instanceVariableNames: 'append filename'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusStatementsSchemaSchema'!

!PltSplitmarkStatement commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY splitmark_statement 
	SUBTYPE OF ( statement );
	filename : expression;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltSplitmarkStatement class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltSplitmarkStatement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltSplitmarkStatement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltSplitmarkStatement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusStatementsSchemaSchemaDefinition singleton

! !

!PltSplitmarkStatement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltSplitmarkStatement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltSplitmarkStatement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltSplitmarkStatement methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptSplitmarkStatement: self

! !

!PltSplitmarkStatement methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetFilename: aPltExpression
	filename := aPltExpression

! !

!PltSplitmarkStatement methodsFor: 'platypus-generated-accessing' stamp: ''!
filename
	^ filename

! !

!PltSplitmarkStatement methodsFor: 'platypus-generated-accessing' stamp: ''!
filename: aPltExpression
	filename := aPltExpression

! !

!PltSplitmarkStatement methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
filenameUsingContext: aContext
	^ self filename

! !

!PltSplitmarkStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self splitmarkStatementFromValues: (super fromValues: values)

! !

!PltSplitmarkStatement methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltSplitmarkStatement
	^ true

! !

!PltSplitmarkStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self splitmarkStatementFromValues: values

! !

!PltSplitmarkStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self splitmarkStatementToValues: values

! !

!PltSplitmarkStatement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltSplitmarkStatement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self splitmarkStatementCopyTo: another

! !

!PltSplitmarkStatement methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self splitmarkStatementCopyTo: another

! !

!PltSplitmarkStatement methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setFilename: aPltExpression
	self filename: aPltExpression

! !

!PltSplitmarkStatement methodsFor: 'platypus-generated-copying' stamp: ''!
splitmarkStatementCopyTo: another
	another fastSetFilename: self filename

! !

!PltSplitmarkStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
splitmarkStatementFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setFilename: valuesloc removeFirst.
	^ valuesloc

! !

!PltSplitmarkStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
splitmarkStatementToValues: values
	values add: self filename.
	^ values

! !

!PltSplitmarkStatement methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	filename := nil

! !

!PltSplitmarkStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self splitmarkStatementToValues: (super toValues: values)

! !

!PltStatement class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltStatement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltStatement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltStatement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusStatementsSchemaSchemaDefinition singleton

! !

!PltStatement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltStatement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltStatement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltStatement methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptStatement: self

! !

!PltStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self statementFromValues: (super fromValues: values)

! !

!PltStatement methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltStatement
	^ true

! !

!PltStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self statementFromValues: values

! !

!PltStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self statementToValues: values

! !

!PltStatement methodsFor: 'platypus-generated-accessing' stamp: ''!
owner
	^ owner

! !

!PltStatement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltStatement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self statementCopyTo: another

! !

!PltStatement methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self statementCopyTo: another

! !

!PltStatement methodsFor: 'platypus-generated-copying' stamp: ''!
statementCopyTo: another
	

! !

!PltStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
statementFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
statementToValues: values
	^ values

! !

!PltStatement methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltStatement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self statementToValues: (super toValues: values)

! !

PltDictionaryInstance subclass: #PltSupertypeConstraint
	instanceVariableNames: 'expr constrained'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltSupertypeConstraint commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY supertype_constraint 
	SUBTYPE OF ( dictionary_instance );
	constrained : entity_definition_reference;
	expr : OPTIONAL supertype_expression;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltSupertypeConstraint class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltSupertypeConstraint class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltSupertypeConstraint class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltSupertypeConstraint class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltSupertypeConstraint class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltSupertypeConstraint class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltSupertypeConstraint class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltSupertypeConstraint methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptSupertypeConstraint: self

! !

!PltSupertypeConstraint methodsFor: 'platypus-generated-accessing' stamp: ''!
constrained
	^ constrained

! !

!PltSupertypeConstraint methodsFor: 'platypus-generated-accessing' stamp: ''!
constrained: aPltEntityDefinitionReference
	constrained := aPltEntityDefinitionReference

! !

!PltSupertypeConstraint methodsFor: 'platypus-generated-group-accessing' stamp: ''!
constrained: aPltEntityDefinitionReference expr: aPltSupertypeExpression 	self setConstrained:aPltEntityDefinitionReference.	self setExpr:aPltSupertypeExpression.

! !

!PltSupertypeConstraint methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
constrainedUsingContext: aContext
	^ self constrained

! !

!PltSupertypeConstraint methodsFor: 'platypus-generated-accessing' stamp: ''!
expr
	^ expr

! !

!PltSupertypeConstraint methodsFor: 'platypus-generated-accessing' stamp: ''!
expr: aPltSupertypeExpression
	expr := aPltSupertypeExpression

! !

!PltSupertypeConstraint methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
exprUsingContext: aContext
	^ self expr

! !

!PltSupertypeConstraint methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetConstrained: aPltEntityDefinitionReference
	constrained := aPltEntityDefinitionReference

! !

!PltSupertypeConstraint methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetExpr: aPltSupertypeExpression
	expr := aPltSupertypeExpression

! !

!PltSupertypeConstraint methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self supertypeConstraintFromValues: (super fromValues: values)

! !

!PltSupertypeConstraint methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltSupertypeConstraint
	^ true

! !

!PltSupertypeConstraint methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self supertypeConstraintFromValues: values

! !

!PltSupertypeConstraint methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self supertypeConstraintToValues: values

! !

!PltSupertypeConstraint methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltSupertypeConstraint methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self supertypeConstraintCopyTo: another

! !

!PltSupertypeConstraint methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self supertypeConstraintCopyTo: another

! !

!PltSupertypeConstraint methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setConstrained: aPltEntityDefinitionReference
	self constrained: aPltEntityDefinitionReference

! !

!PltSupertypeConstraint methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setExpr: aPltSupertypeExpression
	self expr: aPltSupertypeExpression

! !

!PltSupertypeConstraint methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	constrained := nil.
	expr := nil

! !

!PltSupertypeConstraint methodsFor: 'platypus-generated-copying' stamp: ''!
supertypeConstraintCopyTo: another
	another fastSetConstrained: self constrained.
	another fastSetExpr: self expr

! !

!PltSupertypeConstraint methodsFor: 'platypus-generated-group-accessing' stamp: ''!
supertypeConstraintFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setConstrained: valuesloc removeFirst.
	self setExpr: valuesloc removeFirst.
	^ valuesloc

! !

!PltSupertypeConstraint methodsFor: 'platypus-generated-group-accessing' stamp: ''!
supertypeConstraintToValues: values
	values add: self constrained.
	values add: self expr.
	^ values

! !

!PltSupertypeConstraint methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self supertypeConstraintToValues: (super toValues: values)

! !

PltDictionaryInstance subclass: #PltSupertypeExpression
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltSupertypeExpression commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY supertype_expression 
	ABSTRACT SUPERTYPE OF ( ONEOF ( sub_entity_ref_expression, binary_supertype_expression, oneof_supertype_expression ) ) 
	SUBTYPE OF ( dictionary_instance );
END_ENTITY;
</ISO10303-11-EXPRESS>!

PltSupertypeExpression subclass: #PltBinarySupertypeExpression
	instanceVariableNames: 'rightExpr parenthesis leftExpr'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltBinarySupertypeExpression commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY binary_supertype_expression 
	SUBTYPE OF ( supertype_expression );
	parenthesis : OPTIONAL BOOLEAN;
	left_expr : supertype_expression;
	right_expr : supertype_expression;
END_ENTITY;
</ISO10303-11-EXPRESS>!

PltBinarySupertypeExpression subclass: #PltAndSupertype
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltAndSupertype commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY and_supertype 
	SUBTYPE OF ( binary_supertype_expression );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltAndSupertype class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltAndSupertype class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltAndSupertype class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltAndSupertype class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltAndSupertype class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltAndSupertype class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltAndSupertype class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltAndSupertype methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptAndSupertype: self

! !

!PltAndSupertype methodsFor: 'platypus-generated-copying' stamp: ''!
andSupertypeCopyTo: another
	

! !

!PltAndSupertype methodsFor: 'platypus-generated-group-accessing' stamp: ''!
andSupertypeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltAndSupertype methodsFor: 'platypus-generated-group-accessing' stamp: ''!
andSupertypeToValues: values
	^ values

! !

!PltAndSupertype methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self andSupertypeFromValues: (super fromValues: values)

! !

!PltAndSupertype methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltAndSupertype
	^ true

! !

!PltAndSupertype methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self andSupertypeFromValues: values

! !

!PltAndSupertype methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self andSupertypeToValues: values

! !

!PltAndSupertype methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltAndSupertype methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self andSupertypeCopyTo: another

! !

!PltAndSupertype methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self andSupertypeCopyTo: another

! !

!PltAndSupertype methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltAndSupertype methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self andSupertypeToValues: (super toValues: values)

! !

PltBinarySupertypeExpression subclass: #PltAndorSupertype
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltAndorSupertype commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY andor_supertype 
	SUBTYPE OF ( binary_supertype_expression );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltAndorSupertype class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltAndorSupertype class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltAndorSupertype class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltAndorSupertype class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltAndorSupertype class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltAndorSupertype class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltAndorSupertype class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltAndorSupertype methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptAndorSupertype: self

! !

!PltAndorSupertype methodsFor: 'platypus-generated-copying' stamp: ''!
andorSupertypeCopyTo: another
	

! !

!PltAndorSupertype methodsFor: 'platypus-generated-group-accessing' stamp: ''!
andorSupertypeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltAndorSupertype methodsFor: 'platypus-generated-group-accessing' stamp: ''!
andorSupertypeToValues: values
	^ values

! !

!PltAndorSupertype methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self andorSupertypeFromValues: (super fromValues: values)

! !

!PltAndorSupertype methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltAndorSupertype
	^ true

! !

!PltAndorSupertype methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self andorSupertypeFromValues: values

! !

!PltAndorSupertype methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self andorSupertypeToValues: values

! !

!PltAndorSupertype methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltAndorSupertype methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self andorSupertypeCopyTo: another

! !

!PltAndorSupertype methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self andorSupertypeCopyTo: another

! !

!PltAndorSupertype methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltAndorSupertype methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self andorSupertypeToValues: (super toValues: values)

! !

!PltBinarySupertypeExpression class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltBinarySupertypeExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltBinarySupertypeExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltBinarySupertypeExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltBinarySupertypeExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltBinarySupertypeExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltBinarySupertypeExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltBinarySupertypeExpression methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptBinarySupertypeExpression: self

! !

!PltBinarySupertypeExpression methodsFor: 'platypus-generated-copying' stamp: ''!
binarySupertypeExpressionCopyTo: another
	another fastSetParenthesis: self parenthesis.
	another fastSetLeftExpr: self leftExpr.
	another fastSetRightExpr: self rightExpr

! !

!PltBinarySupertypeExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
binarySupertypeExpressionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setParenthesis: valuesloc removeFirst.
	self setLeftExpr: valuesloc removeFirst.
	self setRightExpr: valuesloc removeFirst.
	^ valuesloc

! !

!PltBinarySupertypeExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
binarySupertypeExpressionToValues: values
	values add: self parenthesis.
	values add: self leftExpr.
	values add: self rightExpr.
	^ values

! !

!PltBinarySupertypeExpression methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetLeftExpr: aPltSupertypeExpression
	leftExpr := aPltSupertypeExpression

! !

!PltBinarySupertypeExpression methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetParenthesis: aBoolean
	parenthesis := aBoolean

! !

!PltBinarySupertypeExpression methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetRightExpr: aPltSupertypeExpression
	rightExpr := aPltSupertypeExpression

! !

!PltBinarySupertypeExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self binarySupertypeExpressionFromValues: (super fromValues: values)

! !

!PltBinarySupertypeExpression methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltBinarySupertypeExpression
	^ true

! !

!PltBinarySupertypeExpression methodsFor: 'platypus-generated-accessing' stamp: ''!
leftExpr
	^ leftExpr

! !

!PltBinarySupertypeExpression methodsFor: 'platypus-generated-accessing' stamp: ''!
leftExpr: aPltSupertypeExpression
	leftExpr := aPltSupertypeExpression

! !

!PltBinarySupertypeExpression methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
leftExprUsingContext: aContext
	^ self leftExpr

! !

!PltBinarySupertypeExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self binarySupertypeExpressionFromValues: values

! !

!PltBinarySupertypeExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self binarySupertypeExpressionToValues: values

! !

!PltBinarySupertypeExpression methodsFor: 'platypus-generated-accessing' stamp: ''!
parenthesis
	^ parenthesis

! !

!PltBinarySupertypeExpression methodsFor: 'platypus-generated-accessing' stamp: ''!
parenthesis: aBoolean
	parenthesis := aBoolean

! !

!PltBinarySupertypeExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
parenthesis: aBoolean leftExpr: aPltSupertypeExpression rightExpr: aPltSupertypeExpression1 	self setParenthesis:aBoolean.	self setLeftExpr:aPltSupertypeExpression.	self setRightExpr:aPltSupertypeExpression1.

! !

!PltBinarySupertypeExpression methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
parenthesisUsingContext: aContext
	^ self parenthesis

! !

!PltBinarySupertypeExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltBinarySupertypeExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self binarySupertypeExpressionCopyTo: another

! !

!PltBinarySupertypeExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self binarySupertypeExpressionCopyTo: another

! !

!PltBinarySupertypeExpression methodsFor: 'platypus-generated-accessing' stamp: ''!
rightExpr
	^ rightExpr

! !

!PltBinarySupertypeExpression methodsFor: 'platypus-generated-accessing' stamp: ''!
rightExpr: aPltSupertypeExpression
	rightExpr := aPltSupertypeExpression

! !

!PltBinarySupertypeExpression methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
rightExprUsingContext: aContext
	^ self rightExpr

! !

!PltBinarySupertypeExpression methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setLeftExpr: aPltSupertypeExpression
	self leftExpr: aPltSupertypeExpression

! !

!PltBinarySupertypeExpression methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setParenthesis: aBoolean
	self parenthesis: aBoolean

! !

!PltBinarySupertypeExpression methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setRightExpr: aPltSupertypeExpression
	self rightExpr: aPltSupertypeExpression

! !

!PltBinarySupertypeExpression methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	parenthesis := nil.
	leftExpr := nil.
	rightExpr := nil

! !

!PltBinarySupertypeExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self binarySupertypeExpressionToValues: (super toValues: values)

! !

PltSupertypeExpression subclass: #PltOneofSupertypeExpression
	instanceVariableNames: 'exprList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltOneofSupertypeExpression commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY oneof_supertype_expression 
	SUBTYPE OF ( supertype_expression );
	expr_list : LIST OF supertype_expression;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltOneofSupertypeExpression class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltOneofSupertypeExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltOneofSupertypeExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltOneofSupertypeExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltOneofSupertypeExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltOneofSupertypeExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltOneofSupertypeExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltOneofSupertypeExpression methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptOneofSupertypeExpression: self

! !

!PltOneofSupertypeExpression methodsFor: 'platypus-generated-accessing' stamp: ''!
exprList
	^ exprList

! !

!PltOneofSupertypeExpression methodsFor: 'platypus-generated-accessing' stamp: ''!
exprList: aListOfPltSupertypeExpression
	exprList := aListOfPltSupertypeExpression
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfPltSupertypeExpression as: OrderedCollection ]

! !

!PltOneofSupertypeExpression methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
exprListUsingContext: aContext
	^ self exprList

! !

!PltOneofSupertypeExpression methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetExprList: aListOfPltSupertypeExpression
	exprList := aListOfPltSupertypeExpression

! !

!PltOneofSupertypeExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self oneofSupertypeExpressionFromValues: (super fromValues: values)

! !

!PltOneofSupertypeExpression methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltOneofSupertypeExpression
	^ true

! !

!PltOneofSupertypeExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self oneofSupertypeExpressionFromValues: values

! !

!PltOneofSupertypeExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self oneofSupertypeExpressionToValues: values

! !

!PltOneofSupertypeExpression methodsFor: 'platypus-generated-copying' stamp: ''!
oneofSupertypeExpressionCopyTo: another
	another fastSetExprList: self exprList

! !

!PltOneofSupertypeExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
oneofSupertypeExpressionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setExprList: valuesloc removeFirst.
	^ valuesloc

! !

!PltOneofSupertypeExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
oneofSupertypeExpressionToValues: values
	values add: self exprList.
	^ values

! !

!PltOneofSupertypeExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltOneofSupertypeExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self oneofSupertypeExpressionCopyTo: another

! !

!PltOneofSupertypeExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self oneofSupertypeExpressionCopyTo: another

! !

!PltOneofSupertypeExpression methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setExprList: aListOfPltSupertypeExpression
	self exprList: aListOfPltSupertypeExpression

! !

!PltOneofSupertypeExpression methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	exprList := OrderedCollection new

! !

!PltOneofSupertypeExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self oneofSupertypeExpressionToValues: (super toValues: values)

! !

PltSupertypeExpression subclass: #PltSubEntityRefExpression
	instanceVariableNames: 'entityRef'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltSubEntityRefExpression commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY sub_entity_ref_expression 
	SUBTYPE OF ( supertype_expression );
	entity_ref : entity_definition_reference;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltSubEntityRefExpression class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltSubEntityRefExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltSubEntityRefExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltSubEntityRefExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltSubEntityRefExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltSubEntityRefExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltSubEntityRefExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltSubEntityRefExpression methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptSubEntityRefExpression: self

! !

!PltSubEntityRefExpression methodsFor: 'platypus-generated-accessing' stamp: ''!
entityRef
	^ entityRef

! !

!PltSubEntityRefExpression methodsFor: 'platypus-generated-accessing' stamp: ''!
entityRef: aPltEntityDefinitionReference
	entityRef := aPltEntityDefinitionReference

! !

!PltSubEntityRefExpression methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
entityRefUsingContext: aContext
	^ self entityRef

! !

!PltSubEntityRefExpression methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetEntityRef: aPltEntityDefinitionReference
	entityRef := aPltEntityDefinitionReference

! !

!PltSubEntityRefExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self subEntityRefExpressionFromValues: (super fromValues: values)

! !

!PltSubEntityRefExpression methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltSubEntityRefExpression
	^ true

! !

!PltSubEntityRefExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self subEntityRefExpressionFromValues: values

! !

!PltSubEntityRefExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self subEntityRefExpressionToValues: values

! !

!PltSubEntityRefExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltSubEntityRefExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self subEntityRefExpressionCopyTo: another

! !

!PltSubEntityRefExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self subEntityRefExpressionCopyTo: another

! !

!PltSubEntityRefExpression methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setEntityRef: aPltEntityDefinitionReference
	self entityRef: aPltEntityDefinitionReference

! !

!PltSubEntityRefExpression methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	entityRef := nil

! !

!PltSubEntityRefExpression methodsFor: 'platypus-generated-copying' stamp: ''!
subEntityRefExpressionCopyTo: another
	another fastSetEntityRef: self entityRef

! !

!PltSubEntityRefExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
subEntityRefExpressionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setEntityRef: valuesloc removeFirst.
	^ valuesloc

! !

!PltSubEntityRefExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
subEntityRefExpressionToValues: values
	values add: self entityRef.
	^ values

! !

!PltSubEntityRefExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self subEntityRefExpressionToValues: (super toValues: values)

! !

!PltSupertypeExpression class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltSupertypeExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltSupertypeExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltSupertypeExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltSupertypeExpression class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltSupertypeExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltSupertypeExpression class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltSupertypeExpression methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptSupertypeExpression: self

! !

!PltSupertypeExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self supertypeExpressionFromValues: (super fromValues: values)

! !

!PltSupertypeExpression methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltSupertypeExpression
	^ true

! !

!PltSupertypeExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self supertypeExpressionFromValues: values

! !

!PltSupertypeExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self supertypeExpressionToValues: values

! !

!PltSupertypeExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltSupertypeExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self supertypeExpressionCopyTo: another

! !

!PltSupertypeExpression methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self supertypeExpressionCopyTo: another

! !

!PltSupertypeExpression methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltSupertypeExpression methodsFor: 'platypus-generated-copying' stamp: ''!
supertypeExpressionCopyTo: another
	

! !

!PltSupertypeExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
supertypeExpressionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltSupertypeExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
supertypeExpressionToValues: values
	^ values

! !

!PltSupertypeExpression methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self supertypeExpressionToValues: (super toValues: values)

! !

PltDictionaryInstance subclass: #PltUniquenessRule
	instanceVariableNames: 'label attributes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltUniquenessRule commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY uniqueness_rule 
	SUBTYPE OF ( dictionary_instance );
	label : OPTIONAL STRING;
	attributes : LIST [ 1 : ? ] OF UNIQUE uniqueness_rule_attribute_identifier;
	SELF\entity_instance.owner : entity_definition;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltUniquenessRule class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltUniquenessRule class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltUniquenessRule class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltUniquenessRule class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltUniquenessRule class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltUniquenessRule class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltUniquenessRule class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltUniquenessRule methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptUniquenessRule: self

! !

!PltUniquenessRule methodsFor: 'platypus-generated-accessing' stamp: ''!
attributes
	^ attributes

! !

!PltUniquenessRule methodsFor: 'platypus-generated-accessing' stamp: ''!
attributes: aListOfPltUniquenessRuleAttributeIdentifier
	attributes := aListOfPltUniquenessRuleAttributeIdentifier
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfPltUniquenessRuleAttributeIdentifier as: OrderedCollection ]

! !

!PltUniquenessRule methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
attributesUsingContext: aContext
	^ self attributes

! !

!PltUniquenessRule methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetAttributes: aListOfPltUniquenessRuleAttributeIdentifier
	attributes := aListOfPltUniquenessRuleAttributeIdentifier

! !

!PltUniquenessRule methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetLabel: aString
	label := aString

! !

!PltUniquenessRule methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetOwner: aPltEntityDefinition
	owner := aPltEntityDefinition

! !

!PltUniquenessRule methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self uniquenessRuleFromValues: (super fromValues: values)

! !

!PltUniquenessRule methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltUniquenessRule
	^ true

! !

!PltUniquenessRule methodsFor: 'platypus-generated-accessing' stamp: ''!
label
	^ label

! !

!PltUniquenessRule methodsFor: 'platypus-generated-accessing' stamp: ''!
label: aString
	label := aString

! !

!PltUniquenessRule methodsFor: 'platypus-generated-group-accessing' stamp: ''!
label: aString attributes: aListOfPltUniquenessRuleAttributeIdentifier owner: aPltEntityDefinition 	self setLabel:aString.	self setAttributes:aListOfPltUniquenessRuleAttributeIdentifier.	self setOwner:aPltEntityDefinition.

! !

!PltUniquenessRule methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
labelUsingContext: aContext
	^ self label

! !

!PltUniquenessRule methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self uniquenessRuleFromValues: values

! !

!PltUniquenessRule methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self uniquenessRuleToValues: values

! !

!PltUniquenessRule methodsFor: 'platypus-generated-accessing' stamp: ''!
owner
	^ owner

! !

!PltUniquenessRule methodsFor: 'platypus-generated-accessing' stamp: ''!
owner: aPltEntityDefinition
	owner := aPltEntityDefinition

! !

!PltUniquenessRule methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
ownerUsingContext: aContext
	^ self owner

! !

!PltUniquenessRule methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltUniquenessRule methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self uniquenessRuleCopyTo: another

! !

!PltUniquenessRule methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self uniquenessRuleCopyTo: another

! !

!PltUniquenessRule methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setAttributes: aListOfPltUniquenessRuleAttributeIdentifier
	self attributes: aListOfPltUniquenessRuleAttributeIdentifier

! !

!PltUniquenessRule methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setLabel: aString
	self label: aString

! !

!PltUniquenessRule methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setOwner: aPltEntityDefinition
	self owner: aPltEntityDefinition

! !

!PltUniquenessRule methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	label := nil.
	attributes := OrderedCollection new.
	owner := nil

! !

!PltUniquenessRule methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self uniquenessRuleToValues: (super toValues: values)

! !

!PltUniquenessRule methodsFor: 'platypus-generated-copying' stamp: ''!
uniquenessRuleCopyTo: another
	another fastSetLabel: self label.
	another fastSetAttributes: self attributes.
	another fastSetOwner: self owner

! !

!PltUniquenessRule methodsFor: 'platypus-generated-group-accessing' stamp: ''!
uniquenessRuleFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setLabel: valuesloc removeFirst.
	self setAttributes: valuesloc removeFirst.
	self setOwner: valuesloc removeFirst.
	^ valuesloc

! !

!PltUniquenessRule methodsFor: 'platypus-generated-group-accessing' stamp: ''!
uniquenessRuleToValues: values
	values add: self label.
	values add: self attributes.
	values add: self owner.
	^ values

! !

PltDictionaryInstance subclass: #PltUnresolvedSymbol
	instanceVariableNames: 'token resolver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

PltDictionaryInstance subclass: #PltWhereRule
	instanceVariableNames: 'whereValue label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltWhereRule commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY where_rule 
	SUBTYPE OF ( dictionary_instance );
	label : OPTIONAL STRING;
	SELF\entity_instance.owner : type_or_rule;
	where_value : expression;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltWhereRule class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltWhereRule class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltWhereRule class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltWhereRule class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltWhereRule class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltWhereRule class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltWhereRule class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltWhereRule methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptWhereRule: self

! !

!PltWhereRule methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetLabel: aString
	label := aString

! !

!PltWhereRule methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetOwner: aPltTypeOrRule
	owner := aPltTypeOrRule

! !

!PltWhereRule methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetWhereValue: aPltExpression
	whereValue := aPltExpression

! !

!PltWhereRule methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self whereRuleFromValues: (super fromValues: values)

! !

!PltWhereRule methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltWhereRule
	^ true

! !

!PltWhereRule methodsFor: 'platypus-generated-accessing' stamp: ''!
label
	^ label

! !

!PltWhereRule methodsFor: 'platypus-generated-accessing' stamp: ''!
label: aString
	label := aString

! !

!PltWhereRule methodsFor: 'platypus-generated-group-accessing' stamp: ''!
label: aString owner: aPltTypeOrRule whereValue: aPltExpression 	self setLabel:aString.	self setOwner:aPltTypeOrRule.	self setWhereValue:aPltExpression.

! !

!PltWhereRule methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
labelUsingContext: aContext
	^ self label

! !

!PltWhereRule methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self whereRuleFromValues: values

! !

!PltWhereRule methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self whereRuleToValues: values

! !

!PltWhereRule methodsFor: 'platypus-generated-accessing' stamp: ''!
owner
	^ owner

! !

!PltWhereRule methodsFor: 'platypus-generated-accessing' stamp: ''!
owner: aPltTypeOrRule
	owner := aPltTypeOrRule

! !

!PltWhereRule methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
ownerUsingContext: aContext
	^ self owner

! !

!PltWhereRule methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltWhereRule methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self whereRuleCopyTo: another

! !

!PltWhereRule methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self whereRuleCopyTo: another

! !

!PltWhereRule methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setLabel: aString
	self label: aString

! !

!PltWhereRule methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setOwner: aPltTypeOrRule
	self owner: aPltTypeOrRule

! !

!PltWhereRule methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setWhereValue: aPltExpression
	self whereValue: aPltExpression

! !

!PltWhereRule methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	label := nil.
	owner := nil.
	whereValue := nil

! !

!PltWhereRule methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self whereRuleToValues: (super toValues: values)

! !

!PltWhereRule methodsFor: 'platypus-generated-copying' stamp: ''!
whereRuleCopyTo: another
	another fastSetLabel: self label.
	another fastSetOwner: self owner.
	another fastSetWhereValue: self whereValue

! !

!PltWhereRule methodsFor: 'platypus-generated-group-accessing' stamp: ''!
whereRuleFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setLabel: valuesloc removeFirst.
	self setOwner: valuesloc removeFirst.
	self setWhereValue: valuesloc removeFirst.
	^ valuesloc

! !

!PltWhereRule methodsFor: 'platypus-generated-group-accessing' stamp: ''!
whereRuleToValues: values
	values add: self label.
	values add: self owner.
	values add: self whereValue.
	^ values

! !

!PltWhereRule methodsFor: 'platypus-generated-accessing' stamp: ''!
whereValue
	^ whereValue

! !

!PltWhereRule methodsFor: 'platypus-generated-accessing' stamp: ''!
whereValue: aPltExpression
	whereValue := aPltExpression

! !

!PltWhereRule methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
whereValueUsingContext: aContext
	^ self whereValue

! !

!PltSdaiInstance class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltSdaiInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltSdaiInstance class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltSdaiInstance class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltSdaiInstance class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltSdaiInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltSdaiInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltSdaiInstance methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptSdaiInstance: self

! !

!PltSdaiInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self sdaiInstanceFromValues: (super fromValues: values)

! !

!PltSdaiInstance methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltSdaiInstance
	^ true

! !

!PltSdaiInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self sdaiInstanceFromValues: values

! !

!PltSdaiInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self sdaiInstanceToValues: values

! !

!PltSdaiInstance methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltSdaiInstance methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self sdaiInstanceCopyTo: another

! !

!PltSdaiInstance methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self sdaiInstanceCopyTo: another

! !

!PltSdaiInstance methodsFor: 'platypus-generated-copying' stamp: ''!
sdaiInstanceCopyTo: another
	

! !

!PltSdaiInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
sdaiInstanceFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!PltSdaiInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
sdaiInstanceToValues: values
	^ values

! !

!PltSdaiInstance methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!PltSdaiInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self sdaiInstanceToValues: (super toValues: values)

! !

PltSdaiInstance subclass: #PltSessionInstance
	instanceVariableNames: 'validationResult validationDate changeDate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusDictionarySchemaSchema'!

!PltSessionInstance commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY session_instance 
	ABSTRACT SUPERTYPE 
	SUBTYPE OF ( sdai_instance );
	change_date : OPTIONAL time_stamp;
	validation_date : time_stamp;
	validation_result : LOGICAL;
END_ENTITY;
</ISO10303-11-EXPRESS>!

PltSessionInstance subclass: #PltInstanceScope
	instanceVariableNames: 'owned exportList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusPopulationSchemaSchema'!

!PltInstanceScope commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY instance_scope 
	SUBTYPE OF ( session_instance );
	owned : LIST [ 1 : ? ] OF entity_instance;
	export_list : LIST [ 0 : ? ] OF entity_instance;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltInstanceScope class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltInstanceScope class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltInstanceScope class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltInstanceScope class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusPopulationSchemaSchemaDefinition singleton

! !

!PltInstanceScope class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltInstanceScope class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltInstanceScope class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltInstanceScope methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptInstanceScope: self

! !

!PltInstanceScope methodsFor: 'platypus-generated-accessing' stamp: ''!
exportList
	^ exportList

! !

!PltInstanceScope methodsFor: 'platypus-generated-accessing' stamp: ''!
exportList: aListOfPltEntityInstance
	exportList := aListOfPltEntityInstance
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfPltEntityInstance as: OrderedCollection ]

! !

!PltInstanceScope methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
exportListUsingContext: aContext
	^ self exportList

! !

!PltInstanceScope methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetExportList: aListOfPltEntityInstance
	exportList := aListOfPltEntityInstance

! !

!PltInstanceScope methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetOwned: aListOfPltEntityInstance
	owned := aListOfPltEntityInstance

! !

!PltInstanceScope methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self instanceScopeFromValues: (super fromValues: values)

! !

!PltInstanceScope methodsFor: 'platypus-generated-copying' stamp: ''!
instanceScopeCopyTo: another
	another fastSetOwned: self owned.
	another fastSetExportList: self exportList

! !

!PltInstanceScope methodsFor: 'platypus-generated-group-accessing' stamp: ''!
instanceScopeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setOwned: valuesloc removeFirst.
	self setExportList: valuesloc removeFirst.
	^ valuesloc

! !

!PltInstanceScope methodsFor: 'platypus-generated-group-accessing' stamp: ''!
instanceScopeToValues: values
	values add: self owned.
	values add: self exportList.
	^ values

! !

!PltInstanceScope methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltInstanceScope
	^ true

! !

!PltInstanceScope methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self instanceScopeFromValues: values

! !

!PltInstanceScope methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self instanceScopeToValues: values

! !

!PltInstanceScope methodsFor: 'platypus-generated-accessing' stamp: ''!
owned
	^ owned

! !

!PltInstanceScope methodsFor: 'platypus-generated-accessing' stamp: ''!
owned: aListOfPltEntityInstance
	owned := aListOfPltEntityInstance
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfPltEntityInstance as: OrderedCollection ]

! !

!PltInstanceScope methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
ownedUsingContext: aContext
	^ self owned

! !

!PltInstanceScope methodsFor: 'platypus-generated-accessing' stamp: ''!
owner
	^ owner

! !

!PltInstanceScope methodsFor: 'platypus-generated-group-accessing' stamp: ''!
owner: aPltEntityInstance owned: aListOfPltEntityInstance exportList: aListOfPltEntityInstance1 	self setOwner:aPltEntityInstance.	self setOwned:aListOfPltEntityInstance.	self setExportList:aListOfPltEntityInstance1.

! !

!PltInstanceScope methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltInstanceScope methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self instanceScopeCopyTo: another

! !

!PltInstanceScope methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self instanceScopeCopyTo: another

! !

!PltInstanceScope methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setExportList: aListOfPltEntityInstance
	self exportList: aListOfPltEntityInstance

! !

!PltInstanceScope methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setOwned: aListOfPltEntityInstance
	self owned: aListOfPltEntityInstance

! !

!PltInstanceScope methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	owned := OrderedCollection new.
	exportList := OrderedCollection new

! !

!PltInstanceScope methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self instanceScopeToValues: (super toValues: values)

! !

PltSessionInstance subclass: #PltModelContents
	instanceVariableNames: 'headerInstances dataInstances positionByDataInstanceIndex dataInstancesByEntityIndex dataInstancesByLabelIndex recordComputedInstances entitiesByInstanceIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusEnvironmentSchemaSchema'!

!PltModelContents commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY model_contents 
	SUBTYPE OF ( session_instance );
	SELF\entity_instance.owner : schema_instance;
INVERSE
	instances : SET [ 0 : ? ] OF application_instance FOR owning_model;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltModelContents class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltModelContents class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltModelContents class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltModelContents class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusEnvironmentSchemaSchemaDefinition singleton

! !

!PltModelContents class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltModelContents class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltModelContents class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltModelContents methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptModelContents: self

! !

!PltModelContents methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetOwner: aPltSchemaInstance
	owner := aPltSchemaInstance

! !

!PltModelContents methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self modelContentsFromValues: (super fromValues: values)

! !

!PltModelContents methodsFor: 'platypus-generated-inverse-accessing' stamp: ''!
instances
	^ self instancesUsingContext: self class context

! !

!PltModelContents methodsFor: 'platypus-generated-inverse-accessing' stamp: ''!
instancesUsingContext: aContext
	| founds |
	founds := Set new.
	aContext
		allInstancesOf: PltApplicationInstance
		do: [ :repo :inst | 
			| curr |
			(curr := inst owningModel) == self
				ifTrue: [ founds add: curr ] ].
	^ founds

! !

!PltModelContents methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltModelContents
	^ true

! !

!PltModelContents methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self modelContentsFromValues: values

! !

!PltModelContents methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self modelContentsToValues: values

! !

!PltModelContents methodsFor: 'platypus-generated-copying' stamp: ''!
modelContentsCopyTo: another
	another fastSetOwner: self owner

! !

!PltModelContents methodsFor: 'platypus-generated-group-accessing' stamp: ''!
modelContentsFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setOwner: valuesloc removeFirst.
	^ valuesloc

! !

!PltModelContents methodsFor: 'platypus-generated-group-accessing' stamp: ''!
modelContentsToValues: values
	values add: self owner.
	^ values

! !

!PltModelContents methodsFor: 'platypus-generated-accessing' stamp: ''!
owner
	^ owner

! !

!PltModelContents methodsFor: 'platypus-generated-accessing' stamp: ''!
owner: aPltSchemaInstance
	owner := aPltSchemaInstance

! !

!PltModelContents methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
ownerUsingContext: aContext
	^ self owner

! !

!PltModelContents methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltModelContents methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self modelContentsCopyTo: another

! !

!PltModelContents methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self modelContentsCopyTo: another

! !

!PltModelContents methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setOwner: aPltSchemaInstance
	self owner: aPltSchemaInstance

! !

!PltModelContents methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	owner := nil

! !

!PltModelContents methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self modelContentsToValues: (super toValues: values)

! !

PltSessionInstance subclass: #PltSchemaInstance
	instanceVariableNames: 'associatedModels tamarisItemReferencesIndex schemata name metaConceptsIndex errorsIndex namesBuilder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusEnvironmentSchemaSchema'!

!PltSchemaInstance commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY schema_instance 
	SUBTYPE OF ( session_instance );
	name : STRING;
	associated_models : LIST [ 0 : ? ] OF model_contents;
	schemata : LIST [ 0 : ? ] OF schema_definition;
DERIVE
	accepted : entity_instance := SELF.accept_schema_instance;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltSchemaInstance class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltSchemaInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltSchemaInstance class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltSchemaInstance class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusEnvironmentSchemaSchemaDefinition singleton

! !

!PltSchemaInstance class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltSchemaInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltSchemaInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltSchemaInstance methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptSchemaInstance: self

! !

!PltSchemaInstance methodsFor: 'platypus-generated-deriving' stamp: ''!
accepted
	^ self acceptedUsingContext: self class context

! !

!PltSchemaInstance methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext
	^ self acceptedUsingContext: aContext receiver: self

! !

!PltSchemaInstance methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext receiver: aReceiver
	^ aReceiver acceptSchemaInstanceUsingContext: aContext

! !

!PltSchemaInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
associatedModels
	^ associatedModels

! !

!PltSchemaInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
associatedModels: aListOfPltModelContents
	associatedModels := aListOfPltModelContents
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfPltModelContents as: OrderedCollection ]

! !

!PltSchemaInstance methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
associatedModelsUsingContext: aContext
	^ self associatedModels

! !

!PltSchemaInstance methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetAssociatedModels: aListOfPltModelContents
	associatedModels := aListOfPltModelContents

! !

!PltSchemaInstance methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetName: aString
	name := aString

! !

!PltSchemaInstance methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetSchemata: aListOfPltSchemaDefinition
	schemata := aListOfPltSchemaDefinition

! !

!PltSchemaInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self schemaInstanceFromValues: (super fromValues: values)

! !

!PltSchemaInstance methodsFor: 'platypus-generated-accessing' stamp: 'AlainPlantec 5/11/2012 14:25'!
interpreterScope 
	^ self associatedModels ifEmpty: [] ifNotEmpty: [:l | l first]

! !

!PltSchemaInstance methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltSchemaInstance
	^ true

! !

!PltSchemaInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self schemaInstanceFromValues: values

! !

!PltSchemaInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self schemaInstanceToValues: values

! !

!PltSchemaInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
name
	^ name

! !

!PltSchemaInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
name: aString
	name := aString

! !

!PltSchemaInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
name: aString associatedModels: aListOfPltModelContents schemata: aListOfPltSchemaDefinition 	self setName:aString.	self setAssociatedModels:aListOfPltModelContents.	self setSchemata:aListOfPltSchemaDefinition.

! !

!PltSchemaInstance methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
nameUsingContext: aContext
	^ self name

! !

!PltSchemaInstance methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltSchemaInstance methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self schemaInstanceCopyTo: another

! !

!PltSchemaInstance methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self schemaInstanceCopyTo: another

! !

!PltSchemaInstance methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 6/15/2012 12:34'!
schemaInstance
	^ self! !

!PltSchemaInstance methodsFor: 'platypus-generated-copying' stamp: ''!
schemaInstanceCopyTo: another
	another fastSetName: self name.
	another fastSetAssociatedModels: self associatedModels.
	another fastSetSchemata: self schemata

! !

!PltSchemaInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
schemaInstanceFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setName: valuesloc removeFirst.
	self setAssociatedModels: valuesloc removeFirst.
	self setSchemata: valuesloc removeFirst.
	^ valuesloc

! !

!PltSchemaInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
schemaInstanceToValues: values
	values add: self name.
	values add: self associatedModels.
	values add: self schemata.
	^ values

! !

!PltSchemaInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
schemata
	^ schemata

! !

!PltSchemaInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
schemata: aListOfPltSchemaDefinition
	schemata := aListOfPltSchemaDefinition
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfPltSchemaDefinition as: OrderedCollection ]

! !

!PltSchemaInstance methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
schemataUsingContext: aContext
	^ self schemata

! !

!PltSchemaInstance methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setAssociatedModels: aListOfPltModelContents
	self associatedModels: aListOfPltModelContents

! !

!PltSchemaInstance methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setName: aString
	self name: aString

! !

!PltSchemaInstance methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setSchemata: aListOfPltSchemaDefinition
	self schemata: aListOfPltSchemaDefinition

! !

!PltSchemaInstance methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	name := ''.
	associatedModels := OrderedCollection new.
	schemata := OrderedCollection new

! !

!PltSchemaInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self schemaInstanceToValues: (super toValues: values)

! !

!PltSessionInstance class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltSessionInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltSessionInstance class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltSessionInstance class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusDictionarySchemaSchemaDefinition singleton

! !

!PltSessionInstance class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltSessionInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltSessionInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltSessionInstance methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptSessionInstance: self

! !

!PltSessionInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
changeDate
	^ changeDate

! !

!PltSessionInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
changeDate: aString
	changeDate := aString

! !

!PltSessionInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
changeDate: aString validationDate: aString1 validationResult: aLogical 	self setChangeDate:aString.	self setValidationDate:aString1.	self setValidationResult:aLogical.

! !

!PltSessionInstance methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
changeDateUsingContext: aContext
	^ self changeDate

! !

!PltSessionInstance methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetChangeDate: aString
	changeDate := aString

! !

!PltSessionInstance methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetValidationDate: aString
	validationDate := aString

! !

!PltSessionInstance methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetValidationResult: aLogical
	validationResult := aLogical

! !

!PltSessionInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self sessionInstanceFromValues: (super fromValues: values)

! !

!PltSessionInstance methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltSessionInstance
	^ true

! !

!PltSessionInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self sessionInstanceFromValues: values

! !

!PltSessionInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self sessionInstanceToValues: values

! !

!PltSessionInstance methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltSessionInstance methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self sessionInstanceCopyTo: another

! !

!PltSessionInstance methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self sessionInstanceCopyTo: another

! !

!PltSessionInstance methodsFor: 'platypus-generated-copying' stamp: ''!
sessionInstanceCopyTo: another
	another fastSetChangeDate: self changeDate.
	another fastSetValidationDate: self validationDate.
	another fastSetValidationResult: self validationResult

! !

!PltSessionInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
sessionInstanceFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setChangeDate: valuesloc removeFirst.
	self setValidationDate: valuesloc removeFirst.
	self setValidationResult: valuesloc removeFirst.
	^ valuesloc

! !

!PltSessionInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
sessionInstanceToValues: values
	values add: self changeDate.
	values add: self validationDate.
	values add: self validationResult.
	^ values

! !

!PltSessionInstance methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setChangeDate: aString
	self changeDate: aString

! !

!PltSessionInstance methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setValidationDate: aString
	self validationDate: aString

! !

!PltSessionInstance methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setValidationResult: aLogical
	self validationResult: aLogical

! !

!PltSessionInstance methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	changeDate := nil.
	validationDate := ''.
	validationResult := false

! !

!PltSessionInstance methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self sessionInstanceToValues: (super toValues: values)

! !

!PltSessionInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
validationDate
	^ validationDate

! !

!PltSessionInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
validationDate: aString
	validationDate := aString

! !

!PltSessionInstance methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
validationDateUsingContext: aContext
	^ self validationDate

! !

!PltSessionInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
validationResult
	^ validationResult

! !

!PltSessionInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
validationResult: aLogical
	validationResult := aLogical

! !

!PltSessionInstance methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
validationResultUsingContext: aContext
	^ self validationResult

! !

PltEntityInstance subclass: #PltSimpleRecord
	instanceVariableNames: 'definition parameters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusPopulationSchemaSchema'!

!PltSimpleRecord commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY simple_record 
	SUBTYPE OF ( entity_instance );
	definition : entity_definition_reference;
	parameters : LIST OF primitive;
	SELF\entity_instance.owner : generic_instance;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!PltSimpleRecord class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context ^ self schemaDefinition context

! !

!PltSimpleRecord class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltSimpleRecord class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData 	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!PltSimpleRecord class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ PltPlatypusPopulationSchemaSchemaDefinition singleton

! !

!PltSimpleRecord class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ PltPlatypusMetaSchemasSchemaInstance singleton

! !

!PltSimpleRecord class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltSimpleRecord class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!PltSimpleRecord methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptSimpleRecord: self

! !

!PltSimpleRecord methodsFor: 'platypus-generated-accessing' stamp: ''!
definition
	^ definition

! !

!PltSimpleRecord methodsFor: 'platypus-generated-accessing' stamp: ''!
definition: aPltEntityDefinitionReference
	definition := aPltEntityDefinitionReference

! !

!PltSimpleRecord methodsFor: 'platypus-generated-group-accessing' stamp: ''!
definition: aPltEntityDefinitionReference parameters: aListOfPltExpression owner: aPltGenericInstance 	self setDefinition:aPltEntityDefinitionReference.	self setParameters:aListOfPltExpression.	self setOwner:aPltGenericInstance.

! !

!PltSimpleRecord methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
definitionUsingContext: aContext
	^ self definition

! !

!PltSimpleRecord methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetDefinition: aPltEntityDefinitionReference
	definition := aPltEntityDefinitionReference

! !

!PltSimpleRecord methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetOwner: aPltGenericInstance
	owner := aPltGenericInstance

! !

!PltSimpleRecord methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetParameters: aListOfPltExpression
	parameters := aListOfPltExpression

! !

!PltSimpleRecord methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self simpleRecordFromValues: (super fromValues: values)

! !

!PltSimpleRecord methodsFor: 'platypus-generated-classifying' stamp: ''!
isPltSimpleRecord
	^ true

! !

!PltSimpleRecord methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self simpleRecordFromValues: values

! !

!PltSimpleRecord methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self simpleRecordToValues: values

! !

!PltSimpleRecord methodsFor: 'platypus-generated-accessing' stamp: ''!
owner
	^ owner

! !

!PltSimpleRecord methodsFor: 'platypus-generated-accessing' stamp: ''!
owner: aPltGenericInstance
	owner := aPltGenericInstance

! !

!PltSimpleRecord methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
ownerUsingContext: aContext
	^ self owner

! !

!PltSimpleRecord methodsFor: 'platypus-generated-accessing' stamp: ''!
parameters
	^ parameters

! !

!PltSimpleRecord methodsFor: 'platypus-generated-accessing' stamp: ''!
parameters: aListOfPltExpression
	parameters := aListOfPltExpression
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfPltExpression as: OrderedCollection ]

! !

!PltSimpleRecord methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
parametersUsingContext: aContext
	^ self parameters

! !

!PltSimpleRecord methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!PltSimpleRecord methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self simpleRecordCopyTo: another

! !

!PltSimpleRecord methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self simpleRecordCopyTo: another

! !

!PltSimpleRecord methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setDefinition: aPltEntityDefinitionReference
	self definition: aPltEntityDefinitionReference

! !

!PltSimpleRecord methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setOwner: aPltGenericInstance
	self owner: aPltGenericInstance

! !

!PltSimpleRecord methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setParameters: aListOfPltExpression
	self parameters: aListOfPltExpression

! !

!PltSimpleRecord methodsFor: 'platypus-generated-copying' stamp: ''!
simpleRecordCopyTo: another
	another fastSetDefinition: self definition.
	another fastSetParameters: self parameters.
	another fastSetOwner: self owner

! !

!PltSimpleRecord methodsFor: 'platypus-generated-group-accessing' stamp: ''!
simpleRecordFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setDefinition: valuesloc removeFirst.
	self setParameters: valuesloc removeFirst.
	self setOwner: valuesloc removeFirst.
	^ valuesloc

! !

!PltSimpleRecord methodsFor: 'platypus-generated-group-accessing' stamp: ''!
simpleRecordToValues: values
	values add: self definition.
	values add: self parameters.
	values add: self owner.
	^ values

! !

!PltSimpleRecord methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	definition := nil.
	parameters := OrderedCollection new.
	owner := nil

! !

!PltSimpleRecord methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self simpleRecordToValues: (super toValues: values)

! !

Object subclass: #StepCoreObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-STEP-core'!

StepCoreObject subclass: #StepAbstractRepository
	instanceVariableNames: 'instanceByOidIndex oidByInstanceIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-STEP-core'!

StepAbstractRepository subclass: #PlatypusCoreRepository
	instanceVariableNames: 'header metaDataSchemaInstance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-core'!

!PlatypusCoreRepository class methodsFor: 'accessing' stamp: 'apl 3/10/2005 18:52'!
dataParserClass
	^ StepParser! !

!PlatypusCoreRepository class methodsFor: 'accessing' stamp: 'AlainPlantec 7/14/2011 16:55'!
generatedMetaDataSchemaInstance
	^ (PlatypusPharoSmalltalk at: self generatedMetaDataSchemaInstanceName) singleton! !

!PlatypusCoreRepository class methodsFor: 'accessing' stamp: 'apl 4/19/2006 12:31'!
generatedMetaDataSchemaInstanceName
	^ self subclassResponsibility ! !

!PlatypusCoreRepository class methodsFor: 'instance creation' stamp: 'apl 12/7/2006 17:13'!
new
	^ super new
		metaDataSchemaInstance: self generatedMetaDataSchemaInstance! !

!PlatypusCoreRepository methodsFor: 'accessing' stamp: 'apl 2/27/2006 15:40'!
allApplicationInstances
	^ self allPersistentApplicationInstances
! !

!PlatypusCoreRepository methodsFor: 'accessing' stamp: 'apl 4/11/2006 18:47'!
allPersistentApplicationInstances
	^ self instances! !

!PlatypusCoreRepository methodsFor: 'accessing' stamp: 'AlainPlantec 10/26/2011 23:11'!
alternativeIndex: aListOfAssoc
	"the arg is a collection of association made of:  <entity name> -> <class name> "
	self metaDataSchemaInstance alternativeIndex: aListOfAssoc! !

!PlatypusCoreRepository methodsFor: 'converting' stamp: 'apl 2/27/2006 21:51'!
asSchemaInstanceContext
	self metaDataSchemaInstance context: (PlatypusCoreRunningContext folder: self)! !

!PlatypusCoreRepository methodsFor: 'checking' stamp: 'apl 4/7/2006 19:03'!
checksExternalInstance: instance 
	| errors metaData |
	errors := OrderedCollection new.
	instance records do: [:rec |
		metaData := self metaDataSchemaInstance metaDataForClass: rec class.
		metaData
			inheritedExplicitAttributesDo: [:attr | errors
				addAll: (attr
						checksValueFromInstance: instance
						oid: (self oidOf: instance)
						repository: self)]].
	^ errors! !

!PlatypusCoreRepository methodsFor: 'checking' stamp: 'apl 4/7/2006 19:02'!
checksInstance: instance 
	(instance isKindOf: PlatypusComplexInstance) ifTrue: [
		^ self checksExternalInstance: instance]
	ifFalse: [
		^ self checksInternalInstance: instance]
! !

!PlatypusCoreRepository methodsFor: 'checking' stamp: 'apl 3/2/2006 16:17'!
checksInternalInstance: instance 
	| errors metaData |
	errors := OrderedCollection new.
	metaData := self metaDataSchemaInstance metaDataForClass: instance class.
	metaData inheritedExplicitAttributesDo: 
		 [:attr | errors
				addAll: (attr
						checksValueFromInstance: instance
						oid: (self oidOf: instance)
						repository: self)].
	^ errors! !

!PlatypusCoreRepository methodsFor: 'file in/out' stamp: 'apl 3/11/2005 15:55'!
classFromEntityName: aString 
	^ self metaDataSchemaInstance classFromEntityName: aString ! !

!PlatypusCoreRepository methodsFor: 'file in/out' stamp: 'apl 3/11/2005 14:48'!
createInstanceFromEntityName: entityName 
	| class |
	^ (class := self classFromEntityName: entityName)
		ifNotNil: [class new ]! !

!PlatypusCoreRepository methodsFor: 'file in/out' stamp: 'apl 3/11/2005 14:48'!
createInstanceFromEntityName: entityName withId: id 
	| inst |
	^ (inst := self createInstanceFromEntityName: entityName)
		ifNotNil: [self registerInstance: inst withId: id]! !

!PlatypusCoreRepository methodsFor: 'accessing' stamp: 'apl 3/10/2005 18:52'!
dataParserClass
	^ self class dataParserClass! !

!PlatypusCoreRepository methodsFor: 'initialize/release' stamp: 'apl 3/10/2005 18:52'!
finalize
	super finalize.
! !

!PlatypusCoreRepository methodsFor: 'accessing' stamp: 'apl 3/10/2005 18:52'!
header
	^header! !

!PlatypusCoreRepository methodsFor: 'accessing' stamp: 'apl 3/11/2005 14:03'!
metaDataSchemaInstance
	^metaDataSchemaInstance! !

!PlatypusCoreRepository methodsFor: 'accessing' stamp: 'apl 3/11/2005 14:03'!
metaDataSchemaInstance: anObject
	metaDataSchemaInstance := anObject! !

!PlatypusCoreRepository methodsFor: 'accessing' stamp: 'apl 12/7/2006 14:09'!
namesBuilder
	^ self metaDataSchemaInstance namesBuilder! !

!PlatypusCoreRepository methodsFor: 'file in/out' stamp: 'apl 3/10/2005 18:52'!
parseStream: in 
	^ self parseStream: in onError: [:d :l | self notify: d at: l in: in].! !

!PlatypusCoreRepository methodsFor: 'file in/out' stamp: 'AlainPlantec 6/4/2012 16:02'!
parseStream: in onError: aBlock 
	| id result entityName parameters newInst metaData val setterSymbol records newRec |
	result := self dataParserClass parseStream: in onError: aBlock.
	header := result first.
	result second
		do: [:inst | 
			id := inst label.
			inst isInternalRepresentation
				ifTrue: [
					entityName := inst entityName.
					parameters := inst values.
					(newInst := self createInstanceFromEntityName: entityName  withId: id)
						ifNotNil: [metaData := self metaDataSchemaInstance metaDataForInstance: newInst.
							metaData
								inheritedExplicitAttributesDo: [:attr | ((val := parameters removeFirst) isKindOf: StepRedefinedValue)
										ifFalse: [val isCollection
												ifTrue: [setterSymbol := attr setSelectorFromNamesBuilder: self namesBuilder]
												ifFalse: [
													val  = $$ ifTrue: [val := nil].
													setterSymbol := attr fastSetSelectorFromNamesBuilder: self namesBuilder].
											newInst perform: setterSymbol with: val]]]]
				ifFalse: [records := OrderedCollection new.
					inst records
						do: [:rec | 
							entityName := rec entityName.
							parameters := rec values.
							(newRec := self createInstanceFromEntityName: entityName)
								ifNotNil: [metaData := self metaDataSchemaInstance metaDataForInstance: newRec.
									metaData
										explicitAttributesDo: [:attr | ((val := parameters removeFirst) isKindOf: StepRedefinedValue)
												ifFalse: [val isCollection
														ifTrue: [setterSymbol := attr setSelectorFromNamesBuilder: self namesBuilder]
														ifFalse: [
															val  = $$ ifTrue: [val := nil].
															setterSymbol := attr fastSetSelectorFromNamesBuilder: self namesBuilder].
													newRec perform: setterSymbol with: val]].
									records add: newRec]].
					newInst := PlatypusComplexInstance fromRecords: records.
					self registerInstance: newInst withId: id]].
	self resolvesInstanceReferences! !

!PlatypusCoreRepository methodsFor: 'checking' stamp: 'apl 3/11/2005 14:54'!
resolvedTokenOf: t 
	(t isKindOf: StepInstanceReference)
		ifTrue: [^ self instanceAt: t id]
		ifFalse: [((t isKindOf: Collection)
					and: [(t isKindOf: String) not])
				ifTrue: [^ t
						collect: [:e | self resolvedTokenOf: e]]].
	^ t! !

!PlatypusCoreRepository methodsFor: 'checking' stamp: 'apl 4/7/2006 18:28'!
resolvesInstanceReferencesOf: instance 
	| getterSymbol setterSymbol entityDef |
	(instance isKindOf: PlatypusComplexInstance)
		ifTrue: [instance records
				do: [:rec | self resolvesInstanceReferencesOf: rec]]
		ifFalse: [entityDef := self metaDataSchemaInstance metaDataForInstance: instance.
			entityDef
				inheritedExplicitAttributesDo: [:attr | (entityDef isAttributeRedeclared: attr)
						ifFalse: [getterSymbol := attr getSelectorFromNamesBuilder: self namesBuilder.
							setterSymbol := attr fastSetSelectorFromNamesBuilder: self namesBuilder.
							instance
								perform: setterSymbol
								with: (self
										resolvedTokenOf: (instance perform: getterSymbol))]]]! !

!PlatypusCoreRepository methodsFor: 'file in/out' stamp: 'apl 4/11/2006 08:41'!
stepFileOut: aFilename 
	(PlatypusCoreRepositoryStepFileWriter folder: self) doFolder; stepFileOut: aFilename ! !

PlatypusCoreRepository subclass: #PltPlatypusExpressPrimitivesRepository
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusExpressPrimitivesSchemaInstance'!

!PltPlatypusExpressPrimitivesRepository class methodsFor: 'platypus-generated-accessing' stamp: ''!
generatedMetaDataSchemaInstanceName
	^ #PltPlatypusExpressPrimitivesSchemaInstance

! !

!PltPlatypusExpressPrimitivesRepository class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltPlatypusExpressPrimitivesRepository class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltPlatypusExpressPrimitivesRepository class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

PlatypusCoreRepository subclass: #PltPlatypusMetaSchemasRepository
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-PlatypusMetaSchemasSchemaInstance'!

!PltPlatypusMetaSchemasRepository class methodsFor: 'platypus-generated-accessing' stamp: ''!
generatedMetaDataSchemaInstanceName
	^ #PltPlatypusMetaSchemasSchemaInstance

! !

!PltPlatypusMetaSchemasRepository class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!PltPlatypusMetaSchemasRepository class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!PltPlatypusMetaSchemasRepository class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Platypus

! !

!StepAbstractRepository methodsFor: 'instances accessing' stamp: 'apl 3/3/2005 00:20'!
allInstancesOf: aClass 
	| instances |
	instances := OrderedCollection new.
	self allInstancesOf: aClass do: [:folder :inst| instances add: inst].
	^ instances
! !

!StepAbstractRepository methodsFor: 'instances accessing' stamp: 'apl 4/11/2006 18:49'!
allInstancesOf: aClass do: aBlock 
	^ self instancesDo:
		[:inst | (inst isKindOf: aClass)
				ifTrue: [aBlock value: self value: inst]]! !

!StepAbstractRepository methodsFor: 'checking' stamp: 'apl 4/7/2006 19:04'!
checksExternalInstance: instance 
	"no checking by default, subclasses could do it"
	^ #()! !

!StepAbstractRepository methodsFor: 'checking' stamp: 'apl 4/11/2006 18:52'!
checksInstances
	| errors |
	errors := OrderedCollection new.
	self instancesDo:
		[:inst | errors
				addAll: (self checksInstance: inst)].
	^ errors! !

!StepAbstractRepository methodsFor: 'checking' stamp: 'apl 3/11/2005 13:57'!
checksInternalInstance: instance 
	"no checking by default, subclasses could do it"
	^ #()! !

!StepAbstractRepository methodsFor: 'copying' stamp: 'apl 3/10/2005 18:39'!
copy
	^ self error: 'A repository can''t be copied'! !

!StepAbstractRepository methodsFor: 'accessing' stamp: 'apl 7/15/2004 16:36'!
dataParserClass
	^ self subclassResponsibility ! !

!StepAbstractRepository methodsFor: 'copying' stamp: 'apl 3/9/2005 17:32'!
deepCopy
	^ self copy! !

!StepAbstractRepository methodsFor: 'initialize/release' stamp: 'apl 4/11/2006 18:54'!
destroy
	instanceByOidIndex := nil.
	oidByInstanceIndex := nil.
	super destroy! !

!StepAbstractRepository methodsFor: 'initialize/release' stamp: 'apl 4/11/2006 08:25'!
finalize
	Transcript show: 'a ' , self class name , ' is finalized' , String cr.
	self destroy! !

!StepAbstractRepository methodsFor: 'initialize/release' stamp: 'AlainPlantec 5/11/2012 13:06'!
initialize
	super initialize.
	instanceByOidIndex := Dictionary new.
	oidByInstanceIndex := IdentityDictionary new.
! !

!StepAbstractRepository methodsFor: 'instances accessing' stamp: 'AlainPlantec 5/11/2012 13:06'!
instanceAt: id 
	^ instanceByOidIndex
		at: id 
		ifAbsent: []! !

!StepAbstractRepository methodsFor: 'instances accessing' stamp: 'AlainPlantec 5/11/2012 18:41'!
instanceLabelled: id 
	^ instanceByOidIndex
		at: id 
		ifAbsent: []! !

!StepAbstractRepository methodsFor: 'accessing' stamp: 'AlainPlantec 5/11/2012 10:43'!
instances
	^ oidByInstanceIndex keys! !

!StepAbstractRepository methodsFor: 'accessing' stamp: 'apl 4/11/2006 18:55'!
instancesDo: aBlock 
	instanceByOidIndex
		do: [ :v | aBlock value: v]! !

!StepAbstractRepository methodsFor: 'testing' stamp: 'apl 4/11/2006 08:26'!
oidExists: id 
	^ (self instanceAt: id) notNil! !

!StepAbstractRepository methodsFor: 'instances accessing' stamp: 'apl 4/11/2006 18:46'!
oidOf: anInstance 
	^oidByInstanceIndex at: anInstance
		ifAbsent: [self oidOf: (self registerInstance: anInstance)]! !

!StepAbstractRepository methodsFor: 'file in/out' stamp: 'apl 3/10/2005 08:52'!
parseStream: in 
	^ self subclassResponsibility! !

!StepAbstractRepository methodsFor: 'instance registering' stamp: 'apl 3/10/2005 18:59'!
registerHeaderInstance: headerInst 
	! !

!StepAbstractRepository methodsFor: 'instance registering' stamp: 'AlainPlantec 5/11/2012 10:49'!
registerInstance: appInst  	
	^self registerInstance: appInst withId: oidByInstanceIndex size + 1! !

!StepAbstractRepository methodsFor: 'instance registering' stamp: 'AlainPlantec 5/11/2012 10:41'!
registerInstance: appInst withId: id 
	oidByInstanceIndex at: appInst
		ifAbsent: 
			[instanceByOidIndex at: id put: appInst.
			oidByInstanceIndex at: appInst put: id].
	^appInst! !

!StepAbstractRepository methodsFor: 'instance registering' stamp: 'AlainPlantec 5/16/2012 13:53'!
replace: oldInst with: newInst
	| oldOid |
	oldOid := oidByInstanceIndex at: oldInst.
	self unregisterInstance: oldInst.
	newInst id: oldOid.
	self registerInstance: newInst.
! !

!StepAbstractRepository methodsFor: 'checking' stamp: 'apl 4/11/2006 18:53'!
resolvesInstanceReferences
	self instancesDo: [:inst | self resolvesInstanceReferencesOf: inst]! !

!StepAbstractRepository methodsFor: 'checking' stamp: 'apl 3/11/2005 14:51'!
resolvesInstanceReferencesOf: instance 
! !

!StepAbstractRepository methodsFor: 'file in/out' stamp: 'apl 4/11/2006 09:43'!
stepFileIn: aFilename 
	| stream |
	(stream := (Filename named: aFilename) readStream)
		ifNotNil: [[self parseStream: stream]
				ensure: [stream close]]! !

!StepAbstractRepository methodsFor: 'instance registering' stamp: 'apl 4/11/2006 18:46'!
unregisterInstance: inst 
	oidByInstanceIndex at: inst
		ifPresent: 
			[:oid | 
			instanceByOidIndex removeKey: oid.
			oidByInstanceIndex removeKey: inst.
			^inst].
	^nil! !

!StepAbstractRepository methodsFor: 'copying' stamp: 'apl 3/9/2005 17:33'!
veryDeepCopy
	^ self deepCopy! !

StepAbstractRepository subclass: #StepGenericRepository
	instanceVariableNames: 'header'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-STEP-core'!

!StepGenericRepository class methodsFor: 'accessing' stamp: 'apl 3/9/2005 19:44'!
dataParserClass
	^ StepParser! !

!StepGenericRepository methodsFor: 'accessing' stamp: 'apl 3/9/2005 15:51'!
dataParserClass
	^ self class dataParserClass! !

!StepGenericRepository methodsFor: 'accessing' stamp: 'apl 3/9/2005 22:03'!
header
	^header! !

!StepGenericRepository methodsFor: 'initialize/release' stamp: 'apl 3/10/2005 19:01'!
initialize
	super initialize.
	header := OrderedCollection new.! !

!StepGenericRepository methodsFor: 'file in/out' stamp: 'apl 10/10/2006 09:37'!
notify: error at: location in: stream 
	| contentsWithError errorOut errFilename |
	contentsWithError := stream contents 
				copyReplaceFrom: location
				to: location - 1
				with: '******' , error , '->'.
	(errorOut := (Filename named: (errFilename := self class name , '.error')) 
				writeStream) ifNotNil: 
				[
				[errorOut nextPutAll: contentsWithError.
				Transcript show: 'Error found in a STEP stream, see into ' , errFilename] 
						ensure: [errorOut close]].
	^ (StepGenericRepositoryFileError 
		messageText: error
		contents: stream contents
		pos: location
		folder: self) signal! !

!StepGenericRepository methodsFor: 'file in/out' stamp: 'AlainPlantec 5/16/2012 14:01'!
parseDataStream: in onError: aBlock 
	| id result |
	result := self dataParserClass 
		parseStream: in 
		startingAt: StepParser startingStateForDataEntities 
		onError: aBlock.
	self registerAllInstances: result! !

!StepGenericRepository methodsFor: 'file in/out' stamp: 'apl 3/10/2005 08:57'!
parseStream: in 
	^ self parseStream: in onError: [:d :l | self notify: d at: l in: in].! !

!StepGenericRepository methodsFor: 'file in/out' stamp: 'AlainPlantec 5/16/2012 14:02'!
parseStream: in onError: aBlock 
	| id result |
	result := self dataParserClass parseStream: in onError: aBlock.
	header := result first.
	self registerAllInstances: (result second)! !

!StepGenericRepository methodsFor: 'file in/out' stamp: 'AlainPlantec 5/16/2012 14:02'!
parseStream: in startingAt: startingState onError: aBlock 
	| id result |
	result := self dataParserClass parseStream: in startingAt: startingState onError: aBlock.
	header := result first.
	self registerAllInstances: (result second)! !

!StepGenericRepository methodsFor: 'file in/out' stamp: 'AlainPlantec 5/11/2012 15:00'!
registerAllInstances: aCollection
	aCollection
		do: [:inst | 
			self registerInstance: inst withId: inst label].
	self resolvesInstanceReferences! !

!StepGenericRepository methodsFor: 'instance registering' stamp: 'apl 3/10/2005 19:00'!
registerHeaderInstance: headerInst 
	header add: headerInst! !

!StepGenericRepository methodsFor: 'accessing' stamp: 'AlainPlantec 5/8/2012 17:24'!
resolvedTokenOf: t 
	(t isKindOf: StepInstanceReference)
		ifTrue: [ t ref: (self instanceAt: t id)]
		ifFalse: [
			(t isKindOf: StepSimpleRecord)
				ifTrue: [ t values: (self resolvedTokenOf: t values)]
				ifFalse: [((t isKindOf: Collection) and: [(t isKindOf: String) not])
					ifTrue: [^ t collect: [:e | self resolvedTokenOf: e]]]].
	^ t! !

!StepGenericRepository methodsFor: 'checking' stamp: 'apl 3/9/2005 17:42'!
resolvesInstanceReferencesOf: instance 
	1
		to: instance class instSize
		do: [:i | instance
				instVarAt: i
				put: ( (self
						resolvedTokenOf:  (instance instVarAt: i)))]! !

!StepCoreObject class methodsFor: 'platypus-signature' stamp: 'apl 12/9/2006 09:59'!
vwNamespaceName
	^ #Platypus! !

StepCoreObject subclass: #StepError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-STEP-core'!

StepError subclass: #StepFileError
	instanceVariableNames: 'contents pos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-STEP-core'!

!StepFileError class methodsFor: 'exceptionInstantiator' stamp: 'apl 4/11/2006 18:09'!
messageText: signalerText contents: fileContents pos: aPositionInFileContents 
	"Signal the occurrence of an exceptional condition with a specified
	textual description."
	| err |
	err := self new messageText: signalerText.
	err pos: aPositionInFileContents.
	err contents: fileContents.
	^ err! !

!StepFileError methodsFor: 'accessing' stamp: 'apl 4/11/2006 18:07'!
contents
	^contents! !

!StepFileError methodsFor: 'accessing' stamp: 'apl 4/11/2006 18:07'!
contents: anObject
	contents := anObject! !

!StepFileError methodsFor: 'accessing' stamp: 'apl 4/11/2006 18:07'!
pos
	^pos! !

!StepFileError methodsFor: 'accessing' stamp: 'apl 4/11/2006 18:07'!
pos: anObject
	pos := anObject! !

StepFileError subclass: #StepGenericRepositoryFileError
	instanceVariableNames: 'folder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-STEP-core'!

!StepGenericRepositoryFileError class methodsFor: 'exceptionInstantiator' stamp: 'apl 4/11/2006 18:06'!
messageText: signalerText contents: fileContents pos: aPositionInFileContents folder: aGenericFolder
	| err |
	err := super messageText: signalerText contents: fileContents pos: aPositionInFileContents .
	err folder: aGenericFolder.
	^ err! !

!StepGenericRepositoryFileError methodsFor: 'accessing' stamp: 'apl 4/11/2006 18:06'!
folder
	^folder! !

!StepGenericRepositoryFileError methodsFor: 'accessing' stamp: 'apl 4/11/2006 18:06'!
folder: anObject
	folder := anObject! !

StepCoreObject subclass: #StepGenericRepositoryAbstractVisitor
	instanceVariableNames: 'folder actionMethodsIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-STEP-core'!

StepGenericRepositoryAbstractVisitor subclass: #PlatypusRepositoryBuilder
	instanceVariableNames: 'valuesListStack modelContents index'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-STEP'!

!PlatypusRepositoryBuilder commentStamp: '<historical>' prior: 0!
Build a repository of Platypus metamodele instances from a generic repository!

!PlatypusRepositoryBuilder class methodsFor: 'instance creation' stamp: 'apl 3/10/2005 00:54'!
folder: aDataFolder  modelContents: aModelContents 
	^ self new folder: aDataFolder modelContents: aModelContents ! !

!PlatypusRepositoryBuilder methodsFor: 'accessing' stamp: 'apl 3/20/2006 15:47'!
dataInstances
	^ modelContents dataInstances! !

!PlatypusRepositoryBuilder methodsFor: 'data encoding' stamp: 'AlainPlantec 5/8/2012 17:05'!
doAggregation: aCollection 
	| aggr | 
	aggr := self new: PltListInstance.
	aggr general: true.
	self push: aggr.
	aCollection
		do: [:val | self doToken: val].
	aggr adjustLowerAndUpperBounds.
	self pop.
	self top add: aggr! !

!PlatypusRepositoryBuilder methodsFor: 'data encoding' stamp: 'apl 1/23/2007 14:53'!
doBinary: aBinary 
	self top add: (PltBinaryLiteral val: aBinary)
! !

!PlatypusRepositoryBuilder methodsFor: 'data encoding' stamp: 'apl 3/10/2005 00:40'!
doBoolean: b 
	self doLogical: b! !

!PlatypusRepositoryBuilder methodsFor: 'data encoding' stamp: 'AlainPlantec 5/14/2012 14:12'!
doEnumeration: aString 
	| domain |
	aString = #UNKNOWN
		ifTrue: [self top add: PltUnknownConstant new]
		ifFalse: [aString = #T
			ifTrue: [self top add: PltTrueConstant new]
			ifFalse: [aString = #F
				ifTrue: [self top add: PltFalseConstant new]
				ifFalse: [
					(domain := self enumerationTypeNamed: aString)
						ifNil: [self top add: (PltEnumerationValue domain: nil element: aString asSymbol)]
						ifNotNil: [
							self top add: (PltEnumerationValue
								domain: (PltDefinedTypeReference ref: domain)
								element: (domain domain elementSymbolCorrespondingTo: aString))]]]]! !

!PlatypusRepositoryBuilder methodsFor: 'data encoding' stamp: 'AlainPlantec 5/8/2012 17:03'!
doExternalRepresentation: inst 
	index 
		at: inst
		ifPresent: [:found | self top add: found ]
		ifAbsent: [ 
			| rep sr | 
			rep := self new: PltExternalRepresentation.
			index at: inst put: rep.
			self push: rep records.
			inst records
				do: [:rec | 
					sr := self doSimpleRecord: rec.
					sr owner: rep].
			rep persistentLabel: inst label.
			rep owningModel: self modelContents.
			self pop.
			self top add: rep].
	^ inst! !

!PlatypusRepositoryBuilder methodsFor: 'data encoding' stamp: 'AlainPlantec 5/11/2012 10:47'!
doFolder
	| instances |
	self push: OrderedCollection new.
	folder header
		do: [:h | 
			self doHeaderInstance: h.
			self headerInstances add: self top removeFirst].
	instances := folder instances.
	1
		to: instances size
		do: [:p | | i | (i := instances at: p)
				ifNotNil: [self doInstance: i.
					modelContents add: self top removeFirst]]! !

!PlatypusRepositoryBuilder methodsFor: 'data encoding' stamp: 'apl 3/10/2005 12:09'!
doHeaderInstance: h 
	| inst values name |
	values := h values.
	name := h entityName asUppercase.
	name = 'FILE_SCHEMA'
		ifTrue: [inst := self fileSchemaHeaderInstance: values first]
		ifFalse: [name = 'FILE_NAME'
				ifTrue: [inst := self
								fileNameHeaderInstance: values first
								timeStamp: values second
								authors: values third
								organization: values fourth
								preprocessorVersion: values fifth
								originatingSystem: (values at: 6)
								authorization: (values at: 7)]
				ifFalse: [name = 'FILE_DESCRIPTION'
						ifTrue: [inst := self fileDescriptionHeaderInstance: values first implementationLevel: values second]
						ifFalse: [inst := self new: PltUserDefinedHeaderInstance.
							inst name: name.
							inst parameters: values]]].
	inst owningModel: modelContents.
	self top add: inst
! !

!PlatypusRepositoryBuilder methodsFor: 'data encoding' stamp: 'apl 3/10/2005 17:18'!
doInstance: inst 
	(inst isKindOf: StepExternalRepresentation)
		ifTrue: [self doExternalRepresentation: inst]
		ifFalse: [self doInternalRepresentation: inst]! !

!PlatypusRepositoryBuilder methodsFor: 'data encoding' stamp: 'AlainPlantec 5/11/2012 19:13'!
doInstanceRef: i 
	i ref ifNil: [i ref: (folder ifNotNil: [:f | f instanceLabelled: i id])].
	self doToken: i ref! !

!PlatypusRepositoryBuilder methodsFor: 'data encoding' stamp: 'AlainPlantec 6/4/2012 16:03'!
doInternalRepresentation: inst 
	index 
		at: inst
		ifPresent: [:found | self top add: found ]
		ifAbsent: [
			| rep |
			rep := self new: PltInternalRepresentation.
			index at: inst put: rep.
			rep
				definition: (self lookUpEntityDefinitionBN: inst entityName).
			self push: rep parameters.
			inst values
				ifNotNil: [
					inst values
						do: [:val | self doToken: val]].
			self pop.
			rep persistentLabel: inst label.
			rep owningModel: self modelContents.
			self top add: rep].
	^ inst! !

!PlatypusRepositoryBuilder methodsFor: 'data encoding' stamp: 'apl 3/8/2006 09:07'!
doLogical: l 
	self top
		add: (l = #UNKNOWN
				ifTrue: [PltUnknownConstant new]
				ifFalse: [l
						ifTrue: [PltTrueConstant new]
						ifFalse: [PltFalseConstant new]])! !

!PlatypusRepositoryBuilder methodsFor: 'data encoding' stamp: 'apl 3/10/2005 00:48'!
doNullValue: e 
	self top add: PltMissingValue new! !

!PlatypusRepositoryBuilder methodsFor: 'data encoding' stamp: 'apl 3/10/2005 00:50'!
doNumber: n 
	self top add: (n isFloat ifTrue: [PltRealLiteral val: n] ifFalse: [PltIntegerLiteral val: n])! !

!PlatypusRepositoryBuilder methodsFor: 'data encoding' stamp: 'apl 3/29/2005 08:37'!
doRedefinedValue: aRedefinedValue 
	self top add: PltRedefinedAttributeValue new! !

!PlatypusRepositoryBuilder methodsFor: 'data encoding' stamp: 'AlainPlantec 6/4/2012 15:56'!
doSimpleRecord: aStepRecord 
	| sr |
	sr := self new: PltSimpleRecord.
	sr
		definition: (self lookUpEntityDefinitionBN: aStepRecord entityName).
	self push: sr parameters.
	aStepRecord values
		do: [:val | self doToken: val].
	self pop.
	self top add: sr.
	^ sr! !

!PlatypusRepositoryBuilder methodsFor: 'data encoding' stamp: 'AlainPlantec 5/16/2012 14:11'!
doSingleToken: t
	index := IdentityDictionary new.
	folder instances 
		do: [:i |
			i ~= t 
				ifTrue: [index at: i put: (modelContents instanceLabelled: (folder oidOf: i)) ] ].
	^ super doSingleToken: t! !

!PlatypusRepositoryBuilder methodsFor: 'data encoding' stamp: 'apl 3/10/2005 00:51'!
doString: s 
	self top
		add: ( PltStringLiteral val: s)! !

!PlatypusRepositoryBuilder methodsFor: 'accessing' stamp: 'apl 2/12/2007 10:52'!
enumerationTypeNamed: anIdent 
	^ self schemaInstance lookUpEnumerationTypeFromElement: anIdent! !

!PlatypusRepositoryBuilder methodsFor: 'data encoding' stamp: 'apl 3/10/2005 10:17'!
fileDescriptionHeaderInstance: description implementationLevel: implementationLevel 
	| inst |
	inst := self new: PltFileDescription.
	inst description addAll: description.
	inst implementationLevel: implementationLevel.
	^ inst! !

!PlatypusRepositoryBuilder methodsFor: 'data encoding' stamp: 'apl 3/10/2005 10:13'!
fileNameHeaderInstance: name timeStamp: timeStamp authors: author organization: organization preprocessorVersion: preprocessorVersion originatingSystem: originatingSystem authorization: authorization 
	| inst |
	inst := self new: PltFileName.
	inst name: name .
	inst timeStamp: timeStamp.
	inst author
		addAll: (author ).
	inst organization
		addAll: (organization).
	inst preprocessorVersion: preprocessorVersion.
	inst originatingSystem: originatingSystem.
	inst authorisation: authorization.
	^ inst! !

!PlatypusRepositoryBuilder methodsFor: 'data encoding' stamp: 'apl 3/10/2005 11:34'!
fileSchemaHeaderInstance: aListOfString 
	| inst |
	inst := self new: PltFileSchema.
	inst schemaIdentifiers addAll: aListOfString.
	^ inst! !

!PlatypusRepositoryBuilder methodsFor: 'accessing' stamp: 'apl 3/10/2005 00:54'!
folder: aDataFolder modelContents: aModelContents
	self folder: aDataFolder.
	self modelContents: aModelContents! !

!PlatypusRepositoryBuilder methodsFor: 'accessing' stamp: 'apl 3/20/2006 15:48'!
headerInstances
	^ modelContents headerInstances! !

!PlatypusRepositoryBuilder methodsFor: 'initialize-release' stamp: 'AlainPlantec 5/4/2012 21:07'!
initialize
	super initialize.
	valuesListStack := PlatypusStack new.
	index := IdentityDictionary new.
! !

!PlatypusRepositoryBuilder methodsFor: 'accessing' stamp: 'apl 4/7/2006 09:26'!
lookUpEntityDefinitionBN: entityName 
	| found type metaData |
	self schemata
		do: [:sch | (metaData := sch linkedMetaData)
				ifNotNil: [(found := metaData lookUpEntityDefinitionBN: entityName)
						ifNotNil: ["type := self new:
							PltEntityDefinitionReference. type setName:
							entityName. type setRef: found.
							^ type"
							^ found referenceOnSelf]]].
	type := self new: PltEntityDefinitionReference.
	type setName: entityName.
	^ type! !

!PlatypusRepositoryBuilder methodsFor: 'accessing' stamp: 'apl 3/10/2005 00:30'!
modelContents
	^modelContents! !

!PlatypusRepositoryBuilder methodsFor: 'accessing' stamp: 'apl 3/10/2005 00:30'!
modelContents: anObject
	modelContents := anObject! !

!PlatypusRepositoryBuilder methodsFor: 'step instance creation' stamp: 'apl 3/10/2005 00:29'!
new: aClass 
	^ aClass new stepInitialize! !

!PlatypusRepositoryBuilder methodsFor: 'accessing' stamp: 'apl 3/10/2005 00:32'!
pop
	^ valuesListStack pop! !

!PlatypusRepositoryBuilder methodsFor: 'accessing' stamp: 'apl 3/10/2005 00:32'!
push: anObject 
	^ valuesListStack push: anObject! !

!PlatypusRepositoryBuilder methodsFor: 'accessing' stamp: 'AlainPlantec 6/15/2012 12:38'!
schemaInstance
	^ self modelContents schemaInstance! !

!PlatypusRepositoryBuilder methodsFor: 'accessing' stamp: 'apl 3/10/2005 00:30'!
schemata
	^ self modelContents schemata! !

!PlatypusRepositoryBuilder methodsFor: 'accessing' stamp: 'apl 3/10/2005 09:23'!
top
	^ valuesListStack top! !

StepGenericRepositoryAbstractVisitor subclass: #StepGenericFileWriter
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-STEP-core'!

!StepGenericFileWriter methodsFor: 'data encoding' stamp: 'apl 3/9/2005 22:35'!
doAggregation: a  
	stream nextPut: $(.
	a
		do: [:e | self doToken: e]
		separatedBy: [stream nextPut: $,].
	stream nextPut: $)! !

!StepGenericFileWriter methodsFor: 'data encoding' stamp: 'apl 3/9/2005 22:36'!
doBoolean: b 
	self doLogical: b! !

!StepGenericFileWriter methodsFor: 'data encoding' stamp: 'apl 2/6/2006 17:11'!
doEnumeration: e 
	e isNil
		ifTrue: [stream nextPut: $$]
		ifFalse: [e asUppercase asSymbol = #UNKNOWN
				ifTrue: [stream nextPut: $U]
				ifFalse: [stream nextPut: $..
					stream nextPutAll: e.
					stream nextPut: $.]]! !

!StepGenericFileWriter methodsFor: 'data encoding' stamp: 'apl 4/11/2006 18:12'!
doExternalRepresentation: inst 
	stream nextPut: $#.
	stream nextPutAll: (self oidOf: inst) printString.
	stream nextPut: $=.
	stream nextPut: $(.
		inst records
		do: [:val | self doToken: val]
		separatedBy: [stream nextPut: $ ].
	stream nextPutAll: ');'! !

!StepGenericFileWriter methodsFor: 'data encoding' stamp: 'AlainPlantec 5/11/2012 10:50'!
doFolder
	| dateTime instances |
	dateTime := Time dateAndTimeNow.
	stream nextPutAll: 'ISO-10303-21;'.
	stream nextPut: Character cr.
	stream nextPutAll: 'HEADER;'.
	stream nextPut: Character cr.
	stream nextPutAll: 'FILE_NAME(''<name>'', ''' , dateTime first printString , ' ' , dateTime second printString , ''', (''<author>''), (''<organisation>''), ''<preprocessor version>'', ''<originating system>'', ''<authorization>'');\' withCRs.
	stream nextPutAll: 'FILE_DESCRIPTION((''<description1>'',''<description 2>''),''<implementation level>'');\' withCRs.
	stream nextPutAll: 'FILE_SCHEMA(());\' withCRs.
	stream nextPutAll: 'ENDSEC;'.
	stream nextPut: Character cr.
	stream nextPutAll: 'DATA;'.
	stream nextPut: Character cr.
	instances := folder instances.
	1
		to: instances size
		do: [:p | | i | (i := instances at: p)
				ifNotNil: [self doInstance: i.
					stream nextPut: Character cr]].
	stream nextPutAll: 'ENDSEC;'.
	stream nextPut: Character cr.
	stream nextPutAll: 'END-ISO-10303-21;'.
	stream nextPut: Character cr! !

!StepGenericFileWriter methodsFor: 'data encoding' stamp: 'apl 3/10/2005 13:32'!
doInstance: inst 
	(inst isKindOf: StepExternalRepresentation)
		ifTrue: [self doExternalRepresentation: inst]
		ifFalse: [self doInternalRepresentation: inst]! !

!StepGenericFileWriter methodsFor: 'data encoding' stamp: 'apl 3/10/2005 22:50'!
doInstanceRef: i 
	stream nextPut: $#.
	folder
		ifNotNil: [stream nextPutAll: i id asString]! !

!StepGenericFileWriter methodsFor: 'data encoding' stamp: 'apl 4/11/2006 11:25'!
doInternalRepresentation: inst 
	stream nextPut: $#.
	stream nextPutAll: (self oidOf: inst) printString.
	stream nextPut: $=.
	stream nextPutAll: inst entityName asUppercase.
	stream nextPut: $(.
	inst values
		do: [:val | self doToken: val]
		separatedBy: [stream nextPut: $,].
	stream nextPutAll: ');'! !

!StepGenericFileWriter methodsFor: 'data encoding' stamp: 'apl 2/6/2006 17:11'!
doLogical: l 
	stream nextPut: $..
	l
				ifTrue: [stream nextPut: $T]
				ifFalse: [stream nextPut: $F].
	stream nextPut: $.! !

!StepGenericFileWriter methodsFor: 'data encoding' stamp: 'apl 3/9/2005 22:37'!
doNullValue: e
	stream nextPut: $$! !

!StepGenericFileWriter methodsFor: 'data encoding' stamp: 'apl 3/9/2005 22:38'!
doNumber: n
	stream nextPutAll: n printString! !

!StepGenericFileWriter methodsFor: 'data encoding' stamp: 'apl 3/29/2005 08:37'!
doRedefinedValue: aRedefinedValue 
	stream nextPut: $*.! !

!StepGenericFileWriter methodsFor: 'data encoding' stamp: 'apl 4/11/2006 18:13'!
doSimpleRecord: inst 
	stream nextPutAll: inst entityName asUppercase.
	stream nextPut: $(.
	inst values
		do: [:val | self doToken: val]
		separatedBy: [stream nextPut: $,].
	stream nextPutAll: ')'! !

!StepGenericFileWriter methodsFor: 'data encoding' stamp: 'apl 3/9/2005 22:38'!
doString: s
	stream nextPut: $'.
	s
		do: [:e | 
			stream nextPut: e.
			e == $'
				ifTrue: [stream nextPut: $']].
	stream nextPut: $'! !

!StepGenericFileWriter methodsFor: 'initialize/release' stamp: 'apl 3/9/2005 22:39'!
initialize
	super initialize.
	stream := WriteStream on: String new.! !

!StepGenericFileWriter methodsFor: 'file in-out' stamp: 'apl 4/11/2006 11:29'!
stepFileOut: aFilename 
	| out |
	(out := (Filename named: aFilename) writeStream)
		ifNotNil: [[self doFolder.
			out nextPutAll: stream contents]
				ensure: [out close]]! !

!StepGenericFileWriter methodsFor: 'accessing' stamp: 'apl 3/9/2005 22:39'!
stream
	^ stream! !

!StepGenericFileWriter methodsFor: 'data encoding' stamp: 'apl 3/9/2005 22:32'!
toStream: out 
	| |
	stream := out.
	self doFolder.
! !

!StepGenericRepositoryAbstractVisitor class methodsFor: 'instance creation' stamp: 'apl 3/9/2005 22:18'!
folder: aDataFolder
	^ self new folder:  aDataFolder! !

!StepGenericRepositoryAbstractVisitor methodsFor: 'accessing' stamp: 'apl 3/9/2005 22:26'!
actionMethodsIndex
	^ actionMethodsIndex! !

!StepGenericRepositoryAbstractVisitor methodsFor: 'accessing' stamp: 'apl 3/9/2005 22:26'!
actionMethodsIndex: anIndex 
	actionMethodsIndex := anIndex! !

!StepGenericRepositoryAbstractVisitor methodsFor: 'data encoding' stamp: 'apl 3/9/2005 22:21'!
doAggregation: a 
	self subclassResponsibility! !

!StepGenericRepositoryAbstractVisitor methodsFor: 'data encoding' stamp: 'apl 3/9/2005 22:21'!
doBoolean: b
	self subclassResponsibility! !

!StepGenericRepositoryAbstractVisitor methodsFor: 'data encoding' stamp: 'apl 3/9/2005 22:22'!
doEnumeration: e 
		self subclassResponsibility! !

!StepGenericRepositoryAbstractVisitor methodsFor: 'data encoding' stamp: 'apl 3/9/2005 23:35'!
doExternalRepresentation: inst 
	self subclassResponsibility! !

!StepGenericRepositoryAbstractVisitor methodsFor: 'data encoding' stamp: 'AlainPlantec 5/4/2012 21:05'!
doFolder
	self subclassResponsibility ! !

!StepGenericRepositoryAbstractVisitor methodsFor: 'data encoding' stamp: 'apl 3/9/2005 22:19'!
doInstance: inst 
	self subclassResponsibility ! !

!StepGenericRepositoryAbstractVisitor methodsFor: 'data encoding' stamp: 'apl 3/9/2005 22:22'!
doInstanceRef: i 
		self subclassResponsibility! !

!StepGenericRepositoryAbstractVisitor methodsFor: 'data encoding' stamp: 'apl 3/9/2005 23:35'!
doInternalRepresentation: inst 
	self subclassResponsibility! !

!StepGenericRepositoryAbstractVisitor methodsFor: 'data encoding' stamp: 'apl 3/9/2005 22:22'!
doLogical: l 
		self subclassResponsibility! !

!StepGenericRepositoryAbstractVisitor methodsFor: 'data encoding' stamp: 'apl 3/9/2005 22:25'!
doNullValue
	self subclassResponsibility! !

!StepGenericRepositoryAbstractVisitor methodsFor: 'data encoding' stamp: 'apl 3/9/2005 22:23'!
doNumber: n 
	self subclassResponsibility! !

!StepGenericRepositoryAbstractVisitor methodsFor: 'data encoding' stamp: 'apl 3/10/2005 12:50'!
doObject: b 
	self error: 'Unknown data kind'! !

!StepGenericRepositoryAbstractVisitor methodsFor: 'data encoding' stamp: 'apl 3/29/2005 08:35'!
doRedefinedValue: e 
	self subclassResponsibility! !

!StepGenericRepositoryAbstractVisitor methodsFor: 'data encoding' stamp: 'apl 3/10/2005 12:05'!
doSingleToken: t 
	self push: OrderedCollection new.
	self doToken: t.
	^ self pop first! !

!StepGenericRepositoryAbstractVisitor methodsFor: 'data encoding' stamp: 'apl 3/9/2005 22:23'!
doString: s 
		self subclassResponsibility! !

!StepGenericRepositoryAbstractVisitor methodsFor: 'data encoding' stamp: 'AlainPlantec 6/4/2012 15:48'!
doToken: t 
	(t = $$ or: [t isNil])
		ifTrue: [self doNullValue: nil]
		ifFalse: [self actionMethodsIndex
				do: [:a | (t isKindOf: a key)
						ifTrue: [self perform: a value with: t.
							^ a key]]].
	^ nil! !

!StepGenericRepositoryAbstractVisitor methodsFor: 'accessing' stamp: 'apl 3/9/2005 22:18'!
folder: aDataFolder
	folder := aDataFolder! !

!StepGenericRepositoryAbstractVisitor methodsFor: 'initialize/release' stamp: 'apl 3/31/2006 15:07'!
initialize
	super initialize.
	self actionMethodsIndex: OrderedCollection new.
	self actionMethodsIndex
		add: (Association key: Symbol value: #doEnumeration:).
	self actionMethodsIndex
		add: (Association key: String value: #doString:).
	self actionMethodsIndex
		add: (Association key: Boolean value: #doLogical:).
	self actionMethodsIndex
		add: (Association key: Number value: #doNumber:).
	self actionMethodsIndex
		add: (Association key: UndefinedObject value: #doNullValue:).
	self actionMethodsIndex
		add: (Association key: Collection value: #doAggregation:).
	self actionMethodsIndex
		add: (Association key: StepInternalRepresentation value: #doInternalRepresentation:).
	self actionMethodsIndex
		add: (Association key: StepSimpleRecord value: #doSimpleRecord:).
	self actionMethodsIndex
		add: (Association key: StepExternalRepresentation value: #doExternalRepresentation:).
	self actionMethodsIndex
		add: (Association key: StepInstanceReference value: #doInstanceRef:).
	self actionMethodsIndex
		add: (Association key: StepRedefinedValue value: #doRedefinedValue:).
	self actionMethodsIndex
		add: (Association key: Object value: #doObject:)! !

!StepGenericRepositoryAbstractVisitor methodsFor: 'accessing' stamp: 'apl 3/9/2005 22:18'!
oidOf: anInstance 
	^folder ifNil: [-1] ifNotNil: [folder oidOf: anInstance]! !

StepCoreObject subclass: #StepInstance
	instanceVariableNames: 'label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-STEP-core'!

StepInstance subclass: #StepExternalRepresentation
	instanceVariableNames: 'records'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-STEP-core'!

!StepExternalRepresentation class methodsFor: 'instance creation' stamp: 'apl 3/9/2005 15:00'!
label: aString records: aCollection 
	^ self new label: aString records: aCollection! !

!StepExternalRepresentation methodsFor: 'classification' stamp: 'apl 4/7/2006 17:49'!
isExternalRepresentation
	^ true! !

!StepExternalRepresentation methodsFor: 'accessing' stamp: 'apl 3/9/2005 14:57'!
label: aString records: aCollection
	self label: aString.
	self records: aCollection! !

!StepExternalRepresentation methodsFor: 'accessing' stamp: 'apl 3/9/2005 14:56'!
records
	^records! !

!StepExternalRepresentation methodsFor: 'accessing' stamp: 'apl 3/9/2005 14:56'!
records: anObject
	records := anObject! !

!StepInstance methodsFor: 'classification' stamp: 'apl 4/7/2006 17:50'!
isExternalRepresentation
	^ false! !

!StepInstance methodsFor: 'classification' stamp: 'apl 4/7/2006 17:51'!
isInternalRepresentation
	^ false! !

!StepInstance methodsFor: 'accessing' stamp: 'apl 4/7/2006 17:50'!
label
	^label! !

!StepInstance methodsFor: 'accessing' stamp: 'apl 4/7/2006 17:50'!
label: anObject
	label := anObject! !

StepInstance subclass: #StepInternalRepresentation
	instanceVariableNames: 'entityName values'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-STEP-core'!

!StepInternalRepresentation class methodsFor: 'instance creation' stamp: 'apl 3/9/2005 15:00'!
label: aString entityName: entName values: aCollection 
	^ self new label: aString entityName: entName values: aCollection 
! !

!StepInternalRepresentation methodsFor: 'accessing' stamp: 'apl 3/9/2005 14:56'!
entityName
	^entityName! !

!StepInternalRepresentation methodsFor: 'accessing' stamp: 'apl 3/9/2005 14:56'!
entityName: anObject
	entityName := anObject! !

!StepInternalRepresentation methodsFor: 'classification' stamp: 'apl 4/7/2006 17:52'!
isInternalRepresentation
	^ true! !

!StepInternalRepresentation methodsFor: 'accessing' stamp: 'apl 3/9/2005 14:58'!
label: aString entityName: entName values: aCollection 
	self label: aString.
	self entityName: entName.
	self values: aCollection! !

!StepInternalRepresentation methodsFor: 'accessing' stamp: 'apl 3/9/2005 14:56'!
values
	^values! !

!StepInternalRepresentation methodsFor: 'accessing' stamp: 'apl 3/9/2005 14:56'!
values: anObject
	values := anObject! !

StepCoreObject subclass: #StepInstanceReference
	instanceVariableNames: 'id ref'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-STEP-core'!

!StepInstanceReference class methodsFor: 'instance creation' stamp: ''!
id: anInteger  ^self new id: anInteger! !

!StepInstanceReference methodsFor: 'accessing' stamp: ''!
id	^id! !

!StepInstanceReference methodsFor: 'accessing' stamp: ''!
id: anObject	id := anObject! !

!StepInstanceReference methodsFor: 'printing' stamp: ''!
printOn: aStream  aStream nextPut: $#.  id printOn: aStream.! !

!StepInstanceReference methodsFor: 'accessing' stamp: 'apl 3/10/2005 12:48'!
ref
	^ref! !

!StepInstanceReference methodsFor: 'accessing' stamp: 'apl 3/10/2005 12:48'!
ref: anObject
	ref := anObject! !

StepCoreObject subclass: #StepRedefinedValue
	instanceVariableNames: ''
	classVariableNames: 'Singleton'
	poolDictionaries: ''
	category: 'Platypus-STEP-core'!

!StepRedefinedValue class methodsFor: 'accessing' stamp: 'apl 2/24/2005 23:55'!
new
	^ self singleton
! !

!StepRedefinedValue class methodsFor: 'accessing' stamp: 'apl 2/24/2005 23:55'!
singleton
	^ Singleton
		ifNil: [Singleton := self basicNew]! !

!StepRedefinedValue methodsFor: 'printing' stamp: 'apl 2/24/2005 23:53'!
printOn: aStream 
	aStream nextPut: $*.
! !

StepCoreObject subclass: #StepSimpleRecord
	instanceVariableNames: 'entityName values'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-STEP-core'!

!StepSimpleRecord class methodsFor: 'instance creation' stamp: 'apl 3/9/2005 14:59'!
entityName: entName values: aCollection 
	^ self new entityName: entName values: aCollection ! !

!StepSimpleRecord methodsFor: 'converting' stamp: 'apl 3/9/2005 15:02'!
asInternalRepresentationLabelled: aLabel
	^ StepInternalRepresentation label: aLabel entityName: self entityName values: self values
! !

!StepSimpleRecord methodsFor: 'accessing' stamp: 'apl 3/9/2005 14:56'!
entityName
	^entityName! !

!StepSimpleRecord methodsFor: 'accessing' stamp: 'apl 3/9/2005 14:56'!
entityName: anObject
	entityName := anObject! !

!StepSimpleRecord methodsFor: 'accessing' stamp: 'apl 3/9/2005 14:59'!
entityName: entName values: aCollection 
	self entityName: entName.
	self values: aCollection! !

!StepSimpleRecord methodsFor: 'accessing' stamp: 'apl 3/9/2005 14:56'!
values
	^values! !

!StepSimpleRecord methodsFor: 'accessing' stamp: 'apl 3/9/2005 14:56'!
values: anObject
	values := anObject! !

Error subclass: #PlatypusExpressInterpretorException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-interpreter'!

PlatypusExpressInterpretorException subclass: #PlatypusExpressArgumentNumberException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-interpreter'!

PlatypusExpressInterpretorException subclass: #PlatypusExpressEscapeStatementException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-interpreter'!

PlatypusExpressInterpretorException subclass: #PlatypusExpressIncompatibleDomainInAssignmentException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-interpreter'!

PlatypusExpressInterpretorException subclass: #PlatypusExpressInvalidArgumentException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-interpreter'!

PlatypusExpressInterpretorException subclass: #PlatypusExpressInvalidAttributeException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-interpreter'!

PlatypusExpressInterpretorException subclass: #PlatypusExpressInvalidGroupException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-interpreter'!

PlatypusExpressInterpretorException subclass: #PlatypusExpressInvalidQualifierException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-interpreter'!

PlatypusExpressInterpretorException subclass: #PlatypusExpressReturnStatementException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-interpreter'!

PlatypusExpressInterpretorException subclass: #PlatypusExpressSkipStatementException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-interpreter'!

PlatypusExpressInterpretorException subclass: #PlatypusExpressUncomputableValueException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-interpreter'!

PlatypusExpressInterpretorException subclass: #PlatypusExpressUnresolvedIdentifierException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-interpreter'!

PlatypusExpressInterpretorException subclass: #PlatypusNativeCodeErrorException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-interpreter'!

!String methodsFor: '*platypus-utilities' stamp: 'apl 1/26/2007 11:21'!
capitalizeFirst: firstCapitalized 
	| instr outstr resString curr |
	instr := ReadStream on: self.
	outstr := WriteStream on: String new.
	[instr atEnd] whileFalse: 
			[(curr := instr next) == $_ 
				ifTrue: [(curr := instr next) ifNotNil: [outstr nextPut: curr asUppercase]]
				ifFalse: [outstr nextPut: curr asLowercase]].
	resString := outstr contents.
	firstCapitalized 
		ifTrue: [resString at: 1 put: resString first asUppercase]
		ifFalse: [resString at: 1 put: resString first asLowercase].
	^ resString! !

!String methodsFor: '*platypus-accessing' stamp: 'apl 3/15/2007 10:23'!
updateDictionaryInstanceName: aDictionaryInstance 
	aDictionaryInstance name: self 
! !

!String methodsFor: '*platypus-utilities' stamp: 'AlainPlantec 5/12/2012 22:23'!
withoutCr
	^ self species streamContents: [:strm |
		self do: [:c | 
			(c = Character cr or: [c = Character lf])
				ifTrue: [strm nextPut: Character space]
				ifFalse: [strm nextPut: c]]]! !

SmaCCParser subclass: #PlatypusExpressAbstractParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-parsers'!

!PlatypusExpressAbstractParser class methodsFor: 'accessing' stamp: 'apl 4/19/2006 19:13'!
parse: aString owner: owner onError: aBlock 
	^ [self parseStream: aString readStream owner: owner]
		on: SmaCCParserError
		do: [:ex | ex
				return: (aBlock value: ex description value: ex parameter position)]! !

!PlatypusExpressAbstractParser class methodsFor: 'accessing' stamp: 'apl 9/6/2006 11:13'!
parse: aString startingAt: anInteger owner: owner onError: aBlock 
	^ [self
		parseStream: aString readStream
		startingAt: anInteger
		owner: owner]
		on: SmaCCParserError
		do: [:ex | ex
				return: (aBlock value: ex description value: ex tag position)]! !

!PlatypusExpressAbstractParser class methodsFor: 'accessing' stamp: 'apl 6/17/2003 22:24'!
parseStream: aStream owner: owner
	^ self
		parseStream: aStream
		startingAt: self defaultStartingState
		owner: owner! !

!PlatypusExpressAbstractParser class methodsFor: 'accessing' stamp: 'apl 2/17/2006 13:36'!
parseStream: aStream startingAt: anInteger owner: owner 
	| parser result |
	parser := self on: aStream.
	owner ownerPath
		do: [:o | parser pushContext: o].
	parser pushContext: owner.
	parser setStartingState: anInteger.
	result := parser parse.
	[parser contextsStack isEmpty]
		whileFalse: [parser popContext].
	^ result! !

!PlatypusExpressAbstractParser class methodsFor: 'generated-comments' stamp: 'AlainPlantec 1/13/2012 15:39'!
parserDefinitionComment

	"%left ""="" "">="" "">"" ""in"" "":=:"" "":<>:"" ""<="" ""<"" ""like"" ""<>"";
%left ""-""	 ""+"" ""or"" ""xor"";
%left ""/"" ""mod"" ""div"" ""*"" ""and"" ""andor"" ""||""	;
%right ""**"";
%left ""not"" ;

%id <logical> <integer> <real> <binary> <string> <encodedString> <identifier> <remarkRef> <nativeAlgorithm>;

%start SchemaInstanceEntry SchemaEntry  SchemaContentsEntry ConstantsEntry TypeEntry EntityEntry FunctionEntry ProcedureEntry RuleEntry StatementsEntry ExpressionEntry;

SchemaInstanceEntry 
: SchemaInstance { self schemaInstanceEntry: '1' value}
;

SchemaInstance
: RemarkReference* SchemaEntry* { self schemaInstance: '1' value }
;

ConceptIdentifier
: SimpleIdentifier { self conceptIdentifier: '1' value }
| SimpleIdentifier ""{"" Expression ""}""  { self conceptIdentifier: '1' metaExpression: '3'  }
;

SchemaIdentifier
: ConceptIdentifier { self schemaIdentifier: '1' value }
;

Semicolon
: "";"" RemarkReference*
;

RemarkReference
: <remarkRef> { self remarkReference: '1' value }
;

StatementsEntry
: Statement* { self statementsEntry: '1' value }
;

ExpressionEntry
: Expression { self expressionEntry: '1' value}
;

SchemaEntry
: Schema
{
	self schemaEntry: '1' value
}
;

SchemaContentsEntry
: SchemaContents { self schemaContentsEntry: '1' value }
;


Schema 	
: ""schema"" SchemaIdentifier Semicolon InterfaceSpecification* SchemaContents ""end_schema"" Semicolon 
{
	self schema: '2' value interfaces: '4' blocks: '5'
}
;

SchemaContents
: Block* { '1' value }
;

InterfaceSpecification	
: UseOrReference ""from"" SimpleIdentifier InterfaceList? Semicolon 
{
	self interfaceSpecification: '1' value schema: '3' value interfaceList: '4' value .
}
| ""meta"" ""from"" SimpleIdentifier Semicolon 
{
	self externalMetaSchema: '3' value.
}
;

UseOrReference 
: ""use"" { #USED }
| ""reference"" { #REFERENCED }
;

InterfaceList
: ""("" ExplicitlyImportedItemsList "")"" 
{
	self explicitlyImportedItems: '2' value
}
;

ExplicitlyImportedItemsList 
: ExplicitlyImportedItem { OrderedCollection with: '1' value }
| ExplicitlyImportedItemsList "","" ExplicitlyImportedItem { OrderedCollection new addAll: '1' value; add: '3' value; yourself }
;

ExplicitlyImportedItem
: SimpleIdentifier { self explicitlyImportedItem: '1' value renamedAs: '1' value }
| SimpleIdentifier ""as"" SimpleIdentifier { self explicitlyImportedItem: '1' value renamedAs: '3' value }
;

ConstantsEntry
: ConstantsDecl
{
	self constantsEntry: '1' value 
}
;

ConstantsDecl	
: ""constant"" ConstantBody* ""end_constant"" Semicolon 
{
	self constantsDecl: '2' 
}
;

ConstantBody 
: ConceptIdentifier "":"" BaseType "":="" Expression Semicolon
{
	self constantBody: '1' value baseType: '3' value expression: '5' value
}
;

Block
: ConstantsEntry { self block: '1' value }
| TypeEntry  { self block: '1' value }
| EntityEntry { self block: '1' value }
| FunctionEntry  { self block: '1' value }
| ProcedureEntry { self block: '1' value }
| RuleEntry { self block: '1' value }
;

RuleEntry
: Rule
{
	self ruleEntry: '1' value 
}
;

Rule		
: ""rule"" RuleIdentifier ""for"" ""("" IdentifiersList "")"" Semicolon ActionBody WhereClause ""end_rule"" Semicolon
{ 
	self rule: '2' value entities: '5' value actionBody: '8' value whereClause: '9' value	
}
;

RuleIdentifier
: ConceptIdentifier {	self ruleIdentifier: '1' value }
;

FunctionEntry
: Function
{
	self functionEntry: '1' value
}
;

Function
: ""function"" FunctionIdentifier FormalParametersDecl? "":"" ParameterType Semicolon ActionBody ""end_function"" Semicolon
{ 
	self function: '2' value formalParametersDecl: '3' value returnType: '5' value actionBody: '7' value.
}
;

FunctionIdentifier
: ConceptIdentifier { 	self functionIdentifier: '1' value }
;

ProcedureEntry
: Procedure
{
	self procedureEntry: '1' value
}
;

Procedure
: ""procedure"" ProcedureIdentifier FormalParametersDecl?  Semicolon ActionBody ""end_procedure"" Semicolon
{ 
	self procedure: '2' value formalParametersDecl: '3' value actionBody: '5' value
}
;

ProcedureIdentifier
: ConceptIdentifier {	self procedureIdentifier: '1' value }
;

ActionBody
: ActionBodyDecl* Statement*
{
	self actionBodyDecl: '1' value statements: '2' value. 
}
;

ActionBodyDecl
: Block { '1' value }
| LocalDecl { '1' value }
;

Statement		
: AliasStatement { self statement: '1' value } 
| AssignmentStatement { self statement: '1' value }
| CaseStatement { self statement: '1' value }
| CompoundStatement { self statement: '1' value }
| EscapeStatement { self statement: '1' value }
| IfStatement { self statement: '1' value }
| RepeatStatement { self statement: '1' value }
| ReturnStatement { self statement: '1' value }
| SkipStatement { self statement: '1' value }
| OutputStatement { self statement: '1' value }
| SplitmarkStatement { self statement: '1' value }
| EndSplitmarkStatement { self statement: '1' value } 
| NativeStatement { self statement: '1' value }
| ProcedureCallStatement { self statement: '1' value } 
| NullStatement { self statement: '1' value }
;

NullStatement
: Semicolon { self nullStatement }
;

Assignable
: AssignableList
{
	self assignable: '1' value
}
;

ProcedureCallStatement
: Identifier Semicolon { self procedureCall: '1' value } 
;

AssignableList
: AssignableList Qualifier { OrderedCollection new addAll: '1' value;  add: '2' value; yourself }
| Identifier { OrderedCollection with: '1' value }
;

NativeStatement
: NativeAlgorithm
{
	self nativeStatement: '1' value
}
;

NativeExpression
: NativeAlgorithm
{
	self nativeExpression: '1' value
}
;

NativeAlgorithm
: <nativeAlgorithm>+
{
	self nativeAlgorithm: '1' value
}
;

AliasStatement		
: ""alias"" AliasStatementVariable  Semicolon Statement* ""end_alias"" Semicolon
{
	self aliasStatement: '2' value statements: '4' value
}
;

AliasStatementVariable
: SimpleIdentifier ""for"" Assignable
{
	self aliasStatementVariable: '1' value for: '3' value
}
;

AssignmentStatement	
: Assignable "":="" Expression Semicolon
{
	self assignmentStatement: '1' value from: '3' value
}
;

CaseAction		
: ExpressionsList "":"" Statement
{
	self caseAction: '1' value statement: '3' value
}
;

CaseOtherwise		
: ""otherwise"" "":"" Statement
{
	self caseOtherwise: '3' value
}
;

CaseStatement		
: ""case"" Expression ""of"" CaseAction*  CaseOtherwise? ""end_case"" Semicolon
{
	self caseStatement: '2' value caseActions: '4' value caseOtherwise: '5' value 
}
;

CompoundStatement	
:  CompoundStatementBegin Statement* ""end"" Semicolon
{
	self compoundStatement: '1' value statements: '2' value
}
;

CompoundStatementBegin
: ""begin"" { self compoundStatementBegin }
;

EscapeStatement
: ""escape"" Semicolon
{
	self escapeStatement
}
;

IfStatement		
: ""if"" Expression ""then"" Statement* ""end_if"" Semicolon
{
	self ifStatement: '2' value then: '4' value else: nil
}
| ""if"" Expression ""then"" Statement*  ""else"" Statement* ""end_if"" Semicolon
{
	self ifStatement: '2' value then: '4' value else: '6' value
}
;

ByExpression
: ""by"" Expression
{
	'2' value
}
;

IncrementControl	
: SimpleIdentifier "":="" Expression ""to"" Expression ByExpression?
{
	self incrementControl: '1' value first: '3' last: '5' value step: '6' value
}
;

WhileControl
: ""while"" Expression
{
	'2' value
}
;

UntilControl
: ""until"" Expression
{
	'2' value
}
;

RepeatStatement	
: ""repeat"" IncrementControl? WhileControl? UntilControl? Semicolon Statement* ""end_repeat"" Semicolon
{
	self repeatStatement: '2' value whileControl: '3' value untilControl: '4' value statements: '6' value 
}
;

ReturnStatement	
: ""return"" Semicolon
{
	self returnStatement: nil
}
| ""return"" ""("" Expression "")"" Semicolon
{
	self returnStatement: '3' value
}
;

SkipStatement
: ""skip"" Semicolon
{
	self skipStatement
}
;

OutputStatement
: ""|"" Expression ""|"" Semicolon
{
	self outputStatement: '2' value 
}
;

SplitmarkStatement
: ""{*""  ""*""? ""splitmark"" Expression ""*}""
{
	self beginSplitmarkStatement: '4' value append: '2' notNil
}
;

EndSplitmarkStatement
: ""{*"" ""*""? ""end_splitmark"" ""*}""
{
	self endSplitmarkStatement
}
;

LocalDecl	
: ""local"" LocalBody* ""end_local"" Semicolon 
{
	self localDecl: '2' value
}
;

LocalBody 
: IdentifiersList "":"" BaseType Semicolon
{
	self localBody: '1' value baseType: '3' value initializer: nil
}
| IdentifiersList "":"" BaseType "":="" Expression Semicolon
{
	self localBody: '1' value baseType: '3' value initializer: '5' value
}
;

FormalParametersDecl
: ""("" FormalParametersList "")""
{
	self formalParametersList: '2' value
}
;

FormalParametersList
: FormalParameter { OrderedCollection with: '1' value }
| FormalParametersList Semicolon FormalParameter { OrderedCollection new addAll: '1' value; add: '3' value; yourself }
;

FormalParameter
: Var IdentifiersList "":"" ParameterType
{
	self formalParameter: '2' value parameterType: '4' value var: '1' value 
}
;

Var
: ""var"" { true }
| 	{ false }
;

EntityEntry
: Entity
{
	self entityEntry: '1' value
}
;

Entity
: ""entity"" EntityIdentifier EntitySubSuper? Semicolon  ExplicitAttribute*  DeriveClause?  InverseClause?  UniqueClause?  WhereClause?  ""end_entity"" Semicolon 
{
	self entity: '2' value subSuper: '3' value explicitAttributes: '5' value deriveClause: '6' value inverseClause: '7' value uniqueClause: '8' value whereClause: '9' value
}
;

EntityIdentifier
: ConceptIdentifier { self entityIdentifier: '1' value }
;

EntitySubSuper
: SupertypeConstraint { self entitySupertype: '1' value subtype: nil }
| SubtypeDeclaration { self entitySupertype: nil subtype: '1' value}
| SupertypeConstraint SubtypeDeclaration { self entitySupertype: '1' value subtype: '2' value }
;

SubtypeDeclaration
: ""subtype"" ""of"" ""("" SubtypeIdentifiersList "")""
{
	self subtypeDeclaration: '4' value
}
;

SubtypeIdentifiersList
: SubtypeIdentifier { OrderedCollection with: '1' value }
| SubtypeIdentifiersList "","" SubtypeIdentifier { OrderedCollection new addAll: '1' value; add: '3' value; yourself }
;

SubtypeIdentifier
: SimpleIdentifier { self subtypeIdentifier: '1' value }
;

SupertypeConstraint
: ""abstract"" ""supertype"" SupertypeRuleTail?
{
	self abstractSupertypeConstraint: '3' value
}
| ""supertype"" SupertypeRuleTail
{
	self supertypeConstraint: '2' value
}
;

SupertypeRuleTail
: ""of"" ""("" SupertypeExpression "")""
{
	'3' value
}
; 

SupertypeExpression
: SimpleIdentifier
{
	self supertypeEntityReference: '1' value
}
| SupertypeExpression ""andor"" SupertypeExpression
{
	self supertypeExpression: '1' value andor: '3' value
}
| SupertypeExpression ""and"" SupertypeExpression
{
	self supertypeExpression: '1' value and: '3' value
}
| ""oneof"" ""("" SupertypeExpressionsList "")""
{
	self supertypeOneofExpression: '3' value
}
| ""("" SupertypeExpression "")""
{
	'2' value
}
;

SupertypeExpressionsList 
: SupertypeExpression  { OrderedCollection with: '1' value }
| SupertypeExpressionsList "","" SupertypeExpression  { OrderedCollection new addAll: '1' value; add: '3' value; yourself }
;

AttributeNameDecl
: ConceptIdentifier
{
	self attributeName:  '1' value groupRef: nil
}
| ""self"" ""\"" SimpleIdentifier ""."" ConceptIdentifier
{
	self attributeName:  '5' value groupRef: '3' value
}
;

SimpleAttributeNameDecl
: SimpleIdentifier
{
	self simpleAttributeName:  '1' value groupRef: nil
}
| ""self"" ""\"" SimpleIdentifier ""."" SimpleIdentifier
{
	self simpleAttributeName:  '5' value groupRef: '3' value
}
;

AttributesNameDeclList
: AttributeNameDecl  { OrderedCollection with: '1' value }
| AttributesNameDeclList "","" AttributeNameDecl  { OrderedCollection new addAll: '1' value; add: '3' value; yourself }
;

ExplicitAttribute
: AttributesNameDeclList "":""  Optional BaseType Semicolon
{
	self explicitAttributes: '1' value baseType: '4' value optional: '3' value 
}
;

Optional
: ""optional"" { true }
| { false }
;

DeriveClause		
: ""derive"" RemarkReference* DerivedAttribute+ 
{
	self deriveClause: '3' value
}
;

DerivedAttribute
: AttributeNameDecl "":"" BaseType "":="" Expression Semicolon
{
	self derivedAttribute: '1' value baseType: '3' value expression: '5' value
}
;

InverseClause
: ""inverse"" RemarkReference* InverseAttribute+
{
	self inverseClause: '3' value
}
;

InverseAttribute
: AttributeNameDecl "":"" InverseAttributeDomain ""for"" SimpleIdentifier Semicolon
{
	self inverseAttribute: '1' value baseType: '3' value for: '5' value
}
;

InverseAttributeDomain
: BaseType { self inverseAttributeDomain: '1' value }
;

UniqueClause
: ""unique"" RemarkReference* UniqueAttributesList+
{
	self uniqueClause: '3' value
}
;

UniqueAttributesList
: UniqueListHead UniqueNamesList Semicolon
{
	self uniqueAttributesList: '2' value head: '1' value
}
| UniqueNamesList Semicolon
{
	self uniqueAttributesList: '1' value head: nil
}
;

UniqueListHead
: SimpleIdentifier "":"" 
{
	'1' value
}
;

UniqueNamesList
: SimpleAttributeNameDecl { OrderedCollection with: '1' value }
| UniqueNamesList "","" SimpleAttributeNameDecl { OrderedCollection new addAll: '1' value; add: '3' value; yourself }
;

TypeEntry
: Type
{ 
	self typeEntry: '1' value
}
;

Type
: ""type"" TypeIdentifier ""="" UnderlyingType Semicolon WhereClause? ""end_type"" Semicolon 
{
	self type: '2' value underlyingType: '4' value whereClause: '6' value
}
| ""map"" MapIdentifiersPath ""to""  Expression Semicolon ""end_map"" Semicolon { self typeMapFrom: '2' to: '4' }
| ""map"" ""to"" Expression Semicolon   MapIdentifiersPathAndSemicolon*   ""end_map"" Semicolon { self typeMapTo: '3' from: '5' value }
| ""map"" ""to"" Expression Semicolon WhereClause ""end_map"" Semicolon  { self typeMapWhereClause: '5' to: '3' } 
;

MapIdentifiersPathAndSemicolon
: MapIdentifiersPath Semicolon { '1' value }
;

MapIdentifiersPath
: SimpleIdentifier { OrderedCollection with: '1' value }
| MapIdentifiersPath ""."" SimpleIdentifier { OrderedCollection new addAll: '1' value; add: '3' value; yourself }
;

TypeIdentifier
: ConceptIdentifier
{
	self typeIdentifier: '1' value
}
;

WhereClause
: ""where"" RemarkReference* WhereRule+
{
	self whereClause: '3' value
}
;

WhereRule
: WhereRuleHead Expression Semicolon
{
	self whereRule: '2' value head: '1' value
}
| Expression Semicolon
{
	self whereRule: '1' value head: nil
}
;

WhereRuleHead
: SimpleIdentifier "":""
{
	'1' value
}
;

UnderlyingType
: DomainType
{
	'1' value
}
;

ConstructedType
: SelectType
{
	'1' value
}
| EnumerationType
{
	'1' value
}
;

EnumerationType
: ""enumeration"" ""of"" ""("" IdentifiersList "")""
{
	self enumerationType: '4' value
}
;

SelectType
: ""select"" ""("" IdentifiersList "")""
{
	self selectType: '3' value
}
;

BaseType
: DomainType
{
	'1' value
}
;

ParameterType
: DomainType
{
	'1' value
}
;

DomainType
: AggregationType
{
	'1' value
}
| ConstructedType
{
	'1' value
}
| SimpleType
{
	'1' value
}
| NamedType
{
	'1' value
}
| GenericType
{
	'1' value
}
;

GenericType
: ""generic""
{
	self genericType: nil
}
| ""generic"" "":"" SimpleIdentifier
{
	self genericType: '3' value
}
;


AggregationType
: ArrayType
{
	'1' value
}
| ListType
{
	'1' value
}
| BagType
{
	'1' value
}
| SetType
{
	'1' value
}
| AggregateType
{
	'1' value
}
;

OptionalOrUnique
: ""optional"" ""unique""
{
	Array with: #optional with: #unique
}
| ""unique"" ""optional""
{
	Array with: #optional with: #unique
}
| ""optional"" 
{
	Array with: #optional 
}
| ""unique"" 
{
	Array with: #unique
}
;

IndexSpec	
: ""["" Expression "":"" Expression ""]""
{
	self indexSpecFrom: '2' value to: '4' value
}
;

ListType
: ""list"" IndexSpec? ""of"" ""unique""? BaseType
{
	self listType: '2' value baseType: '5' value unique: '4' value
}
;

ArrayType
: ""array"" IndexSpec? ""of"" OptionalOrUnique? BaseType
{
	self arrayType: '2' value baseType: '5' value optionalOrUnique: '4' value
}
;

BagType
: ""bag"" IndexSpec? ""of"" BaseType
{
	self bagType: '2' value baseType: '4' value 
}
;

SetType
: ""set"" IndexSpec? ""of"" BaseType
{
	self setType: '2' value baseType: '4' value
}
;

AggregateType
: ""aggregate"" ""of"" ParameterType
{
	self aggregateType: nil parameterType: '3' value
}
| ""aggregate"" "":"" SimpleIdentifier ""of"" ParameterType
{
	self aggregateType: '3' value parameterType: '5' value
}
;

SimpleType
: ""string"" FixedOrNotPrecisionSpec?
{
	self stringType: '2' value
}
| ""binary"" FixedOrNotPrecisionSpec?
{
	self binaryType: '2' value
}
| ""number"" 
{
	self numberType
}
| ""real"" PrecisionSpec?
{
	self realType: '2' value
}
| ""integer"" PrecisionSpec?
{
	self integerType: '2' value
}
| ""logical""
{
	self logicalType
}
| ""boolean""
{
	self booleanType
}
;

FixedOrNotPrecisionSpec 
: PrecisionSpec FixedOrNot
{
	Array with: '1' value with: '2' value 
}
;

FixedOrNot
: ""fixed"" { true }
| { false }
;

PrecisionSpec
: ""("" Expression "")""
{
	self precisionSpec: '2' value
}
;

NamedType
: ConceptIdentifier
{
	self namedType: '1' value
}
;

Expression 
: SimpleExpression
{
	'1' value
}
| SimpleExpression ""<"" SimpleExpression
{
	self expression: '1' value lessThan: '3' value
}
| SimpleExpression "">"" SimpleExpression
{
	self expression: '1' value greaterThan: '3' value
}
| SimpleExpression ""="" SimpleExpression
{
	self expression: '1' value equal: '3' value
}
| SimpleExpression ""<="" SimpleExpression
{
	self expression: '1' value lessThanOrEqual: '3' value
}
| SimpleExpression "">="" SimpleExpression
{
	self expression: '1' value greaterThanOrEqual: '3' value
}
| SimpleExpression ""<>"" SimpleExpression
{
	self expression: '1' value notEqual: '3' value
}
| SimpleExpression "":=:"" SimpleExpression
{
	self expression: '1' value instEqual: '3' value
}
| SimpleExpression "":<>:"" SimpleExpression
{
	self expression: '1' value instNotEqual: '3' value
}
| SimpleExpression ""in"" SimpleExpression
{
	self expression: '1' value in: '3' value
}
| SimpleExpression ""like"" SimpleExpression
{
	self expression: '1' value like: '3' value
}
;

SimpleExpression
: Term
{
	'1' value
}
| SimpleExpression ""or"" SimpleExpression
{
	self expression: '1' value or: '3' value
}
| SimpleExpression ""xor"" SimpleExpression
{
	self expression: '1' value xor: '3' value
}
| SimpleExpression ""+"" SimpleExpression
{
	self expression: '1' value plus: '3' value
}
| SimpleExpression ""-"" SimpleExpression
{
	self expression: '1' value minus: '3' value
}
;

Term
: Factor
{
	'1' value
}
| Term ""and"" Term
{
	self expression: '1' value and: '3' value
}
| Term ""mod"" Term
{
	self expression: '1' value mod: '3' value
}
| Term ""/"" Term
{
	self expression: '1' value div: '3' value
}
| Term ""div"" Term
{
	self expression: '1' value realDiv: '3' value
}
| Term ""*"" Term
{
	self expression: '1' value mult: '3' value
}
| Term ""||"" Term
{
	self expression: '1' value instConst: '3' value
}
;

Factor
: SimpleFactor
{
	'1' value
}
| Factor ""**"" Factor
{
	self expression: '1' value expo: '3' value
}
;

SimpleFactor
: SignedSimpleFactor
{
	'1' value
}
| AggregateInitializer
{
	'1' value
}
| SimpleFactor Qualifier+
{
	self qualifiedExpression: '1' value qualifiers: '2' 
}
| Literal
{
	'1' value
}
| Identifier
{
	'1' value
}
| ""("" Expression "")""
{
	self expressionBetweenParenthesis: '2' value
}
| ""%"" Expression ""%""
{
	self escapedExpression: '2' value
}
| Interval
{
	'1' value
}
| QueryExpression
{
	'1' value
}
| ""not"" SimpleFactor
{
	self not: '2' value
}
| SimpleFactor CardinalityOp SimpleFactor
{
	self expression: '1' value cardinality: '2' value expression: '3' value
}
| NativeExpression 
{
	'1' value
}
;

SignedSimpleFactor
: ""+"" SimpleFactor
{
	self positiveExpression: '2' value
} 
| ""-"" SimpleFactor 
{
	self negativeExpression: '2' value
} 
;

QueryExpression	
: ""query"" ""("" QueryVariable ""<*"" Expression ""|"" Expression "")""
{
	self queryExpression: '3' value source: '5' value suchThat: '7' value
}
;

QueryVariable
: SimpleIdentifier 
{
	self queryVariable: '1' value
}
;

Interval		
: ""{"" SimpleExpression IntervalOp SimpleExpression IntervalOp SimpleExpression ""}""
{
	self intervalExpression: '2' value op: '3' value expression: '4' value op: '5' value expression: '6' value
}
;

IntervalOp		
: ""<"" 
{
	#'<'
}
| ""<=""
{
	#'<='
}
;

Literal			
: <integer> 
{
	self integerLiteral: '1' value asNumber
}
| <real> 
{
	self realLiteral: '1' value asNumber
}
| <string> 
{
	self stringLiteral: '1' value
}
| <encodedString> 
{
	self encodedStringLiteral: '1' value
}
| ""true""
{
	self logicalLiteral: #true
}
| ""false""
{
	self logicalLiteral: #false
}
| ""unknown""
{
	self logicalLiteral: #unknown
}
| <binary> 
{
	self binaryLiteral: '1' value
}
| ""pi""
{
	self piConstant
}
| ""const_e""
{
	self eConstant
}
;

Identifier
: ""self""
{
	self selfIdentifier
}
| ""?""
{
	self missingValue: false
}
| SimpleIdentifier
{
	self identifier: '1' value
}
| ArgumentedIdentifier { '1' value }
;

ArgumentedIdentifier
: SimpleIdentifier ""("" ExpressionsList? "")""
{
	self identifier: '1' value arguments: '3' value
}
;

GroupRef
: ""\"" SimpleIdentifier
{
	self groupRef: '2' value
}
;

Qualifier		
:  ""."" SimpleIdentifier
{
	self attributeQualifier: '2' value
}
| GroupRef
{
	'1' value
}
| ""["" SimpleExpression ""]""
{
	self elementQualifier: '2' value
}
| ""["" SimpleExpression "":"" SimpleExpression ""]""
{
	self rangeQualifierFrom: '2' value to: '4' value
}
;

CardinalityOp		
: ""{"" Expression "":"" Expression ""}""
{
	self cardinalityExpressionFrom: '2' value to: '4' value
}
;

AggregateInitializer
: ""["" AggregateInitBody ""]""
{
	self aggregateInitializer: '2' value
}
| ""[""  ""]""
{
	self aggregateInitializer: #()
}
;

AggregateInitElement
: Expression
{
	self aggregateInitializerElement: '1' value repetition: nil
}
| Expression "":"" Expression
{ 
	self aggregateInitializerElement: '1' value repetition: '3' value
}
;

AggregateInitBody
: AggregateInitElement  { OrderedCollection with: '1' value }
| AggregateInitBody "","" AggregateInitElement { OrderedCollection new addAll: '1' value; add: '3' value; yourself }
;

SimpleIdentifier 
: <identifier> { '1' value }
;

IdentifiersList
: SimpleIdentifier RemarkReference* { OrderedCollection with: '1' value }
| IdentifiersList Colon SimpleIdentifier  RemarkReference* { OrderedCollection new addAll: '1' value; add: '3' value; yourself }
;

Colon
: "",""  RemarkReference*
;

ExpressionsList 
: Expression { OrderedCollection with: '1' value }
| ExpressionsList "","" Expression { OrderedCollection new addAll: '1' value; add: '3' value; yourself }
;

"! !

!PlatypusExpressAbstractParser class methodsFor: 'generated-accessing' stamp: 'AlainPlantec 1/13/2012 15:39'!
scannerClass
	^PlatypusExpressScanner! !

!PlatypusExpressAbstractParser class methodsFor: 'generated-starting states' stamp: 'AlainPlantec 1/13/2012 15:39'!
startingStateForConstantsEntry
	^5! !

!PlatypusExpressAbstractParser class methodsFor: 'generated-starting states' stamp: 'AlainPlantec 1/13/2012 15:39'!
startingStateForEntityEntry
	^7! !

!PlatypusExpressAbstractParser class methodsFor: 'generated-starting states' stamp: 'AlainPlantec 1/13/2012 15:39'!
startingStateForExpressionEntry
	^12! !

!PlatypusExpressAbstractParser class methodsFor: 'generated-starting states' stamp: 'AlainPlantec 1/13/2012 15:39'!
startingStateForFunctionEntry
	^8! !

!PlatypusExpressAbstractParser class methodsFor: 'generated-starting states' stamp: 'AlainPlantec 1/13/2012 15:39'!
startingStateForProcedureEntry
	^9! !

!PlatypusExpressAbstractParser class methodsFor: 'generated-starting states' stamp: 'AlainPlantec 1/13/2012 15:39'!
startingStateForRuleEntry
	^10! !

!PlatypusExpressAbstractParser class methodsFor: 'generated-starting states' stamp: 'AlainPlantec 1/13/2012 15:39'!
startingStateForSchemaContentsEntry
	^4! !

!PlatypusExpressAbstractParser class methodsFor: 'generated-starting states' stamp: 'AlainPlantec 1/13/2012 15:39'!
startingStateForSchemaEntry
	^3! !

!PlatypusExpressAbstractParser class methodsFor: 'generated-starting states' stamp: 'AlainPlantec 1/13/2012 15:39'!
startingStateForSchemaInstanceEntry
	^2! !

!PlatypusExpressAbstractParser class methodsFor: 'generated-starting states' stamp: 'AlainPlantec 1/13/2012 15:39'!
startingStateForStatementsEntry
	^11! !

!PlatypusExpressAbstractParser class methodsFor: 'generated-starting states' stamp: 'AlainPlantec 1/13/2012 15:39'!
startingStateForTypeEntry
	^6! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:02'!
abstractSupertypeConstraint: supertypeConstraintOrNil 
	| r | r := OrderedCollection new. r add: #abstractSupertype; add: supertypeConstraintOrNil. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:03'!
actionBodyDecl: declarationsOrNil statements: statementsOrNil
	| r | r := OrderedCollection new. r add: #actionBodyDecl; add: declarationsOrNil; add: statementsOrNil. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:03'!
aggregateInitializer: initList 
	| r | r := OrderedCollection new. r add: #aggregateInitializer; add: initList. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:03'!
aggregateInitializerElement: expression repetition: expressionOrNil 
	| r | r := OrderedCollection new. r add: #aggregateInitializerElement; add: expression; add: expressionOrNil. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:04'!
aggregateType: keyIdentOrNil parameterType: parameterType 
	| r | r := OrderedCollection new. r add: #aggregateType; add: keyIdentOrNil; add: parameterType. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 3/7/2003 15:03'!
aliasStatement: ident statements: statements 
	| r | r := OrderedCollection new. r add: #aliasStatement; add: ident; add: statements. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 3/7/2003 15:04'!
aliasStatementVariable: anIdentifier for: assignable
	| r | r := OrderedCollection new. r add: #aliasStatementVariable; add: anIdentifier; add: assignable. ^ r
! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:04'!
arrayType: indexSpecOrNil baseType: baseType optionalOrUnique: arrayOfSymbols
	| r | r := OrderedCollection new. r add: #arrayType; add: indexSpecOrNil; add: baseType; add: arrayOfSymbols. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:04'!
assignable: aCollection 
	| r | r := OrderedCollection new. r add:  #assignable; add: aCollection. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:08'!
assignmentStatement: assignable from: expression 
	| r | r := OrderedCollection new. r add: #assignementStatement; add: assignable; add: expression. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 16:22'!
attributeName: simpleIdent groupRef: aGroupIdentOrNil
	| r | r := OrderedCollection new. r add: #attributeName; add: simpleIdent; add: aGroupIdentOrNil. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:05'!
attributeQualifier: aQualifier 
	| r | r := OrderedCollection new. r add: #attributeQualifier; add: aQualifier. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:05'!
bagType: indexSpecOrNil baseType: baseType 
	| r | r := OrderedCollection new. r add: #bagType; add: indexSpecOrNil; add: baseType. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:06'!
beginSplitmarkStatement: stringExpression 
	| r | r := OrderedCollection new. r add: #beginSplitmark; add: stringExpression. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:06'!
binaryLiteral: aBinary 
	| r | r := OrderedCollection new. r add: #binaryLiteral; add: aBinary. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:06'!
binaryType: FixedOrNotPrecisionSpecOrNil 
	| r | r := OrderedCollection new. r add: #binaryType; add: FixedOrNotPrecisionSpecOrNil. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 3/14/2006 07:57'!
block: aParserResult 
	^ aParserResult isCollection
		ifTrue: [aParserResult]
		ifFalse: [aParserResult metaData]! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:06'!
booleanType
	| r | r := OrderedCollection new. r add: #booleanType. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 3/13/2006 14:27'!
buildParserResultWith: aMetaData 
	^ aMetaData! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:07'!
cardinalityExpressionFrom: expression1 to: expression2 
	| r | r := OrderedCollection new. r add: #cardinalityExpression; add: expression1; add: expression2. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:07'!
caseAction: expressionsList statement: aStatement 
	| r | r := OrderedCollection new. r add: #caseAction; add: expressionsList; add: aStatement. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:07'!
caseOtherwise: aStatement 
	| r | r := OrderedCollection new. r add: #caseOtherwise; add: aStatement. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:07'!
caseStatement: caseSelectorExpression caseActions: caseActionsListOrNil caseOtherwise: caseOtherwiseOrNil 
	| r | r := OrderedCollection new. r add: #caseStatement; add: caseSelectorExpression; add: caseActionsListOrNil; add: caseOtherwiseOrNil. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 3/7/2003 15:59'!
compoundStatement: aCompoundStatement statements: statementsListOrNil 
	| r | r := OrderedCollection new. r add: #compoundStatement; add: statementsListOrNil . ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 3/7/2003 16:00'!
compoundStatementBegin
	^ #'begin'! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 3/29/2006 17:04'!
conceptIdentifier: anIdent
	^ anIdent! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 3/29/2006 17:05'!
conceptIdentifier: anIdent metaExpression: aMetaExpression 
	| r | r := OrderedCollection new. r add: #conceptIdent; add: anIdent; add: #metaExpression; add: aMetaExpression. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:08'!
constantBody: ident baseType: baseType expression: initExpression 
	| r | r := OrderedCollection new. r add: #constantBody; add: ident; add: baseType; add: initExpression. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:09'!
constantsDecl: constantsBodyCollectionOrNil
	| r | r := OrderedCollection new. r add: #constantsDecl; add: constantsBodyCollectionOrNil. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 3/5/2003 11:05'!
constantsEntry: constantsList
	^ self buildParserResultWith: constantsList! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:09'!
deriveClause: derivedAttributesList 
	| r | r := OrderedCollection new. r add: #deriveClause; add: derivedAttributesList. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 3/6/2003 15:17'!
derivedAttribute: attribute baseType: baseType expression: expression 
	| r | r := OrderedCollection new. r add: #derivedAttribute; add: attribute; add: baseType; add: expression. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:09'!
eConstant
	| r | r := OrderedCollection new. r add: #eConstant. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:09'!
elementQualifier: anExpression
	| r | r := OrderedCollection new. r add: #elementQualifier; add: anExpression. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 4/18/2006 12:43'!
encodedStringLiteral: anEncodedString 
	| r | r := OrderedCollection new. r add:  
		#encodedStringLiteral.
		^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:10'!
endSplitmarkStatement
	| r | r := OrderedCollection new. r add: #endSplitmarkStatement. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:10'!
entity: ident subSuper: anArrayOrNil explicitAttributes: explicitAttrListOrNil deriveClause: derivedClauseOrNil inverseClause: inverseClauseOrNil uniqueClause: uniqueClauseOrNil whereClause: whereClauseOrNil 
	| r | r := OrderedCollection new. r add: #entity; add: ident; add: anArrayOrNil; add: explicitAttrListOrNil; add: derivedClauseOrNil; add: inverseClauseOrNil; add: uniqueClauseOrNil; add: whereClauseOrNil. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 3/11/2003 22:55'!
entityEntry: anEntity
	^ self buildParserResultWith: anEntity! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 3/6/2003 11:31'!
entityIdentifier: anIdent
	^ anIdent! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 16:20'!
entitySupertype: supertypeConstraintOrNil subtype: subtypeDeclarationOrNil
	| r | r := OrderedCollection new. r add: #entitySubSuper; add: supertypeConstraintOrNil; add: subtypeDeclarationOrNil. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:10'!
enumerationType: identList 
	| r | r := OrderedCollection new. r add: #enumerationType; add: identList. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:10'!
escapeStatement
	| r | r := OrderedCollection new. r add: #escapeStatement. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 4/13/2006 11:29'!
escapedExpression: anExpression
	^ Array with: #escapedExpression with: anExpression! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:11'!
explicitAttributes: arg1 baseType: arg4 optional: arg3 
	| r | r := OrderedCollection new. r add: #explicitAttributes; add: arg1; add: arg4; add: arg3. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 3/5/2003 10:02'!
explicitlyImportedItem: name renamedAs: localName
	| r | r := OrderedCollection new. r add: #explicitlyImportedItem; add: name; add:  localName. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 3/5/2003 10:03'!
explicitlyImportedItems: aCollectionOfDomainEquivalentItems
	| r | r := OrderedCollection new. r add: #explicitlyImportedItems; add: aCollectionOfDomainEquivalentItems. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:11'!
expression: op1 and: op2 
	| r | r := OrderedCollection new. r add: #andExpression; add: op1; add: op2. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 3/5/2003 17:39'!
expression: exp1 cardinality: op expression: exp2 
	| r | r := OrderedCollection new. r add: #cardinalityExpression; add: exp1; add: op; add: exp2 . ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:12'!
expression: op1 div: op2 
	| r | r := OrderedCollection new. r add: #divExpression; add: op1; add: op2. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:12'!
expression: op1 equal: op2 
	| r | r := OrderedCollection new. r add: #equalExpression; add: op1; add: op2. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:12'!
expression: op1 expo: op2 
	| r | r := OrderedCollection new. r add: #expoExpression; add: op1; add: op2. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:13'!
expression: op1 greaterThan: op2 
	| r | r := OrderedCollection new. r add: #greaterThanExpression; add: op1; add: op2. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:13'!
expression: op1 greaterThanOrEqual: op2 
	| r | r := OrderedCollection new. r add: #greaterThanOrEqualExpression; add: op1; add: op2. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:13'!
expression: op1 in: op2 
	| r | r := OrderedCollection new. r add: #inExpression; add: op1; add: op2. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:13'!
expression: op1 instConst: op2 
	| r | r := OrderedCollection new. r add: #instanceConstructionExpression; add: op1; add: op2. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:14'!
expression: op1 instEqual: op2 
	| r | r := OrderedCollection new. r add: #instEqualExpression; add: op1; add: op2. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:14'!
expression: op1 instNotEqual: op2 
	| r | r := OrderedCollection new. r add: #instNotEqualExpression; add: op1; add: op2. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:14'!
expression: op1 lessThan: op2 
	| r | r := OrderedCollection new. r add: #lessThanExpression; add: op1; add: op2. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:14'!
expression: op1 lessThanOrEqual: op2 
	| r | r := OrderedCollection new. r add: #lessThanOrEqualExpression; add: op1; add: op2. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:14'!
expression: op1 like: op2 
	| r | r := OrderedCollection new. r add: #likeExpression; add: op1; add: op2. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:15'!
expression: op1 minus: op2 
	| r | r := OrderedCollection new. r add: #minusExpression; add: op1; add: op2. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:15'!
expression: op1 mod: op2 
	| r | r := OrderedCollection new. r add: #modExpression; add: op1; add: op2. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:15'!
expression: op1 mult: op2 
	| r | r := OrderedCollection new. r add: #multExpression; add: op1; add: op2. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:15'!
expression: op1 notEqual: op2 
	| r | r := OrderedCollection new. r add: #notQualExpression; add: op1; add: op2. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:15'!
expression: op1 or: op2 
	| r | r := OrderedCollection new. r add: #orExpression; add: op1; add: op2. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:15'!
expression: op1 plus: op2 
	| r | r := OrderedCollection new. r add: #plusExpression; add: op1; add: op2. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:15'!
expression: op1 realDiv: op2 
	| r | r := OrderedCollection new. r add: #realDicExpression; add: op1; add: op2. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:16'!
expression: op1 xor: op2 
	| r | r := OrderedCollection new. r add: #xorExpression; add: op1; add: op2. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 3/10/2003 23:19'!
expressionBetweenParenthesis: expression
	^ expression! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 12/13/2003 12:15'!
expressionEntry: expression
	^ expression! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 3/25/2006 11:07'!
externalMetaSchema: schemaIdent 
	| r | r := OrderedCollection new. r add: #externalMetaShema; add: schemaIdent. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:16'!
formalParameter: identList parameterType: type var: varOrNotBoolean 
	| r | r := OrderedCollection new. r add: #formalParameter; add: identList; add: type; add: varOrNotBoolean. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:16'!
formalParametersList: aCollection 
	| r | r := OrderedCollection new. r add: #formalParametersList; add: aCollection. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:16'!
function: functionIdent formalParametersDecl: parametersListOrNil returnType: returnType actionBody: actionBody 
	| r | r := OrderedCollection new. r add: #function; add: functionIdent; add: parametersListOrNil; add: returnType; add: actionBody. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 10:08'!
functionEntry: aFunction
	^ self buildParserResultWith: aFunction! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 3/5/2003 16:51'!
functionIdentifier: anIdentifier 
	^ anIdentifier! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 3/5/2003 12:45'!
genericType: keyIdentOrNil
	| r | r := OrderedCollection new. r add: #genericType; add: keyIdentOrNil. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:17'!
groupRef: groupIdent 
	| r | r := OrderedCollection new. r add: #groupRef; add: groupIdent. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 3/5/2003 18:08'!
identifier: aString
	| r | r := OrderedCollection new. r add: #identifier. aString. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 5/24/2004 15:44'!
identifier: aString arguments: arguments
	| r | r := OrderedCollection new. r add: #identifier; add: aString; add: arguments. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:17'!
ifStatement: cond then: thenStatementOrNil else: elseStatementOrNil 
	| r | r := OrderedCollection new. r add: #ifStatement; add: cond; add: thenStatementOrNil; add: elseStatementOrNil. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 3/13/2006 14:23'!
implementedSchemata: anIdentifier 
	| r | r := OrderedCollection new. r add: #implemented; add:  anIdentifier. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:17'!
incrementControl: ident first: firstValueExpression last: lastValueExpression step: byExpressionOrNil 
	| r | r := OrderedCollection new. r add: #incrementControl; add: ident; add: firstValueExpression; add: lastValueExpression; add: byExpressionOrNil. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:17'!
indexSpecFrom: lowIndex to: hiIndex 
	| r | r := OrderedCollection new. r add: #indexSpec; add: lowIndex; add: hiIndex. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:17'!
integerLiteral: anInteger 
	| r | r := OrderedCollection new. r add: #integerLiteral; add: anInteger. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:18'!
integerType: precisionSpecOrNil 
	| r | r := OrderedCollection new. r add: #integerType; add: precisionSpecOrNil. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 4/18/2006 12:41'!
interfaceSpecification: useOrRefSymbol schema: schemaIdent interfaceList: interfacesListOrNil 
	| r | r := OrderedCollection new. r add: #interfaceSpecification; add: useOrRefSymbol; add: schemaIdent; add: interfacesListOrNil.  ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 16:30'!
intervalExpression: expression1 op: lessThanOrLessEqualSymbol1 expression: expression2 op: lessThanOrLessEqualSymbol2 expression: expression3 
	| r | r := OrderedCollection new. r add: #intervalExpression; add: expression1; add: lessThanOrLessEqualSymbol1; add: expression2; add: lessThanOrLessEqualSymbol2; add: expression3. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:18'!
inverseAttribute: ident baseType: baseType for: attrIdent 
	| r | r := OrderedCollection new. r add: #inverseAttribute; add: ident; add: baseType; add: attrIdent. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 3/6/2003 16:04'!
inverseAttributeDomain: baseType
	^baseType! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:18'!
inverseClause: inverseAttributesList 
	| r | r := OrderedCollection new. r add: #inverseClause; add: inverseAttributesList. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:19'!
listType: indexSpecOrNil baseType: baseType unique: uniqueOrNil 
	| r | r := OrderedCollection new. r add: #listType; add: indexSpecOrNil; add: baseType; add: uniqueOrNil. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:19'!
localBody: ident baseType: baseType initializer: expressionOrNil 
	| r | r := OrderedCollection new. r add: #localBody; add: ident; add: baseType; add: expressionOrNil. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:19'!
localDecl: declarationsOrNil
	| r | r := OrderedCollection new. r add: #localDecl; add: declarationsOrNil. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:19'!
logicalLiteral: trueFalseOrUnknown 
	| r | r := OrderedCollection new. r add: #logicalLiteral; add: trueFalseOrUnknown. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 4/18/2006 12:44'!
logicalType
	| r | r := OrderedCollection new. r add: #logicalType. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:19'!
missingValue: isARedefine 
	| r | r := OrderedCollection new. r add: #missingValue; add: isARedefine. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 3/5/2003 11:49'!
namedType: anIdentifier
	| r | r := OrderedCollection new. r add:  #namedType; add: anIdentifier . ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/10/2006 11:18'!
nativeAlgorithm: aNativeAlgorithm 
	| r | r := OrderedCollection new. r add: #nativeAlgorithm; add: aNativeAlgorithm lexicalElement. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/17/2006 08:47'!
nativeExpression: expr
	| r | r := OrderedCollection new. r add: #nativeExpression; add: expr. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/10/2006 11:26'!
nativeStatement: aNativeAlgorithm 
	| r | r := OrderedCollection new. r add: #nativeStatement; add: aNativeAlgorithm. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:20'!
negativeExpression: expression 
	| r | r := OrderedCollection new. r add: #negativeExpression; add: expression. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:20'!
not: expression 
	| r | r := OrderedCollection new. r add: #notExpression; add: expression. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 12/19/2003 13:59'!
nullStatement
	| r | r := OrderedCollection new. r add: #nullStatement . ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 5/22/2003 09:44'!
numberType
	| r | r := OrderedCollection new. r add: #numberType. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:20'!
outputStatement: expression 
	| r | r := OrderedCollection new. r add: #outputStatement; add: expression. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:20'!
piConstant
	| r | r := OrderedCollection new. r add: #piConstant. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:20'!
positiveExpression: expression 
	| r | r := OrderedCollection new. r add: #positiveExpression; add: expression. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:20'!
precisionSpec: anExpression 
	| r | r := OrderedCollection new. r add: #precisionSpec; add: anExpression. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:20'!
procedure: ident formalParametersDecl: parametersListOrNil actionBody: actionBody 
	| r | r := OrderedCollection new. r add: #procedure; add: ident; add: parametersListOrNil; add: actionBody. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 5/24/2004 15:13'!
procedureCall: ident
	| r | r := OrderedCollection new. r add: #procedureCall; add: ident. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 10:08'!
procedureEntry: aProcedure
	^ self buildParserResultWith: aProcedure! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 3/5/2003 16:51'!
procedureIdentifier: anIdentifier 
	^ anIdentifier! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:21'!
qualifiedExpression: expression qualifiers: qualifiersList 
	| r | r := OrderedCollection new. r add: #qualifiedExpression; add: expression; add: qualifiersList. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:21'!
queryExpression: ident source: sourceExpression suchThat: suchThatExpression 
	| r | r := OrderedCollection new. r add: #queryExpression; add: ident; add: sourceExpression; add: suchThatExpression. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 3/5/2003 19:05'!
queryVariable: ident
	| r | r := OrderedCollection new. r add:  #queryVariable; add: ident. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:21'!
rangeQualifierFrom: lowExpression to: highExpression 
	| r | r := OrderedCollection new. r add: #rangeQualifier; add: lowExpression; add: highExpression. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:21'!
realLiteral: aReal 
	| r | r := OrderedCollection new. r add: #realLiteral; add: aReal. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:22'!
realType: precisionSpecOrNil 
	| r | r := OrderedCollection new. r add: #RealType; add: precisionSpecOrNil. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 3/13/2006 17:41'!
realizationEntities: aListOrNil 
	| r | r := OrderedCollection new. r add: #realizationEntities; add: aListOrNil. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 3/13/2006 17:40'!
realizationIdentifier: anIdentifier 
	^ anIdentifier! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 3/13/2006 18:14'!
realizedSchemata: aListOrNil
	| r | r := OrderedCollection new. r add: #realizedSchemata; add: aListOrNil. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForActionBody1: nodes
	^ self actionBodyDecl: (nodes at: 1) value statements: (nodes at: 2) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForActionBodyDecl1: nodes
	^ (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForActionBodyDecl2: nodes
	^ (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForAggregateInitBody1: nodes
	^ OrderedCollection with: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForAggregateInitBody2: nodes
	^ (OrderedCollection new)
		addAll: (nodes at: 1) value;
		add: (nodes at: 3) value;
		yourself! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForAggregateInitElement1: nodes
	^ self aggregateInitializerElement: (nodes at: 1) value repetition: nil! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForAggregateInitElement2: nodes
	^ self aggregateInitializerElement: (nodes at: 1) value repetition: (nodes at: 3) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForAggregateInitializer1: nodes
	^ self aggregateInitializer: (nodes at: 2) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForAggregateInitializer2: nodes
	^ self aggregateInitializer: #()! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForAggregateType1: nodes
	^ self aggregateType: nil parameterType: (nodes at: 3) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForAggregateType2: nodes
	^ self aggregateType: (nodes at: 3) value parameterType: (nodes at: 5) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForAggregationType1: nodes
	^ (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForAggregationType2: nodes
	^ (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForAggregationType3: nodes
	^ (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForAggregationType4: nodes
	^ (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForAggregationType5: nodes
	^ (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForAliasStatement1: nodes
	^ self aliasStatement: (nodes at: 2) value statements: (nodes at: 4) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForAliasStatementVariable1: nodes
	^ self aliasStatementVariable: (nodes at: 1) value for: (nodes at: 3) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForArgumentedIdentifier1: nodes
	^ self identifier: (nodes at: 1) value arguments: (nodes at: 3) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForArrayType1: nodes
	^ self arrayType: (nodes at: 2) value baseType: (nodes at: 5) value optionalOrUnique: (nodes at: 4) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForAssignable1: nodes
	^ self assignable: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForAssignableList1: nodes
	^ (OrderedCollection new)
		addAll: (nodes at: 1) value;
		add: (nodes at: 2) value;
		yourself! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForAssignableList2: nodes
	^ OrderedCollection with: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForAssignmentStatement1: nodes
	^ self assignmentStatement: (nodes at: 1) value from: (nodes at: 3) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForAttributeNameDecl1: nodes
	^ self attributeName: (nodes at: 1) value groupRef: nil! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForAttributeNameDecl2: nodes
	^ self attributeName: (nodes at: 5) value groupRef: (nodes at: 3) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForAttributesNameDeclList1: nodes
	^ OrderedCollection with: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForAttributesNameDeclList2: nodes
	^ (OrderedCollection new)
		addAll: (nodes at: 1) value;
		add: (nodes at: 3) value;
		yourself! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForBagType1: nodes
	^ self bagType: (nodes at: 2) value baseType: (nodes at: 4) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForBaseType1: nodes
	^ (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForBlock1: nodes
	^ self block: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForBlock2: nodes
	^ self block: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForBlock3: nodes
	^ self block: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForBlock4: nodes
	^ self block: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForBlock5: nodes
	^ self block: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForBlock6: nodes
	^ self block: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForByExpression1: nodes
	^ (nodes at: 2) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForCardinalityOp1: nodes
	^ self cardinalityExpressionFrom: (nodes at: 2) value to: (nodes at: 4) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForCaseAction1: nodes
	^ self caseAction: (nodes at: 1) value statement: (nodes at: 3) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForCaseOtherwise1: nodes
	^ self caseOtherwise: (nodes at: 3) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForCaseStatement1: nodes
	^ self caseStatement: (nodes at: 2) value caseActions: (nodes at: 4) value caseOtherwise: (nodes at: 5) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForCompoundStatement1: nodes
	^ self compoundStatement: (nodes at: 1) value statements: (nodes at: 2) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForCompoundStatementBegin1: nodes
	^ self compoundStatementBegin! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForConceptIdentifier1: nodes
	^ self conceptIdentifier: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForConceptIdentifier2: nodes
	^ self conceptIdentifier: (nodes at: 1) metaExpression: (nodes at: 3)! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForConstantBody1: nodes
	^ self constantBody: (nodes at: 1) value baseType: (nodes at: 3) value expression: (nodes at: 5) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForConstantsDecl1: nodes
	^ self constantsDecl: (nodes at: 2)! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForConstantsEntry1: nodes
	^ self constantsEntry: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForConstructedType1: nodes
	^ (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForConstructedType2: nodes
	^ (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForDeriveClause1: nodes
	^ self deriveClause: (nodes at: 3) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForDerivedAttribute1: nodes
	^ self derivedAttribute: (nodes at: 1) value baseType: (nodes at: 3) value expression: (nodes at: 5) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForDomainType1: nodes
	^ (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForDomainType2: nodes
	^ (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForDomainType3: nodes
	^ (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForDomainType4: nodes
	^ (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForDomainType5: nodes
	^ (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForEndSplitmarkStatement1: nodes
	^ self endSplitmarkStatement! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForEntity1: nodes
	^ self
		entity: (nodes at: 2) value
		subSuper: (nodes at: 3) value
		explicitAttributes: (nodes at: 5) value
		deriveClause: (nodes at: 6) value
		inverseClause: (nodes at: 7) value
		uniqueClause: (nodes at: 8) value
		whereClause: (nodes at: 9) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForEntityEntry1: nodes
	^ self entityEntry: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForEntityIdentifier1: nodes
	^ self entityIdentifier: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForEntitySubSuper1: nodes
	^ self entitySupertype: (nodes at: 1) value subtype: nil! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForEntitySubSuper2: nodes
	^ self entitySupertype: nil subtype: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForEntitySubSuper3: nodes
	^ self entitySupertype: (nodes at: 1) value subtype: (nodes at: 2) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForEnumerationType1: nodes
	^ self enumerationType: (nodes at: 4) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForEscapeStatement1: nodes
	^ self escapeStatement! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForExplicitAttribute1: nodes
	^ self explicitAttributes: (nodes at: 1) value baseType: (nodes at: 4) value optional: (nodes at: 3) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForExplicitlyImportedItem1: nodes
	^ self explicitlyImportedItem: (nodes at: 1) value renamedAs: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForExplicitlyImportedItem2: nodes
	^ self explicitlyImportedItem: (nodes at: 1) value renamedAs: (nodes at: 3) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForExplicitlyImportedItemsList1: nodes
	^ OrderedCollection with: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForExplicitlyImportedItemsList2: nodes
	^ (OrderedCollection new)
		addAll: (nodes at: 1) value;
		add: (nodes at: 3) value;
		yourself! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForExpression10: nodes
	^ self expression: (nodes at: 1) value in: (nodes at: 3) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForExpression11: nodes
	^ self expression: (nodes at: 1) value like: (nodes at: 3) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForExpression1: nodes
	^ (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForExpression2: nodes
	^ self expression: (nodes at: 1) value lessThan: (nodes at: 3) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForExpression3: nodes
	^ self expression: (nodes at: 1) value greaterThan: (nodes at: 3) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForExpression4: nodes
	^ self expression: (nodes at: 1) value equal: (nodes at: 3) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForExpression5: nodes
	^ self expression: (nodes at: 1) value lessThanOrEqual: (nodes at: 3) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForExpression6: nodes
	^ self expression: (nodes at: 1) value greaterThanOrEqual: (nodes at: 3) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForExpression7: nodes
	^ self expression: (nodes at: 1) value notEqual: (nodes at: 3) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForExpression8: nodes
	^ self expression: (nodes at: 1) value instEqual: (nodes at: 3) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForExpression9: nodes
	^ self expression: (nodes at: 1) value instNotEqual: (nodes at: 3) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForExpressionEntry1: nodes
	^ self expressionEntry: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForExpressionsList1: nodes
	^ OrderedCollection with: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForExpressionsList2: nodes
	^ (OrderedCollection new)
		addAll: (nodes at: 1) value;
		add: (nodes at: 3) value;
		yourself! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForFactor1: nodes
	^ (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForFactor2: nodes
	^ self expression: (nodes at: 1) value expo: (nodes at: 3) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForFixedOrNot1: nodes
	^ true! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForFixedOrNot2: nodes
	^ false! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForFixedOrNotPrecisionSpec1: nodes
	^ Array with: (nodes at: 1) value with: (nodes at: 2) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForFormalParameter1: nodes
	^ self formalParameter: (nodes at: 2) value parameterType: (nodes at: 4) value var: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForFormalParametersDecl1: nodes
	^ self formalParametersList: (nodes at: 2) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForFormalParametersList1: nodes
	^ OrderedCollection with: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForFormalParametersList2: nodes
	^ (OrderedCollection new)
		addAll: (nodes at: 1) value;
		add: (nodes at: 3) value;
		yourself! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForFunction1: nodes
	^ self
		function: (nodes at: 2) value
		formalParametersDecl: (nodes at: 3) value
		returnType: (nodes at: 5) value
		actionBody: (nodes at: 7) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForFunctionEntry1: nodes
	^ self functionEntry: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForFunctionIdentifier1: nodes
	^ self functionIdentifier: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForGenericType1: nodes
	^ self genericType: nil! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForGenericType2: nodes
	^ self genericType: (nodes at: 3) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForGroupRef1: nodes
	^ self groupRef: (nodes at: 2) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForIdentifier1: nodes
	^ self selfIdentifier! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForIdentifier2: nodes
	^ self missingValue: false! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForIdentifier3: nodes
	^ self identifier: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForIdentifier4: nodes
	^ (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForIdentifiersList1: nodes
	^ OrderedCollection with: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForIdentifiersList2: nodes
	^ (OrderedCollection new)
		addAll: (nodes at: 1) value;
		add: (nodes at: 3) value;
		yourself! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForIfStatement1: nodes
	^ self ifStatement: (nodes at: 2) value then: (nodes at: 4) value else: nil! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForIfStatement2: nodes
	^ self ifStatement: (nodes at: 2) value then: (nodes at: 4) value else: (nodes at: 6) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForIncrementControl1: nodes
	^ self
		incrementControl: (nodes at: 1) value
		first: (nodes at: 3)
		last: (nodes at: 5) value
		step: (nodes at: 6) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForIndexSpec1: nodes
	^ self indexSpecFrom: (nodes at: 2) value to: (nodes at: 4) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForInterfaceList1: nodes
	^ self explicitlyImportedItems: (nodes at: 2) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForInterfaceSpecification1: nodes
	^ self interfaceSpecification: (nodes at: 1) value schema: (nodes at: 3) value interfaceList: (nodes at: 4) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForInterfaceSpecification2: nodes
	^ self externalMetaSchema: (nodes at: 3) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForInterval1: nodes
	^ self
		intervalExpression: (nodes at: 2) value
		op: (nodes at: 3) value
		expression: (nodes at: 4) value
		op: (nodes at: 5) value
		expression: (nodes at: 6) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForIntervalOp1: nodes
	^ #<! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForIntervalOp2: nodes
	^ #<=! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForInverseAttribute1: nodes
	^ self inverseAttribute: (nodes at: 1) value baseType: (nodes at: 3) value for: (nodes at: 5) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForInverseAttributeDomain1: nodes
	^ self inverseAttributeDomain: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForInverseClause1: nodes
	^ self inverseClause: (nodes at: 3) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForListType1: nodes
	^ self listType: (nodes at: 2) value baseType: (nodes at: 5) value unique: (nodes at: 4) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForLiteral10: nodes
	^ self eConstant! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForLiteral1: nodes
	^ self integerLiteral: (nodes at: 1) value asNumber! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForLiteral2: nodes
	^ self realLiteral: (nodes at: 1) value asNumber! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForLiteral3: nodes
	^ self stringLiteral: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForLiteral4: nodes
	^ self encodedStringLiteral: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForLiteral5: nodes
	^ self logicalLiteral: #true! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForLiteral6: nodes
	^ self logicalLiteral: #false! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForLiteral7: nodes
	^ self logicalLiteral: #unknown! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForLiteral8: nodes
	^ self binaryLiteral: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForLiteral9: nodes
	^ self piConstant! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForLocalBody1: nodes
	^ self localBody: (nodes at: 1) value baseType: (nodes at: 3) value initializer: nil! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForLocalBody2: nodes
	^ self localBody: (nodes at: 1) value baseType: (nodes at: 3) value initializer: (nodes at: 5) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForLocalDecl1: nodes
	^ self localDecl: (nodes at: 2) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForMapIdentifiersPath1: nodes
	^ OrderedCollection with: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForMapIdentifiersPath2: nodes
	^ (OrderedCollection new)
		addAll: (nodes at: 1) value;
		add: (nodes at: 3) value;
		yourself! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForMapIdentifiersPathAndSemicolon1: nodes
	^ (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForNamedType1: nodes
	^ self namedType: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForNativeAlgorithm1: nodes
	^ self nativeAlgorithm: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForNativeExpression1: nodes
	^ self nativeExpression: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForNativeStatement1: nodes
	^ self nativeStatement: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForNullStatement1: nodes
	^ self nullStatement! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForOptional1: nodes
	^ true! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForOptional2: nodes
	^ false! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForOptionalOrUnique1: nodes
	^ Array with: #optional with: #unique! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForOptionalOrUnique2: nodes
	^ Array with: #optional with: #unique! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForOptionalOrUnique3: nodes
	^ Array with: #optional! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForOptionalOrUnique4: nodes
	^ Array with: #unique! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForOptionalXXByExpression1: nodes
	^ nil! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForOptionalXXByExpression2: nodes
	^ nodes at: 1! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForOptionalXXCaseOtherwise1: nodes
	^ nil! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForOptionalXXCaseOtherwise2: nodes
	^ nodes at: 1! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForOptionalXXDeriveClause1: nodes
	^ nil! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForOptionalXXDeriveClause2: nodes
	^ nodes at: 1! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForOptionalXXEntitySubSuper1: nodes
	^ nil! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForOptionalXXEntitySubSuper2: nodes
	^ nodes at: 1! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForOptionalXXExpressionsList1: nodes
	^ nil! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForOptionalXXExpressionsList2: nodes
	^ nodes at: 1! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForOptionalXXFixedOrNotPrecisionSpec1: nodes
	^ nil! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForOptionalXXFixedOrNotPrecisionSpec2: nodes
	^ nodes at: 1! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForOptionalXXFormalParametersDecl1: nodes
	^ nil! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForOptionalXXFormalParametersDecl2: nodes
	^ nodes at: 1! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForOptionalXXIncrementControl1: nodes
	^ nil! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForOptionalXXIncrementControl2: nodes
	^ nodes at: 1! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForOptionalXXIndexSpec1: nodes
	^ nil! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForOptionalXXIndexSpec2: nodes
	^ nodes at: 1! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForOptionalXXInterfaceList1: nodes
	^ nil! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForOptionalXXInterfaceList2: nodes
	^ nodes at: 1! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForOptionalXXInverseClause1: nodes
	^ nil! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForOptionalXXInverseClause2: nodes
	^ nodes at: 1! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForOptionalXXOptionalOrUnique1: nodes
	^ nil! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForOptionalXXOptionalOrUnique2: nodes
	^ nodes at: 1! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForOptionalXXPrecisionSpec1: nodes
	^ nil! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForOptionalXXPrecisionSpec2: nodes
	^ nodes at: 1! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForOptionalXXSupertypeRuleTail1: nodes
	^ nil! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForOptionalXXSupertypeRuleTail2: nodes
	^ nodes at: 1! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForOptionalXXUniqueClause1: nodes
	^ nil! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForOptionalXXUniqueClause2: nodes
	^ nodes at: 1! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForOptionalXXUntilControl1: nodes
	^ nil! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForOptionalXXUntilControl2: nodes
	^ nodes at: 1! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForOptionalXXWhereClause1: nodes
	^ nil! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForOptionalXXWhereClause2: nodes
	^ nodes at: 1! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForOptionalXXWhileControl1: nodes
	^ nil! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForOptionalXXWhileControl2: nodes
	^ nodes at: 1! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForOptionalXXXXX1: nodes
	^ nil! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForOptionalXXXXX2: nodes
	^ nodes at: 1! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForOptionalXXXuniqueX1: nodes
	^ nil! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForOptionalXXXuniqueX2: nodes
	^ nodes at: 1! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForOutputStatement1: nodes
	^ self outputStatement: (nodes at: 2) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForParameterType1: nodes
	^ (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForPrecisionSpec1: nodes
	^ self precisionSpec: (nodes at: 2) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForProcedure1: nodes
	^ self procedure: (nodes at: 2) value formalParametersDecl: (nodes at: 3) value actionBody: (nodes at: 5) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForProcedureCallStatement1: nodes
	^ self procedureCall: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForProcedureEntry1: nodes
	^ self procedureEntry: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForProcedureIdentifier1: nodes
	^ self procedureIdentifier: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForQualifier1: nodes
	^ self attributeQualifier: (nodes at: 2) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForQualifier2: nodes
	^ (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForQualifier3: nodes
	^ self elementQualifier: (nodes at: 2) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForQualifier4: nodes
	^ self rangeQualifierFrom: (nodes at: 2) value to: (nodes at: 4) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForQueryExpression1: nodes
	^ self queryExpression: (nodes at: 3) value source: (nodes at: 5) value suchThat: (nodes at: 7) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForQueryVariable1: nodes
	^ self queryVariable: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForRemarkReference1: nodes
	^ self remarkReference: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForRepeatStatement1: nodes
	^ self
		repeatStatement: (nodes at: 2) value
		whileControl: (nodes at: 3) value
		untilControl: (nodes at: 4) value
		statements: (nodes at: 6) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForRepeatXMultipleXXDerivedAttribute1: nodes
	^ OrderedCollection with: (nodes at: 1)! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForRepeatXMultipleXXDerivedAttribute2: nodes
	^ (nodes at: 1)
		add: (nodes at: 2);
		yourself! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForRepeatXMultipleXXInverseAttribute1: nodes
	^ OrderedCollection with: (nodes at: 1)! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForRepeatXMultipleXXInverseAttribute2: nodes
	^ (nodes at: 1)
		add: (nodes at: 2);
		yourself! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForRepeatXMultipleXXQualifier1: nodes
	^ OrderedCollection with: (nodes at: 1)! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForRepeatXMultipleXXQualifier2: nodes
	^ (nodes at: 1)
		add: (nodes at: 2);
		yourself! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForRepeatXMultipleXXUniqueAttributesList1: nodes
	^ OrderedCollection with: (nodes at: 1)! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForRepeatXMultipleXXUniqueAttributesList2: nodes
	^ (nodes at: 1)
		add: (nodes at: 2);
		yourself! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForRepeatXMultipleXXWhereRule1: nodes
	^ OrderedCollection with: (nodes at: 1)! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForRepeatXMultipleXXWhereRule2: nodes
	^ (nodes at: 1)
		add: (nodes at: 2);
		yourself! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForRepeatXMultipleXXXnativeAlgorithmX1: nodes
	^ OrderedCollection with: (nodes at: 1)! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForRepeatXMultipleXXXnativeAlgorithmX2: nodes
	^ (nodes at: 1)
		add: (nodes at: 2);
		yourself! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForRepeatXXActionBodyDecl1: nodes
	^ OrderedCollection new! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForRepeatXXActionBodyDecl2: nodes
	^ (nodes at: 1)
		add: (nodes at: 2);
		yourself! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForRepeatXXBlock1: nodes
	^ OrderedCollection new! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForRepeatXXBlock2: nodes
	^ (nodes at: 1)
		add: (nodes at: 2);
		yourself! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForRepeatXXCaseAction1: nodes
	^ OrderedCollection new! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForRepeatXXCaseAction2: nodes
	^ (nodes at: 1)
		add: (nodes at: 2);
		yourself! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForRepeatXXConstantBody1: nodes
	^ OrderedCollection new! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForRepeatXXConstantBody2: nodes
	^ (nodes at: 1)
		add: (nodes at: 2);
		yourself! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForRepeatXXExplicitAttribute1: nodes
	^ OrderedCollection new! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForRepeatXXExplicitAttribute2: nodes
	^ (nodes at: 1)
		add: (nodes at: 2);
		yourself! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForRepeatXXInterfaceSpecification1: nodes
	^ OrderedCollection new! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForRepeatXXInterfaceSpecification2: nodes
	^ (nodes at: 1)
		add: (nodes at: 2);
		yourself! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForRepeatXXLocalBody1: nodes
	^ OrderedCollection new! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForRepeatXXLocalBody2: nodes
	^ (nodes at: 1)
		add: (nodes at: 2);
		yourself! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForRepeatXXMapIdentifiersPathAndSemicolon1: nodes
	^ OrderedCollection new! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForRepeatXXMapIdentifiersPathAndSemicolon2: nodes
	^ (nodes at: 1)
		add: (nodes at: 2);
		yourself! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForRepeatXXRemarkReference1: nodes
	^ OrderedCollection new! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForRepeatXXRemarkReference2: nodes
	^ (nodes at: 1)
		add: (nodes at: 2);
		yourself! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForRepeatXXSchemaEntry1: nodes
	^ OrderedCollection new! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForRepeatXXSchemaEntry2: nodes
	^ (nodes at: 1)
		add: (nodes at: 2);
		yourself! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForRepeatXXStatement1: nodes
	^ OrderedCollection new! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForRepeatXXStatement2: nodes
	^ (nodes at: 1)
		add: (nodes at: 2);
		yourself! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForReturnStatement1: nodes
	^ self returnStatement: nil! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForReturnStatement2: nodes
	^ self returnStatement: (nodes at: 3) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForRule1: nodes
	^ self
		rule: (nodes at: 2) value
		entities: (nodes at: 5) value
		actionBody: (nodes at: 8) value
		whereClause: (nodes at: 9) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForRuleEntry1: nodes
	^ self ruleEntry: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForRuleIdentifier1: nodes
	^ self ruleIdentifier: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSchema1: nodes
	^ self schema: (nodes at: 2) value interfaces: (nodes at: 4) blocks: (nodes at: 5)! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSchemaContents1: nodes
	^ (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSchemaContentsEntry1: nodes
	^ self schemaContentsEntry: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSchemaEntry1: nodes
	^ self schemaEntry: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSchemaIdentifier1: nodes
	^ self schemaIdentifier: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSchemaInstance1: nodes
	^ self schemaInstance: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSchemaInstanceEntry1: nodes
	^ self schemaInstanceEntry: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSelectType1: nodes
	^ self selectType: (nodes at: 3) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSetType1: nodes
	^ self setType: (nodes at: 2) value baseType: (nodes at: 4) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSignedSimpleFactor1: nodes
	^ self positiveExpression: (nodes at: 2) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSignedSimpleFactor2: nodes
	^ self negativeExpression: (nodes at: 2) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSimpleAttributeNameDecl1: nodes
	^ self simpleAttributeName: (nodes at: 1) value groupRef: nil! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSimpleAttributeNameDecl2: nodes
	^ self simpleAttributeName: (nodes at: 5) value groupRef: (nodes at: 3) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSimpleExpression1: nodes
	^ (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSimpleExpression2: nodes
	^ self expression: (nodes at: 1) value or: (nodes at: 3) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSimpleExpression3: nodes
	^ self expression: (nodes at: 1) value xor: (nodes at: 3) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSimpleExpression4: nodes
	^ self expression: (nodes at: 1) value plus: (nodes at: 3) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSimpleExpression5: nodes
	^ self expression: (nodes at: 1) value minus: (nodes at: 3) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSimpleFactor10: nodes
	^ self not: (nodes at: 2) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSimpleFactor11: nodes
	^ self expression: (nodes at: 1) value cardinality: (nodes at: 2) value expression: (nodes at: 3) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSimpleFactor12: nodes
	^ (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSimpleFactor1: nodes
	^ (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSimpleFactor2: nodes
	^ (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSimpleFactor3: nodes
	^ self qualifiedExpression: (nodes at: 1) value qualifiers: (nodes at: 2)! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSimpleFactor4: nodes
	^ (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSimpleFactor5: nodes
	^ (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSimpleFactor6: nodes
	^ self expressionBetweenParenthesis: (nodes at: 2) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSimpleFactor7: nodes
	^ self escapedExpression: (nodes at: 2) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSimpleFactor8: nodes
	^ (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSimpleFactor9: nodes
	^ (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSimpleIdentifier1: nodes
	^ (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSimpleType1: nodes
	^ self stringType: (nodes at: 2) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSimpleType2: nodes
	^ self binaryType: (nodes at: 2) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSimpleType3: nodes
	^ self numberType! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSimpleType4: nodes
	^ self realType: (nodes at: 2) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSimpleType5: nodes
	^ self integerType: (nodes at: 2) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSimpleType6: nodes
	^ self logicalType! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSimpleType7: nodes
	^ self booleanType! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSkipStatement1: nodes
	^ self skipStatement! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSplitmarkStatement1: nodes
	^ self beginSplitmarkStatement: (nodes at: 4) value append: (nodes at: 2) notNil! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForStatement10: nodes
	^ self statement: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForStatement11: nodes
	^ self statement: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForStatement12: nodes
	^ self statement: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForStatement13: nodes
	^ self statement: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForStatement14: nodes
	^ self statement: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForStatement15: nodes
	^ self statement: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForStatement1: nodes
	^ self statement: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForStatement2: nodes
	^ self statement: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForStatement3: nodes
	^ self statement: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForStatement4: nodes
	^ self statement: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForStatement5: nodes
	^ self statement: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForStatement6: nodes
	^ self statement: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForStatement7: nodes
	^ self statement: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForStatement8: nodes
	^ self statement: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForStatement9: nodes
	^ self statement: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForStatementsEntry1: nodes
	^ self statementsEntry: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSubtypeDeclaration1: nodes
	^ self subtypeDeclaration: (nodes at: 4) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSubtypeIdentifier1: nodes
	^ self subtypeIdentifier: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSubtypeIdentifiersList1: nodes
	^ OrderedCollection with: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSubtypeIdentifiersList2: nodes
	^ (OrderedCollection new)
		addAll: (nodes at: 1) value;
		add: (nodes at: 3) value;
		yourself! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSupertypeConstraint1: nodes
	^ self abstractSupertypeConstraint: (nodes at: 3) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSupertypeConstraint2: nodes
	^ self supertypeConstraint: (nodes at: 2) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSupertypeExpression1: nodes
	^ self supertypeEntityReference: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSupertypeExpression2: nodes
	^ self supertypeExpression: (nodes at: 1) value andor: (nodes at: 3) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSupertypeExpression3: nodes
	^ self supertypeExpression: (nodes at: 1) value and: (nodes at: 3) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSupertypeExpression4: nodes
	^ self supertypeOneofExpression: (nodes at: 3) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSupertypeExpression5: nodes
	^ (nodes at: 2) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSupertypeExpressionsList1: nodes
	^ OrderedCollection with: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSupertypeExpressionsList2: nodes
	^ (OrderedCollection new)
		addAll: (nodes at: 1) value;
		add: (nodes at: 3) value;
		yourself! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForSupertypeRuleTail1: nodes
	^ (nodes at: 3) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForTerm1: nodes
	^ (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForTerm2: nodes
	^ self expression: (nodes at: 1) value and: (nodes at: 3) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForTerm3: nodes
	^ self expression: (nodes at: 1) value mod: (nodes at: 3) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForTerm4: nodes
	^ self expression: (nodes at: 1) value div: (nodes at: 3) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForTerm5: nodes
	^ self expression: (nodes at: 1) value realDiv: (nodes at: 3) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForTerm6: nodes
	^ self expression: (nodes at: 1) value mult: (nodes at: 3) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForTerm7: nodes
	^ self expression: (nodes at: 1) value instConst: (nodes at: 3) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForType1: nodes
	^ self type: (nodes at: 2) value underlyingType: (nodes at: 4) value whereClause: (nodes at: 6) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForType2: nodes
	^ self typeMapFrom: (nodes at: 2) to: (nodes at: 4)! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForType3: nodes
	^ self typeMapTo: (nodes at: 3) from: (nodes at: 5) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForType4: nodes
	^ self typeMapWhereClause: (nodes at: 5) to: (nodes at: 3)! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForTypeEntry1: nodes
	^ self typeEntry: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForTypeIdentifier1: nodes
	^ self typeIdentifier: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForUnderlyingType1: nodes
	^ (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForUniqueAttributesList1: nodes
	^ self uniqueAttributesList: (nodes at: 2) value head: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForUniqueAttributesList2: nodes
	^ self uniqueAttributesList: (nodes at: 1) value head: nil! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForUniqueClause1: nodes
	^ self uniqueClause: (nodes at: 3) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForUniqueListHead1: nodes
	^ (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForUniqueNamesList1: nodes
	^ OrderedCollection with: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForUniqueNamesList2: nodes
	^ (OrderedCollection new)
		addAll: (nodes at: 1) value;
		add: (nodes at: 3) value;
		yourself! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForUntilControl1: nodes
	^ (nodes at: 2) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForUseOrReference1: nodes
	^ #USED! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForUseOrReference2: nodes
	^ #REFERENCED! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForVar1: nodes
	^ true! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForVar2: nodes
	^ false! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForWhereClause1: nodes
	^ self whereClause: (nodes at: 3) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForWhereRule1: nodes
	^ self whereRule: (nodes at: 2) value head: (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForWhereRule2: nodes
	^ self whereRule: (nodes at: 1) value head: nil! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForWhereRuleHead1: nodes
	^ (nodes at: 1) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceActionForWhileControl1: nodes
	^ (nodes at: 2) value! !

!PlatypusExpressAbstractParser methodsFor: 'generated-tables' stamp: 'AlainPlantec 1/13/2012 15:39'!
reduceTable
	^#(
#(132 1 #reduceActionForSchemaEntry1:)
#(133 1 #reduceActionForSchemaContentsEntry1:)
#(134 1 #reduceActionForConstantsEntry1:)
#(135 1 #reduceActionForTypeEntry1:)
#(136 1 #reduceActionForEntityEntry1:)
#(137 1 #reduceActionForFunctionEntry1:)
#(138 1 #reduceActionForProcedureEntry1:)
#(139 1 #reduceActionForRuleEntry1:)
#(140 1 #reduceActionForStatementsEntry1:)
#(141 1 #reduceActionForExpressionEntry1:)
#(142 2 #reduceActionForSchemaInstance1:)
#(143 1 #reduceFor:)
#(144 1 #reduceActionForRemarkReference1:)
#(145 0 #reduceActionForRepeatXXRemarkReference1:)
#(145 2 #reduceActionForRepeatXXRemarkReference2:)
#(146 0 #reduceActionForRepeatXXSchemaEntry1:)
#(146 2 #reduceActionForRepeatXXSchemaEntry2:)
#(147 1 #reduceActionForSimpleIdentifier1:)
#(148 1 #reduceActionForExpression1:)
#(148 3 #reduceActionForExpression2:)
#(148 3 #reduceActionForExpression3:)
#(148 3 #reduceActionForExpression4:)
#(148 3 #reduceActionForExpression5:)
#(148 3 #reduceActionForExpression6:)
#(148 3 #reduceActionForExpression7:)
#(148 3 #reduceActionForExpression8:)
#(148 3 #reduceActionForExpression9:)
#(148 3 #reduceActionForExpression10:)
#(148 3 #reduceActionForExpression11:)
#(149 1 #reduceActionForConceptIdentifier1:)
#(149 4 #reduceActionForConceptIdentifier2:)
#(150 1 #reduceActionForSchemaIdentifier1:)
#(151 2 #reduceFor:)
#(152 1 #reduceActionForStatement1:)
#(152 1 #reduceActionForStatement2:)
#(152 1 #reduceActionForStatement3:)
#(152 1 #reduceActionForStatement4:)
#(152 1 #reduceActionForStatement5:)
#(152 1 #reduceActionForStatement6:)
#(152 1 #reduceActionForStatement7:)
#(152 1 #reduceActionForStatement8:)
#(152 1 #reduceActionForStatement9:)
#(152 1 #reduceActionForStatement10:)
#(152 1 #reduceActionForStatement11:)
#(152 1 #reduceActionForStatement12:)
#(152 1 #reduceActionForStatement13:)
#(152 1 #reduceActionForStatement14:)
#(152 1 #reduceActionForStatement15:)
#(153 0 #reduceActionForRepeatXXStatement1:)
#(153 2 #reduceActionForRepeatXXStatement2:)
#(154 7 #reduceActionForSchema1:)
#(155 1 #reduceActionForSchemaContents1:)
#(156 5 #reduceActionForInterfaceSpecification1:)
#(156 4 #reduceActionForInterfaceSpecification2:)
#(157 0 #reduceActionForRepeatXXInterfaceSpecification1:)
#(157 2 #reduceActionForRepeatXXInterfaceSpecification2:)
#(158 1 #reduceActionForSchemaInstanceEntry1:)
#(159 0 #reduceActionForRepeatXXBlock1:)
#(159 2 #reduceActionForRepeatXXBlock2:)
#(160 1 #reduceActionForUseOrReference1:)
#(160 1 #reduceActionForUseOrReference2:)
#(161 3 #reduceActionForInterfaceList1:)
#(162 0 #reduceActionForOptionalXXInterfaceList1:)
#(162 1 #reduceActionForOptionalXXInterfaceList2:)
#(163 1 #reduceActionForExplicitlyImportedItemsList1:)
#(163 3 #reduceActionForExplicitlyImportedItemsList2:)
#(164 1 #reduceActionForExplicitlyImportedItem1:)
#(164 3 #reduceActionForExplicitlyImportedItem2:)
#(165 4 #reduceActionForConstantsDecl1:)
#(166 6 #reduceActionForConstantBody1:)
#(167 0 #reduceActionForRepeatXXConstantBody1:)
#(167 2 #reduceActionForRepeatXXConstantBody2:)
#(168 1 #reduceActionForBaseType1:)
#(169 11 #reduceActionForRule1:)
#(170 1 #reduceActionForRuleIdentifier1:)
#(171 2 #reduceActionForIdentifiersList1:)
#(171 4 #reduceActionForIdentifiersList2:)
#(172 2 #reduceActionForActionBody1:)
#(173 3 #reduceActionForWhereClause1:)
#(174 9 #reduceActionForFunction1:)
#(175 1 #reduceActionForFunctionIdentifier1:)
#(176 3 #reduceActionForFormalParametersDecl1:)
#(177 0 #reduceActionForOptionalXXFormalParametersDecl1:)
#(177 1 #reduceActionForOptionalXXFormalParametersDecl2:)
#(178 1 #reduceActionForParameterType1:)
#(179 7 #reduceActionForProcedure1:)
#(180 1 #reduceActionForProcedureIdentifier1:)
#(181 1 #reduceActionForActionBodyDecl1:)
#(181 1 #reduceActionForActionBodyDecl2:)
#(182 0 #reduceActionForRepeatXXActionBodyDecl1:)
#(182 2 #reduceActionForRepeatXXActionBodyDecl2:)
#(183 4 #reduceActionForLocalDecl1:)
#(184 6 #reduceActionForAliasStatement1:)
#(185 4 #reduceActionForAssignmentStatement1:)
#(186 7 #reduceActionForCaseStatement1:)
#(187 4 #reduceActionForCompoundStatement1:)
#(188 2 #reduceActionForEscapeStatement1:)
#(189 6 #reduceActionForIfStatement1:)
#(189 8 #reduceActionForIfStatement2:)
#(190 8 #reduceActionForRepeatStatement1:)
#(191 2 #reduceActionForReturnStatement1:)
#(191 5 #reduceActionForReturnStatement2:)
#(192 2 #reduceActionForSkipStatement1:)
#(193 4 #reduceActionForOutputStatement1:)
#(194 5 #reduceActionForSplitmarkStatement1:)
#(195 4 #reduceActionForEndSplitmarkStatement1:)
#(196 1 #reduceActionForNativeStatement1:)
#(197 2 #reduceActionForProcedureCallStatement1:)
#(198 1 #reduceActionForNullStatement1:)
#(199 2 #reduceActionForAssignableList1:)
#(199 1 #reduceActionForAssignableList2:)
#(200 1 #reduceActionForAssignable1:)
#(201 1 #reduceActionForIdentifier1:)
#(201 1 #reduceActionForIdentifier2:)
#(201 1 #reduceActionForIdentifier3:)
#(201 1 #reduceActionForIdentifier4:)
#(202 2 #reduceActionForQualifier1:)
#(202 1 #reduceActionForQualifier2:)
#(202 3 #reduceActionForQualifier3:)
#(202 5 #reduceActionForQualifier4:)
#(203 1 #reduceActionForNativeAlgorithm1:)
#(204 1 #reduceActionForNativeExpression1:)
#(205 1 #reduceActionForRepeatXMultipleXXXnativeAlgorithmX1:)
#(205 2 #reduceActionForRepeatXMultipleXXXnativeAlgorithmX2:)
#(206 3 #reduceActionForAliasStatementVariable1:)
#(207 1 #reduceActionForExpressionsList1:)
#(207 3 #reduceActionForExpressionsList2:)
#(208 3 #reduceActionForCaseAction1:)
#(209 3 #reduceActionForCaseOtherwise1:)
#(210 0 #reduceActionForRepeatXXCaseAction1:)
#(210 2 #reduceActionForRepeatXXCaseAction2:)
#(211 0 #reduceActionForOptionalXXCaseOtherwise1:)
#(211 1 #reduceActionForOptionalXXCaseOtherwise2:)
#(212 1 #reduceActionForCompoundStatementBegin1:)
#(213 2 #reduceActionForByExpression1:)
#(214 0 #reduceActionForOptionalXXByExpression1:)
#(214 1 #reduceActionForOptionalXXByExpression2:)
#(215 6 #reduceActionForIncrementControl1:)
#(216 2 #reduceActionForWhileControl1:)
#(217 2 #reduceActionForUntilControl1:)
#(218 0 #reduceActionForOptionalXXIncrementControl1:)
#(218 1 #reduceActionForOptionalXXIncrementControl2:)
#(219 0 #reduceActionForOptionalXXWhileControl1:)
#(219 1 #reduceActionForOptionalXXWhileControl2:)
#(221 0 #reduceActionForOptionalXXXXX1:)
#(221 1 #reduceActionForOptionalXXXXX2:)
#(222 4 #reduceActionForLocalBody1:)
#(222 6 #reduceActionForLocalBody2:)
#(223 0 #reduceActionForRepeatXXLocalBody1:)
#(223 2 #reduceActionForRepeatXXLocalBody2:)
#(224 1 #reduceActionForFormalParametersList1:)
#(224 3 #reduceActionForFormalParametersList2:)
#(225 4 #reduceActionForFormalParameter1:)
#(226 1 #reduceActionForVar1:)
#(226 0 #reduceActionForVar2:)
#(227 11 #reduceActionForEntity1:)
#(228 1 #reduceActionForEntityIdentifier1:)
#(229 1 #reduceActionForEntitySubSuper1:)
#(229 1 #reduceActionForEntitySubSuper2:)
#(229 2 #reduceActionForEntitySubSuper3:)
#(230 0 #reduceActionForOptionalXXEntitySubSuper1:)
#(230 1 #reduceActionForOptionalXXEntitySubSuper2:)
#(231 5 #reduceActionForExplicitAttribute1:)
#(232 0 #reduceActionForRepeatXXExplicitAttribute1:)
#(232 2 #reduceActionForRepeatXXExplicitAttribute2:)
#(233 3 #reduceActionForDeriveClause1:)
#(234 0 #reduceActionForOptionalXXDeriveClause1:)
#(234 1 #reduceActionForOptionalXXDeriveClause2:)
#(235 3 #reduceActionForInverseClause1:)
#(236 0 #reduceActionForOptionalXXInverseClause1:)
#(236 1 #reduceActionForOptionalXXInverseClause2:)
#(237 3 #reduceActionForUniqueClause1:)
#(238 0 #reduceActionForOptionalXXUniqueClause1:)
#(238 1 #reduceActionForOptionalXXUniqueClause2:)
#(239 0 #reduceActionForOptionalXXWhereClause1:)
#(239 1 #reduceActionForOptionalXXWhereClause2:)
#(240 3 #reduceActionForSupertypeConstraint1:)
#(240 2 #reduceActionForSupertypeConstraint2:)
#(241 5 #reduceActionForSubtypeDeclaration1:)
#(242 1 #reduceActionForSubtypeIdentifiersList1:)
#(242 3 #reduceActionForSubtypeIdentifiersList2:)
#(243 1 #reduceActionForSubtypeIdentifier1:)
#(244 4 #reduceActionForSupertypeRuleTail1:)
#(245 0 #reduceActionForOptionalXXSupertypeRuleTail1:)
#(245 1 #reduceActionForOptionalXXSupertypeRuleTail2:)
#(246 1 #reduceActionForSupertypeExpression1:)
#(246 3 #reduceActionForSupertypeExpression2:)
#(246 3 #reduceActionForSupertypeExpression3:)
#(246 4 #reduceActionForSupertypeExpression4:)
#(246 3 #reduceActionForSupertypeExpression5:)
#(247 1 #reduceActionForSupertypeExpressionsList1:)
#(247 3 #reduceActionForSupertypeExpressionsList2:)
#(248 1 #reduceActionForAttributeNameDecl1:)
#(248 5 #reduceActionForAttributeNameDecl2:)
#(249 1 #reduceActionForSimpleAttributeNameDecl1:)
#(249 5 #reduceActionForSimpleAttributeNameDecl2:)
#(250 1 #reduceActionForAttributesNameDeclList1:)
#(250 3 #reduceActionForAttributesNameDeclList2:)
#(251 1 #reduceActionForOptional1:)
#(251 0 #reduceActionForOptional2:)
#(252 6 #reduceActionForDerivedAttribute1:)
#(253 1 #reduceActionForRepeatXMultipleXXDerivedAttribute1:)
#(253 2 #reduceActionForRepeatXMultipleXXDerivedAttribute2:)
#(254 6 #reduceActionForInverseAttribute1:)
#(255 1 #reduceActionForRepeatXMultipleXXInverseAttribute1:)
#(255 2 #reduceActionForRepeatXMultipleXXInverseAttribute2:)
#(256 1 #reduceActionForInverseAttributeDomain1:)
#(257 3 #reduceActionForUniqueAttributesList1:)
#(257 2 #reduceActionForUniqueAttributesList2:)
#(258 1 #reduceActionForRepeatXMultipleXXUniqueAttributesList1:)
#(258 2 #reduceActionForRepeatXMultipleXXUniqueAttributesList2:)
#(259 2 #reduceActionForUniqueListHead1:)
#(260 1 #reduceActionForUniqueNamesList1:)
#(260 3 #reduceActionForUniqueNamesList2:)
#(261 8 #reduceActionForType1:)
#(261 7 #reduceActionForType2:)
#(261 7 #reduceActionForType3:)
#(261 7 #reduceActionForType4:)
#(262 1 #reduceActionForTypeIdentifier1:)
#(263 1 #reduceActionForUnderlyingType1:)
#(264 1 #reduceActionForMapIdentifiersPath1:)
#(264 3 #reduceActionForMapIdentifiersPath2:)
#(265 2 #reduceActionForMapIdentifiersPathAndSemicolon1:)
#(266 0 #reduceActionForRepeatXXMapIdentifiersPathAndSemicolon1:)
#(266 2 #reduceActionForRepeatXXMapIdentifiersPathAndSemicolon2:)
#(267 3 #reduceActionForWhereRule1:)
#(267 2 #reduceActionForWhereRule2:)
#(268 1 #reduceActionForRepeatXMultipleXXWhereRule1:)
#(268 2 #reduceActionForRepeatXMultipleXXWhereRule2:)
#(269 2 #reduceActionForWhereRuleHead1:)
#(270 1 #reduceActionForDomainType1:)
#(270 1 #reduceActionForDomainType2:)
#(270 1 #reduceActionForDomainType3:)
#(270 1 #reduceActionForDomainType4:)
#(270 1 #reduceActionForDomainType5:)
#(271 4 #reduceActionForSelectType1:)
#(272 5 #reduceActionForEnumerationType1:)
#(273 1 #reduceActionForConstructedType1:)
#(273 1 #reduceActionForConstructedType2:)
#(274 1 #reduceActionForAggregationType1:)
#(274 1 #reduceActionForAggregationType2:)
#(274 1 #reduceActionForAggregationType3:)
#(274 1 #reduceActionForAggregationType4:)
#(274 1 #reduceActionForAggregationType5:)
#(275 2 #reduceActionForSimpleType1:)
#(275 2 #reduceActionForSimpleType2:)
#(275 1 #reduceActionForSimpleType3:)
#(275 2 #reduceActionForSimpleType4:)
#(275 2 #reduceActionForSimpleType5:)
#(275 1 #reduceActionForSimpleType6:)
#(275 1 #reduceActionForSimpleType7:)
#(276 1 #reduceActionForNamedType1:)
#(277 1 #reduceActionForGenericType1:)
#(277 3 #reduceActionForGenericType2:)
#(278 5 #reduceActionForArrayType1:)
#(279 5 #reduceActionForListType1:)
#(280 4 #reduceActionForBagType1:)
#(281 4 #reduceActionForSetType1:)
#(282 3 #reduceActionForAggregateType1:)
#(282 5 #reduceActionForAggregateType2:)
#(283 2 #reduceActionForOptionalOrUnique1:)
#(283 2 #reduceActionForOptionalOrUnique2:)
#(283 1 #reduceActionForOptionalOrUnique3:)
#(283 1 #reduceActionForOptionalOrUnique4:)
#(284 5 #reduceActionForIndexSpec1:)
#(285 0 #reduceActionForOptionalXXIndexSpec1:)
#(285 1 #reduceActionForOptionalXXIndexSpec2:)
#(286 0 #reduceActionForOptionalXXXuniqueX1:)
#(286 1 #reduceActionForOptionalXXXuniqueX2:)
#(287 0 #reduceActionForOptionalXXOptionalOrUnique1:)
#(287 1 #reduceActionForOptionalXXOptionalOrUnique2:)
#(288 2 #reduceActionForFixedOrNotPrecisionSpec1:)
#(289 0 #reduceActionForOptionalXXFixedOrNotPrecisionSpec1:)
#(289 1 #reduceActionForOptionalXXFixedOrNotPrecisionSpec2:)
#(290 3 #reduceActionForPrecisionSpec1:)
#(291 0 #reduceActionForOptionalXXPrecisionSpec1:)
#(291 1 #reduceActionForOptionalXXPrecisionSpec2:)
#(292 1 #reduceActionForFixedOrNot1:)
#(292 0 #reduceActionForFixedOrNot2:)
#(293 1 #reduceActionForSimpleExpression1:)
#(293 3 #reduceActionForSimpleExpression2:)
#(293 3 #reduceActionForSimpleExpression3:)
#(293 3 #reduceActionForSimpleExpression4:)
#(293 3 #reduceActionForSimpleExpression5:)
#(294 1 #reduceActionForTerm1:)
#(294 3 #reduceActionForTerm2:)
#(294 3 #reduceActionForTerm3:)
#(294 3 #reduceActionForTerm4:)
#(294 3 #reduceActionForTerm5:)
#(294 3 #reduceActionForTerm6:)
#(294 3 #reduceActionForTerm7:)
#(295 1 #reduceActionForFactor1:)
#(295 3 #reduceActionForFactor2:)
#(296 1 #reduceActionForSimpleFactor1:)
#(296 1 #reduceActionForSimpleFactor2:)
#(296 2 #reduceActionForSimpleFactor3:)
#(296 1 #reduceActionForSimpleFactor4:)
#(296 1 #reduceActionForSimpleFactor5:)
#(296 3 #reduceActionForSimpleFactor6:)
#(296 3 #reduceActionForSimpleFactor7:)
#(296 1 #reduceActionForSimpleFactor8:)
#(296 1 #reduceActionForSimpleFactor9:)
#(296 2 #reduceActionForSimpleFactor10:)
#(296 3 #reduceActionForSimpleFactor11:)
#(296 1 #reduceActionForSimpleFactor12:)
#(297 2 #reduceActionForSignedSimpleFactor1:)
#(297 2 #reduceActionForSignedSimpleFactor2:)
#(298 3 #reduceActionForAggregateInitializer1:)
#(298 2 #reduceActionForAggregateInitializer2:)
#(299 1 #reduceActionForRepeatXMultipleXXQualifier1:)
#(299 2 #reduceActionForRepeatXMultipleXXQualifier2:)
#(300 1 #reduceActionForLiteral1:)
#(300 1 #reduceActionForLiteral2:)
#(300 1 #reduceActionForLiteral3:)
#(300 1 #reduceActionForLiteral4:)
#(300 1 #reduceActionForLiteral5:)
#(300 1 #reduceActionForLiteral6:)
#(300 1 #reduceActionForLiteral7:)
#(300 1 #reduceActionForLiteral8:)
#(300 1 #reduceActionForLiteral9:)
#(300 1 #reduceActionForLiteral10:)
#(301 7 #reduceActionForInterval1:)
#(302 8 #reduceActionForQueryExpression1:)
#(303 5 #reduceActionForCardinalityOp1:)
#(304 1 #reduceActionForQueryVariable1:)
#(305 1 #reduceActionForIntervalOp1:)
#(305 1 #reduceActionForIntervalOp2:)
#(306 4 #reduceActionForArgumentedIdentifier1:)
#(307 0 #reduceActionForOptionalXXExpressionsList1:)
#(307 1 #reduceActionForOptionalXXExpressionsList2:)
#(308 2 #reduceActionForGroupRef1:)
#(309 1 #reduceActionForAggregateInitBody1:)
#(309 3 #reduceActionForAggregateInitBody2:)
#(310 1 #reduceActionForAggregateInitElement1:)
#(310 3 #reduceActionForAggregateInitElement2:)
#(311 2 #reduceFor:)
#(315 0 #reduceActionForOptionalXXUntilControl1:)
#(315 1 #reduceActionForOptionalXXUntilControl2:)
#(316 1 #reduceActionForBlock1:)
#(316 1 #reduceActionForBlock2:)
#(316 1 #reduceActionForBlock3:)
#(316 1 #reduceActionForBlock4:)
#(316 1 #reduceActionForBlock5:)
#(316 1 #reduceActionForBlock6:)
)! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 3/11/2003 11:17'!
remarkReference: aRemarkToken
	| r | r := OrderedCollection new. r add: #remarkRef; add: aRemarkToken lexicalElement. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:22'!
repeatStatement: incrementControlOrNil whileControl: whileExpressionOrNil untilControl: untilExpressionOrNil statements: statementsListOrNil 
	| r | r := OrderedCollection new. r add: #repeatStatement; add: incrementControlOrNil; add: whileExpressionOrNil; add: untilExpressionOrNil; add: statementsListOrNil. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:22'!
returnStatement: expressionOrNil 
	| r | r := OrderedCollection new. r add: #returnStatement; add: expressionOrNil. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:22'!
rule: ident entities: fromEntitiesList actionBody: actionBody whereClause: whereClause 
	| r | r := OrderedCollection new. r add: #rule; add: ident; add: fromEntitiesList; add: actionBody; add: whereClause. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 10:06'!
ruleEntry: aRule 
	^ self buildParserResultWith: aRule! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 3/5/2003 16:51'!
ruleIdentifier: anIdentifier 
	^ anIdentifier! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:24'!
schema: schemaIdent interfaces: interfacesCollectionOrNil blocks: blocksCollectionOrNil 
	| r | r := OrderedCollection new. r add: #schema; add: schemaIdent; add: interfacesCollectionOrNil; add: blocksCollectionOrNil. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/15/2006 09:48'!
schemaContentsEntry: schemaContents 
	^ self buildParserResultWith: schemaContents! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 5/17/2004 11:32'!
schemaEntry: aSchema 
	^ self buildParserResultWith: aSchema! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 3/5/2003 10:19'!
schemaIdentifier: anIdentifier
	^ anIdentifier! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 3/11/2003 23:15'!
schemaInstance: aCollectionOfSchemata 
	| r | r := OrderedCollection new. r add: #schemaInstance; add: aCollectionOfSchemata. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 3/11/2003 23:09'!
schemaInstanceEntry: aSchemaInstance
	^ self buildParserResultWith: aSchemaInstance! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:24'!
selectType: identifiersList 
	| r | r := OrderedCollection new. r add: #selectType; add: identifiersList. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:24'!
selfIdentifier
	| r | r := OrderedCollection new. r add: #self. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:24'!
setType: indexSpecOrNil baseType: baseType 
	| r | r := OrderedCollection new. r add: #setType; add: indexSpecOrNil; add: baseType. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 3/29/2006 17:08'!
simpleAttributeName: simpleIdent groupRef: aGroupIdentOrNil 
	^ self attributeName: simpleIdent groupRef: aGroupIdentOrNil ! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:24'!
skipStatement
	| r | r := OrderedCollection new. r add: #skipStatement. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 10:07'!
sourceEntry: schemataOrNil
	^ self buildParserResultWith: schemataOrNil! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 12/13/2003 14:33'!
statement: aStatement 
	^ aStatement! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 12/13/2003 14:26'!
statementsEntry: statements 
	^ statements! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:25'!
stringLiteral: aString
	| r | r := OrderedCollection new. r add: #stringLiteral; add: aString. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:25'!
stringType: FixedOrNotPrecisionSpecOrNil
	| r | r := OrderedCollection new. r add: #stringType; add: FixedOrNotPrecisionSpecOrNil. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:25'!
subtypeDeclaration: anIdentifiersList
	| r | r := OrderedCollection new. r add: #subtypeDeclaration; add: anIdentifiersList. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 9/9/2003 13:21'!
subtypeIdentifier: anIdentifier 
	^ anIdentifier! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:25'!
supertypeConstraint: supertypeExpressionOrNil
	| r | r := OrderedCollection new. r add: #supertypeConstraint; add: supertypeExpressionOrNil. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:25'!
supertypeEntityReference: anIdentifier 
	| r | r := OrderedCollection new. r add: #supertypeEntityReference; add: anIdentifier. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:26'!
supertypeExpression: supertypeExpression1 and: supertypeExpression2
	| r | r := OrderedCollection new. r add: #andSupertypeExpression; add: supertypeExpression1; add: supertypeExpression2. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:26'!
supertypeExpression: supertypeExpression1 andor: supertypeExpression2 
	| r | r := OrderedCollection new. r add: #andorSupertypeExpression; add: supertypeExpression1; add: supertypeExpression2. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:26'!
supertypeOneofExpression: identifiersList 
	| r | r := OrderedCollection new. r add: #oneofSupertypeExpression; add: identifiersList. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'generated-tables' stamp: 'AlainPlantec 1/13/2012 15:39'!
transitionTable
	^#(
#[1 0 58 0 53 0 53 0 142 0 57 0 145 0 61 0 158 0 58 0 220 0 58 1 56]
#[1 0 58 0 53 0 53 0 142 0 57 0 145 0 65 0 158 0 58 0 220 0 58 1 56]
#[1 0 69 0 53 0 73 0 132 0 77 0 154]
#[1 0 234 0 2 0 234 0 5 0 234 0 12 0 234 0 14 0 234 0 84 0 234 0 100 0 234 0 116 0 81 0 133 0 85 0 155 0 89 0 159 0 234 1 56]
#[1 0 93 0 14 0 97 0 134 0 101 0 165]
#[1 0 105 0 84 0 109 0 100 0 113 0 135 0 117 1 5]
#[1 0 121 0 116 0 125 0 136 0 129 0 227]
#[1 0 133 0 5 0 137 0 137 0 141 0 174]
#[1 0 145 0 12 0 149 0 138 0 153 0 179]
#[1 0 157 0 2 0 161 0 139 0 165 0 169]
#[1 0 198 0 16 0 198 0 17 0 198 0 18 0 198 0 25 0 198 0 28 0 198 0 31 0 198 0 49 0 198 0 93 0 198 0 96 0 198 0 98 0 198 0 106 0 198 0 107 0 198 0 115 0 198 0 123 0 198 0 130 0 169 0 140 0 173 0 153 0 198 1 56]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 9 0 141 1 13 0 147 1 17 0 148 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 1 37 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[0 0 230 1 56]
#[1 0 66 0 53 1 77 0 144 1 81 0 146 1 85 0 220 0 66 1 56]
#[0 0 0 1 56]
#[0 0 0 1 56]
#[1 1 5 0 130 1 89 0 147 1 93 0 149 1 97 0 150]
#[0 0 0 1 56]
#[0 0 6 0 53 1 56]
#[0 0 0 1 56]
#[0 0 10 1 56]
#[1 0 157 0 2 0 133 0 5 0 145 0 12 0 93 0 14 0 210 0 51 0 105 0 84 0 109 0 100 0 121 0 116 1 101 0 134 1 105 0 135 1 109 0 136 1 113 0 137 1 117 0 138 1 121 0 139 0 101 0 165 0 165 0 169 0 141 0 174 0 153 0 179 0 129 0 227 0 117 1 5 0 210 1 56 1 125 1 60]
#[1 1 30 0 6 1 30 0 130 1 129 0 167]
#[0 0 0 1 56]
#[0 0 14 0 2 0 5 0 8 0 12 0 14 0 16 0 17 0 18 0 24 0 25 0 28 0 31 0 49 0 51 0 71 0 84 0 93 0 96 0 97 0 98 0 100 0 106 0 107 0 115 0 116 0 123 0 130 1 56]
#[1 1 133 0 101 1 5 0 130 1 137 0 147 1 141 1 8]
#[1 1 5 0 130 1 89 0 147 1 145 0 149 1 149 1 6]
#[0 0 0 1 56]
#[0 0 18 0 2 0 5 0 8 0 12 0 14 0 16 0 17 0 18 0 24 0 25 0 28 0 31 0 49 0 51 0 71 0 84 0 93 0 96 0 97 0 98 0 100 0 106 0 107 0 115 0 116 0 123 0 130 1 56]
#[1 1 5 0 130 1 89 0 147 1 153 0 149 1 157 0 228]
#[0 0 0 1 56]
#[0 0 22 0 2 0 5 0 8 0 12 0 14 0 16 0 17 0 18 0 24 0 25 0 28 0 31 0 49 0 51 0 71 0 84 0 93 0 96 0 97 0 98 0 100 0 106 0 107 0 115 0 116 0 123 0 130 1 56]
#[1 1 5 0 130 1 89 0 147 1 161 0 149 1 165 0 175]
#[0 0 0 1 56]
#[0 0 26 0 2 0 5 0 8 0 12 0 14 0 16 0 17 0 18 0 24 0 25 0 28 0 31 0 49 0 51 0 71 0 84 0 93 0 96 0 97 0 98 0 100 0 106 0 107 0 115 0 116 0 123 0 130 1 56]
#[1 1 5 0 130 1 89 0 147 1 169 0 149 1 173 0 180]
#[0 0 0 1 56]
#[0 0 30 0 2 0 5 0 8 0 12 0 14 0 16 0 17 0 18 0 24 0 25 0 28 0 31 0 49 0 51 0 71 0 84 0 93 0 96 0 97 0 98 0 100 0 106 0 107 0 115 0 116 0 123 0 130 1 56]
#[1 1 5 0 130 1 89 0 147 1 177 0 149 1 181 0 170]
#[0 0 0 1 56]
#[0 0 34 0 2 0 5 0 8 0 12 0 14 0 16 0 17 0 18 0 24 0 25 0 28 0 31 0 49 0 51 0 71 0 84 0 93 0 96 0 97 0 98 0 100 0 106 0 107 0 115 0 116 0 123 0 130 1 56]
#[0 0 0 1 56]
#[1 1 185 0 16 1 189 0 17 1 193 0 18 1 197 0 25 1 201 0 28 0 181 0 31 1 205 0 49 1 209 0 93 1 213 0 96 1 217 0 98 1 221 0 106 1 225 0 107 0 233 0 115 0 237 0 123 1 5 0 130 1 13 0 147 1 229 0 151 1 233 0 152 1 237 0 184 1 241 0 185 1 245 0 186 1 249 0 187 1 253 0 188 2 1 0 189 2 5 0 190 2 9 0 191 2 13 0 192 2 17 0 193 2 21 0 194 2 25 0 195 2 29 0 196 2 33 0 197 2 37 0 198 2 41 0 199 2 45 0 200 2 49 0 201 2 53 0 203 1 33 0 205 2 57 0 212 1 73 1 50 0 38 1 56]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 2 61 0 148 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 1 37 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[0 1 202 0 1 0 4 0 11 0 15 0 22 0 29 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 52 0 55 0 56 0 57 0 60 0 61 0 67 0 75 0 88 0 90 0 95 0 96 0 101 0 102 0 103 0 108 0 113 1 56]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 2 65 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 2 69 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 2 73 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 2 77 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 2 81 0 67 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 2 85 0 148 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 1 37 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50 2 89 1 53 2 93 1 54]
#[0 4 242 0 4 0 11 0 15 0 22 0 29 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 52 0 55 0 56 0 57 0 60 0 61 0 67 0 75 0 88 0 90 0 95 0 96 0 101 0 102 0 103 0 108 0 113 1 56]
#[0 4 246 0 4 0 11 0 15 0 22 0 29 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 52 0 55 0 56 0 57 0 60 0 61 0 67 0 75 0 88 0 90 0 95 0 96 0 101 0 102 0 103 0 108 0 113 1 56]
#[0 4 250 0 4 0 11 0 15 0 22 0 29 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 52 0 55 0 56 0 57 0 60 0 61 0 67 0 75 0 88 0 90 0 95 0 96 0 101 0 102 0 103 0 108 0 113 1 56]
#[0 5 6 0 4 0 11 0 15 0 22 0 29 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 52 0 55 0 56 0 57 0 60 0 61 0 67 0 75 0 88 0 90 0 95 0 96 0 101 0 102 0 103 0 108 0 113 1 56]
#[0 2 97 0 10]
#[0 5 2 0 4 0 11 0 15 0 22 0 29 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 52 0 55 0 56 0 57 0 60 0 61 0 67 0 75 0 88 0 90 0 95 0 96 0 101 0 102 0 103 0 108 0 113 1 56]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 2 101 0 148 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 1 37 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[0 1 198 0 1 0 4 0 11 0 15 0 22 0 29 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 52 0 55 0 56 0 57 0 60 0 61 0 67 0 75 0 88 0 90 0 95 0 96 0 101 0 102 0 103 0 108 0 113 1 56]
#[0 1 238 0 4 0 8 0 10 0 11 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 24 0 25 0 26 0 28 0 29 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 50 0 52 0 55 0 56 0 57 0 58 0 60 0 61 0 67 0 71 0 75 0 77 0 78 0 79 0 81 0 82 0 83 0 88 0 90 0 93 0 95 0 96 0 98 0 101 0 102 0 103 0 105 0 106 0 107 0 108 0 113 0 115 0 123 0 125 0 126 0 127 0 128 0 129 0 130 1 56]
#[0 4 226 0 4 0 11 0 15 0 22 0 29 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 52 0 55 0 56 0 57 0 60 0 61 0 67 0 75 0 88 0 90 0 95 0 96 0 101 0 102 0 103 0 108 0 113 1 56]
#[0 4 230 0 4 0 11 0 15 0 22 0 29 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 52 0 55 0 56 0 57 0 60 0 61 0 67 0 75 0 88 0 90 0 95 0 96 0 101 0 102 0 103 0 108 0 113 1 56]
#[0 4 254 0 4 0 11 0 15 0 22 0 29 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 52 0 55 0 56 0 57 0 60 0 61 0 67 0 75 0 88 0 90 0 95 0 96 0 101 0 102 0 103 0 108 0 113 1 56]
#[0 4 234 0 4 0 11 0 15 0 22 0 29 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 52 0 55 0 56 0 57 0 60 0 61 0 67 0 75 0 88 0 90 0 95 0 96 0 101 0 102 0 103 0 108 0 113 1 56]
#[0 4 238 0 4 0 11 0 15 0 22 0 29 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 52 0 55 0 56 0 57 0 60 0 61 0 67 0 75 0 88 0 90 0 95 0 96 0 101 0 102 0 103 0 108 0 113 1 56]
#[0 0 74 0 1 0 3 0 4 0 10 0 11 0 13 0 15 0 22 0 29 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 52 0 55 0 56 0 57 0 59 0 60 0 61 0 67 0 75 0 80 0 88 0 90 0 95 0 96 0 101 0 102 0 103 0 108 0 113 0 119 0 120 0 121 0 220 1 56]
#[0 0 0 1 56]
#[1 1 206 0 1 1 206 0 4 2 105 0 10 1 206 0 11 1 206 0 15 1 206 0 22 1 206 0 29 1 206 0 32 1 206 0 33 1 206 0 34 1 206 0 35 1 206 0 36 1 206 0 37 1 206 0 38 1 206 0 39 1 206 0 40 1 206 0 41 1 206 0 42 1 206 0 43 1 206 0 44 1 206 0 45 1 206 0 46 1 206 0 47 1 206 0 48 1 206 0 49 1 206 0 52 1 206 0 55 1 206 0 56 1 206 0 57 1 206 0 60 1 206 0 61 1 206 0 67 1 206 0 75 1 206 0 88 1 206 0 90 1 206 0 95 1 206 0 96 1 206 0 101 1 206 0 102 1 206 0 103 1 206 0 108 1 206 0 113 1 206 1 56]
#[0 0 42 1 56]
#[0 4 170 0 4 0 11 0 15 0 22 0 29 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 52 0 55 0 56 0 57 0 60 0 61 0 67 0 75 0 88 0 90 0 95 0 96 0 101 0 102 0 103 0 108 0 113 1 56]
#[0 1 234 0 4 0 11 0 15 0 22 0 29 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 52 0 55 0 56 0 57 0 60 0 61 0 67 0 75 0 88 0 90 0 95 0 96 0 101 0 102 0 103 0 108 0 113 1 56]
#[0 4 198 0 4 0 11 0 15 0 22 0 29 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 52 0 55 0 56 0 57 0 60 0 61 0 67 0 75 0 88 0 90 0 95 0 96 0 101 0 102 0 103 0 108 0 113 1 56]
#[1 1 230 0 4 1 230 0 8 1 230 0 10 1 230 0 11 1 230 0 15 1 230 0 16 1 230 0 17 1 230 0 18 1 230 0 19 1 230 0 20 1 230 0 21 1 230 0 22 1 230 0 24 1 230 0 25 1 230 0 26 1 230 0 28 1 230 0 29 1 230 0 30 1 230 0 31 1 230 0 32 1 230 0 33 1 230 0 34 1 230 0 35 1 230 0 36 1 230 0 37 1 230 0 38 1 230 0 39 1 230 0 40 1 230 0 41 1 230 0 42 1 230 0 43 1 230 0 44 1 230 0 45 1 230 0 46 1 230 0 47 1 230 0 48 1 230 0 49 1 230 0 50 1 230 0 52 1 230 0 55 1 230 0 56 1 230 0 57 1 230 0 58 1 230 0 60 1 230 0 61 1 230 0 67 1 230 0 71 1 230 0 75 1 230 0 77 1 230 0 78 1 230 0 79 1 230 0 81 1 230 0 82 1 230 0 83 1 230 0 88 1 230 0 90 1 230 0 93 1 230 0 95 1 230 0 96 1 230 0 98 1 230 0 101 1 230 0 102 1 230 0 103 1 230 0 105 1 230 0 106 1 230 0 107 1 230 0 108 1 230 0 113 1 230 0 115 2 109 0 123 1 230 0 125 1 230 0 126 1 230 0 127 1 230 0 128 1 230 0 129 1 230 0 130 1 230 1 56]
#[1 0 78 0 4 0 78 0 11 0 78 0 15 0 78 0 22 0 78 0 29 2 113 0 32 2 117 0 33 2 121 0 34 2 125 0 35 2 129 0 36 2 133 0 37 2 137 0 38 2 141 0 39 2 145 0 40 2 149 0 41 2 153 0 42 2 157 0 44 2 161 0 45 2 165 0 46 0 78 0 48 0 78 0 49 0 78 0 67 0 78 0 88 0 78 0 90 0 78 0 95 0 78 0 96 0 78 0 101 0 78 0 102 0 78 0 103 0 78 1 56]
#[1 4 98 0 4 4 98 0 11 4 98 0 15 4 98 0 22 4 98 0 29 4 98 0 32 4 98 0 33 4 98 0 34 4 98 0 35 4 98 0 36 4 98 0 37 4 98 0 38 4 98 0 39 4 98 0 40 4 98 0 41 4 98 0 42 2 169 0 43 4 98 0 44 4 98 0 45 4 98 0 46 4 98 0 48 4 98 0 49 2 173 0 55 2 177 0 56 2 181 0 57 2 185 0 60 2 189 0 61 4 98 0 67 4 98 0 88 4 98 0 90 4 98 0 95 4 98 0 96 4 98 0 101 4 98 0 102 4 98 0 103 4 98 1 56]
#[1 4 118 0 4 4 118 0 11 4 118 0 15 4 118 0 22 4 118 0 29 4 118 0 32 4 118 0 33 4 118 0 34 4 118 0 35 4 118 0 36 4 118 0 37 4 118 0 38 4 118 0 39 4 118 0 40 4 118 0 41 4 118 0 42 4 118 0 43 4 118 0 44 4 118 0 45 4 118 0 46 4 118 0 48 4 118 0 49 2 193 0 52 4 118 0 55 4 118 0 56 4 118 0 57 4 118 0 60 4 118 0 61 4 118 0 67 4 118 0 88 4 118 0 90 4 118 0 95 4 118 0 96 4 118 0 101 4 118 0 102 4 118 0 103 4 118 1 56]
#[1 4 146 0 4 4 146 0 11 4 146 0 15 4 146 0 22 4 146 0 29 4 146 0 32 4 146 0 33 4 146 0 34 4 146 0 35 4 146 0 36 4 146 0 37 4 146 0 38 4 146 0 39 4 146 0 40 4 146 0 41 4 146 0 42 4 146 0 43 4 146 0 44 4 146 0 45 4 146 0 46 2 197 0 47 4 146 0 48 4 146 0 49 4 146 0 52 4 146 0 55 4 146 0 56 4 146 0 57 4 146 0 60 4 146 0 61 4 146 0 67 2 201 0 75 4 146 0 88 4 146 0 90 4 146 0 95 4 146 0 96 4 146 0 101 4 146 0 102 4 146 0 103 2 205 0 108 2 209 0 113 2 213 0 202 2 217 1 43 2 221 1 47 2 225 1 52 4 146 1 56]
#[0 4 154 0 4 0 11 0 15 0 22 0 29 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 52 0 55 0 56 0 57 0 60 0 61 0 67 0 75 0 88 0 90 0 95 0 96 0 101 0 102 0 103 0 108 0 113 1 56]
#[0 4 158 0 4 0 11 0 15 0 22 0 29 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 52 0 55 0 56 0 57 0 60 0 61 0 67 0 75 0 88 0 90 0 95 0 96 0 101 0 102 0 103 0 108 0 113 1 56]
#[0 4 166 0 4 0 11 0 15 0 22 0 29 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 52 0 55 0 56 0 57 0 60 0 61 0 67 0 75 0 88 0 90 0 95 0 96 0 101 0 102 0 103 0 108 0 113 1 56]
#[0 4 182 0 4 0 11 0 15 0 22 0 29 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 52 0 55 0 56 0 57 0 60 0 61 0 67 0 75 0 88 0 90 0 95 0 96 0 101 0 102 0 103 0 108 0 113 1 56]
#[0 4 186 0 4 0 11 0 15 0 22 0 29 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 52 0 55 0 56 0 57 0 60 0 61 0 67 0 75 0 88 0 90 0 95 0 96 0 101 0 102 0 103 0 108 0 113 1 56]
#[0 1 210 0 1 0 4 0 11 0 15 0 22 0 29 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 52 0 55 0 56 0 57 0 60 0 61 0 67 0 75 0 88 0 90 0 95 0 96 0 101 0 102 0 103 0 108 0 113 1 56]
#[0 0 62 0 2 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 14 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 34 0 38 0 47 0 49 0 50 0 51 0 53 0 58 0 70 0 71 0 75 0 77 0 78 0 79 0 81 0 82 0 83 0 84 0 90 0 92 0 93 0 96 0 97 0 98 0 100 0 104 0 105 0 106 0 107 0 110 0 111 0 112 0 114 0 115 0 116 0 118 0 123 0 125 0 126 0 127 0 128 0 129 0 130 0 220 1 56]
#[1 0 69 0 53 2 229 0 132 0 77 0 154 0 46 1 56]
#[0 0 54 0 2 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 14 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 34 0 38 0 47 0 49 0 50 0 51 0 53 0 58 0 70 0 71 0 75 0 77 0 78 0 79 0 81 0 82 0 83 0 84 0 90 0 92 0 93 0 96 0 97 0 98 0 100 0 104 0 105 0 106 0 107 0 110 0 111 0 112 0 114 0 115 0 116 0 118 0 123 0 125 0 126 0 127 0 128 0 129 0 130 0 220 1 56]
#[1 0 122 0 1 0 122 0 3 0 122 0 4 0 122 0 10 0 122 0 11 0 122 0 15 0 122 0 40 2 233 0 47 0 122 0 49 0 122 0 119 0 122 0 120 0 122 0 121]
#[0 0 130 0 49]
#[1 1 205 0 49 2 237 0 151]
#[0 5 78 0 2 0 5 0 8 0 12 0 14 0 16 0 17 0 18 0 24 0 25 0 28 0 31 0 49 0 51 0 71 0 84 0 93 0 96 0 97 0 98 0 100 0 106 0 107 0 115 0 116 0 123 0 130 1 56]
#[0 5 82 0 2 0 5 0 8 0 12 0 14 0 16 0 17 0 18 0 24 0 25 0 28 0 31 0 49 0 51 0 71 0 84 0 93 0 96 0 97 0 98 0 100 0 106 0 107 0 115 0 116 0 123 0 130 1 56]
#[0 5 86 0 2 0 5 0 8 0 12 0 14 0 16 0 17 0 18 0 24 0 25 0 28 0 31 0 49 0 51 0 71 0 84 0 93 0 96 0 97 0 98 0 100 0 106 0 107 0 115 0 116 0 123 0 130 1 56]
#[0 5 90 0 2 0 5 0 8 0 12 0 14 0 16 0 17 0 18 0 24 0 25 0 28 0 31 0 49 0 51 0 71 0 84 0 93 0 96 0 97 0 98 0 100 0 106 0 107 0 115 0 116 0 123 0 130 1 56]
#[0 5 94 0 2 0 5 0 8 0 12 0 14 0 16 0 17 0 18 0 24 0 25 0 28 0 31 0 49 0 51 0 71 0 84 0 93 0 96 0 97 0 98 0 100 0 106 0 107 0 115 0 116 0 123 0 130 1 56]
#[0 5 98 0 2 0 5 0 8 0 12 0 14 0 16 0 17 0 18 0 24 0 25 0 28 0 31 0 49 0 51 0 71 0 84 0 93 0 96 0 97 0 98 0 100 0 106 0 107 0 115 0 116 0 123 0 130 1 56]
#[0 0 238 0 2 0 5 0 12 0 14 0 51 0 84 0 100 0 116 1 56]
#[1 2 241 0 6 1 5 0 130 1 89 0 147 2 245 0 149 2 249 0 166]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 2 253 0 148 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 1 37 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[0 3 118 0 49 0 101 0 108]
#[1 3 1 0 101 3 5 0 108]
#[0 3 110 0 40]
#[0 3 9 0 40]
#[0 2 118 0 49 0 119 0 120 0 121]
#[1 2 134 0 49 3 13 0 119 3 17 0 120 3 21 0 121 3 25 0 229 3 29 0 230 3 33 0 240 3 37 0 241]
#[0 1 70 0 4 0 10]
#[1 1 78 0 4 3 41 0 10 3 45 0 176 3 49 0 177]
#[0 1 94 0 10 0 49]
#[1 3 41 0 10 1 78 0 49 3 45 0 176 3 53 0 177]
#[0 1 46 0 3]
#[0 3 57 0 3]
#[0 2 26 0 16 0 17 0 18 0 19 0 25 0 28 0 31 0 49 0 93 0 96 0 98 0 106 0 107 0 115 0 123 0 130]
#[1 1 205 0 49 3 61 0 151]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 3 65 0 148 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 1 37 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[1 1 5 0 130 3 69 0 147 3 73 0 206]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 3 77 0 148 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 1 37 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[1 0 58 0 2 0 58 0 5 0 58 0 6 0 58 0 7 0 58 0 8 0 58 0 9 0 58 0 10 0 58 0 12 0 58 0 14 0 58 0 16 0 58 0 17 0 58 0 18 0 58 0 19 0 58 0 20 0 58 0 21 0 58 0 23 0 58 0 24 0 58 0 25 0 58 0 26 0 58 0 27 0 58 0 28 0 58 0 30 0 58 0 31 0 58 0 34 0 58 0 38 0 58 0 47 0 58 0 49 0 58 0 50 0 58 0 51 0 58 0 53 0 58 0 58 0 58 0 70 0 58 0 71 0 58 0 75 0 58 0 77 0 58 0 78 0 58 0 79 0 58 0 81 0 58 0 82 0 58 0 83 0 58 0 84 0 58 0 90 0 58 0 92 0 58 0 93 0 58 0 96 0 58 0 97 0 58 0 98 0 58 0 100 0 58 0 104 0 58 0 105 0 58 0 106 0 58 0 107 0 58 0 110 0 58 0 111 0 58 0 112 0 58 0 114 0 58 0 115 0 58 0 116 0 58 0 118 0 58 0 123 0 58 0 125 0 58 0 126 0 58 0 127 0 58 0 128 0 58 0 129 0 58 0 130 3 81 0 145 0 58 0 220 0 58 1 56]
#[1 3 85 0 57 2 70 0 94 2 70 0 99 3 89 0 221]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 3 93 0 148 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 1 37 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[1 1 205 0 49 3 97 0 151]
#[1 3 101 0 10 1 205 0 49 3 105 0 151]
#[1 2 54 0 49 2 54 0 102 2 54 0 103 1 5 0 130 3 109 0 147 3 113 0 215 3 117 0 218]
#[0 1 182 0 8 0 10 0 16 0 17 0 18 0 19 0 20 0 21 0 24 0 25 0 26 0 28 0 30 0 31 0 34 0 38 0 47 0 49 0 50 0 58 0 71 0 75 0 77 0 78 0 79 0 81 0 82 0 83 0 90 0 93 0 96 0 98 0 105 0 106 0 107 0 115 0 123 0 125 0 126 0 127 0 128 0 129 0 130 1 56]
#[0 0 202 0 8 0 16 0 17 0 18 0 19 0 20 0 24 0 25 0 26 0 28 0 31 0 49 0 58 0 71 0 93 0 96 0 98 0 105 0 106 0 107 0 115 0 123 0 130 1 56]
#[0 0 138 0 8 0 10 0 16 0 17 0 18 0 19 0 20 0 21 0 24 0 25 0 26 0 28 0 30 0 31 0 34 0 38 0 47 0 49 0 50 0 58 0 71 0 75 0 77 0 78 0 79 0 81 0 82 0 83 0 90 0 93 0 96 0 98 0 105 0 106 0 107 0 115 0 123 0 125 0 126 0 127 0 128 0 129 0 130 1 56]
#[0 0 142 0 8 0 10 0 16 0 17 0 18 0 19 0 20 0 21 0 24 0 25 0 26 0 28 0 30 0 31 0 34 0 38 0 47 0 49 0 50 0 58 0 71 0 75 0 77 0 78 0 79 0 81 0 82 0 83 0 90 0 93 0 96 0 98 0 105 0 106 0 107 0 115 0 123 0 125 0 126 0 127 0 128 0 129 0 130 1 56]
#[0 0 146 0 8 0 10 0 16 0 17 0 18 0 19 0 20 0 21 0 24 0 25 0 26 0 28 0 30 0 31 0 34 0 38 0 47 0 49 0 50 0 58 0 71 0 75 0 77 0 78 0 79 0 81 0 82 0 83 0 90 0 93 0 96 0 98 0 105 0 106 0 107 0 115 0 123 0 125 0 126 0 127 0 128 0 129 0 130 1 56]
#[0 0 150 0 8 0 10 0 16 0 17 0 18 0 19 0 20 0 21 0 24 0 25 0 26 0 28 0 30 0 31 0 34 0 38 0 47 0 49 0 50 0 58 0 71 0 75 0 77 0 78 0 79 0 81 0 82 0 83 0 90 0 93 0 96 0 98 0 105 0 106 0 107 0 115 0 123 0 125 0 126 0 127 0 128 0 129 0 130 1 56]
#[0 0 154 0 8 0 10 0 16 0 17 0 18 0 19 0 20 0 21 0 24 0 25 0 26 0 28 0 30 0 31 0 34 0 38 0 47 0 49 0 50 0 58 0 71 0 75 0 77 0 78 0 79 0 81 0 82 0 83 0 90 0 93 0 96 0 98 0 105 0 106 0 107 0 115 0 123 0 125 0 126 0 127 0 128 0 129 0 130 1 56]
#[0 0 158 0 8 0 10 0 16 0 17 0 18 0 19 0 20 0 21 0 24 0 25 0 26 0 28 0 30 0 31 0 34 0 38 0 47 0 49 0 50 0 58 0 71 0 75 0 77 0 78 0 79 0 81 0 82 0 83 0 90 0 93 0 96 0 98 0 105 0 106 0 107 0 115 0 123 0 125 0 126 0 127 0 128 0 129 0 130 1 56]
#[0 0 162 0 8 0 10 0 16 0 17 0 18 0 19 0 20 0 21 0 24 0 25 0 26 0 28 0 30 0 31 0 34 0 38 0 47 0 49 0 50 0 58 0 71 0 75 0 77 0 78 0 79 0 81 0 82 0 83 0 90 0 93 0 96 0 98 0 105 0 106 0 107 0 115 0 123 0 125 0 126 0 127 0 128 0 129 0 130 1 56]
#[0 0 166 0 8 0 10 0 16 0 17 0 18 0 19 0 20 0 21 0 24 0 25 0 26 0 28 0 30 0 31 0 34 0 38 0 47 0 49 0 50 0 58 0 71 0 75 0 77 0 78 0 79 0 81 0 82 0 83 0 90 0 93 0 96 0 98 0 105 0 106 0 107 0 115 0 123 0 125 0 126 0 127 0 128 0 129 0 130 1 56]
#[0 0 170 0 8 0 10 0 16 0 17 0 18 0 19 0 20 0 21 0 24 0 25 0 26 0 28 0 30 0 31 0 34 0 38 0 47 0 49 0 50 0 58 0 71 0 75 0 77 0 78 0 79 0 81 0 82 0 83 0 90 0 93 0 96 0 98 0 105 0 106 0 107 0 115 0 123 0 125 0 126 0 127 0 128 0 129 0 130 1 56]
#[0 0 174 0 8 0 10 0 16 0 17 0 18 0 19 0 20 0 21 0 24 0 25 0 26 0 28 0 30 0 31 0 34 0 38 0 47 0 49 0 50 0 58 0 71 0 75 0 77 0 78 0 79 0 81 0 82 0 83 0 90 0 93 0 96 0 98 0 105 0 106 0 107 0 115 0 123 0 125 0 126 0 127 0 128 0 129 0 130 1 56]
#[0 0 178 0 8 0 10 0 16 0 17 0 18 0 19 0 20 0 21 0 24 0 25 0 26 0 28 0 30 0 31 0 34 0 38 0 47 0 49 0 50 0 58 0 71 0 75 0 77 0 78 0 79 0 81 0 82 0 83 0 90 0 93 0 96 0 98 0 105 0 106 0 107 0 115 0 123 0 125 0 126 0 127 0 128 0 129 0 130 1 56]
#[0 0 182 0 8 0 10 0 16 0 17 0 18 0 19 0 20 0 21 0 24 0 25 0 26 0 28 0 30 0 31 0 34 0 38 0 47 0 49 0 50 0 58 0 71 0 75 0 77 0 78 0 79 0 81 0 82 0 83 0 90 0 93 0 96 0 98 0 105 0 106 0 107 0 115 0 123 0 125 0 126 0 127 0 128 0 129 0 130 1 56]
#[0 0 186 0 8 0 10 0 16 0 17 0 18 0 19 0 20 0 21 0 24 0 25 0 26 0 28 0 30 0 31 0 34 0 38 0 47 0 49 0 50 0 58 0 71 0 75 0 77 0 78 0 79 0 81 0 82 0 83 0 90 0 93 0 96 0 98 0 105 0 106 0 107 0 115 0 123 0 125 0 126 0 127 0 128 0 129 0 130 1 56]
#[0 0 190 0 8 0 10 0 16 0 17 0 18 0 19 0 20 0 21 0 24 0 25 0 26 0 28 0 30 0 31 0 34 0 38 0 47 0 49 0 50 0 58 0 71 0 75 0 77 0 78 0 79 0 81 0 82 0 83 0 90 0 93 0 96 0 98 0 105 0 106 0 107 0 115 0 123 0 125 0 126 0 127 0 128 0 129 0 130 1 56]
#[0 0 194 0 8 0 10 0 16 0 17 0 18 0 19 0 20 0 21 0 24 0 25 0 26 0 28 0 30 0 31 0 34 0 38 0 47 0 49 0 50 0 58 0 71 0 75 0 77 0 78 0 79 0 81 0 82 0 83 0 90 0 93 0 96 0 98 0 105 0 106 0 107 0 115 0 123 0 125 0 126 0 127 0 128 0 129 0 130 1 56]
#[1 1 194 0 1 1 194 0 49 2 201 0 75 2 205 0 108 2 209 0 113 3 121 0 202 2 225 1 52]
#[0 3 125 0 1]
#[1 1 190 0 1 1 205 0 49 1 190 0 75 1 190 0 108 1 190 0 113 3 129 0 151]
#[0 1 174 0 8 0 10 0 16 0 17 0 18 0 19 0 20 0 21 0 24 0 25 0 26 0 28 0 30 0 31 0 34 0 38 0 47 0 49 0 50 0 58 0 71 0 75 0 77 0 78 0 79 0 81 0 82 0 83 0 90 0 93 0 96 0 98 0 105 0 106 0 107 0 115 0 123 0 125 0 126 0 127 0 128 0 129 0 130 1 56]
#[1 0 198 0 16 0 198 0 17 0 198 0 18 0 198 0 19 0 198 0 25 0 198 0 28 0 198 0 31 0 198 0 49 0 198 0 93 0 198 0 96 0 198 0 98 0 198 0 106 0 198 0 107 0 198 0 115 0 198 0 123 0 198 0 130 3 133 0 153]
#[0 3 137 0 11]
#[1 4 206 0 4 4 206 0 11 4 206 0 15 4 206 0 22 4 206 0 29 4 206 0 32 4 206 0 33 4 206 0 34 4 206 0 35 4 206 0 36 4 206 0 37 4 206 0 38 4 206 0 39 4 206 0 40 4 206 0 41 4 206 0 42 4 206 0 43 4 206 0 44 4 206 0 45 4 206 0 46 2 197 0 47 4 206 0 48 4 206 0 49 4 206 0 52 4 206 0 55 4 206 0 56 4 206 0 57 4 206 0 60 4 206 0 61 4 206 0 67 2 201 0 75 4 206 0 88 4 206 0 90 4 206 0 95 4 206 0 96 4 206 0 101 4 206 0 102 4 206 0 103 2 205 0 108 2 209 0 113 2 213 0 202 2 217 1 43 2 221 1 47 2 225 1 52 4 206 1 56]
#[1 4 202 0 4 4 202 0 11 4 202 0 15 4 202 0 22 4 202 0 29 4 202 0 32 4 202 0 33 4 202 0 34 4 202 0 35 4 202 0 36 4 202 0 37 4 202 0 38 4 202 0 39 4 202 0 40 4 202 0 41 4 202 0 42 4 202 0 43 4 202 0 44 4 202 0 45 4 202 0 46 2 197 0 47 4 202 0 48 4 202 0 49 4 202 0 52 4 202 0 55 4 202 0 56 4 202 0 57 4 202 0 60 4 202 0 61 4 202 0 67 2 201 0 75 4 202 0 88 4 202 0 90 4 202 0 95 4 202 0 96 4 202 0 101 4 202 0 102 4 202 0 103 2 205 0 108 2 209 0 113 2 213 0 202 2 217 1 43 2 221 1 47 2 225 1 52 4 202 1 56]
#[1 2 121 0 34 3 141 0 35 2 129 0 36 3 145 0 37 2 137 0 38 2 141 0 39 3 149 1 49]
#[1 4 190 0 4 4 190 0 11 4 190 0 15 4 190 0 22 4 190 0 29 4 190 0 32 4 190 0 33 4 190 0 34 4 190 0 35 4 190 0 36 4 190 0 37 4 190 0 38 4 190 0 39 4 190 0 40 4 190 0 41 4 190 0 42 4 190 0 43 4 190 0 44 4 190 0 45 4 190 0 46 2 197 0 47 4 190 0 48 4 190 0 49 4 190 0 52 4 190 0 55 4 190 0 56 4 190 0 57 4 190 0 60 4 190 0 61 4 190 0 67 2 201 0 75 4 190 0 88 4 190 0 90 4 190 0 95 4 190 0 96 4 190 0 101 4 190 0 102 4 190 0 103 2 205 0 108 2 209 0 113 2 213 0 202 2 217 1 43 2 221 1 47 2 225 1 52 4 190 1 56]
#[0 4 214 0 4 0 11 0 15 0 22 0 29 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 52 0 55 0 56 0 57 0 60 0 61 0 67 0 75 0 88 0 90 0 95 0 96 0 101 0 102 0 103 0 108 0 113 1 56]
#[1 3 153 0 4 5 58 0 15 5 58 0 67]
#[1 3 157 0 15 3 161 0 67]
#[0 5 50 0 15 0 67]
#[1 1 5 0 130 3 165 0 147 3 169 1 48]
#[0 3 173 0 90]
#[1 0 177 0 10 5 38 0 11 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 3 177 0 148 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 3 181 0 207 1 37 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50 3 185 1 51]
#[0 1 242 0 4 0 8 0 10 0 11 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 24 0 25 0 26 0 28 0 29 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 50 0 52 0 55 0 56 0 57 0 58 0 60 0 61 0 67 0 71 0 75 0 77 0 78 0 79 0 81 0 82 0 83 0 88 0 90 0 93 0 95 0 96 0 98 0 101 0 102 0 103 0 105 0 106 0 107 0 108 0 113 0 115 0 123 0 125 0 126 0 127 0 128 0 129 0 130 1 56]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 3 189 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 3 193 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 3 197 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 3 201 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 3 205 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 3 209 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 3 213 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 3 217 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 3 221 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 3 225 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 3 229 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 3 233 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 3 237 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 3 241 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 3 245 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 3 249 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 3 253 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 4 1 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 4 5 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 4 9 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 4 13 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 4 17 0 148 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 1 37 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 4 21 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[1 1 5 0 130 4 25 0 147]
#[1 1 5 0 130 4 29 0 147]
#[0 4 218 0 4 0 11 0 15 0 22 0 29 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 52 0 55 0 56 0 57 0 60 0 61 0 67 0 75 0 88 0 90 0 95 0 96 0 101 0 102 0 103 0 108 0 113 1 56]
#[1 4 162 0 4 4 162 0 11 4 162 0 15 4 162 0 22 4 162 0 29 4 162 0 32 4 162 0 33 4 162 0 34 4 162 0 35 4 162 0 36 4 162 0 37 4 162 0 38 4 162 0 39 4 162 0 40 4 162 0 41 4 162 0 42 4 162 0 43 4 162 0 44 4 162 0 45 4 162 0 46 4 162 0 47 4 162 0 48 4 162 0 49 4 162 0 52 4 162 0 55 4 162 0 56 4 162 0 57 4 162 0 60 4 162 0 61 4 162 0 67 2 201 0 75 4 162 0 88 4 162 0 90 4 162 0 95 4 162 0 96 4 162 0 101 4 162 0 102 4 162 0 103 2 205 0 108 2 209 0 113 4 33 0 202 2 225 1 52 4 162 1 56]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 4 37 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[0 1 218 0 1 0 4 0 11 0 15 0 22 0 29 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 52 0 55 0 56 0 57 0 60 0 61 0 67 0 75 0 88 0 90 0 95 0 96 0 101 0 102 0 103 0 108 0 113 1 56]
#[0 0 70 0 53 1 56]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 4 41 0 148 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 1 37 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[1 0 222 0 2 0 222 0 5 0 222 0 9 0 222 0 12 0 222 0 14 0 222 0 23 0 222 0 27 0 222 0 51 0 222 0 84 0 222 0 100 0 222 0 116 4 45 0 157]
#[1 1 205 0 49 4 49 0 151]
#[0 4 53 0 4]
#[0 1 34 0 6 0 130]
#[1 1 205 0 49 4 57 0 151]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 4 61 0 148 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 1 37 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[1 1 5 0 130 4 65 0 147]
#[1 4 69 0 62 4 73 0 63 4 77 0 64 4 81 0 65 4 85 0 66 4 89 0 68 4 93 0 69 4 97 0 72 4 101 0 73 4 105 0 74 4 109 0 76 4 113 0 85 4 117 0 86 4 121 0 87 4 125 0 91 1 5 0 130 1 89 0 147 4 129 0 149 4 133 1 7 4 137 1 14 4 141 1 15 4 145 1 16 4 149 1 17 4 153 1 18 4 157 1 19 4 161 1 20 4 165 1 21 4 169 1 22 4 173 1 23 4 177 1 24 4 181 1 25 4 185 1 26]
#[0 4 189 0 29]
#[1 4 193 0 29 4 197 0 244]
#[0 4 201 0 120]
#[0 2 138 0 49]
#[1 1 205 0 49 4 205 0 151]
#[1 2 122 0 49 3 13 0 119 4 209 0 241]
#[0 2 126 0 49]
#[1 4 213 0 111 2 110 0 130 4 217 0 224 4 221 0 225 4 225 0 226]
#[0 1 82 0 4 0 49]
#[0 4 229 0 4]
#[1 1 205 0 49 4 233 0 151]
#[0 4 237 0 10]
#[0 1 134 0 8 0 10 0 16 0 17 0 18 0 19 0 20 0 21 0 24 0 25 0 26 0 28 0 30 0 31 0 34 0 38 0 47 0 49 0 50 0 58 0 71 0 75 0 77 0 78 0 79 0 81 0 82 0 83 0 90 0 93 0 96 0 98 0 105 0 106 0 107 0 115 0 123 0 125 0 126 0 127 0 128 0 129 0 130 1 56]
#[0 4 241 0 22]
#[0 4 245 0 3]
#[1 1 205 0 49 4 249 0 151]
#[0 4 253 0 29]
#[1 0 134 0 2 0 134 0 5 0 134 0 6 0 134 0 7 0 134 0 8 0 134 0 9 0 134 0 10 0 134 0 12 0 134 0 14 0 134 0 16 0 134 0 17 0 134 0 18 0 134 0 19 0 134 0 20 0 134 0 21 0 134 0 23 0 134 0 24 0 134 0 25 0 134 0 26 0 134 0 27 0 134 0 28 0 134 0 30 0 134 0 31 0 134 0 34 0 134 0 38 0 134 0 47 0 134 0 49 0 134 0 50 0 134 0 51 0 134 0 53 0 134 0 58 0 134 0 70 0 134 0 71 0 134 0 75 0 134 0 77 0 134 0 78 0 134 0 79 0 134 0 81 0 134 0 82 0 134 0 83 0 134 0 84 0 134 0 90 0 134 0 92 0 134 0 93 0 134 0 96 0 134 0 97 0 134 0 98 0 134 0 100 0 134 0 104 0 134 0 105 0 134 0 106 0 134 0 107 0 134 0 110 0 134 0 111 0 134 0 112 0 134 0 114 0 134 0 115 0 134 0 116 0 134 0 118 0 134 0 123 0 134 0 125 0 134 0 126 0 134 0 127 0 134 0 128 0 134 0 129 0 134 0 130 1 77 0 144 1 85 0 220 0 134 1 56]
#[0 2 74 0 94 0 99]
#[1 5 1 0 94 5 5 0 99]
#[0 5 9 0 96]
#[0 1 158 0 8 0 10 0 16 0 17 0 18 0 19 0 20 0 21 0 24 0 25 0 26 0 28 0 30 0 31 0 34 0 38 0 47 0 49 0 50 0 58 0 71 0 75 0 77 0 78 0 79 0 81 0 82 0 83 0 90 0 93 0 96 0 98 0 105 0 106 0 107 0 115 0 123 0 125 0 126 0 127 0 128 0 129 0 130 1 56]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 5 13 0 148 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 1 37 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[0 1 150 0 8 0 10 0 16 0 17 0 18 0 19 0 20 0 21 0 24 0 25 0 26 0 28 0 30 0 31 0 34 0 38 0 47 0 49 0 50 0 58 0 71 0 75 0 77 0 78 0 79 0 81 0 82 0 83 0 90 0 93 0 96 0 98 0 105 0 106 0 107 0 115 0 123 0 125 0 126 0 127 0 128 0 129 0 130 1 56]
#[0 5 17 0 1]
#[0 2 58 0 49 0 102 0 103]
#[1 2 62 0 49 5 21 0 102 2 62 0 103 5 25 0 216 5 29 0 219]
#[0 1 186 0 1 0 49 0 75 0 108 0 113]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 5 33 0 148 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 1 37 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[0 1 178 0 8 0 10 0 16 0 17 0 18 0 19 0 20 0 21 0 24 0 25 0 26 0 28 0 30 0 31 0 34 0 38 0 47 0 49 0 50 0 58 0 71 0 75 0 77 0 78 0 79 0 81 0 82 0 83 0 90 0 93 0 96 0 98 0 105 0 106 0 107 0 115 0 123 0 125 0 126 0 127 0 128 0 129 0 130 1 56]
#[1 1 185 0 16 1 189 0 17 1 193 0 18 5 37 0 19 1 197 0 25 1 201 0 28 0 181 0 31 1 205 0 49 1 209 0 93 1 213 0 96 1 217 0 98 1 221 0 106 1 225 0 107 0 233 0 115 0 237 0 123 1 5 0 130 1 13 0 147 1 229 0 151 1 233 0 152 1 237 0 184 1 241 0 185 1 245 0 186 1 249 0 187 1 253 0 188 2 1 0 189 2 5 0 190 2 9 0 191 2 13 0 192 2 17 0 193 2 21 0 194 2 25 0 195 2 29 0 196 2 33 0 197 2 37 0 198 2 41 0 199 2 45 0 200 2 49 0 201 2 53 0 203 1 33 0 205 2 57 0 212 1 73 1 50]
#[0 4 174 0 4 0 11 0 15 0 22 0 29 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 52 0 55 0 56 0 57 0 60 0 61 0 67 0 75 0 88 0 90 0 95 0 96 0 101 0 102 0 103 0 108 0 113 1 56]
#[0 5 26 0 10 0 31 0 34 0 38 0 47 0 50 0 75 0 77 0 78 0 79 0 81 0 82 0 83 0 90 0 115 0 123 0 125 0 126 0 127 0 128 0 129 0 130]
#[0 5 30 0 10 0 31 0 34 0 38 0 47 0 50 0 75 0 77 0 78 0 79 0 81 0 82 0 83 0 90 0 115 0 123 0 125 0 126 0 127 0 128 0 129 0 130]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 5 41 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 5 45 0 148 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 1 37 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 2 85 0 148 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 1 37 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50 5 49 1 54]
#[0 4 210 0 4 0 11 0 15 0 22 0 29 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 52 0 55 0 56 0 57 0 60 0 61 0 67 0 75 0 88 0 90 0 95 0 96 0 101 0 102 0 103 0 108 0 113 1 56]
#[0 5 22 0 80]
#[0 5 53 0 80]
#[0 4 178 0 4 0 11 0 15 0 22 0 29 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 52 0 55 0 56 0 57 0 60 0 61 0 67 0 75 0 88 0 90 0 95 0 96 0 101 0 102 0 103 0 108 0 113 1 56]
#[0 1 250 0 4 0 11 0 15]
#[1 5 42 0 11 5 57 0 15]
#[0 5 61 0 11]
#[1 0 118 0 4 0 118 0 11 0 118 0 15 0 118 0 22 0 118 0 29 2 121 0 34 2 129 0 36 2 137 0 38 2 141 0 39 0 118 0 48 0 118 0 49 0 118 0 67 0 118 0 88 0 118 0 90 0 118 0 95 0 118 0 96 0 118 0 101 0 118 0 102 0 118 0 103 0 118 1 56]
#[1 0 102 0 4 0 102 0 11 0 102 0 15 0 102 0 22 0 102 0 29 2 121 0 34 2 129 0 36 2 137 0 38 2 141 0 39 0 102 0 48 0 102 0 49 0 102 0 67 0 102 0 88 0 102 0 90 0 102 0 95 0 102 0 96 0 102 0 101 0 102 0 102 0 102 0 103 0 102 1 56]
#[0 4 114 0 4 0 11 0 15 0 22 0 29 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 44 0 45 0 46 0 48 0 49 0 67 0 88 0 90 0 95 0 96 0 101 0 102 0 103 1 56]
#[1 0 82 0 4 0 82 0 11 0 82 0 15 0 82 0 22 0 82 0 29 2 121 0 34 2 129 0 36 2 137 0 38 2 141 0 39 0 82 0 48 0 82 0 49 0 82 0 67 0 82 0 88 0 82 0 90 0 82 0 95 0 82 0 96 0 82 0 101 0 82 0 102 0 82 0 103 0 82 1 56]
#[0 4 102 0 4 0 11 0 15 0 22 0 29 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 44 0 45 0 46 0 48 0 49 0 67 0 88 0 90 0 95 0 96 0 101 0 102 0 103 1 56]
#[1 0 94 0 4 0 94 0 11 0 94 0 15 0 94 0 22 0 94 0 29 2 121 0 34 2 129 0 36 2 137 0 38 2 141 0 39 0 94 0 48 0 94 0 49 0 94 0 67 0 94 0 88 0 94 0 90 0 94 0 95 0 94 0 96 0 94 0 101 0 94 0 102 0 94 0 103 0 94 1 56]
#[0 4 110 0 4 0 11 0 15 0 22 0 29 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 44 0 45 0 46 0 48 0 49 0 67 0 88 0 90 0 95 0 96 0 101 0 102 0 103 1 56]
#[0 4 106 0 4 0 11 0 15 0 22 0 29 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 44 0 45 0 46 0 48 0 49 0 67 0 88 0 90 0 95 0 96 0 101 0 102 0 103 1 56]
#[1 0 90 0 4 0 90 0 11 0 90 0 15 0 90 0 22 0 90 0 29 2 121 0 34 2 129 0 36 2 137 0 38 2 141 0 39 0 90 0 48 0 90 0 49 0 90 0 67 0 90 0 88 0 90 0 90 0 90 0 95 0 90 0 96 0 90 0 101 0 90 0 102 0 90 0 103 0 90 1 56]
#[1 0 98 0 4 0 98 0 11 0 98 0 15 0 98 0 22 0 98 0 29 2 121 0 34 2 129 0 36 2 137 0 38 2 141 0 39 0 98 0 48 0 98 0 49 0 98 0 67 0 98 0 88 0 98 0 90 0 98 0 95 0 98 0 96 0 98 0 101 0 98 0 102 0 98 0 103 0 98 1 56]
#[1 0 86 0 4 0 86 0 11 0 86 0 15 0 86 0 22 0 86 0 29 2 121 0 34 2 129 0 36 2 137 0 38 2 141 0 39 0 86 0 48 0 86 0 49 0 86 0 67 0 86 0 88 0 86 0 90 0 86 0 95 0 86 0 96 0 86 0 101 0 86 0 102 0 86 0 103 0 86 1 56]
#[1 0 106 0 4 0 106 0 11 0 106 0 15 0 106 0 22 0 106 0 29 2 121 0 34 2 129 0 36 2 137 0 38 2 141 0 39 0 106 0 48 0 106 0 49 0 106 0 67 0 106 0 88 0 106 0 90 0 106 0 95 0 106 0 96 0 106 0 101 0 106 0 102 0 106 0 103 0 106 1 56]
#[1 0 110 0 4 0 110 0 11 0 110 0 15 0 110 0 22 0 110 0 29 2 121 0 34 2 129 0 36 2 137 0 38 2 141 0 39 0 110 0 48 0 110 0 49 0 110 0 67 0 110 0 88 0 110 0 90 0 110 0 95 0 110 0 96 0 110 0 101 0 110 0 102 0 110 0 103 0 110 1 56]
#[1 0 114 0 4 0 114 0 11 0 114 0 15 0 114 0 22 0 114 0 29 2 121 0 34 2 129 0 36 2 137 0 38 2 141 0 39 0 114 0 48 0 114 0 49 0 114 0 67 0 114 0 88 0 114 0 90 0 114 0 95 0 114 0 96 0 114 0 101 0 114 0 102 0 114 0 103 0 114 1 56]
#[0 4 130 0 4 0 11 0 15 0 22 0 29 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 48 0 49 0 55 0 56 0 57 0 60 0 61 0 67 0 88 0 90 0 95 0 96 0 101 0 102 0 103 1 56]
#[0 4 126 0 4 0 11 0 15 0 22 0 29 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 48 0 49 0 55 0 56 0 57 0 60 0 61 0 67 0 88 0 90 0 95 0 96 0 101 0 102 0 103 1 56]
#[0 4 134 0 4 0 11 0 15 0 22 0 29 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 48 0 49 0 55 0 56 0 57 0 60 0 61 0 67 0 88 0 90 0 95 0 96 0 101 0 102 0 103 1 56]
#[0 4 138 0 4 0 11 0 15 0 22 0 29 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 48 0 49 0 55 0 56 0 57 0 60 0 61 0 67 0 88 0 90 0 95 0 96 0 101 0 102 0 103 1 56]
#[0 4 142 0 4 0 11 0 15 0 22 0 29 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 48 0 49 0 55 0 56 0 57 0 60 0 61 0 67 0 88 0 90 0 95 0 96 0 101 0 102 0 103 1 56]
#[0 4 122 0 4 0 11 0 15 0 22 0 29 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 48 0 49 0 55 0 56 0 57 0 60 0 61 0 67 0 88 0 90 0 95 0 96 0 101 0 102 0 103 1 56]
#[1 4 150 0 4 4 150 0 11 4 150 0 15 4 150 0 22 4 150 0 29 4 150 0 32 4 150 0 33 4 150 0 34 4 150 0 35 4 150 0 36 4 150 0 37 4 150 0 38 4 150 0 39 4 150 0 40 4 150 0 41 4 150 0 42 4 150 0 43 4 150 0 44 4 150 0 45 4 150 0 46 4 150 0 48 4 150 0 49 2 193 0 52 4 150 0 55 4 150 0 56 4 150 0 57 4 150 0 60 4 150 0 61 4 150 0 67 4 150 0 88 4 150 0 90 4 150 0 95 4 150 0 96 4 150 0 101 4 150 0 102 4 150 0 103 4 150 1 56]
#[0 5 65 0 4]
#[1 5 69 0 4 2 121 0 34 2 129 0 36 2 137 0 38 2 141 0 39 5 73 0 67]
#[0 1 214 0 1 0 4 0 11 0 15 0 22 0 29 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 52 0 55 0 56 0 57 0 60 0 61 0 67 0 75 0 88 0 90 0 95 0 96 0 101 0 102 0 103 0 108 0 113 1 56]
#[0 5 46 0 1 0 4 0 11 0 15 0 22 0 29 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 52 0 55 0 56 0 57 0 60 0 61 0 67 0 75 0 88 0 90 0 95 0 96 0 101 0 102 0 103 0 108 0 113 1 56]
#[0 4 222 0 4 0 11 0 15 0 22 0 29 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 52 0 55 0 56 0 57 0 60 0 61 0 67 0 75 0 88 0 90 0 95 0 96 0 101 0 102 0 103 0 108 0 113 1 56]
#[1 4 194 0 4 4 194 0 11 4 194 0 15 4 194 0 22 4 194 0 29 4 194 0 32 4 194 0 33 4 194 0 34 4 194 0 35 4 194 0 36 4 194 0 37 4 194 0 38 4 194 0 39 4 194 0 40 4 194 0 41 4 194 0 42 4 194 0 43 4 194 0 44 4 194 0 45 4 194 0 46 2 197 0 47 4 194 0 48 4 194 0 49 4 194 0 52 4 194 0 55 4 194 0 56 4 194 0 57 4 194 0 60 4 194 0 61 4 194 0 67 2 201 0 75 4 194 0 88 4 194 0 90 4 194 0 95 4 194 0 96 4 194 0 101 4 194 0 102 4 194 0 103 2 205 0 108 2 209 0 113 2 213 0 202 2 217 1 43 2 221 1 47 2 225 1 52 4 194 1 56]
#[0 5 77 0 48]
#[1 0 234 0 2 0 234 0 5 5 81 0 9 0 234 0 12 0 234 0 14 5 85 0 23 5 89 0 27 0 234 0 51 0 234 0 84 0 234 0 100 0 234 0 116 5 93 0 155 5 97 0 156 0 89 0 159 5 101 0 160]
#[0 1 22 0 2 0 5 0 8 0 12 0 14 0 16 0 17 0 18 0 24 0 25 0 28 0 31 0 49 0 51 0 71 0 84 0 93 0 96 0 97 0 98 0 100 0 106 0 107 0 115 0 116 0 123 0 130 1 56]
#[1 4 69 0 62 4 73 0 63 4 77 0 64 4 81 0 65 4 85 0 66 4 89 0 68 4 93 0 69 4 97 0 72 4 101 0 73 4 105 0 74 4 109 0 76 4 113 0 85 4 117 0 86 4 121 0 87 4 125 0 91 1 5 0 130 1 89 0 147 4 129 0 149 5 105 0 168 5 109 1 14 4 141 1 15 4 145 1 16 4 149 1 17 4 153 1 18 4 157 1 19 4 161 1 20 4 165 1 21 4 169 1 22 4 173 1 23 4 177 1 24 4 181 1 25 4 185 1 26]
#[1 3 130 0 70 5 113 0 71 3 130 0 130 5 117 0 173 5 121 1 10]
#[1 1 205 0 49 5 125 0 151]
#[0 3 122 0 49 0 101 0 108]
#[1 4 42 0 29 5 129 0 75 5 133 1 28 5 137 1 29]
#[1 4 42 0 29 5 129 0 75 5 133 1 28 5 141 1 29]
#[1 4 42 0 29 5 129 0 75 5 133 1 28 5 145 1 29]
#[1 4 42 0 29 5 129 0 75 5 133 1 28 5 149 1 29]
#[1 4 70 0 1 4 70 0 3 5 153 0 10 4 70 0 11 4 70 0 49 5 157 1 32 5 161 1 33 5 165 1 34]
#[1 5 169 0 4 5 173 0 29]
#[1 4 70 0 1 4 70 0 3 5 153 0 10 4 70 0 11 4 70 0 49 5 157 1 32 5 177 1 33 5 165 1 34]
#[0 5 181 0 29]
#[0 3 222 0 1 0 3 0 11 0 49]
#[1 3 246 0 1 3 246 0 3 5 185 0 4 3 246 0 11 3 246 0 49]
#[0 5 189 0 10]
#[1 4 82 0 1 4 82 0 3 5 153 0 10 4 82 0 11 4 82 0 49 5 193 1 34 5 197 1 35]
#[1 4 82 0 1 4 82 0 3 5 153 0 10 4 82 0 11 4 82 0 49 5 193 1 34 5 201 1 35]
#[0 3 234 0 1 0 3 0 11 0 49]
#[0 3 238 0 1 0 3 0 11 0 49]
#[0 3 242 0 1 0 3 0 11 0 49]
#[1 1 205 0 49 5 205 0 151]
#[0 3 114 0 49]
#[0 3 186 0 1 0 3 0 11 0 49]
#[0 3 190 0 1 0 3 0 11 0 49]
#[0 3 162 0 1 0 3 0 11 0 49]
#[0 3 158 0 1 0 3 0 11 0 49]
#[0 3 166 0 1 0 3 0 11 0 49]
#[0 3 170 0 1 0 3 0 11 0 49]
#[0 3 174 0 1 0 3 0 11 0 49]
#[0 3 194 0 1 0 3 0 11 0 49]
#[0 3 198 0 1 0 3 0 11 0 49]
#[0 3 202 0 1 0 3 0 11 0 49]
#[0 3 206 0 1 0 3 0 11 0 49]
#[0 3 210 0 1 0 3 0 11 0 49]
#[0 5 209 0 10]
#[0 5 213 0 10]
#[0 2 202 0 49 0 119]
#[1 4 193 0 29 2 226 0 49 2 226 0 119 5 217 0 244 5 221 0 245]
#[1 2 146 0 71 2 146 0 110 2 146 0 112 2 146 0 114 2 146 0 115 2 146 0 118 2 146 0 130 5 225 0 232]
#[0 2 130 0 49]
#[0 2 106 0 130]
#[1 5 229 0 11 1 205 0 49 5 233 0 151]
#[0 2 94 0 11 0 49]
#[1 1 5 0 130 5 237 0 147 5 241 0 171]
#[1 4 69 0 62 4 73 0 63 4 77 0 64 4 81 0 65 4 85 0 66 4 89 0 68 4 93 0 69 4 97 0 72 4 101 0 73 4 105 0 74 4 109 0 76 4 113 0 85 4 117 0 86 4 121 0 87 4 125 0 91 1 5 0 130 1 89 0 147 4 129 0 149 5 245 0 178 5 249 1 14 4 141 1 15 4 145 1 16 4 149 1 17 4 153 1 18 4 157 1 19 4 161 1 20 4 165 1 21 4 169 1 22 4 173 1 23 4 177 1 24 4 181 1 25 4 185 1 26]
#[1 1 106 0 2 1 106 0 5 1 106 0 12 1 106 0 14 1 106 0 16 1 106 0 17 1 106 0 18 1 106 0 24 1 106 0 25 1 106 0 28 1 106 0 31 1 106 0 49 1 106 0 84 1 106 0 93 1 106 0 96 1 106 0 97 1 106 0 98 1 106 0 100 1 106 0 106 1 106 0 107 1 106 0 115 1 106 0 116 1 106 0 123 1 106 0 130 5 253 0 172 6 1 0 182]
#[1 1 5 0 130 5 237 0 147 6 5 0 171]
#[1 0 198 0 16 0 198 0 17 0 198 0 18 0 198 0 20 0 198 0 25 0 198 0 28 0 198 0 31 0 198 0 49 0 198 0 58 0 198 0 93 0 198 0 96 0 198 0 98 0 198 0 106 0 198 0 107 0 198 0 115 0 198 0 123 0 198 0 130 6 9 0 153]
#[1 0 181 0 31 0 233 0 115 1 5 0 130 1 13 0 147 2 41 0 199 6 13 0 200 6 17 0 201 1 73 1 50]
#[1 0 198 0 16 0 198 0 17 0 198 0 18 0 198 0 25 0 198 0 26 0 198 0 28 0 198 0 31 0 198 0 49 0 198 0 93 0 198 0 96 0 198 0 98 0 198 0 106 0 198 0 107 0 198 0 115 0 198 0 123 0 198 0 130 6 21 0 153]
#[1 2 10 0 10 2 10 0 21 2 10 0 30 2 10 0 31 2 10 0 34 2 10 0 38 2 10 0 47 2 10 0 50 2 10 0 75 2 10 0 77 2 10 0 78 2 10 0 79 2 10 0 81 2 10 0 82 2 10 0 83 2 10 0 90 2 10 0 115 2 10 0 123 2 10 0 125 2 10 0 126 2 10 0 127 2 10 0 128 2 10 0 129 2 10 0 130 6 25 0 210]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 6 29 0 148 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 1 37 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[0 6 33 0 95]
#[1 1 205 0 49 6 37 0 151]
#[0 6 41 0 11]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 6 45 0 148 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 1 37 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 6 49 0 148 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 1 37 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[0 2 66 0 49 0 103]
#[1 5 70 0 49 6 53 0 103 6 57 0 217 6 61 1 59]
#[1 1 205 0 49 6 65 0 151]
#[1 1 205 0 49 6 69 0 151]
#[1 2 121 0 34 3 141 0 35 2 129 0 36 3 145 0 37 2 137 0 38 2 141 0 39 6 73 1 49]
#[0 5 62 0 15 0 67]
#[0 5 54 0 15 0 67]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 6 77 0 148 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 1 37 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 6 81 0 148 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 1 37 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[0 5 34 0 1 0 4 0 11 0 15 0 22 0 29 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 52 0 55 0 56 0 57 0 60 0 61 0 67 0 75 0 88 0 90 0 95 0 96 0 101 0 102 0 103 0 108 0 113 1 56]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 6 85 0 148 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 1 37 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 6 89 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[0 1 222 0 1 0 4 0 11 0 15 0 22 0 29 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 52 0 55 0 56 0 57 0 60 0 61 0 67 0 75 0 88 0 90 0 95 0 96 0 101 0 102 0 103 0 108 0 113 1 56]
#[0 0 126 0 1 0 3 0 4 0 10 0 11 0 15 0 40 0 49 0 119 0 120 0 121]
#[0 0 246 0 54]
#[0 6 93 0 54]
#[0 0 242 0 54]
#[0 6 97 0 51]
#[0 0 226 0 2 0 5 0 9 0 12 0 14 0 23 0 27 0 51 0 84 0 100 0 116]
#[0 6 101 0 54]
#[0 6 105 0 1]
#[0 1 38 0 1 0 3 0 11 0 49]
#[1 0 58 0 10 0 58 0 31 0 58 0 34 0 58 0 38 0 58 0 47 0 58 0 50 0 58 0 75 0 58 0 77 0 58 0 78 0 58 0 79 0 58 0 81 0 58 0 82 0 58 0 83 0 58 0 90 0 58 0 115 0 58 0 123 0 58 0 125 0 58 0 126 0 58 0 127 0 58 0 128 0 58 0 129 0 58 0 130 6 109 0 145 0 58 0 220]
#[0 6 113 0 70]
#[1 6 117 0 70 1 5 0 130 1 137 0 147 6 121 1 8 6 125 1 9]
#[0 6 129 0 70]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 6 133 0 148 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 1 37 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[0 4 46 0 29]
#[0 6 137 0 29]
#[0 6 141 0 29]
#[0 6 145 0 29]
#[0 6 149 0 29]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 6 153 0 148 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 1 37 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[0 4 74 0 1 0 3 0 11 0 49]
#[0 3 214 0 1 0 3 0 11 0 49]
#[1 4 94 0 1 4 94 0 3 4 94 0 11 4 94 0 49 6 157 0 89 6 161 1 36]
#[1 1 5 0 130 6 165 0 147]
#[1 4 69 0 62 4 73 0 63 4 77 0 64 4 81 0 65 4 85 0 66 4 89 0 68 4 93 0 69 4 97 0 72 4 101 0 73 4 105 0 74 4 109 0 76 4 113 0 85 4 117 0 86 4 121 0 87 4 125 0 91 1 5 0 130 1 89 0 147 4 129 0 149 6 169 0 178 5 249 1 14 4 141 1 15 4 145 1 16 4 149 1 17 4 153 1 18 4 157 1 19 4 161 1 20 4 165 1 21 4 169 1 22 4 173 1 23 4 177 1 24 4 181 1 25 4 185 1 26]
#[0 3 218 0 1 0 3 0 11 0 49]
#[0 6 173 0 10]
#[1 1 5 0 130 6 177 0 147]
#[1 1 5 0 130 5 237 0 147 6 181 0 171]
#[0 4 86 0 1 0 3 0 11 0 49]
#[0 3 226 0 1 0 3 0 11 0 49]
#[0 3 230 0 1 0 3 0 11 0 49]
#[1 5 113 0 71 2 190 0 92 6 185 0 173 6 189 0 239]
#[1 1 5 0 130 6 193 0 147 6 197 0 242 6 201 0 243]
#[1 6 205 0 10 6 209 0 117 1 5 0 130 6 213 0 147 6 217 0 246]
#[0 2 230 0 49 0 119]
#[0 2 198 0 49 0 119]
#[1 2 158 0 71 6 221 0 110 2 158 0 112 2 158 0 114 6 225 0 115 2 158 0 118 1 5 0 130 1 89 0 147 6 229 0 149 6 233 0 231 6 237 0 233 6 241 0 234 6 245 0 248 6 249 0 250]
#[0 1 74 0 4 0 49]
#[1 4 213 0 111 2 110 0 130 6 253 0 225 4 225 0 226]
#[1 0 58 0 4 0 58 0 11 0 58 0 15 7 1 0 145 0 58 0 220]
#[1 7 5 0 4 7 9 0 15 7 13 1 55]
#[1 1 205 0 49 7 17 0 151]
#[0 1 86 0 1 0 3 0 11 0 49]
#[0 7 21 0 24]
#[1 0 157 0 2 0 133 0 5 0 198 0 8 0 145 0 12 0 93 0 14 0 198 0 16 0 198 0 17 0 198 0 18 0 198 0 24 0 198 0 25 0 198 0 28 0 198 0 31 0 198 0 49 0 198 0 71 0 105 0 84 0 198 0 93 0 198 0 96 7 25 0 97 0 198 0 98 0 109 0 100 0 198 0 106 0 198 0 107 0 198 0 115 0 121 0 116 0 198 0 123 0 198 0 130 1 101 0 134 1 105 0 135 1 109 0 136 1 113 0 137 1 117 0 138 1 121 0 139 7 29 0 153 0 101 0 165 0 165 0 169 0 141 0 174 0 153 0 179 7 33 0 181 7 37 0 183 0 129 0 227 0 117 1 5 7 41 1 60]
#[1 7 45 0 11 7 9 0 15 7 13 1 55]
#[1 1 185 0 16 1 189 0 17 1 193 0 18 7 49 0 20 1 197 0 25 1 201 0 28 0 181 0 31 1 205 0 49 7 53 0 58 1 209 0 93 1 213 0 96 1 217 0 98 1 221 0 106 1 225 0 107 0 233 0 115 0 237 0 123 1 5 0 130 1 13 0 147 1 229 0 151 1 233 0 152 1 237 0 184 1 241 0 185 1 245 0 186 1 249 0 187 1 253 0 188 2 1 0 189 2 5 0 190 2 9 0 191 2 13 0 192 2 17 0 193 2 21 0 194 2 25 0 195 2 29 0 196 2 33 0 197 2 37 0 198 2 41 0 199 2 45 0 200 2 49 0 201 2 53 0 203 1 33 0 205 2 57 0 212 1 73 1 50]
#[0 1 246 0 49]
#[0 1 190 0 49 0 75 0 108 0 113]
#[1 1 185 0 16 1 189 0 17 1 193 0 18 1 197 0 25 7 57 0 26 1 201 0 28 0 181 0 31 1 205 0 49 1 209 0 93 1 213 0 96 1 217 0 98 1 221 0 106 1 225 0 107 0 233 0 115 0 237 0 123 1 5 0 130 1 13 0 147 1 229 0 151 1 233 0 152 1 237 0 184 1 241 0 185 1 245 0 186 1 249 0 187 1 253 0 188 2 1 0 189 2 5 0 190 2 9 0 191 2 13 0 192 2 17 0 193 2 21 0 194 2 25 0 195 2 29 0 196 2 33 0 197 2 37 0 198 2 41 0 199 2 45 0 200 2 49 0 201 2 53 0 203 1 33 0 205 2 57 0 212 1 73 1 50]
#[1 0 177 0 10 2 18 0 21 7 61 0 30 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 3 177 0 148 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 7 65 0 207 7 69 0 208 7 73 0 209 7 77 0 211 1 37 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[0 7 81 0 95]
#[0 1 170 0 8 0 10 0 16 0 17 0 18 0 19 0 20 0 21 0 24 0 25 0 26 0 28 0 30 0 31 0 34 0 38 0 47 0 49 0 50 0 58 0 71 0 75 0 77 0 78 0 79 0 81 0 82 0 83 0 90 0 93 0 96 0 98 0 105 0 106 0 107 0 115 0 123 0 125 0 126 0 127 0 128 0 129 0 130 1 56]
#[0 1 162 0 8 0 10 0 16 0 17 0 18 0 19 0 20 0 21 0 24 0 25 0 26 0 28 0 30 0 31 0 34 0 38 0 47 0 49 0 50 0 58 0 71 0 75 0 77 0 78 0 79 0 81 0 82 0 83 0 90 0 93 0 96 0 98 0 105 0 106 0 107 0 115 0 123 0 125 0 126 0 127 0 128 0 129 0 130 1 56]
#[1 1 205 0 49 7 85 0 151]
#[0 7 89 0 101]
#[0 2 46 0 49 0 103]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 7 93 0 148 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 1 37 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[0 5 74 0 49]
#[1 1 205 0 49 7 97 0 151]
#[0 1 122 0 8 0 10 0 16 0 17 0 18 0 19 0 20 0 21 0 24 0 25 0 26 0 28 0 30 0 31 0 34 0 38 0 47 0 49 0 50 0 58 0 71 0 75 0 77 0 78 0 79 0 81 0 82 0 83 0 90 0 93 0 96 0 98 0 105 0 106 0 107 0 115 0 123 0 125 0 126 0 127 0 128 0 129 0 130 1 56]
#[0 1 130 0 8 0 10 0 16 0 17 0 18 0 19 0 20 0 21 0 24 0 25 0 26 0 28 0 30 0 31 0 34 0 38 0 47 0 49 0 50 0 58 0 71 0 75 0 77 0 78 0 79 0 81 0 82 0 83 0 90 0 93 0 96 0 98 0 105 0 106 0 107 0 115 0 123 0 125 0 126 0 127 0 128 0 129 0 130 1 56]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 7 101 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[0 7 105 0 96]
#[0 1 254 0 4 0 11 0 15]
#[0 7 109 0 48]
#[1 2 121 0 34 2 129 0 36 2 137 0 38 2 141 0 39 7 113 0 67]
#[1 1 5 0 130 7 117 0 147]
#[1 1 205 0 49 7 121 0 151]
#[1 1 5 0 130 7 125 0 147]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 7 129 0 148 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 1 37 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 77 0 144 7 133 0 147 7 137 0 148 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 1 85 0 220 7 141 1 11 7 145 1 12 7 149 1 13 1 37 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[1 1 205 0 49 7 153 0 151]
#[1 1 205 0 49 7 157 0 151]
#[1 1 205 0 49 3 5 0 108 7 161 0 151]
#[0 3 134 0 70 0 130]
#[1 1 205 0 49 7 165 0 151]
#[0 7 169 0 4]
#[1 4 58 0 62 4 58 0 63 4 58 0 64 4 58 0 65 4 58 0 66 4 58 0 68 4 58 0 69 4 58 0 72 4 58 0 73 4 58 0 74 4 58 0 76 4 58 0 85 4 58 0 86 4 58 0 87 4 58 0 91 7 173 0 109 7 177 0 112 4 58 0 130 7 181 1 27 7 185 1 31]
#[1 4 69 0 62 4 73 0 63 4 77 0 64 4 81 0 65 4 85 0 66 4 89 0 68 4 93 0 69 4 97 0 72 4 101 0 73 4 105 0 74 4 109 0 76 4 113 0 85 4 117 0 86 4 121 0 87 4 125 0 91 1 5 0 130 1 89 0 147 4 129 0 149 7 189 0 168 5 109 1 14 4 141 1 15 4 145 1 16 4 149 1 17 4 153 1 18 4 157 1 19 4 161 1 20 4 165 1 21 4 169 1 22 4 173 1 23 4 177 1 24 4 181 1 25 4 185 1 26]
#[1 4 69 0 62 4 73 0 63 4 77 0 64 4 81 0 65 4 85 0 66 4 89 0 68 4 93 0 69 4 97 0 72 4 101 0 73 4 105 0 74 4 109 0 76 4 113 0 85 4 117 0 86 4 121 0 87 4 125 0 91 1 5 0 130 1 89 0 147 4 129 0 149 7 193 0 168 5 109 1 14 4 141 1 15 4 145 1 16 4 149 1 17 4 153 1 18 4 157 1 19 4 161 1 20 4 165 1 21 4 169 1 22 4 173 1 23 4 177 1 24 4 181 1 25 4 185 1 26]
#[1 4 50 0 62 4 50 0 63 4 50 0 64 4 50 0 65 4 50 0 66 4 50 0 68 4 50 0 69 4 50 0 72 4 50 0 73 4 50 0 74 4 50 0 76 4 50 0 85 4 50 0 86 4 50 0 87 4 50 0 91 7 197 0 112 4 50 0 130 7 201 1 30]
#[0 7 205 0 11]
#[0 4 90 0 1 0 3 0 11 0 49]
#[0 4 66 0 1 0 3 0 11 0 49]
#[0 7 209 0 29]
#[0 4 14 0 1 0 3 0 11 0 49]
#[1 1 5 0 130 5 237 0 147 7 213 0 171]
#[0 3 250 0 1 0 3 0 11 0 49]
#[1 7 217 0 11 7 9 0 15 7 13 1 55]
#[0 2 194 0 92 0 118]
#[0 7 221 0 92]
#[0 2 218 0 11 0 15]
#[1 7 225 0 11 7 229 0 15]
#[0 2 210 0 11 0 15]
#[1 6 205 0 10 6 209 0 117 1 5 0 130 6 213 0 147 7 233 0 246]
#[0 7 237 0 10]
#[0 2 234 0 11 0 15 0 59 0 61]
#[1 7 241 0 11 7 245 0 59 7 249 0 61]
#[1 0 58 0 115 0 58 0 130 7 253 0 145 0 58 0 220]
#[0 8 1 0 113]
#[0 3 6 0 4 0 15]
#[0 2 150 0 71 0 110 0 112 0 114 0 115 0 118 0 130]
#[0 2 162 0 71 0 112 0 114 0 118]
#[1 2 170 0 71 2 170 0 112 8 5 0 114 2 170 0 118 8 9 0 235 8 13 0 236]
#[0 3 22 0 4 0 15]
#[1 8 17 0 4 8 21 0 15]
#[0 2 98 0 11 0 49]
#[1 1 50 0 4 1 50 0 11 1 50 0 15 1 77 0 144 1 85 0 220]
#[1 4 69 0 62 4 73 0 63 4 77 0 64 4 81 0 65 4 85 0 66 4 89 0 68 4 93 0 69 4 97 0 72 4 101 0 73 4 105 0 74 4 109 0 76 4 113 0 85 4 117 0 86 4 121 0 87 4 125 0 91 1 5 0 130 1 89 0 147 4 129 0 149 8 25 0 178 5 249 1 14 4 141 1 15 4 145 1 16 4 149 1 17 4 153 1 18 4 157 1 19 4 161 1 20 4 165 1 21 4 169 1 22 4 173 1 23 4 177 1 24 4 181 1 25 4 185 1 26]
#[1 0 58 0 130 8 29 0 145 0 58 0 220]
#[1 1 5 0 130 8 33 0 147]
#[1 1 106 0 2 1 106 0 5 1 106 0 8 1 106 0 12 1 106 0 14 1 106 0 16 1 106 0 17 1 106 0 18 1 106 0 25 1 106 0 28 1 106 0 31 1 106 0 49 1 106 0 84 1 106 0 93 1 106 0 96 1 106 0 97 1 106 0 98 1 106 0 100 1 106 0 106 1 106 0 107 1 106 0 115 1 106 0 116 1 106 0 123 1 106 0 130 8 37 0 172 6 1 0 182]
#[1 1 205 0 49 8 41 0 151]
#[1 2 86 0 104 2 86 0 130 8 45 0 223]
#[1 1 58 0 8 1 185 0 16 1 189 0 17 1 193 0 18 1 58 0 24 1 197 0 25 1 201 0 28 0 181 0 31 1 205 0 49 1 58 0 71 1 209 0 93 1 213 0 96 1 217 0 98 1 221 0 106 1 225 0 107 0 233 0 115 0 237 0 123 1 5 0 130 1 13 0 147 1 229 0 151 1 233 0 152 1 237 0 184 1 241 0 185 1 245 0 186 1 249 0 187 1 253 0 188 2 1 0 189 2 5 0 190 2 9 0 191 2 13 0 192 2 17 0 193 2 21 0 194 2 25 0 195 2 29 0 196 2 33 0 197 2 37 0 198 2 41 0 199 2 45 0 200 2 49 0 201 2 53 0 203 1 33 0 205 2 57 0 212 1 73 1 50]
#[0 1 110 0 2 0 5 0 8 0 12 0 14 0 16 0 17 0 18 0 24 0 25 0 28 0 31 0 49 0 71 0 84 0 93 0 96 0 97 0 98 0 100 0 106 0 107 0 115 0 116 0 123 0 130]
#[0 1 102 0 2 0 5 0 8 0 12 0 14 0 16 0 17 0 18 0 24 0 25 0 28 0 31 0 49 0 71 0 84 0 93 0 96 0 97 0 98 0 100 0 106 0 107 0 115 0 116 0 123 0 130]
#[0 1 98 0 2 0 5 0 8 0 12 0 14 0 16 0 17 0 18 0 24 0 25 0 28 0 31 0 49 0 71 0 84 0 93 0 96 0 97 0 98 0 100 0 106 0 107 0 115 0 116 0 123 0 130]
#[1 1 205 0 49 8 49 0 151]
#[1 1 205 0 49 8 53 0 151]
#[1 0 198 0 16 0 198 0 17 0 198 0 18 0 198 0 20 0 198 0 25 0 198 0 28 0 198 0 31 0 198 0 49 0 198 0 93 0 198 0 96 0 198 0 98 0 198 0 106 0 198 0 107 0 198 0 115 0 198 0 123 0 198 0 130 8 57 0 153]
#[1 1 205 0 49 8 61 0 151]
#[0 8 65 0 4]
#[1 8 69 0 4 5 57 0 15]
#[0 2 14 0 10 0 21 0 30 0 31 0 34 0 38 0 47 0 50 0 75 0 77 0 78 0 79 0 81 0 82 0 83 0 90 0 115 0 123 0 125 0 126 0 127 0 128 0 129 0 130]
#[0 2 22 0 21]
#[0 8 73 0 21]
#[0 1 166 0 8 0 10 0 16 0 17 0 18 0 19 0 20 0 21 0 24 0 25 0 26 0 28 0 30 0 31 0 34 0 38 0 47 0 49 0 50 0 58 0 71 0 75 0 77 0 78 0 79 0 81 0 82 0 83 0 90 0 93 0 96 0 98 0 105 0 106 0 107 0 115 0 123 0 125 0 126 0 127 0 128 0 129 0 130 1 56]
#[0 1 154 0 8 0 10 0 16 0 17 0 18 0 19 0 20 0 21 0 24 0 25 0 26 0 28 0 30 0 31 0 34 0 38 0 47 0 49 0 50 0 58 0 71 0 75 0 77 0 78 0 79 0 81 0 82 0 83 0 90 0 93 0 96 0 98 0 105 0 106 0 107 0 115 0 123 0 125 0 126 0 127 0 128 0 129 0 130 1 56]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 8 77 0 148 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 1 37 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[0 2 50 0 49]
#[1 0 198 0 16 0 198 0 17 0 198 0 18 0 198 0 25 0 198 0 28 0 198 0 31 0 198 0 49 0 198 0 93 0 198 0 96 0 198 0 98 0 198 0 105 0 198 0 106 0 198 0 107 0 198 0 115 0 198 0 123 0 198 0 130 8 81 0 153]
#[1 2 121 0 34 2 129 0 36 2 137 0 38 2 141 0 39 8 85 0 48]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 8 89 0 148 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 1 37 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[0 5 18 0 10 0 31 0 34 0 38 0 47 0 50 0 75 0 77 0 78 0 79 0 81 0 82 0 83 0 90 0 115 0 123 0 125 0 126 0 127 0 128 0 129 0 130]
#[0 1 226 0 1 0 4 0 11 0 15 0 22 0 29 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 52 0 55 0 56 0 57 0 60 0 61 0 67 0 75 0 88 0 90 0 95 0 96 0 101 0 102 0 103 0 108 0 113 1 56]
#[1 1 205 0 49 8 93 0 151]
#[0 0 206 0 53 1 56]
#[1 8 97 0 10 0 254 0 49 8 101 0 161 8 105 0 162]
#[1 1 205 0 49 8 109 0 151]
#[1 8 113 0 4 2 105 0 10 1 206 0 32 1 206 0 33 1 206 0 34 1 206 0 35 1 206 0 36 1 206 0 37 1 206 0 38 1 206 0 39 1 206 0 40 1 206 0 41 1 206 0 42 1 206 0 43 1 206 0 44 1 206 0 45 1 206 0 46 1 206 0 47 1 206 0 49 1 206 0 52 1 206 0 55 1 206 0 56 1 206 0 57 1 206 0 60 1 206 0 61 1 206 0 75 1 206 0 108 1 206 0 113]
#[1 1 205 0 49 8 117 0 151]
#[0 3 146 0 7 0 10 0 31 0 34 0 38 0 47 0 50 0 70 0 75 0 77 0 78 0 79 0 81 0 82 0 83 0 90 0 92 0 115 0 118 0 123 0 125 0 126 0 127 0 128 0 129 0 130]
#[1 1 62 0 7 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 1 62 0 70 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 1 62 0 92 0 233 0 115 1 62 0 118 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 7 133 0 147 7 137 0 148 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 8 121 1 11 7 149 1 13 1 37 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 8 125 0 148 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 1 37 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[0 3 106 0 2 0 5 0 8 0 12 0 14 0 16 0 17 0 18 0 24 0 25 0 28 0 31 0 49 0 51 0 71 0 84 0 93 0 96 0 97 0 98 0 100 0 106 0 107 0 115 0 116 0 123 0 130 1 56]
#[0 3 102 0 2 0 5 0 8 0 12 0 14 0 16 0 17 0 18 0 24 0 25 0 28 0 31 0 49 0 51 0 71 0 84 0 93 0 96 0 97 0 98 0 100 0 106 0 107 0 115 0 116 0 123 0 130 1 56]
#[0 3 126 0 70 0 130]
#[0 3 98 0 2 0 5 0 8 0 12 0 14 0 16 0 17 0 18 0 24 0 25 0 28 0 31 0 49 0 51 0 71 0 84 0 93 0 96 0 97 0 98 0 100 0 106 0 107 0 115 0 116 0 123 0 130 1 56]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 8 129 0 148 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 1 37 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[1 4 30 0 62 4 30 0 63 4 30 0 64 4 30 0 65 4 30 0 66 4 30 0 68 4 30 0 69 4 30 0 72 4 30 0 73 4 30 0 74 4 30 0 76 4 30 0 85 4 30 0 86 4 30 0 87 4 30 0 91 8 133 0 112 4 30 0 130]
#[1 4 34 0 62 4 34 0 63 4 34 0 64 4 34 0 65 4 34 0 66 4 34 0 68 4 34 0 69 4 34 0 72 4 34 0 73 4 34 0 74 4 34 0 76 4 34 0 85 4 34 0 86 4 34 0 87 4 34 0 91 8 137 0 109 4 34 0 130]
#[0 4 62 0 62 0 63 0 64 0 65 0 66 0 68 0 69 0 72 0 73 0 74 0 76 0 85 0 86 0 87 0 91 0 130]
#[1 4 69 0 62 4 73 0 63 4 77 0 64 4 81 0 65 4 85 0 66 4 89 0 68 4 93 0 69 4 97 0 72 4 101 0 73 4 105 0 74 4 109 0 76 4 113 0 85 4 117 0 86 4 121 0 87 4 125 0 91 1 5 0 130 1 89 0 147 4 129 0 149 8 141 0 168 5 109 1 14 4 141 1 15 4 145 1 16 4 149 1 17 4 153 1 18 4 157 1 19 4 161 1 20 4 165 1 21 4 169 1 22 4 173 1 23 4 177 1 24 4 181 1 25 4 185 1 26]
#[0 4 6 0 1 0 3 0 11 0 49]
#[0 4 10 0 1 0 3 0 11 0 49]
#[0 4 54 0 62 0 63 0 64 0 65 0 66 0 68 0 69 0 72 0 73 0 74 0 76 0 85 0 86 0 87 0 91 0 130]
#[1 4 69 0 62 4 73 0 63 4 77 0 64 4 81 0 65 4 85 0 66 4 89 0 68 4 93 0 69 4 97 0 72 4 101 0 73 4 105 0 74 4 109 0 76 4 113 0 85 4 117 0 86 4 121 0 87 4 125 0 91 1 5 0 130 1 89 0 147 4 129 0 149 8 145 0 168 5 109 1 14 4 141 1 15 4 145 1 16 4 149 1 17 4 153 1 18 4 157 1 19 4 161 1 20 4 165 1 21 4 169 1 22 4 173 1 23 4 177 1 24 4 181 1 25 4 185 1 26]
#[0 4 78 0 1 0 3 0 11 0 49 0 89]
#[1 4 69 0 62 4 73 0 63 4 77 0 64 4 81 0 65 4 85 0 66 4 89 0 68 4 93 0 69 4 97 0 72 4 101 0 73 4 105 0 74 4 109 0 76 4 113 0 85 4 117 0 86 4 121 0 87 4 125 0 91 1 5 0 130 1 89 0 147 4 129 0 149 8 149 0 178 5 249 1 14 4 141 1 15 4 145 1 16 4 149 1 17 4 153 1 18 4 157 1 19 4 161 1 20 4 165 1 21 4 169 1 22 4 173 1 23 4 177 1 24 4 181 1 25 4 185 1 26]
#[1 8 153 0 11 7 9 0 15 7 13 1 55]
#[0 3 178 0 1 0 3 0 11 0 49]
#[1 1 205 0 49 8 157 0 151]
#[0 2 206 0 49]
#[1 1 5 0 130 6 193 0 147 8 161 0 243]
#[1 8 165 0 11 7 245 0 59 7 249 0 61]
#[1 6 205 0 10 6 209 0 117 1 5 0 130 6 213 0 147 8 169 0 246 8 173 0 247]
#[0 2 222 0 49 0 119]
#[1 6 205 0 10 6 209 0 117 1 5 0 130 6 213 0 147 8 177 0 246]
#[1 6 205 0 10 6 209 0 117 1 5 0 130 6 213 0 147 8 181 0 246]
#[1 6 225 0 115 1 5 0 130 1 77 0 144 1 89 0 147 6 229 0 149 1 85 0 220 8 185 0 248 8 189 0 252 8 193 0 253]
#[1 1 5 0 130 8 197 0 147]
#[1 0 58 0 115 0 58 0 130 8 201 0 145 0 58 0 220]
#[0 2 174 0 71 0 112 0 118]
#[1 2 182 0 71 8 205 0 112 2 182 0 118 8 209 0 237 8 213 0 238]
#[1 3 34 0 62 3 34 0 63 3 34 0 64 3 34 0 65 3 34 0 66 3 34 0 68 3 34 0 69 3 34 0 72 3 34 0 73 3 34 0 74 3 34 0 76 3 34 0 85 3 34 0 86 3 34 0 87 3 34 0 91 8 217 0 109 3 34 0 130 8 221 0 251]
#[1 6 225 0 115 1 5 0 130 1 89 0 147 6 229 0 149 8 225 0 248]
#[0 2 102 0 11 0 49]
#[1 5 66 0 130 1 77 0 144 1 85 0 220]
#[1 0 58 0 4 0 58 0 11 0 58 0 15 8 229 0 145 0 58 0 220]
#[0 8 233 0 8]
#[0 1 90 0 2 0 5 0 8 0 12 0 14 0 16 0 17 0 18 0 24 0 25 0 28 0 31 0 49 0 51 0 71 0 84 0 93 0 96 0 97 0 98 0 100 0 106 0 107 0 115 0 116 0 123 0 130 1 56]
#[1 8 237 0 104 1 5 0 130 5 237 0 147 8 241 0 171 8 245 0 222]
#[1 1 106 0 2 1 106 0 5 1 106 0 12 1 106 0 14 1 106 0 16 1 106 0 17 1 106 0 18 1 106 0 25 1 106 0 28 1 106 0 31 1 106 0 49 1 106 0 71 1 106 0 84 1 106 0 93 1 106 0 96 1 106 0 97 1 106 0 98 1 106 0 100 1 106 0 106 1 106 0 107 1 106 0 115 1 106 0 116 1 106 0 123 1 106 0 130 8 249 0 172 6 1 0 182]
#[0 1 138 0 8 0 10 0 16 0 17 0 18 0 19 0 20 0 21 0 24 0 25 0 26 0 28 0 30 0 31 0 34 0 38 0 47 0 49 0 50 0 58 0 71 0 75 0 77 0 78 0 79 0 81 0 82 0 83 0 90 0 93 0 96 0 98 0 105 0 106 0 107 0 115 0 123 0 125 0 126 0 127 0 128 0 129 0 130 1 56]
#[1 1 185 0 16 1 189 0 17 1 193 0 18 8 253 0 20 1 197 0 25 1 201 0 28 0 181 0 31 1 205 0 49 1 209 0 93 1 213 0 96 1 217 0 98 1 221 0 106 1 225 0 107 0 233 0 115 0 237 0 123 1 5 0 130 1 13 0 147 1 229 0 151 1 233 0 152 1 237 0 184 1 241 0 185 1 245 0 186 1 249 0 187 1 253 0 188 2 1 0 189 2 5 0 190 2 9 0 191 2 13 0 192 2 17 0 193 2 21 0 194 2 25 0 195 2 29 0 196 2 33 0 197 2 37 0 198 2 41 0 199 2 45 0 200 2 49 0 201 2 53 0 203 1 33 0 205 2 57 0 212 1 73 1 50]
#[0 1 118 0 8 0 10 0 16 0 17 0 18 0 19 0 20 0 21 0 24 0 25 0 26 0 28 0 30 0 31 0 34 0 38 0 47 0 49 0 50 0 58 0 71 0 75 0 77 0 78 0 79 0 81 0 82 0 83 0 90 0 93 0 96 0 98 0 105 0 106 0 107 0 115 0 123 0 125 0 126 0 127 0 128 0 129 0 130 1 56]
#[1 1 185 0 16 1 189 0 17 1 193 0 18 1 197 0 25 1 201 0 28 0 181 0 31 1 205 0 49 1 209 0 93 1 213 0 96 1 217 0 98 1 221 0 106 1 225 0 107 0 233 0 115 0 237 0 123 1 5 0 130 1 13 0 147 1 229 0 151 9 1 0 152 1 237 0 184 1 241 0 185 1 245 0 186 1 249 0 187 1 253 0 188 2 1 0 189 2 5 0 190 2 9 0 191 2 13 0 192 2 17 0 193 2 21 0 194 2 25 0 195 2 29 0 196 2 33 0 197 2 37 0 198 2 41 0 199 2 45 0 200 2 49 0 201 2 53 0 203 1 33 0 205 2 57 0 212 1 73 1 50]
#[1 1 185 0 16 1 189 0 17 1 193 0 18 1 197 0 25 1 201 0 28 0 181 0 31 1 205 0 49 1 209 0 93 1 213 0 96 1 217 0 98 1 221 0 106 1 225 0 107 0 233 0 115 0 237 0 123 1 5 0 130 1 13 0 147 1 229 0 151 9 5 0 152 1 237 0 184 1 241 0 185 1 245 0 186 1 249 0 187 1 253 0 188 2 1 0 189 2 5 0 190 2 9 0 191 2 13 0 192 2 17 0 193 2 21 0 194 2 25 0 195 2 29 0 196 2 33 0 197 2 37 0 198 2 41 0 199 2 45 0 200 2 49 0 201 2 53 0 203 1 33 0 205 2 57 0 212 1 73 1 50]
#[1 1 205 0 49 9 9 0 151]
#[1 2 34 0 49 9 13 0 88 2 34 0 102 2 34 0 103 9 17 0 213 9 21 0 214]
#[1 1 185 0 16 1 189 0 17 1 193 0 18 1 197 0 25 1 201 0 28 0 181 0 31 1 205 0 49 1 209 0 93 1 213 0 96 1 217 0 98 9 25 0 105 1 221 0 106 1 225 0 107 0 233 0 115 0 237 0 123 1 5 0 130 1 13 0 147 1 229 0 151 1 233 0 152 1 237 0 184 1 241 0 185 1 245 0 186 1 249 0 187 1 253 0 188 2 1 0 189 2 5 0 190 2 9 0 191 2 13 0 192 2 17 0 193 2 21 0 194 2 25 0 195 2 29 0 196 2 33 0 197 2 37 0 198 2 41 0 199 2 45 0 200 2 49 0 201 2 53 0 203 1 33 0 205 2 57 0 212 1 73 1 50]
#[0 5 10 0 4 0 11 0 15 0 22 0 29 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 52 0 55 0 56 0 57 0 60 0 61 0 67 0 75 0 88 0 90 0 95 0 96 0 101 0 102 0 103 0 108 0 113 1 56]
#[0 9 29 0 11]
#[0 0 218 0 2 0 5 0 9 0 12 0 14 0 23 0 27 0 51 0 84 0 100 0 116]
#[1 1 5 0 130 9 33 0 147 9 37 0 163 9 41 0 164]
#[0 1 2 0 49]
#[1 1 205 0 49 9 45 0 151]
#[0 1 26 0 6 0 130]
#[0 3 154 0 10 0 31 0 34 0 38 0 47 0 50 0 75 0 77 0 78 0 79 0 81 0 82 0 83 0 90 0 115 0 123 0 125 0 126 0 127 0 128 0 129 0 130]
#[0 3 142 0 7 0 10 0 31 0 34 0 38 0 47 0 50 0 70 0 75 0 77 0 78 0 79 0 81 0 82 0 83 0 90 0 92 0 115 0 118 0 123 0 125 0 126 0 127 0 128 0 129 0 130]
#[0 3 150 0 7 0 10 0 31 0 34 0 38 0 47 0 50 0 70 0 75 0 77 0 78 0 79 0 81 0 82 0 83 0 90 0 92 0 115 0 118 0 123 0 125 0 126 0 127 0 128 0 129 0 130]
#[1 1 205 0 49 9 49 0 151]
#[0 9 53 0 67]
#[0 4 22 0 62 0 63 0 64 0 65 0 66 0 68 0 69 0 72 0 73 0 74 0 76 0 85 0 86 0 87 0 91 0 130]
#[0 4 26 0 62 0 63 0 64 0 65 0 66 0 68 0 69 0 72 0 73 0 74 0 76 0 85 0 86 0 87 0 91 0 130]
#[0 3 254 0 1 0 3 0 11 0 49]
#[0 4 2 0 1 0 3 0 11 0 49]
#[0 4 18 0 1 0 3 0 11 0 49]
#[0 3 182 0 1 0 3 0 11 0 49]
#[0 3 94 0 2 0 5 0 8 0 12 0 14 0 16 0 17 0 18 0 24 0 25 0 28 0 31 0 49 0 51 0 71 0 84 0 93 0 96 0 97 0 98 0 100 0 106 0 107 0 115 0 116 0 123 0 130 1 56]
#[0 2 214 0 11 0 15]
#[0 2 250 0 11 0 15 0 59 0 61]
#[1 2 254 0 11 2 254 0 15 7 245 0 59 7 249 0 61]
#[1 9 57 0 11 9 61 0 15]
#[0 2 238 0 11 0 15 0 59 0 61]
#[0 2 242 0 11 0 15 0 59 0 61]
#[0 9 65 0 4]
#[0 3 42 0 71 0 112 0 114 0 115 0 118 0 130]
#[1 2 154 0 71 2 154 0 112 2 154 0 114 6 225 0 115 2 154 0 118 1 5 0 130 1 89 0 147 6 229 0 149 8 185 0 248 9 69 0 252]
#[0 9 73 0 108]
#[1 6 225 0 115 1 5 0 130 1 77 0 144 1 89 0 147 6 229 0 149 1 85 0 220 9 77 0 248 9 81 0 254 9 85 0 255]
#[1 0 58 0 115 0 58 0 130 9 89 0 145 0 58 0 220]
#[0 2 186 0 71 0 118]
#[1 5 113 0 71 2 190 0 118 6 185 0 173 9 93 0 239]
#[0 3 30 0 62 0 63 0 64 0 65 0 66 0 68 0 69 0 72 0 73 0 74 0 76 0 85 0 86 0 87 0 91 0 130]
#[1 4 69 0 62 4 73 0 63 4 77 0 64 4 81 0 65 4 85 0 66 4 89 0 68 4 93 0 69 4 97 0 72 4 101 0 73 4 105 0 74 4 109 0 76 4 113 0 85 4 117 0 86 4 121 0 87 4 125 0 91 1 5 0 130 1 89 0 147 4 129 0 149 9 97 0 168 5 109 1 14 4 141 1 15 4 145 1 16 4 149 1 17 4 153 1 18 4 157 1 19 4 161 1 20 4 165 1 21 4 169 1 22 4 173 1 23 4 177 1 24 4 181 1 25 4 185 1 26]
#[0 3 26 0 4 0 15]
#[1 1 54 0 4 1 54 0 11 1 54 0 15 1 77 0 144 1 85 0 220]
#[1 1 205 0 49 9 101 0 151]
#[1 1 205 0 49 9 105 0 151]
#[1 9 109 0 4 7 9 0 15 7 13 1 55]
#[0 2 90 0 104 0 130]
#[1 5 113 0 71 9 113 0 173]
#[1 1 205 0 49 9 117 0 151]
#[0 2 6 0 21]
#[0 2 2 0 10 0 21 0 30 0 31 0 34 0 38 0 47 0 50 0 75 0 77 0 78 0 79 0 81 0 82 0 83 0 90 0 115 0 123 0 125 0 126 0 127 0 128 0 129 0 130]
#[0 1 126 0 8 0 10 0 16 0 17 0 18 0 19 0 20 0 21 0 24 0 25 0 26 0 28 0 30 0 31 0 34 0 38 0 47 0 49 0 50 0 58 0 71 0 75 0 77 0 78 0 79 0 81 0 82 0 83 0 90 0 93 0 96 0 98 0 105 0 106 0 107 0 115 0 123 0 125 0 126 0 127 0 128 0 129 0 130 1 56]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 9 121 0 148 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 1 37 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[0 2 38 0 49 0 102 0 103]
#[0 2 42 0 49 0 102 0 103]
#[1 1 205 0 49 9 125 0 151]
#[0 5 14 0 4 0 11 0 15 0 22 0 29 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 52 0 55 0 56 0 57 0 60 0 61 0 67 0 75 0 88 0 90 0 95 0 96 0 101 0 102 0 103 0 108 0 113 1 56]
#[1 1 14 0 11 9 129 0 13 1 14 0 15]
#[1 9 133 0 11 9 137 0 15]
#[0 1 6 0 11 0 15]
#[0 0 214 0 2 0 5 0 9 0 12 0 14 0 23 0 27 0 51 0 84 0 100 0 116]
#[0 3 138 0 7 0 10 0 31 0 34 0 38 0 47 0 50 0 70 0 75 0 77 0 78 0 79 0 81 0 82 0 83 0 90 0 92 0 115 0 118 0 123 0 125 0 126 0 127 0 128 0 129 0 130]
#[0 4 38 0 29]
#[0 2 246 0 11 0 15 0 59 0 61]
#[1 6 205 0 10 6 209 0 117 1 5 0 130 6 213 0 147 9 141 0 246]
#[1 4 69 0 62 4 73 0 63 4 77 0 64 4 81 0 65 4 85 0 66 4 89 0 68 4 93 0 69 4 97 0 72 4 101 0 73 4 105 0 74 4 109 0 76 4 113 0 85 4 117 0 86 4 121 0 87 4 125 0 91 1 5 0 130 1 89 0 147 4 129 0 149 9 145 0 168 5 109 1 14 4 141 1 15 4 145 1 16 4 149 1 17 4 153 1 18 4 157 1 19 4 161 1 20 4 165 1 21 4 169 1 22 4 173 1 23 4 177 1 24 4 181 1 25 4 185 1 26]
#[0 3 46 0 71 0 112 0 114 0 115 0 118 0 130]
#[1 1 5 0 130 1 89 0 147 9 149 0 149]
#[0 9 153 0 4]
#[0 3 54 0 71 0 112 0 115 0 118 0 130]
#[1 2 166 0 71 2 166 0 112 6 225 0 115 2 166 0 118 1 5 0 130 1 89 0 147 6 229 0 149 9 77 0 248 9 157 0 254]
#[1 9 161 0 115 1 5 0 130 1 77 0 144 9 165 0 147 1 85 0 220 9 169 0 249 9 173 1 1 9 177 1 2 9 181 1 3 9 185 1 4]
#[0 9 189 0 118]
#[1 1 205 0 49 9 193 0 151]
#[0 1 66 0 2 0 5 0 8 0 12 0 14 0 16 0 17 0 18 0 24 0 25 0 28 0 31 0 49 0 51 0 71 0 84 0 93 0 96 0 97 0 98 0 100 0 106 0 107 0 115 0 116 0 123 0 130 1 56]
#[0 1 114 0 2 0 5 0 8 0 12 0 14 0 16 0 17 0 18 0 24 0 25 0 28 0 31 0 49 0 71 0 84 0 93 0 96 0 97 0 98 0 100 0 106 0 107 0 115 0 116 0 123 0 130]
#[1 4 69 0 62 4 73 0 63 4 77 0 64 4 81 0 65 4 85 0 66 4 89 0 68 4 93 0 69 4 97 0 72 4 101 0 73 4 105 0 74 4 109 0 76 4 113 0 85 4 117 0 86 4 121 0 87 4 125 0 91 1 5 0 130 1 89 0 147 4 129 0 149 9 197 0 168 5 109 1 14 4 141 1 15 4 145 1 16 4 149 1 17 4 153 1 18 4 157 1 19 4 161 1 20 4 165 1 21 4 169 1 22 4 173 1 23 4 177 1 24 4 181 1 25 4 185 1 26]
#[0 9 201 0 7]
#[0 1 142 0 8 0 10 0 16 0 17 0 18 0 19 0 20 0 21 0 24 0 25 0 26 0 28 0 30 0 31 0 34 0 38 0 47 0 49 0 50 0 58 0 71 0 75 0 77 0 78 0 79 0 81 0 82 0 83 0 90 0 93 0 96 0 98 0 105 0 106 0 107 0 115 0 123 0 125 0 126 0 127 0 128 0 129 0 130 1 56]
#[0 2 30 0 49 0 102 0 103]
#[0 1 146 0 8 0 10 0 16 0 17 0 18 0 19 0 20 0 21 0 24 0 25 0 26 0 28 0 30 0 31 0 34 0 38 0 47 0 49 0 50 0 58 0 71 0 75 0 77 0 78 0 79 0 81 0 82 0 83 0 90 0 93 0 96 0 98 0 105 0 106 0 107 0 115 0 123 0 125 0 126 0 127 0 128 0 129 0 130 1 56]
#[1 1 5 0 130 9 205 0 147]
#[0 0 250 0 49]
#[1 1 5 0 130 9 33 0 147 9 209 0 164]
#[1 3 2 0 11 3 2 0 15 7 245 0 59 7 249 0 61]
#[0 9 213 0 1]
#[0 3 10 0 4 0 15]
#[1 4 69 0 62 4 73 0 63 4 77 0 64 4 81 0 65 4 85 0 66 4 89 0 68 4 93 0 69 4 97 0 72 4 101 0 73 4 105 0 74 4 109 0 76 4 113 0 85 4 117 0 86 4 121 0 87 4 125 0 91 1 5 0 130 1 89 0 147 4 129 0 149 9 217 0 168 9 221 1 0 5 109 1 14 4 141 1 15 4 145 1 16 4 149 1 17 4 153 1 18 4 157 1 19 4 161 1 20 4 165 1 21 4 169 1 22 4 173 1 23 4 177 1 24 4 181 1 25 4 185 1 26]
#[0 3 58 0 71 0 112 0 115 0 118 0 130]
#[0 9 225 0 113]
#[1 9 229 0 4 3 14 0 15 3 14 0 49]
#[0 3 86 0 15 0 49]
#[0 3 74 0 71 0 115 0 118 0 130]
#[1 2 178 0 71 9 161 0 115 2 178 0 118 1 5 0 130 9 165 0 147 9 169 0 249 9 233 1 1 9 181 1 3 9 185 1 4]
#[1 9 161 0 115 1 5 0 130 9 237 0 147 9 169 0 249 9 241 1 4]
#[1 9 245 0 15 1 205 0 49 9 249 0 151]
#[1 1 205 0 49 9 253 0 151]
#[0 2 142 0 71 0 110 0 112 0 114 0 115 0 118 0 130]
#[1 10 1 0 1 1 205 0 49 10 5 0 151]
#[1 1 205 0 49 10 9 0 151]
#[0 1 18 0 11 0 15]
#[0 1 10 0 11 0 15]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 10 13 0 148 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 1 37 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[0 3 62 0 3]
#[0 10 17 0 3]
#[1 1 5 0 130 10 21 0 147]
#[0 3 82 0 115 0 130]
#[0 3 78 0 71 0 115 0 118 0 130]
#[0 3 14 0 15 0 49]
#[1 9 245 0 15 1 205 0 49 10 25 0 151]
#[1 9 161 0 115 1 5 0 130 9 237 0 147 10 29 0 249]
#[0 3 70 0 71 0 115 0 118 0 130]
#[0 2 114 0 2 0 5 0 8 0 12 0 14 0 16 0 17 0 18 0 24 0 25 0 28 0 31 0 49 0 51 0 71 0 84 0 93 0 96 0 97 0 98 0 100 0 106 0 107 0 115 0 116 0 123 0 130 1 56]
#[1 0 177 0 10 0 181 0 31 0 185 0 34 0 189 0 38 0 193 0 47 0 197 0 50 0 201 0 75 0 205 0 77 0 209 0 78 0 213 0 79 0 217 0 81 0 221 0 82 0 225 0 83 0 229 0 90 0 233 0 115 0 237 0 123 0 241 0 125 0 245 0 126 0 249 0 127 0 253 0 128 1 1 0 129 1 5 0 130 1 13 0 147 10 33 0 148 1 21 0 201 1 25 0 203 1 29 0 204 1 33 0 205 1 37 1 37 1 41 1 38 1 45 1 39 1 49 1 40 1 53 1 41 1 57 1 42 1 61 1 44 1 65 1 45 1 69 1 46 1 73 1 50]
#[0 2 78 0 104 0 130]
#[0 1 42 0 2 0 5 0 8 0 12 0 14 0 16 0 17 0 18 0 24 0 25 0 28 0 31 0 49 0 51 0 71 0 84 0 93 0 96 0 97 0 98 0 100 0 106 0 107 0 115 0 116 0 123 0 130 1 56]
#[1 1 205 0 49 10 37 0 151]
#[1 1 5 0 130 10 41 0 147]
#[0 10 45 0 108]
#[0 3 66 0 71 0 115 0 118 0 130]
#[0 3 90 0 15 0 49]
#[1 1 205 0 49 10 49 0 151]
#[0 3 38 0 71 0 112 0 114 0 115 0 118 0 130]
#[1 1 205 0 49 10 53 0 151]
#[1 1 5 0 130 10 57 0 147]
#[0 2 82 0 104 0 130]
#[0 3 50 0 71 0 112 0 115 0 118 0 130]
#[0 3 18 0 15 0 49]
)! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:26'!
type: ident underlyingType: underlyingType whereClause: whereClauseOrNil 
	| r | r := OrderedCollection new. r add: #type; add: ident; add: underlyingType; add: whereClauseOrNil. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 10:55'!
typeEntry: aType
	^self buildParserResultWith: aType! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 3/5/2003 15:55'!
typeIdentifier: anIdentifier
	^ anIdentifier! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 9/20/2007 10:10'!
typeMapFrom: aListOfIdent to: anExpression 
	^ self! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 9/20/2007 10:12'!
typeMapTo: anExpression from: aListOfListOfIdent 
	aListOfListOfIdent do: [:i | self typeMapFrom: i to: anExpression]
! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'MrCleaner 1/20/2011 19:54'!
typeMapWhereClause: whereRuleList to: anExpression
	whereRuleList do: [:i | self typeMapWhere: i to: anExpression]! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:27'!
uniqueAttributesList: anIdentifiersCollection head: anIdentOrNil
	| r | r := OrderedCollection new. r add: #uniqueAttributesList; add: anIdentOrNil; add: anIdentifiersCollection . ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:27'!
uniqueClause: aUniqueClause 
	| r | r := OrderedCollection new. r add: #uniqueClause; add: aUniqueClause. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:27'!
whereClause: aWhereClause 
	| r | r := OrderedCollection new. r add: #whereClause; add: aWhereClause. ^ r! !

!PlatypusExpressAbstractParser methodsFor: 'express semantic actions' stamp: 'apl 2/28/2003 11:27'!
whereRule: anExpression head: anIdentOrNil
	| r | r := OrderedCollection new. r add: #whereRule; add: anIdentOrNil; add: anExpression. ^ r! !

PlatypusExpressAbstractParser subclass: #PlatypusExpressParser
	instanceVariableNames: 'contextsStack errorsIndexMap errorMessages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-parsers'!

!PlatypusExpressParser class methodsFor: 'compiling' stamp: 'AlainPlantec 6/14/2012 11:16'!
schemaInstanceFromSource: aSource
	| parsingResult |
	parsingResult := self 
				parseStream: (ReadStream on: aSource)
				startingAt: self startingStateForSchemaInstanceEntry
				owner: PltSchemaInstance new.
	parsingResult metaData resolvesSilently.
	^ parsingResult metaData! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 5/17/2004 15:14'!
abstractSupertypeConstraint: supertypeConstraintOrNil 
	| supertypeConstraint |
	supertypeConstraint := self supertypeConstraint: supertypeConstraintOrNil.
	self currentContext setInstantiable: false.
	^ supertypeConstraint! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 4/18/2006 12:53'!
actionBodyDecl: declarationsOrNil statements: statementsOrNil 
	^ Array with: declarationsOrNil with: statementsOrNil! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:20'!
aggregateInitializer: initList 
	| aggrInit |
	aggrInit := self new: PltAggregateInitializer.
	aggrInit setContents: initList.
	^ aggrInit! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:20'!
aggregateInitializerElement: expression repetition: expressionOrNil 
	| aggrInitElem |
	aggrInitElem := self new: PltAggregateInitializerElement.
	aggrInitElem setVal: expression.
	aggrInitElem setRepetition: expressionOrNil.
	^ aggrInitElem! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:20'!
aggregateType: keyIdentOrNil parameterType: parameterType 
	| type |
	type := self new: PltGeneralAggregateType.
	type setElementType: parameterType.
	keyIdentOrNil notNil
		ifTrue: [type setTypeLabel: keyIdentOrNil].
	^ type! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 4/9/2003 01:33'!
aliasStatement: aliasStatement statements: statements 
	statements notNil ifTrue: [aliasStatement statements addAll: statements].
	self popContext.
	^aliasStatement! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:21'!
aliasStatementVariable: anIdentifier for: assignable 
	| aliasVariable aliasStatement |
	aliasVariable := self new: PltAliasStatementVariable.
	aliasVariable setAliasIdent: anIdentifier.
	aliasVariable setRef: assignable.
	aliasStatement := self new: PltAliasStatement.
	aliasStatement setVariable: aliasVariable.
	aliasVariable setOwner: aliasStatement.
	self pushContext: aliasStatement.
	self registerIdentifier: aliasVariable named: anIdentifier.
	^ aliasStatement! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'AlainPlantec 6/13/2012 13:13'!
arrayType: indexSpecOrNil baseType: baseType optionalOrUnique: arrayOfSymbolsOrNil 
	| type |
	type := self new: PltArrayType.
	type setElementType: baseType.
	indexSpecOrNil
		ifNil: [type setIsGeneralType: self currentContext isPltNamedType not]
		ifNotNil: [type setIsGeneralType: false.
			type setLowerBound: indexSpecOrNil first.
			type setUpperBound: indexSpecOrNil second.
			indexSpecOrNil first ifNotNil: [:is | is owner: type].
			indexSpecOrNil second ifNotNil: [:is | is owner: type]].
	type setOptionalFlag: false.
	type setUniqueFlag: false.
	arrayOfSymbolsOrNil notNil
		ifTrue: [arrayOfSymbolsOrNil
				do: [:s | s == #optional
						ifTrue: [type setOptionalFlag: true]
						ifFalse: [s == #unique
								ifTrue: [type setUniqueFlag: true]]]].
	^ type! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'AlainPlantec 5/20/2012 01:10'!
assignable: aCollection 
	| assignable |
	assignable := self new: PltAssignable.
	assignable setHead: aCollection first.
	assignable setOwner: self currentContext.
	2
		to: aCollection size
		do: [:pos | assignable qualifiers
				add: (aCollection at: pos)].
	^ assignable! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:21'!
assignmentStatement: assignable from: expression 
	| assignment |
	assignment := self new: PltAssignmentStatement.
	assignment setLeft: assignable.
	assignment setRightExpr: expression.
	^ assignment! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 4/29/2008 11:44'!
attributeName: simpleIdent groupRef: aGroupIdentOrNil 
	| attribute redecl |
	attribute := self new: PltAttribute.
	aGroupIdentOrNil
		ifNotNil: [redecl := self new: PltAttributeReference.
			simpleIdent isString
				ifTrue: [attribute
						setRedeclaring: (redecl name: simpleIdent entityRefName: aGroupIdentOrNil)]
				ifFalse: [attribute
						setRedeclaring: (redecl name: simpleIdent ident entityRefName: aGroupIdentOrNil)]].
	attribute setName: simpleIdent.
	attribute setOwner: self currentNamedType.
	^ attribute! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:34'!
attributeQualifier: aQualifier 
	| qualifier |
	qualifier := self new: PltAttributeQualifier.
	qualifier setAttributeName: aQualifier.
	^ qualifier! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'AlainPlantec 6/13/2012 13:14'!
bagType: indexSpecOrNil baseType: baseType 
	| type |
	type := self new: PltBagType.
	type setElementType: baseType.
	type setIsGeneralType: false.
	indexSpecOrNil notNil
		ifTrue: [
			type setLowerBound: indexSpecOrNil first.
			type setUpperBound: indexSpecOrNil second.
			indexSpecOrNil first ifNotNil: [:is | is owner: type].
			indexSpecOrNil second ifNotNil: [:is | is owner: type]].
	^ type! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:34'!
beginSplitmarkStatement: stringExpression 
	| splitmark |
	splitmark := self new: PltSplitmarkStatement.
	splitmark setFilename: stringExpression.
	^ splitmark! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 12/12/2005 21:04'!
beginSplitmarkStatement: stringExpression append: abool
	| splitmark |
	splitmark := self new: PltSplitmarkStatement.
	splitmark setFilename: stringExpression.
	splitmark append: abool.
	^ splitmark! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:34'!
binaryLiteral: aBinary 
	| lit |
	lit := self new: PltBinaryLiteral.
	lit setVal: aBinary.
	^ lit! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:34'!
binaryType: FixedOrNotPrecisionSpecOrNil 
	| type |
	type := self new: PltBinaryType.
	FixedOrNotPrecisionSpecOrNil notNil
		ifTrue: [type setWidth: FixedOrNotPrecisionSpecOrNil first.
			type setFixedWidth: FixedOrNotPrecisionSpecOrNil second].
	^ type! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:35'!
booleanType
	^ self new: PltBooleanType! !

!PlatypusExpressParser methodsFor: 'result building' stamp: 'apl 3/23/2006 14:08'!
buildParserResultWith: aMetaData 
	^ (PlatypusExpressParserResult tokenList: scanner tokenList metaData: aMetaData)
! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 4/18/2006 12:54'!
cardinalityExpressionFrom: expression1 to: expression2 
	^ Array with: expression1 with: expression2! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:35'!
caseAction: expressionsList statement: aStatement 
	| caseAction |
	caseAction := self new: PltCaseAction.
	caseAction labels addAll: expressionsList.
	caseAction setAction: aStatement.
	^ caseAction! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 3/7/2003 15:49'!
caseOtherwise: aStatement 
	^ aStatement! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 3/15/2005 23:48'!
caseStatement: caseSelectorExpression caseActions: caseActionsListOrNil caseOtherwise: caseOtherwiseOrNil 
	| caseStatement |
	caseStatement := self new: PltCaseStatement.
	caseStatement setSelector: caseSelectorExpression.
	caseActionsListOrNil notNil
		ifTrue: [caseActionsListOrNil do: [ :ca | ca owner: caseStatement].
				caseStatement caseActions addAll: caseActionsListOrNil].
	caseStatement setCaseOtherwise: caseOtherwiseOrNil.
	^ caseStatement! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 3/11/2003 19:33'!
compoundStatement: aCompoundStatement statements: statementsListOrNil 
	statementsListOrNil notNil
		ifTrue: [aCompoundStatement statements
				addAll: statementsListOrNil].
	self popContext.
	^ aCompoundStatement! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:35'!
compoundStatementBegin
	| compound |
	compound := self new: PltCompoundStatement.
	self pushContext: compound.
	^ compound! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 3/29/2006 17:20'!
conceptIdentifier: anIdent 
	^ PlatypusExpressParsedMetaConcept ident: anIdent ! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 3/29/2006 17:20'!
conceptIdentifier: anIdent metaExpression: aMetaExpression 
	^ PlatypusExpressParsedMetaConcept ident: anIdent metaExpression: aMetaExpression! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 3/15/2007 10:20'!
constantBody: ident baseType: baseType expression: initExpression 
	| constant |
	constant := self new: PltConstantDefinition.
	constant setOwner: self currentContextDefinition.
	ident updateDictionaryInstanceName: constant.
	constant setDomain: baseType.
	constant setInitializer: initExpression.
	self registerIdentifier: constant named: ident ident.
	^ constant! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 3/5/2003 17:11'!
constantsDecl: constantsBodyCollectionOrNil 
	constantsBodyCollectionOrNil notNil
		ifTrue: [self currentContextDefinition setConstants: constantsBodyCollectionOrNil].
	^ constantsBodyCollectionOrNil! !

!PlatypusExpressParser methodsFor: 'accessing' stamp: 'apl 3/5/2003 10:21'!
contextsStack
	^contextsStack! !

!PlatypusExpressParser methodsFor: 'accessing' stamp: 'apl 2/23/2005 21:44'!
currentAlgorithmDeclaration
	self contextsStack
		reverseDo: [:c | c isPltAlgorithmDeclaration
				ifTrue: [^ c]].
	^ nil! !

!PlatypusExpressParser methodsFor: 'accessing' stamp: 'apl 12/13/2003 16:53'!
currentContext
	^ self contextsStack isEmpty ifFalse: [self contextsStack last]! !

!PlatypusExpressParser methodsFor: 'accessing' stamp: 'apl 2/23/2005 21:48'!
currentContextDefinition
	self contextsStack
		reverseDo: [:c | c isPltContextDefinition
				ifTrue: [^ c]].
	^ nil! !

!PlatypusExpressParser methodsFor: 'accessing' stamp: 'apl 2/23/2005 22:14'!
currentNamedType
	self contextsStack
		reverseDo: [:c | c isPltNamedType
				ifTrue: [^ c]].
	^ nil! !

!PlatypusExpressParser methodsFor: 'accessing' stamp: 'apl 3/15/2007 10:31'!
currentNamedTypeOrContextDefinition
	self contextsStack
		reverseDo: [:cinst | (cinst isPltContextDefinition
					or: [cinst isPltNamedType])
				ifTrue: [^ cinst]].
	^ nil! !

!PlatypusExpressParser methodsFor: 'accessing' stamp: 'apl 2/23/2005 22:31'!
currentSchema
	self contextsStack
		reverseDo: [:c | c isPltSchemaDefinition
				ifTrue: [^ c]].
	^ nil! !

!PlatypusExpressParser methodsFor: 'accessing' stamp: 'apl 2/23/2005 21:53'!
currentUniquenessRuleContainer
	self contextsStack
		reverseDo: [:c | c isPltEntityDefinition
				ifTrue: [^ c]].
	^ nil! !

!PlatypusExpressParser methodsFor: 'accessing' stamp: 'apl 2/23/2005 22:14'!
currentWhereRuleContainer
	self contextsStack
		reverseDo: [:c | (c isPltNamedType
					or: [c isPltGlobalRule])
				ifTrue: [^ c]].
	^ nil! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/11/2003 01:57'!
deriveClause: derivedAttributesList 
	^ derivedAttributesList! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 3/15/2007 10:20'!
derivedAttribute: attribute baseType: baseType expression: expression 
	| derivedAttribute |
	derivedAttribute := self new: PltDerivedAttribute.
	derivedAttribute setRedeclaring: attribute redeclaring.
	derivedAttribute setOwner: attribute owner.
	attribute name updateDictionaryInstanceName: derivedAttribute.
	self registerIdentifier: derivedAttribute named: derivedAttribute name.
	derivedAttribute setAssign: expression.
	derivedAttribute setDomain: baseType.
	^ derivedAttribute! !

!PlatypusExpressParser methodsFor: 'initialize-release' stamp: 'apl 6/3/2005 16:48'!
destroy
	contextsStack := nil.
	errorsIndexMap := nil.
	errorMessages := nil.
	super destroy! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:35'!
eConstant
	| lit |
	lit := self new: PltEConstant.
	lit setVal: 2.71828.
	^ lit! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:36'!
elementQualifier: anExpression 
	| qualifier |
	qualifier := self new: PltElementQualifier.
	qualifier setIndex: anExpression.
	^ qualifier! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:36'!
encodedStringLiteral: anEncodedString 
	| lit |
	lit := self new: PltBinaryLiteral.
	lit setVal: anEncodedString.
	^ lit! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:36'!
endSplitmarkStatement
	| splitmark |
	splitmark := self new: PltEndSplitmarkStatement.
	^ splitmark! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 5/25/2004 08:38'!
entity: entity subSuper: anArrayOrNil explicitAttributes: explicitAttrListOrNil deriveClause: derivedClauseOrNil inverseClause: inverseClauseOrNil uniqueClause: uniqueClauseOrNil whereClause: whereClauseOrNil 
	entity owner notNil
		ifTrue: [entity owner entities add: entity].
	explicitAttrListOrNil notNil
		ifTrue: [explicitAttrListOrNil
				do: [:attrs | entity attributes addAll: attrs]].
	derivedClauseOrNil notNil
		ifTrue: [derivedClauseOrNil
				do: [:attrs | entity attributes add: attrs]].
	inverseClauseOrNil notNil
		ifTrue: [inverseClauseOrNil
				do: [:attrs | entity attributes add: attrs]].
	uniqueClauseOrNil notNil
		ifTrue: [entity setUniquenessRules: uniqueClauseOrNil].
	whereClauseOrNil notNil
		ifTrue: [entity setWhereRules: whereClauseOrNil].
	entity attributes
		do: [:a | a setOwner: entity].
	entity uniquenessRules
		do: [:a | a setOwner: entity].
	self popContext.
	^ entity! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 3/15/2007 10:20'!
entityIdentifier: anIdentifier 
	| entity |
	entity := self new: PltEntityDefinition.
	self setScannerTokenMetaData: entity.
	entity setOwner: self currentContextDefinition.
	anIdentifier updateDictionaryInstanceName: entity.
	entity setInstantiable: true.
	self registerNamedType: entity named: anIdentifier ident.
	self pushContext: entity.
	self registerIdentifier: entity named: 'SELF'.
	^ entity! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'AlainPlantec 1/28/2011 11:44'!
entityReferenceType: anIdentifier 
	| type |
	type := self new: PltEntityDefinitionReference.
	type owner: self currentNamedTypeOrContextDefinition.
	anIdentifier updateDictionaryInstanceName: type.
	^ type! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 4/18/2006 12:54'!
entitySupertype: supertypeConstraintOrNil subtype: subtypeDeclarationOrNil 
	| entity |
	(entity := self currentNamedType)
		ifNotNil: [entity setSupertypeConstraint: supertypeConstraintOrNil.
			subtypeDeclarationOrNil
				ifNotNil: [entity setSupertypes: subtypeDeclarationOrNil]].
	^ Array with: supertypeConstraintOrNil with: subtypeDeclarationOrNil! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:36'!
enumerationType: identList 
	| type |
	type := self new: PltEnumerationType.
	type setElements: identList.
	type owner: self currentNamedType.
	^ type! !

!PlatypusExpressParser methodsFor: 'accessing' stamp: 'apl 3/6/2003 15:50'!
errorIndexOf: aSymbol
	^ self errorsIndexMap at: aSymbol ifAbsent: [0]! !

!PlatypusExpressParser methodsFor: 'accessing' stamp: 'apl 3/6/2003 15:56'!
errorTable
	^ errorMessages! !

!PlatypusExpressParser methodsFor: 'accessing' stamp: 'apl 3/6/2003 15:51'!
errorsIndexMap
	^ errorsIndexMap! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:36'!
escapeStatement
	| escape |
	escape := self new: PltEscapeStatement.
	^ escape! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 4/13/2006 12:06'!
escapedExpression: anExpression 
	| expr |
	expr := self new: PltEscapedExpression.
	expr expr: anExpression.
	^ expr! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 3/15/2007 10:20'!
explicitAttributes: attributes baseType: baseType optional: isOptional 
	| attribute |
	^ attributes collect: 
			[:a | 
			attribute := self new: PltExplicitAttribute.
			attribute setOwner: a owner.
			attribute setRedeclaring: a redeclaring.
			a name updateDictionaryInstanceName: attribute.
			self registerIdentifier: attribute named: attribute name.
			attribute setOptionalFlag: isOptional.
			attribute setDomain: baseType.
			attribute]! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:36'!
explicitlyImportedItem: name renamedAs: localName 
	| item |
	item := self new: PltDomainEquivalentItem.
	item setName: name.
	item setExternalItemId: localName.
	^ item! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 3/5/2003 10:05'!
explicitlyImportedItems: aCollectionOfDomainEquivalentItems 
	^ aCollectionOfDomainEquivalentItems ! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:36'!
expression: op1 and: op2 
	| expr |
	expr := self new: PltAndExpression.
	expr setLeftExpr: op1.
	expr setRightExpr: op2.
	^ expr! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:37'!
expression: exp1 cardinality: op expression: exp2 
	| expression |
	expression := self new: PltCardinalityExpression.
	expression setLeftExpr: exp1.
	expression setRightExpr: exp2.
	expression setCard1: op first.
	expression setCard2: op second.
	^ expression! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:37'!
expression: op1 div: op2 
	| expr |
	expr := self new: PltDivExpression.
	expr setLeftExpr: op1.
	expr setRightExpr: op2.
	^ expr! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:37'!
expression: op1 equal: op2 
	| expr |
	expr := self new: PltEqualExpression.
	expr setLeftExpr: op1.
	expr setRightExpr: op2.
	^ expr! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:37'!
expression: op1 expo: op2 
	| expr |
	expr := self new: PltExpoExpression.
	expr setLeftExpr: op1.
	expr setRightExpr: op2.
	^ expr! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:37'!
expression: op1 greaterThan: op2 
	| expr |
	expr := self new: PltGreaterThanExpression.
	expr setLeftExpr: op1.
	expr setRightExpr: op2.
	^ expr! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:39'!
expression: op1 greaterThanOrEqual: op2 
	| expr |
	expr := self new: PltGreaterEqualExpression.
	expr setLeftExpr: op1.
	expr setRightExpr: op2.
	^ expr! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:39'!
expression: op1 in: op2 
	| expr |
	expr := self new: PltInExpression.
	expr setLeftExpr: op1.
	expr setRightExpr: op2.
	^ expr! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:39'!
expression: op1 instConst: op2 
	| expr |
	expr := self new: PltInstanceConstructionExpression.
	expr setLeftExpr: op1.
	expr setRightExpr: op2.
	^ expr! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:39'!
expression: op1 instEqual: op2 
	| expr |
	expr := self new: PltInstEqualExpression.
	expr setLeftExpr: op1.
	expr setRightExpr: op2.
	^ expr! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:39'!
expression: op1 instNotEqual: op2 
	| expr |
	expr := self new: PltInstNotEqualExpression.
	expr setLeftExpr: op1.
	expr setRightExpr: op2.
	^ expr! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:39'!
expression: op1 lessThan: op2 
	| expr |
	expr := self new: PltLessThanExpression.
	expr setLeftExpr: op1.
	expr setRightExpr: op2.
	^ expr! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:39'!
expression: op1 lessThanOrEqual: op2 
	| expr |
	expr := self new: PltLessEqualExpression.
	expr setLeftExpr: op1.
	expr setRightExpr: op2.
	^ expr! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:40'!
expression: op1 like: op2 
	| expr |
	expr := self new: PltLikeExpression.
	expr setLeftExpr: op1.
	expr setRightExpr: op2.
	^ expr! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:40'!
expression: op1 minus: op2 
	| expr |
	expr := self new: PltMinusExpression.
	expr setLeftExpr: op1.
	expr setRightExpr: op2.
	^ expr! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:40'!
expression: op1 mod: op2 
	| expr |
	expr := self new: PltModExpression.
	expr setLeftExpr: op1.
	expr setRightExpr: op2.
	^ expr! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:40'!
expression: op1 mult: op2 
	| expr |
	expr := self new: PltMultExpression.
	expr setLeftExpr: op1.
	expr setRightExpr: op2.
	^ expr! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:40'!
expression: op1 notEqual: op2 
	| expr |
	expr := self new: PltNotEqualExpression.
	expr setLeftExpr: op1.
	expr setRightExpr: op2.
	^ expr! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:40'!
expression: op1 or: op2 
	| expr |
	expr := self new: PltOrExpression.
	expr setLeftExpr: op1.
	expr setRightExpr: op2.
	^ expr! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:40'!
expression: op1 plus: op2 
	| expr |
	expr := self new: PltPlusExpression.
	expr setLeftExpr: op1.
	expr setRightExpr: op2.
	^ expr! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:40'!
expression: op1 realDiv: op2 
	| expr |
	expr := self new: PltRealDivExpression.
	expr setLeftExpr: op1.
	expr setRightExpr: op2.
	^ expr! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:41'!
expression: op1 xor: op2 
	| expr |
	expr := self new: PltXorExpression.
	expr setLeftExpr: op1.
	expr setRightExpr: op2.
	^ expr! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 3/10/2003 23:20'!
expressionBetweenParenthesis: expression 
	expression setParenthesis: true.
	^expression! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 3/25/2006 11:07'!
externalMetaSchema: schemaIdent 
	| interface |
	interface := self new: PltExternalMetaSchema.
	interface setName: schemaIdent.
	interface setOwner: self currentSchema.
	^ interface! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 2/24/2006 11:29'!
formalParameter: identList parameterType: type var: varOrNotBoolean 
	| parameter |
	^identList collect: 
			[:ident | 
			parameter := self new: PltParameterDefinition.
			parameter setByCopy: varOrNotBoolean not.
			parameter setName: ident.
			parameter setDomain: type.
			self registerIdentifier: parameter named: ident.
			parameter setOwner: self currentContextDefinition.
			parameter]! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 3/10/2003 12:32'!
formalParametersList: aCollectionOfCollections 
	aCollectionOfCollections
		do: [:col | self currentAlgorithmDeclaration formalParameters addAll: col].
	^ self currentAlgorithmDeclaration formalParameters! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 3/11/2003 19:31'!
function: function formalParametersDecl: parametersListOrNil returnType: returnType actionBody: actionBody 
	function owner notNil
		ifTrue: [function owner algorithmes add: function].
	actionBody second notNil
		ifTrue: [function statements addAll: actionBody second].
	function setReturnType: returnType.
	self popContext.
	^ function! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 3/15/2007 10:20'!
functionIdentifier: anIdentifier 
	| function |
	function := self new: PltFunctionDeclaration.
	function setOwner: self currentContextDefinition.
	anIdentifier updateDictionaryInstanceName: function.
	self setScannerTokenMetaData: function.
	self registerIdentifier: function named: anIdentifier ident.
	self pushContext: function.
	^ function! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:41'!
genericType: keyIdentOrNil 
	| type |
	type := self new: PltGenericType.
	type setTypeLabel: keyIdentOrNil.
	^ type! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:41'!
groupRef: groupIdent 
	| groupRef |
	groupRef := self new: PltGroupQualifier.
	groupRef setGroupName: groupIdent.
	^ groupRef! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'AlainPlantec 5/20/2012 00:30'!
identifier: aString 
	| ident identClass |
	self currentContext
		ifNotNil: [:cc |
			aString asUppercase = 'SELF'
				ifTrue: [identClass := PltSelfIdentifier]
				ifFalse: [identClass := PltIdentifier].
			ident := self new: identClass.
			ident owner: cc.
			ident setName: aString].
	^ ident! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 4/13/2006 09:22'!
identifier: aString arguments: arguments 
	| ident |
	ident := self identifier: aString.
	ident parameters: arguments.
	^ ident! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:41'!
ifStatement: cond then: thenStatementOrNil else: elseStatementOrNil 
	| ifStatement |
	ifStatement := self new: PltIfStatement.
	ifStatement setSelector: cond.
	thenStatementOrNil notNil
		ifTrue: [ifStatement thenStatements addAll: thenStatementOrNil].
	elseStatementOrNil notNil
		ifTrue: [ifStatement setElseStatements: elseStatementOrNil].
	^ ifStatement! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:42'!
incrementControl: ident first: firstValueExpression last: lastValueExpression step: byExpressionOrNil 
	| incrementControlVariable incrementControl |
	incrementControlVariable := self new: PltIncrementControlVariable.
	incrementControlVariable setVariableId: ident.
	incrementControl := self new: PltIncrementControl.
	incrementControl setVariable: incrementControlVariable.
	incrementControlVariable setOwner: incrementControl.
	incrementControl setFirst: firstValueExpression.
	incrementControl setLast: lastValueExpression.
	incrementControl setStep: byExpressionOrNil.
	self pushContext: incrementControl.
	self registerIdentifier: incrementControlVariable named: ident.
	^ incrementControl! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 4/18/2006 12:41'!
indexSpecFrom: lowIndex to: hiIndex 
	^ Array with: lowIndex asBound with: hiIndex asBound! !

!PlatypusExpressParser methodsFor: 'initialize-release' stamp: 'apl 2/17/2006 13:36'!
initialize
	super initialize.
	contextsStack := OrderedCollection new.
	self initializeErrors! !

!PlatypusExpressParser methodsFor: 'initialize-release' stamp: 'AlainPlantec 10/7/2010 15:53'!
initializeErrors
	errorsIndexMap := Dictionary new.
	errorMessages := OrderedCollection new.
	#(#(#BadInverseAttributeDomain '<< Inverse attribute domain must be a Set, a Bag of Entity or an Entity') #(#SupertypeHierarchyCycle 'Cycle in supertype hierarchy') #(#DefinedTypeDomainCycle 'Cycle in domain path') #(#NamingConflict 'Name already used in this context') )
		do: [:couple | 
			errorMessages add: couple second.
			errorsIndexMap at: couple first put: errorMessages size]! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:42'!
integerLiteral: anInteger 
	| lit |
	lit := self new: PltIntegerLiteral.
	lit setVal: anInteger.
	^ lit! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:42'!
integerType: precisionSpecOrNil 
	| type |
	type := self new: PltIntegerType.
	precisionSpecOrNil notNil
		ifTrue: [type setPrecision: precisionSpecOrNil].
	^ type! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 3/25/2006 11:05'!
interfaceSpecification: useOrRefSymbol schema: schemaIdent interfaceList: interfacesListOrNil 
	| interface |
		useOrRefSymbol = #USED
				ifTrue: [interface := self new: PltUsedSchema]
				ifFalse: [interface := self new: PltReferencedSchema].
			interface setExplicitlyImportedItems: interfacesListOrNil.
	interface setName: schemaIdent.
	interface setOwner: self currentSchema.
	^ interface! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:42'!
intervalExpression: expression1 op: lessThanOrLessEqualSymbol1 expression: expression2 op: lessThanOrLessEqualSymbol2 expression: expression3 
	| lexpr1 lexpr2 and interval |
	lessThanOrLessEqualSymbol1 == #<
		ifTrue: [lexpr1 := self expression: expression1 lessThan: expression2]
		ifFalse: [lexpr1 := self expression: expression1 lessThanOrEqual: expression2].
	lessThanOrLessEqualSymbol2 == #<
		ifTrue: [lexpr2 := self expression: expression2 lessThan: expression3]
		ifFalse: [lexpr2 := self expression: expression2 lessThanOrEqual: expression3].
	and := self expression: lexpr1 and: lexpr2.
	interval := self new: PltInterval.
	interval setExpr: and.
	^ interval! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'AlainPlantec 6/13/2012 13:02'!
inverseAttribute: attribute baseType: domain for: attrIdent 
	| unresolvedInverse minbound maxbound unresolvedDomain aref |
	unresolvedInverse := self new: PltInverseAttribute.
	unresolvedInverse setOwner: attribute owner.
	attribute name updateDictionaryInstanceName: unresolvedInverse.
	unresolvedInverse setRedeclaring: attribute redeclaring.
	self registerIdentifier: unresolvedInverse named: unresolvedInverse name.
	domain isPltAggregationType 
		ifTrue: 
			[unresolvedInverse setDomain: domain elementType.
			minbound := domain lowerBound.
			minbound isNil 
				ifTrue: 
					[minbound := self new: PltIntegerBound.
					minbound owner: domain.
					minbound setBoundValue: 0].
			maxbound := domain upperBound.
			maxbound ifNotNil: [maxbound owner: domain].
			domain isPltSetType 
				ifTrue: [unresolvedInverse setDuplicates: false]
				ifFalse: [unresolvedInverse setDuplicates: true].
			unresolvedInverse setMinCardinality: minbound.
			unresolvedInverse setMaxCardinality: maxbound.
			unresolvedDomain := domain elementType]
		ifFalse: 
			[unresolvedInverse setDomain: domain.
			unresolvedDomain := domain].
	aref := self new: PltAttributeReference.
	aref owner: unresolvedInverse.
	aref name: attrIdent entityRefName: unresolvedDomain name.
	unresolvedInverse setInvertedAttr: aref.
	^ unresolvedInverse! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 3/6/2003 15:36'!
inverseClause: inverseAttributesList 
	^ inverseAttributesList! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'AlainPlantec 6/13/2012 13:12'!
listType: indexSpecOrNil baseType: baseType unique: uniqueOrNil 
	| type |
	type := self new: PltListType.
	type setElementType: baseType.
	type setIsGeneralType: false.
	indexSpecOrNil notNil
		ifTrue: [
			type setLowerBound: indexSpecOrNil first.
			type setUpperBound: indexSpecOrNil second.
			indexSpecOrNil first ifNotNil: [:is | is owner: type].
			indexSpecOrNil second ifNotNil: [:is | is owner: type]].
	uniqueOrNil notNil
		ifTrue: [type setUniqueFlag: true]
		ifFalse: [type setUniqueFlag: false].
	^ type! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 2/24/2006 11:27'!
localBody: identsList baseType: baseType initializer: expressionOrNil 
	| local |
	^ identsList
		collect: [:ident | 
			local := self new: PltLocalVariable.
			local setName: ident.
			local setDomain: baseType.
			local setInitializer: expressionOrNil.
			self currentContextDefinition locals add: local.
			local setOwner:  self currentContextDefinition.
			self registerIdentifier: local named: ident.
			local]! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 3/7/2003 11:11'!
localDecl: declarationsOrNil 
	^ declarationsOrNil! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'AlainPlantec 7/14/2011 16:57'!
logicalLiteral: trueFalseOrUnknown 
	#(#(#true #PltTrueConstant) #(#false #PltFalseConstant) #(#unknown #PltUnknownConstant) )
		do: [:couple | trueFalseOrUnknown == couple first
				ifTrue: [^ (PlatypusPharoSmalltalk at: couple second) new]]! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:44'!
logicalType
	^ self new: PltLogicalType! !

!PlatypusExpressParser methodsFor: 'accessing' stamp: 'apl 7/18/2003 12:06'!
lookUpIdentifierBN: anIdentifier 
	^ self currentContext lookUpIdentifierBN: anIdentifier! !

!PlatypusExpressParser methodsFor: 'accessing' stamp: 'apl 7/18/2003 12:06'!
lookUpNamedTypeBN: anIdentifier 
	^ self currentContext lookUpNamedTypeBN: anIdentifier ! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 3/17/2006 10:14'!
metaEntitySpec: anIdentifier namedParameters: parametersOrNil 
	^ Association key: anIdentifier value: parametersOrNil! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 3/17/2006 10:37'!
metaEntitySpec: anIdentifier parameters: parametersOrNil 
	^ Association key: anIdentifier value: parametersOrNil! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:44'!
missingValue: isARedefine 
	^ self new: PltMissingValue! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 3/15/2007 10:34'!
namedType: anIdentifier 
	| type |
	type := self new: PltNamedTypeReference.
	type owner: self currentNamedTypeOrContextDefinition.
	anIdentifier updateDictionaryInstanceName: type.
	^ type! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 2/18/2006 14:20'!
nativeAlgorithm: nativeAlgorithmList 
	| stmt |
	stmt := self new: PltNativeAlgorithm.
	nativeAlgorithmList
		do: [:na | stmt buildNativeCodesFromString: na value lexicalElement].
	^ stmt! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 2/17/2006 08:48'!
nativeExpression: nativeAlgo 
	| expr |
	expr := self new: PltNativeExpression.
	expr source: nativeAlgo.
	^ expr! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 2/10/2006 11:25'!
nativeStatement: nativeAlgo 
	| stmt |
	stmt := self new: PltNativeStatement.
	stmt source: nativeAlgo.
	^ stmt! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:44'!
negativeExpression: expression 
	| expr |
	expr := self new: PltNegativeExpression.
	expr setExpr: expression.
	^ expr! !

!PlatypusExpressParser methodsFor: 'result building' stamp: 'AlainPlantec 1/21/2011 12:11'!
new: aClass 
	| new |
	new := aClass new stepInitialize.
	^ new! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:44'!
not: expression 
	| expr |
	expr := self new: PltNotExpression.
	expr setExpr: expression.
	^ expr! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 2/21/2006 11:39'!
nullStatement
	^ self new: PltNullStatement! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:44'!
numberType
	^ self new: PltNumberType! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:44'!
outputStatement: expression 
	| output |
	output := self new: PltOutputStatement.
	output setOutput: expression.
	^ output! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:44'!
piConstant
	| lit |
	lit := self new: PltPiConstant.
	lit setVal: 3.14159.
	^ lit! !

!PlatypusExpressParser methodsFor: 'accessing' stamp: 'apl 5/17/2004 11:59'!
popContext
	| last |
	last := self contextsStack last.
	self contextsStack removeLast.
	^ last! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:45'!
positiveExpression: expression 
	| expr |
	expr := self new: PltPositiveExpression.
	expr setExpr: expression.
	^ expr! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 3/5/2003 11:53'!
precisionSpec: anExpression 
	^ anExpression asBound! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 3/11/2003 19:31'!
procedure: procedure formalParametersDecl: parametersListOrNil actionBody: actionBody 
	procedure owner notNil
		ifTrue: [procedure owner algorithmes add: procedure].
	actionBody second notNil
		ifTrue: [procedure statements addAll: actionBody second].
	self popContext.
	^ procedure! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 2/23/2006 23:59'!
procedureCall: ident 
	| proc |
	proc := self new: PltProcedureCallStatement.
	proc setCall: ident.
	^ proc
! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 3/15/2007 10:20'!
procedureIdentifier: anIdentifier 
	| procedure |
	procedure := self new: PltProcedureDeclaration.
	self setScannerTokenMetaData: procedure.
	procedure setOwner: self currentContextDefinition.
	anIdentifier updateDictionaryInstanceName: procedure.
	self registerIdentifier: procedure named: anIdentifier ident.
	self pushContext: procedure.
	^ procedure! !

!PlatypusExpressParser methodsFor: 'accessing' stamp: 'apl 5/17/2004 09:37'!
pushContext: aPltDictionaryInstance
	self contextsStack add: aPltDictionaryInstance! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:45'!
qualifiedExpression: expression qualifiers: qualifiersList 
	| expr |
	expr := self new: PltQualifiedExpression.
	expr setHead: expression.
	expr setQualifiers: qualifiersList.
	^ expr! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/23/2004 20:29'!
queryExpression: queryExpression source: sourceExpression suchThat: suchThatExpression 
	queryExpression setAggregateSource: sourceExpression.
	queryExpression setSuchThat: suchThatExpression.
	self popContext.
	^ queryExpression! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:45'!
queryVariable: ident 
	| queryVariable queryExpression |
	queryVariable := self new: PltQueryVariable.
	queryVariable setVariableId: ident.
	queryExpression := self new: PltQueryExpression.
	queryExpression setVariable: queryVariable.
	queryVariable setOwner: queryExpression.
	self pushContext: queryExpression.
	self registerIdentifier: queryVariable named: ident.
	^ queryExpression! !

!PlatypusExpressParser methodsFor: 'private-error handling' stamp: 'apl 3/6/2003 16:01'!
raiseError: aSymbol 
	^ self reportError: (self errorIndexOf: aSymbol)! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:45'!
rangeQualifierFrom: lowExpression to: highExpression 
	| range |
	range := self new: PltRangeQualifier.
	range setIndex1: lowExpression.
	range setIndex2: highExpression.
	^ range! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:45'!
realLiteral: aReal 
	| lit |
	lit := self new: PltRealLiteral.
	lit setVal: aReal.
	^ lit! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:45'!
realType: precisionSpecOrNil 
	| type |
	type := self new: PltRealType.
	precisionSpecOrNil notNil
		ifTrue: [type setRadix: precisionSpecOrNil].
	^ type! !

!PlatypusExpressParser methodsFor: 'accessing' stamp: 'apl 7/26/2004 21:11'!
registerIdentifier: aData named: anIdentifier 
	self currentContext insertIntoIdentifiersCache: aData named: anIdentifier.
! !

!PlatypusExpressParser methodsFor: 'accessing' stamp: 'apl 7/26/2004 21:12'!
registerNamedType: aData named: anIdentifier 
	self currentContext insertIntoNamedTypeCache: aData named: anIdentifier.
! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 3/15/2007 10:32'!
remarkReference: aRemarkToken 
	| remarkRef rem keys idents iref ctxt |
	rem := aRemarkToken lexicalElement.
	keys := rem findBetweenSubStrs: #($" $< $> ).
	keys size > 1
		ifTrue: [idents := keys first findBetweenSubStrs: #($. ).
			idents notEmpty
				ifTrue: [remarkRef := self new: PltRemarkReference.
					remarkRef setRemark: aRemarkToken asPltRemark.
					remarkRef setPrefix: idents first.
					idents size > 1
						ifTrue: [remarkRef setSuffix: idents second].
					iref := self new: PltDictionaryInstanceReference.
					iref name: (ctxt := self currentNamedTypeOrContextDefinition) name.
					iref ref: ctxt.
					remarkRef setInside: iref.
					self currentSchema remarkReferences add: remarkRef.
					^ remarkRef]].
	^ nil! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:46'!
repeatStatement: incrementControlOrNil whileControl: whileExpressionOrNil untilControl: untilExpressionOrNil statements: statementsListOrNil 
	| repeat |
	repeat := self new: PltRepeatStatement.
	statementsListOrNil notNil
		ifTrue: [repeat statements addAll: statementsListOrNil].
	incrementControlOrNil notNil
		ifTrue: [repeat setIncrControl: incrementControlOrNil.
			incrementControlOrNil setOwner: repeat].
	whileExpressionOrNil notNil
		ifTrue: [repeat setWhileControl: whileExpressionOrNil].
	untilExpressionOrNil notNil
		ifTrue: [repeat setUntilControl: untilExpressionOrNil].
	incrementControlOrNil notNil
		ifTrue: [self popContext].
	^ repeat! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:46'!
returnStatement: expressionOrNil 
	| return |
	return := self new: PltReturnStatement.
	return setReturned: expressionOrNil.
	^ return! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'AlainPlantec 1/28/2011 11:44'!
rule: rule entities: fromEntitiesList actionBody: actionBody whereClause: whereClause 
	| instancesSet |
	rule
		setForEntities: (fromEntitiesList
				collect: [:s | 
					instancesSet := self new: PltEntityInstancesSet.
					instancesSet
						setEntityRef: (self entityReferenceType: s).
					instancesSet]).
	rule forEntities
		do: [:fe | self registerIdentifier: fe named: fe entityRef name].
	rule owner notNil
		ifTrue: [rule owner globalRules add: rule].
	rule whereRules addAll: whereClause.
	actionBody second notNil
		ifTrue: [rule statements addAll: actionBody second].
	self popContext.
	^ rule! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 3/15/2007 10:20'!
ruleIdentifier: anIdentifier 
	| rule |
	rule := self new: PltGlobalRule.
	rule setOwner: self currentSchema.
	self setScannerTokenMetaData: rule.
	anIdentifier updateDictionaryInstanceName: rule.
	self pushContext: rule.
	^ rule! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 3/22/2006 18:04'!
schema: schema interfaces: interfacesCollectionOrNil blocks: blocksCollectionOrNil 
	schema setInterface: interfacesCollectionOrNil.
	schema owner addElement: schema.
	self popContext.
	^ schema! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 3/15/2007 10:20'!
schemaIdentifier: anIdentifier 
	| schema |
	schema := self new: PltSchemaDefinition.
	self setScannerTokenMetaData: schema.
	schema setOwner: self schemaInstance.
	anIdentifier updateDictionaryInstanceName: schema.
	self pushContext: schema.
	^ schema! !

!PlatypusExpressParser methodsFor: 'accessing' stamp: 'apl 3/15/2006 20:07'!
schemaInstance
	self contextsStack
		reverseDo: [:c | c isPltSchemaInstance
				ifTrue: [^ c]].
	^ nil! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 3/29/2006 14:11'!
schemaInstance: aCollectionOfSchemaParseResults 
	^ self schemaInstance
! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:46'!
selectType: identifiersList 
	| type |
	type := self new: PltSelectType.
	type
		setSelections: (identifiersList
				collect: [:s | self namedType: s]).
	type owner: self currentNamedType.
	^ type! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 9/25/2006 13:33'!
selfIdentifier
	
	^ self currentNamedType ifNil: [PltSelfIdentifier new] ifNotNil: [self currentNamedType asSelfIdentifier]! !

!PlatypusExpressParser methodsFor: 'result building' stamp: 'apl 3/30/2006 09:17'!
setScannerTokenMetaData: aMetaData 
	| token |
	(token := scanner tokenList previousPrimaryElementOpenKeywordFrom: scanner tokenList last)
	ifNotNil: [token metaData: aMetaData]! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'AlainPlantec 6/13/2012 13:14'!
setType: indexSpecOrNil baseType: baseType 
	| type |
	type := self new: PltSetType.
	type setElementType: baseType.
	type setIsGeneralType: false.
	indexSpecOrNil notNil
		ifTrue: [
			type setLowerBound: indexSpecOrNil first.
			type setUpperBound: indexSpecOrNil second.
			indexSpecOrNil first ifNotNil: [:is | is owner: type].
			indexSpecOrNil second ifNotNil: [:is | is owner: type]].
	^ type! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:46'!
skipStatement
	^ self new: PltSkipStatement! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:46'!
stringLiteral: aString 
	| lit |
	lit := self new: PltStringLiteral.
	lit
		setVal: ((aString copyFrom: 2 to: aString size - 1)
				copyReplaceAll: ''''''
				with: '''').
	^ lit! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 21:47'!
stringType: FixedOrNotPrecisionSpecOrNil 
	| type |
	type := self new: PltStringType.
	FixedOrNotPrecisionSpecOrNil notNil
		ifTrue: [type setWidth: FixedOrNotPrecisionSpecOrNil first.
			type setFixedWidth: FixedOrNotPrecisionSpecOrNil second].
	^ type! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/18/2003 14:02'!
subtypeDeclaration: anIdentifiersList 
	^ anIdentifiersList
! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/19/2003 00:01'!
subtypeIdentifier: anIdentifier 
	| |
	^ self namedType: anIdentifier.
! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 3/15/2007 10:45'!
supertypeConstraint: supertypeExpressionOrNil 
	| supertypeConstraint eref |
	supertypeConstraint := self new: PltSupertypeConstraint.
	eref := (self new: PltEntityDefinitionReference)
				name: self currentContext name.
	eref  owner: self currentNamedTypeOrContextDefinition.
	supertypeConstraint setConstrained: eref.
	self currentContext setInstantiable: true.
	supertypeConstraint setExpr: supertypeExpressionOrNil.
	^ supertypeConstraint! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 22:01'!
supertypeEntityReference: anIdentifier 
	| subEntityRef |
	subEntityRef := self new: PltSubEntityRefExpression.
	subEntityRef
		entityRef: (self namedType: anIdentifier).
	^ subEntityRef! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 22:01'!
supertypeExpression: supertypeExpression1 and: supertypeExpression2 
	| andSupertype |
	andSupertype := self new: PltAndSupertype.
	andSupertype setLeftExpr: supertypeExpression1.
	andSupertype setRightExpr: supertypeExpression2.
	^ andSupertype! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 22:01'!
supertypeExpression: supertypeExpression1 andor: supertypeExpression2 
	| andSupertype |
	andSupertype := self new: PltAndorSupertype.
	andSupertype setLeftExpr: supertypeExpression1.
	andSupertype setRightExpr: supertypeExpression2.
	^ andSupertype! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 22:01'!
supertypeOneofExpression: identifiersList 
	| oneofSupertypeExpression |
	oneofSupertypeExpression := self new: PltOneofSupertypeExpression.
	oneofSupertypeExpression setExprList: identifiersList.
	^ oneofSupertypeExpression! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 3/15/2007 10:35'!
type: aDefinedType underlyingType: underlyingType whereClause: whereClauseOrNil 
	| enumVal |
	aDefinedType setDomain: underlyingType.
	aDefinedType setWhereRules: whereClauseOrNil.
	aDefinedType owner notNil
		ifTrue: [aDefinedType owner types add: aDefinedType].
	self popContext.
	underlyingType isPltEnumerationType
		ifTrue: [underlyingType elements
				do: [:el | 
					enumVal := PltEnumerationValue
								domain: (PltDefinedTypeReference ref: aDefinedType)
								element: el.
					enumVal domain owner: self currentNamedTypeOrContextDefinition.

					self registerIdentifier: enumVal named: el asUppercase]].
	^ aDefinedType! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 3/15/2007 10:20'!
typeIdentifier: anIdentifier 
	| type |
	type := self new: PltDefinedType.
	self setScannerTokenMetaData: type.
	type setOwner: self currentContextDefinition.
	anIdentifier updateDictionaryInstanceName: type.
	self registerNamedType: type named: anIdentifier ident.
	self pushContext: type.
	self registerIdentifier: type named: 'SELF'.
	^ type! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'MrCleaner 1/20/2011 20:02'!
typeMapFrom: aListOfIdent to: anExpression 
	| sch |
	(sch := self currentSchema) isNil
		ifFalse: [
			sch
				addTypeMap: (PltMetaMappingDefinition definitionPath: aListOfIdent metaExpression: anExpression)]! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'MrCleaner 1/20/2011 21:23'!
typeMapWhere: aWhereRule to: anExpression
	| sch |
	(sch := self currentSchema) isNil
		ifFalse: [
			sch
				addTypeMap: (PltMetaMappingRule typeMapWhere: aWhereRule whereValue  to: anExpression)]! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 22:01'!
uniqueAttributesList: anIdentifiersCollection head: anIdentOrNil 
	| uniquenessRule ref |
	uniquenessRule := self new: PltUniquenessRule.
	uniquenessRule
		setAttributes: (anIdentifiersCollection
				collect: [:attr | 
					ref := self new: PltUniquenessRuleAttributeIdentifier.
					ref fastSetParameters: nil.
					ref setName: attr name.
					ref
						setGroupRefName: (attr redeclaring
								ifNotNil: [attr redeclaring entityRef name]).
					ref]).
	uniquenessRule setLabel: anIdentOrNil.
	uniquenessRule setOwner: self currentUniquenessRuleContainer.
	^ uniquenessRule! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 3/5/2003 16:55'!
uniqueClause: UniqueRules 
	^ UniqueRules! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 3/5/2003 16:53'!
whereClause: whereRules 
	^ whereRules! !

!PlatypusExpressParser methodsFor: 'express semantic actions' stamp: 'apl 7/26/2004 22:02'!
whereRule: anExpression head: anIdentOrNil 
	| rule |
	rule := self new: PltWhereRule.
	rule setLabel: anIdentOrNil.
	rule setWhereValue: anExpression.
	rule setOwner: self currentWhereRuleContainer.
	^ rule! !

PlatypusExpressParser subclass: #PlatypusExpressPrimitiveParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-parsers'!

SmaCCParser subclass: #PlatypusExpressBuiltinFormatParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-parsers'!

!PlatypusExpressBuiltinFormatParser class methodsFor: 'generated-comments' stamp: 'apl 12/12/2005 12:03'!
parserDefinitionComment

	"
Rep
: SymbolRep { PlatypusExpressBuiltinFormatSymbolicFormatter sourceFormat: '1' }
| GraphRep { PlatypusExpressBuiltinFormatPictureFormatter sourceFormat: '1' }
;

SymbolRep
: Signe Width Decimals Type
;

Signe
: ""+"" { $+ }
| ""-"" { $- }
| { nil }
;

Width
: <integer> { '1' value }
| { nil }
;

Decimals
: ""."" <integer> { '2' value  }
| { nil }
;

Type
: ""I"" { $I }
| ""F"" { $F }
| ""E"" { $E }
;

GraphRep
: Signe GraphRepContents
| OPar GraphRepContents CPar 
;

OPar
: ""("" { $( }
;
CPar
: "")"" { $) }
;

GraphRepContents
: Diezes Sep Diezes Sep Diezes { Array with: '1' with: '2' with: '3' with: '4' with: '5' }
| Diezes Sep Diezes  { Array with: '1' with: '2' with: '3' }
| Diezes { Array with: '1' }
;

Diezes
: ""#""+ { '1' value size }
;

Sep
: ""."" { $. }
| "","" { $, }
;"! !

!PlatypusExpressBuiltinFormatParser class methodsFor: 'generated-accessing' stamp: 'apl 12/12/2005 12:03'!
scannerClass
	^PlatypusExpressBuiltinFormatScanner! !

!PlatypusExpressBuiltinFormatParser class methodsFor: 'generated-starting states' stamp: 'apl 12/12/2005 12:03'!
startingStateForRep
	^1! !

!PlatypusExpressBuiltinFormatParser methodsFor: 'generated-reduction actions' stamp: 'apl 12/12/2005 12:03'!
reduceActionForCPar1: nodes 
	^$)! !

!PlatypusExpressBuiltinFormatParser methodsFor: 'generated-reduction actions' stamp: 'apl 12/12/2005 12:03'!
reduceActionForDecimals1: nodes 
	^(nodes at: 2) value! !

!PlatypusExpressBuiltinFormatParser methodsFor: 'generated-reduction actions' stamp: 'apl 12/12/2005 12:03'!
reduceActionForDecimals2: nodes 
	^nil! !

!PlatypusExpressBuiltinFormatParser methodsFor: 'generated-reduction actions' stamp: 'apl 12/12/2005 12:03'!
reduceActionForDiezes1: nodes 
	^(nodes at: 1) value size! !

!PlatypusExpressBuiltinFormatParser methodsFor: 'generated-reduction actions' stamp: 'apl 12/12/2005 12:03'!
reduceActionForGraphRepContents1: nodes 
	^Array 
		with: (nodes at: 1)
		with: (nodes at: 2)
		with: (nodes at: 3)
		with: (nodes at: 4)
		with: (nodes at: 5)! !

!PlatypusExpressBuiltinFormatParser methodsFor: 'generated-reduction actions' stamp: 'apl 12/12/2005 12:03'!
reduceActionForGraphRepContents2: nodes 
	^Array 
		with: (nodes at: 1)
		with: (nodes at: 2)
		with: (nodes at: 3)! !

!PlatypusExpressBuiltinFormatParser methodsFor: 'generated-reduction actions' stamp: 'apl 12/12/2005 12:03'!
reduceActionForGraphRepContents3: nodes 
	^Array with: (nodes at: 1)! !

!PlatypusExpressBuiltinFormatParser methodsFor: 'generated-reduction actions' stamp: 'apl 12/12/2005 12:03'!
reduceActionForOPar1: nodes 
	^$(! !

!PlatypusExpressBuiltinFormatParser methodsFor: 'generated-reduction actions' stamp: 'apl 12/12/2005 12:03'!
reduceActionForRep1: nodes 
	^PlatypusExpressBuiltinFormatSymbolicFormatter sourceFormat: (nodes at: 1)! !

!PlatypusExpressBuiltinFormatParser methodsFor: 'generated-reduction actions' stamp: 'apl 12/12/2005 12:03'!
reduceActionForRep2: nodes 
	^PlatypusExpressBuiltinFormatPictureFormatter sourceFormat: (nodes at: 1)! !

!PlatypusExpressBuiltinFormatParser methodsFor: 'generated-reduction actions' stamp: 'apl 12/12/2005 12:03'!
reduceActionForRepeatXMultipleXXXXX1: nodes 
	^OrderedCollection with: (nodes at: 1)! !

!PlatypusExpressBuiltinFormatParser methodsFor: 'generated-reduction actions' stamp: 'apl 12/12/2005 12:03'!
reduceActionForRepeatXMultipleXXXXX2: nodes 
	^(nodes at: 1)
		add: (nodes at: 2);
		yourself! !

!PlatypusExpressBuiltinFormatParser methodsFor: 'generated-reduction actions' stamp: 'apl 12/12/2005 12:03'!
reduceActionForSep1: nodes 
	^$.! !

!PlatypusExpressBuiltinFormatParser methodsFor: 'generated-reduction actions' stamp: 'apl 12/12/2005 12:03'!
reduceActionForSep2: nodes 
	^$,! !

!PlatypusExpressBuiltinFormatParser methodsFor: 'generated-reduction actions' stamp: 'apl 12/12/2005 12:03'!
reduceActionForSigne1: nodes 
	^$+! !

!PlatypusExpressBuiltinFormatParser methodsFor: 'generated-reduction actions' stamp: 'apl 12/12/2005 12:03'!
reduceActionForSigne2: nodes 
	^$-! !

!PlatypusExpressBuiltinFormatParser methodsFor: 'generated-reduction actions' stamp: 'apl 12/12/2005 12:03'!
reduceActionForSigne3: nodes 
	^nil! !

!PlatypusExpressBuiltinFormatParser methodsFor: 'generated-reduction actions' stamp: 'apl 12/12/2005 12:03'!
reduceActionForType1: nodes 
	^$I! !

!PlatypusExpressBuiltinFormatParser methodsFor: 'generated-reduction actions' stamp: 'apl 12/12/2005 12:03'!
reduceActionForType2: nodes 
	^$F! !

!PlatypusExpressBuiltinFormatParser methodsFor: 'generated-reduction actions' stamp: 'apl 12/12/2005 12:03'!
reduceActionForType3: nodes 
	^$E! !

!PlatypusExpressBuiltinFormatParser methodsFor: 'generated-reduction actions' stamp: 'apl 12/12/2005 12:03'!
reduceActionForWidth1: nodes 
	^(nodes at: 1) value! !

!PlatypusExpressBuiltinFormatParser methodsFor: 'generated-reduction actions' stamp: 'apl 12/12/2005 12:03'!
reduceActionForWidth2: nodes 
	^nil! !

!PlatypusExpressBuiltinFormatParser methodsFor: 'generated-tables' stamp: 'apl 12/12/2005 12:03'!
reduceTable
	^#(
#(13 1 #reduceActionForRep1:)
#(13 1 #reduceActionForRep2:)
#(14 2 #reduceFor:)
#(14 3 #reduceFor:)
#(15 1 #reduceActionForSigne1:)
#(15 1 #reduceActionForSigne2:)
#(15 0 #reduceActionForSigne3:)
#(16 1 #reduceActionForWidth1:)
#(16 0 #reduceActionForWidth2:)
#(17 2 #reduceActionForDecimals1:)
#(17 0 #reduceActionForDecimals2:)
#(18 1 #reduceActionForType1:)
#(18 1 #reduceActionForType2:)
#(18 1 #reduceActionForType3:)
#(19 4 #reduceFor:)
#(20 5 #reduceActionForGraphRepContents1:)
#(20 3 #reduceActionForGraphRepContents2:)
#(20 1 #reduceActionForGraphRepContents3:)
#(21 1 #reduceActionForOPar1:)
#(22 1 #reduceActionForCPar1:)
#(23 1 #reduceActionForDiezes1:)
#(24 1 #reduceActionForSep1:)
#(24 1 #reduceActionForSep2:)
#(25 1 #reduceActionForRepeatXMultipleXXXXX1:)
#(25 2 #reduceActionForRepeatXMultipleXXXXX2:)
#(28 1 #reduceFor:)
)! !

!PlatypusExpressBuiltinFormatParser methodsFor: 'generated-tables' stamp: 'apl 12/12/2005 12:03'!
transitionTable
	^#(
#(3 30 1 9 2 30 3 30 4 13 5 30 7 30 9 17 10 30 11 21 13 25 14 29 15 33 19 37 21)
#(2 26 1 3 4 7 9 11)
#(2 22 1 3 4 7 9 11)
#(2 78 7)
#(2 0 26)
#(2 10 26)
#(3 38 1 38 3 38 4 41 7 38 9 45 11 49 16 53 20 57 23 61 25)
#(2 6 26)
#(3 41 7 65 20 57 23 61 25)
#(2 98 1 6 7 8 26)
#(2 34 1 3 4 9)
#(3 69 1 46 3 46 4 46 9 73 17)
#(2 14 26)
#(3 77 1 81 6 74 8 85 24 74 26)
#(3 86 1 86 6 89 7 86 8 86 26)
#(3 93 8 97 22)
#(2 101 11)
#(3 105 3 109 4 113 9 117 18)
#(2 90 7)
#(2 94 7)
#(3 41 7 121 23 61 25)
#(2 102 1 6 7 8 26)
#(2 82 26)
#(2 18 26)
#(2 42 3 4 9)
#(2 50 26)
#(2 54 26)
#(2 58 26)
#(2 62 26)
#(3 77 1 81 6 70 8 125 24 70 26)
#(3 41 7 129 23 61 25)
#(2 66 8 26)
)! !

SmaCCParser subclass: #PlatypusExpressLikeParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-HW-parsers'!

!PlatypusExpressLikeParser class methodsFor: 'generated-comments' stamp: 'apl 2/5/2004 19:15'!
parserDefinitionComment

	"Source
: Char* {'1' value }
;

Char
: ""@""  { '[a-zA-Z]' }
| ""^""   { '[A-Z]' }
| ""?""   { '[a-zA-Z0-9]' }
| <character> { '1' value asString }
| <anti>  { '1' value allButFirst}
;
"! !

!PlatypusExpressLikeParser class methodsFor: 'generated-accessing' stamp: 'apl 2/5/2004 19:15'!
scannerClass
	^PlatypusExpressLikeScanner! !

!PlatypusExpressLikeParser class methodsFor: 'generated-starting states' stamp: 'apl 2/5/2004 19:15'!
startingStateForSource
	^1! !

!PlatypusExpressLikeParser methodsFor: 'generated-reduction actions' stamp: 'apl 2/5/2004 19:15'!
reduceActionForChar1: nodes 
	^'[a-zA-Z]'! !

!PlatypusExpressLikeParser methodsFor: 'generated-reduction actions' stamp: 'apl 2/5/2004 19:15'!
reduceActionForChar2: nodes 
	^'[A-Z]'! !

!PlatypusExpressLikeParser methodsFor: 'generated-reduction actions' stamp: 'apl 2/5/2004 19:15'!
reduceActionForChar3: nodes 
	^'[a-zA-Z0-9]'! !

!PlatypusExpressLikeParser methodsFor: 'generated-reduction actions' stamp: 'apl 2/5/2004 19:15'!
reduceActionForChar4: nodes 
	^(nodes at: 1) value asString! !

!PlatypusExpressLikeParser methodsFor: 'generated-reduction actions' stamp: 'apl 2/5/2004 19:15'!
reduceActionForChar5: nodes 
	^(nodes at: 1) value allButFirst! !

!PlatypusExpressLikeParser methodsFor: 'generated-reduction actions' stamp: 'apl 2/5/2004 19:15'!
reduceActionForRepeatXXChar1: nodes 
	^OrderedCollection new! !

!PlatypusExpressLikeParser methodsFor: 'generated-reduction actions' stamp: 'apl 2/5/2004 19:15'!
reduceActionForRepeatXXChar2: nodes 
	^(nodes at: 1)
		add: (nodes at: 2);
		yourself! !

!PlatypusExpressLikeParser methodsFor: 'generated-reduction actions' stamp: 'apl 2/5/2004 19:15'!
reduceActionForSource1: nodes 
	^(nodes at: 1) value! !

!PlatypusExpressLikeParser methodsFor: 'generated-tables' stamp: 'apl 2/5/2004 19:15'!
reduceTable
	^#(
#(6 1 #reduceActionForSource1:)
#(7 1 #reduceFor:)
#(8 1 #reduceActionForChar1:)
#(8 1 #reduceActionForChar2:)
#(8 1 #reduceActionForChar3:)
#(8 1 #reduceActionForChar4:)
#(8 1 #reduceActionForChar5:)
#(9 0 #reduceActionForRepeatXXChar1:)
#(9 2 #reduceActionForRepeatXXChar2:)
)! !

!PlatypusExpressLikeParser methodsFor: 'generated-tables' stamp: 'apl 2/5/2004 19:15'!
transitionTable
	^#(
#(3 34 1 34 2 34 3 34 4 34 5 9 6 13 9 34 10)
#(2 0 10)
#(3 17 1 21 2 25 3 29 4 33 5 37 8 6 10)
#(2 14 1 2 3 4 5 10)
#(2 18 1 2 3 4 5 10)
#(2 22 1 2 3 4 5 10)
#(2 26 1 2 3 4 5 10)
#(2 30 1 2 3 4 5 10)
#(2 38 1 2 3 4 5 10)
)! !

SmaCCParser subclass: #StepParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Platypus-STEP-core'!

!StepParser class methodsFor: 'generated-comments' stamp: 'AlainPlantec 5/24/2012 00:14'!
parserDefinitionComment

	"%start ExchangeFile DataEntities DataEntity SimpleRecordEntry Parameter	;

ExchangeFile	
	: ""ISO-10303-21"" "";"" HeaderSection  'HS' DataSection 'DS' ""END-ISO-10303-21"" "";""  { Array with: HS with: DS.};
HeaderSection	
	: <identifier> "";"" HeaderEntity* 'entities'  <identifier> "";""  {entities};

EntityName
	: <identifier> { '1' value asUppercase };

HeaderEntity
	: EntityName ""("" Parameters "")"" "";"" { self headerDataNamed: '1' record: '3' }
	| EntityName ""(""  "")"" "";""  {self headerDataNamed: '1' value record: OrderedCollection new };

DataSection	
	: <identifier> "";"" DataEntities 'entities' <identifier> "";"" {entities.};

DataEntities
	: DataEntity* ;

DataEntity	
	: InstLabel  ""="" ""SCOPE"" DataEntity* ""END_SCOPE"" EntityExport EntityInstanceRHS "";"" 
 		{ self data: '1' record: '7'}
	| InstLabel  ""="" EntityInstanceRHS "";"" { self data: '1' record: '3'};

InstLabel
	: ""#"" <integer> 'id' { id value } 
	| ""#"" <identifier> 'id' { id value };
	
EntityInstanceRHS	
	: SimpleRecord {self simpleInstanceKey -> '1'}
	| SubsuperRecord { self complexInstanceKey -> '1'};
	
SubsuperRecord
	: ""("" SubsuperRecordList "")"" {'2'};
	
SubsuperRecordList
	: SubsuperRecordListElement* {'1'};

SubsuperRecordListElement
	: <identifier> 'entity' ""("" Parameters 'attributes' "")"" { Association key: entity value value: attributes }
	| <identifier> 'entity' ""(""  "")"" { Association key: entity value value: OrderedCollection new };

SimpleRecordEntry
	: SimpleRecord { StepSimpleRecord entityName: '1' first values: '1' second } ;

SimpleRecord
	: EntityName 'entity' ""("" Parameters? 'attributes' "")"" 
	{ self simpleRecord: entity attributes: (attributes ifNil: [OrderedCollection new]) };

TypedValue
	:  EntityName ""("" Parameter "")"" { '3' };

Parameters	
: Parameter { OrderedCollection with: '1' }
| Parameters "",""? Parameter { '1' add: '3'. '1' }
;

Parameter
: ParameterValue { '1'  }
| <identifier> "":"" ParameterValue { '3' value }
;

ParameterValue
	: ""$"" { $$ }
	| ""*"" { StepRedefinedValue new }
	| PlusOrMinus? <integer> { | v | v := '2' value asNumber . '1' value = $- ifTrue: [ v := v negated]. v}
	| PlusOrMinus? <real> { | v | v := '2' value asNumber . '1' value = $- ifTrue: [ v := v negated]. v asFloat}
	| <enum>  {('1' value copyFrom:2 to: ('1' value size -1)) asSymbol}
	| <string> { | v | v := '1' value copyFrom:2 to: ('1' value size -1). v copyReplaceAll: '''''' with: '''' }
	| <binary> {'1' value copyFrom:2 to: ('1' value size -1)}
	| Logical {'1' }
	| TypedValue {'1'  }
	| InstanceReference {'1'}
	| EmbeddedList { '1' };
	
Logical
	: "".T."" {true}
	| "".F."" {false}
	| "".U."" {#UNKNOWN};

PlusOrMinus
	: ""+"" { $+ }
	| ""-"" { $- };
	
InstanceReference
	: InstLabel { StepInstanceReference id: '1'};

ScopeInstanceReference
	: InstanceReference;

EntityExport
	:""/""  ScopeInstRefs ""/""
	|;

ScopeInstRefs
	: ScopeInstanceReference
	| ScopeInstRefs "","" ScopeInstanceReference;

EmbeddedList
	: ""("" Parameters "")"" {'2'}
	| ""("" "")"" { OrderedCollection new };

"! !

!StepParser class methodsFor: 'generated-accessing' stamp: 'AlainPlantec 5/24/2012 00:14'!
scannerClass
	^StepScanner! !

!StepParser class methodsFor: 'generated-starting states' stamp: 'AlainPlantec 5/24/2012 00:14'!
startingStateForDataEntities
	^3! !

!StepParser class methodsFor: 'generated-starting states' stamp: 'AlainPlantec 5/24/2012 00:14'!
startingStateForDataEntity
	^4! !

!StepParser class methodsFor: 'generated-starting states' stamp: 'AlainPlantec 5/24/2012 00:14'!
startingStateForExchangeFile
	^1! !

!StepParser class methodsFor: 'generated-starting states' stamp: 'AlainPlantec 5/24/2012 00:14'!
startingStateForParameter
	^6! !

!StepParser class methodsFor: 'generated-starting states' stamp: 'AlainPlantec 5/24/2012 00:14'!
startingStateForSimpleRecordEntry
	^5! !

!StepParser methodsFor: 'semantic actions' stamp: 'apl 3/9/2005 15:57'!
complexInstanceKey
	^ #complexInstance! !

!StepParser methodsFor: 'semantic actions' stamp: 'apl 3/24/2005 15:05'!
data: instLabel record: record 
	| records |
	^ record key = self simpleInstanceKey
		ifTrue: [StepInternalRepresentation
				label: instLabel
				entityName: record value first
				values: record value second]
		ifFalse: [records := record value
						collect: [:v | StepSimpleRecord entityName: v key values: v value].
			StepExternalRepresentation label: instLabel records: records]! !

!StepParser methodsFor: 'semantic actions' stamp: 'apl 3/9/2005 21:56'!
headerDataNamed: name record: record 
	^ StepSimpleRecord		
				entityName: name
				values: record! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForDataEntity1: nodes
	^ self data: (nodes at: 1) record: (nodes at: 7)! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForDataEntity2: nodes
	^ self data: (nodes at: 1) record: (nodes at: 3)! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForDataSection1: nodes
	^ nodes at: 3! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForEmbeddedList1: nodes
	^ nodes at: 2! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForEmbeddedList2: nodes
	^ OrderedCollection new! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForEntityInstanceRHS1: nodes
	^ self simpleInstanceKey -> (nodes at: 1)! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForEntityInstanceRHS2: nodes
	^ self complexInstanceKey -> (nodes at: 1)! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForEntityName1: nodes
	^ (nodes at: 1) value asUppercase! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForExchangeFile1: nodes
	^ Array with: (nodes at: 3) with: (nodes at: 4)! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForHeaderEntity1: nodes
	^ self headerDataNamed: (nodes at: 1) record: (nodes at: 3)! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForHeaderEntity2: nodes
	^ self headerDataNamed: (nodes at: 1) value record: OrderedCollection new! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForHeaderSection1: nodes
	^ nodes at: 3! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForInstLabel1: nodes
	^ (nodes at: 2) value! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForInstLabel2: nodes
	^ (nodes at: 2) value! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForInstanceReference1: nodes
	^ StepInstanceReference id: (nodes at: 1)! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForLogical1: nodes
	^ true! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForLogical2: nodes
	^ false! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForLogical3: nodes
	^ #UNKNOWN! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForOptionalXXParameters1: nodes
	^ nil! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForOptionalXXParameters2: nodes
	^ nodes at: 1! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForOptionalXXPlusOrMinus1: nodes
	^ nil! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForOptionalXXPlusOrMinus2: nodes
	^ nodes at: 1! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForOptionalXXXXX1: nodes
	^ nil! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForOptionalXXXXX2: nodes
	^ nodes at: 1! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForParameter1: nodes
	^ nodes at: 1! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForParameter2: nodes
	^ (nodes at: 3) value! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForParameterValue10: nodes
	^ nodes at: 1! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForParameterValue11: nodes
	^ nodes at: 1! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForParameterValue1: nodes
	^ $$! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForParameterValue2: nodes
	^ StepRedefinedValue new! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForParameterValue3: nodes
	| v |
	v := (nodes at: 2) value asNumber.
	(nodes at: 1) value = $-
		ifTrue: [ v := v negated ].
	^ v! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForParameterValue4: nodes
	| v |
	v := (nodes at: 2) value asNumber.
	(nodes at: 1) value = $-
		ifTrue: [ v := v negated ].
	^ v asFloat! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForParameterValue5: nodes
	^ ((nodes at: 1) value copyFrom: 2 to: (nodes at: 1) value size - 1) asSymbol! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForParameterValue6: nodes
	| v |
	v := (nodes at: 1) value copyFrom: 2 to: (nodes at: 1) value size - 1.
	^ v copyReplaceAll: '''''' with: ''''! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForParameterValue7: nodes
	^ (nodes at: 1) value copyFrom: 2 to: (nodes at: 1) value size - 1! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForParameterValue8: nodes
	^ nodes at: 1! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForParameterValue9: nodes
	^ nodes at: 1! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForParameters1: nodes
	^ OrderedCollection with: (nodes at: 1)! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForParameters2: nodes
	(nodes at: 1) add: (nodes at: 3).
	^ nodes at: 1! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForPlusOrMinus1: nodes
	^ $+! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForPlusOrMinus2: nodes
	^ $-! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForRepeatXXDataEntity1: nodes
	^ OrderedCollection new! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForRepeatXXDataEntity2: nodes
	^ (nodes at: 1)
		add: (nodes at: 2);
		yourself! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForRepeatXXHeaderEntity1: nodes
	^ OrderedCollection new! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForRepeatXXHeaderEntity2: nodes
	^ (nodes at: 1)
		add: (nodes at: 2);
		yourself! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForRepeatXXSubsuperRecordListElement1: nodes
	^ OrderedCollection new! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForRepeatXXSubsuperRecordListElement2: nodes
	^ (nodes at: 1)
		add: (nodes at: 2);
		yourself! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForSimpleRecord1: nodes
	^ self simpleRecord: (nodes at: 1) attributes: ((nodes at: 3) ifNil: [ OrderedCollection new ])! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForSimpleRecordEntry1: nodes
	^ StepSimpleRecord entityName: (nodes at: 1) first values: (nodes at: 1) second! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForSubsuperRecord1: nodes
	^ nodes at: 2! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForSubsuperRecordList1: nodes
	^ nodes at: 1! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForSubsuperRecordListElement1: nodes
	^ Association key: (nodes at: 1) value value: (nodes at: 3)! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForSubsuperRecordListElement2: nodes
	^ Association key: (nodes at: 1) value value: OrderedCollection new! !

!StepParser methodsFor: 'generated-reduction actions' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceActionForTypedValue1: nodes
	^ nodes at: 3! !

!StepParser methodsFor: 'generated-tables' stamp: 'AlainPlantec 5/24/2012 00:14'!
reduceTable
	^#(
#(30 0 #reduceActionForRepeatXXHeaderEntity1:)
#(30 2 #reduceActionForRepeatXXHeaderEntity2:)
#(31 1 #reduceActionForEntityName1:)
#(32 5 #reduceActionForDataSection1:)
#(33 0 #reduceActionForRepeatXXDataEntity1:)
#(33 2 #reduceActionForRepeatXXDataEntity2:)
#(34 2 #reduceActionForInstLabel1:)
#(34 2 #reduceActionForInstLabel2:)
#(35 3 #reduceFor:)
#(35 0 #reduceFor:)
#(36 1 #reduceActionForEntityInstanceRHS1:)
#(36 1 #reduceActionForEntityInstanceRHS2:)
#(37 5 #reduceActionForHeaderSection1:)
#(38 4 #reduceActionForSimpleRecord1:)
#(39 3 #reduceActionForSubsuperRecord1:)
#(40 1 #reduceActionForSubsuperRecordList1:)
#(41 4 #reduceActionForSubsuperRecordListElement1:)
#(41 3 #reduceActionForSubsuperRecordListElement2:)
#(42 0 #reduceActionForRepeatXXSubsuperRecordListElement1:)
#(42 2 #reduceActionForRepeatXXSubsuperRecordListElement2:)
#(43 0 #reduceActionForOptionalXXParameters1:)
#(43 1 #reduceActionForOptionalXXParameters2:)
#(44 5 #reduceActionForHeaderEntity1:)
#(44 4 #reduceActionForHeaderEntity2:)
#(45 0 #reduceActionForOptionalXXXXX1:)
#(45 1 #reduceActionForOptionalXXXXX2:)
#(46 1 #reduceActionForParameterValue1:)
#(46 1 #reduceActionForParameterValue2:)
#(46 2 #reduceActionForParameterValue3:)
#(46 2 #reduceActionForParameterValue4:)
#(46 1 #reduceActionForParameterValue5:)
#(46 1 #reduceActionForParameterValue6:)
#(46 1 #reduceActionForParameterValue7:)
#(46 1 #reduceActionForParameterValue8:)
#(46 1 #reduceActionForParameterValue9:)
#(46 1 #reduceActionForParameterValue10:)
#(46 1 #reduceActionForParameterValue11:)
#(47 1 #reduceActionForPlusOrMinus1:)
#(47 1 #reduceActionForPlusOrMinus2:)
#(48 0 #reduceActionForOptionalXXPlusOrMinus1:)
#(48 1 #reduceActionForOptionalXXPlusOrMinus2:)
#(49 1 #reduceActionForParameter1:)
#(49 3 #reduceActionForParameter2:)
#(50 1 #reduceActionForSimpleRecordEntry1:)
#(51 8 #reduceActionForDataEntity1:)
#(51 4 #reduceActionForDataEntity2:)
#(52 1 #reduceFor:)
#(53 1 #reduceActionForLogical1:)
#(53 1 #reduceActionForLogical2:)
#(53 1 #reduceActionForLogical3:)
#(54 1 #reduceActionForInstanceReference1:)
#(55 3 #reduceActionForEmbeddedList1:)
#(55 2 #reduceActionForEmbeddedList2:)
#(56 1 #reduceFor:)
#(57 1 #reduceFor:)
#(57 3 #reduceFor:)
#(60 6 #reduceActionForExchangeFile1:)
#(61 4 #reduceActionForTypedValue1:)
#(62 1 #reduceFor:)
#(63 1 #reduceActionForParameters1:)
#(63 3 #reduceActionForParameters2:)
)! !

!StepParser methodsFor: 'semantic actions' stamp: 'apl 3/9/2005 15:57'!
simpleInstanceKey
	^ #simpleInstance! !

!StepParser methodsFor: 'semantic actions' stamp: 'apl 4/11/2006 08:00'!
simpleRecord: entity attributes: attributes 
	^ Array with: entity with: attributes! !

!StepParser methodsFor: 'generated-tables' stamp: 'AlainPlantec 5/24/2012 00:14'!
transitionTable
	^#(
#[1 0 29 0 6 0 33 0 60]
#[1 0 29 0 6 0 37 0 60]
#[1 0 22 0 9 0 41 0 33 0 45 0 52 0 22 0 58]
#[1 0 49 0 9 0 53 0 34 0 57 0 51]
#[1 0 61 0 25 0 65 0 31 0 69 0 38 0 73 0 50]
#[1 0 77 0 4 0 49 0 9 0 81 0 11 0 85 0 12 0 89 0 13 0 93 0 14 0 97 0 16 0 101 0 18 0 105 0 19 0 162 0 21 0 162 0 22 0 109 0 23 0 113 0 24 0 117 0 25 0 121 0 26 0 125 0 31 0 129 0 34 0 133 0 46 0 137 0 47 0 141 0 48 0 145 0 49 0 149 0 53 0 153 0 54 0 157 0 55 0 161 0 61]
#[0 0 165 0 7]
#[0 0 0 0 58]
#[0 0 0 0 58]
#[1 0 49 0 9 0 190 0 25 0 53 0 34 0 169 0 51 0 190 0 58]
#[0 0 0 0 58]
#[1 0 173 0 21 0 177 0 25]
#[0 0 181 0 8]
#[0 0 0 0 58]
#[0 0 14 0 4]
#[0 0 185 0 4]
#[0 0 178 0 58]
#[0 0 0 0 58]
#[1 0 189 0 3 0 77 0 4 0 49 0 9 0 81 0 11 0 85 0 12 0 89 0 13 0 93 0 14 0 97 0 16 0 101 0 18 0 105 0 19 0 162 0 21 0 162 0 22 0 109 0 23 0 113 0 24 0 117 0 25 0 121 0 26 0 125 0 31 0 129 0 34 0 133 0 46 0 137 0 47 0 141 0 48 0 193 0 49 0 149 0 53 0 153 0 54 0 157 0 55 0 161 0 61 0 197 0 63]
#[0 0 202 0 3 0 4 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 18 0 19 0 21 0 22 0 23 0 24 0 25 0 26 0 58]
#[0 0 154 0 21 0 22]
#[0 0 198 0 3 0 4 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 18 0 19 0 21 0 22 0 23 0 24 0 25 0 26 0 58]
#[0 0 158 0 21 0 22]
#[0 0 194 0 3 0 4 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 18 0 19 0 21 0 22 0 23 0 24 0 25 0 26 0 58]
#[0 0 110 0 3 0 4 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 18 0 19 0 21 0 22 0 23 0 24 0 25 0 26 0 58]
#[0 0 114 0 3 0 4 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 18 0 19 0 21 0 22 0 23 0 24 0 25 0 26 0 58]
#[0 0 134 0 3 0 4 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 18 0 19 0 21 0 22 0 23 0 24 0 25 0 26 0 58]
#[0 0 130 0 3 0 4 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 18 0 19 0 21 0 22 0 23 0 24 0 25 0 26 0 58]
#[1 0 14 0 4 0 201 0 17]
#[0 0 126 0 3 0 4 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 18 0 19 0 21 0 22 0 23 0 24 0 25 0 26 0 58]
#[0 0 205 0 4]
#[0 0 206 0 1 0 3 0 4 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 18 0 19 0 21 0 22 0 23 0 24 0 25 0 26 0 58]
#[0 0 170 0 3 0 4 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 18 0 19 0 21 0 22 0 23 0 24 0 25 0 26 0 58]
#[0 0 166 0 21 0 22]
#[1 0 209 0 21 0 213 0 22]
#[0 0 0 0 58]
#[0 0 138 0 3 0 4 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 18 0 19 0 21 0 22 0 23 0 24 0 25 0 26 0 58]
#[0 0 146 0 3 0 4 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 18 0 19 0 21 0 22 0 23 0 24 0 25 0 26 0 58]
#[0 0 150 0 3 0 4 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 18 0 19 0 21 0 22 0 23 0 24 0 25 0 26 0 58]
#[0 0 142 0 3 0 4 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 18 0 19 0 21 0 22 0 23 0 24 0 25 0 26 0 58]
#[1 0 217 0 25 0 221 0 37]
#[0 0 26 0 5 0 9 0 25 0 58]
#[0 0 30 0 1 0 3 0 4 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 18 0 19 0 21 0 22 0 23 0 24 0 25 0 26 0 58]
#[0 0 34 0 1 0 3 0 4 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 18 0 19 0 21 0 22 0 23 0 24 0 25 0 26 0 58]
#[1 0 225 0 2 0 229 0 4 0 61 0 25 0 65 0 31 0 233 0 36 0 237 0 38 0 241 0 39]
#[1 0 86 0 3 0 77 0 4 0 49 0 9 0 81 0 11 0 85 0 12 0 89 0 13 0 93 0 14 0 97 0 16 0 101 0 18 0 105 0 19 0 162 0 21 0 162 0 22 0 109 0 23 0 113 0 24 0 117 0 25 0 121 0 26 0 125 0 31 0 129 0 34 0 245 0 43 0 133 0 46 0 137 0 47 0 141 0 48 0 193 0 49 0 149 0 53 0 153 0 54 0 157 0 55 0 161 0 61 0 249 0 63]
#[0 0 214 0 3 0 4 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 18 0 19 0 21 0 22 0 23 0 24 0 25 0 26 0 58]
#[0 0 242 0 3 0 4 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 18 0 19 0 21 0 22 0 23 0 24 0 25 0 26]
#[1 0 253 0 3 0 102 0 4 0 102 0 9 0 102 0 11 0 102 0 12 0 102 0 13 0 102 0 14 1 1 0 15 0 102 0 16 0 102 0 18 0 102 0 19 0 102 0 21 0 102 0 22 0 102 0 23 0 102 0 24 0 102 0 25 0 102 0 26 1 5 0 45]
#[1 0 77 0 4 0 49 0 9 0 81 0 11 0 85 0 12 0 89 0 13 0 93 0 14 0 97 0 16 0 101 0 18 0 105 0 19 0 162 0 21 0 162 0 22 0 109 0 23 0 113 0 24 0 61 0 25 0 121 0 26 0 125 0 31 0 129 0 34 1 9 0 46 0 137 0 47 0 141 0 48 0 149 0 53 0 153 0 54 0 157 0 55 0 161 0 61]
#[1 0 77 0 4 0 49 0 9 0 81 0 11 0 85 0 12 0 89 0 13 0 93 0 14 0 97 0 16 0 101 0 18 0 105 0 19 0 162 0 21 0 162 0 22 0 109 0 23 0 113 0 24 0 117 0 25 0 121 0 26 0 125 0 31 0 129 0 34 0 133 0 46 0 137 0 47 0 141 0 48 1 13 0 49 0 149 0 53 0 153 0 54 0 157 0 55 0 161 0 61]
#[0 0 118 0 3 0 4 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 18 0 19 0 21 0 22 0 23 0 24 0 25 0 26 0 58]
#[0 0 122 0 3 0 4 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 18 0 19 0 21 0 22 0 23 0 24 0 25 0 26 0 58]
#[0 1 17 0 7]
#[1 1 21 0 25 1 25 0 32]
#[1 0 22 0 5 0 22 0 9 1 29 0 33]
#[1 0 78 0 3 0 78 0 25 1 33 0 40 1 37 0 42]
#[0 1 41 0 7]
#[0 0 46 0 7]
#[0 0 50 0 7]
#[0 1 45 0 3]
#[1 0 90 0 3 0 102 0 4 0 102 0 9 0 102 0 11 0 102 0 12 0 102 0 13 0 102 0 14 1 1 0 15 0 102 0 16 0 102 0 18 0 102 0 19 0 102 0 21 0 102 0 22 0 102 0 23 0 102 0 24 0 102 0 25 0 102 0 26 1 5 0 45]
#[0 0 210 0 3 0 4 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 18 0 19 0 21 0 22 0 23 0 24 0 25 0 26 0 58]
#[0 0 106 0 4 0 9 0 11 0 12 0 13 0 14 0 16 0 18 0 19 0 21 0 22 0 23 0 24 0 25 0 26]
#[1 0 77 0 4 0 49 0 9 0 81 0 11 0 85 0 12 0 89 0 13 0 93 0 14 0 97 0 16 0 101 0 18 0 105 0 19 0 162 0 21 0 162 0 22 0 109 0 23 0 113 0 24 0 117 0 25 0 121 0 26 0 125 0 31 0 129 0 34 0 133 0 46 0 137 0 47 0 141 0 48 1 49 0 49 0 149 0 53 0 153 0 54 0 157 0 55 0 161 0 61]
#[0 0 174 0 3 0 4 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 18 0 19 0 21 0 22 0 23 0 24 0 25 0 26 0 58]
#[0 1 53 0 3]
#[1 0 6 0 25 1 57 0 30]
#[0 1 61 0 7]
#[0 1 65 0 10]
#[1 1 69 0 5 0 49 0 9 0 53 0 34 0 169 0 51]
#[0 1 73 0 3]
#[1 0 66 0 3 1 77 0 25 1 81 0 41]
#[0 0 186 0 5 0 9 0 25 0 58]
#[0 0 58 0 7 0 58]
#[0 0 246 0 3 0 4 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 18 0 19 0 21 0 22 0 23 0 24 0 25 0 26]
#[0 0 234 0 3 0 4 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 18 0 19 0 21 0 22 0 23 0 24 0 25 0 26 0 58]
#[1 1 85 0 25 1 89 0 31 1 93 0 44]
#[1 0 22 0 9 0 22 0 25 0 41 0 33 1 97 0 52]
#[0 1 101 0 7]
#[1 1 105 0 1 0 42 0 4 0 42 0 25 1 109 0 35]
#[0 0 62 0 7]
#[0 1 113 0 4]
#[0 0 82 0 3 0 25]
#[1 0 14 0 4 1 117 0 7]
#[0 1 121 0 4]
#[0 0 10 0 25]
#[0 1 125 0 25]
#[0 0 230 0 58]
#[1 0 49 0 9 0 129 0 34 1 129 0 54 1 133 0 56 1 137 0 57]
#[1 0 229 0 4 0 61 0 25 0 65 0 31 1 141 0 36 0 237 0 38 0 241 0 39]
#[1 1 145 0 3 0 77 0 4 0 49 0 9 0 81 0 11 0 85 0 12 0 89 0 13 0 93 0 14 0 97 0 16 0 101 0 18 0 105 0 19 0 162 0 21 0 162 0 22 0 109 0 23 0 113 0 24 0 117 0 25 0 121 0 26 0 125 0 31 0 129 0 34 0 133 0 46 0 137 0 47 0 141 0 48 0 193 0 49 0 149 0 53 0 153 0 54 0 157 0 55 0 161 0 61 1 149 0 63]
#[0 0 54 0 25]
#[1 1 153 0 3 0 77 0 4 0 49 0 9 0 81 0 11 0 85 0 12 0 89 0 13 0 93 0 14 0 97 0 16 0 101 0 18 0 105 0 19 0 162 0 21 0 162 0 22 0 109 0 23 0 113 0 24 0 117 0 25 0 121 0 26 0 125 0 31 0 129 0 34 0 133 0 46 0 137 0 47 0 141 0 48 0 193 0 49 0 149 0 53 0 153 0 54 0 157 0 55 0 161 0 61 1 157 0 63]
#[0 1 161 0 7]
#[0 0 218 0 1 0 15]
#[0 0 222 0 1 0 15]
#[1 1 165 0 1 1 169 0 15]
#[0 1 173 0 7]
#[0 0 74 0 3 0 25]
#[1 1 177 0 3 0 102 0 4 0 102 0 9 0 102 0 11 0 102 0 12 0 102 0 13 0 102 0 14 1 1 0 15 0 102 0 16 0 102 0 18 0 102 0 19 0 102 0 21 0 102 0 22 0 102 0 23 0 102 0 24 0 102 0 25 0 102 0 26 1 5 0 45]
#[0 1 181 0 7]
#[1 1 185 0 3 0 102 0 4 0 102 0 9 0 102 0 11 0 102 0 12 0 102 0 13 0 102 0 14 1 1 0 15 0 102 0 16 0 102 0 18 0 102 0 19 0 102 0 21 0 102 0 22 0 102 0 23 0 102 0 24 0 102 0 25 0 102 0 26 1 5 0 45]
#[0 0 18 0 10]
#[0 0 38 0 4 0 25]
#[1 0 49 0 9 0 129 0 34 1 129 0 54 1 189 0 56]
#[0 0 182 0 5 0 9 0 25 0 58]
#[0 0 70 0 3 0 25]
#[0 0 98 0 25]
#[0 1 193 0 7]
#[0 0 226 0 1 0 15]
#[0 0 94 0 25]
)! !
PlatypusKeywordToken initialize!
